# -*- coding: iso8859_2 -*-

#-----------------------------------------------------------------------------
# Name:        fs_artykuly_dane.py
# Purpose:     wczytuje/edytuje/dodaje/usuwa wzgldniajc uprawnienia operatora 
# Author:      Jarek Plawgo
# Created:     2006/07/21
# RCS-ID:      $Id: fs_artykuly_dane.py $
# Copyright:   (c) 2006 RecordSystem
# Licence:     GNU GPL
#-----------------------------------------------------------------------------

# 2019-01-14 Wojciech Skowron - pobranie liczby artykulow tylko aktywnych
# 2019-06-26 Wojciech Skowron - pobieranie artykuw tylko jeli tylko_detal=FALSE
# 2020-04-30  Mikoaj Kozowski - (11957) dodanie warunku na "TylkoDetal" przy pobraniu danych

UpdateInsertSelect=klucze[-1]
stat = "OK"
dane = []
wyn2=[]

UprEdycja=(self.oddzial_id,'013012') in self.uprawnienia
UprDodawanie=(self.oddzial_id,'013013') in self.uprawnienia
if UprDodawanie>0:
    UprEdycja=UprDodawanie
UprList=(self.oddzial_id,'013000') in self.uprawnienia
UprUsuwanie=(self.oddzial_id,'013014') in self.uprawnienia
artykul_id=klucze[0]


if UpdateInsertSelect==19:
    sql="SELECT ean FROM rs_artykuly WHERE firma_id='"+self.firma_id+"' AND artykul_id='"+artykul_id+"';"
    stat,dane,dump,dump=self.PolSQL.Execute(sql,3)
    if stat<>'OK':
        stat=u'Bd zapytania pobierajcego ean dla artykuu '+artykul_id+' :'+stat
        dane.append(stat)
    elif len(dane)==0:
        stat=u'Brak artykuu o symbolu '+artykul_id
        dane.append(stat)


elif UpdateInsertSelect==11:
    sql="SELECT przelicznik FROM rs_artykuly WHERE firma_id='"+self.firma_id+"' AND artykul_id='"+artykul_id+"';"
    stat,dane,dump,dump=self.PolSQL.Execute(sql,3)
    if stat<>'OK':
        stat='BL SQL PRZEL'
        dane.append(stat)
    elif len(dane)==0:
        stat='BR ART'
        dane.append(stat)
         
elif UpdateInsertSelect==12:
    if (UprEdycja or (self.operator_id == STANDARD_OPERATOR_ID)):
        Data=klucze[1]
        UPD="UPDATE rs_artykuly set aktywny = false "
        UPD+="WHERE rs_artykuly.ilosc1 = 0 AND rs_artykuly.firma_id='"+firma_id+"' AND (select max(data) "
        UPD+=" FROM rs_obroty_magazynowe WHERE rs_artykuly.artykul_id=rs_obroty_magazynowe.artykul_id)<'"+Data+"' "
        stat,dane,wyn1,wyn2=self.PolSQL.Execute(UPD,1)
        if stat<>'OK':
            stat="BL UPD"
    else:
        stat="BL_UPR"   
        dane.append(stat)
        
        
elif UpdateInsertSelect==2: 
    if (UprUsuwanie or (self.operator_id == STANDARD_OPERATOR_ID)):
        sql="DELETE FROM rs_artykuly WHERE artykul_id='%s' AND firma_id = '%s';"%(artykul_id,self.firma_id)
        stat,dane,wyn1,wyn2=self.PolSQL.Execute(sql,1)
    
        if stat!="OK":
            stat="BR_KAS_POZ"
    else:
        stat="BL_UPR"   
        dane.append(stat)

elif (UpdateInsertSelect==1) and stat=='OK':
#pobieranie danych
    artykul_id=rsglobal.Dekoduj(artykul_id)
    artykul_nazwa=rsglobal.Dekoduj(klucze[1])
    kateg_artykulu=rsglobal.Dekoduj(klucze[2])
    typ_artykulu=rsglobal.Dekoduj(klucze[3])
    producent_id=rsglobal.Dekoduj(klucze[4])
    dostawca_id=rsglobal.Dekoduj(klucze[5])
    kateg_mag=rsglobal.Dekoduj(klucze[6])
    kateg_art=rsglobal.Dekoduj(klucze[7])
    klucze_id=rsglobal.Dekoduj(klucze[8])
    aktywny=klucze[9]
    ean=rsglobal.Dekoduj(klucze[10])
    symbol_obcy=rsglobal.Dekoduj(klucze[11])
    tylko_detal=rsglobal.Dekoduj(klucze[13]) #MK 2020-04-20

    if (UprList or (self.operator_id == STANDARD_OPERATOR_ID)):
        sql="SELECT DISTINCT art.artykul_id,art.nazwa,art.kateg_artykulu||' - '||ka.opis,art.typ_artykulu,art.producent_id,art.dostawca_id,art.ost_przychod,ost_rozchod,art.cecha1_opis "
        sql+="FROM rs_artykuly AS art INNER JOIN rs_kateg_artykulow AS ka ON art.firma_id = ka.firma_id  AND art.kateg_artykulu = ka.kod "
        if ean <>'':
            sql+="LEFT OUTER JOIN rs_artykuly_ean AS e ON art.firma_id = e.firma_id AND art.artykul_id = e.artykul_id "
        if symbol_obcy<>'':
            sql+="LEFT OUTER JOIN rs_artykuly_obce AS o ON art.firma_id = o.firma_id AND art.artykul_id = o.artykul_id "
            sql+="LEFT OUTER JOIN rs_kontrahenci AS k ON o.firma_id = k.firma_id AND o.kontrahent_id = k.kontrahent_id "

        sql += " WHERE art.firma_id='"+self.firma_id+"'"
        if tylko_detal: #MK 2020-04-30
            sql += " AND art.tylko_detal=FALSE" #WS 2019-06-26
        if artykul_id<>'':
            sql += " AND upper(art.artykul_id) LIKE upper('"+artykul_id+"%')"
        if artykul_nazwa <> '':
            sql += " AND upper(art.nazwa) LIKE upper('"+artykul_nazwa+"%')"
        if kateg_artykulu <> '':
            sql += " AND upper(art.kateg_artykulu) LIKE upper('"+kateg_artykulu+"%')"
        if typ_artykulu <> '':
            sql += " AND upper(art.typ_artykulu) LIKE upper('"+typ_artykulu+"%')"
        if producent_id <> '':
            sql += " AND upper(art.producent_id) LIKE upper('"+producent_id+"%')"
        if dostawca_id <> '':
            sql += " AND upper(art.dostawca_id) LIKE upper('"+dostawca_id+"%')"
        if ean <> '':
            sql += " AND upper(e.ean) LIKE upper('"+ean+"%')"
        if symbol_obcy <> '':
            sql += " AND upper(o.obcy_id) LIKE upper('"+symbol_obcy+"%')"
        if aktywny:
            sql+=' AND art.aktywny'
        if klucze_id <> []:
            sql+=" OR (art.firma_id='"+self.firma_id+"' AND art.artykul_id IN ("+",".join(["'%s'"%(str(klucz[0])) for klucz in klucze_id])+"))"

        sql+=" ORDER BY art.artykul_id;"
        rsglobal.ZapiszDoLogow(sql,1)
        stat,dane,wyn1,wyn2=self.PolSQL.Execute(sql,3)
        if stat!="OK":
            stat="BL_SQL"
            dane.append(stat)
            
        # pobranie liczby artykuw
        if stat == 'OK':
            #SQL= "SELECT COUNT(*) FROM rs_artykuly WHERE firma_id='"+str(self.firma_id)+"';"
            #WS 2019-01-14
            SQL = "SELECT COUNT(*) FROM rs_artykuly WHERE firma_id='" + str(self.firma_id) + "' AND COALESCE(aktywny,TRUE);"
            stat,wyn1,dump,dump=self.PolSQL.Execute(SQL,3)
    else:
        stat="BL_UPR"
        dane.append(stat)