# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_artykuly_dodaj_zamiennik.py
# Purpose:      
# Author:      Dariusz Boduch
# Created:     2008/06/30
# RCS-ID:      $Id: fs_artykuly_dodaj_zamiennik.py $
# Copyright:   (c) 2006 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

# 2012-10-01 Mariusz Rajfura (6124) kopiowanie stawek VAT przy tworzeniu zamiennika

Artykul=klucze[0]
ArtykulN=klucze[1]


stat="OK"
UprDodawanie=(self.oddzial_id,'013013') in self.uprawnienia
if UprDodawanie:
    UprEdytowanie=True
    UprPrzegl=True
else:    
    UprEdytowanie=(self.oddzial_id,'013012') in self.uprawnienia
    if UprEdytowanie:
        UprPrzegl=True
    else:    
        UprPrzegl=(self.oddzial_id,'013011') in self.uprawnienia 

#sprawdzenie danych
if (not (UprDodawanie or self.operator_id == STANDARD_OPERATOR_ID)) and stat=='OK':
    stat='BL_UPR'
    dane.append(stat)

if stat=='OK':
    stat,d,dump,dump = self.PolSQL.Execute("SELECT artykul_id,dynamiczny_przelicznik FROM rs_artykuly WHERE firma_id = '"+self.firma_id+"' AND artykul_id='"+Artykul+"'",3)
    if stat <>'OK':
        stat='BL_SQL_ART'
        dane.append(stat)
    elif d==[]:
        stat='ART_BRAK'
        dane.append(stat)
    elif d[0][1]:
        stat='ZAM_DYNAM'
        dane.append(stat)
    
    
if stat=='OK':
    stat,d,dump,dump = self.PolSQL.Execute("SELECT artykul_id FROM rs_artykuly WHERE firma_id = '"+self.firma_id+"' AND artykul_id='"+ArtykulN+"'",3)
    if stat <>'OK':
        stat='BL_SQL_ZAM'
        dane.append(stat)
    elif d<>[]:
        stat='ART_JEST'
        dane.append(stat)
       

#-------------------------------------------------------------------------------
#---   DODANIE ZAMIENNIKA DO ARTYKULOW
#-------------------------------------------------------------------------------

if stat=='OK':
    INSERT="INSERT INTO rs_artykuly (firma_id,artykul_id,nazwa, stawka_vat,stawka_vat_import, kateg_artykulu,producent_id,"
    INSERT+="dostawca_id, sww_pkwiu, atest,typ_artykulu,aktywny,artykul_mag_id,zamiennik_id,kod_cn,waga,"
    INSERT+="taryfa_celna, czy_seria,czy_termin,jm1,jm2,przelicznik,jm_kalk,clo_p,clo_w,akcyza_pr,akcyza_wa,"
    INSERT+="czy_jedn_uzupelniajace,ilosc1,ilosc2, ost_cena1,ost_cena2,ost_przychod,ost_rozchod,zapas_min1,"
    INSERT+="zapas_min2,zapas_max1,zapas_max2,rezerwa1,rezerwa2,rezerwacja1,rezerwacja2, zamowienie_w1,"
    INSERT+="zamowienie_w2,zamowienie_z1,zamowienie_z2,model_id,deklaracja_zgodnosci_przeznaczenie, "
    INSERT+="deklaracja_zgodnosci_dokumenty,deklaracja_zgodnosci_partia,cecha1_opis,cecha_standard,przelicznik_odwr, "
    INSERT+="produkt_wiodacy,dni_karencji,oplata_reprograficzna,limit_oplaty_repr,dni_przydatnosci,czy_produkcja_ciagla, "
    INSERT+="dynamiczny_przelicznik,sledzenie_dostaw,faktura_w_jm2,hdi,nazwa_dluga,wydanie_proporcjonalne,wzor_zlecenia, "
    INSERT+="tylko_w_opakowaniach,jm_zlecen) "
    SELECT="SELECT  firma_id ,'"+ArtykulN+"',nazwa, stawka_vat,stawka_vat_import, kateg_artykulu,producent_id,"
    SELECT+="dostawca_id, sww_pkwiu, atest,typ_artykulu,aktywny,artykul_mag_id,'"+Artykul+"',kod_cn,waga,"
    SELECT+="taryfa_celna, czy_seria,czy_termin,jm1,jm2,przelicznik,jm_kalk,clo_p,clo_w,akcyza_pr,akcyza_wa,"
    SELECT+="czy_jedn_uzupelniajace,0,0, 0,0,NULL,NULL,0,0,0,0,0,0,0,0,0,0,0,0,model_id,deklaracja_zgodnosci_przeznaczenie, "
    SELECT+="deklaracja_zgodnosci_dokumenty,deklaracja_zgodnosci_partia,cecha1_opis,cecha_standard,przelicznik_odwr,"
    SELECT+="produkt_wiodacy,dni_karencji,oplata_reprograficzna,limit_oplaty_repr,dni_przydatnosci,czy_produkcja_ciagla,"
    SELECT+="dynamiczny_przelicznik,sledzenie_dostaw,faktura_w_jm2,hdi,nazwa_dluga,wydanie_proporcjonalne,wzor_zlecenia,"
    SELECT+="tylko_w_opakowaniach,jm_zlecen "

    stat,dump,dump,dump = self.PolSQL.Execute(INSERT+SELECT+"FROM rs_artykuly WHERE firma_id='"+self.firma_id+"' AND artykul_id='"+Artykul+"'",1)

    if stat<>"OK":
        stat="BL_SQL_INS_ART$"+stat   
        dane.append(stat) 

#-------------------------------------------------------------------------------
#---   KOPIOWANIE CEN 
#-------------------------------------------------------------------------------

if stat=='OK':
    INSERT="INSERT INTO rs_artykuly_ceny (firma_id, artykul_id, wersja,waluta,data_od,cena_netto1,"
    INSERT+="cena_brutto1, cena_netto2,cena_brutto2)"
    SELECT="SELECT  firma_id,'"+ArtykulN+"', wersja,waluta,data_od,cena_netto1, "
    SELECT+="cena_brutto1, cena_netto2,cena_brutto2 "

    stat,dump,dump,dump = self.PolSQL.Execute(INSERT+SELECT+"FROM rs_artykuly_ceny WHERE firma_id='"+self.firma_id+"' AND artykul_id='"+Artykul+"'",1)
    if stat<>"OK":
        stat="BL_SQL_INS_CEN$"+stat   
        dane.append(stat) 
        
#-------------------------------------------------------------------------------
#---   KOPIOWANIE OBCYCH DANYCH ARTYKULOW 
#-------------------------------------------------------------------------------

if stat=='OK':
    INSERT="INSERT INTO rs_artykuly_obce (firma_id, kontrahent_id,artykul_id,obcy_id,obca_nazwa,obcy_ean,obca_jm) "
    SELECT="SELECT  firma_id, kontrahent_id,'"+ArtykulN+"',obcy_id,obca_nazwa,obcy_ean,obca_jm "
    
    stat,dump,dump,dump = self.PolSQL.Execute(INSERT+SELECT+"FROM rs_artykuly_obce WHERE firma_id='"+self.firma_id+"' AND artykul_id='"+Artykul+"'",1)
    if stat<>"OK":
        stat="BL_SQL_INS_OBCE$"+stat   
        dane.append(stat) 
        
#-------------------------------------------------------------------------------
#---   KOPIOWANIE DANYCH ARTYKULY OPAKOWANIA
#-------------------------------------------------------------------------------

if stat=='OK':
    INSERT="INSERT INTO rs_artykuly_opakowania (firma_id,artykul_id,data_od,masa_netto,masa_brutto,"
    INSERT+="opakowanie_id,ilosc1,ilosc2,dlugosc_j,szerok_j,wysok_j, dlugosc_z, szerok_z,wysok_z, "
    INSERT+="masa_j_papier,masa_j_tworzywa,masa_j_drewno, kod_eie) "
    SELECT="SELECT  firma_id,'"+ArtykulN+"',data_od,masa_netto,masa_brutto,"
    SELECT+="opakowanie_id,ilosc1,ilosc2,dlugosc_j,szerok_j,wysok_j, dlugosc_z, szerok_z,wysok_z,"
    SELECT+="masa_j_papier,masa_j_tworzywa,masa_j_drewno, kod_eie "
    
    stat,dump,dump,dump = self.PolSQL.Execute(INSERT+SELECT+"FROM rs_artykuly_opakowania WHERE firma_id='"+self.firma_id+"' AND artykul_id='"+Artykul+"'",1)
    if stat<>"OK":
        stat="BL_SQL_INS_OPAK$"+stat   
        dane.append(stat) 
        
#-------------------------------------------------------------------------------
#---   KOPIOWANIE DANYCH ARTYKULY OPAKOWANIA ZBIORCZE
#-------------------------------------------------------------------------------

if stat=='OK':
    INSERT="INSERT INTO rs_artykuly_opakowania_zbiorcze (firma_id,opakowanie_id,artykul_id,lp,ilosc1,ilosc2," \
            "kontrahent_id,data_do,paleta_id,pojemnosc_paletowa,cecha1_opis,cecha1_wartosc,czy_unikalna) "
    SELECT="SELECT  firma_id,opakowanie_id,'"+ArtykulN+"',lp,ilosc1,ilosc2,kontrahent_id," \
            " data_do,paleta_id,pojemnosc_paletowa,cecha1_opis,cecha1_wartosc,czy_unikalna "

    stat,dump,dump,dump = self.PolSQL.Execute(INSERT+SELECT+"FROM rs_artykuly_opakowania_zbiorcze WHERE firma_id='"+self.firma_id+"' AND artykul_id='"+Artykul+"'",1)
    if stat<>"OK":
        stat="BL_SQL_INS_OPAKZB$"+stat   
        dane.append(stat) 
        
#-------------------------------------------------------------------------------
#---   KOPIOWANIE DANYCH ARTYKULY PRODUCENCI
#-------------------------------------------------------------------------------

if stat=='OK':
    INSERT="INSERT INTO rs_artykuly_producenci(firma_id,artykul_id,oddzial_zam,oddzial_prod,data_od,data_do,rzut) "
    SELECT="SELECT  firma_id,'"+ArtykulN+"',oddzial_zam,oddzial_prod,data_od,data_do,rzut "
    
    stat,dump,dump,dump = self.PolSQL.Execute(INSERT+SELECT+"FROM rs_artykuly_producenci WHERE firma_id='"+self.firma_id+"' AND artykul_id='"+Artykul+"'",1)
    if stat<>"OK":
        stat="BL_SQL_INS_PROD$"+stat   
        dane.append(stat)
        
#-------------------------------------------------------------------------------
#---   KOPIOWANIE DANYCH ARTYKULY ZESTAWY
#-------------------------------------------------------------------------------

if stat=='OK':
    SQL="INSERT INTO rs_artykuly_zestawy (firma_id,zestaw_id,kontrahent_id,artykul_id,ilosc1,"
    SQL+=" cecha1_opis_z,cecha1_wartosc_z,cecha1_opis_a,cecha1_wartosc_a) "
    SQL+="SELECT firma_id,zestaw_id,kontrahent_id,'"+ArtykulN+"',ilosc1, "
    SQL+=" cecha1_opis_z,cecha1_wartosc_z,cecha1_opis_a,cecha1_wartosc_a "
    SQL+="FROM rs_artykuly_zestawy WHERE firma_id='"+self.firma_id+"' AND artykul_id='"+Artykul+"'"    
    stat,dump,dump,dump = self.PolSQL.Execute(SQL,1)
    if stat<>"OK":
        stat="BL_SQL_INS_ZEST$"+stat   
        dane.append(stat)
        
#-------------------------------------------------------------------------------
#---   KOPIOWANIE DANYCH KONTRAHENCI CENY
#-------------------------------------------------------------------------------

if stat=='OK':
    INSERT="INSERT INTO rs_kontrahenci_ceny (firma_id,kontrahent_id,artykul_id,data_od,waluta,cena_netto1,cena_brutto1, cena_netto2, cena_brutto2) "
    SELECT="SELECT  firma_id,kontrahent_id,'"+ArtykulN+"',data_od,waluta,cena_netto1,cena_brutto1, cena_netto2, cena_brutto2 "
    
    stat,dump,dump,dump = self.PolSQL.Execute(INSERT+SELECT+"FROM rs_kontrahenci_ceny WHERE firma_id='"+self.firma_id+"' AND artykul_id='"+Artykul+"'",1)
    if stat<>"OK":
        stat="BL_SQL_INS_KONT_C$"+stat   
        dane.append(stat)
        
#-------------------------------------------------------------------------------
#---   KOPIOWANIE DANYCH KONTRAHENCI UPUSTY
#-------------------------------------------------------------------------------

if stat=='OK':
    INSERT="INSERT INTO rs_kontrahenci_upusty (firma_id,kontrahent_id,artykul_id,data_od,data_do,upust) "
    SELECT="SELECT  firma_id,kontrahent_id,'"+ArtykulN+"',data_od,data_do,upust "
    
    stat,dump,dump,dump = self.PolSQL.Execute(INSERT+SELECT+"FROM rs_kontrahenci_upusty WHERE firma_id='"+self.firma_id+"' AND artykul_id='"+Artykul+"'",1)
    if stat<>"OK":
        stat="BL_SQL_INS_KONT_U$"+stat   
        dane.append(stat)


#-------------------------------------------------------------------------------
#---   KOPIOWANIE DANYCH ARTYKULY STAWKI VAT
#-------------------------------------------------------------------------------

if stat=='OK':
    INSERT="INSERT INTO rs_artykuly_stawki_vat (firma_id,artykul_id,od_dnia,stawka_vat,stawka_vat_import,sww_pkwiu) "
    SELECT="SELECT firma_id,'"+ArtykulN+"',od_dnia,stawka_vat,stawka_vat_import,sww_pkwiu "
    
    stat,dump,dump,dump = self.PolSQL.Execute(INSERT+SELECT+" FROM rs_artykuly_stawki_vat WHERE firma_id='"+self.firma_id+"' AND artykul_id='"+Artykul+"'",1)
    if stat<>"OK":
        stat="BL_SQL_INS_STAWKI_V$"+stat   
        dane.append(stat)
