#!/usr/bin/python
# -*- coding: iso8859_2 -*-
#-----------------------------------------------------------------------------
# Name:             fs_artykuly_import.py
# Purpose:          importuje artykuly
# Author:           Marcin Grzda, zmiany: Dariusz Boduch
# Created:          2009/05/07
# RCS-ID:           $Id: fs_artykuly_import.py $
# Copyright:        (c) 2009 RecordSystem
# Licence:          GNU GPL
#-----------------------------------------------------------------------------

# #2015-08-25 Piotr Witkowski (6175) przy imporcie artykulw nowy artyk dodaje rwnie do tabeli rs_artykuly_stawki_vat

f=klucze[0]
#rsglobal.ZapiszDoLogow(f,1)

stat='OK'
LArt=[]
LWerCen=[]
dane=[]
wyn1=[]

Insert=''
InsertWerCen=''
UpdateWerCen=''

if not (((self.oddzial_id,'013016') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)):
    stat='UPR IMPORT'

if stat=='OK':  
    lista=f.splitlines()
    NrWiersza=1
    for i in xrange(len(lista)):
        if stat=='OK':
            wiersz=lista[i].split(';')
            #sprawdzenie czy artykul nie wystepuje wiecej niz jeden raz
            ArtykulId = wiersz[0] .replace(' ','').strip('"')
            if ArtykulId in LArt:
                stat='Artyku id : '+str(ArtykulId)+' z wiersza nr '+str(NrWiersza)+' ju wystpuje na licie'
                dane.append(stat)
            else: 
                LArt.append(ArtykulId)
            if stat == 'OK':    
                if len(wiersz)<11:
                    stat='Nieprawidowy wiersz nr: '+str(NrWiersza)
                    dane.append(stat)
            if stat=='OK':    
                Artykul="'"+wiersz[0] .replace(' ','').strip('"')+"'"
                if len(Artykul)<2:
                    stat='Brak id artykuu w wierszu nr: '+str(NrWiersza)
                    dane.append(stat)
                if len(Artykul)>22:
                    stat='Zbyt dugie id artykuu (max 20 znakw) w wierszu nr: '+str(NrWiersza)
                    dane.append(stat)
                
            if stat=='OK':
                ArtykulNazwa="'"+wiersz[1] .replace("'",'"').replace(';',',').strip()+"'" 
                if len(ArtykulNazwa)<2:
                    stat='Brak nazwy artykuu w wierszu nr: '+str(NrWiersza)
                    dane.append(stat)
                if len(ArtykulNazwa)>52:
                    stat='Zbyt duga nazwa artykuu (max 50 znakw) w wierszu nr: '+str(NrWiersza)
                    dane.append(stat)
            if stat=='OK':
                Typ="'"+wiersz[2] .replace(' ','').strip('"')+"'"
                if Typ=='':
                    stat='Brak typu artykuu w wierszu: '+str(NrWiersza)
                    dane.append(stat)
                else:
                    stat,dane_p,dump,dump=self.PolSQL.Execute("SELECT typ FROM rs_typy_artykulow WHERE typ="+Typ+"; ",3)
                    if stat<>'OK':
                        stat='Bd sprawdzania typu arykuu: '+str(Typ)+' w wierszu: '+str(NrWiersza)+' - '+str(stat)
                        dane.append(stat)
                    else:
                        if len(dane_p)<>1:
                            stat='Bdny typ artykuu: '+str(Typ)+' w wierszu: '+str(NrWiersza)
                            dane.append(stat)
            if stat=='OK':
                Kategoria="'"+wiersz[3] .replace(' ','').strip('"')+"'"
                if Kategoria=='':
                    stat='Brak typu kategorii w wierszu: '+str(NrWiersza)
                    dane.append(stat)
                else:
                    stat,dane_p,dump,dump=self.PolSQL.Execute("SELECT kod FROM rs_kateg_artykulow WHERE firma_id='"+self.firma_id+"' AND kod="+Kategoria+"; ",3)
                    if stat<>'OK':
                        stat='Bd sprawdzania typu kategorii: '+str(Kategoria)+' w wierszu: '+str(NrWiersza)+' - '+str(stat)
                        dane.append(stat)
                    else:
                        if len(dane_p)<>1:
                            stat='Bdny typ kategorii: '+str(Kategoria)+' w wierszu: '+str(NrWiersza)
                            dane.append(stat)
            
            if stat=='OK':
                Producent="'"+wiersz[4] .replace(' ','').strip('"')+"'"
                if Producent<>"''":
                    stat,dane_p,dump,dump=self.PolSQL.Execute("SELECT kontrahent_id FROM rs_kontrahenci WHERE firma_id='"+self.firma_id+"' AND kontrahent_id="+Producent+"; ",3)
                    if stat<>'OK':
                        stat='Bd sprawdzania producenta: '+str(Producent)+' w wierszu: '+str(NrWiersza)+' - '+str(stat)
                        dane.append(stat)
                    else:
                        if len(dane_p)<>1:
                            stat='Bdny kod producenta: '+str(Producent)+' w wierszu: '+str(NrWiersza)
                            dane.append(stat)
                else:
                    Producent='None'
                    
            if stat=='OK':
                Dostawca="'"+wiersz[5] .replace(' ','').strip('"')+"'"
                if Dostawca<>"''":
                    stat,dane_p,dump,dump=self.PolSQL.Execute("SELECT kontrahent_id FROM rs_kontrahenci WHERE firma_id='"+self.firma_id+"' AND kontrahent_id="+Dostawca+"; ",3)
                    if stat<>'OK':
                        stat='Bd sprawdzania dostawcy: '+str(Dostawca)+' w wierszu: '+str(NrWiersza)+' - '+str(stat)
                        dane.append(stat)
                    else:
                        if len(dane_p)<>1:
                            stat='Bdny kod dostawcy: '+str(Dostawca)+' w wierszu: '+str(NrWiersza)
                            dane.append(stat)
                else:
                    Dostawca='None'
            
            if stat=='OK':
                StawkaVAT="'"+wiersz[6] .replace(' ','').strip('"')+"'"
                if StawkaVAT=="''":
                    stat='Brak stawki VAT w wierszu: '+str(NrWiersza)
                    dane.append(stat)
                else:
                    stat,dane_p,dump,dump=self.PolSQL.Execute("SELECT kod FROM rs_stawki_vat WHERE kod="+StawkaVAT+"; ",3)
                    if stat<>'OK':
                        stat='Bd sprawdzania stawki VAT: '+str(StawkaVAT)+' w wierszu: '+str(NrWiersza)+' - '+str(stat)
                        dane.append(stat)
                    else:
                        if len(dane_p)<>1:
                            stat='Bdna stawka VAT: '+str(StawkaVAT)+' w wierszu: '+str(NrWiersza)
                            dane.append(stat)
                        else:
                            StVAT=dane_p[0][0]
                            if StVAT in self.ListaStawekZn:
                                StVAT=0
                            else:
                                StVAT=int(StVAT)                    
            if stat=='OK':
                SWW="'"+wiersz[7] .replace(' ','').strip('"')+"'"
                if StawkaVAT<>"'23'":
                    if SWW=="''":
                        stat='Brak SWW / PKWIU przy stawce VAT: '+str(StawkaVAT)+' w wierszu: '+str(NrWiersza)
                        dane.append(stat)
            if stat=='OK':
                Jm1="'"+wiersz[8] .replace(' ','').strip('"')+"'"
                if Jm1=="''":
                    stat='Brak Jm 1 w wierszu: '+str(NrWiersza)
                    dane.append(stat)
                else:
                    stat,dane_p,dump,dump=self.PolSQL.Execute("SELECT kod FROM rs_jednostki_miar WHERE firma_id='"+self.firma_id+"' AND kod="+Jm1+"; ",3)
                    if stat<>'OK':
                        stat='Bd sprawdzania Jm 1: '+str(Jm1)+' w wierszu: '+str(NrWiersza)+' - '+str(stat)
                        dane.append(stat)
                    else:
                        if len(dane_p)<>1:
                            stat='Bdna Jm 1: '+str(Jm1)+' w wierszu: '+str(NrWiersza)
                            dane.append(stat)
            if stat=='OK':       
                Jm2="'"+wiersz[9].replace(' ','').strip('"')+"'"
                if Jm2=="''":
                    stat='Brak Jm 2 w wierszu: '+str(NrWiersza)
                    dane.append(stat)
                else:
                    stat,dane_p,dump,dump=self.PolSQL.Execute("SELECT kod FROM rs_jednostki_miar WHERE firma_id='"+self.firma_id+"' AND kod="+Jm2+"; ",3)
                    if stat<>'OK':
                        stat='Bd sprawdzania Jm 1: '+str(Jm2)+' w wierszu: '+str(NrWiersza)+' - '+str(stat)
                        dane.append(stat)
                    else:
                        if len(dane_p)<>1:
                            stat='Bdna Jm 2: '+str(Jm2)+' w wierszu: '+str(NrWiersza)
                            dane.append(stat)
            if stat=='OK':
                Przelicznik= wiersz[10].replace(',','.').replace(' ','').strip('"') 
                if Przelicznik =='':
                    stat='Brak przelicznika w wierszu: '+str(NrWiersza)
                    dane.append(stat)
                else:
                    Przelicznik= float(Przelicznik)
                    if Jm1==Jm2 and Przelicznik<> 1:
                        stat='Przy Jm1 rwnej Jm2 przelicznik nie jest rwny 1 w wierszu: '+str(NrWiersza)
                        dane.append(stat)
                    elif Przelicznik == 0:
                        stat = 'Przelicznik = 0 w wierszu: '+str(NrWiersza)
                        dane.append(stat)
            #sprawdzanie czy artyku ma by dodany
            if stat=='OK':
                stat,dane_p,dump,dump=self.PolSQL.Execute("SELECT artykul_id FROM rs_artykuly WHERE firma_id='"+self.firma_id+"' AND artykul_id="+Artykul+"; ",3)
                if stat<>'OK':
                    stat='Bd sprawdzania arykuu: '+str(Artykul)+' w wierszu: '+str(NrWiersza)+' - '+str(stat)
                    dane.append(stat)
                else:
                    if len(dane_p)==0:
                        if Producent=='None':
                            Producent=''
                            ProducentIns=''
                        else:
                            ProducentIns='producent_id,'
                            Producent=Producent+','
                        if Dostawca=='None':
                            Dostawca=''
                            DostawcaIns=''
                        else:
                            DostawcaIns='dostawca_id,'
                            Dostawca=Dostawca+','
                        InsertWiersza = "INSERT INTO rs_artykuly (firma_id, artykul_id, nazwa, stawka_vat, stawka_vat_import, "
                        InsertWiersza +="kateg_artykulu, "+DostawcaIns+" "+ProducentIns+" sww_pkwiu, typ_artykulu, jm1, jm2, przelicznik) "
                        InsertWiersza +="VALUES ('"+self.firma_id+"', "+Artykul+","+ArtykulNazwa+", "+str(StawkaVAT)+","+str(StawkaVAT)+", "
                        InsertWiersza +=" "+Kategoria+","+Dostawca+" "+Producent+" "+SWW+","+Typ+","+Jm1+","+Jm2+","+str(Przelicznik)+"); "
                        
                        DataObowiaz="2011-01-01"
                        InsertWiersza += "INSERT INTO rs_artykuly_stawki_vat (firma_id, artykul_id, od_dnia, stawka_vat, stawka_vat_import, sww_pkwiu)"
                        InsertWiersza +="VALUES ('"+self.firma_id+"', "+Artykul+","+"'"+DataObowiaz+"', "+str(StawkaVAT)+","+str(StawkaVAT) + "," + SWW+");"
                        Insert= Insert+InsertWiersza
            #pobranie wersji cenowych
            if stat=='OK':
                if len(wiersz)>10 and len(wiersz)<14:
                    stat='Brak danych cen artykuu: '+str(Artykul)+' w wierszu: '+str(NrWiersza)
                    dane.append(stat)
                else:
                    #ile wersji cenowych
                    IleWersji=len(wiersz)-11
                if IleWersji%4<>0:
                    stat='Niepoprawne dane cen artykuu: '+str(Artykul)+' w wierszu: '+str(NrWiersza)
                    dane.append(stat)
                if stat=='OK':
                    #rsglobal.ZapiszDoLogow(wiersz[11:],1)
                    
                    DaneCenowe=wiersz[11:]
                    Licznik=1
                    #Licznik: 1 = wersja cenowa, 2 = waluta, 3 = data od, 4 = cena netto
                    for w in DaneCenowe:
                        if stat=='OK':
                            if Licznik == 1:
                                WersjaCenowa="'"+w.replace(' ','').strip('"')+"'"
                                if WersjaCenowa<>"''":
                                    stat,dane_p,dump,dump=self.PolSQL.Execute("SELECT kod FROM rs_wersje_cenowe WHERE firma_id='"+self.firma_id+"' AND kod="+WersjaCenowa+"; ",3)
                                    if stat<>'OK':
                                        stat='Bd sprawdzania wersji cenowej: '+str(WersjaCenowa)+' w wierszu: '+str(NrWiersza)+' - '+str(stat)
                                        dane.append(stat)
                                    else:
                                        if len(dane_p)<>1:
                                            stat='Bdny kod wersji cenowej: '+str(WersjaCenowa)+' w wierszu: '+str(NrWiersza)
                                            dane.append(stat)
                            if Licznik == 2:
                                Waluta="'"+w.replace(' ','').strip('"')+"'"
                                if Waluta<>"''":
                                    stat,dane_p,dump,dump=self.PolSQL.Execute("SELECT kod FROM rs_waluty WHERE firma_id='"+self.firma_id+"' AND kod="+Waluta+"; ",3)
                                    if stat<>'OK':
                                        stat='Bd sprawdzania waluty: '+str(Waluta)+' w wierszu: '+str(NrWiersza)+' - '+str(stat)
                                        dane.append(stat)
                                    else:
                                        if len(dane_p)<>1:
                                            stat='Bdny kod waluty: '+str(Waluta)+' w wierszu: '+str(NrWiersza)
                                            dane.append(stat)
                            if Licznik == 3:
                                DataOd = "'"+w.replace(' ','').strip('"')+"'"
                                if DataOd<>"''":
                                    if not rsglobal.SprawdzCzyToData(DataOd.strip("'")):
                                        stat='Bdna data od : '+str(DataOd)+' w wierszu: '+str(NrWiersza)
                                        dane.append(stat)
                            if Licznik == 4:
                                CenaNetto = w.replace(',','.').strip('"')
                                if WersjaCenowa<>"''":
                                    if CenaNetto=='':
                                        stat='Brak ceny netto dla artykuu: '+str(Artykul)+' dla wersji cenowej: '+str(WersjaCenowa)+', daty od: '+str(DataOd)+' w wierszu: '+str(NrWiersza)
                                        dane.append(stat)
                                    else:
                                        CenaNetto=float(CenaNetto)
                                
                            Licznik+= 1
                            if Licznik==5:
                                if WersjaCenowa<>"''":
                                    #sprawdzanie czy w danych do imprtu nie wystepuje 2 razy ten sam klucz wersji cenowej
                                    LWC=[self.firma_id,Artykul,WersjaCenowa,Waluta,DataOd]
                                    if LWC in LWerCen:
                                        stat='Klucz wersji cenowej: '+str(Artykul)+', '+str(WersjaCenowa)+', '+str(Waluta)+', '+str(DataOd)+' w wierszu: '+str(NrWiersza)+' ju wystpuje na licie.'
                                        dane.append(stat)
                                    else:
                                        LWerCen.append(LWC)
                                    if stat=='OK':
                                        CenaBrutto1=CenaNetto*(100+StVAT)*0.01
                                        CenaNetto2=CenaNetto/Przelicznik
                                        CenaBrutto2=CenaNetto2*(100+StVAT)*0.01
                                        #sprawdzenie czy wersja cenowa ma byc dodana do rs_artykuly_ceny
                                        SQL="SELECT wersja FROM rs_artykuly_ceny WHERE firma_id='"+self.firma_id+"' AND artykul_id="+Artykul+" AND wersja="+WersjaCenowa+" "
                                        SQL +=" AND waluta="+Waluta+" AND data_od="+DataOd+"; "
                                        stat,dane_p,dump,dump=self.PolSQL.Execute(SQL,3)
                                        if stat<>'OK':
                                            stat='Bd sprawdzania wersji cenowej : '+str(WersjaCenowa)+' dla artykuu: '+str(Artykul)+' , waluta: '+str(Waluta)+', data od: '+str(DataOd)+' w wierszu: '+str(NrWiersza)+' - '+str(stat)
                                            dane.append(stat)
                                        else:
                                            if len(dane_p)==0:
                                                InsertWierszaWerC = "INSERT INTO rs_artykuly_ceny (firma_id, artykul_id, wersja, waluta, data_od, "
                                                InsertWierszaWerC +="cena_netto1, cena_brutto1, cena_netto2, cena_brutto2) "
                                                InsertWierszaWerC +="VALUES ('"+self.firma_id+"', "+Artykul+","+WersjaCenowa+", "+Waluta+","+DataOd+", "
                                                InsertWierszaWerC +=" round("+str(CenaNetto)+",2),round("+str(CenaBrutto1)+",2),round("+str(CenaNetto2)+",2),round("+str(CenaBrutto2)+",2)); "
                                                
                                                InsertWerCen= InsertWerCen+InsertWierszaWerC
                                            else:
                                                UpdateWierszaWerC=" UPDATE rs_artykuly_ceny SET cena_netto1=round("+str(CenaNetto)+",2),cena_brutto1=round("+str(CenaBrutto1)+",2), "
                                                UpdateWierszaWerC+="cena_netto2=round("+str(CenaNetto2)+",2),cena_brutto2=round("+str(CenaBrutto2)+",2) "
                                                UpdateWierszaWerC+="WHERE firma_id='"+self.firma_id+"' AND artykul_id="+Artykul+" AND wersja="+WersjaCenowa+" "
                                                UpdateWierszaWerC+="AND waluta="+Waluta+" AND data_od="+DataOd+"; "
                                                UpdateWerCen=UpdateWerCen+UpdateWierszaWerC   
                                Licznik=1    
        NrWiersza += 1    


if stat=='OK':
    stat,dump,dump,dump=self.PolSQL.Execute(Insert+InsertWerCen+UpdateWerCen,1)
    if stat<>'OK':
        stat='Bd importu: '+stat
        dane.append(stat)


if len(dane)>0:
    stat=dane[-1]
else:
    stat='OK'