# -*- coding: iso8859_2 -*-
#-----------------------------------------------------------------------------
# Name:        fs_artykuly_karty_przyjecia.py
# Purpose:     wyswietla, dodaje,usuwa dane projektu
# Author:      Dariusz Boduch
# Created:     2010/01/06
# RCS-ID:      $Id: fs_artykuly_karty_przyjecia.py$
# Copyright:   (c) 2009 Record System
# Licence:     GNU GPL
#-----------------------------------------------------------------------------

stat = 'OK'
wyn1 = []
wyn2 = []
dane = []

if not 'Funkcja' in klucze:
    stat = 'Brak podanej funkcji w kluczach'

if stat == 'OK':
    Funkcja = klucze['Funkcja']

    SlPar = {'Artykul':[1,5],}

    Lista = rsglobal.SprawdzParametryWKluczach(SlPar, Funkcja, klucze)
    if Lista <> '':
        stat = "Uwaga: wywoanie funkcji fs_artykuly_karty_przyjecia z numerem "+str(Funkcja)+" bez parametrw: "+Lista

    if Funkcja in [1,5]:
        Artykul = str(klucze['Artykul'])

    UprPrzegladanie=(((self.oddzial_id,'013140') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID))
    UprModyf=(((self.oddzial_id,'013142') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID))

if stat == 'OK' and not UprPrzegladanie:
    stat = u"Brak uprawnie do kart przyj artykuw"

if stat == 'OK' and Funkcja == 1 and not UprModyf:
    stat = u"Brak uprawnie do modyfikowania kart przyj artykuw"

if Funkcja == 1:
    Update=klucze['Update']
    Insert=klucze['Insert']
    Delete=klucze['Delete']


#------------------------------------------------------------------------------------------------------------        
#-------------------------- DELETE    
#------------------------------------------------------------------------------------------------------------        

if stat == "OK" and Funkcja == 1 and len(Delete[0]) > 0:
    sql=''
    for i in xrange(len(Delete[0])):
        DELETE="DELETE FROM rs_artykuly_karty_przyjecia "
        WHERE="WHERE firma_id='"+self.firma_id+"' AND artykul_id='"+str(Artykul)+"'"
        for j in xrange(len(Delete[0][i])):
            pole=Delete[1][j]
            wart=Delete[0][i][j]
            if pole == 'kod':
                WHERE+=" AND "+pole+"='"+str(wart)+"' "
        sql+=DELETE+WHERE+";"
    if sql<>'':
        stat,dump,dump,dump=self.PolSQL.Execute(rsglobal.Dekoduj(sql),1)
    if stat<>'OK':
        stat=u"Bd przy usuwaniu danych: "+stat
        dane.append(stat)


#-------------------------------------------------------------------------------
#---   UPDATE DANYCH (1)
#-------------------------------------------------------------------------------

if stat=="OK" and Funkcja == 1 and len(Update[0])>0:
    WierszeNr = Update[-1]
    for i in xrange(len(Update[0])):
        for j in xrange(len(Update[0][i])):
            pole=Update[0][i][j]
            wart=Update[1][i][j]
            if pole == 'kod':
                if str(wart).strip()=='':
                    stat = u'KOD BR'
                    wyn2.append((WierszeNr[i],0))
                    dane.append(stat)
                else:
                    sql ="SELECT kod FROM rs_karty_przyjecia WHERE firma_id = '"+self.firma_id+"'"
                    sql+=" AND kod = '"+str(wart)+"';"
                    stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                    if stat <> 'OK':
                        wyn2.append((WierszeNr[i],0))
                        dane.append(u'KOD BL SQL')
                    else:
                        if len(d)==0:
                            wyn2.append((WierszeNr[i],0))
                            dane.append(u'KOD BL')

    if len(dane)>0:
        stat='Bdy modyfikacji danych'

    if stat=='OK':
        sql=''
        for i in xrange(len(Update[0])):
            UPDATE="UPDATE rs_artykuly_karty_przyjecia "
            SET='SET '
            for j in xrange(len(Update[0][i])):
                pole=Update[0][i][j]
                wart=Update[1][i][j]
                if pole== 'kod':
                    SET+=pole+"='"+wart+"',"
            SET=SET.strip(",")
            WHERE=" WHERE firma_id='"+self.firma_id+"' AND artykul_id ='"+str(Artykul)+"' "
            for j in xrange(len(Update[2][i])): # petla po kluczu
                pole=Update[3][j]
                wart=rsglobal.Dekoduj(Update[2][i][j])
                WHERE+=" AND "+pole+"='"+str(wart)+"' "
            WHERE+=";"
            if str(SET)=='SET ':
                pass
            else:
                sql+=UPDATE+SET+WHERE;
        if sql<>'':
            stat,dump,dump,dump=self.PolSQL.Execute(rsglobal.Dekoduj(sql),1)
            if stat<>'OK':
                stat=u"Bd przy modyfikowaniu danych: "+stat
                dane.append(stat)


#----------------------------------------------------------------------------------------------------------------------
#---------Sprawdzanie danych do Insert------
#----------------------------------------------------------------------------------------------------------------------

if stat=="OK" and Funkcja == 1 and len(Insert[0])>0:
    WierszeNr = Insert[-1]
    for i in xrange(len(Insert[0])):
        for j in xrange(len(Insert[0][i])):
            pole=Insert[1][j]
            wart=Insert[0][i][j]
            if pole == 'kod':
                if wart.strip()=='':
                    wyn2.append((WierszeNr[i],0))
                    dane.append(u'KOD BR')
                else:
                    sql ="SELECT kod FROM rs_karty_przyjecia WHERE firma_id = '"+self.firma_id+"'"
                    sql+=" AND kod = '"+str(wart)+"';"
                    stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                    if stat <> 'OK':
                        wyn2.append((WierszeNr[i],0))
                        dane.append(u'KOD BL SQL')
                    else:
                        if d==[]:
                            wyn2.append((WierszeNr[i],0))
                            dane.append(u'KOD BL')
    if len(dane)>0:
        stat='Bdy dodawania danych'
                                                        
 #------------------------------------------------------------------------------------------------------------   
 #---------------   INSERT
 #-------------------------------------------------------------------------------------------------------------       

    if stat=='OK':
        sqlIns=''
        for i in xrange(len(Insert[0])):
            INSERT="INSERT INTO rs_artykuly_karty_przyjecia "
            KOLUMNY="(firma_id,artykul_id"
            VALUES=" VALUES ('"+self.firma_id+"','"+Artykul+"'"
            for j in xrange(len(Insert[0][i])):
                pole=Insert[1][j]
                wart=Insert[0][i][j]
                if pole == 'kod':
                    KOLUMNY+=","+pole
                    VALUES+=",'"+wart+"'"
            KOLUMNY+=")"
            VALUES+=");"
            sqlIns+=INSERT+KOLUMNY+VALUES
        if sqlIns<>'':
            stat,dump,dump,dump=self.PolSQL.Execute(rsglobal.Dekoduj(sqlIns),1)
            if stat<>'OK':
                stat=u"Bd przy dodawaniu danych: "+stat
                dane.append(stat)


# ------------------------------------------------------------------------------------------------------------
#---   POBRANIE DANYCH (1- insert 1 -select, 1 -delete)
#------------------------------------------------------------------------------------------------------------

if stat=="OK" and Funkcja in [1,5]:
    # pobranie danych
    SQL="SELECT akp.kod, kp.opis FROM rs_artykuly_karty_przyjecia akp "
    SQL+="JOIN rs_artykuly a ON akp.firma_id = a.firma_id AND akp.artykul_id = a.artykul_id "
    SQL+="JOIN rs_karty_przyjecia kp ON akp.firma_id = kp.firma_id AND akp.kod=kp.kod "
    SQL+="WHERE akp.firma_id = '"+self.firma_id+"' AND akp.artykul_id = '"+str(Artykul)+"';"
    stat,dane,wyn1,wyn2=self.PolSQL.Execute(SQL,3)
    if stat<>'OK':
        stat=u"Bd przy pobieraniu danych: "+stat
        dane.append(stat)