# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_artykuly_kody_ean_dany.py
# Purpose:     edycja oraz dodawanie kodw ean
# Author:      Pawel Wojcikowski
# Created:     2009/05/06
# RCS-ID:      $Id: fs_artykuly_kody_ean_dane.py$
# Copyright:   (c) 2009 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------
# 2020-02-23 Aleksander Bargie Zbiorczy i liczba w opakowaniu w artykuly ean  (11987)

Ean = rsglobal.Dekoduj(klucze[0]) 
Artykul = rsglobal.Dekoduj(klucze[1])
Glowny = klucze[2]
GlownyT='True'
Fun = klucze[-1]
stat = "OK"
dane = []

UprDodawanie=(((self.oddzial_id,'013043') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID))
UprEdytowanie=(((self.oddzial_id,'013042') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)) or UprDodawanie


#-------------------------------------------------------------------------------
#---- Sprawdzanie ---(7)
#-------------------------------------------------------------------------------

if Fun == 7 and stat== "OK":
    stat,dane,dump,dump = self.PolSQL.Execute("SELECT glowny FROM rs_artykuly_ean WHERE firma_id='"+self.firma_id+"' AND ean='"+Ean+"';" ,3)
    if stat<>'OK':
        stat=u"Bd przy sprawdzaniu kodu: "+stat   
        dane.append(stat)              


#-------------------------------------------------------------------------------
#---   INSERT DANYCH (2- bez pobierania,1- z pobieraniem)
#-------------------------------------------------------------------------------

if Fun in [1,2] and stat=='OK':
    #AB 25.05.20r
    Zbiorczy = klucze[3]
    LiczbaSztuk = klucze[4]
    if not UprDodawanie:
        stat="UPR INS"
    
    if (Ean.strip() in ('','None',None)) and stat=='OK':
        stat='BR KOD'
        dane.append(stat)

    #AB 25.05.20r
    if stat == 'OK' and Zbiorczy and LiczbaSztuk < 0:
        stat = u'Liczba sztuk w opakowaniu nie moe by ujemna.'
        dane.append(stat)
        
    if (Ean.strip() not in ('','None',None)) and stat=='OK': # sprawdzenie w ramach tego artykulu
        sel="SELECT ean FROM rs_artykuly_ean WHERE artykul_id='"+Artykul+"' AND firma_id='"+self.firma_id+"'"
        sel+=" AND ean='"+Ean+"';"
        stat,daneO,dump,dump=self.PolSQL.Execute(sel,3)
        if stat<>'OK':
            stat = 'Bdy przy sprawdzaniu unikalnoci kodu EAN :'+stat
            dane.append(stat)
        if stat=='OK':
            if daneO <> []:
                stat='KOD JEST'
                dane.append(stat)
            else: #sprawdzenie w ramach innego artykulu
                sel="SELECT artykul_id FROM rs_artykuly_ean WHERE firma_id='"+self.firma_id+"'"
                sel+=" AND ean='"+Ean+"';"
                stat,daneA,dump,dump=self.PolSQL.Execute(sel,3)
                if stat<>'OK':
                    stat = 'Bdy przy sprawdzaniu unikalnoci kodu EAN :'+stat
                    dane.append(stat)      
                if stat=='OK':
                    if daneA <> []:
                        stat='Podany kod jest ju wykorzystywany w ramach artykuu '+str(daneA[0][0])
                        dane.append(stat)
                             
    for i in range(len(pola)):
        pole = pola[i]
        wart = wartosci[i]    
        if stat=="OK":               
            if pole=='glowny':
                if wart==True:
                    SQL="SELECT glowny FROM rs_artykuly_ean WHERE firma_id = '"+self.firma_id+"' AND artykul_id='"+Artykul+"' AND glowny="+GlownyT+";"
                    stat,dane2,dump,dump = self.PolSQL.Execute(SQL,3)
                    if stat<>'OK':
                        stat = 'Bdy przy sprawdzaniu danych:'+stat
                        dane.append(stat)                       
                    if stat=='OK':
                        if len(dane2)<>0:
                            stat = "GL JEST"
                            dane.append(stat)
    if stat=='OK':
        ins = "INSERT INTO rs_artykuly_ean"       #AB 25.05.20r
        Pola="firma_id,artykul_id,ean,glowny, zbiorczy, liczba_sztuk_w_opakowaniu"
        Wartosci="'"+self.firma_id+"','"+Artykul+"','"+Ean+"','{Glowny}',{Zbiorczy},{LiczbaSztuk}".format(**locals())
        ins = ins+" ("+Pola+") VALUES ("+Wartosci+");"
        stat,dump,dump,dump = self.PolSQL.Execute(ins ,1)
        if stat<>'OK':
            stat = 'Bdy dodawania danych:'+stat
            dane.append(stat)             
            

#-------------------------------------------------------------------------------            
#--- Update (4)
#-------------------------------------------------------------------------------

if Fun in [3,4] and stat=='OK':
    if not UprEdytowanie:
        stat="UPR UPD"

    test_zbiorczy = None
    test_liczba = None

    for i in range(len(pola)):
        pole = pola[i]
        wart = wartosci[i]
        if stat=="OK":               
            if pole=='glowny':
                if wart==True:
                    SQL="SELECT glowny FROM rs_artykuly_ean WHERE firma_id = '"+self.firma_id+"' AND artykul_id = '"+Artykul+"' AND glowny="+GlownyT+";"
                    stat,dane2,dump,dump = self.PolSQL.Execute(SQL,3)
                    if stat<>'OK':
                        stat = 'Bdy sprawdzania danych:'+stat
                        dane.append(stat)                        
                    if stat=='OK':
                        if len(dane2)<>0:
                            stat = "GL JEST"
                            dane.append(stat)
            if pole == 'zbiorczy':
                test_zbiorczy = wart
            if pole == 'liczba_sztuk_w_opakowaniu':
                test_liczba = wart
    if stat == 'OK':
        if test_zbiorczy and test_liczba is not None and test_liczba < 0:
            stat = u'Liczba sztuk w opakowaniu nie moe by ujemna.'
            dane.append(stat)
        elif test_zbiorczy is None and test_liczba < 0:
            SQL = """SELECT zbiorczy 
                     FROM rs_artykuly_ean 
                     WHERE firma_id='{}' AND artykul_id='{}' AND ean='{}'""".format(self.firma_id, Artykul, Ean)
            stat, zbiorczy, dump, dump = self.PolSQL.Execute(SQL, 7)
            if stat != ' OK':
                stat = u'Bd podczas sprawdzania danych: ' + stat
                dane.append(stat)
            elif zbiorczy and test_liczba < 0:
                stat = u'Liczba sztuk w opakowaniu nie moe by ujemna.'
                dane.append(stat)
    if stat=='OK':
        where = " WHERE firma_id='"+self.firma_id+"' AND artykul_id='"+Artykul+"' AND ean='"+Ean+"'; "
        upd = "UPDATE rs_artykuly_ean SET "
        for i in range(len(pola)):
            pole = pola[i]
            wart = wartosci[i]
            if wart=='':
                wart='NULL'
            else:
                wart= "'"+str(wart)+"'"   
            upd=upd+pole+"="+str(wart)+","
        upd = upd[0:len(upd)-1]+where
        stat,dump,dump,dump = self.PolSQL.Execute(upd ,1)
        if stat<>'OK':
            stat = 'Bdy modyfikowania danych:'+stat
            dane.append(stat)  
            
            
#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (5 -select)
#-------------------------------------------------------------------------------

if (klucze[-1] in [5,3,1]) and (stat=='OK'):
    Select= "SELECT * FROM rs_artykuly_ean WHERE artykul_id='"+Artykul+"'" 
    Select+= " AND firma_id='"+self.firma_id+"' AND ean='"+Ean+"';"
    stat,dane,wyn1,tr = self.PolSQL.Execute(Select,3)
    if stat<>'OK':
        stat = 'Bdy pobierania danych:'+stat
        dane.append(stat)              