# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_artykuly_kontrahenci_limity_przydatnosci.py
# Purpose:     obsluga grida edytowalnego z limitami przydatnoci
# Author:      Marcin Natkaski
# Created:     2014/08/22
# RCS-ID:      $Id: fs_artykuly_kontrahenci_limity_przydatnosci.py$
# Copyright:   (c) 2010 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

stat='OK'

if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=='OK':
    Funkcja = klucze['Funkcja']
    
    SlPar={'Artykul':[1,5],'Kontrahent':[1,5],'ArtykulF':[1,5],'KontrahentF':[1,5],'Art':[8,],'Kont':[9,],'Typ':[1,5]}
    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Funkcja,klucze)
    if Lista<>'':
        stat='Uwaga : wywoanie funkcji fs_artykuly_kontrahenci_limity_przydatnosci z numerem '+str(Funkcja)+' bez parametrw: '+Lista
        
    if Funkcja in [1,5]: 
        Artykul = rsglobal.Dekoduj(klucze['Artykul'])
        KontrahentF = rsglobal.Dekoduj(klucze['KontrahentF'])
        ArtykulF = rsglobal.Dekoduj(klucze['ArtykulF'])
        Kontrahent = rsglobal.Dekoduj(klucze['Kontrahent'])
        Typ = rsglobal.Dekoduj(klucze['Typ'])
        
    if Funkcja in [8,]: 
        Art=rsglobal.Dekoduj(klucze['Art'])
    if Funkcja in [9,]: 
        Kont=rsglobal.Dekoduj(klucze['Kont'])    
        
dane = []
wyn1 = []
wyn2 = []

Puste = (None,'')

Insert = []
Update = []
Delete = []

if stat=='OK' and Funkcja == 1:
    Update=klucze['Update']
    Insert=klucze['Insert']
    Delete=klucze['Delete']
    if Typ == 'K':
        UprIns=((self.oddzial_id,'012143') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID
        UprUpd=((self.oddzial_id,'012142') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID or UprIns
        UprDel=((self.oddzial_id,'012144') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID
    else:
        UprIns=((self.oddzial_id,'013123') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID
        UprUpd=((self.oddzial_id,'013122') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID or UprIns
        UprDel=((self.oddzial_id,'013124') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID


#-------------------------------------------------------------------------------
#-------  POBRANIE OPISU i ILOSCI DNI ARTYKUU (8)
#-------------------------------------------------------------------------------

if Funkcja == 8 and stat == "OK":
    sql ="SELECT nazwa,dni_przydatnosci FROM rs_artykuly "
    sql+=" WHERE firma_id='"+self.firma_id+"' AND artykul_id='"+Art+"';"
    stat,dane,dump,dump = self.PolSQL.Execute(sql,3)
    if stat <> 'OK':
        stat = 'Bd przy sprawdzaniu nazwy artykuu: '+stat
        dane.append(stat)
        
#-------------------------------------------------------------------------------
#-------  POBRANIE OPISU KONTRAHENTA (9)
#-------------------------------------------------------------------------------

if Funkcja == 9 and stat == "OK":
    sql ="SELECT nazwa FROM rs_kontrahenci "
    sql+=" WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+Kont+"';"
    stat,dane,dump,dump = self.PolSQL.Execute(sql,3)
    if stat <> 'OK':
        stat = 'Bd przy sprawdzaniu nazwy kontrahenta: '+stat
        dane.append(stat)

#-------------------------------------------------------------------------------
#-------  SPRAWDZANIE DELETE  --------------------------------------------------
#-------------------------------------------------------------------------------

if Funkcja == 1 and stat=="OK":
    if len(Delete[0])>0:
        if not UprDel:
            stat='BR UPR DEL'
            dane.append(stat)
        
        # wykonanie DELETE 
        if stat == 'OK':
            SQLDEL = ''
            SQLFU = ''
            for i in xrange(len(Delete[0])):
                DELETE = "DELETE FROM rs_artykuly_limity_przydatnosci "
                WHERE = " WHERE firma_id='"+self.firma_id+"' "
                SQLFU = "SELECT artykul_id FROM rs_artykuly_limity_przydatnosci "
                SQLFU+= " WHERE firma_id='"+self.firma_id+"' " 
                for j in xrange(len(Delete[0][i])):
                    pole = Delete[1][j]
                    wart = Delete[0][i][j]
                    if pole in ['kontrahent_id', 'artykul_id','typ']:
                        WHERE += " AND "+pole+"='"+wart+"'"
                        SQLFU += " AND "+pole+"='"+wart+"'"
                        

                SQLDEL += DELETE+WHERE+"; "
                SQLFU += " FOR UPDATE NOWAIT; "

            if SQLFU <> '':
                stat,d,dump,dump = self.PolSQL.Execute(rsglobal.Dekoduj(SQLFU),3)
                if stat <> 'OK':
                    stat = 'Bd sprawdzenia danych do usunicia: '+stat
                    dane.append(stat)
            
            if stat == 'OK' and SQLDEL <> '':
                stat,dump,dump,dump = self.PolSQL.Execute(rsglobal.Dekoduj(SQLDEL),1)
                if stat <> 'OK':
                    stat = "Bd przy usuwaniu danych: "+stat   
                    dane.append(stat)

                                 
#-------------------------------------------------------------------------------
#---   UPDATE DANYCH (1)
#-------------------------------------------------------------------------------

if Funkcja == 1 and stat=="OK":
    if len(Update[0])>0:
        if not UprUpd:
            stat='BR UPR UPD'
            dane.append(stat)

        if stat == 'OK':
            SQLFU = ''
            for i in xrange(len(Update[0])):
                SQLFU+= "SELECT artykul_id FROM rs_artykuly_limity_przydatnosci"
                SQLFU+= " WHERE firma_id='"+self.firma_id+"' "
                for j in xrange(len(Update[2][i])): # petla po kluczu
                    pole = Update[3][j]
                    wart = rsglobal.Dekoduj(Update[2][i][j])
                    SQLFU += " AND "+pole+"='"+str(wart)+"'"
                SQLFU += " FOR UPDATE NOWAIT; "
            
            if SQLFU <> '':
                stat,dFU,nFU,dump = self.PolSQL.Execute(rsglobal.Dekoduj(SQLFU),3)
                if stat <> 'OK':
                    stat = 'Bd sprawdzenia danych do modyfikacji: '+stat
                    dane.append(stat)

        if stat == 'OK':
            WierszeNr = Update[-1]
            for i in xrange(len(Update[0])):
                for j in xrange(len(Update[0][i])): 
                    pole = Update[0][i][j]
                    wart = Update[1][i][j]
  
                    if pole == 'typ':
                        wart = wart.strip()
                        if wart == '':
                            stat = 'BR TYP'
                            wyn2.append((WierszeNr[i],6))
                            dane.append(stat)
                        elif len(wart)>1:
                            stat = 'Warto w kolumnie z typem moe mie maksymalnie 1 znak'
                            wyn2.append((WierszeNr[i],6))
                            dane.append(stat)
                        elif str(wart) not in ('P','W','p','w'):
                            stat = 'Warto w kolumnie z typem moe przyjmowa tylko P lub W'
                            wyn2.append((WierszeNr[i],6))
                            dane.append(stat)
                    elif pole == 'artykul_id':
                        wart = wart.strip()
                        if wart == '':
                            stat = 'BR ART'
                            wyn2.append((WierszeNr[i],0))
                            dane.append(stat)
                        else:
                            sql ="SELECT artykul_id FROM rs_artykuly"
                            sql+=" WHERE firma_id='"+self.firma_id+"' AND artykul_id = '"+str(wart)+"';"
                            stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                            if stat <> 'OK':
                                stat = 'BL SQL ART'
                                wyn2.append((WierszeNr[i],0))
                                dane.append(stat)
                            elif len(d) == 0:
                                stat = 'BL ART'
                                wyn2.append((WierszeNr[i],0))
                                dane.append(stat)
                        if wart<> '':
                            sql ="SELECT artykul_id FROM rs_artykuly"
                            sql+=" WHERE firma_id='"+self.firma_id+"' AND artykul_id = '"+str(wart)+"' and czy_termin;"
                            stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                            if stat <> 'OK':
                                stat = 'Bad sprawdznia czy_termin w artykule'
                                wyn2.append((WierszeNr[i],0))
                                dane.append(stat)
                            elif len(d) == 0:
                                stat = 'Artyku "'+wart+'" musi mie zanaczony termin_wanoci w swoich danych'
                                wyn2.append((WierszeNr[i],0))
                                dane.append(stat)    
                                              
                    elif pole == 'kontrahent_id':
                        wart = wart.strip()
                        if wart == '':
                            stat = 'BR KONTR'
                            wyn2.append((WierszeNr[i],2))
                            dane.append(stat)
                        else:
                            sql ="SELECT kontrahent_id FROM rs_kontrahenci "
                            sql+=" WHERE firma_id='"+self.firma_id+"' AND kontrahent_id = '"+str(wart)+"';"
                            stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                            if stat <> 'OK':
                                stat = 'BL SQL KONT'
                                wyn2.append((WierszeNr[i],2))
                                dane.append(stat)
                            elif len(d) == 0:
                                stat = 'BL KONT'
                                wyn2.append((WierszeNr[i],2))
                                dane.append(stat)
                    
                    elif pole == 'limit_procent':
                        if wart> 99:
                            stat = 'BL PROC'
                            wyn2.append((WierszeNr[i],4))
                            dane.append(stat)
                        elif wart <0:
                            stat = 'BL PROC MINUS'
                            wyn2.append((WierszeNr[i],4))
                            dane.append(stat)
                            
                    elif pole == 'limit_dni':
                        if wart> 9999:
                            stat = 'BL PROC'
                            wyn2.append((WierszeNr[i],5))
                            dane.append(stat)
                        elif wart <0:
                            stat = 'BL PROC MINUS'
                            wyn2.append((WierszeNr[i],5))
                            dane.append(stat)
                            
                if stat == 'OK':
                    if len(dane) > 0:
                        stat = dane[0]
                
                # wykonanie UPDATE
                if stat=='OK':
                    sql=''
                    UPDATE="UPDATE rs_artykuly_limity_przydatnosci "
                    SET='SET '
                    for j in xrange(len(Update[0][i])): 
                        pole=Update[0][i][j]
                        wart=Update[1][i][j]
    
                        if pole in ['artykul_id', 'kontrahent_id']:
                            SET+=pole+"='"+wart+"',"
                            
                        elif pole in ['limit_procent','limit_dni']:
                            SET+=pole+"="+str(wart)+","
                            
                        elif pole == 'typ':
                            SET+=pole+"='"+wart.upper()+"',"
                            
                    SET=SET.strip(",")
                    WHERE=" WHERE firma_id='"+self.firma_id+"'" 
                    for j in xrange(len(Update[2][i])): # petla po kluczu
                        pole=Update[3][j]
                        wart=rsglobal.Dekoduj(Update[2][i][j])
                        if pole in ['artykul_id','kontrahent_id','typ']:
                            WHERE+=" AND "+pole+"='"+wart+"'"
                        
                    WHERE+=";"
                        
                    sql+=UPDATE+SET+WHERE
                        
                    stat,dump,dump,dump = self.PolSQL.Execute(rsglobal.Dekoduj(sql),1)
                    if stat<>'OK':
                        stat="Istnieje ju wpis o podanym kluczu: "+stat   
                        dane.append(stat)
                    

#-------------------------------------------------------------------------------
#---------Sprawdzanie danych do Insert------
#-------------------------------------------------------------------------------

if Funkcja == 1 and stat=="OK":
    if len(Insert[0])>0:
        if not UprIns:
            stat='BR UPR INS'
            dane.append(stat)

        if stat == 'OK':
            WierszeNr = Insert[-1]
            for i in xrange(len(Insert[0])):
                typ=None
                artykul=None
                kontrahent=None
                for j in xrange(len(Insert[0][i])): 
                    pole=Insert[1][j]
                    wart=Insert[0][i][j]
                    
                    if pole == 'typ':
                        wart = wart.strip()
                        typ=wart
                        if wart == '':
                            stat = 'BR TYP'
                            wyn2.append((WierszeNr[i],6))
                            dane.append(stat)
                        elif len(wart)>1:
                            stat = 'Warto w kolumnie z typem moe mie maksymalnie 1 znak'
                            wyn2.append((WierszeNr[i],6))
                            dane.append(stat)
                        elif str(wart) not in ('P','W','p','w'):
                            stat = 'Warto w kolumnie z typem moe przyjmowa tylko P lub W'
                            wyn2.append((WierszeNr[i],6))
                            dane.append(stat)
                    elif pole == 'artykul_id':
                        wart = wart.strip()
                        artykul = wart
                        if wart == '':
                            stat = 'BR ART'
                            wyn2.append((WierszeNr[i],0))
                            dane.append(stat)
                        else:
                            sql ="SELECT artykul_id FROM rs_artykuly"
                            sql+=" WHERE firma_id='"+self.firma_id+"' AND artykul_id = '"+str(wart)+"';"
                            stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                            if stat <> 'OK':
                                stat = 'BL SQL ART'
                                wyn2.append((WierszeNr[i],0))
                                dane.append(stat)
                            elif len(d) == 0:
                                stat = 'BL ART'
                                wyn2.append((WierszeNr[i],0))
                                dane.append(stat)

                    elif pole == 'kontrahent_id':
                        wart = wart.strip()
                        kontrahent=wart
                        if wart == '':
                            stat = 'BR KONTR'
                            wyn2.append((WierszeNr[i],2))
                            dane.append(stat)
                        else:
                            sql ="SELECT kontrahent_id FROM rs_kontrahenci "
                            sql+=" WHERE firma_id='"+self.firma_id+"' AND kontrahent_id = '"+str(wart)+"';"
                            stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                            if stat <> 'OK':
                                stat = 'BL SQL KONT'
                                wyn2.append((WierszeNr[i],2))
                                dane.append(stat)
                            elif len(d) == 0:
                                stat = 'BL KONT'
                                wyn2.append((WierszeNr[i],2))
                                dane.append(stat)

                    elif pole == 'limit_procent':
                        if wart> 99:
                            stat = 'BL PROC'
                            wyn2.append((WierszeNr[i],4))
                            dane.append(stat)
                        elif wart <0:
                            stat = 'BL PROC MINUS'
                            wyn2.append((WierszeNr[i],4))
                            dane.append(stat)
                            
                    elif pole == 'limit_dni':
                        if wart>9999:
                            stat = 'BL PROC'
                            wyn2.append((WierszeNr[i],5))
                            dane.append(stat)
                        elif wart <0:
                            stat = 'BL PROC MINUS'
                            wyn2.append((WierszeNr[i],5))
                            dane.append(stat)
                        
                            
                # sprawdzenie, czy nie ma bledow
                if stat == 'OK':
                    if len(dane) > 0:
                        stat = dane[0]
                #sprawdzamy czy dodawany wiersz ju istnieje (czasami przez filtry nie wida)        
                if stat == 'OK':
                    SPRKLUCZ = " SELECT artykul_id FROM  rs_artykuly_limity_przydatnosci "
                    SPRKLUCZ+= " WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+kontrahent+"' "
                    SPRKLUCZ+= " AND artykul_id='"+artykul+"' AND typ='"+typ+"' ;"
                    stat,d,dump,dump = self.PolSQL.Execute(SPRKLUCZ,3)
                    if stat <> 'OK':
                        stat = 'BL SQL KLUCZ'+stat
                        dane.append(stat)
                        wyn2.append((WierszeNr[i],0))
                    elif len(d) > 0:
                        stat = 'BL KLUCZ IST'
                        dane.append(stat)
                        wyn2.append((WierszeNr[i],0))
                        
                # sprawdzamy czy artykul ma zaznaczony termin_przydatnosci        
                if stat == 'OK':
                    SPRTERM = " SELECT artykul_id FROM  rs_artykuly "
                    SPRTERM+= " WHERE firma_id='"+self.firma_id+"' AND artykul_id='"+artykul+"' and czy_termin ;"
                    stat,d,dump,dump = self.PolSQL.Execute(SPRTERM,3)
                    if stat <> 'OK':
                        stat = 'Bd sprawdzania terminu przydatnoci w artykule '+stat
                        dane.append(stat)
                        wyn2.append((WierszeNr[i],0))
                    elif len(d)==0:
                        stat = 'Artyku w swoich danych podstawowych musi mie zaznaczon opcj termin wanoci '
                        dane.append(stat)
                        wyn2.append((WierszeNr[i],0))
                # wykonanie INSERT do pojedynczego wiersza
                if stat == 'OK':    
                    sqlIns=''
                    INSERT="INSERT INTO rs_artykuly_limity_przydatnosci "
                    KOLUMNY="(firma_id"
                    VALUES=" VALUES ('"+self.firma_id+"'"

                    for j in xrange(len(Insert[0][i])): 
                        pole=Insert[1][j]
                        wart=Insert[0][i][j]

                        if pole in ['artykul_id', 'kontrahent_id']:
                            KOLUMNY+=","+pole
                            VALUES+=",'"+wart+"'"
    
                        elif pole in ['limit_procent','limit_dni']:
                            KOLUMNY+=","+pole
                            VALUES+=","+str(wart)
                        elif pole == 'typ':
                            KOLUMNY+=","+pole
                            VALUES+=",'"+wart.upper()+"'"
    
                    KOLUMNY+=")"
                    VALUES+=");"
                    sqlIns+=INSERT+KOLUMNY+VALUES
                if stat == 'OK' and sqlIns<>'': 
                    stat,dump,dump,dump=self.PolSQL.Execute(rsglobal.Dekoduj(sqlIns),1)
                    if stat<>'OK':
                        stat="Bd przy dodawaniu danych: "+stat   
                        dane.append(stat)

#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (1- insert 1 -select, 1 -delete), (5-odczyt)
#-------------------------------------------------------------------------------

if Funkcja in (1,5) and stat == 'OK':
    if Typ == 'K':
        UprPrzegl = ((self.oddzial_id,'012140') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID
    else:
        UprPrzegl = ((self.oddzial_id,'013120') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID
    
    if not UprPrzegl:
        stat = 'Brak uprawnie do przegldania danych'
        
    if stat == 'OK':
        SQL ="SELECT a.artykul_id,b.nazwa,a.kontrahent_id,c.nazwa,a.limit_procent,a.limit_dni,a.typ"
        SQL+=" FROM rs_artykuly_limity_przydatnosci a"
        SQL+=" INNER JOIN rs_artykuly b ON (a.firma_id=b.firma_id AND a.artykul_id=b.artykul_id)"
        SQL+=" INNER JOIN rs_kontrahenci c ON (a.firma_id=c.firma_id AND a.kontrahent_id=c.kontrahent_id)"
        SQL+=" WHERE a.firma_id='"+self.firma_id+"'"
        
        #dane filtru uzywane tylko przy zwyklym odczycie do grida
        if Typ == 'K':
            SQL += " AND a.artykul_id LIKE '" + ArtykulF + "%'"
            SQL += " AND a.kontrahent_id = '" + KontrahentF + "'"
        else:
            SQL += " AND a.artykul_id = '" + ArtykulF + "'"
            SQL += " AND a.kontrahent_id LIKE '" + KontrahentF + "%'"
            
        SQL+=" ORDER BY a.artykul_id ;"
        stat,dane,wyn1,wyn2 = self.PolSQL.Execute(SQL,3)
        if stat <> 'OK':
            stat = "Bd przy pobieraniu danych: "+stat
            dane.append(stat)