# -*- coding: iso8859_2 -*-

#-----------------------------------------------------------------------------
# Name:        fs_artykuly_podaj_dane.py
# Purpose:     podaje opis,upust,jm i ceny artykulu
#
# Author:      Marcin Grzda
# Created:     2008/01/28
# RCS-ID:      $Id: fs_artykuly_podaj_dane.py $
# Copyright:   (c) 2008 Record System
# Licence:     GNU GPL
#-----------------------------------------------------------------------------
# 2009.12.23 Micha Raburski (4151) - zmiany w pobieraniu vat

# klucze[0] - kontrahent
# klucze[1] - symbol artykulu
# klucze[2] - wersja cenowa
# klucze[3] - waluta
# klucze[4] - kurs
# klucze[5] - data
# klucze[6] - wyznacznik faktury
# klucze[7] - numer faktury
# wraca z opisem, upustem,jm, cenami,stawka vat i przelicznikiem
from funkcje import fs_global_ceny_kontrahenta
import rsglobal

Kontr = klucze[0]
Art = klucze[1]
Wersja = klucze[2]
Waluta = klucze[3]
Kurs = klucze[4]
Data = klucze[5]
Wyzn = klucze[6]
Nr = klucze[7]
Tabela=klucze[8]
Upust=-1

Opis=''
Jm1=''
Jm2=''
StawkaVAT='-1'
Przel=1
Kraj='PL'
NiePodlegaVAT=False
CzyZlom=False

dane=[]
if ((self.oddzial_id,'013010') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
    SQL="SELECT nazwa,rsf_podaj_vat_artykulu(firma_id,artykul_id,'"+Data+"'),przelicznik,jm1,jm2,dynamiczny_przelicznik,faktura_w_jm2 FROM rs_artykuly "
    SQL+=" WHERE firma_id='"+self.firma_id+"' AND artykul_id='"+Art+"';"
    stat,wyn,dump,dump = self.PolSQL.Execute(SQL,3)
    if stat<>'OK':
        stat='Bdy transmisji 1. Poinformuj serwis : '+stat
        dane=[stat]
    elif len(wyn)==0:
        stat='Brak artykuu o kodzie '+Art
    else:
        Opis=wyn[0][0]
        StawkaVAT=wyn[0][1]
        Przel=wyn[0][2]
        Jm1=wyn[0][3]
        Jm2=wyn[0][4]
        DynamPrzel=wyn[0][5]
        FakturaJm2=wyn[0][6]
        
if (Wersja== None or Waluta==None or Kurs==None) and stat=='OK':
    if Wersja==None:
        Wersja='BRAK'
    if Waluta==None:
        Waluta='PLN'
    if Kurs==None:
        Kurs=1
    if Wyzn <> None and Nr <> None and Tabela.strip()<>'rs_zamowienia_odbiorcy': #----zamowieniach odbiorcy nie ma podanego kraju_opodatkowania dlatego nie mozemy skorzystac z tej funkcji
        stat,fakt,dump,dump = self.PolSQL.Execute("SELECT wersja,waluta,kurs,kraj_opodatkowania,nie_podlega_vat FROM "+Tabela+" WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyzn+"' AND data='"+Data+"' AND numer="+str(Nr)+";",3)                
        if stat<>'OK':
            stat='Bdy transmisji 2. Poinformuj serwis'
        else:
            if len(fakt)>0:
                if Wersja=='BRAK':
                    Wersja=rsglobal.Dekoduj(fakt[0][0])
                Waluta=rsglobal.Dekoduj(fakt[0][1])
                Kurs=fakt[0][2]
                Kraj=fakt[0][3] 
                NiePodlegaVAT=fakt[0][4] 
    elif Wyzn<>None and Nr<>None:    
        # obrbka dla zamwie odbiorcy
        stat,fakt,dump,dump = self.PolSQL.Execute("SELECT wersja,waluta,kurs FROM "+Tabela+" WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyzn+"' AND data='"+Data+"' AND numer="+str(Nr)+";",3)                
        if stat<>'OK':
            stat='Bdy transmisji 2. Poinformuj serwis'        
        else:
            if len(fakt)>0:
                if Wersja=='BRAK':
                    Wersja=rsglobal.Dekoduj(fakt[0][0])
                Waluta=rsglobal.Dekoduj(fakt[0][1])
                Kurs=fakt[0][2]
                Kraj='PL'

if stat=='OK' and Wyzn <> None:
    SQL="SELECT typ_faktury FROM rs_wyznaczniki WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyzn+"'"
    stat,DWyzn,dump,dump = self.PolSQL.Execute(SQL,3)                    
    if stat=='OK':
        if len(DWyzn)==0:
            stat="Podano nieistniejcy wyznacznik faktury"
        elif DWyzn[0][0]=='ZL':
            CzyZlom=True            
    
if stat=='OK':
    ceny=fs_global_ceny_kontrahenta.PodajCenyDlaKontrahenta(self,self.firma_id,Kontr,Waluta,Data,Art,Wersja,Upust)
    if ceny<>None:
        Upust=ceny[8]
        CenaN1=rsglobal.RSRound(ceny[0]*Kurs,2)
        CenaN2=rsglobal.RSRound(ceny[1]*Kurs,2)
        CenaB1=rsglobal.RSRound(ceny[2]*Kurs,2)        
        CenaB2=rsglobal.RSRound(ceny[3]*Kurs,2)
        CenaWN1=rsglobal.RSRound(ceny[0],2)
        CenaWN2=rsglobal.RSRound(ceny[1],2)
        CenaWB1=rsglobal.RSRound(ceny[2],2)
        CenaWB2=rsglobal.RSRound(ceny[3],2)
            
        CenaN1U=rsglobal.RSRound(CenaN1*((100-Upust)*0.01),2)
        CenaN2U=rsglobal.RSRound(CenaN2*((100-Upust)*0.01),2)
        CenaB1U=rsglobal.RSRound(CenaB1*((100-Upust)*0.01),2)
        CenaB2U=rsglobal.RSRound(CenaB2*((100-Upust)*0.01),2)
        CenaWN1U=rsglobal.RSRound(CenaWN1*((100-Upust)*0.01),2)
        CenaWN2U=rsglobal.RSRound(CenaWN2*((100-Upust)*0.01),2)
        CenaWB1U=rsglobal.RSRound(CenaWB1*((100-Upust)*0.01),2)
        CenaWB2U=rsglobal.RSRound(CenaWB2*((100-Upust)*0.01),2)
    else:
        Upust=0
        CenaN1=0
        CenaN2=0
        CenaB1=0        
        CenaB2=0
        CenaWN1=0
        CenaWN2=0
        CenaWB1=0
        CenaWB2=0
            
        CenaN1U=0
        CenaN2U=0
        CenaB1U=0
        CenaB2U=0
        CenaWN1U=0
        CenaWN2U=0
        CenaWB1U=0
        CenaWB2U=0      
                
    dane=[Opis,StawkaVAT,Przel,Jm1,Jm2,Upust,CenaN1,CenaN2,CenaB1,CenaB2,CenaWN1,CenaWN2, # 0-11
          CenaWB1,CenaWB2,CenaN1U,CenaN2U,CenaB1U,CenaB2U,CenaWN1U,CenaWN2U,CenaWB1U,CenaWB2U,DynamPrzel,FakturaJm2] # 12-23
    
    if CzyZlom:
        dane[1]='oo'
    elif NiePodlegaVAT:
        dane[1]='np'
                    
    if Kraj<>'PL':
        if not NiePodlegaVAT:
            dane[1]='00'
        dane[8]=dane[6]
        dane[9]=dane[7]
        dane[12]=dane[10]
        dane[13]=dane[11]
        dane[16]=dane[14]
        dane[17]=dane[15]
        dane[20]=dane[18]
        dane[21]=dane[19]