# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_artykuly_rezerwacje.py
# Purpose:     rezerwacje artykulw - wprowadzanie i wyswietlanie
# Author:      Pawe Wjcikowski
# Created:     2009-09-28  
# RCS-ID:      $Id: fs_artykuly_rezerwacje.py $
# Copyright:   (c) 2009 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

ArtykulF = string.strip(klucze[0])
KontrahentF = string.strip(klucze[1])
MagazynF = string.strip(klucze[2])
HandlowiecF = string.strip(klucze[3])
AktywneF = klucze[4]
RezerwacjaId = klucze[5]
Klucze = klucze[6]
OddzialF = klucze[7]
KluczeZam=klucze[8]
KluczePozZam=klucze[9]
Fun = klucze[-1]
dane = []
stat = 'OK'
magazyny=[]
handlowiec=''

UprZamykanie=((self.oddzial_id,'039016') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)


#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH Z NAGLOWKA ZAMOWIENIA (15)
#-------------------------------------------------------------------------------

if Fun == 15 and stat=='OK':
    Select="SELECT kontrahent_id,handlowiec,COALESCE(dostawy_do_dnia::TEXT,'') FROM rs_zamowienia_odbiorcy WHERE "
    Select+="firma_id='"+self.firma_id+"' AND wyznacznik_id='"+rsglobal.Dekoduj(KluczeZam[0])+"' AND data='"+rsglobal.Dekoduj(KluczeZam[1])+"' AND numer="+str(KluczeZam[2])+";"
    stat,dane,dump,dump = self.PolSQL.Execute(Select ,3)


#-------------------------------------------------------------------------------
#---   ZAMYKANIE REZERWACJI (6)
#-------------------------------------------------------------------------------

if Fun == 6 and stat=='OK':
    if not UprZamykanie:
        stat = 'Brak uprawnie do zamykania.'
        dane.append(stat)
        
    if stat=='OK':
        Select="SELECT artykul_id,magazyn_id,rezerwacja,zrealizowano FROM rs_artykuly_rezerwacje WHERE "
        Select+="firma_id='"+self.firma_id+"' AND rezerwacja_id='"+str(RezerwacjaId)+"';"
        stat,d,dump,dump = self.PolSQL.Execute(Select ,3)
        if stat<>'OK':
            stat = 'Bdy w pobieraniu rezerwacji :'+stat
            dane.append(stat) 
        else:
            if len(d) <> 0:
                artykul=d[0][0]
                magazyn=d[0][1]
                rezerw=d[0][2]
                zrealizow=d[0][3] 
        if stat=='OK':  
            Select="SELECT przelicznik FROM rs_artykuly WHERE "
            Select+="firma_id='"+self.firma_id+"' AND artykul_id='"+str(artykul)+"';"
            stat,d,dump,dump = self.PolSQL.Execute(Select ,3)
            if stat<>'OK':
                stat = 'Bdy pobierania przelicznika :'+stat
                dane.append(stat) 
            else:
                if len(d) <> 0:
                    przelicznik=d[0][0] 
                    zmiana1=float(rezerw)-float(zrealizow)
                    zmiana2=przelicznik*float(zmiana1)                       
    if stat=='OK':  
        # zdjcie rezerwacji z magazynu   
        SQL="UPDATE rs_artykuly_magazyny SET "
        SQL+="rezerwacja1=rezerwacja1-("+str(zmiana1)+"), "
        SQL+="rezerwacja2=ROUND(rezerwacja2-("+str(zmiana2)+"),2) "        
        SQL+="WHERE firma_id='"+self.firma_id+"' AND artykul_id='"+str(artykul)+"' "
        SQL+="AND magazyn_id='"+str(magazyn)+"';" 
        SQL+="UPDATE rs_artykuly SET "
        SQL+="rezerwacja1=rezerwacja1-("+str(zmiana1)+"), "
        SQL+="rezerwacja2=ROUND(rezerwacja2-("+str(zmiana2)+"),2) "        
        SQL+="WHERE firma_id='"+self.firma_id+"' AND artykul_id='"+str(artykul)+"';" 
        SQL+="UPDATE rs_artykuly_rezerwacje SET zamknieta='TRUE' WHERE"
        SQL+=" firma_id='"+self.firma_id+"' AND rezerwacja_id='"+str(RezerwacjaId)+"';"
        stat,dump,dump,dump = self.PolSQL.Execute(SQL ,1)
        

    if stat<>'OK':
        stat = 'Bdy przy zamykaniu rezerwacji:'+stat
        dane.append(stat)
    


#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (1- insert 5 -select 6 - zamykanie)
#-------------------------------------------------------------------------------

if (Fun in [1,6,5,11]) and (stat=='OK') :
    SQL="SELECT handlowiec_id FROM rs_operatorzy WHERE operator_id='"+str(self.operator_id)+"';"
    stat,handl,dump,dump = self.PolSQL.Execute(SQL ,3)
    if stat<>'OK':
        stat = 'Bdy przy sprawdzaniu operatora :'+stat
        dane.append(stat)
    else:
        
        handlowiec=handl[0][0]   
        
        FiltrO=''
        
        if OddzialF<>'':
            SQL="SELECT magazyn_id FROM rs_magazyny WHERE oddzial_id='"+str(OddzialF)+"';"
            stat,mag,dump,dump = self.PolSQL.Execute(SQL ,3)
            if stat<>'OK':
                stat = 'Bdy przy sprawdzaniu oddziau :'+stat
                dane.append(stat)  
            else:
                for x in mag:
                    magazyny.append(str(x)[3:-2])
                if magazyny<>[]:
                    magazyny="("+str(magazyny)[1:-1]+")"
                FiltrO=" AND ar.magazyn_id in "+str(magazyny)+" "   
                      
    
        Filtr="WHERE ar.firma_id='"+self.firma_id+"' "
        if ArtykulF <> '':
            Filtr+=" AND ar.artykul_id='"+str(ArtykulF)+"'"
        if KontrahentF <> '':
            Filtr+=" AND ar.kontrahent_id LIKE '"+str(KontrahentF)+"%'"
        if MagazynF <> '':
            Filtr+=" AND ar.magazyn_id LIKE '"+str(MagazynF)+"%'"
        if HandlowiecF <> '':
            Filtr+=" AND ar.handlowiec_id LIKE '"+str(HandlowiecF)+"%'"
        if handlowiec not in ['','None',None]:
            Filtr+=" AND ar.handlowiec_id='"+str(handlowiec)+"'"
        if AktywneF:
            Filtr+=" AND NOT ar.zamknieta"
        if KluczeZam <> []:
            Filtr+=" AND ar.wyznacznik_id_z='"+rsglobal.Dekoduj(KluczeZam[0])+"' AND ar.data_z='"+rsglobal.Dekoduj(KluczeZam[1])+"' AND ar.numer_z="+str(KluczeZam[2])
        if KluczePozZam <> []:
            Filtr+=" AND ar.nr_poz_z="+KluczePozZam[0]+" AND ar.nr_ppoz_z="+KluczePozZam[1]


        if Klucze <>[]: #uzywane przy dodawaniu , tak zeby dodawana byla widoczna
            for k in Klucze: 
                Filtr+=" OR (ar.firma_id='"+self.firma_id+"' AND ar.rezerwacja_id='"+str(rsglobal.Dekoduj(k[0]))+"')"
        
        Filtr+=FiltrO    
               
        Select ="SELECT ar.kontrahent_id, k.nazwa, ar.artykul_id, a.nazwa,"
        Select+=" ar.magazyn_id, ar.rezerwacja, ar.zrealizowano,"
        Select+=" ar.koniec, ar.zamknieta, ar.czas_rezerwacji, ar.handlowiec_id, h.opis, ar.rezerwacja_id"
        Select+=" FROM rs_artykuly_rezerwacje AS ar "
        Select+=" INNER JOIN rs_kontrahenci k USING (firma_id,kontrahent_id)"
        Select+=" INNER JOIN rs_artykuly a USING (firma_id,artykul_id)"
        Select+=" INNER JOIN rs_handlowcy h ON h.firma_id=ar.firma_id AND h.kod=ar.handlowiec_id"
        Select+=" "+Filtr+" ORDER BY ar.rezerwacja_id;"                                 
        stat,dane,wyn1,tr = self.PolSQL.Execute(Select,3)
        if stat<>'OK':
            stat = 'Bdy pobierania danych :'+stat
            dane.append(stat)