# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_artykuly_stany_mag_drzewko.py
# Purpose:     podaje liste oddzialow i magazynow w ktorych uzytkownik ma prawo przegladac ilosci
#
# Author:      Micha Raburski
#
# Created:     2006/12/11
# RCS-ID:      $Id: fs_artykuly_stany_mag_drzewko.py $
# Copyright:   (c) 2006 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

sql = "SELECT oddzial_id,opis FROM rs_oddzialy"
sql+=" WHERE firma_id='"+self.firma_id+"' AND oddzial_id <> '**' ORDER BY oddzial_id;"
stat,LOddz,dump,dump = self.PolSQL.Execute(sql,2)

sql = "SELECT magazyn_id,opis FROM rs_magazyny"
sql+= " WHERE firma_id='"+self.firma_id+"' AND oddzial_id <> '**' ORDER BY magazyn_id;"
stat,LMag,dump,dump = self.PolSQL.Execute(sql,2)

if self.operator_id == STANDARD_OPERATOR_ID:
    sql ="SELECT oddzial_id,magazyn_id,opis FROM rs_magazyny"
    sql+=" WHERE firma_id='"+self.firma_id+"' ORDER BY oddzial_id,magazyn_id;"
    stat,dane,dump,dump = self.PolSQL.Execute(sql,2)
else:
    sql ="SELECT m.oddzial_id,mu.magazyn_id,m.opis FROM rs_magazyny_upr mu"
    sql+=" INNER JOIN rs_magazyny m USING (firma_id,magazyn_id)"
    sql+=" WHERE mu.firma_id='"+self.firma_id+"'"
    sql+=" AND mu.operator_id IN "+str(self.operatorzy)+" AND mu.ilosc"
    sql+=" ORDER BY m.oddzial_id, mu.magazyn_id;"
    stat,dane,dump,dump = self.PolSQL.Execute(sql,2)

#rsglobal.ZapiszDoLogow('ODDZIALY '+str(LOddz),1)
#rsglobal.ZapiszDoLogow('MAGAZYNY '+str(dane),1)

SMag=[]
SOdd=[]
for mag in dane:
 #   rsglobal.ZapiszDoLogow('MAG '+mag[1],1)
 #   rsglobal.ZapiszDoLogow('ODDZ '+mag[0],1)
    if mag[0]=='**':
        for oddz in LOddz:
            if mag[1]=='**':
                for magl in LMag:
                    if not [oddz[0],magl[0],magl[1]] in SMag:
                        #rsglobal.ZapiszDoLogow('ZAP3 '+str((oddz[0],magl[0])),1)
                        SMag.append([oddz[0],magl[0],magl[1]])
                        if not oddz[0] in SOdd:
                            SOdd.append(rsglobal.Dekoduj(oddz[0]))
            elif not [oddz[0],mag[1],mag[2]] in SMag:
                #rsglobal.ZapiszDoLogow('ZAP1 '+str((oddz[0],mag[1])),1)
                SMag.append([oddz[0],mag[1],mag[2]])
                if not oddz[0] in SOdd:
                    SOdd.append(rsglobal.Dekoduj(oddz[0]))
            
    else:
        if mag[1]=='**':
            for magl in LMag:
                if not [mag[0],magl[0],magl[1]] in SMag:
                    #rsglobal.ZapiszDoLogow('ZAP4 '+str((mag[0],magl[0])),1)
                    SMag.append([mag[0],magl[0],magl[1]])
                    if not mag[0] in SOdd:
                        SOdd.append(rsglobal.Dekoduj(mag[0]))
        elif not [mag[0],mag[1],mag[2]] in SMag:
            #rsglobal.ZapiszDoLogow('ZAP2 '+str((mag[0],mag[1])),1)
            SMag.append([mag[0],mag[1],mag[2]])
            if not mag[0] in SOdd:
                SOdd.append(rsglobal.Dekoduj(mag[0]))

if len(SOdd) > 0:
    sql = "SELECT opis,oddzial_id FROM rs_oddzialy"
    sql+= " WHERE firma_id='"+self.firma_id+"' AND oddzial_id IN ("+str(SOdd)[1:-1]+");"
    stat,wyn1,dump,dump = self.PolSQL.Execute(sql,2)
    #rsglobal.ZapiszDoLogow('WYN1 '+str(wyn1),1)
    #rsglobal.ZapiszDoLogow('SMAG '+str(SMag),1)
else:
    stat = 'Brak uprawnie do przegldania iloci magazynowych w jakimkolwiek magazynie.'
    
SMag.sort(lambda x, y: cmp(x[0]+x[1], y[0]+y[1]))
wyn2 = SMag
#rsglobal.ZapiszDoLogow('WYN2 '+str(wyn2),1)