# -*- coding: iso8859_2 -*-

#-----------------------------------------------------------------------------
# Name:        fs_kontrahenci_upusty_dane.py
# Purpose:     wczytuje/edytuje/dodaje/usuwa wzgldniajc uprawnienia operatora 
#
# Author:      Jarek Plawgo
# Created:     2006/03/27
# RCS-ID:      $Id: fs_kontrahenci_upusty_dane.py $
# Copyright:   (c) 2005 Cybertronika
# Licence:     GNU GPL
#-----------------------------------------------------------------------------

Kontrahent = klucze[0]
Artykul = klucze[1]
Data = klucze[2]
stat="OK"
Fun=klucze[-1]

puste=['    -  -  ',"NULL",'']

UprDel=((self.oddzial_id,'013094') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)
UprIns=((self.oddzial_id,'013093') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)
UprUpd=((self.oddzial_id,'013092') in self.uprawnienia) or UprIns or (self.operator_id == STANDARD_OPERATOR_ID)

#------------------------------------------------------------------------
#---   Sprawdzanie parametrw
#------------------------------------------------------------------------

if Fun in [3,4,5]:
    if Kontrahent=="":
        stat="BR KONT1"   
        dane.append(stat) 
        
    if Artykul=="":
        stat="BR ART"   
        dane.append(stat)
    else:    
        sql="SELECT artykul_id FROM rs_artykuly  WHERE firma_id='"+self.firma_id+"' AND artykul_id='"+Artykul+"';"
        ok,d,dump,dump = self.PolSQL.Execute(sql,2)
        if ok!="OK":
            stat="BL SQL ART"   
            dane.append(stat)
        else:
            if len(d)==0:    
                stat="BL ART"   
                dane.append(stat)
            
#-------------------------------------------------------------------------------
#---   INSERT DANYCH (2- bez pobierania,1- z pobieraniem)
#-------------------------------------------------------------------------------

if Fun in [1,2,3,4] and stat=='OK' :
    if Fun in [1,2] and not UprIns:
        stat='UPR INS'
        dane.append(stat)
    if Fun in [3,4] and not UprUpd:
        stat='UPR UPD'
        dane.append(stat)
    
    if stat=='OK':
        for i in range(len(pola)):
            pole = pola[i]
            wart = wartosci[i]
            
            data_od=Data
            data_do=''
            
            if pole=="data_od":
                if wart=="    -  -  ":
                    wart="NULL"
                    data_do=wart
                    stat='BR DAT OD'
                    dane.append(stat)
                elif not rsglobal.SprawdzCzyToData(wart):
                    stat='BL DAT OD'
                    dane.append(stat)
                else:
                    data_od=wart
                
                if ('data_do' not in pola) and (Fun in [3,4]):
                    "SELECT data_do FROM rs_kontrahenci_upusty WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+Kontrahent+"' AND artykul_id='"+Artykul+"' AND data_od='"+Data+"'"
                    data_do=d[0][0]
             
            
            elif pole=="data_do":
                if wart=="    -  -  ":
                    wart="NULL"
                    data_do=wart
                elif not rsglobal.SprawdzCzyToData(wart):
                    stat='BL DAT DO'
                    dane.append(stat)
                else:
                    data_do=wart
                
                           
            elif pole=="upust":
                if (wart<0) or (wart>100) or (wart==""):
                    stat="BL UPUST"   
                    dane.append(stat)
                else:    
                    upust=wart
                    
            elif pole=="kontrahent_id":
                if wart=='':
                    stat='BR KONT2'
                    dane.append(stat)
                else:
                    sql="SELECT kontrahent_id FROM rs_kontrahenci WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+wart+"';"
                
                    ok,d,dump,dump = self.PolSQL.Execute(sql,2)
                    if ok!="OK":
                        stat="BL SQL KONT"   
                        dane.append(stat)
                    else:
                        if len(d)<1:    
                            stat="BL KONT"   
                            dane.append(stat)
        
        
        if data_od<>'' and data_do<>'':
            if data_od>data_do:
                stat='BL ZAK DAT'
                dane.append(stat)
        
#----------------------------------------------------------------------------
#------------ INSERT (2- bez pobierania, 1- z pobieraniem) 
#---------------------------------------------------------------------------    
    
if Fun in [1,2] and stat == 'OK':
    ins = "INSERT INTO rs_kontrahenci_upusty "
    Pola="firma_id,artykul_id"
    Wartosci="'"+self.firma_id+"','"+Artykul+"'"
    for i in range(len(pola)):
        pole = pola[i]
        wart = wartosci[i]
            
        if pole in ['kontrahent_id']:
            Pola+=","+pole
            Wartosci+=",'"+wart+"'"
            Kontrahent=wart
        if pole in ['data_od']:
            Pola+=","+pole
            Wartosci+=",'"+wart+"'"
            Data=wart
        elif pole in ['upust']:
            Pola+=","+pole
            Wartosci+=","+str(wart)
        elif pole in ['data_do']:
            Pola+=","+pole
            if wart=='    -  -  ':
                Wartosci+=",NULL"
            else:
                Wartosci+=",'"+wart+"'"
    
    ins += " ("+Pola+") VALUES ("+Wartosci+");"
        
    stat,dump,dump,dump = self.PolSQL.Execute(ins ,1)
        
#-------------------------------------------------------------------------------
#---   UPDATE DANYCH (4- bez pobierania, 3- z pobieraniem)
#-------------------------------------------------------------------------------

if Fun in [3,4] and stat == 'OK':
    where = " WHERE firma_id='"+self.firma_id+"' AND artykul_id='"+Artykul+"' AND kontrahent_id='"+Kontrahent+"' AND data_od='"+Data+"' "
    upd = "UPDATE rs_kontrahenci_upusty SET "
        
    for i in range(len(pola)):
        pole = pola[i]
        wart = wartosci[i]
        
        if pole in ['kontrahent_id','data_od']:
            upd+=pole+"='"+wart+"',"
        elif pole in ['upust']:
            upd+=pole+"="+str(wart)+","
        elif pole in ['data_do']:
            if wart in ['    -  -  ',"NULL",'']:
                upd+=pole+"=NULL,"
            else:
                upd+=pole+"='"+wart+"',"

        upd = upd.strip(',')+where
        stat,dump,dump,dump = self.PolSQL.Execute(upd ,1)

#--------------------------------------------------------------------
#----------  POBIERANIE DANYCH (5-select, 3-update z pobr, 1-insert z pobr
#--------------------------------------------------------------------

if Fun in [1,3,5] and stat=='OK':
    sql ="SELECT * FROM rs_kontrahenci_upusty WHERE firma_id='"+self.firma_id+"'"
    sql+=" AND kontrahent_id='"+Kontrahent+"' AND artykul_id='"+Artykul+"' AND data_od='"+Data+"';"
    stat,dane,wyn1,dump = self.PolSQL.Execute(sql,3)
    if stat<>"OK":
        stat="BL SQL PRZ"   
        dane.append(stat) 
