# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_artykuly_wzory_parametry.py
# Purpose:     pobiera parametry z artykuu
# Author:      Micha Raburski
# Created:     2014/11/24
# RCS-ID:      $Id: fs_artykuly_wzory_parametry.py $
# Copyright:   (c) 2014 RecordSystem
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

# FUNKCJE 
# 1 - pobranie parametrw dla wzoru artykuu na podstawie zlecenia w zamwieniach odbiorcw
# 2 - pobranie parametrw na podstawie artykuu
# 3 - pobranie wzoru oddziau
# 4 - zapis wzoru oddziau

stat='OK'
dane=[]
wyn1 = []
wyn2 = []
UprPob = False

if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=='OK':
    Funkcja = klucze['Funkcja']
    
    SlPar={'KlZam':[1], 'Zlec':[1], 'Art':[2], 'Wzor':[4]}    
    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Funkcja,klucze)
    if Lista<>'':
        stat='Uwaga : wywoanie funkcji fs_artykuly_wzory_parametry z numerem '+str(Funkcja)+' bez parametrw: '+Lista
    
    if Funkcja == 1:
        KlZam = rsglobal.Dekoduj(klucze['KlZam'])
        Zlec = rsglobal.Dekoduj(klucze['Zlec'])

        UprPob=((self.oddzial_id,'124021') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)
    if Funkcja == 2:
        Art = rsglobal.Dekoduj(klucze['Art'])

        UprPob=((self.oddzial_id,'013000') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)
    
    if Funkcja == 3:
        UprPob=((self.oddzial_id,'013000') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)
        
    if Funkcja == 4:
        Wzor = rsglobal.Dekoduj(klucze['Wzor'])
        UprPob=((self.oddzial_id,'013000') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)
        
if not UprPob:
    stat = 'Brak uprawnie do pobrania wzoru'

#-------------------------------------------------------------------------------
# (1) pobranie parametrw na podstawie zlecenia w zamwieniach odbiorcw
#-------------------------------------------------------------------------------

if stat =='OK' and Funkcja == 1:
    # uruchomienie funkcji pomocniczej pobierajcej brakujce zmienne dla pozycji zlecenia
    from funkcje import fs_artykuly_wzory_parametry_pom
    stat,dane = fs_artykuly_wzory_parametry_pom.PodajPodzleceniaDlaArtykuluZeWzorem(self,KlZam,Zlec,'','','',True)

#-------------------------------------------------------------------------------
# (2) pobranie parametrw na podstawie artykuu
#-------------------------------------------------------------------------------
    
if stat =='OK' and Funkcja == 2:
    # uruchomienie funkcji pomocniczej pobierajcej brakujce zmienne dla artykuu
    from funkcje import fs_artykuly_wzory_parametry_pom
    stat,dane = fs_artykuly_wzory_parametry_pom.PodajPodzleceniaDlaArtykuluZeWzorem(self,'','',Art,'','',True)
    
#-------------------------------------------------------------------------------
# (3) pobranie wzoru oddziau
#-------------------------------------------------------------------------------
    
if stat =='OK' and Funkcja == 3:
    SQL = "SELECT stale_wzorow_zlecen FROM rs_oddzialy "
    SQL+=" WHERE firma_id = '"+self.firma_id+"' AND oddzial_id = '"+self.oddzial_id+"';"
    stat,dane,dump,dump = self.PolSQL.Execute(SQL,3)
    
#-------------------------------------------------------------------------------
# (4) zapis wzoru oddziau
#-------------------------------------------------------------------------------

if stat =='OK' and Funkcja == 4:
    SQL = "UPDATE rs_oddzialy SET stale_wzorow_zlecen = '"+Wzor+"' "
    SQL+=" WHERE firma_id = '"+self.firma_id+"' AND oddzial_id = '"+self.oddzial_id+"';"
    stat,dump,dump,dump = self.PolSQL.Execute(SQL,1)
