# -*- coding: iso8859_2 -*-
#-----------------------------------------------------------------------------
# Name:        fs_crm_kalendarz.py
# Purpose:     
#
# Author:      Micha Raburski
#
# Created:     2013/06/16
# RCS-ID:      $Id: fs_crm_kalendarz.py $
# Copyright:   (c) 2013 Record System
# Licence:     GNU GPL
#-----------------------------------------------------------------------------
# 2021-03-16  - Aleksander Bargie (12395) Doda trim na imi i nazwisko
stat='OK'
dane=[]
wyn =[]
wyn2=[]

if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=='OK':
    Fun = klucze['Funkcja']
    # 5 - pobieranie danych
    # 8 - usuwanie danych
    
    SlPar={'Kontr':[5,8],'KategKontr':[5,8],'Typ':[5,8],'DataOd':[5,8],'NrZdarzenia':[8]}    
    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Fun,klucze)
    if Lista<>'':
        stat='Uwaga : wywoanie funkcji fs_crm_kalendarz z numerem '+str(Fun)+' bez parametrw: '+Lista

if stat=='OK':
    if Fun in [5,8]:
        Kontr=rsglobal.Dekoduj(klucze['Kontr'])
        KategKontr=rsglobal.Dekoduj(klucze['KategKontr'])
        Typ=rsglobal.Dekoduj(klucze['Typ'])
        DataOd=rsglobal.Dekoduj(klucze['DataOd'])
    
    if Fun in [8,]:
        NrZdarzenia=klucze['NrZdarzenia']

#-------------------------------------------------------------------------------
#---  USUWANIE DANYCH (8)
#-------------------------------------------------------------------------------

if Fun==8 and stat=='OK':        
    if NrZdarzenia<>'':
        SQL="DELETE FROM rs_kalendarz_zdarzenia WHERE firma_id='"+self.firma_id+"' AND zdarzenie_id="+str(NrZdarzenia)+";"
        stat,dump,dump,dump = self.PolSQL.Execute(SQL, 1)
        
#-------------------------------------------------------------------------------
#---  POBRANIE DANYCH (5,8)
#-------------------------------------------------------------------------------

if Fun in (5,8) and stat=='OK':
    # sprawdzenie poprawnoci daty
    if not rsglobal.SprawdzCzyToData(DataOd):
        stat='Podana data od jest nieprawidowa'
        
    if stat=='OK':
        SQL="SELECT kz.zdarzenie_id,ktz.opis,kz.czas::TEXT, kz.temat, kz.opis," # 0 - 4
        SQL+=" kz.czas_trwania, kz.czas_powiadomienia,COALESCE(kz.wyslano::TEXT,''), " # 5 - 7
        #AB 16.03.21r dodanie TRIM
        SQL+=" COALESCE(kz.pracownik_id,''), COALESCE(TRIM(dos.nazwisko)||' '||TRIM(dos.imie),'NIEPRZYPISANE'), " # 8 - 9
        SQL+=" COALESCE(kz.kontrahent_id,''),COALESCE(k.nazwa,'') " # 10 - 11
        SQL+=" FROM rs_kalendarz_zdarzenia kz "
        SQL+=" LEFT OUTER JOIN rs_kontrahenci k USING (firma_id,kontrahent_id)"
        SQL+=" LEFT OUTER JOIN rs_kp_dane_osobowe dos USING (firma_id,pracownik_id)"
        SQL+=" INNER JOIN rs_kalendarz_typy_zdarzen ktz ON (kz.firma_id=ktz.firma_id AND kz.typ=ktz.kod)"
        SQL+=" WHERE kz.firma_id='"+self.firma_id+"'"
        SQL+=" AND kz.czas>='"+DataOd+"'::DATE AND kz.czas<='"+DataOd+"'::DATE + 7"
        if Typ <>'':
            SQL+=" AND kz.typ='"+Typ+"'"
        if Kontr <>'':
            SQL+=" AND kz.kontrahent_id='"+Kontr+"'"
        if KategKontr<>'':
            SQL+=" AND k.kateg_kontrahenta LIKE '"+KategKontr+"%'"
        if self.operator_id <> STANDARD_OPERATOR_ID:
            # filtr na pracownikw
            SQLPrac="SELECT rsf_kadry_lista_dozwolonych_pracownikow('"+self.firma_id+"',"
            SQLPrac+="'"+str(self.operator_id)+"', 'kalendarz_zdarzen');"
            rsglobal.ZapiszDoLogow('SQL '+SQLPrac,1)
            stat,DPrac,dump,dump = self.PolSQL.Execute(SQLPrac, 3)
            rsglobal.ZapiszDoLogow('DPrac '+str(DPrac),1)
            if stat<>'OK':
                stat='Bd pobierania uprawnie do pracownikw :'+stat
            if stat=='OK':
                DPrac=eval(DPrac[0][0])
                stat=DPrac[0]
                if stat<>'OK':
                    stat='Bd pobierania uprawnie do pracownikw :'+stat
                    
            # pobranie numeru pracownika. Jeli ** to ma do wszystkich
            if stat=='OK':
                FiltrPrac=''
                if len(DPrac[1])==0:
                    stat='Operator nie ma przypisanego pracownika. Nie bd wywietlone adne dane w kalendarzu.'
            
            if stat=='OK':
                if not '**' in DPrac[1]:
                    FiltrPrac=" kz.pracownik_id IN ("
                    for prac in DPrac[1]:
                        FiltrPrac+="'"+rsglobal.Dekoduj(prac)+"',"

            if stat=='OK' and FiltrPrac <>'':
                for prac in rsglobal.rseval(DPrac[2][0]):
                    FiltrPrac+="'"+rsglobal.Dekoduj(prac)+"',"
                
                SQL+="AND ("+FiltrPrac.strip(',')+") OR pracownik_id IS NULL) "

        # ustawienie kolejnoci
        if stat=='OK':
            SQL+=" ORDER BY czas;"
            
    # pobranie danych
    if stat=='OK':
        rsglobal.ZapiszDoLogow('SQL '+SQL,1)
        stat,dane,dump,dump = self.PolSQL.Execute(SQL, 3)
        if stat<>'OK':
            stat='Bd pobierania danych kalendarza :'+stat       