# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_crm_kalendarz_dane
# Purpose:     dodawanie/edycja zdarze kalendarza CRM
# Author:      Micha Raburski
# Created:     2013/06/19
# RCS-ID:      $Id: fs_crm_kalendarz_dane.py $
# Copyright:   (c) 2013 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------
# 2021-03-16  - Aleksander Bargie (12395) Doda trim na imi i nazwisko

stat = 'OK'
dane = []
wyn1 = []
wyn2 = []



if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=='OK':
    Fun = klucze['Funkcja']

    SlPar={'Zdarzenie':[3,4,5]}    
    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Fun,klucze)
    if Lista<>'':
        stat='Uwaga : wywoanie funkcji fs_crm_kalendarz_dane z numerem '+str(Fun)+' bez parametrw: '+Lista

    if Fun in [3,4,5]: 
        Zdarzenie=rsglobal.Dekoduj(klucze['Zdarzenie'])

#UprDodawanie = (((self.oddzial_id,'053003') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID))
#UprEdycja = (((self.oddzial_id,'053002') in self.uprawnienia) or UprDodawanie or (self.operator_id == STANDARD_OPERATOR_ID))

#-------------------------------------------------------------------------------
# sprawdzenie uprawnien
#-------------------------------------------------------------------------------

#if Fun in (1,2) and stat == 'OK':
#    if not UprDodawanie:
#        stat = 'BR UPR INS'

#if Fun in (3,4) and stat == 'OK':
#    if not UprEdycja:
#        stat = 'BR UPR UPD'

#-------------------------------------------------------------------------------
# POBRANIE PRACOWNIKA DLA OPERATORA
#-------------------------------------------------------------------------------

if Fun ==11 and stat == 'OK':  #AB 16.03.21r dodanie TRIM
    SQL="SELECT COALESCE(kdo.pracownik_id,''),COALESCE(TRIM(kdo.nazwisko)||' '||TRIM(kdo.imie),'') FROM rs_operatorzy o "
    SQL+=" LEFT OUTER JOIN rs_kp_dane_osobowe kdo ON (kdo.firma_id='"+self.firma_id+"'"
    SQL+=" AND o.pracownik_id=kdo.pracownik_id)WHERE operator_id="+str(self.operator_id)+";"
    stat,dane,dump,dump = self.PolSQL.Execute(SQL, 3)


#-------------------------------------------------------------------------------
# SPRAWDZENIE DANYCH (1,2,3,4)
#-------------------------------------------------------------------------------

if stat == 'OK' and Fun in [1,2,3,4]:
    # uzupenienie parametrw do zapisu do kontrolek czas i czas_pow
    CzasData=''
    CzasGodz=''
    PowData=''
    PowGodz=''
    if Fun in[3,4]:
        SQL="SELECT COALESCE(czas::TEXT,''),COALESCE(czas_powiadomienia::TEXT,'') "
        SQL+="FROM rs_kalendarz_zdarzenia WHERE zdarzenie_id="+str(Zdarzenie)+";"
        stat,DaneCz,dump,dump = self.PolSQL.Execute(SQL, 3)
        if stat=='OK':
            if len(DaneCz)==0:
                stat='Podano numer nieistniejcego zdarzenia'
        
        if stat=='OK':
            if DaneCz[0][0]<>'':
                CzasData=DaneCz[0][0][:10]
                CzasGodz=DaneCz[0][0][11:16]
            if DaneCz[0][1]<>'':
                PowData=DaneCz[0][1][:10]
                PowGodz=DaneCz[0][1][11:16]
    
    if stat=='OK':
        CzyscicWyslano=False
        for i in range(len(pola)):
            pole = pola[i].lower()
            wart = wartosci[i]

            if pole == 'pracownik_id':
                if wart <> '':
                    SQL="SELECT * FROM rs_kp_dane_osobowe WHERE firma_id='"+self.firma_id+"' AND pracownik_id='"+wart+"';"
                    stat,DPrac,dump,dump = self.PolSQL.Execute(SQL, 3)
                    if stat<>'OK':
                        dane.append('Bdy w zapytaniu sprawdzajcym pracownika :'+stat)
                    if len(DPrac)==0:
                        dane.append('BL PRAC')
                    
                    elif stat=='OK':
                        SQLPrac="SELECT rsf_kadry_lista_dozwolonych_pracownikow('"+self.firma_id+"',"
                        SQLPrac+="'"+str(self.operator_id)+"', 'kalendarz_zdarzen');"
                        stat,DPrac,dump,dump = self.PolSQL.Execute(SQLPrac, 3)
                        if stat<>'OK':
                            dane.append('Bd pobierania uprawnie do pracownikw :'+stat)
                        if stat=='OK':
                            DPrac=eval(DPrac[0][0])
                            stat=DPrac[0]
                            if stat<>'OK':
                                dane.append(stat='Bd pobierania uprawnie do pracownikw :'+stat)
                    
                        if stat=='OK':
                            if len(DPrac[1])==0:
                                dane.append('BR UPR PRAC')
            
                        if stat=='OK':
                            if not '**' in DPrac[1]:
                                LPrac=[]
                                for prac in DPrac[1]:
                                    LPrac.append(prac)
                        
                                for prac in DPrac[2]:
                                    LPrac.append(prac)
                
                                if not wart in LPrac:
                                    dane.append('BR UPR PRAC')
              
            elif pole == 'typ':
                if wart == '':
                    dane.append('BR TYP')
                else:
                    sql ="SELECT kod FROM rs_kalendarz_typy_zdarzen"
                    sql+=" WHERE firma_id = '"+self.firma_id+"' AND kod = '"+wart+"';"
                    stat,d,dump,dump = self.PolSQL.Execute(sql, 3)
                    if stat <> 'OK':
                        dane.append('Bd pobrania typu zdarzenia : '+stat)
                    elif len(d) == 0:
                        dane.append('BL TYP')
                        
            elif pole == 'kontrahent_id':
                if wart <> '':
                    sql ="SELECT kontrahent_id FROM rs_kontrahenci"
                    sql+=" WHERE firma_id = '"+self.firma_id+"' AND kontrahent_id = '"+wart+"';"
                    stat,d,dump,dump = self.PolSQL.Execute(sql, 3)
                    if stat <> 'OK':
                        dane.append('Bd pobrania kontrahenta : '+stat)
                    elif len(d) == 0:
                        dane.append('BL KONTR')

            elif pole == 'data':
                if wart.strip() in ['','-  -']:
                    dane.append('BR DATA')
                elif not rsglobal.SprawdzCzyToData(wart):
                    dane.append('BL DATA')
                else:
                    CzasData=wart
                    
            elif pole == 'godz_minuta':
                if wart.strip()==':':
                    dane.append('BR GODZ')
                elif not rsglobal.SprCzyToGodzina(wart):
                    dane.append('BL GODZ')
                else:
                    CzasGodz=wart
                    
            elif pole == 'data_pow':
                if not wart.strip() in ['','-  -']:
                    if not rsglobal.SprawdzCzyToData(wart):
                        dane.append('BL DATA POW')
                    else:
                        PowData=wart
                        CzyscicWyslano=True
                    
            elif pole == 'godz_minuta_pow':
                if not wart.strip()==':':
                    if not rsglobal.SprCzyToGodzina(wart):
                        dane.append('BL GODZ POW')
                    else:
                        PowGodz=wart
                        CzyscicWyslano=True

        # sprawdzenie czy przypomnienie jest caociowo wypenione
        if (PowData<>'' and PowGodz=='') or (PowData=='' and PowGodz<>''):
            dane.append('BL CZAS POW')

        if len(dane) > 0:
            stat = dane[0]

        

#-------------------------------------------------------------------------------
#--- DODAWANIE DANYCH (1 -z pobraniem select  2 - bez pobrania
#-------------------------------------------------------------------------------

if Fun in (1,2) and stat == 'OK':
    ins = "INSERT INTO rs_kalendarz_zdarzenia"
    Pola="firma_id, czas" 
    Wartosci="'"+self.firma_id+"', '"+CzasData+' '+CzasGodz+":00'"
    if PowData<>'':
        Pola+=", czas_powiadomienia"
        Wartosci+=", '"+PowData+' '+PowGodz+":00'"
    if CzyscicWyslano:
        Pola+=", wyslano"
        Wartosci+=",NULL"
    
    for i in range(len(pola)):
        pole = pola[i]
        wart = wartosci[i]
        if pole in ['temat','opis']:
            Pola= Pola+","+pole
            Wartosci= Wartosci+",'"+wart+"'"
            
        elif pole in ['pracownik_id','kontrahent_id','typ']: 
            Pola= Pola+","+pole
            
            if wart<>'':
                Wartosci= Wartosci+",'"+wart+"'"
            else:                 
                Wartosci= Wartosci+",NULL"
                
    ins = ins+" ("+Pola+") VALUES ("+Wartosci+");"        
    stat,dump,dump,dump = self.PolSQL.Execute(ins,1)
    if stat <> 'OK':
        stat = 'Bd dodawania nowego zdarzenia : '+stat
        dane.append(stat)


#-------------------------------------------------------------------------------
#--- UPDATE DANYCH ( 3-select, 4 -update z pobraniem)
#-------------------------------------------------------------------------------
rsglobal.ZapiszDoLogow('Fun '+str(Fun)+' '+stat,1)        
if Fun in (3,4) and stat == 'OK':
    upd = "UPDATE rs_kalendarz_zdarzenia SET "
    WHERE=" WHERE firma_id = '"+self.firma_id+"' and zdarzenie_id = '"+str(Zdarzenie)+"';"
        
    Pola=',czas'
    Wartosci=",'"+CzasData+' '+CzasGodz+":00'"
    Pola+=',czas_powiadomienia'
    if PowData=='':
        Wartosci+=",NULL"
    else:
        Wartosci+=", '"+PowData+' '+PowGodz+":00'"
    rsglobal.ZapiszDoLogow('Pola '+Pola,1)        
    rsglobal.ZapiszDoLogow('Wart '+Wartosci,1)        
    if CzyscicWyslano:
        Pola+=", wyslano"
        Wartosci+=",NULL"
    
    for i in range(len(pola)):
        pole = pola[i]
        wart = wartosci[i]
        
        if pole in ['temat','opis']:
            Pola= Pola+","+pole
            Wartosci= Wartosci+",'"+wart+"'"
            
        elif pole in ['pracownik_id','kontrahent_id','typ']: 
            Pola= Pola+","+pole
            
            if wart<>'':
                Wartosci= Wartosci+",'"+wart+"'"
            else:                 
                Wartosci= Wartosci+",NULL"
    
    rsglobal.ZapiszDoLogow('Pola '+Pola,1)        
    rsglobal.ZapiszDoLogow('Wart '+Wartosci,1)        
    upd = upd+" ("+Pola[1:]+") = ("+Wartosci[1:]+")" + WHERE
    rsglobal.ZapiszDoLogow('upd '+upd,1)        
    stat,dump,dump,dump = self.PolSQL.Execute(upd,1)        
    if stat <> 'OK':
        stat = 'Bd aktualizacji zdarzenia : '+stat
        dane.append(stat)


#-------------------------------------------------------------------------------
#--- POBRANIE DANYCH ( 5-select)
#-------------------------------------------------------------------------------

if Fun in [5,] and stat=='OK':
    SQL ="SELECT zdarzenie_id,pracownik_id,kontrahent_id,typ,temat,opis,"
    SQL+="COALESCE(SUBSTRING(czas::TEXT FOR 10),'-  -') AS data,"
    SQL+="COALESCE(SUBSTRING(czas::TEXT FROM 12 FOR 5),':') AS godz_minuta,"
    SQL+="COALESCE(SUBSTRING(czas_powiadomienia::TEXT FOR 10),'-  -') AS data_pow,"
    SQL+="COALESCE(SUBSTRING(czas_powiadomienia::TEXT FROM 12 FOR 5),':') AS godz_minuta_pow,"
    SQL+="COALESCE(SUBSTRING(wyslano::TEXT FOR 16),'') AS wyslano,"
    SQL+=" z_op_id, z_czas"
    SQL+=" FROM rs_kalendarz_zdarzenia "
    SQL+=" WHERE firma_id='"+self.firma_id+"' AND zdarzenie_id="+str(Zdarzenie)+";"
    stat,dane,wyn1,dump = self.PolSQL.Execute(SQL,3)    
    if stat <> 'OK':
        stat = 'Bd pobrania danych szkolenia : '+stat
        dane.append(stat)

    if stat == 'OK':
        tr = rssql.RSTableRowset(dane,wyn1)

        # [0] nazwisko i imi pracownika
        if tr.GetVal(0,"pracownik_id")<>'None':
            if (self.oddzial_id,'052000') in self.uprawnienia or self.operator_id == STANDARD_OPERATOR_ID:
                sql ="SELECT TRIM(nazwisko)||' '||TRIM(imie) FROM rs_kp_dane_osobowe"  #AB 16.03.21r dodanie TRIM
                sql+=" WHERE firma_id='"+self.firma_id+"' AND pracownik_id='"+tr.GetVal(0,"pracownik_id")+"';"
                stat,d,dump,dump = self.PolSQL.Execute(sql, 3)
                if stat <> 'OK':
                    wyn2.append('Bd pobrania nazwiska i imienia pracownika : '+stat)
                else:
                    if len(d) == 0:
                        wyn2.append('Bdny kod pracownika.')
                    else:
                        wyn2.append(d[0][0])
            else:
                wyn2.append('Brak uprawnie do sownika. Poinformuj administratora.')
        else:
            wyn2.append('')

        # [1] nazwa kontrahenta
        if tr.GetVal(0,"kontrahent_id")<>'None':
            if (self.oddzial_id,'012000') in self.uprawnienia or self.operator_id == STANDARD_OPERATOR_ID:
                sql ="SELECT nazwa FROM rs_kontrahenci"
                sql+=" WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+tr.GetVal(0,"kontrahent_id")+"';"
                stat,d,dump,dump = self.PolSQL.Execute(sql, 3)
                if stat <> 'OK':
                    wyn2.append('Bd pobrania opisu z kartoteki kontrahentw : '+stat)
                else:
                    if len(d) == 0:
                        wyn2.append('Bdny kod kontrahenta.')
                    else:
                        wyn2.append(d[0][0])
            else:
                wyn2.append('Brak uprawnie do sownika. Poinformuj administratora.')
        else:
            wyn2.append('')
            
        # [2] nazwa typu zdarzenia
        if tr.GetVal(0,"typ")<>'None':
            if (self.oddzial_id,'021120') in self.uprawnienia or self.operator_id == STANDARD_OPERATOR_ID:
                sql ="SELECT opis FROM rs_kalendarz_typy_zdarzen"
                sql+=" WHERE firma_id='"+self.firma_id+"' AND kod='"+tr.GetVal(0,"typ")+"';"
                stat,d,dump,dump = self.PolSQL.Execute(sql, 3)
                if stat <> 'OK':
                    wyn2.append('Bd pobrania opisu ze sownika typw zdarze : '+stat)
                else:
                    if len(d) == 0:
                        wyn2.append('Bdny typ zdarzenia.')
                    else:
                        wyn2.append(d[0][0])
            else:
                wyn2.append('Brak uprawnie do sownika. Poinformuj administratora.')
        else:
            wyn2.append('')