# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_crm_windykacja.py
# Purpose:     pobieranie danych na grida windykacji
#
# Author:      Micha Raburski
#
# Created:     2011/12/30
# RCS-ID:      $Id: fs_crm_windykacja.py $
# Copyright:   (c) 2011 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

from funkcje import fs_rozrachunki_pom

Fun=klucze[-1]

stat='OK'
dane=[]

# pobranie danych
if Fun==1:
    Kontr=klucze[0]
    Kateg=klucze[1]
    NaDzien=klucze[2]
    if NaDzien.strip() in ['','-  -','None']:
        NaDzien=rsglobal.PodajDzis()
    KontoOdb=klucze[3]
    KontoDost=klucze[4]
    Region=klucze[5]
    SposPlat=klucze[6]
    Okres1=klucze[7]
    Okres2=klucze[8]
    Okres3=klucze[9]
    Okres4=klucze[10]
    Okres5=klucze[11]
    Okres6=klucze[12]
    
    if Kontr=='' and Kateg=='' and KontoOdb=='' and KontoDost=='':
        stat='Nie podano ani kontrahenta ani kategorii ani adnego konta'
        
    if not rsglobal.SprawdzCzyToData(NaDzien):
        stat='Bdna data na dzi'
        
    SQL="SELECT okres_id FROM rs_definicje_okresow WHERE firma_id='"+self.firma_id+"' AND '"+NaDzien+"' BETWEEN data_od AND data_do"
    stat,DZakr,dump,dump=self.PolSQL.Execute(SQL,3)
    if stat!="OK":
        stat="Bd zapytania pobierajcego okres dla daty:"+stat    
    elif len(DZakr)==0:
        stat="Brak okresu obrachunkowego pasujcego do daty"
    else:
        Okres=DZakr[0][0]
            
    
    if stat=='OK':
        if KontoOdb == '' and KontoDost=='':
            WarOdb=" ((k.odbiorca OR k.pracownik) AND (CASE WHEN COALESCE(k.konto_odbiorca,'')='' THEN TRUE "
            WarOdb+=" ELSE r.konto::BYTEA>=k.konto_odbiorca::BYTEA AND r.konto::BYTEA<=(k.konto_odbiorca||'}')::BYTEA END))"
            WarDost=" ((k.dostawca OR k.pracownik) AND (CASE WHEN COALESCE(k.konto_dostawca,'')='' THEN TRUE "
            WarDost+=" ELSE r.konto::BYTEA>=k.konto_dostawca::BYTEA AND r.konto::BYTEA<=(k.konto_dostawca||'}')::BYTEA END))"
        else:
            WarOdb='FALSE'
            WarDost='FALSE'
            
            if KontoOdb <> '':
                WarOdb="((k.odbiorca OR k.pracownik) AND r.konto::BYTEA>='"+KontoOdb+"'::BYTEA AND r.konto::BYTEA<=('"+KontoOdb+"'||'}')::BYTEA)"
           
            if KontoDost <> '':
                WarDost="((k.dostawca OR k.pracownik) AND r.konto::BYTEA>='"+KontoDost+"'::BYTEA AND r.konto::BYTEA<=('"+KontoDost+"'||'}')::BYTEA)"
            
        # pobranie okresu/w z uwzgldnieniem istnienia BO
        stat,LOkr=fs_rozrachunki_pom.PodajOkresyDlaRozrachunkow(self,Okres)
        if stat <>'OK':
            stat = 'Bdy pobierania okresw :'+stat
            
    if stat=='OK':
        LOkr=LOkr[0]
        
        # pobranie listy kont i kontrahentw pasujcych do raportu
        # kontrahent,nazwa,konto, czy konto odb, czy konto dost, data rozlicz, #0-5
        # termin plat,kwota_wn,saldo_wn,rozliczone_wn                          #6-9
        # kwota_ma,saldo_ma,rozliczone_ma                                      #10-12
        SQL="SELECT k.kontrahent_id,k.nazwa,r.konto, "+WarOdb+","+WarDost+",COALESCE(r.data_rozlicz::TEXT,''),"
        SQL+="COALESCE(r.termin_plat::TEXT,''),COALESCE(kwota_bo_wn,kwota_wn),r.saldo_wn,r.rozliczone_wn,"
        SQL+="COALESCE(kwota_bo_ma,kwota_ma),r.saldo_ma,r.rozliczone_ma"
        SQL+=" FROM rs_rozrachunki r INNER JOIN rs_kontrahenci k ON (k.firma_id=r.firma_id AND "
        SQL+=" (k.kontrahent_id=r.kontrahent_id OR k.kontrahent_id=regexp_replace(r.konto,'^.*-',''))) "
        # filtr na konto odbiorcy/dostawcy z rs_kontrahenci
        SQL+=" WHERE r.firma_id='"+self.firma_id+"' AND r.okres_id IN ("+LOkr+") "
        if Kontr<>'':
            SQL+=" AND k.kontrahent_id='"+Kontr+"'"
        if Kateg<>'':
            SQLKateg="SELECT kontrahent_id FROM rs_kontrahenci WHERE firma_id='"+self.firma_id+"' AND kateg_kontrahenta='"+Kateg+"';"
            stat,DKateg,dump,dump=self.PolSQL.Execute(SQLKateg,3)
            if stat!="OK":
                stat="Bd zapytania pobierajcego kontrahentw dla kategorii:"+stat    
            elif len(DKateg)==0:
                stat="Brak kontrahentw dla podanej kategorii"
            else:
                #SQL+=" AND TRIM(k.kateg_kontrahenta)=TRIM('"+Kateg+"')"
                SQL+=" AND k.kontrahent_id IN ("
                for poz in DKateg:
                    SQL+="'"+rsglobal.Dekoduj(poz[0])+"',"
                SQL=SQL.strip(',')
                SQL+=")"                
            
    if stat=='OK':    
        SQL+=" AND ("+WarOdb+" OR "+WarDost+")"
            
        if SposPlat<>'':
            SQL+=" AND k.spos_zaplaty='"+SposPlat+"'"
        
        if NaDzien==rsglobal.PodajDzis():
            SQL+=" AND r.data_rozlicz IS NULL " 
        else:
            SQL+=" AND r.data<='"+NaDzien+"'" 
        
        if Region<>'':
            SQL+=" AND k.region LIKE '"+Region+"%'"
    if stat=='OK':
        stat,DRoz,dump,dump=self.PolSQL.Execute(SQL,3)
        if stat!="OK":
            stat="Bd zapytania pobierajcego dane rozrachunkw:"+stat    
        
    if stat=='OK':
        # pobranie dat wynikajcych z okresw
        SQL="SELECT '"+NaDzien+"'::DATE - "+str(Okres1)+",'"+NaDzien+"'::DATE - "+str(Okres2)
        SQL+=",'"+NaDzien+"'::DATE - "+str(Okres3)+",'"+NaDzien+"'::DATE - "+str(Okres4)
        SQL+=",'"+NaDzien+"'::DATE - "+str(Okres5)+",'"+NaDzien+"'::DATE - "+str(Okres6)+";"
        stat,DOkr,dump,dump=self.PolSQL.Execute(SQL,3)
        if stat!="OK":
            stat="Bd zapytania pobierajcego dane okresw:"+stat    
        
        # analiza okresow
        SKonta={}
        for poz in DRoz:
            # klucz to kontrahent+nazwa+konto
            klucz=(poz[0],poz[1],poz[2])
            if not klucz in SKonta:
                SKonta[klucz]=[0,0,0,0,0,0,0,0,0,0,0]
            
            KwotaWn=0
            KwotaMa=0  
            TerminPlat=poz[6]
            
            CzyOdb=poz[3]  
            CzyDost=poz[4]  

            # Przypadek gdy same salda nas interesuj
            if NaDzien==rsglobal.PodajDzis():
                KwotaWn=poz[8]
                KwotaMa=poz[11]
            else:
                # jeli uwzgldnia saldo i rozliczone rozrachunki
                if poz[7]==poz[8]:
                    KwotaWn=poz[8]
                if poz[10]==poz[11]:
                    KwotaMa=poz[11]
                if poz[5]<=NaDzien and not poz[5]=='':
                    KwotaWn=KwotaWn-poz[9]
                    KwotaMa=KwotaMa-poz[12]
        
            #razem
            if CzyOdb:
                SKonta[klucz][0]+=KwotaWn
            else:
                SKonta[klucz][0]+=KwotaMa
            
            #w terminie i kolejne okresy
            if TerminPlat=='' or TerminPlat>=NaDzien:
                if CzyOdb:
                    SKonta[klucz][1]+=KwotaWn
                else:
                    SKonta[klucz][1]+=KwotaMa
            
            elif TerminPlat<NaDzien and (DOkr[0][0]==NaDzien or DOkr[0][0]<=TerminPlat):
                if CzyOdb:
                    SKonta[klucz][2]+=KwotaWn
                else:
                    SKonta[klucz][2]+=KwotaMa
            
            elif TerminPlat<DOkr[0][0] and (DOkr[0][1]==NaDzien or DOkr[0][1]<=TerminPlat):
                if CzyOdb:
                    SKonta[klucz][3]+=KwotaWn
                else:
                    SKonta[klucz][3]+=KwotaMa
                    
            elif TerminPlat<DOkr[0][1] and (DOkr[0][2]==NaDzien or DOkr[0][2]<=TerminPlat):
                if CzyOdb:
                    SKonta[klucz][4]+=KwotaWn
                else:
                    SKonta[klucz][4]+=KwotaMa
                    
            elif TerminPlat<DOkr[0][2] and (DOkr[0][3]==NaDzien or DOkr[0][3]<=TerminPlat):
                if CzyOdb:
                    SKonta[klucz][5]+=KwotaWn
                else:
                    SKonta[klucz][5]+=KwotaMa
                    
            elif TerminPlat<DOkr[0][3] and (DOkr[0][4]==NaDzien or DOkr[0][4]<=TerminPlat):
                if CzyOdb:
                    SKonta[klucz][6]+=KwotaWn
                else:
                    SKonta[klucz][6]+=KwotaMa
                    
            elif TerminPlat<DOkr[0][4] and (DOkr[0][5]==NaDzien or DOkr[0][5]<=TerminPlat):
                if CzyOdb:
                    SKonta[klucz][7]+=KwotaWn
                else:
                    SKonta[klucz][7]+=KwotaMa
                    
            elif TerminPlat<DOkr[0][5]:
                if CzyOdb:
                    SKonta[klucz][8]+=KwotaWn
                else:
                    SKonta[klucz][8]+=KwotaMa
                    
            #wpaty nierozliczone
            if CzyOdb:
                SKonta[klucz][9]+=KwotaMa
            else:
                SKonta[klucz][9]+=KwotaWn
        
        KluczeR=SKonta.keys()
        KluczeR.sort()        

        # rnica wpat, zaokrglenie i zapis do danych
        for kl in KluczeR:
            SKonta[kl][10]=SKonta[kl][0]-SKonta[kl][9]
            for i in range(11):
                SKonta[kl][i]=rsglobal.RSRound(SKonta[kl][i],2)
            dane.append([kl[0],kl[1],kl[2]]+SKonta[kl])
        
# sprawdzenie zgodnoci daty i okresu
if stat=='OK' and Fun==11:
    Data=klucze[0]
    Okres=klucze[1]
    SQL="SELECT '"+Data+"' BETWEEN data_od AND data_do "
    SQL+=" FROM rs_definicje_okresow WHERE firma_id='"+self.firma_id+"' AND okres_id='"+Okres+"';"
    stat,DOkr,dump,dump=self.PolSQL.Execute(SQL,3)
    if stat!="OK":
        stat="Bd zapytania pobierajcego dane okresu:"+stat+"."    
    elif len(DOkr)==0:
        stat="Brak podanego okresu:"+Okres+"."
    elif not DOkr[0][0]:
        stat=" Podana data jest spoza aktualnie wybranego okresu. Moe to spowodowa bdne pobranie danych."