# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_definicje_bankow_w_kursach_walut.py
# Purpose:     obsuga bankw - rde pobierania kursw walut
# Author:      Jan Kaliszewski, niektre elementy z fs_konta_bankowe_dane
# Created:     2009/10/24
# RCS-ID:      $Id: fs_definicje_bankow_w_kursach_walut.py $
# Copyright:   (c) 2009 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------


from rs_pobieranie_kursow_walut import usunImporterKursow

#-------------------------------------------------------------------------------
# Funkcja, klucze i zmienne stanu:

Fun = klucze[-1]

for i, _klucz in enumerate(klucze[:-1]):
    klucze[i] = _klucz.strip()
    
bank_id = klucze[0]
firma_id = self.firma_id

stat = 'OK'
dane = []

#-------------------------------------------------------------------------------
# Ustalenie uprawnie:

if self.operator_id != STANDARD_OPERATOR_ID:
    UprPrz = (self.oddzial_id, '014013') in self.uprawnienia  # moe dod. kursy
    UprUsuw = False  # tylko anakonda
else:
    UprPrz = True
    UprUsuw = True

#-------------------------------------------------------------------------------
#--- DELETE: 6
#-------------------------------------------------------------------------------

if Fun == 6:
    if UprUsuw:
        usunImporterKursow(bank_id)  # zmiana info o banku, trzeba usun importer
        stat, dump, dump, dump = self.PolSQL.Execute(
                "DELETE FROM rs_definicje_bankow_w_kursach_walut"
                " WHERE bank_id='" + bank_id + "'"
                " AND firma_id ='" + firma_id + "'",
                1
        )
        if stat != 'OK':
            stat = 'Wystpi bd podczas usuwania ("%s").' % stat
    else:
        stat = 'Brak uprawnie do usuwania bankw - rde kursw walut.'
          
#-------------------------------------------------------------------------------
#--- SELECT: sam (5) lub po DELETE (6)
#-------------------------------------------------------------------------------

if Fun in (5, 6) and stat == 'OK':
    if UprPrz:    
        stat, dane, wyn1, tr = self.PolSQL.Execute(
                "SELECT bank_id, bank_nazwa, format_pliku"
                " FROM rs_definicje_bankow_w_kursach_walut"
                " WHERE firma_id='" + firma_id + "' ORDER BY bank_id",
                3
        )
        if stat != 'OK':
            stat = 'Wystpi bd podczas pobierania ("%s").' % stat
    else:
        stat = 'Brak uprawnie do przegldania bankw - rde kursw walut.'
