# -*- coding: iso8859_2 -*-
#-----------------------------------------------------------------------------
# Name:        fs_dekretacja_automatyczna_projekty.py
# Purpose:     Wymagana by mona byo odpali podjunkcj w dekretacji automatycznej
# Author:      Micha Raburski    
# Created:     2010/01/12
# RCS-ID:      $Id: fs_dekretacja_automatyczna_projekty.py $
# Copyright:   (c) 2009 Record System
# Licence:     GNU GPL
#-----------------------------------------------------------------------------


def DodajProjektyDzialyDoDowodu(PolSQL,Firma,OkresDekr,Dowod,Nazwa,Data,Numer,TypDok,Dokument,Kontr='NULL'):
    import rsglobal
    
    stat='OK'
    # sprawdzenie, czy trzeba robi projekty dziay
    SQL="SELECT projekty_podzial,zespol_kont FROM rs_wzory_dekretacji WHERE firma_id='"+Firma+"'"
    SQL+=" AND okres_id='"+OkresDekr+"' AND dowod_id='"+Dowod+"' AND nazwa_id='"+Nazwa+"'"
    stat,DWzoru,dump,dump = PolSQL.Execute(SQL,3)                    
    if stat=='OK':
        if not DWzoru[0][0]:
            return 'OK'
    
        PoczKonta=rsglobal.Dekoduj(DWzoru[0][1]).strip()
        
        # sprawdzenie, sumy pozycji do podziau 
        if TypDok in ['F','K']:
            Strona='ma'
        else:
            Strona='wn'
        
        SQL="SELECT SUM(kwota_"+Strona+") FROM rs_dowody_ksiegowe_pozycje WHERE firma_id='"+Firma+"' "
        SQL+=" AND okres_id='"+OkresDekr+"' AND dowod_id='"+Dowod+"' AND nazwa_id='"+Nazwa+"' "
        SQL+=" AND data='"+Data+"' AND numer="+str(Numer)
        SQL+=" AND POSITION(SUBSTRING(konto_"+Strona+" FROM 1 FOR 1) IN '"+PoczKonta+"')>0;"

        stat,DSuma,dump,dump = PolSQL.Execute(SQL,3)                    
    if stat=='OK':
        if DSuma[0][0]==0:
            return 'OK'
    
        KwotaCala=DSuma[0][0]
        Kwota=DSuma[0][0]
        #pobranie projektu z dowodu
        SQL="SELECT projekt_id,COALESCE(kontrahent_id,'NULL') FROM rs_dowody_ksiegowe WHERE firma_id='"+Firma+"' "
        SQL+=" AND okres_id='"+OkresDekr+"' AND dowod_id='"+Dowod+"' AND nazwa_id='"+Nazwa+"' "
        SQL+=" AND data='"+Data+"' AND numer="+str(Numer)+";"
        stat,DDow,dump,dump = PolSQL.Execute(SQL,3)                    
    if stat=='OK':
        Proj=rsglobal.Dekoduj(DDow[0][0]).strip()
        if Kontr=='NULL':
            Kontr=rsglobal.Dekoduj(DDow[0][1])
        
        if Kontr <> 'NULL':
            Kontr="'"+Kontr+"'"
            
        SQL="SELECT numer,dzial_id,handlowiec_id,COALESCE("+Kontr+",kontrahent_id),koszty_proc,przychody_proc FROM rs_projekty_dzialy"
        SQL+=" WHERE firma_id='"+Firma+"' AND projekt_id='"+Proj+"' ORDER BY numer;"
        stat,DDzialy,dump,dump = PolSQL.Execute(SQL,3)                    
    if stat=='OK':
        if len(DDzialy)==0:
            #pobranie z projektu gwnego
            SQL="SELECT 1,dzial_wiad,handlowiec_wiad,"+Kontr+",100,100 FROM rs_projekty"
            SQL+=" WHERE firma_id='"+Firma+"' AND projekt_id='"+Proj+"' AND NOT dzial_wiad IS NULL;"
            stat,DDzialy,dump,dump = PolSQL.Execute(SQL,3)                    
            if stat=='OK':
                if len(DDzialy)==0:
                    if TypDok=='M':
                        return 'Brak danych umoliwiajcych uzupenienie tabeli z rozbiciem dowodu ksigowego wzgldem projektu '+Proj+'. Dokument magazynowy '+Dokument
                    elif TypDok=='F':
                        return 'Brak danych umoliwiajcych uzupenienie tabeli z rozbiciem dowodu ksigowego wzgldem projektu '+Proj+'. Faktura '+Dokument
                    else:
                        return 'Brak danych umoliwiajcych uzupenienie tabeli z rozbiciem dowodu ksigowego wzgldem projektu '+Proj+'. Korekta '+Dokument
                    
    if stat=='OK':
        SQL=""
        Proc=0
        # jeli kosztowy to 4, jeli przychodowy to 5
        KtoryProc=4
        if PoczKonta in ['7','8']:
            KtoryProc=5
        
        for d in DDzialy:
            Proc=round(Proc+d[KtoryProc],1)
            if Proc>100:
                return "Suma procentw przy projekcie "+Proj+" przekracza 100%"
            if Proc==100:
                KwotaPoz=Kwota
            else:
                KwotaPoz=rsglobal.RSRound(KwotaCala*0.01*d[KtoryProc],2)
              
            Kwota=Kwota-KwotaPoz
              
            Dzial=d[1]
            if Dzial in (None,'None',''):
                Dzial='NULL'
            else:
                Dzial="'"+rsglobal.Dekoduj(Dzial)+"'"  
                
            Handlowiec=d[2]
            if Handlowiec in (None,'None',''):
                Handlowiec='NULL'
            else:
                Handlowiec="'"+rsglobal.Dekoduj(Handlowiec)+"'"  
              
            Kontr=d[3]
            if Kontr in (None,'None',''):
                Kontr='NULL'
            else:
                Kontr="'"+rsglobal.Dekoduj(Kontr)+"'"
            
            #skadanie zapytania dodajcego pozycje do tabeli rs_dowody_ksiegowe_projekty
            SQL+="INSERT INTO rs_dowody_ksiegowe_projekty (firma_id,okres_id,dowod_id,nazwa_id,data,numer,"
            SQL+="nr_poz,projekt_id, kontrahent_id, dzial_id,handlowiec_id,kwota_"+Strona+") VALUES "
            SQL+="('"+Firma+"','"+OkresDekr+"','"+Dowod+"','"+Nazwa+"','"+Data+"',"+str(Numer)+","
            SQL+=str(d[0])+",'"+Proj+"',"+Kontr+","+Dzial+","+Handlowiec+","
            SQL+=str(KwotaPoz)+");"
        
        if SQL <> "":
            stat,dump,dump,dump = PolSQL.Execute(SQL,1)        
    return stat