# -*- coding: iso8859_2 -*-
#-----------------------------------------------------------------------------
# Name:        fs_dokumenty_magazynowe_import_z_dow_dost
# Purpose:     importuje pozycje dok. magazynowego z dowodw dostaw
# Author:      Micha Raburski
# Created:     2006/11/16
# Copyright:   (c) 2006 Record System
# Licence:     GNU GPL
#-----------------------------------------------------------------------------
Mag = klucze[0]
Typ= klucze[1]
Data = klucze[2]
Nr = klucze[3]
Tryby = klucze[4]

stat="OK"
dane=[]

UprDodawanie = ((self.oddzial_id,'032023') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)
if not UprDodawanie:
    stat = "BR UPR"
else:
    stat,dane,dump,dump = self.PolSQL.Execute("SELECT typ_dokumentu FROM rs_typy_dokumentow_m WHERE firma_id='"+self.firma_id+"' AND dokument_id='"+Typ+"'",3)
    if dane[0][0]=='W':
        Pole='ilosc_dost1'
    elif dane[0][0]=='P':
        Pole='ilosc_zwr1'
    else:
        stat=u'Niepoprawny rodzaj dokumentu (P/W)'
    
if stat=='OK':
    #zapytanie pobierajce pozycje z dowodw
    SQL="SELECT dd.artykul_id,sum(dd."+Pole+"),round(sum(dd."+Pole+")*a.przelicznik,3) FROM rs_dowody_dostaw_pozycje dd INNER JOIN rs_artykuly a USING (firma_id,artykul_id)"
    SQL+="WHERE dd.firma_id='"+self.firma_id+"' AND dd.oddzial_id='"+self.oddzial_id+"' "
    SQL+="AND (strpos('"+Tryby+"',dd.tryb_dostawy)>0 OR '"+Tryby+"'='') AND dd.data='"+Data+"'"
    SQL+=" GROUP BY dd.artykul_id,a.typ_artykulu,a.przelicznik HAVING sum("+Pole+")>0 AND a.typ_artykulu not in ('31','99') ORDER BY dd.artykul_id;"
    stat,dane,dump,dump = self.PolSQL.Execute(SQL,3)

    if stat != 'OK':
        stat = 'BL_SQL'
    elif not dane:
        stat = 'BR POZ POBR'

    poz=1
    SQL=''
    for d in dane:
        SQL+= "INSERT INTO rs_dokumenty_magazynowe_pozycje"
        SQL+= "(firma_id,magazyn_id,dokument_id,data,numer,nr_poz,nr_ppoz,artykul_id,ilosc1,ilosc2," 
        SQL+= "cena1,cena2,cena_wal1,cena_wal2,nr_serii)"
        SQL+= " VALUES('"+self.firma_id+"','"+Mag+"','"+Typ+"','"+Data+"',"+str(Nr)+","+str(poz)+",0,'"+rsglobal.Dekoduj(d[0])+"',"+str(d[1])+","+str(d[2])+","
        SQL+= "0,0,0,0,NULL);"
        poz=poz+1

    if stat=='OK':
        stat,dump,dump,dump = self.PolSQL.Execute(SQL,1)
