# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_dokumenty_magazynowe_pozycje_po_korektach.py
# Purpose:     grid wirtulany z pozycjami dokumentu z uwzglednieniem korekt
# Author:      Mariusz Rajfura
# Created:     2013/08/08
# RCS-ID:      $Id: fs_dokumenty_magazynowe_pozycje_po_korektach.py
# Copyright:   (c) 2013 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

stat = 'OK'
dane = []
wyn1 = []
wyn2 = {}

if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=='OK':
    Funkcja = klucze['Funkcja']
    
    SlPar={'Magazyn':(5,15), 'Dokument':(5,15), 'Data':(5,15), 'Numer':(5,15)}
    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Funkcja,klucze)
    if Lista<>'':
        stat='Uwaga : wywoanie funkcji fs_dokumenty_magazynowe_pozycje_po_korektach z numerem '+str(Funkcja)+' bez parametrw: '+Lista
        
    if Funkcja in (5,15): 
        Magazyn = rsglobal.Dekoduj(klucze['Magazyn'])
        Dokument = rsglobal.Dekoduj(klucze['Dokument'])
        Data = rsglobal.Dekoduj(klucze['Data'])
        Numer = rsglobal.Dekoduj(klucze['Numer'])
        Artykul = ''
        if klucze.has_key('Artykul'):
            Artykul = rsglobal.Dekoduj(klucze['Artykul'])


#-------------------------------------------------------------------------------
#--- SPRAWDZENIE KOREKT DO DOKUMENTU
#-------------------------------------------------------------------------------
if Funkcja in (15,) and stat == 'OK':
    sql ="SELECT magazyn_id,dokument_id,data,numer"
    sql+=" FROM rs_dokumenty_magazynowe"
    sql+=" WHERE firma_id='"+self.firma_id+"' AND kor_dm_magazyn_id='"+Magazyn+"'"
    sql+=" AND kor_dm_dokument_id='"+Dokument+"' AND kor_dm_data='"+Data+"'"
    sql+=" AND kor_dm_numer="+str(Numer)+";"

    stat,dane,wyn1,dump = self.PolSQL.Execute(sql,3)
    if stat <> 'OK':
        stat = "Bd sprawdzenia korekt do dokumentu: "+stat
        dane.append(stat)


#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (5)
#-------------------------------------------------------------------------------

if Funkcja in (5,) and stat=='OK':
    # dokument zrodlowy
    SQL ="SELECT dmp.nr_poz,dmp.nr_ppoz,dmp.artykul_id,dmp.ilosc1,"
    SQL+=" COALESCE(a.jm1,''),dmp.ilosc2,COALESCE(a.jm2,''),COALESCE(a.nazwa,''),"
    SQL+=" ''"
    SQL+=" FROM rs_dokumenty_magazynowe_pozycje dmp"
    SQL+=" INNER JOIN rs_artykuly a USING(firma_id,artykul_id)"
    SQL+=" WHERE dmp.firma_id='"+self.firma_id+"' AND dmp.magazyn_id='"+Magazyn+"'"
    SQL+=" AND dmp.dokument_id='"+Dokument+"' AND dmp.data='"+Data+"'"
    SQL+=" AND dmp.numer="+str(Numer)
    if Artykul <> '':
        SQL+=" AND dmp.artykul_id='"+Artykul+"'"
    SQL+=" ORDER BY dmp.nr_poz,dmp.nr_ppoz;"

    stat,dane,wyn1,dump = self.PolSQL.Execute(SQL,3)
    if stat <> 'OK':
        stat = "Bd przy pobieraniu danych: "+stat
        dane.append(stat)
        
    if stat == 'OK':
        # pobranie informacji o korektach przypisanych do pozycji dokumentu
        sql ="SELECT dm.stan,tdm.typ_dokumentu,dmp.nr_poz,dmp.nr_ppoz,"     # 0-3    
        sql+=" dmp.magazyn_id,dmp.dokument_id,dmp.data,dmp.numer,"          # 4-7
        sql+=" dmp.artykul_id,COALESCE(a.nazwa,''),"                        # 8-9
        sql+=" dmp.ilosc1,COALESCE(a.jm1,''),dmp.ilosc2,COALESCE(a.jm2,'')" # 10-13
        sql+=" FROM rs_dokumenty_magazynowe_pozycje dmp"
        sql+=" INNER JOIN rs_dokumenty_magazynowe dm USING(firma_id,magazyn_id,dokument_id,data,numer)"
        sql+=" INNER JOIN rs_artykuly a USING(firma_id,artykul_id)"
        sql+=" INNER JOIN rs_typy_dokumentow_m tdm USING(firma_id,dokument_id)"
        sql+=" WHERE dm.firma_id='"+self.firma_id+"' AND dm.kor_dm_magazyn_id='"+Magazyn+"'"
        sql+=" AND dm.kor_dm_dokument_id='"+Dokument+"' AND dm.kor_dm_data='"+Data+"'"
        sql+=" AND dm.kor_dm_numer="+str(Numer)
        if Artykul <> '':
            sql+=" AND dmp.artykul_id='"+Artykul+"'"
        sql+=";"
        
        stat,KorektyPozycje,dump,dump = self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Bd pobrania informacji o korektach do dokumentu: '+stat
        else:
            wyn2['KorektyPozycje'] = KorektyPozycje

        # pobranie informacji o korektach przypisanych do calego dokumentu
        sql ="SELECT dm.stan,tdm.typ_dokumentu,"                # 0-1    
        sql+=" dm.magazyn_id,dm.dokument_id,dm.data,dm.numer"   # 2-5
        sql+=" FROM rs_dokumenty_magazynowe dm"
        sql+=" INNER JOIN rs_typy_dokumentow_m tdm USING(firma_id,dokument_id)"
        sql+=" WHERE dm.firma_id='"+self.firma_id+"' AND dm.kor_dm_magazyn_id='"+Magazyn+"'"
        sql+=" AND dm.kor_dm_dokument_id='"+Dokument+"' AND dm.kor_dm_data='"+Data+"'"
        sql+=" AND dm.kor_dm_numer="+str(Numer)
        sql+=" ORDER BY dm.data;"
        
        stat,KorektyNaglowki,dump,dump = self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Bd pobrania informacji o korektach do dokumentu: '+stat
        else:
            wyn2['KorektyNaglowki'] = KorektyNaglowki 

    if stat == 'OK':
        # pobranie informacji z naglowka korygowanego dokumentu
        sql ="SELECT tdm.typ_dokumentu,dm.stan,"
        sql+=" COALESCE(dm.magazyn_skad,''),COALESCE(dm.magazyn_dokad,'')"
        sql+=" FROM rs_dokumenty_magazynowe dm"
        sql+=" INNER JOIN rs_typy_dokumentow_m tdm USING(firma_id,dokument_id)"
        sql+=" WHERE dm.firma_id='"+self.firma_id+"' AND dm.magazyn_id='"+Magazyn+"'"
        sql+=" AND dm.dokument_id='"+Dokument+"' AND dm.data='"+Data+"'"
        sql+=" AND dm.numer="+str(Numer)+";"
        
        stat,Naglowek,dump,dump = self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Bd pobrania danych z nagwka korygowanego dokumentu: '+stat
        else:
            wyn2['Naglowek'] = Naglowek

