
# -*- coding: iso8859_2 -*-

#-----------------------------------------------------------------------------
# Name:        fs_dokumenty_magazynowe_pozycje_z_produkcji.py
# Purpose:     tworzy pozycje RW na podstawie danych kalkulacyjnych z produkcji
#
# Author:      Micha Raburski
# Created:     2007/06/20
# RCS-ID:      $Id: fs_dokumenty_magazynowe_pozycje_z_produkcji.py $
# Copyright:   (c) 2004-2007 Record System
# Licence:     GNU GPL
#-----------------------------------------------------------------------------

stat='OK'
dane=[]

Magazyn=rsglobal.Dekoduj(klucze[0])
Typ=rsglobal.Dekoduj(klucze[1])
Data=rsglobal.Dekoduj(klucze[2])
Numer=klucze[3]

Funkcja=klucze[-1]

#sprawdzenie typu dokumentu i pobranie numeru zlecenia
stat,d,dump,dump = self.PolSQL.Execute("SELECT tdm.typ_dokumentu,dm.nr_zlecenia,dm.wersja FROM rs_dokumenty_magazynowe dm INNER JOIN rs_typy_dokumentow_m tdm USING (firma_id,dokument_id) WHERE dm.firma_id='"+self.firma_id+"' AND dm.magazyn_id='"+Magazyn+"' AND dm.dokument_id='"+Typ+"' AND dm.data='"+Data+"' AND dm.numer="+str(Numer)+";",3)        
if len(d)==0:
    stat='BL DOK'

elif d[0][0]<>'W':
    stat='BL TYPDOK'

if stat=='OK':
    if d[0][1] in (None,'None',''):
        NrZlec=''
    else:
        NrZlec=d[0][1]
    Wersja=rsglobal.Dekoduj(d[0][2])

if stat=='OK':
    #sprawdzenie czy dokument ma pozycje - jesli tak to nie robimy dalej
    stat,d,dump,dump = self.PolSQL.Execute("SELECT nr_poz FROM rs_dokumenty_magazynowe_pozycje WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+Magazyn+"' AND dokument_id='"+Typ+"' AND data='"+Data+"' AND numer="+str(Numer)+";",3)        
    if len(d)>0:
        stat='ISTN POZ'
        
if stat=='OK':
    #pobranie oddziau
    stat,d,dump,dump = self.PolSQL.Execute("SELECT oddzial_id FROM rs_magazyny WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+Magazyn+"';",3)        
if stat=='OK':
    Oddzial=rsglobal.Dekoduj(d[0][0])

    #pobranie listy magazynw
    stat,d,dump,dump = self.PolSQL.Execute("SELECT DISTINCT magazyn_id FROM rs_magazyny WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+Oddzial+"';",3)        

    if len(d)==0:
        stat='BR MAG'

if stat=='OK':        
    LMag=[]
    for mag in d:
        LMag.append(rsglobal.Dekoduj(mag[0]))
                
    #pobranie listy par magazyn/typ dokumentu
    stat,DaneMD,dump,dump = self.PolSQL.Execute("SELECT DISTINCT dm.magazyn_id,dm.dokument_id FROM rs_dokumenty_magazyny dm INNER JOIN rs_typy_dokumentow_m tdm USING (firma_id,dokument_id) WHERE dm.firma_id='"+self.firma_id+"' AND dm.magazyn_id IN ("+str(LMag)[1:-1]+") AND tdm.typ_dokumentu='P';",3)                

if stat=='OK':            
    #inicjalizacja zmiennych    
       
    #Slownik z kluczem : (zlecenie,artykul) ; warto :[ilosc1,ilosc2,wartosc,ilosc_kalk1,ilosc_kalk2,wartosc_kalk]
    LElem={}
    #Slownik z kluczem : (zlecenie,artykul) ; warto :[ilosc1,ilosc2,wartosc,ilosc_kalk1,ilosc_kalk2,wartosc_kalk]
    LOpak={}
    #Slownik z kluczem : (zlecenie,artykul) ; warto :[ilosc1,ilosc2,wartosc,ilosc_kalk1,ilosc_kalk2,wartosc_kalk]
    LSur={}
    #Slownik z kluczem : (zlecenie,artykul) ; warto :[ilosc1,ilosc2,wartosc,wartosc_kalk]
    LWyr={}  

    #obsluga par magazyn/dokument w petli    
    for para in DaneMD:
        Mag=rsglobal.Dekoduj(para[0])
        Dok=rsglobal.Dekoduj(para[1])
            
        #pobranie danych
        stat,LObroty,dump,dump = self.PolSQL.Execute("SELECT nr_zlecenia,artykul_id,ilosc1,ilosc2,wartosc FROM rs_obroty_magazynowe WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+Mag+"' AND dokument_id='"+Dok+"' AND data='"+str(Data)+"';",3)                
        for obrot in LObroty:
            NrZl=rsglobal.Dekoduj(obrot[0])
            if NrZl == 'None':
                NrZl=''
            
            if NrZl == NrZlec:
                Art=rsglobal.Dekoduj(obrot[1])
                Ilosc1=obrot[2]
                Ilosc2=obrot[3]
                Wart=obrot[4]
                
                Klucz=(NrZlec,Art)
                
                #------------------------------------------
                #PRZYJECIE
                #------------------------------------------

                stat,dane,dump,dump = self.PolSQL.Execute("SELECT typ_artykulu FROM rs_artykuly WHERE firma_id='"+self.firma_id+"' AND artykul_id='"+Art+"'",3)                                    
                    
                if dane[0][0] in ['02','03','11']:
                    #sprawdzenie ceny kalkulacyjnej
                    if Wersja <> 'None':
                        stat,dane,dump,dump = self.PolSQL.Execute("SELECT rsf_podaj_cene_n1('"+self.firma_id+"','"+Art+"','"+Wersja+"','PLN','"+Data+"')",3)                                        
                        CenaK=dane[0][0]
                    else:
                        CenaK=0

                    #pobranie receptury
                    stat,DRec,dump,dump = self.PolSQL.Execute("SELECT rsf_receptury_podaj('"+self.firma_id+"','"+Oddzial+"','"+Art+"','"+Data+"')",3)                
                    #rsglobal.ZapiszDoLogow(str(DRec),1)
                        
                    #Analiza receptury
                    if DRec[0][0] not in ["BR","NZ","[]"]:
                        Rec=rsglobal.rseval(DRec[0][0])
                        for El in Rec:
                            Kl=(NrZlec,El[1])
                                   
                            #Zapisanie surowca
                            if El[0]=='04':
                                if not Kl in LSur:
                                    LSur[Kl]=[0,0,0,El[2]*Ilosc1,El[3]*Ilosc1,0]
                                else:
                                    Sur =LSur[Kl]
                                    Sur[3]=Sur[3]+(El[2]*Ilosc1)
                                    Sur[4]=Sur[4]+(El[3]*Ilosc1)
                                    LSur[Kl]=Sur
                                    
    #------------------------------------------
    # ZAPIS DANYCH
    #------------------------------------------

    # wstawienie surowcw do pozcji dokumentu
    Ins=''
    Poz=1
    for Kl in LSur:
        Sur=LSur[Kl]
        SQL="INSERT INTO rs_dokumenty_magazynowe_pozycje "
        SQL+="(firma_id,magazyn_id,dokument_id,data,numer,nr_poz,nr_ppoz,artykul_id,ilosc1,ilosc2)"
        SQL+=" VALUES "
        SQL+="('"+self.firma_id+"','"+Magazyn+"','"+Typ+"','"+Data+"',"+str(Numer)+","+str(Poz)+",0,'"+Kl[1]+"',"+str(Sur[3])+","+str(Sur[4])+");"
        Poz=Poz+1
        Ins=Ins+SQL

    if Ins<>'':
        self.PolSQL.Execute(Ins,1)
