
# -*- coding: iso8859_2 -*-

#-----------------------------------------------------------------------------
# Name:        fs_dokumenty_magazynowe_sprawdz_filtr.py
# Purpose:     sprawdza czy do filtra zosta podany magazyn lub typ dokumentu 
#
# Author:      Micha Raburski
# Created:     2006/12/19
# RCS-ID:      $Id: fs_dokumenty_magazynowe_sprawdz_filtr.py $
# Copyright:   (c) 2006 Record System
# Licence:     GNU GPL
#-----------------------------------------------------------------------------

Magazyn=klucze[0]
Typ=klucze[1]
stat="OK"
dane = [""]

stat,mag,dump,dump=self.PolSQL.Execute("SELECT magazyn_id FROM rs_magazyny WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+Magazyn+"';",3)
dl=len(mag)
stat,dok,dump,dump=self.PolSQL.Execute("SELECT typ_dokumentu FROM rs_typy_dokumentow_m WHERE firma_id='"+self.firma_id+"' AND dokument_id='"+Typ+"';",3)
dl=dl+len(dok)

if dl>0:
    if (self.operator_id == STANDARD_OPERATOR_ID):
        dane=[""]
    elif dl==2:
        rsglobal.ZapiszDoLogow("SELECT rsf_sprawdz_upr_do_dok('"+self.firma_id+"','"+Magazyn+"','"+Typ+"',6)",1)
        stat,upr,dump,dump=self.PolSQL.Execute("SELECT rsf_sprawdz_upr_do_dok('"+self.firma_id+"','"+Magazyn+"','"+Typ+"',6);",3)        
        if stat=='OK':
            if len(upr)==0:
                #brak danych
                stat="BR UPR 1"
            elif not upr[0][0]:
                #nie ma uprawnie
                stat="BR UPR 1"
            else:
                #wszystko ok
                dane=[""]
                
    # podany jeden magazyn
    elif len(mag)==1:
        SQL="SELECT DISTINCT dokument_id FROM rs_dokumenty_m_upr WHERE firma_id='"+self.firma_id+"' AND dokument_id LIKE '"+Typ+"%' "
        SQL+=" AND magazyn_id='"+Magazyn+"' AND operator_id in "+self.operatorzy
        SQL+" AND (wprowadzanie OR edycja OR usuwanie OR przegladanie OR zamykanie OR otwieranie);"
        stat,upr,dump,dump=self.PolSQL.Execute(SQL,3)        
        if len(upr)==0:
            stat="BR UPR 2"
        else:
            Lu=''
            for u in upr:
                Lu=Lu+"'"+rsglobal.Dekoduj(u[0])+"',"
            dane=["AND dokument_id IN ("+Lu[0:-1]+")"]
    # podany jeden dokument
    elif len(dok)==1:   
        SQL="SELECT DISTINCT magazyn_id FROM rs_dokumenty_m_upr WHERE firma_id='"+self.firma_id+"' AND dokument_id= '"+Typ+"' "
        SQL+=" AND magazyn_id LIKE '"+Magazyn+"%' AND operator_id in "+self.operatorzy
        SQL+" AND (wprowadzanie OR edycja OR usuwanie OR przegladanie OR zamykanie OR otwieranie);"
        stat,upr,dump,dump=self.PolSQL.Execute(SQL,3)        
        if len(upr)==0:
            stat="BR UPR 3"
        else:
            Lu=''
            for u in upr:
                Lu=Lu+"'"+rsglobal.Dekoduj(u[0])+"',"
            dane=["AND (magazyn_skad IN ("+Lu[0:-1]+") OR magazyn_dokad IN ("+Lu[0:-1]+"))"]
else:
    stat="BL FILTR"
    
