# -*- coding: iso8859_2 -*-

#-----------------------------------------------------------------------------
# Name:        fs_dostawy_pobierz_pozycje_zmowien.py
# Purpose:     pobiera pozycje z zamowien dostawcow do pozycji dostaw
#
# Author:      Dariusz Boduch, uzdatnienie : Jan Raburski
# Created:     2008/07/16
# RCS-ID:      $Id: fs_dostawy_pobierz_pozycje_zamowien.py $
# Copyright:   (c) 2006 Record System
# Licence:     GNU GPL
#-----------------------------------------------------------------------------

#2014-01-30 Micha Raburski (7625) przenoszenie cech z zamwienia na dostaw

Kontrahent=klucze[0]
DataDost=klucze[1]
NumerDost=klucze[2]
WyznZd=klucze[3]
DataZd=klucze[4]
NumerZd=klucze[5]
Fun=klucze[-1]

stat = "OK"
dane = []

puste_pola = ['    -  -  ','',[]]

if self.operator_id == STANDARD_OPERATOR_ID:
    UprPrz=True
    UprIns=True
else:
    UprPrz=(self.oddzial_id,'035021') in self.uprawnienia
    UprIns=(self.oddzial_id,'035023') in self.uprawnienia

if stat=='OK':
    if DataDost <> '    -  -  ':
        if not rsglobal.SprawdzCzyToData(DataDost):
            stat='BL DATADOST'
            dan.append(stat)
            
if stat=='OK':
    if DataZd <> '    -  -  ':
        if not rsglobal.SprawdzCzyToData(DataZd):
            stat='BL DATAZD'
            dane.append(stat)
#SPRAWDZANIE DANYCH Z KLUCZA
#KONTRAHENT
if stat=='OK':
    sql = "SELECT kontrahent_id FROM rs_kontrahenci WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+Kontrahent+"';"    
    stat,dane,dump,dump=self.PolSQL.Execute(sql,3)
    if stat<>'OK':
        stat='BL SQL KONTR'
        dane.append(stat)
    if len(dane)==0:
        stat='BL KONTR'
        dane.append(stat)
#DOSTAWA
if stat=='OK':
    sql = "SELECT * FROM rs_dostawy WHERE firma_id='"+self.firma_id+"' AND data='"+DataDost+"' AND numer="+str(NumerDost)+" AND kontrahent_id='"+Kontrahent+"';"
    stat,dane,dump,dump=self.PolSQL.Execute(sql,3)
    if stat<>'OK':
        stat='BL SQL DOST'
        dane.append(stat)
    if len(dane)==0:
        stat='BR DOST'
        dane.append(stat)

#ZAMOWIENIA DOSTAWCY
if stat=='OK':
    if Fun==2:       
        sql = "SELECT * FROM rs_zamowienia_dostawcy WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+WyznZd+"' AND data='"+DataZd+"' AND numer="+str(NumerZd)+" AND kontrahent_id='"+Kontrahent+"' AND stan='A';"
        stat,DZamDost,dump,dump=self.PolSQL.Execute(sql,3)
        if stat<>'OK':
            stat='BL SQL ZD'
            dane.append(stat)
        if len(DZamDost)==0:
            stat='BR ZD'
            dane.append(stat)

if stat=='OK':            
    Select="SELECT zdp.firma_id,zdp.artykul_id, sum(zdp.ilosc1-zdp.anulowano1-zdp.dostarczono1), sum(zdp.ilosc2-zdp.anulowano2-zdp.dostarczono2), "
    Select+="zdp.cena_upust1, zdp.cena_upust2, a.stawka_vat_import, a.stawka_vat,zdp.upust,zdp.cena_netto1,zdp.cena_netto2, "
    Select+=" TRIM(COALESCE(zdp.cecha1_opis,'')),TRIM(COALESCE(zdp.cecha1_wartosc,'')),COALESCE(k.kraj,'PL') "
    Select+=" FROM rs_zamowienia_dostawcy_pozycje zdp "
    Select+=" LEFT OUTER JOIN rs_zamowienia_dostawcy zd ON (zdp.firma_id=zd.firma_id AND zdp.wyznacznik_id=zd.wyznacznik_id AND zdp.data=zd.data AND zdp.numer=zd.numer) "
    Select+=" LEFT OUTER JOIN rs_artykuly a ON(zdp.firma_id=a.firma_id AND zdp.artykul_id=a.artykul_id) "
    Select+=" LEFT OUTER JOIN rs_kontrahenci k on (a.firma_id=k.firma_id AND a.producent_id=k.kontrahent_id)"
    
    Where="WHERE zdp.firma_id='"+self.firma_id+"' AND zd.kontrahent_id='"+Kontrahent+"' AND zd.stan='A' AND zdp.ilosc1-zdp.anulowano1-zdp.dostarczono1>0 "
    GroupBy="GROUP BY k.kraj,zdp.firma_id,zdp.artykul_id, zdp.cena_upust1, zdp.cena_upust2, a.stawka_vat_import, a.stawka_vat,zdp.upust,zdp.cena_netto1,zdp.cena_netto2,zdp.cecha1_opis,zdp.cecha1_wartosc "
    if Fun==2:
        GroupBy+=",zdp.nr_poz"
    OrderBy=" ORDER BY "
    if Fun==2:
        OrderBy+="nr_poz,"
    OrderBy+="zdp.artykul_id, zdp.cena_upust1,zdp.upust,zdp.cena_netto1,zdp.cena_netto2,zdp.cecha1_opis,zdp.cecha1_wartosc"
    UPDATE="pobrane_z_zamowien=True "

    if Fun==2:       
        Where+=" AND zdp.wyznacznik_id='"+WyznZd+"' AND zdp.data='"+DataZd+"' AND zdp.numer="+str(NumerZd)+" "
        UPDATE+=" ,zd_wyznacznik='"+WyznZd+"' , zd_data='"+DataZd+"' , zd_numer="+str(NumerZd)+" " 
    
    stat,DaneZd,dump,dump=self.PolSQL.Execute(Select+Where+GroupBy+OrderBy,3)
     
    if stat<>'OK':
        stat='BL SQL ZD POZ'
        dane.append(stat)
    if len(DaneZd)==0:
        stat='BR POZ'
        dane.append(stat)
        
    
    if stat=='OK':
        NrPoz=1
        WpiszPozycje=False
        Insert=""
        for w in DaneZd:
            stawkavat=str(w[6])
            if stawkavat in ['','None']:
                stawkavat=str(w[7])
            
            Kraj=str(w[13])
            if Kraj in ['','None']:
                Kraj='NULL'
            else:
                Kraj="'"+Kraj+"'"
                
            Insert+="INSERT INTO rs_dostawy_pozycje (firma_id, data, numer, nr_poz, artykul_id, ilosc_zam1, ilosc_zam2, ilosc_dost1, ilosc_dost2, "
            Insert+="cena_upust_wal1, cena_upust_wal2, cena_z_zamowienia1, cena_z_zamowienia2, stawka_vat, "
            Insert+="cena_wal1, cena_wal2, upust_procent,cecha1_opis,cecha1_wartosc,kraj_pochodz) "
            Insert+="VALUES ('"+str(w[0])+"','"+str(DataDost)+"', "+str(int(NumerDost))+","+str(int(NrPoz))+", '"+str(w[1])+"',"+str(w[2])+","+str(w[3])+","+str(w[2])+","+str(w[3])+", "
            Insert+=" "+str(w[4])+","+str(w[5])+","+str(w[4])+","+str(w[5])+",'"+stawkavat+"', "
            Insert+=" "+str(w[9])+","+str(w[10])+","+str(w[8])+",'"+rsglobal.Dekoduj(w[11])+"','"+rsglobal.Dekoduj(w[12])+"',"+Kraj+"); "
            NrPoz=NrPoz+1
        stat,dump,dump,dump=self.PolSQL.Execute(Insert,1)
        if stat<>'OK':
            stat='BL SQL INS'
            dane.append(stat)
        else:
            WpiszPozycje=True
    #wstawienie cen i wartosci odpowiednich na dostawe
    if stat=='OK':
        Select="SELECT kurs,narzut_proc,transport_proc,kurs2,miejsc_po_przecinku FROM rs_dostawy WHERE firma_id='"+self.firma_id+"' AND data='"+DataDost+"' AND numer="+str(NumerDost)
        stat,d,dump,dump=self.PolSQL.Execute(Select,3)
        if stat=='OK' and len(d)>0:
            Kurs=d[0][0]
            Narzut=d[0][1]
            Transport=d[0][2]
            Kurs2=d[0][3]
            IlMPP=str(d[0][4]).rstrip('.0')
                    
            CenaUpust1="round(cena_wal1*(100-upust_procent)*0.01*"+str(Kurs)+"*(100+"+str(Transport)+")*0.01,2)"
            CenaUpust2="round(cena_wal2*(100-upust_procent)*0.01*"+str(Kurs)+"*(100+"+str(Transport)+")*0.01,2)"
            WartoscNetto="round(ilosc_dost1*"+CenaUpust1+",2)"
            WartoscNettoWal="round(ilosc_dost1*cena_upust_wal1,2)"
            WartoscNarzut="round("+WartoscNetto+"*"+str(Narzut)+"*0.01,2)"
            WartoscClo="round(("+WartoscNetto+" + "+WartoscNarzut+")*clo_procent*0.01,2)"
                        
            CenaUpust1PZ="round(round(cena_wal1*(100-upust_procent)*0.01*"+str(Kurs2)+",2)*(100+"+str(Transport)+")*0.01,2)"
            CenaUpust2PZ="round(round(cena_wal2*(100-upust_procent)*0.01*"+str(Kurs2)+",2)*(100+"+str(Transport)+")*0.01,2)"
            WartoscNettoPZ="round(ilosc_dost1*"+CenaUpust1PZ+",2)"
            WartoscNarzutPZ="round("+WartoscNettoPZ+"*"+str(Narzut)+"*0.01,2)"
            WartoscCloPZ="round(("+WartoscNettoPZ+" + "+WartoscNarzutPZ+")*clo_procent*0.01,2)"
                        
            WartoscVAT="round(("+WartoscNetto+" + "+WartoscNarzut+" + "+WartoscClo+")*(CASE WHEN stawka_vat IN ("+str(self.ListaStawekZn)[1:-1]+") THEN 0 ELSE stawka_vat::NUMERIC END)*0.01,2)"
            CenaDostawy1="round(CASE WHEN ilosc_dost1=0 THEN 0 ELSE ("+WartoscNetto+" + "+WartoscNarzut+" + "+WartoscClo+")/ilosc_dost1 END,2)"
            CenaDostawy2="round(CASE WHEN ilosc_dost2=0 THEN 0 ELSE ("+WartoscNetto+" + "+WartoscNarzut+" + "+WartoscClo+")/ilosc_dost2 END,2)"
            WartoscDostawy="round(round(CASE WHEN ilosc_dost1=0 THEN 0 ELSE ("+WartoscNetto+" + "+WartoscNarzut+" + "+WartoscClo+")/ilosc_dost1 END,"+IlMPP+")*ilosc_dost1"+",2)"
                        
            CenaDostawy1PZ="round(CASE WHEN ilosc_dost1=0 THEN 0 ELSE ("+WartoscNettoPZ+" + "+WartoscNarzutPZ+" + "+WartoscCloPZ+")/ilosc_dost1 END,2)"
            CenaDostawy2PZ="round(CASE WHEN ilosc_dost2=0 THEN 0 ELSE ("+WartoscNettoPZ+" + "+WartoscNarzutPZ+" + "+WartoscCloPZ+")/ilosc_dost2 END,2)"
            WartoscDostawyPZ="round(round(CASE WHEN ilosc_dost1=0 THEN 0 ELSE ("+WartoscNettoPZ+" + "+WartoscNarzutPZ+" + "+WartoscCloPZ+")/ilosc_dost1 END,"+IlMPP+")*ilosc_dost1"+",2)"
            
            Update="UPDATE rs_dostawy_pozycje SET wartosc_netto="+WartoscNetto+",wartosc_narzut="+WartoscNarzut+",wartosc_clo="+WartoscClo
            Update+=",wartosc_vat="+WartoscVAT+",cena_dostawy1="+CenaDostawy1+",cena_dostawy2="+CenaDostawy2+",wartosc_dostawy="+WartoscDostawy
            Update+=",cena_upust1="+CenaUpust1+",cena_upust2="+CenaUpust2
            Update+=",cena_upust1_pz="+CenaUpust1PZ+",cena_upust2_pz="+CenaUpust2PZ+',wartosc_wal_netto='+WartoscNettoWal
            Update+=", wartosc_netto_pz="+WartoscNettoPZ+",wartosc_narzut_pz="+WartoscNarzutPZ+",wartosc_clo_pz="+WartoscCloPZ
            Update+=",cena_dostawy1_pz="+CenaDostawy1PZ+",cena_dostawy2_pz="+CenaDostawy2PZ+",wartosc_dostawy_pz="+WartoscDostawyPZ
            Update+=" WHERE firma_id='"+self.firma_id+"' AND data='"+DataDost+"' AND numer="+str(NumerDost)
            rsglobal.ZapiszDoLogow(Update,5)
            stat,dump,dump,dump=self.PolSQL.Execute(Update,1)
            if stat<>'OK':
                stat="BL SQL UPD POZ"
                dane.append(stat)
        else:
            stat="BL SQL UPD POZ"
            dane.append(stat)

    if stat=='OK' and WpiszPozycje:               
        Update="UPDATE rs_dostawy SET "+UPDATE+""
        Update+="WHERE firma_id='"+self.firma_id+"' AND data='"+DataDost+"' AND numer="+str(int(NumerDost))+";"
        stat,dump,dump,dump=self.PolSQL.Execute(Update,1)
        if stat<>'OK':
            stat='BL SQL UPT'
            dane.append(stat)