# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_dowody_dostaw_palety.py
# Purpose:     obsluga grida edytowalnego udziaw handlowcw w fakturze
# Author:      Piotr Witkowski
# Created:     2015/12/29
# RCS-ID:      $Id: fs_dowody_dostaw_palety $
# Copyright:   (c) 2015 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

stat='OK'

if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=='OK':
    Funkcja = klucze['Funkcja']
    
    SlPar={'Trasa':[1,5],'Data':[1,5],'Tryb':[1,5],'Numer':[1,5], 'Oddzial':[1,5]}
    
    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Funkcja,klucze)
    if Lista<>'':
        stat='Uwaga : wywoanie funkcji fs_dowody_dostaw_pozycje z numerem ' +str(Funkcja)+' bez parametrw: '+Lista

if stat=='OK':
    if Funkcja in [1,5]:
        Trasa  = str(klucze['Trasa'])
        Data   = str(klucze['Data'])
        Tryb   = str(klucze['Tryb'])
        Numer  = str(klucze['Numer'])
        Oddzial= str(klucze['Oddzial'])

dane = []
wyn1 = []
wyn2 = []
LArtPoziom=[]


#-------------------------------------------------------------------------------
#-------- EDYCJA GRIDA EDYTOWALNEGO (1)
#-------------------------------------------------------------------------------

Insert = []
Update = []
Delete = []

if Funkcja == 1:
    Update=klucze['Update']
    Insert=klucze['Insert']
    Delete=klucze['Delete']

#-------------------------------------------------------------------------------
#-------  SPRAWDZANIE DELETE  --------------------------------------------------
#-------------------------------------------------------------------------------

if Funkcja == 1 and stat=="OK":
    if len(Delete[0])>0 and stat=='OK':
        sql=''
        for i in xrange(len(Delete[0])):
            if stat=='OK':
                DELETE="DELETE FROM rs_dowody_dostaw_palety "
                WHERE="WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+Oddzial+"' AND trasa='"+Trasa
                WHERE+="' AND data='"+Data+"' AND tryb_dostawy='"+Tryb+"' AND numer="+str(Numer)
                for j in xrange(len(Delete[0][i])):
                    pole=Delete[1][j]
                    wart=Delete[0][i][j]
                    if pole in ['paleta_id']:
                        WHERE+=" AND "+pole+"='"+str(wart)+"'"
                sql+=DELETE+WHERE+";"

        if sql<>'' and stat=='OK':
            stat,dump,dump,dump=self.PolSQL.Execute(rsglobal.Dekoduj(sql),1)
            if stat<>'OK':
                stat='BL SQL DEL'
                dane.append(stat)


#-------------------------------------------------------------------------------
#-------     Sprawdzanie danych do Update
#-------------------------------------------------------------------------------

    if stat == 'OK':
        if len(Update[0])>0 and stat == 'OK':
            for i in xrange(len(Update[0])):   # petla po ilosci wierszy updatowanych
                for j in xrange(len(Update[0][i])): # petla po pozycjach do zmiany
                    if stat == 'OK':
                        pole=Update[0][i][j]
                        wart=Update[1][i][j]
                        if pole=='paleta_id':
                            if wart<=0 or wart.strip()=='':
                                dane.append('PALETA BR$'+str(Update[-1][i]))
                                wyn2.append([Update[-1][i],0])
                            elif wart>3:
                                dane.append('PALETA DL$'+str(Update[-1][i]))
                                wyn2.append([Update[-1][i],0])
                            else:
                                Sql ="SELECT paleta_id FROM rs_palety"
                                Sql+=" WHERE firma_id='"+self.firma_id+"' AND paleta_id='"+str(wart)+"';"
                                stat,d,dump,dump=self.PolSQL.Execute(Sql,3)
                                if stat<>'OK':
                                    stat='PALETA BL SQL'
                                    dane.append(stat)
                                if stat == 'OK':
                                    if len(d)==0:
                                        dane.append('PALETA BL$'+str(Update[-1][i]))
                                        wyn2.append([Update[-1][i],1])

                        elif pole == 'liczba_palet':
                            if wart>9999:
                                wyn2.append((WierszeNr[i],2))
                                dane.append('LICZBA DL')

            if len(dane)>0 and stat == 'OK':
                stat=dane[-1]


#-------------------------------------------------------------------------------
#---------- UPDATE
#-------------------------------------------------------------------------------

    if stat == 'OK' and len(Update[0])>0:
        sql=''
        for i in xrange(len(Update[0])):   # petla po ilosci wierszy updatowanych
            if stat == 'OK':
                UPDATE="UPDATE rs_dowody_dostaw_palety "
                SET='SET '

                for j in xrange(len(Update[0][i])): # petla po pozycjach do zmiany
                    pole=Update[0][i][j]
                    wart=Update[1][i][j]
                    if pole in ['liczba_palet','drukowac']:
                        SET+=pole+"='"+str(wart)+"',"
                SET=SET.strip(",")
                WHERE=" WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+Oddzial+"' AND trasa='"+Trasa+"' AND data='"+Data+"' AND tryb_dostawy='"+Tryb+"' AND numer="+str(Numer)
                for j in xrange(len(Update[2][i])): # petla po kluczu
                    pole=Update[3][j]
                    wart=Update[2][i][j]
                    if pole in ['paleta_id']:
                        WHERE+=" AND "+pole+"='"+wart+"'"
                sql+=UPDATE+SET+WHERE+";"

        if sql<>'' and stat == 'OK':
            stat,dump,dump,dump=self.PolSQL.Execute(rsglobal.Dekoduj(sql),1)
            if stat<>'OK':
                stat='BL SQL UPD'
                dane.append(stat)


#-------------------------------------------------------------------------------
#----------Sprawdzanie danych do Insert
#-------------------------------------------------------------------------------

    if stat =='OK' and len(Insert[0])>0:
        rsglobal.ZapiszDoLogow('!!! Insert '+str(Insert),1)

        for i in xrange(len(Insert[0])):
            for j in xrange(len(Insert[0][i])):
                pole=Insert[1][j]
                wart=Insert[0][i][j]

                if pole=='paleta_id':
                    if wart<=0 or wart.strip()=='':
                        dane.append('PALETA BR$'+str(Insert[-1][i]))
                        wyn2.append([Insert[-1][i],0])
                    elif len(wart)>3:
                        dane.append('PALETA DL$'+str(Insert[-1][i]))
                        wyn2.append([Insert[-1][i],0])
                    else:
                        Sql = "SELECT paleta_id FROM rs_palety"
                        Sql+=" WHERE firma_id='"+self.firma_id+"' AND paleta_id='"+str(wart)+"';"
                        stat,d,dump,dump=self.PolSQL.Execute(Sql,3)
                        if stat<>'OK':
                            stat='PALETA BL SQL'
                            dane.append(stat)
                        if stat == 'OK':
                            if len(d)==0:
                                dane.append('PALETA BL$'+str(Insert[-1][i]))
                                wyn2.append([Insert[-1][i],1])

                elif pole == 'liczba_palet':
                    if wart>9999:
                        dane.append('LICZBA DL'+str(Insert[-1][i]))
                        wyn2.append([Insert[-1][i],-1])

        if len(dane)>0:
            stat=dane[-1]


 #------------------------------------------------------------------------------------------------------------
 #---------------   INSERT
 #-------------------------------------------------------------------------------------------------------------

        if stat=='OK':
            sql=''
            for i in xrange(len(Insert[0])):
                INSERT="INSERT INTO rs_dowody_dostaw_palety "
                KOLUMNY="(firma_id,oddzial_id,trasa,data,tryb_dostawy,numer"
                VALUES=" VALUES ('"+self.firma_id+"','"+Oddzial+"','"+Trasa+"','"+Data+"','"+Tryb+"',"+str(Numer)

                for j in xrange(len(Insert[0][i])):
                    pole=Insert[1][j]
                    wart=Insert[0][i][j]
                    if pole in ['paleta_id','drukowac','liczba_palet']:
                        KOLUMNY+=","+pole
                        VALUES+=",'"+str(wart)+"'"

                KOLUMNY+=")"
                VALUES+=");"
                sql+=INSERT+KOLUMNY+VALUES
            if sql<>'':
                stat,dump,dump,dump=self.PolSQL.Execute(rsglobal.Dekoduj(sql),1)
                if stat<>'OK':
                    stat='BL SQL INS'
                    dane.append(stat)


#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (1- insert 1 -select, 1 -delete, 5 -select) 
#-------------------------------------------------------------------------------

if Funkcja in (1,5) and stat=='OK':    
    SQL =" SELECT d.paleta_id, p.opis, d.liczba_palet, d.drukowac "
    SQL+=" FROM rs_dowody_dostaw_palety d INNER JOIN rs_palety p "
    SQL+=" ON d.paleta_id = p.paleta_id and d.firma_id = p.firma_id "
    SQL+=" WHERE d.firma_id='"+self.firma_id+"' AND d.oddzial_id='"+Oddzial+"' AND d.trasa='"+Trasa+"'"
    SQL+=" AND d.data='"+Data+"' AND  d.tryb_dostawy='"+Tryb+"' AND d.numer="+str(Numer)
    SQL+=" ORDER BY paleta_id;"
    stat,dane,wyn1,wyn2 = self.PolSQL.Execute(SQL,3)
    if stat <> 'OK':
        stat = "Bd przy pobieraniu danych: "+stat
