#!/usr/bin/python
# -*- coding: iso8859_2 -*-
#-----------------------------------------------------------------------------
# Name:             fs_dowody_dostaw_podglad_stanow_mag.py
# Purpose:          podglad : ilosci artykulu minus wydanie z dowodow dostaw 
# Author:           Dariusz Boduch
# Created:          2008/11/21
# RCS-ID:           $Id: fs_dowody_dostaw_podglad_stanow_mag.py $
# Copyright:        (c) 2007 RecordSystem
# Licence:          GNU GPL
#-----------------------------------------------------------------------------
stat = "OK"
dane = []

if self.operator_id == STANDARD_OPERATOR_ID:
    UprPrz=True
else:
    UprPrz=(self.oddzial_id,'028021') in self.uprawnienia

if stat=='OK':
    if UprPrz:
       #pobranie listy magazynow handlowych
        stat,daneM,dump,dump=self.PolSQL.Execute("SELECT magazyn_id FROM rs_magazyny WHERE firma_id='"+self.firma_id+"' AND handlowy=True ;",3)
        if stat !='OK':
            stat="BL SQL MAG"
        LMag=[]
        for w in daneM:
            mag=str(w[0]).replace('[','').replace(']','')
            LMag.append(mag)
        ListaMag=str(LMag).replace('[','').replace(']','')
        #pobieranie artykulu
        SELECT="SELECT  ap.artykul_id, a.nazwa, LOWER(a.jm1), sum(ap.ilosc1-ap.rezerwacja1),0,0  "
        FROM = "FROM rs_artykuly_przyjecia ap INNER JOIN rs_artykuly a on (ap.firma_id=a.firma_id and ap.artykul_id=a.artykul_id) "
        WHERE = "WHERE ap.firma_id='"+self.firma_id+"' AND ap.magazyn_id in ("+ListaMag+") "
        WHERE+=" AND ap.ilosc1 > 0 AND NOT ap.wirtualne "
        GROUPBY="GROUP BY ap.artykul_id,  a.nazwa, (a.jm1) HAVING sum(ap.ilosc1-ap.rezerwacja1)>0 "
        ORDERBY="ORDER BY ap.artykul_id ;"
        sql=SELECT+FROM+WHERE+GROUPBY+ORDERBY
        stat,dane,dump,dump=self.PolSQL.Execute(sql,3)
        if stat!="OK":
            stat="BL SQL ART"
            dane.append(stat)
        else:
            #pobieranie daty, danych z dowodow dostaw
            stat,Data,dump,dump=self.PolSQL.Execute("SELECT CURRENT_DATE;",3)
            DataD=Data[0][0]
            
            SELECT="SELECT artykul_id, sum(ilosc_pobr1) FROM rs_dowody_dostaw_pozycje WHERE firma_id='"+self.firma_id+"' AND data='"+str(DataD)+"' GROUP BY artykul_id ORDER BY artykul_id; "
            stat,DaneD,dump,dump=self.PolSQL.Execute(SELECT,3)
            
            if stat!="OK":
                stat="BL SQL DP"
                dane.append(stat)
            
    else:
        stat='UPR PRZ'
        dane.append(stat) 
        
if stat=='OK':
    #laczenie danych wg po artykule
    #lista artykulow
 
    for w in dane:
        Art=w[0]
        for s in DaneD:
            if s[0]==Art:
                w[4]=s[1]
                w[5]=w[3]-s[1]
                break
            if s[0]>Art:
                break   