# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_dowody_ksiegowe_projekty.py
# Purpose:     wyswietla, dodaje,usuwa dane projektu w dowodach ksiegowych
# Author:      Dariusz Boduch, Micha Raburski
# Created:     2010/01/06
# RCS-ID:      $Id: fs_dowody_ksiegowe_projekty.py$
# Copyright:   (c) 2009 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

# 2011-11-25 Mariusz Rajfura  - uszczelnienie: blokada zmian dla stanu Z (5079)
# 2022-05-11 Wojciech Skowron - nowy stan M w dk (13004)

stat='OK'

if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=='OK':
    Funkcja = klucze['Funkcja']

    SlPar={'Dowod':[5,22],'Nazwa':[5,22],'Data':[5,22],'Numer':[5,22],'Nr_poz':[5,22],'Projekt':[10],'Kontrahent':[9,],
           'Dzial':[7,],'Handlowiec':[8,]}

    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Funkcja,klucze)
    if Lista<>'':
        stat='Uwaga : wywoanie funkcji fs_artykuly_cechy_wartosci z numerem '+str(Funkcja)+' bez parametrw: '+Lista

    if Funkcja in [1,5,22]:
        Dowod=rsglobal.Dekoduj(klucze['Dowod'])
        Nazwa=rsglobal.Dekoduj(klucze['Nazwa'])
        Data=rsglobal.Dekoduj(klucze['Data'])
        Numer=rsglobal.Dekoduj(klucze['Numer'])
        Nr_Poz=rsglobal.Dekoduj(klucze['Nr_Poz'])
    if Funkcja in [10,]:
        Projek = rsglobal.Dekoduj(klucze['Projekt'])
    if Funkcja in [9,]:
        Kontrahent = rsglobal.Dekoduj(klucze['Kontrahent'])
    if Funkcja in [8,]:
        Handlowiec = rsglobal.Dekoduj(klucze['Handlowiec'])
    if Funkcja in [7,]:
        Dzial = rsglobal.Dekoduj(klucze['Dzial'])









#UWAGA Fun - 14 zajte !!!! 

stat = "OK"
dane = []
DaneI = []

UprProjekty=(((self.oddzial_id,'027010') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)) 
UprDzialy=(((self.oddzial_id,'027021') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)) 
UprHandl=(((self.oddzial_id,'011221') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)) 
UprKontr=(((self.oddzial_id,'012011') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)) 


Insert = []
Update = []
Delete = []

if stat=='OK' and Funkcja == 1:
    Update=klucze['Update']
    Insert=klucze['Insert']
    Delete=klucze['Delete']

#-------------------------------------------------------------------------------
#-------  SPRAWDZENIE CZY DOWOD KSIEGOWY UTWORZONY ZE WZORU DEKRETACJI W KTOREJ
#-------  ZAZNACZONO "PODZIAL NA PROJEKTY"
#-------------------------------------------------------------------------------

if stat=='OK' and Funkcja not in [7,8,9,10]:
    sel1="SELECT projekty_podzial FROM rs_wzory_dekretacji WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"' "
    sel1+=" and dowod_id='"+Dowod+"' and nazwa_id='"+Nazwa+"' ;"
    stat,daneWD,dump,dump = self.PolSQL.Execute(sel1,3)   
    if stat<>'OK':
        stat=u"Bd przy sprawdzaniu wzoru dekretacji: "+stat   
        dane.append(stat)        
    if stat=='OK':
        if daneWD==[]:
            stat='BL WD'
            dane.append(stat) 
        if not (daneWD[0][0]):
            stat='BR PODZ PROJ'
            dane.append(stat)

#-------------------------------------------------------------------------------
#-------  WYPELNIENIE GRIDA Z UWZGLEDNIENIEM DEFINICJI W RS_PROJEKTY_DZIALY - 13
#-------------------------------------------------------------------------------

if Funkcja == 13 and stat == 'OK':
    from funkcje import fs_dowody_ksiegowe_projekty_tworzenie
    stat=fs_dowody_ksiegowe_projekty_tworzenie.StworzPozycjeProjektoweWDowodzieKsiegowym(self.firma_id,self.okres_id,Dowod,Nazwa,Data,Numer,self.PolSQL)
            
            
#-------------------------------------------------------------------------------
#-------   SPRAWDZANIE OPISU      ----------------------------------------------
#-------------------------------------------------------------------------------

if Funkcja == 7 and stat=="OK":
    sel1="SELECT opis FROM rs_dzialy_firmy WHERE firma_id='"+self.firma_id+"' AND kod='"+Dzial+"';"
    stat,dane,dump,dump = self.PolSQL.Execute(sel1,3)   
    if stat<>'OK':
        stat=u"Bd przy sprawdzaniu opisu dziau: "+stat   
        dane.append(stat)        
    if stat=='OK':
        if UprDzialy==0 and len(dane)<>0:
            stat='BR UPR SLOWN'
            dane.append(stat) 

#-------------------------------------------------------------------------------

if Funkcja == 8 and stat=="OK":
    sel2="SELECT opis FROM rs_handlowcy WHERE firma_id='"+self.firma_id+"' AND kod='"+Handlowiec+"';"
    stat,dane,dump,dump = self.PolSQL.Execute(sel2,3)   
    if stat<>'OK':
        stat=u"Bd przy sprawdzaniu opisu handlowca : "+stat   
        dane.append(stat)        
    if stat=='OK':
        if UprHandl==0 and len(dane)<>0:
            stat='BR UPR SLOWN'
            dane.append(stat) 
            
#-------------------------------------------------------------------------------

if Funkcja == 9 and stat=="OK":
    sel3="SELECT nazwa FROM rs_kontrahenci WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+Kontrahent+"';"
    stat,dane,dump,dump = self.PolSQL.Execute(sel3,3)   
    if stat<>'OK':
        stat=u"Bd przy sprawdzaniu opisu kontrahenta: "+stat   
        dane.append(stat)        
    if stat=='OK':
        if UprKontr==0 and len(dane)<>0:
            stat='BR UPR SLOWN'
            dane.append(stat) 

#-------------------------------------------------------------------------------
#--- POBRANIE OPISU PROJEKTU
#-------------------------------------------------------------------------------

if Funkcja == 10 and stat=="OK":
    sel3="SELECT rsf_opis_symbol_projektu('"+self.firma_id+"', '"+str(Projek)+"'); "
    rsglobal.ZapiszDoLogow('SQL '+sel3,1)
    stat,d,dump,dump = self.PolSQL.Execute(sel3,3)
    rsglobal.ZapiszDoLogow('DANE '+str(d),1)
    if stat<>'OK':
        stat=u"Bd przy sprawdzaniu opisu projektu: "+stat   
        dane.append(stat)        
    if stat=='OK':
        if UprProjekty==0 and len(d)<>0:
            stat='BR UPR SLOWN'
            dane.append(stat) 
        else:
            wyn = rsglobal.rseval(d[0][0])
            dane=wyn 

#-------------------------------------------------------------------------------
# POBRANIE STANU DOWODU (22)
#-------------------------------------------------------------------------------

if Funkcja == 22 and stat=="OK":
    sql ="SELECT stan FROM rs_dowody_ksiegowe"
    sql+=" WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"'"
    sql+=" AND dowod_id='"+Dowod+"' AND nazwa_id='"+Nazwa+"' AND data='"+Data+"' AND numer="+str(Numer)+";"
    stat,dane,dump,dump=self.PolSQL.Execute(sql,3)
    if stat <> 'OK':
        stat = 'Bd pobrania stanu dowodu ksigowego: '+stat
    elif len(dane) <> 1:
        stat = 'Brak dowodu o podanym numerze.'


#-------------------------------------------------------------------------------
# OGLNE SPRAWDZENIE CZY MONA ZMIENIA DANE            
#-------------------------------------------------------------------------------

if Funkcja == 1 and stat=="OK":
    SQL="SELECT stan FROM rs_dowody_ksiegowe WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"'"
    SQL+=" AND dowod_id='"+Dowod+"' AND nazwa_id='"+Nazwa+"' AND data='"+Data+"' AND numer="+str(Numer)+";"
    stat,DTest,dump,dump=self.PolSQL.Execute(SQL,3)
    if stat=='OK':
        #WS 2022-05-11
        if not DTest[0][0] in ['M','W','G']:
        # if not DTest[0][0] in ['W','G']:
            stat='ZAMK DOK'
            dane.append(stat)
                
#-------------------------------------------------------------------------------
#-------------------------- DELETE    
#-------------------------------------------------------------------------------        
        
if Funkcja == 1 and stat=="OK":
    sql=''
    for i in xrange(len(Delete[0])):
        DELETE="DELETE FROM rs_dowody_ksiegowe_projekty "
        WHERE=" WHERE firma_id='"+self.firma_id+"' AND okres_id ='"+self.okres_id+"' "
        WHERE+=" AND dowod_id='"+Dowod+"' AND nazwa_id='"+Nazwa+"' "
        WHERE+=" AND data='"+Data+"' AND numer="+str(Numer)+" " 
        for j in xrange(len(Delete[0][i])):
            pole=Delete[1][j]
            wart=Delete[0][i][j]
            if pole == 'nr_poz':
                WHERE+=" AND "+pole+"="+str(wart)+" "
        sql+=DELETE+WHERE+";"
    
    UPD="UPDATE rs_dowody_ksiegowe SET stan='W' WHERE firma_id='"+self.firma_id+"' "
    UPD+=" AND okres_id='"+self.okres_id+"' AND dowod_id='"+Dowod+"' AND nazwa_id='"+Nazwa+"' "
    UPD+=" AND data='"+Data+"' AND numer="+str(Numer)+" ; "
    SQL=sql+UPD
    if sql<>'':
        stat,dump,dump,dump=self.PolSQL.Execute(rsglobal.Dekoduj(SQL),1)
    if stat<>'OK':
        stat=u"Bd przy usuwaniu danych: "+stat   
        dane.append(stat)        
                         
#-------------------------------------------------------------------------------
#---   UPDATE DANYCH (1)
#-------------------------------------------------------------------------------
if Funkcja == 1 and stat=="OK":
    if len(Update[0])>0:
        #Update=klucze[-2]
        WierszeNr = Update[-1]
        for i in xrange(len(Update[0])):
            for j in xrange(len(Update[0][i])): 
                #if stat == "OK":
                pole=Update[0][i][j]
                wart=Update[1][i][j]
                if pole == 'projekt_id':
                    if wart.strip()=='':
                        stat = u'BR PR'
                        wyn2.append((WierszeNr[i],0))
                        dane.append(stat)
                    else:
                        sql="SELECT rsf_opis_symbol_projektu('"+self.firma_id+"', '"+str(wart)+"'); "
                        stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                        
                        if stat <> 'OK':
                            stat = u'BL SQL PR'
                            wyn2.append((WierszeNr[i],0))
                            dane.append(stat)
                        else:
                            wyn = rsglobal.rseval(d[0][0])
                            if wyn==['','']:
                                stat = u'BL PR'
                                wyn2.append((WierszeNr[i],0))
                                dane.append(stat)
                                                                
                if pole == 'dzial_id':
                    if wart.strip() != '':
                        sql ="SELECT kod FROM rs_dzialy_firmy WHERE firma_id = '"+self.firma_id+"'"
                        sql+=" AND kod = '"+str(wart)+"';" 
                        stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                        if stat <> 'OK':
                            stat = u'BL SQL DZ'
                            wyn2.append((WierszeNr[i],0))
                            dane.append(stat)
                        else:
                            if d==[]:
                                stat = u'BL DZ'
                                wyn2.append((WierszeNr[i],0))
                                dane.append(stat)
                if pole == 'handlowiec_id':
                    if wart != '':
                        sql ="SELECT kod FROM rs_handlowcy WHERE firma_id = '"+self.firma_id+"'"
                        sql+=" AND kod = '"+str(wart)+"';" 
                        stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                        if stat <> 'OK':
                            stat = u'BL SQL HANDL'
                            wyn2.append((WierszeNr[i],0))
                            dane.append(stat)
                        else:
                            if d==[]:
                                stat = u'BL HANDL'
                                wyn2.append((WierszeNr[i],0))
                                dane.append(stat)
                if pole == 'kontrahent_id':
                    if wart != '':
                        sql ="SELECT kontrahent_id FROM rs_kontrahenci WHERE firma_id = '"+self.firma_id+"'"
                        sql+=" AND kontrahent_id = '"+str(wart)+"';" 
                        stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                        if stat <> 'OK':
                            stat = u'BL SQL KONTR'
                            wyn2.append((WierszeNr[i],0))
                            dane.append(stat)
                        else:
                            if d==[]:
                                stat = u'BL KONTR'
                                wyn2.append((WierszeNr[i],0))
                                dane.append(stat)

            
        if stat=='OK':
            sql=''        
            for i in xrange(len(Update[0])):   
                UPDATE="UPDATE rs_dowody_ksiegowe_projekty "
                SET='SET '
                for j in xrange(len(Update[0][i])): 
                    pole=Update[0][i][j]
                    wart=Update[1][i][j]
                    if pole== 'projekt_id':
                        sql="SELECT rsf_opis_symbol_projektu('"+self.firma_id+"', '"+str(wart)+"'); "
                        stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                        wyn = rsglobal.rseval(d[0][0])
                        wart=wyn[1]
                        SET+=pole+"='"+wart+"',"
                    elif pole in ['dzial_id','handlowiec_id','kontrahent_id']:
                        if len(str(wart).strip())==0:
                            SET+=pole+"="+str('NULL')+","
                        else:
                            SET+=pole+"='"+wart+"',"
                    elif pole in ['kwota_wn', 'kwota_ma','nr_poz']:
                        SET+=pole+"="+str(wart)+","
                SET=SET.strip(",")
                WHERE=" WHERE firma_id='"+self.firma_id+"' AND okres_id ='"+self.okres_id+"' "
                WHERE+=" AND dowod_id='"+Dowod+"' AND nazwa_id='"+Nazwa+"' "
                WHERE+=" AND data='"+Data+"' AND numer="+str(Numer)+" " 
                for j in xrange(len(Update[2][i])): # petla po kluczu
                    pole=Update[3][j]
                    wart=rsglobal.Dekoduj(Update[2][i][j])
                    WHERE+=" AND "+pole+"="+str(wart)+" "
                WHERE+=";" 
                if str(SET)=='SET ':
                    pass
                else:
                    sql+=UPDATE+SET+WHERE;
            
            UPD="UPDATE rs_dowody_ksiegowe SET stan='W' WHERE firma_id='"+self.firma_id+"' "
            UPD+=" AND okres_id='"+self.okres_id+"' AND dowod_id='"+Dowod+"' AND nazwa_id='"+Nazwa+"' "
            UPD+=" AND data='"+Data+"' AND numer="+str(Numer)+" ; "
            SQL=sql+UPD
            if sql<>'': 
                stat,dump,dump,dump=self.PolSQL.Execute(rsglobal.Dekoduj(SQL),1)   
                if stat<>'OK':
                    stat=u"Bd przy modyfikowaniu danych: "+stat   
                    dane.append(stat)  
                                    
#----------------------------------------------------------------------------------------------------------------------
#---------Sprawdzanie danych do Insert------
#----------------------------------------------------------------------------------------------------------------------

if Funkcja == 1 and stat=="OK":
   
    #Insert=klucze[-3]
    WierszeNr = Insert[-1]
    for i in xrange(len(Insert[0])):
        for j in xrange(len(Insert[0][i])): 
                pole=Insert[1][j]
                wart=Insert[0][i][j]
                if pole == 'projekt_id':
                    if wart.strip()=='':
                        stat = u'BR PR'
                        wyn2.append((WierszeNr[i],0))
                        dane.append(stat)
                    else:
                        sql="SELECT rsf_opis_symbol_projektu('"+self.firma_id+"', '"+str(wart)+"'); "
                        stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                        
                        if stat <> 'OK':
                            stat = u'BL SQL PR'
                            wyn2.append((WierszeNr[i],0))
                            dane.append(stat)
                        else:
                            wyn = rsglobal.rseval(d[0][0])
                            if wyn==['','']:
                                stat = u'BL PR'
                                wyn2.append((WierszeNr[i],0))
                                dane.append(stat)
                if pole == 'dzial_id':
                    if wart.strip() != '':
                        sql ="SELECT kod FROM rs_dzialy_firmy WHERE firma_id = '"+self.firma_id+"'"
                        sql+=" AND kod = '"+str(wart)+"';" 
                        stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                        if stat <> 'OK':
                            stat = u'BL SQL DZ'
                            wyn2.append((WierszeNr[i],0))
                            dane.append(stat)
                        else:
                            if d==[]:
                                stat = u'BL DZ'
                                wyn2.append((WierszeNr[i],0))
                                dane.append(stat)
                if pole == 'handlowiec_id':
                    if wart.strip() != '':
                        sql ="SELECT kod FROM rs_handlowcy WHERE firma_id = '"+self.firma_id+"'"
                        sql+=" AND kod = '"+str(wart)+"';" 
                        stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                        if stat <> 'OK':
                            stat = u'BL SQL HANDL'
                            wyn2.append((WierszeNr[i],0))
                            dane.append(stat)
                        else:
                            if d==[]:
                                stat = u'BL HANDL'
                                wyn2.append((WierszeNr[i],0))
                                dane.append(stat)
                if pole == 'kontrahent_id':
                    if wart.strip() != '':
                        sql ="SELECT kontrahent_id FROM rs_kontrahenci WHERE firma_id = '"+self.firma_id+"'"
                        sql+=" AND kontrahent_id = '"+str(wart)+"';" 
                        stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                        if stat <> 'OK':
                            stat = u'BL SQL KONTR'
                            wyn2.append((WierszeNr[i],0))
                            dane.append(stat)
                        else:
                            if d==[]:
                                stat = u'BL KONTR'
                                wyn2.append((WierszeNr[i],0))
                                dane.append(stat)
    
                                                        
 #------------------------------------------------------------------------------------------------------------   
 #---------------   INSERT
 #-------------------------------------------------------------------------------------------------------------       

    if stat=='OK':    
        sqlIns=''
        for i in xrange(len(Insert[0])):
            INSERT="INSERT INTO rs_dowody_ksiegowe_projekty "
            KOLUMNY="(firma_id,okres_id,dowod_id,nazwa_id,data,numer "
            VALUES=" VALUES ('"+self.firma_id+"','"+self.okres_id+"','"+Dowod+"','"+Nazwa+"','"+Data+"',"+str(Numer)+"  "
            for j in xrange(len(Insert[0][i])):
                pole=Insert[1][j]
                wart=Insert[0][i][j]
                if pole == 'projekt_id':
                    sql="SELECT rsf_opis_symbol_projektu('"+self.firma_id+"', '"+str(wart)+"'); "
                    stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                    wyn = rsglobal.rseval(d[0][0])
                    wart=wyn[1]
                    KOLUMNY+=","+pole
                    VALUES+=",'"+wart+"'"  
                elif pole in ['dzial_id','handlowiec_id', 'kontrahent_id']:
                    if len(wart)==0:
                        KOLUMNY+=","+pole
                        VALUES+=","+str('NULL')+""                        
                    else:
                        KOLUMNY+=","+pole
                        VALUES+=",'"+wart+"'"             
                elif pole in ['kwota_wn', 'kwota_ma','nr_poz']:
                    KOLUMNY+=","+pole
                    VALUES+=","+str(wart)+" "             
            KOLUMNY+=")"
            VALUES+="); "
            sqlIns+=INSERT+KOLUMNY+VALUES
        UPD="UPDATE rs_dowody_ksiegowe SET stan='W' WHERE firma_id='"+self.firma_id+"' "
        UPD+=" AND okres_id='"+self.okres_id+"' AND dowod_id='"+Dowod+"' AND nazwa_id='"+Nazwa+"' "
        UPD+=" AND data='"+Data+"' AND numer="+str(Numer)+" ; "
        SQLIns=sqlIns+UPD
        if sqlIns<>'':
            stat,dump,dump,dump=self.PolSQL.Execute(rsglobal.Dekoduj(SQLIns),1)
            if stat<>'OK':
                stat=u"Bd przy dodawaniu danych: "+stat   
                dane.append(stat)
                                                             
#---   POBRANIE DANYCH (1- insert 1 -select, 1 -delete)
if (Funkcja in [1,4,5,6,13]) and (stat=='OK') :
    # pobranie danych 
    SQL="SELECT coalesce(pd.projekt_id,''), "
    if UprProjekty<>0:
        SQL+=" coalesce(p.nazwa,'') "
    else:
        SQL+="'Brak uprawnie do przegldania danych projektw'"
    SQL+=" ,coalesce(pd.kontrahent_id,''), "
    if UprKontr<>0:
        SQL+=" coalesce(k.nazwa,'') "
    else:
        SQL+="'Brak uprawnie do przegldania danych kontrahentw'"
    SQL+=" ,coalesce(pd.dzial_id,''), "
    if UprDzialy<>0:
        SQL+=" coalesce(df.opis,'') "
    else:
        SQL+="'Brak uprawnie do przegldania danych dziaw'"
    SQL+=", coalesce(pd.handlowiec_id,''), "
    if UprHandl<>0:
        SQL+=" coalesce(h.opis,'') "
    else:
        SQL+="'Brak uprawnie do przegldania danych handlowcw'"
    SQL+=", pd.kwota_wn,pd.kwota_ma,pd.nr_poz "
    
    SQL+="FROM rs_dowody_ksiegowe_projekty pd "
    SQL+="LEFT OUTER JOIN rs_projekty p ON(pd.firma_id=p.firma_id AND pd.projekt_id=p.projekt_id) "
    SQL+="LEFT OUTER JOIN rs_dzialy_firmy df ON(pd.firma_id=df.firma_id AND pd.dzial_id=df.kod) "
    SQL+="LEFT OUTER JOIN rs_handlowcy h ON(pd.firma_id=h.firma_id AND pd.handlowiec_id=h.kod) "
    SQL+="LEFT OUTER JOIN rs_kontrahenci k ON(pd.firma_id=k.firma_id AND pd.kontrahent_id=k.kontrahent_id) "
    SQL+="WHERE pd.firma_id='"+self.firma_id+"' AND pd.okres_id='"+self.okres_id+"' "
    SQL+="AND pd.dowod_id='"+Dowod+"' AND pd.nazwa_id='"+Nazwa+"' AND pd.data='"+Data+"' AND pd.numer="+str(Numer)+" "
    SQL+="ORDER BY nr_poz;"
    stat,dane,wyn1,wyn2=self.PolSQL.Execute(SQL,3)
    if stat<>'OK':
        stat=u"Bd przy pobieraniu danych: "+stat   
        dane.append(stat)