# -*- coding: iso8859_2 -*-
#-----------------------------------------------------------------------------
# Name:        fs_drukarki_fiskalne_stawki_vat.py
# Purpose:     wyswietla, dodaje,usuwa stawki vat operujc na tabeli rs_stawki_vat
# Author:      Pawe Wjcikowski
# Created:     2009/02/05
# RCS-ID:      $Id: fs_drukarki_fiskalne_stawki_vat.py$
# Copyright:   (c) 2009 Record System
# Licence:     GNU GPL
#-----------------------------------------------------------------------------

Oddzial=klucze[0]
Kasa=klucze[1]
Stawka=klucze[2]
Kod=klucze[3]
Fun = klucze[-1]

stat = "OK"
dane = []
Dana = []

UprEdycja=(((self.oddzial_id,'014068') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID))
UprUsuwanie=(((self.oddzial_id,'014068') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID))
UprPrzegladanie=(((self.oddzial_id,'014067') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID))    
UprDodawanie=(((self.oddzial_id,'014068') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID))
    
#-------------------------------------------------------------------------------
#-------  SPRAWDZANIE DELETE
#-------------------------------------------------------------------------------

if Fun == 1 and stat=="OK":
    Delete=klucze[-4]
    if len(Delete[0])>0:
        if not UprUsuwanie:
            stat='UPR DEL'
            dane.append(stat)
   
#------------------------------------------------------------------------------------------------------------        
#-------------------------- DELETE    
#------------------------------------------------------------------------------------------------------------        
        
        if stat=='OK':
            sql=''
            for i in xrange(len(Delete[0])):
                DELETE="DELETE FROM rs_kasy_fiskalne_vat "
                WHERE="WHERE firma_id='"+self.firma_id+"' AND kasa_id='"+str(Kasa)+"'"
                for j in xrange(len(Delete[0][i])):
                    pole=Delete[1][j]
                    wart=Delete[0][i][j]
                    if pole in ['stawka_vat','kod']:
                        WHERE+=" AND "+pole+"='"+wart+"'"
                sql+=DELETE+WHERE+";"
            if sql<>'': 
                stat,dump,dump,dump=self.PolSQL.Execute(rsglobal.Dekoduj(sql),1)
                if stat<>'OK':
                    stat='BL DEL'
                    dane.append(stat)
                                 
#-------------------------------------------------------------------------------
#---   UPDATE DANYCH (1)
#-------------------------------------------------------------------------------

if Fun == 1 and stat=="OK":
    if not UprEdycja:
        stat='UPR SEL'   
    if stat=='OK':
        sel1="SELECT kod FROM rs_stawki_vat;"
        stat,D,dump,dump = self.PolSQL.Execute(sel1,3)
        Dane=[]
        
        for i in xrange(len(D)):
            for x in D[i]:
                Dane.append(str(x))            
        
        Update=klucze[-2]
        WierszeNr = Update[-1]
        for i in xrange(len(Update[0])):
            for j in xrange(len(Update[0][i])): 
                    #if stat == "OK":
                    pole=Update[0][i][j]
                    wart=Update[1][i][j]
                    if pole == 'stawka_vat':
                        if str(wart) not in Dane:
                            stat = 'Stawka VAT niepoprawna'
                            wyn2.append((WierszeNr[i],0))
                            dane.append(stat)
                    if pole == 'kod':
                        if len(wart) not in [0,1]:                            
                            stat = 'Za duga warto w polu kod'
                            wyn2.append((WierszeNr[i],1))
                            dane.append(stat)              
    if stat=='OK':
        sql=''        
        for i in xrange(len(Update[0])):   
            UPDATE="UPDATE rs_kasy_fiskalne_vat "
            SET='SET '
            for j in xrange(len(Update[0][i])): 
                pole=Update[0][i][j]
                wart=Update[1][i][j]
                if pole in ['stawka_vat','kod']: 
                    SET+=pole+"='"+wart+"',"
                else:
                    SET+=pole+"="+str(wart)+","
            SET=SET.strip(",")
            WHERE=" WHERE firma_id='"+self.firma_id+"' AND kasa_id ='"+str(Kasa)+"' AND oddzial_id='"+str(Oddzial)+"'"
            for j in xrange(len(Update[2][i])): # petla po kluczu
                pole=Update[3][j]
                wart=rsglobal.Dekoduj(Update[2][i][j])
                WHERE+=" AND "+pole+"='"+wart+"'"
            WHERE+=";"    
            sql+=UPDATE+SET+WHERE;
        if sql<>'': 
            stat,dump,dump,dump=self.PolSQL.Execute(rsglobal.Dekoduj(sql),1)    
                    
#----------------------------------------------------------------------------------------------------------------------
#---------Sprawdzanie danych do Insert------
#----------------------------------------------------------------------------------------------------------------------
                        
if Fun == 1 and stat=="OK":
    if not UprEdycja:
        stat='UPR SEL1'   
    if stat=='OK':
        sel1="SELECT kod FROM rs_stawki_vat;"
        stat,I,dump,dump = self.PolSQL.Execute(sel1,3)
        Insert=klucze[-3]
        WierszeNr = Insert[-1]
        DaneI=[]
        
        for i in xrange(len(I)):
            for x in D[i]:
                DaneI.append(str(x))  
        
        for i in xrange(len(Insert[0])):
            for j in xrange(len(Insert[0][i])): 
                    pole=Insert[1][j]
                    wart=Insert[0][i][j]
                    if pole == 'stawka_vat':
                        if str(wart) not in DaneI:
                            stat = 'Stawka VAT niepoprawna'
                            dane.append(stat)
                            wyn2.append((WierszeNr[i],0))
                    if pole == 'kod':
                        if len(wart) not in [0,1]:                            
                            stat = 'Za duga warto w polu kod'
                            dane.append(stat)  
                            wyn2.append((WierszeNr[i],1))  
                            
 #------------------------------------------------------------------------------------------------------------   
 #---------------   INSERT
 #-------------------------------------------------------------------------------------------------------------       

    if stat=='OK':    
            sqlIns=''
            for i in xrange(len(Insert[0])):
                INSERT="INSERT INTO rs_kasy_fiskalne_vat "
                KOLUMNY="(firma_id,oddzial_id,kasa_id"
                VALUES=" VALUES ('"+self.firma_id+"','"+Oddzial+"','"+Kasa+"'"
                for j in xrange(len(Insert[0][i])):
                    pole=Insert[1][j]
                    wart=Insert[0][i][j]
                    if pole in ['stawka_vat','kod']:
                        KOLUMNY+=","+pole
                        VALUES+=",'"+wart+"'"  
                    else:
                        KOLUMNY+=","+pole
                        VALUES+=","+str(wart)                 
                KOLUMNY+=")"
                VALUES+=");"
                sqlIns+=INSERT+KOLUMNY+VALUES
            if sqlIns<>'': 
                stat,dump,dump,dump=self.PolSQL.Execute(rsglobal.Dekoduj(sqlIns),1)
                if stat<>'OK':
                    stat='BL INS'
                    dane.append(stat)            
                                         
#---   POBRANIE DANYCH (1- insert 1 -select, 1 -delete)
if (Fun in [1,4,5,6]) and (stat=='OK') :
        # pobranie danych 
    if not UprPrzegladanie:
        stat='UPR PRZ' 
   
    if stat=="OK": 
        Filtr="WHERE firma_id='"+self.firma_id+"' AND oddzial_id = '"+str(Oddzial)+"' AND kasa_id = '"+str(Kasa)+ "' "
        sql="SELECT stawka_vat,kod FROM rs_kasy_fiskalne_vat "+Filtr+" "
        sql+="ORDER BY oddzial_id;"
        stat,dane,wyn1,wyn2=self.PolSQL.Execute(sql,3)
        if stat<>'OK':
            stat='BL PRZ'
            dane.append(stat) 