# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_dziennik_rodo.py
# Purpose:     obsuga grida nieedytowalnego z dziennikiem rodo
# Author:      Mikoaj Kozowski
# Created:     2019/05/24
# RCS-ID:      $Id: fs_dziennik_rodo.py$
# Copyright:   (c) 2019 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

stat='OK'
if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=='OK':
    Funkcja = klucze['Funkcja']
    
    SlPar = {'GrupaF': [5, ], 'DataOdF': [5, ], 'DataDoF': [5, ], 'OperatorF': [5, ], }
    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Funkcja,klucze)
    if Lista<>'':
        stat='Uwaga : wywoanie funkcji fs_dziennik_rodo.py '+str(Funkcja)+' bez parametrw: '+Lista

    if Funkcja in [5, ]:
        GrupaF = rsglobal.Dekoduj(klucze['GrupaF'])
        DataOdF = rsglobal.Dekoduj(klucze['DataOdF'])
        DataDoF = rsglobal.Dekoduj(klucze['DataDoF'])
        OperatorF = rsglobal.Dekoduj(klucze['OperatorF'])

dane = []
wyn1 = []
wyn2 = []


UprSelect=((self.oddzial_id,'002100') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID
if not UprSelect:
    stat = 'Brak uprawnie do przegldania dziennika RODO.'

#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (5)
#-------------------------------------------------------------------------------

if Funkcja in (5, ) and stat == 'OK':
    SQL = "SELECT zmieniona_grupa, zmieniony_operator::TEXT, opis, z_czas, z_typ, z_op_id "
    SQL += "FROM rs_rodo_dziennik_anakonda WHERE firma_id='"+self.firma_id+"'"
    if GrupaF.strip() <> '':
        SQL += " AND zmieniona_grupa='"+GrupaF+"'"
    if OperatorF.strip() <> '':
        SQL += " AND zmieniony_operator='"+OperatorF+"'"
    if DataOdF.strip() <> '-  -':
        SQL += " AND SUBSTRING (z_czas::TEXT FROM 1 FOR 10)>='"+DataOdF+"'"
    if DataDoF.strip() <> '-  -':
        SQL += " AND SUBSTRING (z_czas::TEXT FROM 1 FOR 10)<='"+DataDoF+"'"
    SQL += " ORDER BY z_czas DESC"
    stat,dane,wyn1,wyn2 = self.PolSQL.Execute(SQL,3)
    if stat <> 'OK':
        stat = "Bd przy pobieraniu danych: "+stat
        dane.append(stat)
