#!/usr/bin/python
# -*- coding: iso8859_2 -*-
#-----------------------------------------------------------------------------
# Name:             fs_faktury_pozycje_opisowe.py
# Purpose:          dodaje/pobiera/usuwa faktury
# Author:           Marcin Grzeda
# Created:          2006/10/22
# RCS-ID:           $Id: fs_faktury_pozycje_opisowe.py $
# Copyright:        (c) 2006 RecordSystem
# Licence:          GNU GPL
#-----------------------------------------------------------------------------

#03.04.2009 - Dariusz Boduch - obsuga dla faktury z paragonu - mantis: 1945

Wyznacznik=klucze[0]
Data=klucze[1]
Numer=klucze[2]
NrPoz=klucze[3]


Fun=klucze[-1]
stat = "OK"
dane = []

#rsglobal.ZapiszDoLogow('Funkcja '+str(Fun),1)

puste_pola = ['    -  -  ','',[]]

self.CzyZParagonu = False

#pobranie uprawnie do wyznacznikw dla operatora
if self.operator_id == STANDARD_OPERATOR_ID:
    UprPrz=True
    UprDel=True
else:
    UprPrz=(self.oddzial_id,'022030') in self.uprawnienia
    UprDel=(self.oddzial_id,'022034') in self.uprawnienia
    
    
#sprawdzenie czy mona dodawa podany wyznacznik
if (Fun==11):
    UprDodawanie=True
    if self.operator_id <> STANDARD_OPERATOR_ID:
        UprDodawanie = ((self.oddzial_id,'022033') in self.uprawnienia)
    
        if UprDodawanie:
            Lista=[self.firma_id,self.oddzial_id,self.operator_id]
            sql = "SELECT rsf_podaj_wyznaczniki('"+str(Lista).replace("'",'"')+"','[]','[False,True,False,False,False,False]');"    
            stat,wyzn,dump,dump=self.PolSQL.Execute(sql,3)
            if stat=='OK':
                LWyzn=rsglobal.rseval(wyzn[0][0])[1]
                UprDodawanie=(Wyznacznik in LWyzn) and UprDodawanie
            
    dane=[[str(UprDodawanie)]]

#-------------------------------------------------------------------------------
#Funkcja 17
#Sprawdzanie czy faktura utworzona z paragonu
#jesli tak, to nie zmieniac rabatow, upustow, wersji cenowych 
#-------------------------------------------------------------------------------
if Fun in [17,6] and stat=='OK':
    sql = "SELECT z_paragonow FROM rs_faktury WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyznacznik+"' AND data='"+Data+"' AND numer="+str(Numer)
    stat,dane,dump,dump=self.PolSQL.Execute(sql,3)
    if stat=='OK' and len(dane)>0:
        CzyZParagonu=rsglobal.Dekoduj(dane[0][0])
    else:
        stat="BL SQL PAR"
        dane.append(stat)
    self.CzyZParagonu = CzyZParagonu

#-------------------------------------------------------------------------------


if Fun in [10] and stat=='OK':
    SELECT_WALUTA="SELECT waluta,kurs FROM rs_faktury WHERE firma_id = '"+self.firma_id+"' AND wyznacznik_id = '"+Wyznacznik+"' AND data='"+Data+"' AND numer="+str(Numer)+";"
    st,dane,dump,dump=self.PolSQL.Execute(SELECT_WALUTA,3)
    if st<>'OK':
        stat='BL SEL WAL'

# -- Usuwanie 6 -- #
if Fun in [6] and stat=='OK' and (not self.CzyZParagonu):    
    if UprDel:
        sql="DELETE FROM rs_faktury_pozycje_opisowe WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id = '"+Wyznacznik+"' AND data = '"+Data+"' AND numer = "+str(Numer)+" AND nr_poz = "+NrPoz+" "
        st,dump,dump,dump=self.PolSQL.Execute(sql,1)
        if st=='OK':
            sql="UPDATE rs_faktury_pozycje_opisowe SET nr_poz=nr_poz-1 WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id = '"+Wyznacznik+"' AND data = '"+Data+"' AND numer = "+str(Numer)+" AND nr_poz > "+NrPoz+";"
            st,dump,dump,dump=self.PolSQL.Execute(sql,1)
            if st<>'OK':
                stat='BL SQL UPD'
                dane.append(stat)
        else:
            stat='BL SQL DEL'
            dane.append(stat)
    else:
        stat="UPR DEL"   
        dane.append(stat)
            
        
# -- przegladanie 5, usuwanie 6 -- #
if (Fun in [5,6]) and (stat=='OK'):
    if UprPrz:
        SELECT_WALUTA="SELECT waluta FROM rs_faktury WHERE firma_id = '"+self.firma_id+"' AND wyznacznik_id = '"+Wyznacznik+"' AND data='"+Data+"' AND numer="+str(Numer)+";"
        d=[]
        st,d,dump,dump=self.PolSQL.Execute(SELECT_WALUTA,3)
        if st=='OK' and len(d)>0:
            Waluta=d[0][0]
            sql="SELECT nr_poz,opis_pozycji,stawka_vat,wartosc_netto,wartosc_vat,"
            sql+="wartosc_brutto,wartosc_wal_netto,wartosc_wal_vat,wartosc_wal_brutto "
            sql+="FROM rs_faktury_pozycje_opisowe WHERE firma_id='"+self.firma_id
            sql+="' AND wyznacznik_id='"+Wyznacznik+"' AND data='"+Data+"' AND numer="
            sql+=str(Numer)+"  ORDER BY nr_poz"
            stat,dane,wyn1,wyn2=self.PolSQL.Execute(rsglobal.Dekoduj(sql),3)
            if stat!="OK":
                stat="BL SQL SEL"
                dane.append(stat)
            else:
                wyn1=Waluta
        else:
            stat='BL SEL WAL'
            dane.append(stat)
    else:
        stat="UPR PRZ"
        dane.append(stat)
        

    
        
