import rsglobal

# -*- coding: iso8859_2 -*-

#-----------------------------------------------------------------------------
# Name:        fs_firmy.py
# Purpose:     obsluga firm: wybor,edycja,usuwanie
#
# Author:      Mariusz Rajfura
# Created:     2009/04/10
# RCS-ID:      $Id: fs_firmy.py $
# Copyright:   (c) 2009 Record System
# Licence:     GNU GPL
#-----------------------------------------------------------------------------

Firma = klucze[0].strip()
Fun = klucze[-1]

stat = 'OK'
dane = []
wyn2 = []

#-------------------------------------------------------------------------------
#---   USUWANIE DANYCH ( 3 )
#-------------------------------------------------------------------------------

if stat=='OK' and Fun==3:
    if self.operator_id != STANDARD_OPERATOR_ID:
        stat='BR_UPR'
        dane.append(stat)
        
    if stat=='OK':
        if Firma == '**':
            stat='BL_GWIAZDKI_DELETE'
            dane.append(stat)
            
    if stat=='OK':
        if Firma == self.firma_id:
            stat='BL_SELF_DELETE'
            dane.append(stat)

    if stat=='OK':
        sql="DELETE FROM rs_firmy WHERE firma_id='"+Firma+"';"
        stat,dane,wyn1,dump = self.PolSQL.Execute(sql,1)
        if stat<>'OK':
            stat='BL_DELETE'
            dane.append(stat)

#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH ( 5 )
#-------------------------------------------------------------------------------

if stat=='OK':
    if self.operator_id == STANDARD_OPERATOR_ID:
        sql="SELECT firma_id,opis FROM rs_firmy WHERE firma_id != '**' ORDER BY firma_id;"
        stat,dane,wyn1,dump = self.PolSQL.Execute(sql,3)
        if stat<>'OK':
            stat='BL_SELECT'
            dane.append(stat)
    else:
        sql = "SELECT DISTINCT f.firma_id,f.opis FROM rs_firmy f"
        sql +=" INNER JOIN rs_grupa_operator_oddzial go ON (f.firma_id=go.firma_id"
        sql +=" AND go.operator_id IN "+str(self.operatorzy)+") "
        sql +=" JOIN rs_operatorzy o USING (operator_id) "
        sql +=" WHERE f.firma_id != '**'  "
        sql +="AND (kontrahent_id IS NULL OR EXISTS(SELECT 1 FROM rs_kontrahenci k "
        sql +="WHERE k.firma_id=f.firma_id AND k.kontrahent_id=o.kontrahent_id ))"
        sql +="ORDER BY firma_id;"
        
        stat,dane,wyn1,dump = self.PolSQL.Execute(sql,3)
        if stat<>'OK':
            rsglobal.ZapiszDoLogow("Blad pobrania listy firm", 1)
            rsglobal.ZapiszDoLogow(sql, 1)
            stat='BL_SELECT'
            if dane is None:
                dane = []
            dane.append(stat)
