
# -*- coding: iso8859_2 -*-

#-------------------------------------------------------------------------------
# Name:        fs_formularze_dane.py
# Purpose:     formularze wprowadzanie i edycja
# Author:      Pawe Wojcikowski
# Created:     2009/07/16
# RCS-ID:      $Id: fs_formularze_dane.py $
# Copyright:   (c) 2009 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

FormularzId = klucze[0]
LiczbaWierszy = klucze[1]
LiczbaKolumn = klucze[2]
stat='OK'
dane = []

UprDodawanie=((self.oddzial_id,'077063') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)
UprEdycja=((self.oddzial_id,'077062') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID) or UprDodawanie

LiczbaWierszyN=LiczbaWierszy
LiczbaKolumnN=LiczbaKolumn
Zmieniac=False 


#-------------------------------------------------------------------------------
#---   SPR. DANYCH PRZED DELETE (11)
#-------------------------------------------------------------------------------

if klucze[-1] == 11 and stat=='OK':      
    Select="SELECT l_kolumn,l_wierszy FROM rs_formularze WHERE "
    Select+="firma_id='"+self.firma_id+"' AND formularz_id='"+FormularzId+"';"
    stat,daneL,dump,dump = self.PolSQL.Execute(Select ,3)    
    if stat=='OK':
        if len(daneL)<>0:
            LKol=str(daneL[0][0])[0:-2]
            LWier=str(daneL[0][1])[0:-2]
            if int(LiczbaKolumn)<int(LKol) or int(LiczbaWierszy)<int(LWier):
                stat='DEL POZ' 
                dane.append(stat)
    else:
        stat="Bd przy sprawdzaniu danych : "+stat   
        dane.append(stat)        


#-------------------------------------------------------------------------------
#---   UPDATE DANYCH (4- bez pobierania,3- z pobieraniem)
#-------------------------------------------------------------------------------

if klucze[-1] == 4 or klucze[-1]==3:      
    if not UprEdycja:
        stat='UPR UPD'
        dane.append(stat)
        
    if stat=='OK':
        #---   Sprawdzenie danych
        for i in range(len(pola)):
            pole = pola[i]
            wart = wartosci[i]
                      
            if pole=='okres_id' and stat== "OK":
                if wart <> '':
                    Select="SELECT okres_id FROM rs_definicje_okresow WHERE "
                    Select+="firma_id='"+self.firma_id+"' AND okres_id='"+wart+"';"
                    stat,d,dump,dump = self.PolSQL.Execute(Select ,3)
                    if stat=='OK':
                        if len(d) == 0:
                            stat = "BL OKRES"
                            dane.append(stat)
                         
            if pole in ['l_kolumn','l_wierszy'] and stat=='OK':
                Select="SELECT l_kolumn,l_wierszy FROM rs_formularze WHERE "
                Select+="firma_id='"+self.firma_id+"' AND formularz_id='"+FormularzId+"';"
                stat,daneL,dump,dump = self.PolSQL.Execute(Select ,3)
                if stat=='OK':
                    if len(daneL)<>0:
                        LiczbaKolumnS=daneL[0][0]
                        LiczbaWierszyS=daneL[0][1]
                    else:
                        LiczbaKolumnS=0
                        LiczbaWierszyS=0 
                    Zmieniac=True   
                else:    
                    stat="Bdy przy sprawdzaniu kolumn : "+stat   
                    dane.append(stat)     

        #--- zapis
        if stat == 'OK':
            where = " WHERE firma_id='"+self.firma_id+"' AND formularz_id='"+FormularzId+"';"
            upd = "UPDATE rs_formularze SET "
            
            for i in range(len(pola)):
                pole = pola[i]
                wart = wartosci[i]
                
                if pole in ['l_wierszy','l_kolumn']:
                    if wart=='':
                        upd=upd+pole+"=NULL,"
                    else:
                        upd=upd+pole+"="+str(wart)+","
                    
                elif pole in ['nazwa','okres_id','modul']:
                    if wart=='':
                        upd=upd+pole+"=NULL,"
                    else:
                        upd=upd+pole+"='"+str(wart)+"'," 
                elif pole in ['naglowek','stopka']:
                    if wart=='':
                        upd=upd+pole+"='',"
                    else:
                        upd=upd+pole+"='"+str(wart)+"',"         
            upd = upd[0:len(upd)-1]+where
                    
            stat,dump,dump,dump = self.PolSQL.Execute(upd ,1)   
                        
            if stat!="OK":
                stat="Bd przy modyfikowaniu danych : "+stat   
                dane.append(stat)
            
            #-zmiany liczby wierszy i kolumn w pozycjach
            if Zmieniac==True:
                if LiczbaWierszyN>LiczbaWierszyS: 
                    for LW in range(int(LiczbaWierszyS)+1,int(LiczbaWierszyN)+1):
                        for LK in range (1,int(LiczbaKolumnS)+1):
                            query="INSERT INTO rs_formularze_pozycje (firma_id,formularz_id"
                            query+=",wiersz,kolumna,nazwa,opis)"
                            query+=" VALUES ('"+self.firma_id+"','"+str(FormularzId)+"',"
                            query+=""+str(LW)+","+str(LK)+",NULL,NULL);"
                            stat,dump,dump,dump = self.PolSQL.Execute(query ,1)  
                            if stat<>'OK':
                                stat = 'Bdy przy dodawaniu danych wierszy :'+stat
                                dane.append(stat)  
                             
                if LiczbaKolumnN>LiczbaKolumnS:    
                    for LW in range(1,int(LiczbaWierszyN)+1):
                        for LK in range (int(LiczbaKolumnS)+1,int(LiczbaKolumnN)+1):
                            query="INSERT INTO rs_formularze_pozycje (firma_id,formularz_id,"
                            query+="wiersz,kolumna,nazwa,opis)"
                            query+=" VALUES ('"+self.firma_id+"','"+str(FormularzId)+"',"
                            query+=""+str(LW)+","+str(LK)+",NULL,NULL);"
                            stat,dump,dump,dump = self.PolSQL.Execute(query ,1)  
                            if stat<>'OK':
                                stat = 'Bdy przy dodawaniu danych kolumn :'+stat
                                dane.append(stat)  

                if int(LiczbaWierszyN)<int(str(LiczbaWierszyS)[0:-2]):
                    query="DELETE FROM rs_formularze_pozycje WHERE"
                    query+=" firma_id='"+self.firma_id+"' AND formularz_id='"+str(FormularzId)+"'"
                    query+=" AND wiersz>"+str(LiczbaWierszyN)+";"
                    query+=" DELETE FROM rs_formularze_definicje WHERE"
                    query+=" firma_id='"+self.firma_id+"' AND formularz_id='"+str(FormularzId)+"'"
                    query+=" AND wiersz>"+str(LiczbaWierszyN)+";"
                    stat,dump,dump,dump = self.PolSQL.Execute(query ,1)                              
                    if stat<>'OK':
                        stat = 'Bdy przy usuwaniu wierszy:'+stat
                        dane.append(stat) 
                                        
                if int(LiczbaKolumnN)<int(str(LiczbaKolumnS)[0:-2]):   
                    query="DELETE FROM rs_formularze_pozycje WHERE"
                    query+=" firma_id='"+self.firma_id+"' AND formularz_id='"+str(FormularzId)+"'"
                    query+=" AND kolumna>"+str(LiczbaKolumnN)+";"
                    query+=" DELETE FROM rs_formularze_pozycje WHERE"
                    query+=" firma_id='"+self.firma_id+"' AND formularz_id='"+str(FormularzId)+"'"
                    query+=" AND kolumna>"+str(LiczbaKolumnN)+";"
                    stat,dump,dump,dump = self.PolSQL.Execute(query ,1)                              
                    if stat<>'OK':
                        stat = 'Bdy przy usuwaniu kolumn:'+stat
                        dane.append(stat)  
           
            
#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (5 -select, 3 -update z pobraniem, 1 -insert z pobraniem)
#-------------------------------------------------------------------------------

if (klucze[-1] in [5,3,1]) and (stat=='OK'):
    Select="SELECT * FROM rs_formularze WHERE firma_id='"+self.firma_id+"' "
    Select+="AND formularz_id='"+FormularzId+"' ;"
    stat,dane,wyn1,tr = self.PolSQL.Execute(Select,3)
    if stat!="OK":
        stat="Bd przy pobieraniu danych : "+stat   
        dane.append(stat)