# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_formularze_pozycje_dane.py
# Purpose:     formularze wprowadzanie i edycja
# Author:      Pawe Wojcikowski
# Created:     2009/07/16
# RCS-ID:      $Id: fs_formularze_pozycje_dane.py $
# Copyright:   (c) 2009 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

# 2012-02-03 Mariusz Rajfura  kontrola pola 'opis' w powiazaniu z definicjami (5443)
    

FormularzId = klucze[0]
Wiersz = klucze[1]
Kolumna = klucze[2]

Fun = klucze[-1]
stat = 'OK'
dane = []
wyn1 = []
wyn2 = []

UprDodawanie=((self.oddzial_id,'077063') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)
UprEdycja=((self.oddzial_id,'077062') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID) or UprDodawanie


#-------------------------------------------------------------------------------
#---   UPDATE DANYCH (4- bez pobierania,3- z pobieraniem)
#-------------------------------------------------------------------------------

if Fun in [3,4] and stat== 'OK':   
    if not UprEdycja:
        stat = "Brak uprawnie do modyfikacji danych."   
        dane.append(stat)
    
    if stat == 'OK':
        sql ="SELECT nazwa FROM rs_formularze_pozycje"
        sql+=" WHERE firma_id='"+self.firma_id+"' AND formularz_id='"+FormularzId+"'"
        sql+=" AND kolumna='"+Kolumna+"' AND wiersz='"+Wiersz+"' FOR UPDATE NOWAIT;"
        
        stat,d,dump,dump = self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Bd sprawdzenia istnienia pozycji: '+stat
        elif len(d) == 0:
            stat = 'Brak pozycji o podanym kluczu.'
        
    if stat == 'OK':
        #---   Sprawdzenie danych
        for i in range(len(pola)):
            pole = pola[i]
            wart = wartosci[i]
            if pole == 'opis':
                wart = wart.strip()
                if wart <> '':
                    sql ="SELECT COUNT(*)>0 FROM rs_formularze_definicje"
                    sql+=" WHERE firma_id='"+self.firma_id+"' AND formularz_id='"+FormularzId+"'"
                    sql+=" AND kolumna="+Kolumna+" AND wiersz="+Wiersz+";"
                    stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                    if stat <> 'OK':
                        stat = 'Bd pobrania informacji o definicjach w pozycji formularza: '+stat
                    elif d[0][0]:
                        stat = 'Uycie formuy obliczeniowej wyklucza wprowadzenie opisu.'

            
    if stat == 'OK':
        #--- zapis
        if stat == 'OK':
            where = " WHERE firma_id='"+self.firma_id+"' AND formularz_id='"+FormularzId+"'"
            where +=" AND kolumna='"+Kolumna+"' AND wiersz='"+Wiersz+"';"
            upd = "UPDATE rs_formularze_pozycje SET "
            for i in range(len(pola)):
                pole = pola[i]
                wart = wartosci[i]
                if pole in ['wytluszczenie','wyposrodkowanie']:
                    upd=upd+pole+"="+str(wart)+","
                elif pole in ['opis','nazwa']:
                    if wart=='':
                        upd=upd+pole+"=NULL,"
                    else:
                        upd=upd+pole+"='"+str(wart)+"',"    
            upd = upd[0:len(upd)-1]+where
            stat,dump,dump,dump = self.PolSQL.Execute(upd ,1)     
            if stat!="OK":
                stat="Bd przy modyfikowaniu danych : "+stat   
                dane.append(stat)
            
            
#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (5 -select, 3 -update z pobraniem, 1 -insert z pobraniem)
#-------------------------------------------------------------------------------

if Fun in [1,3,5] and (stat=='OK'): 
    Select="SELECT * FROM rs_formularze_pozycje WHERE firma_id='"+self.firma_id+"' "
    Select+="AND formularz_id='"+FormularzId+"' AND kolumna="+Kolumna+" AND wiersz="+Wiersz+";"
    stat,dane,wyn1,tr = self.PolSQL.Execute(Select,3)
    if stat!="OK":
        stat="Bd przy pobieraniu danych : "+stat   
        dane.append(stat)

    # pobranie danych dodatkowych
    if stat == 'OK':
        # [0] czy pozycja posiada definicje
        sql ="SELECT COUNT(*)>0 FROM rs_formularze_definicje"
        sql+=" WHERE firma_id='"+self.firma_id+"' AND formularz_id='"+FormularzId+"'"
        sql+=" AND kolumna="+Kolumna+" AND wiersz="+Wiersz+";"
        stat,d,dump,dump = self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Bd pobrania informacji o definicjach w pozycji formularza: '+stat
        else:
            wyn2.append(d[0][0])