# -*- coding: iso8859_2 -*-
#-----------------------------------------------------------------------------
# Name:        fs_gr_raport_generatora.py
# Purpose:     wykonuje raport generatora
#
# Author:      Micha Raburski
#
# Created:     2007/10/01
# RCS-ID:      $Id: fs_gr_raport_generatora.py $
# Copyright:   (c) 200-2008 Record System
# Licence:     GNU GPL
#-----------------------------------------------------------------------------

# 2020-02-19 11867 JR uzupelnienie raportu o definiowalne wiersze

Tabela = klucze[0]
Nr = klucze[1]
Param = klucze[2]
Fun = klucze[-1]

stat = 'OK'
dane = '[]'
wyn2 = []

#-------------------------------------------------------------------------------
# SPRAWDZENIE PODSTAWOWYCH DANYCH
#-------------------------------------------------------------------------------

stat,d,dump,dump = self.PolSQL.Execute("SELECT rodzaj FROM rs_tabele_generatora WHERE tabela='"+Tabela+"';", 2)
if stat == 'OK':
    if len(d) == 0:
        stat='BR TAB'
    
if stat == 'OK':
    typ=d[0][0]
    
if (self.operator_id <> STANDARD_OPERATOR_ID):
    if typ == 'SP':
        if not ((self.oddzial_id,'083000') in self.uprawnienia):
            stat = 'UPR'
    elif typ == 'KS':
        if not ((self.oddzial_id,'084000') in self.uprawnienia):
            stat = 'UPR'
    elif typ == 'KP':
        if not ((self.oddzial_id,'086000') in self.uprawnienia):
            stat = 'UPR'
    ## pamietac o dodaniu uprawnien do kadr
    else:
        stat = 'UPR'

if stat=='OK':
    #pobranie danych do raportu
    stat,DNagl,dump,dump = self.PolSQL.Execute("SELECT klauzula_where FROM rs_raporty_generatora WHERE tabela='"+Tabela+"' AND numer='"+str(Nr)+"';",3)
    if stat == 'OK':
        stat,DPola,dump,dump = self.PolSQL.Execute("SELECT nazwa,definicja,grupowanie,kolejnosc FROM rs_raporty_generatora_pola WHERE tabela='"+Tabela+"' AND numer='"+str(Nr)+"' AND NOT wiersz ORDER BY nr_poz;", 3)
    if stat == 'OK':
        stat,DWiersze,dump,dump = self.PolSQL.Execute("SELECT nazwa,definicja,grupowanie,kolejnosc FROM rs_raporty_generatora_pola WHERE tabela='"+Tabela+"' AND numer='"+str(Nr)+"' AND wiersz ORDER BY nr_poz;", 3)
    if stat == 'OK':
        if (self.operator_id <> STANDARD_OPERATOR_ID):
            stat,DGenOddz,dump,dump = self.PolSQL.Execute("SELECT generator_oddzial_id FROM rs_operatorzy WHERE operator_id in "+str(self.operatorzy).replace("[","(").replace("]",")")+";",3)

#-------------------------------------------------------------------------------
# POBRANIE PARAMETRW - 1 
#-------------------------------------------------------------------------------

if Fun == 1 and stat == 'OK':
    LParam = []
    wiersz = DNagl[0][0]
    while wiersz.find('##') >= 0:
        Pocz=wiersz.find('##')
        Kon=wiersz.find('##',Pocz+2)
        if Kon == -1:
            wiersz = ''
        else:
            param = wiersz[Pocz+2:Kon]
            wiersz = wiersz[Kon+2:]
            if not param in LParam:
                LParam.append(param)

    for w in DPola:
        wiersz = w[1]
        while wiersz.find('##') >= 0:
            Pocz=wiersz.find('##')
            Kon=wiersz.find('##',Pocz+2)
            if Kon == -1:
                wiersz = ''
            else:
                param = wiersz[Pocz+2:Kon]
                wiersz = wiersz[Kon+2:]
                if not param in LParam:
                    LParam.append(param)
    
    dane = LParam
        

#-------------------------------------------------------------------------------
# WYKONANIE RAPORTU - 2
#-------------------------------------------------------------------------------

elif Fun==2 and stat=='OK':
    #rsglobal.ZapiszDoLogow(str(DNagl),1)
    #rsglobal.ZapiszDoLogow(str(DPola),1)
    #rsglobal.ZapiszDoLogow(str(DHaving),1)
    SQL="SELECT "
    
    #pola
    for p in DPola:
        defin=rsglobal.Dekoduj(p[1].strip())
        
        #jeli s parametry to wstawiamy je
        if defin.find('##')>=0:
            for par in Param:
                defin = defin.replace('##'+par[0]+'##',rsglobal.Dekoduj(par[1]))
            
        SQL+=rsglobal.Dekoduj(defin)+' AS "'+rsglobal.Dekoduj(p[0].strip())+'",'
    SQL=SQL[0:-1]
    SQL+=" FROM "+Tabela.strip()
    
    #where
    #rsglobal.ZapiszDoLogow('HANDLOWIEC '+str(self.handlowiec_id),1)
    #rsglobal.ZapiszDoLogow('HANDLOWIEC '+str(self.handlowiec_id),1)
    SQL+=" WHERE firma_id='"+self.firma_id+"'"
    if (self.operator_id <> STANDARD_OPERATOR_ID):
        if DGenOddz[0][0] not in ('  ','',None,'None'):
            SQL+=" AND oddzial_id='"+rsglobal.Dekoduj(DGenOddz[0][0])+"'"
            
    if (Tabela.strip() in ['rs_gr_dowody_dostaw','rs_gr_dowody_dostaw_sumy']):
        if self.handlowiec_id not in ('   ','',None,'None'):
            SQL+=" AND handlowiec_id='"+rsglobal.Dekoduj(self.handlowiec_id)+"'"            
    
    if (Tabela.strip() in ['rs_gr_sprzedaz','rs_gr_sprzedaz_pozycje']):
        if self.handlowiec_id not in ('   ','',None,'None'):
            SQL+=" AND handlowiec_kod='"+rsglobal.Dekoduj(self.handlowiec_id)+"'"            
            
    #rsglobal.ZapiszDoLogow('SQL '+str(SQL),1)
    #wstawienie filtra
    if DNagl[0][0] <> '':
        defin=rsglobal.Dekoduj(DNagl[0][0])
        #wstawienie parametrow
        if defin.find('##')>=0:
            for par in Param:
                defin=defin.replace('##'+par[0]+'##',rsglobal.Dekoduj(par[1]))
        
        SQL+=" AND ("+rsglobal.Dekoduj(defin)+")"
    #rsglobal.ZapiszDoLogow(SQL,5)
    #grupowanie
    LGrup=[]
    SQLGroup = ''
    for p in DPola:
        if p[2]:
            defin=rsglobal.Dekoduj(p[1].strip())
            #jeli s parametry to wstawiamy je
            if defin.find('##')>=0:
                for par in Param:
                    defin=defin.replace('##'+par[0]+'##',rsglobal.Dekoduj(par[1]))
        
            LGrup.append([defin])
            
    if len(LGrup)>0:
        SQLGroup  = " GROUP BY "
        for gr in LGrup:
            SQLGroup += rsglobal.Dekoduj(gr[0].strip())+","
        SQLGroup = SQLGroup[0:-1]
            
    if len(DWiersze) == 0:
        # raport bez definicji wierszy
        SQL += SQLGroup
        #order by
        LOrder = []
        for p in DPola:
            if p[3] >0:
                defin=rsglobal.Dekoduj(p[1].strip())
                #jeli s parametry to wstawiamy je
                if defin.find('##')>=0:
                    for par in Param:
                        defin=defin.replace('##'+par[0]+'##',rsglobal.Dekoduj(par[1]))
                    
                LOrder.append([p[3],defin])
    
        LOrder.sort()
        if len(LOrder)>0:
            SQL+=" ORDER BY "
            for ord in LOrder:
                SQL+=rsglobal.Dekoduj(ord[1].strip())+","
            SQL=SQL[0:-1]
    
        SQL+=";"
        rsglobal.ZapiszDoLogow(SQL,5)
        stat,Dane,Wyn1,Wyn2=self.PolSQL2.Execute(SQL,3,None,False,True)

    else:
        # raport z definicjami wierszy
        Dane = []
        MaxSzer = 0
        for p in DWiersze:
            MaxSzer = max(MaxSzer,len(p[0].strip()))
            defin = rsglobal.Dekoduj(p[1].strip())
            # jeli s parametry to wstawiamy je
            if defin.find('##') >= 0:
                for par in Param:
                    defin = defin.replace('##' + par[0] + '##', rsglobal.Dekoduj(par[1]))
            if stat == 'OK':
                stat, wiersze, Wyn1, Wyn2 = self.PolSQL2.Execute(SQL + " AND (" + defin + ") " + SQLGroup + ";", 3, None, False, True)
            if stat == 'OK':
                #if len(wiersz) > 1:
                #    stat = 'Wicej ni jeden wiersz w zapytaniu: ' + SQL + " AND (" + defin + ") " + SQLGroup + ";"
                if len(wiersze) >= 1:
                    Wyn1Pom = Wyn1
                    for wiersz in wiersze:
                        d = []
                        d.append(rsglobal.Dekoduj(p[0].strip()))
                        for w in wiersz:
                            d.append(w)
                        Dane.append(d)
        if stat == 'OK':
            Wyn1 = []
            if len(Dane) > 0:
                Wyn1.append(['Opis','str',MaxSzer,MaxSzer,None,None,None])
                for w in Wyn1Pom:
                    Wyn1.append(w)

    dane=str([Dane,Wyn1,Wyn2])