# -*- coding: iso8859_2 -*-
#-----------------------------------------------------------------------------
# Name:        fs_gr_raporty_uzytkownikow.py
# Purpose:     pobiera liste raportw dotyczc wybranej tabeli generatora
#
# Author:      Micha Raburski
#
# Created:     2007/09/21
# RCS-ID:      $Id: fs_gr_raporty_uzytkownikow.py $
# Copyright:   (c) 2007 Record System
# Licence:     GNU GPL
#-----------------------------------------------------------------------------
# Marcin Natkaski - Dodanie komunikatu(4306)
# 2020-02-21 Aleksander Bargie (11865) Generator - kadry/pace.

typ=klucze[0]
Tabela=klucze[1]
NumerF=klucze[2]
LoginF=klucze[3]
RodzajF=klucze[4]
OpisF=klucze[5]
Numer=klucze[6]

Fun=klucze[-1]

stat='OK'
dane=[]

if (self.operator_id <> STANDARD_OPERATOR_ID):
    if typ=='SP':
        if not ((self.oddzial_id,'083000') in self.uprawnienia):
            stat='Brak uprawnie do przegldania raportw generatora w sprzeday'
        self.UprKopiowanie=((self.oddzial_id,'083002') in self.uprawnienia)
        self.UprUsuwanie=((self.oddzial_id,'083003') in self.uprawnienia)
        self.UprUsuwanieCudzych=((self.oddzial_id,'083005') in self.uprawnienia)
        
    elif typ=='KS':
        if not ((self.oddzial_id,'084000') in self.uprawnienia):
            stat='Brak uprawnie do przegldania raportw generatora w ksigowoci'
        self.UprKopiowanie=((self.oddzial_id,'084002') in self.uprawnienia)
        self.UprUsuwanie=((self.oddzial_id,'084003') in self.uprawnienia)
        self.UprUsuwanieCudzych=((self.oddzial_id,'084005') in self.uprawnienia)
    #AB 21.02.20r
    elif typ=='KP':
        if not ((self.oddzial_id,'086000') in self.uprawnienia):
            stat='Brak uprawnie do przegldania raportw generatora w kadrach'
        self.UprKopiowanie=((self.oddzial_id,'086002') in self.uprawnienia)
        self.UprUsuwanie=((self.oddzial_id,'086003') in self.uprawnienia)
        self.UprUsuwanieCudzych=((self.oddzial_id,'086005') in self.uprawnienia)
    else:
        stat='UPR'
else:
    self.UprUsuwanie=True
    self.UprKopiowanie=True
    self.UprUsuwanieCudzych=True

#--- KOPIOWANIE
if Fun==7 and stat=='OK':
    if not self.UprKopiowanie:
        if typ=='SP':
            stat='Brak uprawnie do kopiowania raportw generatora w sprzeday'
        elif typ=='KS':
            stat='Brak uprawnie do kopiowania raportw generatora w ksigowoci'
            #AB 21.02.20r
        elif typ=='KP':
            stat='Brak uprawnie do kopiowania raportw generatora w kadrach'
        else:    
            stat='Brak uprawnie do kopiowania raportw'
            
    #pobranie nowego numeru
    if stat=='OK':    
        dump,d,dump,dump = self.PolSQL.Execute("SELECT max(numer) FROM rs_raporty_generatora WHERE tabela='"+Tabela+"';",3)
        if len(d)>0:
            Nr=str(d[0][0]+1)[0:-2]
        else:
            Nr='1'
            
        stat,dump,dump,dump=self.PolSQL.Execute("INSERT INTO rs_raporty_generatora (tabela,numer,raport,rodzaj,wlasciciel_id,klauzula_where) SELECT tabela,"+Nr+",raport,rodzaj,"+str(self.operator_id)+",klauzula_where FROM rs_raporty_generatora WHERE tabela='"+Tabela+"' AND numer="+str(Numer)+";",1)
        if stat<>'OK':
            stat='Wystpiy bdy podczas kopiowania raportu'
        stat,dump,dump,dump=self.PolSQL.Execute("INSERT INTO rs_raporty_generatora_pola (tabela,numer,nr_poz,nazwa,definicja,grupowanie,kolejnosc, wiersz) SELECT tabela,"+Nr+",nr_poz,nazwa,definicja,grupowanie,kolejnosc, wiersz FROM rs_raporty_generatora_pola WHERE tabela='"+Tabela+"' AND numer="+str(Numer)+";",1)
        if stat<>'OK':
            stat='Wystpiy bdy podczas kopiowania raportu'
        wyn1=Nr
        

#--- USUWANIE
if Fun==6 and stat=='OK':
    if not self.UprUsuwanie:
        if typ=='SP':
            stat='Brak uprawnie do usuwania raportw generatora w sprzeday'
        elif typ=='KS':
            stat='Brak uprawnie do usuwania raportw generatora w ksigowoci'
            #AB 21.02.20r
        elif typ=='KP':
            stat='Brak uprawnie do usuwania raportw generatora w kadrach'
        else:    
            stat='Brak uprawnie do usuwania raportw'

    if stat=='OK':
        st,d,dump,dump=self.PolSQL.Execute("SELECT wlasciciel_id FROM rs_raporty_generatora WHERE tabela='"+Tabela+"' AND numer="+str(Numer)+";",3)
        if len(d)==0:
            stat='Brak usuwanego raportu'
        
    if stat=='OK':    
        Wlasc=d[0][0]
        if Wlasc <> self.operator_id:
            if not self.UprUsuwanieCudzych:
                if typ=='SP':
                    stat='Brak uprawnie do usuwania cudzych raportw generatora w sprzeday'
                elif typ=='KS':
                    stat='Brak uprawnie do usuwania cudzych raportw generatora w ksigowoci'
                    #AB 21.02.20r
                elif typ=='KP':
                    stat='Brak uprawnie do usuwania cudzych raportw generatora w kadrach'
                else:    
                    stat='Brak uprawnie do usuwania cudzych raportw'

    if stat=='OK':
        stat,dump,dump,dump=self.PolSQL.Execute("DELETE FROM rs_raporty_generatora WHERE tabela='"+Tabela+"' AND numer="+str(Numer)+";",1)


#--- PRZEGLDANIE
if stat=='OK' and Fun in [4,5,6,7]:
    Filtr ="WHERE r.tabela='"+Tabela+"'"
    if NumerF <> 0:
        Filtr+=" AND r.numer="+str(NumerF)
    if LoginF <> '':
        Filtr+=" AND o.login LIKE '"+LoginF+"%'"
    if RodzajF <> '':
        Filtr+=" AND r.rodzaj='"+RodzajF+"'"
    if OpisF<>'':
        Filtr+=" AND r.raport LIKE '%"+OpisF+"%'"
        
    stat,dane,dump,dump=self.PolSQL.Execute("SELECT r.numer,r.raport,r.rodzaj,o.login FROM rs_raporty_generatora r INNER JOIN rs_operatorzy o ON (r.wlasciciel_id=o.operator_id) "+Filtr+" ORDER BY r.rodzaj,r.numer;",3)
