#!/usr/bin/python
# -*- coding: iso8859_2 -*-
#-----------------------------------------------------------------------------
# Name:             fs_gr_sprzedaz.py
# Purpose:          dodaje/pobiera/usuwa dane sprzedaowe
# Author:           Dariusz Boduch
# Created:          2007/09/29
# RCS-ID:           $Id: fs_gr_sprzedaz.py $
# Copyright:        (c) 2006 RecordSystem
# Licence:          GNU GPL
#-----------------------------------------------------------------------------

#klucze:
# 0: firma_id
# 1: Data_od
# 2: Data_do


firma_id=klucze[0]
Data_od=klucze[1]
Data_do=klucze[2]



Fun=klucze[-1]
stat = "OK"
dane = []

UprPrz=(self.oddzial_id,'083000') in self.uprawnienia or (self.operator_id == STANDARD_OPERATOR_ID)



# -- Usuwanie danych -- 
if Fun in [6]:
    Filtr="firma_id='"+self.firma_id+"' AND data>='"+Data_od+"' AND data<='"+Data_do+"'"
    stat,dane,wyn1,wyn2=self.PolSQL2.Execute("DELETE FROM rs_gr_sprzedaz WHERE "+Filtr,1)


#--INSERT danych sprzedaowych z faktur
if stat=="OK":
            
    Filtr="f1.firma_id='"+self.firma_id+"' AND f1.data>='"+Data_od+"' AND f1.data<='"+Data_do+"'"
    
    Insert="rs_gr_sprzedaz "
    Insert=Insert+"(firma_id,oddzial_id,oddz_opis,data,kontrahent_id,kontrahent_opis,k_kraj,"
    Insert=Insert+"k_adr_kod,k_adr_miej,k_adr_ulica,k_adr_poczta,k_adr_nry,k_bank_nazwa,k_bank_konto,k_tel1,k_tel2,k_fax,k_email,"
    Insert=Insert+"k_regon,k_nip,kateg_kontrahenta,kateg_kontr_opis,k_region,region_opis,handlowiec_kod,handlowiec_opis,f_wyznacznik_id,f_numer,f_stan,f_zamawiajacy_id,"
    Insert=Insert+"f_platnik_id,f_projekt_id,projekt_nazwa,f_kwota_netto,f_kwota_netto_wal,d_kwota,d_kwota_wal)"
     
    Select="SELECT f1.firma_id,f1.oddzial_id,o.opis,f1.data,f1.kontrahent_id,k1.nazwa,k1.kraj,k1.adr_kod,k1.adr_miej,k1.adr_ulica,k1.adr_poczta,k1.adr_nry,k1.bank_nazwa,"
    Select=Select+"k1.bank_konto,k1.tel1,k1.tel2,k1.fax,k1.email,k1.regon, k1.nip,k1.kateg_kontrahenta,kk.opis,k1.region,r.opis,f1.handlowiec,h1.opis,f1.wyznacznik_id,f1.numer,"
    Select=Select+"f1.stan,f1.zamawiajacy_id,f1.platnik_id,f1.projekt_id,p.nazwa,f1.kwota_netto,f1.kwota_netto_wal,sum(dm.kwota),sum(dm.kwota_wal)"
    
    From="rs_faktury f1"
    From=From+"LEFT OUTER JOIN rs_oddzialy o ON (f1.firma_id=o.firma_id AND f1.oddzial_id=o.oddzial_id) "
    From=From+"LEFT OUTER JOIN rs_kontrahenci k1 ON (f1.firma_id=k1.firma_id AND f1.kontrahent_id=k1.kontrahent_id) "
    From=From+"LEFT OUTER JOIN rs_kateg_kontrahentow kk ON (k1.firma_id=kk.firma_id AND k1.kateg_kontrahenta=kk.kod) "
    From=From+"LEFT OUTER JOIN rs_handlowcy h1 ON (f1.firma_id=h1.firma_id AND f1.handlowiec=h1.kod) "
    From=From+"LEFT OUTER JOIN rs_dokumenty_magazynowe dm ON(f1.firma_id=dm.firma_id AND f1.wyznacznik_id=dm.f_wyznacznik_id AND f1.data=dm.f_data AND f1.numer=dm.f_numer) "
    From=From+"LEFT OUTER JOIN rs_regiony r ON (k1.firma_id=r.firma_id AND k1.region=r.kod) "
    From+From+"LEFT OUTER JOIN rs_projekty p ON (f1.firma_id=p.firma_id AND f1.projekt_id=p.projekt_id)"
    
    GroupBy="f1.firma_id,f1.oddzial_id,o.opis,f1.data,f1.kontrahent_id,k1.nazwa,k1.kraj,k1.adr_kod,k1.adr_miej,k1.adr_ulica,k1.adr_poczta,k1.adr_nry,k1.bank_nazwa,"
    GroupBy=GroupBy+"k1.bank_konto,k1.tel1,k1.tel2,k1.fax,k1.email,k1.regon, k1.nip,k1.kateg_kontrahenta,kk.opis,k1.region,r.opis,f1.handlowiec,h1.opis,f1.wyznacznik_id,f1.numer,"
    GroupBy=GroupBy+"f1.stan,f1.zamawiajacy_id,f1.platnik_id,f1.projekt_id,p.nazwa,f1.kwota_netto,f1.kwota_netto_wal"
    
    stat,dane,wyn1,wyn2=self.PolSQL2.Execute("INSERT INTO "+Insert+" SELECT "+Select+" FROM "+From+" WHERE "+Filtr+" GROUP BY "+GroupBy+" ;",1)



#--INSERT danych sprzedaowych z korekt
if stat=="OK":
    
    Filtr="ko.firma_id='"+self.firma_id+"' AND ko.data>='"+Data_od+"' AND ko.data<='"+Data_do+"'"
    
    Insert="rs_gr_sprzedaz "
    Insert=Insert+"(firma_id,oddzial_id,oddz_opis,data,kontrahent_id,kontrahent_opis,k_kraj,"
    Insert=Insert+"k_adr_kod,k_adr_miej,k_adr_ulica,k_adr_poczta,k_adr_nry,k_bank_nazwa,k_bank_konto,k_tel1,k_tel2,k_fax,k_email,"
    Insert=Insert+"k_regon,k_nip,kateg_kontrahenta,kateg_kontr_opis,k_region,region_opis,handlowiec_kod,handlowiec_opis,k_wyznacznik_id,k_numer,k_stan,k_zamawiajacy_id,"
    Insert=Insert+"k_platnik_id,k_projekt_id,projekt_nazwa,k_kwota_netto,k_kwota_netto_wal,d_kwota,d_kwota_wal)"
    
    Select="ko.firma_id,ko.oddzial_id,o.opis,ko.data,ko.kontrahent_id,k1.nazwa,k1.kraj,k1.adr_kod,k1.adr_miej,k1.adr_ulica,k1.adr_poczta,k1.adr_nry,k1.bank_nazwa,"
    Select=Select+"k1.bank_konto,k1.tel1,k1.tel2,k1.fax,k1.email,k1.regon, k1.nip,k1.kateg_kontrahenta,kk.opis,k1.region,r.opis,ko.handlowiec,h1.opis,ko.wyznacznik_id,ko.numer,"
    Select=Select+"ko.stan,ko.zamawiajacy_id,ko.platnik_id,ko.projekt_id,p.nazwa,ko.kwota_netto,ko.kwota_netto_wal,sum(dm.kwota),sum(dm.kwota_wal)"
    
    From="rs_korekty ko"
    From=From+"LEFT OUTER JOIN rs_oddzialy o ON (ko.firma_id=o.firma_id AND ko.oddzial_id=o.oddzial_id) " 
    From=From+"LEFT OUTER JOIN rs_kontrahenci k1 ON (ko.firma_id=k1.firma_id AND ko.kontrahent_id=k1.kontrahent_id) " 
    From=From+"LEFT OUTER JOIN rs_kateg_kontrahentow kk ON (k1.firma_id=kk.firma_id AND k1.kateg_kontrahenta=kk.kod) "
    From=From+"LEFT OUTER JOIN rs_handlowcy h1 ON (ko.firma_id=h1.firma_id AND ko.handlowiec=h1.kod) "
    From=From+"LEFT OUTER JOIN rs_dokumenty_magazynowe dm ON(ko.firma_id=dm.firma_id AND ko.wyznacznik_id=dm.k_wyznacznik_id AND ko.data=dm.k_data AND ko.numer=dm.k_numer) "
    From=From+"LEFT OUTER JOIN rs_regiony r ON (k1.firma_id=r.firma_id AND k1.region=r.kod) "
    From=From+"LEFT OUTER JOIN rs_projekty p ON (ko.firma_id=p.firma_id AND ko.projekt_id=p.projekt_id) "
    
    GroupBy="ko.firma_id,ko.oddzial_id,o.opis,ko.data,ko.kontrahent_id,k1.nazwa,k1.kraj,k1.adr_kod,k1.adr_miej,k1.adr_ulica,k1.adr_poczta,k1.adr_nry,k1.bank_nazwa,"
    GroupBy=GroupBy+"k1.bank_konto,k1.tel1,k1.tel2,k1.fax,k1.email,k1.regon, k1.nip,k1.kateg_kontrahenta,kk.opis,k1.region,r.opis,ko.handlowiec,h1.opis,ko.wyznacznik_id,ko.numer,"
    GroupBy=GroupBy+"ko.stan,ko.zamawiajacy_id,ko.platnik_id,ko.projekt_id,p.nazwa,ko.kwota_netto,ko.kwota_netto_wal"

    stat,dane,wyn1,wyn2=self.PolSQL2.Execute("INSERT INTO "+Insert+" SELECT "+Select+" FROM "+From+" WHERE "+Filtr+" GROUP BY "+GroupBy+" ;",1)









