# -*- coding: iso8859_2 -*-

#-------------------------------------------------------------------------------
# Name:        fs_grupy_analityczne_dane.py
# Purpose:     edycja grupy analitycznej
#
# Author:      Mariusz Rajfura
# Created:     2009/09/05
# RCS-ID:      $Id: fs_grupy_analityczne_dane.py $
# Copyright:   (c) 2009 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

Grupa = rsglobal.Dekoduj(klucze[0]).strip()
Fun = klucze[-1]

stat = 'OK'
dane = []
wyn1 = []

if Fun in (1,2):
    if not (((self.oddzial_id,'072013') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID):
        stat = 'BR UPR INS'
        
if Fun in (3,4):
    if not (((self.oddzial_id,'072012') in self.uprawnienia) or ((self.oddzial_id,'072013') in self.uprawnienia) or \
            self.operator_id == STANDARD_OPERATOR_ID):
        stat = 'BR UPR UPD'

#-------------------------------------------------------------------------------
# INSERT  1-z pobraniem   2-bez pobrania
#-------------------------------------------------------------------------------

if Fun in (1,2) and stat == 'OK':
    if Grupa == '':
        stat = 'BR GRUPA'
        dane.append(stat)
    
    if stat == 'OK':
        sql ="SELECT grupa_id FROM rs_grupy_analityczne"
        sql+=" WHERE firma_id = '"+self.firma_id+"' AND okres_id = '"+self.okres_id+"' AND grupa_id = '"+Grupa+"';"
        stat,d,wyn1,dump = self.PolSQL.Execute(sql, 3)
        if stat <> 'OK':
            stat = 'Bd sprawdzenia grupy analitycznej : '+stat
        elif len(d) > 0:
            stat = 'BL GRUPA IST'
    
    if stat == 'OK':             
        sqlpola = 'firma_id,okres_id'
        sqlwart = "'"+self.firma_id+"','"+self.okres_id+"'"
    
        for i in xrange(len(pola)):
            pole = pola[i]
            wart = wartosci[i]
            
            if pole == 'grupa_id':
                wart = "'"+wart+"'"
                
            elif pole == 'nazwa':
                if wart == '':
                    dane.append('BR NAZWA')
                else:
                    wart = "'"+wart+"'"
            
            elif pole == 'dlugosc':
                if not wart in xrange(1,21):
                    dane.append('BL DLUGOSC')
                wart = str(wart)
                
            elif type(wart) == type(True):
                wart = str(wart)
                    
            sqlpola += ","+pole
            sqlwart += ","+wart
        
        if len(dane) > 0:
            stat = dane[0]
            
        if stat == 'OK':
            sqlins = "INSERT INTO rs_grupy_analityczne ("+sqlpola+") VALUES ("+sqlwart+");"
            
            stat,d,dump,dump = self.PolSQL.Execute(sqlins, 1)
            if stat <> 'OK':
                stat = 'Bd dodawania nowej grupy analitycznej : '+stat

#-------------------------------------------------------------------------------
# UPDATE  3-z pobraniem   4-bez pobrania
#-------------------------------------------------------------------------------

if Fun in (3,4) and stat == 'OK':
    if stat == 'OK':             
        sqlupd = ''
    
        for i in xrange(len(pola)):
            pole = pola[i]
            wart = wartosci[i]
            
            if pole == 'nazwa':
                if wart == '':
                    dane.append('BR NAZWA')
                else:
                    sqlupd += pole+" = '"+wart+"',"
            
        if len(dane) > 0:
            stat = dane[0]
            
        if stat == 'OK' and len(sqlupd) > 0:
            sqlupd = sqlupd[:-1]
            SQLUPD ="UPDATE rs_grupy_analityczne SET "+sqlupd
            SQLUPD+=" WHERE firma_id = '"+self.firma_id+"' AND okres_id = '"+self.okres_id+"' AND grupa_id = '"+Grupa+"';"
            
            stat,d,dump,dump = self.PolSQL.Execute(SQLUPD, 1)
            if stat <> 'OK':
                stat = 'Bd aktualizacji danych grupy analitycznej : '+stat

#-------------------------------------------------------------------------------
# SELECT 
#-------------------------------------------------------------------------------

if Fun in (1,3,5) and stat == 'OK':
    sql ="SELECT * FROM rs_grupy_analityczne"
    sql+=" WHERE firma_id = '"+self.firma_id+"' AND okres_id = '"+self.okres_id+"' AND grupa_id = '"+Grupa+"';"
    stat,dane,wyn1,dump = self.PolSQL.Execute(sql, 3)
    if stat <> 'OK':
        stat = 'Bd pobrania danych grupy analitycznej : '+stat
