# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_grupy_operatora.py
# Purpose:     dodawanie i usuwanie grup dla operatora
# Author:      Pawe Wjcikowski
# Created:     2009/04/27
# RCS-ID:      $Id: fs_grupy_operatora.py$
# Copyright:   (c) 2009 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

# 2018-02-07 Rafa Woniak    (10536) refaktoryzacja rsoperatorzy i podokien
# 2021-02-07 Wojciech Skowron (12284) sprawdzenie uprawnie

#RW pobieranie danych z kluczy
stat = 'OK'
if not 'Funkcja' in klucze:
    stat = 'Brak podanej funkcji w kluczach'

if stat == 'OK':
    Fun = klucze['Funkcja']

    if stat == 'OK':
        if Fun in [1, 6]:
            Oddzial = klucze['Oddzial']
            Grupa = klucze['Grupa']
        if Fun in [1, 5, 6]:
            Operator = str(klucze['User'])
dane = []

#-------------------------------------------------------------------------------
#---   UPRAWNIENIA
#-------------------------------------------------------------------------------

#WS 2021-02-07
Upr = ((self.oddzial_id, '001330') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)

if stat == 'OK' and not Upr:
    stat = 'Brak uprawnie do grup i oddziaw operatora'

#-------------------------------------------------------------------------------
#---   INSERT DANYCH (1)
#-------------------------------------------------------------------------------

if stat == "OK" and Fun == 1:
    Select="SELECT oddzial_id FROM rs_grupa_operator_oddzial WHERE" 
    Select+=" firma_id='"+self.firma_id+"' AND operator_id = '"+str(Operator)+"' AND grupa_id='"+str(Grupa)+"' "
    Select+="AND oddzial_id='"+str(Oddzial)+"';"
    stat,dane,wyn1,tr = self.PolSQL.Execute(Select,3)
    if stat!="OK":
        stat = 'Bdy przy sprawdzaniu danych :'+stat
        dane.append(stat) 
    else:
        if len(dane)<>0:
            stat = 'Symbol grupy ju istnieje.'
            dane.append(stat)
    if stat=='OK':  
        query="INSERT INTO rs_grupa_operator_oddzial (firma_id,operator_id,grupa_id,oddzial_id)"
        query+=" VALUES ('"+self.firma_id+"','"+str(Operator)+"','"+str(Grupa)+"','"+str(Oddzial)+"');"
        stat,dump,dump,dump = self.PolSQL.Execute(query ,1)
        if stat!="OK":
            stat="BL INS"   
            dane.append(stat)


#-------------------------------------------------------------------------------
#---   DELETE DANYCH (6)
#-------------------------------------------------------------------------------

if stat == "OK" and Fun == 6:
    SQL="DELETE FROM rs_grupa_operator_oddzial WHERE operator_id='"+str(Operator)+"' AND grupa_id='"+str(Grupa)+"' AND"
    SQL+=" oddzial_id='"+str(Oddzial)+"' AND firma_id='"+self.firma_id+"'" 
    stat,dump,dump,dump = self.PolSQL.Execute(SQL,1) 
    if stat!="OK":
        stat="BL DEL"   
        dane.append(stat)


#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (1- insert 5 -select, 6 -delete)
#-------------------------------------------------------------------------------

if stat == 'OK' and Fun in [1,5,6]:
    Select="SELECT goo.oddzial_id,o.opis,goo.grupa_id,g.opis FROM rs_grupa_operator_oddzial goo INNER JOIN" 
    Select+=" rs_grupy g USING (grupa_id,firma_id) INNER JOIN rs_oddzialy o USING (oddzial_id,firma_id) WHERE" 
    Select+=" operator_id = '"+str(Operator)+"' AND goo.firma_id='"+self.firma_id+"' ORDER BY oddzial_id, grupa_id;"
    stat,dane,wyn1,tr = self.PolSQL.Execute(Select,3)
    if stat!="OK":
        stat="BL PRZ"   
        dane.append(stat)