# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_hd_paragony_import.py
# Purpose:     Import paragonw z PC Market
# Author:      Wojciech Skowron
# Created:     2020/02/13
# RCS-ID:      $Id: fs_hd_paragony_import.py $
# Copyright:   (c) 2020 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

from funkcje import fs_hd_paragony_import_pom

import rsmssql
import rsglobal

stat = "OK"

if not 'Funkcja' in klucze:
    stat = 'Brak podanej funkcji w kluczach'

if stat == "OK":
    Funkcja = klucze['Funkcja']

    SlPar = {}
    Lista = rsglobal.SprawdzParametryWKluczach(SlPar, Funkcja, klucze)
    if Lista != '':
        stat = 'Uwaga : wywoanie funkcji fs_hd_paragony_import z numerem '+str(Funkcja)+' bez parametrw: '+Lista

if stat == "OK":
    if Funkcja == 2:
        Data  = klucze['Data']
        Sklep = klucze['Sklep']

dane = []
wyn2 = []

# ----------------------------------------------------------------------------------------------------------------------
# Pobranie sklepw
# ----------------------------------------------------------------------------------------------------------------------

if stat == 'OK' and Funkcja == 1:
    SEL = """SELECT sklep_id, pcmarket FROM rs_hd_sklepy
             WHERE firma_id='{firma_id}' AND pcmarket != 0
             ORDER BY sklep_id ASC;"""
    SEL = SEL.format(firma_id=self.firma_id)
    stat, dane, dump, dump = self.PolSQL.Execute(SEL, 3, CzyDodawacBlad=True)
    if stat != 'OK':
        stat = 'Bd pobrania danych placwek handlowych: ' + stat

# ----------------------------------------------------------------------------------------------------------------------
# Import paragonw
# ----------------------------------------------------------------------------------------------------------------------

if stat == 'OK' and Funkcja == 2:
    self.RSPCMarketSQL = rsmssql.RSPCMarketSQL()
    stat = self.RSPCMarketSQL.Polacz()
    if stat == 'OK':
        stat = fs_hd_paragony_import_pom.ImportujParagony(self, Data, Sklep)
        self.RSPCMarketSQL.Rozlacz()
