# -*- coding: iso8859_2 -*-

# -----------------------------------------------------------------------------
# Name:        fs_hd_placowki_handlowe_wczytaj_opis.py
# Purpose:     wczytuje opis (nazwe) sklepu uwzgldniajc uprawnienia operatora
# Author:      Aleksander Bargie
# Created:     2023/11/07
# RCS-ID:      $Id: fs_hd_placowki_handlowe_wczytaj_opis.py $
# Copyright:   (c) 20023 Record System
# Licence:     GNU GPL
# -----------------------------------------------------------------------------

# klucze[0] - symbol sklepu
# wraca z opisem sklepu
kod = klucze[0]
dane=['']
if ((self.oddzial_id, '091300') in self.uprawnienia) or (('**', '091300') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
    sql = "SELECT nazwa FROM rs_hd_sklepy WHERE firma_id=%s AND sklep_id=%s;"
    args = [self.firma_id, kod]
    args = [str(x) if isinstance(x, unicode) else x for x in args]
    rsglobal.ZapiszDoLogow(self.PolSQL.Mogrify(sql, args))
    stat, wyn, dump, dump = self.PolSQL.Execute(sql, 3, args, CzyDodawacBlad=True)
    if stat == 'OK':
        if len(wyn) > 0:
            dane[0] = wyn[0][0]
else:    
    stat = 'Brak uprawnie do sklepw. Poinformuj administratora.'
    dane = [stat]


