# -*- coding: iso8859_2 -*-

# -----------------------------------------------------------------------------
# Name:        fs_hd_pos_kasy.py
# Purpose:     Przegladanie punktw POS - kas
# Author:      Wojciech Skowron
# Created:     2019/10/08
# RCS-ID:      $Id: fs_hd_pos_kasy.py $
# Copyright:   (c) 2019 RecordSystem
# Licence:     GNU GPL
# -----------------------------------------------------------------------------

import rsglobal

"""
091510 Przegldanie
091520 Modyfikacja
"""

stat = 'UPR PRZ'

# -------------------------------------------------------------------------------
# -----------------------   UPRAWNIENIA   ---------------------------------------
# -------------------------------------------------------------------------------

UprMod = ((self.oddzial_id, '091520') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)
UprPrz = ((self.oddzial_id, '091510') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID) or UprMod

if UprPrz > 0:
    stat = 'OK'

if stat == 'OK' and not 'Funkcja' in klucze:
    stat = 'Brak podanej funkcji w kluczach'

if stat == 'OK':
    Funkcja = klucze['Funkcja']

# -------------------------------------------------------------------------------
# ---------------------------   INSERT(1)   -------------------------------------
# -------------------------------------------------------------------------------

# if stat == "OK" and Funkcja == 1:
#     INS = """INSERT INTO rs_hd_kasy (firma_id, nazwa, nazwa_skrocona, data_wprowadzenia, operator)
#              VALUES ('{}', '', '', now(), rsf_getuserid());
#           """.format(self.firma_id)
#
#     stat, dump, dump, dump = self.PolSQL.Execute(INS, 1, CzyDodawacBlad=True)
#     rsglobal.ZapiszDoLogow(INS)
#     if stat != 'OK':
#         stat = 'Bd dodawania kasy: ' + stat

# -------------------------------------------------------------------------------
# ----------------------   POBRANIE DANYCH(1, 5)   ------------------------------
# -------------------------------------------------------------------------------

if stat == 'OK' and Funkcja in (1, 5):
    SEL = """SELECT kasa_id, nazwa, nazwa_skrocona, data_od, data_do, '' as stoisko_id
             FROM rs_hd_kasy WHERE firma_id='{}' ORDER BY kasa_id;""".format(self.firma_id)

    stat, dane, wyn1, wyn2 = self.PolSQL.Execute(SEL, 3, CzyDodawacBlad=True)
    rsglobal.ZapiszDoLogow(SEL)
    if stat != 'OK':
        rsglobal.ZapiszDoLogow(stat, 1)
        stat = 'Bd pobierania danych: ' + stat
