# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_jpk_parametry_stale.py
# Purpose:     obsluga grida edytowalnego dla parametrw staych JPK
# Author:      Marcin Natkaski
# Created:     2016/12/10
# RCS-ID:      $Id: fs_jpk_parametry_stale $
# Copyright:   (c) 2016 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

stat='OK'

if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=='OK':
    Funkcja = klucze['Funkcja']
    
    SlPar={}
    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Funkcja,klucze)
    if Lista<>'':
        stat='Uwaga : wywoanie funkcji fs_jpk_parametry_stale z numerem '+str(Funkcja)+' bez parametrw: '+Lista

dane = []
wyn1 = []
wyn2 = []


#-------------------------------------------------------------------------------
#-------- EDYCJA GRIDA EDYTOWALNEGO (1)
#-------------------------------------------------------------------------------

Insert = []
Update = []
Delete = []

if stat=='OK' and Funkcja == 1:
    Update=klucze['Update']
    Insert=klucze['Insert']
    Delete=klucze['Delete']

#-------------------------------------------------------------------------------
#-------  SPRAWDZANIE DELETE  --------------------------------------------------
#-------------------------------------------------------------------------------

if Funkcja == 1 and stat=="OK":
    if len(Delete[0])>0:
        # wykonanie DELETE 
        if stat == 'OK':
            SQLDEL = ''
            SQLFU = ''
            for i in xrange(len(Delete[0])):
                DELETE = "DELETE FROM rs_jpk_parametry "
                WHERE = "WHERE firma_id='"+self.firma_id+"'"
                for j in xrange(len(Delete[0][i])):
                    pole = Delete[1][j]
                    wart = Delete[0][i][j]
                    WHERE += " AND "+pole+"='"+str(wart)+"'"
                SQLDEL += DELETE+WHERE+"; "

            if stat == "OK" and SQLDEL <> '':
                stat,dump,dump,dump = self.PolSQL.Execute(rsglobal.Dekoduj(SQLDEL),1)
                if stat <> 'OK':
                    stat = "Bd przy usuwaniu danych: "+stat   
                    dane.append(stat)


#-------------------------------------------------------------------------------
#---   UPDATE DANYCH (1)
#-------------------------------------------------------------------------------

if Funkcja == 1 and stat=="OK":
    if len(Update[0])>0:
        SQLFU = ''
        for i in xrange(len(Update[0])):
            for j in xrange(len(Update[2][i])): # petla po kluczu
                pole = Update[3][j]
                wart = rsglobal.Dekoduj(Update[2][i][j])

        if stat == 'OK':
            WierszeNr = Update[-1]

            for i in xrange(len(Update[0])):
                WartoscNowa = None

                for j in xrange(len(Update[0][i])):
                    pole = Update[0][i][j]
                    wart = Update[1][i][j]

                    if 'UPDATE' in wart.upper():
                        stat = 'W zapytaniu nie mona uywa sowa kluczowego UPDATE'
                        wyn2.append((WierszeNr[i],2))
                        dane.append(stat)
                    elif 'DELETE' in wart.upper():
                        stat = 'W zapytaniu nie mona uywa sowa kluczowego DELETE'
                        wyn2.append((WierszeNr[i],2))
                        dane.append(stat)
                    elif 'INSERT' in wart.upper():
                        stat = 'W zapytaniu nie mona uywa sowa kluczowego INSERT'
                        wyn2.append((WierszeNr[i],2))
                        dane.append(stat)
                    elif 'DROP' in wart.upper():
                        stat = 'W zapytaniu nie mona uywa sowa kluczowego DROP'
                        wyn2.append((WierszeNr[i],2))
                        dane.append(stat)
                    elif 'ALTER' in wart.upper():
                        stat = 'W zapytaniu nie mona uywa sowa kluczowego ALTER'
                        wyn2.append((WierszeNr[i],2))
                        dane.append(stat)
                    elif 'TRUNCATE' in wart.upper():
                        stat = 'W zapytaniu nie mona uywa sowa kluczowego TRUNCATE'
                        wyn2.append((WierszeNr[i],2))
                        dane.append(stat)



        if stat == 'OK':
            WierszeNr = Update[-1]

            for i in xrange(len(Update[0])):
                WartoscNowa = None

                for j in xrange(len(Update[0][i])): 
                    pole = Update[0][i][j]
                    wart = Update[1][i][j]
                    if pole == 'jpk_id':
                        if wart.strip() == '':
                            stat = 'NAZWA BR'
                            wyn2.append((WierszeNr[i], 1))
                            dane.append(stat)
                        else:
                            SQL = "SELECT kod FROM rs_jpk_typy WHERE kod='" + wart + "'"
                            stat, dane, dump, dump = self.PolSQL.Execute(SQL, 3)
                            if stat <> 'OK':
                                stat = "Bd przy pobieraniu typu JPK: " + stat
                            elif not dane:
                                stat = 'Bdny typ JPK'
                                wyn2.append((WierszeNr[i], 1))
                                dane.append(stat)

        if stat <> 'OK':
            if len(dane) > 0:
                stat = dane[0]
                
        # wykonanie UPDATE
        if stat=='OK':
            sql=''
            for i in xrange(len(Update[0])):
                UPDATE="UPDATE rs_jpk_parametry "
                SET='SET '
                for j in xrange(len(Update[0][i])): 
                    pole=Update[0][i][j]
                    wart=Update[1][i][j]
                    SET+=pole+"='"+str(wart.replace("'","\\'"))+"',"

                SET=SET.strip(",")
                WHERE=" WHERE firma_id='"+self.firma_id+"'"
                for j in xrange(len(Update[2][i])): # petla po kluczu
                    pole=Update[3][j]
                    wart=rsglobal.Dekoduj(Update[2][i][j])
                    WHERE+= " AND "+pole+"='"+str(wart)+"'"

                WHERE+=";"
                
                sql+=UPDATE+SET+WHERE;
                
            if sql<>'':
                stat,dump,dump,dump=self.PolSQL.Execute(rsglobal.Dekoduj(sql),1)
                if stat<>'OK':
                    stat="Bd przy modyfikowaniu danych: "+stat   
                    dane.append(stat)

#-------------------------------------------------------------------------------
#---------Sprawdzanie danych do Insert------
#-------------------------------------------------------------------------------

if Funkcja == 1 and stat=="OK":
    if len(Insert[0])>0:
        WierszeNr = Insert[-1]

        for i in xrange(len(Insert[0])):
            WartoscNowa = None

            for j in xrange(len(Insert[0][i])):
                pole = Insert[1][j]
                wart = Insert[0][i][j]

                if 'UPDATE' in wart.upper():
                    stat = 'W zapytaniu nie mona uywa sowa kluczowego UPDATE'
                    wyn2.append((WierszeNr[i], 2))
                    dane.append(stat)
                elif 'DELETE' in wart.upper():
                    stat = 'W zapytaniu nie mona uywa sowa kluczowego DELETE'
                    wyn2.append((WierszeNr[i], 2))
                    dane.append(stat)
                elif 'INSERT' in wart.upper():
                    stat = 'W zapytaniu nie mona uywa sowa kluczowego INSERT'
                    wyn2.append((WierszeNr[i], 2))
                    dane.append(stat)
                elif 'DROP' in wart.upper():
                    stat = 'W zapytaniu nie mona uywa sowa kluczowego DROP'
                    wyn2.append((WierszeNr[i], 2))
                    dane.append(stat)
                elif 'ALTER' in wart.upper():
                    stat = 'W zapytaniu nie mona uywa sowa kluczowego ALTER'
                    wyn2.append((WierszeNr[i], 2))
                    dane.append(stat)
                elif 'TRUNCATE' in wart.upper():
                    stat = 'W zapytaniu nie mona uywa sowa kluczowego TRUNCATE'
                    wyn2.append((WierszeNr[i], 2))
                    dane.append(stat)


            if stat=='OK':
                for j in xrange(len(Insert[0][i])):
                    pole=Insert[1][j]
                    wart=Insert[0][i][j]
                    if pole == 'jpk_id':
                        if wart.strip() == '':
                            stat = 'NAZWA BR'
                            wyn2.append((WierszeNr[i],1))
                            dane.append(stat)
                        else:
                            SQL="SELECT kod FROM rs_jpk_typy WHERE kod='"+wart+"'"
                            stat, dane, dump, dump = self.PolSQL.Execute(SQL, 3)
                            if stat <> 'OK':
                                stat = "Bd przy pobieraniu typu JPK: " + stat
                            elif not dane:
                                stat = 'Bdny typ JPK'
                                wyn2.append((WierszeNr[i], 1))
                                dane.append(stat)

        if stat <> 'OK':
            if len(dane) > 0:
                stat = dane[0]

        # wykonanie INSERT
        if stat == 'OK':
            sqlIns=''
            for i in xrange(len(Insert[0])):
                INSERT="INSERT INTO rs_jpk_parametry "
                KOLUMNY="(firma_id"
                VALUES=" VALUES ('"+self.firma_id+"'"
                for j in xrange(len(Insert[0][i])):
                    pole=Insert[1][j]
                    wart=Insert[0][i][j]
                    KOLUMNY+=","+pole
                    VALUES+=",'"+wart.replace("'","\\'")+"'"

                KOLUMNY+=")"
                VALUES+=");"
                sqlIns+=INSERT+KOLUMNY+VALUES
            if sqlIns<>'':
                stat,dump,dump,dump=self.PolSQL.Execute(rsglobal.Dekoduj(sqlIns),1)
                if stat<>'OK':
                    stat="Bd przy dodawaniu danych: "+stat
                    dane.append(stat)


#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (1- insert 1 -select, 1 -delete, 5 -select) 
#-------------------------------------------------------------------------------

if Funkcja in (1,5) and stat=='OK':
    SQL ="SELECT jpk_id, data_od, war_1, war_2, war_3, war_4, war_5, war_6, war_7, war_8, war_9, war_10"
    SQL+=" FROM rs_jpk_parametry"
    SQL+=" WHERE firma_id='"+self.firma_id+"'"
    SQL+=" ORDER BY jpk_id, data_od;"
    stat,dane,wyn1,wyn2 = self.PolSQL.Execute(SQL,3)
    if stat <> 'OK':
        stat = "Bd przy pobieraniu danych: "+stat