# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_kartoteka_napraw_dane.py
# Purpose:     wczytuje/edytuje dane naprawy
# Author:      Marcin Wodarczyk - kilka poprawek Pawe Wjcikowski
# Created:     2008/09/08
# RCS-ID:      $Id: fs_kartoteka_napraw_dane.py $
# Copyright:   (c) 2008 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

stat='OK'
NaprawaId = klucze[0]
Kontrahent = klucze[1]
WykonawcaOsoba = klucze[2]
Data=klucze[3]

UprEdytowanie = ((self.oddzial_id,'029412') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID


#-------------------------------------------------------------------------------
#---   UPDATE DANYCH (4- bez pobierania,3- z pobieraniem)
#-------------------------------------------------------------------------------

if klucze[-1] == 4 or klucze[-1]==3:
    if not UprEdytowanie:
        stat='UPR UPD'
        dane.append(stat)
    if stat=='OK':    
        stat = "OK"
        dane = []
        
        if Data=='    -  -  ':
            stat = "PUSTA DATA"
            dane.append(stat)            
        
        if (not 'osoba_id' in pola) and ('kontrahent_id' in pola):
            pola.append('osoba_id')
            wartosci.append(str(WykonawcaOsoba))  

        #---   Sprawdzenie danych
        for i in range(len(pola)):
            pole = pola[i]
            wart = wartosci[i]
            
            if pole=='rodzaj_naprawy' and stat == "OK":
                if wart == '':
                    wartosci[i]='NULL'
                else:
                    Select="SELECT kod FROM rs_rodzaje_napraw WHERE firma_id='"+self.firma_id+"' AND kod='"+wart+"';"
                    dump,d,dump,dump = self.PolSQL.Execute(Select,3)
                    if len(d) == 0:
                        stat = "BL RODZAJ"
                        dane.append(stat)
                    else:
                        wartosci[i]="'"+wartosci[i]+"'"
                        
            if pole=='wykonawca_id' and stat == "OK":
                if wart == '':
                    wartosci[i]='NULL'
                else:
                    Select="SELECT kontrahent_id FROM rs_kontrahenci WHERE firma_id='"+self.firma_id+"' "
                    Select+="AND kontrahent_id='"+wart+"';"
                    dump,d,dump,dump = self.PolSQL.Execute(Select,3)
                    if len(d) == 0:
                        stat = "BL WYKONAWCA"
                        dane.append(stat)
                    else:
                        wartosci[i]="'"+wartosci[i]+"'"
                    
            if pole=='wykonawca_id_osoba' and stat == "OK":
                if wart != '' and Kontrahent=='':
                    stat = "PUS WYKONAWCA"
                
                if wart == '':
                    wartosci[i]='NULL'
                
                if wart != '' and Kontrahent<>'':
                    Select="SELECT osoba_id FROM rs_kontrahenci_osoby WHERE firma_id='"+self.firma_id+"' "
                    Select+="AND osoba_id='"+wart+"' AND kontrahent_id='"+str(Kontrahent)+"';"
                    dump,d,dump,dump = self.PolSQL.Execute(Select,3)
                    if len(d) == 0:
                        stat = "BL OSOBA"
                        dane.append(stat)
                    else:
                        wartosci[i]="'"+wartosci[i]+"'"
                        

        for i in range(len(pola)):
            if pola[i] == 'data_naprawy':                    
                if (not rsglobal.SprawdzCzyToData(wartosci[i])) and wartosci[i] != '    -  -  ':
                    stat='BL DATA'
                    dane.append(stat)

        #--- zapis
        if stat == 'OK':
            where = " WHERE firma_id='"+self.firma_id+"' AND naprawa_id="+NaprawaId+";"
            upd = "UPDATE rs_serwis_naprawy SET "
                
            for i in range(len(pola)):
                pole = pola[i]
                wart = wartosci[i]
                
                if pole in ['rodzaj_naprawy','wykonawca_id', 'wykonawca_id_osoba']:
                    upd=upd+pole+"="+str(wart)+","
                elif pole in ['uwagi','data_naprawy','odpis_data']:
                    if wart=='    -  -  ' or wart=='':
                        upd=upd+pole+"=NULL,"
                    else:
                        upd=upd+pole+"='"+str(wart)+"',"

            upd = upd[0:len(upd)-1]+where
            
            stat,dump,dump,dump = self.PolSQL.Execute(upd ,1)


#-------------------------------------------------------------------------------
#---   USUWANIE KONT Z ZEROWYMI POZYCJAMI (9 - delete)
#-------------------------------------------------------------------------------

if klucze[-1] in [9] and stat=='OK':
    if stat=='OK':
        sql="DELETE FROM rs_serwis_naprawy WHERE firma_id='"+self.firma_id+"' "
        sql+=" AND naprawa_id='"+str(NaprawaId)+"';"
        stat,dump,dump,dump = self.PolSQL.Execute(sql, 1)
  
  
#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (5 -select, 3 -update z pobraniem, 1 -insert z pobraniem)
#-------------------------------------------------------------------------------

if (klucze[-1] in [5,3,1]) and (stat=='OK'):
    
    # pobranie danych sprawy
    Select="SELECT * FROM rs_serwis_naprawy WHERE firma_id='"+self.firma_id+"' AND naprawa_id="+NaprawaId+""
    Select+=" ORDER BY naprawa_id;"
    stat,dane,wyn1,tr = self.PolSQL.Execute(Select,3)
    
    # pobranie opisu 
    if len(dane) == 1:
        tr = rssql.RSTableRowset(dane,wyn1)

        #--- dzia
        if ((self.oddzial_id,'011490') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
            Select="SELECT opis FROM rs_rodzaje_napraw WHERE firma_id='"+self.firma_id+"' "
            Select+="AND kod='"+tr.GetVal(0,"rodzaj_naprawy")+"';"
            dump,d,dump,dump = self.PolSQL.Execute(Select ,3)
            if len(d) == 0:
                wyn2.append('')
            else:
                wyn2.append(d[0][0])
        else:
            wyn2.append('Brak uprawnie do sownika. Poinformuj administratora.')
        
        if ((self.oddzial_id,'011011') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
            Select="SELECT nazwa FROM rs_kontrahenci WHERE firma_id='"+self.firma_id+"' AND "
            Select+="kontrahent_id='"+tr.GetVal(0,"wykonawca_id")+"';"
            dump,d,dump,dump = self.PolSQL.Execute(Select ,3)
            if len(d) == 0:
                wyn2.append('')
            else:
                wyn2.append(d[0][0])
        else:
            wyn2.append('Brak uprawnie do sownika. Poinformuj administratora.')
            
        #--- osoba odpowiedzialna
        if ((self.oddzial_id,'012031') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
            Select="SELECT imie,nazwisko FROM rs_kontrahenci_osoby WHERE firma_id='"+self.firma_id+"' "
            Select+="AND osoba_id='"+tr.GetVal(0,"wykonawca_id_osoba")+"';"
            dump,d,dump,dump = self.PolSQL.Execute(Select ,3)
            if len(d)<>0:
                c=str(d[0][0]+' '+d[0][1])
            else:
                c=''
            if len(c) <= 1:
                wyn2.append('')
            else:
                wyn2.append(c)
        else:
            wyn2.append('Brak uprawnie do sownika. Poinformuj administratora.')