# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_kasy_banki_plik_naglowek.py
# Purpose:     wczytuje/edytuje dane naglowka pliku kasy/banku
#
# Author:      Mariusz Rajfura
# Created:     2011/06/09
# RCS-ID:      $Id: fs_kasy_banki_plik_naglowek.py $
# Copyright:   (c) 2011 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

# 2011-12-07 Mariusz Rajfura  nowe pole 'plik_mt' (5263)

Id = rsglobal.Dekoduj(klucze[0])
Fun = klucze[-1]

stat = 'OK'
dane = []
wyn1 = []
wyn2 = []


#-------------------------------------------------------------------------------
#--- SPRAWDZENIE UPRAWNIEN
#-------------------------------------------------------------------------------

if Fun in (3,4):
    if not (((self.oddzial_id,'171017') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID):
        stat = 'BR UPR UPD'


#-------------------------------------------------------------------------------
#---   UPDATE DANYCH (4- bez pobierania,3- z pobieraniem)
#-------------------------------------------------------------------------------

if Fun in [3,4] and stat == 'OK':
    sql ="SELECT kasa_bank_id FROM rs_kasy_banki"
    sql+=" WHERE firma_id='"+self.firma_id+"' AND kasa_bank_id='"+Id+"'"
    sql+=" AND okres_id='"+self.okres_id+"' FOR UPDATE NOWAIT;"

    stat,d,dump,dump = self.PolSQL.Execute(sql,3)
    if stat <> 'OK':
        stat = 'Bd pobrania danych kasy-banku: '+stat
        dane.append(stat)
    elif len(d) == 0:
        stat = 'Brak Kasy/Banku o podanym kodzie.'
        dane.append(stat)

    # modyfikacja
    if stat == 'OK':
        UPD = "UPDATE rs_kasy_banki SET "
        for i in range(len(pola)):
            pole = pola[i]
            wart = wartosci[i]

            if pole in ('rozszerzenie','sygnatura_tekst','separator','separator_tekstu',
                        'kropka_dziesietna','separator_tysiecy','strona_kodowa'):
                wart = wart.strip()
                if wart == '':
                    UPD += pole+"=NULL,"
                else:
                    UPD += pole+"='"+wart+"',"

            elif pole in ('sygnatura_wiersz','data_wiersz','data_kolumna','szerokosc_stala',
                          'plik_mt'):
                UPD += pole+"="+str(wart)+","
                
        UPD = UPD[:-1]                
        UPD += " WHERE firma_id='"+self.firma_id+"'"
        UPD += " AND kasa_bank_id='"+Id+"' AND okres_id='"+self.okres_id+"';"
        
        stat,dump,dump,dump = self.PolSQL.Execute(UPD ,1)
   

#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (5 -select, 3 -update z pobraniem, 1 -insert z pobraniem)
#-------------------------------------------------------------------------------

if Fun in [5,3,1] and stat=='OK':
    sql ="SELECT * FROM rs_kasy_banki"
    sql+=" WHERE firma_id='"+self.firma_id+"'"
    sql+=" AND kasa_bank_id='"+Id+"' AND okres_id='"+self.okres_id+"' ORDER BY kasa_bank_id;"
    
    stat,dane,wyn1,dump = self.PolSQL.Execute(sql,3)