#!/usr/bin/python
# -*- coding: iso8859_2 -*-
#-----------------------------------------------------------------------------
# Name:			fs_kierowcy_wersje.py
# Purpose:		zmiana wersji cenowych dla kierowcw
# Author:		Micha Raburski
# Created:		2009/02/23
# RCS-ID:		$Id: fs_kierowcy_wersje.py $
# Copyright:	(c) 2004-2009 RecordSystem
# Licence:		GNU GPL
#-----------------------------------------------------------------------------
# 2016-12-14 Piotr Witkowski (10164) Trasy - stawki - 9 zapisuje wersje stawki, 10 pobiera wersje stawki
# 2018-02-19 Aleksander Bargie 10939 - Poprawka pobieranego przewonika podczas wyliczania rentownoci
# 2018-02-27 (0010944) Rafa Woniak - dwie nowe kolumny
# 2019-02-05 Aleksander Bargie (11393) Zmiana w obliczaniu rentownoci tras.
# 2019-08-20 Aleksander Bargie (11595) Bd insertu danych do rs_dowody_dostaw_rentownosc_kontrahenci
# 2020-09-23 Wojciech Skowron   (12126) Kolumna dodatek
# 2020-09-24 Aleksander Bargie (12131) [SP] dodatek w sprzeda->crm->rentowno
# 2022-11-29 Aleksander Bargie (13252) Wystawianie faktur dla transportu - okno zlece transportowych(zmiana numerow uprawnien)


import rs_anakonda_daty
stat='OK'
wyn2=[]
dane=[]
rentownosc_kontrahentow = False

if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=='OK':
    Funkcja = klucze['Funkcja']
    print(Funkcja)
    SlPar={'DataFiltru':[10],'Kod':[11],'DataRaportu':[12], 'Zwrocone':[12]}

    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Funkcja,klucze)
    if Lista<>'':
        stat='Uwaga : wywoanie funkcji fs_kp_dane_osobowe_absencje z numerem '+str(Funkcja)+' bez parametrw: '+Lista

if Funkcja == 10:
    DataFiltru = klucze['DataFiltru']
if Funkcja == 11:
    Kod = klucze['Kod']
if Funkcja == 12:
    DataRaportu = klucze['DataRaportu']
    Zwrocone    = klucze['Zwrocone']
#    if klucze['rentownosc_kontrahentow']:
#        rentownosc_kontrahentow = klucze['rentownosc_kontrahentow']




UprEdycja=(((self.oddzial_id,'103002') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID))
UprUsuwanie=(((self.oddzial_id,'103004') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID))
UprDodawanie=(((self.oddzial_id,'103003') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID))

if stat=='OK' and Funkcja in [1,9]:
    Update=klucze['Update']
    Insert=klucze['Insert']
    Delete=klucze['Delete']

#-------------------------------------------------------------------------------
#-------  SPRAWDZANIE DELETE
#-------------------------------------------------------------------------------

if Funkcja == 1 and stat=="OK":
    if len(Delete[0])>0:
        if not UprUsuwanie:
            stat='UPR DEL'
            dane.append(stat)
   
#------------------------------------------------------------------------------------------------------------        
#-------------------------- DELETE    
#------------------------------------------------------------------------------------------------------------        
        
        if stat=='OK':
            sql=''
            for i in xrange(len(Delete[0])):
                DELETE="DELETE FROM rs_kierowcy_wersje "
                WHERE="WHERE firma_id='"+self.firma_id+"'"
                for j in xrange(len(Delete[0][i])):
                    pole=Delete[1][j]
                    wart=Delete[0][i][j]
                    if pole =='oddzial_id':
                        WHERE+=" AND "+pole+"='"+wart+"'"
                    if pole in ['wlasny','specjalny']:
                        if wart:
                            WHERE+=" AND "+pole+"=TRUE"
                        else:
                            WHERE+=" AND "+pole+"=FALSE"
                        
                sql+=DELETE+WHERE+";"
            if sql<>'': 
                stat,dump,dump,dump=self.PolSQL.Execute(rsglobal.Dekoduj(sql),1)
                if stat<>'OK':
                    stat='BL DEL'
                    dane.append(stat)
                                 
#-------------------------------------------------------------------------------
#---   UPDATE DANYCH (1)
#-------------------------------------------------------------------------------

if Funkcja == 1 and stat=="OK":
    if not UprEdycja:
        stat='UPR UPD'   
    if stat=='OK':
        stat,D,dump,dump = self.PolSQL.Execute("SELECT kod FROM rs_wersje_cenowe WHERE firma_id='"+self.firma_id+"';",3)
        DaneWer=[]
        for poz in D:
            DaneWer.append(str(poz[0]))            

        WierszeNr = Update[-1]
        for i in xrange(len(Update[0])):
            for j in xrange(len(Update[0][i])): 
                #if stat == "OK":
                pole=Update[0][i][j]
                wart=rsglobal.Dekoduj(Update[1][i][j])
                if pole == 'oddzial_id':
                    stat,D,dump,dump = self.PolSQL.Execute("SELECT oddzial_id FROM rs_oddzialy WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+wart+"';",3)
                    if len(D)==0:
                        stat = 'Niepoprawny oddzia'
                        wyn2.append((WierszeNr[i],0))
                        dane.append(stat)
                #elif pole in ['wlasny','specjalny']:
                elif pole =='wc_normal':
                    if wart<>'':
                        if str(wart) not in DaneWer:
                            stat = 'Niepoprawna wersja normalna'
                            wyn2.append((WierszeNr[i],3))
                            dane.append(stat)
                elif pole =='wc_swiat':
                    if wart<>'':
                        if str(wart) not in DaneWer:
                            stat = 'Niepoprawna wersja witeczna'
                            wyn2.append((WierszeNr[i],4))
                            dane.append(stat)
                elif pole =='wc_przerz':
                    if wart<>'':
                        if str(wart) not in DaneWer:
                            stat = 'Niepoprawna wersja przerzutowa'
                            wyn2.append((WierszeNr[i],5))
                            dane.append(stat)
                elif pole =='wc_noc':
                    if wart<>'':
                        if str(wart) not in DaneWer:
                            stat = 'Niepoprawna wersja nocna'
                            wyn2.append((WierszeNr[i],6))
                            dane.append(stat)
                elif pole == 'magazyn_id':
                    if wart<>'':
                        stat,D,dump,dump = self.PolSQL.Execute("SELECT magazyn_id FROM rs_magazyny WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+wart+"';",3)
                        if len(D)==0:
                            stat = 'Niepoprawny magazyn'
                            wyn2.append((WierszeNr[i],7))
                            dane.append(stat)

    
    if stat=='OK':
        sql=''        
        for i in xrange(len(Update[0])):
            UPDATE="UPDATE rs_kierowcy_wersje "
            SET='SET '
            for j in xrange(len(Update[0][i])): 
                pole=Update[0][i][j]
                wart=Update[1][i][j]
                if pole=='platnicy':
                    SET+=pole+"='"+wart.replace("'","\\\'")+"',"
                elif pole =='oddzial_id': 
                    SET+=pole+"='"+wart+"',"
                elif pole in ['wlasny','specjalny']:
                    if wart==1:
                        SET+=pole+"=TRUE,"
                    else:
                        SET+=pole+"=FALSE,"
                else:
                    if wart=='':
                        SET+=pole+"=NULL,"
                    else:
                        SET+=pole+"='"+wart+"',"
                    
            SET=SET.strip(",")
            WHERE=" WHERE firma_id='"+self.firma_id+"'" 
            for j in xrange(len(Update[2][i])): # petla po kluczu
                pole=Update[3][j]
                wart=rsglobal.Dekoduj(Update[2][i][j])
                if pole=='oddzial_id':
                    WHERE+=" AND "+pole+"='"+wart+"'"
                else:
                    if wart==1: 
                        WHERE+=" AND "+pole+"=TRUE"
                    else:
                        WHERE+=" AND "+pole+"=FALSE"
            WHERE+=";"    
            sql+=UPDATE+SET+WHERE;
        if sql<>'': 
            stat,dump,dump,dump=self.PolSQL.Execute(rsglobal.Dekoduj(sql),1)    
                    
#----------------------------------------------------------------------------------------------------------------------
#---------Sprawdzanie danych do Insert------
#----------------------------------------------------------------------------------------------------------------------
                        
if Funkcja == 1 and stat=="OK":
    if not UprDodawanie:
        stat='UPR INS'   
    if stat=='OK':
        stat,D,dump,dump = self.PolSQL.Execute("SELECT kod FROM rs_wersje_cenowe WHERE firma_id='"+self.firma_id+"';",3)
        DaneWer=[]
        for poz in D:
            DaneWer.append(str(poz[0]))            

        WierszeNr = Insert[-1]
        
        for i in xrange(len(Insert[0])):
            for j in xrange(len(Insert[0][i])): 
                pole=Insert[1][j]
                wart=rsglobal.Dekoduj(Insert[0][i][j])
                if pole == 'oddzial_id':
                    stat,D,dump,dump = self.PolSQL.Execute("SELECT oddzial_id FROM rs_oddzialy WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+wart+"';",3)
                    if len(D)==0:
                        stat = 'Niepoprawny oddzia'
                        wyn2.append((WierszeNr[i],0))
                        dane.append(stat)
                #elif pole in ['wlasny','specjalny']:
                elif pole =='wc_normal':
                    if wart<>'':
                        if str(wart) not in DaneWer:
                            stat = 'Niepoprawna wersja normalna'
                            wyn2.append((WierszeNr[i],3))
                            dane.append(stat)
                elif pole =='wc_swiat':
                    if wart<>'':
                        if str(wart) not in DaneWer:
                            stat = 'Niepoprawna wersja witeczna'
                            wyn2.append((WierszeNr[i],4))
                            dane.append(stat)
                elif pole =='wc_przerz':
                    if wart<>'':
                        if str(wart) not in DaneWer:
                            stat = 'Niepoprawna wersja przerzutowa'
                            wyn2.append((WierszeNr[i],5))
                            dane.append(stat)
                elif pole =='wc_noc':
                    if wart<>'':
                        if str(wart) not in DaneWer:
                            stat = 'Niepoprawna wersja nocna'
                            wyn2.append((WierszeNr[i],6))
                            dane.append(stat)
                elif pole == 'magazyn_id':
                    if wart<>'':
                        stat,D,dump,dump = self.PolSQL.Execute("SELECT magazyn_id FROM rs_magazyny WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+wart+"';",3)
                        if len(D)==0:
                            stat = 'Niepoprawny magazyn'
                            wyn2.append((WierszeNr[i],7))
                            dane.append(stat)
                      
 #------------------------------------------------------------------------------------------------------------   
 #---------------   INSERT
 #-------------------------------------------------------------------------------------------------------------       

    #stat='BLAD'
    if stat=='OK':  
        sqlIns=''
        for i in xrange(len(Insert[0])):
            INSERT="INSERT INTO rs_kierowcy_wersje "
            KOLUMNY="(firma_id"
            VALUES=" VALUES ('"+self.firma_id+"'"
            for j in xrange(len(Insert[0][i])):
                pole=Insert[1][j]
                wart=Insert[0][i][j]
                KOLUMNY+=","+pole
                if pole=='platnicy':
                    VALUES+=",'"+wart.replace("'","\\\'")+"'"  
                elif pole =='oddzial_id': 
                    VALUES+=",'"+wart+"'"  
                elif pole in ['wlasny','specjalny']:
                    if wart==1:
                        VALUES+=",TRUE"                 
                    else:
                        VALUES+=",FALSE"                 
                else:
                    if wart=='':
                        VALUES+=",NULL"                 
                    else:
                        VALUES+=",'"+wart+"'"                 
            KOLUMNY+=")"
            VALUES+=");"
            sqlIns+=INSERT+KOLUMNY+VALUES
            
        if sqlIns<>'': 
            stat,dump,dump,dump=self.PolSQL.Execute(rsglobal.Dekoduj(sqlIns),1)
            if stat<>'OK':
                stat='BL INS'
                dane.append(stat)


# -------------------------------------------------------------------------------
# ---   UPDATE DANYCH TYPW STAWEK (9)
# -------------------------------------------------------------------------------

if Funkcja == 9 and stat == "OK":
    if not UprEdycja:
        stat = 'UPR UPD'
    if stat == 'OK':
        WierszeNr = Update[-1]
        for i in xrange(len(Update[0])):
            for j in xrange(len(Update[0][i])):
                # if stat == "OK":
                pole = Update[0][i][j]
                wart = rsglobal.Dekoduj(Update[1][i][j])
                if pole == 'ryczalt':
                    if len(str(int(wart))) > 16:
                        stat = u'Przekroczona dugo wartoci ryczat'
                        wyn2.append((WierszeNr[i], 3))
                        dane.append(stat)
                elif pole == 'za_km':
                    if len(str(int(wart))) > 6:
                        stat = u'Przekroczona dugo wartoci za km'
                        wyn2.append((WierszeNr[i], 4))
                        dane.append(stat)
                elif pole == 'za_godz':
                    if len(str(int(wart))) > 6:
                        stat = u'Przekroczona dugo wartoci za godz'
                        wyn2.append((WierszeNr[i], 5))
                        dane.append(stat)
                elif pole == 'za_godz':
                    if len(str(int(wart))) > 5:
                        stat = u'Przekroczona dugo wartoci % obrotu'
                        wyn2.append((WierszeNr[i], 6))
                        dane.append(stat)
                #AB 17.01.19r
                elif pole == 'dystans_km':
                    if len(str(int(wart))) > 3:
                        stat = u'Przekroczona dugo wartoci km'
                        wyn2.append((WierszeNr[i], 6))
                        dane.append(stat)
                #WS 2020-09-23
                elif pole == 'dodatek':
                    if len(str(int(wart))) > 16:
                        stat = u'Przekroczona dugo wartoci dodatek'
                        wyn2.append((WierszeNr[i], 7))
                        dane.append(stat)

    if stat == 'OK':
        sql = ''
        for i in xrange(len(Update[0])):
            UPDATE = "UPDATE rs_trasy "
            SET = 'SET '
            for j in xrange(len(Update[0][i])):
                pole = Update[0][i][j]
                wart = Update[1][i][j]
                                                                        #AB 17.01.19r   #WS 2020-09-23
                if pole in ['ryczalt', 'za_km', 'za_godz', 'proc_obrotu', 'dystans_km', 'dodatek']:
                    if wart in [None, "NULL", '']:
                        SET += pole + "=NULL,"
                    else:
                        SET += pole + "='" + str(wart) + "',"

            SET = SET.strip(",")
            WHERE = " WHERE firma_id='" + self.firma_id + "'"
            for j in xrange(len(Update[2][i])):  # petla po kluczu
                pole = Update[3][j]
                wart = rsglobal.Dekoduj(Update[2][i][j])
                if pole in ['oddzial_id', 'kod']:
                    WHERE += " AND " + pole + "='" + wart + "'"
            WHERE += ";"
            sql += UPDATE + SET + WHERE +';'
        if sql != '':
            stat, dump, dump, dump = self.PolSQL.Execute(rsglobal.Dekoduj(sql), 1)


#-------------------------------------------------------------------------------
# POBIERANIE DANYCH
#-------------------------------------------------------------------------------

if stat=='OK' and (Funkcja in [1,5,6]):
    SQL ="SELECT oddzial_id, wlasny,specjalny,COALESCE(wc_normal,''),COALESCE(wc_swiat,''),COALESCE(wc_przerz,''),"
    SQL+="COALESCE(wc_noc,''),COALESCE(magazyn_id,''),platnicy"
    SQL+=" FROM rs_kierowcy_wersje kw WHERE firma_id='"+self.firma_id+"'"
    SQL+=" ORDER BY oddzial_id,wlasny,specjalny;"	
    stat,dane,wyn1,wyn2=self.PolSQL.Execute(SQL,3)

if stat=='OK' and Funkcja == 10:
    SQL ="SELECT tr.oddzial_id, tr.kod, tr.opis,"
    SQL+="(SELECT tp.przewoznik_id FROM rs_trasy_przewoznicy tp "
    SQL+="WHERE tr.firma_id=tp.firma_id AND tr.kod=tp.kod AND tp.od_dnia<='"+DataFiltru+"' ORDER BY tp.od_dnia DESC LIMIT 1),"
    SQL+="(SELECT k.nazwa FROM rs_kontrahenci k "
    SQL+="INNER JOIN rs_trasy_przewoznicy tp ON (k.firma_id=tp.firma_id AND k.kontrahent_id=tp.przewoznik_id) "
    SQL+="WHERE tr.firma_id=tp.firma_id AND tr.kod=tp.kod AND tp.od_dnia<='"+DataFiltru+"' ORDER BY tp.od_dnia DESC LIMIT 1),"
    SQL+="(SELECT tt.ryczalt FROM rs_trasy_transport tt "
    SQL+="WHERE tr.firma_id=tt.firma_id AND tr.kod=tt.kod AND tt.od_dnia<='"+DataFiltru+"' ORDER BY tt.od_dnia DESC LIMIT 1),"
    SQL+="(SELECT tt.za_km FROM rs_trasy_transport tt "
    SQL+="WHERE tr.firma_id=tt.firma_id AND tr.kod=tt.kod AND tt.od_dnia<='"+DataFiltru+"' ORDER BY tt.od_dnia DESC LIMIT 1),"
    SQL+="(SELECT tt.za_godz FROM rs_trasy_transport tt "
    SQL+="WHERE tr.firma_id=tt.firma_id AND tr.kod=tt.kod AND tt.od_dnia<='"+DataFiltru+"' ORDER BY tt.od_dnia DESC LIMIT 1),"
    SQL+="(SELECT tt.proc_obrotu FROM rs_trasy_transport tt "
    SQL+="WHERE tr.firma_id=tt.firma_id AND tr.kod=tt.kod AND tt.od_dnia<='"+DataFiltru+"' ORDER BY tt.od_dnia DESC LIMIT 1),"
    SQL+="(SELECT tt.proc_got_w_terminie FROM rs_trasy_transport tt "
    SQL+="WHERE tr.firma_id=tt.firma_id AND tr.kod=tt.kod AND tt.od_dnia<='" + DataFiltru + "' ORDER BY tt.od_dnia DESC LIMIT 1),"
    SQL+="(SELECT tt.proc_got_po_terminie FROM rs_trasy_transport tt "
    SQL+="WHERE tr.firma_id=tt.firma_id AND tr.kod=tt.kod AND tt.od_dnia<='" + DataFiltru + "' ORDER BY tt.od_dnia DESC LIMIT 1),"
    SQL+="(SELECT tt.bez_wywozu FROM rs_trasy_transport tt "
    SQL+="WHERE tr.firma_id=tt.firma_id AND tr.kod=tt.kod AND tt.od_dnia<='"+DataFiltru+"' ORDER BY tt.od_dnia DESC LIMIT 1),"
    SQL+="(SELECT tt.opis FROM rs_trasy_transport tt "
        #AB 17.01.19r
    SQL+="WHERE tr.firma_id=tt.firma_id AND tr.kod=tt.kod AND tt.od_dnia<='"+DataFiltru+"' ORDER BY tt.od_dnia DESC LIMIT 1),"
    SQL+="(SELECT tt.dystans_km FROM rs_trasy_transport tt "
    SQL+="WHERE tr.firma_id=tt.firma_id AND tr.kod=tt.kod AND tt.od_dnia<='"+DataFiltru+"' ORDER BY tt.od_dnia DESC LIMIT 1),"
        #WS 2020-09-23
    SQL+="(SELECT tt.dodatek FROM rs_trasy_transport tt "
    SQL+="WHERE tr.firma_id=tt.firma_id AND tr.kod=tt.kod AND tt.od_dnia<='"+DataFiltru+"' ORDER BY tt.od_dnia DESC LIMIT 1) "
    SQL+="FROM rs_trasy tr WHERE firma_id='"+self.firma_id+"' ORDER BY tr.kod;"
    stat,dane,wyn1,wyn2=self.PolSQL.Execute(SQL,3)
    if stat<>'OK':
        stat = 'Bd pobrania wersji tras'


#--------------------------------------------------------------------------------
# Funkcja dla Ryczatu
#--------------------------------------------------------------------------------

if stat == 'OK' and Funkcja == 12:
    #AB 20.08.19r
    rzuty = "SELECT kod FROM rs_tryby_dostaw WHERE firma_id='{}' AND (rzut IS NULL OR rzut = '');".format(self.firma_id)
    stat, brakujaceRzuty, dump, dump = self.PolSQL.Execute(rzuty, 3)
    if stat != 'OK':
        stat = 'Bd sprawdzania czy dla wszystkich trybw wprowadzono rzut.'
    elif len(brakujaceRzuty)>0:
        stat = "W sowniku Tryby dostaw nie uzupeniono rzutu dla trybu/w: {}".format(', '.join([rzut[0] for rzut in brakujaceRzuty]))
    else:

        #AB 06.02.19r
        SQLDEL = "DELETE FROM rs_dowody_dostaw_rentownosc WHERE firma_id='"+self.firma_id+"' AND data='"+DataRaportu+"'; \n"
        SQLDEL += "DELETE FROM rs_dowody_dostaw_rentownosc_rzut WHERE firma_id='"+self.firma_id+"' AND data='"+DataRaportu+"';"
        stat, dane, dump, dump = self.PolSQL.Execute(SQLDEL, 1)
    #AB 06.02.19r w starej wersji poprawka na dzielenie przez 0
if stat == 'OK' and Funkcja == 12:
    #Zliczanie iloci przejazdw
    SQL = "SELECT dk.oddzial_id,dk.trasa,SUM(dk.kor) FROM (SELECT oddzial_id,trasa,"
    SQL+= "CASE WHEN NOT korekta THEN COUNT(DISTINCT tryb_dostawy) ELSE 0 END AS kor "
    SQL+= "FROM rs_dowody_dostaw dd WHERE firma_id='"+ self.firma_id +"' AND data = '"+DataRaportu+"' "
    if Zwrocone:
        SQL += " AND ((NOT (SELECT blokowac_edycje_dd from rs_oddzialy o WHERE o.firma_id=dd.firma_id AND o.oddzial_id=dd.oddzial_id)) OR dd.zwrocony ) "
    SQL+= "GROUP BY oddzial_id, trasa, korekta) dk GROUP BY dk.oddzial_id,dk.trasa;"
    rsglobal.ZapiszDoLogow('Zapytanie o trasy'+str(SQL),5)
    stat, daneIle, dump, dump = self.PolSQL.Execute(SQL, 3)
    if stat != 'OK':
        stat = 'Bd pobierania iloci tras'

    elif len(daneIle)>0:
        #Sprawdza czy dzien tygodnia jest witem lub niedziel
        CzySwieto = rs_anakonda_daty.CzySwieto(DataRaportu)
        if CzySwieto:
            Swieta=" wc_swiat "
        else:
            Swieta=" wc_normal "

        SQL ="SELECT moja.oddzial_id,moja.trasa,round(SUM(moja.cena_upust1*moja.ilosc_dost1),2),"
        SQL+="round(SUM(moja.cena_upust1*moja.ilosc_zwr1),2), "
        SQL+="round(SUM(rsf_podaj_cene_n1('"+self.firma_id+"', moja.artykul_id,"+Swieta+",'PLN','"+DataRaportu+"')*(moja.ilosc_dost1-(moja.ilosc_zwr1))),2) "
        SQL+="FROM rs_kierowcy_wersje kw "
        SQL+="INNER JOIN (SELECT ddp.firma_id,ddp.oddzial_id, ddp.trasa, artykul_id,ilosc_dost1,ilosc_zwr1,cena_upust1,platnik_id,wlasny "
        SQL+="FROM rs_dowody_dostaw_pozycje ddp "
        SQL+="INNER JOIN rs_dowody_dostaw dd ON (dd.firma_id=ddp.firma_id AND dd.oddzial_id=ddp.oddzial_id "
        if Zwrocone:
            SQL += " AND ((NOT (SELECT blokowac_edycje_dd from rs_oddzialy o WHERE o.firma_id=dd.firma_id AND o.oddzial_id=dd.oddzial_id)) OR dd.zwrocony ) "
        SQL+="AND dd.data=ddp.data AND  dd.trasa=ddp.trasa AND dd.tryb_dostawy=ddp.tryb_dostawy AND dd.numer=ddp.numer) "
        SQL+="INNER JOIN rs_kierowcy k ON (dd.firma_id=k.firma_id AND dd.kierowca=k.kod) "
        SQL+="WHERE ddp.firma_id='"+self.firma_id+"' and ddp.data='"+DataRaportu+"') moja ON (moja.firma_id = kw.firma_id AND moja.oddzial_id=kw.oddzial_id) "
        SQL+="WHERE kw.firma_id='"+self.firma_id+"' AND kw.oddzial_id=moja.oddzial_id "
        SQL+="AND kw.specjalny = (moja.platnik_id = ANY (STRING_TO_ARRAY(replace(kw.platnicy,'\\'',''),','))) AND kw.wlasny=moja.wlasny "
        SQL+="GROUP BY moja.oddzial_id,moja.trasa;"
        rsglobal.ZapiszDoLogow('Zapytanie o dane'+str(SQL),5)
        stat,daneW,dump,dump=self.PolSQL.Execute(SQL,3)
        if stat != 'OK':
            stat = 'Bd pobierania danych do wyliczenia rentownoci'

        elif len(daneW)>0 and stat == 'OK':
            for rent in xrange(len(daneW)):
                for ile in xrange(len(daneIle)):
                    if daneW[rent][:2] == daneIle[ile][:2] and stat == 'OK':
                        SqlTr ="SELECT tt.ryczalt, tt.za_km, tt.za_godz, tt.proc_obrotu, tt.bez_wywozu, tt.opis, p.przewoznik_id, tt.dystans_km, tt.dodatek "  #AB 24.09.20r
                        SqlTr+="FROM rs_trasy_transport tt "
                        SqlTr+="JOIN rs_trasy_przewoznicy p ON tt.firma_id=p.firma_id and tt.kod=p.kod and "
                        SqlTr+="p.od_dnia=(SELECT pp.od_dnia From rs_trasy_przewoznicy pp WHERE pp.kod=p.kod AND pp.od_dnia<='"+DataRaportu+"' ORDER BY pp.od_dnia DESC LIMIT 1) "
                        SqlTr+="WHERE tt.firma_id='"+self.firma_id+"' AND tt.kod='"+daneW[rent][1]+"' AND tt.od_dnia ="
                        SqlTr+="(SELECT max(pom.od_dnia) FROM rs_trasy_transport pom WHERE tt.kod=pom.kod AND pom.od_dnia<='"+DataRaportu+"');"
                        rsglobal.ZapiszDoLogow('Zapytanie o dane transportu'+str(SqlTr),5)
                        stat,daneTr,dump,dump=self.PolSQL.Execute(SqlTr,3)
                        if stat != 'OK':
                            stat = 'Bd pobierania danych z rs_trasy_transport'
                        elif stat == 'OK' and len(daneTr)>0:
                            #sprawdzenie czy s dane
                            SprIns ="SELECT * FROM rs_dowody_dostaw_rentownosc WHERE firma_id='"+self.firma_id+"' AND oddzial_id ='"+daneW[rent][0]+"' "
                            SprIns+="AND trasa='"+daneW[rent][1]+"' AND data='"+DataRaportu+"'; "
                            rsglobal.ZapiszDoLogow('Zapytanie33'+str(SprIns),5)
                            stat,daneSpr,dump,dump=self.PolSQL.Execute(SprIns,3)
                            if stat != 'OK':
                                stat = 'Bd pobierania danych z rs_dowody_dostaw_rentownosc'

                            #robienie updatu jeli s ju dane
                            elif len(daneSpr)>0 and stat == 'OK':
                                SqlUpd ="UPDATE rs_dowody_dostaw_rentownosc SET liczba="+str(daneIle[ile][2])+","
                                SqlUpd+="sprzedaz="+str(daneW[rent][2])+",zwroty="+str(daneW[rent][3])+""
                                if daneIle[ile][2]<>0:
                                    if daneTr[0][4]:
                                        SqlUpd+=",transport=0"
                                    else:
                                        SqlUpd+=",transport="+str(daneW[rent][4])
                                    SqlUpd+=",dod_km=round("+str(daneTr[0][1])+",2),dod_godz=round("+str(daneTr[0][2])+",2)"
                                    SqlUpd+=",ryczalt="+str(daneTr[0][0])+",opis='"+str(daneTr[0][5])+"'"
                                    SqlUpd+=",dod_proc=round("+str(daneTr[0][3])+"/100*("+str(daneW[rent][2])+"-("+str(daneW[rent][3])+")),2) "
                                    SqlUpd+=",przewoznik_id='"+str(daneTr[0][6])+"' ,dystans_km='"+str(daneTr[0][7])
                                    SqlUpd+="' ,dodatek='"+str(daneTr[0][8])+"' "  #AB 24.09.20r
                                else:
                                    if daneTr[0][4]:
                                        SqlUpd+=",transport=0"
                                    else:
                                        SqlUpd+=",transport="+str(daneW[rent][4])
                                    SqlUpd+=",dod_km=0,dod_godz=0,ryczalt=0,opis='"+str(daneTr[0][5])+"'"
                                    SqlUpd+=",dod_proc=round("+str(daneTr[0][3])+"/100*("+str(daneW[rent][2])+"-("+str(daneW[rent][3])+")),2) "
                                    SqlUpd+=",przewoznik_id='"+str(daneTr[0][6])+"' ,dystans_km='"+str(daneTr[0][7])
                                    SqlUpd+="' ,dodatek='"+str(daneTr[0][8])+"' "  #AB 24.09.20r
                                SqlUpd+="WHERE firma_id='"+self.firma_id+"' AND oddzial_id ='"+daneW[rent][0]+"' "
                                SqlUpd+="AND trasa='"+daneW[rent][1]+"' AND data='"+DataRaportu+"';"
                                rsglobal.ZapiszDoLogow('Polecenie Updatu'+str(SqlUpd), 5)
                                stat,dump,dump,dump=self.PolSQL.Execute(SqlUpd,1)
                                if stat != 'OK':
                                    stat = 'Bd updatu danych do rs_dowody_dostaw_rentownosc'

                            else:
                                SqlIns ="INSERT INTO rs_dowody_dostaw_rentownosc (firma_id,oddzial_id,trasa,data,liczba,sprzedaz,zwroty,"
                                SqlIns+="transport,dod_km,dod_godz,dod_proc,ryczalt,opis,przewoznik_id, dystans_km, dodatek) "  #AB 24.09.20r
                                SqlIns+="VALUES ('"+self.firma_id+"','"+daneW[rent][0]+"','"+daneW[rent][1]+"','"+DataRaportu+"',"+str(daneIle[ile][2])+","
                                SqlIns+=str(daneW[rent][2])+","+str(daneW[rent][3])
                                if daneIle[ile][2]<>0:
                                    if daneTr[0][4]:
                                        SqlIns+=",0"
                                    else:
                                        SqlIns+=","+str(daneW[rent][4])
                                    SqlIns+=",round("+str(daneTr[0][1])+",2),round("+str(daneTr[0][2])+",2)"
                                    SqlIns+=",round("+str(daneTr[0][3])+"/100*("+str(daneW[rent][2])+"-("+str(daneW[rent][3])+")),2),"
                                    SqlIns+=str(daneTr[0][0])+",'"+str(daneTr[0][5])+"','"+str(daneTr[0][6])+"',"
                                    SqlIns+=str(daneTr[0][7])+","+str(daneTr[0][8])+");"  #AB 24.09.20r
                                else:
                                    if daneTr[0][4]:
                                        SqlIns+=",0"
                                    else:
                                        SqlIns+=","+str(daneW[rent][4])
                                    SqlIns+=",0,0,round("+str(daneTr[0][3])+"/100*("+str(daneW[rent][2])+"-("+str(daneW[rent][3])+")),2),"
                                    SqlIns+="0,'"+str(daneTr[0][5])+"','"+str(daneTr[0][6])+"',"
                                    SqlIns+=str(daneTr[0][7])+","+str(daneTr[0][8])+");"  #AB 24.09.20r
                                rsglobal.ZapiszDoLogow('Polecenie Inserta'+str(SqlIns),5)
                                stat,dump,dump,dump=self.PolSQL.Execute(SqlIns,1)
                                if stat != 'OK':
                                    stat = 'Bd insertu danych do rs_dowody_dostaw_rentownosc'
  
  
        if stat == 'OK':
            # uzupelnienie o dane za przewozy z MM
            # firma, oddzial, kierowca, data, wartosc
            SQL = "SELECT mm.firma_id, mm.oddzial_id, mm.kierowca,mm.data,"
            SQL+= " round(((round(SUM(rsf_podaj_cene_n1('"+self.firma_id+"', mm.artykul_id, mm.wc_przerz,'PLN','"+DataRaportu+"')*(CASE WHEN mm.czy_nocny=false THEN mm.ilosc1 ELSE 0 END)),2)) +"
            SQL+= " (round(SUM(rsf_podaj_cene_n1('"+self.firma_id+"', mm.artykul_id,mm.wc_noc,'PLN','"+DataRaportu+"')*(CASE WHEN mm.czy_nocny=true THEN mm.ilosc1 ELSE 0 END)),2)))*(1.05),2)"
            SQL+= " FROM rs_kierowcy_wersje kw"
            SQL+= " INNER JOIN (SELECT om.firma_id, tr.oddzial_id, om.magazyn_id, data, kierowca, artykul_id, czy_nocny, ilosc1, kwm.wc_przerz, kwm.wc_noc"
            SQL+= " FROM rs_obroty_magazynowe om"
            SQL+= " INNER JOIN rs_kierowcy_wersje kwm ON (om.firma_id=kwm.firma_id AND om.magazyn_id=kwm.magazyn_id)"
            SQL+= " INNER JOIN rs_trasy tr ON (om.firma_id=tr.firma_id AND om.kierowca=tr.kod)"
            SQL+= " WHERE om.firma_id=kwm.firma_id AND om.magazyn_id=kwm.magazyn_id AND om.dokument_id='MM' AND om.typ_znak='-1' AND om.kierowca=tr.kod"
            SQL+= " GROUP BY om.firma_id, tr.oddzial_id, om.magazyn_id, om.dokument_id, om.data, om.numer, om.nr_poz, om.nr_ppoz, kierowca, om.artykul_id, ilosc1, kwm.wc_przerz, kwm.wc_noc, czy_nocny"
            SQL+= " HAVING om.kierowca IS NOT NULL"
            SQL+= " ORDER BY artykul_id) mm"
            SQL+= " ON (mm.firma_id=kw.firma_id AND mm.oddzial_id=kw.oddzial_id AND mm.magazyn_id=kw.magazyn_id)"
            SQL+= " WHERE kw.firma_id='"+self.firma_id+"' AND kw.oddzial_id=mm.oddzial_id AND kw.wlasny AND kw.specjalny=FALSE AND mm.data='"+DataRaportu+"'"
            SQL+= " GROUP BY mm.firma_id, mm.oddzial_id, mm.kierowca, mm.data"
            SQL+= " ORDER BY mm.oddzial_id, mm.kierowca, mm.data "
            rsglobal.ZapiszDoLogow('Zapytanie o 0000'+str(SQL),5)
            stat,dane,dump,dump=self.PolSQL.Execute(SQL,3)
            if stat == 'OK':
                SqlIns=''
                SqlUpd=''
                # petla po wierszach wyniku, przygotowanie inserta lub update
                for w in dane:
                    # insert albo udate
                    SQL = "SELECT * FROM rs_dowody_dostaw_rentownosc"
                    SQL+= " WHERE firma_id='"+w[0]+"' AND oddzial_id='"+w[1]+"' AND trasa='"+w[2]+"' AND data='"+str(w[3])+"';"
                    rsglobal.ZapiszDoLogow('Zapytanie czyjest'+str(SQL),5)
                    stat,czyjest,dump,dump=self.PolSQL.Execute(SQL,3)
                    if stat == 'OK':
                        if len(czyjest) == 0:
                            # insert
                            if not w[1] in ['None',None,'']:
                                SqlIns+=" INSERT INTO rs_dowody_dostaw_rentownosc (firma_id,oddzial_id,trasa,data,transport)"
                                SqlIns+=" VALUES ('"+w[0]+"','"+w[1]+"','"+w[2]+"','"+str(w[3])+"',"+str(w[4])+");"
                        else:
                            # update
                            if not w[1] in ['None',None,'']:
                                SqlUpd+=" UPDATE rs_dowody_dostaw_rentownosc SET transport=transport+"+str(w[4])
                                SqlUpd+=" WHERE firma_id='"+w[0]+"' AND oddzial_id ='"+w[1]+"' "
                                SqlUpd+=" AND trasa='"+w[2]+"' AND data='"+str(w[3])+"';"
                    
                
                if stat == 'OK':
                    if SqlIns != '':
                        rsglobal.ZapiszDoLogow('Zapytanie SqlIns' + str(SqlIns), 5)
                        stat,dump,dump,dump=self.PolSQL.Execute(SqlIns,1)
                        if stat != 'OK':
                            stat = 'Bd insertu danych o przerzutach do rs_dowody_dostaw_rentownosc'
                if stat == 'OK':
                    if SqlUpd != '':
                        rsglobal.ZapiszDoLogow('Zapytanie SqlUpd' + str(SqlUpd), 5)
                        stat,dump,dump,dump=self.PolSQL.Execute(SqlUpd,1)
                        if stat != 'OK':
                            stat = 'Bd update danych o przerzutach do rs_dowody_dostaw_rentownosc'

        if stat == 'OK':
            # uzupelnienie o premie za zbieranie gotowki
            # select pobierajacy dane o terminowych i przeterminowanych wplatach
            SQL = " SELECT rp.firma_id, (SELECT tr.oddzial_id FROM rs_trasy tr where tr.firma_id='"+self.firma_id+"' and tr.kod=rpp.kierowca), rpp.kierowca, rp.data,"
            SQL+= " ROUND (((SUM(CASE WHEN rp.typ_fakt = 'F' AND f.termin_zaplaty+integer '3'>=rp.data "
            SQL+= " THEN CASE WHEN rp.typ='W' THEN rp.kwota*(-1) ELSE rp.kwota END ELSE CASE WHEN rp.typ_fakt='K' AND k.termin_zaplaty+integer '3'>=rp.data"
            SQL+= " THEN CASE WHEN rp.typ='W' THEN rp.kwota*(-1) ELSE rp.kwota END ELSE 0 END END) + (SUM(CASE WHEN rp.typ_fakt = 'D' THEN CASE WHEN rp.typ='W'"
            SQL+= " THEN rp.kwota*(-1) ELSE rp.kwota END ELSE 0 END))) * (select tt.proc_got_w_terminie from rs_trasy_transport tt where tt.firma_id='"+self.firma_id+"' and tt.kod=rpp.kierowca and tt.od_dnia<='"+DataRaportu+"' order by tt.od_dnia desc limit 1) *0.01) +"
            SQL+= " ((SUM(CASE WHEN rp.typ_fakt = 'F' AND f.termin_zaplaty+integer '3'<rp.data "
            SQL+= " THEN CASE WHEN rp.typ='W' THEN rp.kwota*(-1) ELSE rp.kwota END ELSE CASE WHEN rp.typ_fakt='K' AND k.termin_zaplaty+integer '3'<rp.data"
            SQL+= " THEN CASE WHEN rp.typ='W' THEN rp.kwota*(-1) ELSE rp.kwota END ELSE 0 END END)) * (select tt.proc_got_po_terminie from rs_trasy_transport tt where tt.firma_id='"+self.firma_id+"' and tt.kod=rpp.kierowca and tt.od_dnia<='"+\
                  DataRaportu+"' order by tt.od_dnia desc limit 1) *0.01),5)"
            SQL+= " FROM rs_raporty_wyciagi_pozycje rp"
            SQL+= " INNER JOIN rs_raporty_wyciagi_pozycje rpp ON (rp.firma_id=rpp.firma_id AND rp.okres_id=rpp.okres_id AND rp.kasa_bank_id=rpp.kasa_bank_id AND rp.data=rpp.data AND rp.numer=rpp.numer AND rp.nr_poz=rpp.nr_poz AND rpp.nr_ppoz=0)"
            SQL+= " INNER JOIN rs_raporty_wyciagi rw  ON (rw.firma_id=rp.firma_id AND rw.okres_id=rp.okres_id AND rw.kasa_bank_id=rp.kasa_bank_id AND rw.data=rp.data AND rw.numer=rp.numer)"
            SQL+= " LEFT OUTER JOIN rs_faktury f ON (rp.firma_id=f.firma_id AND rp.wyznacznik_id=f.wyznacznik_id AND rp.data_fakt=f.data AND rp.numer_fakt=f.numer)"
            SQL+= " LEFT OUTER JOIN rs_korekty k ON (rp.firma_id=k.firma_id AND rp.wyznacznik_id=k.wyznacznik_id AND rp.data_fakt=k.data AND rp.numer_fakt=k.numer)"
            SQL+= " WHERE rw.firma_id='"+self.firma_id+"' AND rw.data='"+DataRaportu+"' AND (f.oddzial_id=(SELECT tr.oddzial_id FROM rs_trasy tr where tr.firma_id='"+self.firma_id+"' AND tr.kod=rpp.kierowca) OR k.oddzial_id=(SELECT tr.oddzial_id " \
                                                                                                                                                                                "FROM rs_trasy tr where tr.firma_id='"+self.firma_id+"' AND tr.kod=rpp.kierowca))"
            SQL+= " GROUP BY rp.firma_id, (SELECT tr.oddzial_id FROM rs_trasy tr where tr.firma_id='"+self.firma_id+"' and tr.kod=rpp.kierowca), rpp.kierowca, rp.data"
            SQL+= " HAVING rpp.kierowca IS NOT NULL"
            SQL+= " ORDER BY 2,3,4"
            rsglobal.ZapiszDoLogow('Zapytanie dfsagff' + str(SQL), 5)
            stat,dane,dump,dump=self.PolSQL.Execute(SQL,3)

            if stat == 'OK':
                SqlIns=''
                SqlUpd=''
                # petla po wierszach wyniku, przygotowanie inserta lub update
                for w in dane:
                    # insert albo udate
                    SQL = "SELECT * FROM rs_dowody_dostaw_rentownosc"
                    SQL+= " WHERE firma_id='"+w[0]+"' AND oddzial_id='"+w[1]+"' AND trasa='"+w[2]+"' AND data='"+str(w[3])+"';"
                    rsglobal.ZapiszDoLogow('Zapytanie dfsff' + str(SQL), 5)
                    stat,czyjest,dump,dump=self.PolSQL.Execute(SQL,3)
                    if stat == 'OK':
                        if len(czyjest) == 0:
                            # insert
                            if not w[1] in ['None',None,'']:
                                SqlIns+=" INSERT INTO rs_dowody_dostaw_rentownosc (firma_id,oddzial_id,trasa,data,dod_got)"
                                SqlIns+=" VALUES ('"+w[0]+"','"+w[1]+"','"+w[2]+"','"+str(w[3])+"',"+str(w[4])+");"
                        else:
                            # update
                            if not w[1] in ['None',None,'']:
                                SqlUpd+=" UPDATE rs_dowody_dostaw_rentownosc SET dod_got="+str(w[4])
                                SqlUpd+=" WHERE firma_id='"+w[0]+"' AND oddzial_id ='"+w[1]+"' "
                                SqlUpd+=" AND trasa='"+w[2]+"' AND data='"+str(w[3])+"';"
                    
                
                if stat == 'OK':
                    if SqlIns != '':
                        rsglobal.ZapiszDoLogow('Zapytanie SqlIns2' + str(SqlIns), 5)
                        stat,dump,dump,dump=self.PolSQL.Execute(SqlIns,1)
                        if stat != 'OK':
                            stat = 'Bd insertu danych o patnociach do rs_dowody_dostaw_rentownosc'
                if stat == 'OK':
                    if SqlUpd != '':
                        rsglobal.ZapiszDoLogow('Zapytanie SqlUpd2' + str(SqlUpd), 5)
                        stat,dump,dump,dump=self.PolSQL.Execute(SqlUpd,1)
                        if stat != 'OK':
                            stat = 'Bd update danych o patnociach do rs_dowody_dostaw_rentownosc'
#AB 06.02.19r nowe wersja zogdnie z wczeniejszymi zmianami, plus nowe nazwy tabel i kolumna dystans_km
if stat == 'OK' and Funkcja == 12:
    #Zliczanie iloci przejazdw
    SQL = "SELECT dk.oddzial_id,dk.trasa,SUM(dk.kor), rzut FROM (SELECT oddzial_id,trasa,"
    SQL+= "CASE WHEN NOT korekta THEN COUNT(DISTINCT tryb_dostawy) ELSE 0 END AS kor "
    SQL+= ", (SELECT rzut FROM rs_tryby_dostaw td WHERE td.firma_id='"+self.firma_id+"' AND td.kod=dd.tryb_dostawy) AS rzut "
    SQL+= "FROM rs_dowody_dostaw dd WHERE firma_id='"+ self.firma_id +"' AND data = '"+DataRaportu+"' "
    if Zwrocone:
        SQL += " AND ((NOT (SELECT blokowac_edycje_dd from rs_oddzialy o WHERE o.firma_id=dd.firma_id AND o.oddzial_id=dd.oddzial_id)) OR dd.zwrocony ) "
    SQL+= "GROUP BY oddzial_id, trasa, korekta, rzut) dk GROUP BY dk.oddzial_id,dk.trasa, rzut;"
    rsglobal.ZapiszDoLogow('Zapytanie o trasy'+str(SQL),5)
    stat, daneIle, dump, dump = self.PolSQL.Execute(SQL, 3)
    if stat != 'OK':
        stat = 'Bd pobierania iloci tras'

    elif len(daneIle)>0:
        #Sprawdza czy dzien tygodnia jest witem lub niedziel
        CzySwieto = rs_anakonda_daty.CzySwieto(DataRaportu)
        if CzySwieto:
            Swieta=" wc_swiat "
        else:
            Swieta=" wc_normal "

        SQL ="SELECT moja.oddzial_id,moja.trasa,"
        SQL+="round(SUM(moja.cena_upust1*moja.ilosc_dost1),2),"
        SQL+="round(SUM(moja.cena_upust1*moja.ilosc_zwr1),2), "
        SQL+="round(SUM(rsf_podaj_cene_n1('"+self.firma_id+"', moja.artykul_id,"+Swieta+",'PLN','"+DataRaportu+"')*(moja.ilosc_dost1-(moja.ilosc_zwr1))),2) "
        SQL+=", (SELECT rzut FROM rs_tryby_dostaw td WHERE td.firma_id='"+self.firma_id+"' AND td.kod=moja.tryb_dostawy) AS rzut "
        SQL+="FROM rs_kierowcy_wersje kw "
        SQL+="INNER JOIN (SELECT ddp.firma_id,ddp.oddzial_id, ddp.trasa, artykul_id,ilosc_dost1,ilosc_zwr1,cena_upust1,platnik_id,wlasny, dd.tryb_dostawy "
        SQL+="FROM rs_dowody_dostaw_pozycje ddp "
        SQL+="INNER JOIN rs_dowody_dostaw dd ON (dd.firma_id=ddp.firma_id AND dd.oddzial_id=ddp.oddzial_id "
        if Zwrocone:
            SQL += " AND ((NOT (SELECT blokowac_edycje_dd from rs_oddzialy o WHERE o.firma_id=dd.firma_id AND o.oddzial_id=dd.oddzial_id)) OR dd.zwrocony ) "
        SQL+="AND dd.data=ddp.data AND  dd.trasa=ddp.trasa AND dd.tryb_dostawy=ddp.tryb_dostawy AND dd.numer=ddp.numer) "
        SQL+="INNER JOIN rs_kierowcy k ON (dd.firma_id=k.firma_id AND dd.kierowca=k.kod) "
        SQL+="WHERE ddp.firma_id='"+self.firma_id+"' and ddp.data='"+DataRaportu+"') moja ON (moja.firma_id = kw.firma_id AND moja.oddzial_id=kw.oddzial_id) "
        SQL+="WHERE kw.firma_id='"+self.firma_id+"' AND kw.oddzial_id=moja.oddzial_id "
        SQL+="AND kw.specjalny = (moja.platnik_id = ANY (STRING_TO_ARRAY(replace(kw.platnicy,'\\'',''),','))) AND kw.wlasny=moja.wlasny "
        SQL+="GROUP BY moja.oddzial_id,moja.trasa, rzut;"
        rsglobal.ZapiszDoLogow('Zapytanie o dane'+str(SQL), 5)
        stat,daneW,dump,dump=self.PolSQL.Execute(SQL,3)
        if stat != 'OK':
            stat = 'Bd pobierania danych do wyliczenia rentownoci'

        elif len(daneW)>0 and stat == 'OK':
            for rent in xrange(len(daneW)):
                for ile in xrange(len(daneIle)):
                    if daneW[rent][:2] == daneIle[ile][:2] and daneIle[ile][-1] == daneW[rent][-1] and stat == 'OK':
                        # liczba przejazdw=daneIle[ile][2], oddzial_id=daneW[rent][0], trasa=daneW[rent][1], sprzedaz=daneW[rent][2],
                        # zwrot=daneW[rent][3],transport=daneW[rent][4]
                        SqlTr ="SELECT tt.ryczalt, tt.za_km, tt.za_godz, tt.proc_obrotu, tt.bez_wywozu, tt.opis, p.przewoznik_id, tt.dystans_km, tt.dodatek "  #AB 24.09.20r
                        SqlTr+="FROM rs_trasy_transport tt "
                        SqlTr+="JOIN rs_trasy_przewoznicy p ON tt.firma_id=p.firma_id and tt.kod=p.kod and "
                        SqlTr+="p.od_dnia=(SELECT pp.od_dnia From rs_trasy_przewoznicy pp WHERE pp.kod=p.kod AND pp.od_dnia<='"+DataRaportu+"' ORDER BY pp.od_dnia DESC LIMIT 1) "
                        SqlTr+="WHERE tt.firma_id='"+self.firma_id+"' AND tt.kod='"+daneW[rent][1]+"' AND tt.od_dnia ="
                        SqlTr+="(SELECT max(pom.od_dnia) FROM rs_trasy_transport pom WHERE tt.kod=pom.kod AND pom.od_dnia<='"+DataRaportu+"');"
                        rsglobal.ZapiszDoLogow('Zapytanie o dane transportu'+str(SqlTr), 5)
                        stat,daneTr,dump,dump=self.PolSQL.Execute(SqlTr,3)
                        if stat != 'OK':
                            stat = 'Bd pobierania danych z rs_trasy_transport'
                        elif stat == 'OK' and len(daneTr)>0:
                            #sprawdzenie czy s dane
                            SprIns ="SELECT * FROM rs_dowody_dostaw_rentownosc_rzut WHERE firma_id='"+self.firma_id+"' AND oddzial_id ='"+daneW[rent][0]+"' "
                            SprIns+="AND trasa='"+daneW[rent][1]+"' AND data='"+DataRaportu+"' AND rzut='"+str(daneW[rent][5])+"'; "
                            rsglobal.ZapiszDoLogow('Zapytanie o dane zrs_dowody_dostaw_rentownosc' + str(SprIns), 5)
                            stat,daneSpr,dump,dump=self.PolSQL.Execute(SprIns,3)
                            if stat != 'OK':
                                stat = 'Bd pobierania danych z rs_dowody_dostaw_rentownosc'

                            #robienie updatu jeli s ju dane
                            elif len(daneSpr)>0 and stat == 'OK':
                                SqlUpd ="UPDATE rs_dowody_dostaw_rentownosc_rzut SET liczba="+str(daneIle[ile][2])+","
                                SqlUpd+="sprzedaz="+str(daneW[rent][2])+",zwroty="+str(daneW[rent][3])+""
                                if daneIle[ile][2]<>0:
                                    if daneTr[0][4]:
                                        SqlUpd+=",transport=0"
                                    else:
                                        SqlUpd+=",transport="+str(daneW[rent][4])
                                    SqlUpd+=",dod_km=round("+str(daneTr[0][1])+",2),dod_godz=round("+str(daneTr[0][2])+",2)"
                                    SqlUpd+=",ryczalt="+str(daneTr[0][0])+",opis='"+str(daneTr[0][5])+"'"
                                    SqlUpd+=",dod_proc=round("+str(daneTr[0][3])+"/100*("+str(daneW[rent][2])+"-("+str(daneW[rent][3])+")),2) "
                                    SqlUpd+=",przewoznik_id='"+str(daneTr[0][6])+"', dystans_km= "+str(daneTr[0][7])
                                    SqlUpd+="' ,dodatek="+str(daneTr[0][8])+" "  #AB 24.09.20r
                                else:
                                    if daneTr[0][4]:
                                        SqlUpd+=",transport=0"
                                    else:
                                        SqlUpd+=",transport="+str(daneW[rent][4])
                                    SqlUpd+=",dod_km=0,dod_godz=0,ryczalt=0,opis='"+str(daneTr[0][5])+"'"
                                    SqlUpd+=",dod_proc=round("+str(daneTr[0][3])+"/100*("+str(daneW[rent][2])+"-("+str(daneW[rent][3])+")),2) "
                                    SqlUpd+=",przewoznik_id='"+str(daneTr[0][6])+"', dystans_km= "+str(daneTr[0][7])
                                    SqlUpd+="' ,dodatek="+str(daneTr[0][8])+" "  #AB 24.09.20r
                                SqlUpd+="WHERE firma_id='"+self.firma_id+"' AND oddzial_id ='"+daneW[rent][0]+"' "
                                                                                                    #AB 22.11.18r
                                SqlUpd+="AND trasa='"+daneW[rent][1]+"' AND data='"+DataRaportu+"' AND rzut='"+str(daneW[rent][5])+"';"
                                rsglobal.ZapiszDoLogow('Polecenie Updatu'+str(SqlUpd),5)
                                stat,dump,dump,dump=self.PolSQL.Execute(SqlUpd,1)
                                if stat != 'OK':
                                    stat = 'Bd updatu danych do rs_dowody_dostaw_rentownosc'

                            else:
                                SqlIns ="INSERT INTO rs_dowody_dostaw_rentownosc_rzut (firma_id,oddzial_id,trasa,data,liczba,sprzedaz,zwroty,"
                                                                                                    #AB 22.11.18r
                                SqlIns+="transport,dod_km,dod_godz,dod_proc,ryczalt,opis,przewoznik_id, rzut, dystans_km, dodatek) "  #AB 24.09.20r
                                SqlIns+="VALUES ('"+self.firma_id+"','"+daneW[rent][0]+"','"+daneW[rent][1]+"','"+DataRaportu+"',"+str(daneIle[ile][2])+","
                                SqlIns+=str(daneW[rent][2])+","+str(daneW[rent][3])
                                if daneIle[ile][2]<>0:
                                    if daneTr[0][4]:
                                        SqlIns+=",0"
                                    else:
                                        SqlIns+=","+str(daneW[rent][4])
                                    SqlIns+=",round("+str(daneTr[0][1])+",2),round("+str(daneTr[0][2])+",2)"
                                    SqlIns+=",round("+str(daneTr[0][3])+"/100*("+str(daneW[rent][2])+"-("+str(daneW[rent][3])+")),2),"
                                                                                                                #AB 22.11.18r
                                    SqlIns+=str(daneTr[0][0])+",'"+str(daneTr[0][5])+"','"+str(daneTr[0][6])+"'"+","
                                    SqlIns+=str(daneW[rent][5])+", "+str(daneTr[0][7])+", "+str(daneTr[0][8])+");"  #AB 24.09.20r
                                else:
                                    if daneTr[0][4]:
                                        SqlIns+=",0"
                                    else:
                                        SqlIns+=","+str(daneW[rent][4])
                                    SqlIns+=",0,0,round("+str(daneTr[0][3])+"/100*("+str(daneW[rent][2])+"-("+str(daneW[rent][3])+")),2),"
                                    SqlIns+="0,'"+str(daneTr[0][5])+"','"+str(daneTr[0][6])+"'"+","
                                    SqlIns+=str(daneW[rent][5])+", "+str(daneTr[0][7])+", "+str(daneTr[0][8])+");"  #AB 24.09.20r
                                rsglobal.ZapiszDoLogow('Polecenie Inserta'+str(SqlIns),5)
                                stat,dump,dump,dump=self.PolSQL.Execute(SqlIns,1)
                                if stat != 'OK':
                                    rsglobal.ZapiszDoLogow('stat Inserta'+str(stat),5)
                                    stat = 'Bd insertu danych do rs_dowody_dostaw_rentownosc'

        #
        # if stat == 'OK':
        #     # uzupelnienie o dane za przewozy z MM
        #     # firma, oddzial, kierowca, data, wartosc
        #     SQL = "SELECT mm.firma_id, mm.oddzial_id, mm.kierowca,mm.data,"
        #     SQL+= " round(((round(SUM(rsf_podaj_cene_n1('"+self.firma_id+"', mm.artykul_id, mm.wc_przerz,'PLN','"+DataRaportu+"')*(CASE WHEN mm.czy_nocny=false THEN mm.ilosc1 ELSE 0 END)),2)) +"
        #     SQL+= " (round(SUM(rsf_podaj_cene_n1('"+self.firma_id+"', mm.artykul_id,mm.wc_noc,'PLN','"+DataRaportu+"')*(CASE WHEN mm.czy_nocny=true THEN mm.ilosc1 ELSE 0 END)),2)))*(1.05),2)"
        #     SQL+= " FROM rs_kierowcy_wersje kw"
        #     SQL+= " INNER JOIN (SELECT om.firma_id, tr.oddzial_id, om.magazyn_id, data, kierowca, artykul_id, czy_nocny, ilosc1, kwm.wc_przerz, kwm.wc_noc"
        #     SQL+= " FROM rs_obroty_magazynowe om"
        #     SQL+= " INNER JOIN rs_kierowcy_wersje kwm ON (om.firma_id=kwm.firma_id AND om.magazyn_id=kwm.magazyn_id)"
        #     SQL+= " INNER JOIN rs_trasy tr ON (om.firma_id=tr.firma_id AND om.kierowca=tr.kod)"
        #     SQL+= " WHERE om.firma_id=kwm.firma_id AND om.magazyn_id=kwm.magazyn_id AND om.dokument_id='MM' AND om.typ_znak='-1' AND om.kierowca=tr.kod"
        #     SQL+= " GROUP BY om.firma_id, tr.oddzial_id, om.magazyn_id, om.dokument_id, om.data, om.numer, om.nr_poz, om.nr_ppoz, kierowca, om.artykul_id, ilosc1, kwm.wc_przerz, kwm.wc_noc, czy_nocny"
        #     SQL+= " HAVING om.kierowca IS NOT NULL"
        #     SQL+= " ORDER BY artykul_id) mm"
        #     SQL+= " ON (mm.firma_id=kw.firma_id AND mm.oddzial_id=kw.oddzial_id AND mm.magazyn_id=kw.magazyn_id)"
        #     SQL+= " WHERE kw.firma_id='"+self.firma_id+"' AND kw.oddzial_id=mm.oddzial_id AND kw.wlasny AND kw.specjalny=FALSE AND mm.data='"+DataRaportu+"'"
        #     SQL+= " GROUP BY mm.firma_id, mm.oddzial_id, mm.kierowca, mm.data"
        #     SQL+= " ORDER BY mm.oddzial_id, mm.kierowca, mm.data "
        #     rsglobal.ZapiszDoLogow('uzupelnienie o dane za przewozy z MM' + str(SQL), 5)
        #     stat,dane,dump,dump=self.PolSQL.Execute(SQL,3)
        #     if stat == 'OK':
        #         SqlIns=''
        #         SqlUpd=''
        #         # petla po wierszach wyniku, przygotowanie inserta lub update
        #         for w in dane:
        #             # insert albo udate
        #             SQL = "SELECT * FROM rs_dowody_dostaw_rentownosc"                                                       #AB 22.11.18r
        #             SQL+= " WHERE firma_id='"+w[0]+"' AND oddzial_id='"+w[1]+"' AND trasa='"+w[2]+"' AND data='"+str(w[3])+"' and rzut ='"+rzut+"';"
        #             rsglobal.ZapiszDoLogow('uzupelnienie oddddd' + str(SQL), 5)
        #             stat,czyjest,dump,dump=self.PolSQL.Execute(SQL,3)
        #             if stat == 'OK':
        #                 if len(czyjest) == 0:
        #                     # insert
        #                     if not w[1] in ['None',None,'']:                                                               #AB 22.11.18r
        #                         SqlIns+=" INSERT INTO rs_dowody_dostaw_rentownosc_rzut (firma_id,oddzial_id,trasa,data,transport, rzut)"
        #                         SqlIns+=" VALUES ('"+w[0]+"','"+w[1]+"','"+w[2]+"','"+str(w[3])+"',"+str(w[4])+", '"+rzut+"');"
        #                 else:
        #                     # update
        #                     if not w[1] in ['None',None,'']:
        #                         SqlUpd+=" UPDATE rs_dowody_dostaw_rentownosc_rzut SET transport=transport+"+str(w[4])
        #                         SqlUpd+=" WHERE firma_id='"+w[0]+"' AND oddzial_id ='"+w[1]+"' "#AB 22.11.18r
        #                         SqlUpd+=" AND trasa='"+w[2]+"' AND data='"+str(w[3])+"' and rzut ='"+rzut+"';"
        #
        #
        #         if stat == 'OK':
        #             if SqlIns != '':
        #                 rsglobal.ZapiszDoLogow('uzupelnienie odddSqlInsdd' + str(SqlIns), 5)
        #                 stat,dump,dump,dump=self.PolSQL.Execute(SqlIns,1)
        #                 if stat != 'OK':
        #                     stat = 'Bd insertu danych o przerzutach do rs_dowody_dostaw_rentownosc'
        #         if stat == 'OK':
        #             if SqlUpd != '':
        #                 rsglobal.ZapiszDoLogow('uzupelnienie odddSqlUpddd' + str(SqlUpd), 5)
        #                 stat,dump,dump,dump=self.PolSQL.Execute(SqlUpd,1)
        #                 if stat != 'OK':
        #                     stat = 'Bd update danych o przerzutach do rs_dowody_dostaw_rentownosc'
        #
        if stat == 'OK':
            # uzupelnienie o premie za zbieranie gotowki
            # select pobierajacy dane o terminowych i przeterminowanych wplatach
            rzut = '1'
            SQL = " SELECT rp.firma_id, (SELECT tr.oddzial_id FROM rs_trasy tr where tr.firma_id='"+self.firma_id+"' and tr.kod=rpp.kierowca), rpp.kierowca, rp.data,"
            SQL+= " ROUND (((SUM(CASE WHEN rp.typ_fakt = 'F' AND f.termin_zaplaty+integer '3'>=rp.data "
            SQL+= " THEN CASE WHEN rp.typ='W' THEN rp.kwota*(-1) ELSE rp.kwota END ELSE CASE WHEN rp.typ_fakt='K' AND k.termin_zaplaty+integer '3'>=rp.data"
            SQL+= " THEN CASE WHEN rp.typ='W' THEN rp.kwota*(-1) ELSE rp.kwota END ELSE 0 END END) + (SUM(CASE WHEN rp.typ_fakt = 'D' THEN CASE WHEN rp.typ='W'"
            SQL+= " THEN rp.kwota*(-1) ELSE rp.kwota END ELSE 0 END))) * (select tt.proc_got_w_terminie from rs_trasy_transport tt where tt.firma_id='"+self.firma_id+"' and tt.kod=rpp.kierowca and tt.od_dnia<='"+DataRaportu+"' order by tt.od_dnia desc limit 1) *0.01) +"
            SQL+= " ((SUM(CASE WHEN rp.typ_fakt = 'F' AND f.termin_zaplaty+integer '3'<rp.data "
            SQL+= " THEN CASE WHEN rp.typ='W' THEN rp.kwota*(-1) ELSE rp.kwota END ELSE CASE WHEN rp.typ_fakt='K' AND k.termin_zaplaty+integer '3'<rp.data"
            SQL+= " THEN CASE WHEN rp.typ='W' THEN rp.kwota*(-1) ELSE rp.kwota END ELSE 0 END END)) * (select tt.proc_got_po_terminie from rs_trasy_transport tt where tt.firma_id='"+self.firma_id+"' and tt.kod=rpp.kierowca and tt.od_dnia<='"+\
                  DataRaportu+"' order by tt.od_dnia desc limit 1) *0.01),5)"
            SQL+= " FROM rs_raporty_wyciagi_pozycje rp"
            SQL+= " INNER JOIN rs_raporty_wyciagi_pozycje rpp ON (rp.firma_id=rpp.firma_id AND rp.okres_id=rpp.okres_id AND rp.kasa_bank_id=rpp.kasa_bank_id AND rp.data=rpp.data AND rp.numer=rpp.numer AND rp.nr_poz=rpp.nr_poz AND rpp.nr_ppoz=0)"
            SQL+= " INNER JOIN rs_raporty_wyciagi rw  ON (rw.firma_id=rp.firma_id AND rw.okres_id=rp.okres_id AND rw.kasa_bank_id=rp.kasa_bank_id AND rw.data=rp.data AND rw.numer=rp.numer)"
            SQL+= " LEFT OUTER JOIN rs_faktury f ON (rp.firma_id=f.firma_id AND rp.wyznacznik_id=f.wyznacznik_id AND rp.data_fakt=f.data AND rp.numer_fakt=f.numer)"
            SQL+= " LEFT OUTER JOIN rs_korekty k ON (rp.firma_id=k.firma_id AND rp.wyznacznik_id=k.wyznacznik_id AND rp.data_fakt=k.data AND rp.numer_fakt=k.numer)"
            SQL+= " WHERE rw.firma_id='"+self.firma_id+"' AND rw.data='"+DataRaportu+"' AND (f.oddzial_id=(SELECT tr.oddzial_id FROM rs_trasy tr where tr.firma_id='"+self.firma_id+"' AND tr.kod=rpp.kierowca) OR k.oddzial_id=(SELECT tr.oddzial_id " \
                                                                                                                                                                                "FROM rs_trasy tr where tr.firma_id='"+self.firma_id+"' AND tr.kod=rpp.kierowca))"
            SQL+= " GROUP BY rp.firma_id, (SELECT tr.oddzial_id FROM rs_trasy tr where tr.firma_id='"+self.firma_id+"' and tr.kod=rpp.kierowca), rpp.kierowca, rp.data"
            SQL+= " HAVING rpp.kierowca IS NOT NULL"
            SQL+= " ORDER BY 2,3,4"
            stat,dane,dump,dump=self.PolSQL.Execute(SQL,3)
            rsglobal.ZapiszDoLogow('uzupelnienie o premie za zbieranie gotowki' + str(SQL), 5)

            if stat == 'OK':
                SqlIns=''
                SqlUpd=''
                # petla po wierszach wyniku, przygotowanie inserta lub update
                for w in dane:
                    # insert albo udate
                    SQL = "SELECT * FROM rs_dowody_dostaw_rentownosc_rzut"                                                               #AB 22.11.18r
                    SQL+= " WHERE firma_id='"+w[0]+"' AND oddzial_id='"+w[1]+"' AND trasa='"+w[2]+"' AND data='"+str(w[3])+"' and rzut ='"+rzut+"';"
                    stat,czyjest,dump,dump=self.PolSQL.Execute(SQL,3)
                    rsglobal.ZapiszDoLogow('uzupelnienie o czyjest' + str(SQL), 5)
                    if stat == 'OK':
                        if len(czyjest) == 0:
                            # insert
                            if not w[1] in ['None',None,'']:                                                            #AB 22.11.18r
                                SqlIns+=" INSERT INTO rs_dowody_dostaw_rentownosc_rzut (firma_id,oddzial_id,trasa,data,dod_got, rzut)"
                                SqlIns+=" VALUES ('"+w[0]+"','"+w[1]+"','"+w[2]+"','"+str(w[3])+"',"+str(w[4])+", '"+rzut+"');"
                        else:
                            # update
                            if not w[1] in ['None',None,'']:
                                SqlUpd+=" UPDATE rs_dowody_dostaw_rentownosc_rzut SET dod_got="+str(w[4])
                                SqlUpd+=" WHERE firma_id='"+w[0]+"' AND oddzial_id ='"+w[1]+"' " #AB 22.11.18r
                                SqlUpd+=" AND trasa='"+w[2]+"' AND data='"+str(w[3])+"' and rzut ='"+rzut+"';"


                if stat == 'OK':
                    if SqlIns != '':
                        rsglobal.ZapiszDoLogow('SqlIns3' + str(SqlIns), 5)
                        stat,dump,dump,dump=self.PolSQL.Execute(SqlIns,1)
                        if stat != 'OK':
                            stat = 'Bd insertu danych o patnociach do rs_dowody_dostaw_rentownosc'
                if stat == 'OK':
                    if SqlUpd != '':
                        rsglobal.ZapiszDoLogow('SqlUpd3' + str(SqlUpd), 5)
                        stat,dump,dump,dump=self.PolSQL.Execute(SqlUpd,1)
                        if stat != 'OK':
                            stat = 'Bd update danych o patnociach do rs_dowody_dostaw_rentownosc'

# #################################################################################################################### #
# #################################################################################################################### #
# #######################################   OBLICZENIA DLA KONTRAHENTW   ############################################ #
# #################################################################################################################### #
# #################################################################################################################### #

if stat == 'OK' and Funkcja == 12:
    SQLDEL = "DELETE FROM rs_dowody_dostaw_rentownosc_kontrahenci WHERE firma_id='"+self.firma_id+"' AND data='"+DataRaportu+"';\n"
    SQLDEL += "DELETE FROM rs_dowody_dostaw_rentownosc_kontrahenci_rzut WHERE firma_id='"+self.firma_id+"' AND data='"+DataRaportu+"';"
    stat, dane, dump, dump = self.PolSQL.Execute(SQLDEL, 1)
    
if stat == 'OK' and Funkcja == 12:
    # Zliczanie liczby przejazdw
    zwr = " AND ((NOT (SELECT blokowac_edycje_dd from rs_oddzialy o WHERE o.firma_id=dd.firma_id AND o.oddzial_id=dd.oddzial_id)) OR dd.zwrocony ) "

    SQL = """SELECT oddzial_id, trasa, kontrahent_id, count(CASE WHEN NOT korekta THEN 1 ELSE 0 END) AS suma_kontr
       FROM rs_dowody_dostaw dd WHERE firma_id='{firma}' AND data = '{data}' {zwr}
       GROUP BY oddzial_id, kontrahent_id, trasa 
       ORDER BY oddzial_id, kontrahent_id, trasa ;""".format(firma=self.firma_id, data=DataRaportu,
                                                             zwr=zwr if Zwrocone else '')
    rsglobal.ZapiszDoLogow('Zapytanie o trasy2'+str(SQL), 5)
    stat, daneIle, dump, dump = self.PolSQL.Execute(SQL, 3)
    if stat != 'OK':
        stat = 'Bd pobierania liczby przejazdow dla kontrahenta'

    elif len(daneIle) > 0:
        # Sprawdza czy dzien tygodnia jest witem lub niedziel
        CzySwieto = rs_anakonda_daty.CzySwieto(DataRaportu)
        if CzySwieto:
            Swieta = " wc_swiat "
        else:
            Swieta = " wc_normal "

        SQL ="SELECT moja.oddzial_id,moja.trasa,moja.kontrahent_id,round(SUM(moja.cena_upust1*moja.ilosc_dost1),2),"
        SQL+=" round(SUM(moja.cena_upust1*moja.ilosc_zwr1),2), "
        SQL+=" round(SUM(rsf_podaj_cene_n1('"+self.firma_id+"', moja.artykul_id,"+Swieta+",'PLN','"+DataRaportu+"')*(moja.ilosc_dost1-(moja.ilosc_zwr1))),2) "
        SQL+=" FROM rs_kierowcy_wersje kw "
        SQL+=" INNER JOIN (SELECT ddp.firma_id,ddp.oddzial_id, ddp.trasa, ddp.kontrahent_id, artykul_id,ilosc_dost1,ilosc_zwr1,cena_upust1,platnik_id,wlasny "
        SQL+=" FROM rs_dowody_dostaw_pozycje ddp "
        SQL+=" INNER JOIN rs_dowody_dostaw dd ON (dd.firma_id=ddp.firma_id AND dd.oddzial_id=ddp.oddzial_id "
        if Zwrocone:
            SQL += " AND ((NOT (SELECT blokowac_edycje_dd from rs_oddzialy o WHERE o.firma_id=dd.firma_id AND o.oddzial_id=dd.oddzial_id)) OR dd.zwrocony ) "
        SQL+=" AND dd.data=ddp.data AND  dd.trasa=ddp.trasa AND dd.tryb_dostawy=ddp.tryb_dostawy AND dd.numer=ddp.numer) "
        SQL+=" INNER JOIN rs_kierowcy k ON (dd.firma_id=k.firma_id AND dd.kierowca=k.kod) "
        SQL+=" WHERE ddp.firma_id='"+self.firma_id+"' and ddp.data='"+DataRaportu+"') moja ON (moja.firma_id = kw.firma_id AND moja.oddzial_id=kw.oddzial_id) "
        SQL+=" WHERE kw.firma_id='"+self.firma_id+"' AND kw.oddzial_id=moja.oddzial_id "
        SQL+=" AND kw.specjalny = (moja.platnik_id = ANY (STRING_TO_ARRAY(replace(kw.platnicy,'\\'',''),','))) AND kw.wlasny=moja.wlasny "
        SQL+=" GROUP BY moja.oddzial_id,moja.trasa,moja.kontrahent_id"
        SQL+=" ORDER BY moja.oddzial_id,moja.trasa,moja.kontrahent_id;"
 
        rsglobal.ZapiszDoLogow('Zapytanie o dane'+str(SQL), 5)
        stat, daneW, dump, dump = self.PolSQL.Execute(SQL, 3)
        if stat != 'OK':
            stat = 'Bd pobierania danych do wyliczenia rentownoci2'
        elif len(daneW) > 0 :
            SqlIns = ""
            for i in xrange(len(daneW)):
                SqlIns += " INSERT INTO rs_dowody_dostaw_rentownosc_kontrahenci "
                SqlIns += " (firma_id,oddzial_id,trasa,kontrahent_id,data,liczba,sprzedaz,zwroty,transport) "
                SqlIns += " VALUES ('" + self.firma_id + "','" + daneW[i][0] + "','" + daneW[i][1] 
                SqlIns +=  "','" +daneW[i][2] +"','"+ DataRaportu + "'," + str(daneIle[i][3]) + ","
                SqlIns += str(daneW[i][3]) + "," + str(daneW[i][4]) + "," + str(daneW[i][5])+');'
                # rsglobal.ZapiszDoLogow('Polecenie Inserta'+str(SqlIns),1)
            if SqlIns != '':
                stat, dump, dump, dump = self.PolSQL.Execute(SqlIns, 1)
                if stat != 'OK':
                    stat = 'Bd insertu danych do rs_dowody_dostaw_rentownosc_kontrahenci'

        # inne koszty dla kontrahenta
        if stat == 'OK':  #AB 24.09.20r dodana kol. dodatek
            SQL = """SELECT rk.firma_id,rk.oddzial_id, rk.trasa, rk.kontrahent_id, rk.data,
             CASE WHEN (r.sprzedaz - r.zwroty) = 0 THEN 1 ELSE ROUND( (rk.sprzedaz - rk.zwroty) / (r.sprzedaz - r.zwroty), 2) END as przelicz,
             r.dod_godz, r.dod_km, r.dod_proc, r.dod_got, r.ryczalt, coalesce(r.opis,''),
             coalesce(r.przewoznik_id,''), r.transport, rk.dystans_km, rk.dodatek
             FROM rs_dowody_dostaw_rentownosc_kontrahenci rk
             INNER JOIN rs_dowody_dostaw_rentownosc r USING (firma_id,oddzial_id,trasa,data)
             WHERE rk.kontrahent_id IS NOT NULL AND rk.firma_id='{firma}' AND rk.data = '{data}' ;""".format(firma=self.firma_id, data=DataRaportu)
             #rsglobal.ZapiszDoLogow('Zapytanie o trasy2'+str(SQL), 5)
            stat, danedod, dump, dump = self.PolSQL.Execute(SQL, 3)
            if stat != 'OK':
                stat = 'Bd pobierania liczby kosztow dodatkowych dla kontrahenta:'+stat
            else:
                SqlUpd = ""
                for w in danedod:
                    SqlUpd += " UPDATE rs_dowody_dostaw_rentownosc_kontrahenci SET"
                    if w[13] == 0:
                        SqlUpd += " transport=0,"
                    SqlUpd += " dod_godz=ROUND( "+str(w[6])+" * "+str(w[5])+" ,2),"
                    SqlUpd += " dod_km=ROUND( "+str(w[7])+" * "+str(w[5])+" ,2),"
                    SqlUpd += " dod_proc=ROUND( "+str(w[8])+" * "+str(w[5])+" ,2),"
                    SqlUpd += " dod_got=ROUND( "+str(w[9])+" * "+str(w[5])+" ,2),"
                    SqlUpd += " ryczalt=ROUND( "+str(w[10])+" * "+str(w[5])+" ,2),"
                    SqlUpd += " opis='"+str(w[11])+"', przewoznik_id='"+str(w[12])+"', dystans_km="+str(w[14])+", "
                    SqlUpd += " dodatek="+str(w[15])  #AB 24.09.20r
                    SqlUpd +=" WHERE  firma_id = '"+ w[0]+"' AND oddzial_id = '"+w[1]+"' "
                    SqlUpd +=" AND  trasa = '"+ w[2]+"' AND kontrahent_id = '"+w[3]+"' AND data = '"+DataRaportu+"'; "
                    # rsglobal.ZapiszDoLogow('Polecenie Inserta'+str(SqlIns),1)
                if SqlUpd != '':
                    rsglobal.ZapiszDoLogow('Zapytanie jjjSqlUpd' + str(SqlUpd), 5)
                    stat, dump, dump, dump = self.PolSQL.Execute(SqlUpd, 1)
                    if stat != 'OK':
                        stat = 'Bd update danych do rs_dowody_dostaw_rentownosc_kontrahenci'


            if stat == 'OK':
                pass
if stat == 'OK' and Funkcja == 12:
    zwr = "AND ((NOT (SELECT blokowac_edycje_dd from rs_oddzialy o WHERE o.firma_id=dd.firma_id AND o.oddzial_id=dd.oddzial_id)) OR dd.zwrocony ) "
    SQL = """SELECT oddzial_id, trasa, kontrahent_id, count(CASE WHEN NOT korekta THEN 1 ELSE 0 END) AS suma_kontr,
       (SELECT rzut FROM rs_tryby_dostaw td WHERE td.firma_id=dd.firma_id AND td.kod=dd.tryb_dostawy) AS rzut
       FROM rs_dowody_dostaw dd WHERE firma_id='{firma}' AND data = '{data}' {zwr}
       GROUP BY oddzial_id, kontrahent_id, trasa, rzut
       ORDER BY oddzial_id, kontrahent_id, trasa, rzut ;""".format(firma=self.firma_id, data=DataRaportu, zwr=zwr if Zwrocone else '')

    rsglobal.ZapiszDoLogow('Zapytanie o trasy2' + str(SQL), 5)
    stat, daneIle, dump, dump = self.PolSQL.Execute(SQL, 3)
    if stat != 'OK':
        stat = 'Bd pobierania liczby przejazdow dla kontrahenta'

    elif len(daneIle) > 0:
        # Sprawdza czy dzien tygodnia jest witem lub niedziel
        CzySwieto = rs_anakonda_daty.CzySwieto(DataRaportu)
        if CzySwieto:
            Swieta = " wc_swiat "
        else:
            Swieta = " wc_normal "

        SQL = """SELECT moja.oddzial_id,
       moja.trasa,
       moja.kontrahent_id, 
       round(SUM(moja.cena_upust1*moja.ilosc_dost1),2) AS wart_dost,
       round(SUM(moja.cena_upust1*moja.ilosc_zwr1),2) AS wart_zwr,
       round(SUM(rsf_podaj_cene_n1(moja.firma_id, moja.artykul_id,{swieta},'PLN',moja.data)*(moja.ilosc_dost1-(moja.ilosc_zwr1))),2) AS transport,
       (SELECT rzut FROM rs_tryby_dostaw td WHERE td.firma_id=moja.firma_id AND td.kod=moja.tryb_dostawy) AS rzut
    FROM rs_kierowcy_wersje kw 
    INNER JOIN (SELECT ddp.firma_id, ddp.oddzial_id, ddp.trasa, ddp.kontrahent_id, artykul_id, ilosc_dost1, ilosc_zwr1, 
                       cena_upust1, platnik_id, wlasny, dd.tryb_dostawy, ddp.data
                FROM rs_dowody_dostaw_pozycje ddp 
                    INNER JOIN rs_dowody_dostaw dd USING (firma_id, oddzial_id, data, trasa, tryb_dostawy, numer) 
                    INNER JOIN rs_kierowcy k ON (dd.firma_id=k.firma_id AND dd.kierowca=k.kod)
                WHERE ddp.firma_id='{firma}' and ddp.DATA='{data}' {zwr}) moja 
          using (firma_id, oddzial_id) 
    WHERE kw.specjalny = (moja.platnik_id = ANY(STRING_TO_ARRAY(replace(kw.platnicy,'\\'',''),','))) AND kw.wlasny=moja.wlasny 
    GROUP BY moja.oddzial_id,moja.trasa,moja.kontrahent_id, rzut
    ORDER BY moja.oddzial_id,moja.trasa,moja.kontrahent_id, rzut;""".format(firma=self.firma_id, data=DataRaportu,
                                                                            swieta=Swieta,
                                                                            zwr=zwr if Zwrocone else '')

        rsglobal.ZapiszDoLogow('Zapytanie o dane' + str(SQL), 5)
        stat, daneW, dump, dump = self.PolSQL.Execute(SQL, 3)
        if stat != 'OK':
            stat = 'Bd pobierania danych do wyliczenia rentownoci2'
        elif len(daneW) > 0:
            rsglobal.ZapiszDoLogow('daneW:' + str(daneW), 5)
            rsglobal.ZapiszDoLogow('len(daneW):' + str(len(daneW)), 5)
            SqlIns = ""
            for i in xrange(len(daneW)):
                SqlIns += " INSERT INTO rs_dowody_dostaw_rentownosc_kontrahenci_rzut "  # AB 22.11.18r
                SqlIns += " (firma_id,oddzial_id,trasa,kontrahent_id,data,liczba,sprzedaz,zwroty,transport, rzut) "
                SqlIns += " VALUES ('" + self.firma_id + "','" + daneW[i][0] + "','" + daneW[i][1]
                SqlIns += "','" + daneW[i][2] + "','" + DataRaportu + "'," + str(daneIle[i][3]) + ","  # AB 22.11.18r
                SqlIns += str(daneW[i][3]) + "," + str(daneW[i][4]) + "," + str(daneW[i][5]) + ",'" + str(
                        daneW[i][6]) + "');"
            rsglobal.ZapiszDoLogow('Polecenie Inserta' + str(SqlIns), 5)
            # rsglobal.ZapiszDoLogow('i: ' + str(i), 5)
            if SqlIns != '':
                stat, dump, dump, dump = self.PolSQL.Execute(SqlIns, 1)
                if stat != 'OK':
                    stat = 'Bd insertu danych do rs_dowody_dostaw_rentownosc_kontrahenci'

        # inne koszty dla kontrahenta
        if stat == 'OK':  #AB 24.09.20r dodana kol. dodatek
            SQL = """SELECT rk.firma_id,rk.oddzial_id, rk.trasa, rk.kontrahent_id, rk.data,
             CASE WHEN (r.sprzedaz - r.zwroty) = 0 THEN 1 ELSE ROUND( (rk.sprzedaz - rk.zwroty) / (r.sprzedaz - r.zwroty), 2) END as przelicz,
             r.dod_godz, r.dod_km, r.dod_proc, r.dod_got, r.ryczalt, coalesce(r.opis,''),
             coalesce(r.przewoznik_id,''), r.transport, rk.rzut, rk.dystans_km, rk.dodatek
             FROM rs_dowody_dostaw_rentownosc_kontrahenci_rzut rk
             INNER JOIN rs_dowody_dostaw_rentownosc_rzut r USING (firma_id,oddzial_id,trasa,data, rzut)
             WHERE rk.kontrahent_id IS NOT NULL AND rk.firma_id='{firma}' AND rk.data = '{data}' ;""".format(
                firma=self.firma_id, data=DataRaportu)
            rsglobal.ZapiszDoLogow('Zapytanie o trasy2' + str(SQL), 5)
            stat, danedod, dump, dump = self.PolSQL.Execute(SQL, 3)
            if stat != 'OK':
                stat = 'Bd pobierania liczby kosztow dodatkowych dla kontrahenta:' + stat
            else:
                SqlUpd = ""
                for w in danedod:
                    SqlUpd += " UPDATE rs_dowody_dostaw_rentownosc_kontrahenci_rzut SET"
                    if w[13] == 0:
                        SqlUpd += " transport=0,"
                    SqlUpd += " dod_godz=ROUND( " + str(w[6]) + " * " + str(w[5]) + " ,2),"
                    SqlUpd += " dod_km=ROUND( " + str(w[7]) + " * " + str(w[5]) + " ,2),"
                    SqlUpd += " dod_proc=ROUND( " + str(w[8]) + " * " + str(w[5]) + " ,2),"
                    SqlUpd += " dod_got=ROUND( " + str(w[9]) + " * " + str(w[5]) + " ,2),"
                    SqlUpd += " ryczalt=ROUND( " + str(w[10]) + " * " + str(w[5]) + " ,2),"
                    SqlUpd += " opis='" + str(w[11]) + "', przewoznik_id='" + str(w[12]) + "',"
                    SqlUpd += " rzut='" + str(w[14]) + "', dystans_km=" + str(w[15]) + ","
                    SqlUpd += " dodatek=" + str(w[16])  #AB 24.09.20r
                    SqlUpd += " WHERE  firma_id = '" + w[0] + "' AND oddzial_id = '" + w[1] + "' "
                    SqlUpd += "AND trasa='" + w[2] + "' AND kontrahent_id='" + w[
                        3] + "' AND data='" + DataRaportu + "' AND rzut='" + str(w[14]) + "'; "
                rsglobal.ZapiszDoLogow('Polecenie Upd' + str(SqlUpd), 5)
                if SqlUpd != '':
                    stat, dump, dump, dump = self.PolSQL.Execute(SqlUpd, 1)
                    if stat != 'OK':
                        stat = 'Bd update danych do rs_dowody_dostaw_rentownosc_kontrahenci'

            if stat == 'OK':
                pass