# -*- coding: iso8859_2 -*-
#-----------------------------------------------------------------------------
# Name:        fs_kontrachenci_dane.py
# Purpose:     formatowanie danych do zapisania i zapisywanie do pliku
# Author:      Piotr Szydeko
# Created:     2008/10/16
# RCS-ID:      $Id: fs_komser_zapisz_zmiany.py $
# Copyright:   (c) 2008 RecordSystem
# Licence:     GNU GPL
#-----------------------------------------------------------------------------

# klucze0: "query" LUB rs_jakas_tabela LUB "funkcja"
#    jesli klucze0 to nazwa tabeli:
#       klucze1: I/U/D
#       klucze2: 
#    jesli klucze0 to "funkcja":
#       pola1, pola2, pola3 = klucze, pola, wartosci   z zapisywanej fun
# w dalszych kluczach kolejnosc nie istotna
#   nie-zapisuj - tylko zwr w danych wynikowy cig
#   dodaj-do: - nastpny uyty jako warto pocztkowa wynikowego cigu


stat = "OK"
zapisz_do_pliku = True
wynik = ""
rodzaj_zmiany = None
wynik_klucze = []
wynik_dane = []
skip = False
nazwa_pliku = "dane"

#====================================   M  A  I  N   ======================
#open("/tmp/query-data", "a").write(repr((klucze, pola, wartosci))+"\n")

if self.zdalne_zlecenie and self.zdalne_zlecenie[0]:
    # jesli juz wykonujemy cos przeslanego to nie zapisuj std
    stat = "OK"
    skip = True
elif klucze[0] in ("query", "funkcja"):
    opcje = klucze[1:]
elif klucze[0].startswith("rs_"):
    opcje = klucze[3:]
else:
    stat = "BLAD"

wyjscie = ""
dodatkoweDane = []

if not skip and stat == "OK":
    if "nie-zapisuj" in opcje:
        zapisz_do_pliku = False
        opcje.remove("nie-zapisuj")
    if "dodaj-do:" in opcje:
        idx = opcje.index("dodaj-do:")
        if idx < len(opcje):
            wyjscie = opcje[idx+1]
            opcje.pop(idx+1)
            opcje.pop(idx)
        else:
            stat = "BLAD: dodaj-do: bez wartosci"
    if "dodane:" in opcje or "dodatkowe-dane:" in opcje:
        if "dodatkowe-dane:" in opcje:
            idx = opcje.index("dodatkowe-dane:")
        elif "dodane:" in opcje:
            idx = opcje.index("dodane:")
        if idx < len(opcje):
            dodatkoweDane = opcje[idx+1]
            opcje.pop(idx+1)
            opcje.pop(idx)
        else:
            stat = "BLAD: dodatkowe-dane: bez wartosci"

if skip or stat != "OK":
    pass
elif klucze[0] == "query":
    query = pola[0]
    query = query.replace("\\\'","'").replace("\\\\","\\")
    dane = rs_anakonda_server_komser.ParserSQL().czytajZapytanie(query)
    nazwa_pliku = "query"
    for row in dane:
        wyjscie += "%s %s\n" % (row[1], row[0][0])
        nazwa_pliku = row[1]
        if row[0] == "UPDATE":
            wyjscie += "  WARUNEK : %s\n" % row[3]
            wyjscie += "  WARTOSCI: %s\n" % row[2]
        elif row[0] == "INSERT":
            wyjscie += "  WARTOSCI: %s\n" % row[2]
        elif row[0] == "DELETE":
            wyjscie += "  WARUNEK : %s\n" % row[2]
        wyjscie += "\n"
elif klucze[0] == "funkcja":
    assert len(pola) == 4, "len(pola) == %d != 4" % len(pola)
    fnazwa, fklucze, fpola, fwartosci = pola
    
    # jeli dict to usuwanie escape'owania inaczej wyglda
    if isinstance(fklucze,dict):
        for kl in fklucze:
            if isinstance(fklucze[kl], str):
                fklucze[kl] = fklucze[kl].replace("\\\'", "\'").replace("\\\\", "\\")
                
        for kl in fwartosci:
            if isinstance(fwartosci[kl], str):
                fwartosci[kl] = fwartosci[kl].replace("\\\'", "\'").replace("\\\\", "\\")
    else: 
        # usun escapowanie ktore i tak bdzie dodane przy wywoaniu funkcji
        for lista in fklucze, fwartosci:
            for i, w in enumerate(lista):
                if isinstance(w, str):
                    lista[i] = w.replace("\\\'", "\'").replace("\\\\", "\\")

    wyjscie += "WYKONAJ %s\n" % fnazwa
    wyjscie += "  OPERATOR: %r\n" % [self.operator_id, self.firma_id, self.oddzial_id, self.okres_id]
    wyjscie += "  KLUCZE  : %r\n" % fklucze
    if fpola:
        wyjscie += "  POLA    : %r\n" % fpola
    if fwartosci:
        wyjscie += "  WARTOSCI: %r\n" % fwartosci
    for dd in dodatkoweDane:
        wyjscie += "  %-8s: %r\n" % (dd[0].upper(), dd[1])
    nazwa_pliku = fnazwa

#open("/tmp/dane-do-wyslania", "a").write(" ==== KOLEJNY  =====\n" + wyjscie)

dane = [None]
if skip or stat != "OK":
    pass
elif zapisz_do_pliku:
    dane[0] = rs_anakonda_server_komser.Zapisz(nazwa_pliku, wyjscie)
else:
    dane = [wyjscie]
