# -*- coding: iso8859_2 -*-

#-------------------------------------------------------------------------------
# Name:        fs_konta_analityczne_dane.py
# Purpose:     edycja konta analitycznego
#
# Author:      Mariusz Rajfura
# Created:     2009/09/05
# RCS-ID:      $Id: fs_konta_analityczne_dane.py $
# Copyright:   (c) 2009 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

Grupa = rsglobal.Dekoduj(klucze[0]).strip()
KontoA = rsglobal.Dekoduj(klucze[1]).strip()

Fun = klucze[-1]

stat = 'OK'
dane = []
wyn1 = []

if Fun in (1,2):
    if not (((self.oddzial_id,'072023') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID):
        stat = 'BR UPR INS'
        
if Fun in (3,4):
    if not (((self.oddzial_id,'072022') in self.uprawnienia) or ((self.oddzial_id,'072023') in self.uprawnienia) or \
            self.operator_id == STANDARD_OPERATOR_ID):
        stat = 'BR UPR UPD'

#-------------------------------------------------------------------------------
# INSERT  1-z pobraniem   2-bez pobrania
#-------------------------------------------------------------------------------
if Fun in (1,2) and stat == 'OK':
    Dlugosc = 0
    if KontoA == '':
        stat = 'BR KONTA'
        dane.append(stat)
    
    if stat == 'OK':
        sql ="SELECT kontoa_id FROM rs_konta_analityczne WHERE firma_id = '"+self.firma_id+"'"
        sql+=" AND okres_id = '"+self.okres_id+"' AND grupa_id = '"+Grupa+"' AND kontoa_id = '"+KontoA+"';"
        stat,d,wyn1,dump = self.PolSQL.Execute(sql, 3)
        if stat <> 'OK':
            stat = 'Bd sprawdzenia konta analitycznego : '+stat
        else:
            if len(d) > 0:
                stat = 'BL KONTO IST'
    
    if stat == 'OK':
        sql ="SELECT dlugosc FROM rs_grupy_analityczne WHERE firma_id = '"+self.firma_id+"'"
        sql+=" AND okres_id = '"+self.okres_id+"' AND grupa_id = '"+Grupa+"';"
        stat,d,dump,dump = self.PolSQL.Execute(sql, 3)
        if stat <> 'OK':
            stat = 'Bd pobrania dugoci konta z grupy analitycznej : '+stat
        else:
            if len(d) == 1:
                Dlugosc = d[0][0]
            else:
                stat = 'BL GRUPA NIST'
    
    if stat == 'OK':             
        sqlpola = 'firma_id,okres_id,grupa_id'
        sqlwart = "'"+self.firma_id+"','"+self.okres_id+"','"+Grupa+"'"
    
        for i in xrange(len(pola)):
            pole = pola[i]
            wart = wartosci[i]
            
            if pole == 'kontoa_id':
                if len(wart) < Dlugosc:
                    dane.append('BL DLUGOSC')
                else:
                    wart = "'"+wart+"'"
                
            elif pole == 'nazwa':
                if wart == '':
                    dane.append('BR NAZWA')
                else:
                    wart = "'"+wart+"'"
            
            sqlpola += ","+pole
            sqlwart += ","+wart
        
        if len(dane) > 0:
            stat = dane[0]
            
        if stat == 'OK':
            sqlins = "INSERT INTO rs_konta_analityczne ("+sqlpola+") VALUES ("+sqlwart+");"
            stat,d,dump,dump = self.PolSQL.Execute(sqlins, 1)
            if stat <> 'OK':
                stat = 'Bd dodawania nowego konta analitycznego : '+stat

#-------------------------------------------------------------------------------
# UPDATE  3-z pobraniem   4-bez pobrania
#-------------------------------------------------------------------------------
if Fun in (3,4) and stat == 'OK':
    if stat == 'OK':             
        sqlupd = ''
    
        for i in xrange(len(pola)):
            pole = pola[i]
            wart = wartosci[i]
            
            if pole == 'nazwa':
                if wart == '':
                    dane.append('BR NAZWA')
                else:
                    sqlupd += pole+" = '"+wart+"',"
            
        if len(dane) > 0:
            stat = dane[0]
            
        if stat == 'OK' and len(sqlupd) > 0:
            sqlupd = sqlupd[:-1]
            SQLUPD ="UPDATE rs_konta_analityczne SET "+sqlupd
            SQLUPD+=" WHERE firma_id = '"+self.firma_id+"' AND okres_id = '"+self.okres_id+"' AND grupa_id = '"+Grupa+"' AND kontoa_id = '"+KontoA+"';"
            stat,d,dump,dump = self.PolSQL.Execute(SQLUPD, 1)
            if stat <> 'OK':
                stat = 'Bd aktualizacji danych konta analitycznego : '+stat

#-------------------------------------------------------------------------------
# SELECT-5   INSERT Z POBRANIEM-1  UPDATE Z POBRANIEM-3
#-------------------------------------------------------------------------------
if Fun in (1,3,5) and stat == 'OK':
    sql ="SELECT * FROM rs_konta_analityczne WHERE firma_id = '"+self.firma_id+"'"
    sql+=" AND okres_id = '"+self.okres_id+"' AND grupa_id = '"+Grupa+"' AND kontoa_id = '"+KontoA+"';"
    stat,dane,wyn1,dump = self.PolSQL.Execute(sql, 3)
    if stat <> 'OK':
        stat = 'Bd pobrania danych konta analitycznego : '+stat
