#!/usr/bin/python
# -*- coding: iso8859_2 -*-
#-----------------------------------------------------------------------------
# Name:             fs_konta_bankowe_dane.py
# Purpose:          dodaje/pobiera/usuwa dane kont
# Author:           Dariusz Boduch
# Created:          2008/10/27
# RCS-ID:           $Id: fs_konta_bankowe_dane.py $
# Copyright:        (c) 2007 RecordSystem
# Licence:          GNU GPL
#-----------------------------------------------------------------------------
# 2016-07-08 Piotr Witkowski (9943) Dodatkowe pole 'IBAN' plus refaktoryzacja


stat='OK'
if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=='OK':
    Funkcja = klucze['Funkcja']
    SlPar={'KontoId':[1,2,3,4,5,6,],}

    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Funkcja,klucze)
    if Lista<>'':
        stat='Uwaga : wywoanie funkcji fs_konta_bankowe_dane z numerem ' +str(Funkcja)+' bez parametrw: '+Lista

if stat=='OK':
    if Funkcja in [1,2,3,4,5,6,]:
        KontoId = klucze['KontoId']

if stat=='OK':
    dane = []
    wyn1 = []
    wyn2 = []
    puste_pola = ['',[],'None',None]

if stat=='OK':
    UprUpd=((self.oddzial_id,'014052') in self.uprawnienia or (self.operator_id == STANDARD_OPERATOR_ID))
    UprIns=((self.oddzial_id,'014053') in self.uprawnienia or (self.operator_id == STANDARD_OPERATOR_ID))
    UprDel=((self.oddzial_id,'014054') in self.uprawnienia or (self.operator_id == STANDARD_OPERATOR_ID))


#-------------------------------------------------------------------------------
#---   INSERT DANYCH (2- bez pobierania,1- z pobieraniem)
#-------------------------------------------------------------------------------

# sprawdzenie danych
if stat == "OK" and Funkcja in [1,2,3,4]:
    for i in range(len(pola)):
        wart = wartosci[i]
        pole = pola[i]
        if pole == 'pli_typ':
            Select="SELECT * FROM rs_typy_plikow_pli WHERE kod='"+wart+"'"
            stat,d,dump,dump=self.PolSQL.Execute(Select,3)
            if len(d)==0:
                stat='BL TYP PLI'
                dane.append(stat)
                
if stat == "OK" and Funkcja in [1,2]:
    Select="SELECT * FROM rs_konta_bankowe WHERE firma_id='"+self.firma_id+"' AND konto_id='"+KontoId+"'"
    stat,d,dump,dump=self.PolSQL.Execute(Select,3)
    if stat=='OK':
        if len(d)>0:
            stat='KONTO ISTN'
            dane.append(stat)

if stat == "OK" and Funkcja in [1,2]:
    if not UprIns:
        stat='UPR INS'
        dane.append(stat)
    else:
        sql = "INSERT INTO rs_konta_bankowe "
        PolaN="firma_id"
        WartosciN = "'"+self.firma_id+"'"
        for i in range(len(pola)):
            pole = pola[i]
            wart = str(wartosci[i])
            PolaN += ","+pole
            WartosciN += ",'"+str(wart)+"'"
        sql += " ("+PolaN+") VALUES ("+WartosciN+");"

        stat,dump,dump,dump = self.PolSQL.Execute(sql ,1)
        if stat<>'OK':
            stat='BL INS'
            dane.append(stat)
        
#-------------------------------------------------------------------------------
#--- Update danych (3,4)
#-------------------------------------------------------------------------------

if stat == "OK" and Funkcja in [3,4]:
    if not UprUpd:
        stat='UPR UPD'
        dane.append(stat)
    else:
        sql = "UPDATE rs_konta_bankowe SET "
        Filtr = "firma_id='"+self.firma_id+"' AND konto_id='"+KontoId+"'"
        for i in range(len(pola)):
            wart = wartosci[i]
            pole = pola[i]
            if pole in ['konto_id','bank','konto','iban','pli_typ','pli_folder']:
                sql += pole+"='"+str(wart)+"',"
            
        sql=sql.strip(",")
        
        sql += " WHERE "+Filtr+";"
        stat,dump,dump,dump = self.PolSQL.Execute(sql ,1)
        if stat <> 'OK':
            stat = 'BL UPD'
            dane.append(stat)

#SELECT
if stat == "OK" and Funkcja in [1,2,3,4,5,6]:
    Sql="SELECT * FROM rs_konta_bankowe WHERE firma_id='"+self.firma_id+"' AND konto_id='"+KontoId+"';"

    stat,dane,wyn1,tr=self.PolSQL.Execute(Sql,3)
    if stat<>'OK':
        stat='BL PRZ'
        dane.append(stat)

     #pobranie danych do opisow
    if len(dane) == 1:
        tr = rssql.RSTableRowset(dane,wyn1)

        #--- typ pliku pli
        if ((self.oddzial_id,'011510') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
            stat,d,dump,dump = self.PolSQL.Execute("SELECT opis FROM rs_typy_plikow_pli WHERE kod='"+rsglobal.Dekoduj(tr.GetVal(0,"pli_typ"))+"';" ,3)
            if stat=='OK' and len(d) == 0:
                wyn2.append('')
            else:
                wyn2.append(d[0][0])
        else:
            wyn2.append('Brak uprawnie do sownika. Poinformuj administratora.')