# -*- coding: iso8859_2 -*-

#-----------------------------------------------------------------------------
# Name:        fs_kontrahenci_ceny_dane.py
# Purpose:     wczytuje/edytuje/dodaje/usuwa wzgldniajc uprawnienia operatora 
#
# Author:      Jarek Plawgo
# Created:     2006/03/27
# RCS-ID:      $Id: fs_kontrahenci_ceny_dane.py $
# Copyright:   (c) 2005 Cybertronika
# Licence:     GNU GPL
#-----------------------------------------------------------------------------
# 2010.12.21 MR, obsuga vat w cenniku kontrahenta

UprDodawanie=((self.oddzial_id,'012063') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)
UprEdytowanie=((self.oddzial_id,'012062') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID) or UprDodawanie

Kontrahent = string.strip(klucze[0])
Artykul = string.strip(klucze[1])
DataOd = klucze[2]
Oddzial = klucze[3]
Fun=klucze[-1]

stat="OK"
dane=[]

waluta=''
CenaNetto1=0
CenaBrutto1=0
CenaNetto2=0
CenaBrutto2=0


#-------------------------------------------------------------------------------
#   POBRANIE DANYCH DODATKOWYCH ARTYKULU (6)
#-------------------------------------------------------------------------------

if stat == "OK" and Fun == 6:
    SQL="SELECT nazwa,przelicznik,rsf_podaj_vat_artykulu(firma_id,artykul_id,'"+DataOd+"') "
    SQL+=" FROM rs_artykuly WHERE firma_id='"+self.firma_id+"' AND artykul_id='"+Artykul+"';"
    stat,dane,dump,dump = self.PolSQL.Execute(SQL,3)

#-------------------------------------------------------------------------------
#---   SPRAWDZANIE DANYCH 
#-------------------------------------------------------------------------------

if Fun in [1,2,3,4]:
    sql= "SELECT artykul_id, oddzial_id, cena_netto1,cena_brutto1,cena_netto2,cena_brutto2,waluta FROM "
    sql+="rs_kontrahenci_ceny  WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+str(Kontrahent)+"'"
    sql+=" AND artykul_id='"+str(Artykul)+"' AND oddzial_id='"+str(Oddzial)+"'"
    if DataOd<>'    -  -  ':
        sql+= " AND data_od='"+str(DataOd)+"'"
    sql+=";"
    stat,d,dump,dump = self.PolSQL.Execute(sql,2)
    if stat!="OK":
        stat="Bd przy sprawdzaniu danych : "+stat   
        dane.append(stat)
    else:
        if Fun in [1,2]:
            if len(d)>0:    
                stat="BL_ISTN_CENY"   
                dane.append(stat)
        elif Fun in [3,4,5]:
            CenaNetto1=d[0][1]
            CenaBrutto1=d[0][2]
            CenaNetto2=d[0][3]
            CenaBrutto2=d[0][4]
            
    for i in range(len(pola)):
        pole = pola[i]
        wart = wartosci[i]
        if pole=="waluta":
            Waluta=string.strip(wart)
        if pole=="cena_netto1":
            CenaNetto1=wart  
        if pole=="cena_brutto1":
            CenaBrutto1=wart  
        if pole=="cena_netto2":
            CenaNetto2=wart  
        if pole=="cena_brutto2":
            CenaBrutto2=wart  
        
    #sprawdzenie kontrahenta
    if Kontrahent=="":
        stat="BR_Kontrahenta"   
        dane.append(stat) 

    #sprawdzenie artykulu    
    if Artykul=="":
        stat="BR_Artykulu"   
        dane.append(stat)
    else:    
        sql="SELECT artykul_id FROM rs_artykuly"  
        sql+=" WHERE firma_id='"+self.firma_id+"' AND artykul_id='"+str(Artykul)+"';"              
        st,d,dump,dump = self.PolSQL.Execute(sql,2)
        if st!="OK":
            stat="Bd sprawdzania artykuu : "+stat   
            dane.append(stat)
        else:
            if len(d)==0:    
                stat="BL_NIE_ISTN_ART"   
                dane.append(stat)

    #sprawdzenie artykulu
    if Oddzial=="":
        stat="BR_Oddzialu"
        dane.append(stat)
    else:
        sql="SELECT oddzial_id FROM rs_oddzialy"
        sql+=" WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+str(Oddzial)+"';"
        st,d,dump,dump = self.PolSQL.Execute(sql,2)
        if st!="OK":
            stat="Bd sprawdzania oddziau : "+stat
            dane.append(stat)
        else:
            if len(d)==0:
                stat="BL_NIE_ISTN_ODDZ"
                dane.append(stat)
                
    #sprawdzenie daty    
    if DataOd<>'    -  -  ':    
        st,d,dump,dump = self.PolSQL.Execute("SELECT rsf_sprawdz_date('"+str(DataOd)+"') ;",3)
        if st=="OK":
            if d[0][0]==0 or d[0][0]==1:
                stat="BL_DATY"   
                dane.append(stat)        
        else:
            stat="Bd przy sprawdzaniu daty : "+stat   
            dane.append(stat)

    #sprawdzenie ceny     
    if CenaNetto1 <= 0.0 or CenaBrutto1 <= 0.0:
        stat="BL_CENA"   
        dane.append(stat)

    #sprawdzenie waluty
    if "waluta" in pola:    
        if Waluta=="":
            stat="BR_WALUTY"   
            dane.append(stat)
        else:     
            sql="SELECT kod FROM rs_waluty"  
            sql+=" WHERE firma_id='"+self.firma_id+"' AND kod='"+str(Waluta)+"';"
            st,d,dump,dump = self.PolSQL.Execute(sql,2)
            if st!="OK":
                stat="Bd przy sprawdzaniu waluty : "+stat   
                dane.append(stat)
            else:
                if len(d)==0:    
                    stat="BL_ISTN_WALUTY"   
                    dane.append(stat)

                
#-------------------------------------------------------------------------------
#---   DODANIE DANYCH (1 -select, 2 -update z pobraniem)
#-------------------------------------------------------------------------------

if Fun in [1,2] and stat=='OK':
    if not UprDodawanie:
        stat="Brak uprawnie do dodawania danych."   
        dane.append(stat)
    else:   
        sql="INSERT INTO rs_kontrahenci_ceny (firma_id,kontrahent_id, oddzial_id,artykul_id,data_od,"
        sql+="waluta,cena_netto1,cena_brutto1,cena_netto2,cena_brutto2) VALUES "
        sql+="('"+self.firma_id+"','"+str(Kontrahent)+"','"+str(Oddzial)+"','"+str(Artykul)+"','"+str(DataOd)+"',"
        sql+="'"+str(Waluta)+"',"+str(CenaNetto1)+","+str(CenaBrutto1)+","+str(CenaNetto2)+","+str(CenaBrutto2)+");"
        stat,dane,wyn1,dump = self.PolSQL.Execute(sql,1)
        if stat!="OK":
            stat="Bd przy dodawaniu danych : "+stat   
            dane.append(stat)


#-------------------------------------------------------------------------------
#---   UPDATE DANYCH (3- z pobieraniem,4- bez pobierania)
#-------------------------------------------------------------------------------

if Fun in [3,4] and stat=='OK':
    if not UprEdytowanie:
        stat="Brak uprawnie do modyfikacji."   
        dane.append(stat)
    else:    
        upd="UPDATE rs_kontrahenci_ceny SET "
        for i in range(len(pola)):
            pole = pola[i]
            wart = wartosci[i]
            if pole in ["cena_netto1","cena_brutto1","waluta","cena_netto2","cena_brutto2"]:
                upd=upd+pole+"='"+str(wart)+"',"
        upd = upd[0:len(upd)-1]
        upd+=" WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+str(Kontrahent)+"' AND"
        upd+=" artykul_id='"+str(Artykul)+"' AND data_od='"+str(DataOd)+"' AND oddzial_id='"+str(Oddzial)+"';"
        stat,d,wyn1,dump = self.PolSQL.Execute(upd,1)
        if stat!="OK":
            stat="Bd przy modyfikacji danych : "+stat   
            dane.append(stat)


#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (5 -select, 3 -update z pobraniem)
#-------------------------------------------------------------------------------

if (Fun in [5,3,1]) and (stat=='OK'):
    sql="SELECT data_od,artykul_id, oddzial_id, cena_netto1,cena_brutto1,cena_netto2,cena_brutto2,"
    sql+="waluta,z_czas,z_typ,z_op_id FROM rs_kontrahenci_ceny WHERE firma_id='"+self.firma_id+"' "
    sql+="AND kontrahent_id='"+str(Kontrahent)+"' AND artykul_id='"+str(Artykul)+"' AND data_od='"+str(DataOd)
    sql+="' AND oddzial_id='"+str(Oddzial)+"';"
    stat,dane,wyn1,dump = self.PolSQL.Execute(sql,3)
    if stat!="OK":
        stat="Bd przy pobieraniu danych : "+stat   
        dane.append(stat)