# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_kontrahenci_ceny_dostaw_z_oddzialow.py
# Purpose:     obsuga edytowalnego grida z cenami dostaw z oddziaw
# Author:      Aleksander Bargie
# Created:     2020/12/07
# RCS-ID:      $Id: fs_kontrahenci_ceny_dostaw_z_oddzialow.py$
# Copyright:   (c) 2020 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

stat='OK'

if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=='OK':
    Funkcja = klucze['Funkcja']
    
    SlPar={'Kontrahent': [1,5]}
    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Funkcja,klucze)
    if Lista!='':
        stat='Uwaga : wywoanie funkcji fs_kontrahenci_ceny_dostaw_z_oddzialow z numerem '+str(Funkcja)+' bez parametrw: '+Lista
        
    if Funkcja in [1,5]:
        Kontrahent= rsglobal.Dekoduj(klucze['Kontrahent'])

        
dane = []
wyn1 = []
wyn2 = []

Puste = (None,'')

Insert = []
Update = []
Delete = []

if stat=='OK' and Funkcja == 1:
    Update=klucze['Update']
    Insert=klucze['Insert']
    Delete=klucze['Delete']
    UprIns=((self.oddzial_id,'012173') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID
    UprUpd=((self.oddzial_id,'012172') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID or UprIns
    UprDel=((self.oddzial_id,'012174') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID

#-------------------------------------------------------------------------------
#-------  SPRAWDZANIE DELETE  --------------------------------------------------
#-------------------------------------------------------------------------------

if Funkcja == 1 and stat=="OK":
    if len(Delete[0])>0:
        if not UprDel:
            stat='BR UPR DEL'
            dane.append(stat)
        
        # wykonanie DELETE 
        if stat == 'OK':
            SQLDEL = ''
            SQLFU = ''
            for i in xrange(len(Delete[0])):
                DELETE = "DELETE FROM rs_kontrahenci_ceny_dostaw_z_oddzialow "
                WHERE = " WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+Kontrahent+"' "
                SQLFU = "SELECT kontrahent_id FROM rs_kontrahenci_ceny_dostaw_z_oddzialow "
                SQLFU+= " WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+Kontrahent+"' "
                for j in xrange(len(Delete[0][i])):
                    pole = Delete[1][j]
                    wart = Delete[0][i][j]
                    if pole in ['kontrahent_id', 'oddzial_id','data_od']:
                        WHERE += " AND "+pole+"='"+wart+"'"
                        SQLFU += " AND "+pole+"='"+wart+"'"
                        

                SQLDEL += DELETE+WHERE+"; "
                SQLFU += " FOR UPDATE NOWAIT; "

            if SQLFU != '':
                stat,d,dump,dump = self.PolSQL.Execute(rsglobal.Dekoduj(SQLFU),3)
                if stat != 'OK':
                    stat = 'Bd sprawdzenia danych do usunicia: '+stat
                    dane.append(stat)
            
            if stat == 'OK' and SQLDEL != '':
                stat,dump,dump,dump = self.PolSQL.Execute(rsglobal.Dekoduj(SQLDEL),1)
                if stat != 'OK':
                    stat = "Bd przy usuwaniu danych: "+stat   
                    dane.append(stat)

                                 
#-------------------------------------------------------------------------------
#---   UPDATE DANYCH (1)
#-------------------------------------------------------------------------------

if Funkcja == 1 and stat=="OK":
    if len(Update[0])>0:
        if not UprUpd:
            stat='BR UPR UPD'
            dane.append(stat)

        if stat == 'OK':
            SQLFU = ''
            for i in xrange(len(Update[0])):
                SQLFU+= "SELECT oddzial_id FROM rs_kontrahenci_ceny_dostaw_z_oddzialow"
                SQLFU+= " WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+Kontrahent+"' "
                for j in xrange(len(Update[2][i])): # petla po kluczu
                    pole = Update[3][j]
                    wart = rsglobal.Dekoduj(Update[2][i][j])
                    SQLFU += " AND "+pole+"='"+str(wart)+"'"
                SQLFU += " FOR UPDATE NOWAIT; "
            
            if SQLFU != '':
                stat,dFU,nFU,dump = self.PolSQL.Execute(rsglobal.Dekoduj(SQLFU),3)
                if stat != 'OK':
                    stat = 'Bd sprawdzenia danych do modyfikacji: '+stat
                    dane.append(stat)

        if stat == 'OK':
            WierszeNr = Update[-1]
            for i in xrange(len(Update[0])):
                for j in xrange(len(Update[0][i])): 
                    pole = Update[0][i][j]
                    wart = Update[1][i][j]
  
                    if pole == 'oddzial_id':
                        wart = wart.strip()
                        if wart == '':
                            stat = 'BR ODDZ'
                            wyn2.append((WierszeNr[i], 0))
                            dane.append(stat)
                        else:
                            sql ="SELECT oddzial_id FROM rs_oddzialy "
                            sql+=" WHERE firma_id='"+self.firma_id+"' AND oddzial_id = '"+str(wart)+"';"
                            stat,d,dump,dump = self.PolSQL.Execute(sql, 3)
                            if stat != 'OK':
                                stat = 'BL SQL ODDZ'
                                wyn2.append((WierszeNr[i], 0))
                                dane.append(stat)
                            elif len(d) == 0:
                                stat = 'BL ODDZ$'+str(wart)
                                wyn2.append((WierszeNr[i], 0))
                                dane.append(stat)
                    elif pole == 'data_od':
                        if wart == '':
                            stat = 'BR DATA'
                            wyn2.append((WierszeNr[i], 1))
                            dane.append(stat)
                        elif not rsglobal.SprawdzCzyToData(wart):
                            stat = 'BL DATA$'+wart
                            wyn2.append((WierszeNr[i], 1))
                            dane.append(stat)
                    elif pole == 'cena_dostawy':
                        if wart > 9999999999999999:
                            stat = 'BL CENA'
                            wyn2.append((WierszeNr[i], 2))
                            dane.append(stat)
                        elif wart < 0:
                            stat = 'BL CENA MINUS'
                            wyn2.append((WierszeNr[i], 2))
                            dane.append(stat)
                            
                if stat == 'OK':
                    if len(dane) > 0:
                        stat = dane[0]
                
                # wykonanie UPDATE
                if stat=='OK':
                    sql=''
                    UPDATE="UPDATE rs_kontrahenci_ceny_dostaw_z_oddzialow "
                    SET='SET '
                    for j in xrange(len(Update[0][i])): 
                        pole=Update[0][i][j]
                        wart=Update[1][i][j]
    
                        if pole in ['oddzial_id', 'data_od']:
                            SET+=pole+"='"+wart+"',"
                            
                        elif pole in ['cena_dostawy',]:
                            SET+=pole+"="+str(wart)+","
                            
                    SET=SET.strip(",")
                    WHERE=" WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+Kontrahent+"' "
                    for j in xrange(len(Update[2][i])): # petla po kluczu
                        pole=Update[3][j]
                        wart=rsglobal.Dekoduj(Update[2][i][j])
                        if pole in ['oddzial_id', 'data_od']:
                            WHERE+=" AND "+pole+"='"+wart+"'"
                        
                    WHERE+=";"
                        
                    sql+=UPDATE+SET+WHERE
                        
                    stat,dump,dump,dump = self.PolSQL.Execute(rsglobal.Dekoduj(sql),1)
                    if stat!='OK':
                        stat="Istnieje ju wpis o podanym kluczu: "+stat   
                        dane.append(stat)
                    

#-------------------------------------------------------------------------------
#---------Sprawdzanie danych do Insert------
#-------------------------------------------------------------------------------

if Funkcja == 1 and stat=="OK":
    if len(Insert[0])>0:
        if not UprIns:
            stat='BR UPR INS'
            dane.append(stat)

        if stat == 'OK':
            WierszeNr = Insert[-1]
            for i in xrange(len(Insert[0])):
                for j in xrange(len(Insert[0][i])): 
                    pole=Insert[1][j]
                    wart=Insert[0][i][j]

                    if pole == 'oddzial_id':
                        wart = wart.strip()
                        if wart == '':
                            stat = 'BR ODDZ'
                            wyn2.append((WierszeNr[i], 0))
                            dane.append(stat)
                        else:
                            sql ="SELECT oddzial_id FROM rs_oddzialy "
                            sql+=" WHERE firma_id='"+self.firma_id+"' AND oddzial_id = '"+str(wart)+"';"
                            stat,d,dump,dump = self.PolSQL.Execute(sql, 3)
                            if stat != 'OK':
                                stat = 'BL SQL ODDZ'
                                wyn2.append((WierszeNr[i], 0))
                                dane.append(stat)
                            elif len(d) == 0:
                                stat = 'BL ODDZ$'+str(wart)
                                wyn2.append((WierszeNr[i], 0))
                                dane.append(stat)
                    elif pole == 'data_od':
                        if wart == '':
                            stat = 'BR DATA'
                            wyn2.append((WierszeNr[i], 1))
                            dane.append(stat)
                        elif not rsglobal.SprawdzCzyToData(wart):
                            stat = 'BL DATA$'+wart
                            wyn2.append((WierszeNr[i], 1))
                            dane.append(stat)
                    elif pole == 'cena_dostawy':
                        if wart > 9999999999999999:
                            stat = 'BL CENA'
                            wyn2.append((WierszeNr[i], 2))
                            dane.append(stat)
                        elif wart < 0:
                            stat = 'BL CENA MINUS'
                            wyn2.append((WierszeNr[i], 2))
                            dane.append(stat)
                        
                            
                # sprawdzenie, czy nie ma bledow
                if stat == 'OK':
                    if len(dane) > 0:
                        stat = dane[0]
                # wykonanie INSERT do pojedynczego wiersza
                if stat == 'OK':    
                    sqlIns=''
                    INSERT="INSERT INTO rs_kontrahenci_ceny_dostaw_z_oddzialow "
                    KOLUMNY="(firma_id, kontrahent_id"
                    VALUES=" VALUES ('"+self.firma_id+"', '"+Kontrahent+"'"

                    for j in xrange(len(Insert[0][i])): 
                        pole=Insert[1][j]
                        wart=Insert[0][i][j]

                        if pole in ['oddzial_id', 'data_od']:
                            KOLUMNY+=","+pole
                            VALUES+=",'"+wart+"'"

                        elif pole in ['cena_dostawy',]:
                            KOLUMNY+=","+pole
                            VALUES+=","+str(wart)
    
                    KOLUMNY+=")"
                    VALUES+=");"
                    sqlIns+=INSERT+KOLUMNY+VALUES
                if stat == 'OK' and sqlIns!='': 
                    stat,dump,dump,dump=self.PolSQL.Execute(rsglobal.Dekoduj(sqlIns),1)
                    if stat!='OK':
                        stat="Bd przy dodawaniu danych: "+stat   
                        dane.append(stat)

#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (1- insert 1 -select, 1 -delete), (5-odczyt)
#-------------------------------------------------------------------------------

if Funkcja in (1, 5) and stat == 'OK':
    UprPrzegl = ((self.oddzial_id,'012170') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID
    
    if not UprPrzegl:
        stat = 'Brak uprawnie do przegldania danych'
        
    if stat == 'OK':
        SQL ="SELECT oddzial_id, data_od, cena_dostawy"
        SQL+=" FROM rs_kontrahenci_ceny_dostaw_z_oddzialow "
        SQL+=" WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+Kontrahent+"' "
        SQL+=" ORDER BY oddzial_id, data_od DESC;"
        stat,dane,wyn1,wyn2 = self.PolSQL.Execute(SQL,3)
        if stat != 'OK':
            stat = "Bd przy pobieraniu danych: "+stat
            if isinstance(dane, list):
                dane.append(stat)
            else:
                dane = [stat]
