# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_kontrahenci_dane_fakturowe.py
# Purpose:     wczytuje/usuwa dane fakturowe kontrahenta
#
# Author:      Micha Raburski
# Created:     2005/12/20
# RCS-ID:      $Id: fs_kontrahenci_dane_fakturowe.py $
# Copyright:   (c) 2005-2009 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

# 2009/05/24  Mariusz Rajfura  mantis: 2050
# przejscie na funkcje - fs_kontrahenci_dane_fakturowe
# usuwanie danych (Fun==6) bylo zrealizowane w fs_funkcje_dane_fakturowe_dane i
# zostalo przesuniete do fs_kotraheci_dane_fakturowe 
# 2011-10-20 Mariusz Rajfura - popr.wysw.grida (likwidacja None) jesli brak wyznacznika (5125)

Fun = klucze[-1]
stat='OK'
dane = []
nagl = []

UprUsun = (self.oddzial_id,'012044') in self.uprawnienia or self.operator_id == STANDARD_OPERATOR_ID

if Fun == 6 and not UprUsun:
    stat = 'Brak uprawnie do usuwania danych fakturowych kontrahenta.'


#-------------------------------------------------------------------------------
#---   DELETE DANYCH (6)
#-------------------------------------------------------------------------------

if Fun == 6 and UprUsun:
    kontr = klucze[0]
    dataod = klucze[1]
    sql = "DELETE FROM rs_kontrahenci_fakturowanie WHERE firma_id = '"+self.firma_id+"' "
    sql += " AND kontrahent_id='"+kontr+"' AND data_od='"+dataod+"';"
    stat,none,none,none = self.PolSQL.Execute(sql,1)
    if stat<>'OK':
        stat = 'Bd usuwania danych fakturowych kontrahenta '+kontr+' i daty '+dataod+': '+stat
        
#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (5 -select)
#-------------------------------------------------------------------------------

if Fun == 5 and stat=='OK':
    kontr = klucze[0]
    dataod = klucze[1]
    filtr = ''
    if dataod <> '':
        filtr = " AND data_od >= '"+dataod+"' "
        
    sql = "SELECT data_od,COALESCE(wyznacznik,''::TEXT),dni,COALESCE(wersja::TEXT,''),"
    sql+= " upust,maks_wart,czy_fakt,"
    sql+= " spos_zaplaty,COALESCE(konto_id::TEXT,'') "
    sql+= " FROM rs_kontrahenci_fakturowanie WHERE firma_id='"+self.firma_id+"'"
    sql+= " AND kontrahent_id='"+kontr+"' "+filtr+" ORDER BY data_od;"
    
    stat,dane,nagl,dump = self.PolSQL.Execute(sql,3)
    if stat<>'OK':
        stat = 'Bd pobrania danych fakturowych dla kontrahenta: '+stat

#----------------  sprawdzamy czy dane maj by przesyane dalej
if stat == "OK" and Fun == 6 and self.firma_id == '01':  #WS 2020-12-16 - self.firma_id
    stat, jest, none, none = self.PolSQL.Execute("SELECT COUNT(*) FROM rs_komser_funkcje WHERE nazwa='fs_kategorie_fakturowanie'", 4)
    if stat != "OK":
        stat = "BL rs_komser_funkcje"
    elif jest:
        stat, odp, none, none = self.WykonajFunkcje("fs_komser_zapisz", ["funkcja"], [funkcja, klucze, pola, wartosci])
