# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_kontrahenci_kuke.py
# Purpose:     obsluga grida dla kontrahentw KUKE
# Author:      Konrad Opieka
# Created:     2014/05/19
# RCS-ID:      $Id: fs_kontrahenci_kuke $
# Copyright:   (c) 2014 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------
 
stat='OK'

if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=='OK':
    Funkcja = klucze['Funkcja']
    
    SlPar={'Kontrahent':[1,5],'DataOd':[1,5],'DataDo':[1,5],'Nazwany':[1,5],'Nienazwany':[1,5],'Aktywne':[1,5]}
    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Funkcja,klucze)
    if Lista<>'':
        stat='Uwaga : wywoanie funkcji fs_kontrahenci_kuke z numerem '+str(Fun)+' bez parametrw: '+Lista

if stat=='OK':
    if Funkcja in [1,5]:
        Kontrahent = klucze['Kontrahent']
        DataOd = klucze['DataOd']
        DataDo = klucze['DataDo']
        Nazwany = klucze['Nazwany']
        Nienazwany = klucze['Nienazwany']
        Wszystkie = klucze['Wszystkie']
        Aktywne = klucze['Aktywne']
    
dane = []
wyn1 = []
wyn2 = []

UprDel=((self.oddzial_id,'131014') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID


#-------------------------------------------------------------------------------
#-------- SPRAWDZANIE POPRAWNOSCI DANYCH
#-------------------------------------------------------------------------------

if stat=='OK' and DataOd.replace("'",'')<>'    -  -  ':
    dane_wyn = rsglobal.SprawdzCzyToData(DataOd.replace("'",''))  
    if not dane_wyn:
        stat = "BL DATAOD"
if stat=='OK' and DataDo.replace("'",'')<>'    -  -  ':
    dane_wyn = rsglobal.SprawdzCzyToData(DataDo.replace("'",''))  
    if not dane_wyn:
        stat = "BL DATADO"
        
        
#-------------------------------------------------------------------------------
#-------- EDYCJA GRIDA EDYTOWALNEGO (1)
#-------------------------------------------------------------------------------

Delete = []

if stat=='OK' and Funkcja == 1:
    Delete=klucze['Delete']
    

#-------------------------------------------------------------------------------
#-------  SPRAWDZANIE DELETE  --------------------------------------------------
#-------------------------------------------------------------------------------

if Funkcja == 1 and stat=="OK":
    if len(Delete[0])>0:
        if not UprDel:
            stat='BR UPR DEL'
            dane.append(stat)
                
        # wykonanie DELETE 
        if stat == 'OK':
            SQLDEL = ''
            SQLFU = ''
            for i in xrange(len(Delete[0])):
                SQLFU ="SELECT kontrahent_id FROM rs_kontrahenci_kuke"
                SQLFU+=" WHERE firma_id='"+self.firma_id+"'"
                DELETE = "DELETE FROM rs_kontrahenci_kuke "
                WHERE = "WHERE firma_id='"+self.firma_id+"'"
                for j in xrange(len(Delete[0][i])):
                    pole = Delete[1][j]
                    wart = Delete[0][i][j]
                    if pole in ('kontrahent_id','data_od','data_do'):  
                        WHERE += " AND "+pole+"='"+wart+"'"
                        SQLFU += " AND "+pole+"='"+wart+"'"
                    elif pole in ('nazwany','prywatny'):
                        WHERE += " AND "+pole+"="+str(wart)
                        SQLFU += " AND "+pole+"="+str(wart)
                
                SQLDEL += DELETE+WHERE+"; "
                SQLFU += " FOR UPDATE NOWAIT; "
                
            if stat == "OK" and SQLFU <> '':
                stat,d,dump,dump = self.PolSQL.Execute(rsglobal.Dekoduj(SQLFU),3)
                if stat <> 'OK':
                    stat = 'Bd sprawdzenia danych do usunicia: '+stat
                    dane.append(stat)

            if stat == "OK" and SQLDEL <> '':
                stat,dump,dump,dump = self.PolSQL.Execute(rsglobal.Dekoduj(SQLDEL),1)
                if stat <> 'OK':
                    stat = "Bd przy usuwaniu danych: "+stat   
                    dane.append(stat)


#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (1 -delete, 5 - pobieranie danych) 
#-------------------------------------------------------------------------------

if Funkcja in [1,5] and stat=='OK':
    Dzis = rsglobal.PodajDzis()
    SQL= "SELECT kk.kontrahent_id,k.nazwa,kk.data_od,"
    SQL+="kk.data_do,kk.data_przerwania,kk.karencja_do,"
    SQL+="kk.kwota,kk.kwota_wal,kk.waluta,"
    SQL+="kk.kurs,kk.nazwany,kk.prywatny"
    SQL+=" FROM rs_kontrahenci_kuke kk"
    SQL+=" INNER JOIN rs_kontrahenci k USING (firma_id,kontrahent_id) "
    SQL+="WHERE kk.firma_id='"+self.firma_id+"' "
    if Kontrahent<>'':
        SQL+=" AND kk.kontrahent_id LIKE'"+Kontrahent.strip().replace('"','').replace("'",'')+"%'"
    if DataOd<>'    -  -  ':
        SQL+=" AND kk.data_od>='"+DataOd+"'"
    if DataDo<>'    -  -  ':
        SQL+=" AND kk.data_do<='"+DataDo+"'"
    if Nazwany:
        SQL+=" AND kk.nazwany"
    if Nienazwany:
        SQL+=" AND NOT kk.nazwany"
    if Aktywne:
        SQL+=" AND kk.data_do>='"+Dzis+"' AND (kk.data_przerwania >'"+Dzis+"' OR kk.karencja_do<'"+Dzis+"' OR kk.data_przerwania is Null)"
    SQL+=" ORDER BY kk.kontrahent_id,kk.data_od,kk.data_do"
    stat,dane,dump,dump = self.PolSQL.Execute(SQL,3)
    if stat <> 'OK':
        stat = 'Bd przy pobietaniu danych: '+stat
        dane.append(stat)
