#!/usr/bin/python
# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        RSKontrahenciKukeDane.py
# Purpose:     dodawanie i edycja w ubezpieczeniach KUKE 
# Author:      Konrad Opieka
# Created:     2014-05-07
# RCS-ID:      $Id: RSKontrahenciKukeDane.py $
# Copyright:   (c) 2014 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

stat='OK'
if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=='OK':
    Funkcja = klucze['Funkcja']
    
    SlPar={'Kontrahent':[1,2,3,4,5],'DataOd':[1,2,3,4,5],'DataDo':[1,2,3,4,5],'Nazwany':[1,2,3,4,5],'Prywatny':[1,2,3,4,5]}
    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Funkcja,klucze)
    if Lista<>'':
        stat='Uwaga : wywoanie funkcji fs_kontrahenci_kuke_dane z numerem '+str(Fun)+' bez parametrw: '+Lista

if stat=='OK':
    Kontrahent=klucze['Kontrahent']
    DataOd=klucze['DataOd']
    DataDo=klucze['DataDo']
    Nazwany=klucze['Nazwany']
    Prywatny=klucze['Prywatny']

    KontrahentTmp=''
    DataOdTmp=''
    DataDoTmp=''
    NazwanyTmp=''
    PrywatnyTmp=''

#w celach informacyjno rozeznaniowych
Pola=pola
Wartosci=wartosci
dane=[]
wyn1=[]
wyn2=[]

UprIns=((self.oddzial_id,'131013') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID
UprUpd=((self.oddzial_id,'131012') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID or UprIns


#-------------------------------------------------------------------------------
#---   Sprawdzam dane
#-------------------------------------------------------------------------------

if stat=='OK' and UprUpd:
    if Funkcja in [1,2,3,4] and stat=='OK':
        KON="'"+Kontrahent+"'"
        DOD="'"+DataOd+"'"
        DDO="'"+DataDo+"'"
        WAL=''
        PRZER='    -  -  '
        KAREN='    -  -  '
        KURS=''
        KWOTA=''
        KWOTAWAL=''
        SQLNOT=''
        
        for i in range(len(Pola)):
            pole = Pola[i]
            wart = Wartosci[i]
            if pole=='kontrahent_id':
                KON="'"+wart+"'"
            if pole=='data_od':
                DOD="'"+str(wart)+"'"
            if pole =='data_do':
                DDO="'"+str(wart)+"'"
            if pole =='waluta':
                WAL="'"+wart+"'"
            if pole =='data_przerwania':
                PRZER="'"+str(wart)+"'"
            if pole=='karencja_do':
                KAREN="'"+str(wart)+"'"
            if pole=='kurs':
                KURS=str(wart)
            if pole=='kwota':
                KWOTA=str(wart)
            if pole=='kwota_wal':
                KWOTAWAL=str(wart)
        
        WHERE =" WHERE firma_id='"+self.firma_id+"' AND kontrahent_id="+KON
        if Funkcja in [3,4]:
            SQLNOT =" AND NOT (firma_id='"+self.firma_id+"' AND kontrahent_id='"+Kontrahent+"'"
            SQLNOT+=" AND data_od='"+DataOd+"' AND data_do='"+DataDo+"' AND nazwany="+str(Nazwany)+" AND prywatny="+str(Prywatny)+")"
                
        #sprawdzenie czy kurs, krowa i kwota_wal wiksze od 0
        if KWOTA<>''and KWOTA<=0:
            dane.append('ZL KWOTA')
        if KWOTAWAL<>'' and KWOTAWAL<=0:
            dane.append('ZL KWOTAWAL')
        if KURS<>'' and KURS<=0:
            dane.append('ZL KURS')
            
        #sprawdzanie czy data poprawna
        if stat=='OK':
            dane_wyn = rsglobal.SprawdzCzyToData(DOD.replace("'",''))  
            if not dane_wyn:
                stat = "BL ZLDOD"
        if stat=='OK':
            dane_wyn = rsglobal.SprawdzCzyToData(DDO.replace("'",''))  
            if not dane_wyn:
                stat = "BL ZLDDO"
        if stat=='OK' and PRZER.replace("'",'')<>'    -  -  ':
            dane_wyn = rsglobal.SprawdzCzyToData(PRZER.replace("'",''))  
            if not dane_wyn:
                stat = "BL ZLPRZER"
        if stat=='OK' and KAREN.replace("'",'')<>'    -  -  ':
            dane_wyn = rsglobal.SprawdzCzyToData(KAREN.replace("'",''))  
            if not dane_wyn:
                stat = "BL ZLKAREN"
        if stat=='OK'and DOD > DDO:
            dane.append('ZL DODDDO')
            
        #skladanie zapytania o kontrahenta
        if stat=='OK':
            SQL="SELECT kontrahent_id FROM rs_kontrahenci "+WHERE
            stat,kon,dump,dump = self.PolSQL.Execute(SQL,3)
            if stat <> 'OK':
                stat = 'BL KON'
                dane.append(stat)
            elif len(kon)==0:
                dane.append('BR KON')
            
        #skadanie zapytanie czy waluta istnieje
        if stat=='OK' and WAL<>'':
            SQL="SELECT kod FROM rs_waluty WHERE firma_id='"+self.firma_id+"'"
            SQL+=" AND kod="+WAL
            stat,wal,dump,dump = self.PolSQL.Execute(SQL,3)
            if stat <> 'OK':
                stat = 'BL WAL'
                dane.append(stat)
            elif len(wal)==0:
                dane.append('ZL WAL')
        
        #sprawdzanie czy data przerwania w przedziale dat
        if stat=='OK' and PRZER.replace("'",'')<>'    -  -  ':
            if not (DOD <= PRZER and DDO >= PRZER):
                dane.append('ZL PRZER')
                
        #sprawdzanie czy data karencji nie jest przed rozpoczeciem
        if stat=='OK' and KAREN.replace("'",'')<>'    -  -  ':
            if not DOD <= KAREN:
                dane.append('ZL KAREN')
        
        #skladanie zapytania o to czy data od nie jest pomiedzy uzytymi datami
        if stat=='OK':
            SQL="SELECT data_od FROM rs_kontrahenci_kuke"
            SQL+=WHERE+" AND nazwany="+str(Nazwany)+" AND prywatny="+str(Prywatny)+" AND data_od < "+DOD+" AND data_do > "+DOD
            SQL+=SQLNOT
            stat,dod,dump,dump = self.PolSQL.Execute(SQL,3)
            if stat <> 'OK':
                stat = 'BL DOD'
                dane.append(stat)
            elif len(dod)<>0:
                dane.append('ZL DOD')
        
        #skladanie zapytania o to czy data do nie jest pomiedzy uzytymi datami
        if stat=='OK':
            SQL="SELECT data_od FROM rs_kontrahenci_kuke"
            SQL+=WHERE+" AND nazwany="+str(Nazwany)+" AND prywatny="+str(Prywatny)+" AND data_od < "+DDO+" AND data_do > "+DDO
            SQL+=SQLNOT
            stat,ddo,dump,dump = self.PolSQL.Execute(SQL,3)
            if stat <> 'OK':
                stat = 'BL DDO'
                dane.append(stat)
            elif len(ddo)<>0:
                dane.append('ZL DDO')
                
        #skladanie zapytania o to czy podane daty nie beda mialy w zakresie uzytych dat
        if stat=='OK':
            SQL="SELECT data_od FROM rs_kontrahenci_kuke"
            SQL+=WHERE+" AND nazwany="+str(Nazwany)+" AND prywatny="+str(Prywatny)+" AND data_od >= "+DOD+" AND data_do <= "+DDO
            SQL+=SQLNOT
            stat,ddd,dump,dump = self.PolSQL.Execute(SQL,3)
            if stat <> 'OK':
                stat = 'BL DDD'
                dane.append(stat)
            elif len(ddd)<>0:
                dane.append('ZL DDD')
        
        if stat=='OK':   
            if len(dane) > 0:
                stat = dane[0]
        
            
#-------------------------------------------------------------------------------
#---   INSERT DANYCH (2- bez pobierania,1- z pobieraniem)
#-------------------------------------------------------------------------------

if stat == "OK" and Funkcja in [2,1]:
    SQL ="INSERT INTO rs_kontrahenci_kuke "
    SQLP="firma_id,kontrahent_id,data_od,data_do,nazwany,prywatny"
    SQLW="'"+self.firma_id+"','"+Kontrahent+"','"+DataOd+"','"+DataDo+"',"+str(Nazwany)+","+str(Prywatny)
    for i in range(len(Pola)):
        pole = Pola[i]
        wart = Wartosci[i]
        if pole in ['kurs','kwota','kwota_wal']:
            SQLP+= ","+pole
            SQLW+= ","+str(wart)
        elif pole in ['data_przerwania','karencja_do']:
            SQLP+= ","+pole
            if wart=='    -  -  ':
                SQLW+= ",NULL"
            else:
                SQLW+= ",'"+str(wart)+"'"
        elif pole in ['waluta']:
            SQLP+= ","+pole
            SQLW+= ",'"+wart+"'"
    SQL+= " ("+SQLP+") VALUES ("+SQLW+");"
    if stat == 'OK':        
        stat,d,dump,dump = self.PolSQL.Execute(SQL,1)
        if stat <> 'OK':
            stat = 'BL INSERT'
            dane.append(stat)
        

#-------------------------------------------------------------------------------
#---   UPDATE DANYCH (4- bez pobierania,3- z pobieraniem)
#-------------------------------------------------------------------------------

if stat == "OK" and Funkcja in [3,4]:
    dane = []  
    SQL = "UPDATE rs_kontrahenci_kuke SET "
    Filtr = "firma_id='"+self.firma_id+"' AND kontrahent_id='"+Kontrahent+"'"
    Filtr+= " AND data_od='"+DataOd+"' AND data_do='"+DataDo+"' AND nazwany="+str(Nazwany)+" AND prywatny="+str(Prywatny)
    for i in range(len(Pola)):
        wart = Wartosci[i]
        pole = Pola[i]
        if pole in ['kurs','kwota','kwota_wal','nazwany','prywatny']:
            SQL+= pole+"="+str(wart)+","
        elif pole in ['data_od','data_do','data_przerwania','karencja_do']:
            SQL+=pole+"="
            if wart=='    -  -  ':
                SQL+= "NULL,"
            else:
                SQL+= "'"+str(wart)+"',"
        elif pole in ['kontrahent_id','waluta']:
            SQL+= pole+"='"+wart+"',"
            
        if pole =='kontrahent_id':
            KontrahentTmp=wart
        if pole =='data_od':
            DataOdTmp=wart
        if pole =='data_do':
            DataDoTmp=wart
        if pole =='nazwany':
            NazwanyTmp=wart   
        if pole =='prywatny':
            PrywatnyTmp=wart
            
    SQL = SQL.strip(',')
    SQL += " WHERE "+Filtr+";"  
    stat,dump,dump,dump = self.PolSQL.Execute(SQL ,1)
    if stat != 'OK':
        stat = 'BL_SQL'
        dane.append(stat)
    else:
        if KontrahentTmp <> '':
            Kontrahent = KontrahentTmp
        if DataOdTmp <> '':
            DataOd = DataOdTmp
        if DataDoTmp <> '':
            DataDo = DataDoTmp
        if NazwanyTmp <> '':
            Nazwany = NazwanyTmp
        if PrywatnyTmp <> '':
            Prywatny = PrywatnyTmp


#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (5 -select, 3 -update z pobraniem, 1 -insert z pobraniem)
#-------------------------------------------------------------------------------

if stat == "OK" and Funkcja in [5,3,1]:
    dane = []
    SQL ="SELECT * FROM rs_kontrahenci_kuke "
    SQL+="WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+Kontrahent+"' "
    SQL+="AND data_od='"+DataOd+"' AND data_do='"+DataDo+"' AND nazwany="+str(Nazwany)+" AND prywatny="+str(Prywatny)+";"
    stat,dane,wyn1,tr = self.PolSQL.Execute(SQL,3)
    if stat=='OK':
        tr = rssql.RSTableRowset(dane,wyn1)
        wyn2=[]
        if ((self.oddzial_id,'012010') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
            SQL = "SELECT nazwa FROM rs_kontrahenci WHERE firma_id = '"+self.firma_id+"' "
            SQL+= "AND kontrahent_id = '"+Kontrahent+"' "
            st,d,dump,dump=self.PolSQL.Execute(SQL,3)
            if len(d) == 0:
                wyn2.append('')
            else:
                wyn2.append(d[0][0])
        else:
            wyn2.append('Brak uprawnie do przegldania kontrahentw. Poinformuj administratora.')
            
        if ((self.oddzial_id,'011130') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
            SQL = "SELECT opis FROM rs_waluty WHERE firma_id = '"+self.firma_id+"' "
            SQL+= "AND kod= '"+tr.GetVal(0,"waluta")+"' "
            st,d,dump,dump=self.PolSQL.Execute(SQL,3)
            if len(d) == 0:
                wyn2.append('')
            else:
                wyn2.append(d[0][0])
        else:
            wyn2.append('Brak uprawnie do przegldania walut. Poinformuj administratora.')
    