# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_kontrahenci_notatki.py
# Purpose:     grid z notatkami kontrahenta
# Author:      Micha Raburski
# Created:     2012/04/24
# RCS-ID:      $Id: fs_kontrahenci_notatki.py $
# Copyright:   (c) 2012 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

dane = []
wyn1 = []
wyn2 = []
stat = 'OK'
Fun=-1

if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=='OK':
    Fun = klucze['Funkcja']
    
    SlPar={'Kontrahent':[1,2,3,5,6],'OperatorF':[1,2,3,5,6],'DataOd':[1,2,3,5,6],'DataDo':[1,2,3,5,6],
    'Aktywne':[1,2,3,5,6],'Czas':[2,3,6],'Operator':[2,3,6],'Tresc':[2]}    
    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Fun,klucze)
    if Lista<>'':
        stat='Uwaga : wywoanie funkcji fs_kontrahenci_notatki z numerem '+str(Fun)+' bez parametrw: '+Lista

if stat=='OK':
    if Fun in [1,2,3,5,6]:
        OpBuf=str(klucze['OperatorF'])
        FOper = ''
        for znak in OpBuf:
            if znak in ['0','1','2','3','4','5','6','7','8','9']:
                FOper+=znak
        Kontr = klucze['Kontrahent']
        FDataOd = rsglobal.Dekoduj(klucze['DataOd'])
        FDataDo = rsglobal.Dekoduj(klucze['DataDo'])
        FAktywne = klucze['Aktywne']
        
    if Fun in [2,3,6]:
        # usuwanie,edycja i archiwizacja
        Czas = rsglobal.Dekoduj(klucze['Czas'])
        Operator = rsglobal.Dekoduj(klucze['Operator'])
        
        
    # edycja
    if Fun==2:
        Tresc=rsglobal.Dekoduj(klucze['Tresc'])
    
    
    UprDodawanie = ((self.oddzial_id,'012133') in self.uprawnienia or self.operator_id == STANDARD_OPERATOR_ID)
    UprEdycja = ((self.oddzial_id,'012132') in self.uprawnienia or self.operator_id == STANDARD_OPERATOR_ID) or UprDodawanie
    UprUsuwanie = ((self.oddzial_id,'012134') in self.uprawnienia or self.operator_id == STANDARD_OPERATOR_ID)
    UprArchiwizacja = ((self.oddzial_id,'012135') in self.uprawnienia or self.operator_id == STANDARD_OPERATOR_ID)


#-------------------------------------------------------------------------------
#--- SPRAWDZENIE DAT W FILTRZE - 1,5
#-------------------------------------------------------------------------------

if stat=='OK' and Fun in [1,2,3,5,6]:
    if FDataOd <> '    -  -  ':
        if not rsglobal.SprawdzCzyToData(FDataOd):
            stat='Bdna data od w filtrze'
            dane.append(stat)  
            
    if FDataDo <> '    -  -  ':
        if not rsglobal.SprawdzCzyToData(FDataDo):
            stat='Bdna data do w filtrze'
            dane.append(stat)  


#-------------------------------------------------------------------------------
#--- INSERT - 1
#-------------------------------------------------------------------------------
            
if stat=='OK' and Fun==1:
    if not UprDodawanie:
        stat = 'Brak uprawnie do dodawania notatek dla kontrahenta.'
    
    if stat=='OK':
        # pobranie czasu w celu podania do klucza
        stat,DTeraz,dump,dump = self.PolSQL.Execute("SELECT now()::TEXT;", 3)
        Czas=DTeraz[0][0].split('.')[0]
        if stat<>'OK':
            stat='Bd pobierania aktualnego czasu :'+stat
    
    if stat=='OK':
        SQL="INSERT INTO rs_kontrahenci_notatki (firma_id,kontrahent_id,operator_id,data_i_godzina,notatka) "
        SQL+=" VALUES('"+self.firma_id+"','"+Kontr+"',"+str(self.operator_id)+",'"+str(Czas)+"','')"
        stat,dump,dump,dump = self.PolSQL.Execute(SQL, 1)
        if stat <> 'OK':
            stat='Bd wstawiania notatki dla kontrahenta : '+stat
        else:
            wyn2=[Kontr,Czas]

#-------------------------------------------------------------------------------
#--- EDYCJA NOTATKI - 2
#-------------------------------------------------------------------------------

if stat=='OK' and Fun==2:
    if not UprEdycja:
        stat = 'Brak uprawnie do edycji notatki kontrahenta.'

    if stat == 'OK':
        SQL ="UPDATE rs_kontrahenci_notatki SET notatka='"+Tresc+"' WHERE firma_id='"+self.firma_id+"'"
        SQL+=" AND kontrahent_id='"+str(Kontr)+"' AND data_i_godzina='"+Czas+"'"
        SQL+=" AND operator_id="+str(Operator)+"; "
        
        stat,dump,dump,dump = self.PolSQL.Execute(SQL, 1)
        if stat <> 'OK':
            stat='Bd edycji notatki kontrahenta : '+stat


#-------------------------------------------------------------------------------
#--- AKTYWACJA/DEAKTYWACJA NOTATKI - 3
#-------------------------------------------------------------------------------

if stat=='OK' and Fun==3:
    if not UprArchiwizacja:
        stat = 'Brak uprawnie do aktywacji/deaktywacji notatki kontrahenta.'

    if stat == 'OK':
        SQL ="UPDATE rs_kontrahenci_notatki SET aktywna=NOT aktywna WHERE firma_id='"+self.firma_id+"'"
        SQL+=" AND kontrahent_id='"+str(Kontr)+"' AND data_i_godzina='"+Czas+"'"
        SQL+=" AND operator_id="+str(Operator)+"; "
        
        stat,dump,dump,dump = self.PolSQL.Execute(SQL, 1)
        if stat <> 'OK':
            stat='Bd aktywacji/deaktywacji notatki kontrahenta : '+stat

            
#-------------------------------------------------------------------------------
#--- DELETE - 6
#-------------------------------------------------------------------------------

if stat=='OK' and Fun==6:
    if not UprUsuwanie:
        stat = 'Brak uprawnie do usuwania notatki kontrahenta.'

    if stat == 'OK':
        SQL ="DELETE FROM rs_kontrahenci_notatki WHERE firma_id='"+self.firma_id+"'"
        SQL+=" AND kontrahent_id='"+str(Kontr)+"' AND data_i_godzina='"+Czas+"'"
        SQL+=" AND operator_id="+str(Operator)+"; "
        
        stat,dump,dump,dump = self.PolSQL.Execute(SQL, 1)
        if stat <> 'OK':
            stat='Bd usuwania notatki kontrahenta : '+stat



#-------------------------------------------------------------------------------
#---- SELECT - 1,2,3,5,6  Pobieranie listy notatek
#-------------------------------------------------------------------------------

if stat=='OK' and Fun in [1,2,3,5,6]:
    SQL="SELECT kn.data_i_godzina,kn.operator_id||' - '||o.login,kn.notatka,kn.aktywna"
    SQL+=" FROM rs_kontrahenci_notatki kn "
    SQL+=" LEFT OUTER JOIN rs_operatorzy o USING (operator_id) "
    SQL+=" WHERE kn.firma_id='"+self.firma_id+"' AND kn.kontrahent_id='"+Kontr+"'"
    if FOper <> '':
        SQL+=" AND o.operator_id="+FOper
    if FDataOd <> '    -  -  ':
        SQL+=" AND kn.data_i_godzina>='"+FDataOd+"'"
    if FDataDo <> '    -  -  ':
        SQL+=" AND kn.data_i_godzina<='"+FDataDo+"'"
    if FAktywne:
        SQL+=" AND kn.aktywna"
    SQL+=" ORDER BY data_i_godzina DESC;"

    stat,dane,wyn1,dump =self.PolSQL.Execute(SQL, 3)
    if stat <> 'OK':
        stat='Bd pobrania listy notatek kontrahenta : '+stat
        
    # jeli si udao to pobieramy te dane kontrahenta
    if stat=='OK':
        SQL="SELECT TRIM(TRIM(COALESCE(adr_ulica,'')||' '||COALESCE(adr_nry,''))||TRIM(', '||"
        SQL+="COALESCE(adr_kod,'')||' '||COALESCE(adr_miej,'')),' ,'),"
        SQL+="TRIM(COALESCE(tel1,'')||','||COALESCE(tel2,''),', '),COALESCE(TRIM(nip),''),"
        SQL+="COALESCE((SELECT TRIM(kod||' - '||opis) FROM rs_sposoby_zaplaty WHERE firma_id='"+self.firma_id+"' "
        SQL+=" AND kod=TRIM(rsf_podaj_pole_z_danych_do_fakturowania('"+self.firma_id+"',kontrahent_id,current_date,'spos_zaplaty'))),''),"
        SQL+="rsf_podaj_pole_z_danych_do_fakturowania('"+self.firma_id+"',kontrahent_id,current_date,'dni')"
        SQL+=" FROM rs_kontrahenci WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+Kontr+"';"
        stat,wyn2,dump,dump =self.PolSQL.Execute(SQL, 3)      