# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_kontrahenci_opiekunowie.py
# Purpose:     obsluga grida z opiekunami kontrahentw
# Author:      Pawe Wjcikowski
# Created:     2010/09/02
# RCS-ID:      $Id: fs_kontrahenci_opiekunowie.py $
# Copyright:   (c) 2010 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

Kontrahent = rsglobal.Dekoduj(klucze[0])
Operator = rsglobal.Dekoduj(klucze[1])
Fun = klucze[-1]
dane = []
wyn1 = []
wyn2 = []
stat = 'OK'
odd=''

if str(Operator)[-2:]=='.0':
    Operator=str(Operator)[0:-2]

UprDodawanie = ((self.oddzial_id,'012113') in self.uprawnienia or self.operator_id == STANDARD_OPERATOR_ID)
UprEdycja = ((self.oddzial_id,'012112') in self.uprawnienia or self.operator_id == STANDARD_OPERATOR_ID) or UprDodawanie
UprUsuwanie = ((self.oddzial_id,'012114') in self.uprawnienia or self.operator_id == STANDARD_OPERATOR_ID)

Insert = []
Update = []
Delete = []
        
if Fun == 1:
    Update=klucze[-2]
    Insert=klucze[-3]
    Delete=klucze[-4]  
        
        
#-------------------------------------------------------------------------------
#---   POBRANIE OPERATORA (7)
#-------------------------------------------------------------------------------

if Fun == 7 and stat=="OK":
    if int(Operator)>9999 or int(Operator)<0:
        stat='Id operatora musi zawiera si w przedziale 0-9999' 
        dane.append(stat)  
    else:    
        SELECT =" SELECT imie,nazwisko FROM rs_operatorzy WHERE operator_id = '"+str(Operator)+"'; "
        stat,dane,wyn1,dump =self.PolSQL.Execute(SELECT, 3)    
        if stat <> 'OK':
            stat='Bd pobrania danych operatora : '+stat                  


#-------------------------------------------------------------------------------
#---   POBRANIE DOMYSLNEGO ODDZIALU (8)
#-------------------------------------------------------------------------------

if Fun == 8 and stat=="OK":
    if int(Operator)>9999 or int(Operator)<0:
        stat='Id operatora musi zawiera si w przedziale 0-9999' 
        dane.append(stat)  
    else:     
        SELECT =" SELECT generator_oddzial_id FROM rs_operatorzy WHERE operator_id = '"+str(Operator)+"'; "
        stat,dane,wyn1,dump =self.PolSQL.Execute(SELECT, 3)    
        if stat <> 'OK':
            stat='Bd pobrania danych o domylnym oddziale : '+stat

                      
#-------------------------------------------------------------------------------
#---   UPDATE DANYCH (1)
#-------------------------------------------------------------------------------

if Fun == 1 and stat=="OK":
    if len(Update[0])>0:
        if not UprEdycja:
            stat='Brak uprawnie do edycji danych'
            dane.append(stat)  
                  
        if stat == 'OK':
            WierszeNr = Update[-1]
            for i in xrange(len(Update[0])):                
                for j in xrange(len(Update[0][i])): 
                    pole = Update[0][i][j]
                    wart = Update[1][i][j]
                    if pole == 'oddzial_id':
                        wart=str(wart).strip()
                        if wart == '':
                            stat = 'BR ODDZ'
                            wyn2.append((WierszeNr[i],0))
                            dane.append(stat)
                        else:
                            sql ="SELECT oddzial_id FROM rs_oddzialy"
                            sql+=" WHERE firma_id = '"+self.firma_id+"'"
                            sql+=" AND oddzial_id = '"+str(wart)+"';" 
                            st,d,dump,dump = self.PolSQL.Execute(sql,3)
                            if st <> 'OK':
                                stat = 'Bd pobrania danych oddziau '
                                wyn2.append((WierszeNr[i],0))
                                dane.append(stat)
                            elif len(d) == 0:
                                stat = 'BL ODDZ'
                                wyn2.append((WierszeNr[i],0))
                                dane.append(stat) 
                            else:
                                odd = d[0][0]             

                    elif pole == 'opiekun_id':
                        wart=str(wart).strip()
                        if wart == '':
                            stat = 'BR OP'
                            wyn2.append((WierszeNr[i],1))
                            dane.append(stat)
                        elif wart in ('0','0.0'):
                            stat = 'Operator anakonda (id 0) nie moe by opiekunem adnego klienta'
                            wyn2.append((WierszeNr[i],1))
                            dane.append(stat)
                        else:
                            if str(wart)[-2:]=='.0':
                                wart=str(wart)[0:-2]
                            if int(wart)>9999 or int(wart)<0:
                                stat='Id operatora musi zawiera si w przedziale 0-9999' 
                                dane.append(stat)                                   
                            else:    
                                sql ="SELECT operator_id,aktywny FROM rs_operatorzy"
                                sql+=" WHERE operator_id = '"+str(wart)+"';" 
                                st,d,dump,dump = self.PolSQL.Execute(sql,3)                                
                                if st <> 'OK':
                                    stat = 'Bd pobrania danych operatora '
                                    wyn2.append((WierszeNr[i],1))
                                    dane.append(stat)
                                elif len(d) == 0:
                                    stat = 'BL OP'
                                    wyn2.append((WierszeNr[i],1))
                                    dane.append(stat) 
                                elif d[0][1]==False:
                                    stat = "Operator z id : "+str(wart)+" jest nieaktywny"
                                    wyn2.append((WierszeNr[i],1))
                                    dane.append(stat) 
                                elif odd<>'':
                                    sql ="SELECT oddzial_id FROM rs_kontrahenci_opiekunowie"
                                    sql+=" WHERE kontrahent_id='"+str(Kontrahent)+"' AND opiekun_id = '"+str(wart)+"' AND oddzial_id = '"+str(odd)+"';" 
                                    st,d,dump,dump = self.PolSQL.Execute(sql,3)                                
                                    if st <> 'OK':
                                        stat = 'Bd przy sprawdzaniu danych operatora '
                                        wyn2.append((WierszeNr[i],1))
                                        dane.append(stat)
                                    elif len(d) <> 0:
                                        stat = "Operator z id : "+str(wart)+" jest ju zdefiniowany"
                                        wyn2.append((WierszeNr[i],1))
                                        dane.append(stat)                                          
                                                     
        if stat == 'OK':
            if len(dane) > 0:
                stat = dane[0]
                                                                    
        if stat=='OK':
            sql=''        
            for i in xrange(len(Update[0])):   
                UPDATE="UPDATE rs_kontrahenci_opiekunowie "
                SET='SET '
                for j in xrange(len(Update[0][i])): 
                    pole=Update[0][i][j]
                    wart=Update[1][i][j]
                    if pole in ['oddzial_id']:
                        if str(wart) =='':
                            SET+=pole+"=NULL,"
                        else:
                            SET+=pole+"='"+str(wart)+"',"
                    elif pole in ['opiekun_id']:
                        if str(wart)[-2:] =='.0':
                            SET+=pole+"='"+str(wart)[0:-2]+"',"
                        else:
                            SET+=pole+"='"+str(wart)+"',"
                SET=SET.strip(",")
                WHERE=" WHERE firma_id='"+self.firma_id+"' AND kontrahent_id ='"+str(Kontrahent)+"'"
                for j in xrange(len(Update[2][i])): # petla po kluczu
                    pole=Update[3][j]
                    wart=rsglobal.Dekoduj(Update[2][i][j])
                    WHERE+=" AND "+pole+"='"+str(wart)+"'"
                WHERE+=";" 
                if str(SET)=='SET ':
                    pass
                else:
                    sql+=UPDATE+SET+WHERE;
                if sql<>'':                                 
                    stat,dump,dump,dump=self.PolSQL.Execute(rsglobal.Dekoduj(sql),1)   
                    if stat<>'OK':
                        stat=u"Bd przy modyfikowaniu danych: "+stat   
                        dane.append(stat)  


#-------------------------------------------------------------------------------
#-------   DELETE  (1)
#-------------------------------------------------------------------------------

if Fun == 1 and stat=="OK":
    if len(Delete[0])>0:
        if not UprUsuwanie:
            stat='Brak uprawnie do usuwania danych'
            dane.append(stat)    
                       
        if stat=='OK':
            sql=''
            for i in xrange(len(Delete[0])):
                DELETE="DELETE FROM rs_kontrahenci_opiekunowie "
                WHERE="WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+str(Kontrahent)+"'"
                for j in xrange(len(Delete[0][i])):
                    pole=Delete[1][j]
                    wart=Delete[0][i][j]
                    if pole in ['oddzial_id']:
                        WHERE+=" AND "+pole+"='"+str(wart)+"'"
                    elif pole in ['opiekun_id']:
                        if str(wart)[-2:]=='.0':
                            WHERE+=" AND "+pole+"='"+str(wart)[0:-2]+"'"
                        else:
                            WHERE+=" AND "+pole+"='"+str(wart)+"'"
                sql+=DELETE+WHERE+";"
            if sql<>'': 
                stat,dump,dump,dump=self.PolSQL.Execute(rsglobal.Dekoduj(sql),1)
            if stat<>'OK':
                stat=u"Bd przy usuwaniu danych: "+stat   
                dane.append(stat)  

                                    
#-------------------------------------------------------------------------------
#--------- INSERT (1)
#-------------------------------------------------------------------------------

if Fun == 1 and stat=="OK":
    if len(Insert[0])>0:
        if not UprDodawanie:
            stat='Brak uprawnie do dodawania danych'
            dane.append(stat)
            
        if stat=='OK':        
            Insert=klucze[-3]
            WierszeNr = Insert[-1]        
            for i in xrange(len(Insert[0])):
                for j in xrange(len(Insert[0][i])): 
                    pole=Insert[1][j]
                    wart=Insert[0][i][j]
                    if pole == 'oddzial_id':
                        wart=str(wart).strip()
                        if wart == '':
                            stat = 'BR ODDZ'
                            wyn2.append((WierszeNr[i],0))
                            dane.append(stat)
                        else:

                            sql ="SELECT oddzial_id FROM rs_oddzialy"
                            sql+=" WHERE firma_id = '"+self.firma_id+"'"
                            sql+=" AND oddzial_id = '"+str(wart)+"';" 
                            st,d,dump,dump = self.PolSQL.Execute(sql,3)
                            if st <> 'OK':
                                stat = 'Bd pobrania danych oddziau '
                                wyn2.append((WierszeNr[i],0))
                                dane.append(stat)
                            elif len(d) == 0:
                                stat = 'BL ODDZ'
                                wyn2.append((WierszeNr[i],0))
                                dane.append(stat)   
                            else:
                                odd=d[0][0] 
                                              
                    elif pole == 'opiekun_id':
                        wart=str(wart).strip()
                        if wart == '':
                            stat = 'BR OP'
                            wyn2.append((WierszeNr[i],1))
                            dane.append(stat)
                        elif wart in ('0','0.0'):
                            stat = 'Operator anakonda (id 0) nie moe by opiekunem adnego klienta'
                            wyn2.append((WierszeNr[i],1))
                            dane.append(stat)
                        else:
                            if str(wart)[-2:]=='.0':
                                wart=str(wart)[0:-2]
                            if int(wart)>9999 or int(wart)<0:
                                stat='Id operatora musi zawiera si w przedziale 0-9999' 
                                dane.append(stat)                                                                   
                            else:  
                                sql ="SELECT operator_id,aktywny FROM rs_operatorzy"
                                sql+=" WHERE operator_id = '"+str(wart)+"';" 
                                st,d,dump,dump = self.PolSQL.Execute(sql,3)                                
                                if st <> 'OK':
                                    stat = 'Bd pobrania danych operatora '
                                    wyn2.append((WierszeNr[i],1))
                                    dane.append(stat)
                                elif len(d) == 0:
                                    stat = 'BL OP'
                                    wyn2.append((WierszeNr[i],1))
                                    dane.append(stat)  
                                elif d[0][1]==False:
                                    stat = "Operator z id : "+str(wart)+" jest nieaktywny"
                                    wyn2.append((WierszeNr[i],1))
                                    dane.append(stat)                                
                                elif odd<>'':
                                    sql ="SELECT oddzial_id FROM rs_kontrahenci_opiekunowie"
                                    sql+=" WHERE kontrahent_id='"+str(Kontrahent)+"' AND opiekun_id = '"+str(wart)+"' AND oddzial_id = '"+str(odd)+"';" 
                                    st,d,dump,dump = self.PolSQL.Execute(sql,3)                                
                                    if st <> 'OK':
                                        stat = 'Bd przy sprawdzaniu danych operatora '
                                        wyn2.append((WierszeNr[i],1))
                                        dane.append(stat)
                                    elif len(d) <> 0:
                                        stat = "Operator z id : "+str(wart)+" jest ju zdefiniowany"
                                        wyn2.append((WierszeNr[i],1))
                                        dane.append(stat)  
        if stat == 'OK':
            if len(dane) > 0:
                stat = dane[0]

        if stat=='OK':    
            sqlIns=''
            for i in xrange(len(Insert[0])):
                INSERT="INSERT INTO rs_kontrahenci_opiekunowie "
                KOLUMNY="(firma_id,kontrahent_id"
                VALUES=" VALUES ('"+self.firma_id+"','"+str(Kontrahent)+"'"
                for j in xrange(len(Insert[0][i])):
                    pole=Insert[1][j]
                    wart=Insert[0][i][j]
                    if pole in ['oddzial_id']:
                        KOLUMNY+=","+pole
                        VALUES+=",'"+str(wart)+"'"     
                    elif pole in ['opiekun_id']:
                        KOLUMNY+=","+pole
                        if str(wart)[-2:]=='.0':
                            VALUES+=",'"+str(wart)[0:-2]+"'"
                        else:    
                            VALUES+=",'"+str(wart)+"'"            
                KOLUMNY+=")"
                VALUES+=");"
                sqlIns+=INSERT+KOLUMNY+VALUES
                            
            if sqlIns<>'': 
                stat,dump,dump,dump=self.PolSQL.Execute(rsglobal.Dekoduj(sqlIns),1)
                if stat<>'OK':
                    stat=u"Bd przy dodawaniu danych: "+stat   
                    dane.append(stat)    
                    

#-------------------------------------------------------------------------------
#---- SELECT - 5 Pobieranie listy opiekunw dla kontrahenta 
#-------------------------------------------------------------------------------

if Fun in (1,5,6) and stat == 'OK':    
    SELECT =" SELECT ko.oddzial_id,ko.opiekun_id,o.imie,o.nazwisko "
    SELECT+=" FROM rs_kontrahenci_opiekunowie ko "
    SELECT+=" LEFT OUTER JOIN rs_operatorzy o ON (ko.opiekun_id=o.operator_id)"
    SELECT+=" WHERE ko.firma_id = '"+self.firma_id+"' AND ko.kontrahent_id = '"+Kontrahent+"';"   
    stat,dane,wyn1,dump =self.PolSQL.Execute(SELECT, 3)    
    if stat <> 'OK':
        stat='Bd pobrania listy opiekunw : '+stat