# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_korekty_handlowcy.py
# Purpose:     obsluga grida edytowalnego udziaw handlowcw w korektze
# Author:      Micha Raburski
# Created:     2014/04/08
# RCS-ID:      $Id: fs_korekty_handlowcy $
# Copyright:   (c) 2014 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

stat='OK'

if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=='OK':
    Funkcja = klucze['Funkcja']
    
    SlPar={'Wyznacznik':[1,5],'Data':[1,5], 'Numer':[1,5]}
    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Funkcja,klucze)
    if Lista<>'':
        stat='Uwaga : wywoanie funkcji fs_korekty_handlowcy z numerem '+str(Funkcja)+' bez parametrw: '+Lista
        
    if Funkcja in [1,5]: 
        Wyznacznik=klucze['Wyznacznik']
        Data=klucze['Data']
        Numer=str(klucze['Numer'])
        
dane = []
wyn1 = []
wyn2 = []

UprIns=((self.oddzial_id,'022053') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID
UprUpd=((self.oddzial_id,'022052') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID or UprIns
UprDel=((self.oddzial_id,'022054') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID


#-------------------------------------------------------------------------------
#-------- EDYCJA GRIDA EDYTOWALNEGO (1)
#-------------------------------------------------------------------------------

Insert = []
Update = []
Delete = []

if Funkcja == 1:
    Update=klucze['Update']
    Insert=klucze['Insert']
    Delete=klucze['Delete']

#-------------------------------------------------------------------------------
#-------  SPRAWDZANIE DELETE  --------------------------------------------------
#-------------------------------------------------------------------------------

if Funkcja == 1 and stat=="OK":
    if len(Delete[0])>0:
        if not UprDel:
            stat='BR UPR DEL'
            dane.append(stat)
                
        # wykonanie DELETE 
        if stat == 'OK':
            SQLDEL = ''
            SQLFU = ''
            for i in xrange(len(Delete[0])):
                SQLFU ="SELECT handlowiec_id FROM rs_korekty_handlowcy"
                SQLFU+=" WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyznacznik+"'"
                SQLFU+=" AND data='"+Data+"' AND numer="+Numer
                DELETE="DELETE FROM rs_korekty_handlowcy"
                WHERE=" WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyznacznik+"'"
                WHERE+=" AND data='"+Data+"' AND numer="+Numer
                for j in xrange(len(Delete[0][i])):
                    pole = Delete[1][j]
                    wart = Delete[0][i][j]
                    if pole in ['handlowiec_id']:
                        WHERE += " AND "+pole+"='"+wart+"'"
                        SQLFU += " AND "+pole+"='"+wart+"'"
                
                SQLDEL += DELETE+WHERE+"; "
                SQLFU += " FOR UPDATE NOWAIT; "

            if stat == "OK" and SQLFU <> '':
                stat,d,dump,dump = self.PolSQL.Execute(rsglobal.Dekoduj(SQLFU),3)
                if stat <> 'OK':
                    stat = 'Bd sprawdzenia danych do usunicia: '+stat
                    dane.append(stat)

            if stat == "OK" and SQLDEL <> '':
                stat,dump,dump,dump = self.PolSQL.Execute(rsglobal.Dekoduj(SQLDEL),1)
                if stat <> 'OK':
                    stat = "Bd przy usuwaniu danych: "+stat   
                    dane.append(stat)


#-------------------------------------------------------------------------------
#---   UPDATE DANYCH (1)
#-------------------------------------------------------------------------------

if Funkcja == 1 and stat=="OK":
    if len(Update[0])>0:
        if not UprUpd:
            stat='BR UPR UPD'
            dane.append(stat)

        if stat == 'OK':
            SQLFU = ''
            for i in xrange(len(Update[0])):
                SQLFU+="SELECT handlowiec_id FROM rs_korekty_handlowcy"
                SQLFU+=" WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyznacznik+"'"
                SQLFU+=" AND data='"+Data+"' AND numer="+Numer
                for j in xrange(len(Update[2][i])): # petla po kluczu
                    pole = Update[3][j]
                    wart = rsglobal.Dekoduj(Update[2][i][j].strip())
                    if pole in ['handlowiec_id']:
                        SQLFU += " AND "+pole+"='"+wart+"'"
                SQLFU += " FOR UPDATE NOWAIT; "
            
            if SQLFU <> '':
                stat,d,dump,dump = self.PolSQL.Execute(rsglobal.Dekoduj(SQLFU),3)
                if stat <> 'OK':
                    stat = 'Bd sprawdzenia danych do modyfikacji: '+stat
                    dane.append(stat)
                elif len(d)==0:
                    stat = 'Zmieniana pozycja nie istnieje'
                    dane.append(stat)
            
        if stat == 'OK':
            WierszeNr = Update[-1]

            for i in xrange(len(Update[0])):
                for j in xrange(len(Update[0][i])): 
                    if stat =='OK':
                        pole = Update[0][i][j]
                        wart = Update[1][i][j]
    
                        if pole == 'handlowiec_id':
                            WartoscNowa = str(wart)
                            if wart.strip() == '':
                                wyn2.append((WierszeNr[i],0))
                                dane.append('BR HANDL')
                            else:
                                SQL="SELECT kod FROM rs_handlowcy WHERE firma_id='"+self.firma_id+"'"
                                SQL+=" AND kod='"+wart.strip()+"';"
                                stat,DTest,dump,dump = self.PolSQL.Execute(SQL,3)
                                if stat <> 'OK':
                                    stat='Bd sprawdzania poprawnoci handlowca :'+stat
                                    wyn2.append((WierszeNr[i],0))
                                    dane.append(stat)
                                elif len(DTest) ==0:
                                    wyn2.append((WierszeNr[i],0))
                                    dane.append('BL HANDL')

                        elif pole == 'udzial':
                            if wart <= 0 or wart>100:
                                wyn2.append((WierszeNr[i],2))
                                dane.append('ZAKR UDZIAL')
                                
        if stat == 'OK':
            if len(dane) > 0:
                stat = dane[0]
                
        # wykonanie UPDATE
        if stat=='OK':
            sql=''
            for i in xrange(len(Update[0])):
                UPDATE="UPDATE rs_korekty_handlowcy "
                SET='SET '
                for j in xrange(len(Update[0][i])): 
                    pole=Update[0][i][j]
                    wart=Update[1][i][j]
                    if pole in ['handlowiec_id']:
                        SET+=pole+"='"+wart+"',"
                    elif pole in ['udzial']:
                        SET+=pole+"="+str(wart)+","

                SET=SET.strip(",")
                WHERE=" WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyznacznik+"'"
                WHERE+=" AND data='"+Data+"' AND numer="+Numer
                for j in xrange(len(Update[2][i])): # petla po kluczu
                    pole=Update[3][j]
                    wart=rsglobal.Dekoduj(Update[2][i][j])
                    if pole in ['handlowiec_id']:
                        WHERE+= " AND "+pole+"='"+wart+"'"

                WHERE+=";"
                
                sql+=UPDATE+SET+WHERE;
                
            if sql<>'':
                stat,dump,dump,dump=self.PolSQL.Execute(rsglobal.Dekoduj(sql),1)
                if stat<>'OK':
                    stat="Bd przy modyfikowaniu danych: "+stat   
                    dane.append(stat)


#-------------------------------------------------------------------------------
#---------Sprawdzanie danych do Insert------
#-------------------------------------------------------------------------------

if Funkcja == 1 and stat=="OK":
    if len(Insert[0])>0:
        if not UprIns:
            stat='BR UPR INS'
            dane.append(stat)

        if stat == 'OK':
            WierszeNr = Insert[-1]
            for i in xrange(len(Insert[0])):
                for j in xrange(len(Insert[0][i])): 
                    pole=Insert[1][j]
                    wart=Insert[0][i][j]

                    if pole == 'handlowiec_id':
                        if wart.strip() == '':
                            wyn2.append((WierszeNr[i],0))
                            dane.append('BR HANDL')
                        else:
                          SQL="SELECT kod FROM rs_handlowcy WHERE firma_id='"+self.firma_id+"'"
                          SQL+=" AND kod='"+wart.strip()+"';"
                          stat,DTest,dump,dump = self.PolSQL.Execute(SQL,3)
                          if stat <> 'OK':
                              stat='Bd sprawdzania poprawnoci handlowca :'+stat
                              wyn2.append((WierszeNr[i],0))
                              dane.append(stat)
                          elif len(DTest) ==0:
                              wyn2.append((WierszeNr[i],0))
                              dane.append('BL HANDL')
                       
                    elif pole == 'udzial':
                        if wart <= 0 or wart>100:
                            wyn2.append((WierszeNr[i],2))
                            dane.append('ZAKR UDZIAL')
                
        if stat == 'OK':
            if len(dane) > 0:
                stat = dane[0]

        # wykonanie INSERT
        if stat == 'OK':
            sqlIns=''
            for i in xrange(len(Insert[0])):
                INSERT="INSERT INTO rs_korekty_handlowcy "
                KOLUMNY="(firma_id,wyznacznik_id,data,numer"
                VALUES=" VALUES ('"+self.firma_id+"','"+Wyznacznik+"','"+Data+"',"+Numer
                for j in xrange(len(Insert[0][i])):
                    pole=Insert[1][j]
                    wart=Insert[0][i][j]
                    if pole in ['handlowiec_id']:
                        KOLUMNY+=","+pole
                        VALUES+=",'"+wart+"'"
                    elif pole in ['udzial']:
                        KOLUMNY+=","+pole
                        VALUES+=","+str(wart)+""

                KOLUMNY+=")"
                VALUES+=");"
                sqlIns+=INSERT+KOLUMNY+VALUES
            if sqlIns<>'': 
                stat,dump,dump,dump=self.PolSQL.Execute(rsglobal.Dekoduj(sqlIns),1)
                if stat<>'OK':
                    stat="Bd przy dodawaniu danych: "+stat
                    dane.append(stat)


if Funkcja == 1 and stat == 'OK':
    # po zmianach kontrola, czy procenty si sumuj do 100
    SQL ="SELECT SUM(COALESCE(udzial,0)) FROM rs_korekty_handlowcy"
    SQL+=" WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyznacznik+"'"
    SQL+=" AND data='"+Data+"' AND numer="+Numer
    stat,DTest,dump,dump = self.PolSQL.Execute(SQL,3)
    if stat <> 'OK':
        stat = 'Bd sprawdzenie sumy udziaw: '+stat
    elif len(DTest) == 1:
        if not DTest[0][0] in [0,100]:
            stat = 'Suma udziaw powinna wynosi 100%, a wynosi '+rsglobal.UsunKropkaZero(str(DTest[0][0]))+'%'
            dane.append(stat)


#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (1- insert 1 -select, 1 -delete, 5 -select) 
#-------------------------------------------------------------------------------

if Funkcja in (1,5) and stat=='OK':
    SQL ="SELECT fh.handlowiec_id,h.opis,fh.udzial"
    SQL+=" FROM rs_korekty_handlowcy fh "
    SQL+=" INNER JOIN rs_handlowcy h ON (h.firma_id = fh.firma_id AND h.kod = fh.handlowiec_id)"
    SQL+=" WHERE fh.firma_id='"+self.firma_id+"' AND fh.wyznacznik_id='"+Wyznacznik+"' AND fh.data='"+Data+"'"
    SQL+=" AND fh.numer="+Numer
    SQL+=" ORDER BY fh.handlowiec_id;"

    stat,dane,wyn1,wyn2 = self.PolSQL.Execute(SQL,3)
    if stat <> 'OK':
        stat = "Bd przy pobieraniu danych: "+stat