
# -*- coding: iso8859_2 -*-

#-----------------------------------------------------------------------------
# Name:        fs_korekty_zbiorcze.py
# Purpose:     dodawanie korekt zbiorczych
#
# Author:      Micha Raburski
# Created:     2010/03/01
# RCS-ID:      $Id: fs_korekty_zbiorcze.py $
# Copyright:   (c) 2010 Record System
# Licence:     GNU GPL
#-----------------------------------------------------------------------------
# 2019-08-01 Aleksander Bargie (11568) - Poprawka komuniaktu przy okazji innego zagadnienia
# 2019-08-30 Wojciech Skowron   (11620) - Split payment w korektach zbiorczych

from funkcje import fs_sprzedaz_pom

Kontr=klucze[0]
DataOd=klucze[1]
DataDo=klucze[2]
RabatP=klucze[3]
RabatN=klucze[4]
RabatB=klucze[5]
WyznFak=klucze[6]
WyznKor=klucze[7]
DataKor=klucze[8]
PowodZm=klucze[9]
Fun=klucze[-1]
stat = "OK"
dane = []

dl=10

if stat=='OK':
    Lista=[self.firma_id,self.oddzial_id,self.operator_id]
    sql = "SELECT rsf_podaj_wyznaczniki('"+str(Lista).replace("'",'"')+"','[]','[False,True,False,False,False,False]');"    
    stat,wyzn,dump,dump=self.PolSQL.Execute(sql,3)
if stat=='OK':
    LWyzn=rsglobal.rseval(wyzn[0][0])[1]

#sprawdzenie uprawnien
if stat=='OK':
    if self.operator_id <> STANDARD_OPERATOR_ID:
        if not WyznKor in LWyzn:
            stat='BR UPR'
            
#-------------------------------------------------------------------------------
#sprawdzenie przychodzcych danych
#-------------------------------------------------------------------------------
if stat=='OK':
    if Kontr=='':
        stat='BR KONTR'
    else:
        SQL="SELECT aktywny FROM rs_kontrahenci WHERE firma_id='"+self.firma_id+"' AND kontrahent_id = '"+Kontr+"';"
        stat,Dane,dump,dump = self.PolSQL.Execute(SQL,3)
        if len(Dane) == 0:
            stat="BL KONTR"
        elif not Dane[0][0]:
            stat="NA KONTR"
        
if stat=='OK':
    if DataOd=='    -  -  ':
        stat='BR DATYOD'
    elif not rsglobal.SprawdzCzyToData(DataOd):
        stat='BL DATAOD'

if stat=='OK':
    if DataDo=='    -  -  ':
        stat='BR DATYDO'
    elif not rsglobal.SprawdzCzyToData(DataDo):
        stat='BL DATADO'
        
if stat=='OK':
    if DataOd>DataDo:
        stat='DATY ODWR'

if stat=='OK':
    if RabatP==0 and RabatN==0 and RabatB==0:
        stat='BR RAB'
    elif (RabatP<>0 and RabatN <>0) or (RabatP<>0 and RabatB <>0) or (RabatN<>0 and RabatB <>0):
        stat='DWA RABATY'
        
if stat=='OK':
    if WyznKor=='':
        stat='BR WYZN KOR'
    else:
        SQL="SELECT wyznacznik_id FROM rs_wyznaczniki WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id = '"+WyznKor+"';"
        stat,Dane,dump,dump = self.PolSQL.Execute(SQL,3)
        if len(Dane) == 0:
            stat="BL WYZN KOR"
        
if stat=='OK':
    if DataKor=='    -  -  ':
        stat='BR DATYKOR'
    elif not rsglobal.SprawdzCzyToData(DataKor):
        stat='BL DATAKOR'

if stat=='OK':
    if DataDo>DataKor:
        stat='DATA KOR MALA'

if stat=='OK':
    if PowodZm=='':
        stat='BR POWZM'
    else:
        SQL="SELECT kod FROM rs_tytuly_zmniejszenia_podatku WHERE firma_id='"+self.firma_id+"' AND kod = '"+PowodZm+"';"
        stat,Dane,dump,dump = self.PolSQL.Execute(SQL,3)
        if len(Dane) == 0:
            stat="BL POWZM"

#-------------------------------------------------------------------------------
#sprawdzenie czy trzeba pyta o odrzucenie niektrych faktur
#-------------------------------------------------------------------------------

if stat=='OK' and Fun==1:
    SQL="SELECT wyznacznik_id FROM rs_korekty WHERE firma_id='"+self.firma_id+"' AND data>'"+DataDo+"'"
    SQL+=" AND data_o>='"+DataOd+"' AND data_o<='"+DataDo+"' AND platnik_id='"+Kontr+"'"
    if WyznFak <>'':
        SQL+=" AND wyznacznik_id_o= ANY( STRING_TO_ARRAY('"+WyznFak+"','/'))"
    
    stat,Dane,dump,dump = self.PolSQL.Execute(SQL,3)
    if stat=='OK':
        if len(Dane)>0:
            stat='PYT'
            
            
#-##############################################################################
#  ALGORYTM TWORZENIA KOREKTY ZBIORCZEJ
#-##############################################################################

if stat=='OK' and Fun==2:
    #-------------------------------------------------------------------------------
    # zebranie  informacji o wartoci zbiorczej faktur
    #-------------------------------------------------------------------------------
    #WS 2019-08-30 - pobranie czy_mpp
    SQL="SELECT TRIM(f.wyznacznik_id),f.data,f.numer,TRIM(COALESCE(k.wyznacznik_id,'')),k.data,k.numer,COALESCE(k.kwota_netto,f.kwota_netto),"
    SQL+="COALESCE(k.do_zaplaty,f.do_zaplaty),COALESCE(k.stan,f.stan), f.czy_mpp FROM rs_faktury f LEFT OUTER JOIN rs_korekty k ON (f.firma_id=k.firma_id AND "
    SQL+=" f.wyznacznik_id=k.wyznacznik_id_o AND f.data=k.data_o AND f.numer=k.numer_o) "
    SQL+=" WHERE f.firma_id='"+self.firma_id+"' AND f.data>='"+DataOd+"' AND f.data <='"+DataDo+"' AND f.platnik_id='"+Kontr+"' "
    if WyznFak <>'':
        SQL+=" AND TRIM(f.wyznacznik_id)= ANY( STRING_TO_ARRAY('"+WyznFak+"','/'))"
    SQL+=" ORDER BY TRIM(f.wyznacznik_id),f.data,f.numer,k.data,k.numer;"
    stat,DaneN,dump,dump = self.PolSQL.Execute(SQL,3)

    #dane.append('ZACZYNAM')
    rsglobal.ZapiszDoLogow('ZACZYNAM',dl)
    if stat=='OK':
        if len(DaneN)==0:
            stat='BR FAKT'
            
    if stat=='OK':
        SFakt={}
        for poz in DaneN:
            if stat=='OK':
                klucz=(poz[0],poz[1],poz[2])
                
                # faktura bez korekt
                if poz[3]=='':
                    #sprawdzenie stanu
                    if poz[8] in ['W','G']:
                        stat='Faktura '+poz[0]+'/'+poz[1]+'/'+str(poz[2])+' nie jest zamknita'
                    elif not klucz in SFakt:
                        #WS 2019-08-30
                        SFakt[klucz]=['','',0,poz[6],poz[7],poz[9]]
                        # SFakt[klucz]=['','',0,poz[6],poz[7]]
                # korekta poza zakresem
                elif poz[4]>DataDo:
                    if klucz in SFakt:
                        del SFakt[klucz]
                # korekta w zakresie
                else:
                    if poz[8] in ['W','G']:
                        #AB 01.08.19r
                        stat='Korekta faktury '+poz[0]+'/'+poz[1]+'/'+str(poz[2])+' nie jest zamknita'
                    else:
                        SFakt[klucz]=[poz[3],poz[4],poz[5],poz[6],poz[7],poz[9]]
                        # SFakt[klucz]=[poz[3],poz[4],poz[5],poz[6],poz[7]]

    if stat=='OK':
        if len(SFakt)==0:
            stat='BR FAKT K'
    rsglobal.ZapiszDoLogow('DALEJ 2 '+str(SFakt),dl)     
    if stat=='OK':
        # sumowanie wartoci dokumentw
        SumaN=0
        SumaB=0
        
        for kl in SFakt:
            SumaN+=SFakt[kl][3]
            SumaB+=SFakt[kl][4]
        
        if SumaN==0:
            stat='NETTO 0'
    
    if stat=='OK':    
        # analiza wysokoci rabatu
        #dane.append('S '+str(SumaN)+' '+str(SumaB))
        
        # to s zmienne obliczane w oparciu o jeden podany rabat. Wykorzystuje si je do oblicze dalszych
        RProc=0
        RKwotaN=0
        RKwotaB=0
        
        # jeli jest rabat brutto, to sprawdzamy czy wszystkie faktury uwzgldniane maj ten sam VAT
        if RabatB<>0:
            if RabatB>SumaB:
                stat='RABAT B WIEKSZY'
            
            if stat=='OK':
                SQL="SELECT DISTINCT COALESCE(kv.stawka_vat,fv.stawka_vat) FROM rs_faktury f LEFT OUTER JOIN rs_korekty k ON (f.firma_id=k.firma_id AND "
                SQL+=" f.wyznacznik_id=k.wyznacznik_id_o AND f.data=k.data_o AND f.numer=k.numer_o) "
                SQL+=" LEFT OUTER JOIN rs_faktury_vat fv ON (f.firma_id=fv.firma_id AND f.wyznacznik_id=fv.wyznacznik_id "
                SQL+=" AND f.data=fv.data AND f.numer=fv.numer) "
                SQL+=" LEFT OUTER JOIN rs_korekty_vat kv ON (k.firma_id=kv.firma_id AND k.wyznacznik_id=kv.wyznacznik_id "
                SQL+=" AND k.data=kv.data AND k.numer=kv.numer) "
                SQL+=" WHERE f.firma_id='"+self.firma_id+"' AND f.data>='"+DataOd+"' AND f.data <='"+DataDo+"' AND f.platnik_id='"+Kontr+"' AND (k.data<='"+DataDo+"' OR k.data IS NULL) "
                if WyznFak <>'':
                    SQL+=" AND TRIM(f.wyznacznik_id)= ANY( STRING_TO_ARRAY('"+WyznFak+"','/'))"
            
                stat,DTest,dump,dump = self.PolSQL.Execute(SQL,3)        
                
            if stat=='OK':
                if len(DTest)>1:
                    stat='DWIE STAWKI'
                    
            if stat=='OK':
                RKwotaB=RabatB
                RProc=RabatB/SumaB
                RKwotaN=rsglobal.RSRound(SumaN*RProc,2)
        
        elif RabatN <> 0:
            if RabatN>SumaN:
                stat='RABAT N WIEKSZY'
            
            if stat=='OK':
                RKwotaN=RabatN
                RProc=RabatN/SumaN

        else:
            RProc=RabatP*0.01
            RKwotaN=rsglobal.RSRound(SumaN*RProc,2)
            
        #dane.append('W '+str(RProc)+' '+str(RKwotaN)+' '+str(RKwotaB))
        rsglobal.ZapiszDoLogow('DALEJ 3 '+str(RProc)+' '+str(RKwotaN)+' '+str(RKwotaB),dl)     
# pobranie poszczeglnych pozycji faktur i korekt na ktrych mona pracowa
    if stat=='OK':
        FiltrFakt=''
        FiltrKor=''
        LKor=[]
        DFakt=[]
        DKor=[]
        
        for klucz in SFakt:
            if SFakt[klucz][0]=='':
                if FiltrFakt <>'':
                    FiltrFakt+=" OR "
                FiltrFakt+="(TRIM(wyznacznik_id)='"+rsglobal.Dekoduj(klucz[0]).strip()+"'"
                FiltrFakt+=" AND data='"+rsglobal.Dekoduj(klucz[1]).strip()+"' AND numer="+str(klucz[2]).replace('.0','')+")"
            else:
                if FiltrKor <>'':
                    FiltrKor+=" OR "
                FiltrKor+="(TRIM(wyznacznik_id)='"+rsglobal.Dekoduj(SFakt[klucz][0]).strip()+"'"
                FiltrKor+=" AND data='"+rsglobal.Dekoduj(SFakt[klucz][1]).strip()+"' AND numer="+str(SFakt[klucz][2]).replace('.0','')+")"

        if FiltrFakt<>'':
            SQL="SELECT 'F',fp.wyznacznik_id,fp.data,fp.numer,fp.nr_poz,fp.nr_ppoz,fp.ilosc1,fp.cena_upust1,fp.cena_brutto1,a.przelicznik,fp.stawka_vat"
            SQL+=" FROM rs_faktury_pozycje fp INNER JOIN rs_artykuly a USING (firma_id,artykul_id) WHERE "
            SQL+=" firma_id='"+self.firma_id+"' AND ("+FiltrFakt+")"
            #dane.append('SQL '+SQL)
            stat,DFakt,dump,dump = self.PolSQL.Execute(SQL,3)        
        #dane.append('D '+str(DFakt))
        rsglobal.ZapiszDoLogow('DALEJ 5 '+str(DFakt),dl)
    if stat=='OK':
        if FiltrKor<>'':
            SQL="SELECT 'K',kp.wyznacznik_id,kp.data,kp.numer,kp.nr_poz,kp.nr_ppoz,kp.ilosc1,kp.cena_upust1,kp.cena_brutto1,a.przelicznik,kp.stawka_vat"
            SQL+=" FROM rs_korekty_pozycje kp INNER JOIN rs_artykuly a USING (firma_id,artykul_id) WHERE "
            SQL+=" firma_id='"+self.firma_id+"' AND ("+FiltrKor+")"
            #dane.append('SQL2 '+SQL)
            stat,DKor,dump,dump = self.PolSQL.Execute(SQL,3)        
        #dane.append('D2 '+str(DKor))
        rsglobal.ZapiszDoLogow('DALEJ 6 '+str(DKor),dl)
    if stat=='OK':
        SPoz={}
        
        for poz in DFakt:
            #klucz to'F/K', wyznacznik,data,numer,nr_poz, nr_ppoz
            # wynik klucza to ilosc, cena netto,cena netto wal, cena brutto, przelicznik, stawka vat, cena netto nowa,, cena netto wal nowa, cena brutto nowa, ile razy zmieniana cena ( i w ktr stron +-)
            klucz=(rsglobal.Dekoduj(poz[0]),rsglobal.Dekoduj(poz[1]).strip(),rsglobal.Dekoduj(poz[2]).strip(),str(poz[3]).replace('.0',''),str(poz[4]).replace('.0',''),str(poz[5]).replace('.0',''))
            if poz[10] in self.ListaStawekZn:
                VAT=0
            else:
                VAT=int(poz[10])
            SPoz[klucz]=[poz[6],poz[7],poz[8],poz[9],VAT,poz[7],poz[8],0]
    
        for poz in DKor:
            #klucz to'F/K', wyznacznik,data,numer,nr_poz, nr_ppoz
            # wynik klucza to ilosc, cena netto,cena netto wal, cena brutto, przelicznik, stawka vat, cena netto nowa,, cena netto wal nowa, cena brutto nowa
            klucz=(rsglobal.Dekoduj(poz[0]),rsglobal.Dekoduj(poz[1]).strip(),rsglobal.Dekoduj(poz[2]).strip(),str(poz[3]).replace('.0',''),str(poz[4]).replace('.0',''),str(poz[5]).replace('.0',''))
            if poz[10] in self.ListaStawekZn:
                VAT=0
            else:
                VAT=int(poz[10])
            SPoz[klucz]=[poz[6],poz[7],poz[8],poz[9],VAT,poz[7],poz[8],0]
            
        #dane.append('D3 '+str(SPoz))


    #-------------------------------------------------------------------------------
    # praca na poszczeglnych pozycjach dokumentw
    #-------------------------------------------------------------------------------
    if stat=='OK':
        RoznicaNetto=0
        
        # najpierw ptla oglnie zmieniajca warto pozycji o przybliony procent -wszystkie si zmieniaj.
        for klucz in SPoz:
            poz=SPoz[klucz]
            CenaNNowa=rsglobal.RSRound(poz[1]*(1-RProc),2)
            CenaBNowa=rsglobal.RSRound(CenaNNowa*(100+poz[4])*0.01,2)
            RoznicaNetto=RoznicaNetto+rsglobal.RSRound((poz[1]-CenaNNowa)*poz[0],2)
            
            SPoz[klucz][5]=CenaNNowa
            SPoz[klucz][6]=CenaBNowa
            
        #dane.append('D4 '+str(SPoz))
        #dane.append('D5 Zaoenie :'+str(RKwotaN)+' Na razie : '+str(RoznicaNetto)+' Rnica : '+str(RKwotaN-RoznicaNetto))
        rsglobal.ZapiszDoLogow('D5 Zaoenie :'+str(RKwotaN)+' Na razie : '+str(RoznicaNetto)+' Rnica : '+str(RKwotaN-RoznicaNetto),dl)

        KluczeTemp=SPoz.keys()
        KluczeTemp.sort()
        rsglobal.ZapiszDoLogow('POCZ LISTY',dl)            
        for kl in KluczeTemp:
            rsglobal.ZapiszDoLogow(str(kl)+' '+str(SPoz[kl]),dl)            
        
        rsglobal.ZapiszDoLogow('KONIEC LISTY',1)            


        #ptla rubujca przyblienie rnicy rabatu domylnego i faktycznego do zera
        RobicPetle=True
        #zmienna, ktra mwi jaki wspczynnik rnicy od ceny rednio zrabatowanej nas interesuje
        CzyBrany=0
        while RobicPetle and RKwotaN-RoznicaNetto <> 0:
            # na pewno szukamy jak rabat niewypeniony
            RobicPetle=(RKwotaN-RoznicaNetto>0)
            Wybrany=''
            KwotaAktRozn=0
            Brany=0
            #dane.append('RN '+str(RKwotaN-RoznicaNetto>0))
            rsglobal.ZapiszDoLogow('RN '+str(RKwotaN-RoznicaNetto),dl)
            rsglobal.ZapiszDoLogow('RN2 '+str(RKwotaN-RoznicaNetto>0),dl)
            
            if RKwotaN-RoznicaNetto>0:
                #szukanie najlepszego przyblienia rabatu od gry, ktry nie przekracza 0
                for klucz in SPoz:
                    #dane.append('P1 '+str(klucz))
                    poz=SPoz[klucz]
                    
                    # jeli bierzemy pozycj pod uwag to tylko tak co jeszcze nie bya brana
                    if CzyBrany>=poz[7]:
                        #tyle moemy minimalnie zmieni w zotwkach (ilo * 0.01 PLN czyli grosz)
                        RoznBuf=rsglobal.RSRound(poz[0]*poz[5],2)-rsglobal.RSRound(poz[0]*(poz[5]-0.01),2)
                        # jeli nie przekroczymy rabatu na -
                        if RoznBuf<=RKwotaN-RoznicaNetto:
                            # jeli bardziej si zbliymy ni wybrana dotychczas pozycja
                            if KwotaAktRozn<RoznBuf:
                                Wybrany=klucz
                                KwotaAktRozn=RoznBuf  
                            
                # jeli nie znalelimy takiego to szukamy najlepszego przyblienia, 
                # ktre bdzie najmniejsze na minusie
                if Wybrany=='':
                    for klucz in SPoz:
                        #dane.append('P2 '+str(klucz))
                        poz=SPoz[klucz]
                        # jeli bierzemy pozycj pod uwag to tylko tak co jeszcze nie bya brana
                        if CzyBrany>=poz[7]:
                            #tyle moemy minimalnie zmieni w zotwkach (ilo * 0.01 PLN czyli grosz)
                            RoznBuf=rsglobal.RSRound(poz[0]*poz[5],2)-rsglobal.RSRound(poz[0]*(poz[5]-0.01),2)
                            # jeli mniej przekroczymy ni wybrana dotychczas pozycja
                            rsglobal.ZapiszDoLogow('RBUF '+str(RoznBuf),dl)
                            rsglobal.ZapiszDoLogow('CZY1 '+str(RoznBuf<KwotaAktRozn),dl)
                            rsglobal.ZapiszDoLogow('CZY2 '+str(KwotaAktRozn==0),dl)
                            rsglobal.ZapiszDoLogow('CZY3 '+str(KwotaAktRozn),dl)
                            if RoznBuf<KwotaAktRozn or KwotaAktRozn==0:
                                rsglobal.ZapiszDoLogow('PING '+str(klucz),dl)
                                Wybrany=klucz
                                KwotaAktRozn=RoznBuf  
                
                #jeli dalej nic nie znalelimy to znaczy tylko, e wszystkie "brane" s ju o 1 grosz pomniejszone
                # zwikszamy CzyBrany i jedziemy dalej
                #dane.append('W '+str(Wybrany))
                rsglobal.ZapiszDoLogow('WYBRANY+ '+str(Wybrany),dl)
                if Wybrany=='':
                    CzyBrany=CzyBrany+1
                else:
                    poz=SPoz[Wybrany]
                    rsglobal.ZapiszDoLogow('WYBRANY2+ '+str(poz),dl)
                    #dane.append('PPR '+str(poz))
                    CenaNNowa=poz[5]-0.01
                    CenaBNowa=rsglobal.RSRound(CenaNNowa*(100+poz[4])*0.01,2)
                    RoznicaNetto=RoznicaNetto-rsglobal.RSRound((poz[1]-poz[5])*poz[0],2)+rsglobal.RSRound((poz[1]-CenaNNowa)*poz[0],2)
                    
                    SPoz[Wybrany][5]=CenaNNowa
                    SPoz[Wybrany][6]=CenaBNowa
                    SPoz[Wybrany][7]=SPoz[klucz][7]+1
                    #dane.append('PPO '+str(poz))
                    
                    
            else:
                #szukanie najlepszego przyblienia rabatu od dou
                Brany=1000
                for klucz in SPoz:
                    #dane.append('P3 '+str(klucz))
                    poz=SPoz[klucz]
                                        
                    #tyle moemy minimalnie zmieni w zotwkach (ilo * 0.01 PLN czyli grosz)
                    RoznBuf=rsglobal.RSRound(poz[0]*poz[5],2)-rsglobal.RSRound(poz[0]*(poz[5]+0.01),2)
                    # jeli nie przekroczymy rabatu na +
                    #dane.append('P31 '+str(RoznBuf)+' '+str(RKwotaN-RoznicaNetto))
                    if RoznBuf>=(RKwotaN-RoznicaNetto):
                        #dane.append('P32 '+str(Brany)+' '+str(poz[7])+' '+str(KwotaAktRozn)+' '+str(RoznBuf) )
                        #dane.append('P33 '+str(Brany==1000)+' '+str(Brany< poz[7])+' '+str(KwotaAktRozn<RoznBuf and Brany==poz[7]) )
                        # jeli bardziej si zbliymy ni wybrana dotychczas pozycja lub mamy mniejsz ilo odejmowa
                        if Brany==1000 or Brany< poz[7] or (KwotaAktRozn<RoznBuf and Brany==poz[7]):
                            Wybrany=klucz
                            KwotaAktRozn=RoznBuf  
                            Brany=poz[7]

                #dane.append('W2 '+str(Wybrany))
                rsglobal.ZapiszDoLogow('WYBRANY- '+str(Wybrany),dl)
                if Wybrany <> '':
                    poz=SPoz[Wybrany]
                    rsglobal.ZapiszDoLogow('WYBRANY2- '+str(poz),dl)
                    #dane.append('W3 '+str(poz))
                    CenaNNowa=poz[5]+0.01
                    CenaBNowa=rsglobal.RSRound(CenaNNowa*(100+poz[4])*0.01,2)
                    RoznicaNetto=RoznicaNetto-rsglobal.RSRound((poz[1]-poz[5])*poz[0],2)+rsglobal.RSRound((poz[1]-CenaNNowa)*poz[0],2)

                    SPoz[Wybrany][5]=CenaNNowa
                    SPoz[Wybrany][6]=CenaBNowa
                    SPoz[Wybrany][7]=SPoz[Wybrany][7]-1
                    RobicPetle=True

        #dane.append('KP '+str(SPoz)+' '+str(RKwotaN)+' '+str(RoznicaNetto))            
        rsglobal.ZapiszDoLogow('KONCOWO '+str(RKwotaN)+' '+str(RoznicaNetto),dl)            
        rsglobal.ZapiszDoLogow('KONCOWO2: ',dl)            
        KluczeTemp=SPoz.keys()
        KluczeTemp.sort()
        for kl in KluczeTemp:
            rsglobal.ZapiszDoLogow(str(kl)+' '+str(SPoz[kl]),dl)            
            
        rsglobal.ZapiszDoLogow('KONCOWO3: ',dl)            
    
    #-------------------------------------------------------------------------------
    # zmiana w bazie danych
    #-------------------------------------------------------------------------------
    if stat=='OK':
        # pobranie numeru korekty zbiorczej
        SQL="SELECT COALESCE(max(nr_zbiorczy),0)+1 FROM rs_korekty WHERE firma_id='"+self.firma_id+"' "
        SQL+=" AND EXTRACT(YEAR FROM data::TIMESTAMP)=EXTRACT(YEAR FROM '"+DataKor+"'::TIMESTAMP);"
        stat,DNrZbiorczy,dump,dump = self.PolSQL.Execute(SQL, 3) 
    if stat=='OK':
        NrZbiorczy=str(DNrZbiorczy[0][0]).replace('.0','')
        
        # utworzenie korekt w oparciu o list faktur
        for klucz in SFakt:
            if stat=='OK':
                #dane.append('KOR '+str(klucz))
                stat,DaneNum,dump,dump = self.PolSQL.Execute("SELECT rsf_sprawdz_czy_mozna_dodac_dokument('"+self.firma_id+"','[\\\'"+WyznKor+"\\\',\\\'"+DataKor+"\\\']','K');",3)            
                if stat =='OK':
                    if DaneNum[0][0]=='OK':
                        stat,DaneNum,dump,dump = self.PolSQL.Execute("SELECT rsf_podaj_nowy_numer_dokumentu('"+self.firma_id+"','[\\\'"+WyznKor+"\\\',\\\'"+DataKor+"\\\']','K');",3)        
                        if DaneNum[0][0] in (None,'None',''):
                            stat="Bdy w pobieraniu numeru korekty. Poinformuj serwis"
                    elif stat=='OK':
                        stat="Nie mona doda korekty - "+str(DaneNum[0])
    
                if stat=='OK':
                    Klucz1=[self.firma_id,self.oddzial_id]
                    Klucz2=[self.firma_id,WyznKor,DataKor,DaneNum[0][0]]
                    Klucz3=[self.firma_id,rsglobal.Dekoduj(klucz[0]),rsglobal.Dekoduj(klucz[1]),klucz[2]]
                    SQL="SELECT rsf_korekta_insert('"+str(Klucz1).replace("'","\\\'")+"','"+str(Klucz2).replace("'","\\\'")+"','"+str(Klucz3).replace("'","\\\'")+"','[]')"
                    stat,dump,dump,dump = self.PolSQL.Execute(SQL, 1) 
                    
                if stat == 'OK':
                    stat = fs_sprzedaz_pom.PrzeniesUdzialyHandlowcowZFakturyDoKorekty(self,WyznKor,DataKor,DaneNum[0][0])


            
    if stat=='OK':
        # modyfikacja nagwkw korekt
        SQL=""
        for klucz in SFakt:
            #WS 2019-08-30
            SQL+="UPDATE rs_korekty SET nr_zbiorczy="+NrZbiorczy+",tytul_zmniejszenia_podatku='"+PowodZm+"',"
            SQL+="czy_mpp="+("TRUE" if SFakt[klucz][5] else "FALSE")+" WHERE firma_id='"+self.firma_id+"'"
            # SQL+="UPDATE rs_korekty SET nr_zbiorczy="+NrZbiorczy+",tytul_zmniejszenia_podatku='"+PowodZm+"' WHERE firma_id='"+self.firma_id+"'"
            if SFakt[klucz][0]=='':
                SQL+=" AND wyznacznik_id_p='"+rsglobal.Dekoduj(klucz[0])+"' AND data_p='"+rsglobal.Dekoduj(klucz[1])+"'"
                SQL+=" AND numer_p="+str(klucz[2])+";"
            else:
                SQL+=" AND wyznacznik_id_p='"+rsglobal.Dekoduj(SFakt[klucz][0])+"' AND data_p='"+rsglobal.Dekoduj(SFakt[klucz][1])+"'"
                SQL+=" AND numer_p="+str(SFakt[klucz][2])+";"
                
        rsglobal.ZapiszDoLogow('Naglowki '+SQL,1)
        stat,dump,dump,dump = self.PolSQL.Execute(SQL, 1) 
        
    if stat=='OK':
        # modyfikacja pozycji korekt
        for klucz in SPoz:
            if stat=='OK':
                poz=SPoz[klucz]
                CenaU1=rsglobal.RSRound(poz[5],2)
                CenaU2=rsglobal.RSRound(CenaU1/poz[3],2)
                CenaB1=rsglobal.RSRound(poz[6],2)
                CenaB2=rsglobal.RSRound(CenaB1/poz[3],2)
                Upust="ROUND(100-(100*"+str(CenaU1)+")/cena_netto1,2)"
                
                NrFaktBuf="(SELECT numer FROM rs_korekty WHERE firma_id='"+self.firma_id+"' AND "
                NrFaktBuf+=" wyznacznik_id_p='"+klucz[1]+"' AND "
                NrFaktBuf+=" data_p='"+klucz[2]+"' AND numer_p="+klucz[3]+")"
                
                SQLTest="SELECT cena_netto1,"+Upust+",ilosc1,* FROM rs_korekty_pozycje WHERE firma_id='"+self.firma_id+"'"
                SQLTest+=" AND wyznacznik_id='"+WyznKor+"' AND data='"+DataKor+"' AND numer="+NrFaktBuf+" AND "
                SQLTest+=" nr_poz="+klucz[4]+" AND nr_ppoz="+klucz[5]+";"
                stat,DTest,dump,dump = self.PolSQL.Execute(SQLTest, 3)
            if stat=='OK':
                rsglobal.ZapiszDoLogow('DTest '+str(DTest),1)
                rsglobal.ZapiszDoLogow(str(100-(100*CenaU1)/DTest[0][0]),1)
                
                WartN="ROUND(ilosc1*"+str(CenaU1)+",2)"
                WartB="ROUND("+WartN+"*(100+"+str(poz[4])+")*0.01,2)"
                Kurs="(SELECT kurs FROM rs_korekty WHERE firma_id=rs_korekty_pozycje.firma_id AND "
                Kurs+=" wyznacznik_id=rs_korekty_pozycje.wyznacznik_id AND"
                Kurs+=" data=rs_korekty_pozycje.data AND numer=rs_korekty_pozycje.numer)"
                CenaUW1="ROUND("+str(CenaU1)+"/"+Kurs+",2)"
                CenaUW2="ROUND("+CenaUW1+"/"+str(poz[3])+",2)"
                
                
                
                SQL=" UPDATE rs_korekty_pozycje SET cena_upust1="+str(CenaU1)+", cena_upust2="+str(CenaU2)+","
                SQL+=" cena_brutto1="+str(CenaB1)+", cena_brutto2="+str(CenaB2)+","
                SQL+=" upust="+Upust+",upust_wartosc=ROUND(ilosc1*(cena_netto1- "+str(CenaU1)+"),2),"
                SQL+=" wartosc_netto="+WartN+", wartosc_vat=ROUND("+WartB+"-"+WartN+",2),"
                SQL+=" wartosc_brutto="+WartB+",cena_upust_wal1="+CenaUW1+","
                SQL+=" cena_upust_wal2="+CenaUW2+", wartosc_wal_netto=ROUND("+WartN+"/"+Kurs+",2),"
                SQL+=" wartosc_wal_vat=ROUND(("+WartB+"-"+WartN+")/"+Kurs+",2),"
                SQL+=" wartosc_wal_brutto=ROUND("+WartB+"/"+Kurs+",2) WHERE firma_id='"+self.firma_id+"'"
                SQL+=" AND wyznacznik_id='"+WyznKor+"' AND data='"+DataKor+"' AND numer="+NrFaktBuf+" AND "
                SQL+=" nr_poz="+klucz[4]+" AND nr_ppoz="+klucz[5]+";"
    
                rsglobal.ZapiszDoLogow('SQL POZ '+SQL,1)
                stat,dump,dump,dump = self.PolSQL.Execute(SQL, 1)         