# -*- coding: iso8859_2 -*-
# -------------------------------------------------------------------------------
# Name:        fs_kp_dane_osobowe_kary
# Purpose:     usuwanie/wyswietlanie danych o karach pracownika
# Author:      Pawe Wjcikowski
# Created:     2010/08/24
# RCS-ID:      $Id: fs_kp_dane_osobowe_kary.py $
# Copyright:   (c) 2010 Record System
# Licence:     GNU GPL
# -------------------------------------------------------------------------------
# 2018-08-23  (10560) Aleksander Bargie - Refaktoryzacja

Pracownik     = klucze['Pracownik']
Fun           = klucze['Funkcja']
if Fun == 6:
    KaraId    = klucze['IdKary']
if Fun in (5, 6):
    DataNadaniaF  = rsglobal.Dekoduj(klucze['DataNadania'])
    DataWaznosciF = rsglobal.Dekoduj(klucze['DataWaznosci'])
    RodzajF       = rsglobal.Dekoduj(klucze['RodzajKary'])
if Fun in (5, 6):
    Klucze_Id     = klucze['Klucze']
stat = 'OK'
dane = []
wyn1 = []

# spr. czy jest taka pozycja
sql = "SELECT rsf_kadry_dozwolony_modul('"+self.firma_id+"','"+str(self.operator_id)+"','kary','"+Pracownik+"');"
stat, Dane, dump, dump = self.PolSQL.Execute(sql, 3)
if stat == 'OK':
    if Dane[0][0] != 'OK':
        stat = Dane[0][0]
        dane.append(stat)
else:
    stat = 'Problemy przy sprawdzaniu uprawnie do wybranego moduu :'+stat
    dane.append(stat)

UprUsuwanie = ((self.oddzial_id, '052154') in self.uprawnienia or self.operator_id == STANDARD_OPERATOR_ID)


# -------------------------------------------------------------------------------
# --- SPRAWDZENIE DAT W FILTRZE - 5,6
# -------------------------------------------------------------------------------

if Fun in (5, 6) and stat == 'OK':
    if DataNadaniaF != '    -  -  ':
        if not rsglobal.SprawdzCzyToData(DataNadaniaF):
            stat = 'Bdna data nadania w filtrze'
            dane.append(stat)  
    elif DataWaznosciF != '    -  -  ':
        if not rsglobal.SprawdzCzyToData(DataWaznosciF):
            stat = 'Bdna data wanoci w filtrze'
            dane.append(stat)  
                                                 

# -------------------------------------------------------------------------------
# --- DELETE - 6
# -------------------------------------------------------------------------------

if Fun == 6 and stat == 'OK':
    if not UprUsuwanie:
        stat = 'Brak uprawnie do usuwania kar pracownika.'
    if stat == 'OK':
        sql  = "DELETE FROM rs_kp_dane_osobowe_kary"
        sql += " WHERE firma_id = '"+self.firma_id+"' AND pracownik_id = '"+str(Pracownik)+"'"
        sql += " AND kara_id = '"+str(KaraId)+"';"
        sql += " UPDATE rs_kp_dane_osobowe_kary"
        sql += " SET kara_id=kara_id-1 WHERE firma_id='"+self.firma_id+"' AND pracownik_id = '"+str(Pracownik)+"'"
        sql += " AND kara_id > '"+str(KaraId)+"';"
        stat, dump, dump, dump = self.PolSQL.Execute(sql, 1)
        if stat != 'OK':
            stat = 'Bd usuwania kary pracownika : '+stat
            dane.append(stat)
            

# -------------------------------------------------------------------------------
# --- POBRANIE DANYCH ( 5-select, 6 -delete)
# -------------------------------------------------------------------------------

if Fun in (5, 6) and stat == 'OK':
    FILTR = "(kp.firma_id = '"+self.firma_id+"' AND kp.pracownik_id = '"+Pracownik+"'"
    if DataNadaniaF != '    -  -  ':
        FILTR += " AND kp.data_nadania <= '"+DataNadaniaF+"' "
    if DataWaznosciF != '    -  -  ':
        FILTR += " AND kp.data_waznosci <= '"+DataWaznosciF+"'"
    if RodzajF != '':
        FILTR += " AND kp.kara_rodzaj = '"+RodzajF+"' "
    FILTR += ")"

    # uzupelnienie podgladu o klucze nowe lub zmienione
    if len(Klucze_Id) > 0:
        FILTR += " OR (kp.firma_id = '"+self.firma_id+"' AND kp.pracownik_id = '"+Pracownik+"' AND kp.kara_id IN ("
        for i in xrange(len(Klucze_Id)):
            if i > 0:
                FILTR += ","
            FILTR += "'"+str(Klucze_Id[i])+"'"
        FILTR += "))"    
    
    SELECT  = "SELECT kp.kara_rodzaj,k.opis,kp.data_nadania,COALESCE(kp.data_waznosci::text,'')  AS data_waznosci, "
    SELECT += "COALESCE(kp.tresc,'') AS tresc,kp.kara_id FROM rs_kp_dane_osobowe_kary kp"
    SELECT += " LEFT OUTER JOIN rs_rodzaje_kar k ON (kp.firma_id=k.firma_id AND kp.kara_rodzaj=k.kod) "
    SELECT += " WHERE "+FILTR+" ORDER BY kp.kara_id ;"    
    stat, dane, wyn1, dump = self.PolSQL.Execute(SELECT, 3)
    if stat != 'OK':
        stat = 'Bd pobrania danych o karach pracownika : '+stat
        dane.append(stat)
