# -*- coding: iso8859_2 -*-
# -------------------------------------------------------------------------------
# Name:        fs_kp_dane_osobowe_kwalifikacje.py
# Purpose:     grid z biezacymi kwalifikacjami pracownika
# Author:      Pawe Wjcikowski
# Created:     2010/07/19
# RCS-ID:      $Id: fs_kp_dane_osobowe_kwalifikacje.py $
# Copyright:   (c) 2018 Record System
# Licence:     GNU GPL
# -------------------------------------------------------------------------------
# 2018-03-22 Piotr Witkowski (10561) Refaktoryzacja


stat = 'OK'

if not 'Funkcja' in klucze:
    stat = 'Brak podanej funkcji w kluczach'

if stat == 'OK':
    Funkcja = klucze['Funkcja']
    SlPar = {
        'Pracownik': [5, 6, 10],
        'Kwalifikacja': [6, ],
        'DataUkonczenia': [6, ],
    }

    Lista = rsglobal.SprawdzParametryWKluczach(SlPar, Funkcja, klucze)
    if Lista != '':
        stat = 'Uwaga : wywoanie funkcji fs_kp_dane_osobowe_kwalifikacje z numerem '
        stat += str(Funkcja) + ' bez parametrw: ' + Lista

if stat == 'OK':
    dane = []
    wyn1 = []
    wyn2 = []

    if Funkcja in [5, 6, 10, ]:
        Pracownik = klucze['Pracownik']
    if Funkcja in [6, ]:
        Kwalifikacja = klucze['Kwalifikacja']
        DataUkonczenia = klucze['DataUkonczenia']

if stat == 'OK':
    # spr. czy jest taka pozycja
    sql = "SELECT rsf_kadry_dozwolony_modul('" + self.firma_id + "','"
    sql += str(self.operator_id) + "','kwalifikacje','" + Pracownik + "');"
    stat, Dane, dump, dump = self.PolSQL.Execute(sql, 3)
    if stat == 'OK':
        if Dane[0][0] != 'OK':
            stat = Dane[0][0]
            dane.append(stat)
    else:
        stat = 'Problemy przy sprawdzaniu uprawnie do wybranego moduu :' + stat
        dane.append(stat)

    UprUsuwanie = ((self.oddzial_id, '052124') in self.uprawnienia or self.operator_id == STANDARD_OPERATOR_ID)

# -------------------------------------------------------------------------------
# --- DELETE - 6
# -------------------------------------------------------------------------------

if stat == 'OK' and Funkcja == 6:
    if not UprUsuwanie:
        stat = 'Brak uprawnie do usuwania kwalifikacji pracownika.'
    if stat == 'OK':
        DELETE = "DELETE FROM rs_kp_dane_osobowe_kwalifikacje"
        DELETE += " WHERE firma_id = '" + self.firma_id + "' AND pracownik_id = '" + str(Pracownik) + "'"
        DELETE += " AND kwalifikacja_id = '" + str(Kwalifikacja) + "' "
        DELETE += " AND data_ukonczenia = '" + str(DataUkonczenia) + "';"
        stat, dump, dump, dump = self.PolSQL.Execute(DELETE, 1)
        if stat != 'OK':
            stat = 'Bd usuwania kwalifikacji pracownika : ' + stat

# -------------------------------------------------------------------------------
# ---- SELECT - 5,6  Pobieranie listy historycznych zatrudnien
# -------------------------------------------------------------------------------

if stat == 'OK' and Funkcja in [5, 6]:
    SQL = "SELECT kwalifikacja_id,data_ukonczenia,data_waznosci,coalesce(opis,'')"
    SQL += " FROM rs_kp_dane_osobowe_kwalifikacje WHERE firma_id = '" + self.firma_id + "'"
    SQL += " AND pracownik_id = '" + str(Pracownik) + "';"
    stat, dane, wyn1, dump = self.PolSQL.Execute(SQL, 3)
    if stat != 'OK':
        stat = 'Bd pobrania listy kwalifikacji pracownika : ' + stat
