# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_kp_dane_osobowe_nagrody
# Purpose:     usuwanie/wyswietlanie danych o nagrodach pracownika
# Author:      Pawe Wjcikowski
# Created:     2010/08/24
# RCS-ID:      $Id: fs_kp_dane_osobowe_nagrody.py $
# Copyright:   (c) 2010 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

Pracownik = klucze[0]
NagrodaId = klucze[1]
DataNadaniaF = rsglobal.Dekoduj(klucze[2][0]) #parametry filtra
RodzajF = rsglobal.Dekoduj(klucze[2][1]) 
Klucze_Id = klucze[3]
Fun = klucze[-1]
stat = 'OK'
dane = []
wyn1 = []

#spr. czy jest taka pozycja
sql ="SELECT rsf_kadry_dozwolony_modul('"+self.firma_id+"','"+str(self.operator_id)+"','nagrody','"+Pracownik+"');"
stat,Dane,dump,dump = self.PolSQL.Execute(sql,3)
if stat == 'OK':
    if Dane[0][0]<>'OK':       
        stat = Dane[0][0]
        dane.append(stat)
else:
    stat='Problemy przy sprawdzaniu uprawnie do wybranego moduu :'+stat
    dane.append(stat)

UprUsuwanie = ((self.oddzial_id,'052144') in self.uprawnienia or self.operator_id == STANDARD_OPERATOR_ID)


#-------------------------------------------------------------------------------
#--- SPRAWDZENIE DAT W FILTRZE - 5,6
#-------------------------------------------------------------------------------

if Fun in (5,6) and stat == 'OK':
    if DataNadaniaF <> '    -  -  ':
        if not rsglobal.SprawdzCzyToData(DataNadaniaF):
            stat='Bdna data nadania w filtrze'
            dane.append(stat) 


#-------------------------------------------------------------------------------
#--- DELETE - 6
#-------------------------------------------------------------------------------

if Fun == 6 and stat == 'OK':
    if not UprUsuwanie:
        stat='Brak uprawnie do usuwania.'
    if stat == 'OK':
        sql ="DELETE FROM rs_kp_dane_osobowe_nagrody"
        sql+=" WHERE firma_id = '"+self.firma_id+"' AND pracownik_id = '"+str(Pracownik)+"'"
        sql+=" AND nagroda_id = '"+str(NagrodaId)+"';" 
        sql+=" UPDATE rs_kp_dane_osobowe_nagrody"
        sql+=" SET nagroda_id=nagroda_id-1 WHERE firma_id='"+self.firma_id+"' AND pracownik_id = '"+str(Pracownik)+"'"
        sql+=" AND nagroda_id > '"+str(NagrodaId)+"';" 
        stat,dump,dump,dump = self.PolSQL.Execute(sql, 1)
        if stat <> 'OK':
            stat='Bd usuwania nagrody pracownika : '+stat
            dane.append(stat)
            

#-------------------------------------------------------------------------------
#--- POBRANIE DANYCH ( 5-select, 6 -delete)
#-------------------------------------------------------------------------------

if Fun in (5,6) and stat=='OK':
    FILTR ="(kp.firma_id = '"+self.firma_id+"' AND kp.pracownik_id = '"+Pracownik+"'"
    if DataNadaniaF <> '    -  -  ':
        FILTR += " AND kp.data_nadania <= '"+DataNadaniaF+"' "   
    if RodzajF <> '':
        FILTR += " AND kp.nagroda_rodzaj = '"+RodzajF+"' "
    FILTR += ")"

    #uzupelnienie podgladu o klucze nowe lub zmienione
    if len(Klucze_Id) > 0:
        FILTR+= " OR (kp.firma_id = '"+self.firma_id+"' AND kp.nagroda_id IN ("
        for i in xrange(len(Klucze_Id)):
            if i > 0:
                FILTR += ","
            FILTR += "'"+str(Klucze_Id[i])+"'"
        FILTR += "))"        
        
    SELECT ="SELECT kp.nagroda_rodzaj,n.opis,kp.data_nadania,kp.wartosc,COALESCE(kp.tresc,''),kp.nagroda_id FROM rs_kp_dane_osobowe_nagrody kp"
    SELECT+=" LEFT OUTER JOIN rs_rodzaje_nagrod n ON (kp.firma_id=n.firma_id AND kp.nagroda_rodzaj=n.kod) "
    SELECT+=" WHERE "+FILTR+" ORDER BY kp.nagroda_id ;"
    stat,dane,wyn1,dump = self.PolSQL.Execute(SELECT,3)
    if stat <> 'OK':
        stat = 'Bd pobrania danych o nagrodach pracownika : '+stat
        dane.append(stat)