# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_kp_dane_osobowe_nagrody_dane
# Purpose:     dodawanie/edycja danych o nagrodach pracownika
# Author:      Pawe Wjcikowski
# Created:     2010/08/24
# RCS-ID:      $Id: fs_kp_dane_osobowe_nagrody_dane.py $
# Copyright:   (c) 2010 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

Pracownik = klucze[0]
NagrodaId = klucze[1]
Fun = klucze[-1]
stat = 'OK'
dane = []
wyn1 = []
wyn2 = []
Numer=0
DataNadania = '    -  -  '
Rok1=0
Rok2=0
Rok3=0
Miesiac1=2000
Miesiac2=2000
Miesiac3=2000

UprDodawanie = (((self.oddzial_id,'052143') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID))
UprEdycja = (((self.oddzial_id,'052142') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)) or UprDodawanie


#-------------------------------------------------------------------------------
#---   SPRAWDZENIE UPRAWNIEN
#-------------------------------------------------------------------------------

if Fun in (1,2) and stat == 'OK':
    if not UprDodawanie:
        stat = 'BR UPR INS'

if Fun in (3,4) and stat == 'OK':
    if not UprEdycja:
        stat = 'BR UPR UPD'
        

#-------------------------------------------------------------------------------
#--- POBRANIE NUMERU ( 9 - pobranie nowego numeru)
#-------------------------------------------------------------------------------

if Fun ==9:
    SELECT ="SELECT nagroda_id FROM rs_kp_dane_osobowe_nagrody"
    SELECT+=" WHERE firma_id = '"+self.firma_id+"' AND pracownik_id = '"+str(Pracownik)+"' "
    SELECT+=" ORDER BY nagroda_id DESC LIMIT 1;"
    stat,dane,wyn1,dump = self.PolSQL.Execute(SELECT,3)
    if stat <> 'OK':
        stat = 'Bd pobrania danych o nowym id nagrody : '+stat
        dane.append(stat)
    if stat=='OK':
        if len(dane)<>0:
            Numer=int(dane[0][0])+1
        else:
            Numer=1
            
        dane=str(Numer)


#-------------------------------------------------------------------------------
#--- SPRAWDZENIE DANYCH (1,2,3,4) - bez 5 (pobieranie)
#-------------------------------------------------------------------------------

if Fun in (1,2,3,4) and stat == 'OK':               
    for i in range(len(pola)):
        pole = pola[i]
        wart = wartosci[i]   
        if pole == 'nagroda_rodzaj':
            if wart == '':
                stat='BR_NRODZ'
            else:
                sql ="SELECT kod FROM rs_rodzaje_nagrod"
                sql+=" WHERE firma_id = '"+self.firma_id+"' AND kod = '"+str(wart)+"';"
                stat,d,dump,dump = self.PolSQL.Execute(sql, 3)
                if stat <> 'OK':
                    dane.append('Bd pobrania rodzaju nagrody : '+stat)
                elif len(d) == 0:
                    dane.append('BL_NRODZ')        
          
        elif pole == 'data_nadania':
            if wart <> '    -  -  ':
                if not rsglobal.SprawdzCzyToData(wart):
                    dane.append('BL DATA_NAD')
            else:    
                stat='BR DATA_NAD'
                dane.append(stat)    
            DataNadania=wart         
           
        elif pole == 'tresc':
            if len(wart) > 100:
                stat='DL_TRESC'
                dane.append(stat)

    if len(dane) > 0:
        stat = dane[0]
    
    
#-------------------------------------------------------------------------------
#--- DODAWANIE DANYCH (1 -z pobraniem select  2 - bez pobrania
#-------------------------------------------------------------------------------

if Fun in (1,2) and stat == 'OK':
    #wypelnienie 3 ostatnich miesiecy
    #data nadania wypelniona
    Rok=str(DataNadania[:4])
    Miesiac=str(DataNadania[5:7])
    #trzy mozliwosci zmian 
    if str(Miesiac)=='03': # jesli miesiac 3 
        Rok1=Rok
        Miesiac1=int(Miesiac)-1
        Rok2=Rok
        Miesiac2=int(Miesiac)-2
        Rok3=int(Rok)-1
        Miesiac3=12
    elif str(Miesiac)=='02': # jesli miesiac 2
        Rok1=Rok
        Miesiac1=int(Miesiac)-1
        Rok2=int(Rok)-1
        Miesiac2=12
        Rok3=int(Rok)-1
        Miesiac3=11        
    elif str(Miesiac)=='01': # jesli styczen 01
        Rok1=int(Rok)-1
        Miesiac1=12
        Rok2=int(Rok)-1
        Miesiac2=11
        Rok3=int(Rok)-1
        Miesiac3=10       
    else:                    # reszta
        Rok1=Rok
        Miesiac1=int(Miesiac)-1
        Rok2=Rok
        Miesiac2=int(Miesiac)-2
        Rok3=Rok
        Miesiac3=int(Miesiac)-3         
    
    ins = "INSERT INTO rs_kp_dane_osobowe_nagrody"
    Pola="firma_id,pracownik_id,nagroda_id,rok1,miesiac1,rok2,miesiac2,rok3,miesiac3"
    Wartosci="'"+self.firma_id+"','"+Pracownik+"','"+str(NagrodaId)+"','"+str(Rok1)+"','"+str(Miesiac1)+"'"
    Wartosci+=",'"+str(Rok2)+"','"+str(Miesiac2)+"','"+str(Rok3)+"','"+str(Miesiac3)+"'"
    for i in range(len(pola)):
        pole = pola[i]
        wart = wartosci[i]
        if pole in ['tresc','nagroda_rodzaj','data_nadania']:
            Pola= Pola+","+pole
            if wart.strip()=='' or wart=='    -  -  ':
                Wartosci= Wartosci+",NULL"                
            else:
                Wartosci= Wartosci+",'"+str(wart)+"'"  
        elif pole in ['lista_id','wartosc']:
            Pola= Pola+","+pole
            if wart=='':
                Wartosci= Wartosci+",NULL"                
            else:
                Wartosci= Wartosci+",'"+str(wart)+"'"                             
    ins = ins+" ("+Pola+") VALUES ("+Wartosci+");"        
    stat,dump,dump,dump = self.PolSQL.Execute(ins ,1)
    if stat<>'OK':
        stat = 'Bdy dodawania danych:'+stat
        dane.append(stat)  
        
          
#-------------------------------------------------------------------------------
#--- UPDATE DANYCH ( 3-select, 4 -update z pobraniem)
#-------------------------------------------------------------------------------

if Fun in (3,4) and stat == 'OK':
    UPDATE = "UPDATE rs_kp_dane_osobowe_nagrody SET "
    for i in xrange(len(pola)):
        pole = pola[i]
        wart = wartosci[i]
        UPDATE += pole+"='"+str(wart)+"',"

    UPDATE = UPDATE[:-1]
    UPDATE+=" WHERE firma_id = '"+self.firma_id+"' AND pracownik_id = '"+str(Pracownik)+"' "
    UPDATE+=" AND nagroda_id = '"+str(NagrodaId)+"';"
    stat,dump,dump,dump = self.PolSQL.Execute(UPDATE ,1)
    if stat <> 'OK':
        stat = 'Bd modyfikacji uprawnienia dot.kadr : '+stat


#-------------------------------------------------------------------------------
#--- POBRANIE DANYCH ( 5 - select, 3 - update z pobraniem)
#-------------------------------------------------------------------------------

if Fun in (1,3,5) and stat=='OK':
    SELECT ="SELECT * FROM rs_kp_dane_osobowe_nagrody"
    SELECT+=" WHERE firma_id = '"+self.firma_id+"' AND pracownik_id = '"+str(Pracownik)+"' "
    SELECT+=" AND nagroda_id = '"+str(NagrodaId)+"';"
    stat,dane,wyn1,dump = self.PolSQL.Execute(SELECT,3)
    if stat <> 'OK':
        stat = 'Bd pobrania danych o nagrodach pracownika : '+stat
        dane.append(stat)
    kw=''
    if stat == 'OK' and len(dane) == 1:
        tr = rssql.RSTableRowset(dane,wyn1)
        if (self.oddzial_id,'011830') in self.uprawnienia or self.operator_id == STANDARD_OPERATOR_ID:
            sql = "SELECT opis FROM rs_rodzaje_nagrod WHERE kod = '"+tr.GetVal(0,"nagroda_rodzaj")+"';"
            stat,d,dump,dump = self.PolSQL.Execute(sql, 3)
            if stat <> 'OK':
                kw = 'Bd pobrania opisu ze sownika rodzajw nagrd : '+stat
            else:
                if len(d) == 0:
                    kw = 'Bdny rodzaj nagrody.'
                else:
                    kw = str(d[0][0])
        else:
            kw = 'Brak uprawnie do sownika. Poinformuj administratora.'
    wyn2 = [kw]