#!/usr/bin/python
# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_kp_dane_osobowe_staz_pracy.py
# Purpose:     pobieranie i usuwanie wartosci z grida
# Author:      Konrad Opieka
# Created:     2015-05-19
# RCS-ID:      $Id: fs_kp_dane_osobowe_staz_pracy.py $
# Copyright:   (c) 2015 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

stat='OK'

if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=='OK':
    Funkcja = klucze['Funkcja']
    
    SlPar={'Pracownik':[5],'Data':[5]}
    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Funkcja,klucze)
    if Lista<>'':
        stat='Uwaga : wywoanie funkcji fs_kp_dane_osobowe_staz_pracy z numerem '+str(Fun)+' bez parametrw: '+Lista

if stat=='OK':
    if Funkcja in [5]:
        Pracownik = klucze['Pracownik']
        Data = klucze['Data']
        
dane = []
wyn1 = []
wyn2 = []
puste_pola = [[],"","    -  -  ",None,'None']

def DajDni(Dni):
    lat = Dni/365
    Tlat = ' lat '
    if lat == 1:
        Tlat = ' rok '
    elif lat > 1 and lat <5:
        Tlat = ' lata '
    mies = (Dni%365)/30
    Tmies = ' miesicy '
    if mies == 1:
        Tmies = ' miesic '
    elif mies >1 and mies < 5:
        Tmies = ' miesice '
    dni = (Dni%365)%30
    Tdni = ' dni'
    if dni == 1:
        Tdni = ' dzie'
    return str(lat)+Tlat+str(mies)+Tmies+str(dni)+Tdni
      

#-------------------------------------------------------------------------------
#--- POBRANIE DANYCH ( 5-select)
#-------------------------------------------------------------------------------

if Funkcja in (1,5) and stat=='OK':
    #Ta sama firma    
    SQL ="SELECT SUM(sum) FROM ( "
    SQL+="SELECT sum(do_kiedy-od_kiedy) FROM rs_kp_historia_zatrudnienia WHERE firma_id ='"+self.firma_id+"' "
    SQL+="AND pracownik_id='"+Pracownik+"' AND do_kiedy<='"+Data+"' AND ta_sama AND do_stazu UNION "
    SQL+="SELECT sum('"+Data+"'-od_kiedy) FROM rs_kp_historia_zatrudnienia WHERE firma_id='"+self.firma_id+"' "
    SQL+="AND pracownik_id='"+Pracownik+"' AND od_kiedy<'"+Data+"' AND do_kiedy>'"+Data+"' AND ta_sama AND do_stazu)s;"
    stat,DTaSt,wyn1,dump = self.PolSQL.Execute(SQL,3)
    rsglobal.ZapiszDoLogow('aaaaaaaaaaaaaaaa '+SQL,1)
    rsglobal.ZapiszDoLogow('cos '+str(DTaSt),1)
    if stat=='OK':
        if len(DTaSt)>0:
            STaSt=DTaSt[0][0]
        else:
            STaSt=0
            
    if stat=='OK':
        SQL ="SELECT SUM(sum) FROM ( "
        SQL+="SELECT sum(do_kiedy-od_kiedy) FROM rs_kp_historia_zatrudnienia WHERE firma_id ='"+self.firma_id+"' "
        SQL+="AND pracownik_id='"+Pracownik+"' AND do_kiedy<='"+Data+"' AND ta_sama AND do_jubileuszu UNION "
        SQL+="SELECT sum('"+Data+"'-od_kiedy) FROM rs_kp_historia_zatrudnienia WHERE firma_id='"+self.firma_id+"' "
        SQL+="AND pracownik_id='"+Pracownik+"' AND od_kiedy<'"+Data+"' AND do_kiedy>'"+Data+"' AND ta_sama AND do_jubileuszu)s;"
        stat,DTaJu,wyn1,dump = self.PolSQL.Execute(SQL,3)
        if stat=='OK':
            if len(DTaJu)>0:
                STaJu=DTaJu[0][0]
            else:
                STaJu=0
    
    if stat=='OK':
        SQL ="SELECT SUM(sum) FROM ( "
        SQL+="SELECT sum(do_kiedy-od_kiedy) FROM rs_kp_historia_zatrudnienia WHERE firma_id ='"+self.firma_id+"' "
        SQL+="AND pracownik_id='"+Pracownik+"' AND do_kiedy<='"+Data+"' AND ta_sama AND do_urlopu UNION "
        SQL+="SELECT sum('"+Data+"'-od_kiedy) FROM rs_kp_historia_zatrudnienia WHERE firma_id='"+self.firma_id+"' "
        SQL+="AND pracownik_id='"+Pracownik+"' AND od_kiedy<'"+Data+"' AND do_kiedy>'"+Data+"' AND ta_sama AND do_urlopu)s;"
        stat,DTaUr,wyn1,dump = self.PolSQL.Execute(SQL,3)
        if stat=='OK':
            if len(DTaUr)>0:
                STaUr=DTaUr[0][0]
            else:
                STaUr=0
    if stat=='OK':
        SQL ="SELECT SUM(sum) FROM ( "
        SQL+="SELECT sum(do_kiedy-od_kiedy) FROM rs_kp_historia_zatrudnienia WHERE firma_id ='"+self.firma_id+"' "
        SQL+="AND pracownik_id='"+Pracownik+"' AND do_kiedy<='"+Data+"' AND ta_sama AND do_emerytury UNION "
        SQL+="SELECT sum('"+Data+"'-od_kiedy) FROM rs_kp_historia_zatrudnienia WHERE firma_id='"+self.firma_id+"' "
        SQL+="AND pracownik_id='"+Pracownik+"' AND od_kiedy<'"+Data+"' AND do_kiedy>'"+Data+"' AND ta_sama AND do_emerytury)s;"
        stat,DTaEm,wyn1,dump = self.PolSQL.Execute(SQL,3)
        if stat=='OK':
            if len(DTaEm)>0:
                STaEm=DTaEm[0][0]
            else:
                STaEm=0
    
    #Ta sama branza
    if stat=='OK':
        SQL ="SELECT SUM(sum) FROM ( "
        SQL+="SELECT sum(do_kiedy-od_kiedy) FROM rs_kp_historia_zatrudnienia WHERE firma_id ='"+self.firma_id+"' "
        SQL+="AND pracownik_id='"+Pracownik+"' AND do_kiedy<='"+Data+"' AND branza AND do_stazu UNION "
        SQL+="SELECT sum('"+Data+"'-od_kiedy) FROM rs_kp_historia_zatrudnienia WHERE firma_id='"+self.firma_id+"' "
        SQL+="AND pracownik_id='"+Pracownik+"' AND od_kiedy<'"+Data+"' AND do_kiedy>'"+Data+"' AND branza AND do_stazu)s;"
        stat,DBrSt,wyn1,dump = self.PolSQL.Execute(SQL,3)
        if stat=='OK':
            if len(DBrSt)>0:
                SBrSt=DBrSt[0][0]
            else:
                SBrSt=0
    
    if stat=='OK':
        SQL ="SELECT SUM(sum) FROM ( "
        SQL+="SELECT sum(do_kiedy-od_kiedy) FROM rs_kp_historia_zatrudnienia WHERE firma_id ='"+self.firma_id+"' "
        SQL+="AND pracownik_id='"+Pracownik+"' AND do_kiedy<='"+Data+"' AND branza AND do_jubileuszu UNION "
        SQL+="SELECT sum('"+Data+"'-od_kiedy) FROM rs_kp_historia_zatrudnienia WHERE firma_id='"+self.firma_id+"' "
        SQL+="AND pracownik_id='"+Pracownik+"' AND od_kiedy<'"+Data+"' AND do_kiedy>'"+Data+"' AND branza AND do_jubileuszu)s;"      
        stat,DBrJu,wyn1,dump = self.PolSQL.Execute(SQL,3)
        if stat=='OK':
            if len(DBrJu)>0:
                SBrJu=DBrJu[0][0]
            else:
                SBrJu=0
    
    if stat=='OK':
        SQL ="SELECT SUM(sum) FROM ( "
        SQL+="SELECT sum(do_kiedy-od_kiedy) FROM rs_kp_historia_zatrudnienia WHERE firma_id ='"+self.firma_id+"' "
        SQL+="AND pracownik_id='"+Pracownik+"' AND do_kiedy<='"+Data+"' AND branza AND do_urlopu UNION "
        SQL+="SELECT sum('"+Data+"'-od_kiedy) FROM rs_kp_historia_zatrudnienia WHERE firma_id='"+self.firma_id+"' "
        SQL+="AND pracownik_id='"+Pracownik+"' AND od_kiedy<'"+Data+"' AND do_kiedy>'"+Data+"' AND branza AND do_urlopu)s;" 
        stat,DBrUr,wyn1,dump = self.PolSQL.Execute(SQL,3)
        if stat=='OK':
            if len(DBrUr)>0:
                SBrUr=DBrUr[0][0]
            else:
                SBrUr=0
    
    if stat=='OK':
        SQL ="SELECT SUM(sum) FROM ( "
        SQL+="SELECT sum(do_kiedy-od_kiedy) FROM rs_kp_historia_zatrudnienia WHERE firma_id ='"+self.firma_id+"' "
        SQL+="AND pracownik_id='"+Pracownik+"' AND do_kiedy<='"+Data+"' AND branza AND do_emerytury UNION "
        SQL+="SELECT sum('"+Data+"'-od_kiedy) FROM rs_kp_historia_zatrudnienia WHERE firma_id='"+self.firma_id+"' "
        SQL+="AND pracownik_id='"+Pracownik+"' AND od_kiedy<'"+Data+"' AND do_kiedy>'"+Data+"' AND branza AND do_emerytury)s;" 
        stat,DBrEm,wyn1,dump = self.PolSQL.Execute(SQL,3)
        if stat=='OK':
            if len(DBrEm)>0:
                SBrEm=DBrEm[0][0]
            else:
                SBrEm=0
    
    #Sumowanie po angaach biecych
    if stat=='OK':
        SQL ="SELECT SUM(do_kiedy - od_kiedy) FROM(SELECT firma_id,pracownik_id,od_kiedy, "
        SQL+="lead(od_kiedy) over (Partition by pracownik_id Order by pracownik_id, od_kiedy) As do_kiedy "
        SQL+="FROM(SELECT firma_id,pracownik_id, od_kiedy FROM rs_kp_angaze WHERE firma_id ='"+self.firma_id+"' AND pracownik_id='"+Pracownik+"' UNION "
        SQL+="SELECT firma_id,pracownik_id,COALESCE(do_kiedy,'"+Data+"') FROM rs_kp_angaze "
        SQL+="WHERE firma_id ='"+self.firma_id+"' AND pracownik_id='"+Pracownik+"' UNION " 
        SQL+="SELECT firma_id,pracownik_id,'"+Data+"' FROM rs_kp_angaze WHERE firma_id ='"+self.firma_id+"' AND pracownik_id='"+Pracownik+"')x) x "
        SQL+="WHERE do_kiedy is not NULL AND EXISTS (SELECT 1 FROM rs_kp_angaze t "
        SQL+="WHERE firma_id ='"+self.firma_id+"' AND pracownik_id='"+Pracownik+"' AND "
        SQL+="(t.od_kiedy < x.do_kiedy AND COALESCE(t.do_kiedy,'"+Data+"') > x.od_kiedy "
        SQL+="AND '"+Data+"' > x.od_kiedy) OR (t.od_kiedy = x.od_kiedy "
        SQL+="AND COALESCE(t.do_kiedy,'"+Data+"') = x.do_kiedy AND '"+Data+"' >= x.do_kiedy)) "
        SQL+="AND firma_id ='"+self.firma_id+"' AND pracownik_id='"+Pracownik+"';"
        stat,DAng,wyn1,dump = self.PolSQL.Execute(SQL,3)
        if stat=='OK':
            if len(DAng)>0:
                SAng=DAng[0][0]
            else:
                SAng=0
    
    #Sumowanie czne dla stazu
    if stat=='OK':
        SQL ="SELECT SUM(sum) FROM ( "
        SQL+="SELECT sum(do_kiedy-od_kiedy) FROM rs_kp_historia_zatrudnienia WHERE firma_id ='"+self.firma_id+"' "
        SQL+="AND pracownik_id='"+Pracownik+"' AND do_kiedy<='"+Data+"' AND do_stazu UNION "
        SQL+="SELECT sum('"+Data+"'-od_kiedy) FROM rs_kp_historia_zatrudnienia WHERE firma_id='"+self.firma_id+"' "
        SQL+="AND pracownik_id='"+Pracownik+"' AND od_kiedy<'"+Data+"' AND do_kiedy>'"+Data+"' AND do_stazu)s;" 
        stat,DLaSt,wyn1,dump = self.PolSQL.Execute(SQL,3)
        if stat=='OK':
            if len(DLaSt)>0:
                SLaSt=DLaSt[0][0]
            else:
                SLaSt=0
                
    #Sumowanie czne dla jubileuszu
    if stat=='OK':
        SQL ="SELECT SUM(sum) FROM ( "
        SQL+="SELECT sum(do_kiedy-od_kiedy) FROM rs_kp_historia_zatrudnienia WHERE firma_id ='"+self.firma_id+"' "
        SQL+="AND pracownik_id='"+Pracownik+"' AND do_kiedy<='"+Data+"' AND do_jubileuszu UNION "
        SQL+="SELECT sum('"+Data+"'-od_kiedy) FROM rs_kp_historia_zatrudnienia WHERE firma_id='"+self.firma_id+"' "
        SQL+="AND pracownik_id='"+Pracownik+"' AND od_kiedy<'"+Data+"' AND do_kiedy>'"+Data+"' AND do_jubileuszu)s;" 
        stat,DLaJu,wyn1,dump = self.PolSQL.Execute(SQL,3)
        if stat=='OK':
            if len(DLaJu)>0:
                SLaJu=DLaJu[0][0]
            else:
                SLaJu=0
                
    #Sumowanie czne dla urlopu
    if stat=='OK':
        SQL ="SELECT SUM(sum) FROM ( "
        SQL+="SELECT sum(do_kiedy-od_kiedy) FROM rs_kp_historia_zatrudnienia WHERE firma_id ='"+self.firma_id+"' "
        SQL+="AND pracownik_id='"+Pracownik+"' AND do_kiedy<='"+Data+"' AND do_urlopu UNION "
        SQL+="SELECT sum('"+Data+"'-od_kiedy) FROM rs_kp_historia_zatrudnienia WHERE firma_id='"+self.firma_id+"' "
        SQL+="AND pracownik_id='"+Pracownik+"' AND od_kiedy<'"+Data+"' AND do_kiedy>'"+Data+"' AND do_urlopu)s;" 
        stat,DLaUr,wyn1,dump = self.PolSQL.Execute(SQL,3)
        if stat=='OK':
            if len(DLaUr)>0:
                SLaUr=DLaUr[0][0]
            else:
                SLaUr=0
                
    #Sumowanie czne dla emerytury
    if stat=='OK':
        SQL ="SELECT SUM(sum) FROM ( "
        SQL+="SELECT sum(do_kiedy-od_kiedy) FROM rs_kp_historia_zatrudnienia WHERE firma_id ='"+self.firma_id+"' "
        SQL+="AND pracownik_id='"+Pracownik+"' AND do_kiedy<='"+Data+"' AND do_emerytury UNION "
        SQL+="SELECT sum('"+Data+"'-od_kiedy) FROM rs_kp_historia_zatrudnienia WHERE firma_id='"+self.firma_id+"' "
        SQL+="AND pracownik_id='"+Pracownik+"' AND od_kiedy<'"+Data+"' AND do_kiedy>'"+Data+"' AND do_emerytury)s;" 
        stat,DLaEm,wyn1,dump = self.PolSQL.Execute(SQL,3)
        if stat=='OK':
            if len(DLaEm)>0:
                SLaEm=DLaEm[0][0]
            else:
                SLaEm=0
                
    if stat=='OK':
        DajDni(SAng)
        dane = [[u'Biece',DajDni(SAng),DajDni(SAng),DajDni(SAng),DajDni(SAng)]]
        dane.append([u'Firma',DajDni(int(STaSt+SAng)),DajDni(int(STaJu+SAng)),DajDni(int(STaUr+SAng)),DajDni(int(STaEm+SAng))])
        dane.append([u'Brana',DajDni(int(SBrSt+SAng)),DajDni(int(SBrJu+SAng)),DajDni(int(SBrUr+SAng)),DajDni(int(SBrEm+SAng))])
        dane.append([u'czne',DajDni(int(SLaSt+SAng)),DajDni(int(SLaJu+SAng)),DajDni(int(SLaUr+SAng)),DajDni(int(SLaEm+SAng))])
        