# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_kp_grafik_panowany_dodawanie
# Purpose:     dodawanie grafikw planowanych
# Author:      Marcin Natkaski
# Created:     2015/06/026
# RCS-ID:      $Id: fs_kp_grafik_planowany_dodawanie.py $
# Copyright:   (c) 2015 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

#KU PAMIECI!!! CZY NIE POWINNISMY POBIERAC STANOWISKO_MIEJSCE_ID Z ANGAZY?

from datetime import datetime, timedelta

stat='OK'
INS=""
if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=='OK':
    Funkcja = klucze['Funkcja']
    
    SlPar={'DataDo':[1,],'DataOd':[1,]}    
    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Funkcja,klucze)
    if Lista<>'':
        stat='Uwaga : wywoanie funkcji fs_kp_grafik_planowany_dodawanie z numerem '+str(Funkcja)+' bez parametrw: '+Lista

if stat=='OK':    
    if Funkcja in [1,]:
        DataOd = rsglobal.Dekoduj(klucze['DataOd'])
        DataDo = rsglobal.Dekoduj(klucze['DataDo'])

UprDodawanie = (((self.oddzial_id,'052073') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID))

#-------------------------------------------------------------------------------
#---   SPRAWDZENIE UPRAWNIEN
#-------------------------------------------------------------------------------

if Funkcja in (1,) and stat == 'OK':
    if not UprDodawanie:
        stat = 'Brak uprawniedo dodawania'
        dane.append(stat)
        
#-------------------------------------------------------------------------------
#--- SPRAWDZENIE DANYCH (1,) 
#-------------------------------------------------------------------------------
if Funkcja in (1,) and stat == 'OK':
    SQL= "SELECT substring(plan_czas_od::TEXT from 1 for 10) FROM rs_kp_grafiki_pozycje WHERE "
    SQL+=" firma_id='"+self.firma_id+"' AND "
    SQL+=" plan_czas_od::DATE>='"+DataOd+"'::DATE AND plan_czas_do::DATE<='"+DataDo+"'::DATE AND stan='Z' "
    #rsglobal.ZapiszDoLogow("SQL sprawdzenie:" + SQL,1)
    stat,stanz,dump,dump = self.PolSQL.Execute(SQL ,3)
    if stat<>'OK':
        dane.append('Bdy sprawdzania stanu listy obecnoci') 
    elif len(stanz)>0:
        lista_stanz = [list(x) for x in set(tuple(x) for x in stanz)]
        komunikat = ''
        for i in lista_stanz:
            komunikat+=i[0]+'\n'
        dane.append("Nie mona utworzy grafiku - istniej zamknite zapisy dla dat:\n"+komunikat+" ")
    
    if DataDo == '    -  -  ':
        dane.append('Brak daty do')
    elif not rsglobal.SprawdzCzyToData(DataDo):
        dane.append('Bdna data do')
        
    if DataOd == '    -  -  ':
        dane.append('Brak daty od')
    elif not rsglobal.SprawdzCzyToData(DataOd):
        dane.append('Bdna data od')
        
    if len(dane) > 0:
        stat = dane[0]
    

#-------------------------------------------------------------------------------
#--- DODAWANIE DANYCH (1 -z pobraniem select  2 - bez pobrania
#-------------------------------------------------------------------------------

if Funkcja in (1,) and stat == 'OK':
    #pobieramy dane PENE dane dla grafikw za podany okres
    SQL= "SELECT DISTINCT pracownik_id, plan_czas_od, plan_czas_do FROM rs_kp_grafiki_pozycje WHERE firma_id='"+self.firma_id+"' "
    SQL+=" AND plan_czas_od::DATE>= '"+DataOd+"' AND plan_czas_do::DATE<='"+DataDo+"';"
    #rsglobal.ZapiszDoLogow("SQL pobranie 1:" + SQL,1)
    stat,dane_grafikow,dump,dump = self.PolSQL.Execute(SQL ,3)
    if stat <> 'OK':
        dane.append(stat)
    #Zamieniamy listy tak, eby poprawi date_do, jeeli zmiana przechodzi przez pnoc
    for k in dane_grafikow:
        if k[1].strip()[-8:]>k[2].strip()[-8:]:
            data=datetime.strptime(k[1].strip()[:10], "%Y-%m-%d")
            data=data = data+timedelta(days=1)
            data = str(data.date())
            k[2] = data+' '+k[2][-8:]
        k[2] = datetime.strptime(k[2], "%Y-%m-%d %H:%M:%S")

    # Sprawdzamy czy wypenione miejsce
    if stat == 'OK':
        SQL=" SELECT pracownik_id, zatrudnienie_id, umowa_id,angaz_id"
        SQL+=" FROM rs_kp_angaze WHERE firma_id='"+self.firma_id+"' AND "
        SQL+=" kalendarz_id IS NOT NULL AND (do_kiedy>='"+DataDo+"' OR do_kiedy IS NULL) "    #TODO do_kiedy powinno by <=
        SQL+=" AND (miejsce_id is null OR trim(miejsce_id)='') ; "                              #TODO co to za warunek?
        #rsglobal.ZapiszDoLogow("SQL miejsce 2:" + SQL,1)
        stat,miejsce,dump,dump = self.PolSQL.Execute(SQL ,3)
        if stat <> 'OK':
            stat='Bdy sprawdzania wypenienia stanowisko-miejsce'
            dane.append(stat)
        if len(miejsce)>0:
            stat='Brak wypenionego miejsca pracy dla: \n'
            for i in miejsce:
                stat+='Pracownik: '+i[0]+' zatr: '+str(i[1])+' umowa: '+str(i[2])+' anga: '+str(i[3])+'\n'
            dane.append(stat)

    # Sprawdzamy czy wypenione stanowiska
    if stat == 'OK':
        SQL=" SELECT pracownik_id, zatrudnienie_id, umowa_id,angaz_id"
        SQL+=" FROM rs_kp_angaze WHERE firma_id='"+self.firma_id+"' AND "
        SQL+=" kalendarz_id IS NOT NULL AND (do_kiedy>='"+DataDo+"' OR do_kiedy IS NULL) "
        SQL+=" AND (stanowisko_id is null OR trim(stanowisko_id)='') ; "
        #rsglobal.ZapiszDoLogow("SQL stanowisko 3:" + SQL,1)
        stat,stanowisko,dump,dump = self.PolSQL.Execute(SQL ,3)

        if stat <> 'OK':
            stat='Bdy sprawdzania wypenienia stanowiska.'
            dane.append(stat)
        if len(stanowisko)>0:
            stat='Brak wypenionego stanowiska pracy dla: \n'
            for i in stanowisko:
                stat+='Pracownik: '+i[0]+' zatr: '+str(i[1])+' umowa: '+str(i[2])+' anga: '+str(i[3])+'\n'
            dane.append(stat)

    # Sprawdzamy czy wypenione stanowiska miejsca
    if stat == 'OK':
        SQL=" SELECT pracownik_id, zatrudnienie_id, umowa_id,angaz_id"
        SQL+=" FROM rs_kp_angaze WHERE firma_id='"+self.firma_id+"' AND "
        SQL+=" kalendarz_id IS NOT NULL AND (do_kiedy>='"+DataDo+"' OR do_kiedy IS NULL) "
        SQL+=" AND (stanowisko_miejsce_id is null OR trim(stanowisko_miejsce_id)=''); "
        #rsglobal.ZapiszDoLogow("SQL stanowisko-miejsce 4:" + SQL,1)
        stat,stanowisko_miejsce,dump,dump = self.PolSQL.Execute(SQL ,3)

        if stat <> 'OK':
            stat='Bdy sprawdzania wypenienia stanowiska miejsca.'
            dane.append(stat)
        if len(stanowisko_miejsce)>0:
            stat='Brak wypenionego stanowiska pracy miejsca dla: \n'
            for i in stanowisko_miejsce:
                stat+='Pracownik: '+i[0]+' zatr: '+str(i[1])+' umowa: '+str(i[2])+' anga: '+str(i[3])+'\n'
            dane.append(stat)

    if stat=='OK':
        #pobieramy pracownikw z danymi z angay, jeeli nie ma nic to przerywam
        SQL=" SELECT pracownik_id, kalendarz_id, miejsce_id, stanowisko_id, "
        SQL+=" CASE WHEN od_kiedy <= '"+DataOd+"' THEN '"+DataOd+"' "
        SQL+=" WHEN od_kiedy >= '"+DataOd+"' AND od_kiedy <='"+DataDo+"' THEN od_kiedy END, "
        SQL+=" CASE WHEN do_kiedy IS NULL THEN '9999-12-31' "
        SQL+=" WHEN do_kiedy<='"+DataDo+"' THEN do_kiedy END , stanowisko_miejsce_id"
        SQL+=" FROM rs_kp_angaze WHERE firma_id='"+self.firma_id+"' AND "
        SQL+=" kalendarz_id IS NOT NULL AND (do_kiedy>='"+DataDo+"' OR do_kiedy IS NULL); "
        #rsglobal.ZapiszDoLogow("SQL angaze 5:" + SQL,1)
        stat,krotki,dump,dump = self.PolSQL.Execute(SQL ,3)
        if stat <> 'OK':
            dane.append(stat)
        if len(krotki)==0:
            stat='Nie znaleziono adnego angau do analizy.'
            dane.append(stat)
    #towrzymy sownik z kalendarz_id jako kluczem i krotaki jako wartociami
    if stat=='OK':
        slownik = {}
        for i in krotki:
            if i[1].strip() in slownik:
                slownik[i[1].strip()].append(i)
            else:
                slownik[i[1].strip()] = []
                slownik[i[1].strip()].append(i)
    #analizyjemy kady klucz sownika po kolei
    if stat=='OK':
        CzyDzienWKalendarzu=False
        for j in slownik.keys():
            #pobieramy dni dla kadego kalendarza
            SQL="SELECT dzien,od_kiedy1,do_kiedy1,od_kiedy2,do_kiedy2,od_kiedy3,do_kiedy3 FROM rs_kp_kalendarze_dni "
            SQL+=" WHERE firma_id='"+self.firma_id+"' AND kalendarz_id='"+j+"' AND dzien>='"+DataOd+"' AND dzien<='"+DataDo+"' AND " 
            SQL+=" (od_kiedy1 is not null OR od_kiedy2 is not null or od_kiedy3 is not null)"
            #rsglobal.ZapiszDoLogow("SQL kazdy klucz 6:" + SQL,1)
            stat,dni,dump,dump = self.PolSQL.Execute(SQL ,3)
            if stat <> 'OK':
                dane.append(stat)
            elif len(dni)>0:
                CzyDzienWKalendarzu=True
                #analizujemy kady pobrany przed chwil dzie
                for d in dni:
                    #analizujemy kady wiersz w sowniku spod odpowiedniego klucza
                    for g in slownik[j]:
                        #godziny mog by wypenione dla jednej, dwch albo trzech zmian - wszystko trzeba sprawdzi
                        if d[1] not in ('None',None,''):
                            robic_insert = 0
                            for q in dane_grafikow:
                                if q[0].strip()== g[0].strip() and q[2]>datetime.strptime((d[0]+' '+d[1]+':00'),"%Y-%m-%d %H:%M:%S"):
                                    robic_insert=robic_insert+1
                            if robic_insert==0:
                                INS+=" INSERT INTO rs_kp_grafiki_pozycje (firma_id,pracownik_id,plan_stanowisko_pracy_id,"
                                INS+=" plan_miejsce_pracy_id,plan_czas_od,plan_czas_do,kalendarz_id,plan_stanowisko_miejsce_id) VALUES ("
                                INS+=" '"+self.firma_id+"','"+g[0]+"','"+g[3]+"','"+g[2]+"',"
                                INS+=" ('"+d[0]+"'||' '||'"+d[1]+"')::TIMESTAMP,('"+d[0]+"'||' '||'"+d[2]+"')::TIMESTAMP,'"+g[1]+"','"+g[6]+"');"
                        if d[3] not in ('None',None,''):
                            robic_insert = 0
                            for q in dane_grafikow:
                                if q[0].strip()== g[0].strip() and q[2]>datetime.strptime((d[0]+' '+d[3]+':00'),"%Y-%m-%d %H:%M:%S"):
                                    robic_insert=robic_insert+1
                            if robic_insert==0:
                                INS+=" INSERT INTO rs_kp_grafiki_pozycje (firma_id,pracownik_id,plan_stanowisko_pracy_id,"
                                INS+=" plan_miejsce_pracy_id,plan_czas_od,plan_czas_do,kalendarz_id,plan_stanowisko_miejsce_id) VALUES ("
                                INS+=" '"+self.firma_id+"','"+g[0]+"','"+g[3]+"','"+g[2]+"',"
                                INS+=" ('"+d[0]+"'||' '||'"+d[3]+"')::TIMESTAMP,('"+d[0]+"'||' '||'"+d[2]+"')::TIMESTAMP,'"+g[1]+"','"+g[6]+"');"
                        if d[5] not in ('None',None,''):
                            robic_insert = 0
                            for q in dane_grafikow:
                                if q[0].strip()== g[0].strip() and q[2]>datetime.strptime((d[0]+' '+d[5]+':00'),"%Y-%m-%d %H:%M:%S"):
                                    robic_insert=robic_insert+1
                            if robic_insert==0:
                                INS+=" INSERT INTO rs_kp_grafiki_pozycje (firma_id,pracownik_id,plan_stanowisko_pracy_id,"
                                INS+=" plan_miejsce_pracy_id,plan_czas_od,plan_czas_do,kalendarz_id,plan_stanowisko_miejsce_id) VALUES ("
                                INS+=" '"+self.firma_id+"','"+g[0]+"','"+g[3]+"','"+g[2]+"',"
                                INS+=" ('"+d[0]+"'||' '||'"+d[5]+"')::TIMESTAMP,('"+d[0]+"'||' '||'"+d[6]+"')::TIMESTAMP,'"+g[1]+"','"+g[6]+"');"
        if not CzyDzienWKalendarzu:
            stat='Brak uzupenionego kalendarza'
    if stat=='OK' and len(INS)>0:
        #rsglobal.ZapiszDoLogow("SQL Ins:" + INS,1)
        stat,dump,dump,dump = self.PolSQL.Execute(INS ,1)
        if stat <> 'OK':
            dane.append(stat)