# -*- coding: iso8859_2 -*-

# -----------------------------------------------------------------------------
# Name:        fs_kp_import_danych_kadrowych.py
# Purpose:     funkcja do importowania danych kadrowych
# Author:      Aleksander Bargie
# Created:     2018/04/06
# RCS-ID:      $Id: fs_kp_import_danych_kadrowych.py $
# Copyright:   (c) 2018 RecordSystem
# Licence:     GNU GPL
# -----------------------------------------------------------------------------

# 2022-09-21 Wojciech Skowron   - (12174) Poprawiona obsuga pliku

import rsglobal

dane = []
wyn1 = []
wyn2 = []
stat = 'OK'
doImportu = 0


def wykonaj_sql_z_pliku(self, nazwa_pliku):
    wynik = []
    dodano = 0
    istnieje = 0
    inne = 0

    #WS 2022-09-21
    sql = ''
    try:
        with open(nazwa_pliku, 'r') as plik:
            sql = plik.read().replace("ID_FIRMY", self.firma_id).split('INSERT')[1:]
    except:
        import traceback
        wynik.insert(0, u'    bd odczytu pliku: ' + unicode(traceback.format_exc))
    # plik = open(nazwa_pliku, 'r')
    # sql = plik.read().replace("ID_FIRMY", self.firma_id).split('INSERT')[1:]
    else:
        for insert in sql:
            stat, dump, dump, dump = self.PolSQL.Execute("INSERT " + insert, 1, CzyDodawacBlad=True)
            if stat == 'OK':
                self.PolSQL.Commit()
                dodano += 1
            else:
                if u'ju istnieje.' in unicode(stat) or u'already exists.' in unicode(stat):
                    istnieje += 1
                else:
                    inne += 1
                    wynik.append(u'        ' + unicode(stat))
        if inne > 0:
            wynik.insert(0, u'    bdy: ' + str(inne))
        if istnieje > 0:
            wynik.insert(0, u'    Wiersze istniejce ju wczeniej: ' + str(istnieje))
        if dodano > 0:
            wynik.insert(0, u'    Zaimportowane wiersze: ' + str(dodano))
        else:
            wynik.insert(0, u'    Nie zaimportowano adnych danych')
    return wynik


if 'Funkcja' not in klucze:
    stat = 'Brak podanej funkcji w kluczach'

if stat == 'OK':
    Fun = klucze['Funkcja']
    SlPar = {'Import': [1]}
    Lista = rsglobal.SprawdzParametryWKluczach(SlPar, Fun, klucze)
    if Lista != '':
        stat = 'Uwaga : wywoanie funkcji fs_import_danych_kadrowych z numerem '+str(Fun)+' bez parametrw: '+Lista
    else:
        doImportu = klucze['Import']
if stat == 'OK':
    if Fun == 1:
        dane = []
        if doImportu/8 == 1:  # skadniki pacowe
            doImportu -= 8
            dane.append(u'Skadniki pacowe:')
            dane += wykonaj_sql_z_pliku(self, 'importy/in_rs_skladniki_placowe.sql')
        if doImportu/4 == 1:  # stae
            doImportu -= 4
            dane.append(u'Wartoci stae:')
            dane += wykonaj_sql_z_pliku(self, 'importy/in_rs_stale_kadrowe.sql')
        if doImportu/2 == 1:  # szablony dokumentw
            doImportu -= 2
            dane.append(u'Wzory dokumentw:')
            dane += wykonaj_sql_z_pliku(self, 'importy/in_rs_szablony_dokumentow.sql')
        if doImportu == 1:  # szablony list pac
            dane.append(u'Szablony list pac:')
            dane += wykonaj_sql_z_pliku(self, 'importy/in_rs_szablony_list_plac.sql')
