# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_kp_kalendarze_dni_dane.py
# Purpose:     dodawanie/edycja danych o zmianach pracy
# Author:      Pawe Wjcikowski
# Created:     2010/08/04
# RCS-ID:      $Id: fs_kp_kalendarze_dni_dane.py $
# Copyright:   (c) 2010 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

Kalendarz = klucze[0]
Rok = klucze[1]
Miesiac = klucze[2]
OdDnia = str(klucze[3])
DoDnia = str(klucze[4])
OdKiedy1 = str(klucze[5])
DoKiedy1 = str(klucze[6])
OdKiedy2 = str(klucze[7])
DoKiedy2 = str(klucze[8])
OdKiedy3 = str(klucze[9])
DoKiedy3 = str(klucze[10])


Fun = klucze[-1]
stat = 'OK'
dane = []
wyn1 = []
wyn2 = []

UprDodawanie = (((self.oddzial_id,'051033') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID))
UprEdycja = (((self.oddzial_id,'051032') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)) or UprDodawanie


#-------------------------------------------------------------------------------
#---   SPRAWDZENIE UPRAWNIEN
#-------------------------------------------------------------------------------

if not UprEdycja:
    stat = 'BR UPR UPD'
        

#-------------------------------------------------------------------------------
#--- SPRAWDZENIE DANYCH (1,2,3,4) - bez 5 (pobieranie)
#-------------------------------------------------------------------------------

if stat == 'OK':
    
    #spr. ostatni dzien   
    ilosc_dni = rsglobal.PodajOstatniDzien(str(Rok)+'-'+str(Miesiac)+'-01')                  
            
    if OdDnia == '':
        stat='PS_ODDNIA'
        dane.append(stat)
    elif DoDnia == '':
        stat='PS_DODNIA'
        dane.append(stat)           
    elif int(OdDnia) < 1:
        stat='BL_ODDNIA'
        dane.append(stat)                
    elif int(OdDnia) > int(DoDnia):
        stat='BL_ODDNIA1'
        dane.append(stat)
    elif int(DoDnia) > int(ilosc_dni):
        stat='BL_DODNIA'
        dane.append(stat)   
                          
    if len(dane) > 0:
        stat = dane[0]
                        
          
#-------------------------------------------------------------------------------
#--- UPDATE DANYCH 
#-------------------------------------------------------------------------------

if stat == 'OK':
    zmiana=False
    UPDATE=''
    if OdKiedy1 <> '  :  ':
        UPDATE+=",od_kiedy1='"+str(OdKiedy1)+"' "
        zmiana=True
    #else:
    #    UPDATE+=" od_kiedy1=NULL "

    if DoKiedy1 <> '  :  ':
        UPDATE+=",do_kiedy1='"+str(DoKiedy1)+"' "
        zmiana=True
    #else:
    #    UPDATE+=" ,do_kiedy1=NULL "
          
    if OdKiedy2 <> '  :  ':
        UPDATE+=",od_kiedy2='"+str(OdKiedy2)+"' "
        zmiana=True
    #else:
    #    UPDATE+=" ,od_kiedy2=NULL "
        
    if DoKiedy2 <> '  :  ':
        UPDATE+=",do_kiedy2='"+str(DoKiedy2)+"' "
        zmiana=True
    #else:
    #    UPDATE+=" ,do_kiedy2=NULL "
              
    if OdKiedy3 <> '  :  ':
        UPDATE+=",od_kiedy3='"+str(OdKiedy3)+"' "
        zmiana=True
    #else:
    #    UPDATE+=" ,od_kiedy3=NULL "
        
    if DoKiedy3 <> '  :  ':
        UPDATE+=",do_kiedy3='"+str(DoKiedy3)+"' "
        zmiana=True
    #else:
    #    UPDATE+=" ,do_kiedy3=NULL "

    if zmiana:
        UPDATE = "UPDATE rs_kp_kalendarze_dni SET "+UPDATE[1:]
        UPDATE+=" WHERE firma_id = '"+self.firma_id+"' AND kalendarz_id = '"+str(Kalendarz)+"' "
        UPDATE+=" AND status_dnia='R' AND (zmiana_id is NULL or zmiana_id='') "
        UPDATE+=" AND dzien BETWEEN '"+str(Rok)+'-'+str(Miesiac)+'-'+str(OdDnia)+"' AND "
        UPDATE+="'"+str(Rok)+'-'+str(Miesiac)+'-'+str(DoDnia)+"';"
        stat,dump,dump,dump = self.PolSQL.Execute(UPDATE ,1)
        if stat <> 'OK':
            stat = 'Bd modyfikacji danych zwizanych ze zmianami pracy : '+stat