# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_kp_typy_informacji_pozycje.py
# Purpose:     obsluga grida edytowalnego pozycji dla typw informacji
# Author:      Marcin Natkaski
# Created:     2014/08/01
# RCS-ID:      $Id: fs_kp_typy_informacji_pozycje $
# Copyright:   (c) 2014 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

stat='OK'

if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=='OK':
    Funkcja = klucze['Funkcja']
    
    SlPar={'Komorka':[1,5],'Czas_od':[1,5],'Czas_do':[1,5],'PracownikG':[2,],'AbsencjaG':[3,]}
    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Funkcja,klucze)
    if Lista<>'':
        stat='Uwaga : wywoanie funkcji fs_kp_listy_obecnosci_pozycje z numerem '+str(Funkcja)+' bez parametrw: '+Lista
        
    if Funkcja in [1,5]: 
        Komorka=rsglobal.Dekoduj(klucze['Komorka'])
        Czas_do=rsglobal.Dekoduj(klucze['Czas_do'])
        Czas_od=rsglobal.Dekoduj(klucze['Czas_od'])
    if Funkcja in [2,]:
        PracownikG=rsglobal.Dekoduj(klucze['PracownikG'])
    if Funkcja in [3,]:
        AbsencjaG=rsglobal.Dekoduj(klucze['AbsencjaG'])

dane = []
wyn1 = []
wyn2 = []

UprIns=((self.oddzial_id,'054202') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID
UprUpd=((self.oddzial_id,'054202') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID or UprIns
UprDel=((self.oddzial_id,'054202') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID


#-------------------------------------------------------------------------------
#-------- EDYCJA GRIDA EDYTOWALNEGO (1)
#-------------------------------------------------------------------------------

Insert = []
Update = []
Delete = []

if stat=='OK' and Funkcja == 1:
    Update=klucze['Update']
    Insert=klucze['Insert']
    Delete=klucze['Delete']



#-------------------------------------------------------------------------------
#-------  POBRANIE NAZWY PRACOWNIKA
#-------------------------------------------------------------------------------
if Funkcja == 2 and stat == 'OK':
    SQL= "SELECT imie||' '||nazwisko FROM rs_kp_dane_osobowe WHERE"
    SQL+=" firma_id='"+self.firma_id+"' AND pracownik_id='"+PracownikG+"'"
    stat,dane,dump,dump = self.PolSQL.Execute(rsglobal.Dekoduj(SQL),3)
    if stat <> 'OK':
        stat = 'Bd pobierania nazwiska pracownika: '+stat
        dane.append(stat)


#-------------------------------------------------------------------------------
#-------  POBRANIE NAZWY ABSENCJI
#-------------------------------------------------------------------------------
if Funkcja == 3 and stat == 'OK':
    SQL= "SELECT nazwa FROM rs_kp_absencje_rodzaje WHERE"
    SQL+=" firma_id='"+self.firma_id+"' AND typ_absencji_id='"+AbsencjaG+"'"
    stat,dane,dump,dump = self.PolSQL.Execute(rsglobal.Dekoduj(SQL),3)
    if stat <> 'OK':
        stat = 'Bd pobierania nazwy absencji: '+stat
        dane.append(stat)

#-------------------------------------------------------------------------------
#-------  SPRAWDZANIE DELETE  --------------------------------------------------
#-------------------------------------------------------------------------------

if Funkcja == 1 and stat=="OK":
    if len(Delete[0])>0:
        if not UprDel:
            stat='BR UPR DEL'
            dane.append(stat)
            
        # wykonanie DELETE 
        if stat == 'OK':
            SQLDEL = ''
            SQLFU = ''
            SQLSPR = ''
            for i in xrange(len(Delete[0])):
                SQLFU =" SELECT pracownik_id FROM rs_kp_listy_obecnosci_pozycje "
                SQLFU+=" WHERE firma_id='"+self.firma_id+"' AND komorka_id='"+str(Komorka)+"' AND "
                SQLFU+=" czas_od='"+Czas_od+"' AND czas_do='"+Czas_do+"' "
                DELETE = "DELETE FROM rs_kp_listy_obecnosci_pozycje "
                WHERE = " WHERE firma_id='"+self.firma_id+"' AND komorka_id='"+str(Komorka)+"' AND "
                WHERE+=" czas_od='"+Czas_od+"' AND czas_do='"+Czas_do+"' "
                for j in xrange(len(Delete[0][i])):
                    pole = Delete[1][j]
                    wart = Delete[0][i][j]
                    if pole in ['pracownik_id']:
                        WHERE += " AND "+pole+"='"+wart+"'"
                        SQLFU += " AND "+pole+"='"+wart+"'"


                SQLDEL += DELETE+WHERE+"; "
                SQLFU += " FOR UPDATE NOWAIT; "
                SQLSPR +=" ;"

            if stat == "OK" and SQLFU <> '':
                stat,d,dump,dump = self.PolSQL.Execute(rsglobal.Dekoduj(SQLFU),3)
                if stat <> 'OK':
                    stat = 'Bd sprawdzenia danych do usunicia: '+stat
                    dane.append(stat)

            if stat == "OK" and SQLDEL <> '':
                stat,dump,dump,dump = self.PolSQL.Execute(rsglobal.Dekoduj(SQLDEL),1)
                if stat <> 'OK':
                    stat = "Bd przy usuwaniu danych: "+stat   
                    dane.append(stat)
              
#-------------------------------------------------------------------------------
#---   UPDATE DANYCH (1)
#-------------------------------------------------------------------------------

if Funkcja == 1 and stat=="OK":
    if len(Update[0])>0:
        if not UprUpd:
            stat='BR UPR UPD'
            dane.append(stat)

        if stat == 'OK':
            SQLFU = ''
            for i in xrange(len(Update[0])):
                SQLFU =" SELECT komorka_id FROM rs_kp_listy_obecnosci "
                SQLFU+=" WHERE firma_id='"+self.firma_id+"' AND komorka_id='"+str(Komorka)+"' AND "
                SQLFU+=" czas_od='"+Czas_od+"' AND czas_do='"+Czas_do+"' "
                SQLFU += " FOR UPDATE NOWAIT; "
            
            if SQLFU <> '' and stat == "OK":
                stat,d,dump,dump = self.PolSQL.Execute(rsglobal.Dekoduj(SQLFU),3)
                if stat <> 'OK':
                    stat = 'Bd sprawdzenia danych do modyfikacji: '+stat
                    dane.append(stat)
            
        if stat == 'OK':
            WierszeNr = Update[-1]

            for i in xrange(len(Update[0])):
                WartoscNowa = None

                for j in xrange(len(Update[0][i])): 
                    pole = Update[0][i][j]
                    wart = Update[1][i][j]

                    if pole == 'godz_od':
                        wart = wart.strip()
                        if wart == '':
                            stat = 'Niewypeniona godzina od.'
                            wyn2.append((WierszeNr[i],3))
                            dane.append(stat)

                    elif pole == 'godz_do':
                        wart = wart.strip()
                        if wart == '':
                            stat = 'Niewypeniona godzina do.'
                            wyn2.append((WierszeNr[i],5))
                            dane.append(stat)

                    elif pole == 'data_do':
                        wart = wart.strip()
                        if wart == '':
                            stat = 'Niewypeniona data do.'
                            wyn2.append((WierszeNr[i],4))
                            dane.append(stat)

                    elif pole == 'typ_absencji_id':
                        if wart<>'':
                            wart = wart.strip()
                            ABS =" SELECT typ_absencji_id FROM rs_kp_absencje_rodzaje  "
                            ABS+=" WHERE firma_id='"+self.firma_id+"' AND typ_absencji_id='"+wart+"'"
                            stat,d,dump,dump = self.PolSQL.Execute(rsglobal.Dekoduj(ABS),3)
                            if stat <> 'OK':
                                stat = 'Bd sprawdzenia absencji: '+stat
                                dane.append(stat)
                            elif len(d) == 0:
                                stat = 'Bdnie wypeniony typ absencji.'
                                wyn2.append((WierszeNr[i],6))
                                dane.append(stat)

                    elif pole == 'pracownik_id':
                        wart = wart.strip()
                        if wart<>'':
                            PR =" SELECT pracownik FROM rs_kp_dane_osobowe  "
                            PR+=" WHERE firma_id='"+self.firma_id+"' AND pracownik_id='"+wart+"'"
                            stat,d,dump,dump = self.PolSQL.Execute(rsglobal.Dekoduj(PR),3)
                            if stat <> 'OK':
                                stat = 'Bd sprawdzenia pracownika: '+stat
                                dane.append(stat)
                            elif len(d) == 0:
                                stat = 'Bdnie wypeniony pracownik.'
                                wyn2.append((WierszeNr[i],0))
                                dane.append(stat)
                        else:
                            stat = 'Brak pracownika.'
                            wyn2.append((WierszeNr[i],0))
                            dane.append(stat)
        if stat == 'OK':
            if len(dane) > 0:
                stat = dane[0]
        if stat=='OK':
            sql=''
            SQLSPRUPD = ''
            for i in xrange(len(Update[0])):
                UPDATE="UPDATE rs_kp_listy_obecnosci_pozycje "
                SET='SET '
                for j in xrange(len(Update[0][i])): 
                    pole=Update[0][i][j]
                    wart=Update[1][i][j]
                    if pole in ['pracownik_id','typ_absencji_id']:
                        SET+=pole+"='"+wart+"',"
                    elif pole in ['data_do',]:
                        SET+="czas_fakt_do=('"+wart+"'||' '||SUBSTRING(czas_fakt_do::TEXT FROM 11 FOR 6))::TIMESTAMP ,"
                    elif pole in ['godz_do',]:
                        SET+="czas_fakt_do=(SUBSTRING(czas_fakt_do::TEXT FROM 1 FOR 10)||' '||'"+wart+":00')::TIMESTAMP ,"
                    elif pole in ['godz_od']:
                        SET+="czas_fakt_od=(SUBSTRING(czas_fakt_od::TEXT FROM 1 FOR 10)||' '||'"+wart+":00')::TIMESTAMP ,"
                SET=SET.strip(",")
                WHERE=" WHERE firma_id='"+self.firma_id+"' AND komorka_id='"+str(Komorka)+"' AND "
                WHERE+=" czas_od='"+Czas_od+"' AND czas_do='"+Czas_do+"' "
                for j in xrange(len(Update[2][i])): # petla po kluczu
                    pole=Update[3][j]
                    wart=rsglobal.Dekoduj(Update[2][i][j])
                    if pole in ['pracownik_id']:
                        WHERE+= " AND "+pole+"='"+str(wart)+"'"
                        wart_spr = str(wart)
                WHERE+=";"
                sql+=UPDATE+SET+WHERE;
            if stat=="OK" and sql<>'':
                stat,dump,dump,dump=self.PolSQL.Execute(rsglobal.Dekoduj(sql),1)
                if stat<>'OK':
                    stat="Bd przy modyfikowaniu danych: "+stat   
                    dane.append(stat)


#-------------------------------------------------------------------------------
#---------Sprawdzanie danych do Insert------
#-------------------------------------------------------------------------------

if Funkcja == 1 and stat=="OK":
    if len(Insert[0])>0:
        if not UprIns:
            stat='BR UPR INS'
            dane.append(stat)

        if stat == 'OK':
            WierszeNr = Insert[-1]
            for i in xrange(len(Insert[0])):
                WartoscNowa = None
                
                for j in xrange(len(Insert[0][i])): 
                    pole=Insert[1][j]
                    wart=Insert[0][i][j]

                    if pole == 'godz_od':
                        wart = wart.strip()
                        if wart == '':
                            stat = 'Brak godziny od.'
                            wyn2.append((WierszeNr[i],3))
                            dane.append(stat)
                    elif pole == 'data_do':
                        wart = wart.strip()
                        if wart == '':
                            stat = 'Brak daty do.'
                            wyn2.append((WierszeNr[i],4))
                            dane.append(stat)
                    elif pole == 'godz_do':
                        wart = wart.strip()
                        if wart == '':
                            stat = 'Brak godziny do.'
                            wyn2.append((WierszeNr[i],3))
                            dane.append(stat)
                    elif pole == 'typ_absencji_id':
                        wart = wart.strip()
                        if wart<>'':
                            ABS =" SELECT typ_absencji_id FROM rs_kp_absencje_rodzaje  "
                            ABS+=" WHERE firma_id='"+self.firma_id+"' AND typ_absencji_id='"+wart+"'"
                            stat,d,dump,dump = self.PolSQL.Execute(rsglobal.Dekoduj(ABS),3)
                            if stat <> 'OK':
                                stat = 'Bd sprawdzenia absencji: '+stat
                                dane.append(stat)
                            elif len(d) == 0:
                                stat = 'Bdnie wypeniony typ absencji.'
                                wyn2.append((WierszeNr[i],6))
                                dane.append(stat)
                    elif pole == 'pracownik_id':
                        wart = wart.strip()
                        if wart<>'':
                            PR =" SELECT pracownik FROM rs_kp_dane_osobowe  "
                            PR+=" WHERE firma_id='"+self.firma_id+"' AND pracownik_id='"+wart+"'"
                            stat,d,dump,dump = self.PolSQL.Execute(rsglobal.Dekoduj(PR),3)
                            if stat <> 'OK':
                                stat = 'Bd sprawdzenia pracownika: '+stat
                                dane.append(stat)
                            elif len(d) == 0:
                                stat = 'Bdnie wypeniony pracownik.'
                                wyn2.append((WierszeNr[i],0))
                                dane.append(stat)
                        else:
                            stat = 'Brak pracownika.'
                            wyn2.append((WierszeNr[i],0))
                            dane.append(stat)

        if stat == 'OK':
            if len(dane) > 0:
                stat = dane[0]

        # wykonanie INSERT
        if stat == 'OK':
            sqlIns=''
            for i in xrange(len(Insert[0])):
                czas_fakt_od = ''
                czas_fakt_do = ''
                INSERT="INSERT INTO rs_kp_listy_obecnosci_pozycje "
                KOLUMNY="(firma_id,komorka_id,czas_od,czas_do"
                VALUES=" VALUES ('"+self.firma_id+"','"+Komorka+"','"+Czas_od+"','"+Czas_do+"' "
                #skladamy odpowiednie wartosc
                for j in xrange(len(Insert[0][i])):
                    pole=Insert[1][j]
                    wart=Insert[0][i][j]
                    #tutaj liczymy na odpowiedni kolejno pl
                    if pole == 'data_od':
                        czas_fakt_od = wart
                    elif pole == 'godz_od':
                        czas_fakt_od = czas_fakt_od+' '+wart
                    elif pole == 'data_do':
                        czas_fakt_do = wart
                    elif pole == 'godz_do':
                        czas_fakt_do = czas_fakt_do+' '+wart
                KOLUMNY+=" ,czas_fakt_od,czas_fakt_do"
                VALUES+=" ,'"+czas_fakt_od+"','"+czas_fakt_do+"' "

                for j in xrange(len(Insert[0][i])):
                    pole=Insert[1][j]
                    wart=Insert[0][i][j]
                    if pole in ['pracownik_id','typ_absencji_id']:
                        KOLUMNY+=","+pole
                        VALUES+=",'"+wart+"'"
                KOLUMNY+=")"
                VALUES+=");"
                sqlIns+=INSERT+KOLUMNY+VALUES
            if sqlIns<>'': 
                stat,dump,dump,dump=self.PolSQL.Execute(rsglobal.Dekoduj(sqlIns),1)
                if stat<>'OK':
                    stat="Bd przy dodawaniu danych: "+stat
                    dane.append(stat)

        
#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (1- insert 1 -select, 1 -delete, 5 -select) 
#-------------------------------------------------------------------------------

if Funkcja in (1,5) and stat=='OK':
    SQL= " SELECT a.pracownik_id, b.imie||' '||b.nazwisko, "
    SQL+=" SUBSTRING(a.czas_fakt_od::TEXT FROM 1 FOR 10), SUBSTRING(a.czas_fakt_od::TEXT FROM 12 FOR 5), "
    SQL+=" SUBSTRING(a.czas_fakt_do::TEXT FROM 1 FOR 10), SUBSTRING(a.czas_fakt_do::TEXT FROM 12 FOR 5), "
    SQL+=" a.typ_absencji_id, c.nazwa "
    SQL+=" FROM rs_kp_listy_obecnosci_pozycje a INNER JOIN rs_kp_dane_osobowe b USING(firma_id, pracownik_id) "
    SQL+=" LEFT JOIN rs_kp_absencje_rodzaje c USING (firma_id, typ_absencji_id)"
    SQL+=" WHERE firma_id= '"+self.firma_id+"' AND komorka_id='"+Komorka+"'  "
    SQL+=" AND czas_od::TEXT='"+Czas_od+"' AND czas_do::TEXT='"+Czas_do+"'"
    stat,dane,wyn1,wyn2 = self.PolSQL.Execute(SQL,3)
    if stat <> 'OK':
        stat = "Bd przy pobieraniu danych: "+stat
        dane.append(stat)
