# -*- coding: iso8859_2 -*-
#-----------------------------------------------------------------------------
# Name:        fs_kp_skladniki_placowe_pom.py
# Purpose:     funkcje pomocnicze dla skadnikw pacowych
# Author:      Micha Raburski
# Created:     2015/07/15
# RCS-ID:      $Id: fs_kp_skladniki_placowe_pom.py $
# Copyright:   (c) 2015 Record System
# Licence:     GNU GPL
#-----------------------------------------------------------------------------

import rsglobal

# funkcja sprawdzajca poprawno skadni algorytmu dla skadnika
def SprawdzSkladnieAlgorytmuSkladnika(self,Algorytm):
    # sprawdzenie wartoci staych pacowych
    rsglobal.ZapiszDoLogow('A1 '+Algorytm,1)
    AlgSt = Algorytm.split('$')
    AlgTmp = ''
    for i in range(len(AlgSt)):
        # sprawdzenie staej
        rsglobal.ZapiszDoLogow('11 '+str(i)+' '+str(i % 2)+' '+AlgSt[i],1)
        if i % 2 == 1:
            SQL = "SELECT stala_id FROM rs_kp_stale WHERE firma_id = '"+self.firma_id+"' AND stala_id = '"+AlgSt[i]+"' LIMIT 1;"
            stat,dane,dump,dump = self.PolSQL.Execute(SQL,3)
            if stat <> 'OK':
                return u'Bd pobierania staej '+AlgSt[i].strip()+':'+stat
            if len(dane) == 0:
                return u'Brak staej '+AlgSt[i].strip()
            
            AlgTmp += ' 1 '
        else:
            AlgTmp += AlgSt[i]
    
    Algorytm = AlgTmp        
    rsglobal.ZapiszDoLogow('A2 '+Algorytm,1)        
    # sprawdzenie wartoci skadnikw pacowych
    AlgSk = Algorytm.split('#')
    AlgTmp = ''
    for i in range(len(AlgSk)):
        # sprawdzenie skadnikw
        rsglobal.ZapiszDoLogow('12 '+str(i)+' '+str(i % 2)+' '+AlgSk[i],1)
        if i % 2 == 1:
            SQL = "SELECT skladnik_id FROM rs_kp_skladniki_placowe WHERE firma_id = '"+self.firma_id+"' AND skladnik_id = '"+AlgSk[i]+"' LIMIT 1;"
            stat,dane,dump,dump = self.PolSQL.Execute(SQL,3)
            if stat <> 'OK':
                return u'Bd pobierania skadnika '+AlgSk[i].strip()+':'+stat
            if len(dane) == 0:
                return u'Brak skadnika '+AlgSk[i].strip()
                        
            AlgTmp += ' 1 '
        else:
            AlgTmp += AlgSk[i]
    
    Algorytm = AlgTmp    
    rsglobal.ZapiszDoLogow('A3 '+Algorytm,1)
    
    # sprawdzenie skadni
    Tmp = 'a = '+Algorytm
    try:
        rsglobal.ZapiszDoLogow('Tmp '+Tmp,1)
        exec(Tmp)
    except Exception,e:
        return u'Niepoprawna skadniowo definicja algorytmu dla treci algorytmu \n'+Tmp+'\nBd :'+str(e)
    
    return 'OK'