# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_kp_szkolenia_harmonogram_planowanie.py
# Purpose:     odsluga grida z planowanymi szkoleniami
# Author:      Marcin Natkaski
# Created:     2012/11/14
# RCS-ID:      $Id: fs_kp_szkolenia_harmonogram_planowanie.py $
# Copyright:   (c) 2012 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

dane = []
wyn1 = []
wyn2 = []
prac2 = []
prac = []

stat = 'OK'

if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=='OK':
    Fun = klucze['Funkcja']
    
    SlPar={'Szkolenie':[5],'DataOd':[5],'DataDo':[5]}    
    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Fun,klucze)
    if Lista<>'':
        stat='Uwaga : wywoanie funkcji fs_kp_szkolenia_harmonogram_planowanie z numerem '+str(Fun)+' bez parametrw: '+Lista

if stat=='OK':    
    if Fun in [5,6]:
        Szkolenie=rsglobal.Dekoduj(klucze['Szkolenie'])
        DataOd=rsglobal.Dekoduj(klucze['DataOd'])
        DataDo=rsglobal.Dekoduj(klucze['DataDo'])
            
#-------------------------------------------------------------------------------
#-----POBIERANIE PRACOWNIKW NA GRIDA 5
#-------------------------------------------------------------------------------

if Fun==5 and stat == 'OK':
    #--Pobieramy wszystkich pracownikw dopisanych do podanego szkolenia, ale tylko tych, ktrzy anga maj w terminie szkolenia
    SQL= "SELECT DISTINCT ang.pracownik_id FROM rs_kp_angaze ang "
    SQL+= " WHERE ang.firma_id='"+self.firma_id+"' AND ( "
    SQL+= "(ang.stanowisko_id IN (SELECT DISTINCT stanowisko FROM rs_szkolenia_stanowiska_dzialy WHERE firma_id='"+self.firma_id+"' AND szkolenie_id='"+Szkolenie+"'))"
    SQL+= "  OR  (ang.komorka_id IN "
    SQL+= "(SELECT DISTINCT komorka_organizacyjna FROM rs_szkolenia_stanowiska_dzialy "
    SQL+= " WHERE firma_id='"+self.firma_id+"' AND szkolenie_id='"+Szkolenie+"')) )"
    SQL+= " AND (ang.do_kiedy>='"+DataOd+"' OR (ang.od_kiedy<='"+DataOd+"' AND do_kiedy is NULL))  "
    stat,prac,dump,dump = self.PolSQL.Execute(SQL,3)
    if stat<>'OK':
        stat='Bdy pobierania listy pracownikw'+stat
    
    #--Pobieramy liczb dni karencji dla szkolenia
    dni=[]
    SQL=" SELECT dni_karencji from rs_szkolenia WHERE firma_id='"+self.firma_id+"' AND szkolenie_id='"+Szkolenie+"' ;"
    stat,dni,dump,dump = self.PolSQL.Execute(SQL,3)
    if stat<>'OK':
        stat='Bdy pobierania okresu wanoci szkolenia'+stat
        
    #--Pobieramy pracownikw, ktrzy api si terminem wanoci swojego szkolenia na nowe szkolenie, albo szkolenia nie odbyli wcale
    if stat=='OK' and len(prac)>0:
        SQL=''
        prac2=[]       
        for i in xrange(len(prac)):
            SQL= " SELECT kp.pracownik_id FROM rs_kp_dane_osobowe kp"
            SQL+=" LEFT JOIN rs_kp_dane_osobowe_szkolenia ds"
            SQL+=" USING(firma_id,pracownik_id)"
            SQL+=" WHERE kp.firma_id='"+self.firma_id+"' AND kp.pracownik_id='"+prac[i][0]+"'  "
            SQL+=" AND (ds.szkolenie_id is NULL OR (ds.szkolenie_id='"+Szkolenie+"' AND (ds.data_waznosci<=('"+DataDo+"'::DATE+"+str(dni[0][0])+"::INTEGER)))) "            
            stat,dat,dump,dump = self.PolSQL.Execute(SQL,3)
            if stat<>'OK':
                stat='Bdy pobierania pracownikw'+stat
            elif len(dat)>0:
                prac2.append(dat[0])
            
    #---Sprawdzamy czy pracownicy przydzieleni do planowanych szkole nie s zapisani na licie wczeniej utworzonego szkolenia w harmonogramie.
    #---Jeelli tacy s do pobieramy dla nich dat zharmonogramowanego szkolenia.
    if stat=='OK' and len(prac2)>0:
        SQL=''
        dane=[]     
        prac3=[]
        for i in xrange(len(prac2)):
            SQL= " SELECT DISTINCT 0,  ang.komorka_id||' '|| kz.opis, ang.stanowisko_id||' '||sp.opis,"
            SQL+=" kp.imie||' '||kp.nazwisko, ang.pracownik_id, COALESCE(szp.data::TEXT,'') "
            SQL+=" FROM rs_kp_angaze ang LEFT JOIN rs_szkolenia_harmonogram_pracownicy szp "
            SQL+=" ON (szp.firma_id=ang.firma_id AND szp.pracownik_id=ang.pracownik_id)"
            SQL+=" INNER JOIN rs_komorki_zatrudniajace kz ON (ang.firma_id=kz.firma_id AND ang.komorka_id=kz.kod) "
            SQL+=" INNER JOIN rs_stanowiska_pracy sp ON (ang.firma_id=sp.firma_id AND ang.stanowisko_id=sp.kod) "
            SQL+=" INNER JOIN rs_kp_dane_osobowe kp ON (ang.firma_id=kp.firma_id AND ang.pracownik_id=kp.pracownik_id)"
            SQL+=" WHERE ang.firma_id='"+self.firma_id+"' AND ang.pracownik_id='"+prac2[i][0]+"'"
            SQL+=" AND ((szp.data<='"+DataDo+"' OR szp.data>='"+DataOd+"' ) OR szp.data is NULL)"
            stat,prac3,dump,dump = self.PolSQL.Execute(SQL,3)
            if stat<>'OK':
                stat='Bdy pobierania pracownikw'+stat
            elif len(prac3)>0:
                dane.append(prac3[0])
                prac3=[]