# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_kp_szkolenia_harmonogram_planowanie_tworzenie
# Purpose:     Tworzenie harmonogramu szkole z poziomu planowania
# Author:      Marcin Natkaski
# Created:     2012/11/22
# RCS-ID:      $Id: fs_kp_szkolenia_harmonogram_planowanie_tworzenie.py $
# Copyright:   (c) 2012 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

stat='OK'
SQL=''
dane=[]

if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=='OK':
    Fun = klucze['Funkcja']
    
    SlPar={'Szkolenie':[2,3],'Data':[2,3],'Godzina':[2],'Miejsce':[2],'Prowadzacy':[2],'ProwadzacyObcy':[2],'Pracownicy':[2,3]}    
    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Fun,klucze)
    if Lista<>'':
        stat='Uwaga : wywoanie funkcji fs_kp_szkolenia_harmonogram_planowanie_tworzenie z numerem '+str(Fun)+' bez parametrw: '+Lista

if stat=='OK':
    
    if Fun in [2]:        
        Godzina=rsglobal.Dekoduj(klucze['Godzina'])
        Miejsce=rsglobal.Dekoduj(klucze['Miejsce'])
        Prowadzacy=rsglobal.Dekoduj(klucze['Prowadzacy'])
        ProwadzacyObcy=rsglobal.Dekoduj(klucze['ProwadzacyObcy'])
        
    if Fun in [2,3]:
        Szkolenie=rsglobal.Dekoduj(klucze['Szkolenie'])
        Pracownicy=rsglobal.Dekoduj(klucze['Pracownicy'])
        Data=rsglobal.Dekoduj(klucze['Data'])
        
UprDodawanie = (((self.oddzial_id,'053203') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID))

#-------------------------------------------------------------------------------
#---   SPRAWDZENIE UPRAWNIE (2)
#-------------------------------------------------------------------------------        

if Fun==2 and stat == 'OK':
    if not UprDodawanie:
        stat = 'Brak uprawnie do tworzenia szkole'
        dane.append(stat)

#-------------------------------------------------------------------------------
#SPRAWDZENIE CZY PRACOWNICY S JU W KONKRETNEJ DACIE ZAPISANI NA SZKOLENIE (3)
#-------------------------------------------------------------------------------

if Fun in (3,) and stat=='OK':
    dane=[]
    for i in xrange(len(Pracownicy)):
        SQL= " SELECT kp.imie||' '||kp.nazwisko, hp.szkolenie_id from rs_szkolenia_harmonogram_pracownicy hp"
        SQL+=" INNER JOIN rs_kp_dane_osobowe kp USING (firma_id,pracownik_id)"
        SQL+=" WHERE hp.data='"+Data+"' AND hp.pracownik_id='"+Pracownicy[i]+"' "
        stat,d,dump,dump = self.PolSQL.Execute(SQL,3)
        if len(d)>0:
            dane.append(d[0])

#-------------------------------------------------------------------------------
#--- SPRAWDZENIE DANYCH (2) 
#-------------------------------------------------------------------------------

if Fun in (2,) and stat == 'OK': 
    for i in range(len(pola)):
        pole = pola[i]
        wart = wartosci[i]     
        if pole == 'data':
            if wart == '    -  -  ':
                dane.append('Brak daty')
            elif not rsglobal.SprawdzCzyToData(wart):
                dane.append('Bdnie wpisana data')
            else:       
                Data=wart
        elif pole == 'szkolenie_id':
            if wart <> '':
                SQL= "SELECT szkolenie_id from rs_szkolenia WHERE firma_id='"+self.firma_id+"' AND szkolenie_id='"+Szkolenie+"';"
                stat,szk,dump,dump = self.PolSQL.Execute(SQL ,3)
                if stat<>'OK': 
                    dane.append('Bdy sprawdzania czy szkolenie istnieje.')
                elif len(szk)==0:
                    dane.append('Podane szkolenie nie istnieje')               
                else:            
                    Szkolenie=wart
            else:
                dane.append('Niewypenione szkolenie')
        elif pole == 'miejsce':
            if wart<>'':
                SQL=" SELECT kod from rs_szkolenia_miejsca WHERE firma_id='"+self.firma_id+"' AND kod='"+Miejsce+"';"
                stat,miej,dump,dump = self.PolSQL.Execute(SQL ,3)
                if stat<>'OK': 
                    dane.append('Bdy sprawdzania czy miejsce istnieje.')
                elif len(miej)==0:
                    dane.append('Podane miejsce nie istnieje')               
                else:            
                    Miejsce=wart
            else:
                dane.append('Niewypenione miejsce')
        elif pole == 'prowadzacy_pracownik':
            if wart<>'':
                SQL="SELECT pracownik_id from rs_kp_dane_osobowe WHERE firma_id='"+self.firma_id+"' AND pracownik_id='"+Prowadzacy+"';"
                stat,prac,dump,dump = self.PolSQL.Execute(SQL ,3)
                if stat<>'OK': 
                    dane.append('Bdy sprawdzania czy pracownik istnieje.')
                elif len(prac)==0:
                    dane.append('Podany pracownik nie istnieje')               
                else:            
                    Prowadzacy=wart
        elif pole == 'prowadzacy_kontrahent':
            if wart<>'':
                SQL="SELECT kontrahent_id from rs_kontrahenci WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+ProwadzacyObcy+"';"
                stat,kont,dump,dump = self.PolSQL.Execute(SQL ,3)
                if stat<>'OK': 
                    dane.append('Bdy sprawdzania czy kontrahent istnieje.')
                elif len(kont)==0:
                    dane.append('Podany kontrahent nie istnieje')               
                else:            
                    ProwadzacyObcy=wart
    if len(dane) > 0:
        stat = dane[0]

#-------------------------------------------------------------------------------
#--- SPRAWDZAM UNIKALNO KLUCZA (2)
#-------------------------------------------------------------------------------

if Fun==2 and stat=='OK':
    KL = " SELECT szkolenie_id FROM rs_szkolenia_harmonogram"
    KL+= " WHERE firma_id='"+self.firma_id+"' AND szkolenie_id='"+Szkolenie+"' AND data='"+Data+"' "
    KL+= " AND godzina='"+Godzina+"' AND miejsce='"+Miejsce+"' "
    stat,kl,wyn1,dump = self.PolSQL.Execute(KL ,3)
    if stat=='OK':
        if len(kl)<>0:
            dane.append('Istnieje ju identyczne szkolenie w harmonogramie')
    else:            
        dane.append('Bdy sprawdzania klucza szkolenia')
    if len(dane) > 0:
        stat = dane[0]
            
#-------------------------------------------------------------------------------
#--- TWORZENIE HARMONOGRAMU Z PLANU (2)
#-------------------------------------------------------------------------------

if Fun==2 and stat == 'OK':
    #--INSERT danych do harmonogramu szkole
    SQL= "INSERT INTO rs_szkolenia_harmonogram (firma_id,szkolenie_id,data,godzina,miejsce,stan,prowadzacy_pracownik, prowadzacy_kontrahent) "
    SQL+=" VALUES ('"+self.firma_id+"','"+Szkolenie+"','"+Data+"','"+Godzina+":00','"+Miejsce+"','W'"
    if Prowadzacy<>'':
        SQL+=" ,'"+Prowadzacy+"' "
    else:
        SQL+=" ,NULL "
    if ProwadzacyObcy<>'':
        SQL+=" ,'"+ProwadzacyObcy+"' " 
    else:
        SQL+=" ,NULL "
    SQL+=" ) ; "
    stat,d,dump,dump = self.PolSQL.Execute(SQL,1)
    if stat<>'OK':
        dane.append('Bdy dodawania szkolenia do harmonogramu')        
    #--INSERT pracownikw (w ptli po jednym) do przeszkolenia 
    if stat=='OK':
        INS=""
        for i in xrange(len(Pracownicy)):
            INS+="INSERT INTO rs_szkolenia_harmonogram_pracownicy "
            INS+=" (firma_id, szkolenie_id, data, godzina,miejsce,pracownik_id,obecny) "
            INS+=" VALUES ('"+self.firma_id+"','"+Szkolenie+"','"+Data+"','"+Godzina+"','"+Miejsce+"','"+Pracownicy[i]+"', TRUE ); "
        if INS<>'':
            stat,d,dump,dump = self.PolSQL.Execute(INS,1)
            if stat<>'OK':
                dane.append('Bd dodawania pracownikw do harmonogramu')