# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_kp_szkolenia_harmonogram_tworzenie
# Purpose:     Tworzenie harmonogramu szkole
# Author:      Marcin Natkaski
# Created:     2010/08/04
# RCS-ID:      $Id: fs_kp_szkolenia_harmonogram_tworzenie.py $
# Copyright:   (c) 2010 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

stat='OK'
SQL=''
dane=[]

if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=='OK':
    Fun = klucze['Funkcja']
    
    SlPar={'Szkolenie':[1,2,3,4,5],'Data':[1,2,3,4,5],'Godzina':[1,2,3,4,5],'Miejsce':[1,2,3,4,5],'Prowadzacy':[1,2,3,4],'ProwadzacyObcy':[1,2,3,4]}    
    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Fun,klucze)
    if Lista<>'':
        stat='Uwaga : wywoanie funkcji fs_kp_szkolenia_harmonogram_tworzenie z numerem '+str(Fun)+' bez parametrw: '+Lista

if stat=='OK':
    if Fun in [1,2,3, 4,5]:
        Szkolenie=rsglobal.Dekoduj(klucze['Szkolenie'])
        Data=rsglobal.Dekoduj(klucze['Data'])
        Godzina=rsglobal.Dekoduj(klucze['Godzina'])
        Miejsce=rsglobal.Dekoduj(klucze['Miejsce'])
    if Fun in [1,2,3, 4]:
        Prowadzacy=rsglobal.Dekoduj(klucze['Prowadzacy'])
        ProwadzacyObcy=rsglobal.Dekoduj(klucze['ProwadzacyObcy'])
            
UprDodawanie = (((self.oddzial_id,'053203') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID))
UprEdycja = (((self.oddzial_id,'053202') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID))

#-------------------------------------------------------------------------------
#---   SPRAWDZENIE UPRAWNIEN (2,3)
#-------------------------------------------------------------------------------

if Fun==1 and stat == 'OK':
    if not UprDodawanie:
        stat = 'Brak uprawnie do towrzenia harmonogramowania'
        dane.append(stat)
        
if Fun==2 and stat == 'OK':
    if not UprDodawanie:
        stat = 'Brak uprawnie do modyfikacji harmonogramowania'
        dane.append(stat)

#-------------------------------------------------------------------------------
#--- SPRAWDZENIE DANYCH (1,2,3,4) 
#-------------------------------------------------------------------------------

if Fun in (1,2,3,4) and stat == 'OK': 
    stat='OK'      
    for i in range(len(pola)):
        pole = pola[i]
        wart = wartosci[i]     
        if pole == 'data':
            if wart == '    -  -  ':
                dane.append('Brak daty')
            elif not rsglobal.SprawdzCzyToData(wart):
                dane.append('Bdnie wpisana data')
            else:       
                Data=wart
        elif pole == 'szkolenie_id':
            if wart != '':
                SQL= "SELECT szkolenie_id from rs_szkolenia WHERE firma_id='"+self.firma_id+"' AND szkolenie_id='"+Szkolenie+"';"
                stat,szk,dump,dump = self.PolSQL.Execute(SQL ,3)
                if stat<>'OK': 
                    dane.append('Bdy sprawdzania czy szkolenie istnieje.')
                elif len(szk)==0:
                    dane.append('Podane szkolenie nie istnieje')               
                else:            
                    Szkolenie=wart
            else:
                dane.append('Niewypenione szkolenie')
        elif pole == 'miejsce':
            if wart<>'':
                SQL=" SELECT kod from rs_szkolenia_miejsca WHERE firma_id='"+self.firma_id+"' AND kod='"+Miejsce+"';"
                stat,miej,dump,dump = self.PolSQL.Execute(SQL ,3)
                if stat<>'OK': 
                    dane.append('Bdy sprawdzania czy miejsce istnieje.')
                elif len(miej)==0:
                    dane.append('Podane miejsce nie istnieje')               
                else:            
                    Miejsce=wart
            else:
                dane.append('Niewypenione miejsce')
        elif pole == 'prowadzacy_pracownik':
            if wart<>'':
                SQL="SELECT pracownik_id from rs_kp_dane_osobowe WHERE firma_id='"+self.firma_id+"' AND pracownik_id='"+Prowadzacy+"';"
                stat,prac,dump,dump = self.PolSQL.Execute(SQL ,3)
                if stat<>'OK': 
                    dane.append('Bdy sprawdzania czy pracownik istnieje.')
                elif len(prac)==0:
                    dane.append('Podany pracownik nie istnieje')               
                else:            
                    Prowadzacy=wart
        elif pole == 'prowadzacy_kontrahent':
            if wart<>'':
                SQL="SELECT kontrahent_id from rs_kontrahenci WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+ProwadzacyObcy+"';"
                stat,kont,dump,dump = self.PolSQL.Execute(SQL ,3)
                if stat<>'OK': 
                    dane.append('Bdy sprawdzania czy kontrahent istnieje.')
                elif len(kont)==0:
                    dane.append('Podany kontrahent nie istnieje')               
                else:            
                    ProwadzacyObcy=wart
    if len(dane) > 0:
        stat = dane[0]

#-------------------------------------------------------------------------------
#--- SPRAWDZENIE UNIKALNOCI KLUCZA (2)
#-------------------------------------------------------------------------------

    if Fun==2 and stat=='OK':
        KL = " SELECT szkolenie_id FROM rs_szkolenia_harmonogram"
        KL+= " WHERE firma_id='"+self.firma_id+"' AND szkolenie_id='"+Szkolenie+"' AND data='"+Data+"' "
        KL+= " AND godzina='"+Godzina+"' AND miejsce='"+Miejsce+"' "
        stat,kl,wyn1,dump = self.PolSQL.Execute(KL ,3)
        if stat=='OK':
            if len(kl)<>0:
                dane.append('Istnieje ju identyczne szkolenie w harmonogramie')
        else:            
            dane.append('Bdy sprawdzania klucza szkolenia')
    if len(dane) > 0:
        stat = dane[0]

#-------------------------------------------------------------------------------
#--- TWORZENIE HARMONOGRAMU (2)
#-------------------------------------------------------------------------------

if Fun==2 and stat == 'OK':
    #--Pobieramy pracownikw dopisanych do podanego szkolenia, ale tylko tych, ktrzy anga maj w terminie szkolenia
    SQL= "SELECT DISTINCT ang.pracownik_id FROM rs_kp_angaze ang "
    SQL+= " WHERE ang.firma_id='"+self.firma_id+"' AND ( "
    SQL+= "(ang.stanowisko_id IN (SELECT DISTINCT stanowisko FROM rs_szkolenia_stanowiska_dzialy WHERE firma_id='"+self.firma_id+"' AND szkolenie_id='"+Szkolenie+"'))"
    SQL+= "  OR  (ang.komorka_id IN "
    SQL+= "(SELECT DISTINCT komorka_organizacyjna FROM rs_szkolenia_stanowiska_dzialy WHERE firma_id='"+self.firma_id+"' AND szkolenie_id='"+Szkolenie+"')) )"
    SQL+= " AND ang.od_kiedy<='"+Data+"' AND (ang.do_kiedy>='"+Data+"' OR ang.do_kiedy is NULL) "
    stat,prac,dump,dump = self.PolSQL.Execute(SQL,3)
    if stat<>'OK':
        dane.append('Bdy pobierania listy pracownikw')
    #--Pobieramy liczb dni karencji dla szkolenia
    SQL=" SELECT dni_karencji from rs_szkolenia WHERE firma_id='"+self.firma_id+"' AND szkolenie_id='"+Szkolenie+"' ;"
    stat,dni,dump,dump = self.PolSQL.Execute(SQL,3)
    if stat<>'OK':
        dane.append('Bdy pobierania okresu wanoci szkolenia')
    #--Pobieramy pracownikw, ktrzy "api si" terminem wanoci swojego szkolenia na nowe szkolenie, albo szkolenia nie odbyli wcale
    if stat=='OK':
        SQL=''
        prac2=[]       
        for i in xrange(len(prac)):
            SQL= " SELECT kp.pracownik_id FROM rs_kp_dane_osobowe kp "
            SQL+=" LEFT JOIN rs_kp_dane_osobowe_szkolenia ds"
            SQL+=" USING(firma_id,pracownik_id)"
            SQL+=" WHERE kp.firma_id='"+self.firma_id+"' AND "
            SQL+=" (ds.szkolenie_id is NULL OR (ds.data_waznosci<=('"+Data+"'::DATE+"+str(dni[0][0])+"::INTEGER))) "
            SQL+=" AND kp.pracownik_id='"+prac[i][0]+"'"
            stat,dat,dump,dump = self.PolSQL.Execute(SQL,3)
            if len(dat)>0:
                prac2.append(dat[0])
    #--INSERT danych do harmonogramu szkole
    SQL= "INSERT INTO rs_szkolenia_harmonogram (firma_id,szkolenie_id,data,godzina,miejsce,stan,prowadzacy_pracownik, prowadzacy_kontrahent) "
    SQL+=" VALUES ('"+self.firma_id+"','"+Szkolenie+"','"+Data+"','"+Godzina+":00','"+Miejsce+"','W'"
    if Prowadzacy<>'':
        SQL+=" ,'"+Prowadzacy+"' "
    else:
        SQL+=" ,NULL "
    if ProwadzacyObcy<>'':
        SQL+=" ,'"+ProwadzacyObcy+"' " 
    else:
        SQL+=" ,NULL "
    SQL+=" ) ; "
    stat,d,dump,dump = self.PolSQL.Execute(SQL,1)
    if stat<>'OK':
        dane.append('Bdy dodawania szkolenia do harmonogramu')        
    #--INSERT pracowikw do przeszkolenia w ptli po jednym
    if stat=='OK':
        INS=""
        for i in xrange(len(prac2)):
            pracownik=rsglobal.Dekoduj(prac2[i][0])
            INS+="INSERT INTO rs_szkolenia_harmonogram_pracownicy "
            INS+=" (firma_id, szkolenie_id, data, godzina,miejsce,pracownik_id,obecny) "
            INS+=" VALUES ('"+self.firma_id+"','"+Szkolenie+"','"+Data+"','"+Godzina+"','"+Miejsce+"','"+pracownik+"', TRUE ); "
        if INS<>'':
            stat,d,dump,dump = self.PolSQL.Execute(INS,1)
            if stat<>'OK':
                dane.append('Bd dodawania pracownikw do harmonogramu')

#-------------------------------------------------------------------------------
#--- UPDATE DANYCH (4)
#-------------------------------------------------------------------------------

if Fun in(3, 4) and stat=='OK':
    #--sprawdzamy stan szkolenia
    STAN= "SELECT szkolenie_id from rs_szkolenia_harmonogram WHERE "
    STAN+=" firma_id='"+self.firma_id+"' AND szkolenie_id='"+Szkolenie+"' AND data='"+Data+"' "
    STAN+=" AND godzina='"+Godzina+"' AND miejsce='"+Miejsce+"' AND stan='W' "
    stat,d,dump,dump = self.PolSQL.Execute(STAN,3)
    if stat<>'OK':
        dane.append('Problemy z pobieraniem stanu szkolenia')
    elif len(d)==1:
        dane.append('Szkolenie w stanie Z. Nie mona zmieni prowadzcego')
    #--UPDATE
    if stat=='OK':
        UPDATE = "UPDATE rs_szkolenia_harmonogram SET "
        for i in xrange(len(pola)):
            pole = pola[i]
            wart = wartosci[i]
            if pole in ('prowadzacy_pracownik','prowadzacy_kontrahent'):
                if wart=='':
                    UPDATE += pole+"=NULL,"
                else:
                    UPDATE += pole+"='"+str(wart)+"',"
        UPDATE = UPDATE[:-1]
        UPDATE+=" WHERE (firma_id, szkolenie_id, data, godzina,miejsce) "
        UPDATE+=" = ('"+self.firma_id+"','"+Szkolenie+"','"+Data+"','"+Godzina+"','"+Miejsce+"');" 
        stat,dump,dump,dump = self.PolSQL.Execute(UPDATE ,1)    
        if stat != 'OK':
            dane.append(stat)
    else:
        dane.append(stat)
        
#-------------------------------------------------------------------------------
#---POBIERANIE DANYCH (1,2,3)
#-------------------------------------------------------------------------------

if Fun in (1,2,3,5) and stat=='OK':
    SELECT ="SELECT * FROM rs_szkolenia_harmonogram"
    SELECT+=" WHERE firma_id = '"+self.firma_id+"' AND szkolenie_id = '"+str(Szkolenie)+"' "
    SELECT+="AND data = '"+str(Data)+"' and godzina = '"+str(Godzina)+"' AND miejsce='"+str(Miejsce)+"';"
    stat,dane,wyn1,dump = self.PolSQL.Execute(SELECT,3)
    if stat != 'OK':
        stat = 'Bd pobrania danych szkolenia : '+stat
        dane.append(stat)
    if stat == 'OK' and len(dane) == 1:        
        tr = rssql.RSTableRowset(dane,wyn1)
        if (self.oddzial_id,'053200') in self.uprawnienia or self.operator_id == STANDARD_OPERATOR_ID:
            sql = "SELECT nazwa FROM rs_szkolenia WHERE firma_id='"+self.firma_id+"' AND szkolenie_id = '"+tr.GetVal(0,"szkolenie_id")+"';"
            stat,d,dump,dump = self.PolSQL.Execute(sql, 3)
            if stat != 'OK':
                wyn2.append('Bd pobrania opisu ze sownika rodzaju bada')
            else:
                if len(d) == 0:
                    wyn2.append('Bdny kod szkolenia.')
                else:
                    wyn2.append(d[0][0])
        else:
            wyn2.append('Brak uprawnie do szkole. Poinformuj administratora.')
      
        if (self.oddzial_id,'012000') in self.uprawnienia or self.operator_id == STANDARD_OPERATOR_ID:
            sql = "SELECT nazwa FROM rs_kontrahenci WHERE firma_id='"+self.firma_id+"' AND kontrahent_id = '"+tr.GetVal(0,"prowadzacy_kontrahent")+"';"
            stat,d,dump,dump = self.PolSQL.Execute(sql, 3)
            if stat != 'OK':
                wyn2.append('Bd pobrania opisu kontrahenta')
            else:
                if len(d) == 0:
                    wyn2.append( 'Bdny kod kontrahenta.')
                else:
                    wyn2.append(d[0][0])
        else:
            wyn2.append('Brak uprawnie do kontrahentw. Poinformuj administratora.')
            
        if (self.oddzial_id,'053200') in self.uprawnienia or self.operator_id == STANDARD_OPERATOR_ID:
            sql = "SELECT imie||' '||nazwisko FROM rs_kp_dane_osobowe WHERE firma_id='"+self.firma_id+"' AND pracownik_id = '"+tr.GetVal(0,"prowadzacy_pracownik")+"';"
            stat,d,dump,dump = self.PolSQL.Execute(sql, 3)
            if stat != 'OK':
                wyn2.append('Bd pobrania opisu pracownika : ')
            else:
                if len(d) == 0:
                    wyn2.append('Bdny kod pracownika.')
                else:
                    wyn2.append(d[0][0])
        else:
            wyn2.append('Brak uprawnie do pracownikw. Poinformuj administratora.')