# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_kp_szkolenia_stanowiska_dzialy.py
# Purpose:     obsluga grida edytowalnego ze list szkole-dziaw
# Author:      Marcin Natkaski
# Created:     2012/08/31
# RCS-ID:      $Id: fs_kp_szkolenia_stanowiska_dzialy.py$
# Copyright:   (c) 2010 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

stat='OK'

if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=='OK':
    Funkcja = klucze['Funkcja']
    
    SlPar={'Szkolenie':[1,5], 'Stanowisko':[1,5], 'Dzial':[1,5], 'StanowiskoOpis':[8], 'DzialOpis':[9],
           'StanowiskoF':[1,5],'DzialF':[1,5]}    
    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Funkcja,klucze)
    if Lista<>'':
        stat='Uwaga : wywoanie funkcji fs_kp_szkolenia_dane z numerem '+str(Funkcja)+' bez parametrw: '+Lista
        
    if Funkcja in (1,5): 
        Szkolenie=rsglobal.Dekoduj(klucze['Szkolenie'])
        Stanowisko=rsglobal.Dekoduj(klucze['Stanowisko'])
        StanowiskoF=rsglobal.Dekoduj(klucze['StanowiskoF'])
        Dzial=rsglobal.Dekoduj(klucze['Dzial'])
        DzialF=rsglobal.Dekoduj(klucze['DzialF'])
        
    if Funkcja == 8:
        StanowiskoOpis = rsglobal.Dekoduj(klucze['StanowiskoOpis'])
        
    if Funkcja == 9:
        DzialOpis = rsglobal.Dekoduj(klucze['DzialOpis'])
        
UprDodawanie = (((self.oddzial_id,'053003') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID))
UprEdycja = (((self.oddzial_id,'053002') in self.uprawnienia) or UprDodawanie or (self.operator_id == STANDARD_OPERATOR_ID))
UprUsuwanie = (((self.oddzial_id,'053004') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID))

#-------------------------------------------------------------------------------
#-------  POBRANIE OPISU STANOWISKA (8)
#-------------------------------------------------------------------------------

if Funkcja == 8 and stat == "OK":
    sql ="SELECT opis FROM rs_stanowiska_pracy "
    sql+=" WHERE firma_id='"+self.firma_id+"' AND kod='"+StanowiskoOpis+"';"

    stat,dane,dump,dump = self.PolSQL.Execute(sql,3)
    if stat <> 'OK':
        stat = 'Bd przy sprawdzaniu opisu stanowiska: '+stat
        dane.append(stat)
        
#-------------------------------------------------------------------------------
#-------  POBRANIE OPISU DZIALU (9)
#-------------------------------------------------------------------------------

if Funkcja == 9 and stat == "OK":
    sql ="SELECT opis FROM rs_komorki_zatrudniajace "
    sql+=" WHERE firma_id='"+self.firma_id+"' AND kod='"+DzialOpis+"';"

    stat,dane,dump,dump = self.PolSQL.Execute(sql,3)
    if stat <> 'OK':
        stat = 'Bd przy sprawdzaniu opisu stanowiska: '+stat
        dane.append(stat)

#-------------------------------------------------------------------------------
#-------  SPRAWDZANIE DELETE  (1)
#-------------------------------------------------------------------------------

if Funkcja == 1 and stat=="OK":
    Delete=klucze['Delete']
    if len(Delete[0])>0:
        if not UprUsuwanie:
            stat='BR UPR DEL'
            dane.append(stat)
        
        # wykonanie DELETE 
        if stat == 'OK':
            SQLDEL = ''
            SQLFU = ''
            for i in xrange(len(Delete[0])):
                SQLFU+= "SELECT stanowisko FROM rs_szkolenia_stanowiska_dzialy"
                SQLFU+=" WHERE firma_id='"+self.firma_id+"' AND szkolenie_id='"+Szkolenie+"'"
                DELETE = "DELETE FROM rs_szkolenia_stanowiska_dzialy "
                WHERE = "WHERE firma_id='"+self.firma_id+"' AND szkolenie_id='"+Szkolenie+"'"
                for j in xrange(len(Delete[0][i])):
                    pole = Delete[1][j]
                    wart = Delete[0][i][j]
                    if pole in ['stanowisko','komorka_organizacyjna']:
                        WHERE += " AND "+pole+"='"+wart+"'"
                        SQLFU += " AND "+pole+"='"+wart+"'"
                        
                SQLDEL += DELETE+WHERE+"; "
                SQLFU += " FOR UPDATE NOWAIT; "

            if SQLFU <> '':
                stat,d,dump,dump = self.PolSQL.Execute(rsglobal.Dekoduj(SQLFU),3)
                if stat <> 'OK':
                    stat = 'Bd sprawdzenia danych do usunicia: '+stat
                    dane.append(stat)

            if stat == "OK" and SQLDEL <> '':
                stat,dump,dump,dump = self.PolSQL.Execute(rsglobal.Dekoduj(SQLDEL),1)
                if stat <> 'OK':
                    stat = "Bd przy usuwaniu danych: "+stat   
                    dane.append(stat)

                                 
#-------------------------------------------------------------------------------
#---   UPDATE DANYCH (1)
#-------------------------------------------------------------------------------

if Funkcja == 1 and stat=="OK":
    Update=klucze['Update']

    if len(Update[0])>0:
        if not UprEdycja:
            stat='BR UPR UPD'
            dane.append(stat)

        if stat == 'OK':
            SQLFU = ''
            for i in xrange(len(Update[0])):
                SQLFU+= "SELECT stanowisko FROM rs_szkolenia_stanowiska_dzialy"
                SQLFU+=" WHERE firma_id='"+self.firma_id+"' AND szkolenie_id='"+Szkolenie+"'"

                for j in xrange(len(Update[2][i])): # petla po kluczu
                    pole = Update[3][j]
                    wart = rsglobal.Dekoduj(Update[2][i][j])
                    SQLFU += " AND "+pole+"='"+wart+"'"                        
                SQLFU += " FOR UPDATE NOWAIT; "
            
            if SQLFU <> '':
                stat,d,dump,dump = self.PolSQL.Execute(rsglobal.Dekoduj(SQLFU),3)
                if stat <> 'OK':
                    stat = 'Bd sprawdzenia danych do modyfikacji: '+stat
                    dane.append(stat)

        if stat == 'OK':
            WierszeNr = Update[-1]
            for i in xrange(len(Update[0])):
                StanowiskoNowe = None
                DzialNowy = None               
                for j in xrange(len(Update[0][i])): 
                    pole=Update[0][i][j]
                    wart=Update[1][i][j]
                    
                    if pole == 'stanowisko':
                        if wart == '':
                            stat = 'BR STAN'
                            wyn2.append((WierszeNr[i],0))
                            dane.append(stat)
                        else:
                            sql ="SELECT kod FROM rs_stanowiska_pracy"
                            sql+=" WHERE firma_id = '"+self.firma_id+"'"
                            sql+=" AND kod = '"+str(wart)+"';" 
                            stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                            if stat <> 'OK':
                                stat = 'BL SQL STAN'
                                wyn2.append((WierszeNr[i],0))
                                dane.append(stat)
                            elif len(d) == 0:
                                stat = 'BL STAN'
                                wyn2.append((WierszeNr[i],0))
                                dane.append(stat)

                    elif pole == 'komorka_organizacyjna':
                        wart = wart.strip()
                        TrasaNowy = str(wart)
                        if wart == '':
                            stat = 'BR DZIAL'
                            wyn2.append((WierszeNr[i],3))
                            dane.append(stat)
                        else:
                            sql ="SELECT kod FROM rs_komorki_zatrudniajace"
                            sql+=" WHERE firma_id = '"+self.firma_id+"'"
                            sql+=" AND kod = '"+str(wart)+"';"
                            stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                            if stat <> 'OK':
                                stat = 'BL SQL DZIAL'
                                wyn2.append((WierszeNr[i],3))
                                dane.append(stat)
                            elif len(d) == 0:
                                stat = 'BL DZIAL'
                                wyn2.append((WierszeNr[i],3))
                                dane.append(stat)
 
        if stat == 'OK':
            if len(dane) > 0:
                stat = dane[0]
                
        # wykonanie UPDATE
        if stat=='OK':
            sql=''
            for i in xrange(len(Update[0])):
                UPDATE="UPDATE rs_szkolenia_stanowiska_dzialy "
                SET='SET '
                for j in xrange(len(Update[0][i])): 
                    pole=Update[0][i][j]
                    wart=Update[1][i][j]
                    if pole in ['stanowisko', 'komorka_organizacyjna']:
                        SET+=pole+"='"+wart+"',"
                    
                SET=SET.strip(",")
                WHERE=" WHERE firma_id='"+self.firma_id+"' AND szkolenie_id='"+Szkolenie+"'" 
                for j in xrange(len(Update[2][i])): # petla po kluczu
                    pole=Update[3][j]
                    wart=rsglobal.Dekoduj(Update[2][i][j])
                    if pole in ['stanowisko', 'komorka_organizacyjna']:
                        WHERE+=" AND "+pole+"='"+wart+"'"
                        
                WHERE+=";"    
                
                sql+=UPDATE+SET+WHERE;
                
            if sql<>'':
                stat,dump,dump,dump=self.PolSQL.Execute(rsglobal.Dekoduj(sql),1)
                if stat<>'OK':
                    stat="Bd przy modyfikowaniu danych: "+stat   
                    dane.append(stat)  


#-------------------------------------------------------------------------------
#---------INSERT DANYCH (1)
#-------------------------------------------------------------------------------

if Funkcja == 1 and stat=="OK":
    Insert=klucze['Insert']
    if len(Insert[0])>0:
        if not UprDodawanie:
            stat='BR UPR INS'
            dane.append(stat)

        if stat == 'OK':
            WierszeNr = Insert[-1]
            for i in xrange(len(Insert[0])):
                StanowiskoNowe = None
                DzialNowy = None               
                for j in xrange(len(Insert[0][i])): 
                    pole=Insert[1][j]
                    wart=Insert[0][i][j]
                    
                    if pole == 'stanowisko':
                        wart = wart.strip()
                        if wart == '':
                            stat = 'BR ODDZ'
                            wyn2.append((WierszeNr[i],0))
                            dane.append(stat)
                        else:
                            StanowiskoNowe = wart
                            sql ="SELECT kod FROM rs_stanowiska_pracy"
                            sql+=" WHERE firma_id = '"+self.firma_id+"'"
                            sql+=" AND kod = '"+str(wart)+"';" 
                            stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                            if stat <> 'OK':
                                stat = 'BL SQL ODDZ'
                                wyn2.append((WierszeNr[i],0))
                                dane.append(stat)
                            elif len(d) == 0:
                                stat = 'BL ODDZ'
                                wyn2.append((WierszeNr[i],0))
                                dane.append(stat)

                    elif pole == 'komorka_organizacyjna':
                        wart = wart.strip()
                        if wart == '':
                            stat = 'BR DZIAL'
                            wyn2.append((WierszeNr[i],2))
                            dane.append(stat)
                        else:
                            DzialNowy = wart
                            sql ="SELECT kod FROM rs_komorki_zatrudniajace"
                            sql+=" WHERE firma_id = '"+self.firma_id+"'"
                            sql+=" AND kod = '"+str(wart)+"';"
                            stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                            if stat <> 'OK':
                                stat = 'BL SQL DZIAL'
                                wyn2.append((WierszeNr[i],2))
                                dane.append(stat)
                            elif len(d) == 0:
                                stat = 'BL DZIAL'
                                wyn2.append((WierszeNr[i],2))
                                dane.append(stat)
                                
                #sprawdzam przed dodawaniem, czy podany klucz ju istnieje,
                #bo operator moze miec na gridzie filtr i nie widziec,
                #ze podany (choc dozwolony) klucz juz istnieje
                if len(dane) == 0 and DzialNowy <> None and StanowiskoNowe <> None and stat=='OK':
                    sql ="SELECT szkolenie_id FROM rs_szkolenia_stanowiska_dzialy"
                    sql+=" WHERE firma_id='"+self.firma_id+"' AND szkolenie_id='"+Szkolenie+"'"
                    sql+=" AND komorka_organizacyjna='"+DzialNowy+"'"
                    sql+=" AND stanowisko='"+StanowiskoNowe+"';"

                    stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                    if stat <> 'OK':
                        stat = 'BL SQL KLUCZ'+stat
                        dane.append(stat)
                        wyn2.append((WierszeNr[i],0))
                        wyn2.append((WierszeNr[i],2))
                    elif len(d) > 0:
                        stat = 'BL KLUCZ IST'
                        dane.append(stat)
                        wyn2.append((WierszeNr[i],0))
                        wyn2.append((WierszeNr[i],2))

        if stat == 'OK':
            if len(dane) > 0:
                stat = dane[0]
                                                        
        # wykonanie INSERT
        if stat == 'OK':    
            sqlIns=''
            for i in xrange(len(Insert[0])):
                INSERT="INSERT INTO rs_szkolenia_stanowiska_dzialy "
                KOLUMNY="(firma_id, szkolenie_id"
                VALUES=" VALUES ('"+self.firma_id+"','"+Szkolenie+"' "
                for j in xrange(len(Insert[0][i])):
                    pole=Insert[1][j]
                    wart=Insert[0][i][j]
                    if pole in ['stanowisko','komorka_organizacyjna']:
                        KOLUMNY+=","+pole
                        VALUES+=",'"+wart+"'"                                           
                        
                KOLUMNY+=")"
                VALUES+=");"
                sqlIns+=INSERT+KOLUMNY+VALUES
            if sqlIns<>'': 
                stat,dump,dump,dump=self.PolSQL.Execute(rsglobal.Dekoduj(sqlIns),1)

                if stat<>'OK':
                    stat="Bd przy dodawaniu danych: "+stat   
                    dane.append(stat)                   

#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (1- insert 1 -select, 1 -delete)
#-------------------------------------------------------------------------------

if Funkcja in (1,5) and stat=='OK':
    SQL ="SELECT ssd.stanowisko, sp.opis, ssd.komorka_organizacyjna, kz.opis"
    SQL+=" FROM rs_szkolenia_stanowiska_dzialy ssd"
    SQL+=" LEFT OUTER JOIN rs_stanowiska_pracy sp ON (sp.firma_id=ssd.firma_id AND sp.kod=ssd.stanowisko)"
    SQL+=" LEFT OUTER JOIN rs_komorki_zatrudniajace kz ON (kz.firma_id=ssd.firma_id AND kz.kod=ssd.komorka_organizacyjna)"
    SQL+=" WHERE ssd.firma_id='"+self.firma_id+"' AND ssd.szkolenie_id='"+Szkolenie+"'"
    if StanowiskoF <>'':
        SQL+=" AND ssd.stanowisko ='"+StanowiskoF+"' "
    if DzialF <> '':
        SQL+=" AND ssd.komorka_organizacyjna='"+DzialF+"' "
    SQL+=" ORDER BY ssd.stanowisko, ssd.komorka_organizacyjna;"
    stat,dane,wyn1,wyn2 = self.PolSQL.Execute(SQL,3)

    if stat <> 'OK':
        stat = "Bd przy pobieraniu danych: "+stat
        dane.append(stat)