# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_kp_szkolenia_wersje_dane
# Purpose:     dodawanie/edycja wersji szkole
# Author:      Marcin Natkaski
# Created:     2012/06/14
# RCS-ID:      $Id: fs_kp_szkolenia_wersje_dane.py $
# Copyright:   (c) 2012 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------
import rsglobal

stat = 'OK'
dane = []
wyn1 = []
wyn2 = []

if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=='OK':
    Fun = klucze['Funkcja']
    
    SlPar={'Szkolenie':[1,2,3,4,5],'Wersja':[1,2,3,4,5],'DataOd':[1,2,3,4,5],'WersjaStara':[3,4,5],'DataOdStara':[3,4,5]}    
    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Fun,klucze)
    if Lista<>'':
        stat='Uwaga : wywoanie funkcji fs_kp_szkolenia_wersje_dane z numerem '+str(Fun)+' bez parametrw: '+Lista
        
    if Fun in (1,2,3,4,5,): 
        Szkolenie=rsglobal.Dekoduj(klucze['Szkolenie'])
        Wersja=rsglobal.Dekoduj(klucze['Wersja'])
        DataOd=rsglobal.Dekoduj(klucze['DataOd'])
        
    if Fun in (3,4,5):
        WersjaStara=rsglobal.Dekoduj(klucze['WersjaStara'])
        DataOdStara=rsglobal.Dekoduj(klucze['DataOdStara'])

UprDodawanie = (((self.oddzial_id,'053103') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID))
UprEdycja = (((self.oddzial_id,'053102') in self.uprawnienia) or UprDodawanie or (self.operator_id == STANDARD_OPERATOR_ID))

#-------------------------------------------------------------------------------
# sprawdzenie uprawnien
#-------------------------------------------------------------------------------

if Fun in (1,2) and stat == 'OK':
    if not UprDodawanie:
        stat = 'BR UPR INS'

if Fun in (3,4) and stat == 'OK':
    if not UprEdycja:
        stat = 'BR UPR UPD'

#-------------------------------------------------------------------------------
# sprawdzenie danych
#-------------------------------------------------------------------------------
  
if stat == 'OK':
   for i in range(len(pola)):
        pole = pola[i].lower()
        wart = wartosci[i]

        if pole in ('opracowal','sprawdzil','zweryfikowal','zatwierdzil'):
            if wart != '':
                sql="SELECT * from rs_operatorzy WHERE operator_id='"+str(wart)+"';"
                stat,d,dump,dump = self.PolSQL.Execute(sql, 3)
                if stat != 'OK':
                    dane.append('Bd pobrania id operatora : '+stat)
                elif len(d)==0:
                    dane.append("Operator: '"+str(wart)+"' nie istnieje w systemie.")
            wartosci[i] = wart
        if pole in ('data_od'):
            if wart<>'    -  -  ':
                if not rsglobal.SprawdzCzyToData(wart):
                    dane.append("To jest bdny format daty: '"+wart+"'")
                else:
                    wartosci[i]=wart
            else:
                dane.append("Pole Data musi by wypenione")
        if pole in ('opracowal_data','sprawdzil_data','zweryfikowal_data','sprawdzil_data','data_od'):
            if wart<>'    -  -  ':
                if not rsglobal.SprawdzCzyToData(wart):
                    dane.append("To jest bdny format daty: '"+wart+"'")
                else:
                    wartosci[i]=wart 
        if pole in ('wersja'):
            sql ="SELECT * from rs_szkolenia_wersje WHERE firma_id='"+self.firma_id+"' "
            sql+=" AND szkolenie_id='"+Szkolenie+"' AND wersja='"+str(wart)+"'"
            stat,d,dump,dump = self.PolSQL.Execute(sql, 3)
            if len(d)>0:
                dane.append('Istnieje ju taka wersja szkolenia : '+str(wart))
            else:
                wartosci[i]=str(wart) 

        if len(dane) > 0:
            stat = dane[0]


#-------------------------------------------------------------------------------
#--- DODAWANIE DANYCH (1 -z pobraniem select  2 - bez pobrania
#-------------------------------------------------------------------------------

if Fun in (1,2):
    if stat == 'OK':
        ins = "INSERT INTO rs_szkolenia_wersje"
        Pola="firma_id" 
        Wartosci="'"+self.firma_id+"'" 
        for i in range(len(pola)):
            pole = pola[i]
            wart = wartosci[i]
            if pole in ['szkolenie_id']:
                Pola= Pola+","+pole
                Wartosci= Wartosci+",'"+wart+"'"
                    
            elif pole in ['opracowal','sprawdzil','zweryfikowal','zatwierdzil','wersja']:
                Pola= Pola+","+pole
                Wartosci= Wartosci+","+str(wart)
            
            elif pole == 'data_od':
                if wart == '    -  -  ':
                    dane.append('BR DATA_OD')

                else:
                    Pola= Pola+","+pole
                    Wartosci= Wartosci+",'"+wart+"'"
                    
            elif pole in ['opracowal_data','sprawdzil_data','zweryfikowal_data','zatwierdzil_data']:
                Pola= Pola+","+pole
                if wart != '    -  -  ':
                    Wartosci=Wartosci+",'"+wart+"'"
                else:
                    Wartosci= Wartosci+",NULL"
            
        ins = ins+" ("+Pola+") VALUES ("+Wartosci+");"        
        stat,dump,dump,dump = self.PolSQL.Execute(ins,1)
        if stat != 'OK':
            stat = 'Bd dodawania nowego szkolenia : '+stat
            dane.append(stat)


#-------------------------------------------------------------------------------
#--- UPDATE DANYCH ( 3-update, 4 -update z pobraniem)
#-------------------------------------------------------------------------------

if Fun in (3,4) and stat == 'OK':
    upd = "UPDATE rs_szkolenia_wersje SET "
    WHERE = " WHERE firma_id = '"+self.firma_id+"' and szkolenie_id = '"+Szkolenie+"'"
    WHERE += " AND wersja='"+str(WersjaStara)+"' AND data_od='"+DataOdStara+"';"
    Wartosci=''
    Pola=''
    for i in range(len(pola)):
            pole = pola[i]
            wart = wartosci[i]
            if pole in ['szkolenie_id','wersja']:
                Pola= Pola+","+pole
                Wartosci= Wartosci+",'"+wart+"'"
                
            elif pole == ['wersja']: 
                Pola= Pola+","+pole
                
                if wart<>'':
                    Wartosci= Wartosci+",'"+wart+"'"
                else:                 
                    Wartosci= Wartosci+",NULL"
                    
            elif pole in ['opracowal','sprawdzil','zweryfikowal','zatwierdzil']:
                Pola= Pola+","+pole
                Wartosci= Wartosci+","+str(wart)
            
            elif pole == 'data_od':
                if wart == '    -  -  ':
                    dane.append('BR DATA_OD')

                else:
                    Pola= Pola+","+pole
                    Wartosci= Wartosci+",'"+wart+"'"
                    
            elif pole in ['opracowal_data','sprawdzil_data','zweryfikowal_data','zatwierdzil_data']:
                Pola= Pola+","+pole
                if wart != '    -  -  ':
                    Wartosci=Wartosci+",'"+wart+"'"
                else:
                    Wartosci= Wartosci+",NULL"

    if len(pola)>1:
        upd = upd+" ("+Pola[1:]+") = ("+Wartosci[1:]+")" + WHERE
    elif len(pola) == 1:
        upd = upd+" "+Pola[1:]+" = "+Wartosci[1:]+"" + WHERE

    if len(pola)>0:
        rsglobal.ZapiszDoLogow(upd)
        stat,d,dump,dump = self.PolSQL.Execute(upd,1)
        if stat != 'OK':
            stat = 'Bd aktualizacji wersji szkolenia : '+stat
            dane.append(stat)


#-------------------------------------------------------------------------------
#--- POBRANIE DANYCH ( 5-select, 3 -update z pobraniem)
#-------------------------------------------------------------------------------

if Fun in (1,3,5,9) and stat=='OK':
    SELECT ="SELECT * FROM rs_szkolenia_wersje"
    SELECT+=" WHERE firma_id='"+self.firma_id+"' AND szkolenie_id='"+Szkolenie+"'"
    SELECT+=" AND wersja='"+str(Wersja)+"'" 
    if DataOd=='    -  -  ':
        SELECT+=" AND data_od IS NULL ;"
    else:    
        SELECT+=" AND data_od='"+DataOd+"';"
    rsglobal.ZapiszDoLogow(SELECT)
    stat,dane,wyn1,dump = self.PolSQL.Execute(SELECT,3)
    if stat != 'OK':
        stat = 'Bd pobrania danych wersji szkolenia : '+stat
        dane.append(stat)