# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_kp_typy_informacji_pozycje.py
# Purpose:     obsluga grida edytowalnego pozycji dla typw informacji
# Author:      Marcin Natkaski
# Created:     2014/08/01
# RCS-ID:      $Id: fs_kp_typy_informacji_pozycje $
# Copyright:   (c) 2014 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

stat='OK'

if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=='OK':
    Funkcja = klucze['Funkcja']
    
    SlPar={'Typ':[1,5]}
    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Funkcja,klucze)
    if Lista<>'':
        stat='Uwaga : wywoanie funkcji fs_kp_typy_informacji_pozycje z numerem '+str(Funkcja)+' bez parametrw: '+Lista
        
    if Funkcja in [1,5]: 
        Typ=rsglobal.Dekoduj(klucze['Typ'])
        
dane = []
wyn1 = []
wyn2 = []

UprIns= self.operator_id == STANDARD_OPERATOR_ID
UprUpd= self.operator_id == STANDARD_OPERATOR_ID or UprIns
UprDel= self.operator_id == STANDARD_OPERATOR_ID

#-------------------------------------------------------------------------------
#-------- EDYCJA GRIDA EDYTOWALNEGO (1)
#-------------------------------------------------------------------------------

Insert = []
Update = []
Delete = []

if stat=='OK' and Funkcja == 1:
    Update=klucze['Update']
    Insert=klucze['Insert']
    Delete=klucze['Delete']

#-------------------------------------------------------------------------------
#-------  SPRAWDZANIE DELETE  --------------------------------------------------
#-------------------------------------------------------------------------------

if Funkcja == 1 and stat=="OK":
    if len(Delete[0])>0:
        if not UprDel:
            stat='BR UPR DEL'
            dane.append(stat)
            
        # wykonanie DELETE 
        if stat == 'OK':
            SQLDEL = ''
            SQLFU = ''
            SQLSPR = ''
            for i in xrange(len(Delete[0])):
                SQLSPR = "SELECT typ_id FROM rs_kp_dane_osobowe_dane_dodatkowe WHERE firma_id='"+self.firma_id+"' AND typ_id='"+Typ+"'"
                SQLFU =" SELECT lp FROM rs_kp_typy_informacji_pozycje "
                SQLFU+=" WHERE firma_id='"+self.firma_id+"' AND typ_id='"+str(Typ)+"' "
                DELETE = "DELETE FROM rs_kp_typy_informacji_pozycje "
                WHERE = "WHERE firma_id='"+self.firma_id+"' AND typ_id='"+str(Typ)+"' " 
                for j in xrange(len(Delete[0][i])):
                    pole = Delete[1][j]
                    wart = Delete[0][i][j]
                    if pole in ['typ','opis_kolumny']:
                        WHERE += " AND "+pole+"='"+wart+"'"
                        SQLFU += " AND "+pole+"='"+wart+"'"
                        
                    elif pole in ['po_przecinku','dlugosc']:
                        WHERE += " AND "+pole+"="+str(wart)
                        SQLFU += " AND "+pole+"="+str(wart)
                        
                    elif pole in ['lp']:
                        WHERE += " AND "+pole+"="+str(wart)
                        SQLFU += " AND "+pole+"="+str(wart)
                        #SQLSPR +=" AND "+pole+"="+str(wart)
                        SQLSPR +=" AND ("+str(wart)+"  in (SELECT pole1_id FROM rs_kp_dane_osobowe_dane_dodatkowe WHERE firma_id='"+self.firma_id+"') "
                        SQLSPR +=" OR "+str(wart)+"  in (SELECT pole2_id FROM rs_kp_dane_osobowe_dane_dodatkowe WHERE firma_id='"+self.firma_id+"') "
                        SQLSPR +=" OR "+str(wart)+"  in (SELECT pole3_id FROM rs_kp_dane_osobowe_dane_dodatkowe WHERE firma_id='"+self.firma_id+"') "
                        SQLSPR +=" OR "+str(wart)+"  in (SELECT pole4_id FROM rs_kp_dane_osobowe_dane_dodatkowe WHERE firma_id='"+self.firma_id+"') "
                        SQLSPR +=" OR "+str(wart)+"  in (SELECT pole5_id FROM rs_kp_dane_osobowe_dane_dodatkowe WHERE firma_id='"+self.firma_id+"') "
                        SQLSPR +=" OR "+str(wart)+"  in (SELECT pole6_id FROM rs_kp_dane_osobowe_dane_dodatkowe WHERE firma_id='"+self.firma_id+"') "
                        SQLSPR +=" OR "+str(wart)+"  in (SELECT pole7_id FROM rs_kp_dane_osobowe_dane_dodatkowe WHERE firma_id='"+self.firma_id+"') "
                        SQLSPR +=" OR "+str(wart)+"  in (SELECT pole8_id FROM rs_kp_dane_osobowe_dane_dodatkowe WHERE firma_id='"+self.firma_id+"') "
                        SQLSPR +=" OR "+str(wart)+"  in (SELECT pole9_id FROM rs_kp_dane_osobowe_dane_dodatkowe WHERE firma_id='"+self.firma_id+"') "
                        SQLSPR +=" OR "+str(wart)+"  in (SELECT pole10_id FROM rs_kp_dane_osobowe_dane_dodatkowe WHERE firma_id='"+self.firma_id+"')) "
                        wart_spr = str(wart)
                        
                SQLDEL += DELETE+WHERE+"; "
                SQLFU += " FOR UPDATE NOWAIT; "
                SQLSPR +=" ;"
                 # SPrawdzamy czy mona usun pozycj   
                stat,d,dump,dump = self.PolSQL.Execute(rsglobal.Dekoduj(SQLSPR),3)
                if stat <> 'OK':
                    stat = 'Bd sprawdzenia danych do usunicia: '+stat
                    dane.append(stat)
                elif len(d) > 0:
                    stat = "Nie mona usuwa pozycji z lp ="+str(wart)+"  bo wystpuje w danych dodatkowych pracownika"
                    dane.append(stat)
                    break
                
            if stat == "OK" and SQLFU <> '':
                stat,d,dump,dump = self.PolSQL.Execute(rsglobal.Dekoduj(SQLFU),3)
                if stat <> 'OK':
                    stat = 'Bd sprawdzenia danych do usunicia: '+stat
                    dane.append(stat)

            if stat == "OK" and SQLDEL <> '':
                stat,dump,dump,dump = self.PolSQL.Execute(rsglobal.Dekoduj(SQLDEL),1)
                if stat <> 'OK':
                    stat = "Bd przy usuwaniu danych: "+stat   
                    dane.append(stat)
              
#-------------------------------------------------------------------------------
#---   UPDATE DANYCH (1)
#-------------------------------------------------------------------------------

if Funkcja == 1 and stat=="OK":
    if len(Update[0])>0:
        if not UprUpd:
            stat='BR UPR UPD'
            dane.append(stat)

        if stat == 'OK':
            SQLFU = ''
            for i in xrange(len(Update[0])):
                SQLFU+="SELECT typ_id FROM rs_kp_typy_informacji_pozycje "
                SQLFU+=" WHERE firma_id='"+self.firma_id+"' AND typ_id='"+Typ+"' "
                SQLFU += " FOR UPDATE NOWAIT; "
            
            if SQLFU <> '' and stat == "OK":
                stat,d,dump,dump = self.PolSQL.Execute(rsglobal.Dekoduj(SQLFU),3)
                if stat <> 'OK':
                    stat = 'Bd sprawdzenia danych do modyfikacji: '+stat
                    dane.append(stat)
            
        if stat == 'OK':
            WierszeNr = Update[-1]

            for i in xrange(len(Update[0])):
                WartoscNowa = None

                for j in xrange(len(Update[0][i])): 
                    pole = Update[0][i][j]
                    wart = Update[1][i][j]

                    if pole == 'opis_kolumny':
                        wart = wart.strip()
                        if len(wart) > 30:
                            stat = 'BL OPIS'
                            wyn2.append((WierszeNr[i],1))
                            dane.append(stat)
                        if wart == '':
                            stat = 'BR OPIS'
                            wyn2.append((WierszeNr[i],1))
                            dane.append(stat)
                            
                    elif pole == 'lp':
                        if wart == 0:
                            stat = 'BR LP'
                            wyn2.append((WierszeNr[i],0))
                            dane.append(stat)
                        if wart < 0:
                            stat = 'BR LP ZERO'
                            wyn2.append((WierszeNr[i],0))
                            dane.append(stat)
                    elif pole == 'typ':
                        if len(wart) > 1:
                            stat = 'BL TYP'
                            wyn2.append((WierszeNr[i],2))
                            dane.append(stat)
                        if wart not in('B','T','D','I','N'):
                            stat = 'Bdny format danych'
                            wyn2.append((WierszeNr[i],2))
                            dane.append(stat)
                            
                    elif pole == 'po_przecinku':
                        if wart < 0:
                            stat = 'BR PO PRZEC ZERO'
                            wyn2.append((WierszeNr[i],3))
                            dane.append(stat) 
                            
                    elif pole == 'dlugosc':
                        if wart < 0:
                            stat = 'BR DLUG ZERO'
                            wyn2.append((WierszeNr[i],4))
                            dane.append(stat) 
        if stat == 'OK':
            if len(dane) > 0:
                stat = dane[0]
                

        if stat=='OK':
            sql=''
            SQLSPRUPD = ''
            for i in xrange(len(Update[0])):
                SQLSPRUPD = "SELECT typ_id FROM rs_kp_dane_osobowe_dane_dodatkowe WHERE firma_id='"+self.firma_id+"' AND typ_id='"+Typ+"' "
                UPDATE="UPDATE rs_kp_typy_informacji_pozycje "
                SET='SET '
                for j in xrange(len(Update[0][i])): 
                    pole=Update[0][i][j]
                    wart=Update[1][i][j]
                    
                    if pole in ['typ','opis_kolumny']:
                        SET+=pole+"='"+wart+"',"

                    elif pole in ['po_przecinku','dlugosc']:
                        SET+=pole+"="+str(wart)+","

                    elif pole in ['lp']:
                        SET+=pole+"='"+str(wart)+"',"
                SET=SET.strip(",")
                WHERE=" WHERE firma_id='"+self.firma_id+"' AND typ_id='"+Typ+"' "
                
                for j in xrange(len(Update[2][i])): # petla po kluczu
                    pole=Update[3][j]
                    wart=rsglobal.Dekoduj(Update[2][i][j])
                    if pole in ['lp']:
                        WHERE+= " AND "+pole+"='"+str(wart)+"'"
                        wart_spr = str(wart)

                WHERE+=";"
                
                sql+=UPDATE+SET+WHERE;
                #Sprawdzamy czy mona edytowa pozycje    
                SQLSPRUPD +=" AND ("+str(wart)+"  in (SELECT pole1_id FROM rs_kp_dane_osobowe_dane_dodatkowe WHERE firma_id='"+self.firma_id+"') "
                SQLSPRUPD +=" OR "+str(wart)+"  in (SELECT pole2_id FROM rs_kp_dane_osobowe_dane_dodatkowe WHERE firma_id='"+self.firma_id+"') "
                SQLSPRUPD +=" OR "+str(wart)+"  in (SELECT pole3_id FROM rs_kp_dane_osobowe_dane_dodatkowe WHERE firma_id='"+self.firma_id+"') "
                SQLSPRUPD +=" OR "+str(wart)+"  in (SELECT pole4_id FROM rs_kp_dane_osobowe_dane_dodatkowe WHERE firma_id='"+self.firma_id+"') "
                SQLSPRUPD +=" OR "+str(wart)+"  in (SELECT pole5_id FROM rs_kp_dane_osobowe_dane_dodatkowe WHERE firma_id='"+self.firma_id+"') "
                SQLSPRUPD +=" OR "+str(wart)+"  in (SELECT pole6_id FROM rs_kp_dane_osobowe_dane_dodatkowe WHERE firma_id='"+self.firma_id+"') "
                SQLSPRUPD +=" OR "+str(wart)+"  in (SELECT pole7_id FROM rs_kp_dane_osobowe_dane_dodatkowe WHERE firma_id='"+self.firma_id+"') "
                SQLSPRUPD +=" OR "+str(wart)+"  in (SELECT pole8_id FROM rs_kp_dane_osobowe_dane_dodatkowe WHERE firma_id='"+self.firma_id+"') "
                SQLSPRUPD +=" OR "+str(wart)+"  in (SELECT pole9_id FROM rs_kp_dane_osobowe_dane_dodatkowe WHERE firma_id='"+self.firma_id+"') "
                SQLSPRUPD +=" OR "+str(wart)+"  in (SELECT pole10_id FROM rs_kp_dane_osobowe_dane_dodatkowe WHERE firma_id='"+self.firma_id+"')) ; "        
                #SQLSPRUPD+="AND lp="+str(wart)+" ;"
                rsglobal.ZapiszDoLogow('11111111111111111111111111111'+SQLSPRUPD,1)
                stat,d,dump,dump = self.PolSQL.Execute(rsglobal.Dekoduj(SQLSPRUPD),3)
                if stat <> 'OK':
                    stat = 'Bd sprawdzenia danych do edycji: '+stat
                    dane.append(stat)
                elif len(d) > 0:
                    stat = "Nie mona edytowa pozycji z lp ="+str(wart_spr)+"  bo wystpuje w danych dodatkowych pracownika"
                    dane.append(stat)
                    break
                
            if stat=="OK" and sql<>'':
                stat,dump,dump,dump=self.PolSQL.Execute(rsglobal.Dekoduj(sql),1)
                if stat<>'OK':
                    stat="Bd przy modyfikowaniu danych: "+stat   
                    dane.append(stat)


#-------------------------------------------------------------------------------
#---------Sprawdzanie danych do Insert------
#-------------------------------------------------------------------------------

if Funkcja == 1 and stat=="OK":
    if len(Insert[0])>0:
        if not UprIns:
            stat='BR UPR INS'
            dane.append(stat)

        if stat == 'OK':
            WierszeNr = Insert[-1]
            for i in xrange(len(Insert[0])):
                WartoscNowa = None
                
                for j in xrange(len(Insert[0][i])): 
                    pole=Insert[1][j]
                    wart=Insert[0][i][j]

                    if pole == 'opis_kolumny':
                        wart = wart.strip()
                        if len(wart) > 30:
                            stat = 'BL OPIS'
                            wyn2.append((WierszeNr[i],1))
                            dane.append(stat)
                        if wart == '':
                            stat = 'BR OPIS'
                            wyn2.append((WierszeNr[i],1))
                            dane.append(stat)
                            
                    elif pole == 'lp':
                        if wart == 0:
                            stat = 'BR LP'
                            wyn2.append((WierszeNr[i],0))
                            dane.append(stat)
                        if wart < 0:
                            stat = 'BR LP ZERO'
                            wyn2.append((WierszeNr[i],0))
                            dane.append(stat)
                    elif pole == 'typ':
                        if len(wart) > 1:
                            stat = 'BL TYP'
                            wyn2.append((WierszeNr[i],2))
                            dane.append(stat)
                        if wart not in('B','T','D','I','N'):
                            stat = 'Bdny format danych'
                            wyn2.append((WierszeNr[i],2))
                            dane.append(stat)

                    elif pole == 'po_przecinku':
                        if wart < 0:
                            stat = 'BR PO PRZEC ZERO'
                            wyn2.append((WierszeNr[i],3))
                            dane.append(stat) 
                            
                    elif pole == 'dlugosc':
                        if wart < 0:
                            stat = 'BR DLUG ZERO'
                            wyn2.append((WierszeNr[i],4))
                            dane.append(stat) 
                                            
        if stat == 'OK':
            if len(dane) > 0:
                stat = dane[0]

        # wykonanie INSERT
        if stat == 'OK':
            sqlIns=''
            for i in xrange(len(Insert[0])):
                INSERT="INSERT INTO rs_kp_typy_informacji_pozycje "
                KOLUMNY="(firma_id,typ_id"
                VALUES=" VALUES ('"+self.firma_id+"','"+Typ+"'"
                for j in xrange(len(Insert[0][i])):
                    pole=Insert[1][j]
                    wart=Insert[0][i][j]
                    if pole in ['typ','opis_kolumny']:
                        KOLUMNY+=","+pole
                        VALUES+=",'"+wart+"'"
                    elif pole in ['lp','dlugosc','po_przecinku']:
                        KOLUMNY+=","+pole
                        VALUES+=","+str(wart)

                KOLUMNY+=")"
                VALUES+=");"
                sqlIns+=INSERT+KOLUMNY+VALUES
            if sqlIns<>'': 
                stat,dump,dump,dump=self.PolSQL.Execute(rsglobal.Dekoduj(sqlIns),1)
                if stat<>'OK':
                    stat="Bd przy dodawaniu danych: "+stat
                    dane.append(stat)

        
#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (1- insert 1 -select, 1 -delete, 5 -select) 
#-------------------------------------------------------------------------------

if Funkcja in (1,5) and stat=='OK':
    SQL ="SELECT lp,opis_kolumny,typ, dlugosc,po_przecinku"
    SQL+=" FROM rs_kp_typy_informacji_pozycje"
    SQL+=" WHERE firma_id='"+self.firma_id+"' AND typ_id='"+str(Typ)+"'"
    SQL+=" ORDER BY lp;"
    stat,dane,wyn1,wyn2 = self.PolSQL.Execute(SQL,3)
    #print 'takie sa dane  ',dane
    if stat <> 'OK':
        stat = "Bd przy pobieraniu danych: "+stat
        dane.append(stat)
    elif len(dane)>10:
        stat = "Za duo pozycji: "+stat
        dane.append(stat)
    #przenumerowanie pozycji     
    else:
        for i in xrange(len(dane)):
            if dane[i][0] <> i+1:
                UPD = "UPDATE rs_kp_typy_informacji_pozycje  "
                UPD+= " SET lp='"+str(i+1)+"' WHERE firma_id='"+self.firma_id+"' AND typ_id='"+str(Typ)+"' "
                UPD+= " AND lp='"+str(dane[i][0])+"' ;"
                stat,dump,dump,dump = self.PolSQL.Execute(UPD,1)
                if stat <> 'OK':
                    stat = "Bd przy przenumerowywaniu pozycji: "+stat
                    dane.append(stat)
    # pobranie danych po przenumerowaniu pozycji                 
    SQL ="SELECT lp,opis_kolumny,typ, dlugosc,po_przecinku"
    SQL+=" FROM rs_kp_typy_informacji_pozycje"
    SQL+=" WHERE firma_id='"+self.firma_id+"' AND typ_id='"+str(Typ)+"'"
    SQL+=" ORDER BY lp;"
    stat,dane,wyn1,wyn2 = self.PolSQL.Execute(SQL,3)
    if stat <> 'OK':
        stat = "Bd przy pobieraniu danych: "+stat
        dane.append(stat)