# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_kp_wzory_dokumentow.py
# Purpose:     grid z badaniami pracownika
# Author:      Konrad Opieka
# Created:     2014/10/13
# RCS-ID:      $Id: fs_kp_wzory_dokumentow.py $
# Copyright:   (c) 2014 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

import rsglobal
from funkcje import fs_kp_zmienne_placowe_pom


#-------------------------------------------------------------------------------

stat = 'OK'
dane = []

if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=='OK':
    Funkcja = klucze['Funkcja']
    SlPar={'Grupa':[1,5], 'Pracownik':[8], 'Zatrudnienie':[8], 'Umowa':[8], 'Angaz':[8], 'Tresc':[8]}    
    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Funkcja,klucze)
    if Lista<>'':
        stat='Uwaga : wywoanie funkcji fs_kp_wzory_dokumentow z numerem '+str(Funkcja)+' bez parametrw: '+Lista

if stat=='OK':
    if Funkcja in [1,5]:
        Grupa = klucze['Grupa']    
    if Funkcja == 8:
        Pracownik = klucze['Pracownik']
        Zatrudnienie = klucze['Zatrudnienie']
        Umowa = klucze['Umowa']
        Angaz = klucze['Angaz']
        Tresc = klucze['Tresc']

UprIns=((self.oddzial_id,'017023') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID
UprUpd=((self.oddzial_id,'017022') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID or UprIns
UprDel=((self.oddzial_id,'017024') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID

#-------------------------------------------------------------------------------
#-------- EDYCJA GRIDA EDYTOWALNEGO (1)
#-------------------------------------------------------------------------------

Insert = []
Update = []
Delete = []

if stat=='OK' and Funkcja == 1:
    Update=klucze['Update']
    Insert=klucze['Insert']
    Delete=klucze['Delete']

#-------------------------------------------------------------------------------
#--- DELETE - 1
#-------------------------------------------------------------------------------

if Funkcja == 1 and stat == 'OK':
    if len(Delete[0])>0:
        if not UprDel:
            stat='DEL BR UPR'
            dane.append(stat)
            
        # wykonanie DELETE 
        if stat == 'OK':
            SQLDEL = ''
            SQLFU = ''
            for i in xrange(len(Delete[0])):
                SQLFU ="SELECT grupa_id FROM rs_kp_szablony_dokumentow "
                SQLFU+="WHERE firma_id='"+self.firma_id+"'"
                DELETE ="DELETE FROM rs_kp_szablony_dokumentow "
                DELETE+="WHERE firma_id='"+self.firma_id+"'"
                for j in xrange(len(Delete[0][i])):
                    pole = Delete[1][j]
                    wart = Delete[0][i][j]
                    if pole in ('grupa_id','szablon_id','opis'):  
                        DELETE+= " AND "+pole+"='"+wart+"'"
                        SQLFU += " AND "+pole+"='"+wart+"'"
                
                SQLDEL += DELETE+"; "
                SQLFU += " FOR UPDATE NOWAIT; "
                
            if stat == "OK" and SQLFU <> '':
                stat,d,dump,dump = self.PolSQL.Execute(SQLFU,3)
                if stat <> 'OK':
                    stat = 'DEL BL SPR'
                    dane.append(stat)

            if stat == "OK" and SQLDEL <> '':
                stat,dump,dump,dump = self.PolSQL.Execute(SQLDEL,1)
                if stat <> 'OK':
                    stat = 'DEL BL SQL'  
                    dane.append(stat)

#-------------------------------------------------------------------------------
#---   UPDATE DANYCH (1)
#-------------------------------------------------------------------------------

if Funkcja == 1 and stat=="OK":
    if len(Update[0])>0:
        if not UprUpd:
            stat='UPD BR UPR'
            dane.append(stat)

        if stat == 'OK':
            SQLFU = ''
            for i in xrange(len(Update[0])):
                SQLFU+="SELECT grupa_id,szablon_id FROM rs_kp_szablony_dokumentow"
                SQLFU+=" WHERE firma_id='"+self.firma_id+"'"
                for j in xrange(len(Update[2][i])): # petla po kluczu
                    pole = Update[3][j]
                    wart = rsglobal.Dekoduj(Update[2][i][j].strip())
                    if pole in ('grupa_id','szblon_id','opis'):
                        SQLFU += " AND "+pole+"='"+wart+"'"
                SQLFU += " FOR UPDATE NOWAIT; "
            
            if SQLFU <> '' and stat == "OK":
                stat,d,dump,dump = self.PolSQL.Execute(SQLFU,3)
                if stat <> 'OK':
                    stat = 'UPD BL SPR'
                    dane.append(stat)
            
        if stat == 'OK':
            WierszeNr = Update[-1]
            
            for i in xrange(len(Update[0])):

                for j in xrange(len(Update[0][i])): 
                    pole = Update[0][i][j]
                    wart = Update[1][i][j]

                    if pole == 'grupa_id':
                        if wart.strip() == '':
                            stat = 'GR BR'
                            wyn2.append((WierszeNr[i],0))
                            dane.append(stat)
                        if len(wart.strip()) > 4:
                            stat = 'GR BL'
                            wyn2.append((WierszeNr[i],0))
                            dane.append(stat)
                        else:
                            sql = "SELECT kod FROM rs_kp_grupy_dokumentow "
                            sql += "WHERE kod='" + wart.strip()+ "';"
                            stat, gr, dump, dump = self.PolSQL.Execute(sql, 3)
                            if stat <> 'OK':
                                stat = 'GR BL SQL'
                                dane.append(stat)
                                wyn2.append((WierszeNr[i],0))
                            elif len(gr) == 0:
                                stat = 'GR BR SQL'
                                dane.append(stat)
                                wyn2.append((WierszeNr[i], 0))
                    elif pole == 'szablon_id':
                        if wart.strip() == '':
                            stat = 'SZ BR'
                            wyn2.append((WierszeNr[i],2))
                            dane.append(stat)
                        if len(wart.strip()) > 4:
                            stat = 'SZ BL'
                            wyn2.append((WierszeNr[i],2))
                            dane.append(stat)
                    elif pole == 'opis':
                        if len(wart.strip()) > 50:
                            stat = 'OP BL'
                            wyn2.append((WierszeNr[i], 3))
                            dane.append(stat)
                            
        if stat == 'OK':
            if len(dane) > 0:
                stat = dane[0]
                
        # wykonanie UPDATE
        if stat=='OK':
            sql=''
            for i in xrange(len(Update[0])):
                UPDATE="UPDATE rs_kp_szablony_dokumentow "
                SET='SET '
                for j in xrange(len(Update[0][i])): 
                    pole=Update[0][i][j]
                    wart=Update[1][i][j]
                    if pole in ['grupa_id','szablon_id','opis','definicja']:
                        SET+=pole+"='"+wart.replace("'","`").replace("\\","/")+"',"

                SET=SET.strip(",")
                WHERE=" WHERE firma_id='"+self.firma_id+"'"
                for j in xrange(len(Update[2][i])): # petla po kluczu
                    pole=Update[3][j]
                    wart=rsglobal.Dekoduj(Update[2][i][j])
                    if pole in ['grupa_id','szablon_id']:
                        WHERE+= " AND "+pole+"='"+wart.replace("'","`").replace("\\","/")+"'"
                WHERE+=";"
                sql+=UPDATE+SET+WHERE;
                
            if sql<>'':
                stat,dump,dump,dump=self.PolSQL.Execute(rsglobal.Dekoduj(sql),1)
                if stat<>'OK':
                    stat='UPD BL SQL' 
                    dane.append(stat)


#-------------------------------------------------------------------------------
#---------Sprawdzanie danych do Insert------
#-------------------------------------------------------------------------------

if Funkcja == 1 and stat=="OK":
    if len(Insert[0])>0:
        if not UprIns:
            stat='INS BR UPR'
            dane.append(stat)
                    
        if stat == 'OK':
            WierszeNr = Insert[-1]
            for i in xrange(len(Insert[0])):
                
                for j in xrange(len(Insert[0][i])): 
                    pole=Insert[1][j]
                    wart=Insert[0][i][j]

                    if pole == 'grupa_id':
                        if wart.strip() == '':
                            stat = 'GR BR'
                            wyn2.append((WierszeNr[i],0))
                            dane.append(stat)
                        elif len(wart.strip()) >4:
                            stat = 'GR BL'
                            wyn2.append((WierszeNr[i],0))
                            dane.append(stat)
                        else:
                            sql = "SELECT kod FROM rs_kp_grupy_dokumentow "
                            sql += "WHERE kod='" + wart.strip()+ "';"
                            stat, gr, dump, dump = self.PolSQL.Execute(sql, 3)
                            if stat <> 'OK':
                                stat = 'GR BL SQL'
                                dane.append(stat)
                                wyn2.append((WierszeNr[i],0))
                            elif len(gr) == 0:
                                stat = 'GR BR SQL'
                                dane.append(stat)
                                wyn2.append((WierszeNr[i], 0))

                    elif pole == 'szablon_id':
                        wart = wart.strip()
                        if wart == '':
                            stat = 'SZ BR'
                            wyn2.append((WierszeNr[i],2))
                            dane.append(stat)
                        if len(wart.strip()) >4:
                            stat = 'SZ BL'
                            wyn2.append((WierszeNr[i],2))
                            dane.append(stat)
                    elif pole == 'opis':
                        if len(wart.strip()) > 50:
                            stat = 'OP BL'
                            wyn2.append((WierszeNr[i], 3))
                            dane.append(stat)
                
        if stat == 'OK':
            if len(dane) > 0:
                stat = dane[0]

        # wykonanie INSERT
        if stat == 'OK':
            sqlIns=''
            for i in xrange(len(Insert[0])):
                INSERT="INSERT INTO rs_kp_szablony_dokumentow "
                KOLUMNY="(firma_id"
                VALUES=" VALUES ('"+self.firma_id+"'"
                for j in xrange(len(Insert[0][i])):
                    pole=Insert[1][j]
                    wart=Insert[0][i][j].replace("'", "`").replace("\\","/")
                    if pole in ['grupa_id', 'szablon_id', 'opis', 'definicja']:
                        KOLUMNY += "," + pole
                        VALUES += ",'" + wart + "'"

                KOLUMNY+=")"
                VALUES+=");"
                sqlIns+=INSERT+KOLUMNY+VALUES
            if sqlIns<>'': 
                stat,dump,dump,dump=self.PolSQL.Execute(sqlIns,1)
                if stat<>'OK':
                    stat='INS BL SQL'
                    dane.append(stat)


#-------------------------------------------------------------------------------
#---- SELECT - 5
#-------------------------------------------------------------------------------

if Funkcja in [5] and stat == 'OK':
    SQL ="SELECT s.grupa_id,g.opis,s.szablon_id,s.opis,s.definicja "
    SQL+="FROM rs_kp_szablony_dokumentow s "
    SQL+="INNER JOIN rs_kp_grupy_dokumentow g ON (s.grupa_id)=(g.kod) "
    SQL+="WHERE s.firma_id = '"+self.firma_id+"' "
    if Grupa <> '':               
        SQL+="AND s.grupa_id LIKE '"+Grupa.strip()+"%' "
    
    stat,dane,wyn1,dump =self.PolSQL.Execute(SQL, 3)
    if stat <> 'OK':
        stat='PO BL'
        dane.append(stat)
        
#-------------------------------------------------------------------------------
#---   Pobranie danych do wydruku
#-------------------------------------------------------------------------------

if Funkcja == 8 and stat == 'OK':
    stat,Wyn=fs_kp_zmienne_placowe_pom.PodmienDanymi(self,Tresc,Pracownik,Zatrudnienie,Umowa,Angaz) 
            
    if stat == 'OK':
        dane = Wyn