# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_kp_wzory_dokumentow_dane.py
# Purpose:     grid z badaniami pracownika
# Author:      Konrad Opieka
# Created:     2014/10/13
# RCS-ID:      $Id: fs_kp_wzory_dokumentow_dane.py $
# Copyright:   (c) 2014 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

stat = 'OK'
dane = []

if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=='OK':
    Funkcja = klucze['Funkcja']
    SlPar={'Tresc':[6,7,8],'KGlowny':[6],'Tabela':[6],'Pola':[6],'PoleZapisu':[6]}    
    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Funkcja,klucze)
    if Lista<>'':
        stat='Uwaga : wywoanie funkcji fs_kp_wzory_dokumentow_dane z numerem '+str(Funkcja)+' bez parametrw: '+Lista

if stat=='OK':
    if Funkcja in [7,8]:
        Tresc = klucze['Tresc']  
    if Funkcja == 6:
        Tresc = klucze['Tresc']      
        KluczGlowny = klucze['KGlowny']  
        Pola = klucze['Pola']    
        Tabela = klucze['Tabela']
        PoleZapisu = klucze['PoleZapisu']

UprIns=((self.oddzial_id,'017023') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID
UprUpd=((self.oddzial_id,'017022') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID or UprIns


#-------------------------------------------------------------------------------
#---   UPDATE DANYCH (6)
#-------------------------------------------------------------------------------

if Funkcja == 6 and stat == 'OK':
    if not UprUpd:
        stat='BR UPR UPD'
        dane.append(stat)

    if stat == 'OK':
        SQLFU = ''
        SQLFU+="SELECT * FROM "+str(Tabela)
        SQLFU+=" WHERE firma_id='"+self.firma_id+"'"
        for i in xrange(len(KluczGlowny)): # petla po kluczu
            pole = Pola[i]
            wart = KluczGlowny[i]
            SQLFU += " AND "+pole+"='"+wart+"'"
        SQLFU += " FOR UPDATE NOWAIT; "
            
        if SQLFU <> '' and stat == 'OK':
            stat,d,dump,dump = self.PolSQL.Execute(SQLFU,3)
            if stat <> 'OK':
                stat = 'Bd sprawdzenia danych do modyfikacji: '+stat
                dane.append(stat)
            
           
    # wykonanie UPDATE
    if stat=='OK':
        SQL ="UPDATE "+str(Tabela)+" SET "+str(PoleZapisu)+"='"+Tresc+"'"
        SQL+=" WHERE firma_id='"+self.firma_id+"'"
        for i in xrange(len(KluczGlowny)): # petla po kluczu
            pole = Pola[i]
            wart = KluczGlowny[i]
            SQL+=" AND "+pole+"='"+wart+"'"
        stat,dump,dump,dump=self.PolSQL.Execute(SQL,1)
        if stat<>'OK':
            stat="Bd przy modyfikowaniu danych: "+stat   
            dane.append(stat)


#-------------------------------------------------------------------------------
#---   Zamiana w tekcie na kropki (7)
#-------------------------------------------------------------------------------

if Funkcja == 7 and stat == 'OK':
    SQL ="SELECT pole_id, kropki FROM rs_kp_szablony_dokumentow_pola"
    stat,LParametry,dump,dump = self.PolSQL.Execute(SQL,3)
    if stat <> 'OK':
        stat = 'Bd przy pobieraniu danych dotyczcych pl'+stat
        
    if stat == 'OK':
        Tresc = Tresc.replace('>9</symbol>','></symbol><text>"       "</text>')
        for par in LParametry:
            pole = par[0].strip()
            kropki = par[1]
            Tresc = Tresc.replace('$$'+pole+'$$',int(kropki)*str('.'))
            
        dane = Tresc
