# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_kp_zatrudnienie.py
# Purpose:     grid z biezacymi zatrudnieniami pracownika
#
# Author:      Mariusz Rajfura
# Created:     2009/11/19
# RCS-ID:      $Id: fs_kp_zatrudnienie.py $
# Copyright:   (c) 2009 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------
#  2022-04-26 (12999) Aleksander Bargie Poprawi dodawanie umowy u pracownika ktrego ostatnie zatrudnienie jest zakoczone
Pracownik = rsglobal.Dekoduj(klucze[0])
Numer = klucze[1]
Klucze_Id = klucze[2]

Fun = klucze[-1]
FHistoria = False
if Fun in [5,6]:
    FHistoria = klucze[3]
    
dane = []
wyn1 = []
stat = 'OK'


sql ="SELECT rsf_kadry_dozwolony_modul('"+self.firma_id+"','"+str(self.operator_id)+"','zatrudnienie','"+Pracownik+"');"
stat,d,dump,dump = self.PolSQL.Execute(sql,3)
if stat == 'OK':
    stat = d[0][0]

UprUsuwanie = ((self.oddzial_id,'052024') in self.uprawnienia or self.operator_id == STANDARD_OPERATOR_ID)

#-------------------------------------------------------------------------------
#--- POBRANIE STANU ZATRUDNIENIA (9)  #AB 26.04.22r
#-------------------------------------------------------------------------------

if Fun == 9 and stat == 'OK':
    sql ="SELECT stan_pracownika_id FROM rs_kp_zatrudnienie"
    sql += " WHERE firma_id = '"+self.firma_id+"' AND pracownik_id = '"+Pracownik+"' "
    sql += "AND numer_id ='"+str(Numer)+"';"
    stat, dane, dump, dump = self.PolSQL.Execute(sql, 3)
    if stat != 'OK':
        stat = 'Bd sprawdzenia stanu zatrudnienia : '+stat
    else:
        if len(dane) == 0:
            stat = 'Brak jakiegokolwiek zatrudnienia'

#-------------------------------------------------------------------------------
#--- DELETE - 6
#-------------------------------------------------------------------------------

if Fun == 6 and stat == 'OK':
    if not UprUsuwanie:
        stat='Brak uprawnie do usuwania zatrudnienia.'

    if stat == 'OK':
        sql = "SELECT numer_id FROM rs_kp_zatrudnienie"
        sql+=" WHERE firma_id = '"+self.firma_id+"' AND pracownik_id = '"+Pracownik+"'"
        sql+=" AND numer_id = "+str(Numer)+" FOR UPDATE NOWAIT;" 
        stat,d,dump,dump = self.PolSQL.Execute(sql,3)
        if stat != 'OK':
            stat = 'Bd pobrania danych zatrudnienia dla pracownika : '+stat
        elif len(d) == 0:
            stat = 'Brak zatrudnienia o podanym numerze : '+stat

        if stat == 'OK':
            sql ="SELECT MAX(numer_id) FROM rs_kp_zatrudnienie"
            sql+=" WHERE firma_id = '"+self.firma_id+"' AND pracownik_id = '"+Pracownik+"';"
            stat,d,dump,dump = self.PolSQL.Execute(sql, 3)
            if stat != 'OK':
                stat = 'Bd pobrania informacji o licie zatrudnie dla pracownika : '+stat
            elif d[0][0] > Numer:
                stat = 'Usunicie niemoliwe. Mona usun tylko ostatnie zatrudnienie.'

        if stat == 'OK':
            sql ="SELECT od_kiedy FROM rs_kp_umowy_o_prace"
            sql+=" WHERE firma_id = '"+self.firma_id+"' AND pracownik_id = '"+Pracownik+"' AND zatrudnienie_id="+str(Numer)+";"
            stat,d,dump,dump = self.PolSQL.Execute(sql, 3)
            if stat != 'OK':
                stat = 'Bd pobrania informacji o umowach o prac dot.usuwanego zatrudnienia : '+stat
            elif len(d) > 0:
                stat = 'Usunicie niemoliwe. Istniej umowy o prac ('+str(len(d))+').'

        if stat == 'OK':
            DELETE ="DELETE FROM rs_kp_zatrudnienie"
            DELETE+=" WHERE firma_id = '"+self.firma_id+"' AND pracownik_id = '"+Pracownik+"'"
            DELETE+=" AND numer_id = "+str(Numer)+";" 
            stat,dump,dump,dump = self.PolSQL.Execute(DELETE, 1)
            if stat != 'OK':
                stat='Bd usuwania danych zatrudnienia dla pracownika : '+stat

#-------------------------------------------------------------------------------
#---- SELECT - 5,6,7  Pobieranie listy historycznych zatrudnien
#-------------------------------------------------------------------------------

if Fun in (5,6,7) and stat == 'OK':
    # Fun 7 pokazuje tylko stan zwolniony - funkcja przywracania stosunku pracy
    FILTR = "(z.firma_id = '"+self.firma_id+"' AND z.pracownik_id = '"+Pracownik+"'"
    if Fun == 7:
        FILTR += " AND stan_pracownika_id = 'Z'"
    elif not FHistoria:
        FILTR += " AND stan_pracownika_id != 'Z'"
    FILTR+=")"
    #uzupelnienie podgladu o klucze nowe lub zmienione
    if len(Klucze_Id) > 0:
        FILTR += " OR (z.firma_id = '"+self.firma_id+"' AND z.pracownik_id = '"+Pracownik+"' AND z.numer_id IN ("
        for i in xrange(len(Klucze_Id)):
            if i > 0:
                FILTR += ","
            FILTR += "'"+str(Klucze_Id[i])+"'"
        FILTR += "))"
        
    SELECT ="SELECT z.numer_id,z.stan_pracownika_id||' - '||sp.opis,"
    SELECT+=" COALESCE((SELECT min(od_kiedy) FROM rs_kp_umowy_o_prace WHERE firma_id=z.firma_id AND zatrudnienie_id=z.numer_id AND z.pracownik_id=pracownik_id)::TEXT,'') "
    SELECT+=" ,COALESCE(ubezpieczenie_id,''),z.numer_archiwalny,"
    SELECT+=" COALESCE((z.zrodlo_naboru_id||' - '||c.opis)::TEXT,''::TEXT)"
    SELECT+=" FROM rs_kp_zatrudnienie z"
    SELECT+=" INNER JOIN rs_stany_pracownika sp ON sp.kod = z.stan_pracownika_id"
    SELECT+=" LEFT JOIN rs_zrodla_naboru c on(z.firma_id=c.firma_id AND z.zrodlo_naboru_id=c.kod)"
    SELECT+=" WHERE "+FILTR+" ORDER BY z.numer_id;"
    stat,dane,wyn1,dump =self.PolSQL.Execute(SELECT, 3)
    if stat != 'OK':
        stat='Bd pobrania listy zatrudnien dla pracownika : '+stat
