# -*- coding: iso8859_2 -*-
# -------------------------------------------------------------------------------
# Name:        fs_kp_zatrudnienie_umowy.py
# Purpose:     odsluga multigrida zatrudnienia
# Author:      Marcin Natkaski
# Created:     2016/06/14
# RCS-ID:      $Id: fs_kp_zatrudnienie_umowy.py $
# Copyright:   (c) 2016 Record System
# Licence:     GNU GPL
# -------------------------------------------------------------------------------
# 2017-03-03 (10290)Piotr Witkowski - Zmiany w oknie Zatrudnienie - umowy
# 2019-06-27 (11529)Wojciech Skowron - Kolumny dodatek_fun i kategoria_zaszeregowania

dane = []
dane_zatrudnienia = []
wyn1 = []
wyn2 = []
stat = 'OK'

if not 'Funkcja' in klucze:
    stat = 'Brak podanej funkcji w kluczach'

if stat == 'OK':
    Fun = klucze['Funkcja']

    SlPar = {'Pracownik': [5, 8, 9, 10], 'Aktywne': [5, ], 'Zatrudnienie': [8, 9, 10], 'Umowa': [8, 9], 'Angaz': [8, ]}
    Lista = rsglobal.SprawdzParametryWKluczach(SlPar, Fun, klucze)
    if Lista <> '':
        stat = 'Uwaga : wywoanie funkcji fs_kp_zatrudnienie_umowy z numerem ' + str(Fun) + ' bez parametrw: ' + Lista

if stat == 'OK':
    if Fun in [5, ]:
        Pracownik = rsglobal.Dekoduj(klucze['Pracownik'])
        Aktywne = rsglobal.Dekoduj(klucze['Aktywne'])
    if Fun in [8, ]:
        Pracownik = rsglobal.Dekoduj(klucze['Pracownik'])
        Zatrudnienie = rsglobal.Dekoduj(klucze['Zatrudnienie'])
        Umowa = rsglobal.Dekoduj(klucze['Umowa'])
        Angaz = rsglobal.Dekoduj(klucze['Angaz'])

    if Fun in [9, ]:
        Pracownik = rsglobal.Dekoduj(klucze['Pracownik'])
        Zatrudnienie = rsglobal.Dekoduj(klucze['Zatrudnienie'])
        Umowa = rsglobal.Dekoduj(klucze['Umowa'])

    if Fun in [10, ]:
        Pracownik = rsglobal.Dekoduj(klucze['Pracownik'])
        Zatrudnienie = rsglobal.Dekoduj(klucze['Zatrudnienie'])

UprUsuwanie = ((self.oddzial_id, '053004') in self.uprawnienia or self.operator_id == STANDARD_OPERATOR_ID)
AngazeUprUsuwanie = ((self.oddzial_id, '052044') in self.uprawnienia or self.operator_id == STANDARD_OPERATOR_ID)
UmowaUprUsuwanie = ((self.oddzial_id, '052034') in self.uprawnienia or self.operator_id == STANDARD_OPERATOR_ID)
ZatrudnienieUprUsuwanie = ((self.oddzial_id, '052024') in self.uprawnienia or self.operator_id == STANDARD_OPERATOR_ID)

sql = "SELECT rsf_kadry_dozwolony_modul('" + self.firma_id + "','" + str(
    self.operator_id) + "','zatrudnienie','" + Pracownik + "');"
stat, d, dump, dump = self.PolSQL.Execute(sql, 3)
if stat == 'OK':
    stat = d[0][0]

# -------------------------------------------------------------------------------
# --- DELETE ANGAY - 8
# -------------------------------------------------------------------------------

if Fun == 8 and stat == 'OK':
    if not AngazeUprUsuwanie:
        stat = 'Brak uprawnie do usuwania angau.'

    if stat == 'OK':
        sql = "SELECT angaz_id FROM rs_kp_angaze"
        sql += " WHERE firma_id = '" + self.firma_id + "' AND pracownik_id = '" + Pracownik + "'"
        sql += " AND zatrudnienie_id = " + str(Zatrudnienie) + " AND umowa_id = " + str(Umowa)
        sql += " AND angaz_id = " + str(Angaz) + " FOR UPDATE NOWAIT;"
        stat, d, dump, dump = self.PolSQL.Execute(sql, 3)
        if stat <> 'OK':
            stat = 'Bd pobrania danych angau dla pracownika : ' + stat
        elif len(d) == 0:
            stat = 'Brak angau o podanym numerze : ' + stat

        if stat == 'OK':
            sql = " SELECT firma_id FROM rs_kp_listy_plac_osoby WHERE firma_id='" + self.firma_id + "' "
            sql += " AND pracownik_id='" + str(Pracownik) + "' AND zatrudnienie_id='" + str(Zatrudnienie) + "' "
            sql += " AND umowa_id='" + str(Umowa) + "' AND angaz_id='" + str(Angaz) + "';"
            stat, d, dump, dump = self.PolSQL.Execute(sql, 3)
            if stat <> 'OK':
                stat = 'Bdy pobierania danych z list pac : ' + stat
            elif len(d) != 0:
                stat = 'Usuwany anga wystpuje w innych tabelach. Usunicie niemoliwe.'

        # if stat == 'OK':
        #     sql = "SELECT MAX(angaz_id) FROM rs_kp_angaze"
        #     sql += " WHERE firma_id = '" + self.firma_id + "' AND pracownik_id = '" + Pracownik + "'"
        #     sql += " AND zatrudnienie_id = " + str(Zatrudnienie) + " AND umowa_id = " + str(Umowa) + ";"
        #     stat, d, dump, dump = self.PolSQL.Execute(sql, 3)
        #     if stat <> 'OK':
        #         stat = 'Bd pobrania informacji o licie angay dla pracownika : ' + stat
        #     elif d[0][0] > Angaz:
        #         stat = 'Usunicie niemoliwe. Mona usun tylko ostatni anga.'

        if stat == 'OK':
            DELETE = "DELETE FROM rs_kp_angaze"
            DELETE += " WHERE firma_id = '" + self.firma_id + "' AND pracownik_id = '" + Pracownik + "'"
            DELETE += " AND zatrudnienie_id = " + str(Zatrudnienie) + "AND umowa_id = " + str(Umowa)
            DELETE += " AND angaz_id = " + str(Angaz) + ";"
            stat, dump, dump, dump = self.PolSQL.Execute(DELETE, 1)
            if stat <> 'OK':
                stat = 'Bd usuwania angau dla pracownika : ' + stat

# -------------------------------------------------------------------------------
# --- DELETE UMW - 9
# -------------------------------------------------------------------------------


if Fun == 9 and stat == 'OK':
    if not UmowaUprUsuwanie:
        stat = 'Brak uprawnie do usuwania umw o prac.'

    if stat == 'OK':
        sql = "SELECT umowa_id FROM rs_kp_umowy_o_prace"
        sql += " WHERE firma_id = '" + self.firma_id + "' AND pracownik_id = '" + Pracownik + "'"
        sql += " AND zatrudnienie_id = " + str(Zatrudnienie) + " AND umowa_id = " + str(Umowa) + " FOR UPDATE NOWAIT;"
        stat, d, dump, dump = self.PolSQL.Execute(sql, 3)
        if stat <> 'OK':
            stat = 'Bd pobrania danych umowy o prac dla pracownika : ' + stat
        elif len(d) == 0:
            stat = 'Brak umowy o podanym numerze : ' + stat

        if stat == 'OK':
            sql = " SELECT firma_id FROM rs_kp_zawieszenia WHERE firma_id='" + self.firma_id + "' "
            sql += " AND pracownik_id='" + str(Pracownik) + "' "
            sql += " AND zatrudnienie_id='" + str(Zatrudnienie) + "' AND umowa_id='" + str(Umowa) + "';"
            stat, d, dump, dump = self.PolSQL.Execute(sql, 3)
            if stat <> 'OK':
                stat = 'Bd pobrania danych zawieszenia : ' + stat
            elif len(d) != 0:
                stat = 'Dla umowy istniej zawieszenia. Usunicie niemoliwe.'

        # if stat == 'OK':
        #     sql = "SELECT MAX(umowa_id) FROM rs_kp_umowy_o_prace"
        #     sql += " WHERE firma_id = '" + self.firma_id + "' AND pracownik_id = '" + Pracownik + "'"
        #     sql += " AND zatrudnienie_id = " + str(Zatrudnienie) + ";"
        #     stat, d, dump, dump = self.PolSQL.Execute(sql, 3)
        #     if stat <> 'OK':
        #         stat = 'Bd pobrania informacji o licie umw dla pracownika : ' + stat
        #     elif d[0][0] > Umowa:
        #         stat = 'Usunicie niemoliwe. Mona usun tylko ostatni umow o prac.'

        if stat == 'OK':
            sql = "SELECT angaz_id FROM rs_kp_angaze"
            sql += " WHERE firma_id = '" + self.firma_id + "' AND pracownik_id = '" + Pracownik + "'"
            sql += " AND zatrudnienie_id = " + str(Zatrudnienie) + " AND umowa_id = " + str(Umowa) + ";"
            stat, d, dump, dump = self.PolSQL.Execute(sql, 3)
            if stat <> 'OK':
                stat = 'Bd pobrania informacji o angaach dot. usuwanej umowy o prac dla pracownika : ' + stat
            elif len(d) > 0:
                stat = 'Usunicie niemoliwe. Istniej angae do usuwanej umowy o prac (' + str(len(d)) + ').'

        if stat == 'OK':
            DELETE = "DELETE FROM rs_kp_umowy_o_prace"
            DELETE += " WHERE firma_id = '" + self.firma_id + "' AND pracownik_id = '" + Pracownik + "'"
            DELETE += " AND zatrudnienie_id = " + str(Zatrudnienie) + " AND umowa_id = " + str(Umowa) + ";"
            stat, dump, dump, dump = self.PolSQL.Execute(DELETE, 1)
            if stat <> 'OK':
                stat = 'Bd usuwania umowy o prac dla pracownika : ' + stat

# -------------------------------------------------------------------------------
# --- DELETE ZATRUDNIENIA - 10
# -------------------------------------------------------------------------------

if Fun == 10 and stat == 'OK':
    if not ZatrudnienieUprUsuwanie:
        stat = 'Brak uprawnie do usuwania zatrudnienia.'

    if stat == 'OK':
        sql = "SELECT numer_id FROM rs_kp_zatrudnienie"
        sql += " WHERE firma_id = '" + self.firma_id + "' AND pracownik_id = '" + Pracownik + "'"
        sql += " AND numer_id = " + str(Zatrudnienie) + " FOR UPDATE NOWAIT;"
        stat, d, dump, dump = self.PolSQL.Execute(sql, 3)
        if stat <> 'OK':
            stat = 'Bd pobrania danych zatrudnienia dla pracownika : ' + stat
        elif len(d) == 0:
            stat = 'Brak zatrudnienia o podanym numerze : ' + stat

        # if stat == 'OK':
        #     sql = "SELECT MAX(numer_id) FROM rs_kp_zatrudnienie"
        #     sql += " WHERE firma_id = '" + self.firma_id + "' AND pracownik_id = '" + Pracownik + "';"
        #     stat, d, dump, dump = self.PolSQL.Execute(sql, 3)
        #     if stat <> 'OK':
        #         stat = 'Bd pobrania informacji o licie zatrudnie dla pracownika : ' + stat
        #     elif d[0][0] > Zatrudnienie:
        #         stat = 'Usunicie niemoliwe. Mona usun tylko ostatnie zatrudnienie.'

        if stat == 'OK':
            sql = "SELECT od_kiedy FROM rs_kp_umowy_o_prace"
            sql += " WHERE firma_id = '" + self.firma_id + "' AND pracownik_id = '" + Pracownik + "' "
            sql += " AND zatrudnienie_id=" + str(Zatrudnienie) + ";"
            stat, d, dump, dump = self.PolSQL.Execute(sql, 3)
            if stat <> 'OK':
                stat = 'Bd pobrania informacji o umowach o prac dot.usuwanego zatrudnienia : ' + stat
            elif len(d) > 0:
                stat = 'Usunicie niemoliwe. Istniej umowy o prac (' + str(len(d)) + ').'

        if stat == 'OK':
            DELETE = "DELETE FROM rs_kp_zatrudnienie"
            DELETE += " WHERE firma_id = '" + self.firma_id + "' AND pracownik_id = '" + Pracownik + "'"
            DELETE += " AND numer_id = " + str(Zatrudnienie) + ";"
            stat, dump, dump, dump = self.PolSQL.Execute(DELETE, 1)
            if stat <> 'OK':
                stat = 'Bd usuwania danych zatrudnienia dla pracownika : ' + stat

# -------------------------------------------------------------------------------
# ---- SELECT - 5 Pobieranie listy zatrudnien
# -------------------------------------------------------------------------------

if Fun in (5,) and stat == 'OK':
    # Pobieramy dane zatrudnienia
    SQL = " SELECT a.numer_id, a.stan_pracownika_id, a.start_rok_urlop, "
    SQL += " a.urlop_wykorzystany, a.urlop_zalegly, a.start_rok_zwolnienie,"
    SQL += " a.choroba_wykorzystana,a.ubezpieczenie_id||' - '||ru.opis, "
    SQL += " a.glowne_miejsce_pracy, a.zrodlo_naboru_id||' - '||zn.opis, "
    SQL += " a.zwolnienie_id||' - '||rz.opis,a.zwolnienie_data,"
    SQL += " a.urzad_skarbowy_id||' - '||us.opis,a.oddzial_nfz_id||' - '||nfz.opis, "
    SQL += " a.dane_globalne,a.pit_11_8,a.pit_40,a.koszty_podstawowe,a.koszty_podwyzszone,a.ulga"
    SQL += " FROM rs_kp_zatrudnienie a "
    SQL += " LEFT JOIN rs_rodzaje_ubezpieczen ru ON (a.firma_id=ru.firma_id AND a.ubezpieczenie_id=ru.kod)"
    SQL += " LEFT JOIN rs_zrodla_naboru zn ON (a.firma_id=zn.firma_id AND a.zrodlo_naboru_id=zn.kod)"
    SQL += " LEFT JOIN rs_rodzaje_zwolnien rz ON (a.firma_id=rz.firma_id AND a.zwolnienie_id=rz.kod)"
    SQL += " LEFT JOIN rs_urzedy_skarbowe us ON (a.firma_id=us.firma_id AND a.urzad_skarbowy_id=us.kod)"
    SQL += " LEFT JOIN rs_oddzialy_nfz nfz ON (a.oddzial_nfz_id=nfz.kod)"
    SQL += " WHERE a.firma_id='" + self.firma_id + "' AND a.pracownik_id='" + Pracownik + "'"
    if Aktywne:
        SQL += " AND a.stan_pracownika_id='A' "
    SQL += " ORDER BY a.numer_id DESC"
    stat, dane_zatrudnienia, wyn1, dump = self.PolSQL.Execute(SQL, 3)
    if stat <> 'OK':
        stat = 'Bd pobrania listy zatrudnien : ' + stat

    # Pobieramy dane umw
    SQL = "SELECT a.zatrudnienie_id,a.umowa_id,a.data_zawarcia,a.rodzaj_umowy_id||' - '||ur.opis,a.od_kiedy,a.do_kiedy,"
    SQL += " typ_pracownika_id||' - '||t.opis,a.od_kiedy_zus,a.do_kiedy_zus, zatr.stan_pracownika_id <> 'Z' "
    # PW 2017-11-01
    SQL += " FROM rs_kp_umowy_o_prace a "
    SQL += " LEFT JOIN rs_kp_zatrudnienie zatr ON zatr.firma_id=a.firma_id "
    SQL += " AND zatr.pracownik_id=a.pracownik_id AND zatr.numer_id=a.zatrudnienie_id "
    SQL += " LEFT JOIN rs_umowy_rodzaj ur ON (a.firma_id=ur.firma_id AND a.rodzaj_umowy_id=ur.kod) "
    SQL += " LEFT JOIN rs_typy_pracownikow t ON(a.firma_id=t.firma_id AND a.typ_pracownika_id=t.kod) "
    SQL += " WHERE a.firma_id='" + self.firma_id + "' AND a.pracownik_id='" + Pracownik + "'"
    if Aktywne:
        SQL += " AND (SELECT stan_pracownika_id FROM rs_kp_zatrudnienie WHERE a.firma_id=firma_id "
        SQL += " AND numer_id=a.zatrudnienie_id AND pracownik_id='" + Pracownik + "') = 'A' "
    SQL += " ORDER BY (a.zatrudnienie_id,a.umowa_id) DESC"
    stat, dane_umow, wyn1, dump = self.PolSQL.Execute(SQL, 3)
    if stat <> 'OK':
        stat = 'Bd pobrania listy umow : ' + stat

    # Pobieramy dane angazy
    SQL = " SELECT a.zatrudnienie_id,a.umowa_id,a.angaz_id,a.od_kiedy,a.do_kiedy,a.miejsce_id||' - '||mp.opis,"
    SQL += " a.komorka_id||' - '||kz.opis, a.stanowisko_id||' - '||sp.opis,a.placa,a.stawka,\n"
    SQL += " a.dodatek_fun,COALESCE(a.kategoria_zaszeregowania,''),"  #WS 2019-06-27
    # SQL += "(a.do_kiedy >= now() or a.do_kiedy IS NULL) AND" # jeli chcemy eby by tylko dla aktywnych angay
    SQL += " za.stan_pracownika_id <> 'Z'\n"
    SQL += " AND (a.od_kiedy = (SELECT max(od_kiedy) FROM rs_kp_angaze aa"
    SQL += " WHERE a.firma_id=aa.firma_id AND a.zatrudnienie_id=aa.zatrudnienie_id "
    SQL += " AND a.umowa_id=aa.umowa_id AND a.pracownik_id=aa.pracownik_id)\n"
    SQL += " OR a.od_kiedy ISNULL)\n"
    SQL += " FROM rs_kp_angaze a "
    SQL += " JOIN rs_kp_zatrudnienie za ON a.firma_id=za.firma_id "
    SQL += " AND a.zatrudnienie_id=za.numer_id AND a.pracownik_id=za.pracownik_id"
    SQL += " LEFT JOIN rs_miejsca_pracy mp ON (a.firma_id=mp.firma_id AND a.miejsce_id=mp.kod) "
    SQL += " LEFT JOIN rs_komorki_zatrudniajace kz ON (a.firma_id=kz.firma_id AND a.komorka_id=kz.kod)"
    SQL += " LEFT JOIN rs_stanowiska_pracy sp ON (a.firma_id=sp.firma_id AND a.stanowisko_id=sp.kod)"
    SQL += " WHERE a.firma_id='" + self.firma_id + "' AND a.pracownik_id='" + Pracownik + "'"
    if Aktywne:
        SQL += " AND (SELECT stan_pracownika_id FROM rs_kp_zatrudnienie WHERE a.firma_id=firma_id "
        SQL += " AND numer_id=a.zatrudnienie_id AND pracownik_id='" + Pracownik + "') = 'A' "
    SQL += " ORDER BY (a.zatrudnienie_id,a.umowa_id) DESC "
    stat, dane_angazy, wyn1, dump = self.PolSQL.Execute(SQL, 3)
    if stat <> 'OK':
        stat = 'Bd pobrania listy angay : ' + stat

    # Pobieramy dane skadnikw
    SQL = "SELECT ask.zatrudnienie_id,ask.umowa_id,ask.angaz_id,ask.skladnik_id,sp.opis, ask.data_od, "
    SQL += " ask.data_do, ask.kwota FROM rs_kp_angaze_skladniki ask "
    SQL += " INNER JOIN rs_kp_skladniki_placowe sp USING (firma_id,skladnik_id) "
    if Aktywne:
        SQL += " INNER JOIN rs_kp_zatrudnienie z ON z.firma_id=ask.firma_id "
        SQL += " AND z.numer_id=ask.zatrudnienie_id AND z.pracownik_id=ask.pracownik_id "
    SQL += "WHERE ask.firma_id='" + str(self.firma_id) + "' AND ask.pracownik_id='" + Pracownik + "' "
    if Aktywne:
        SQL += " AND z.stan_pracownika_id = 'A' "
    SQL += "ORDER BY ask.zatrudnienie_id, ask.umowa_id, ask.angaz_id, ask.data_od DESC, ask.skladnik_id;"

    stat, dane_skladnikow, wyn1, wyn2 = self.PolSQL.Execute(SQL, 3)
    if stat <> 'OK':
        stat = "Bd przy pobieraniu listy skladnikow : " + stat
        dane.append(stat)

    # czymy dane
    if stat == 'OK':
        ZATRUDNIENIE = {}
        ZATRUDNIENIE['dane_zatrudnienia'] = dane_zatrudnienia
        ZATRUDNIENIE['dane_umow'] = dane_umow
        ZATRUDNIENIE['dane_angazy'] = dane_angazy
        ZATRUDNIENIE['dane_skladnikow'] = dane_skladnikow

        dane = ZATRUDNIENIE
