# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_kp_zmiany_pracy_dane.py
# Purpose:     dodawanie/edycja danych o zmianach pracy
# Author:      Pawe Wjcikowski
# Created:     2010/07/20
# RCS-ID:      $Id: fs_kp_zmiany_pracy_dane.py $
# Copyright:   (c) 2010 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

Zmiana = klucze[0]
Fun = klucze[-1]
stat = 'OK'
dane = []
wyn1 = []
wyn2 = []

UprDodawanie = (((self.oddzial_id,'051023') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID))
UprEdycja = (((self.oddzial_id,'051022') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)) or UprDodawanie


#-------------------------------------------------------------------------------
#---   SPRAWDZENIE UPRAWNIEN
#-------------------------------------------------------------------------------

if Fun in (1,2) and stat == 'OK':
    if not UprDodawanie:
        stat = 'BR UPR INS'

if Fun in (3,4) and stat == 'OK':
    if not UprEdycja:
        stat = 'BR UPR UPD'
        

#-------------------------------------------------------------------------------
#--- SPRAWDZENIE DANYCH (1,2,3,4) - bez 5 (pobieranie)
#-------------------------------------------------------------------------------

if Fun in (1,2,3,4) and stat == 'OK':       
    for i in range(len(pola)):
        pole = pola[i]
        wart = wartosci[i]     
        if pole == 'zmiana_id':
            if wart == '':
                stat='BR_ZM'
            else:
                sql ="SELECT zmiana_id FROM rs_kp_zmiany_pracy"
                sql+=" WHERE firma_id = '"+self.firma_id+"' AND zmiana_id = '"+str(wart)+"';"
                stat,d,dump,dump = self.PolSQL.Execute(sql, 3)
                if stat <> 'OK':
                    dane.append('Bd pobrania zmiany : '+stat)
                elif len(d) <> 0:
                    dane.append('ZM_JEST')
                                                
        elif pole == 'nazwa':
            if wart.strip() =='':
                stat='BR_NAZWA'
                dane.append(stat)                
            elif len(wart) > 30:
                stat='DL_NAZWA'
                dane.append(stat)
                
        elif pole == 'od_kiedy1':
            if wart.strip() =='  :  ':
                stat='BR_ODKIEDY'
                dane.append(stat)                

        elif pole == 'do_kiedy1':
            if wart.strip() =='  :  ':
                stat='BR_DOKIEDY'
                dane.append(stat)  

    if len(dane) > 0:
        stat = dane[0]
    
    
#-------------------------------------------------------------------------------
#--- DODAWANIE DANYCH (1 -z pobraniem select  2 - bez pobrania
#-------------------------------------------------------------------------------

if Fun in (1,2) and stat == 'OK':
    ins = "INSERT INTO rs_kp_zmiany_pracy"
    Pola="firma_id,zmiana_id"
    Wartosci="'"+self.firma_id+"','"+str(Zmiana)+"'"
    for i in range(len(pola)):
        pole = pola[i]
        wart = wartosci[i]
        if pole in ['nazwa']:
            Pola= Pola+","+pole
            if wart.strip()=='':
                Wartosci= Wartosci+",NULL"
            else:
                Wartosci= Wartosci+",'"+wart+"'"      
        elif pole in ['od_kiedy1','do_kiedy1','od_kiedy2','do_kiedy2','od_kiedy3','do_kiedy3']:
            Pola= Pola+","+pole
            if wart=='  :  ':
                Wartosci= Wartosci+",NULL"
            else:
                Wartosci= Wartosci+",'"+wart+"'"             
    ins = ins+" ("+Pola+") VALUES ("+Wartosci+");"            
    stat,dump,dump,dump = self.PolSQL.Execute(ins ,1)
    if stat<>'OK':
        stat = 'Bdy dodawania zmiany pracy :'+stat
        dane.append(stat)  
        
          
#-------------------------------------------------------------------------------
#--- UPDATE DANYCH ( 3-select, 4 -update z pobraniem)
#-------------------------------------------------------------------------------

if Fun in (3,4) and stat == 'OK':
    UPDATE = "UPDATE rs_kp_zmiany_pracy SET "
    for i in xrange(len(pola)):
        pole = pola[i]
        wart = wartosci[i]
        zmiana=Zmiana
        if pole=='zmiana_id':
            zmiana=wart.strip()
        if pole in ['od_kiedy1','do_kiedy1','od_kiedy2','do_kiedy2','od_kiedy3','do_kiedy3']:
            if wart == '  :  ':
                UPDATE += pole+"=NULL,"  
            else:
                UPDATE += pole+"='"+str(wart)+"',"    
        else:      
            UPDATE += pole+"='"+str(wart)+"',"
    UPDATE = UPDATE[:-1]
    UPDATE+=" WHERE firma_id = '"+self.firma_id+"' AND zmiana_id = '"+str(Zmiana)+"';"
    Zmiana=zmiana
    stat,dump,dump,dump = self.PolSQL.Execute(UPDATE ,1)
    if stat <> 'OK':
        stat = 'Bd modyfikacji danych zwizanych ze zmianami pracy : '+stat


#-------------------------------------------------------------------------------
#--- POBRANIE DANYCH ( 5-select, 3 -update z pobraniem)
#-------------------------------------------------------------------------------

if Fun in (1,3,5) and stat=='OK':
    SELECT ="SELECT * FROM rs_kp_zmiany_pracy"
    SELECT+=" WHERE firma_id = '"+self.firma_id+"' AND zmiana_id = '"+str(Zmiana)+"';"
    stat,dane,wyn1,dump = self.PolSQL.Execute(SELECT,3)
    if stat <> 'OK':
        stat = 'Bd pobrania danych o zmianie : '+stat
        dane.append(stat)