# -*- coding: iso8859_2 -*-
#-----------------------------------------------------------------------------
# Name:        fs_kursy_walut_nowe.py
# Purpose:     dodawanie kursw dla wszystkich dostpnych walut
# Author:      Pawe Wjcikowski - przejscie na funkcje
#              Jan Kaliszewski - zasadnicze zmiany
# Created:     2009/06/19
# RCS-ID:      $Id: fs_kursy_walut_nowe.py $
# Copyright:   (c) 2009 Record System
# Licence:     GNU GPL
#-----------------------------------------------------------------------------
# Pawe Wjcikowski, 2009-06-19 - patrz metryczka powyej
# Jan Kaliszewski, 2009-10-24 - patrz metryczka powyej (ad mantis #0000254)


Fun = klucze[-1]
data = klucze[0]
nr_tabeli = klucze[1]
firma_id = self.firma_id

stat = "OK"
dane = []

#-------------------------------------------------------------------------------
#--- POBRANIE DANYCH (1): jakie s wszystkie dostpne waluty oraz dla ktrych s
#                         ju ustawione kursy dla podanej daty i numeru tabeli
#                         (info na potrzeby dodawania nowych "pustych" kursw)
#-------------------------------------------------------------------------------

if (Fun == 1) and (stat == 'OK'):
    if ((self.oddzial_id, '014013') in self.uprawnienia  # (moe dodawa kursy)
                or self.operator_id == STANDARD_OPERATOR_ID):

        stat, znane_waluty, wyn1, wyn2 = self.PolSQL.Execute(
                "SELECT kod FROM rs_waluty"
                " WHERE firma_id='" + firma_id + "' AND kod <> 'PLN'",
                2
        )
        if stat == 'OK':
            stat, zajete_waluty, wyn1, tr = self.PolSQL.Execute(
                    "SELECT waluta FROM rs_kursy_walut"
                    " WHERE firma_id='" + self.firma_id + "' AND data='"
                    + data + "' AND nr_tabeli='" + nr_tabeli + "';",
                    3
            )
            if stat == 'OK':
                dane = ([wal[0] for wal in znane_waluty],
                        [wal[0] for wal in zajete_waluty])
            else:
                stat = ('Bd przy pobieraniu z bazy danych '
                        'informacji o kursach walut ("%s").' % stat)
        else:
            stat = ('Bd przy pobieraniu z bazy danych '
                    'informacji o walutach ("%s").' % stat)
    else:
        stat = 'Brak uprawnie do dodawania kursw walut.'
