# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_login.py
# Purpose:      
# Author:      Micha Raburski
# Created:     2009/09/29
# RCS-ID:      $Id: fs_login.py $
# Copyright:   (c) 2004-2009 RecordSystem
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

# 2011-04-03 Mariusz Rajfura - pobranie nazwiska i imienia operatora (4439)
# 2013-04-25 Mariusz Rajfura (6817) pobranie informacji o uruchomieniu przez operatora
#                                   innych modulow zamiast standardowej anakondy
# 2018-02-28 Aleksander Bargie 10945 - uwzglcznienie czy EMS z danych operatora
# 2020-02-05 Aleksander Bargie (11848) Opcja "Uproszczone Kadry"

Fun=klucze[-1]
stat="OK"
dane=[]

#-------------------------------------------------------------------------------
# Pobranie listy operatorw (1)
#-------------------------------------------------------------------------------

if Fun==1:
    stat,dane,dump,dump=self.PolSQL.Execute("SELECT operator_id FROM rs_operatorzy WHERE zastepca_id='"+str(self.operator_id)+"';",3)
    
    # dodatkowo by nie byo wicej zapyta pobieramy liczb artykuw i kontrahentw
    if stat =='OK':
        stat,DIlArt,dump,dump = self.PolSQL.Execute("SELECT COUNT(*) FROM rs_artykuly WHERE firma_id='"+str(self.firma_id)+"' AND COALESCE(aktywny,TRUE);",3)
    if stat =='OK':
        stat,DIlKontr,dump,dump = self.PolSQL.Execute("SELECT COUNT(*) FROM rs_kontrahenci WHERE firma_id='"+str(self.firma_id)+"' AND COALESCE(aktywny,TRUE);",3)
    wyn1 = [DIlArt[0][0],DIlKontr[0][0]]

#-------------------------------------------------------------------------------
# Pobranie opisu oddziau (2)
#-------------------------------------------------------------------------------

if Fun==2:
    SQL="SELECT opis FROM rs_oddzialy WHERE oddzial_id = '"+self.oddzial_id+"' AND firma_id = '"+self.firma_id+"';"
    stat,dane,dump,dump=self.PolSQL.Execute(SQL,3)

#-------------------------------------------------------------------------------
# Pobranie uprawnie magazynowych uytkownika (3)
#-------------------------------------------------------------------------------

if Fun==3:
    if self.operator_id == STANDARD_OPERATOR_ID:
        SQL="SELECT magazyn_id FROM rs_magazyny WHERE firma_id='"+self.firma_id+"';"
    else:
        SQL="SELECT DISTINCT magazyn_id,ilosc,dostawy FROM rs_magazyny_upr "
        SQL+="WHERE operator_id IN "+self.operatorzy+" AND firma_id='"+self.firma_id+"' ORDER BY magazyn_id;"
    stat,dane,dump,dump=self.PolSQL.Execute(SQL,3)


#-------------------------------------------------------------------------------
# Pobranie danych firmy (4)
#-------------------------------------------------------------------------------
#AB 05.02.20r dodane uproszczone_kadry
if Fun==4:
    SQL="SELECT dwie_jedn_miar,dynam_przel,import,eksport,produkcja,opis,czy_drukowac_biuro,skrocone_numery,"
    SQL+="automat_numery,wymuszac_wz_na_parag,lokacje_jm, uproszczone_kadry FROM rs_firmy WHERE firma_id='"+self.firma_id+"';"
    stat,dane,dump,dump=self.PolSQL.Execute(SQL,3)

#-------------------------------------------------------------------------------
# Pobranie uprawnie magazynowych uytkownika (5)
#-------------------------------------------------------------------------------

if Fun==5:
    SQL="SELECT okres_id FROM rs_operatorzy WHERE operator_id='"+str(self.operator_id)+"';"
    stat,dane,dump,dump=self.PolSQL.Execute(SQL,3)
    if stat=='OK':
        #sprawdzenie czy wybrany okres istnieje w danej firmie
        SQL="SELECT okres_id FROM rs_definicje_okresow WHERE "
        SQL+="firma_id='"+self.firma_id+"' AND okres_id='"+rsglobal.Dekoduj(dane[0][0])+"';"
        stat,dane,dump,dump=self.PolSQL.Execute(SQL,3)
                
    



if False:
    if ((self.oddzial_id,'013015') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
        ok,row,dump,dump=self.WykonajFunkcje("fs_artykuly_pobierz",[artykul_old])
        ok="OK"
        if ok!="OK":
            stat="BL_SQL"   
            dane.append(stat)
        else:
           if len(row)==0:    
                stat="BL_ISTN"   
                dane.append(stat)
    
        ok,row,dump,dump=self.WykonajFunkcje("fs_artykuly_pobierz",[artykul_id])
        ok="OK"
        if ok!="OK":
            stat="BL_SQL"   
            dane.append(stat)
        else:
           if len(row)>0:    
                stat="BL_ISTN1"   
                dane.append(stat)
        if stat=="OK":
            sql="UPDATE rs_artykuly SET artykul_id = '%s' WHERE artykul_id='%s' AND firma_id='%s';"%(artykul_id,artykul_old,self.firma_id)
            ok,dane,wyn1,wyn2=self.PolSQL.Execute(sql,1)
            if ok!="OK":
                stat="BL_ZMIANA"   
                dane.append(stat)
    else:
        stat="BL_UPR"   
        dane.append(stat)

#-------------------------------------------------------------------------------
# Pobranie nazwiska i imienia operatora (6)
#-------------------------------------------------------------------------------

if Fun==6:
    SQL="SELECT nazwisko,imie FROM rs_operatorzy WHERE operator_id='"+str(self.operator_id)+"';"
    stat,dane,dump,dump=self.PolSQL.Execute(SQL,3)


#-------------------------------------------------------------------------------
# Pobranie informacji o uruchomieniu innych modulow zamiast standardowej anakondy (7)
#-------------------------------------------------------------------------------

if Fun==7: #AB dodane ,ems w zapytaniu
    SQL="SELECT pos, czas_pracy, ems FROM rs_operatorzy WHERE operator_id='"+str(self.operator_id)+"';"
    stat,d,dump,dump=self.PolSQL.Execute(SQL,3)
    if stat <> 'OK':
        stat = 'Bd pobrania danych operatora: '+stat
    
    if stat == 'OK':
        if d[0][0]:
            dane.append(['pos'])
        if d[0][1]:
            dane.append(['czas_pracy'])
            #AB
        if d[0][2]:
            dane.append(['ems'])
            
        if self.operator_id == STANDARD_OPERATOR_ID:
            if len(dane) > 0:
                rsglobal.ZapiszDoLogow('!!!Operator anakonda posiada przypisane moduy do uruchomienia!!! '+str(dane),1)
                # automatyczna podmiana danych aby anakonda mogla wejsc do pelnego systemu
                dane = []

        elif len(dane) > 1:
            stat = 'Operator ma przypisany wicej ni jeden modu do uruchomienia'
