# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_kp_szkolenia.py
# Purpose:     odsluga grida szkole
# Author:      Marcin Natkaski
# Created:     2012/06/14
# RCS-ID:      $Id: fs_kp_szkolenia.py $
# Copyright:   (c) 2012 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

dane = []
wyn1 = []
wyn2 = []
stat = 'OK'

if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=='OK':
    Fun = klucze['Funkcja']
    
    # 5 - przegldanie; 6 - usuwanie; 8 - zamykanie; 9 - otwieranie, 11 - przeliczanie
    
    SlPar={'Stan':[5,6,8,9,11],'Oddzial':[5,6,8,9,11],'Kontrahent':[5,6,8,9,11],'DataWystOd':[5,6,8,9,11],
    'DataWystDo':[5,6,8,9,11],'Nota':[5,6,8,9,11],'NumerNoty':[6,8,9,11]}
    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Fun,klucze)
    if Lista<>'':
        stat='Uwaga : wywoanie funkcji fs_noty_ilosciowe z numerem '+str(Fun)+' bez parametrw: '+Lista


if stat=='OK':
    if Fun in [6,8,9,11]:
        NumerNoty=str(klucze['NumerNoty'])
        
    if Fun in [5,6,8,9,11]:
        FStan=rsglobal.Dekoduj(klucze['Stan'])
        FOddzial=rsglobal.Dekoduj(klucze['Oddzial'])
        FKontrahent=rsglobal.Dekoduj(klucze['Kontrahent'])
        FDataWystOd=rsglobal.Dekoduj(klucze['DataWystOd'])
        FDataWystDo=rsglobal.Dekoduj(klucze['DataWystDo'])
        FNota=rsglobal.Dekoduj(klucze['Nota'])

UprUsuwanie = ((self.oddzial_id,'027204') in self.uprawnienia or self.operator_id == STANDARD_OPERATOR_ID)
UprZmianaStanu = ((self.oddzial_id,'027206') in self.uprawnienia or self.operator_id == STANDARD_OPERATOR_ID)

 
#-------------------------------------------------------------------------------
#--- DELETE - 6
#-------------------------------------------------------------------------------

if Fun == 6 and stat == 'OK':
    if not UprUsuwanie:
        stat='Brak uprawnie do usuwania not ilociowych.'
        
    if stat=='OK':
        SQL="SELECT stan FROM rs_noty_ilosciowe WHERE firma_id='"+self.firma_id+"' AND "
        SQL+=" numer="+NumerNoty+" FOR UPDATE NOWAIT;"
        stat,Dane,dump,dump = self.PolSQL.Execute(SQL, 3)
        if stat<>'OK':
            stat='Bd pobierania stanu noty. Prawdopodobnie nie powiodo si zablokowanie noty. Sprbuj ponownie.'
    
    if stat=='OK':
        if len(Dane)==0:
            stat='Uwaga podano nieprawidowy numer noty ilociowej do usunicia'
        elif Dane[0][0]<>'W':
            stat='Uwaga stan noty ilociowej nie pozwala na jej usunicie'
        else:
            DELETE ="DELETE FROM rs_noty_ilosciowe"
            DELETE+=" WHERE firma_id = '"+self.firma_id+"' AND numer = "+NumerNoty+";"
            stat,dump,dump,dump = self.PolSQL.Execute(DELETE, 1)
            if stat <> 'OK':
                stat='Bd usuwania noty ilociowej : '+stat
                

#-------------------------------------------------------------------------------
#--- ZAMYKANIE - 8/9 -  OTWIERANIE (TYLKO ZMIANA STANU)
#-------------------------------------------------------------------------------

if Fun in [8,9] and stat == 'OK':
    if not UprZmianaStanu:
        stat='Brak uprawnie do zmiany stanu not ilociowych'
        
    if stat=='OK':
        SQL="SELECT stan FROM rs_noty_ilosciowe WHERE firma_id='"+self.firma_id+"' AND "
        SQL+=" numer="+NumerNoty+" FOR UPDATE NOWAIT;"
        stat,Dane,dump,dump = self.PolSQL.Execute(SQL, 3)
        if stat<>'OK':
            stat='Bd pobierania stanu noty. Prawdopodobnie nie powiodo si zablokowanie noty. Sprbuj ponownie.'

    if stat=='OK':
        if len(Dane)==0:
            stat='Uwaga podano nieprawidowy numer noty ilociowej do zmiany stanu'
        elif (Dane[0][0]=='W' and Fun==9):
            stat='Uwaga stan noty ilociowej nie pozwala na jej otwarcie'
        elif (Dane[0][0]=='Z' and Fun==8):
            stat='Uwaga stan noty ilociowej nie pozwala na jej zamknicie'
        else:
            SQL ="UPDATE rs_noty_ilosciowe"
            if Fun==8:
                SQL+=" SET stan='Z'"
            else:
                SQL+=" SET stan='W'"
                
            SQL+=" WHERE firma_id = '"+self.firma_id+"' AND numer = "+NumerNoty+";"
            stat,dump,dump,dump = self.PolSQL.Execute(SQL, 1)
            if stat <> 'OK':
                stat='Bd zmiany stanu noty ilociowej : '+stat
                
                
#-------------------------------------------------------------------------------
#---- 11 - przeliczenie noty ilociowej na podstawie danych z podtabel
#-------------------------------------------------------------------------------

if Fun==11 and stat=='OK':
    # blokada noty
    SQL="SELECT stan FROM rs_noty_ilosciowe WHERE firma_id='"+self.firma_id+"' AND "
    SQL+=" numer="+NumerNoty+" FOR UPDATE NOWAIT;"
    stat,Dane,dump,dump = self.PolSQL.Execute(SQL, 3)
    if stat<>'OK':
        stat='Bd pobierania stanu noty. Prawdopodobnie nie powiodo si zablokowanie noty. Sprbuj ponownie.'

    if stat=='OK':
        if len(Dane)==0:
            stat='Uwaga podano nieprawidowy numer noty ilociowej do przeliczenia'
        elif Dane[0][0]<>'W':
            stat='Uwaga stan noty ilociowej nie pozwala na jej przeliczenie'
    
    if stat=='OK':
        # pobranie pozycji noty
        SQL="SELECT nr_poz,artykul_id,cena FROM rs_noty_ilosciowe_pozycje "
        SQL+="WHERE firma_id='"+self.firma_id+"' AND numer="+NumerNoty
        stat,Dane,dump,dump = self.PolSQL.Execute(SQL, 3)
        if stat<>'OK':
            stat='Bd pobierania pozycji noty: '+stat
    
    if stat=='OK':
        for poz in Dane:
            if stat=='OK':
                IloscK=0
                IloscDD=0
                Art=rsglobal.Dekoduj(poz[1])

                # pobranie danych z korekt
                SQL="SELECT SUM(kp.ilosc1_p-kp.ilosc1) FROM rs_noty_ilosciowe_korekty nk"
                SQL+=" INNER JOIN rs_korekty_pozycje kp ON (kp.firma_id=nk.firma_id "
                SQL+=" AND kp.wyznacznik_id=nk.wyznacznik_id AND kp.data=nk.data "
                SQL+=" AND kp.numer=nk.numer_k AND kp.artykul_id='"+Art+"' AND kp.cena_brutto1="+str(poz[2])+")"
                SQL+="WHERE nk.firma_id='"+self.firma_id+"' AND nk.numer="+NumerNoty
                stat,DKor,dump,dump = self.PolSQL.Execute(SQL, 3)
                if stat<>'OK':
                    stat='Bd pobierania danych z korekt: '+stat
            
            if stat=='OK':
                if len(DKor)>0:
                    if not DKor[0][0] in [None,'None']:
                        IloscK=DKor[0][0]
                        
                # pobranie danych z dowodw dostaw
                SQL="SELECT SUM(ilosc_zwr1) FROM rs_noty_ilosciowe_dowody_dostaw ndd "
                SQL+=" INNER JOIN rs_dowody_dostaw_pozycje ddp ON (ddp.firma_id=ndd.firma_id "
                SQL+=" AND ddp.oddzial_id=ndd.oddzial_id AND ddp.trasa=ndd.trasa AND ddp.data=ndd.data"
                SQL+=" AND ddp.tryb_dostawy=ndd.tryb_dostawy AND ddp.numer=ndd.numer_dd"
                SQL+=" AND ddp.artykul_id='"+Art+"' AND ddp.cena_brutto1="+str(poz[2])+")"
                SQL+=" WHERE ndd.firma_id='"+self.firma_id+"' AND ndd.numer="+NumerNoty
                stat,DDowD,dump,dump = self.PolSQL.Execute(SQL, 3)
                if stat<>'OK':
                    stat='Bd pobierania danych z dowodw dostaw: '+stat
            
            if stat=='OK':
                if len(DDowD)>0:
                    if not DDowD[0][0] in [None,'None']:
                        IloscDD=DDowD[0][0]
                        
            if stat=='OK':
                # wstawienie danych do noty
                SQL="UPDATE rs_noty_ilosciowe_pozycje SET ilosc_k="+str(IloscK)+",ilosc_dd="+str(IloscDD)
                SQL+="WHERE firma_id='"+self.firma_id+"' AND numer="+NumerNoty+" AND nr_poz="+str(poz[0])
                stat,dump,dump,dump = self.PolSQL.Execute(SQL, 1)
                if stat<>'OK':
                    stat='Bd zmiany iloci na nocie: '+stat
        
#-------------------------------------------------------------------------------
#---- SELECT - 5 Pobieranie listy szkole
#-------------------------------------------------------------------------------

if Fun in [5,6,8,9,11]  and stat == 'OK':    
    SQL =" SELECT stan,numer_noty,oddzial_id,kontrahent_id,data_wystawienia,data_wprowadzenia,numer"
    SQL+=" FROM rs_noty_ilosciowe "
    SQL+=" WHERE  firma_id='"+self.firma_id+"'"
    if FStan <> '' :    
        SQL+=" AND stan='"+FStan+"'"
    if FOddzial <> '':
        SQL+=" AND oddzial_id='"+FOddzial+"'"
    if FKontrahent <> '':
        SQL+=" AND kontrahent_id LIKE '"+FKontrahent+"%'"
    if FDataWystOd <> '    -  -  ':
        SQL+=" AND data_wystawienia>='"+FDataWystOd+"'"
    if FDataWystDo <> '    -  -  ':
        SQL+=" AND data_wystawienia<='"+FDataWystDo+"'"
    if FNota<> '':
        SQL+= " AND numer_noty LIKE '"+FNota+"%'"   

    SQL+=" ORDER BY numer_noty"
    stat,dane,wyn1,dump =self.PolSQL.Execute(SQL, 3)
    if stat <> 'OK':
        stat='Bd pobrania listy not ilociowych : '+stat