# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_noty_ilosciowe_dowody_dostaw.py
# Purpose:     obsuga dowodw_dostaw podpitych do noty ilociowej
#
# Author:      Micha Raburski
# Created:     2012/09/10
# RCS-ID:      $Id: fs_noty_ilosciowe_dowody_dostaw.py $
# Copyright:   (c) 2012 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

dane = []
wyn1 = []
wyn2 = []
stat = 'OK'


if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=='OK':
    Fun = klucze['Funkcja']
    
    SlPar={'Nota':[1,5,6],'Trasa':[1,6],'Data':[1,6],'Tryb':[1,6],'NumerDD':[1,6]}    
    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Fun,klucze)
    if Lista<>'':
        stat='Uwaga : wywoanie funkcji fs_noty_ilosciowe_dowody_dostaw z numerem '+str(Fun)+' bez parametrw: '+Lista

if stat=='OK':    
    if Fun in [1,5,6]:
        Nota=str(klucze['Nota'])
    if Fun in [1,6]:
        Trasa=rsglobal.Dekoduj(klucze['Trasa'])
        Data=rsglobal.Dekoduj(klucze['Data'])
        Tryb=rsglobal.Dekoduj(klucze['Tryb'])
        NumerDD=str(klucze['NumerDD'])
        
UprDodawanie = ((self.oddzial_id,'027203') in self.uprawnienia or self.operator_id == STANDARD_OPERATOR_ID)
UprUsuwanie = ((self.oddzial_id,'027204') in self.uprawnienia or self.operator_id == STANDARD_OPERATOR_ID)

#-------------------------------------------------------------------------------
#--- INSERT - 1
#-------------------------------------------------------------------------------

if Fun == 1 and stat == 'OK':
    if not UprDodawanie:
        stat='Brak uprawnie do dodawania dowodw dostaw do noty ilociowej.'
    if stat=='OK':
        # sprawdzenie czy nota nie jest zamknita
        SQL="SELECT stan,dostawy_od,dostawy_do FROM rs_noty_ilosciowe "
        SQL+=" WHERE firma_id='"+self.firma_id+"' AND numer="+Nota+" FOR UPDATE;"
        stat,DTest,dump,dump = self.PolSQL.Execute(SQL, 3)
        if stat <> 'OK':
            stat='Bd sprawdzania stanu noty : '+stat
        elif len(DTest)==0:
            stat='Brak noty o podanych parametrach'
        elif DTest[0][0]=='Z':
            stat='Nie mona edytowa noty w stanie Z'
        else:
            DostawyOd=DTest[0][1]
            DostawyDo=DTest[0][2]
        
    if stat=='OK':    
        # sprawdzenie istnienia dowodu dostawy
        SQL="SELECT trasa FROM rs_dowody_dostaw WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+self.oddzial_id+"'"
        SQL+=" AND trasa='"+Trasa+"' AND data='"+Data+"' AND tryb_dostawy='"+Tryb+"' AND numer="+NumerDD
        stat,DTest,dump,dump = self.PolSQL.Execute(SQL, 3)
        if stat <> 'OK':
            stat='Bd sprawdzania istnienia dowodu dostawy : '+stat
        elif len(DTest)==0:
            stat='Brak dowodu dostawy o podanych parametrach'

    if stat=='OK':
        # dodanie ewentualnego komunikatu, e data dowodu dostawy poza zakresem
        if not DostawyOd in [None,'None','    -  -  ']:
            if DostawyOd>Data:
                wyn2.append('UWAGA! Data dowodu dostawy ('+Data+') jest wczeniejsza ni data dostaw od na nocie.')
        
        if not DostawyDo in [None,'None','    -  -  ']:
            if DostawyDo<Data:
                wyn2.append('UWAGA! Data dowodu dostawy ('+Data+') jest pniejsza ni data dostaw do na nocie.')
                
        # sprawdzenie czy dowd dostawy nie jest ju dodany do noty
        SQL="SELECT trasa FROM rs_noty_ilosciowe_dowody_dostaw WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+self.oddzial_id+"'"
        SQL+=" AND trasa='"+Trasa+"' AND data='"+Data+"' AND tryb_dostawy='"+Tryb+"' AND numer_dd="+NumerDD
        SQL+=" AND numer="+Nota
        stat,DTest,dump,dump = self.PolSQL.Execute(SQL, 3)
        if stat <> 'OK':
            stat='Bd sprawdzania istnienia dowodu dostawy na nocie : '+stat
        elif len(DTest)>0:
            stat='Wybrany dowd dostawy jest ju dodany na nocie'
    
    if stat=='OK':
        # wstawienie dowodu dostawy do noty
        SQL="INSERT INTO rs_noty_ilosciowe_dowody_dostaw (firma_id,numer,oddzial_id,trasa,data,tryb_dostawy,numer_dd)"
        SQL+=" VALUES('"+self.firma_id+"',"+Nota+",'"+self.oddzial_id+"','"+Trasa+"','"+Data+"','"+Tryb+"',"+NumerDD+");"
        stat,dump,dump,dump = self.PolSQL.Execute(SQL, 1)
        if stat <> 'OK':
            stat='Bd wstawiania dowodu dostawy na not : '+stat


#-------------------------------------------------------------------------------
#--- DELETE - 6
#-------------------------------------------------------------------------------

if Fun == 6 and stat == 'OK':
    if not UprUsuwanie:
        stat='Brak uprawnie do usuwania dowodw dostaw z noty.'
        
    if stat=='OK':
        # sprawdzenie czy nota nie jest zamknita
        SQL="SELECT stan FROM rs_noty_ilosciowe WHERE firma_id='"+self.firma_id+"' AND numer="+Nota+" FOR UPDATE;"
        stat,DTest,dump,dump = self.PolSQL.Execute(SQL, 3)
        if stat <> 'OK':
            stat='Bd sprawdzania stanu noty : '+stat
        elif len(DTest)==0:
            stat='Brak noty o podanych parametrach'
        elif DTest[0][0]=='Z':
            stat='Nie mona edytowa noty w stanie Z'
        
    if stat=='OK':
        SQL ="DELETE FROM rs_noty_ilosciowe_dowody_dostaw"
        SQL+=" WHERE firma_id = '"+self.firma_id+"' AND numer = '"+Nota+"' AND oddzial_id='"+self.oddzial_id+"'"
        SQL+=" AND trasa='"+Trasa+"' AND data='"+Data+"' AND tryb_dostawy='"+Tryb+"' AND numer_dd="+NumerDD
        stat,dump,dump,dump = self.PolSQL.Execute(SQL, 1)
        if stat <> 'OK':
            stat='Bd usuwania dowodu dostawy z noty : '+stat
            
                
#-------------------------------------------------------------------------------
#---- SELECT - 5 Pobieranie listy dowodw dostaw dla noty
#-------------------------------------------------------------------------------

if Fun in (1,5,6)  and stat == 'OK':
    SQL ="SELECT trasa,data,tryb_dostawy,numer_dd"
    SQL+=" FROM rs_noty_ilosciowe_dowody_dostaw "
    SQL+=" WHERE firma_id = '"+self.firma_id+"' AND numer='"+str(Nota)+"' ORDER BY trasa,data,tryb_dostawy,numer_dd;"
    stat,dane,wyn1,dump =self.PolSQL.Execute(SQL, 3)
    if stat <> 'OK':
        stat='Bd pobrania listy dowodw dostaw dla noty ilociowej : '+stat