# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_noty_ilosciowe_korekty.py
# Purpose:     obsuga korekt podpitych do noty ilociowej
#
# Author:      Micha Raburski
# Created:     2012/09/04
# RCS-ID:      $Id: fs_noty_ilosciowe_korekty.py $
# Copyright:   (c) 2012 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

dane = []
wyn1 = []
wyn2 = []
stat = 'OK'


if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=='OK':
    Fun = klucze['Funkcja']
    
    SlPar={'Nota':[1,5,6],'Wyznacznik':[1,6],'Data':[1,6],'NumerK':[1,6]}    
    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Fun,klucze)
    if Lista<>'':
        stat='Uwaga : wywoanie funkcji fs_noty_ilosciowe_korekty z numerem '+str(Fun)+' bez parametrw: '+Lista

if stat=='OK':    
    if Fun in [1,5,6]:
        Nota=str(klucze['Nota'])
    if Fun in [1,6]:
        Wyznacznik=rsglobal.Dekoduj(klucze['Wyznacznik'])
        Data=rsglobal.Dekoduj(klucze['Data'])
        NumerK=str(klucze['NumerK'])
        
UprDodawanie = ((self.oddzial_id,'027203') in self.uprawnienia or self.operator_id == STANDARD_OPERATOR_ID)
UprUsuwanie = ((self.oddzial_id,'027204') in self.uprawnienia or self.operator_id == STANDARD_OPERATOR_ID)

#-------------------------------------------------------------------------------
#--- INSERT - 1
#-------------------------------------------------------------------------------

if Fun == 1 and stat == 'OK':
    if not UprDodawanie:
        stat='Brak uprawnie do dodawania korekt do noty ilociowej.'
    if stat=='OK':
        # sprawdzenie czy nota nie jest zamknita
        SQL="SELECT stan FROM rs_noty_ilosciowe WHERE firma_id='"+self.firma_id+"' AND numer="+Nota+" FOR UPDATE;"
        stat,DTest,dump,dump = self.PolSQL.Execute(SQL, 3)
        if stat <> 'OK':
            stat='Bd sprawdzania stanu noty : '+stat
        elif len(DTest)==0:
            stat='Brak noty o podanych parametrach'
        elif DTest[0][0]=='Z':
            stat='Nie mona edytowa noty w stanie Z'
    
        # sprawdzenie istnienia korekty
        SQL="SELECT wyznacznik_id FROM rs_korekty WHERE firma_id='"+self.firma_id+"'"
        SQL+=" AND wyznacznik_id='"+Wyznacznik+"' AND data='"+Data+"' AND numer="+NumerK
        stat,DTest,dump,dump = self.PolSQL.Execute(SQL, 3)
        if stat <> 'OK':
            stat='Bd sprawdzania istnienia korekty : '+stat
        elif len(DTest)==0:
            stat='Brak korekty o podanych parametrach'
    
    if stat=='OK':
        # sprawdzenie czy korekta nie jest ju dodana do noty
        SQL="SELECT wyznacznik_id FROM rs_noty_ilosciowe_korekty WHERE firma_id='"+self.firma_id+"'"
        SQL+=" AND wyznacznik_id='"+Wyznacznik+"' AND data='"+Data+"' AND numer_k="+NumerK
        SQL+=" AND numer="+Nota
        stat,DTest,dump,dump = self.PolSQL.Execute(SQL, 3)
        if stat <> 'OK':
            stat='Bd sprawdzania istnienia korekty na nocie : '+stat
        elif len(DTest)>0:
            stat='Wybrana korekta jest ju dodana na nocie'
    
    if stat=='OK':
        # wstawienie korekty do noty
        SQL="INSERT INTO rs_noty_ilosciowe_korekty (firma_id,numer,wyznacznik_id,data,numer_k)"
        SQL+=" VALUES('"+self.firma_id+"',"+Nota+",'"+Wyznacznik+"','"+Data+"',"+NumerK+");"
        stat,dump,dump,dump = self.PolSQL.Execute(SQL, 1)
        if stat <> 'OK':
            stat='Bd wstawiania korekty na not : '+stat


#-------------------------------------------------------------------------------
#--- DELETE - 6
#-------------------------------------------------------------------------------

if Fun == 6 and stat == 'OK':
    if not UprUsuwanie:
        stat='Brak uprawnie do usuwania korekt z noty.'
        
    if stat=='OK':
        # sprawdzenie czy nota nie jest zamknita
        SQL="SELECT stan FROM rs_noty_ilosciowe WHERE firma_id='"+self.firma_id+"' AND numer="+Nota+" FOR UPDATE;"
        stat,DTest,dump,dump = self.PolSQL.Execute(SQL, 3)
        if stat <> 'OK':
            stat='Bd sprawdzania stanu noty : '+stat
        elif len(DTest)==0:
            stat='Brak noty o podanych parametrach'
        elif DTest[0][0]=='Z':
            stat='Nie mona edytowa noty w stanie Z'
        
    if stat=='OK':
        SQL ="DELETE FROM rs_noty_ilosciowe_korekty"
        SQL+=" WHERE firma_id = '"+self.firma_id+"' AND numer = '"+Nota+"'"
        SQL+=" AND wyznacznik_id='"+Wyznacznik+"' AND data='"+Data+"' AND numer_k="+NumerK
        stat,dump,dump,dump = self.PolSQL.Execute(SQL, 1)
        if stat <> 'OK':
            stat='Bd usuwania korekty z noty : '+stat
            
                
#-------------------------------------------------------------------------------
#---- SELECT - 5 Pobieranie listy korekt dla noty
#-------------------------------------------------------------------------------

if Fun in (1,5,6)  and stat == 'OK':
    SQL ="SELECT wyznacznik_id,data,numer_k"
    SQL+=" FROM rs_noty_ilosciowe_korekty "
    SQL+=" WHERE firma_id = '"+self.firma_id+"' AND numer='"+str(Nota)+"' ORDER BY wyznacznik_id,data,numer_k;"
    stat,dane,wyn1,dump =self.PolSQL.Execute(SQL, 3)
    if stat <> 'OK':
        stat='Bd pobrania listy korekt dla noty ilociowej : '+stat