# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_noty_ilosciowe_pozycje.py
# Purpose:     obsluga grida edytowalnego w pozycjach not ilociowych
# Author:      Micha Raburski
# Created:     2012/09/11
# RCS-ID:      $Id: fs_noty_ilosciowe_pozycje.py$
# Copyright:   (c) 2012 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

stat='OK'

if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=='OK':
    Funkcja = klucze['Funkcja']
    
    SlPar={'Nota':[1,5], 'ArtykulOpis':[8]}    
    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Funkcja,klucze)
    if Lista<>'':
        stat='Uwaga : wywoanie funkcji fs_noty_ilosciowe_pozycje z numerem '+str(Funkcja)+' bez parametrw: '+Lista
        
    if Funkcja in (1,5): 
        Nota=str(klucze['Nota'])
        
    if Funkcja == 8:
        ArtykulOpis = rsglobal.Dekoduj(klucze['ArtykulOpis'])
        
UprDodawanie = (((self.oddzial_id,'027203') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID))
UprEdycja = (((self.oddzial_id,'027202') in self.uprawnienia) or UprDodawanie or (self.operator_id == STANDARD_OPERATOR_ID))
UprUsuwanie = (((self.oddzial_id,'027204') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID))


#-------------------------------------------------------------------------------
#-------  POBRANIE OPISU ARTYKUU (8)
#-------------------------------------------------------------------------------

if Funkcja == 8 and stat == "OK":
    sql ="SELECT nazwa FROM rs_artykuly "
    sql+=" WHERE firma_id='"+self.firma_id+"' AND artykul_id='"+ArtykulOpis+"';"

    stat,dane,dump,dump = self.PolSQL.Execute(sql,3)
    if stat <> 'OK':
        stat = 'Bd przy pobieraniu opisu artykuu: '+stat
        dane.append(stat)
        
        
#-------------------------------------------------------------------------------
#-------  SPRAWDZANIE DELETE  --------------------------------------------------
#-------------------------------------------------------------------------------

if Funkcja == 1 and stat=="OK":
    Delete=klucze['Delete']
    if len(Delete[0])>0:
        if not UprUsuwanie:
            stat='BR UPR DEL'
            dane.append(stat)
        
        # wykonanie DELETE 
        if stat == 'OK':
            SQLDEL = ''
            SQLFU = ''
            for i in xrange(len(Delete[0])):
                SQLFU+= "SELECT artykul_id FROM rs_noty_ilosciowe_pozycje"
                SQLFU+=" WHERE firma_id='"+self.firma_id+"' AND numer='"+Nota+"'"
                DELETE = "DELETE FROM rs_noty_ilosciowe_pozycje "
                WHERE = "WHERE firma_id='"+self.firma_id+"' AND numer='"+Nota+"'"
                for j in xrange(len(Delete[0][i])):
                    pole = Delete[1][j]
                    wart = Delete[0][i][j]
                    if pole in ['nr_poz']:
                        WHERE += " AND "+pole+"="+str(wart)
                        SQLFU += " AND "+pole+"="+str(wart)
                        
                SQLDEL += DELETE+WHERE+"; "
                SQLFU += " FOR UPDATE NOWAIT; "

            if SQLFU <> '':
                stat,d,dump,dump = self.PolSQL.Execute(rsglobal.Dekoduj(SQLFU),3)
                if stat <> 'OK':
                    stat = 'Bd sprawdzenia danych do usunicia: '+stat
                    dane.append(stat)

            if stat == "OK" and SQLDEL <> '':
                stat,dump,dump,dump = self.PolSQL.Execute(rsglobal.Dekoduj(SQLDEL),1)
                if stat <> 'OK':
                    stat = "Bd przy usuwaniu danych: "+stat   
                    dane.append(stat)

                                 
#-------------------------------------------------------------------------------
#---   UPDATE DANYCH (1)
#-------------------------------------------------------------------------------

if Funkcja == 1 and stat=="OK":
    Update=klucze['Update']

    if len(Update[0])>0:
        if not UprEdycja:
            stat='BR UPR UPD'
            dane.append(stat)

        if stat == 'OK':
            SQLFU = ''
            for i in xrange(len(Update[0])):
                SQLFU+= "SELECT nr_poz FROM rs_noty_ilosciowe_pozycje"
                SQLFU+=" WHERE firma_id='"+self.firma_id+"' AND numer='"+Nota+"'"

                for j in xrange(len(Update[2][i])): # petla po kluczu
                    pole = Update[3][j]
                    wart = rsglobal.Dekoduj(Update[2][i][j])
                    SQLFU += " AND "+pole+"="+str(wart)                        
                SQLFU += " FOR UPDATE NOWAIT; "
            
            if SQLFU <> '':
                stat,d,dump,dump = self.PolSQL.Execute(rsglobal.Dekoduj(SQLFU),3)
                if stat <> 'OK':
                    stat = 'Bd sprawdzenia danych do modyfikacji: '+stat
                    dane.append(stat)

        if stat == 'OK':
            WierszeNr = Update[-1]
            for i in xrange(len(Update[0])):
                StanowiskoNowe = None
                DzialNowy = None               
                for j in xrange(len(Update[0][i])): 
                    pole=Update[0][i][j]
                    wart=Update[1][i][j]
                    
                    if pole == 'nr_poz':
                        if wart == 0:
                            stat = 'BR NR POZ'
                            wyn2.append((WierszeNr[i],0))
                            dane.append(stat)
                        
                    elif pole == 'artykul_id':
                        if wart == '':
                            stat = 'BR ART'
                            wyn2.append((WierszeNr[i],0))
                            dane.append(stat)
                        else:
                            sql ="SELECT artykul_id FROM rs_artykuly"
                            sql+=" WHERE firma_id = '"+self.firma_id+"'"
                            sql+=" AND artykul_id = '"+str(wart)+"';" 
                            stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                            if stat <> 'OK':
                                stat = 'BL SQL ART'
                                wyn2.append((WierszeNr[i],0))
                                dane.append(stat)
                            elif len(d) == 0:
                                stat = 'BL ART'
                                wyn2.append((WierszeNr[i],0))
                                dane.append(stat)
                                
                    elif pole == 'ilosc':
                        if wart == 0:
                            stat = 'BR ILOSC'
                            wyn2.append((WierszeNr[i],0))
                            dane.append(stat)
                    
                    elif pole == 'cena':
                        if wart == 0:
                            stat = 'BR CENA'
                            wyn2.append((WierszeNr[i],0))
                            dane.append(stat)

        if stat == 'OK':
            if len(dane) > 0:
                stat = dane[0]
                
        # wykonanie UPDATE
        if stat=='OK':
            sql=''
            for i in xrange(len(Update[0])):
                UPDATE="UPDATE rs_noty_ilosciowe_pozycje "
                SET='SET '
                for j in xrange(len(Update[0][i])): 
                    pole=Update[0][i][j]
                    wart=Update[1][i][j]
                    if pole in ['nr_poz', 'artykul_id','ilosc','cena']:
                        SET+=pole+"='"+str(wart)+"',"
                    
                SET=SET.strip(",")
                WHERE=" WHERE firma_id='"+self.firma_id+"' AND numer='"+Nota+"'" 
                for j in xrange(len(Update[2][i])): # petla po kluczu
                    pole=Update[3][j]
                    wart=rsglobal.Dekoduj(Update[2][i][j])
                    if pole in ['nr_poz']:
                        WHERE+=" AND "+pole+"="+str(wart)
                        
                WHERE+=";"    
                
                sql+=UPDATE+SET+WHERE;
                
            if sql<>'':
                stat,dump,dump,dump=self.PolSQL.Execute(rsglobal.Dekoduj(sql),1)
                if stat<>'OK':
                    stat="Bd przy modyfikowaniu danych: "+stat   
                    dane.append(stat)  


#-------------------------------------------------------------------------------
#---------Sprawdzanie danych do Insert------
#-------------------------------------------------------------------------------

if Funkcja == 1 and stat=="OK":
    Insert=klucze['Insert']
    if len(Insert[0])>0:
        if not UprDodawanie:
            stat='BR UPR INS'
            dane.append(stat)

        if stat == 'OK':
            WierszeNr = Insert[-1]
            for i in xrange(len(Insert[0])):
                NrNowy = None
                for j in xrange(len(Insert[0][i])): 
                    pole=Insert[1][j]
                    wart=Insert[0][i][j]
                    
                    if pole == 'nr_poz':
                        if wart == 0:
                            stat = 'BR NR POZ'
                            wyn2.append((WierszeNr[i],0))
                            dane.append(stat)

                    elif pole == 'artykul_id':
                        if wart == '':
                            stat = 'BR ART'
                            wyn2.append((WierszeNr[i],0))
                            dane.append(stat)
                        else:
                            sql ="SELECT artykul_id FROM rs_artykuly"
                            sql+=" WHERE firma_id = '"+self.firma_id+"'"
                            sql+=" AND artykul_id = '"+str(wart)+"';" 
                            stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                            if stat <> 'OK':
                                stat = 'BL SQL ART'
                                wyn2.append((WierszeNr[i],0))
                                dane.append(stat)
                            elif len(d) == 0:
                                stat = 'BL ART'
                                wyn2.append((WierszeNr[i],0))
                                dane.append(stat)
                                
                    elif pole == 'ilosc':
                        if wart == 0:
                            stat = 'BR ILOSC'
                            wyn2.append((WierszeNr[i],0))
                            dane.append(stat)
                    
                    elif pole == 'cena':
                        if wart == 0:
                            stat = 'BR CENA'
                            wyn2.append((WierszeNr[i],0))
                            dane.append(stat)
                                
                #sprawdzam przed dodawaniem, czy podany klucz juz istnieje,
                #bo operator moze miec na gridzie filtr i nie widziec,
                #ze podany (choc dozwolony) klucz juz istnieje
                if len(dane) == 0 and NrNowy <> None:
                    sql ="SELECT nr_poz FROM rs_noty_ilosciowe_pozycje"
                    sql+=" WHERE firma_id='"+self.firma_id+"' AND numer='"+Nota+"'"
                    sql+=" AND nr_poz="+str(NrNowy)+";"

                    stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                    if stat <> 'OK':
                        stat = 'BL SQL KLUCZ'+stat
                        dane.append(stat)
                        wyn2.append((WierszeNr[i],0))
                        wyn2.append((WierszeNr[i],2))
                    elif len(d) > 0:
                        stat = 'BL KLUCZ IST'
                        dane.append(stat)
                        wyn2.append((WierszeNr[i],0))
                        wyn2.append((WierszeNr[i],2))

        if stat == 'OK':
            if len(dane) > 0:
                stat = dane[0]
                                                        
        # wykonanie INSERT
        if stat == 'OK':    
            sqlIns=''
            for i in xrange(len(Insert[0])):
                INSERT="INSERT INTO rs_noty_ilosciowe_pozycje "
                KOLUMNY="(firma_id, numer"
                VALUES=" VALUES ('"+self.firma_id+"',"+Nota+" "
                for j in xrange(len(Insert[0][i])):
                    pole=Insert[1][j]
                    wart=Insert[0][i][j]
                    if pole in ['nr_poz','artykul_id','cena','ilosc']:
                        KOLUMNY+=","+pole
                        VALUES+=",'"+str(wart)+"'"                                           
                        
                KOLUMNY+=")"
                VALUES+=");"
                sqlIns+=INSERT+KOLUMNY+VALUES
            if sqlIns<>'': 
                stat,dump,dump,dump=self.PolSQL.Execute(rsglobal.Dekoduj(sqlIns),1)

                if stat<>'OK':
                    stat="Bd przy dodawaniu danych: "+stat   
                    dane.append(stat)                   

#-------------------------------------------------------------------------------
# JELI BYY USUWANE WIERSZE TO PRZENUMEROWANIE
#-------------------------------------------------------------------------------
if Funkcja == 1 and stat=="OK" and len(Delete)>0:
    # pobranie aktualnych numerw pozycji
    SQL="SELECT nr_poz FROM rs_noty_ilosciowe_pozycje"
    SQL+=" WHERE firma_id='"+self.firma_id+"' AND numer='"+Nota+"' ORDER BY nr_poz;"
    stat,DPoz,dump,dump=self.PolSQL.Execute(rsglobal.Dekoduj(SQL),3)
    if stat=='OK':
        if len(DPoz)>0:
            i=1
            UPD=''
            for poz in DPoz:
                if poz[0]<>i:
                    UPD+="UPDATE rs_noty_ilosciowe_pozycje SET nr_poz="+str(i)
                    UPD+=" WHERE firma_id='"+self.firma_id+"' AND numer='"+Nota+"' AND nr_poz="+str(poz[0])+";"
                i+=1
            if UPD<>'':
                stat,dump,dump,dump=self.PolSQL.Execute(rsglobal.Dekoduj(UPD),1)

#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (1- insert 1 -select, 1 -delete)
#-------------------------------------------------------------------------------

if Funkcja in (1,5) and stat=='OK':
    SQL ="SELECT nip.nr_poz, nip.artykul_id, a.nazwa, nip.ilosc,nip.cena,nip.ilosc_dd,nip.ilosc_k"
    SQL+=" FROM rs_noty_ilosciowe_pozycje nip"
    SQL+=" LEFT OUTER JOIN rs_artykuly a USING(firma_id,artykul_id)"
    SQL+=" WHERE nip.firma_id='"+self.firma_id+"' AND nip.numer='"+Nota+"'"
    SQL+=" ORDER BY nip.nr_poz;"
    stat,dane,wyn1,wyn2 = self.PolSQL.Execute(SQL,3)

    if stat <> 'OK':
        stat = "Bd przy pobieraniu danych: "+stat
        dane.append(stat)