# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_obroty_magazynowe.py
# Purpose:     pobiera stan pocztkowy, kocowy i dane pomidzy podanymi datami
#
# Author:      Micha Raburski
# Created:     2006/01/19
# RCS-ID:      $Id: fs_obroty_magazynowe.py $
# Copyright:   (c) 2005 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

#2011.02.02 Mariusz Rajfura - nowe pole 'produkt_id' (4223)

#przychodz parametry: KLUCZ,NIC,NIC 
# gdzie KLUCZ ma struktur : [klucz,data_od,data_do]
#gdzie klucz to 4 parametry.W zalenoci od 4 parametru s to :
# 1 : artyku,'','',1
# 2 : artyku,oddzia,'',2
# 3 : artyku,magazyn,oddzial,3

#wraca status,dane,tablica=[stan pocztkowy, stan kocowy]

stat = "OK"
dane = []
wyn2=[0,0]
if klucze[4]== '    -  -  ':
    DataOd='1960-01-01'
else:
    DataOd=klucze[4]
    
if klucze[5]== '    -  -  ':
    DataDo='2260-12-31'
else:
    DataDo=klucze[5]

Filtr="WHERE firma_id='"+self.firma_id+"' AND artykul_id='"+klucze[0]+"' "
Magazyn=''
Magazyny=''
if klucze[3]==3:
    Filtr=Filtr+" AND magazyn_id='"+klucze[1]+"'"
    Magazyn=klucze[1]


if ((self.oddzial_id,'032030') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
    if self.operator_id <> STANDARD_OPERATOR_ID:
        #uprawnienia operatora do poszczeglnych magazynw
        sql = "SELECT magazyn_id FROM rs_magazyny_upr WHERE firma_id='"+str(self.firma_id)+"' AND operator_id='"+str(self.operator_id)+"' "
        sql+= " AND ilosc;"
        stat,mag,dump,dump = self.PolSQL.Execute(sql,3)
        if stat != 'OK':
            stat = stat
            dane.append(stat)       
        if stat == 'OK': # magazyny do ktorych mamy uprawnienia 
            if len(mag)<>0:
                Magazyny = " AND magazyn_id IN (   "
                for i in mag:
                    Magazyny += "'"+str(i[0])+"' , "
                Magazyny = Magazyny[0:-3]+" ) "
                Filtr = Filtr + Magazyny

    #---   Pobranie danych
    Il1="case when typ='P' then ilosc1 when typ='W' then -1*ilosc1 else 0 end as ilosc1"
    Il2="case when typ='P' then ilosc2 when typ='W' then -1*ilosc2 else 0 end as ilosc2"
    Wart="case when typ='P' then wartosc when typ='W' then -1*wartosc else 0 end as wartosc"

    sql = "SELECT magazyn_id||'/'||dokument_id||'/'||data||'/'||numer as dokument,nr_poz,nr_ppoz,"
    sql+= "cena1,"+Il1+",cena2,"+Il2+","+Wart
    sql+=",nr_serii,dokument_przych,COALESCE(nr_faktury,''::TEXT),"
    sql+=" COALESCE(kontrahent_id,''::TEXT),COALESCE(produkt_id,''::TEXT)"
    sql+=" FROM rs_obroty_magazynowe "+Filtr 
    sql+=" AND data>='"+DataOd+"' AND data <= '"+DataDo+"' ORDER BY data;"
    stat,d,dump,dump = self.PolSQL.Execute(sql,3)    
    if stat=="OK":
       dane=d
    
    if Magazyn in Magazyny or self.operator_id == STANDARD_OPERATOR_ID:
        #--- pobranie stanw pocztkowego i kocowego(ilosc1,ilosc2,wart)
        if stat=="OK":
            stat,d,dump,dump = self.PolSQL.Execute("SELECT rsf_podaj_pole_z_obrotow_na_dzien_p('"+self.firma_id+"','"+Magazyn+"','"+klucze[0]+"','"+DataOd+"','ilosc1');" ,3)
        if stat=="OK":
            pil1=d[0][0]
            stat,d,dump,dump = self.PolSQL.Execute("SELECT rsf_podaj_pole_z_obrotow_na_dzien_p('"+self.firma_id+"','"+Magazyn+"','"+klucze[0]+"','"+DataOd+"','ilosc2');" ,3)
        if stat=="OK":
            pil2=d[0][0]
            stat,d,dump,dump = self.PolSQL.Execute("SELECT rsf_podaj_pole_z_obrotow_na_dzien_p('"+self.firma_id+"','"+Magazyn+"','"+klucze[0]+"','"+DataOd+"','wartosc');" ,3)
        if stat=="OK":
            pwart=d[0][0]
            stat,d,dump,dump = self.PolSQL.Execute("SELECT rsf_podaj_pole_z_obrotow_na_dzien_k('"+self.firma_id+"','"+Magazyn+"','"+klucze[0]+"','"+DataDo+"','ilosc1');" ,3)
        if stat=="OK":
            kil1=d[0][0]
            stat,d,dump,dump = self.PolSQL.Execute("SELECT rsf_podaj_pole_z_obrotow_na_dzien_k('"+self.firma_id+"','"+Magazyn+"','"+klucze[0]+"','"+DataDo+"','ilosc2');" ,3)
        if stat=="OK":
            kil2=d[0][0]
            stat,d,dump,dump = self.PolSQL.Execute("SELECT rsf_podaj_pole_z_obrotow_na_dzien_k('"+self.firma_id+"','"+Magazyn+"','"+klucze[0]+"','"+DataDo+"','wartosc');" ,3)        
        if stat=="OK":
            kwart=d[0][0]
            wyn1=[pil1,pil2,pwart,kil1,kil2,kwart]
    else:
        wyn1=['00.00','00.00','00.00','00.00','00.00','00.00']
else:
    stat='Brak uprawnie do przegldania obrotw magazynowych.'