
# -*- coding: iso8859_2 -*-

#-----------------------------------------------------------------------------
# Name:        fs_oddzialy.py
# Purpose:     obsluga oddzialow: wybor,edycja,usuwanie, zmiana klucza
#
# Author:      Mariusz Rajfura
# Created:     2009/04/08
# RCS-ID:      $Id: fs_oddzialy.py $
# Copyright:   (c) 2009 Record System
# Licence:     GNU GPL
#-----------------------------------------------------------------------------
from funkcje import fs_sprawdz_analityke

Symbol = klucze[0].strip()
CzyUprawnione = klucze[1]

Fun = klucze[-1]

stat = 'OK'
dane = []
wyn2 = []

UprDodawanie = ((self.oddzial_id,'001130') in self.uprawnienia or (self.operator_id == STANDARD_OPERATOR_ID))
UprEdycja = ((self.oddzial_id,'001110') in self.uprawnienia or UprDodawanie or (self.operator_id == STANDARD_OPERATOR_ID))
UprUsuwanie = ((self.oddzial_id,'001140') in self.uprawnienia or (self.operator_id == STANDARD_OPERATOR_ID))
UprZmianaKlucza = ((self.oddzial_id,'001150') in self.uprawnienia or (self.operator_id == STANDARD_OPERATOR_ID))


#-------------------------------------------------------------------------------
#---   USUWANIE DANYCH ( 3 )
#-------------------------------------------------------------------------------

if stat=='OK' and Fun==3:
    if Symbol == '**':
       stat='BL_GWIAZDKI_DELETE'
       dane.append(stat)
            
    if stat=='OK':
        if Symbol == self.oddzial_id:
            stat='BL_SELF_DELETE'
            dane.append(stat)

    if stat=='OK':
        if not UprUsuwanie:
            stat='BRAK_UPR'
            dane.append(stat)
        else:
            if Symbol == self.oddzial_id:
                stat='BL_SELF_DELETE'
                dane.append(stat)
                
            stat = fs_sprawdz_analityke.CzyMoznaUsunac(self,'rs_oddzialy',Symbol,'')
        
            if stat=='OK':
                sql="DELETE FROM rs_oddzialy WHERE firma_id='"+self.firma_id+"' AND oddzial_id = '"+Symbol+"';"
                stat,dane,wyn1,dump = self.PolSQL.Execute(sql,1)
                if stat<>'OK':
                    stat='BL_DELETE'
                    dane.append(stat)


#-------------------------------------------------------------------------------
#---   ZMIANA KLUCZA ( 6 )
#-------------------------------------------------------------------------------

if stat=='OK' and Fun==6:
    if not UprZmianaKlucza:
        stat='BRAK_UPR_ZM_KLUCZA'
        dane.append(stat)
        
    if stat == 'OK':
        stat = fs_sprawdz_analityke.CzyMoznaUsunac(self,'rs_oddzialy',Symbol,'')
        
    if stat=='OK':
        SymbolN = klucze[1].strip()
        sql="UPDATE rs_oddzialy SET oddzial_id = '"+SymbolN+"' WHERE firma_id='"+self.firma_id+"' AND oddzial_id = '"+Symbol+"';"
        stat,dane,wyn1,dump = self.PolSQL.Execute(sql,1)
        if stat<>'OK':
            stat='BL_ZM_KLUCZA'
            dane.append(stat)


#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH  ( 8 - administrator z gwiazdkami )
#-------------------------------------------------------------------------------

if stat=='OK':
    if self.operator_id==STANDARD_OPERATOR_ID:
        zgw = "AND oddzial_id <> '**'"
        if Fun==8:
            zgw = ''
            
        sql="SELECT oddzial_id,opis FROM rs_oddzialy WHERE firma_id='"+self.firma_id+"' "+zgw+" ORDER BY oddzial_id;"
    elif Fun in (1,9):
        FiltrUpr=''
        if CzyUprawnione:
            sql = "SELECT DISTINCT oddzial_id FROM rs_grupa_operator_oddzial"
            sql += " WHERE firma_id='"+self.firma_id+"' "
            sql+=" AND operator_id in "+str(self.operatorzy).replace("[","(").replace("]",")")+";"        
            stat,DOddz,dump,dump = self.PolSQL.Execute(sql,3)
            ListaOddz=[]
            if stat=='OK':
                for poz in DOddz:
                    ListaOddz.append(rsglobal.Dekoduj(poz[0]))
            
            if len(ListaOddz)==0:
                FiltrUpr=' AND FALSE '
            elif not '**' in ListaOddz:
                FiltrUpr=' AND oddzial_id IN '+str(ListaOddz).replace("[","(").replace("]",")")
            
        sql= "SELECT oddzial_id,opis FROM rs_oddzialy WHERE firma_id='"+self.firma_id+"'"
        sql+=" AND oddzial_id <> '**' "+FiltrUpr+" ORDER BY oddzial_id;"
    else:  
        sql= "SELECT DISTINCT o.oddzial_id,o.opis FROM rs_oddzialy o "
        sql+=" INNER JOIN rs_grupa_operator_oddzial go ON (o.firma_id=go.firma_id "
        sql+=" AND (o.oddzial_id=go.oddzial_id OR go.oddzial_id='**'))"
        sql+=" WHERE o.firma_id='"+self.firma_id+"' AND o.oddzial_id <> '**' "
        sql+=" AND go.operator_id in "+str(self.operatorzy).replace("[","(").replace("]",")")+" ORDER BY o.oddzial_id;"
        
    stat,dane,wyn1,dump = self.PolSQL.Execute(sql,3)
    if stat<>'OK':
        stat='BL_SELECT'
        dane.append(stat)