# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_operatorzy_przepisz_uprawnienia.py
# Purpose:     przepisuje uprawnienia od jednego operatora do drugiego
# Author:      Micha Raburski
# Created:     2007/08/09
# RCS-ID:      $Id: fs_operatorzy_przepisz_uprawnienia.py $
# Copyright:   (c) 2004-2007 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------
# 2013-05-17 Mariusz Rajfura (6879) przepisywanie uprawnien kadrowych
# 2017-12-20 Rafa Woniak (10536) refaktoryzacja rsoperatorzy i podokien

#RW pobieranie danych z kluczy
Oper=klucze["Wybrany"]
OperUpr=klucze["UprOper"]
stat="OK"
dane=[]


#--- deklaracja filtrw
WhereOper=" WHERE firma_id='"+self.firma_id+"' AND operator_id="+str(Oper)+";"
WhereOperUpr=" WHERE firma_id='"+self.firma_id+"' AND operator_id="+str(OperUpr)+";"  

#--- usunicie poprzednich uprawnie operatora
stat,dump,dump,dump = self.PolSQL.Execute("DELETE FROM rs_grupa_operator_oddzial "+WhereOper,1)
stat,dump,dump,dump = self.PolSQL.Execute("DELETE FROM rs_kasy_banki_upr "+WhereOper,1)
stat,dump,dump,dump = self.PolSQL.Execute("DELETE FROM rs_dokumenty_m_upr "+WhereOper,1)
stat,dump,dump,dump = self.PolSQL.Execute("DELETE FROM rs_magazyny_upr "+WhereOper,1)
stat,dump,dump,dump = self.PolSQL.Execute("DELETE FROM rs_wyznaczniki_upr "+WhereOper,1)
stat,dump,dump,dump = self.PolSQL.Execute("DELETE FROM rs_wzory_dekretacji_upr "+WhereOper,1)
stat,dump,dump,dump = self.PolSQL.Execute("DELETE FROM rs_kadry_upr "+WhereOper,1)
stat,dump,dump,dump = self.PolSQL.Execute("DELETE FROM rs_zamowienia_trasy_upr "+WhereOper,1)

#--- Wstawienie nowych uprawnie
Ins="INSERT INTO rs_grupa_operator_oddzial (firma_id,grupa_id,operator_id,oddzial_id) SELECT firma_id,grupa_id,"+str(Oper)+",oddzial_id FROM rs_grupa_operator_oddzial "+WhereOperUpr
stat,dump,dump,dump = self.PolSQL.Execute(Ins,1)

Ins="INSERT INTO rs_kasy_banki_upr (firma_id,okres_id,operator_id,kasa_bank_id,wprowadzanie,edycja,usuwanie,przegladanie,zamykanie,otwieranie)"
Ins+=" SELECT firma_id,okres_id,"+str(Oper)+",kasa_bank_id,wprowadzanie,edycja,usuwanie,przegladanie,zamykanie,otwieranie FROM rs_kasy_banki_upr "+WhereOperUpr
stat,dump,dump,dump = self.PolSQL.Execute(Ins,1)

Ins="INSERT INTO rs_magazyny_upr (firma_id,magazyn_id,operator_id,ilosc,dostawy,dokumenty,przeceny)"
Ins+=" SELECT firma_id,magazyn_id,"+str(Oper)+",ilosc,dostawy,dokumenty,przeceny FROM rs_magazyny_upr "+WhereOperUpr
rsglobal.ZapiszDoLogow('Mag '+Ins,1)
stat,dump,dump,dump = self.PolSQL.Execute(Ins,1)

Ins="INSERT INTO rs_dokumenty_m_upr (firma_id,magazyn_id,operator_id,dokument_id,wprowadzanie,edycja,usuwanie,przegladanie,wnag,zamykanie,otwieranie,gnaw,zmiana_ceny,wprowadzanie_poz,edycja_poz,usuwanie_poz)"
Ins+=" SELECT firma_id,magazyn_id,"+str(Oper)+",dokument_id,wprowadzanie,edycja,usuwanie,przegladanie,wnag,zamykanie,otwieranie,gnaw,zmiana_ceny,wprowadzanie_poz,edycja_poz,usuwanie_poz FROM rs_dokumenty_m_upr "+WhereOperUpr
stat,dump,dump,dump = self.PolSQL.Execute(Ins,1)

Ins="INSERT INTO rs_wyznaczniki_upr (firma_id,operator_id,wyznacznik_id,przegladanie,wprowadzanie,edycja,usuwanie,zamykanie,otwieranie)"
Ins+=" SELECT firma_id,"+str(Oper)+",wyznacznik_id,przegladanie,wprowadzanie,edycja,usuwanie,zamykanie,otwieranie FROM rs_wyznaczniki_upr "+WhereOperUpr
stat,dump,dump,dump = self.PolSQL.Execute(Ins,1)

Ins="INSERT INTO rs_wzory_dekretacji_upr (firma_id,operator_id,okres_id,dowod_id,nazwa_id,wprowadzanie,edycja,usuwanie,przegladanie,zamykanie,otwieranie)"
Ins+=" SELECT firma_id,"+str(Oper)+",okres_id,dowod_id,nazwa_id,wprowadzanie,edycja,usuwanie,przegladanie,zamykanie,otwieranie FROM rs_wzory_dekretacji_upr "+WhereOperUpr
stat,dump,dump,dump = self.PolSQL.Execute(Ins,1)

# uprawnienia do kadr
if stat == 'OK':
    stat, listapol = rsglobal.PolaTabeli(self.PolSQL, 'rs_kadry_upr', [])
    if stat == 'OK':
        pola = str(listapol).replace("[","").replace("]","").replace("'","").replace(" ","")
        Ins =" INSERT INTO rs_kadry_upr ("+pola+")"
        Ins+=" SELECT "
        for i in xrange(len(listapol)):
            if i > 0:
                Ins+=","
            if listapol[i] == 'operator_id':
                Ins+=str(Oper)
            else:
                Ins+=listapol[i]
        Ins+=" FROM rs_kadry_upr "+WhereOperUpr
        stat,dump,dump,dump = self.PolSQL.Execute(Ins,1)

Ins="INSERT INTO rs_zamowienia_trasy_upr (firma_id,operator_id,trasa_id,dodawanie,modyfikacja)"
Ins+=" SELECT firma_id,"+str(Oper)+",trasa_id,dodawanie,modyfikacja FROM rs_zamowienia_trasy_upr "+WhereOperUpr
stat,dump,dump,dump = self.PolSQL.Execute(Ins,1)
