# -*- coding: iso8859_2 -*-

#-------------------------------------------------------------------------------
# Name:        fs_operatorzy_uprawnienia_kadry.py
# Purpose:     uprawnienia do modulu kadr - grid
# Author:      Mariusz Rajfura
# Created:     2009/11/30
# RCS-ID:      $Id: fs_operatorzy_uprawnienia_kadry.py $
# Copyright:   (c) 2009 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

# 2018-02-09 Rafa Woniak (10536) refaktoryzacja rsoperatorzy i podokien

stat = 'OK'
if not 'Funkcja' in klucze:
    stat = 'Brak podanej funkcji w kluczach'

if stat == 'OK':
    Fun = klucze['Funkcja']
    if Fun in [5, 6]:
        Operator = str(klucze['Operator'])
    if Fun in [6]:
        Komorka = str(klucze['Komorka'])

dane = []

UprUsuwanie = (self.oddzial_id,'001354') in self.uprawnienia or self.operator_id == STANDARD_OPERATOR_ID

#-------------------------------------------------------------------------------
#--- DELETE - 6
#-------------------------------------------------------------------------------
if stat == "OK":
    if Fun == 6:
        if not UprUsuwanie:
            stat = 'Brak uprawnien do usuwania uprawnien dot.kadr'

        if stat == 'OK':
            sql ="SELECT komorka_id FROM rs_kadry_upr"
            sql+=" WHERE firma_id = '"+self.firma_id+"' AND operator_id = "+str(Operator)+""
            sql+=" AND komorka_id = '"+Komorka+"' FOR UPDATE NOWAIT;"
            stat,d,dump,dump = self.PolSQL.Execute(sql,3)
            if stat <> 'OK':
                stat = 'Bd pobrania informacji o uprawnieniu'
            elif len(d) <> 1:
                stat = 'Brak danych o podanym kluczu'

            if stat == 'OK':
                DELETE ="DELETE FROM rs_kadry_upr"
                DELETE+=" WHERE firma_id = '"+self.firma_id+"' AND operator_id = "+str(Operator)+""
                DELETE+=" AND komorka_id = '"+Komorka+"';"
                stat,dump,dump,dump = self.PolSQL.Execute(DELETE,1)
                if stat <> 'OK':
                    stat = 'Bd usuwania uprawnienia dot.kadr'

#-------------------------------------------------------------------------------
#--- POBRANIE DANYCH 
#-------------------------------------------------------------------------------

if stat == 'OK':
    if Fun in (5,6):
        SELECT ="SELECT ku.komorka_id,kz.opis FROM rs_kadry_upr ku"
        SELECT+=" INNER JOIN rs_komorki_zatrudniajace kz ON kz.firma_id = ku.firma_id AND kz.kod = ku.komorka_id"
        SELECT+=" WHERE ku.firma_id = '"+self.firma_id+"' AND ku.operator_id = "+str(Operator)+" ORDER BY ku.komorka_id;"

        stat,dane,wyn1,wyn2 = self.PolSQL.Execute(SELECT,3)
        if stat <> 'OK':
            stat = 'Bd pobrania uprawnie do kadr dla operatora'


