# -*- coding: iso8859_2 -*-
#-----------------------------------------------------------------------------
# Name:        fs_operatorzy_uprawnienia_kadry_dane.py
# Purpose:     dodaje/wczytuje/edytuje/zapisuje dane upr.do kadr dla operatora
# Author:      Mariusz Rajfura
# Created:     2009/11/30
# RCS-ID:      $Id: fs_operatorzy_uprawnienia_kadry_dane.py $
# Copyright:   (c) 2009 Record System
# Licence:     GNU GPL
#-----------------------------------------------------------------------------

Operator = klucze[0]
Komorka = rsglobal.Dekoduj(klucze[1]).strip()

Fun = klucze[-1]

stat = "OK"
dane = []
wyn2 = []

UprDodawanie = (self.oddzial_id,'001553') in self.uprawnienia or self.operator_id == STANDARD_OPERATOR_ID
UprEdycja = UprDodawanie or (self.oddzial_id,'001552') in self.uprawnienia


#-------------------------------------------------------------------------------
#--- sprawdzenie uprawnien
#-------------------------------------------------------------------------------

if Fun in (1,2):
    if not UprDodawanie:
        stat == 'UPR_INS'

if Fun in (3,4):
    if not UprEdycja:
        stat == 'UPR_UPD'


#-------------------------------------------------------------------------------
#--- sprawdzenie danych 
#-------------------------------------------------------------------------------

if Fun in (1,2,3,4) and stat == 'OK':

    if Fun in (1,2):
        if Komorka == '':
            dane.append('BR_KOMORKA')
        else:
            sql ="SELECT kod FROM rs_komorki_zatrudniajace"
            sql+=" WHERE firma_id = '"+self.firma_id+"' AND kod = '"+Komorka+"';"
            dump,d,dump,dump = self.PolSQL.Execute(sql,3)
            if stat <> 'OK':
                dane.append('Bd sprawdzenia kodu komrki zatrudniajcej : '+stat)
            else:
                if len(d) == 0:
                    dane.append('BL_KOMORKA')
                else:
                    sql = "SELECT komorka_id FROM rs_kadry_upr WHERE firma_id = '"+self.firma_id+"'"
                    sql+=" AND operator_id = "+str(Operator)+" AND komorka_id = '"+Komorka+"';"
                    dump,d,dump,dump = self.PolSQL.Execute(sql,3)
                    if stat <> 'OK':
                        dane.append('Bd sprawdzenia uprawnienia dla podanej komrki : '+stat)
                    elif len(d) <> 0:
                        dane.append('BL_KOMORKA_IST')

    for i in xrange(len(pola)):
        pole = pola[i]
        wart = wartosci[i]

        if pole == "komorka_id":
            continue

        elif pole in ('kartoteka_osobowa','zatrudnienie','zawieszenie_pracownika','zwolnienie_pracownika',
                      'umowy_o_prace','angaze','historia_zatrudnienia','dane_adresowe','rodzina','rachunki_ror',
                      'kwalifikacje','badania','kary','nagrody','jezyki_obce','szkoly','absencje','kalendarz_zdarzen'):
            wartosci[i] = str(wart)

    #jesli byly jakies bledy
    if len(dane) > 0:
        stat = dane[0]


#-------------------------------------------------------------------------------
#--- INSERT  1-z pobraniem   2-bez pobrania
#-------------------------------------------------------------------------------

if Fun in (1,2) and stat == 'OK':
    inspola = 'firma_id,operator_id,komorka_id'
    inswart = "'"+self.firma_id+"',"+str(Operator)+",'"+Komorka+"'"
    for i in xrange(len(pola)):
        pole = pola[i]
        wart = wartosci[i]
        if pole == 'komorka_id':
            continue

        inspola += ","+pole
        inswart += ","+str(wart)

    INSERT = "INSERT INTO rs_kadry_upr ("+inspola+") VALUES ("+inswart+");"
    stat,d,dump,dump = self.PolSQL.Execute(INSERT,1)
    if stat <> 'OK':
        stat = 'Bd dodawania nowego uprawnienia dot.kadr : '+str


#-------------------------------------------------------------------------------
#---   UPDATE DANYCH (4- bez pobierania,3- z pobieraniem)
#-------------------------------------------------------------------------------

if Fun in (3,4) and stat == 'OK':
    UPDATE = "UPDATE rs_kadry_upr SET "
    for i in xrange(len(pola)):
        pole = pola[i]
        wart = wartosci[i]
        if pole == 'komorka_id':
            continue

        UPDATE += pole+"="+str(wart)+","

    UPDATE = UPDATE[:-1]
    UPDATE+=" WHERE firma_id = '"+self.firma_id+"' AND operator_id = "+str(Operator)+" AND komorka_id = '"+Komorka+"';"

    stat,dump,dump,dump = self.PolSQL.Execute(UPDATE ,1)
    if stat <> 'OK':
        stat = 'Bd modyfikacji uprawnienia dot.kadr : '+stat


#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (5 -select, 3 -update z pobraniem, 1 -insert z pobraniem)
#-------------------------------------------------------------------------------

if Fun in (1,3,5) and stat=='OK':
    KomorkaOpis = ''

    SELECT ="SELECT * FROM rs_kadry_upr WHERE firma_id = '"+self.firma_id+"' AND operator_id = "+str(Operator)
    SELECT+=" AND komorka_id = '"+Komorka+"';"

    stat,dane,wyn1,dump = self.PolSQL.Execute(SELECT,3)
    if stat <> 'OK':
        stat = 'Bd pobrania danych dot.uprawnienia do kadr : '+stat
    else:
        #pobranie opisu komrki
        if (self.oddzial_id,'011710') in self.uprawnienia or self.operator_id == STANDARD_OPERATOR_ID:
            sql = "SELECT opis FROM rs_komorki_zatrudniajace WHERE firma_id = '"+self.firma_id+"' AND kod = '"+Komorka+"';"
            dump,d,dump,dump = self.PolSQL.Execute(sql,3)
            if len(d) == 0:
                KomorkaOpis = 'Brak komrki o podanym kodzie'
            else:
                KomorkaOpis = str(d[0][0])
        else:
            KomorkaOpis = 'Brak uprawnie do sownika. Poinformuj administratora.'

    wyn2 = [KomorkaOpis]