
# -*- coding: iso8859_2 -*-

#-----------------------------------------------------------------------------
# Name:        fs_operatorzy_uprawnienia_kasy_banki_dane.py
# Purpose:     wczytuje/edytuje/zapisuje dane uprawnien do kas/bankw dla operatora
#
# Author:      Micha Raburski
# Created:     2007/02/13
# RCS-ID:      $Id: fs_operatorzy_uprawnienia_kasy_banki_dane.py $
# Copyright:   (c) 2007 Record System
# Licence:     GNU GPL
#-----------------------------------------------------------------------------


#-------------------------------------------------------------------------------
#---   INSERT DANYCH (2- bez pobierania,1- z pobieraniem)
#-------------------------------------------------------------------------------

Oper=str(klucze[0])
stat = "OK"
dane = []
nkasabank=''

if (klucze[-1] in [1,2]) and (stat=='OK'):
    if (((self.oddzial_id,'001373') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID):
    #---   Sprawdzenie danych


        #pobranie klucza
        
        Okres=''
        KasaBank=''
        for i in range(len(pola)):
            pole = pola[i]
            wart = wartosci[i]

            if pole=='okres_id':
                Okres=wart
                
            if pole=='kasa_bank_id':
                KasaBank=wart
                

        #sprawdzenie poprawnosci okresu        
        if Okres=='':        
            stat='BR OKR'        
        else:
            dump,d,dump,dump = self.PolSQL.Execute("SELECT okres_id FROM rs_definicje_okresow WHERE firma_id='"+self.firma_id+"' AND okres_id='"+Okres+"';" ,3)

            if len(d) == 0:
                stat = "BL OKR"
                dane.append(stat)
            
        # utworzenie filtra
        if stat == 'OK':    
            Filtr="WHERE firma_id='"+self.firma_id+"' AND okres_id='"+Okres+"'"
            if KasaBank <> '':
                Filtr=Filtr+" AND kasa_bank_id='"+KasaBank+"'"

            #pobranie potencjalnych kas/bankw
            dump,d,dump,dump = self.PolSQL.Execute("SELECT kasa_bank_id FROM rs_kasy_banki "+Filtr+";" ,3)            
            if len(d) ==0:
                stat = "BR KB"
                dane.append(stat)
            else:
                #utworzenie listy wszytstkich moliwych kas/bankw
                LKB=[]
                for kb in d:
                    LKB.append(kb[0])
                
            
        if stat =='OK':
            #pobranie kas/bankow ju dodanych
            dump,d,dump,dump = self.PolSQL.Execute("SELECT kasa_bank_id FROM rs_kasy_banki_upr "+Filtr+" AND operator_id="+Oper+";" ,3)            
            if len(d) <>0:
                for kb in d:
                    if kb[0] in LKB:
                        LKB.remove(kb[0])
                
            #gdy nie ma nic do dodania
            if len(LKB)==0:
                stat = "BR NWKB"
                dane.append(stat)
        
        nkasabank= rsglobal.Dekoduj(LKB[0])
        
        if stat =='OK':    
            # przygotowanie listy pol
            LIns=''
            for kb in LKB:
                Ins="INSERT INTO rs_kasy_banki_upr (firma_id,operator_id,okres_id,kasa_bank_id,przegladanie,wprowadzanie,edycja,usuwanie,zamykanie,otwieranie) "
                rsglobal.ZapiszDoLogow(str(wartosci),1)
                Ins=Ins+"VALUES ('"+self.firma_id+"',"+Oper+",'"+Okres+"','"+rsglobal.Dekoduj(kb)+"',"+str(wartosci[2])+","+str(wartosci[3])+","+str(wartosci[4])+","+str(wartosci[5])+","+str(wartosci[6])+","+str(wartosci[7])+");"
                LIns=LIns+Ins
            
            stat,dump,dump,dump = self.PolSQL.Execute(LIns ,1)
               
    else:
        stat='UPR INS'

#-------------------------------------------------------------------------------
#---   UPDATE DANYCH (4- bez pobierania,3- z pobieraniem)
#-------------------------------------------------------------------------------

if (klucze[-1] in [3,4]) and (stat=='OK'):
    if (((self.oddzial_id,'001372') in self.uprawnienia) or ((self.oddzial_id,'001342') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID):
    #---   Sprawdzenie danych
        stat = "OK"
        dane = []

        if stat == 'OK':
            where = " WHERE firma_id='"+self.firma_id+"' AND operator_id="+Oper+" AND okres_id='"+klucze[1]+"' AND kasa_bank_id='"+klucze[2]+"';"
            upd = "UPDATE rs_kasy_banki_upr SET "
            rsglobal.ZapiszDoLogow(str(pola),1)
            rsglobal.ZapiszDoLogow(str(wartosci),1)
            for i in range(len(pola)):
                pole = pola[i]
                wart = wartosci[i]
            
                if pole in ['przegladanie','wprowadzanie','edycja','usuwanie','zamykanie','otwieranie']:
                    upd=upd+pole+"="+str(wart)+","

            upd = upd[0:len(upd)-1]+where
            
            stat,dump,dump,dump = self.PolSQL.Execute(upd ,1)
    else:
        stat='UPR UPD'

   
#-------------------------------------------------------------------------------
# Dodanie listy kas/bankw (11)
#-------------------------------------------------------------------------------

if klucze[-1] == 11 and stat == 'OK':
    if not ((self.oddzial_id,'001373') in self.uprawnienia or self.operator_id==STANDARD_OPERATOR_ID):
        stat='UPR INS'

    if stat =='OK':
        Oper = str(klucze[0])
        Okres = klucze[1]
        ListaKas = klucze[2]
        ListaChb = klucze[3]

        if len(ListaKas) == 0:
            stat = 'BL PUSTA LISTA'
            dane.append(stat)
            
    if stat == 'OK':
        #sprawdzenie poprawnosci okresu        
        if Okres=='':        
            stat='BR OKR'        
        else:
            SQL="SELECT okres_id FROM rs_definicje_okresow WHERE firma_id='"+self.firma_id+"' AND okres_id='"+Okres+"';"
            stat,d,dump,dump = self.PolSQL.Execute(SQL ,3)
            if stat <> 'OK':
                stat = 'Bd sprawdzania poprawnoci oddziau: '+stat
            elif len(d) == 0:
                stat = "BL OKR"
                dane.append(stat)
                
    if stat == 'OK':    
        dListaDok = []
    
        INSLIST = ''
        LJuzByly = []
        
        for Kasa in ListaKas:
            # sprawdzenie pojedynczej kasy, aby doda te, ktrych operator
            # jeszcze nie posiada
            
            Kasa = rsglobal.Dekoduj(Kasa)
            
            SQL ="SELECT kasa_bank_id FROM rs_kasy_banki_upr"
            SQL+=" WHERE firma_id='"+self.firma_id+"' AND okres_id='"+Okres+"'"
            SQL+=" AND operator_id="+Oper+" AND kasa_bank_id='"+str(Kasa)+"'"

            stat,dKasa,dump,dump = self.PolSQL.Execute(SQL,3)
            if stat <> 'OK':
                stat = 'Bd sprawdzenia kasy/banku dla operatora: '+stat
                dane.append(stat)
                break
            
            elif len(dKasa) == 0:
                INSLIST+="INSERT INTO rs_kasy_banki_upr"
                INSLIST+=" (firma_id,operator_id,okres_id,kasa_bank_id,"
                INSLIST+="  przegladanie,wprowadzanie,"
                INSLIST+="  edycja,usuwanie,"
                INSLIST+="  zamykanie,otwieranie)"
                INSLIST+=" VALUES"
                INSLIST+=" ('"+self.firma_id+"',"+Oper+",'"+Okres+"','"+Kasa+"',"
                INSLIST+="  "+str(ListaChb[0])+","+str(ListaChb[1])+","
                INSLIST+="  "+str(ListaChb[2])+","+str(ListaChb[3])+","
                INSLIST+="  "+str(ListaChb[4])+","+str(ListaChb[5])+");"
            else:
                LJuzByly.append(Kasa)
        
    if stat == 'OK':
        wyn2.append(LJuzByly)
        # moze tak byc, ze wybrane do dodania magazyny juz sa przydzielone
        # do operatora, wiec nie ma nic do dodania
        if INSLIST <> '':
            stat,dump,dump,dump = self.PolSQL.Execute(INSLIST,1)
            if stat <> 'OK':
                stat = 'Bd dodawania listy kas: '+stat
                dane.append(stat)
                

#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (5 -select, 3 -update z pobraniem, 1 -insert z pobraniem)
#-------------------------------------------------------------------------------

if (klucze[-1] in [1,3,5]) and (stat=='OK'):
    if (((self.oddzial_id,'001370') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID):
        # pobranie danych uprawnien
        if klucze[1]<> '' and klucze[2]<> '':
            stat,dane,wyn1,tr = self.PolSQL.Execute("SELECT * FROM rs_kasy_banki_upr WHERE firma_id='"+self.firma_id+"' AND operator_id="+Oper
                +" AND okres_id='"+klucze[1]+"' AND kasa_bank_id='"+klucze[2]+"';",3)
        elif nkasabank<>'':
            stat,dane,wyn1,tr = self.PolSQL.Execute("SELECT * FROM rs_kasy_banki_upr WHERE firma_id='"+self.firma_id+"' AND operator_id="+Oper
                +" AND okres_id='"+klucze[1]+"' AND kasa_bank_id='"+nkasabank+"';",3)
        else:
            stat,dane,wyn1,tr = self.PolSQL.Execute("SELECT * FROM rs_kasy_banki_upr WHERE firma_id='"+self.firma_id+"' AND operator_id="+Oper
                +" AND okres_id='"+klucze[1]+"' LIMIT 1;",3)

        #pobranie danych do opisow

        if len(dane) == 1:
            tr = rssql.RSTableRowset(dane,wyn1)

            #--- okres
            #if ((self.oddzial_id,'014020') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
            #    dump,d,dump,dump = self.PolSQL.Execute("SELECT nazwa_dokumentu FROM rs_typy_dokumentow_m WHERE firma_id='"+self.firma_id+"' AND dokument_id='"+tr.GetVal(0,"dokument_id")+"';" ,3)
            #    if len(d) == 0:
            #        wyn2.append('')
            #    else:
            #        wyn2.append(d[0][0])
            #else:
            #    wyn2.append('Brak uprawnie do sownika. Poinformuj administratora.')
    else:
        stat='UPR SEL'