# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_dokument_magazynowy_podaj.py
# Purpose:     wczytuje/edytuje/zapisuje dane uprawnien do magazynw operatora
#
# Author:      Micha Raburski
# Created:     2005/11/08
# RCS-ID:      $Id: fs_operatorzy_uprawnienia_magazyny_dane.py $
# Copyright:   (c) 2005 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

# 2011-10-05 Mariusz Rajfura  dodawanie listy magazynow (5068)

#ustawianie na nie zmienianie uprawnien do magazynu 0 - bez zmian, 1 -zmiana na peny, 2 -zmiana na pusty
CzyDokumenty=0

Operator = klucze[0]
Magazyn = rsglobal.Dekoduj(klucze[1])
ListaMagazynow = klucze[2]
ListaCheckboxow = klucze[3]
Fun = klucze[-1]

stat = 'OK'
dane = []
wyn1 = []
wyn2 = []


#-------------------------------------------------------------------------------
#---   INSERT DANYCH (2- bez pobierania,1- z pobieraniem)
#-------------------------------------------------------------------------------

if Fun in (1,2):
    if (((self.oddzial_id,'001343') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID):
    #---   Sprawdzenie danych
        for i in range(len(pola)):
            pole = pola[i]
            wart = wartosci[i]
            if pole=='dokumenty':
                if wart:
                    CzyDokumenty=1

            if pole=='magazyn_id':
                if wart == '':
                    stat = "BR MAG"
                    dane.append(stat)
                else:
                    dump,d,dump,dump = self.PolSQL.Execute("SELECT magazyn_id FROM rs_magazyny WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+wart+"';" ,3)
                    if len(d) == 0:
                        stat = "BL MAG"
                        dane.append(stat)
                    else:
                        dump,d,dump,dump = self.PolSQL.Execute("SELECT magazyn_id FROM rs_magazyny_upr WHERE firma_id='"+self.firma_id+"' AND operator_id="+klucze[0]+" AND magazyn_id='"+wart+"';" ,3)
                        if len(d) > 0:
                            stat = "UZ MAG"
                            dane.append(stat)
               
        if stat == 'OK':
            ins = "INSERT INTO rs_magazyny_upr (firma_id,operator_id,magazyn_id,ilosc,dostawy,dokumenty,przeceny) VALUES ('"+self.firma_id+"',"+str(klucze[0])+",'"+wartosci[0]+"','"+str(wartosci[1])+"','"+str(wartosci[2])+"','"+str(wartosci[3])+"','"+str(wartosci[4])+"');"
        
            stat,dump,dump,dump = self.PolSQL.Execute(ins ,1)
               
    else:
        stat='UPR INS'


#-------------------------------------------------------------------------------
#---   UPDATE DANYCH (4- bez pobierania,3- z pobieraniem)
#-------------------------------------------------------------------------------

if Fun in (3,4):
    if (((self.oddzial_id,'001343') in self.uprawnienia) or ((self.oddzial_id,'001342') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID):
    #---   Sprawdzenie danych
        for i in range(len(pola)):
            pole = pola[i]
            wart = wartosci[i]
            if pole=='dokumenty':
                if wart:
                    CzyDokumenty=1
                else:
                    CzyDokumenty=2
                        
        if stat == 'OK':
            where = " WHERE firma_id='"+self.firma_id+"' AND operator_id="+str(klucze[0])+" AND magazyn_id='"+klucze[1]+"';"
            upd = "UPDATE rs_magazyny_upr SET "
        
            for i in range(len(pola)):
                pole = pola[i]
                wart = wartosci[i]
            
                if pole in ['ilosc','dostawy','dokumenty','przeceny']:
                    upd=upd+pole+"="+str(wart)+","

            upd = upd[0:len(upd)-1]+where
            
            stat,dump,dump,dump = self.PolSQL.Execute(upd ,1)
    else:
        stat='UPR UPD'

if Fun in (1,2,3,4) and stat=='OK':
    #Zmiana uprawnien szczegolowych do magazynu (1 - True, 2 - False)
    if CzyDokumenty==1:
        s,d,w,tr = self.PolSQL.Execute("SELECT dokument_id FROM rs_typy_dokumentow_m WHERE firma_id='"+self.firma_id+"';",3)
        if len(d) >0:
            tr = rssql.RSTableRowset(d,w)
            for i in range(len(d)):
                self.PolSQL.Execute("INSERT INTO rs_dokumenty_m_upr (firma_id,magazyn_id,dokument_id,operator_id) VALUES ('"+self.firma_id+"','"+klucze[1]
                    +"','"+tr.GetVal(i,"dokument_id")+"','"+str(klucze[0])+"');",1)
                
    elif CzyDokumenty==2:
        self.PolSQL.Execute("DELETE FROM rs_dokumenty_m_upr WHERE operator_id="+str(klucze[0])
            +" AND magazyn_id='"+klucze[1] +"' AND firma_id='"+self.firma_id+"';",1)


#-------------------------------------------------------------------------------
# Dodanie listy wyznacznikow (11)
#-------------------------------------------------------------------------------

if Fun == 11 and stat == 'OK':
    if not ((self.oddzial_id,'001343') in self.uprawnienia or self.operator_id==STANDARD_OPERATOR_ID):
        stat='UPR INS'

    if len(ListaMagazynow) == 0:
        stat = 'BL PUSTA LISTA'
        dane.append(stat)
        
    dListaDok = []
    # jesli wybrano opcje dokumentow, pobieramy liste dostepnych dokumentow
    if stat=='OK' and ListaCheckboxow[2]:
        sql = "SELECT dokument_id FROM rs_typy_dokumentow_m WHERE firma_id='"+self.firma_id+"';"
        stat,dListaDok,dump,dump = self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Bd pobrania listy dokumentw: '+stat
            dane.append(stat)

    if stat == 'OK':
        INSLIST = ''
        LJuzByly = []
        
        for NowyMag in ListaMagazynow:
            # sprawdzenie pojedynczego magazynu, aby dodac te, ktrych operator
            # jeszcze nie posiada
            
            NowyMag = rsglobal.Dekoduj(NowyMag)
            
            sql ="SELECT magazyn_id FROM rs_magazyny_upr"
            sql+=" WHERE firma_id='"+self.firma_id+"' AND operator_id="+str(Operator)
            sql+=" AND magazyn_id='"+NowyMag+"';"

            stat,dMag,dump,dump = self.PolSQL.Execute(sql,3)
            if stat <> 'OK':
                stat = 'Bd sprawdzenia magazynu dla operatora: '+stat
                dane.append(stat)
                break
            elif len(dMag) == 0:
                INSLIST+="INSERT INTO rs_magazyny_upr"
                INSLIST+=" (firma_id,operator_id,magazyn_id,"
                INSLIST+="  ilosc,dostawy,"
                INSLIST+="  dokumenty,przeceny)"
                INSLIST+=" VALUES"
                INSLIST+=" ('"+self.firma_id+"',"+str(Operator)+",'"+NowyMag+"',"
                INSLIST+="  "+str(ListaCheckboxow[0])+","+str(ListaCheckboxow[1])+","
                INSLIST+="  "+str(ListaCheckboxow[2])+","+str(ListaCheckboxow[3])+");"
                
                if len(dListaDok) > 0:
                    # dodanie uprawnien do dokumentow w dodanym magazynie
                    for j in xrange(len(dListaDok)):
                        Dok = rsglobal.Dekoduj(dListaDok[j][0])
                        INSLIST+="INSERT INTO rs_dokumenty_m_upr"
                        INSLIST+=" (firma_id,magazyn_id,dokument_id,operator_id)"
                        INSLIST+=" VALUES"
                        INSLIST+=" ('"+self.firma_id+"','"+NowyMag+"','"+Dok+"',"+str(Operator)+");"
                
            else:
                LJuzByly.append(NowyMag)
        
    if stat == 'OK':
        wyn2.append(LJuzByly)
        # moze tak byc, ze wybrane do dodania magazyny juz sa przydzielone
        # do operatora, wiec nie ma nic do dodania
        if INSLIST <> '':
            stat,dump,dump,dump = self.PolSQL.Execute(INSLIST,1)
            if stat <> 'OK':
                stat = 'Bd dodawania listy magazynw: '+stat
                dane.append(stat)


#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (5 -select, 3 -update z pobraniem, 1 -insert z pobraniem)
#-------------------------------------------------------------------------------

if Fun in (5,3,1) and stat=='OK':
    # pobranie danych magazynowych
    stat,dane,wyn1,tr = self.PolSQL.Execute("SELECT * FROM rs_magazyny_upr WHERE operator_id="+klucze[0]
        +" AND magazyn_id='"+klucze[1]+"' AND firma_id='"+self.firma_id+"';",3)

    #pobranie danych do opisow

    if len(dane) == 1:
        tr = rssql.RSTableRowset(dane,wyn1)

        #--- magazyn
        if ((self.oddzial_id,'031010') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
            dump,d,dump,dump = self.PolSQL.Execute("SELECT opis FROM rs_magazyny WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+tr.GetVal(0,"magazyn_id")+"';" ,3)
            if len(d) == 0:
                wyn2.append('')
            else:
                wyn2.append(d[0][0])
        else:
            wyn2.append('Brak uprawnie do sownika. Poinformuj administratora.')
