# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_operatorzy_uprawnienia_trasy_zamowien.py
# Purpose:     obsluga grida edytowalnego uprawnie do tras zamwie
# Author:      Micha Raburski
# Created:     2016/06/16
# RCS-ID:      $Id: fs_operatorzy_uprawnienia_trasy_zamowien.py$
# Copyright:   (c) 2016 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

stat='OK'

if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=='OK':
    Funkcja = klucze['Funkcja']
    
    SlPar={'Operator':[1,5],'Trasa':[8]}
    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Funkcja,klucze)
    if Lista<>'':
        stat='Uwaga : wywoanie funkcji fs_operatorzy_uprawnienia_trasy_zamowien z numerem '+str(Funkcja)+' bez parametrw: '+Lista
        
    if Funkcja in [1,5]: 
        Operator=rsglobal.Dekoduj(klucze['Operator'])
    if Funkcja == 8:
        Trasa=rsglobal.Dekoduj(klucze['Trasa'])
        
dane = []
wyn1 = []
wyn2 = []

Puste = (None,'')

UprIns=((self.oddzial_id,'991333') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID
UprUpd=((self.oddzial_id,'991332') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID or UprIns
UprDel=((self.oddzial_id,'991334') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID

Insert = []
Update = []
Delete = []

#-------------------------------------------------------------------------------
#--- POBRANIE OPISU TRASY
#-------------------------------------------------------------------------------

if stat=='OK' and Funkcja == 8:
    SQL = "SELECT opis FROM rs_trasy WHERE firma_id='"+self.firma_id+"' AND kod = '"+Trasa+"'"
    stat,dane,dump,dump = self.PolSQL.Execute(SQL,3)

#-------------------------------------------------------------------------------

if stat=='OK' and Funkcja == 1:
    Update=klucze['Update']
    Insert=klucze['Insert']
    Delete=klucze['Delete']


#-------------------------------------------------------------------------------
#-------  SPRAWDZANIE DELETE  --------------------------------------------------
#-------------------------------------------------------------------------------

if Funkcja == 1 and stat=="OK":
    if len(Delete[0])>0:
        if not UprDel:
            stat='BR UPR DEL'
            dane.append(stat)
        
        # wykonanie DELETE 
        if stat == 'OK':
            SQLDEL = ''
            SQLFU = ''
            for i in xrange(len(Delete[0])):
                DELETE = "DELETE FROM rs_zamowienia_trasy_upr "
                WHERE = "WHERE firma_id='"+self.firma_id+"' AND operator_id='"+str(Operator)+"' "
                SQLFU = "SELECT firma_id FROM rs_zamowienia_trasy_upr"
                SQLFU+= " WHERE firma_id='"+self.firma_id+"' AND operator_id='"+str(Operator)+"' "
                for j in xrange(len(Delete[0][i])):
                    pole = Delete[1][j]
                    wart = Delete[0][i][j]
                    if pole in ['trasa_id',]:
                        WHERE += " AND "+pole+"='"+wart+"'"
                        SQLFU += " AND "+pole+"='"+wart+"'"

                SQLDEL += DELETE+WHERE+"; "
                SQLFU += " FOR UPDATE NOWAIT; "

            if SQLFU <> '':
                stat,d,dump,dump = self.PolSQL.Execute(rsglobal.Dekoduj(SQLFU),3)
                if stat <> 'OK':
                    stat = 'Bd sprawdzenia danych do usunicia: '+stat
                    dane.append(stat)
            
            if stat == 'OK' and SQLDEL <> '':
                stat,dump,dump,dump = self.PolSQL.Execute(rsglobal.Dekoduj(SQLDEL),1)
                if stat <> 'OK':
                    stat = "Bd przy usuwaniu danych: "+stat   
                    dane.append(stat)

                                 
#-------------------------------------------------------------------------------
#---   UPDATE DANYCH (1)
#-------------------------------------------------------------------------------

if Funkcja == 1 and stat=="OK":
    if len(Update[0])>0:
        if not UprUpd:
            stat='BR UPR UPD'
            dane.append(stat)

        if stat == 'OK':
            SQLFU = ''
            for i in xrange(len(Update[0])):
                SQLFU+= "SELECT operator_id FROM rs_zamowienia_trasy_upr"
                SQLFU+= " WHERE firma_id='"+self.firma_id+"' AND operator_id='"+str(Operator)+"' "
                for j in xrange(len(Update[2][i])): # petla po kluczu
                    pole = Update[3][j]
                    wart = rsglobal.Dekoduj(Update[2][i][j])
                    SQLFU += " AND "+pole+"='"+str(wart)+"'"
                SQLFU += " FOR UPDATE NOWAIT; "
            
            if SQLFU <> '':
                stat,dFU,nFU,dump = self.PolSQL.Execute(rsglobal.Dekoduj(SQLFU),3)
                if stat <> 'OK':
                    stat = 'Bd sprawdzenia danych do modyfikacji: '+stat
                    dane.append(stat)

        if stat == 'OK':
            WierszeNr = Update[-1]
            for i in xrange(len(Update[0])):
                for j in xrange(len(Update[0][i])): 
                    pole = Update[0][i][j]
                    wart = Update[1][i][j]

                    if pole == 'trasa_id':
                        wart = wart.strip()
                        if wart == '':
                            wyn2.append((WierszeNr[i],0))
                            dane.append('TRASA BR')
                        else:
                            sql ="SELECT kod FROM rs_trasy "
                            sql+=" WHERE kod = '"+str(wart)+"' ;" 
                            stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                            if stat <> 'OK':
                                wyn2.append((WierszeNr[i],0))
                                dane.append(stat)
                            elif len(d) == 0:
                                wyn2.append((WierszeNr[i],0))
                                dane.append('TRASA BL')

                if stat == 'OK':
                    if len(dane) > 0:
                        stat = dane[0]
                
                # wykonanie UPDATE
                if stat=='OK':
                    sql=''
                    UPDATE="UPDATE rs_zamowienia_trasy_upr "
                    SET='SET '
                    for j in xrange(len(Update[0][i])): 
                        pole=Update[0][i][j]
                        wart=Update[1][i][j]
    
                        if pole in ['trasa_id',]:
                            SET+=pole+"='"+wart+"',"
    
                        elif pole in ['dodawanie','modyfikacja']:
                            SET+=pole+"="
                            if wart:
                                SET+="TRUE,"
                            else:
                                SET+="FALSE,"
                        
                    SET=SET.strip(",")
                    WHERE=" WHERE firma_id='"+self.firma_id+"' AND operator_id='"+str(Operator)+"' " 
                    for j in xrange(len(Update[2][i])): # petla po kluczu
                        pole=Update[3][j]
                        wart=rsglobal.Dekoduj(Update[2][i][j])
                        if pole in ['trasa_id',]:
                            WHERE+=" AND "+pole+"='"+wart+"'"
                        
                    WHERE+=";"
                        
                    sql+=UPDATE+SET+WHERE
                        
                    stat,dump,dump,dump = self.PolSQL.Execute(rsglobal.Dekoduj(sql),1)
                    if stat<>'OK':
                        stat="Istnieje ju wpis o podanym kluczu: "+stat   
                        dane.append(stat)
                    

#-------------------------------------------------------------------------------
#---------Sprawdzanie danych do Insert
#-------------------------------------------------------------------------------

if Funkcja == 1 and stat=="OK":
    if len(Insert[0])>0:
        if not UprIns:
            stat='BR UPR INS'
            dane.append(stat)

        if stat == 'OK':
            WierszeNr = Insert[-1]
            for i in xrange(len(Insert[0])):
                for j in xrange(len(Insert[0][i])): 
                    pole=Insert[1][j]
                    wart=Insert[0][i][j]
                    
                    if pole == 'trasa_id':
                        wart = wart.strip()
                        if wart == '':
                            wyn2.append((WierszeNr[i],0))
                            dane.append('TRASA BR')
                        else:
                            sql ="SELECT kod FROM rs_trasy "
                            sql+=" WHERE kod = '"+str(wart)+"' ;" 
                            stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                            if stat <> 'OK':
                                wyn2.append((WierszeNr[i],0))
                                dane.append(stat)
                            elif len(d) == 0:
                                wyn2.append((WierszeNr[i],0))
                                dane.append('TRASA BL')

                # sprawdzenie, czy nie ma bledow
                if stat == 'OK':
                    if len(dane) > 0:
                        stat = dane[0]
        
                # wykonanie INSERT do pojedynczego wiersza
                if stat == 'OK':    
                    sqlIns=''
                    INSERT="INSERT INTO rs_zamowienia_trasy_upr "
                    KOLUMNY="(firma_id, operator_id"
                    VALUES=" VALUES ('"+self.firma_id+"','"+str(Operator)+"' "

                    for j in xrange(len(Insert[0][i])): 
                        pole=Insert[1][j]
                        wart=Insert[0][i][j]

                        if pole in ['trasa_id',]:
                            KOLUMNY+=","+pole
                            VALUES+=",'"+wart+"'"
                        
                        elif pole in ['dodawanie','modyfikacja']:
                            KOLUMNY+=","+pole
                            VALUES+=",'"+str(wart)+"'"
    
                    KOLUMNY+=")"
                    VALUES+=");"
                    sqlIns+=INSERT+KOLUMNY+VALUES
                    
                if stat == 'OK' and sqlIns<>'': 
                    stat,dump,dump,dump=self.PolSQL.Execute(rsglobal.Dekoduj(sqlIns),1)
                    if stat<>'OK':
                        stat="Bd przy dodawaniu danych: "+stat   
                        dane.append(stat)

#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (1- insert 1 -select, 1 -delete), (5-odczyt)
#-------------------------------------------------------------------------------

if Funkcja in (1,5) and stat == 'OK':
    SQL ="SELECT ztu.trasa_id,t.opis,ztu.dodawanie, ztu.modyfikacja"
    SQL+=" FROM rs_zamowienia_trasy_upr ztu "
    SQL+="INNER JOIN rs_trasy t "
    SQL+="ON (ztu.firma_id=t.firma_id AND ztu.trasa_id = t.kod)"
    SQL+=" WHERE ztu.firma_id='"+self.firma_id+"' and ztu.operator_id = '"+str(Operator)+"'"
    SQL+=" ORDER BY ztu.trasa_id;"
    stat,dane,wyn1,wyn2 = self.PolSQL.Execute(SQL,3)
    if stat <> 'OK':
        stat = "Bd przy pobieraniu danych: "+stat
        dane.append(stat)