
# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_operatorzy_uprawnienia_typy_plikow_zam_odb.py
# Purpose:     obsluga grida edytowalnego z uprawnieniami do typw plikw zamwie odbiorcw
# Author:      Micha Raburski
# Created:     2014/02/27
# RCS-ID:      $Id: fs_operatorzy_uprawnienia_typy_plikow_zam_odb
# Copyright:   (c) 2014 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

stat='OK'

if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=='OK':
    Funkcja = klucze['Funkcja']
    
    SlPar={'Operator':[1,5]}
    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Funkcja,klucze)
    if Lista<>'':
        stat='Uwaga : wywoanie funkcji fs_operatorzy_uprawnienia_typy_plikow_zam_odb z numerem '+str(Funkcja)+' bez parametrw: '+Lista
    
if stat == 'OK':
    if Funkcja in [1,5]:
        Operator = str(klucze["Operator"])
        
dane = []
wyn1 = []
wyn2 = []

UprIns=((self.oddzial_id,'991313') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID
UprUpd=((self.oddzial_id,'991312') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID or UprIns
UprDel=((self.oddzial_id,'991314') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID


#-------------------------------------------------------------------------------
#-------- EDYCJA GRIDA EDYTOWALNEGO (1)
#-------------------------------------------------------------------------------

Insert = []
Update = []
Delete = []

if Funkcja == 1:
    Update=klucze['Update']
    Insert=klucze['Insert']
    Delete=klucze['Delete']


#-------------------------------------------------------------------------------
#-------  SPRAWDZANIE DELETE  --------------------------------------------------
#-------------------------------------------------------------------------------

if Funkcja == 1 and stat=="OK":
    if len(Delete[0])>0:
        if not UprDel:
            stat='BR UPR DEL'
            dane.append(stat)
        
        # wykonanie DELETE 
        if stat == 'OK':
            SQLDEL = ''
            SQLFU = ''
            for i in xrange(len(Delete[0])):
                SQLFU = "SELECT typ_pliku FROM rs_typy_plikow_zamowien_odb_upr WHERE firma_id='"+self.firma_id+"' AND operator_id="+Operator
                DELETE = "DELETE FROM rs_typy_plikow_zamowien_odb_upr "
                WHERE = "WHERE firma_id='"+self.firma_id+"' AND operator_id="+Operator
                for j in xrange(len(Delete[0][i])):
                    pole = Delete[1][j]
                    wart = Delete[0][i][j]
                    if pole in ['typ_pliku']:
                        WHERE += " AND "+pole+"='"+wart+"'"
                        SQLFU += " AND "+pole+"='"+wart+"'"
                
                SQLDEL += DELETE+WHERE+"; "
                SQLFU += " FOR UPDATE NOWAIT; "

            if SQLFU <> '':
                stat,d,dump,dump = self.PolSQL.Execute(rsglobal.Dekoduj(SQLFU),3)
                if stat <> 'OK':
                    stat = 'Bd sprawdzenia danych do usunicia: '+stat
                    dane.append(stat)

            if stat == "OK" and SQLDEL <> '':
                stat,dump,dump,dump = self.PolSQL.Execute(rsglobal.Dekoduj(SQLDEL),1)
                if stat <> 'OK':
                    stat = "Bd przy usuwaniu danych: "+stat   
                    dane.append(stat)


#-------------------------------------------------------------------------------
#---   UPDATE DANYCH (1)
#-------------------------------------------------------------------------------

if Funkcja == 1 and stat=="OK":
    if len(Update[0])>0:
        if not UprUpd:
            stat='BR UPR UPD'
            dane.append(stat)

        if stat == 'OK':
            SQLFU = ''
            for i in xrange(len(Update[0])):
                SQLFU = "SELECT typ_pliku FROM rs_typy_plikow_zamowien_odb_upr WHERE firma_id='"+self.firma_id+"' AND operator_id="+Operator
                for j in xrange(len(Update[2][i])): # petla po kluczu
                    pole = Update[3][j]
                    wart = rsglobal.Dekoduj(Update[2][i][j])
                    if pole == 'typ_pliku':
                        SQLFU += " AND "+pole+"='"+wart+"'"
                
                SQLFU += " FOR UPDATE NOWAIT; "
            
                if SQLFU <> '':
                    stat,d,dump,dump = self.PolSQL.Execute(rsglobal.Dekoduj(SQLFU),3)
                    if stat <> 'OK':
                        stat = 'Bd sprawdzenia danych do modyfikacji: '+stat
                        dane.append(stat)
            
        if stat == 'OK':
            WierszeNr = Update[-1]

            for i in xrange(len(Update[0])):
                for j in xrange(len(Update[0][i])): 
                    pole = Update[0][i][j]
                    wart = Update[1][i][j]

                    if pole == 'typ_pliku':
                        wart = wart.strip()
                        if wart == '':
                            wyn2.append((WierszeNr[i],0))
                            dane.append('BR TYP')
                        if stat=='OK':
                            sql ="SELECT kod FROM rs_typy_plikow_zamowien_odb"
                            sql+=" WHERE firma_id='"+self.firma_id+"'"
                            sql+=" AND kod='"+wart+"';"
                            stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                            if stat <> 'OK':
                                stat = 'Bdy sprawdzania wystpowania typu w sowniku :'+stat
                                wyn2.append((WierszeNr[i],0))
                                dane.append(stat)
                            elif len(d) == 0:
                                wyn2.append((WierszeNr[i],0))
                                dane.append('BL TYP')
                        if stat=='OK':
                            sql ="SELECT typ_pliku FROM rs_typy_plikow_zamowien_odb_upr"
                            sql+=" WHERE firma_id='"+self.firma_id+"' AND operator_id="+Operator
                            sql+=" AND typ_pliku='"+wart+"';"
                            stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                            if stat <> 'OK':
                                stat = 'Bdy sprawdzania wystpowania typu w tabeli :'+stat
                                wyn2.append((WierszeNr[i],0))
                                dane.append(stat)
                            elif len(d) > 0:
                                stat = 'BL TYP IST'
                                wyn2.append((WierszeNr[i],0))
                                dane.append(stat)

        if stat == 'OK':
            if len(dane) > 0:
                stat = dane[0]
                
        # wykonanie UPDATE
        if stat=='OK':
            sql=''
            for i in xrange(len(Update[0])):
                UPDATE="UPDATE rs_typy_plikow_zamowien_odb_upr "
                SET='SET '
                for j in xrange(len(Update[0][i])): 
                    pole=Update[0][i][j]
                    wart=Update[1][i][j]
                    if pole in ['typ_pliku']:
                        SET+=pole+"='"+wart+"',"
                    elif pole in ['modyfikowac_w_zamknietym_zamowieniu']:
                        if wart:
                            SET+=pole+"=TRUE,"
                        else:
                            SET+=pole+"=FALSE,"

                SET=SET.strip(",")
                WHERE=" WHERE firma_id='"+self.firma_id+"' AND operator_id="+Operator 
                for j in xrange(len(Update[2][i])): # petla po kluczu
                    pole=Update[3][j]
                    wart=rsglobal.Dekoduj(Update[2][i][j])
                    if pole in ['typ_pliku']:
                        WHERE+= " AND "+pole+"='"+wart+"'"

                WHERE+=";"
                
                sql+=UPDATE+SET+WHERE;
                
            if sql<>'':
                stat,dump,dump,dump=self.PolSQL.Execute(rsglobal.Dekoduj(sql),1)
                if stat<>'OK':
                    stat="Bd przy modyfikowaniu danych: "+stat   
                    dane.append(stat)  


#-------------------------------------------------------------------------------
#---------Sprawdzanie danych do Insert------
#-------------------------------------------------------------------------------

if Funkcja == 1 and stat=="OK":
    if len(Insert[0])>0:
        if not UprIns:
            stat='BR UPR INS'
            dane.append(stat)

        if stat == 'OK':
            WierszeNr = Insert[-1]
            for i in xrange(len(Insert[0])):
                for j in xrange(len(Insert[0][i])): 
                    pole=Insert[1][j]
                    wart=Insert[0][i][j]
                    
                    if pole == 'typ_pliku':
                        wart = wart.strip()
                        if wart == '':
                            wyn2.append((WierszeNr[i],0))
                            dane.append('BR TYP')
                        if stat=='OK':
                            sql ="SELECT kod FROM rs_typy_plikow_zamowien_odb"
                            sql+=" WHERE firma_id='"+self.firma_id+"'"
                            sql+=" AND kod='"+wart+"';"
                            stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                            if stat <> 'OK':
                                stat = 'Bdy sprawdzania wystpowania typu w sowniku :'+stat
                                wyn2.append((WierszeNr[i],0))
                                dane.append(stat)
                            elif len(d) == 0:
                                wyn2.append((WierszeNr[i],0))
                                dane.append('BL TYP')
                        if stat=='OK':
                            sql ="SELECT typ_pliku FROM rs_typy_plikow_zamowien_odb_upr"
                            sql+=" WHERE firma_id='"+self.firma_id+"' AND operator_id="+Operator
                            sql+=" AND typ_pliku='"+wart+"';"
                            stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                            if stat <> 'OK':
                                stat = 'Bdy sprawdzania wystpowania typu w tabeli :'+stat
                                wyn2.append((WierszeNr[i],0))
                                dane.append(stat)
                            elif len(d) > 0:
                                stat = 'BL TYP IST'
                                wyn2.append((WierszeNr[i],0))
                                dane.append(stat)

        if stat == 'OK':
            if len(dane) > 0:
                stat = dane[0]

        # wykonanie INSERT
        if stat == 'OK':
            sqlIns=''
            for i in xrange(len(Insert[0])):
                INSERT="INSERT INTO rs_typy_plikow_zamowien_odb_upr "
                KOLUMNY="(firma_id,operator_id"
                VALUES=" VALUES ('"+self.firma_id+"',"+Operator
                for j in xrange(len(Insert[0][i])):
                    pole=Insert[1][j]
                    wart=Insert[0][i][j]
                    
                    if pole in ['typ_pliku']:
                        KOLUMNY+=","+pole
                        VALUES+=",'"+wart+"'"
                    elif pole in ['modyfikowac_w_zamknietym_zamowieniu']:
                        KOLUMNY+=","+pole
                        if wart:
                            VALUES+=",TRUE"
                        else:
                            VALUES+=",FALSE"

                KOLUMNY+=")"
                VALUES+=");"
                sqlIns+=INSERT+KOLUMNY+VALUES
            if sqlIns<>'': 
                stat,dump,dump,dump=self.PolSQL.Execute(rsglobal.Dekoduj(sqlIns),1)
                if stat<>'OK':
                    stat="Bd przy dodawaniu danych: "+stat
                    dane.append(stat)


#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (1- insert 1 -select, 1 -delete, 5 - select)
#-------------------------------------------------------------------------------

if Funkcja in (1,5) and stat=='OK':
    SQL ="SELECT tu.typ_pliku,t.opis,tu.modyfikowac_w_zamknietym_zamowieniu "
    SQL+=" FROM rs_typy_plikow_zamowien_odb_upr tu"
    SQL+=" INNER JOIN rs_typy_plikow_zamowien_odb t ON (t.firma_id=tu.firma_id AND t.kod=tu.typ_pliku)"
    SQL+=" WHERE tu.firma_id='"+self.firma_id+"' AND tu.operator_id="+Operator+" ORDER BY tu.typ_pliku;"

    stat,dane,wyn1,wyn2 = self.PolSQL.Execute(SQL,3)
    if stat <> 'OK':
        stat = "Bd przy pobieraniu danych: "+stat
        dane.append(stat)
