
# -*- coding: iso8859_2 -*-

#-----------------------------------------------------------------------------
# Name:        fs_operatorzy_uprawnienia_wzory_dekretacji_dane.py
# Purpose:     wczytuje/edytuje/zapisuje dane uprawnien do wzorw dekretacji dla operatora
#
# Author:      Micha Raburski
# Created:     2006/11/02
# RCS-ID:      $Id: fs_operatorzy_uprawnienia_wzory_dekretacji_dane.py $
# Copyright:   (c) 2006 Record System
# Licence:     GNU GPL
#-----------------------------------------------------------------------------


#-------------------------------------------------------------------------------
#---   INSERT DANYCH (2- bez pobierania,1- z pobieraniem)
#-------------------------------------------------------------------------------

Oper=str(klucze[0])
stat = "OK"
dane = []
nwzor=''
ndowod=''

if (klucze[-1] in [1,2]) and (stat=='OK'):
    if (((self.oddzial_id,'001363') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID):
    #---   Sprawdzenie danych


        #pobranie klucza
        
        Okres=''
        Dowod=''
        Nazwa=''

        for i in range(len(pola)):
            pole = pola[i]
            wart = wartosci[i]

            if pole=='okres_id':
                Okres=wart
                
            if pole=='dowod_id':
                Dowod=wart
                
            if pole=='nazwa_id':
                Nazwa=wart    

        #sprawdzenie poprawnosci okresu        
        if Okres=='':        
            stat='BR OKR'        
        else:
            dump,d,dump,dump = self.PolSQL.Execute("SELECT okres_id FROM rs_definicje_okresow WHERE firma_id='"+self.firma_id+"' AND okres_id='"+Okres+"';" ,3)

            if len(d) == 0:
                stat = "BL OKR"
                dane.append(stat)
            
        # utworzenie filtra
        if stat == 'OK':    
            Filtr="WHERE firma_id='"+self.firma_id+"' AND okres_id='"+Okres+"'"
            if Dowod <> '':
                Filtr=Filtr+" AND dowod_id='"+Dowod+"'"
            if Nazwa <> '':
                Filtr=Filtr+" AND nazwa_id='"+Nazwa+"'"
            
            #pobranie potencjalnych wzorw
            dump,d,dump,dump = self.PolSQL.Execute("SELECT dowod_id,nazwa_id FROM rs_wzory_dekretacji "+Filtr+";" ,3)            
            if len(d) ==0:
                stat = "BR WZR"
                dane.append(stat)
            else:
                #utworzenie listy wszytstkich moliwych wzorw
                LWzory=[]
                for wzor in d:
                    LWzory.append((wzor[0],wzor[1]))
                
            
        if stat =='OK':
            #pobranie wzorw ju dodanych
            dump,d,dump,dump = self.PolSQL.Execute("SELECT dowod_id,nazwa_id FROM rs_wzory_dekretacji_upr "+Filtr+" AND operator_id="+Oper+";" ,3)            
            if len(d) <>0:
                for wzor in d:
                    if (wzor[0],wzor[1]) in LWzory:
                        LWzory.remove((wzor[0],wzor[1]))
                
            #gdy nie ma nic do dodania
            if len(LWzory)==0:
                stat = "BR NWZR"
                dane.append(stat)
        
        ndowod= rsglobal.Dekoduj(LWzory[0][0])
        nnazwa=rsglobal.Dekoduj(LWzory[0][1])
        
        if stat =='OK':    
            # przygotowanie listy pol
            LIns=''
            for wzor in LWzory:
                Ins="INSERT INTO rs_wzory_dekretacji_upr (firma_id,operator_id,okres_id,dowod_id,nazwa_id,przegladanie,wprowadzanie,edycja,usuwanie,zamykanie,otwieranie) "
                Ins=Ins+"VALUES ('"+self.firma_id+"',"+Oper+",'"+Okres+"','"+rsglobal.Dekoduj(wzor[0])+"','"+rsglobal.Dekoduj(wzor[1])+"',"+str(wartosci[3])+","+str(wartosci[4])+","+str(wartosci[5])+","+str(wartosci[6])+","+str(wartosci[7])+","+str(wartosci[8])+");"
                LIns=LIns+Ins
            
            stat,dump,dump,dump = self.PolSQL.Execute(LIns ,1)
               
    else:
        stat='UPR INS'

#-------------------------------------------------------------------------------
#---   UPDATE DANYCH (4- bez pobierania,3- z pobieraniem)
#-------------------------------------------------------------------------------

if (klucze[-1] in [3,4]) and (stat=='OK'):
    if (((self.oddzial_id,'001362') in self.uprawnienia) or ((self.oddzial_id,'001342') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID):
    #---   Sprawdzenie danych
        stat = "OK"
        dane = []

        if stat == 'OK':
            where = " WHERE firma_id='"+self.firma_id+"' AND operator_id="+Oper+" AND okres_id='"+klucze[1]+"' AND dowod_id='"+klucze[2]+"' AND nazwa_id='"+klucze[3]+"';"
            upd = "UPDATE rs_wzory_dekretacji_upr SET "
        
            for i in range(len(pola)):
                pole = pola[i]
                wart = wartosci[i]
            
                if pole in ['przegladanie','wprowadzanie','edycja','usuwanie','zamykanie','otwieranie']:
                    upd=upd+pole+"="+str(wart)+","

            upd = upd[0:len(upd)-1]+where
            
            stat,dump,dump,dump = self.PolSQL.Execute(upd ,1)
    else:
        stat='UPR UPD'

   

#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (5 -select, 3 -update z pobraniem, 1 -insert z pobraniem)
#-------------------------------------------------------------------------------

if (klucze[-1] in [1,3,5]) and (stat=='OK'):
    if (((self.oddzial_id,'001360') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID):
        # pobranie danych uprawnien
        if klucze[1]<> '' and klucze[2]<> '' and klucze[3] <> '':
            stat,dane,wyn1,tr = self.PolSQL.Execute("SELECT * FROM rs_wzory_dekretacji_upr WHERE firma_id='"+self.firma_id+"' AND operator_id="+Oper
                +" AND okres_id='"+klucze[1]+"' AND dowod_id='"+klucze[2]+"' AND nazwa_id='"+klucze[3]+"';",3)
        elif (ndowod<>'' and nnazwa<> ''):
            stat,dane,wyn1,tr = self.PolSQL.Execute("SELECT * FROM rs_wzory_dekretacji_upr WHERE firma_id='"+self.firma_id+"' AND operator_id="+Oper
                +" AND okres_id='"+klucze[1]+"' AND dowod_id='"+ndowod+"' AND nazwa_id='"+nnazwa+"';",3)
        else:
            stat,dane,wyn1,tr = self.PolSQL.Execute("SELECT * FROM rs_wzory_dekretacji_upr WHERE firma_id='"+self.firma_id+"' AND operator_id="+Oper
                +" AND okres_id='"+klucze[1]+"' LIMIT 1;",3)

        #pobranie danych do opisow

        if len(dane) == 1:
            tr = rssql.RSTableRowset(dane,wyn1)

            #--- okres
            #if ((self.oddzial_id,'014020') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
            #    dump,d,dump,dump = self.PolSQL.Execute("SELECT nazwa_dokumentu FROM rs_typy_dokumentow_m WHERE firma_id='"+self.firma_id+"' AND dokument_id='"+tr.GetVal(0,"dokument_id")+"';" ,3)
            #    if len(d) == 0:
            #        wyn2.append('')
            #    else:
            #        wyn2.append(d[0][0])
            #else:
            #    wyn2.append('Brak uprawnie do sownika. Poinformuj administratora.')
    else:
        stat='UPR SEL'