
# -*- coding: iso8859_2 -*-

#-----------------------------------------------------------------------------
# Name:        fs_oddzialy.py
# Purpose:     obsluga oddzialow: wybor,edycja,usuwanie, zmiana klucza
#
# Author:      Mariusz Rajfura
# Created:     2009/04/08
# RCS-ID:      $Id: fs_oddzialy.py $
# Copyright:   (c) 2009 Record System
# Licence:     GNU GPL
#-----------------------------------------------------------------------------

Symbol = klucze[0].strip()

Fun = klucze[-1]

stat = 'OK'
dane = []
wyn2 = []

UprDodawanie = ((self.oddzial_id,'001130') in self.uprawnienia or (self.operator_id == STANDARD_OPERATOR_ID))
UprEdycja = ((self.oddzial_id,'001110') in self.uprawnienia or UprDodawanie or (self.operator_id == STANDARD_OPERATOR_ID))
UprUsuwanie = ((self.oddzial_id,'001140') in self.uprawnienia or (self.operator_id == STANDARD_OPERATOR_ID))
UprZmianaKlucza = ((self.oddzial_id,'001150') in self.uprawnienia or (self.operator_id == STANDARD_OPERATOR_ID))


#-------------------------------------------------------------------------------
#---   USUWANIE DANYCH ( 3 )
#-------------------------------------------------------------------------------

if stat=='OK' and Fun==3:
    if Symbol == '**':
       stat='BL_GWIAZDKI_DELETE'
       dane.append(stat)
            
    if stat=='OK':
        if Symbol == self.oddzial_id:
            stat='BL_SELF_DELETE'
            dane.append(stat)

    if stat=='OK':
        if not UprUsuwanie:
            stat='BRAK_UPR'
            dane.append(stat)
        else:
            if Symbol == self.oddzial_id:
                stat='BL_SELF_DELETE'
                dane.append(stat)
        
            if stat=='OK':
                sql="DELETE FROM rs_oddzialy WHERE firma_id='"+self.firma_id+"' AND oddzial_id = '"+Symbol+"';"
                stat,dane,wyn1,dump = self.PolSQL.Execute(sql,1)
                if stat<>'OK':
                    stat='BL_DELETE'
                    dane.append(stat)


#-------------------------------------------------------------------------------
#---   ZMIANA KLUCZA ( 6 )
#-------------------------------------------------------------------------------

if stat=='OK' and Fun==6:
    if not UprZmianaKlucza:
        stat='BRAK_UPR_ZM_KLUCZA'
        dane.append(stat)
        
    if stat=='OK':
        SymbolN = klucze[1].strip()
        sql="UPDATE rs_oddzialy SET oddzial_id = '"+SymbolN+"' WHERE firma_id='"+self.firma_id+"' AND oddzial_id = '"+Symbol+"';"
        stat,dane,wyn1,dump = self.PolSQL.Execute(sql,1)
        if stat<>'OK':
            stat='BL_ZM_KLUCZA'
            dane.append(stat)


#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH  ( 8 - administrator z gwiazdkami )
#-------------------------------------------------------------------------------

if stat=='OK':
    
    if self.operator_id==STANDARD_OPERATOR_ID:
        
        zgw = "AND oddzial_id <> '**'"
        if Fun==8:
            zgw = ''
            
        sql="SELECT oddzial_id,opis FROM rs_oddzialy WHERE firma_id='"+self.firma_id+"' "+zgw+" ORDER BY oddzial_id;"
        stat,dane,wyn1,dump = self.PolSQL.Execute(sql,3)
        if stat<>'OK':
            stat='BL_SELECT'
            dane.append(stat)
            
    else:
        
        sql = "SELECT DISTINCT o.oddzial_id,o.opis FROM rs_oddzialy o "
        sql += "INNER JOIN rs_grupa_operator_oddzial go ON (o.firma_id=go.firma_id AND (o.oddzial_id=go.oddzial_id OR go.oddzial_id='**'))"
        sql += "WHERE o.firma_id='"+self.firma_id+"' AND o.oddzial_id <> '**' AND go.operator_id="+str(self.operator_id)+" ORDER BY o.oddzial_id;"
        
        if Fun in (1,9):
            sql = "SELECT oddzial_id,opis FROM rs_oddzialy WHERE firma_id='"+self.firma_id+"' AND oddzial_id <> '**' ORDER BY oddzial_id;"
        
        stat,dane,wyn1,dump = self.PolSQL.Execute(sql,3)
        if stat<>'OK':
            stat='BL_SELECT'
            dane.append(stat)
