# -*- coding: iso8859_2 -*-

#-----------------------------------------------------------------------------
# Name:        fs_paragony_fiskalne_pozycje_dane.py
# Purpose:     wczytuje/edytuje dane dotyczace pozycji paragonu fiskalnego
#
# Author:      Micha Raburski
# Created:     2007/04/27
# RCS-ID:      $Id:$
# Copyright:   (c) 2006 Record System
# Licence:     GNU GPL
#-----------------------------------------------------------------------------

#klucze = [Oddzial,Kasa,Data,Numer,Poz,funkcja]


stat='OK'
Oddzial=rsglobal.Dekoduj(klucze[0]) 
Kasa=rsglobal.Dekoduj(klucze[1]) 
Data=rsglobal.Dekoduj(klucze[2]) 
Numer=klucze[3]
Poz=klucze[4]


Funkcja=klucze[-1]
#w celach informacyjno rozeznaniowych
Pola=pola
Wartosci=wartosci


if self.operator_id != STANDARD_OPERATOR_ID:
    UprEdycja = ((self.oddzial_id,'025022') in self.uprawnienia)
    UprDodawanie = ((self.oddzial_id,'025023') in self.uprawnienia)
else:
    UprEdycja = UprDodawanie = True

if Funkcja == 9: #sprawdzenie wersji
    dane=[]
    sql = "SELECT wersja FROM rs_paragony_fiskalne WHERE firma_id='"+self.firma_id+"' AND kasa_id = '"+Kasa+"' AND oddzial_id = '"+Oddzial+"' AND data = '"+Data+"' AND numer = "+str(Numer)+";"
    stat,dane,dump,dump = self.PolSQL.Execute(sql ,3)    

    if stat == "OK":
        sql = "SELECT zaokrag_piatki, zaokrag_sumy FROM rs_kasy_fiskalne WHERE firma_id='" + self.firma_id + "' AND oddzial_id='" + Oddzial + "' AND kasa_id='" + Kasa + "'"
        stat,d,dump,dump = self.PolSQL.Execute(sql, 2)
        wyn2 = d[0]

if Funkcja == 10: # nowy numer pozycji
    dane=[]
    sql = "SELECT nr_poz FROM rs_paragony_fiskalne_pozycje WHERE firma_id = '"+self.firma_id+"' AND oddzial_id='"+Oddzial+"' AND kasa_id = '"+Kasa+"' AND data = '"+Data+"' AND numer="+str(Numer)+" ORDER BY nr_poz DESC LIMIT 1"
    stat,dane,dump,dump = self.PolSQL.Execute(sql ,3)    
    if len(dane)==0:
        dane = 1
    else:
        dane = int(dane[0][0]) + 1
        
if Funkcja == 11:
    dane = []
    sql = "SELECT przelicznik,jm1,jm2 FROM rs_artykuly WHERE artykul_id='"+Oddzial+"' AND firma_id = '"+self.firma_id+"';"
    stat,dane,dump,dump = self.PolSQL.Execute(sql,3)

#-------------------------------------------------------------------------------
#   pobranie informacji o cechach (25)
#-------------------------------------------------------------------------------

if (Funkcja == 25) and stat=='OK': 
    # wraca stat,[cecha, opis cechy, liczba wartoci, domylna warto]
    Artykul= str(klucze[0])
    from funkcje import fs_artykuly_cechy_pom
    stat,dane = fs_artykuly_cechy_pom.PodajDaneCechyArtykulu(self,Artykul)

#-------------------------------------------------------------------------------
#---   Sprawdzam dane
#-------------------------------------------------------------------------------

if Funkcja in [1,2,3,4]:
    if not UprEdycja:
        stat = 'UPR UPD'
        dane.append(stat)
        
    if stat == 'OK':
        #sprawdzenie daty z klucza
        if Data not in ('','    -  -  '):
            dane_wyn = rsglobal.SprawdzCzyToData(Data)   
            if not dane_wyn:
                stat = "BL KLDATA"
        else:
            stat = "BR KLDATA"
            dane.append(stat)
                    
    #sprawdzenie paragonu z klucza
    if stat == "OK":
        Filtr = "firma_id='"+self.firma_id+"' AND oddzial_id='"+Oddzial+"' AND kasa_id = '"+Kasa+"' AND data='"+Data+"' AND numer="+str(Numer)
        sql="SELECT oddzial_id FROM rs_paragony_fiskalne WHERE "+Filtr+";"
        stat,dane_wyn,dump,dump = self.PolSQL.Execute(sql ,3)
    
        if stat =='OK':
            if len(dane_wyn) == 0:
                stat = "BL KLUCZ"
                dane.append(stat)

        # pobranie informacji o cechach (dla update)
    if stat =='OK':
        CechaArt=''
        Cecha=''
        CechaWart=''
        if Funkcja in [3,4]:
            SQL = "SELECT TRIM(COALESCE(a.cecha1_opis,'')),TRIM(COALESCE(pfp.cecha1_opis,'')),"
            SQL+=" TRIM(COALESCE(pfp.cecha1_wartosc,''))"
            SQL+= " FROM rs_paragony_fiskalne_pozycje pfp LEFT OUTER JOIN rs_artykuly a USING (firma_id,artykul_id)"
            SQL+= " WHERE pfp.firma_id='"+self.firma_id+"' AND pfp.oddzial_id='"+Oddzial+"' AND pfp.kasa_id = '"+Kasa+"'"
            SQL+=" AND pfp.data='"+Data+"' AND pfp.numer="+str(Numer)+" AND pfp.nr_poz="+str(Poz)+";"
            stat,Dane,dump,dump = self.PolSQL.Execute(SQL ,3)
            if stat <> 'OK':
                stat = "Bd pobierania danych o cechach z artykuu z pozycji paragonu fiskalnego"
                dane.append(stat)
            else:
                CechaArt=Dane[0][0]
                Cecha=Dane[0][1]
                CechaWart=Dane[0][2]        
                
    #sprawdzenie przychodzacych danych
    if stat == "OK":
        dane = []
        NrPoz = Poz
        i = 0
                
        for pole in Pola:
            if stat=='OK':
                wart = Wartosci[i]
                if pole=='nr_poz':
                    if wart < 1:
                        dane.append("BL NRPOZYCJI")
                    sql = "SELECT nr_poz FROM rs_paragony_fiskalne_pozycje WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+Oddzial+"' AND kasa_id = '"+Kasa+"' AND data='"+Data+"' AND numer="+str(Numer)+" AND nr_poz="+str(wart)+";"
                    stat,Dane,dump,dump = self.PolSQL.Execute(sql ,3) 
                    if stat =='OK':
                        if Dane <> []:
                            dane.append("BR NRPOZYCJI")
                    
                elif pole == 'artykul_id':
                    if wart == '':
                        dane.append("BR ART")
                    else:
                        sql = "SELECT artykul_id,TRIM(COALESCE(cecha1_opis,'')),aktywny FROM rs_artykuly WHERE firma_id='"+self.firma_id+"' AND artykul_id = '"+wart+"';"
                        stat,Dane,dump,dump = self.PolSQL.Execute(sql ,3) 
                        if stat =='OK':
                            if Dane == []:
                                dane.append("BL ART")
                            elif not Dane[0][2]:
                                dane.append('ART NIEAKT')
                            else:
                                art_id = wart
                                CechaArt = Dane[0][1]
                                
                elif pole == 'ilosc1':
                    if wart <= 0:
                        dane.append("BL ILOSCART1")

                elif pole == 'rabat':
                    if (wart < 0 or wart >=100):
                        dane.append("BL RABAT")
                    
                elif pole == 'ilosc2':
                    if wart <= 0:
                        dane.append("BL ILOSCART2")
            
                elif pole == '':
                    if wart <= 0:
                        dane.append("BL ILOSCART2")
                    
                elif pole == 'cena_netto1':
                    if wart <= 0:
                        dane.append("BL CENANETTO1")
                    
                elif pole == 'cena_netto2':
                    if wart <= 0:
                        dane.append("BL CENANETTO2")
                    
                elif pole == 'cena_brutto1':
                    if wart <= 0:
                        dane.append("BL CENABRUTTO1")
                    
                elif pole == 'cena_brutto2':
                    if wart <= 0:
                        dane.append("BL CENABRUTTO2")

                elif pole == 'stawka_vat':
                    sql = "SELECT kod FROM rs_kasy_fiskalne_vat WHERE firma_id='" + self.firma_id + "' AND oddzial_id='"+ Oddzial + "' AND kasa_id='" + Kasa + "' AND stawka_vat='" + wart + "'"
                    stat,Dane,dump,dump = self.PolSQL.Execute(sql ,3) 
                    if stat == 'OK':
                        if Dane == []:
                            dane.append("BL STAWKA")
                            
                elif pole == 'cecha1_opis':
                    Cecha = wart.strip()                   
                elif pole == 'cecha1_wartosc':
                    CechaWart = wart.strip()           
                
            i= i+1
                
        # sprawdzenie spjnoci informacji o cechach
        if stat == 'OK' :
            # jeli opis cechy pozycji inny ni artykuu
            if Cecha <> CechaArt:
                dane.append('BL CECHA')
            # jeli opis podany a warto pusta
            elif Cecha <> '' and CechaWart =='':
                dane.append('BR CECHA WART')
            # jeli opis pusty a warto podana
            elif Cecha == '' and CechaWart <>'':
                dane.append('CECHA WART NIEPUSTA')
            else:
                SQL="SELECT rsf_podaj_parametry_cechy('"+self.firma_id+"','"+Cecha+"','"+CechaWart+"','poprawna')"
                stat,d,dump,dump = self.PolSQL.Execute(SQL,3)
                if stat <> 'OK':
                    stat = 'Bd sprawdzenia wartoci cechy: '+stat
                else:
                    Wynik=eval(d[0][0])
                    if not Wynik[0]:
                        dane.append(Wynik[1])

    
        if stat == 'OK':
            if len(dane) > 0:
                stat = dane[0]

#-------------------------------------------------------------------------------
#---   INSERT DANYCH (2- bez pobierania,1- z pobieraniem)
#-------------------------------------------------------------------------------

if stat == "OK" and Funkcja in [2,1]:
    if UprDodawanie:
        sql = "INSERT INTO rs_paragony_fiskalne_pozycje"
        PolaN="firma_id,oddzial_id,kasa_id,data,numer"
        WartosciN = "'"+self.firma_id+"','"+Oddzial+"','"+Kasa+"','"+Data+"','"+Numer+"'"
        for i in range(len(pola)):
            pole = pola[i]
            wart = wartosci[i]
            if pole in ['artykul_id','cecha1_opis','cecha1_wartosc','stawka_vat','rabat','cena_przed_rabatem1','cena_przed_rabatem2']:
                PolaN += ","+pole
                WartosciN += ",'"+str(wart)+"'"
            else:
                PolaN += ","+pole
                WartosciN += ","+str(wart)
            if pole == "nr_poz":
                Poz = wart
        sql += " ("+PolaN+") VALUES ("+WartosciN+");"
        stat,dump,dump,dump = self.PolSQL.Execute(sql ,1)
    else:
        stat='UPR INS'
        dane.append(stat)

#-------------------------------------------------------------------------------
#---   UPDATE DANYCH (4- bez pobierania,3- z pobieraniem)
#-------------------------------------------------------------------------------
if stat == "OK" and Funkcja in [3,4]:
    if UprEdycja:
        dane = []
        sql = "UPDATE rs_paragony_fiskalne_pozycje SET "
        Filtr = "firma_id='"+self.firma_id+"' AND oddzial_id='"+Oddzial+"' AND kasa_id = '"+Kasa+"' AND data='"+Data+"' AND numer="+Numer+" AND nr_poz="+str(Poz)
        for i in range(len(Pola)):
            wart = Wartosci[i]
            pole = Pola[i]
            if pole in ['artykul_id','cecha1_opis','cecha1_wartosc','stawka_vat','rabat','cena_przed_rabatem1','cena_przed_rabatem2']:
                sql += pole+"='"+str(wart)+"',"
            elif wart == "NULL":
                sql += pole+"="+str(wart)+","
            else:
                sql += pole+"="+str(wart)+","
            if pole == "nr_poz":
                Poz = wart
        sql = sql.strip(',')
        sql += " WHERE "+Filtr+";"
        stat,dump,dump,dump = self.PolSQL.Execute(sql ,1)
        if stat != 'OK':
            stat = 'BL SQL'
            dane.append(stat)
    else:
        stat = 'UPR UPD'
        dane.append(stat)

#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (5 -select, 3 -update z pobraniem, 1 -insert z pobraniem)
#-------------------------------------------------------------------------------

if stat == "OK" and Funkcja in [5,3,1]:
    SQL = "SELECT * FROM rs_paragony_fiskalne_pozycje WHERE firma_id='"+self.firma_id+"'"
    SQL+=" AND oddzial_id='"+Oddzial+"' AND kasa_id = '"+Kasa+"' AND data='"+Data+"'"
    SQL+=" AND numer="+str(Numer)+" AND nr_poz="+str(Poz)
    stat,dane,wyn1,tr = self.PolSQL.Execute(SQL,3)

    if stat=='OK':
        tr = rssql.RSTableRowset(dane,wyn1)
            
        SQL = "SELECT nazwa FROM rs_artykuly WHERE firma_id = '"+self.firma_id+"' AND artykul_id = '"+tr.GetVal(0,"artykul_id")+"'"
        stat,d,dump,dump=self.PolSQL.Execute(SQL,3)
        if stat =='OK':
            if len(d)>0:
                wyn2=[d[0][0]]
            else:
                wyn2=['']