# -*- coding: iso8859_2 -*-

#-----------------------------------------------------------------------------
# Name:        fs_platnosci_dane.py
# Purpose:     wczytuje/edytuje dane platnosci
#
# Author:      Dariusz Boduch, 
# Created:     2008/12/02
# RCS-ID:      $Id:$
# Copyright:   (c) 2006 Record System
# Licence:     GNU GPL
#-----------------------------------------------------------------------------
# 2015-12-15 Piotr Witkowski (9454) [KS] Zmiany w patnociach
# 2018-06-22 Aleksander Bargie (11113) Kwota_vat w platnosciach - wprowadzanie i edycja
# 2021-03-16  - Aleksander Bargie (12395) Doda trim na imi i nazwisko

#klucze = platnosc_id  


stat='OK'
platnosc_id=rsglobal.Dekoduj(klucze[0]) 
Funkcja=klucze[-1]
#w celach informacyjno rozeznaniowych
Pola=pola
Wartosci=wartosci
wyn2=[]
puste_pola = [[],"","    -  -  "]

if self.operator_id != STANDARD_OPERATOR_ID:
    UprDodawanie = ((self.oddzial_id,'076703') in self.uprawnienia)
    if UprDodawanie:
        UprEdycja=True
    else:
        UprEdycja = ((self.oddzial_id,'076702') in self.uprawnienia)
else:
    UprEdycja = UprDodawanie = True

#-----------------------------------------------------------------------------
#---   wstawienie czy pracownik/kontrahent
#-----------------------------------------------------------------------------

if Funkcja == 10:
    self.ktory = klucze[-2]


#-------------------------------------------------------------------------------
#---   Sprawdzam dane
#-----------------------------------------------------------------------------
if UprEdycja:
    if Funkcja in [1,2,3,4,5,9] and stat=='OK':
        i=0
        dane=[]
        for pole in Pola:
            wart = Wartosci[i]
            if pole=='konto_id':
                if wart == '':
                    stat='BR KONTA'
                    dane.append(stat)
                else:
                    sql = "SELECT konto_id FROM rs_konta_bankowe WHERE firma_id='"+self.firma_id+"' AND konto_id='"+str(wart)+"';"
                    dump,Dane,dump,dump = self.PolSQL.Execute(sql ,3) 
                    if Dane == []:
                        stat = 'BL KONTO'
                        dane.append(stat)
            elif pole == 'kontrahent_id':
                if wart == '':
                    stat = "BR KONTR"
                    dane.append(stat)
                else:
                    sql = "SELECT kontrahent_id FROM rs_kontrahenci WHERE firma_id='"+self.firma_id+"' AND kontrahent_id = '"+str(wart)+"';"
                    dump,Dane,dump,dump = self.PolSQL.Execute(sql ,3) 
                    if Dane == []:
                        stat = "BL KONTR"
                        dane.append(stat)

            elif pole == 'pracownik_id':
                sql ="SELECT pracownik_id FROM rs_kp_dane_osobowe"
                sql+=" WHERE firma_id = '"+self.firma_id+"' AND pracownik_id = '"+str(wart)+"';"
                stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                if stat <> 'OK':
                    stat = "BL PRAC"
                    dane.append(stat)
                elif len(d) == 0:
                    stat = "BR PRAC"
                    dane.append(stat)

            elif pole == 'numer_listy_id':
                if len(str(wart).strip())==0:
                    stat = "Niewypeniony numer listy pac"
                    dane.append(stat)
                elif len(str(wart).strip())==11:                    
                    sql ="Select 1 From rs_kp_listy_plac"
                    sql+=" WHERE firma_id = '"+self.firma_id+"' AND numer_listy_id = '"+str(wart)+"';"
                    stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                    if stat <> 'OK':
                        stat = "Bdny numer listy pac"
                        dane.append(stat)
                    elif len(d) ==0:
                        stat = "Nie istnieje listy pac o podanym numerze"
                        dane.append(stat)
                else:                    
                    stat = "Bdny numer listy pac"
                    dane.append(stat)

            elif pole == 'termin_plat':
                if wart in puste_pola:
                    stat='BR TERMINPLAT'
                    dane.append(stat)
                if wart <> '    -  -  ':
                    if not rsglobal.SprawdzCzyToData(wart):
                        stat='BL TERMINPLAT'
                        dane.append(stat)
                        
            elif pole =="konto_fk":
                if wart <> '':
                    sql = "SELECT rsf_podaj_parametry_konta('"+self.firma_id+"','"+self.okres_id+"','"+wart+"');"
                    stat,DaneTmp,dump,dump = self.PolSQL.Execute(sql,3)
                    if stat<>'OK':
                        stat='BL_KRY_KONTO_FK'
                        dane.append(stat)
                    if stat=='OK':    
                        if (DaneTmp == []) or (DaneTmp == None):
                            stat='BL_KRY_KONTO_FK'
                            dane.append(stat)    
                    if stat=='OK':    
                        Dane = rsglobal.rseval(DaneTmp[0][0])
                        if Dane[0] == '':
                            stat='BL_KONTO_FK'
                            dane.append(stat)    
                        elif not Dane[2]:
                            stat='KONTO_FK_NIE_KSIE'
                            dane.append(stat)

            i = i+1
    else:
        stat="BL_SQL"
        dane.append(stat)  

#-------------------------------------------------------------------------------
#---   UPDATE DANYCH (2,4- bez pobierania,1,3- z pobieraniem)
#-------------------------------------------------------------------------------
    if stat == "OK" and Funkcja in [1,2,3,4]:
        dane = []
        if Funkcja in [1,2]:
            op=" "
        else:
            op= "op_ed="+str(self.operator_id)+",  "
        sql = "UPDATE rs_platnosci SET "+op
        Filtr = " firma_id='"+self.firma_id+"' AND platnosc_id="+str(platnosc_id)
        for i in range(len(Pola)):
            wart = Wartosci[i]
            pole = Pola[i]
            if pole in ['pracownik_id','numer_listy_id']:
                sql += pole+"="
                if wart in puste_pola:
                    sql += "NULL,"
                else:
                    sql += "'"+str(wart)+"',"  

            elif pole in ['kontrahent_id','nr_faktury']:
                sql += pole+"="
                if wart in puste_pola:
                    sql += "NULL,"
                else:
                    sql += "'"+str(wart)+"',"   
            elif pole in ['konto_id','konto_fk']:
                sql += pole+"="
                if wart in puste_pola:
                    sql += "NULL,"
                else:
                    sql += "'"+str(wart)+"',"   
            elif pole in ['termin_plat']:
                sql += pole+"="
                if wart in puste_pola:
                    sql += "NULL,"
                else:
                    sql += "'"+str(wart)+"',"
            elif pole in ['kwota_oryg']:
                sql += pole+" = "
                if wart in puste_pola:
                    sql += "NULL,"
                else:
                    sql += " "+str(wart)+" ,"
                sql +="kwota_platnosci = "+str(wart)+","
 #AB 22.06.18r Dopanie kwoty VAT i NIPU
            elif pole in ['kwota_vat']:
                sql += pole+" = "
                if wart in puste_pola:
                    sql += "NULL,"
                else:
                    sql += " "+str(wart)+" ,"
            elif wart == "NULL":
                sql += pole+"="+str(wart)+","
            else:
                sql += pole+"="+str(wart)+","
          
        sql = sql.strip(',')
        sql += " WHERE "+Filtr+";"
        stat,dump,dump,dump = self.PolSQL.Execute(sql ,1)
        if stat != 'OK':
            stat = 'BL_SQL'
            dane.append(stat)
        pass

#-------------------------------------------------------------------------------
#---   USUNIECIE WIERSZA PRZY DODAWANIU GDY REZYGNACJA 9
#-------------------------------------------------------------------------------

if stat == "OK" and Funkcja == 9:
    Delete="DELETE FROM rs_platnosci WHERE platnosc_id = '" + str(platnosc_id) + "' ;"
    stat,dump,dump,dump=self.PolSQL.Execute(Delete,1)
    if stat!="OK":
        dane.append(stat)    
        

#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (5 -select, 3 -update z pobraniem, 1 -insert z pobraniem)
#-------------------------------------------------------------------------------

if stat == "OK" and Funkcja in [1,3,5]:
    dane = []
    where="WHERE firma_id='"+self.firma_id+"' AND platnosc_id= "+str(platnosc_id) 
    if self.ktory == 'Pracownik':
 #AB 22.06.18r Dopanie kwoty VAT i NIPU
        sql = "SELECT konto_id,pracownik_id,numer_listy_id,termin_plat, kwota_oryg, kwota_vat, "
    else:
 #AB 22.06.18r Dopanie kwoty VAT i NIPU
        sql = "SELECT konto_id,kontrahent_id,nr_faktury,termin_plat, kwota_oryg, kwota_vat, "
    sql += "COALESCE(CAST(op_wpr AS TEXT),'') as op_wpr, COALESCE(CAST(op_zatw AS TEXT),'') as op_zatw, COALESCE(CAST(op_ed AS TEXT),'') as op_ed, "
    sql += " COALESCE(CAST(op_zapl AS TEXT),'') as op_zapl, z_czas, z_op_id,konto_fk FROM rs_platnosci "+where+" ;"

    stat,dane,wyn1,tr = self.PolSQL.Execute(rsglobal.Dekoduj(sql),3)
    #stat,dane,dump,dump = self.PolSQL.Execute(sql,3)
    if stat=='OK':
        tr = rssql.RSTableRowset(dane,wyn1)
        wyn2=[]
        if ((self.oddzial_id,'014050') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
            sql = "SELECT bank FROM rs_konta_bankowe WHERE firma_id = '"+self.firma_id+"' AND konto_id = '"+tr.GetVal(0,"konto_id")+"' "
            st,d,dump,dump=self.PolSQL.Execute(sql,3)
            if len(d) == 0:
                wyn2.append('')
            else:
                wyn2.append(d[0][0])
        else:
            wyn2.append('Brak uprawnie do przegldania kont. Poinformuj administratora.')
        
        if ((self.oddzial_id,'012010') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
            if self.ktory == 'Pracownik':   #AB 16.03.21r dodanie TRIM
                sql = "SELECT TRIM(nazwisko)||' '||TRIM(imie), nip FROM rs_kp_dane_osobowe WHERE firma_id = '"+self.firma_id+"' AND pracownik_id = '"+tr.GetVal(0,"pracownik_id")+"' "
            else:
 #AB 22.06.18r Dopanie kwoty VAT i NIPU
                sql = "SELECT nazwa, nip FROM rs_kontrahenci WHERE firma_id = '"+self.firma_id+"' AND kontrahent_id = '"+tr.GetVal(0,"kontrahent_id")+"' "
            st,d,dump,dump=self.PolSQL.Execute(sql,3)
            if len(d) == 0:
                wyn2.append('')
            else:
                wyn2.append(d[0][0])
 #AB 22.06.18r Dopanie kwoty VAT i NIPU
                wyn2.append(d[0][1])
        else:
            if self.ktory == 'Pracownik':
                wyn2.append('Brak uprawnie do przegldania pracownikw. Poinformuj administratora.')
            else:
                wyn2.append('Brak uprawnie do przegldania kontrahentw. Poinformuj administratora.')
        
        #dane wprowadzajcego
        wpr=tr.GetVal(0,"op_wpr")
        if wpr == '':
            wyn2.append('')
        else:    
            if ((self.oddzial_id,'001320') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
                sql = "SELECT login FROM rs_operatorzy WHERE operator_id = '"+wpr+"' "
                st,d,dump,dump=self.PolSQL.Execute(sql,3)
                if len(d) == 0:
                    wyn2.append('')
                else:
                    wyn2.append(d[0][0])
            else:
                wyn2.append('Brak uprawnie do przegldania operatorw. Poinformuj administratora.')
            
        #dane zatwierdzajacego
        zatw=tr.GetVal(0,"op_zatw")
        if zatw == '':
            wyn2.append('')
        else:
            if ((self.oddzial_id,'001320') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):    
                sql = "SELECT login FROM rs_operatorzy WHERE operator_id = '"+zatw+"' "
                st,d,dump,dump=self.PolSQL.Execute(sql,3)
                if len(d) == 0:
                    wyn2.append('')
                else:
                    wyn2.append(d[0][0])
            else:
                wyn2.append('Brak uprawnie do przegldania operatorw. Poinformuj administratora.')
            
        #dane edytujacego
        edyt=tr.GetVal(0,"op_ed")
        if edyt == '':
            wyn2.append('')
        else:
            if ((self.oddzial_id,'001320') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):           
                sql = "SELECT login FROM rs_operatorzy WHERE operator_id = '"+edyt+"' "
                st,d,dump,dump=self.PolSQL.Execute(sql,3)
                if len(d) == 0:
                    wyn2.append('')
                else:
                    wyn2.append(d[0][0])
            else:
                wyn2.append('Brak uprawnie do przegldania operatorw. Poinformuj administratora.')
            
        #dane zamykajacego
        zam=tr.GetVal(0,"op_zapl")
        if zam == '':
            wyn2.append('')
        else:    
            if ((self.oddzial_id,'001320') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):        
                sql = "SELECT login FROM rs_operatorzy WHERE operator_id = '"+zam+"' "
                st,d,dump,dump=self.PolSQL.Execute(sql,3)
                if len(d) == 0:
                    wyn2.append('')
                else:
                    wyn2.append(d[0][0])
            else:
                wyn2.append('Brak uprawnie do przegldania operatorw. Poinformuj administratora.') 
        #kwota biezacej platnosci
        sql = "SELECT kwota_platnosci FROM rs_platnosci "+where
        st,d,dump,dump=self.PolSQL.Execute(sql,3)
        if len(d) == 0:
            wyn2.append('')
        else:
            wyn2.append(d[0][0])
        #kwota uregulowana
        sql = "SELECT uregulowano FROM rs_platnosci "+where
        st,d,dump,dump=self.PolSQL.Execute(sql,3)
        if len(d) == 0:
            wyn2.append('')
        else:
            wyn2.append(d[0][0])
        #nr dowod ksiegowego
        sql = "SELECT COALESCE(dowod,'') FROM rs_platnosci "+where
        st,d,dump,dump=self.PolSQL.Execute(sql,3)
        if len(d) == 0:
            wyn2.append('')
        else:
            wyn2.append(d[0][0])