# -*- coding: iso8859_2 -*-

#-----------------------------------------------------------------------------
# Name:        fs_pliki.py
# Purpose:     funkcje do obsugi plikw na serwerze ale dostpna z klienta
# Author:      Micha Raburski
# Created:     2012/06/27
# RCS-ID:      $Id: fs_pliki.py $
# Copyright:   (c) 2012 RecordSystem
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

# 2021-11-03 Wojciech Skowron - (12174) Poprawiona obsuga pliku
# 2024-02-15 Wojciech Skowron - (13695) Zwracany stat z fs_pliki_office.ZapiszXLS

from funkcje import fs_pliki_office
import tempfile
import binascii
import rsglobal

dane = []
wyn1 = []
wyn2 = []
stat = 'OK'

if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=='OK':
    Fun = klucze['Funkcja']
    
    SlPar={'Dane':[1],'Kodowanie':[1],'ZAgaty':[1]}    
    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Fun,klucze)
    if Lista<>'':
        stat='Uwaga : wywoanie funkcji fs_pliki z numerem '+str(Fun)+' bez parametrw: '+Lista

if Fun==1:
    Dane=rsglobal.Dekoduj(klucze['Dane']) # struktura opisana w fs_pliki_office
    Kodowanie=rsglobal.Dekoduj(klucze['Kodowanie'])
    ZAgaty=rsglobal.Dekoduj(klucze['ZAgaty']) # agata przysya csv w swoim formacie i wymaga to dodatkowej obrbki
    
    
    
    
#--#############################################################################
#   FUNKCJA ZMIENIAJCA CSV NA XLS (1)
#--#############################################################################
if Fun==1 and stat=='OK':
    Tresc=[]
    for dokument in Dane:
        # nazwa zakadki
        DForm=[dokument[0]]
        S=fs_pliki_office.PrzygotujTrescZCSV(dokument[1],Kodowanie,ZAgaty)
        DForm.append(fs_pliki_office.PrzygotujTrescZCSV(dokument[1],Kodowanie,ZAgaty))
        Tresc.append(DForm)
    Plik=tempfile.mktemp('.xlsx')
    stat=fs_pliki_office.ZapiszXLS(Tresc,Plik,Kodowanie)  #WS 2024-02-15 - stat=
    if stat == 'OK':
        #WS 2021-11-03
        try:
            with open(Plik,'rb') as p:
                dane=[binascii.hexlify(buffer(p.read()))]
        except:
            import traceback
            stat = 'Bdy odczytu pliku: '+traceback.format_exc()
        # dane=[binascii.hexlify(buffer(open(Plik,'rb').read()))]
