# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_produkcja_dokumenty.py
# Purpose:     obsluga grida edytowalnego
# Author:      mariusz rajfura
# Created:     2010/01/20
# RCS-ID:      $Id: fs_produkcja_dokumenty.py$
# Copyright:   (c) 2010 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

Oddzial = rsglobal.Dekoduj(klucze[0]).strip()
Kod =  rsglobal.Dekoduj(klucze[1]).strip()
Fun = klucze[-1]

stat = 'OK'
dane = []

UprIns=((self.oddzial_id,'014093') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID
UprUpd=((self.oddzial_id,'014092') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID or UprIns
UprDel=((self.oddzial_id,'014094') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID

Insert = []
Update = []
Delete = []

if Fun == 1:
    Update=klucze[-2]
    Insert=klucze[-3]
    Delete=klucze[-4]

#-------------------------------------------------------------------------------
#-------   SPRAWDZANIE OPISU
#-------------------------------------------------------------------------------

if Fun == 7 and stat=="OK":
    sql ="SELECT opis FROM rs_oddzialy"
    sql+=" WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+Kod+"';"
    stat,dane,dump,dump = self.PolSQL.Execute(sql,3)   
    if stat<>'OK':
        stat = 'Bd przy sprawdzaniu opisu oddziau: '+stat   
        dane.append(stat)        

#-------------------------------------------------------------------------------

if Fun == 8 and stat=="OK":
    sql ="SELECT opis FROM rs_magazyny"
    sql+=" WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+Kod+"';"
    stat,dane,dump,dump = self.PolSQL.Execute(sql,3)   
    if stat<>'OK':
        stat = 'Bd pobrania opisu magazynu: '+stat   
        dane.append(stat)        
            
#-------------------------------------------------------------------------------

if Fun == 9 and stat=="OK":
    sql ="SELECT opis FROM rs_wersje_cenowe"
    sql+=" WHERE firma_id='"+self.firma_id+"' AND kod='"+Kod+"';"
    stat,dane,dump,dump = self.PolSQL.Execute(sql,3)   
    if stat<>'OK':
        stat = 'Bd pobrania opisu wersji cenowej : '+stat   
        dane.append(stat)        

#-------------------------------------------------------------------------------

if Fun == 10 and stat=="OK":
    sql ="SELECT nazwa FROM rs_kontrahenci"
    sql+=" WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+Kod+"';"
    stat,dane,dump,dump = self.PolSQL.Execute(sql,3)   
    if stat<>'OK':
        stat = 'Bd pobrania nazwy kontrahenta : '+stat   
        dane.append(stat)        


#-------------------------------------------------------------------------------
#-------  SPRAWDZANIE DELETE  --------------------------------------------------
#-------------------------------------------------------------------------------

if Fun == 1 and stat=="OK":
    if len(Delete[0])>0:
        if not UprDel:
            stat='BR UPR DEL'
            dane.append(stat)    
            
        # wykonanie DELETE 
        if stat=='OK':
            sql=''
            for i in xrange(len(Delete[0])):
                DELETE="DELETE FROM rs_produkcja_dokumenty "
                WHERE="WHERE firma_id='"+self.firma_id+"'"
                for j in xrange(len(Delete[0][i])):
                    pole=Delete[1][j]
                    wart=Delete[0][i][j]
                    if pole in ['oddzial_id','magazyn_pw','wersja_pw','magazyn_mm',
                                'magazyn_brak','kontrahent_id','wersja_pw_braki','kontrahent_id_braki']:
                        WHERE+=" AND "+pole+"='"+wart+"'"
                sql+=DELETE+WHERE+";"
            if sql<>'':
                stat,dump,dump,dump=self.PolSQL.Execute(rsglobal.Dekoduj(sql),1)
                if stat<>'OK':
                    stat = "Bd przy usuwaniu danych: "+stat   
                    dane.append(stat)        

                                 
#-------------------------------------------------------------------------------
#---   UPDATE DANYCH (1)
#-------------------------------------------------------------------------------

if Fun == 1 and stat=="OK":
    if len(Update[0])>0:
        if not UprUpd:
            stat='BR UPR UPD'
            dane.append(stat)
            
        if stat == 'OK':
            #pobranie klucza dla oddzialu
            for i in xrange(len(Update[0])):
                for j in xrange(len(Update[2][i])): # petla po kluczu
                    pole=Update[3][j]
                    wart=rsglobal.Dekoduj(Update[2][i][j])
                    if pole == 'oddzial_id':
                        Oddzial = wart

        if stat == 'OK':
            WierszeNr = Update[-1]
            for i in xrange(len(Update[0])):
                for j in xrange(len(Update[0][i])): 
                    pole=Update[0][i][j]
                    wart=Update[1][i][j]

                    if pole == 'oddzial_id':
                        #jesli zmieniono oddzial, pobranie oddzialu
                        #do sprawdzenia magazynu
                        if wart.strip()=='':
                            stat = 'BR ODDZ'
                            wyn2.append((WierszeNr[i],0))
                            dane.append(stat)
                        else:
                            sql ="SELECT oddzial_id FROM rs_oddzialy"
                            sql+=" WHERE firma_id = '"+self.firma_id+"'"
                            sql+=" AND oddzial_id = '"+str(wart)+"';" 
                            stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                            if stat <> 'OK':
                                stat = 'BL SQL ODDZ'
                                wyn2.append((WierszeNr[i],0))
                                dane.append(stat)
                            elif d==[]:
                                stat = 'BL ODDZ'
                                wyn2.append((WierszeNr[i],0))
                                dane.append(stat)
                            else:
                                Oddzial = str(wart)
                    
                    elif pole == 'magazyn_pw':
                        if wart.strip() == '':
                            stat = 'BR MAGAZ PW'
                            wyn2.append((WierszeNr[i],2))
                            dane.append(stat)
                        else:
                            sql ="SELECT magazyn_id FROM rs_magazyny"
                            sql+=" WHERE firma_id = '"+self.firma_id+"'"
                            sql+=" AND oddzial_id = '"+Oddzial+"'"
                            sql+=" AND magazyn_id = '"+str(wart)+"';" 
                            stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                            if stat <> 'OK':
                                stat = 'BL SQL MAGAZ PW'
                                wyn2.append((WierszeNr[i],2))
                                dane.append(stat)
                            elif d==[]:
                                stat = 'BL MAGAZ PW'
                                wyn2.append((WierszeNr[i],2))
                                dane.append(stat)


                    elif pole == 'wersja_pw':
                        if str(wart).strip()=='':
                            stat = 'BR WERS CEN PW'
                            wyn2.append((WierszeNr[i],4))
                            dane.append(stat)
                        else:
                            sql ="SELECT kod FROM rs_wersje_cenowe"
                            sql+=" WHERE firma_id = '"+self.firma_id+"'"
                            sql+=" AND kod = '"+str(wart)+"';" 
                            stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                            if stat <> 'OK':
                                stat = 'BL SQL WERS CEN PW'
                                wyn2.append((WierszeNr[i],4))
                                dane.append(stat)
                            elif d==[]:
                                stat = 'BL WERS CEN PW'
                                wyn2.append((WierszeNr[i],4))
                                dane.append(stat)
                                
                    elif pole == 'wersja_pw_braki':
                        if str(wart).strip()=='':
                            stat = 'BR WERS CEN B'
                            wyn2.append((WierszeNr[i],4))
                            dane.append(stat)
                        else:
                            sql ="SELECT kod FROM rs_wersje_cenowe"
                            sql+=" WHERE firma_id = '"+self.firma_id+"'"
                            sql+=" AND kod = '"+str(wart)+"';" 
                            stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                            if stat <> 'OK':
                                stat = 'BL SQL WERS CEN PW B'
                                wyn2.append((WierszeNr[i],4))
                                dane.append(stat)
                            elif d==[]:
                                stat = 'BL WERS CEN PW B'
                                wyn2.append((WierszeNr[i],4))
                                dane.append(stat)
    
                    elif pole == 'magazyn_mm':
                        if wart.strip() == '':
                            stat = 'BR MAGAZ MM'
                            wyn2.append((WierszeNr[i],6))
                            dane.append(stat)
                        else:
                            sql ="SELECT magazyn_id FROM rs_magazyny"
                            sql+=" WHERE firma_id = '"+self.firma_id+"'"
                            sql+=" AND oddzial_id = '"+Oddzial+"'"
                            sql+=" AND magazyn_id = '"+str(wart)+"';" 
                            stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                            if stat <> 'OK':
                                stat = 'BL SQL MAGAZ MM'
                                wyn2.append((WierszeNr[i],6))
                                dane.append(stat)
                            elif d==[]:
                                stat = 'BL MAGAZ MM'
                                wyn2.append((WierszeNr[i],6))
                                dane.append(stat)

                    elif pole == 'magazyn_braki':
                        if wart.strip() == '':
                            stat = 'BR MAGAZ BRAKI'
                            wyn2.append((WierszeNr[i],8))
                            dane.append(stat)
                        else:
                            sql ="SELECT magazyn_id FROM rs_magazyny"
                            sql+=" WHERE firma_id = '"+self.firma_id+"'"
                            sql+=" AND oddzial_id = '"+Oddzial+"'"
                            sql+=" AND magazyn_id = '"+str(wart)+"';" 
                            stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                            if stat <> 'OK':
                                stat = 'BL SQL MAGAZ BRAKI'
                                wyn2.append((WierszeNr[i],8))
                                dane.append(stat)
                            elif d==[]:
                                stat = 'BL MAGAZ BRAKI'
                                wyn2.append((WierszeNr[i],8))
                                dane.append(stat)

                    elif pole == 'kontrahent_id':
                        if wart.strip() == '':
                            stat = 'BR KTH'
                            wyn2.append((WierszeNr[i],10))
                            dane.append(stat)
                        else:
                            sql ="SELECT kontrahent_id FROM rs_kontrahenci"
                            sql+=" WHERE firma_id='"+self.firma_id+"'"
                            sql+=" AND kontrahent_id='"+str(wart)+"' AND aktywny;" 
                            stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                            if stat <> 'OK':
                                stat = 'BL SQL KTH'
                                wyn2.append((WierszeNr[i],10))
                                dane.append(stat)
                            elif d==[]:
                                stat = 'BL KTH'
                                wyn2.append((WierszeNr[i],10))
                                dane.append(stat)
                                
                    elif pole == 'kontrahent_id_braki':
                        if wart.strip() == '':
                            stat = 'BR KTHB'
                            wyn2.append((WierszeNr[i],10))
                            dane.append(stat)
                        else:
                            sql ="SELECT kontrahent_id FROM rs_kontrahenci"
                            sql+=" WHERE firma_id='"+self.firma_id+"'"
                            sql+=" AND kontrahent_id='"+str(wart)+"' AND aktywny;" 
                            stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                            if stat <> 'OK':
                                stat = 'BL SQL KTHB'
                                wyn2.append((WierszeNr[i],10))
                                dane.append(stat)
                            elif d==[]:
                                stat = 'BL KTHB'
                                wyn2.append((WierszeNr[i],10))
                                dane.append(stat)
    
        if stat == 'OK':
            if len(dane) > 0:
                stat = dane[0]
                
        # wykonanie UPDATE
        if stat=='OK':
            sql=''
            for i in xrange(len(Update[0])):
                UPDATE="UPDATE rs_produkcja_dokumenty "
                SET='SET '
                for j in xrange(len(Update[0][i])): 
                    pole=Update[0][i][j]
                    wart=Update[1][i][j]
                    if pole in ['oddzial_id', 'magazyn_pw', 'wersja_pw',
                                'magazyn_mm','magazyn_braki','kontrahent_id',
                                'wersja_pw_braki','kontrahent_id_braki']: 
                        SET+=pole+"='"+wart+"',"
                    else:
                        if wart.strip()=='':
                            SET+=pole+"=NULL,"
                        else:
                            SET+=pole+"='"+wart+"',"
                    
                SET=SET.strip(",")
                WHERE=" WHERE firma_id='"+self.firma_id+"'" 
                for j in xrange(len(Update[2][i])): # petla po kluczu
                    pole=Update[3][j]
                    wart=rsglobal.Dekoduj(Update[2][i][j])
                    WHERE+=" AND "+pole+"='"+wart+"'"
                WHERE+=";"    
                
                sql+=UPDATE+SET+WHERE;
                
            if sql<>'':
                stat,dump,dump,dump=self.PolSQL.Execute(rsglobal.Dekoduj(sql),1)
                if stat<>'OK':
                    stat="Bd przy modyfikowaniu danych: "+stat   
                    dane.append(stat)  

                                    
#-------------------------------------------------------------------------------
#---------Sprawdzanie danych do Insert------
#-------------------------------------------------------------------------------

if Fun == 1 and stat=="OK":
    Oddzial = ''
    if len(Insert[0])>0:
        if not UprIns:
            stat='BR UPR INS'
            dane.append(stat)

        if stat == 'OK':
            #wyszukanie oddzial_id z linii grida -
            #potrzebny do sprawdzenia poprawnosci magazynu
            WierszeNr = Insert[-1]
            for i in xrange(len(Insert[0])):
                for j in xrange(len(Insert[0][i])): 
                        pole=Insert[1][j]
                        wart=Insert[0][i][j].strip()
                        
                        if pole == 'oddzial_id':
                            if wart.strip()=='':
                                stat = 'BR ODDZ'
                                wyn2.append((WierszeNr[i],0))
                                dane.append(stat)
                            else:
                                sql ="SELECT oddzial_id FROM rs_oddzialy"
                                sql+=" WHERE firma_id = '"+self.firma_id+"'"
                                sql+=" AND oddzial_id = '"+str(wart)+"';" 
                                stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                                if stat <> 'OK':
                                    stat = 'BL SQL ODDZ'
                                    wyn2.append((WierszeNr[i],0))
                                    dane.append(stat)
                                elif d==[]:
                                    stat = 'BL ODDZ'
                                    wyn2.append((WierszeNr[i],0))
                                    dane.append(stat)
                                else:
                                    Oddzial = wart.strip()
            if stat == 'OK':
                if len(dane) > 0:
                    stat = dane[0]
                    
        if stat == 'OK':
            #petla sprawdzenia pozostalych pol
            WierszeNr = Insert[-1]
            for i in xrange(len(Insert[0])):
                for j in xrange(len(Insert[0][i])): 
                        pole=Insert[1][j]
                        wart=Insert[0][i][j].strip()
                        
                        if pole == 'magazyn_pw':
                            if wart == '':
                                stat = 'BR MAGAZ PW'
                                wyn2.append((WierszeNr[i],2))
                                dane.append(stat)
                            else:
                                sql ="SELECT magazyn_id FROM rs_magazyny"
                                sql+=" WHERE firma_id = '"+self.firma_id+"'"
                                sql+=" AND oddzial_id = '"+str(Oddzial)+"'"
                                sql+=" AND magazyn_id = '"+str(wart)+"';" 
                                stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                                if stat <> 'OK':
                                    stat = 'BL SQL MAGAZ PW'
                                    wyn2.append((WierszeNr[i],2))
                                    dane.append(stat)
                                elif d==[]:
                                    stat = 'BL MAGAZ PW'
                                    wyn2.append((WierszeNr[i],2))
                                    dane.append(stat)

                        elif pole == 'wersja_pw':
                            if wart == '':
                                stat = 'BR WERS CEN PW'
                                wyn2.append((WierszeNr[i],4))
                                dane.append(stat)
                            else:
                                sql ="SELECT kod FROM rs_wersje_cenowe"
                                sql+=" WHERE firma_id = '"+self.firma_id+"'"
                                sql+=" AND kod = '"+str(wart)+"';" 
                                stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                                if stat <> 'OK':
                                    stat = 'BL SQL WERS CEN PW'
                                    wyn2.append((WierszeNr[i],4))
                                    dane.append(stat)
                                elif d==[]:
                                    stat = 'BL WERS CEN PW'
                                    wyn2.append((WierszeNr[i],4))
                                    dane.append(stat)
                                    
                        elif pole == 'wersja_pw_braki':
                            if wart == '':
                                stat = 'BR WERS CEN PW B'
                                wyn2.append((WierszeNr[i],4))
                                dane.append(stat)
                            else:
                                sql ="SELECT kod FROM rs_wersje_cenowe"
                                sql+=" WHERE firma_id = '"+self.firma_id+"'"
                                sql+=" AND kod = '"+str(wart)+"';" 
                                stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                                if stat <> 'OK':
                                    stat = 'BL SQL WERS CEN PW B'
                                    wyn2.append((WierszeNr[i],4))
                                    dane.append(stat)
                                elif d==[]:
                                    stat = 'BL WERS CEN PW B'
                                    wyn2.append((WierszeNr[i],4))
                                    dane.append(stat)

                        elif pole == 'magazyn_mm':
                            if wart == '':
                                stat = 'BR MAGAZ MM'
                                wyn2.append((WierszeNr[i],6))
                                dane.append(stat)
                            else:
                                sql ="SELECT magazyn_id FROM rs_magazyny"
                                sql+=" WHERE firma_id = '"+self.firma_id+"'"
                                sql+=" AND oddzial_id = '"+str(Oddzial)+"'"
                                sql+=" AND magazyn_id = '"+str(wart)+"';" 
                                stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                                if stat <> 'OK':
                                    stat = 'BL SQL MAGAZ MM'
                                    wyn2.append((WierszeNr[i],6))
                                    dane.append(stat)
                                elif d==[]:
                                    stat = 'BL MAGAZ MM'
                                    wyn2.append((WierszeNr[i],6))
                                    dane.append(stat)

                        elif pole == 'magazyn_braki':
                            if wart == '':
                                stat = 'BR MAGAZ BRAKI'
                                wyn2.append((WierszeNr[i],8))
                                dane.append(stat)
                            else:
                                sql ="SELECT magazyn_id FROM rs_magazyny"
                                sql+=" WHERE firma_id = '"+self.firma_id+"'"
                                sql+=" AND oddzial_id = '"+str(Oddzial)+"'"
                                sql+=" AND magazyn_id = '"+str(wart)+"';" 
                                stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                                if stat <> 'OK':
                                    stat = 'BL SQL MAGAZ BRAKI'
                                    wyn2.append((WierszeNr[i],8))
                                    dane.append(stat)
                                elif d==[]:
                                    stat = 'BL MAGAZ BRAKI'
                                    wyn2.append((WierszeNr[i],8))
                                    dane.append(stat)

                        elif pole == 'kontrahent_id':
                            if wart == '':
                                stat = 'BR KTH'
                                wyn2.append((WierszeNr[i],10))
                                dane.append(stat)
                            else:
                                sql ="SELECT kontrahent_id FROM rs_kontrahenci"
                                sql+=" WHERE firma_id='"+self.firma_id+"'"
                                sql+=" AND kontrahent_id='"+str(wart)+"' AND aktywny;" 
                                stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                                if stat <> 'OK':
                                    stat = 'BL SQL KTH'
                                    wyn2.append((WierszeNr[i],10))
                                    dane.append(stat)
                                elif d==[]:
                                    stat = 'BL KTH'
                                    wyn2.append((WierszeNr[i],10))
                                    dane.append(stat)
                        
                        elif pole == 'kontrahent_id_braki':
                            if wart == '':
                                stat = 'BR KTHB'
                                wyn2.append((WierszeNr[i],10))
                                dane.append(stat)
                            else:
                                sql ="SELECT kontrahent_id FROM rs_kontrahenci"
                                sql+=" WHERE firma_id='"+self.firma_id+"'"
                                sql+=" AND kontrahent_id='"+str(wart)+"' AND aktywny;" 
                                stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                                if stat <> 'OK':
                                    stat = 'BL SQL KTHB'
                                    wyn2.append((WierszeNr[i],10))
                                    dane.append(stat)
                                elif d==[]:
                                    stat = 'BL KTHB'
                                    wyn2.append((WierszeNr[i],10))
                                    dane.append(stat)

        if stat == 'OK':
            if len(dane) > 0:
                stat = dane[0]
                                                        
        # wykonanie INSERT
        if stat=='OK':    
            sqlIns=''
            for i in xrange(len(Insert[0])):
                INSERT="INSERT INTO rs_produkcja_dokumenty "
                KOLUMNY="(firma_id"
                VALUES=" VALUES ('"+self.firma_id+"'"
                for j in xrange(len(Insert[0][i])):
                    pole=Insert[1][j]
                    wart=Insert[0][i][j]
                    if pole in ('oddzial_id','magazyn_pw','magazyn_mm','wersja_pw',
                                'magazyn_braki','kontrahent_id','wersja_pw_braki','kontrahent_id_braki'):
                        if len(wart)==0:
                            KOLUMNY+=","+pole
                            VALUES+=","+str('NULL')+""                        
                        else:
                            KOLUMNY+=","+pole
                            VALUES+=",'"+wart+"'"             
                KOLUMNY+=")"
                VALUES+=");"
                sqlIns+=INSERT+KOLUMNY+VALUES
            if sqlIns<>'': 
                stat,dump,dump,dump=self.PolSQL.Execute(rsglobal.Dekoduj(sqlIns),1)
                if stat<>'OK':
                    stat="Bd przy dodawaniu danych: "+stat   
                    dane.append(stat)                   

#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (1- insert 1 -select, 1 -delete)
#-------------------------------------------------------------------------------

if Fun in (1,5) and stat=='OK':
    SQL="SELECT pd.oddzial_id,o.opis "
    SQL+=", coalesce(pd.magazyn_pw,''), coalesce(m1.opis,'')"
    SQL+=", coalesce(pd.wersja_pw,''), coalesce(wc.opis,'')"
    SQL+=", coalesce(pd.kontrahent_id,''), coalesce(k.nazwa,'')"
    SQL+=", coalesce(pd.magazyn_mm,''), coalesce(m2.opis,'')"
    SQL+=", coalesce(pd.magazyn_braki,''), coalesce(m3.opis,'')"
    SQL+=", coalesce(pd.wersja_pw_braki,''), coalesce(wc2.opis,'')"
    SQL+=", coalesce(pd.kontrahent_id_braki,''), coalesce(k2.nazwa,'')"
    SQL+=" FROM rs_produkcja_dokumenty pd"
    SQL+=" LEFT OUTER JOIN rs_oddzialy o ON(pd.firma_id=o.firma_id AND pd.oddzial_id=o.oddzial_id)"
    SQL+=" LEFT OUTER JOIN rs_magazyny m1 ON(pd.firma_id=m1.firma_id AND pd.magazyn_pw=m1.magazyn_id)"
    SQL+=" LEFT OUTER JOIN rs_wersje_cenowe wc ON(pd.firma_id=wc.firma_id AND pd.wersja_pw=wc.kod)"
    SQL+=" LEFT OUTER JOIN rs_wersje_cenowe wc2 ON(pd.firma_id=wc2.firma_id AND pd.wersja_pw_braki=wc2.kod)"
    SQL+=" LEFT OUTER JOIN rs_magazyny m2 ON(pd.firma_id=m2.firma_id AND pd.magazyn_mm=m2.magazyn_id)"
    SQL+=" LEFT OUTER JOIN rs_magazyny m3 ON(pd.firma_id=m3.firma_id AND pd.magazyn_braki=m3.magazyn_id)"
    SQL+=" LEFT OUTER JOIN rs_kontrahenci k ON(pd.firma_id=k.firma_id AND pd.kontrahent_id=k.kontrahent_id)"
    SQL+=" LEFT OUTER JOIN rs_kontrahenci k2 ON(pd.firma_id=k2.firma_id AND pd.kontrahent_id_braki=k2.kontrahent_id)"
    SQL+=" WHERE pd.firma_id='"+self.firma_id+"'"
    SQL+=" ORDER BY pd.oddzial_id;"
    
    stat,dane,wyn1,wyn2=self.PolSQL.Execute(SQL,3)
    if stat<>'OK':
        stat="Bd przy pobieraniu danych: "+stat   
        dane.append(stat)
