# -*- coding: iso8859_2 -*-

#-----------------------------------------------------------------------------
# Name:        fs_projekty_dane.py
# Purpose:     wczytuje/edytuje dane projektu
#
# Author:      Micha Raburski
# Created:     2006/12/29
# RCS-ID:      $Id: fs_projekty_dane.py $
# Copyright:   (c) 2006 Record System
# Licence:     GNU GPL
#-----------------------------------------------------------------------------

#klucze = [Id,funkcja]

stat='OK'
Id=klucze[0]
Fun=klucze[-1]

UprPrzegladanie=((self.oddzial_id,'027010') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)
UprDodawanie=((self.oddzial_id,'027013') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)
UprEdycja=((self.oddzial_id,'027012') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID) or UprDodawanie

if not UprPrzegladanie:
    stat = 'Brak uprawnie do danych projektu'

#-------------------------------------------------------------------------------
#---   UPDATE DANYCH (4- bez pobierania,3- z pobieraniem)
#-------------------------------------------------------------------------------

if stat =='OK' and Fun in [3,4]:
    if not UprEdycja:
        stat="Brak uprawnie do edycji"     
        dane.append(stat)        
    else:
        stat = "OK"
        dane = []

        #---   Sprawdzenie danych
        for i in range(len(pola)):
            pole = pola[i]
            wart = wartosci[i]
                      
            if pole=='handlowiec_wiad' and stat== "OK":
                if wart <> '':
                    Select="SELECT kod FROM rs_handlowcy WHERE "
                    Select+="firma_id='"+self.firma_id+"' AND kod='"+wart+"';"
                    stat,d,dump,dump = self.PolSQL.Execute(Select ,3)
                    if stat=='OK':
                        if len(d) == 0:
                            stat = "Podany handlowiec wiodcay jest nieprawidowy"
                            dane.append(stat)
                            
            if pole=='dzial_wiad' and stat== "OK":
                if wart.strip()=='':
                    stat = 'Niewypenione pole "Dzia wiodcy"'
                    dane.append(stat)
                else:
                    Select="SELECT kod FROM rs_dzialy_firmy WHERE "
                    Select+="firma_id='"+self.firma_id+"' AND kod='"+wart+"';"
                    stat,d,dump,dump = self.PolSQL.Execute(Select ,3)
                    if stat=='OK':
                        if len(d) == 0:
                            stat = "Podany dzia wiodcay jest nieprawidowy"
                            dane.append(stat)

        #--- zapis
        if stat == 'OK':
            where = " WHERE firma_id='"+self.firma_id+"' AND projekt_id='"+Id+"';"
            upd = "UPDATE rs_projekty SET "
        
            for i in range(len(pola)):
                pole = pola[i]
                wart = wartosci[i]
                if pole in ['data_od','data_do']:
                    if wart=='    -  -  ':
                        upd=upd+pole+"=NULL,"
                    else:
                        upd=upd+pole+"='"+str(wart)+"',"
                        
                elif pole in ['nazwa','opis','handlowiec_wiad','dzial_wiad']:
                    upd=upd+pole+"='"+str(wart)+"',"

                elif pole =='aktywny':
                    upd=upd+pole+"='"+str(wart)+"',"
                    if wart == False:
                        spr= "SELECT data_do FROM rs_projekty "+where
                        stat, d, dump, dump = self.PolSQL.Execute(spr, 3)
                        if stat =='OK' and len(d)>0 and d[0][0] in ['None',None,'']:
                            if 'data_do' not in pola:
                                upd+='data_do=CURRENT_DATE,'

                elif pole in ['identyfikator']:
                    if wart=='':
                        upd=upd+pole+"=NULL,"
                    else:
                        upd=upd+pole+"='"+str(wart)+"',"

            upd = upd[0:len(upd)-1]+where
            stat,dump,dump,dump = self.PolSQL.Execute(upd ,1)
   

#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (5 -select, 3 -update z pobraniem, 1 -insert z pobraniem)
#-------------------------------------------------------------------------------

if (Fun in [5,3,1]) and (stat=='OK'):
    # pobranie danych sprawy
    Select="SELECT * FROM rs_projekty WHERE firma_id='"+self.firma_id+"' AND projekt_id='"+Id+"' ORDER BY projekt_id;"
    stat,dane,wyn1,tr = self.PolSQL.Execute(Select,3)

    #pobranie danych do opisow
    if len(dane) == 1:
        tr = rssql.RSTableRowset(dane,wyn1)

        #handlowiec
        if ((self.oddzial_id,'011220') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
            dump,d,dump,dump = self.PolSQL.Execute("SELECT opis FROM rs_handlowcy WHERE firma_id='"+self.firma_id+"' AND kod='"+tr.GetVal(0,"handlowiec_wiad")+"';" ,3)
            if len(d) == 0:
                wyn2.append('')
            else:
                wyn2.append(d[0][0])
        else:
            wyn2.append('Brak uprawnie do sownika. Poinformuj administratora.')

        #dzial
        if ((self.oddzial_id,'011290') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
            dump,d,dump,dump = self.PolSQL.Execute("SELECT opis FROM rs_dzialy_firmy WHERE firma_id='"+self.firma_id+"' AND kod='"+tr.GetVal(0,"dzial_wiad")+"';" ,3)
            if len(d) == 0:
                wyn2.append('')
            else:
                wyn2.append(d[0][0])
        else:
            wyn2.append('Brak uprawnie do sownika. Poinformuj administratora.')
        wyn2.append(str(UprEdycja))