# -*- coding: iso8859_2 -*-
#-----------------------------------------------------------------------------
# Name:        fs_projekty_dzialy.py
# Purpose:     wyswietla, dodaje,usuwa dane projektu
# Author:      Dariusz Boduch
# Created:     2010/01/06
# RCS-ID:      $Id: fs_projekty_dzialy.py$
# Copyright:   (c) 2009 Record System
# Licence:     GNU GPL
#-----------------------------------------------------------------------------
# 2017-08-23 Piotr Witkowski (10676) Refaktoryzacja

stat = 'OK'
wyn1 = []
wyn2 = []
dane = []

if not 'Funkcja' in klucze:
    stat = 'Brak podanej funkcji w kluczach'

if stat == 'OK':
    Funkcja = klucze['Funkcja']

    SlPar = {'ProjektId':[1,5],'Numer':[7,8,9],}

    Lista = rsglobal.SprawdzParametryWKluczach(SlPar, Funkcja, klucze)
    if Lista <> '':
        stat = "Uwaga: wywoanie funkcji fs_projekty_dzialy z numerem "+str(Funkcja)+" bez parametrw: "+Lista

    if Funkcja in [1,5]:
        ProjektId = str(klucze['ProjektId'])
    if Funkcja in [7,8,9]:
        Numer = str(klucze['Numer'])

    UprDzialy=(((self.oddzial_id,'027020') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID))
    UprHandl=(((self.oddzial_id,'011221') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID))
    UprKontr=(((self.oddzial_id,'012011') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID))

    UprModyf=(((self.oddzial_id,'027022') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID))
    UprUsuwanie=(((self.oddzial_id,'027024') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID))

if Funkcja == 1:
    Update=klucze['Update']
    Insert=klucze['Insert']
    Delete=klucze['Delete']


#-------------------------------------------------------------------------------
#-------   SPRAWDZANIE OPISU      ----------------------------------------------
#-------------------------------------------------------------------------------

if stat=="OK" and Funkcja == 7:
    sel1="SELECT opis FROM rs_dzialy_firmy WHERE firma_id='"+self.firma_id+"' AND kod='"+Numer+"';"
    stat,dane,dump,dump = self.PolSQL.Execute(sel1,3)   
    if stat<>'OK':
        stat=u"Bd przy sprawdzaniu opisu: "+stat   
        dane.append(stat)        
    if stat=='OK':
        if UprDzialy==0 and len(dane)<>0:
            stat='BR UPR SLOWN'
            dane.append(stat) 

#-------------------------------------------------------------------------------

if stat=="OK" and Funkcja == 8:
    sel2="SELECT opis FROM rs_handlowcy WHERE firma_id='"+self.firma_id+"' AND kod='"+Numer+"';"
    stat,dane,dump,dump = self.PolSQL.Execute(sel2,3)   
    if stat<>'OK':
        stat=u"Bd przy sprawdzaniu opisu: "+stat   
        dane.append(stat)        
    if stat=='OK':
        if UprHandl==0 and len(dane)<>0:
            stat='BR UPR SLOWN'
            dane.append(stat) 
            
#-------------------------------------------------------------------------------

if stat=="OK" and Funkcja == 9:
    sel3="SELECT nazwa FROM rs_kontrahenci WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+Numer+"';"
    stat,dane,dump,dump = self.PolSQL.Execute(sel3,3)   
    if stat<>'OK':
        stat=u"Bd przy sprawdzaniu opisu: "+stat   
        dane.append(stat)        
    if stat=='OK':
        if UprKontr==0 and len(dane)<>0:
            stat='BR UPR SLOWN'
            dane.append(stat) 


#-------------------------------------------------------------------------------
#-------------------------------------------------------------------------------
#-------  SPRAWDZANIE DELETE  --------------------------------------------------
#-------------------------------------------------------------------------------

if stat=="OK" and Funkcja == 1:
    if len(Delete[0])>0:
        if not UprUsuwanie:
            stat='Brak uprawnie do usuwania danych'
            dane.append(stat)    


#------------------------------------------------------------------------------------------------------------        
#-------------------------- DELETE    
#------------------------------------------------------------------------------------------------------------        
        
        if stat=='OK':
            sql=''
            for i in xrange(len(Delete[0])):
                DELETE="DELETE FROM rs_projekty_dzialy "
                WHERE="WHERE firma_id='"+self.firma_id+"' AND projekt_id='"+str(ProjektId)+"'"
                for j in xrange(len(Delete[0][i])):
                    pole=Delete[1][j]
                    wart=Delete[0][i][j]
                    if pole == 'numer':
                        WHERE+=" AND "+pole+"="+str(wart)+" "
                sql+=DELETE+WHERE+";"
            if sql<>'':
                stat,dump,dump,dump=self.PolSQL.Execute(rsglobal.Dekoduj(sql),1)
            if stat<>'OK':
                stat=u"Bd przy usuwaniu danych: "+stat   
                dane.append(stat)        


#-------------------------------------------------------------------------------
#---   UPDATE DANYCH (1)
#-------------------------------------------------------------------------------

if stat=="OK" and Funkcja == 1:
    if len(Update[0])>0:
        if not UprModyf:
            stat='Brak uprawnie do edycji danych'
            dane.append(stat)
        else:
            WierszeNr = Update[-1]
            for i in xrange(len(Update[0])):
                for j in xrange(len(Update[0][i])): 
                    #if stat == "OK":
                    pole=Update[0][i][j]
                    wart=Update[1][i][j]
                    if pole == 'dzial_id':
                        if str(wart).strip()=='':
                            stat = u'BR DZ'
                            wyn2.append((WierszeNr[i],0))
                            dane.append(stat)
                        else:
                            sql ="SELECT kod FROM rs_dzialy_firmy WHERE firma_id = '"+self.firma_id+"'"
                            sql+=" AND kod = '"+str(wart)+"';" 
                            stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                            if stat <> 'OK':
                                wyn2.append((WierszeNr[i],0))
                                dane.append(u'BL SQL DZ')
                            else:
                                if d==[]:
                                    wyn2.append((WierszeNr[i],0))
                                    dane.append(u'BL DZ')
                    elif pole == 'handlowiec_id':
                        if wart != '':
                            sql ="SELECT kod FROM rs_handlowcy WHERE firma_id = '"+self.firma_id+"'"
                            sql+=" AND kod = '"+str(wart)+"';" 
                            stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                            if stat <> 'OK':
                                wyn2.append((WierszeNr[i],0))
                                dane.append(u'BL SQL HANDL')
                            else:
                                if d==[]:
                                    wyn2.append((WierszeNr[i],2))
                                    dane.append(u'BL HANDL')
                    elif pole == 'kontrahent_id':
                        if wart != '':
                            sql ="SELECT kontrahent_id FROM rs_kontrahenci WHERE firma_id = '"+self.firma_id+"'"
                            sql+=" AND kontrahent_id = '"+str(wart)+"';" 
                            stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                            if stat <> 'OK':
                                wyn2.append((WierszeNr[i],0))
                                dane.append(u'BL SQL KONTR')
                            else:
                                if d==[]:
                                    wyn2.append((WierszeNr[i],6))
                                    dane.append(u'BL KONTR')

                    elif pole =='koszty_proc':
                        if wart < 0:
                            wyn2.append((WierszeNr[i],4))
                            dane.append(u'BL KOSZTY UJ')

                    elif pole =='przychody_proc':
                        if wart < 0:
                            wyn2.append((WierszeNr[i],5))
                            dane.append(u'BL PRZYCH UJ')
        if len(dane)>0:
            stat='Bdy modyfikacji danych'

        if stat=='OK':
            sql=''        
            for i in xrange(len(Update[0])):   
                UPDATE="UPDATE rs_projekty_dzialy "
                SET='SET '
                for j in xrange(len(Update[0][i])): 
                    pole=Update[0][i][j]
                    wart=Update[1][i][j]
                    if pole== 'dzial_id':
                        SET+=pole+"='"+wart+"',"
                    elif pole in ['handlowiec_id','kontrahent_id']:
                        if len(str(wart).strip())==0:
                            SET+=pole+"="+str('NULL')+","
                        else:
                            SET+=pole+"='"+wart+"',"
                    elif pole in ['koszty_proc', 'przychody_proc','numer']:
                        SET+=pole+"="+str(wart)+","
                SET=SET.strip(",")
                WHERE=" WHERE firma_id='"+self.firma_id+"' AND projekt_id ='"+str(ProjektId)+"' "
                for j in xrange(len(Update[2][i])): # petla po kluczu
                    pole=Update[3][j]
                    wart=rsglobal.Dekoduj(Update[2][i][j])
                    WHERE+=" AND "+pole+"="+str(wart)+" "
                WHERE+=";" 
                if str(SET)=='SET ':
                    pass
                else:
                    sql+=UPDATE+SET+WHERE;
            if sql<>'': 
                stat,dump,dump,dump=self.PolSQL.Execute(rsglobal.Dekoduj(sql),1)   
                if stat<>'OK':
                    stat=u"Bd przy modyfikowaniu danych: "+stat   
                    dane.append(stat)  


#----------------------------------------------------------------------------------------------------------------------
#---------Sprawdzanie danych do Insert------
#----------------------------------------------------------------------------------------------------------------------

if stat=="OK" and Funkcja == 1:
    if not UprModyf:
        stat='Brak uprawnie do dodawania danych'
        dane.append(stat)
    else:
        WierszeNr = Insert[-1]
        for i in xrange(len(Insert[0])):
            for j in xrange(len(Insert[0][i])): 
                pole=Insert[1][j]
                wart=Insert[0][i][j]
                if pole == 'dzial_id':
                    if wart.strip()=='':
                        wyn2.append((WierszeNr[i],0))
                        dane.append(u'BR DZ')
                    else:
                        sql ="SELECT kod FROM rs_dzialy_firmy WHERE firma_id = '"+self.firma_id+"'"
                        sql+=" AND kod = '"+str(wart)+"';"
                        stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                        if stat <> 'OK':
                            wyn2.append((WierszeNr[i],0))
                            dane.append(u'BL SQL DZ')
                        else:
                            if d==[]:
                                wyn2.append((WierszeNr[i],0))
                                dane.append(u'BL DZ')
                if pole == 'handlowiec_id':
                    if wart.strip() != '':
                        sql ="SELECT kod FROM rs_handlowcy WHERE firma_id = '"+self.firma_id+"'"
                        sql+=" AND kod = '"+str(wart)+"';"
                        stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                        if stat <> 'OK':
                            wyn2.append((WierszeNr[i],0))
                            dane.append(u'BL SQL HANDL')
                        else:
                            if d==[]:
                                wyn2.append((WierszeNr[i],2))
                                dane.append(u'BL HANDL')
                if pole == 'kontrahent_id':
                    if wart.strip() != '':
                        sql ="SELECT kontrahent_id FROM rs_kontrahenci WHERE firma_id = '"+self.firma_id+"'"
                        sql+=" AND kontrahent_id = '"+str(wart)+"';"
                        stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                        if stat <> 'OK':
                            wyn2.append((WierszeNr[i],0))
                            dane.append(u'BL SQL KONTR')
                        else:
                            if d==[]:
                                wyn2.append((WierszeNr[i],6))
                                dane.append(u'BL KONTR')

                elif pole == 'koszty_proc':
                    if wart < 0:
                        wyn2.append((WierszeNr[i], 4))
                        dane.append(u'BL KOSZTY UJ')

                elif pole == 'przychody_proc':
                    if wart < 0:
                        wyn2.append((WierszeNr[i], 5))
                        dane.append(u'BL PRZYCH UJ')

        if len(dane)>0:
            stat='Bdy dodawania danych'
                                                        
 #------------------------------------------------------------------------------------------------------------   
 #---------------   INSERT
 #-------------------------------------------------------------------------------------------------------------       

        if stat=='OK':    
            sqlIns=''
            for i in xrange(len(Insert[0])):
                INSERT="INSERT INTO rs_projekty_dzialy "
                KOLUMNY="(firma_id,projekt_id"
                VALUES=" VALUES ('"+self.firma_id+"','"+ProjektId+"'"
                for j in xrange(len(Insert[0][i])):
                    pole=Insert[1][j]
                    wart=Insert[0][i][j]
                    if pole == 'dzial_id':
                        KOLUMNY+=","+pole
                        VALUES+=",'"+wart+"'"  
                    elif pole in ['handlowiec_id', 'kontrahent_id']:
                        if len(wart)==0:
                            KOLUMNY+=","+pole
                            VALUES+=","+str('NULL')+""                        
                        else:
                            KOLUMNY+=","+pole
                            VALUES+=",'"+wart+"'"             
                    elif pole in ['koszty_proc', 'przychody_proc','numer']:
                        KOLUMNY+=","+pole
                        VALUES+=","+str(wart)+" "             
                KOLUMNY+=")"
                VALUES+=");"
                sqlIns+=INSERT+KOLUMNY+VALUES
            if sqlIns<>'': 
                stat,dump,dump,dump=self.PolSQL.Execute(rsglobal.Dekoduj(sqlIns),1)
                if stat<>'OK':
                    stat=u"Bd przy dodawaniu danych: "+stat   
                    dane.append(stat)

# ------------------------------------------------------------------------------------------------------------
#---   POBRANIE DANYCH (1- insert 1 -select, 1 -delete)
#------------------------------------------------------------------------------------------------------------

if stat=="OK" and Funkcja in [1,5]:
    # pobranie danych
    SQL="SELECT pd.dzial_id, "
    if UprDzialy<>0:
        SQL+=" df.opis "
    else:
        SQL+="'Brak uprawnie do przegldania danych dziaw'"
    SQL+=", coalesce(pd.handlowiec_id,''), "
    if UprHandl<>0:
        SQL+=" coalesce(h.opis,'') "
    else:
        SQL+="'Brak uprawnie do przegldania danych handlowcw'"
    SQL+=", pd.koszty_proc,pd.przychody_proc,coalesce(pd.kontrahent_id,''), "
    if UprKontr<>0:
        SQL+=" coalesce(k.nazwa,'') "
    else:
        SQL+="'Brak uprawnie do przegldania danych kontrahentw'"
    SQL+=",pd.numer "
    SQL+="FROM rs_projekty_dzialy pd "
    SQL+="LEFT OUTER JOIN rs_dzialy_firmy df ON(pd.firma_id=df.firma_id AND pd.dzial_id=df.kod) "
    SQL+="LEFT OUTER JOIN rs_handlowcy h ON(pd.firma_id=h.firma_id AND pd.handlowiec_id=h.kod) "
    SQL+="LEFT OUTER JOIN rs_kontrahenci k ON(pd.firma_id=k.firma_id AND pd.kontrahent_id=k.kontrahent_id) "
    SQL+="WHERE pd.firma_id='"+self.firma_id+"' AND pd.projekt_id='"+ProjektId+"' "
    SQL+="ORDER BY numer;"
    print SQL
    stat,dane,wyn1,wyn2=self.PolSQL.Execute(SQL,3)
    if stat<>'OK':
        stat=u"Bd przy pobieraniu danych: "+stat
        dane.append(stat)