
# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_projekty_wczytaj_opis.py
# Purpose:     wczytuje opis (nazwe) projektu uwzgldniajc uprawnienia operatora 
#
# Author:      Micha Raburski
# Created:     2006/12/30
# RCS-ID:      $Id: fs_projekty_wczytaj_opis.py $
# Copyright:   (c) 2006 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------
# 2009/12/27 pobranie opisu i symbolu projektu na podst symbolu lub identyfikatora
# mariusz rajfura  mantis:3016

# klucze[0] - symbol projektu lub identyfikator
# wraca z nazw projektu i symbolem

kod = rsglobal.Dekoduj(klucze[0]).strip()
dane=['','']

sql = "SELECT rsf_opis_symbol_projektu('"+self.firma_id+"','"+kod+"');"
stat,wyn,dump,dump = self.PolSQL.Execute(sql,3)
if stat <> 'OK':
    stat = 'Bd pobrania opisu projektu : '+stat
    dane[0] = stat
else:
    wyn = rsglobal.rseval(wyn[0][0])
    if len(wyn)>0:
        dane[0]=wyn[0]  #opis
        dane[1]=wyn[1]  #symbol
    
    #sprawdzenie uprawnien po wykonaniu funkcji rsf, ktora wykonuje ewent.zamiane identyfikatora na projekt_id
    #brak uprawnien do projektw nie powinien blokowac pracy jesli operator zna identyfikatory projektow
    #udana zamiana identyfikator->projekt_id umozliwia zapisanie danych
    #identycznie jest w przypadku innych slownikow, kartotek - brak uprawnien do przegladania nie blokuje
    #mozliwosci zapisania prawidlowych danych. tyle tylko, ze operator nie ma opisow
    if not ((self.oddzial_id,'027010') in self.uprawnienia or self.operator_id == STANDARD_OPERATOR_ID):
        #jesli brak uprawnien, to zamiast opisu projektu komunikat o braku uprawnien
        dane[0]='Brak uprawnie do projektw. Poinformuj administratora.'
