
# -*- coding: iso8859_2 -*-

#-------------------------------------------------------------------------------
# Name:        fs_przeceny_klucz.py
# Purpose:     dodaje przecen
# Author:      Micha Raburski
# Created:     2007/01/11
# RCS-ID:      $Id: fs_przeceny_klucz.py $
# Copyright:   (c) 2007 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------
#                           modyfikacje Pawe Wjcikowski 13.11.2009r.          

Mag = klucze[0]
Data = klucze[1]
Nr = klucze[2]
Fun = klucze[3]

DataOdF = pola[0]
DataDoF = pola[1]
MagF = pola[2]

stat = "OK"
dane = []
UprMag=False

UprDodawanie=((self.oddzial_id,'034013') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)


#-------------------------------------------------------------------------------
#pobranie magazynw do ktrych sa uprawnienia do przecen
#-------------------------------------------------------------------------------

LMag=["ZASLEPKA"]
if self.operator_id <> STANDARD_OPERATOR_ID:
    Select= "SELECT magazyn_id FROM rs_magazyny_upr WHERE firma_id='"+self.firma_id+"' AND"
    Select+=" przeceny AND operator_id in "+str(self.operatorzy).replace("[","(").replace("]",")")+";"
    stat,dane,wyn1,tr = self.PolSQL.Execute(Select,3)
    if stat<>'OK':
        stat="Bdy przy sprawdzaniu uprawnie do magazynw"
    else:
        for m in dane:
            LMag.append(rsglobal.Dekoduj(m[0]))


#-------------------------------------------------------------------------------
#---- ZAPIS PRZECENY ---(6)
#-------------------------------------------------------------------------------

if Fun == 6:           
    #dodawanie nowej przeceny
    if not UprDodawanie:
        stat="Brak uprawnie do dodawania przecen"
        dane.append(stat)
    if stat=='OK':
        Select="SELECT przeceny FROM rs_magazyny_upr WHERE firma_id='"+self.firma_id+"' AND operator_id='"+str(self.operator_id)+"' "
        Select+=" AND magazyn_id='"+str(Mag)+"';"        
        stat,MAG,dump,dump = self.PolSQL.Execute(Select,3)                 
        if stat<>'OK':
            stat = "Bdy przy sprawdzaniu uprawnie : "+stat
            dane.append(stat)
        else:
            if self.operator_id <> STANDARD_OPERATOR_ID:
                if len(MAG)==0 or not MAG[0][0]:                
                    stat="Brak uprawnie do dodawania przecen w danym magazynie."
                    dane.append(stat)      
    if stat=='OK':
        #sprawdzenie magazynu
        if Mag=='':
            stat='BR MAG'
            wart.append(stat)
        else:
            Mag = (Mag+'    ')[0:4]
            SQL="SELECT magazyn_id FROM rs_magazyny WHERE firma_id='"+self.firma_id+"' "
            SQL+="AND magazyn_id='"+str(Mag)+"';"
            ok,wyn,dump,dump = self.PolSQL.Execute(SQL,3)
            if ok=='OK':
                if len(wyn)==0:
                    stat='BL MAG'
                    wart.append(stat)
            else:
                stat='BL OG'

            #sprawdzenie istnienia przeceny
            Filtr="WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+Mag+"'"
            Filtr+=" AND data_przec='"+Data+"' AND numer_przec="+str(Nr)
            ok,wyn,wyn1,tr = self.PolSQL.Execute("SELECT stan FROM rs_przeceny "+Filtr+";",3)        
            if ok=='OK':
                if len(wyn)<>0:
                    stat='BL PRZ'
                    wart.append(stat)
            else:
                stat='BL OG'
                
            #dodawanie nagwka przeceny
            Ins="INSERT INTO rs_przeceny (firma_id,magazyn_id,data_przec,numer_przec,stan,kwota_przeceny)"
            Ins+=" VALUES ('"+self.firma_id+"','"+Mag+"','"+Data+"',"+str(Nr)+",'W',0);"
            self.PolSQL.Execute(Ins,1)
        
    if stat=='OK':
        # pobranie przecen
        Filtr="WHERE p.firma_id='"+self.firma_id+"'"
        if MagF <> '':
            Filtr+=" AND p.magazyn_id='"+MagF+"'"
        if DataOdF <> '    -  -  ':
            Filtr+=" AND p.data_przec>='"+DataOdF+"'"                
        if DataDoF <> '    -  -  ':
            Filtr+=" AND p.data_przec<='"+DataDoF+"'"  
        if self.operator_id <> STANDARD_OPERATOR_ID:
            Filtr=Filtr+" AND p.magazyn_id IN ("+str(LMag)[1:-1]+")"                          
        Select="SELECT p.stan,p.magazyn_id||' - '||m.opis,p.data_przec,p.numer_przec,"
        Select+="p.kwota_przeceny FROM rs_przeceny p LEFT OUTER JOIN rs_magazyny m "
        Select+="USING (firma_id,magazyn_id) "+Filtr+";"
        stat,wyn1,dump,dump = self.PolSQL.Execute(Select,3) 
        if stat<>'OK':
            stat = "Bdy przy zapisie danych: "+stat
            dane.append(stat)
            

#-------------------------------------------------------------------------------
#---- SPRAWDZANIE NASTEPNEGO NUMERU ---(7)
#-------------------------------------------------------------------------------

if Fun == 7:    
    Warunek = "magazyn_id=\\\'"+Mag+"\\\' AND data_przec=\\\'"+Data+"\\\'"
    stat,dane,dump,dump = self.PolSQL.Execute("SELECT rsf_klucz_where_new('rs_przeceny','"+Warunek+"','numer_przec');",3)     
    if stat<>'OK':
        stat = "Bdy pobierania numeru : "+stat
        dane.append(stat)