
# -*- coding: iso8859_2 -*-

#-----------------------------------------------------------------------------
# Name:        fs_przeceny_pozycje.py
# Purpose:     wczytuje/usuwa dane pozycji przecen
#
# Author:      Marcin Grzeda
# Created:     2006/01/12
# RCS-ID:      $Id: fs_przeceny_pozycje.py $
# Copyright:   (c) 2006 Record System
# Licence:     GNU GPL
#-----------------------------------------------------------------------------

#klucze=[Data,Magazyn,Kategoria,Artykul,funkcja]

MagId=klucze[0]
DataPrzeceny=klucze[1]
NumerPrzeceny=str(klucze[2])

Art=klucze[3]
Data=klucze[4]
DokumentId=klucze[5]
Numer=str(klucze[6])
NrPoz=str(klucze[7])
NrPpoz=str(klucze[8])
stat='OK'
#INSERT
if (klucze[-1] ==1):
    if ((self.oddzial_id,'034023') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
        # sprawdzenie czy bdzie co do wstawienia
        SQL="SELECT firma_id,magazyn_id,'"+DataPrzeceny+"','"+NumerPrzeceny+"',artykul_id,data,dokument_id,numer,"
        SQL+="nr_poz,nr_ppoz,nr_serii,ilosc1,ilosc2,cena1,cena2,cena1,cena2,cena_wal1,cena_wal2,cena_wal1,cena_wal2 "
        SQL+="FROM rs_artykuly_przyjecia WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+MagId+"'"
        SQL+=" AND artykul_id='"+Art+"' AND rezerwacja1=0 AND ilosc1>0 AND data<='"+DataPrzeceny+"' AND NOT wirtualne;"         
        stat,DTest,dump,dump=self.PolSQL.Execute(SQL,3)
        if stat <>'OK':
            stat = u'Bd pobrania danych do wstawienia: '+stat
        elif len(DTest) == 0:
            stat = u'Brak wybranego artykuu na magazynie'
        
        if stat == 'OK':
            Ins="INSERT INTO rs_przeceny_pozycje " 
            Ins=Ins+"(firma_id,magazyn_id,data_przec,numer_przec,artykul_id,data,dokument_id,numer,"
            Ins=Ins+"nr_poz,nr_ppoz,nr_serii,ilosc1,ilosc2,cena1,cena2,nowa_cena1,nowa_cena2,cena_wal1,cena_wal2,nowa_cena_wal1,nowa_cena_wal2) "
            Select="SELECT firma_id,magazyn_id,'"+DataPrzeceny+"','"+NumerPrzeceny+"',artykul_id,data,dokument_id,numer,"
            Select=Select+"nr_poz,nr_ppoz,nr_serii,ilosc1,ilosc2,cena1,cena2,cena1,cena2,cena_wal1,cena_wal2,cena_wal1,cena_wal2 "
            From="FROM rs_artykuly_przyjecia "
            Where="WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+MagId+"' AND artykul_id='"+Art+"' AND rezerwacja1=0 AND ilosc1>0 AND data<='"+DataPrzeceny+"' AND NOT wirtualne;" 
            #dodanie pozycji 
            Sql=Ins+Select+From+Where
            #ustawienie rezerwacji na pen (zablokowanie pozycji)
            Upd="UPDATE rs_artykuly_przyjecia SET rezerwacja1=ilosc1, rezerwacja2=ilosc2 "+Where
            Sql=Sql+Upd
            stat,dump,dump,dump=self.PolSQL.Execute(Sql,1)
    else:
        stat='UPR DOD'

#DELETE
if (klucze[-1] ==6):
    if ((self.oddzial_id,'034024') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
        #Usunicie pozycji przeceny
        Sql="DELETE FROM rs_przeceny_pozycje WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+MagId+"' AND data_przec='"+DataPrzeceny+"' AND numer_przec='"+NumerPrzeceny+"' AND artykul_id='"+Art+"' AND data='"+Data+"' AND dokument_id='"+DokumentId+"' AND numer='"+Numer+"' AND nr_poz='"+NrPoz+"' AND nr_ppoz='"+NrPpoz+"';"      
        #Zdjcie rezerwacji z artykuw przyjcia
        Where="WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+MagId+"' AND artykul_id='"+Art+"' AND rezerwacja1=ilosc1 AND ilosc1>0 AND data='"+Data+"' AND dokument_id='"+DokumentId+"' AND numer="+Numer+" AND nr_poz="+NrPoz+" AND nr_ppoz="+NrPpoz+" AND NOT wirtualne;" 
        Upd="UPDATE rs_artykuly_przyjecia SET rezerwacja1=0, rezerwacja2=0 "+Where
        Sql=Sql+Upd
        #rsglobal.ZapiszDoLogow(Sql,1)
        stat,dump,dump,dump = self.PolSQL.Execute(Sql,1)    
    else:
        stat='UPR US'
            

if stat=='OK':
#---   POBRANIE DANYCH (1 - insert, 5 -select, 6- delete)
    if (klucze[-1] in [1,5,6]):
    # pobranie danych o pozycjach
        if ((self.oddzial_id,'034021') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
            stat,DaneDwieJM,dump,dump=self.PolSQL.Execute("SELECT dwie_jedn_miar FROM rs_firmy WHERE firma_id='"+self.firma_id+"'",3)
            DJM=DaneDwieJM[0][0]
            Sql="SELECT ip.artykul_id,a.nazwa,ap.cecha1_opis, ap.cecha1_wartosc,rsf_podaj_parametry_cechy(ap.firma_id,ap.cecha1_opis,ap.cecha1_wartosc,'opis'),ip.cena1,ip.nowa_cena1,ip.cena_wal1,ip.nowa_cena_wal1,ip.ilosc1,lower(a.jm1),ip.nr_serii,"
            Sql+="ip.cena2,ip.nowa_cena2,ip.cena_wal2,ip.nowa_cena_wal2,ip.ilosc2,lower(a.jm2),"
            Sql+="ip.data,ip.dokument_id,ip.numer,ip.nr_poz,ip.nr_ppoz"
            Sql+=" FROM rs_przeceny_pozycje ip INNER JOIN rs_artykuly a USING (firma_id,artykul_id) "
            Sql+=" INNER JOIN rs_artykuly_przyjecia ap USING(firma_id,magazyn_id,data,dokument_id,numer,nr_poz,nr_ppoz)"
            Sql+=" WHERE ip.magazyn_id='"+MagId+"' AND ip.data_przec='"+DataPrzeceny+"' AND ip.numer_przec='"+NumerPrzeceny+"'"+" AND ip.firma_id='"+self.firma_id+"' ORDER BY artykul_id;"
            stat,dane,wyn1,tr = self.PolSQL.Execute(Sql,3)
        else:
            stat='UPR PRZ'    

    else:
        stat='BDNA FUNKCJA : '+str(klucze[-1])