#!/usr/bin/python
# -*- coding: iso8859_2 -*-
#-----------------------------------------------------------------------------
# Name:             fs_przesylki.py
# Purpose:          przeglda przesyki
# Author:           Dariusz Boduch
# Created:          2010/06/30
# RCS-ID:           $Id: fs_przesylki.py $
# Copyright:        (c) 2007 RecordSystem
# Licence:          GNU GPL
#-----------------------------------------------------------------------------

#klucze (czyli filtr):
#DataOdF
#DataDoF
#ListPrzewF
#FirmaPrzewF
#StanF
#pozostae (z grida)
#Data
#Numer

import time

DataOdF=klucze[0]
DataDoF=klucze[1]
ListPrzewF=klucze[2]
FirmaPrzewF=klucze[3]
StanF=klucze[4]
Data=klucze[5]
Numer=klucze[6]
Fun=klucze[-1]
stat = "OK"
dane = []
wyn2=[]

puste_pola = ['    -  -  ','',[]]

if stat=='OK':
    if DataOdF not in puste_pola:
        if not rsglobal.SprawdzCzyToData(DataOdF):
            stat='BL DATAOD'
            dane.append(stat)

if stat=='OK':
    if DataDoF not in puste_pola:
        if not rsglobal.SprawdzCzyToData(DataDoF):
            stat='BL DATADO'
            dane.append(stat)    

if stat=='OK' and DataOdF not in puste_pola and DataDoF not in puste_pola:
    if DataDoF<DataOdF:
        stat='BL ZAKR DAT'
        dane.append(stat)
if stat=='OK' and Data not in puste_pola:
     if not rsglobal.SprawdzCzyToData(Data):
         stat='BL DATA'


if self.operator_id == STANDARD_OPERATOR_ID:
    UprEdy=True
    UprDel=True
    UprIns=True
    UprZam=True
    UprOtw=True
else:
    UprEdy=(self.oddzial_id,'231012') in self.uprawnienia
    UprDel=(self.oddzial_id,'231014') in self.uprawnienia
    UprIns=(self.oddzial_id,'231013') in self.uprawnienia
    UprZam=(self.oddzial_id,'231018') in self.uprawnienia
    UprOtw=(self.oddzial_id,'231019') in self.uprawnienia

#-------------------------------------------------------------------------------
#---------- USUWANIE
#-------------------------------------------------------------------------------

if Fun in [6] and stat=='OK':    
    if not UprDel:
        stat="UPR DEL"   
        dane.append(stat)
    if stat=='OK':
        Filtr = "firma_id='"+self.firma_id+"' AND data = '"+Data+"' AND numer = "+str(Numer)
        #czy przesyka w stanie W
        stat,stan,dump,dump=self.PolSQL.Execute('Select stan from rs_przesylki where '+Filtr+';' ,3)
        if stat<>'OK':
            stat='BL SQL STAN'
            dane.append(stat)
        else:
            if stan[0][0]<>'W':
                stat='BL STAN'
                dane.append(stat)
        if stat=='OK':
            sql="UPDATE rs_dokumenty_magazynowe SET p_data=NULL , p_numer=NULL "
            sql+="WHERE firma_id='"+self.firma_id+"' AND p_data='"+Data+"' AND p_numer = "+str(Numer)+"; "
            sql+="DELETE FROM rs_przesylki WHERE " + Filtr + "; "
            
            stat,dump,dump,dump=self.PolSQL.Execute(sql,1)
            if stat<>'OK':
                stat='BL SQL DEL'
                dane.append(stat)

#-------------------------------------------------------------------------------
#------------- ZAMYKANIE
#-------------------------------------------------------------------------------

if Fun in [7] and stat=='OK':
    if not UprZam:
        stat='UPR ZAM'
        dane.append(stat)
    if stat=='OK':
        Filtr = "firma_id='"+self.firma_id+"' AND data = '"+Data+"' AND numer = "+str(Numer)
        #czy przesyka w stanie W
        stat,stan,dump,dump=self.PolSQL.Execute('Select stan from rs_przesylki where '+Filtr+';' ,3)
        if stat<>'OK':
            stat='BL SQL STAN'
            dane.append(stat)
        else:
            if stan[0][0]<>'W':
                stat='BL STAN'
                dane.append(stat)
        #Czy przesyka ma pozycje
        stat,poz,dump,dump=self.PolSQL.Execute("Select * from rs_dokumenty_magazynowe where firma_id='"+self.firma_id+"' AND p_data = '"+Data+"' AND p_numer = "+str(Numer)+" ; ",3)
        if stat<>'OK':
            stat='BL SQL POZ'
            dane.append(stat)
        else:
            if len(poz)==0:
                stat='BR POZ'
                dane.append(stat)
        
        if stat=='OK':
            stat,dump,dump,dump=self.PolSQL.Execute("UPDATE rs_przesylki SET stan='Z' WHERE "+Filtr+";",1)
            if stat<>'OK':
                stat='BL SQL UPDZ'
                dane.append(stat)            

#-------------------------------------------------------------------------------
#---------- OTWIERANIE
#-------------------------------------------------------------------------------

if Fun in [8] and stat=='OK':
    if not UprOtw:
        stat='UPR OTW'
        dane.append(stat)
    if stat=='OK':
        Filtr = "firma_id='"+self.firma_id+"' AND data = '"+Data+"' AND numer = "+str(Numer)
        #czy przesyka w stanie Z
        stat,stan,dump,dump=self.PolSQL.Execute('Select stan from rs_przesylki where '+Filtr+';' ,3)
        if stat<>'OK':
            stat='BL SQL STAN'
            dane.append(stat)
        else:
            if stan[0][0]<>'Z':
                stat='BL STAN Z'
                dane.append(stat)
        if stat=='OK':
            stat,dump,dump,dump=self.PolSQL.Execute("UPDATE rs_przesylki SET stan='W' WHERE "+Filtr+";" ,1)
            if stat<>'OK':
                stat='BL SQL UPDW'
                dane.append(stat)            

#-------------------------------------------------------------------------------
#---------- POBRANIE DANYCH
#-------------------------------------------------------------------------------

if Fun in [5,6,7,8,1] and stat=='OK':
    Filtr = " z.firma_id = '" + self.firma_id+"'"
    if DataOdF not in puste_pola:
        Filtr+=" AND z.data>='"+DataOdF+"'"
    if DataDoF not in puste_pola:
        Filtr+=" AND z.data<='"+DataDoF+"'"
    if ListPrzewF.strip()<>'':
        Filtr+=" AND z.list_przewozowy LIKE '"+ListPrzewF+"%'"
    if FirmaPrzewF.strip()<>'':
        Filtr+=" AND z.firma_przewozowa='"+FirmaPrzewF+"'"
    if StanF.strip()<>'':
        Filtr+=" AND z.stan='"+StanF+"'" 
        
    SELECT="SELECT  z.stan,z.data,z.numer,CASE WHEN z.firma_przewozowa is NULL THEN '' ELSE z.firma_przewozowa||' - '|| k.nazwa END,COALESCE(z.list_przewozowy,''),liczba_palet "
    FROM=" FROM rs_przesylki z LEFT OUTER JOIN rs_kontrahenci k ON (z.firma_id=k.firma_id AND z.firma_przewozowa=k.kontrahent_id) " 
    WHERE=" WHERE "+Filtr
    ORDER=" ORDER BY z.data DESC, z.numer DESC ;"	
    
    sql=SELECT+FROM+WHERE+ORDER
    stat,dane,wyn1,wyn2=self.PolSQL.Execute(rsglobal.Dekoduj(sql),3)
    if stat!="OK":
        stat='BL SQL PRZ'
        dane.append(stat)