
# -*- coding: iso8859_2 -*-

#-------------------------------------------------------------------------------
# Name:        fs_raporty_dane.py
# Purpose:     operacje na tabeli rs_raporty
# Author:      Pawe Wjcikowski
# Created:     2009/08/17
# RCS-ID:      $Id: fs_raporty_dane.py$
# Copyright:   (c) 2009 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

Symbol=klucze[0]
Nazwa=klucze[1]
Agata=klucze[2]
Znakowy=klucze[3]
Graficzny=klucze[4]
Naglowek=klucze[5]
Kolumny=klucze[6]
SQLRaport=klucze[7]
Tabela=klucze[8]

Fun = klucze[-1]
stat = "OK"
dane = []


#-------------------------------------------------------------------------------
#---   SPRAWDZANIE DANYCH (1,2,3,4)
#-------------------------------------------------------------------------------

if (Fun in [1,2,3,4]) and (stat=='OK'):  
    if not (Agata or Znakowy or Graficzny):
        stat = "BR RAP"
        dane.append(stat) 
            
    elif Agata==False:
        if str(Naglowek) == '':
            stat = "BR NAGL"
            dane.append(stat) 
        
        elif str(Kolumny) == '':
            stat = "BR KOL"
            dane.append(stat)

        elif str(SQLRaport) == '':
            stat = "BR SQL"
            dane.append(stat)
            
    elif str(Tabela) == '':
        stat = "BR PLIK"
        dane.append(stat) 
        
    else:  
        for i in range(len(pola)):
            pole = pola[i]
            wart = wartosci[i]    
            if stat=="OK":               
                if pole=='nazwa':
                    if str(wart)=='':
                        stat = "BR NAZWA"
                        dane.append(stat)     
                if pole == 'wys_okna':
                    if wart <=0:
                        stat = "BL WYS"
                        dane.append(stat)    
                if pole == 'szer_okna':
                    if wart <=0:
                        stat = "BL SZER"
                        dane.append(stat)      


#-------------------------------------------------------------------------------
#---   INSERT DANYCH (1- bez pobierania,2- z pobieraniem)
#-------------------------------------------------------------------------------

if Fun in [1,2] and stat=='OK':    
    ins = "INSERT INTO rs_raporty"
    Pola="firma_id,raport_id"
    Wartosci="'"+self.firma_id+"','"+Symbol+"'"
    for i in range(len(pola)):
        pole = pola[i]
        wart = wartosci[i]
        if pole in ['nazwa','czcionka_pdf','tabela','modul_id','autor','wys_okna',
                    'szer_okna','czy_znakowy','czy_graficzny','czy_agata','naglowek','kolumny',
                    'sql_przed','sql_raport','sql_po']:            
            Pola= Pola+","+pole
            if str(wart).strip()=='':
                Wartosci= Wartosci+",NULL"
            else:
                Wartosci= Wartosci+",'"+str(wart)+"'"
                    
    ins = ins+" ("+Pola+") VALUES ("+Wartosci+");"        
    stat,dump,dump,dump = self.PolSQL.Execute(ins ,1)
    if stat<>'OK':
        stat = 'Bdy dodawania danych:'+stat
        dane.append(stat)             

#-------------------------------------------------------------------------------
#---   UPDATE DANYCH (4- bez pobierania,3- z pobieraniem)
#-------------------------------------------------------------------------------

if Fun in [3,4] and stat=='OK':    
    where = " WHERE firma_id='"+self.firma_id+"' AND raport_id='"+Symbol+"'"
    upd = "UPDATE rs_raporty SET "
    for i in range(len(pola)):
        pole = pola[i]
        wart = wartosci[i]
        if pole in []:
            if wart=='':
                upd=upd+pole+"=NULL,"
            else:
                upd=upd+pole+"="+str(wart)+","
        elif pole in ['raport_id','nazwa','czcionka_pdf','tabela','modul_id','autor','wys_okna',
                      'szer_okna','czy_znakowy','czy_graficzny','czy_agata','naglowek','kolumny',
                      'sql_przed','sql_raport','sql_po']:
            if wart=='':
                upd=upd+pole+"=NULL,"
            else:
                upd=upd+pole+"='"+str(wart)+"',"   
    upd = upd[0:len(upd)-1]+where                        
    stat,dump,dump,dump = self.PolSQL.Execute(upd ,1)         
    if stat!="OK":
        stat="Bd przy modyfikowaniu danych : "+stat   
        dane.append(stat)   
            

#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (5 -select 3-update 1-insert)
#-------------------------------------------------------------------------------

if (Fun in [5,3,1]) and (stat=='OK'):
    Select="SELECT * FROM rs_raporty WHERE raport_id='"+str(Symbol)+"' AND firma_id='"+self.firma_id+"'"
    stat,dane,wyn1,tr = self.PolSQL.Execute(Select,3)
    if stat<>'OK':
        stat = 'Bdy pobierania danych:'+stat
        dane.append(stat)