#!/usr/bin/python
# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:             fs_raporty_wyciagi_import.py
# Purpose:          
# Author:           Jan Raburski
# Created:          
# RCS-ID:           $Id: fs_raporty_wyciagi_import.py $
# Copyright:        (c) 2011 RecordSystem
# Licence:          GNU GPL
# 2014.07.11 - Jan Raburski - wprowadzenie obslugi dowolnej liczby kolumn z trescia
# 2014.11.11 - Jan Raburski - obsluga multicash i PekaoBiznes
# 2021-01-29 - Jan Raburski - obsluga ING
#-------------------------------------------------------------------------------


def ZrobListeZMT5(Wiersze):
    # zmiana wg formatu sta MT940 np.ING
    Wiersze1 = []
    stat = 'OK'
    i = 0
    while i < len(Wiersze):
        wiersz1 = Wiersze[i]
        if wiersz1[0:5] == ':62F:':
            # stopka - koniec
            break
        if wiersz1[0:4] != ':61:':
            # czekamy na kolejny wiersz
            i += 1
            continue

        # rsglobal.ZapiszDoLogow('!!!'+ wiersz,1)

        j = wiersz1.find(',')
        if j > 0:
            znak = ''
            if wiersz1[14] == 'D':
                znak = '-'
            kwota = znak + wiersz1[15:j + 3]
        else:
            kwota = '0'

        while wiersz1[0:4] != ':86:':
            i += 1
            wiersz1 = Wiersze[i]

        tresc = ''
        konto = ''
        nazwa = ''
        operacja = ''
        wirtualny = '-'
        if wiersz1[0:20] == ':86:rach. wirtualny:':
            # platnosci masowe
            konto = wiersz1[20:]
            i += 1
            wiersz1 = Wiersze[i]
            j = wiersz1.find('od:')
            nazwa = wiersz1[j + 3:]
            i += 1
            wiersz1 = Wiersze[i]
            nazwa += wiersz1
            i += 1
            wiersz1 = Wiersze[i]
            tresc = wiersz1[5:]
            Wiersze1.append([konto, nazwa, tresc, kwota])
            continue
        if wiersz1[0:4] == ':86:':
            operacja += wiersz1[4:8]
            tresc += operacja + ' '
            i += 1
            wiersz1 = Wiersze[i]
        if wiersz1[0:4] == ':86:':
            i += 1
            wiersz1 = Wiersze[i]
        if wiersz1[0:3] == '~00':
            #tresc += wiersz1[3:]
            i += 1
            wiersz1 = Wiersze[i]
        if wiersz1[0:3] == '~10':
            i += 1
            wiersz1 = Wiersze[i]
        if wiersz1[0:3] == '~20':
            tresc += wiersz1[3:]
            i += 1
            wiersz1 = Wiersze[i]
        if wiersz1[0:3] == '~21':
            tresc += wiersz1[3:]
            i += 1
            wiersz1 = Wiersze[i]
        if wiersz1[0:3] == '~22':
            tresc += wiersz1[3:]
            i += 1
            wiersz1 = Wiersze[i]
        if wiersz1[0:3] == '~23':
            tresc += wiersz1[3:]
            i += 1
            wiersz1 = Wiersze[i]
        if wiersz1[0:3] == '~24':
            tresc += wiersz1[3:]
            i += 1
            wiersz1 = Wiersze[i]
        if wiersz1[0:3] == '~25':
            tresc += wiersz1[3:]
            i += 1
            wiersz1 = Wiersze[i]
        # nieciekawe opuszczamy
        if wiersz1[0:3] == '~26':
            i += 1
            wiersz1 = Wiersze[i]
        if wiersz1[0:3] == '~27':
            i += 1
            wiersz1 = Wiersze[i]
        if wiersz1[0:3] == '~28':
            i += 1
            wiersz1 = Wiersze[i]
        if wiersz1[0:3] == '~29':
            wirtualny = wiersz1[3:].strip()
            if wirtualny == '':
                wirtualny = '-'
            i += 1
            wiersz1 = Wiersze[i]
        if wiersz1[0:3] == '~30':
            i += 1
            wiersz1 = Wiersze[i]
        if wiersz1[0:3] == '~31':
            if wiersz1.find('~32') == -1:
                i += 1
                wiersz1 = Wiersze[i]
            else:
                wiersz1 = wiersz1[wiersz1.find('~32'):]
        # nazwa
        if wiersz1[0:3] == '~32':
            nazwa += wiersz1[3:]
            i += 1
            wiersz1 = Wiersze[i]
        # nieciekawe opuszczamy
        if wiersz1[0:3] == '~33':
            nazwa += wiersz1[3:]
            i += 1
            wiersz1 = Wiersze[i]
        if wiersz1[0:3] == '~34':
            i += 1
            wiersz1 = Wiersze[i]
        if wiersz1[0:3] == '~38':
            konto += wiersz1[5:]
            i += 1
            wiersz1 = Wiersze[i]
        if wiersz1[0:3] == '~60':
            i += 1
            wiersz1 = Wiersze[i]
        if wiersz1[0:3] == '~63':
            i += 1
            wiersz1 = Wiersze[i]
        if wiersz1[0:3] == '~64':
            # wirtualny dla millenium
            wirtualny = wiersz1[3:].strip()
            if wirtualny == '':
                wirtualny = '-'
            i += 1
            wiersz1 = Wiersze[i]

        tresc = tresc.replace(chr(10), '').replace(chr(13), '')
        konto = konto.replace(chr(10), '').replace(chr(13), '')
        nazwa = nazwa.replace(chr(10), '').replace(chr(13), '')
        wirtualny = wirtualny.replace(chr(10), '').replace(chr(13), '')
        # rsglobal.ZapiszDoLogow('!!!'+ tresc+'!!!'+nazwa,1)
        # if wirtualny<>'':
        #    Wiersze1.append([konto,nazwa,tresc,kwota,wirtualny])
        # else:
        #    Wiersze1.append([konto,nazwa,tresc,kwota,''])
        Wiersze1.append([konto, nazwa, tresc, kwota, wirtualny])

    return (stat, Wiersze1)

##------------------------------------------------

def ZrobListeZMT4(Wiersze):
# zmiana wg formatu sta np.PekaoBiznes
    Wiersze1=[]
    stat='OK'
    i=0
    while i < len(Wiersze):
        wiersz1=Wiersze[i]
        if wiersz1[0:5]==':62F:':
            # stopka - koniec
            break
        if wiersz1[0:4]<>':61:':
            # czekamy na kolejny wiersz
            i+=1
            continue
        
        #rsglobal.ZapiszDoLogow('!!!'+ wiersz,1)
        
        j=wiersz1.find(',')
        if j>0:
            znak=''
            if wiersz1[14]=='D':
                znak='-'
            kwota=znak+wiersz1[16:j+3]
        else:
            kwota='0'
            
        while wiersz1[0:4]<>':86:':
            i+=1
            wiersz1=Wiersze[i]
        
        tresc=''
        konto=''
        nazwa=''
        operacja=''
        wirtualny='-'
        if wiersz1[0:20]==':86:rach. wirtualny:':
            # platnosci masowe
            konto=wiersz1[20:]
            i+=1
            wiersz1=Wiersze[i]
            j=wiersz1.find('od:')
            nazwa=wiersz1[j+3:]
            i+=1
            wiersz1=Wiersze[i]
            nazwa+=wiersz1
            i+=1
            wiersz1=Wiersze[i]
            tresc=wiersz1[5:]
            Wiersze1.append([konto,nazwa,tresc,kwota])
            continue
        if wiersz1[0:4]==':86:':
            operacja+=wiersz1[4:8]
            tresc+=operacja+' '
            i+=1
            wiersz1=Wiersze[i]
        if wiersz1[0:3]=='<00':
            tresc+=wiersz1[3:]
            i+=1
            wiersz1=Wiersze[i]
        if wiersz1[0:3]=='<10':
            i+=1
            wiersz1=Wiersze[i]
        if wiersz1[0:3]=='<20':
            tresc+=wiersz1[3:]
            i+=1
            wiersz1=Wiersze[i]
        if wiersz1[0:3]=='<21':
            tresc+=wiersz1[3:]
            i+=1
            wiersz1=Wiersze[i]
        if wiersz1[0:3]=='<22':
            tresc+=wiersz1[3:]
            i+=1
            wiersz1=Wiersze[i]
        if wiersz1[0:3]=='<23':
            tresc+=wiersz1[3:]
            i+=1
            wiersz1=Wiersze[i]
        if wiersz1[0:3]=='<24':
            tresc+=wiersz1[3:]
            i+=1
            wiersz1=Wiersze[i]
        if wiersz1[0:3]=='<25':
            tresc+=wiersz1[3:]
            i+=1
            wiersz1=Wiersze[i]
        # nieciekawe opuszczamy
        if wiersz1[0:3]=='<26':
            i+=1
            wiersz1=Wiersze[i]
        if wiersz1[0:3]=='<27':
            i+=1
            wiersz1=Wiersze[i]
        if wiersz1[0:3]=='<28':
            i+=1
            wiersz1=Wiersze[i]
        if wiersz1[0:3]=='<29':
            wirtualny=wiersz1[3:].strip()
            if wirtualny=='':
                wirtualny='-'
            i+=1
            wiersz1=Wiersze[i]
        if wiersz1[0:3]=='<30':
            i+=1
            wiersz1=Wiersze[i]
        if wiersz1[0:3]=='<31':
            i+=1
            wiersz1=Wiersze[i]
        #nazwa
        if wiersz1[0:3]=='<32':
            nazwa+=wiersz1[3:]
            i+=1
            wiersz1=Wiersze[i]
        # nieciekawe opuszczamy
        if wiersz1[0:3]=='<33':
            i+=1
            wiersz1=Wiersze[i]
        if wiersz1[0:3]=='<34':
            i+=1
            wiersz1=Wiersze[i]
        if wiersz1[0:3]=='<38':
            konto+=wiersz1[3:]
            i+=1
            wiersz1=Wiersze[i]
        if wiersz1[0:3]=='<60':
            i+=1
            wiersz1=Wiersze[i]
        if wiersz1[0:3]=='<63':
            i+=1
            wiersz1=Wiersze[i]
        if wiersz1[0:3]=='<64':
            # wirtualny dla millenium
            wirtualny=wiersz1[3:].strip()
            if wirtualny=='':
                wirtualny='-'
            i+=1
            wiersz1=Wiersze[i]
        
        tresc=tresc.replace(chr(10),'').replace(chr(13),'')
        konto=konto.replace(chr(10),'').replace(chr(13),'')
        nazwa=nazwa.replace(chr(10),'').replace(chr(13),'')
        wirtualny=wirtualny.replace(chr(10),'').replace(chr(13),'')
        #rsglobal.ZapiszDoLogow('!!!'+ tresc+'!!!'+nazwa,1)
        #if wirtualny<>'':
        #    Wiersze1.append([konto,nazwa,tresc,kwota,wirtualny])
        #else:
        #    Wiersze1.append([konto,nazwa,tresc,kwota,''])
        Wiersze1.append([konto,nazwa,tresc,kwota,wirtualny])
            
    return (stat,Wiersze1)

##------------------------------------------------

def ZrobListeZMT3(Wiersze):
# zmiana wg platnosci masowych Credit Agricole
    Wiersze1=[]
    stat='OK'
    i=0
    while i < len(Wiersze):
        wiersz1=Wiersze[i]
        if wiersz1[0:5]==':62F:':
            # stopka - koniec
            break
        if wiersz1[0:4]<>':61:':
            # czekamy na kolejny wiersz
            i+=1
            continue
        
        #rsglobal.ZapiszDoLogow('!!!1'+ wiersz1,1)
        j=wiersz1.find(',')
        if j>0:
            znak=''
            if wiersz1[14]=='D':
                znak='-'
            kwota=znak+wiersz1[16:j+3]
        else:
            kwota='0'
            
        while wiersz1[0:4]<>':86:':
            i+=1
            wiersz1=Wiersze[i]
        
        #rsglobal.ZapiszDoLogow('!!!2'+ wiersz1,1)
        tresc=''
        konto=''
        nazwa=''
        operacja=''
        wirtualny=''
        if wiersz1.find('(V)')>0:
            # platnosci masowe
            konto+=wiersz1[6:32].strip()
            i+=2
            wiersz1=Wiersze[i]
            #rsglobal.ZapiszDoLogow('!!!3'+ wiersz1,1)
            nazwa+=wiersz1
            i+=4
            wiersz1=Wiersze[i]
            #rsglobal.ZapiszDoLogow('!!!4'+ wiersz1,1)
            tresc+=wiersz1
            Wiersze1.append([konto,nazwa,tresc,kwota])
    return (stat,Wiersze1)

##------------------------------------------------

def ZrobListeZMT2(Wiersze):
# zmiana wg drugiego formatu    
    Wiersze1=[]
    stat='OK'
    for i in xrange(len(Wiersze)):
        wiersz1=Wiersze[i]
        if wiersz1[0:5]==':62F:':
            # stopka - koniec
            break
        if wiersz1[0:4]<>':61:':
            # czekamy na kolejny wiersz
            continue
        
        #rsglobal.ZapiszDoLogow('!!!'+ wiersz,1)
        wiersz2=Wiersze[i+1]
        wiersz3=Wiersze[i+2]
        if Wiersze[i+3][0:4]<>':61:':
            wiersz3+=Wiersze[i+3]
            if Wiersze[i+4][0:4]<>':61:':
                wiersz3+=Wiersze[i+4]
        
        j=wiersz1.find('NMSC')
        if j>0:
            kwota=wiersz1[16:j]
        else:
            kwota='0'
        
        if wiersz3[0:6]=='z rach':
            # przychodzi cos
            konto=wiersz3[7:34]
            j=wiersz3.find('; tyt.')
            nazwa=wiersz3[43:j]
            tresc=wiersz3[j+7:]
        elif wiersz3[0:7]=='na rach':
            # przychodzi cos
            konto=wiersz3[8:35]
            j=wiersz3.find('; tyt.')
            nazwa=wiersz3[41:j]
            tresc=wiersz3[j+7:]
        else:
            konto=''
            nazwa=''
            tresc=wiersz3
        
        operacja=wiersz2[4:7]
        tresc=operacja+':'+tresc
        if operacja in ['001','003']:
            # wyplata gotowki
            kwota='-'+kwota
        elif operacja >='051' and operacja<='075':
            # przelew wychodzacy
            kwota='-'+kwota
        elif operacja >='085' and operacja<='143':
            # przelew wychodzacy zlecenie
            kwota='-'+kwota
        elif operacja >='151' and operacja<='165':
            # przelew miedzyoddzialowy
            kwota='-'+kwota
        elif operacja >='202' and operacja<='220':
            # wyplaty w bankomatach i platnosci karta
            kwota='-'+kwota
        elif operacja =='251':
            # zalozenie lokaty
            kwota='-'+kwota
        elif operacja =='267':
            # zdjecie lokaty
            kwota='-'+kwota
        elif operacja =='271':
            # przelew miedzyoddzialowy
            kwota='-'+kwota
        elif operacja >='273' and operacja<='275':
            # podwyzszenie kaucji
            kwota='-'+kwota
        elif operacja in ['309','313','315','323','327','329']:
            # wyplata gotowki
            kwota='-'+kwota
        elif operacja >='501' and operacja<='747':
            # oplaty i prowizje
            kwota='-'+kwota
#        else:
#            stat='Nierozpoznana transakcja - poinformuj serwis: '+wiersz2
#            break
        Wiersze1.append([konto,nazwa,tresc,kwota])
            
    return (stat,Wiersze1)

##------------------------------------------------

def ZrobListeZMT1(Wiersze):
# zmiana wg pierwszego formatu    
    Wiersze1=[]
    stat='OK'
    for i in xrange(len(Wiersze)):
        wiersz=Wiersze[i]
        #rsglobal.ZapiszDoLogow('!!!'+ wiersz,1)
        lista=[]
        if wiersz[0:4]==':61:':
            wiersz1=Wiersze[i+1]
            j=wiersz1.find('RACH]')
            if j>0:
                rach=wiersz1[j+5:j+39].strip()
            else:
                rach=''
            if wiersz1[0:10]==':86:[PRZE]':
                j=wiersz1.find('[TYTU1]')
                if j>0:
                    w=wiersz1[11:j-11].split()
                    if len(w)>1:
                        lista.append(w[0]+' '+w[1])
                    elif len(w)==1:
                        lista.append(w[0])
                    else:
                        lista.append('')
                    lista.append(wiersz1[j+7:].strip())
                    j=wiersz.find('NMSC')
                    if j>0:
                        lista.append('-'+wiersz[16:j])
            elif wiersz1[0:12]==':86:[PRZOD1]':
                j=wiersz1.find('[ZRACH]')
                if j>0:
                    lista.append(wiersz1[12:j-12].strip())
                    j=wiersz1.find('[TYTU1]')
                    lista.append(wiersz1[j+7:].strip())
                    j=wiersz.find('NMSC')
                    if j>0:
                        lista.append(wiersz[16:j])
            elif wiersz1[0:12]==':86:[PRZEDL]':
                j=wiersz1.find('[NARACH]')
                if j>0:
                    lista.append(wiersz1[12:j-12].strip())
                    j=wiersz1.find('[TYTU1]')
                    lista.append(wiersz1[j+7:].strip())
                    j=wiersz.find('NMSC')
                    if j>0:
                        lista.append('-'+wiersz[16:j])
            elif wiersz1[0:12]==':86:[PRZTYT]':
                j=wiersz1.find('[ZAOKRE]')
                if j>0:
                    lista.append('')
                    lista.append(wiersz1[12:j-12].strip())
                    j=wiersz.find('NMSC')
                    if j>0:
                        lista.append('-'+wiersz[16:j])
                else:
                    lista.append('')
                    lista.append(wiersz1[12:j-12].strip())
                    j=wiersz.find('NMSC')
                    if j>0:
                        lista.append('-'+wiersz[16:j])
            elif wiersz1[0:11]==':86:[NADOD]':
                j=wiersz1.find('[TYTU1]')
                if j>0:
                    lista.append(wiersz1[12:j-12])
                    lista.append(wiersz1[j+7:].strip())
                    j=wiersz.find('NMSC')
                    if j>0:
                        lista.append('-'+wiersz[16:j])
            elif wiersz1[0:11]==':86:[WPLAC]':
                j=wiersz1.find('[TYTUL]')
                if j>0:
                    lista.append(wiersz1[12:j-12])
                    lista.append(wiersz1[j+7:].strip())
                    j=wiersz.find('NMSC')
                    if j>0:
                        lista.append(wiersz[16:j])
            elif wiersz1[0:10]==':86:[RACH]':
                j=wiersz1.find('[TYTU]')
                if j>0:
                    w=wiersz1[11:j-11].split()
                    lista.append(w[0])
                    lista.append(wiersz1[j+6:].strip())
                    j=wiersz.find('NMSC')
                    if j>0:
                        lista.append('-'+wiersz[16:j])
                else:
                    j=wiersz1.find('[ODS]')
                    if j>0:
                        w=wiersz1[j:]
                        lista.append(w)
                        lista.append(wiersz1[j+6:].strip())
                        j=wiersz.find('NMSC')
                        if j>0:
                            lista.append('-'+wiersz[16:j])
            elif wiersz1[0:10]==':86:[BEN1]':
                j=wiersz1.find('[TYTU1]')
                if j>0:
                    w=wiersz1[10:j-10].split()
                    lista.append(w[0]+' '+w[1])
                    lista.append(wiersz1[j+7:].strip())
                    j=wiersz.find('NMSC')
                    if j>0:
                        lista.append('-'+wiersz[16:j])
            elif wiersz1[0:10]==':86:[PROD]':
                j=wiersz1.find('[PR1]')
                if j>0:
                    w=wiersz1[10:]
                    lista.append(w)
                    lista.append(wiersz1[j+7:].strip())
                    j=wiersz.find('NMSC')
                    if j>0:
                        lista.append('-'+wiersz[16:j])
            elif wiersz1[0:9]==':86:[ODS]':
                w=wiersz1[9:]
                lista.append(w)
                lista.append(w.strip())
                j=wiersz.find('NMSC')
                if j>0:
                    lista.append('-'+wiersz[16:j])
            elif wiersz1[0:11]==':86:[ZUSTO]':
                j=wiersz1.find('[RACH]')
                if j>0:
                    w=wiersz1[11:j-11].strip()
                    lista.append(w)
                    j=wiersz1.find('[TYP]')
                    lista.append(wiersz1[j+5:].strip())
                    j=wiersz.find('NMSC')
                    if j>0:
                        lista.append('-'+wiersz[16:j])
            elif wiersz1[0:11]==':86:[USFOR]':
                j=wiersz1.find('[RACH]')
                if j>0:
                    w=wiersz1[11:j-11].strip()
                    lista.append(w)
                    j=wiersz1.find('[OKRES]')
                    lista.append(wiersz1[j:].strip())
                    j=wiersz.find('NMSC')
                    if j>0:
                        lista.append('-'+wiersz[16:j])
            elif wiersz1[0:12]==':86:[SPLAKR]':
                j=wiersz1.find('[TYTU]')
                if j>0:
                    w=wiersz1[j:]
                    lista.append(w)
                    lista.append(wiersz1[j+7:].strip())
                    j=wiersz.find('NMSC')
                    if j>0:
                        lista.append('-'+wiersz[16:j])
            else:
                stat='Nierozpoznana transakcja - poinformuj serwis: '+wiersz1
                break
        if len(lista)>0:
            lista.append(rach)
            Wiersze1.append(lista)
            
    return (stat,Wiersze1)

##------------------------------------------------

def SzukajWZaleglosciach(polacz,firma,platnik_id, kwota, tresc):
    listafaktur=[]
    sql ="SELECT typ_dok, wyznacznik_id, data, numer, do_zaplaty, "
    sql+=" rsf_podaj_numer_dokumentu_na_wydruk('"+firma+"','[\"'||wyznacznik_id||'\",\"'||data||'\",\"'||numer||'\"]',typ_dok)"
    sql+=" FROM rs_zaleglosci"
    sql+=" WHERE firma_id='"+firma+"' AND platnik_id="+platnik_id
    sql+=" AND ureg_kwota=0 AND typ_dok<>'N' ORDER BY do_zaplaty;"
    stat,d,dump,dump=polacz.Execute(sql,3)
    if stat <> 'OK':
        stat = 'Bd wczytania listy zalegoci: '+stat
    else:
        if tresc[0:4] == '/VAT':
            i = tresc.find('/INV')
            if i>0:
                tresc = tresc[i+5:]
        trescold=tresc
        tresc=tresc.upper()
        for w in d:
            if kwota==0:
                break
            kwotazal=float(w[4])
            nrfakt=w[5].upper()
            if (tresc[0:len(nrfakt)]==nrfakt) or (tresc.count(' '+nrfakt)>0) or (tresc.count(','+nrfakt)>0) or (tresc.count(';'+nrfakt)>0) or (tresc.count('.'+nrfakt)>0) or (tresc.count('-'+nrfakt)>0):
                kwotazal=float(w[4])
                if kwotazal<0 or (kwotazal>0 and kwota>=kwotazal):
                    listafaktur.append([w[0],w[1],w[2],w[3],w[4]])
                    kwota-=kwotazal
                else:
                    listafaktur.append([w[0],w[1],w[2],w[3],str(kwota)])
                    kwota=0
                tresc=tresc.replace(w[5].upper(),'')
                tresc=tresc.replace(',,',',')
        tresc=tresc.strip(',')
        if len(listafaktur)==0:
            tresc=trescold
    return (listafaktur,tresc)

#---------------------------------------

def SzukajWPlatnosciach(polacz,firma,platnik_id, kwota, tresc, data, konto_id):
    listaplatnosci=[]
    sql ="SELECT platnosc_id, nr_faktury, konto_fk, kwota_platnosci "
    sql+=" FROM rs_platnosci"
    sql+=" WHERE firma_id='"+firma+"' AND kontrahent_id="+platnik_id
    sql+=" AND data_pli='"+str(data)+"' AND konto_id='"+konto_id+"';"

    stat,d,dump,dump=polacz.Execute(sql,3)
    if stat <> 'OK':
        stat = 'Bd wczytania listy patnoci: '+stat
    else:
        tresc=tresc.upper()
        for w in d:
            if kwota==0:
                break
            kwotaplat=float(w[3])
            if tresc.count(w[1].upper())>0 or tresc[0:3]=='WED':
                listaplatnosci.append([w[0],w[1],w[2],w[3]])
                kwota+=kwotaplat
                
    return listaplatnosci

#---------------------------------------

import csv

KasaBank = rsglobal.Dekoduj(klucze[0])
# reszta parametrow w zaleznosci od funkcji
Fun = klucze[-1]

stat = 'OK'
dane = []
wyn2 = []

UprDod = (self.oddzial_id,'172023') in self.uprawnienia or (self.operator_id == STANDARD_OPERATOR_ID)

#-------------------------------------------------------------------------------
# Import pozycji z pliku (10)
#-------------------------------------------------------------------------------

if Fun == 10:
    Data = rsglobal.Dekoduj(klucze[1])
    Numer = klucze[2]
    Wiersze = klucze[3]
    if not UprDod:
        stat='BR_UPR_INS'

    # sprawdzenie czy plik nie jest pusty, usuniecie pustych wierszy na poczatku
    while len(Wiersze)>0:
        if Wiersze[0].strip()=='':
            Wiersze=Wiersze[1:]
        else:
            break
    if len(Wiersze)==0:
        stat='Brak poprawnych pozycji w pliku'

    #sprawdzenie czy raport jest w stanie W
    if stat=='OK':
        sql ="SELECT stan FROM rs_raporty_wyciagi"
        sql+=" WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"'"
        sql+=" AND kasa_bank_id='"+KasaBank+"' AND data='"+Data+"' AND numer="+str(Numer)+" FOR UPDATE NOWAIT;"

        stat,d,dump,dump=self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Bd sprawdzenia stanu raportu: '+stat
        elif len(d) == 0:
            stat = 'BR RAP'
        elif d[0][0] <> 'W':
            stat = 'ZAM RAP'
            
    if stat == 'OK':
        # sprawdzenie czy raport zawiera pozycje
        sql ="SELECT COUNT(*) FROM rs_raporty_wyciagi_pozycje"
        sql+=" WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"'"
        sql+=" AND kasa_bank_id='"+KasaBank+"' AND data='"+Data+"' AND numer="+str(Numer)+";"

        stat,d,dump,dump=self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Bd sprawdzenia pozycji raportu: '+stat
        elif d[0][0] > 0:
            stat = 'BL_IST_POZ'
            
    if stat == 'OK':
        # wczytanie opisu pliku
        sql ="SELECT sygnatura_wiersz,sygnatura_tekst,data_wiersz,data_kolumna, separator,"
        sql+=" szerokosc_stala,strona_kodowa,separator_tekstu,kropka_dziesietna,separator_tysiecy,konto_id,plik_mt FROM rs_kasy_banki"
        sql+=" WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"'"
        sql+=" AND kasa_bank_id='"+KasaBank+"';"

        stat,d,dump,dump=self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Bd wczytania parametrw pliku: '+stat
        elif len(d)==0:
            stat = 'Brak parametrw pliku.'
        else:
            sygnatura_wiersz=d[0][0]
            if sygnatura_wiersz>0:
                sygnatura=d[0][1]
                if Wiersze[sygnatura_wiersz-1].count(sygnatura)==0:
                    stat = 'Bdny plik - niezgodno sygnatury '
            data_wiersz=int(d[0][2])
            data_kolumna=int(d[0][3])
            if stat=='OK' and data_wiersz>0 and data_kolumna>0:
                data=Wiersze[data_wiersz-1][data_kolumna-1:data_kolumna+9]
                if data.count(Data[0:4])==0:
                    stat = 'Niepoprawna data w pliku (rok)'
                elif data.count(Data[5:7])==0:
                    stat = 'Niepoprawna data w pliku (miesic)'
                elif data.count(Data[8:10])==0:
                    stat = 'Niepoprawna data w pliku (dzie)'
        if stat=='OK':
            separator=d[0][4].strip()
            if separator=='' or separator=='None':
                separator=';'
            szerokosc_stala=d[0][5]
            strona_kodowa=d[0][6].strip()
            if strona_kodowa=='None':
                strona_kodowa='iso8859-2'
            separator_tekstu=d[0][7].strip()
            kropka_dziesietna=d[0][8].strip()
            if kropka_dziesietna=='None':
                kropka_dziesietna=''
            separator_tysiecy=d[0][9].strip()
            if separator_tysiecy=='None':
                separator_tysiecy=' '
            konto_id=d[0][10].strip()
            czy_plik_mt=d[0][11]
                    
    if stat == 'OK':
        # wczytanie opisu kolumn pliku
        sql ="SELECT typ_kolumny, nazwa_kolumny, dlugosc_kolumny, format_daty, wartosc_stala, nr_kolumny"
        sql+=" FROM rs_kasy_banki_plik_kolumny "
        sql+=" WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"'"
        sql+=" AND kasa_bank_id='"+KasaBank+"' ORDER BY nr_kolumny;"
        stat,def_kolumn,dump,dump=self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Bd wczytania definicji kolumn: '+stat
        else:
            if len(def_kolumn)==0:
                stat = 'Brak definicji kolumn'
            else:
                # zlozenie naglowka i sprawdzenie czy jest w pliku
                # dodatkowe zmienne z waznymi kolumnami
                naglowek=''
                liczba_kolumn=len(def_kolumn)
                kolumna_wirtualny=-1
                kolumna_dane_kontrahenta=-1
                kolumna_adres_kontrahenta=-1
                kolumna_kwota=-1
                #kolumna_rachunek=-1
                kolumna_rachunek=[]
                kolumna_tresc=[]
                kolumna_rodzaj=-1
                kolumna_dc=-1
                for w in def_kolumn:
                    if not (w[1].strip() in ['','None']):
                        naglowek=naglowek+w[1].strip()+separator
                    if w[0]=='10':
                        kolumna_wirtualny=int(w[5])-1
                    elif w[0]=='06':
                        kolumna_dane_kontrahenta=int(w[5])-1
                    elif w[0]=='14':
                        kolumna_adres_kontrahenta=int(w[5])-1
                    elif w[0]=='12':
                        kolumna_kwota=int(w[5])-1
                    elif w[0]=='07':
                        kolumna_rachunek.append(int(w[5])-1)
                    elif w[0]=='11':
                        kolumna_tresc.append(int(w[5])-1)
                    elif w[0]=='05':
                        kolumna_rodzaj=int(w[5])-1
                    elif w[0]=='15':
                        kolumna_dc=int(w[5])-1
                poczatek=0
                if len(naglowek)>0:
                    if len(naglowek)>len(def_kolumn):
                        for w in Wiersze:
                            nag=w.replace(chr(10),'').replace(chr(13),'').replace(chr(160),'')
                            poczatek+=1
                            if strona_kodowa.upper()<>'ISO8859-2' and strona_kodowa<>'' and strona_kodowa<>'None':
                                nag=nag.encode('iso8859-2').decode(strona_kodowa)
                            if (naglowek==nag) or (naglowek==nag+separator):
                                break
                if poczatek>=len(Wiersze):
                    stat = 'Brak wiersza z nagwkiem w pliku '
                if kolumna_kwota==-1:
                    stat = 'Brak kolumny z kwot '
                
    if stat == 'OK':
        # wczytanie dekretacji pliku
        sql ="SELECT nr_kolumny1, wartosc1, nr_kolumny2, wartosc2, konto, dodawac_kontrahenta"
        sql+=" FROM rs_kasy_banki_plik_dekretacja "
        sql+=" WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"'"
        sql+=" AND kasa_bank_id='"+KasaBank+"' ORDER BY nr_poz;"
        stat,def_dekretacji,dump,dump=self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Bd wczytania definicji dekretacji: '+stat
        else:
            if (len(def_dekretacji)==0) and (kolumna_wirtualny==-1):
                stat = 'Brak definicji dekretacji'
    
    if stat=='OK':
        sql_insert=''
        sql_insert0="INSERT INTO rs_raporty_wyciagi_pozycje (firma_id, okres_id, kasa_bank_id, data, numer,"
        sql_insert0+=" nr_poz, nr_ppoz, stan_poz, typ, symbol_dok, platnik_id,"
        sql_insert0+=" typ_fakt, wyznacznik_id, data_fakt, numer_fakt, konto, kwota,tresc, platnosc_id) "
        sql_insert0+=" VALUES ('"+self.firma_id+"','"+self.okres_id+"','"+KasaBank+"','"+str(Data)+"',"+str(Numer)+","
        
        # wyczyszczenie z podwojnych ""
        #for i in xrange(len(Wiersze)):
        #    if Wiersze[i][-4:]=='"""'+chr(10):
        #        Wiersze[i]=Wiersze[i][1:-2]
        #    Wiersze[i]=Wiersze[i].replace('""','"')
        #rsglobal.ZapiszDoLogow('csv po obrobce:'+str(Wiersze),0)
        Wiersze1=[]
        if czy_plik_mt:
            # przygotowanie csv z pliku o strukturze MT
            if Wiersze[0][0:3]=='{1:' and Wiersze[0].find('{2:')>0 and Wiersze[0].find('{3:')>0:
                #platnosci masowe Credit Agricole
                (stat,Wiersze1)=ZrobListeZMT3(Wiersze)
            elif Wiersze[0][0:4]==':20:' and Wiersze[1][0:4]==':21:' and Wiersze[2][0:4]==':25:' :
                (stat,Wiersze1)=ZrobListeZMT1(Wiersze)
            elif Wiersze[0][0:4]==':20:' and Wiersze[1][0:4]==':25:' and Wiersze[2][0:5]==':28C:' and Wiersze[3][0:6]=='NS:22:' :
                # multicash
                (stat,Wiersze1)=ZrobListeZMT4(Wiersze)
            elif Wiersze[0][0:9] == ':20:MT940' and Wiersze[1][0:4] == ':25:' and Wiersze[2][0:5] == ':28C:':
                # ING
                (stat, Wiersze1) = ZrobListeZMT5(Wiersze)
            elif Wiersze[0][0:4]==':20:' and Wiersze[1][0:4]==':25:' and Wiersze[2][0:5]==':28C:' :
                # pekao Biznes
                (stat,Wiersze1)=ZrobListeZMT4(Wiersze)
            elif Wiersze[0][0:4]==':20:' and Wiersze[1][0:4]==':25:' :
                #citi
                (stat,Wiersze1)=ZrobListeZMT2(Wiersze)
            elif Wiersze[1][0:4]==':20:' and Wiersze[2][0:4]==':25:' :
                (stat,Wiersze1)=ZrobListeZMT2(Wiersze)
            else:
                stat='Nierozpoznana struktura pliku MT - poinformuj serwis'

        elif szerokosc_stala:
            Wiersze1=[]
            for w in Wiersze:
                wiersz=[]
                odkad=0
                for d in def_kolumn:
                    wiersz.append(w[odkad:odkad+int(d[2])])
                    odkad+=int(d[2])
                Wiersze1.append(wiersz)
        else:
            Wiersze1=csv.reader(Wiersze,delimiter=chr(ord(separator)))
        rsglobal.ZapiszDoLogow('nowy csv:'+str(Wiersze1),0)
        i=-1
        nrpoz=0
        zly_poczatek=0
        zly_koniec=0
        for w in Wiersze1:
            # analiza wierszy - przygotowanie zapisu pozycji
            #rsglobal.ZapiszDoLogow('wiersz:'+str(w),0)
            i+=1
            if i<poczatek:
                continue
            if True:
                wbuf=w
                if len(wbuf)<>liczba_kolumn:
                    if nrpoz==0:
                        zly_poczatek+=1
                        continue
                    else:
                        zly_koniec+=1
                        stat = 'Niepoprawna struktura wiersza nr '+str(i+1)+' '+str(w)
                        continue
##                    if i==poczatek:
##                        stat = 'Niepoprawna struktura wiersza nr '+str(i+1)+' '+str(w)
##                    else:
##                        if len(wbuf)>liczba_kolumn:
##                            stat = 'Niepoprawna struktura wiersza nr '+str(i+1)+' '+str(w)
##                        else:
##                            stat = 'Niepoprawna struktura wiersza nr '+str(i+1)+' '+str(w)
##                            break
                else:
                    if zly_koniec>0:
                        break
                if stat=='OK':
                    # przygotowanie kwoty
                    kwotastr=wbuf[kolumna_kwota].strip().replace(' ','').replace(separator_tekstu,'')
                    if separator_tysiecy<>'':
                        kwotastr=kwotastr.replace(separator_tysiecy,'')
                    if kropka_dziesietna==',':
                        kwotastr=kwotastr.replace(',','.')
                    elif kropka_dziesietna=='' or kropka_dziesietna=='None':
                        kwotastr=kwotastr[0:len(kwotastr)-2]+'.'+kwotastr[len(kwotastr)-2:len(kwotastr)]
                    kwota=float(kwotastr)
                    if kolumna_dc>=0:
                        if wbuf[kolumna_dc].strip()=='D':
                            kwota=-kwota
                    if kwota>0:
                        typpoz='P'
                    elif kwota<0:
                        typpoz='W'
                    else:
                        continue
                    
                    nrpoz+=1
                    nrppoz=0
                    zapisano=False
                    platnik_id=''
                    tresc=''
                    konto=''
                    typ_fakt=''
                    wyznacznik='NULL'
                    data_fakt='NULL'
                    numer_fakt='0'
                    # wyszukanie platnika
                    if kolumna_wirtualny>=0:
                        # same faktury i korekty
                        kontowirtualne=wbuf[kolumna_wirtualny].strip().replace(' ','').replace('-','').replace('\'','').replace('"','')
                        if kontowirtualne=='':
                            # opuszczenie zapisow dla Millenium o obciazeniu
                            continue
                        sql ="SELECT DISTINCT kontrahent_id"
                        sql+=" FROM rs_kontrahenci_fakturowanie "
                        sql+=" WHERE firma_id='"+self.firma_id+"' AND platnosc_subkonto_i='"+kontowirtualne+"';"
                        stat,dane,dump,dump=self.PolSQL.Execute(sql,3)
                        if stat <> 'OK':
                            stat = 'Bd szukania patnika wg wirtualnego konta: '+stat
                            break
                        elif len(dane)==0:
                            stat = 'Brak patnika z wirtualnym kontem: '+kontowirtualne+' wiersz nr: '+str(i+1)
                            break
                        elif len(dane)>1:
                            stat = 'Zdublowane wirtualne konto dla kontrahentw: '+str(dane)
                            break
                        platnik_id=rsglobal.Dekoduj(dane[0][0])
                    
                    
                    else:
                        # standardowy wyciag
                        #if kolumna_rachunek>=0:   JR
                        rachunki = ''
                        danekontrahenta = ''
                        if len(kolumna_rachunek) > 0:
                            for i in kolumna_rachunek:
                                rachunek=wbuf[i].strip().replace('ACC:','').replace(' ','').replace('-','').replace('\'','').replace('"','')
                                if rachunek <> '':
                                    rachunki += "'"+rachunek+"',"
                            if rachunki<>'':
                                rachunki = rachunki[:-1]
                                sql ="SELECT kontrahent_id"
                                sql+=" FROM rs_kontrahenci "
                                sql+=" WHERE firma_id='"+self.firma_id+"' AND bank_konto_i IN ("+rachunki+")"
                                sql+=" AND (platnik_id IS NULL OR platnik_id=kontrahent_id OR TRIM(platnik_id)='') AND aktywny "
                                if kwota>0:
                                    sql+=" AND odbiorca;"
                                else:
                                    sql+=" AND dostawca;"
                                stat,dane,dump,dump=self.PolSQL.Execute(sql,3)
                                if stat <> 'OK':
                                    stat = 'Bd szukania patnika wg numeru rachunku: '+stat
                                    break
                                elif len(dane)>1:
                                    stat = 'Zdublowany numer rachunku dla kontrahentw: '+str(dane)
                                    break
                                elif len(dane)==1:
                                    platnik_id=rsglobal.Dekoduj(dane[0][0])
                                else:
                                    #--- szukanie po nazwie, adresie itd. dla wplat
                                    if kolumna_dane_kontrahenta>=0:  # and kwota>0:
                                        danekontrahenta = wbuf[kolumna_dane_kontrahenta]
                                        listaslow=wbuf[kolumna_dane_kontrahenta].split()
                                        #rsglobal.ZapiszDoLogow('slowa:'+str(listaslow),0)    
                                        for slowo in listaslow:
                                            #if strona_kodowa.upper()<>'ISO8859-2' and strona_kodowa<>'' and strona_kodowa<>'None':
                                            #    slowo=slowo.encode('iso8859-2').decode(strona_kodowa)
                                            #slowo=slowo.strip()
                                            slowo=rsglobal.ZmienKodowanie(slowo,strona_kodowa)
                                            sql ="SELECT DISTINCT CASE WHEN (platnik_id IS NULL OR TRIM(platnik_id)='') THEN kontrahent_id ELSE platnik_id END"
                                            sql+=" FROM rs_kontrahenci "
                                            sql+=" WHERE firma_id='"+self.firma_id+"' AND upper(nazwa) LIKE upper('%"+slowo+" %')"
                                            sql+=" AND aktywny AND odbiorca;"
                                            #rsglobal.ZapiszDoLogow('sql:'+str(sql),0)
                                            stat,dane,dump,dump=self.PolSQL.Execute(sql,3)
                                            if stat <> 'OK':
                                                stat = 'Bd szukania patnika wg nazwy: '+stat
                                                break
                                            elif len(dane)==1:
                                                platnik_id=rsglobal.Dekoduj(dane[0][0])
                                                break
                            
                    if platnik_id.strip()=='' or platnik_id=='None':
                        platnik_id='NULL'
                        wyn2.append('Nie znaleziono kontrahenta: Konto-'+rachunki+' dane-'+danekontrahenta)
                    else:
                        platnik_id="\'"+platnik_id+"\'"
                    #if kolumna_tresc>=0:
                        #    tresc=wbuf[kolumna_tresc].strip().replace('\'','/').replace('"','').replace('\\','/')
                    for kt in kolumna_tresc:
                        tresc=tresc+wbuf[kt]
                    if tresc.strip()=='':
                        if kolumna_rodzaj>=0:
                        #        tresc=wbuf[kolumna_rodzaj].strip().replace('\'','').replace('"','').replace('\\','/')
                            tresc=wbuf[kolumna_rodzaj]
                    #if strona_kodowa.upper()<>'ISO8859-2' and strona_kodowa<>'' and strona_kodowa<>'None':
                    #    tresc=tresc.encode('iso8859-2').decode(strona_kodowa)
                    tresc=rsglobal.ZmienKodowanie(tresc,strona_kodowa)
                    
                    #sql_insert+=sql_insert0
                    if kolumna_wirtualny<0:
                        #--- standardowy wyciag
                        #--- sprawdzenie w definicji dekretacji
                        #---nr_kolumny1, wartosc1, nr_kolumny2, wartosc2, konto, dodawac_kontrahenta
                        for wdef in def_dekretacji:
                            kol1=int(wdef[0])-1
                            kol2=int(wdef[2])-1
                            wart1=rsglobal.Dekoduj(wdef[1].strip())
                            wart2=rsglobal.Dekoduj(wdef[3].strip())
                            #rsglobal.ZapiszDoLogow('wiersz:'+str(wbuf),5)    
                            #rsglobal.ZapiszDoLogow(str(kol1)+'|'+str(wart1)+'|'+str(kol2)+'|'+str(wart2),5)
                            if kol1>=0 and kol2>=0:
                                #if strona_kodowa.upper()<>'ISO8859-2' and strona_kodowa<>'' and strona_kodowa<>'None':
                                #    wbuf1=wbuf[kol1].encode('iso8859-2').decode(strona_kodowa)
                                #    wbuf2=wbuf[kol2].encode('iso8859-2').decode(strona_kodowa)
                                wbuf1=rsglobal.ZmienKodowanie(wbuf[kol1],strona_kodowa)
                                wbuf2=rsglobal.ZmienKodowanie(wbuf[kol2],strona_kodowa)
                                if wbuf1.count(wart1)>0 and wbuf2.count(wart2)>0:
                                    konto=rsglobal.Dekoduj(wdef[4]).strip()
                                    if wdef[5]:
                                        konto+='-'+platnik_id.replace("'","")
                                    break
                            elif kol1>=0:
                                #if strona_kodowa.upper()<>'ISO8859-2' and strona_kodowa<>'' and strona_kodowa<>'None':
                                #    wbuf1=wbuf[kol1].encode('iso8859-2').decode(strona_kodowa)
                                wbuf1=rsglobal.ZmienKodowanie(wbuf[kol1],strona_kodowa)
                                if wbuf1.count(wart1)>0:
                                    konto=wdef[4]
                                    if wdef[5]:
                                        konto+='-'+platnik_id.replace("'","")
                                    break
                    if kolumna_wirtualny>=0 or (platnik_id<>'NULL' and konto=='' and kwota>0 and tresc<>''):
                        #--- platnosci masowe lub brak dekretu zwyklego
                        #--- sprawdzenie w zalegociach
                        (listafaktur,tresc)=SzukajWZaleglosciach(self.PolSQL,self.firma_id,platnik_id, kwota, tresc)
                        #rsglobal.ZapiszDoLogow(str(listafaktur),5)
                        #if len(listafaktur)>0:
                        zapisano=True
                        kwotazal=0
                        for faktura in  listafaktur:
                            kwotazal+=round(float(faktura[4]),2)
                        if (kwotazal<>0 and round(kwota,2)<>round(kwotazal,2)) or len(listafaktur)>1:
                            #--- beda podpozycje - zapisujemy pozycje
                            sql_insert+=sql_insert0+str(nrpoz)+","+str(nrppoz)+",'W','"+typpoz+"','',"+platnik_id+","
                            sql_insert+="NULL,NULL,NULL,0,NULL,"+str(kwota)+",'',NULL);"
                        else:
                            if len(listafaktur)>0:
                                nrppoz=-1
                        for faktura in  listafaktur:
                            #--- kolejne faktury
                            nrppoz+=1
                            typ_fakt=rsglobal.Dekoduj(faktura[0])
                            wyznacznik="\'"+rsglobal.Dekoduj(faktura[1])+"\'"
                            data_fakt="\'"+rsglobal.Dekoduj(faktura[2])+"\'"
                            numer_fakt=str(faktura[3]).strip()
                            kwotazal=round(float(faktura[4]),2)
                            sql_insert+=sql_insert0+str(nrpoz)+","+str(nrppoz)+",'W','"+typpoz+"','',"+platnik_id+","
                            sql_insert+="'"+typ_fakt+"',"+wyznacznik+","+data_fakt+","+numer_fakt+",'"+konto+"',"+str(kwotazal)+",'',NULL);"
                            kwota-=kwotazal
                        if round(kwota,2)<>0:
                            #--- reszta jako niezidentyfikowana wplata
                            if len(listafaktur)>0:
                                nrppoz+=1
                            sql_insert+=sql_insert0+str(nrpoz)+","+str(nrppoz)+",'W','"+typpoz+"','',"+platnik_id+","
                            sql_insert+="'N',NULL,NULL,0,NULL,"+str(kwota)+",'"+tresc[0:100]+"',NULL);"
                            wyn2.append('poz.:'+str(nrpoz)+' nierozpoznana wpata dla '+platnik_id+' na kwot:'+str(kwota)+' tre:'+tresc)
                    elif platnik_id<>'NULL' and konto=='' and kwota<0:
                        #--- szukanie w platnosciach
                        #to=tresc
                        if len(tresc)>108:
                            if tresc[35]==' ' and tresc[71]==' ' and tresc[107]==' ':
                                tresc=tresc[0:35]+tresc[36:71]+tresc[72:107]+tresc[108:]
                        elif len(tresc)>72:
                            if tresc[35]==' ' and tresc[71]==' ':
                                tresc=tresc[0:35]+tresc[36:71]+tresc[72:]
                        elif len(tresc)>36:
                            if tresc[35]==' ':
                                tresc=tresc[0:35]+tresc[36:]
                        #if to<>tresc:
                        #    rsglobal.ZapiszDoLogow('tresc przed:'+str(to),5)
                        #    rsglobal.ZapiszDoLogow('tresc po   :'+str(tresc),5)
                        listaplatnosci=SzukajWPlatnosciach(self.PolSQL,self.firma_id,platnik_id, kwota, tresc, Data, konto_id)
                        if len(listaplatnosci)>0:
                            zapisano=True
                            kwotaplat=0
                            for platnosc in listaplatnosci:
                                kwotaplat-=round(float(platnosc[3]),2)
                            if round(kwotaplat,2)<>round(kwota,2) or len(listaplatnosci)>1:
                                #--- beda podpozycje - zapisujemy pozycje
                                sql_insert+=sql_insert0+str(nrpoz)+","+str(nrppoz)+",'W','"+typpoz+"','',"+platnik_id+","
                                sql_insert+="NULL,NULL,NULL,0,NULL,"+str(-kwota)+",'"+tresc[0:100]+"',NULL);"
                            else:
                                if len(listaplatnosci)>0:
                                    nrppoz=-1
                            for platnosc in listaplatnosci:
                                #--- kolejne platnosci
                                nrppoz+=1
                                platnosc_id=platnosc[0]
                                trescp=platnosc[1].strip()
                                trescp=trescp[0:100]
                                konto=platnosc[2].strip()
                                kwotaplat=platnosc[3]
                                sql_insert+=sql_insert0+str(nrpoz)+","+str(nrppoz)+",'W','"+typpoz+"','',"+platnik_id+","
                                sql_insert+="NULL,NULL,NULL,0,'"+konto+"',"+str(kwotaplat)+",'"+trescp+"',"+str(platnosc_id)+");"
                                kwota+=float(kwotaplat)
                            if round(kwota,2)<>0:
                                #--- reszta jako niezidentyfikowana wyplata
                                if len(listaplatnosci)>0:
                                    nrppoz+=1
                                sql_insert+=sql_insert0+str(nrpoz)+","+str(nrppoz)+",'W','"+typpoz+"','',"+platnik_id+","
                                sql_insert+="NULL,NULL,NULL,0,'"+konto+"',"+str(-kwota)+",'"+tresc[0:100]+"',"+str(platnosc_id)+");"
                                wyn2.append('poz.:'+str(nrpoz)+' nierozpoznana wypata dla '+platnik_id+' na kwot:'+str(kwota)+' tre:'+tresc)
                    if not zapisano:
                        if typpoz=='W':
                            kwota=-kwota
                        if czy_plik_mt:
                            #t=wbuf[kolumna_dane_kontrahenta].strip()
                            #if strona_kodowa.upper()<>'ISO8859-2' and strona_kodowa<>'' and strona_kodowa<>'None':
                            #    t=t.encode('iso8859-2').decode(strona_kodowa)
                            t=rsglobal.ZmienKodowanie(wbuf[kolumna_dane_kontrahenta],strona_kodowa)
                            tresc=tresc+' - '+t
                        tresc=tresc[0:100]
                        #rsglobal.ZapiszDoLogow('tresc:'+str(tresc),0)
                        sql_insert+=sql_insert0+str(nrpoz)+","+str(nrppoz)+",'W','"+typpoz+"','',"+platnik_id+","
                        sql_insert+="'"+typ_fakt+"',"+wyznacznik+","+data_fakt+","+numer_fakt+",'"+konto+"',"+str(kwota)+",'"+tresc+"',NULL);"
                        if konto=='' or konto=='NULL':
                            wyn2.append('poz.:'+str(nrpoz)+' brak konta  na kwot:'+str(kwota)+' tre:'+tresc)

    #rsglobal.ZapiszDoLogow(str(stat)+'|'+str(zly_poczatek)+'|'+str(nrpoz)+'|'+str(zly_koniec),0)
    if zly_poczatek+nrpoz+zly_koniec==len(Wiersze):
        stat='OK'
        
    if stat == 'OK':
        # zapisywanie pozycji
#        if sql_insert<>'':
        if nrpoz>0:
            sql_insert=sql_insert.replace('\u20ac','EUR').replace(u'\u20ac','EUR')
            #rsglobal.ZapiszDoLogow(str(sql_insert),0)
            stat,dump,dump,dump=self.PolSQL.Execute(sql_insert,1)
        else:
            stat='Brak poprawnych pozycji w pliku'


            
#-------------------------------------------------------------------------------
# Wczytanie rozszerzenia pliku (11)
#-------------------------------------------------------------------------------

if Fun == 11:
    sql ="SELECT rozszerzenie FROM rs_kasy_banki"
    sql+=" WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"'"
    sql+=" AND kasa_bank_id='"+KasaBank+"';"

    stat,dane,dump,dump=self.PolSQL.Execute(sql,3)
    if stat <> 'OK':
        stat = 'Bd wczytania rozszerzenia: '+stat
        dane.append(stat)


#-------------------------------------------------------------------------------
# Usuniecie wszystkich pozycji (12)
#-------------------------------------------------------------------------------

if Fun == 12:
    sql ="SELECT rozszerzenie FROM rs_kasy_banki"
    sql+=" WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"'"
    sql+=" AND kasa_bank_id='"+KasaBank+"';"

    stat,dump,dump,dump=self.PolSQL.Execute(sql,1)
    if stat <> 'OK':
        stat = 'Bd usuwania pozycji: '+stat
        dane.append(stat)
