# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_rotacja_opakowan_dok_mag.py
# Purpose:     obsluga grida edytowalnego
# Author:      Piotr Witkowski
# Created:     2017/07/21
# RCS-ID:      $Id: fs_rotacja_opakowan_dok_mag.py$
# Copyright:   (c) 2017 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

#Funkcje:
#1. insert/update/delete
#5. pobranie danych

stat='OK'

if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=='OK':
    Funkcja = klucze['Funkcja']

    dane=[]
    wyn1 = []
    wyn2 = []

    UprPrz = self.operator_id == STANDARD_OPERATOR_ID
    UprDodawanie = self.operator_id == STANDARD_OPERATOR_ID
    UprEdycja = self.operator_id == STANDARD_OPERATOR_ID
    UprUsuwanie = self.operator_id == STANDARD_OPERATOR_ID

#-------------------------------------------------------------------------------
#-------  SPRAWDZANIE DELETE  (1)
#-------------------------------------------------------------------------------

if stat=="OK" and Funkcja == 1:
    Delete=klucze['Delete']
    if len(Delete[0])>0:
        if not UprUsuwanie:
            stat='BR UPR DEL'
            dane.append(stat)

        # wykonanie DELETE
        if stat == 'OK':
            for i in xrange(len(Delete[0])):
                DELETE = "DELETE FROM rs_opakowania_rotacja_magazyny "
                DELETE +="WHERE firma_id='"+self.firma_id+"' "
                for j in xrange(len(Delete[0][i])):
                    pole = Delete[1][j]
                    wart = Delete[0][i][j]
                    if pole in ['oddzial_id',]:
                        DELETE += " AND "+pole+"='"+wart+"'"
                DELETE += "; "

            if stat == "OK" and DELETE <> '':
                stat,dump,dump,dump = self.PolSQL.Execute(rsglobal.Dekoduj(DELETE),1)
                if stat <> 'OK':
                    stat = "Bdy przy usuwaniu danych: "+stat
                    dane.append(stat)


#-------------------------------------------------------------------------------
#---   UPDATE DANYCH (1)
#-------------------------------------------------------------------------------

if stat=="OK" and Funkcja == 1:
    Update=klucze['Update']

    if len(Update[0])>0:
        if not UprEdycja:
            stat='BR UPR UPD'
            dane.append(stat)

        if stat == 'OK':
            WierszeNr = Update[-1]
            for i in xrange(len(Update[0])):
                for j in xrange(len(Update[0][i])):
                    pole=Update[0][i][j]
                    wart=Update[1][i][j]

                    if pole == 'oddzial_id':
                        wart = wart.strip()
                        if wart == '':
                            stat = 'BR ODDZ'
                            wyn2.append((WierszeNr[i],0))
                            dane.append(stat)
                        else:
                            sql ="SELECT oddzial_id FROM rs_oddzialy"
                            sql+=" WHERE firma_id = '"+self.firma_id+"'"
                            sql+=" AND oddzial_id = '"+str(wart)+"';"
                            stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                            if stat <> 'OK':
                                stat = 'BL ODDZ'
                                wyn2.append((WierszeNr[i],0))
                                dane.append(stat)
                            elif len(d) == 0:
                                stat = 'BR2 ODDZ'
                                wyn2.append((WierszeNr[i],0))
                                dane.append(stat)

                    elif pole == 'magazyn_id':
                        wart = wart.strip()
                        if wart == '':
                            stat = 'BR MAG'
                            wyn2.append((WierszeNr[i],1))
                            dane.append(stat)
                        else:
                            sql ="SELECT magazyn_id FROM rs_magazyny"
                            sql+=" WHERE firma_id = '"+self.firma_id+"'"
                            sql+=" AND magazyn_id = '"+str(wart)+"';"
                            stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                            if stat <> 'OK':
                                stat = 'BL MAG'
                                wyn2.append((WierszeNr[i],1))
                                dane.append(stat)
                            elif len(d) == 0:
                                stat = 'BR2 MAG'
                                wyn2.append((WierszeNr[i],1))
                                dane.append(stat)

                    elif pole == 'dokument_przyjecia':
                        wart = wart.strip()
                        if wart == '':
                            stat = 'BR PRZ'
                            wyn2.append((WierszeNr[i],2))
                            dane.append(stat)
                        else:
                            sql ="SELECT dokument_id FROM rs_typy_dokumentow_m"
                            sql+=" WHERE firma_id = '"+self.firma_id+"'"
                            sql+=" AND typ_dokumentu='P' AND dokument_id = '"+str(wart)+"';"
                            stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                            if stat <> 'OK':
                                stat = 'BL PRZ'
                                wyn2.append((WierszeNr[i],2))
                                dane.append(stat)
                            elif len(d) == 0:
                                stat = 'BR2 PRZ'
                                wyn2.append((WierszeNr[i],2))
                                dane.append(stat)

                    elif pole == 'dokument_wydania':
                        wart = wart.strip()
                        if wart == '':
                            stat = 'BR WYD'
                            wyn2.append((WierszeNr[i],3))
                            dane.append(stat)
                        else:
                            sql ="SELECT dokument_id FROM rs_typy_dokumentow_m"
                            sql+=" WHERE firma_id = '"+self.firma_id+"'"
                            sql+="  AND typ_dokumentu='W' AND dokument_id = '"+str(wart)+"';"
                            stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                            if stat <> 'OK':
                                stat = 'BL WYD'
                                wyn2.append((WierszeNr[i],3))
                                dane.append(stat)
                            elif len(d) == 0:
                                stat = 'BR2 WYD'
                                wyn2.append((WierszeNr[i],3))
                                dane.append(stat)

                    elif pole == 'wersje_cenowe_id':
                        wart = wart.strip()
                        if wart == '':
                            stat = 'BR WERCEN'
                            wyn2.append((WierszeNr[i],3))
                            dane.append(stat)
                        else:
                            sql ="SELECT kod FROM rs_wersje_cenowe"
                            sql+=" WHERE firma_id = '"+self.firma_id+"' AND kod = '"+str(wart)+"';"
                            stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                            if stat <> 'OK':
                                stat = 'BL WERCEN'
                                wyn2.append((WierszeNr[i],4))
                                dane.append(stat)
                            elif len(d) == 0:
                                stat = 'BR2 WERCEN'
                                wyn2.append((WierszeNr[i],4))
                                dane.append(stat)

        if stat == 'OK':
            if len(dane) > 0:
                stat = dane[0]

        # wykonanie UPDATE
        if stat=='OK':
            sql=''
            for i in xrange(len(Update[0])):
                UPDATE="UPDATE rs_opakowania_rotacja_magazyny "
                SET='SET '
                for j in xrange(len(Update[0][i])):
                    pole=Update[0][i][j]
                    wart=Update[1][i][j]
                    if pole in ['oddzial_id','magazyn_id','dokument_przyjecia','dokument_wydania','wersje_cenowe_id']:
                        SET+=pole+"='"+wart+"',"

                SET=SET.strip(",")
                WHERE=" WHERE firma_id='"+self.firma_id+"'"
                for j in xrange(len(Update[2][i])): # petla po kluczu
                    pole=Update[3][j]
                    wart=rsglobal.Dekoduj(Update[2][i][j])
                    if pole in ['oddzial_id',]:
                        WHERE+=" AND "+pole+"='"+wart+"'"

                WHERE+=";"
                sql+=UPDATE+SET+WHERE;

            if sql<>'':
                stat,dump,dump,dump=self.PolSQL.Execute(rsglobal.Dekoduj(sql),1)
                if stat<>'OK':
                    stat="Bd przy modyfikowaniu danych: "+stat
                    dane.append(stat)


#-------------------------------------------------------------------------------
#---------INSERT DANYCH (1)
#-------------------------------------------------------------------------------

if stat=="OK" and Funkcja == 1:
    Insert=klucze['Insert']
    if len(Insert[0])>0:
        if not UprDodawanie:
            stat='BR UPR INS'
            dane.append(stat)

        if stat == 'OK':
            WierszeNr = Insert[-1]
            for i in xrange(len(Insert[0])):
                StanowiskoNowe = None
                DzialNowy = None
                for j in xrange(len(Insert[0][i])):
                    pole=Insert[1][j]
                    wart=Insert[0][i][j]

                    if pole == 'oddzial_id':
                        wart = wart.strip()
                        if wart == '':
                            stat = 'BR ODDZ'
                            wyn2.append((WierszeNr[i],0))
                            dane.append(stat)
                        else:
                            sql ="SELECT oddzial_id FROM rs_oddzialy"
                            sql+=" WHERE firma_id = '"+self.firma_id+"'"
                            sql+=" AND oddzial_id = '"+str(wart)+"';"
                            stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                            if stat <> 'OK':
                                stat = 'BL ODDZ'
                                wyn2.append((WierszeNr[i],0))
                                dane.append(stat)
                            elif len(d) == 0:
                                stat = 'BR2 ODDZ'
                                wyn2.append((WierszeNr[i],0))
                                dane.append(stat)

                    elif pole == 'magazyn_id':
                        wart = wart.strip()
                        if wart == '':
                            stat = 'BR MAG'
                            wyn2.append((WierszeNr[i],1))
                            dane.append(stat)
                        else:
                            sql ="SELECT magazyn_id FROM rs_magazyny"
                            sql+=" WHERE firma_id = '"+self.firma_id+"'"
                            sql+=" AND magazyn_id = '"+str(wart)+"';"
                            stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                            if stat <> 'OK':
                                stat = 'BL MAG'
                                wyn2.append((WierszeNr[i],1))
                                dane.append(stat)
                            elif len(d) == 0:
                                stat = 'BR2 MAG'
                                wyn2.append((WierszeNr[i],1))
                                dane.append(stat)

                    elif pole == 'dokument_przyjecia':
                        wart = wart.strip()
                        if wart == '':
                            stat = 'BR PRZ'
                            wyn2.append((WierszeNr[i],2))
                            dane.append(stat)
                        else:
                            sql ="SELECT dokument_id FROM rs_typy_dokumentow_m"
                            sql+=" WHERE firma_id = '"+self.firma_id+"'"
                            sql+=" AND typ_dokumentu='P' AND dokument_id = '"+str(wart)+"';"
                            stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                            if stat <> 'OK':
                                stat = 'BL PRZ'
                                wyn2.append((WierszeNr[i],2))
                                dane.append(stat)
                            elif len(d) == 0:
                                stat = 'BR2 PRZ'
                                wyn2.append((WierszeNr[i],2))
                                dane.append(stat)

                    elif pole == 'dokument_wydania':
                        wart = wart.strip()
                        if wart == '':
                            stat = 'BR WYD'
                            wyn2.append((WierszeNr[i],3))
                            dane.append(stat)
                        else:
                            sql ="SELECT dokument_id FROM rs_typy_dokumentow_m"
                            sql+=" WHERE firma_id = '"+self.firma_id+"'"
                            sql+=" AND typ_dokumentu='W' AND dokument_id = '"+str(wart)+"';"
                            stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                            if stat <> 'OK':
                                stat = 'BL WYD'
                                wyn2.append((WierszeNr[i],3))
                                dane.append(stat)
                            elif len(d) == 0:
                                stat = 'BR2 WYD'
                                wyn2.append((WierszeNr[i],3))
                                dane.append(stat)

                    elif pole == 'wersje_cenowe_id':
                        wart = wart.strip()
                        if wart == '':
                            stat = 'BR WERCEN'
                            wyn2.append((WierszeNr[i],3))
                            dane.append(stat)
                        else:
                            sql ="SELECT kod FROM rs_wersje_cenowe"
                            sql+=" WHERE firma_id = '"+self.firma_id+"' AND kod = '"+str(wart)+"';"
                            stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                            if stat <> 'OK':
                                stat = 'BL WERCEN'
                                wyn2.append((WierszeNr[i],4))
                                dane.append(stat)
                            elif len(d) == 0:
                                stat = 'BR2 WERCEN'
                                wyn2.append((WierszeNr[i],4))
                                dane.append(stat)

        if stat == 'OK':
            if len(dane) > 0:
                stat = dane[0]

        # wykonanie INSERT
        if stat == 'OK':
            sqlIns=''
            for i in xrange(len(Insert[0])):
                INSERT="INSERT INTO rs_opakowania_rotacja_magazyny "
                KOLUMNY="(firma_id "
                VALUES=" VALUES ('"+self.firma_id+"' "
                for j in xrange(len(Insert[0][i])):
                    pole=Insert[1][j]
                    wart=Insert[0][i][j]
                    if pole in ['oddzial_id','magazyn_id','dokument_przyjecia','dokument_wydania','wersje_cenowe_id']:
                        KOLUMNY+=","+pole
                        VALUES+=",'"+wart+"'"

                KOLUMNY+=")"
                VALUES+=");"
                sqlIns+=INSERT+KOLUMNY+VALUES
            if sqlIns<>'':
                stat,dump,dump,dump=self.PolSQL.Execute(rsglobal.Dekoduj(sqlIns),1)

                if stat<>'OK':
                    stat="Bd przy dodawaniu danych: "+stat
                    dane.append(stat)

#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (1- insert 1 -select, 1 -delete)
#-------------------------------------------------------------------------------

if stat=='OK' and Funkcja in (1,5):
    if not UprPrz:
        stat='Brak uprawnie do przegldania.'
        dane.append(stat)
    if stat=='OK':
        SQL ="SELECT r.oddzial_id, r.magazyn_id, r.dokument_przyjecia, r.dokument_wydania, r.wersje_cenowe_id"
        SQL+=" FROM rs_opakowania_rotacja_magazyny r"
        SQL+=" WHERE r.firma_id='"+self.firma_id+"' "
        SQL+=" ORDER BY r.oddzial_id, r.magazyn_id, r.dokument_przyjecia, r.dokument_wydania;"
        stat,dane,wyn1,wyn2 = self.PolSQL.Execute(SQL,3)

        if stat <> 'OK':
            stat = "Bd przy pobieraniu danych: "+stat
            dane.append(stat)