
# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_rozliczenia_miedzyokresowe_dane.py
# Purpose:     wczytuje/edytuje dane w rozliczeniach miedzyokresowych
#
# Author:      Marcin Wodarczyk, Pawe Wjcikowski
# Modyfikacja: Jan Raburski
# Created:     2008/10/09
# RCS-ID:      $Id: fs_rozliczenia_miedzyokresowe_dane.py $
# Copyright:   (c) 2008 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

Numer = klucze[0]
Fun = klucze[-1]
stat = 'OK'
dane = []
wyn2 = []

UprEdycja = ((self.oddzial_id,'173012') in self.uprawnienia) or ((self.oddzial_id,'173013') in self.uprawnienia) or \
            self.operator_id == STANDARD_OPERATOR_ID

#-------------------------------------------------------------------------------
#---   UPDATE DANYCH (4- bez pobierania,3- z pobieraniem)
#-------------------------------------------------------------------------------

if Fun in (3,4):
    if not UprEdycja:
        stat='UPR UPD'
    
    if stat == 'OK':
        sql ="SELECT numer FROM rs_rozliczenia_miedzyokresowe"
        sql+=" WHERE firma_id = '"+self.firma_id+"' AND numer = "+str(Numer)+" FOR UPDATE NOWAIT;"
        stat,d,dump,dump = self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Bd pobrania danych rozliczenia : '+stat
        elif len(d) <> 1:
            stat = 'Brak rozliczenia o podanym numerze'
            
    if stat == 'OK':
        #sprawdzenie danych
        for i in xrange(len(pola)):
            pole = pola[i]
            wart = wartosci[i]

            if pole=='grupa':
                if wart == '':
                    stat = 'PUS GRUPA'
                    dane.append(stat)
                else:
                    sql = "SELECT kod FROM rs_grupy_rozliczen WHERE firma_id='"+self.firma_id+"' AND kod='"+wart+"';"
                    stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                    if stat <> 'OK':
                        dane.append('Bd sprawdzenia kodu grupy rozlicze : '+stat)
                    elif len(d) == 0:
                         dane.append('BL GRUPA')
                    wartosci[i]="'"+wart+"'"
                        
            elif pole=='opis':
                if wart == '':
                    dane.append('PUS OPIS')
                wartosci[i]="'"+wart+"'"
            
            elif pole=='projekt_id':
                if wart == '':
                    dane.append('PUS PROJEKT')
                else:
                    sql ="SELECT projekt_id FROM rs_projekty WHERE firma_id='"+self.firma_id+"' AND projekt_id='"+wart+"';"
                    stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                    if stat <> 'OK':
                        dane.append('Bd sprawdzenia kodu projektu : '+stat)
                    elif len(d) == 0:
                        dane.append('BL PROJEKT')
                    wartosci[i]="'"+wart+"'"
            
            elif pole == 'konto':
                if wart == '':
                    dane.append('PUS KONTO')
                else:
                    sql = "SELECT rsf_podaj_parametry_konta('"+self.firma_id+"','"+self.okres_id+"','"+wart+"');"
                    DaneTmp = self.PolSQL.Execute(sql,3)[1]
                    if (DaneTmp <> []) and (DaneTmp <> None):
                        Dane = rsglobal.rseval(DaneTmp[0][0])
                        if Dane[0] == '':
                            dane.append('BL_KONTO_WN')
                    wartosci[i]="'"+wart+"'"
                        
            elif pole == 'data_wprow':
                if wart == '    -  -  ':
                    dane.append('PUS DATAWPROW')
                else:
                    if not rsglobal.SprawdzCzyToData(wart):
                        dane.append('BL_DATAWPROW')
                    wartosci[i]="'"+wart+"'"

            elif pole == 'data_pierwszego_odpisu':
                if wart == '    -  -  ':
                    wart = 'NULL'
                    wartosci[i]=wart
                else:
                    if not rsglobal.SprawdzCzyToData(wart):
                        dane.append('BL DATA PIERWSZEGO ODPISU')
                    wartosci[i]="'"+wart+"'"
                
            elif pole in ('kwota_pocz','kwota_akt','liczba_miesiecy','odpis_kwota','odpis_ostatni',
                           'kwota_pierwszego_odpisu','kwota_ostatniego_odpisu'):
                wartosci[i]=str(wart)
                
        #jesli byly jakies bledy
        if len(dane) > 0:
            stat = dane[0]
            
    #zapis
    if stat == 'OK':
        UPDATE = "UPDATE rs_rozliczenia_miedzyokresowe SET "
        for i in xrange(len(pola)):
            pole = pola[i]
            wart = wartosci[i]
            UPDATE += pole+"="+wart+","

        UPDATE = UPDATE[0:-1]+" WHERE firma_id='"+self.firma_id+"' AND numer = "+str(Numer)+";"
        stat,dump,dump,dump = self.PolSQL.Execute(UPDATE,1)

#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (5 -select, 3 -update z pobraniem, 1 -insert z pobraniem)
#-------------------------------------------------------------------------------

if Fun in (5,3,1) and stat == 'OK':
    Grupa = ''
    Projekt = ''
    
    SELECT = "SELECT * FROM rs_rozliczenia_miedzyokresowe WHERE firma_id='"+self.firma_id+"' AND numer="+Numer+";"
    stat,dane,wyn1,dump = self.PolSQL.Execute(SELECT,3)
    if stat <> 'OK':
        stat = 'Bd pobrania danych rozliczenia : '+stat
    else:
        #pobranie opisow slownikowych
        for i in xrange(len(wyn1)):
            pole = wyn1[i][0]
            wart = str(dane[0][i])
            
            if pole == 'grupa' and wart <> 'None':
                if ((self.oddzial_id,'011490') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID:
                    sql = "SELECT opis FROM rs_grupy_rozliczen WHERE firma_id='"+self.firma_id+"' AND kod='"+wart+"';"
                    st,d,dump,dump = self.PolSQL.Execute(sql,3)
                    if st <> 'OK':
                        Grupa = 'Bd pobrania opisu grupy rozlicze : '+st
                    else:
                        if len(d) == 0:
                            Grupa = 'Brak grupy o podanym kodzie'
                        else:
                            Grupa = str(d[0][0])
                else:
                    Grupa = 'Brak uprawnie do sownika grupy rozlicze. Poinformuj administratora.'
            
            elif pole == 'projekt_id' and wart <> 'None':
                if ((self.oddzial_id,'027000') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID:
                    sql ="SELECT nazwa FROM rs_projekty WHERE firma_id='"+self.firma_id+"' AND projekt_id='"+wart+"';"
                    st,d,dump,dump = self.PolSQL.Execute(sql,3)
                    if st <> 'OK':
                        Projekt = 'Bd pobrania opisu projektu : '+st
                    else:
                        if len(d) == 0:
                            Projekt = 'Brak projektu o podanym kodzie'
                        else:
                            Projekt = str(d[0][0])
                else:
                    Projekt = 'Brak uprawnie do projektw. Poinformuj administratora.'
                    
    wyn2 = [Grupa,Projekt]
