#!/usr/bin/python
# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:             fs_serwis_zgloszenia.py
# Purpose:          przegldanie zgloszen do serwisu
# Author:           Dariusz Boduch
# Created:          2008/08/01
# RCS-ID:           $Id: fs_serwis_zgloszenia.py $
# Copyright:        (c) 2007 RecordSystem
# Licence:          GNU GPL
#-------------------------------------------------------------------------------
# drobne modyfikacje - Pawe Wjcikowski < koniec 05.07.2009r >

ModelF=klucze[0]
NrSeriiF=klucze[1]
KontrahentF=klucze[2]
DataOdF=klucze[3]
DataDoF=klucze[4]
StatusF=klucze[5]
NrZgloszeniaF=str(klucze[6])
ModelU=klucze[7]
NrSeriiU=klucze[8]
KontrU=klucze[9]

Fun=klucze[-1]
stat = "OK"
dane = []
puste_pola = ['    -  -  ','',[]]


#-------------------------------------------------------------------------------
#--- SPRAWDZANIE DANYCH
#-------------------------------------------------------------------------------

if DataOdF <> '    -  -  ':
    if not rsglobal.SprawdzCzyToData(DataOdF):
        stat='BL DATAOD'
if DataDoF <> '    -  -  ':
    if not rsglobal.SprawdzCzyToData(DataDoF):
        stat='BL DATADO'

if DataOdF <> '    -  -  ' and DataDoF <> '    -  -  ':
    if DataDoF<DataOdF:
        stat='BL ZAKR DAT'


#-------------------------------------------------------------------------------
#--- POBRANIE DANYCH (5 -select)
#-------------------------------------------------------------------------------

if stat=='OK' and Fun in [5] :
    Filtr = " firma_id = '" + self.firma_id+"' "
    if ModelF not in puste_pola:
        Filtr+=" AND artykul_id LIKE '"+ModelF+"%' "
    if NrSeriiF not in puste_pola:
        Filtr+=" AND nr_serii LIKE '"+NrSeriiF+"%' "
    if KontrahentF.strip()<>'':
        Filtr+=" AND kontrahent_id LIKE '"+KontrahentF+"%' "
    if DataOdF not in puste_pola:
        Filtr+=" AND zgloszenie_data>='"+DataOdF+"' "
    if DataDoF not in puste_pola:
        Filtr+=" AND zgloszenie_data<='"+DataDoF+"' "
    if StatusF not in puste_pola:
        Filtr+=" AND zgloszenie_status = '"+StatusF+"' "
    if (ModelU not in puste_pola) and (NrSeriiU not in puste_pola) and (KontrU not in puste_pola):
        Filtr+=" AND artykul_id='"+ModelU+"' AND nr_serii='"+NrSeriiU+"' AND kontrahent_id='"+KontrU+"' "
    
    SELECT="SELECT zgloszenie_id,artykul_id, nr_serii, kontrahent_id, osoba_id, zgloszenie_data, zgloszenie_termin, "
    SELECT+=" zgloszenie_rodzaj, zgloszenie_status"
    FROM=" FROM rs_serwis_zgloszenia " 
    WHERE=" WHERE "+Filtr
    ORDER=" ORDER BY zgloszenie_data, zgloszenie_id ;"	
    
    sql=SELECT+FROM+WHERE+ORDER
    stat,dane,dump,dump=self.PolSQL.Execute(rsglobal.Dekoduj(sql),3)
    if stat!="OK":
        stat="BL SQL PRZ$"+stat
        dane.append(stat)