# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_slowniki_wczytaj_slownik.py
# Purpose:     podaje parametry slownika i wczytuje dane uwzgldniajc uprawnienia operatora 
#
# Author:      Jan Raburski
# Created:     2005/10/28
# RCS-ID:      $Id: fs_slowniki_wczytaj_slownik.py $
# Copyright:   (c) 2005 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

# 2019-05-13 Wojciech Skowron (11486) RSSLowniki - refaktoryzacja - klucze w postaci sownika zamiast listy

# klucze[0] - nazwa tabeli ze slownikiem
# wraca z danymi ze slownika + opisem (wyn2)

dane = []
stat = "OK"

if not 'Funkcja' in klucze:
    stat = 'Brak podanej funkcji w kluczach'
    Fun = 999

if stat == 'OK':
    Fun = klucze['Funkcja']

    SlPar = {'Tabela':[5,9,15], 'Kod':[15], 'Pola':[15]}
    Lista = rsglobal.SprawdzParametryWKluczach(SlPar, Fun, klucze)
    if Lista != '':
        stat = 'Uwaga : wywoanie funkcji fs_slowniki_wczytaj_slownik z numerem '+str(Fun)+' bez parametrw: '+Lista

if stat == 'OK':
    if Fun in [5,9,15]:
        Tabela = klucze['Tabela']
    if Fun == 15:
        Kod = klucze["Kod"]
        Pola = klucze["Pola"]

# tabela = klucze[0]
# Fun = klucze[-1]
#
# dane = []
# wyn1 = []
# stat = 'OK'

#-------------------------------------------------------------------------------
# SPRAWDZENIE, CZY MAMY UPRAWNIENIA DO SLOWNIKA - 9
#-------------------------------------------------------------------------------

if stat == "OK" and Fun == 9:
# if Fun == 9:
    sql = "SELECT slownik_id FROM rs_slowniki WHERE tabela = '"+Tabela+"';"
    stat,dane,dump,dump = self.PolSQL.Execute(sql,3);
    if stat <> 'OK':
        stat = 'Bd pobrania informacji o sowniku '+Tabela+' : '+stat
    else:
        if (self.oddzial_id,dane[0][0]) in self.uprawnienia or self.operator_id == STANDARD_OPERATOR_ID:
            dane[0][0] = 'OK'
        else:
            dane[0][0] = 'Brak uprawnie do sownika '+Tabela

#-------------------------------------------------------------------------------
# POBRANIE SLOWNIKA - 5
#-------------------------------------------------------------------------------

if stat == "OK" and Fun == 5:
# if Fun not in [9,15]:
    stat,opis,dump,dump = self.PolSQL.Execute("SELECT slownik_id,menu_id,nazwa,typ,dlugosc,pola,funkcja FROM rs_slowniki WHERE tabela = \'%s\';" % Tabela,3)
    if stat=='OK':
        wyn2 = opis
        orderby = 'kod'
        inne = opis[0][3]=='I'
        if inne:
            funkcja = rsglobal.rseval(opis[0][6])
            orderby, dump, dump, dump = funkcja[0]
        slownik = opis[0][0]
        if ((self.oddzial_id,slownik) in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
            if inne:
                stat,dane,wyn1,dump = self.PolSQL.Execute("SELECT * FROM %s ORDER BY %s;" % (Tabela,orderby),3)
            else:
                if opis[0][5]==1:
                    stat,dane,wyn1,dump = self.PolSQL.Execute("SELECT kod,opis FROM %s WHERE firma_id=\'%s\' ORDER BY kod;" % (Tabela,self.firma_id),3)
                else:
                    stat,dane,wyn1,dump = self.PolSQL.Execute("SELECT kod,opis FROM %s WHERE firma_id=\'%s\' AND oddzial_id=\'%s\' ORDER BY kod;" % (Tabela,self.firma_id,self.oddzial_id),3)
        else:    
            stat='Brak uprawnie do sownika. Poinformuj administratora.'
            dane=[[]]

#-------------------------------------------------------------------------------
# POBRANIE danych sownika 15
#-------------------------------------------------------------------------------

if stat == "OK" and Fun == 15:
# if Fun == 15:
#     Kod = klucze[1]
#     Pola = klucze[2]
    SQL ="SELECT "+str(Pola).replace('[','').replace(']','').replace("\'","")+" FROM "+str(Tabela)+" WHERE kod='"+Kod+"' AND firma_id='"+self.firma_id+"';"
    rsglobal.ZapiszDoLogow('aaaaaaaaaaa '+str(SQL),1)
    stat,dane,dump,dump = self.PolSQL.Execute(SQL,3)
    if stat <> 'OK':
        stat = 'Bd pobrania informacji o sowniku '+Tabela+' : '+stat