# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_srodki_trwale_zawieszenia_amortyzacji.py
# Purpose:     wyswietla, dodaje,usuwa zawieszenia amortyzacji operujc na tabeli rs_srodki_trwale_zawieszenia_amortyzacji
# Author:      Dariusz Boduch
# Created:     2010/10/28
# RCS-ID:      $Id: fs_srodki_trwale_zawieszenia_amortyzacji.py$
# Copyright:   (c) 2010 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

# 2012-08-27 Mariusz Rajfura (5901) popr.kontroli dat (0001-01-01 zamiast 0000-01-01)

stat='OK'

if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=='OK':
    Funkcja = klucze['Funkcja']

    SlPar={'SrodekId':[1,5],'DataOd':[1,5],'DataDo':[1,5]}
    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Funkcja,klucze)
    if Lista<>'':
        stat='Uwaga : wywoanie funkcji fs_kontrahenci_kuke z numerem '+str(Fun)+' bez parametrw: '+Lista

if stat=='OK':
    if Funkcja in [1,5]:
        SrodekId = klucze['SrodekId']
        DataOd = klucze['DataOd']
        DataDo = klucze['DataDo']

dane = []
wyn1=[]
wyn2=[]
self.CzyLiczycPlan=False

UprDodawanie=(((self.oddzial_id,'174123') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID))
UprEdycja=(((self.oddzial_id,'174122') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)) or UprDodawanie
UprUsuwanie=(((self.oddzial_id,'174124') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID))


# -------------------------------------------------------------------
#-------- EDYCJA GRIDA EDYTOWALNEGO (1)
#-------------------------------------------------------------------------------

Insert = []
Update = []
Delete = []

if Funkcja == 1:
    Update=klucze['Update']
    Insert=klucze['Insert']
    Delete=klucze['Delete']


#-------------------------------------------------------------------------------
#------- SPRAWDZAM CZY JEST UTWORZONY PLAN DLA SRODKA TRWAEGO
#-------------------------------------------------------------------------------

if Funkcja == 1 and (len(Insert[0])>0 or len(Update[0])>0) and stat=='OK':
    SQL="SELECT rok,miesiac FROM rs_srodki_trwale_plan WHERE firma_id='"+str(self.firma_id)+"' AND srodek_id='"+str(SrodekId)+"' "
    SQL+="ORDER BY rok DESC, miesiac DESC  LIMIT 1;"
    stat,dp,dump,dump=self.PolSQL.Execute(SQL,3)
    if stat<>'OK':
        stat='Bd pobrania danych palnu amortyzacji: '+stat
        dane.append(stat)
    elif len(dp)==0:
        stat='BR PLAN'
        dane.append(stat)
    else:
        #Maksymalna data planu amortyzacji (zeby przy dodawaniu/edycji nie wyjsc poza plan data od)
        RokMax=dp[0][0]
        McMax =dp[0][1]        
    
    if stat=='OK':
        SQL="SELECT rok,miesiac FROM rs_srodki_trwale_plan WHERE firma_id='"+str(self.firma_id)+"' AND srodek_id='"+str(SrodekId)+"' "
        SQL+="ORDER BY rok, miesiac LIMIT 1;"
        stat,dp,dump,dump=self.PolSQL.Execute(SQL,3)
        if stat<>'OK':
            stat='Bd pobrania danych palnu amortyzacji: '+stat
            dane.append(stat)
        elif len(dp)==0:
            stat='BR PLAN'
            dane.append(stat)
        else:
            #Minimalna data planu amortyzacji (zeby przy dodawaniu/edycji nie wyjsc poza plan data od)
            RokMin=dp[0][0]
            McMin =dp[0][1]        
    

#-------------------------------------------------------------------------------
#-------  SPRAWDZANIE DELETE
#-------------------------------------------------------------------------------

if Funkcja == 1 and stat=='OK':
    if len(Delete[0])>0:
        if not UprUsuwanie:
            stat='Brak uprawnie do usuwania danych'
            dane.append(stat)    
        if stat=='OK':
            sql=''
            for i in xrange(len(Delete[0])):
                SQL="SELECT rok, miesiac FROM rs_srodki_trwale_plan "
                WHERE="WHERE firma_id='"+str(self.firma_id)+"' AND srodek_id='"+str(SrodekId)+"'"
                WHERE+=" AND umorzone AND rok||miesiac between "
                for j in xrange(len(Delete[0][i])):
                    pole=Delete[1][j]
                    wart=Delete[0][i][j]
                    if pole in ['data_od','data_do']:
                        #WHERE+=" AND "+pole+"='"+wart+"'"
                        WHERE+= " '"+str(wart[0:4])+str(wart[5:7])+"' AND"
                sql+=SQL+WHERE[:-3]+";"
                stat,du,dump,dump=self.PolSQL.Execute(sql,3)
                if stat<>'OK':
                    stat='Bd sprawdzania danych przed usuniciem zawieszenia: '+stat
                    dane.append(stat)
                elif len(du)>0:
                    TXT=''
                    for w in du:
                        TXT=TXT+'Nie mona usun zawieszenia, rodek zosta zamortyzowany: '+str(w[0])+' - '+str(w[1])+' \n '
                    stat=TXT
                    dane.append(stat)
                    
#-------------------------------------------------------------------------------
#-------------------------- DELETE    
#-------------------------------------------------------------------------------
        
        if stat=='OK':
            sql=''
            for i in xrange(len(Delete[0])):
                DELETE="DELETE FROM rs_srodki_trwale_zawieszenia_amortyzacji "
                WHERE="WHERE firma_id='"+self.firma_id+"' AND srodek_id='"+str(SrodekId)+"'"
                for j in xrange(len(Delete[0][i])):
                    pole=Delete[1][j]
                    wart=Delete[0][i][j]
                    if pole in ['data_od','data_do']:
                        WHERE+=" AND "+pole+"='"+wart+"'"
                sql+=DELETE+WHERE+";"
            if sql<>'': 
                stat,dump,dump,dump=self.PolSQL.Execute(rsglobal.Dekoduj(sql),1)
                if stat<>'OK':
                    stat=u"Bd przy usuwaniu danych: "+stat   
                    dane.append(stat)
                else:
                     self.CzyLiczycPlan=True
                                 
#-------------------------------------------------------------------------------
#---   UPDATE DANYCH (1)
#-------------------------------------------------------------------------------

if Funkcja == 1 and stat=="OK":
    if len(Update[0])>0:
        if not UprEdycja:
            stat='Brak uprawnie do edycji danych'
            dane.append(stat)
           
        if stat=='OK':
            sel1="SELECT kod FROM rs_miejsca_uzytkowania;"
            stat,D,dump,dump = self.PolSQL.Execute(sel1,3)
            if stat<>'OK':
                stat=u"Bd przy sprawdzaniu kodu: "+stat   
                dane.append(stat)        
            DaneI=[]
    
            for i in xrange(len(D)):
                for x in D[i]:
                    DaneI.append(str(x).strip())     

            WierszeNr = Update[-1]
            for i in xrange(len(Update[0])):
                for j in xrange(len(Update[0][i])): 
                        #if stat == "OK":
                        pole=Update[0][i][j]
                        wart=Update[1][i][j]
                        DataOD=''
                        DataDO=''
                        if pole == 'data_od':
                            if (not rsglobal.SprawdzCzyToData(wart)) and wart != '':                          
                                stat='BL DATA1'
                                dane.append(stat)
                                wyn2.append((WierszeNr[i],0))
                            elif wart == '':
                                stat='PUS DATA1'
                                dane.append(stat)
                                wyn2.append((WierszeNr[i],0))
                            else:
                                SQL="SELECT data_od FROM rs_srodki_trwale_zawieszenia_amortyzacji "
                                SQL+="WHERE  firma_id='"+self.firma_id+"' AND srodek_id='"+str(SrodekId)+"' "
                                SQL+="AND data_od='"+str(wart)+"' ;"
                                stat,d,dump,dump=self.PolSQL.Execute(SQL,3)
                                if stat<>'OK':
                                    stat='Bd sprawdzania daty od: '+stat
                                    dane.append(stat)
                                    wyn2.append((WierszeNr[i],0))
                                elif len(d)>0:
                                    stat='Data od jest wykorzystana'
                                    dane.append(stat)
                                    wyn2.append((WierszeNr[i],0))
                                else:
                                    DataOD=wart[0:4]+wart[5:7]
                        if pole == 'data_do':
                            if (not rsglobal.SprawdzCzyToData(wart)) and wart != '':
                                stat='BL DATA2'
                                dane.append(stat)
                                wyn2.append((WierszeNr[i],1))
                            elif wart == '':
                                stat='PUS DATA2'
                                dane.append(stat)
                                wyn2.append((WierszeNr[i],0))
                            else:
                                DataDO=wart[0:4]+wart[5:7]
                        
                        for j in xrange(len(Update[2][i])): # pobranie zakresu zmienianego do sprawdzenia czy nie nie ma pozniejszego
                            poleK=Update[3][j]
                            wartK=rsglobal.Dekoduj(Update[2][i][j])
                            if poleK=='data_od':
                                dataod=wartK
                            if poleK=='data_do':
                                datado=wartK
                        if stat=='OK':
                            SQL="SELECT data_od,data_do FROM rs_srodki_trwale_zawieszenia_amortyzacji "
                            SQL+="WHERE  firma_id='"+self.firma_id+"' AND srodek_id='"+str(SrodekId)+"' "
                            SQL+="AND data_od>'"+str(datado)+"' ;"
                            stat,dz,dump,dump=self.PolSQL.Execute(SQL,3)
                            if stat<>'OK':
                                stat='Bd sprawdzania zakresu planu (update) :'+stat
                                dane.append(stat)
                            else:
                                if len(dz)>0:
                                    stat='Nie mona zmieni zawieszenia, rodek zosta zamortyzowany.'
                                    dane.append(stat)
                                    wyn2.append((WierszeNr[i],0))
                                    wyn2.append((WierszeNr[i],1))       
                        
                        for j in xrange(len(Update[2][i])): # petla po kluczu do zoenia penego selecta
                            poleK=Update[3][j]
                            wartK=rsglobal.Dekoduj(Update[2][i][j])
                            if DataOD=='':
                                if poleK=='data_od':
                                    DataOD=wartK[0:4]+wartK[5:7]
                            if DataDO=='':
                                if poleK=='data_do':
                                    DataDO=wartK[0:4]+wartK[5:7]
 
                        if stat=='OK':
                            #CZY DATA OD NIE WYCHODZI PRZED PLAN AMORTYZACJI
                            DataMin=RokMin+McMin
                            if int(DataMin)>int(DataOD):
                                stat='Data od wykracza przed plan amortyzacji'
                                dane.append(stat)
                                
                        if stat=='OK':
                            #CZY DATA OD NIE WYCHODZI POZA PLAN AMORTYZACJI
                            DataMax=RokMax+McMax
                            if int(DataMax)<int(DataOD):
                                stat='Data od wykracza poza plan amortyzacji'
                                dane.append(stat)         
                        
                        DataDOUPD=int(DataDO)+1
                        if stat=='OK': #SPRAWDZAM CZY DATY NIE POKRYWAJA SIE Z AMORTYZACJA
                            SQL="SELECT rok, miesiac FROM rs_srodki_trwale_plan "
                            SQL+="WHERE firma_id='"+self.firma_id+"' AND srodek_id='"+str(SrodekId)+"' "
                            SQL+=" AND rok||miesiac>='"+str(DataOD)+"' "
                            SQL+="AND rok||miesiac<='"+str(DataDOUPD)+"' "
                            SQL+="AND NOT umorzone "
                            SQL+="ORDER BY 1,2 ;"
                            stat,dz,dump,dump=self.PolSQL.Execute(SQL,3)
                            if stat<>'OK':
                                stat='Bd sprawdzania zakresu planu (update) :'+stat
                                dane.append(stat)
                            else:
                                if len(dz)==0:
                                    stat='W podanym okresie rodek zosta zamortyzowany lub zakres dat nie obejmuje planu amortyzacji'
                                    dane.append(stat)
                                    wyn2.append((WierszeNr[i],0))
                                    wyn2.append((WierszeNr[i],1))            
        
        
        if stat=='OK':    
            sql=''        
            for i in xrange(len(Update[0])):   
                UPDATE="UPDATE rs_srodki_trwale_zawieszenia_amortyzacji "
                SET='SET '
                for j in xrange(len(Update[0][i])): 
                    pole=Update[0][i][j]
                    wart=Update[1][i][j]
                    if pole in []: 
                        SET+=pole+"='"+wart+"',"
                    if pole in ['data_od','data_do']:
                        if len(wart)==0:
                            SET+=pole+"="+str('NULL')+","
                        else:
                            SET+=pole+"='"+wart+"',"
                SET=SET.strip(",")
                WHERE=" WHERE firma_id='"+self.firma_id+"' AND srodek_id ='"+str(SrodekId)+"'"
                for j in xrange(len(Update[2][i])): # petla po kluczu
                    pole=Update[3][j]
                    wart=rsglobal.Dekoduj(Update[2][i][j])
                    WHERE+=" AND "+pole+"='"+wart+"'"
                WHERE+=" ;" 
                if str(SET)=='SET ':
                    pass
                else:
                    sql+=UPDATE+SET+WHERE;
            if sql<>'': 
                
                stat,dump,dump,dump=self.PolSQL.Execute(rsglobal.Dekoduj(sql),1)   
                if stat<>'OK':
                    stat=u"Bd przy modyfikowaniu danych: "+stat   
                    dane.append(stat)  
                else:
                    self.CzyLiczycPlan=True

                    
#----------------------------------------------------------------------------------------------------------------------
#---------Sprawdzanie danych do Insert------
#----------------------------------------------------------------------------------------------------------------------

if Funkcja == 1 and stat=='OK':
    if len(Insert[0])>0:
        if not UprDodawanie:
            stat='Brak uprawnie do dodawania danych'
            dane.append(stat)
        
        #CZY ZOSTAY ZAMORTYZOWANE POPRZEDNIE ZAWIESZENIA
        if stat=='OK':
            SQL="SELECT rok, miesiac FROM rs_srodki_trwale_plan "
            SQL+="WHERE firma_id='"+str(self.firma_id)+"' AND srodek_id='"+str(SrodekId)+"'"
            SQL+=" AND NOT umorzone AND rach_procent=0 AND rach_kwota=0 and rach_metoda is not null; "
            stat,di,dump,dump=self.PolSQL.Execute(SQL,3)
            if stat<>'OK':
                stat='Bd sprawdzania zakresu planu (insert) :'+stat
                dane.append(stat)
            else:
                if len(di)>0:
                    TXT=''
                    for w in di:
                        TXT=TXT+'Nie mona doda nowego zawieszenia,w podanym okresie rodek nie zosta zamortyzowany : '+str(w[0])+' - '+str(w[1])+' \n '
                    stat=TXT
                    dane.append(stat)
                    wyn2.append((WierszeNr[i],0))
                    wyn2.append((WierszeNr[i],1)) 

        if stat=='OK':                    

            WierszeNr = Insert[-1]
            DaneI=[]
    
            DataOD=''
            DataDO=''
            if len(Insert[0])>1:
                stat='Nie mona doda '+str(len(Insert[0]))+' zawiesze jednorazowo'
                dane.append(stat)
        if stat=='OK':
            for i in xrange(len(Insert[0])):
                for j in xrange(len(Insert[0][i])):
                    pole=Insert[1][j]
                    wart=Insert[0][i][j]
                    if pole == 'data_od':
                        if (not rsglobal.SprawdzCzyToData(wart)) and wart != '':
                            stat='BL DATA1'
                            dane.append(stat)
                            wyn2.append((WierszeNr[i],0))
                        elif wart == '':
                            stat='PUS DATA1'
                            dane.append(stat)
                            wyn2.append((WierszeNr[i],0))
                        else:
                            #Czy data od nie jest wczesniejsza ni data wprowadzenia do systemu, daty przyjecia
                            SQL="SELECT COALESCE(data_przyjecia,'0001-01-01'::DATE), COALESCE(data_wprowadzenia_do_systemu,'0001-01-01'::DATE) "
                            SQL+="FROM rs_srodki_trwale "
                            SQL+="WHERE  firma_id='"+self.firma_id+"' AND srodek_id='"+str(SrodekId)+"' ; "
                            stat,d,dump,dump=self.PolSQL.Execute(SQL,3)
                            if stat<>'OK':
                                stat='Bd pobrania daty przyjcia rodka trwaego: '+stat
                                dane.append(stat)
                                wyn2.append((WierszeNr[i],0))
                            elif d[0][0]=='0001-01-01':
                                stat='Brak daty przyjcia rodka trwaego lub bdny symbol rodka trwaego'
                                dane.append(stat)
                                wyn2.append((WierszeNr[i],0))
                            else:
                                if wart<max(d[0][0],d[0][1]):
                                    stat='Data od nie moe by mniejsza ni data wprowadzenia / przyjcia rodka trwaego: '+max(d[0][0],d[0][1])
                                    dane.append(stat)
                                    wyn2.append((WierszeNr[i],0))
                            if stat=='OK':
                                #Czy nowa data od nie pokrywa si z zakresem poprzedniego zawieszenia
                                SQL="SELECT data_do FROM rs_srodki_trwale_zawieszenia_amortyzacji "
                                SQL+="WHERE  firma_id='"+self.firma_id+"' AND srodek_id='"+str(SrodekId)+"' "
                                SQL+="AND data_do >='"+str(wart)+"' ORDER BY data_do DESC LIMIT 1 ;"
                                stat,dod,dump,dump=self.PolSQL.Execute(SQL,3)
                                if stat<>'OK':
                                    stat='Bd sprawdzania daty od: '+stat
                                    dane.append(stat)
                                    wyn2.append((WierszeNr[i],0))
                                elif len(dod)>0:
                                    stat='Data od nie moe by wczeniejsza ni Data do poprzedniego zawieszenia '
                                    dane.append(stat)
                                    wyn2.append((WierszeNr[i],0))
                            if stat=='OK':
                                #Czy nie ma ju daty_od w tabeli (jest kluczem gwnym)
                                SQL="SELECT data_od FROM rs_srodki_trwale_zawieszenia_amortyzacji "
                                SQL+="WHERE  firma_id='"+self.firma_id+"' AND srodek_id='"+str(SrodekId)+"' "
                                SQL+="AND data_od='"+str(wart)+"' ;"
                                stat,d,dump,dump=self.PolSQL.Execute(SQL,3)
                                if stat<>'OK':
                                    stat='Bd sprawdzania daty od: '+stat
                                    dane.append(stat)
                                    wyn2.append((WierszeNr[i],0))
                                elif len(d)>0:
                                    stat='Data od jest wykorzystana'
                                    dane.append(stat)
                                    wyn2.append((WierszeNr[i],0))
                                else:
                                    DataOD=wart[0:4]+wart[5:7]
                    elif pole == 'data_do':
                        if (not rsglobal.SprawdzCzyToData(wart)) and wart != '':
                            stat='BL DATA2'
                            dane.append(stat)
                            wyn2.append((WierszeNr[i],1))
                        elif wart == '':
                                stat='PUS DATA2'
                                dane.append(stat)
                                wyn2.append((WierszeNr[i],0))
                        else:
                            DataDO=wart[0:4]+wart[5:7]
                    
                    
                    if stat=='OK':
                        #CZY DATA OD NIE WYCHODZI PRZED PLAN AMORTYZACJI
                        DataMin=RokMin+McMin
                        if int(DataMin)>int(DataOD):
                            stat='Data od wykracza przed plan amortyzacji'
                            dane.append(stat)
                    
                    if stat=='OK':
                        #CZY DATA OD NIE WYCHODZI POZA PLAN AMORTYZACJI
                        DataMax=RokMax+McMax
                        if int(DataMax)<int(DataOD):
                            stat='Data od wykracza poza plan amortyzacji'
                            dane.append(stat)
                    #CZY DATA OD < OD DATY DO
                    if ((DataOD<>'') and (DataDO<>'')) and (int(DataOD)>int(DataDO))and stat=='OK':
                        stat='Niepoprawny zakres dat'
                        dane.append(stat)
                        wyn2.append((WierszeNr[i],0))
                    #SPRAWDZAM CZY DATY NIE POKRYWAJA SIE Z AMORTYZACJA    
                    if ((DataOD<>'') and (DataDO<>'')) and stat=='OK': 
                        SQL="SELECT rok, miesiac FROM rs_srodki_trwale_plan "
                        SQL+="WHERE firma_id='"+self.firma_id+"' AND srodek_id='"+str(SrodekId)+"' "
                        SQL+=" AND rok||miesiac>='"+str(DataOD)+"' "
                        SQL+="AND rok||miesiac<='"+str(DataDO)+"' "
                        SQL+="AND umorzone "
                        SQL+="ORDER BY 1,2 ;"
                        stat,dz,dump,dump=self.PolSQL.Execute(SQL,3)
                        if stat<>'OK':
                            stat='Bd sprawdzania zakresu planu :'+stat
                            dane.append(stat)
                        else:
                            if len(dz)>0:
                                TXT=''
                                for w in dz:
                                    TXT=TXT+'W podanym okresie rodek zosta zamortyzowany: '+str(w[0])+' - '+str(w[1])+' \n '
                                stat=TXT
                                dane.append(stat)
                                wyn2.append((WierszeNr[i],0))
                                wyn2.append((WierszeNr[i],1))
                    #SPRAWDZIC CZY POCZATEK ZAWIESZENIA NIE JEST PRZED POCZATKIEM PLANU AMORYACJI
                                                          
 #------------------------------------------------------------------------------
 #---------------   INSERT
 #------------------------------------------------------------------------------

        if stat=='OK':
            sqlIns=''
            for i in xrange(len(Insert[0])):
                INSERT="INSERT INTO rs_srodki_trwale_zawieszenia_amortyzacji "
                KOLUMNY="(firma_id,srodek_id"
                VALUES=" VALUES ('"+self.firma_id+"','"+SrodekId+"'"
                for j in xrange(len(Insert[0][i])):
                    pole=Insert[1][j]
                    wart=Insert[0][i][j]
                    if pole in ['data_od','data_od']:
                        KOLUMNY+=","+pole
                        VALUES+=",'"+wart+"'"  
                    if pole == 'data_do':
                        if len(wart)==0:
                            KOLUMNY+=","+pole
                            VALUES+=","+str('NULL')+""                        
                        else:
                            KOLUMNY+=","+pole
                            VALUES+=",'"+wart+"'"             
                KOLUMNY+=")"
                VALUES+=");"
                sqlIns+=INSERT+KOLUMNY+VALUES
            if sqlIns<>'': 
                stat,dump,dump,dump=self.PolSQL.Execute(rsglobal.Dekoduj(sqlIns),1)
                if stat<>'OK':
                    stat=u"Bd przy dodawaniu danych: "+stat   
                    dane.append(stat)
                else:
                    self.CzyLiczycPlan=True                   
                                                             
#-------------------------------------------------------------------------------
#   LICZENIE PLANU
#-------------------------------------------------------------------------------

if stat=='OK' and self.CzyLiczycPlan:
    from funkcje import fs_srodki_trwale_tworzenie_planu
    stat=fs_srodki_trwale_tworzenie_planu.StworzPlanSrodkaTrwalego(self.firma_id,SrodekId,self.PolSQL)                                                             
                                                             
#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (1- insert 1 -select, 1 -delete)
#-------------------------------------------------------------------------------

if Funkcja in [1,5] and stat=='OK':
    # pobranie danych 
    sql="SELECT COALESCE(data_od::TEXT,''), COALESCE(data_do::TEXT,'')"
    sql+=" FROM rs_srodki_trwale_zawieszenia_amortyzacji "  
    sql+="WHERE firma_id='"+self.firma_id+"' AND srodek_id = '"+str(SrodekId)+"' "  
    sql+="ORDER BY data_od;"
    stat,dane,wyn1,wyn2=self.PolSQL.Execute(sql,3)
    if stat<>'OK':
        stat=u"Bd przy pobieraniu danych: "+stat   
        dane.append(stat)        