# -*- coding: iso8859_2 -*-
#-----------------------------------------------------------------------------
# Name:        fs_srodki_trwale_zmiany_stawki.py
# Purpose:     wyswietla, dodaje,usuwa, edytuje zmiany stawki operujc na tabeli rs_srodki_trwale_zmiany_stawki
# Author:      Dariusz Boduch, Micha Raburski
# Created:     2010/10/20
# RCS-ID:      $Id: fs_srodki_trwale_zmiany_stawki.py$
# Copyright:   (c) 2010 Record System
# Licence:     GNU GPL
#-----------------------------------------------------------------------------

stat='OK'

if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=='OK':
    Funkcja = klucze['Funkcja']

    SlPar={'SrodekId':[5,6],'Data':[5,6]}
    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Funkcja,klucze)
    if Lista<>'':
        stat='Uwaga : wywoanie funkcji fs_kontrahenci_kuke z numerem '+str(Funkcja)+' bez parametrw: '+Lista

if stat=='OK':
    if Funkcja in [5,6]:
        SrodekId = klucze['SrodekId']
        Data = klucze['Data']

dane = []
wyn1 = []
wyn2 = []

UprDodawanie=(((self.oddzial_id,'174133') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID))
UprEdycja=(((self.oddzial_id,'174132') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)) or UprDodawanie
UprUsuwanie=(((self.oddzial_id,'174134') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID))


#-------------------------------------------------------------------------------
#------- DELETE (6)
#-------------------------------------------------------------------------------

if Funkcja == 6 and stat=="OK":
    if not UprUsuwanie:
        stat='UPR DEL'
        dane.append(stat)    

    if stat=='OK':
        #blokada usuwania wczeniejszych zmian  
        SQL="SELECT data FROM rs_srodki_trwale_zmiany_stawki WHERE firma_id='"+self.firma_id+"' "
        SQL+=" AND srodek_id='"+SrodekId+"' AND data > '"+Data+"' ;"
        stat,dt,dump,dump=self.PolSQL.Execute(SQL,3)
        if stat<>'OK':
            stat='Bd sprawdzania DELETE: '+stat
            dane.append(stat)
        elif len(dt)>0:
            stat='DATA POZN'
            dane.append(stat)
            
    #sprawdzam czy w srodek nie jest umorzony
    if stat=='OK':
        ROK=Data[:4]
        MC=Data[5:7]
        SQL="SELECT rok,miesiac FROM rs_srodki_trwale_plan WHERE firma_id='"+self.firma_id+"' AND srodek_id='"+SrodekId+"' "
        SQL+="AND rok>='"+ROK+"' AND miesiac>='"+MC+"' AND umorzone ORDER BY rok DESC, miesiac DESC ;"
        stat,umoz,dump,dump=self.PolSQL.Execute(SQL,3)
        if stat<>'OK':
            stat='Bd sprawdzania umorze: '+stat
            dane.append(stat)
        elif len(umoz)>0:
            stat='SR UMOZ'
            dane.append(stat)
    
    if stat=='OK':
        # pobieramy stare stawki i wpisujemy je do rodka.
        SQL="UPDATE rs_srodki_trwale SET stawka_procent=stzs.poprzednia_stawka,stawka_procent_p=stzs.poprzednia_stawka_p"
        SQL+=" FROM rs_srodki_trwale_zmiany_stawki stzs"
        SQL+=" WHERE rs_srodki_trwale.firma_id='"+self.firma_id+"' AND rs_srodki_trwale.srodek_id='"+str(SrodekId)+"'"
        SQL+=" AND stzs.data='"+Data+"' AND stzs.firma_id=rs_srodki_trwale.firma_id AND stzs.srodek_id=rs_srodki_trwale.srodek_id;"
        stat,dump,dump,dump=self.PolSQL.Execute(SQL,1)
            
    if stat=='OK':
        # usuwamy zmian stawki
        DELETE="DELETE FROM rs_srodki_trwale_zmiany_stawki "
        DELETE+="WHERE firma_id='"+self.firma_id+"' AND srodek_id='"+str(SrodekId)+"' AND data='"+Data+"' ;"
        stat,dump,dump,dump=self.PolSQL.Execute(rsglobal.Dekoduj(DELETE),1)
        if stat<>'OK':
            stat=u"Bd przy usuwaniu danych: "+stat   
            dane.append(stat)

    if stat=='OK':
        # przeliczamy warto stawki rodka
        from funkcje import fs_global_srodki_trwale
        stat=fs_global_srodki_trwale.PrzeliczWartoscSrodka(self,self.firma_id,SrodekId)            
        
    if stat=='OK':
        # Przeliczamy plan 
        from funkcje import fs_srodki_trwale_tworzenie_planu
        stat=fs_srodki_trwale_tworzenie_planu.StworzPlanSrodkaTrwalego(self.firma_id,SrodekId,self.PolSQL)                                                             
           
                                                             
#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (1- insert 1 -select, 1 -delete)
#-------------------------------------------------------------------------------

if (Funkcja in [5,6]) and (stat=='OK') :
    # pobranie danych 
    sql="SELECT data, poprzednia_stawka, nowa_stawka,  poprzednia_stawka_p, nowa_stawka_p"
    sql+=" FROM rs_srodki_trwale_zmiany_stawki "  
    sql+="WHERE firma_id='"+self.firma_id+"' AND srodek_id = '"+str(SrodekId)+"' "  
    sql+="ORDER BY data;"
    stat,dane,wyn1,wyn2=self.PolSQL.Execute(sql,3)
    if stat<>'OK':
        stat=u"Bd przy pobieraniu danych: "+stat   
        dane.append(stat)        