# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_typy_dokumentow_magazynowych.py  
# Author:      Pawel Wojcikowski
# Created:     2009/11/12
# RCS-ID:      $Id: fs_typy_dokumentow_magazynowych.py$
# Copyright:   (c) 2009 Record System
# Licence:     GNU GPL  
#-------------------------------------------------------------------------------
# 2017-07-19 Piotr Witkowski  Refaktoryzacja (10648)

stat='OK'
if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=='OK':
    Funkcja = klucze['Funkcja']
    SlPar={'Dokument':[1,6,],'DokumentN':[1,],'Typ':[1,5,6],}

    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Funkcja,klucze)
    if Lista<>'':
        stat='Uwaga : wywoanie funkcji fs_typy_dokumentow_magazynowych z numerem ' +str(Funkcja)+' bez parametrw: '+Lista

if stat=='OK':
    if Funkcja in [1,6]:
        Dokument = klucze['Dokument']
    if Funkcja in [1,]:
        DokumentN = klucze['DokumentN']
    if Funkcja in [1,5,6]:
        Typ = klucze['Typ']

if stat == 'OK':
    dane = []
    wyn1 = []
    wyn2 = []
    UprUsuwanie=(((self.oddzial_id,'014024') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID))
    UprZmianaKlucza=(((self.oddzial_id,'014025') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID))


#-------------------------------------------------------------------------------
#---- UPDATE DANYCH ---(1)
#-------------------------------------------------------------------------------

if stat=='OK' and Funkcja == 1:
    if not UprZmianaKlucza:
        stat = 'Brak uprawnie do zmiany klucza.'
        dane.append(stat)
     
    if stat=='OK':
        UPD="UPDATE rs_typy_dokumentow_m SET dokument_id='"+str(DokumentN)+"' WHERE firma_id='"+self.firma_id+"' AND dokument_id='"+str(Dokument)+"';" 
        stat,dump,dump,dump = self.PolSQL.Execute(UPD,1)
        if stat<>'OK':
            stat = 'Bdy przy zmianie klucza :'+stat
            dane.append(stat)    
                            
                    
#-------------------------------------------------------------------------------
#---   DELETE DANYCH (6)
#-------------------------------------------------------------------------------

if stat=='OK' and Funkcja == 6:
    if not UprUsuwanie:
        stat = 'Brak uprawnie do usuwania danych.'
        dane.append(stat)          
    if stat=='OK':
        Sel="SELECT * FROM rs_dokumenty_magazynowe WHERE firma_id='"+self.firma_id+"' AND dokument_id='"+str(Dokument)+"';"
        stat,DM,dump,dump = self.PolSQL.Execute(Sel,3)
        if stat<>'OK':
            stat = 'Bdy przy sprawdzaniu danych :'+stat
            dane.append(stat)
        else:
            if len(DM)<>0:
                stat = 'Usuwany typ jest wykorzystywany w dokumentach magazynowych.'
                dane.append(stat)     
    if stat=='OK':
        SQL="DELETE FROM rs_typy_dokumentow_m WHERE firma_id = '"+self.firma_id+"' AND dokument_id='"+str(Dokument)+"';"
        stat,dump,dump,dump = self.PolSQL.Execute(SQL,1)
        if stat<>'OK':
            stat = 'Bdy usuwania danych :'+stat
            dane.append(stat)     

 
#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (1- insert 5 -select, 6 -delete)
#-------------------------------------------------------------------------------

if stat=='OK' and Funkcja in [1,5,6]:
    Sel="SELECT dokument_id,typ_dokumentu,nazwa_dokumentu,czy_kontrahent,czy_zlecenie,"
    Sel+="czy_konto_kosztow,czy_faktura,czy_poddokumenty,czy_miejsce,czy_wartosci, "
    Sel+="czy_projekt FROM rs_typy_dokumentow_m WHERE firma_id='"+self.firma_id+"' "
    if Typ<>'':
        Sel+="AND typ_dokumentu='"+Typ+"' "
    Sel+="ORDER BY dokument_id;"
    stat,dane,wyn1,tr = self.PolSQL.Execute(Sel,3)
    if stat<>'OK':
        stat = 'Bdy pobierania danych :'+stat
        dane.append(stat)