# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_uboje_zywce.py
# Purpose:     grid zywcow dla uboju
# Author:      Mariusz Rajfura
# Created:     2013/09/09
# RCS-ID:      $Id: fs_uboje_zywce.py
# Copyright:   (c) 2013 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

stat = 'OK'
dane = []
wyn1 = []
wyn2 = {}

if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=='OK':
    Funkcja = klucze['Funkcja']
    
    SlPar={'Data':(5,6), 'NumerUboju':(5,6), 'NrPoz':(6,)}
           
    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Funkcja,klucze)
    if Lista<>'':
        stat='Uwaga : wywoanie funkcji fs_uboje_zywce z numerem '+str(Funkcja)+' bez parametrw: '+Lista
        
    if Funkcja in (5,6): 
        Data = rsglobal.Dekoduj(klucze['Data'])
        NumerUboju = rsglobal.Dekoduj(klucze['NumerUboju'])

    if Funkcja in (6,): 
        NrPoz = rsglobal.Dekoduj(klucze['NrPoz'])

UprUsuwanie = (((self.oddzial_id,'602004') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID))

#-------------------------------------------------------------------------------
#---   USUWANIE ZYWCA (6)
#-------------------------------------------------------------------------------

if Funkcja == 6 and stat == 'OK':
    if not UprUsuwanie:
        stat = 'Brak uprawnie do usuwania ywcw'

    if stat == 'OK':
        sql = "SELECT stan FROM rs_uboje"
        sql+=" WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+self.oddzial_id+"'"
        sql+=" AND data='"+Data+"' AND numer_uboju="+str(NumerUboju)+";"
    
        stat,d,dump,dump = self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Bd sprawdzenia stanu uboju: '+stat
        elif len(d) == 0:
            stat = 'Brak uboju o podanym kluczu'
        elif not d[0][0] in ('W','G'):
            stat = 'Ubj w stanie '+d[0][0]+'. Usunicie niemoliwe.'

    if stat == 'OK':
        # zablokowanie pozycji
        sql = "SELECT artykul_id FROM rs_uboje_zywce"
        sql+=" WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+self.oddzial_id+"'"
        sql+=" AND data='"+Data+"' AND numer_uboju="+str(NumerUboju)+" AND nr_poz="+str(NrPoz)
        sql+=" FOR UPDATE;"
        
        stat,d,dump,dump = self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Bd sprawdzenia ywca: '+stat
        elif len(d) == 0:
            stat = 'Brak ywca podanym kluczu'

    if stat == 'OK':
        DELETE ="DELETE FROM rs_uboje_zywce"
        DELETE+=" WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+self.oddzial_id+"'"
        DELETE+=" AND data='"+Data+"' AND numer_uboju="+str(NumerUboju)
        DELETE+=" AND nr_poz="+str(NrPoz)+"; "
        
        # przenumerowanie pozycji 
        DELETE+="UPDATE rs_uboje_zywce SET nr_poz=nr_poz+1000"
        DELETE+=" WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+self.oddzial_id+"'"
        DELETE+=" AND data='"+Data+"' AND numer_uboju="+str(NumerUboju)
        DELETE+=" AND nr_poz>"+str(NrPoz)+"; "

        DELETE+="UPDATE rs_uboje_zywce SET nr_poz=nr_poz-1001"
        DELETE+=" WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+self.oddzial_id+"'"
        DELETE+=" AND data='"+Data+"' AND numer_uboju="+str(NumerUboju)
        DELETE+=" AND nr_poz>"+str(1000+NrPoz)+"; "
        
        stat,dump,dump,dump = self.PolSQL.Execute(DELETE,1)
        if stat <> 'OK':
            stat = 'Bd usuwania ywca: '+stat


#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (5,6)
#-------------------------------------------------------------------------------

if Funkcja in (5,6) and stat=='OK':
    SQL ="SELECT z.nr_poz,z.artykul_id,a.nazwa,z.ilosc2,z.ilosc1"
    SQL+=" FROM rs_uboje_zywce z"
    SQL+=" INNER JOIN rs_artykuly a USING(firma_id,artykul_id)"
    SQL+=" WHERE z.firma_id='"+self.firma_id+"' AND z.oddzial_id='"+self.oddzial_id+"'"
    SQL+=" AND z.data='"+Data+"' AND z.numer_uboju="+str(NumerUboju)
    SQL+=" ORDER BY z.nr_poz;"
    
    stat,dane,wyn1,dump = self.PolSQL.Execute(SQL,3)
    if stat <> 'OK':
        stat = "Bd przy pobieraniu danych: "+stat
        dane.append(stat)

    # pobranie dodatkowych informacji
    if stat == 'OK':
        # pobranie biezacego stanu
        sql = "SELECT stan FROM rs_uboje"
        sql+=" WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+self.oddzial_id+"'"
        sql+=" AND data='"+Data+"' AND numer_uboju="+str(NumerUboju)+";"

        stat,d,dump,dump = self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Bd sprawdzenia stanu uboju: '+stat
        elif len(d) == 0:
            stat = 'Brak uboju o podanym kluczu'
        else:
            wyn2['Stan'] = d[0][0]
        
