# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_wczytaj_teskt.py
# Author:      Pawe Wjcikowski
# Created:     2009/09/03
# RCS-ID:      $Id: fs_wczytaj_teskt.py $
# Copyright:   (c) 2009 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------
# sprawdzenie upr do tabeli  2009/10/07  mariusz rajfura  mantis : 2465

# 2021-11-22 Wojciech Skowron (12711) Kopiowanie skadnikw pacowych

Pole = rsglobal.Dekoduj(klucze[0])
Tabela = rsglobal.Dekoduj(klucze[1])
NowySymbol = rsglobal.Dekoduj(klucze[2])
CzyFirma = klucze[3]
CzyOddzial = klucze[4]

Fun = klucze[-1]
dane = []
wyn1 = []
stat = 'OK'
Upr = False
Okres = False

if Tabela == 'rs_konta_bankowe':
    if Pole == 'konto_id':
        #dodawanie
        Upr = ((self.oddzial_id,'014053') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)
    
elif Tabela == 'rs_definicje_bankow_w_kursach_walut':
    #tak samo jak waluty
    if Pole == 'bank_id':
        #dodawanie
        Upr = ((self.oddzial_id,'011133') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)
    
elif Tabela == 'rs_artykuly':
    if Pole == 'artykul_id':
        #dodawanie-wstaw zamiennik, zmiana klucza
        Upr = ((self.oddzial_id,'013013') in self.uprawnienia) or ((self.oddzial_id,'013015') in self.uprawnienia) or \
                (self.operator_id == STANDARD_OPERATOR_ID)

elif Tabela == 'rs_kontrahenci':
    if Pole == 'kontrahent_id':
        #zmiana klucza
        Upr = ((self.oddzial_id,'012015') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)

elif Tabela == 'rs_srodki_trwale':
    if Pole == 'srodek_id':
        #zmiana klucza
        Upr = ((self.oddzial_id,'174105') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)

elif Tabela == 'rs_kasy_banki':
    if Pole == 'kasa_bank_id':
        Okres = True
        #dodawanie
        Upr = ((self.oddzial_id,'171013') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)

elif Tabela == 'rs_wiadomosci_foldery':
    if Pole == 'nazwa':
        #dodawanie
        Upr = ((self.oddzial_id,'000000') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)

elif Tabela == 'rs_wyznaczniki':
    if Pole == 'wyznacznik_id':
        #dodawanie, zmiana klucza
        Upr = ((self.oddzial_id,'021013') in self.uprawnienia) or ((self.oddzial_id,'021015') in self.uprawnienia) or \
            (self.operator_id == STANDARD_OPERATOR_ID)

elif Tabela == 'rs_projekty':
    if Pole == 'projekt_id':
        #dodawanie
        Upr = ((self.oddzial_id,'027013') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)

elif Tabela == 'rs_typy_dokumentow_m':
    if Pole == 'dokument_id':
        #zmiana klucza
        Upr = ((self.oddzial_id,'014025') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)

elif Tabela == 'rs_magazyny':
    if Pole == 'magazyn_id':
        #zmiana klucza
        Upr = ((self.oddzial_id,'031015') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)

elif Tabela == 'rs_oddzialy':
    if Pole == 'oddzial_id':
        #zmiana klucza
        Upr = ((self.oddzial_id,'001150') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)

elif Tabela == 'rs_grupy':
    if Pole == 'grupa_id':
        #dodawanie
        Upr = ((self.oddzial_id,'001250') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)
    elif Pole == 'opis':
        #edycja
        Upr = ((self.oddzial_id,'001210') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)

elif Tabela == 'rs_urzadzenia':
    if Pole == 'urzadzenie_id':
        #dodawanie,zmiana klucza
        Upr = ((self.oddzial_id,'046003') in self.uprawnienia) or ((self.oddzial_id,'046005') in self.uprawnienia) or\
              (self.operator_id == STANDARD_OPERATOR_ID)

elif Tabela == 'rs_procesy':
    if Pole == 'proces_id':
        #dodawanie,zmiana klucza
        Upr = ((self.oddzial_id,'047003') in self.uprawnienia) or ((self.oddzial_id,'047005') in self.uprawnienia) or\
              (self.operator_id == STANDARD_OPERATOR_ID)

elif Tabela == 'rs_kp_kalendarze':
    if Pole == 'kalendarz_id':
        #dodawanie
        Upr = ((self.oddzial_id,'051033') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)
        
elif Tabela == 'rs_kp_szablony_list_plac':
    if Pole == 'lista_id':
        #dodawanie
        Upr = ((self.oddzial_id,'061023') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)

elif Tabela == 'rs_raporty':
    if Pole == 'raport_id':
        #dodawanie
        Upr = self.operator_id == STANDARD_OPERATOR_ID

#WS 2021-11-22
elif Tabela == 'rs_kp_skladniki_placowe':
    if Pole == 'skladnik_id':
        #dodawanie
        Upr = ((self.oddzial_id,'061013') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)

else:
    #czy to tabela slownikowa
    stat,d,dump,dump = self.PolSQL.Execute("SELECT slownik_id FROM rs_slowniki WHERE tabela = '"+Tabela+"';", 2)
    if stat <> 'OK':
        stat = 'Bd wczytania listy sownikw : '+stat
        dane.append(stat)
    elif len(d) == 1:
        #zmiana klucza w tabeli slownikowej - ostatnia cyfra uprawnienia to '5'
        UprZmKlucza = str(d[0][0])[:5]+'5'
        Upr = ((self.oddzial_id,UprZmKlucza) in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)

if not Upr:
    stat = 'Brak uprawnien do zmiany danych w tabeli : '+Tabela
    dane.append(stat)

#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (5 -select)
#-------------------------------------------------------------------------------
if Fun == 5 and stat == 'OK':
    SELECT = "SELECT "+str(Pole)+" FROM "+str(Tabela)+" WHERE "+str(Pole)+" = '"+str(NowySymbol)+"'"
    if CzyFirma:
        SELECT+=" AND firma_id = '"+self.firma_id+"'"
    if CzyOddzial:
        SELECT+=" AND oddzial_id = '"+self.oddzial_id+"'"
    if Okres:
        SELECT+=" AND okres_id = '"+self.okres_id+"'"
        
    SELECT += ";"
    stat,dane,wyn1,tr = self.PolSQL.Execute(SELECT,3)
    if stat <> 'OK':
        stat = 'Bd przy pobieraniu danych : '+stat   
        dane.append(stat)
