# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_wiadomosci.py
# Author:      Pawel Wojcikowski
# Created:     2009/07/02
# RCS-ID:      $Id: fs_wiadomosci.py$
# Copyright:   (c) 2009 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

Folder=klucze[0]
FolderN=klucze[1]
Numer=klucze[2]
WiadomoscN=klucze[3]
Nazwa=klucze[4]
Klucze_id=klucze[5]
Fun = klucze[-1]
stat = "OK"
dane = []
wyn1=[]


#-------------------------------------------------------------------------------
#---- OKIENKO DODAWANIA ---(1)
#-------------------------------------------------------------------------------

if Fun == 1 and stat == "OK": 
        Warunek = "operator_id='"+str(self.operator_id)+"' AND folder_id < 9999"        
        SQL1="SELECT folder_id FROM rs_wiadomosci_foldery WHERE "+Warunek+" ORDER BY folder_id DESC LIMIT 1;"
        stat,NumerN,dan1,dan2 = self.PolSQL.Execute(SQL1,3)      
        if stat<>'OK':
            stat = 'Bdy przy pobieraniu numeru:'+stat
            dane.append(stat)               
        else:
            if len(NumerN)==0:
                NumerN = 1
            else:
                NumerN=NumerN[0][0]+1              
            SQL="INSERT INTO rs_wiadomosci_foldery (operator_id,folder_id,nazwa) VALUES "
            SQL+="('"+str(self.operator_id)+"',"+str(NumerN)+",'"+str(Nazwa)+"');"
            stat,dump,dump,dump = self.PolSQL.Execute(SQL,1)
            if stat<>'OK':
                stat = 'Bdy przy dodawaniu danych :'+stat
                dane.append(stat)


#-------------------------------------------------------------------------------
#---   DELETE DANYCH (2)
#-------------------------------------------------------------------------------

if Fun in [2] and stat=='OK':  
    Update="UPDATE rs_wiadomosci_operatorzy SET folder_id=0 WHERE operator_id="+str(self.operator_id)+" AND folder_id="+str(Numer)+";"
    stat,dump,dump,dump = self.PolSQL.Execute(Update ,1)                
    if stat<>'OK':
        stat = 'Bdy przy modyfikacji danych :'+stat
        dane.append(stat)
    else:
        SQL="DELETE FROM rs_wiadomosci_foldery WHERE operator_id='"+str(self.operator_id)+"' AND folder_id="+str(Numer)+";"
        stat,dump,dump,dump = self.PolSQL.Execute(SQL,1)
        if stat<>'OK':
            stat = 'Bdy usuwania danych :'+stat
            dane.append(stat)             


#-------------------------------------------------------------------------------
#---   UPDATE DANYCH (4)
#-------------------------------------------------------------------------------

if Fun in [4] and stat=='OK':
    Update="UPDATE rs_wiadomosci_operatorzy SET folder_id="+str(Folder)+" WHERE operator_id= '"+str(self.operator_id)+"' "
    Update+="AND folder_id='"+str(FolderN)+"' AND wiadomosc_id="+str(WiadomoscN)+";"        
    stat,dump,dump,dump = self.PolSQL.Execute(Update ,1)                
    if stat<>'OK':
        stat = 'Bdy modyfikowania danych :'+stat
        dane.append(stat)

           
#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (5,6)
#-------------------------------------------------------------------------------

if (Fun in [5]) and (stat=='OK'):       
    Filtr = "wo.operator_id='"+str(self.operator_id)+"' AND wo.folder_id='"+str(Folder)+"' AND wo.usunieta=FALSE AND w.priorytet IN ('N','W')"
    Select = "SELECT DISTINCT op.imie||' '||op.nazwisko,w.naglowek,w.czas_zapisu,CAST(w.priorytet='W' AS BOOLEAN)"
    Select+=",CAST(NOT (wz.zalacznik_id IS NULL) AS BOOLEAN),CAST((wo.czas_przeczytania IS NULL) AS BOOLEAN)"
    Select+=",w.wiadomosc_id FROM rs_wiadomosci w INNER JOIN rs_operatorzy op ON op.operator_id=w.operator_id "
    Select+="INNER JOIN rs_wiadomosci_operatorzy wo ON w.wiadomosc_id = wo.wiadomosc_id LEFT OUTER JOIN "
    Select+="rs_wiadomosci_zalaczniki wz ON w.wiadomosc_id = wz.wiadomosc_id WHERE "+Filtr+" ORDER "
    Select+="BY w.czas_zapisu DESC;"                     
    stat,dane,wyn1,tr = self.PolSQL.Execute(Select,3)
    if stat<>'OK':
        stat = 'Bdy w pobieraniu wiaomoci:'+stat
        dane.append(stat)
        
if (Fun in [6]) and (stat=='OK'):                  
    Filtr = "w.operator_id='"+str(self.operator_id)+"' AND usunieta = FALSE AND w.priorytet IN ('N','W')"      
    Select="SELECT DISTINCT rsf_poczta_podaj_adresatow(w.wiadomosc_id)"
    Select+=",w.naglowek,w.czas_zapisu,CAST(w.priorytet='W' "
    Select+="AS BOOLEAN),CAST(NOT (wz.zalacznik_id IS NULL) AS BOOLEAN),FALSE,w.wiadomosc_id FROM rs_wiadomosci w "
    Select+="INNER JOIN rs_operatorzy op ON op.operator_id=w.operator_id LEFT OUTER JOIN rs_wiadomosci_zalaczniki "
    Select+="wz ON w.wiadomosc_id = wz.wiadomosc_id WHERE "+Filtr+" ORDER BY w.czas_zapisu DESC;"            
    stat,dane,wyn1,tr = self.PolSQL.Execute(Select,3)
    if stat<>'OK':
        stat = 'Bdy pobierania danych :'+stat
        dane.append(stat)        
        
#-------------------------------------------------------------------------------
#---- DELETE FOLDEROW I WIADOMOSCI - z rsf -  --- (7)
#-------------------------------------------------------------------------------

if Fun == 7 and stat == "OK":
    Wiadom = Klucze_id[0]
    Folder = Klucze_id[1]
    DZIALKA = 512
    Dane = []
    # pobieranie danych kawalkami eby unikn 'stack depth limit exceeded'
    for i in range((len(Wiadom) - 1) / DZIALKA + 1):
        WiadomDzialka = Wiadom[i * DZIALKA : (i + 1) * DZIALKA]
        WiadomDzialka = str(tuple(WiadomDzialka)).replace(",)", ")")   
        Select="SELECT W.wiadomosc_id, W.usunieta, COALESCE(SUM(CASE WHEN WO.usunieta THEN 0 ELSE 1 END), 0) AS uzywana,"            
        Select+="   MIN(WO.operator_id) AS min_operator_id"
        Select+=" FROM rs_wiadomosci W LEFT JOIN rs_wiadomosci_operatorzy WO USING(wiadomosc_id) "
        Select+=" WHERE wiadomosc_id IN "+str(WiadomDzialka)+" GROUP BY W.wiadomosc_id, W.usunieta"
        stat,DaneDzialka,wyn1,tr = self.PolSQL.Execute(Select,3)
        if stat<>'OK':
            stat = 'Bdy pobrania danych wiadomoci :'+stat
            dane.append(stat)            
            break
        Dane += DaneDzialka
    if Folder == 9999:        
        for pozycja in Dane:
            wiad = pozycja[0] # przelatuje po wiadomosciach
            if not pozycja[2]: # jesli nie jest uzywana 
                # wszyscy adresaci juz usuneli wiadomosc, mozna sprzatac
                SQL="DELETE FROM rs_zalaczniki WHERE zalacznik_id IN ("
                SQL+="SELECT zalacznik_id FROM rs_wiadomosci_zalaczniki WHERE wiadomosc_id="+str(wiad)+"); "
                SQL+="DELETE FROM rs_wiadomosci_zalaczniki WHERE wiadomosc_id="+str(wiad)+"; "
                SQL+="DELETE FROM rs_wiadomosci_operatorzy WHERE wiadomosc_id="+str(wiad)+"; "
                SQL+="DELETE FROM rs_wiadomosci WHERE wiadomosc_id="+str(wiad)+";"
                stat,dump,dump,dump = self.PolSQL.Execute(SQL,1)
                if stat<>'OK':
                    stat = 'Bdy usuwania wiadomoci wysanych :'+stat
                    dane.append(stat)
            else:
                # ktos jeszcze ma ta wiadomosc, nie usuwaj jej z bazy tylko oznacz jako usunieta                
                SQL="UPDATE rs_wiadomosci SET usunieta = TRUE WHERE wiadomosc_id="+str(wiad)+";"
                stat,dump,dump,dump = self.PolSQL.Execute(SQL,1)
                if stat<>'OK':
                    stat = 'Bdy odzanaczania wiadomoci :'+stat
                    dane.append(stat)
    else:
        for pozycja in Dane:
            wiad = pozycja[0] # przelatuje po wiadomosciach
            if not pozycja[2] and (not pozycja[2] or pozycja[2] == 1 and pozycja[3] == int(self.operator_id)): # jesli nie jest uzywana 
                # nadawca i wszyscy odbiorcy (lub chociaz wszyscy pozostali odb) tez juz ja usuneli, mozna sprzatac               
                SQL="DELETE FROM rs_zalaczniki WHERE zalacznik_id IN ("
                SQL+="SELECT zalacznik_id FROM rs_wiadomosci_zalaczniki WHERE wiadomosc_id="+str(wiad)+"); "
                SQL+="DELETE FROM rs_wiadomosci_zalaczniki WHERE wiadomosc_id="+str(wiad)+"; "
                SQL+="DELETE FROM rs_wiadomosci_operatorzy WHERE wiadomosc_id="+str(wiad)+"; "
                SQL+="DELETE FROM rs_wiadomosci WHERE wiadomosc_id="+str(wiad)+";"               
                stat,dump,dump,dump = self.PolSQL.Execute(SQL,1)
                if stat<>'OK':
                    stat = 'Bdy usuwania wiadomoci odebranych :'+stat
                    dane.append(stat)
            elif pozycja[1]:
                # nadawca juz usunal ta wiadomosc ze swojej skrzynki
                SQL="DELETE FROM rs_wiadomosci_operatorzy WHERE wiadomosc_id="+str(wiad)+" AND operator_id='"+str(self.operator_id)+"'"
                stat,dump,dump,dump = self.PolSQL.Execute(SQL,1)
                if stat<>'OK':
                    stat = 'Bdy usuwania wiadomoci :'+stat
                    dane.append(stat)
            else:
                SQL="UPDATE rs_wiadomosci_operatorzy SET usunieta=TRUE WHERE wiadomosc_id="+str(wiad)+" "
                SQL+="AND operator_id='"+str(self.operator_id)+"'"
                stat,dump,dump,dump = self.PolSQL.Execute(SQL,1)
                if stat<>'OK':
                    stat = 'Bdy odznaczania usunicia wiadomoci  :'+stat
                    dane.append(stat)       
             
                    
#-------------------------------------------------------------------------------
#---- SELECT FOLDEROW - z rsf -  --- (8)
#-------------------------------------------------------------------------------

if Fun == 8 and stat == "OK":
    SQL1="SELECT folder_id,nazwa FROM rs_wiadomosci_foldery WHERE operator_id='"+str(self.operator_id)+"' ORDER BY folder_id;"
    stat,dane,dan1,dan2 = self.PolSQL.Execute(SQL1,3)
    if stat<>'OK':
        stat = 'Bdy przy pobieraniu numeru:'+stat
        dane.append(stat)                                      
