# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_wiadomosci_dane.py
# Author:      Pawel Wojcikowski
# Created:     2009/07/02
# RCS-ID:      $Id: fs_wiadomosci_dane.py$
# Copyright:   (c) 2009 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

# 2011-04-03 Mariusz Rajfura    - rozglaszanie ksieg.dow.ksieg.harm - lista zalogowanych (4439)
# 2024-01-03 Aleksander Bargie - Poprawa wizualna rozgosze  (13654)
Wiadomosc=rsglobal.Dekoduj(klucze[0])
Adres=rsglobal.Dekoduj(klucze[1])
Temat=rsglobal.Dekoduj(klucze[2])
Tresc=rsglobal.Dekoduj(klucze[3])
Typ=rsglobal.Dekoduj(klucze[4])
Operator=rsglobal.Dekoduj(klucze[5])
Numer=rsglobal.Dekoduj(klucze[6])
Zalacznik=rsglobal.Dekoduj(klucze[7])
Grupa=rsglobal.Dekoduj(klucze[8])
Tabela=rsglobal.Dekoduj(klucze[9])
Fun = klucze[-1]
stat = "OK"
dane = []
wyn1=[]


#-------------------------------------------------------------------------------
#---   SELECT czy_rozgloszenia (1) 
#-------------------------------------------------------------------------------

if (Fun in [1, 3, 11]) and (stat=='OK'):  #AB 2024-01-03
    Select="SELECT czy_rozgloszenie FROM rs_operatorzy WHERE operator_id="+str(self.operator_id)+";"     
    stat,dane,wyn1,tr = self.PolSQL.Execute(Select,3)
    mozna_rozgloszenia = dane[0][0]  #AB 2024-01-03
    if stat<>'OK':
        stat = 'Bdy pobierania rozgloszenia :'+stat
        dane.append(stat)


#-------------------------------------------------------------------------------
#---   SELECT operatora_id (2)
#-------------------------------------------------------------------------------

if (Fun in [2]) and (stat=='OK'): 
    Select="SELECT login FROM rs_operatorzy WHERE login='"+str(Adres)+"';" 
    stat,dane,wyn1,tr = self.PolSQL.Execute(Select,3)
    if str(Adres)=='raporty' or str(Adres)=='harmonogramy':
        stat = 'Bd pobrania listy operatorw: nie mona wysa do operatorw technicznych'
        dane.append(stat)
    if stat=='OK':    
        Select="SELECT operator_id FROM rs_operatorzy WHERE login='"+str(Adres)+"';"     
        stat,dane,wyn1,tr = self.PolSQL.Execute(Select,3)
        if stat<>'OK':
            stat = 'Bdy pobierania id operatora :'+stat
            dane.append(stat)
    

#-------------------------------------------------------------------------------
#---   SELECT nastepnego numerka (3) oraz dodanie pozycji (11)
#-------------------------------------------------------------------------------

if (Fun in [3,11]) and (stat=='OK'):
    if mozna_rozgloszenia:  #AB 2024-01-03
        Select="SELECT nextval('"+Tabela+"');"
        stat,dane,wyn1,tr = self.PolSQL.Execute(Select,3)
        if stat<>'OK':
            stat = 'Bdy pobierania id operatora :'+stat
            dane.append(stat)
        else:
            Numer=dane[0][0]
            if (Fun in [11]) and (stat=='OK'):
                Insert="INSERT INTO rs_wiadomosci (firma_id,wiadomosc_id,operator_id,naglowek,tresc,priorytet,usunieta)"
                Insert+=" VALUES ('"+self.firma_id+"',"+str(Numer)+","+str(self.operator_id)+",'"+str(Temat)+"'"
                Insert+=",'"+str(Tresc)+"','"+str(Typ)+"',FALSE);"
                stat,dump,dump,dump = self.PolSQL.Execute(Insert,1)
                if stat<>'OK':
                    stat = 'Bdy dodawania wiadomoci :'+stat
                    dane.append(stat)
    else:  #AB 2024-01-03
        stat = "Brak uprawnie do wysyania rozgosze"

#-------------------------------------------------------------------------------
#---   SELECT op_id (4)
#-------------------------------------------------------------------------------
            
if (Fun in [4]) and (stat=='OK'):
    Select="SELECT op_id FROM rs_polaczenia WHERE op_id="+str(Operator)+" AND koniec IS NULL;"   
    stat,dane,wyn1,tr = self.PolSQL.Execute(Select,3) # numer jako dane
    if stat<>'OK':
        stat = 'Bdy pobierania operatora :'+stat
        dane.append(stat)


#-------------------------------------------------------------------------------
#---   INSERT wiadomosci (5)
#-------------------------------------------------------------------------------

if (Fun in [5]) and (stat=='OK'):
    Select="INSERT INTO rs_wiadomosci_operatorzy (wiadomosc_id,folder_id,operator_id,usunieta,nowa) "
    Select+="VALUES ("+str(Numer)+",0,"+str(Operator)+",FALSE,TRUE)"   
    stat,dump,wyn1,tr = self.PolSQL.Execute(Select,1)
    if stat<>'OK':
        stat = 'Bd pobrania listy operatorw: nie mona wysa do operatorw technicznych'
         

#-------------------------------------------------------------------------------
#---   INSERT zacznikw wiadomosci (6)
#-------------------------------------------------------------------------------
    
if (Fun in [6]) and (stat=='OK'): 
    Insert="INSERT INTO rs_wiadomosci_zalaczniki (wiadomosc_id,zalacznik_id) VALUES ("+str(Numer)+","+str(Zalacznik)+")" 
    stat,dump,wyn1,tr = self.PolSQL.Execute(Insert,1)
    if stat<>'OK':
        stat = 'Bdy przy dodawaniu zacznikw :'+stat
        dane.append(stat)    


#-------------------------------------------------------------------------------
#---   SELECT loginu (7)
#-------------------------------------------------------------------------------
        
if (Fun in [7]) and (stat=='OK'):
    if Grupa == '**':
        Select="SELECT DISTINCT o.login FROM rs_grupa_operator_oddzial goo INNER JOIN rs_operatorzy"
        Select+=" o ON o.operator_id = goo.operator_id WHERE goo.firma_id = '"+self.firma_id+"'"
        stat,dane,wyn1,tr = self.PolSQL.Execute(Select,3)
        if stat<>'OK':
            stat = 'Bdy w pobieraniu danych :'+stat
            dane.append(stat)
    else:
        Select="SELECT DISTINCT o.login FROM rs_grupa_operator_oddzial goo INNER JOIN rs_operatorzy "
        Select+="o ON o.operator_id = goo.operator_id WHERE goo.firma_id = '"+self.firma_id+"' AND goo.grupa_id = '"+str(Grupa)+"'"
        stat,dane,wyn1,tr = self.PolSQL.Execute(Select,3)
        if stat<>'OK':
            stat = 'Bdy pobierania danych :'+stat
            dane.append(stat)


#-------------------------------------------------------------------------------
#---   SELECT noglowka itp (8)
#-------------------------------------------------------------------------------
            
if (Fun in [8]) and (stat=='OK'): 
    Select ="SELECT w.naglowek,w.tresc,o.login,"
    Select+=" rsf_poczta_podaj_adresatow("+str(Wiadomosc)+")"
    Select+=" FROM rs_wiadomosci w"
    Select+=" INNER JOIN rs_operatorzy o ON (w.operator_id = o.operator_id)"
    Select+=" WHERE wiadomosc_id="+str(Wiadomosc)+";"
    stat,dane,wyn1,tr = self.PolSQL.Execute(Select,3)
    if stat<>'OK':
        stat = 'Bdy pobierania operatora :'+stat
        dane.append(stat)         


#-------------------------------------------------------------------------------
#---   UPDATE wiadomosci po przeczytaniu (9)
#-------------------------------------------------------------------------------
            
if (Fun in [9]) and (stat=='OK'):
    Update ="UPDATE rs_wiadomosci_operatorzy SET czas_przeczytania=now()"
    Update+=" WHERE wiadomosc_id="+str(Wiadomosc)+" AND operator_id="+str(self.operator_id)+";"
    stat,dane,wyn1,tr = self.PolSQL.Execute(Update,1)
    if stat<>'OK':
        stat = 'Bdy pobierania operatora :'+stat
        dane.append(stat)           


#-------------------------------------------------------------------------------
#---   SELECT zalcznikw (10)
#-------------------------------------------------------------------------------
            
if (Fun in [10]) and (stat=='OK'): 
    Select="SELECT z.zalacznik_id,z.nazwa FROM rs_zalaczniki z INNER JOIN rs_wiadomosci_zalaczniki"
    Select+=" wz ON (z.zalacznik_id = wz.zalacznik_id) WHERE wz.wiadomosc_id = "+str(Wiadomosc)
    stat,dane,wyn1,tr = self.PolSQL.Execute(Select,3)
    if stat<>'OK':
        stat = 'Bdy pobierania operatora :'+stat
        dane.append(stat)
        
#-------------------------------------------------------------------------------
#--- LISTA ZALOGOWANYCH UZYTKOWNIKOW (12)
#-------------------------------------------------------------------------------

if Fun in [12] and stat=='OK':
    # pobranie operatorow posiadajacych jakiekolwiek uprawnienia do biezacej firmy
    sql ="SELECT DISTINCT operator_id FROM rs_grupa_operator_oddzial"
    sql+=" WHERE firma_id='"+self.firma_id+"';"

    stat,dOper,dump,dump = self.PolSQL.Execute(sql,3)
    if stat != 'OK':
        stat = 'Bd pobrania listy operatorw z biecej firmy: '+stat
        dane.append(stat)
    
    if stat == 'OK':
        # dodanie anakondy
        dOper.append([0])
        
        Operatorzy = ''
        for i in xrange(len(dOper)):
            if i > 0:
                Operatorzy += ","
            Operatorzy += "'"+str(dOper[i][0])+"'"
            
        sql ="SELECT DISTINCT p.op_id,o.login"
        sql+=" FROM rs_polaczenia p"
        sql+=" INNER JOIN rs_operatorzy o ON (o.operator_id=p.op_id)"
        sql+=" WHERE p.poczatek>NOW()-INTERVAL '24 HOURS' "
        sql+=" AND p.op_id IN ("+Operatorzy+")"
        if str(Operator) == '-1':
            # ominiecie siebie samego (przydatne przy rozgloszeniu)
            sql+=" AND p.op_id<>"+str(self.operator_id)
        sql+=" AND p.koniec IS NULL;"   
    
        stat,dane,wyn1,tr = self.PolSQL.Execute(sql,3)
        if stat<>'OK':
            stat = 'Bdy pobierania zalogowanych operatorw :'+stat
            dane.append(stat)