# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_artykuly_cechy_wartosci.py
# Purpose:     obsluga grida edytowalnego wartosci dla cechy artykulu
# Author:      Mariusz Rajfura, Micha Raburski
# Created:     2013/05/31
# RCS-ID:      $Id: fs_artykuly_cechy_wartosci $
# Copyright:   (c) 2013 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------


stat='OK'

if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=='OK':
    Funkcja = klucze['Funkcja']

dane = []
wyn1 = []
wyn2 = []

# maksymalne dlugosci pol opisowych
dlugosci = {'paleta_id':3,'opis':50}

UprIns=((self.oddzial_id,'014113') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID
UprUpd=((self.oddzial_id,'014112') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID or UprIns
UprDel=((self.oddzial_id,'014114') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID

#-------------------------------------------------------------------------------
#-------- POBRANIE OPISU (9)
#-------------------------------------------------------------------------------

if stat=='OK' and Funkcja == 9:
    SQL = "SELECT opis FROM rs_palety WHERE firma_id='"+self.firma_id+"' AND paleta_id='"+klucze["Paleta"]+"'"
    stat,dane,dump,dump = self.PolSQL.Execute(SQL,3)
    if stat <> 'OK':
        stat = "Bd przy pobieraniu opisu palety: "+stat

#-------------------------------------------------------------------------------
#-------- EDYCJA GRIDA EDYTOWALNEGO (1)
#-------------------------------------------------------------------------------

Insert = []
Update = []
Delete = []
if stat=='OK' and Funkcja == 1:
    Update=klucze['Update']
    Insert=klucze['Insert']
    Delete=klucze['Delete']


#-------------------------------------------------------------------------------
#-------  SPRAWDZANIE DELETE  --------------------------------------------------
#-------------------------------------------------------------------------------

if Funkcja == 1 and stat=="OK":
    if len(Delete[0])>0:
        if not UprDel:
            stat='BR UPR DEL'
            dane.append(stat)
                
        # wykonanie DELETE 
        if stat == 'OK':
            SQLDEL = ''
            SQLFU = ''
            for i in xrange(len(Delete[0])):
                SQLFU ="SELECT paleta_id FROM rs_palety"
                SQLFU+=" WHERE firma_id='"+self.firma_id+"'"
                DELETE = "DELETE FROM rs_palety "
                WHERE = "WHERE firma_id='"+self.firma_id+"'"
                for j in xrange(len(Delete[0][i])):
                    pole = Delete[1][j]
                    wart = Delete[0][i][j]
                       
                    WHERE += " AND "+pole+"='"+wart+"'"
                    SQLFU += " AND "+pole+"='"+wart+"'"
                
                SQLDEL += DELETE+WHERE+"; "
                SQLFU += " FOR UPDATE NOWAIT; "
                
            if stat == "OK" and SQLFU <> '':
                SQLSPR = "SELECT 1 FROM rs_artykuly_opakowania_zbiorcze "+WHERE
                stat,d,dump,dump = self.PolSQL.Execute(rsglobal.Dekoduj(SQLSPR),3)
                if stat <> 'OK':
                    stat = u'Bd sprawdzenia w opakowaniach zbiorczych artykuu, przed usuniciem danych: '+stat
                    dane.append(stat)
                elif len(d)>0:
                    stat = u'Nie mona usun danych, istniej odwoania w opakowaniach zbiorczych artykuu'

            if stat == "OK" and SQLFU <> '':
                stat,d,dump,dump = self.PolSQL.Execute(rsglobal.Dekoduj(SQLFU),3)
                if stat <> 'OK':
                    stat = 'Bd sprawdzenia danych do usunicia: '+stat
                    dane.append(stat)

            if stat == "OK" and SQLDEL <> '':
                stat,dump,dump,dump = self.PolSQL.Execute(rsglobal.Dekoduj(SQLDEL),1)
                if stat <> 'OK':
                    stat = "Bd przy usuwaniu danych: "+stat   
                    dane.append(stat)


#-------------------------------------------------------------------------------
#---   UPDATE DANYCH (1)
#-------------------------------------------------------------------------------

if Funkcja == 1 and stat=="OK":
    if len(Update[0])>0:
        if not UprUpd:
            stat='BR UPR UPD'
            dane.append(stat)

        if stat == 'OK':
            SQLFU = ''
            for i in xrange(len(Update[0])):
                SQLFU+="SELECT paleta_id,opis,pojemnosc_lokacyjna FROM rs_palety"
                SQLFU+=" WHERE firma_id='"+self.firma_id+"'"
                for j in xrange(len(Update[2][i])): # petla po kluczu
                    pole = Update[3][j]
                    wart = rsglobal.Dekoduj(Update[2][i][j].strip())
                    nowepole = Update[0][i][j]
                    nowawart = rsglobal.Dekoduj(Update[1][i][j])
                    
                    SQLFU += " AND "+pole+"='"+wart+"'"
                
                SQLFU += " FOR UPDATE NOWAIT; "
            
            if SQLFU <> '' and stat == "OK":
                stat,d,dump,dump = self.PolSQL.Execute(rsglobal.Dekoduj(SQLFU),3)
                if stat <> 'OK':
                    stat = 'Bd sprawdzenia danych do modyfikacji: '+stat
                    dane.append(stat)
            
        if stat == 'OK':
            WierszeNr = Update[-1]

            for i in xrange(len(Update[0])):
                WartoscNowa = None

                for j in xrange(len(Update[0][i])): 
                    pole = Update[0][i][j]
                    wart = Update[1][i][j]

                    if pole == 'paleta_id':
                        WartoscNowa = str(wart)
                        if wart.strip() == '':
                            stat = 'BR WARTOSC'
                            wyn2.append((WierszeNr[i],0))
                            dane.append(stat)
                        elif len(wart.strip()) > dlugosci[pole]:
                            stat = 'BL WARTOSC DLG'
                            wyn2.append((WierszeNr[i],0))
                            dane.append(stat)
                    elif pole == 'opis':
                        if wart.strip() == '':
                            stat = 'BR OPIS'
                            wyn2.append((WierszeNr[i],0))
                            dane.append(stat)
                        elif len(wart.strip()) > dlugosci[pole]:
                            stat = 'BL OPIS DLG'
                            wyn2.append((WierszeNr[i],0))
                            dane.append(stat)
                        
                            
        if stat == 'OK':
            if len(dane) > 0:
                stat = dane[0]
                
        # wykonanie UPDATE
        if stat=='OK':
            sql=''
            for i in xrange(len(Update[0])):
                UPDATE="UPDATE rs_palety "
                SET='SET '
                for j in xrange(len(Update[0][i])): 
                    pole=Update[0][i][j]
                    wart=Update[1][i][j]
                    if pole in ['paleta_id','opis']:
                        SET+=pole+"='"+wart+"',"
                    elif pole in ['domyslna']:
                        SET+=pole+"="+str(wart==1)+","
                    elif pole in ['pojemnosc_lokacyjna']:
                        SET+=pole+"="+str(wart)+","

                SET=SET.strip(",")
                WHERE=" WHERE firma_id='"+self.firma_id+"'"
                for j in xrange(len(Update[2][i])): # petla po kluczu
                    pole=Update[3][j]
                    wart=rsglobal.Dekoduj(Update[2][i][j])
                    if pole in ['paleta_id']:
                        WHERE+= " AND "+pole+"='"+wart+"'"

                WHERE+=";"
                
                sql+=UPDATE+SET+WHERE;
                
            if sql<>'':
                stat,dump,dump,dump=self.PolSQL.Execute(rsglobal.Dekoduj(sql),1)
                if stat<>'OK':
                    stat="Bd przy modyfikowaniu danych: "+stat   
                    dane.append(stat)


#-------------------------------------------------------------------------------
#---------Sprawdzanie danych do Insert------
#-------------------------------------------------------------------------------

if Funkcja == 1 and stat=="OK":
    if len(Insert[0])>0:
        if not UprIns:
            stat='BR UPR INS'
            dane.append(stat)

        if stat == 'OK':
            WierszeNr = Insert[-1]
            for i in xrange(len(Insert[0])):
                WartoscNowa = None
                
                for j in xrange(len(Insert[0][i])): 
                    pole=Insert[1][j]
                    wart=Insert[0][i][j]

                    if pole == 'paleta_id':
                        WartoscNowa = str(wart)
                        if wart.strip() == '':
                            stat = 'BR WARTOSC'
                            wyn2.append((WierszeNr[i],0))
                            dane.append(stat) 
                        elif len(wart.strip()) > dlugosci[pole]:
                            stat = 'BL WARTOSC DLG'
                            wyn2.append((WierszeNr[i],0))
                            dane.append(stat)     
                        else:
                            sql ="SELECT paleta_id FROM rs_palety"
                            sql+=" WHERE firma_id='"+self.firma_id+"' AND paleta_id='"+WartoscNowa+"';"
                            stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                            if stat <> 'OK':
                                stat = 'Bd sprawdzenia nowej wartosci: '+stat
                                wyn2.append((WierszeNr[i],0))
                                dane.append(stat)
                            elif len(d) > 0:
                                stat = 'BL WARTOSC IST'
                                wyn2.append((WierszeNr[i],0))
                                dane.append(stat)

                    elif pole == 'opis':
                        wart = wart.strip()
                        if wart == '':
                            stat = 'BR OPIS'
                            wyn2.append((WierszeNr[i],1))
                            dane.append(stat)
                        elif len(wart.strip()) > dlugosci[pole]:
                            stat = 'BL OPIS DLG'
                            wyn2.append((WierszeNr[i],0))
                            dane.append(stat)
                
        if stat == 'OK':
            if len(dane) > 0:
                stat = dane[0]

        # wykonanie INSERT
        if stat == 'OK':
            sqlIns=''
            for i in xrange(len(Insert[0])):
                INSERT="INSERT INTO rs_palety "
                KOLUMNY="(firma_id"
                VALUES=" VALUES ('"+self.firma_id+"'"
                for j in xrange(len(Insert[0][i])):
                    pole=Insert[1][j]
                    wart=Insert[0][i][j]
                    if pole in ['paleta_id','opis']:
                        KOLUMNY+=","+pole
                        VALUES+=",'"+wart+"'"
                    elif pole in ['pojemnosc_lokacyjna']:
                        KOLUMNY+=","+pole
                        VALUES+=","+str(wart)+""

                KOLUMNY+=")"
                VALUES+=");"
                sqlIns+=INSERT+KOLUMNY+VALUES
            if sqlIns<>'': 
                stat,dump,dump,dump=self.PolSQL.Execute(rsglobal.Dekoduj(sqlIns),1)
                if stat<>'OK':
                    stat="Bd przy dodawaniu danych: "+stat
                    dane.append(stat)


#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (1- insert 1 -select, 1 -delete, 5 -select) 
#-------------------------------------------------------------------------------

if Funkcja in (1,5) and stat=='OK':
    SQL ="SELECT paleta_id,COALESCE(opis,''),pojemnosc_lokacyjna"
    SQL+=" FROM rs_palety"
    SQL+=" WHERE firma_id='"+self.firma_id+"'"
    SQL+=" ORDER BY paleta_id;"
    stat,dane,wyn1,wyn2 = self.PolSQL.Execute(SQL,3)
    if stat <> 'OK':
        stat = "Bd przy pobieraniu danych: "+stat
        dane.append(stat)