# -*- coding: iso8859_2 -*-
#-----------------------------------------------------------------------------
# Name:        fs_wydruki_dokument_magazynowy.py
# Purpose:      
# Author:      Micha Raburski
# Created:     2007/01/30
# RCS-ID:      $Id: fs_wydruki_dokument_magazynowy.py $
# Copyright:   (c) 2007 Record System
# Licence:     GNU GPL
#-----------------------------------------------------------------------------

#klucze= magazyn,dokument,data_dok,numer

Mag=klucze[0]
Dokum=klucze[1]
Data=klucze[2]
Nr=str(klucze[3])

stat = "OK"
dane = []

#zrobic sprawdzanie uprawnien do dokumentu magazynowego
   
#jeli uprawnienia sa ok
if stat=='OK':
    #--- pobranie pozycji dokumentu
    filtr="dmp.firma_id='"+self.firma_id+"' AND dmp.magazyn_id='"+Mag+"' AND dmp.dokument_id='"+Dokum+"' AND dmp.data='"+Data+"'  AND dmp.numer="+Nr
    pola="CAST(dmp.nr_poz AS TEXT) || '/' || CAST(dmp.nr_ppoz AS TEXT) AS pozycja,dmp.artykul_id,rsart.nazwa,dmp.ilosc1,rsart.jm1,dmp.cena1,dmp.ilosc1*dmp.cena1 AS wartosc,dmp.opis"
    pola=pola+",dmp.ilosc2,rsart.jm2,dmp.cena2,dmp.nr_serii,dmp.termin_przyd,dmp.dokument_przych, COALESCE(dmp.lokacja_skad,'') AS lokacja_skad,COALESCE(dmp.lokacja_dokad,'') AS lokacja_dokad "
    pola=pola+",COALESCE(dmp.cecha1_opis,'') AS cecha1_opis, COALESCE(dmp.cecha1_wartosc,'') AS cecha1_wartosc,"
    pola+="rsf_podaj_parametry_cechy(dmp.firma_id,COALESCE(dmp.cecha1_opis,''),COALESCE(dmp.cecha1_wartosc,''),'opis') AS opis_cechy" 
    stat,daneP,naglP,dump= self.PolSQL.Execute("SELECT "+pola+" FROM rs_dokumenty_magazynowe_pozycje dmp INNER JOIN rs_artykuly rsart USING (firma_id,artykul_id) WHERE "+filtr+" ORDER BY dmp.nr_poz,dmp.nr_ppoz;",3)
    if stat<>'OK':
        stat = 'Bd w pobieraniu pozycji dokumentu magazynowego'
        #dane.append(stat)
if stat=='OK':
    if len(daneP)==0:
        stat='Brak pozycji na dokumencie'
        dane.append(stat)
if stat=='OK':    
    DaneP = rssql.RSTableRowset(daneP,naglP)
    #--- Czy wartosci
    stat,daneCzyW,naglCzyW,dump= self.PolSQL.Execute("SELECT czy_wartosci, typ_dokumentu, typ_wydruku FROM rs_typy_dokumentow_m WHERE firma_id='"+self.firma_id+"' AND dokument_id='"+Dokum+"';",3)
    if stat<>'OK':
        stat = 'Bd w pobieraniu danych typu dokumentu.'
        dane.append(stat)
if stat=='OK':
    DaneCzyW = rssql.RSTableRowset(daneCzyW,naglCzyW)
    #--- sprawdzenie nagwka przed zmian skadania numeru faktury / korekty
    Firma=self.firma_id
    KlPom=str([Mag,Dokum,Data,Nr]).replace("'",'"')
    stat,daneN,naglN,dump= self.PolSQL.Execute("SELECT kontrahent_id,waluta,konto_kosztow,nr_zlecenia,nr_faktury,stan,kwota,miejsce_dostawy,magazyn_dokad,magazyn_skad,opis,projekt_id,CASE WHEN f_wyznacznik_id IS NULL OR f_data IS NULL OR f_numer IS NULL THEN '' ELSE rsf_podaj_numer_dokumentu_na_wydruk(firma_id,'[\"'||f_wyznacznik_id||'\",\"'||f_data||'\",\"'||f_numer||'\"]', 'F') END as numer_faktury,CASE WHEN k_wyznacznik_id IS NULL OR k_data IS NULL OR k_numer IS NULL THEN '' ELSE rsf_podaj_numer_dokumentu_na_wydruk(firma_id,'[\"'||k_wyznacznik_id||'\",\"'||k_data||'\",\"'||k_numer||'\"]', 'K') END as numer_korekty,list_przewozowy, rsf_podaj_numer_dokumentu_na_wydruk('"+Firma+"','"+KlPom+"','M') as nr_dok, numer_dokad FROM rs_dokumenty_magazynowe WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+Mag+"' AND dokument_id='"+Dokum+"' AND data='"+Data+"' AND numer="+Nr+";",3)
    
    if stat<>'OK':
        stat='Bd w pobieraniu nagwka dokumentu magazynowego'
        dane.append(stat)
    DaneN = rssql.RSTableRowset(daneN,naglN)
    if len(daneN)>0:
        kontrahent = DaneN.GetVal(0,"kontrahent_id")
        kontokosztow = DaneN.GetVal(0,"konto_kosztow")
        nrzlecenia = DaneN.GetVal(0,"nr_zlecenia")
        miejscedostawy = DaneN.GetVal(0,"miejsce_dostawy")
        magazyndokad = DaneN.GetVal(0,"magazyn_dokad")
        magazynskad = DaneN.GetVal(0,"magazyn_skad")
        projekt= DaneN.GetVal(0,"projekt_id")
        numerdokad= DaneN.GetVal(0,"numer_dokad")    
    else:
        stat='Bdny dokument : '+Mag+"/"+Dokum+"/"+Data+"/"+Nr
        dane.append(stat)
    if stat=='OK':
        #--- dane magazynu
        stat,daneMag,naglMag,dump= self.PolSQL.Execute("SELECT oddzial_id,czy_ceny FROM rs_magazyny WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+Mag+"';",3)
        if stat<>'OK':
            stat='Bd w pobieraniu oddziau'
            dane.append(stat)
    if stat=='OK':
        DaneMag = rssql.RSTableRowset(daneMag,naglMag)
        if len(daneMag)<>0:
            oddzial=DaneMag.GetVal(0,"oddzial_id")
            CzyCenyMag=DaneMag.GetVal(0,"czy_ceny")
        else:
            stat='Bdny magazyn : '+Mag
            dane.append(stat)
    if stat=='OK':
        #--- dane oddziau
        stat,daneOddz,naglOddz,dump= self.PolSQL.Execute("SELECT nazwa,adr_miej,adr_ulica,adr_nry, adr_kod  FROM rs_oddzialy WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+oddzial+"';",3)
        if stat<>'OK':
            stat='Bd w pobieraniu danych oddziau'
            dane.append(stat)
    if stat=='OK':
        DaneOddz = rssql.RSTableRowset(daneOddz,naglOddz)
        if len(daneOddz)==0:
            stat='Bdny oddzia : '+oddzial
            dane.append(stat)
    if stat=='OK':
        opismagazynuskad=''
        opismagazynudokad=''
        TekstKontr=''
        TekstKontr1=''
        TekstKontr2=[[''],['']]
        TekstMiej=''
        TekstMiej1=''
        TekstKontoK=''
        TekstKontoK1=''
        TekstNrZlec=''
        TekstNrZlec1=''
        Proj=''
        Proj1=''

        
        #--- magazyn skad
        if magazynskad<>'None':
            stat,daneMS,naglMS,dump= self.PolSQL.Execute("SELECT opis FROM rs_magazyny WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+magazynskad+"';",3)    
            if stat<>'OK':
                stat='Bd w pobieraniu opisu magazynu: '+magazynskad
                dane.append(stat)
            DaneMS = rssql.RSTableRowset(daneMS,naglMS)
            if len(daneMS)>0:
                opismagazynuskad = DaneMS.GetVal(0,"opis")
        
        #--- magazyn dokad
        if magazyndokad<>'None':
            stat,daneMD,naglMD,dump= self.PolSQL.Execute("SELECT opis FROM rs_magazyny WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+magazyndokad+"';",3)    
            if stat<>'OK':
                stat='Bd w pobieraniu opisu magazynu: '+magazyndokad
                dane.append(stat)
            DaneMD = rssql.RSTableRowset(daneMD,naglMD)
            if len(daneMD)>0:
                opismagazynudokad = DaneMD.GetVal(0,"opis")
    
        #--- kontrahent
        if kontrahent<>'None':
            stat,daneK,naglK,dump= self.PolSQL.Execute("SELECT nazwa,adr_kod,adr_miej,adr_ulica,adr_nry FROM rs_kontrahenci WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+kontrahent+"';",3)    
            if stat<>'OK':
                stat='Bd w pobieraniu danych kontrahenta'
                dane.append(stat)
            else:
                DaneK = rssql.RSTableRowset(daneK,naglK)
                if len(daneK)>0:
                    TekstKontr="       Kontrahent : ("+kontrahent+") - "+string.strip(DaneK.GetVal(0,"nazwa"))+", "+string.strip(DaneK.GetVal(0,"adr_kod"))+" "+string.strip(DaneK.GetVal(0,"adr_miej"))+", "+string.strip(DaneK.GetVal(0,"adr_ulica"))+" "+string.strip(DaneK.GetVal(0,"adr_nry"))
                    TekstKontr1=": ("+kontrahent+") - "+string.strip(DaneK.GetVal(0,"nazwa"))+", "+string.strip(DaneK.GetVal(0,"adr_kod"))+" "+string.strip(DaneK.GetVal(0,"adr_miej"))+", "+string.strip(DaneK.GetVal(0,"adr_ulica"))+" "+string.strip(DaneK.GetVal(0,"adr_nry"))
                    TekstKontr2=[[u"("+kontrahent+") - "+string.strip(DaneK.GetVal(0,"nazwa"))],[u""+string.strip(DaneK.GetVal(0,"adr_kod"))+" "+string.strip(DaneK.GetVal(0,"adr_miej"))+", "+string.strip(DaneK.GetVal(0,"adr_ulica"))+" "+string.strip(DaneK.GetVal(0,"adr_nry"))]]
    if stat=='OK':    
        #--- miejsce dostawy
        if miejscedostawy<>'None':
            stat,daneMiej,naglMiej,dump= self.PolSQL.Execute("SELECT nazwa,adr_kod,adr_miej,adr_ulica,adr_nry FROM rs_kontrahenci WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+miejscedostawy+"';",3)    
            if stat<>'OK':
                stat='Bd w pobieraniu danych miejsca dostawy'
                dane.append(stat)
            DaneMiej = rssql.RSTableRowset(daneMiej,naglMiej)
            if len(daneMiej)>0:
                TekstMiej="   Miejsce dostawy : ("+miejscedostawy+") - "+string.strip(DaneMiej.GetVal(0,"nazwa"))+", "+string.strip(DaneMiej.GetVal(0,"adr_kod"))+" "+string.strip(DaneMiej.GetVal(0,"adr_miej"))+", "+string.strip(DaneMiej.GetVal(0,"adr_ulica"))+" "+string.strip(DaneMiej.GetVal(0,"adr_nry"))
                TekstMiej1=": ("+miejscedostawy+") - "+string.strip(DaneMiej.GetVal(0,"nazwa"))+", "+string.strip(DaneMiej.GetVal(0,"adr_kod"))+" "+string.strip(DaneMiej.GetVal(0,"adr_miej"))+", "+string.strip(DaneMiej.GetVal(0,"adr_ulica"))+" "+string.strip(DaneMiej.GetVal(0,"adr_nry"))
    if stat=='OK':
        #--- konto kosztw
        if kontokosztow <>'None':
            stat,daneKK,naglKK,dump= self.PolSQL.Execute("SELECT opis FROM rs_konta_kosztow WHERE firma_id='"+self.firma_id+"' AND kod='"+kontokosztow+"';",3)    
            if stat<>'OK':
                stat='Bd w pobieraniu opisu konta kosztw'
                dane.append(stat)
            DaneKK = rssql.RSTableRowset(daneKK,naglKK)
            if len(daneKK)>0:
                TekstKontoK="Konto koszt\xf3w : "+kontokosztow+" - "+DaneKK.GetVal(0,"opis")
                TekstKontoK1=": "+kontokosztow+" - "+DaneKK.GetVal(0,"opis")
    if stat=='OK':
        #--- nr zlecenia
        if nrzlecenia <>'None':
            stat,daneNZ,naglNZ,dump= self.PolSQL.Execute("SELECT opis FROM rs_numery_zlecen WHERE firma_id='"+self.firma_id+"' AND kod='"+nrzlecenia+"';",3)    
            if stat<>'OK':
                stat='Bd w pobieraniu opisu numeru zlecenia'
                dane.append(stat)
            DaneNZ = rssql.RSTableRowset(daneNZ,naglNZ)
            if len(daneNZ)>0:
                TekstNrZlec="        Zlecenie : "+nrzlecenia+" - "+DaneNZ.GetVal(0,"opis")
                TekstNrZlec1=": "+nrzlecenia+" - "+DaneNZ.GetVal(0,"opis")
    if stat=='OK':           
        #--- projekt
        if projekt not in ('None','','zzzz'):
            stat,daneNPr,naglNPr,dump= self.PolSQL.Execute("SELECT nazwa FROM rs_projekty WHERE firma_id='"+self.firma_id+"' AND projekt_id='"+projekt+"';",3)    
            if stat<>'OK':
                stat='Bd w pobieraniu nazwy projektu'
                dane.append(stat)
            DaneNPr = rssql.RSTableRowset(daneNPr,naglNPr)
            if len(daneNPr)<>0:
                Proj="          Projekt : "+projekt+" - "+DaneNPr.GetVal(0,"nazwa")
                Proj1=": "+projekt+" - "+DaneNPr.GetVal(0,"nazwa")
            
    if stat=='OK':
        # --- numer dokumentu w magazynie dokd 
        NumerDokad=int(numerdokad)
        if magazyndokad.strip() not in ('','None',None) and NumerDokad<>0:
            KlPomDokad=str([magazyndokad,Dokum,Data,NumerDokad]).replace("'",'"')
            stat,daneNrMD,naglNrMD,dump=self.PolSQL.Execute("SELECT rsf_podaj_numer_dokumentu_na_wydruk('"+Firma+"','"+KlPomDokad+"','M') as nr_mag_dokad;",3)
            if stat<>'OK':
                stat="Bd w pobieraniu numeru dokumentu w magazynie "+magazyndokad
                dane.append(stat)
        else:
            daneNrMD=[]
            naglNrMD=[]       
        
        if stat=='OK':
                     #   0    1      2    3                         4                                                                                   5        6          7                 8                9         10       11            12       13     14       15        16         17        18           19            20       21        22
            dane=str([daneP,naglP,daneN,naglN,[DaneCzyW.GetVal(0,"czy_wartosci"),DaneCzyW.GetVal(0,"typ_dokumentu"),DaneCzyW.GetVal(0,"typ_wydruku")],daneOddz,naglOddz,opismagazynuskad,opismagazynudokad,TekstKontr,TekstMiej,TekstKontoK,TekstNrZlec,Proj,daneNrMD,naglNrMD,TekstKontr1,TekstMiej1,TekstKontoK1,TekstNrZlec1,Proj1,TekstKontr2,CzyCenyMag])