#!/usr/bin/python
# -*- coding: iso8859_2 -*-
#-----------------------------------------------------------------------------
# Name:             fs_wydruki_formularz.py
# Purpose:          wydruk formularza
# Author:           Dariusz Boduch
# Created:          2009/08/05
# RCS-ID:           $Id: fs_wydruki_formularz.py $
# Copyright:        (c) 2007 RecordSystem
# Licence:          GNU GPL
#-----------------------------------------------------------------------------
#klucze: Symbol
Symbol=klucze[0]

stat = "OK"
dane = []
#sprawdzenie poprawnosci danych
if Symbol.strip() in (None,'','None'):
    stat='Brak nazwy'
    
if self.operator_id == STANDARD_OPERATOR_ID:
    UprWyk=True
else:
    UprWyk=(self.oddzial_id,'077066') in self.uprawnienia

if stat=='OK':
    if not UprWyk:
        stat='Brak uprawnie do wykonywania. Skontaktuj si z administratorem.'
    else:
       #pobieranie danych nagwka
        SELECT="SELECT formularz_id, nazwa, obliczenia_okres, obliczenia_miesiac, obliczenia_data, l_kolumn "
        SELECT+=",naglowek, stopka, obliczenia_rok "
        FROM="FROM rs_formularze "
        WHERE="WHERE firma_id='"+self.firma_id+"' AND formularz_id='"+Symbol+"' ;"
        stat,daneN,naglN,dump=self.PolSQL.Execute(SELECT+FROM+WHERE,3)
        if stat!="OK":
            stat="Bd w pobieraniu danych formularza"
        else:
            if len(daneN)==0:
                stat='Brak danych formularza'
if stat=='OK':
    #pobranie danych pozycji formularza
    SELECT="SELECT opis, wartosc, wytluszczenie,wyposrodkowanie,coalesce(length(opis),4),coalesce(length(wartosc::text),4),wiersz,kolumna "
    FROM="FROM rs_formularze_pozycje "
    WHERE="WHERE firma_id='"+self.firma_id+"' AND formularz_id='"+Symbol+"' ORDER BY wiersz, kolumna ;"
    stat,daneP,naglP,dump=self.PolSQL.Execute(SELECT+FROM+WHERE,3)
    if stat!="OK":
        stat="Bd w pobieraniu danych pozycji formularza"
    else:
        if len(daneN)==0:
            stat='Brak danych pozycji formularza'            
if stat=='OK':
    #pobranie danych do pol z naglowka i stopki
    SELECT="SELECT nazwa, adr_kod, adr_miej, adr_ulica, adr_nry, COALESCE(tel1,''), COALESCE(tel2,''), nip, regon, CURRENT_DATE "
    SELECT+="FROM rs_oddzialy WHERE firma_id='"+self.firma_id+"' and oddzial_id='"+self.oddzial_id+"';"
    stat,daneO,naglO,dump=self.PolSQL.Execute(SELECT,3)
    if stat!="OK":
        stat="Bd w pobieraniu danych oddziau"
    else:
        if len(daneN)==0:
            stat='Brak danych oddziau'            


if stat=='OK':
    #           0     1     2      3    4       5   
    dane=str([daneN,naglN,daneP,naglP,daneO,naglO])