# -*- coding: iso8859_2 -*-
#-----------------------------------------------------------------------------
# Name:        fs_wydruki_kierowcy_wersje.py
# Purpose:     pobiera dane do wydruku zestawen dostarczonego pieczywa
#
# Author:      Dariusz Boduch
#
# Created:     2009/02/25
# RCS-ID:      $Id: fs_wydruki_kierowcy_wersje.py $
# Copyright:   (c) 2006 Record System
# Licence:     GNU GPL
#-----------------------------------------------------------------------------
#2017-04-07 Piotr Witkowski (10421) Zestawienie kosztw wywozu w pdf dla przewonikw
# 2022-11-29 Aleksander Bargie (13252) Wystawianie faktur dla transportu - okno zlece transportowych(zmiana numerow uprawnien)

#klucze= DataOd, DataDo, Kierowca, Normalny, Specjalny, Przerzuty

import rsglobal

def Wydruk(self,DataOd,DataDo,Kierowca,Oddzial,Normalny,Specjalny,Przerzuty,STANDARD_OPERATOR_ID):

    rsglobal.ZapiszDoLogow('Kierowca'+str(Kierowca), 1)
    dane=[]
    Dane=[]
    #daneN=[[u'None']]
    #naglN=['None']
    #daneS=[[u'None']]
    #naglS=['None']
    #daneM=[[u'None']]
    #naglM=['None']
    daneN=[]  # jr
    naglN=[]
    daneS=[]
    naglS=[]
    daneM=[]
    naglM=[]
    #slownik z kluczem: (artykul, wersja cenowa); wartosc: [cena n1]
    LArt={}
    stat='OK'
    if (not (self.oddzial_id,'103007') in self.uprawnienia) and not (self.operator_id == STANDARD_OPERATOR_ID):
        stat='Brak uprawnie do wydruku'
        dane.append(stat)
    #sprawdzenie poprawnoci kierowcy:
    if stat=='OK':
        if Kierowca.strip()<>'':
            sql="SELECT kod FROM rs_kierowcy WHERE firma_id='"+self.firma_id+"' AND kod='"+str(Kierowca)+"' ;"
            stat,daneT,dump,dump=self.PolSQL.Execute(sql,3)
            if stat<>'OK':
                stat='Bd pobierania danych kierowcy'
                dane.append(stat)
            else:
                if len(daneT)==0:
                    stat='Niepoprawny symbol kierowcy'
                    dane.append(stat)

    if stat=='OK':
        if Kierowca.strip()=='':
            WKierowca=''
        else:
            WKierowca= "AND kierowca='"+str(Kierowca)+"' "

    #pobranie danych z rs_kierowcy_wersje
    if stat=='OK':
        SQL ="SELECT kw.wlasny,kw.specjalny, kw.wc_normal, kw.wc_swiat,kw.wc_przerz,kw.wc_noc, kw.magazyn_id, kw.platnicy, m.opis "
        SQL+="FROM rs_kierowcy_wersje kw LEFT OUTER JOIN rs_magazyny m ON(kw.firma_id=m.firma_id AND kw.oddzial_id=m.oddzial_id "
        SQL+="AND kw.magazyn_id=m.magazyn_id) WHERE kw.firma_id='"+self.firma_id+"' and kw.oddzial_id='"+Oddzial+"' ; "
        stat,daneK,naglK,dump=self.PolSQL.Execute(SQL,3)
        if stat<>'OK':
            stat='Bd pobierania danych wersji cenowych'
            dane.append(stat)
        else:
            if len(daneK)==0:
                stat='Brak danych wersji cenowych'
                dane.append(stat)
        #sprawdzenie czy nie zmienia si wersja cenowa
        if stat=='OK':
            wersja=[]
            for w in daneK:
                if str(w[2]) not in wersja:
                    wersja.append(str(w[2]))
                if str(w[3]) not in wersja:
                    wersja.append(str(w[3]))
                if str(w[4]) not in wersja:
                    wersja.append(str(w[4]))
                if str(w[5]) not in wersja:
                    wersja.append(str(w[5]))

            Wersje=str(wersja).replace('[','(').replace(']',')')
            SQL="SELECT wersja, data_od FROM rs_artykuly_ceny WHERE firma_id='"+self.firma_id+"' AND wersja in "+Wersje+" "
            SQL+="AND data_od>'"+DataOd+"' AND data_od <='"+DataDo+"' GROUP BY wersja, data_od ORDER BY wersja, data_od "
            stat,daneW,dump,dump=self.PolSQL.Execute(SQL,3)
            if stat<>'OK':
                stat='Bd sprawdzania czy zmieniana bya wersja cenowa'
                dane.append(stat)
            else:
                if len(daneW)>0:
                    DaneBl=[]
                    for w in daneW:
                        wiersz=str(w[0])+" - "+str(w[1])
                        DaneBl.append(wiersz)
                    WersjeZm=str(DaneBl).replace('[','').replace(']','')
                    stat=u'W okresie obejmujcym wydruk nastpiy nastpujce zmiany wersji cenowych: '+str(WersjeZm)
    #slownik z kluczem: (artykul, wersja cenowa); wartosc: [cena n1]
    if stat=='OK':
        SQL="SELECT artykul_id, wersja, rsf_podaj_cene_n1('"+self.firma_id+"',artykul_id ,wersja, 'PLN', '"+DataDo+"') "
        SQL+="FROM rs_artykuly_ceny WHERE firma_id='"+self.firma_id+"' AND wersja in  "+Wersje+" "
        SQL+="GROUP BY artykul_id, wersja ORDER BY artykul_id, wersja "
        stat,daneA,dump,dump=self.PolSQL.Execute(SQL,3)
        if stat<>'OK':
            stat='Bd pobierania cen artykuw dla wersji cenowych'
            dane.append(stat)
        else:
            for w in daneA:
                LArt[(str(w[0]),str(w[1]))] = w[2]
    #lista platnikow
    if stat=='OK':
        Platnicy=daneK[0][-2]
        Magazyn=daneK[0][-3]

        if Platnicy.strip() in (None,'','None'):
            NPlatnicy=SPlatnicy=''
            Platnicy = "'',''"
        else:
            NPlatnicy=" AND dd.platnik_id not in ("+str(Platnicy)+") "
            SPlatnicy=" AND dd.platnik_id in ("+str(Platnicy)+") "

    #pobranie danych wydruk Normalny
    if stat=='OK':
        if Normalny:
            SQLN="SELECT dd.kierowca, dd.kierowca_opis, dd.artykul_id,dd.artykul_opis,upper(dd.jm1) as jm "
            SQLN+=",SUM(CASE WHEN extract(DOW from dd.data)<>0 THEN dd.ilosc_dost1 ELSE 0 END) as dostarczone "
            SQLN+=",SUM(CASE WHEN extract(DOW from dd.data)<>0 THEN dd.ilosc_zwr1 ELSE 0 END) as zwroty "
            SQLN+=",SUM(CASE WHEN extract(DOW from dd.data)<>0 THEN dd.ilosc_dost1 ELSE 0 END) - SUM(CASE WHEN extract(DOW from dd.data)<>0 THEN dd.ilosc_zwr1 ELSE 0 END) as roznica "
            SQLN+=",SUM(CASE WHEN extract(DOW from dd.data)=0 THEN dd.ilosc_dost1 ELSE 0 END) as dostarczone_nd, k.wlasny "
            SQLN+="FROM rs_gr_dowody_dostaw dd "
            SQLN+="LEFT OUTER JOIN rs_kierowcy k ON (dd.firma_id=k.firma_id AND dd.kierowca=k.kod) "
            SQLN+="WHERE dd.firma_id='"+self.firma_id+"' AND dd.oddzial_id='"+Oddzial+"' "
            SQLN+="AND dd.data>='"+DataOd+"' and dd.data<='"+DataDo+"' "+WKierowca+" "+NPlatnicy+" "
            SQLN+="GROUP BY dd.kierowca, dd.kierowca_opis, dd.artykul_id,dd.artykul_opis,dd.jm1, k.wlasny "
            SQLN+="ORDER BY dd.kierowca, dd.artykul_id ; "
            stat,daneN,naglN,dump=self.PolSQL2.Execute(SQLN,3)
            if stat<>'OK':
                stat='Bd pobierania danych dla dostaw normalnych'
                dane.append(stat)
    #pobranie danych wydruk Specjalny
    if stat=='OK':
        if Specjalny:
            SQLS="SELECT dd.kierowca, dd.kierowca_opis, dd.artykul_id,dd.artykul_opis,upper(dd.jm1) as jm"
            SQLS+=",SUM(CASE WHEN extract(DOW from dd.data)<>0 THEN dd.ilosc_dost1 ELSE 0 END) as dostarczone "
            SQLS+=",0 as zwroty ,0 as roznica, k.wlasny "
            SQLS+=",SUM(CASE WHEN extract(DOW from dd.data)=0 THEN dd.ilosc_dost1 ELSE 0 END) as dostarczone_nd "
            SQLS+="FROM rs_gr_dowody_dostaw dd "
            SQLS+="LEFT OUTER JOIN rs_kierowcy k ON (dd.firma_id=k.firma_id AND dd.kierowca=k.kod) "
            SQLS+="WHERE dd.firma_id='"+self.firma_id+"' AND dd.oddzial_id='"+Oddzial+"' "
            SQLS+="AND dd.data>='"+DataOd+"' and dd.data<='"+DataDo+"' "+WKierowca+" "+SPlatnicy+" "
            SQLS+="GROUP BY dd.kierowca, dd.kierowca_opis, dd.artykul_id, dd.artykul_opis, dd.jm1, k.wlasny "
            SQLS+="ORDER BY dd.kierowca, dd.artykul_id ; "
            stat,daneS,naglS,dump=self.PolSQL2.Execute(SQLS,3)
            if stat<>'OK':
                stat='Bd pobierania danych dla dostaw specjalnych'
                dane.append(stat)
    #pobranie danych wydruk Przerzuty
    if stat=='OK':
        if Przerzuty:
            SQLM="SELECT om.kierowca,k.opis, om.artykul_id as artykul , a.nazwa as nazwa , upper(a.jm1) as jm "
            SQLM+=",SUM(CASE WHEN czy_nocny=False THEN om.ilosc1 ELSE 0 END) as iloscdzien "
            SQLM+=",SUM(CASE WHEN czy_nocny=True THEN om.ilosc1 ELSE 0 END) as iloscnoc "
            SQLM+=",k.wlasny "
            SQLM+="FROM rs_obroty_magazynowe om "
            SQLM+="LEFT OUTER JOIN rs_artykuly a ON (om.firma_id=a.firma_id AND om.artykul_id=a.artykul_id) "
            SQLM+="LEFT OUTER JOIN rs_kierowcy k ON (om.firma_id=k.firma_id AND om.kierowca=k.kod) "
            SQLM+="WHERE om.firma_id='"+self.firma_id+"' AND om.magazyn_id='"+str(Magazyn)+"' AND om.dokument_id='MM' "
            SQLM+="AND om.typ_znak=-1 AND om.data>='"+DataOd+"' AND om.data<='"+DataDo+"' "+WKierowca+" "
            SQLM+="GROUP BY om.kierowca, om.artykul_id, a.nazwa, a.jm1, k.opis, k.wlasny HAVING om.kierowca IS NOT NULL "
            SQLM+="ORDER BY om.kierowca, om.artykul_id ;"
            stat,daneM,naglM,dump=self.PolSQL2.Execute(SQLM,3)
            if stat<>'OK':
                stat='Bd pobierania danych dla przerzutw'
                dane.append(stat)
    if stat=='OK':
        dane=str([daneK,naglK,daneN,naglN,daneS,naglS,daneM,naglM,LArt])
    return stat, dane



def WydrukPdf(self,DataOd,DataDo,Trasa,Oddzial,Normalny,Specjalny,Przerzuty,STANDARD_OPERATOR_ID):

    rsglobal.ZapiszDoLogow('Trasa'+str(Trasa), 1)
    dane=[]
    Dane=[]
    #daneN=[[u'None']]
    #naglN=['None']
    #daneS=[[u'None']]
    #naglS=['None']
    #daneM=[[u'None']]
    #naglM=['None']
    daneN=[]  # jr
    naglN=[]
    daneS=[]
    naglS=[]
    daneM=[]
    naglM=[]
    #slownik z kluczem: (artykul, wersja cenowa); wartosc: [cena n1]
    LArt={}
    stat='OK'
    if (not (self.oddzial_id,'103007') in self.uprawnienia) and not (self.operator_id == STANDARD_OPERATOR_ID):
        stat='Brak uprawnie do wydruku'
        dane.append(stat)
    #sprawdzenie poprawnoci kierowcy:
    if stat=='OK':
        if Trasa.strip()<>'':
            sql="SELECT kod FROM rs_trasy WHERE firma_id='"+self.firma_id+"' AND kod='"+str(Trasa)+"' ;"
            stat,daneT,dump,dump=self.PolSQL.Execute(sql,3)
            if stat<>'OK':
                stat='Bd pobierania danych trasy'
                dane.append(stat)
            else:
                if len(daneT)==0:
                    stat='Niepoprawny symbol trasy'
                    dane.append(stat)

    if stat=='OK':
        if Trasa.strip()=='':
            WTrasa=''
        else:
            WTrasa= "trasa='"+str(Trasa)+"' "

    #pobranie danych z rs_kierowcy_wersje
    if stat=='OK':
        SQL ="SELECT kw.wlasny,kw.specjalny, kw.wc_normal, kw.wc_swiat,kw.wc_przerz,kw.wc_noc, kw.magazyn_id, kw.platnicy, m.opis "
        SQL+="FROM rs_kierowcy_wersje kw LEFT OUTER JOIN rs_magazyny m ON(kw.firma_id=m.firma_id AND kw.oddzial_id=m.oddzial_id "
        SQL+="AND kw.magazyn_id=m.magazyn_id) WHERE kw.firma_id='"+self.firma_id+"' and kw.oddzial_id='"+Oddzial+"' ; "
        stat,daneK,naglK,dump=self.PolSQL.Execute(SQL,3)
        if stat<>'OK':
            stat='Bd pobierania danych wersji cenowych'
            dane.append(stat)
        else:
            if len(daneK)==0:
                stat='Brak danych wersji cenowych'
                dane.append(stat)
        #sprawdzenie czy nie zmienia si wersja cenowa
        if stat=='OK':
            wersja=[]
            for w in daneK:
                if str(w[2]) not in wersja:
                    wersja.append(str(w[2]))
                if str(w[3]) not in wersja:
                    wersja.append(str(w[3]))
                if str(w[4]) not in wersja:
                    wersja.append(str(w[4]))
                if str(w[5]) not in wersja:
                    wersja.append(str(w[5]))

            Wersje=str(wersja).replace('[','(').replace(']',')')
            SQL="SELECT wersja, data_od FROM rs_artykuly_ceny WHERE firma_id='"+self.firma_id+"' AND wersja in "+Wersje+" "
            SQL+="AND data_od>'"+DataOd+"' AND data_od <='"+DataDo+"' GROUP BY wersja, data_od ORDER BY wersja, data_od "
            stat,daneW,dump,dump=self.PolSQL.Execute(SQL,3)
            if stat<>'OK':
                stat='Bd sprawdzania czy zmieniana bya wersja cenowa'
                dane.append(stat)
            else:
                if len(daneW)>0:
                    DaneBl=[]
                    for w in daneW:
                        wiersz=str(w[0])+" - "+str(w[1])
                        DaneBl.append(wiersz)
                    WersjeZm=str(DaneBl).replace('[','').replace(']','')
                    stat=u'W okresie obejmujcym wydruk nastpiy nastpujce zmiany wersji cenowych: '+str(WersjeZm)

    #slownik z kluczem: (artykul, wersja cenowa); wartosc: [cena n1]
    if stat=='OK':
        SQL="SELECT artykul_id, wersja, rsf_podaj_cene_n1('"+self.firma_id+"',artykul_id ,wersja, 'PLN', '"+DataDo+"') "
        SQL+="FROM rs_artykuly_ceny WHERE firma_id='"+self.firma_id+"' AND wersja in  "+Wersje+" "
        SQL+="GROUP BY artykul_id, wersja ORDER BY artykul_id, wersja "
        stat,daneA,dump,dump=self.PolSQL.Execute(SQL,3)
        if stat<>'OK':
            stat='Bd pobierania cen artykuw dla wersji cenowych'
            dane.append(stat)
        else:
            for w in daneA:
                LArt[(str(w[0]),str(w[1]))] = w[2]
                
    #lista platnikow
    if stat=='OK':
        Platnicy=daneK[0][-2]
        Magazyn=daneK[0][-3]

        if Platnicy.strip() in (None,'','None'):
            NPlatnicy=SPlatnicy=''
            Platnicy = "'',''"
        else:
            NPlatnicy=" AND dd.platnik_id not in ("+str(Platnicy)+") "
            SPlatnicy=" AND dd.platnik_id in ("+str(Platnicy)+") "

    #pobranie danych wydruk Normalny
    if stat=='OK':
        if Normalny:
            SQLN="SELECT dd.trasa, dd.trasa_opis, dd.artykul_id,dd.artykul_opis,upper(dd.jm1) as jm "
            SQLN+=",SUM(CASE WHEN extract(DOW from dd.data)<>0 THEN dd.ilosc_dost1 ELSE 0 END) as dostarczone "
            SQLN+=",SUM(CASE WHEN extract(DOW from dd.data)<>0 THEN dd.ilosc_zwr1 ELSE 0 END) as zwroty "
            SQLN+=",SUM(CASE WHEN extract(DOW from dd.data)<>0 THEN dd.ilosc_dost1 ELSE 0 END) - "
            SQLN+="     SUM(CASE WHEN extract(DOW from dd.data)<>0 THEN dd.ilosc_zwr1 ELSE 0 END) as roznica "
            SQLN+=",SUM(CASE WHEN extract(DOW from dd.data)=0 THEN dd.ilosc_dost1 ELSE 0 END) as dostarczone_nd, k.wlasny "
            SQLN+="FROM rs_gr_dowody_dostaw dd "
            SQLN+="LEFT OUTER JOIN rs_kierowcy k ON (dd.firma_id=k.firma_id AND dd.kierowca=k.kod) "
            SQLN+="LEFT OUTER JOIN rs_trasy t ON (dd.firma_id=t.firma_id AND dd.trasa=t.kod)  "
            SQLN+="WHERE dd.firma_id='"+self.firma_id+"' AND dd.oddzial_id='"+Oddzial+"' "
            SQLN+="AND dd.data>='"+DataOd+"' and dd.data<='"+DataDo+"' AND dd."+WTrasa+" "+NPlatnicy+" "
            SQLN+="GROUP BY dd.trasa, dd.trasa_opis, dd.artykul_id,dd.artykul_opis,dd.jm1, k.wlasny "
            SQLN+="ORDER BY dd.trasa, dd.artykul_id ; "
            #rsglobal.ZapiszDoLogow('SQLN'+str(SQLN), 1)
            stat,daneN,naglN,dump=self.PolSQL2.Execute(SQLN,3)
            if stat<>'OK':
                stat='Bd pobierania danych dla dostaw normalnych'
                dane.append(stat)
    #pobranie danych wydruk Specjalny
    if stat=='OK':
        if Specjalny:
            SQLS="SELECT dd.trasa, dd.trasa_opis, dd.artykul_id,dd.artykul_opis,upper(dd.jm1) as jm"
            SQLS+=",SUM(CASE WHEN extract(DOW from dd.data)<>0 THEN dd.ilosc_dost1 ELSE 0 END) as dostarczone "
            SQLS+=",0 as zwroty ,0 as roznica, k.wlasny "
            SQLS+=",SUM(CASE WHEN extract(DOW from dd.data)=0 THEN dd.ilosc_dost1 ELSE 0 END) as dostarczone_nd "
            SQLS+="FROM rs_gr_dowody_dostaw dd "
            SQLS+="LEFT OUTER JOIN rs_kierowcy k ON (dd.firma_id=k.firma_id AND dd.kierowca=k.kod) "
            SQLS+="WHERE dd.firma_id='"+self.firma_id+"' AND dd.oddzial_id='"+Oddzial+"' "
            SQLS+="AND dd.data>='"+DataOd+"' and dd.data<='"+DataDo+"' AND dd."+WTrasa+" "+SPlatnicy+" "
            SQLS+="GROUP BY dd.trasa, dd.trasa_opis, dd.artykul_id, dd.artykul_opis, dd.jm1, k.wlasny "
            SQLS+="ORDER BY dd.trasa, dd.artykul_id ; "
            #rsglobal.ZapiszDoLogow('SQLS'+str(SQLS), 1)
            stat,daneS,naglS,dump=self.PolSQL2.Execute(SQLS,3)
            if stat<>'OK':
                stat='Bd pobierania danych dla dostaw specjalnych'
                dane.append(stat)
    #pobranie danych wydruk Przerzuty
    if stat=='OK':
        if Przerzuty:
            if Trasa.strip()=='':   #decyzja z spc
                WTrasa=''
            else:
                WTrasa= "AND om.kierowca='"+str(Trasa)+"' "
            SQLM="SELECT om.kierowca as trasa,k.opis, om.artykul_id , a.nazwa as artykul_opis, upper(a.jm1) as jm "
            SQLM+=",SUM(CASE WHEN czy_nocny=False THEN om.ilosc1 ELSE 0 END) as iloscdzien "
            SQLM+=",SUM(CASE WHEN czy_nocny=True THEN om.ilosc1 ELSE 0 END) as iloscnoc "
            SQLM+=",k.wlasny "
            SQLM+="FROM rs_obroty_magazynowe om "
            SQLM+="LEFT OUTER JOIN rs_artykuly a ON (om.firma_id=a.firma_id AND om.artykul_id=a.artykul_id) "
            SQLM+="LEFT OUTER JOIN rs_kierowcy k ON (om.firma_id=k.firma_id AND om.kierowca=k.kod) "
            SQLM+="WHERE om.firma_id='"+self.firma_id+"' AND om.magazyn_id='"+str(Magazyn)+"' AND om.dokument_id='MM' "
            SQLM+="AND om.typ_znak=-1 AND om.data>='"+DataOd+"' AND om.data<='"+DataDo+"' "+WTrasa+" "
            SQLM+="GROUP BY om.kierowca, om.artykul_id, a.nazwa, a.jm1, k.opis, k.wlasny HAVING om.kierowca IS NOT NULL "
            SQLM+="ORDER BY om.kierowca, om.artykul_id ;"
            stat,daneM,naglM,dump=self.PolSQL2.Execute(SQLM,3)
            #rsglobal.ZapiszDoLogow('SQLM z PDF '+str(SQLM), 1)
            if stat<>'OK':
                stat='Bd pobierania danych dla przerzutw'
                dane.append(stat)
    if stat=='OK':
        dane=str([daneK,naglK,daneN,naglN,daneS,naglS,daneM,naglM,LArt])
    return stat, dane