# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_wydruki_produkcja_przewodnik.py
# Purpose:      
# Author:      Micha Raburski
# Created:     2013/04/29
# RCS-ID:      $Id: fs_wydruki_produkcja_przewodnik.py $
# Copyright:   (c) 2013 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

from funkcje import fs_pliki_global

Partia=klucze[0]

stat = "OK"
dane = []

# pobranie nazwy firmy
SQL="SELECT opis FROM rs_firmy WHERE firma_id='"+self.firma_id+"';"
stat,daneF,naglF,dump= self.PolSQL.Execute(SQL,3)
if stat<>"OK":
    stat = 'Bd w pobieraniu danych firmy : '+stat
    dane.append(stat)
        
# pobranie danych nagwka/pozycji przewodnika
if stat=='OK':
    SQL="SELECT pp.przewodnik, tp.opis AS tech_opis, pp.artykul_id, COALESCE(a.nazwa_dluga,a.nazwa) AS art_nazwa, pp.do_produkcji," # 0 -4
    SQL+=" pp.nr_zamowienia, pp.data_konca,pp.kolejnosc, pp.lp," # 5 - 8
    SQL+=" pp.proces_id, p.nazwa AS proces_nazwa, p.ean AS proces_ean, " # 9 - 11
    SQL+=" pp.urzadzenie_id, u.nazwa AS urzadz_nazwa, u.ean AS urzadz_ean," # 12 - 14
    SQL+=" COALESCE(p.plik_id,0),COALESCE(pl.nazwa,''), COALESCE(pa.uwagi,'') AS uwagi" # 15 - 17
    SQL+=" FROM rs_produkcja_plan pp "
    SQL+=" INNER JOIN rs_artykuly a USING (firma_id,artykul_id) "
    SQL+=" INNER JOIN rs_procesy p USING (firma_id,proces_id) "
    SQL+=" INNER JOIN rs_urzadzenia u USING (firma_id,urzadzenie_id) "
    SQL+=" LEFT OUTER JOIN rs_pliki pl USING (plik_id) "
    SQL+=" LEFT OUTER JOIN rs_procesy_artykuly pa ON (pa.firma_id=pp.firma_id AND pa.oddzial_id=pp.oddzial_id "
    SQL+=" AND pa.proces_id=pp.proces_id AND pa.artykul_id=pp.artykul_id AND pa.urzadzenie_id=pp.urzadzenie_id) "
    SQL+=" LEFT OUTER JOIN rs_technologie_produkcji tp ON (pp.firma_id=tp.firma_id AND pp.technologia_id=tp.kod) "
    SQL+=" WHERE pp.firma_id='"+self.firma_id+"' AND pp.partia_id="+str(Partia)
    SQL+=" ORDER BY kolejnosc,lp;"
    stat,daneP,naglP,dump= self.PolSQL.Execute(SQL,3)
    if stat<>"OK":
        stat = 'Bd w pobieraniu danych nagwka/pozycji przewodnika : '+stat
        dane.append(stat)

# pobranie treci kolejnych plikw
if stat=='OK':
    SPliki={}
    for poz in daneP:
        if poz[15]<>0:
            stat,Tresc=fs_pliki_global.PobierzPlikZSerwera(self.KatalogPlikow,poz[15])
            if stat=='OK':
                SPliki[poz[15]]=[poz[16],Tresc]

# pobranie danych surowcw/dokumentw magazynowych przewodnika
if stat=='OK':
    SQL="SELECT rsf_podaj_numer_dokumentu_na_wydruk(dmp.firma_id,'[\"'||dmp.magazyn_id||'\",\"'||dmp.dokument_id||'\",\"'||dmp.data||'\",'||dmp.numer::TEXT||']','M') AS nr_dok,"
    SQL+=" dmp.artykul_id, a.nazwa, a.typ_artykulu, a.jm1, dmp.ilosc1, dmp.nr_serii, COALESCE(dmp.opis,'') AS opis"
    SQL+=" FROM rs_dokumenty_magazynowe_pozycje dmp "
    SQL+=" INNER JOIN rs_artykuly a USING (firma_id, artykul_id) "
    SQL+=" WHERE dmp.firma_id='"+self.firma_id+"' AND partia_id="+str(Partia)
    SQL+=" ORDER BY dmp.artykul_id;"
    stat,daneDM,naglDM,dump= self.PolSQL.Execute(SQL,3)
    if stat<>"OK":
        stat = 'Bd w pobieraniu danych z dokumentw magazynowych : '+stat
        dane.append(stat)

if stat=="OK":
    dane=[daneF,naglF,daneP,naglP,daneDM,naglDM,SPliki]