#!/usr/bin/python
# -*- coding: iso8859_2 -*-
#-----------------------------------------------------------------------------
# Name:             fs_wydruki_protokol_odbioru.py
# Purpose:          wydruk protokolu odbioru przeslki
# Author:           Dariusz Boduch
# Created:          2010/07/23
# RCS-ID:           $Id: fs_wydruki_protokol_odbioru.py $
# Copyright:        (c) 2010 RecordSystem
# Licence:          GNU GPL
#-----------------------------------------------------------------------------
#klucze: WiadId
Data=klucze[0]
Numer=klucze[1]

stat = "OK"
dane = []

#dane oddzialu wystawiajacego protokol (na razie centrala,mozliwa zmiana na self.oddzial)
daneO=[]
naglO=[]
SQL="SELECT nazwa,nazwa1,nazwa2, adr_ulica, adr_nry, adr_kod, adr_miej, tel1, tel2, fax, email, nip, faktura_miej, "
SQL+=" adr_poczta FROM rs_oddzialy "
SQL+=" WHERE firma_id='"+self.firma_id+"' AND oddzial_id='01' ;"
stat,daneO,naglO,dump= self.PolSQL.Execute(SQL,3)
if stat<>'OK':
    stat='Bd pobrania danych oddziau: '+stat
    dane.append(stat)

#dane dokumentow magazynowych podpietych do przesylki
#nr faktury utworzonej z dm, nr dm 
if stat=='OK':
    daneDM=[]
    nagldm=[]
    SQL="SELECT CASE WHEN (f_wyznacznik_id IS NOT NULL AND f_data IS NOT NULL AND f_numer IS NOT NULL) " 
    SQL+="THEN rsf_podaj_numer_dokumentu_na_wydruk('"+self.firma_id+"','[\"'||f_wyznacznik_id||'\",\"'||f_data||'\",\"'||f_numer||'\"]','F') ELSE '' END as nr_fakt, "
    SQL+= "CASE WHEN magazyn_id IS NOT NULL AND dokument_id IS NOT NULL AND data IS NOT NULL AND numer IS NOT NULL "
    SQL+= "THEN rsf_podaj_numer_dokumentu_na_wydruk('"+self.firma_id+"','[\"'||magazyn_id||'\",\"'||dokument_id||'\",\"'||data||'\",\"'||numer||'\"]', 'M') "
    SQL+= "ELSE '' END as nr_dokmag  "
    SQL+="FROM rs_dokumenty_magazynowe WHERE firma_id='"+self.firma_id+"' AND p_data='"+Data+"' AND p_numer="+str(Numer)+" "
    SQL+="ORDER BY 1 DESC,2 ;"
    stat,daneDM,naglDM,dump= self.PolSQL.Execute(SQL,3)
    if stat<>'OK':
        stat='Bd pobrania danych dokumentw magazynowych: '+stat
        dane.append(stat)

#dane kontraheta 
if stat=='OK':
    daneK=[]
    naglK=[]
    SQL="SELECT kontrahent_id "
    SQL+="FROM rs_dokumenty_magazynowe WHERE firma_id='"+self.firma_id+"' AND p_data='"+Data+"' AND p_numer="+str(Numer)+" "
    SQL+="GROUP BY kontrahent_id ;"
    stat,daneK,naglK,dump= self.PolSQL.Execute(SQL,3)
    if stat<>'OK':
        stat='Bd pobrania kontrahenta: '+stat
        dane.append(stat)
    else:
        #jesli jeden kontrahent na wszystkich dokumentach to pobierac jego dane
        if len(daneK)==1 and daneK[0][0] not in (None,'','None'):
            SQL="SELECT nazwa, adr_kod, adr_miej, adr_ulica, adr_nry,kontrahent_id FROM rs_kontrahenci "
            SQL+="WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+str(daneK[0][0])+"' ;"
            stat,daneK,naglK,dump= self.PolSQL.Execute(SQL,3)
            if stat<>'OK':
                stat='Bd pobrania danych kontrahenta: '+stat
                dane.append(stat)
        else:
            daneK=[]
            naglK=[]   

#dane miejsca dostawy
if stat=='OK':
    daneMD=[]
    naglMD=[]
    SQL="SELECT miejsce_dostawy "
    SQL+="FROM rs_dokumenty_magazynowe WHERE firma_id='"+self.firma_id+"' AND p_data='"+Data+"' AND p_numer="+str(Numer)+" "
    SQL+="GROUP BY miejsce_dostawy ;"
    stat,daneMD,naglMD,dump= self.PolSQL.Execute(SQL,3)
    if stat<>'OK':
        stat='Bd pobrania kontrahenta: '+stat
        dane.append(stat)
    else:
        #jesli jedno miejsce dostawy na wszystkich dokumentach to pobierac jego dane
        if len(daneMD)==1 and daneMD[0][0] not in (None,'','None'):
            SQL="SELECT nazwa, adr_kod, adr_miej, adr_ulica, adr_nry FROM rs_kontrahenci "
            SQL+="WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+str(daneMD[0][0])+"' ;"
            stat,daneMD,naglMD,dump= self.PolSQL.Execute(SQL,3)
            if stat<>'OK':
                stat='Bd pobrania danych miejsca dostawy: '+stat
                dane.append(stat)
        #jesli zadnego miejsca dostawy na wszystkich dokumentach
        elif len(daneMD)==1 and daneMD[0][0] in (None,'','None') and daneK<>[]:
            SQL="SELECT nazwa, adr_kod, adr_miej, adr_ulica, adr_nry FROM rs_kontrahenci "
            SQL+="WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+str(daneK[0][5])+"' ;"
            stat,daneMD,naglMD,dump= self.PolSQL.Execute(SQL,3)
            if stat<>'OK':
                stat='Bd pobrania danych miejsca dostawy: '+stat
                dane.append(stat)
        else:
            daneMD=[]
            naglMD=[]   
    
#dane artykolow z dok. mag
if stat=='OK':
    danePoz=[]
    naglPoz=[]
    SQL="SELECT dp.artykul_id as artykul, a.nazwa as nazwa, dp.nr_serii as nr_serii, dp.ilosc1 as ilosc, a.waga as waga, a.czy_seria as czyseria "
    SQL+="FROM rs_dokumenty_magazynowe dm LEFT OUTER JOIN rs_dokumenty_magazynowe_pozycje dp "
    SQL+="ON(dm.firma_id=dp.firma_id AND dm.magazyn_id=dp.magazyn_id AND dm.dokument_id=dp.dokument_id AND dm.data=dp.data AND dm.numer=dp.numer) "
    SQL+="LEFT OUTER JOIN rs_artykuly a ON(dp.firma_id=a.firma_id AND dp.artykul_id=a.artykul_id) "
    SQL+="WHERE dm.firma_id='"+self.firma_id+"' AND dm.p_data='"+Data+"' AND dm.p_numer="+str(Numer)+" "
    SQL+="ORDER BY dp.artykul_id ;"
    stat,danePoz,naglPoz,dump= self.PolSQL.Execute(SQL,3)
    if stat<>'OK':
        stat='Bd pobrania pozycji dokumentw magazynowych: '+stat
        dane.append(stat)

#dane osoby do kontaktow u kontrahenta
daneOsoba=[]
naglOsoba=[]
if stat=='OK' and daneK<>[]:
    SQL="SELECT imie, nazwisko, tel1, tel2 FROM rs_kontrahenci_osoby WHERE firma_id='"+self.firma_id+"' "
    SQL+="AND kontrahent_id='"+str(daneK[0][5])+"' ORDER BY osoba_id LIMIT 1 ;"
    stat,daneOsoba,naglOsoba,dump= self.PolSQL.Execute(SQL,3)
    if stat<>'OK':
        stat='Bd pobrania danych osoby do kontaktw: '+stat
        dane.append(stat)
#dane przesyki
danePrzes=[]
naglPrzes=[]
if stat=='OK':
    SQL="SELECT list_przewozowy FROM rs_przesylki WHERE firma_id='"+self.firma_id+"' "
    SQL+="AND data='"+Data+"' AND numer="+str(Numer)+" ;"
    stat,danePrzes,naglPrzes,dump= self.PolSQL.Execute(SQL,3)
    if stat<>'OK':
        stat='Bd pobrania danych przesyki: '+stat
        dane.append(stat)

if stat=='OK':
    #           0     1     2       3     4     5      6     7       8       9       10        11       12          13
    dane=str([daneO,naglO,daneDM,naglDM,daneK,naglK,daneMD,naglMD,danePoz,naglPoz,daneOsoba,naglOsoba,danePrzes, naglPrzes])