# -*- coding: iso8859_2 -*-
#-----------------------------------------------------------------------------
# Name:        fs_wydruki_raport_kasowy
# Purpose:      
# Author:      Dariusz Boduch 
# Created:     2007/12/13
# RCS-ID:      $Id: fs_wydruki_raport_kasowy.py $
# Copyright:   (c) 2007 Record System
# Licence:     GNU GPL
#-----------------------------------------------------------------------------
# 2021-09-30 - (12655) Aleksander Bargie - Bdne wartoci dla pozycji raportu kasowego

#klucze= data,kasa_bank,numer

Data=klucze[0]
Kasa=klucze[1]
Nr=str(klucze[2])

stat = "OK"
dane = []

   
#jeli uprawnienia sa ok
if stat=='OK':
    #--- pobranie salda poczatkowego, kasy
    FILTR="rw.firma_id='"+self.firma_id+"' AND rw.okres_id='"+self.okres_id+"' AND rw.data='"+Data+"' AND rw.kasa_bank_id='"+Kasa+"' AND rw.numer="+Nr
    
    POLA="CASE WHEN rw.saldo_pocz>=0 THEN rw.saldo_pocz ELSE 0 END as spocz_pl  "
    POLA+=", sum(case when rp.nr_ppoz=0 then CASE WHEN rp.typ='P' THEN rp.kwota ELSE 0 END end)+CASE WHEN rw.saldo_pocz<=0 THEN rw.saldo_pocz ELSE 0 END as razem_pl "
    POLA+=", sum(case when rp.nr_ppoz=0 then CASE WHEN rp.typ='P' THEN rp.kwota ELSE 0 END end)-sum(case when rp.nr_ppoz=0 then CASE WHEN rp.typ='W' THEN rp.kwota ELSE 0 END end)+CASE WHEN rw.saldo_pocz>=0 THEN rw.saldo_pocz ELSE 0 END+CASE WHEN rw.saldo_pocz<0 THEN rw.saldo_pocz ELSE 0 END as stan_got "
    POLA+=", sum(case when rp.nr_ppoz=0 then CASE WHEN rp.typ='P' THEN rp.kwota ELSE 0 END end) as przychod "
    POLA+=", sum(case when rp.nr_ppoz=0 then CASE WHEN rp.typ='W' THEN rp.kwota ELSE 0 END end) as rozchod "
    POLA+=", CASE WHEN rw.saldo_pocz<0 THEN rw.saldo_pocz ELSE 0 END as  saldo_pocz_min "
    POLA+=", (sum(case when rp.nr_ppoz=0 then CASE WHEN rp.typ='W' THEN rp.kwota ELSE 0 END end)*-1)+CASE WHEN rw.saldo_pocz<0 THEN rw.saldo_pocz ELSE 0 END as razem_min "
    POLA+=", rw.numer as rnumer, kb.nazwa as knazwa"
    FROM="rs_raporty_wyciagi rw "
    FROM+="LEFT OUTER JOIN rs_raporty_wyciagi_pozycje rp ON (rw.firma_id=rp.firma_id AND rw.okres_id=rp.okres_id AND rw.kasa_bank_id=rp.kasa_bank_id AND rw.data=rp.data AND rw.numer=rp.numer) "
    FROM+="LEFT OUTER JOIN rs_kasy_banki kb on(rw.firma_id=kb.firma_id AND rw.okres_id=kb.okres_id AND rw.kasa_bank_id=kb.kasa_bank_id) "
    stat,daneS,naglS,dump=self.PolSQL.Execute("SELECT "+POLA+" FROM "+FROM+" WHERE "+FILTR+" GROUP BY rw.saldo_pocz, rw.numer, kb.nazwa;",3)
    if stat<>'OK':
        stat='Bd w pobieraniu sald'
        dane.append(stat)
    #--- pobranie pozycji raportu kasowego
if stat=='OK':    
    Filtr="rw.firma_id='"+self.firma_id+"' AND rw.okres_id='"+self.okres_id+"' AND rw.data='"+Data+"' AND rw.kasa_bank_id='"+Kasa+"' AND rw.numer="+Nr
    Pola="rp.nr_poz as Nrpoz, rp.nr_ppoz as Nrppoz, rp.wyznacznik_id as wyznacznikf, rp.data_fakt as dataf, rp.numer_fakt as numerf, rp.typ_fakt as typf, rp.tresc as tresc, CASE WHEN (rp.tresc IS NULL OR rp.tresc ='') AND  rp.wyznacznik_id IS NOT NULL AND rp.data_fakt IS NOT NULL THEN rsf_podaj_numer_dokumentu_na_wydruk(rw.firma_id, '[\"'||rp.wyznacznik_id||'\",\"'||rp.data_fakt||'\",\"'||rp.numer_fakt||'\"]',rp.typ_fakt) END as nr_faktury "  
    Pola+=", CASE WHEN rp.typ='P' THEN rp.kwota ELSE CASE WHEN COALESCE(rp.typ_fakt, '')='K' THEN (rp.kwota*-1) ELSE 0 END END as Przychod, CASE WHEN rp.typ='W' AND COALESCE(rp.typ_fakt, '') <> 'K' THEN rp.kwota ELSE 0 END as Rozchod, rp.konto as Konto , rp.kierowca as Osoba , rp.platnik_id as Platnik "  #AB 30.09.21r
    From="rs_raporty_wyciagi rw LEFT OUTER JOIN rs_raporty_wyciagi_pozycje rp ON (rw.firma_id=rp.firma_id AND rw.okres_id=rp.okres_id AND rw.kasa_bank_id=rp.kasa_bank_id AND rw.data=rp.data AND rw.numer=rp.numer) "
    stat,daneP,naglP,dump=self.PolSQL.Execute("Select "+Pola+" FROM "+From+" WHERE "+Filtr+" ORDER BY rp.nr_poz, rp.nr_ppoz ;",3)
    if stat<>'OK':
        stat='Bd w pobieraniu danych pozycji raportu'
        dane.append(stat)
    #--- pobieranie danych operatora
if stat=='OK':
    stat,daneOP,naglOP,dump=self.PolSQL.Execute("SELECT imie, nazwisko FROM rs_operatorzy WHERE operator_id="+str(self.operator_id),3)
    if stat<>"OK":
        stat="Bd w pobieraniu danych operatora"
        dane.append(stat)
if stat=='OK':
    dane=str([daneS,naglS,daneP,naglP,daneOP,naglOP])