# -*- coding: iso8859_2 -*-
#-----------------------------------------------------------------------------
# Name:        fs_wydruki_rejestr_vat.py
# Purpose:      
# Author:      Micha Raburski
# Created:     2007/01/23
# RCS-ID:      $Id: fs_wydruki_rejestr_vat.py $
# Copyright:   (c) 2004-2008 Record System
# Licence:     GNU GPL
#-----------------------------------------------------------------------------

#klucze= Dokumenty,DataOd,DataDo,Oddzial,Wyznacznik,SposZapl,RodzSpos,SposOdbioru,RodzOdbioru,CzyWgDatZaplaty,CzyWgDatOdbioru, DataOdOdbioru,
#        DataDoOdbioru, CzyNiepotwierdzone

#2009.01.27 Micha Raburski  wyrzucenie filtrowania po oddziale z raportu (1446)
#2009.02.02 Micha Raburski  wyrzucenie filtrowania po oddziale z raportu (1446) cd
#2010.12.06 Micha Raburski  cakowite przerobienie formatu wydruku (4072)

Dokumenty = klucze[0]
DataOd = klucze[1]
DataDo = klucze[2]
Oddzial = klucze[3]
Platnik = klucze[4]
WyznacznikRejestr = klucze[5]
SposZapl = klucze[6]
RodzSpos = klucze[7]
SposOdbioru = klucze[8]
RodzOdbioru = klucze[9]
CzyWgDatZapl = klucze[10]
CzyWgDatOdb = klucze[11]
DataOdOdb = klucze[12]
DataDoOdb = klucze[13]
CzyNiepotwierdzone = klucze[14]
CzyZUwglTermPlat = klucze[15]
Dni = str(klucze[16])
CzyWgDatWpl = klucze[17]
DataOdWpl = klucze[18]
DataDoWpl = klucze[19]
CzyNiepotwierdzoneWpl = klucze[20]
SposWprowDatyWpl = klucze[21]
DataOdPrz = klucze[22]
DataDoPrz = klucze[23]

LStawek=[]

stat = "OK"
dane = []

if DataOd=='    -  -  ':
    stat='Brak daty od'
    dane.append(stat)  
elif not rsglobal.SprawdzCzyToData(DataOd):
    stat='Bdna data od'
    dane.append(stat)                  

if DataDo=='    -  -  ':
    stat='Brak daty do'
    dane.append(stat)  
elif not rsglobal.SprawdzCzyToData(DataDo):
    stat='Bdna data do'
    dane.append(stat)

if DataOdPrz<>'    -  -  ':
    if not rsglobal.SprawdzCzyToData(DataOdPrz):
        stat='Bdna data od przychodu'
        dane.append(stat)
        
if DataDoPrz<>'    -  -  ':
    if not rsglobal.SprawdzCzyToData(DataDoPrz):
        stat='Bdna data do przychodu'
        dane.append(stat)

#-##############################################################################
# wydruk dla faktur i korekt
#-##############################################################################

if Dokumenty in ['Faktury','Korekty'] and stat=='OK':
    LW=[]
    UprWszystWyzn=((self.oddzial_id,'077031') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)
    
    if not UprWszystWyzn:
        #pobranie wyznacznikw dostpnych
        Lista=[self.firma_id,self.oddzial_id,self.operator_id]
        if ((self.oddzial_id,'077031') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
            Lista[1]=''
        sql = "SELECT rsf_podaj_wyznaczniki('"+str(Lista).replace("'",'"')+"','[]','None');"    
        stat,wyzn,dump,dump=self.PolSQL.Execute(sql,3)
        
        if stat=='OK':
            LW=rsglobal.rseval(wyzn[0][0])[1]
            if len(LW)>0:
                LW=str(LW)[1:-1]+",'ZASLEPKA'"
            else:
                LW="'ZASLEPKA'"
    
                      
    if not RodzSpos in ('dla wybranego', 'bez wybranego'):
        stat='Bdny rodzaj zapaty'
        dane.append(stat)  
        
    if not RodzOdbioru in ('dla wybranego', 'bez wybranego'):
        stat='Bdny rodzaj odbioru faktury'
        dane.append(stat)  
        
    if WyznacznikRejestr != '' and (not UprWszystWyzn):
        LBufWyzn=WyznacznikRejestr.split(',')
        for Wyzn in LBufWyzn:
            if not Wyzn in LW:
                stat='Brak uprawnie do wyznacznika '+Wyzn
                dane.append(stat)     
                
    if CzyWgDatOdb:
        if DataOdOdb=='    -  -  ':
            stat='Brak daty od odbioru'
            dane.append(stat)  
        elif not rsglobal.SprawdzCzyToData(DataOdOdb):
            stat='Bdna data od odbioru'
            dane.append(stat)                  
    
        if DataDoOdb=='    -  -  ':
            stat='Brak daty do odbioru'
            dane.append(stat)  
        elif not rsglobal.SprawdzCzyToData(DataDoOdb):
            stat='Bdna data do odbioru'
            dane.append(stat)  

    if CzyWgDatWpl:
        if DataOdWpl=='    -  -  ':
            stat='Brak daty od wpywu'
            dane.append(stat)  
        elif not rsglobal.SprawdzCzyToData(DataOdWpl):
            stat='Bdna data od wpywu'
            dane.append(stat)                  
    
        if DataDoWpl=='    -  -  ':
            stat='Brak daty do wpywu'
            dane.append(stat)  
        elif not rsglobal.SprawdzCzyToData(DataDoWpl):
            stat='Bdna data do wpywu'
            dane.append(stat)  
        
    if stat=='OK':
        OddzialGen=''
        sql = "SELECT generator_oddzial_id FROM rs_operatorzy WHERE operator_id="+str(self.operator_id)
        sql+=" AND NOT generator_oddzial_id IS NULL AND TRIM(generator_oddzial_id)<>'';"    
        stat,DOddzGen,dump,dump=self.PolSQL.Execute(sql,3)
        if stat=='OK':
            if len(DOddzGen)>0:
                OddzialGen=rsglobal.Dekoduj(DOddzGen[0][0])
    
    
    if stat=='OK':
        if Dokumenty=='Faktury':
            brutto='t.do_zaplaty'
            vat='t.kwota_vat'
            nettost='t.wartosc_netto'
            vatst='t.wartosc_vat'
            tabela='rs_faktury'
        else:
            brutto='t.do_zaplaty-t.do_zaplaty_p'
            vat='t.kwota_vat-t.kwota_vat_p'
            nettost='t.wartosc_netto-t.wartosc_netto_p'
            vatst='t.wartosc_vat-t.wartosc_vat_p'
            tabela='rs_korekty'
        
        WHERE=" t.firma_id='"+self.firma_id+"' AND data >= '"+DataOd+"' AND data <= '"+DataDo+"'"
        
        if CzyWgDatOdb:
            WHERE+=" AND t.data_odbioru >= '"+DataOdOdb+"' AND t.data_odbioru <= '"+DataDoOdb+"'"        
        elif CzyNiepotwierdzone:
            WHERE+=" AND t.data_odbioru IS NULL"        
        
        if CzyWgDatWpl:
            WHERE+=" AND t.data_wplywu >= '"+DataOdWpl+"' AND t.data_wplywu <= '"+DataDoWpl+"'"        
        elif CzyNiepotwierdzoneWpl:
            WHERE+=" AND t.data_wplywu IS NULL"        
        
        if DataOdPrz != '    -  -  ':
            WHERE+=" AND t.data_przychodu >= '"+DataOdPrz+"' "
        if DataDoPrz != '    -  -  ':
            WHERE+=" AND t.data_przychodu <= '"+DataDoPrz+"' "
        
        WFAKT=""
        WHRWPL=""
        if WyznacznikRejestr <>'':
            WyznacznikRejestr=WyznacznikRejestr.replace(",","','")
            WHERE +=" AND t.wyznacznik_id IN('"+WyznacznikRejestr+"')"
            WHRWPL=" AND f.wyznacznik_id IN ('"+WyznacznikRejestr+"')"
        elif not UprWszystWyzn:
            WHERE +=" AND t.wyznacznik_id in ("+str(LW)+")"
            WHRWPL +=" AND f.wyznacznik_id in ("+str(LW)+")"
        
        if SposZapl != '':
            if RodzSpos=='dla wybranego':
                WFAKT +=" AND t.sposob_zaplaty='"+SposZapl+"'"
                WHRWPL +=" AND f.sposob_zaplaty='"+SposZapl+"'"
            else:
                WFAKT +=" AND t.sposob_zaplaty != '"+SposZapl+"'"
                WHRWPL +=" AND f.sposob_zaplaty != '"+SposZapl+"'"
                
        if SposOdbioru != '':
            if RodzOdbioru=='dla wybranego':
                WFAKT +=" AND t.sposob_odbioru_faktury='"+SposOdbioru+"'"
                WHRWPL +=" AND f.sposob_odbioru_faktury='"+SposOdbioru+"'"
            else:
                WFAKT +=" AND t.sposob_odbioru_faktury != '"+SposOdbioru+"'"
                WHRWPL +=" AND f.sposob_odbioru_faktury != '"+SposOdbioru+"'"
    
        if Oddzial <>'':
            WFAKT+=" AND t.oddzial_id='"+Oddzial+"'"            
            WHRWPL +=" AND f.oddzial_id = '"+Oddzial+"'"
            
        if OddzialGen<>'':
            WFAKT+=" AND t.oddzial_id='"+OddzialGen+"'"            
            WHRWPL +=" AND f.oddzial_id = '"+OddzialGen+"'"

        if Platnik <>'':
            WFAKT+=" AND t.platnik_id='"+Platnik+"'"            
            WHRWPL +=" AND f.platnik_id = '"+Platnik+"'"

        if tabela=='rs_korekty':
            if SposWprowDatyWpl<>'':
                WFAKT+=" AND POSITION(t.data_sposob IN '"+SposWprowDatyWpl+"')>0"            
                WHRWPL+=" AND POSITION(ko.data_sposob IN '"+SposWprowDatyWpl+"')>0"            
                
        if Dokumenty in ['Faktury','Korekty'] and CzyZUwglTermPlat:
            #wydruk rejestru - z uwzgldnieniem terminu patnoci (% dni)
            #czymy faktury i korekty z zalegociami
            DataDni="COALESCE(f.data_przychodu,ko.data_przychodu)+integer '"+Dni+"'-integer '1'"
            
            SQL="SELECT DISTINCT z.wyznacznik_id,z.data,z.numer::TEXT,k.nip,k.nazwa,k.adr_kod,k.adr_miej,k.adr_ulica,k.adr_nry," # 0-8
            SQL+=" COALESCE(f.do_zaplaty,ko.do_zaplaty),COALESCE(f.kwota_vat,ko.kwota_vat),COALESCE(f.numer_z_rs,ko.numer_z_rs),"# 9-11
            SQL+=" COALESCE(f.data_odbioru::TEXT,ko.data_odbioru::TEXT,'          '),z.typ_dok,z.numer," # 12-14
            SQL+=" rsf_podaj_numer_dokumentu_na_wydruk('"+self.firma_id+"','[\"'||z.wyznacznik_id||'\",\"'||z.data||'\",'||z.numer||']',z.typ_dok)," # 15
            if Dokumenty=='Korekty':
                SQL+="COALESCE(ko.data_wplywu::TEXT,''),data_sposob," # 16-17
            else:
                SQL+="'',''," # 16-17
            SQL+=" t.data_przychodu " # 18
            SQL+=" FROM rs_zaleglosci z LEFT OUTER JOIN rs_faktury f ON (z.firma_id=f.firma_id AND z.wyznacznik_id=f.wyznacznik_id"
            SQL+=" AND z.data=f.data AND z.numer=f.numer)"
            SQL+=" LEFT OUTER JOIN rs_korekty ko ON (z.firma_id=ko.firma_id AND z.wyznacznik_id=ko.wyznacznik_id"
            SQL+=" AND z.data=ko.data AND z.numer=ko.numer)"
            # SQL+=" LEFT OUTER JOIN rs_kontrahenci k ON (f.firma_id=k.firma_id AND f.kontrahent_id=k.kontrahent_id) "
            SQL+=" LEFT OUTER JOIN rs_kontrahenci k ON (f.firma_id=k.firma_id AND f.platnik_id=k.kontrahent_id) "  #JR (13208) zmiana z kontrahenta na platnika
            SQL+=" LEFT OUTER JOIN rs_wyznaczniki w  ON (f.firma_id=w.firma_id AND f.wyznacznik_id=w.wyznacznik_id) "
            SQL+=" WHERE z.firma_id='"+self.firma_id+"' "+WHRWPL
            #cay warunek na date rozliczenia itp
            SQL+=" AND CASE WHEN (z.ureg_data IS NULL OR z.ureg_data>'"+DataDo+"')"
            #pierwszy warunek z zagadnienia 2289
            SQL+=" THEN ("+DataDni+">='"+DataOd+"' AND "+DataDni+"<='"+DataDo+"')"
            #drugi warunek z zagadnienia 2289
            SQL+=" ELSE (z.ureg_data>='"+DataOd+"' AND z.ureg_data<='"+DataDo+"' AND "+DataDni+">='"+DataOd+"') END"
            SQL+=" AND rodzaj='Z' AND w.typ_faktury<>'RR' ORDER BY z.wyznacznik_id,z.data,z.numer;"
            
        elif Dokumenty=='Faktury' and CzyWgDatZapl:
            SQL="SELECT DISTINCT f.wyznacznik_id,f.data,CAST(f.numer AS TEXT),k.nip,k.nazwa,k.adr_kod,k.adr_miej,k.adr_ulica,k.adr_nry," #0-8
            SQL+=" f.do_zaplaty,f.kwota_vat,f.numer_z_rs,COALESCE(CAST (f.data_odbioru AS TEXT),'          '),'F',f.numer," # 9 - 14
            SQL+=" rsf_podaj_numer_dokumentu_na_wydruk('"+self.firma_id+"','[\"'||f.wyznacznik_id||'\",\"'||f.data||'\",'||f.numer||']','F')," # 15
            SQL+=" '',''," # 16-17
            SQL+=" t.data_przychodu " # 18
            SQL+=" FROM rs_zaleglosci z INNER JOIN rs_faktury f ON (z.firma_id=f.firma_id AND z.wyznacznik_id=f.wyznacznik_id"
            SQL+=" AND z.data=f.data AND z.numer=f.numer)"
            #SQL+=" LEFT OUTER JOIN rs_kontrahenci k ON (f.firma_id=k.firma_id AND f.kontrahent_id=k.kontrahent_id) "
            SQL+=" LEFT OUTER JOIN rs_kontrahenci k ON (f.firma_id=k.firma_id AND f.platnik_id=k.kontrahent_id) "  #JR (13208) zmiana z kontrahenta na platnika
            SQL+=" LEFT OUTER JOIN rs_wyznaczniki w  ON (f.firma_id=w.firma_id AND f.wyznacznik_id=w.wyznacznik_id) "
            SQL+=" WHERE z.firma_id='"+self.firma_id+"' AND z.ureg_data>='"+DataOd+"' AND z.ureg_data<='"+DataDo+"' "+WHRWPL
            SQL+=" AND f.stan in ('Z','K') AND rodzaj='Z' AND w.typ_faktury<>'RR' ORDER BY f.wyznacznik_id,f.data,f.numer;"
        else:
            SQL="SELECT t.wyznacznik_id,t.data,CAST(t.numer AS TEXT),k.nip,k.nazwa,k.adr_kod,k.adr_miej,k.adr_ulica,k.adr_nry,"+brutto+","+vat+"," # 0-10
            SQL+=" t.numer_z_rs,COALESCE(CAST (t.data_odbioru AS TEXT),'          '),'"+Dokumenty[0]+"',t.numer," # 11-14
            SQL+=" rsf_podaj_numer_dokumentu_na_wydruk('"+self.firma_id+"','[\"'||t.wyznacznik_id||'\",\"'||t.data||'\",'||t.numer||']','"+Dokumenty[0]+"')," # 15
            if Dokumenty=='Korekty':
                SQL+="COALESCE(t.data_wplywu::TEXT,''),data_sposob," # 16-17
            else:
                SQL+="'',''," # 16-17
            SQL+=" t.data_przychodu " # 18
            #SQL+=" FROM "+tabela+" t LEFT OUTER JOIN rs_kontrahenci k ON (t.firma_id=k.firma_id AND t.kontrahent_id=k.kontrahent_id) "
            SQL+=" FROM "+tabela+" t LEFT OUTER JOIN rs_kontrahenci k ON (t.firma_id=k.firma_id AND t.platnik_id=k.kontrahent_id) "
            SQL+=" LEFT OUTER JOIN rs_wyznaczniki w  ON (t.firma_id=w.firma_id AND t.wyznacznik_id=w.wyznacznik_id) "
            SQL+=" WHERE "+WHERE+WFAKT+" AND t.stan in ('Z','K') AND t.wyznacznik_id<>'NO' AND w.typ_faktury<>'RR'"
            SQL+=" ORDER BY t.wyznacznik_id,t.data,t.numer;"

        stat,daneN,dump,dump = self.PolSQL.Execute(SQL,3)        
        daneprzed=[]
        dane=[]
        
        
        for fakt in daneN:
            SDaneSt={}
            rsglobal.ZapiszDoLogow(str(fakt),5)
            #dla kadej faktury generujemy rekord (wyznacznik,data,numer,nip,kontr,kod,miejscowosc,ulica,nr,brutto,vat, numer z rs,data odbioru,typ F/K, numer na wydruk,data wpywu, sposb daty,sownik wartoci stawek)
            
            Linia=[fakt[0],fakt[1],fakt[2],fakt[3],fakt[4],fakt[5],fakt[6],fakt[7],fakt[8],fakt[9],round(fakt[10],2),fakt[11],fakt[12],fakt[13],fakt[15],fakt[16],fakt[17],fakt[18],{}]

            #pobranie stawek vat
            SQL="SELECT t.stawka_vat,"+nettost+","+vatst+" FROM "+tabela+"_vat t"
            SQL+=" WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+rsglobal.Dekoduj(fakt[0])+"' AND data='"+rsglobal.Dekoduj(fakt[1])+"' AND numer="+rsglobal.Dekoduj(str(fakt[2]))+" ORDER BY t.wyznacznik_id,t.data,t.numer;"
            #rsglobal.ZapiszDoLogow("SQL "+SQL,1)
            stat,daneST,dump,dump = self.PolSQL.Execute(SQL,3)        
            
            for st in daneST:
                if st[0] in self.ListaStawekZn:
                    Stawka=(1,st[0])
                else:
                    Stawka=(2,st[0]) 
                if not Stawka in LStawek:
                    LStawek.append(Stawka) 
            
                SDaneSt[Stawka]=[st[1],st[2]]
            
                Linia[-1]=eval(str(SDaneSt))
            daneprzed.append(Linia)

    # gdy ju znamy wszystkie stawki to jeszcze przebiegamy dane i "rozcigamy je" o kolumny ze stawkami
    LStawek.sort()
    LStawek.reverse()
    for l in daneprzed:
        SDaneSt=l[-1]
        linia=eval(str(l[:-1]))
        
        for st in LStawek:
            if st in SDaneSt:
                linia+=[SDaneSt[st][0],SDaneSt[st][1]]
            else:
                linia+=[0,0]
        dane.append(linia)
            

#-##############################################################################
# wydruk dla dowodow ksiegowych
#-##############################################################################

elif Dokumenty=='Dowody ksigowe' and stat=='OK':
    if WyznacznikRejestr=='':
        stat='Brak rejestru'
        dane.append(stat)  

    #--- sprawdzenie czy jest pomijanie nazwy w okresach miesicach
    if stat=='OK':
        Rok=DataOd[:4]
        Mc=DataOd[5:7]
        OrderByNazwa=",dk.nazwa_id"
        
        sql="SELECT numerowanie_pomijac_nazwe FROM rs_definicje_okresow_miesiace WHERE firma_id='"+self.firma_id+"'"
        sql+=" AND okres_id='"+self.okres_id+"' AND rok='"+Rok+"' AND miesiac='"+Mc+"';"
        stat,TestNr,dump,dump = self.PolSQL.Execute(sql,3)        
    if stat=='OK':
        if len(TestNr)>0:
            if TestNr[0][0]:    
                OrderByNazwa=""

        #przerobienie rejestrw
        WyznacznikRejestr=WyznacznikRejestr.replace(',',"','")

    if stat=='OK':
        # pobranie uywanych stawek VAT
        SQL ="SELECT DISTINCT dkp.stawka_vat_ma FROM rs_dowody_ksiegowe dk"
        SQL+=" INNER JOIN rs_dowody_ksiegowe_pozycje dkp USING (firma_id,dowod_id,nazwa_id,data,numer)"
	SQL+=" INNER JOIN rs_rejestry_vat rv ON (dk.firma_id=rv.firma_id AND dk.rejestr=rv.kod) "
        SQL+=" WHERE dk.firma_id='"+self.firma_id+"' AND COALESCE(dk.data_rejestru,dk.data) >= '"+DataOd+"' "
        SQL+=" AND COALESCE(dk.data_rejestru,dk.data) <= '"+DataDo+"' AND dk.rejestr IN ('"+WyznacznikRejestr+"')"
        SQL+=" AND NOT dkp.zamkniecie_kregu AND dk.stan='Z' AND NOT dkp.stawka_vat_ma IS NULL AND rv.typ='S';"
        stat,DaneST,dump,dump = self.PolSQL.Execute(SQL,3)                
    if stat=='OK':
        LStawek=[]
        for st in DaneST:
            if st[0] in self.ListaStawekZn:
                LStawek.append((1,st[0])) 
            else:
                LStawek.append((2,st[0])) 
        LStawek.sort()
        LStawek.reverse()
        
    #pobranie waciwych danych
    # rekord (wyznacznik -> nr dowodu,data - zaslepka,numer -zaslepka,nip,kontr,kod,miejscowosc,ulica,nr,brutto,vat, numer z rs - zaslepka,data odbioru - zaslepka)
    if stat=='OK':
        SQL ="SELECT trim(dk.dowod_id)||'/'||trim(dk.nazwa_id)||'/'||dk.data||'/'||dk.numer||'|'||dk.symbol_dok,'','',k.nip,"
        SQL+="COALESCE(dkk.nazwa,k.nazwa),COALESCE(dkk.adr_kod,k.adr_kod),"
        SQL+="COALESCE(dkk.adr_miej,k.adr_miej),COALESCE(dkk.adr_ulica,k.adr_ulica),COALESCE(dkk.adr_nry,k.adr_nry),"
        SQL+="SUM(COALESCE(CASE WHEN NOT stawka_vat_ma IS NULL THEN dkp.kwota_ma ELSE 0 END,0)" # brutto 
        SQL+="+COALESCE(CASE WHEN NOT stawka_vat_ma IS NULL THEN dkp.kwota_vat_ma ELSE 0 END,0))," # brutto cd
        SQL+="SUM(COALESCE(dkp.kwota_vat_ma,0))," # vat
        SQL+="'','','','','','',''" # zalepki na kolejne pola
        # dodanie listy stawek
        for stawka in LStawek:
            SQL+=",SUM(CASE WHEN dkp.stawka_vat_ma='"+rsglobal.Dekoduj(stawka[1])+"' THEN dkp.kwota_ma ELSE 0 END)"
            SQL+=",SUM(CASE WHEN dkp.stawka_vat_ma='"+rsglobal.Dekoduj(stawka[1])+"' THEN dkp.kwota_vat_ma ELSE 0 END)"
        SQL+=" FROM rs_dowody_ksiegowe dk INNER JOIN rs_dowody_ksiegowe_pozycje dkp USING (firma_id,dowod_id,nazwa_id,data,numer)"
        SQL+=" LEFT OUTER JOIN rs_kontrahenci k ON (dk.firma_id=k.firma_id AND dk.kontrahent_id=k.kontrahent_id)"
        SQL+=" LEFT OUTER JOIN rs_dowody_ksiegowe_kontrahent dkk "
        SQL+="ON (dk.firma_id=dkk.firma_id AND dk.dowod_id=dkk.dowod_id AND dk.nazwa_id=dkk.nazwa_id AND dk.data=dkk.data AND dk.numer=dkk.numer)"
    	SQL+=" INNER JOIN rs_rejestry_vat rv ON (dk.firma_id=rv.firma_id AND dk.rejestr=rv.kod) "
        SQL+=" WHERE dk.firma_id='"+self.firma_id+"' AND COALESCE(dk.data_rejestru,dk.data) >= '"+DataOd+"' "
        SQL+=" AND COALESCE(dk.data_rejestru,dk.data) <= '"+DataDo+"' AND dk.rejestr IN ('"+WyznacznikRejestr+"') AND rv.typ='S'"
        SQL+=" AND NOT dkp.zamkniecie_kregu AND dk.stan='Z'"
        SQL+=" GROUP BY dk.dowod_id,dk.nazwa_id,dk.data,dk.numer,dk.symbol_dok,dk.rejestr,dk.kwota_wn,"
        SQL+="k.kontrahent_id,k.nazwa,k.nip,k.adr_kod,k.adr_miej,k.adr_ulica,k.adr_nry,"
        SQL+="dkk.nazwa,dkk.nip,dkk.adr_kod,dkk.adr_miej,dkk.adr_ulica,dkk.adr_nry,dk.data_wyst,dk.data_rejestru"
        
        SQL+=" ORDER BY dk.data,dk.dowod_id"+OrderByNazwa+",dk.numer;"
        stat,dane,dump,dump = self.PolSQL.Execute(SQL,3)        

elif stat=='OK':
    stat=u'Bdny dokument' 
    
wyn2=LStawek