# -*- coding: iso8859_2 -*-
#-----------------------------------------------------------------------------
# Name:        fs_wydruki_rejestr_vat_sumy.py
# Purpose:      
# Author:      Dariusz Boduch
# Created:     2009/01/21
# RCS-ID:      $Id: fs_wydruki_rejestr_vat_sumy.py $
# Copyright:   (c) 2004-2008 Record System
# Licence:     GNU GPL
#-----------------------------------------------------------------------------

#klucze= Dokumenty,DataOd,DataDo,Oddzial,Wyznacznik,SposZapl,RodzSpos,SposOdbioru,RodzOdbioru,CzyWgDatZaplaty,CzyWgDatOdbioru, DataOdOdbioru,
#        DataDoOdbioru, CzyNiepotwierdzone

#2009.01.27 Micha Raburski  (1446) wyrzucenie filtrowania po oddziale z raportu 
#2009.02.02 Micha Raburski  (1446) wyrzucenie filtrowania po oddziale z raportu  cd
#2012.06.13 Micha Raburski  (5794) data wpywu
Dokumenty = klucze[0]
DataOd = klucze[1]
DataDo = klucze[2]
Oddzial = klucze[3]
Platnik = klucze[4]
Wyznacznik = klucze[5]
SposZapl = klucze[6]
RodzSpos = klucze[7]
SposOdbioru = klucze[8]
RodzOdbioru = klucze[9]
CzyWgDatZapl = klucze[10]
CzyWgDatOdb = klucze[11]
DataOdOdb = klucze[12]
DataDoOdb = klucze[13]
CzyNiepotwierdzone = klucze[14]
CzyWgDatWpl = klucze[15]
DataOdWpl = klucze[16]
DataDoWpl = klucze[17]
CzyNiepotwierdzoneWpl = klucze[18]
SposWprowDatyWpl = klucze[19]
DataOdPrz = klucze[20]
DataDoPrz = klucze[21]

LStawek=[]

stat = "OK"
dane = []

#pobranie wyznacznikw dostpnych

LW=[]

UprWszystWyzn=((self.oddzial_id,'077031') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)

if not UprWszystWyzn:
    Lista=[self.firma_id,self.oddzial_id,self.operator_id]

    sql = "SELECT rsf_podaj_wyznaczniki('"+str(Lista).replace("'",'"')+"','[]','None');"    
    stat,wyzn,dump,dump=self.PolSQL.Execute(sql,3)

    if stat=='OK':
        LW=rsglobal.rseval(wyzn[0][0])[1]
        if len(LW)>0:
            LW=str(LW)[1:-1]+",'ZASLEPKA'"
        else:
            LW="'ZASLEPKA'"

#sprawdzenie poprawnosci kluczy
if not Dokumenty in ('Faktury', 'Korekty'):
    stat='Bedny dokument'
    dane.append(stat)  
    
if DataOd=='    -  -  ':
    stat='Brak daty od'
    dane.append(stat)  
else:
    if not rsglobal.SprawdzCzyToData(DataOd):
        stat='Bdna data od'
        dane.append(stat)                  

if DataDo=='    -  -  ':
    stat='Brak daty do'
    dane.append(stat)  
else:
    if not rsglobal.SprawdzCzyToData(DataDo):
        stat='Bdna data do'
        dane.append(stat)                  

if DataOd<>'    -  -  ' and DataDo <>'    -  -  ':
    if DataDo<DataOd:
        stat='Niepoprawny zakres dat'
        dane.append(stat)  

if not RodzSpos in ('dla wybranego', 'bez wybranego'):
    stat='Bdny rodzaj zapaty'
    dane.append(stat)  
    
if not RodzOdbioru in ('dla wybranego', 'bez wybranego'):
    stat='Bdny rodzaj odbioru faktury'
    dane.append(stat)  
    
if Wyznacznik <> '' and (not UprWszystWyzn):
    LBufWyzn=Wyznacznik.split(',')
    for Wyzn in LBufWyzn:
        if not Wyzn in LW:
            stat='Brak uprawnie do wyznacznika '+Wyzn
            dane.append(stat)                  

if CzyWgDatOdb:
    if DataOdOdb=='    -  -  ':
        stat='Brak daty od odbioru'
        dane.append(stat)  
    elif not rsglobal.SprawdzCzyToData(DataOdOdb):
        stat='Bdna data od odbioru'
        dane.append(stat)                  

    if DataDoOdb=='    -  -  ':
        stat='Brak daty do odbioru'
        dane.append(stat)  
    elif not rsglobal.SprawdzCzyToData(DataDoOdb):
        stat='Bdna data do odbioru'
        dane.append(stat)  
    
if CzyWgDatWpl:
    if DataOdWpl=='    -  -  ':
        stat='Brak daty od wpywu'
        dane.append(stat)  
    elif not rsglobal.SprawdzCzyToData(DataOdWpl):
        stat='Bdna data od wpywu'
        dane.append(stat)                  

    if DataDoWpl=='    -  -  ':
        stat='Brak daty do wpywu'
        dane.append(stat)  
    elif not rsglobal.SprawdzCzyToData(DataDoWpl):
        stat='Bdna data do wpywu'
        dane.append(stat)  
        
if DataOdPrz<>'    -  -  ':
    if not rsglobal.SprawdzCzyToData(DataOdPrz):
        stat='Bdna data od przychodu'
        dane.append(stat)
        
if DataDoPrz<>'    -  -  ':
    if not rsglobal.SprawdzCzyToData(DataDoPrz):
        stat='Bdna data do przychodu'
        dane.append(stat)

if stat=='OK':
    OddzialGen=''
    sql = "SELECT generator_oddzial_id FROM rs_operatorzy WHERE operator_id="+str(self.operator_id)
    sql+=" AND NOT generator_oddzial_id IS NULL AND TRIM(generator_oddzial_id)<>'';"    
    stat,DOddzGen,dump,dump=self.PolSQL.Execute(sql,3)
    if stat=='OK':
        if len(DOddzGen)>0:
            OddzialGen=rsglobal.Dekoduj(DOddzGen[0][0])
            
if stat=='OK':
    if Dokumenty=='Faktury':
        brutto='tv.do_zaplaty'
        vat='tv.kwota_vat'
        nettost='tv.wartosc_netto'
        vatst='tv.wartosc_vat'
        tabela='rs_faktury'
    else:
        brutto='tv.do_zaplaty-tv.do_zaplaty_p'
        vat='tv.kwota_vat-tv.kwota_vat_p'
        nettost='tv.wartosc_netto-tv.wartosc_netto_p'
        vatst='tv.wartosc_vat-tv.wartosc_vat_p'
        tabela='rs_korekty'
    
    WHERE=" t.firma_id='"+self.firma_id+"' AND t.data >= '"+DataOd+"' AND t.data <= '"+DataDo+"'"
    
    if CzyWgDatOdb:
        WHERE+=" AND t.data_odbioru >= '"+DataOdOdb+"' AND t.data_odbioru <= '"+DataDoOdb+"'"        
    elif CzyNiepotwierdzone:
        WHERE+=" AND t.data_odbioru IS NULL"        
    
    if CzyWgDatWpl:
        WHERE+=" AND t.data_wplywu >= '"+DataOdWpl+"' AND t.data_wplywu <= '"+DataDoWpl+"'"        
    elif CzyNiepotwierdzoneWpl:
        WHERE+=" AND t.data_wplywu IS NULL"        
    
    if DataOdPrz <> '    -  -  ':
        WHERE+=" AND t.data_przychodu >= '"+DataOdPrz+"' "
    if DataDoPrz <> '    -  -  ':
        WHERE+=" AND t.data_przychodu <= '"+DataDoPrz+"' "
    
    WFAKT=""
    WHRWPL=""
    if Wyznacznik <>'':
        Wyznacznik=Wyznacznik.replace(",","','")
        WHERE +=" AND t.wyznacznik_id IN('"+Wyznacznik+"')"
        WHRWPL+=" AND f.wyznacznik_id IN ('"+Wyznacznik+"')"
    elif not UprWszystWyzn:
        WHERE +=" AND t.wyznacznik_id in ("+str(LW)+")"
        WHRWPL +=" AND f.wyznacznik_id in ("+str(LW)+")"
    
    if SposZapl <> '':
        if RodzSpos=='dla wybranego':
            WFAKT +=" AND t.sposob_zaplaty='"+SposZapl+"'"
            WHRWPL +=" AND f.sposob_zaplaty='"+SposZapl+"'"
        else:
            WFAKT +=" AND t.sposob_zaplaty <> '"+SposZapl+"'"
            WHRWPL +=" AND f.sposob_zaplaty <> '"+SposZapl+"'"
            
    if SposOdbioru <> '':
        if RodzOdbioru=='dla wybranego':
            WFAKT +=" AND t.sposob_odbioru_faktury='"+SposOdbioru+"'"
            WHRWPL +=" AND f.sposob_odbioru_faktury='"+SposOdbioru+"'"
        else:
            WFAKT +=" AND t.sposob_odbioru_faktury <> '"+SposOdbioru+"'"
            WHRWPL +=" AND f.sposob_odbioru_faktury <> '"+SposOdbioru+"'"

    if Oddzial <>'':
        WFAKT+=" AND t.oddzial_id='"+Oddzial+"'"            
        WHRWPL +=" AND f.oddzial_id = '"+Oddzial+"'"
    if OddzialGen<>'':
        WFAKT+=" AND t.oddzial_id='"+OddzialGen+"'"            
        WHRWPL +=" AND f.oddzial_id = '"+OddzialGen+"'"

    if Platnik <>'':
        WFAKT+=" AND t.platnik_id='"+Platnik+"'"            
        WHRWPL +=" AND f.platnik_id = '"+Platnik+"'"

    if tabela=='rs_korekty':
        if SposWprowDatyWpl<>'':
            WFAKT+=" AND POSITION(t.data_sposob IN '"+SposWprowDatyWpl+"')>0"            
   
    if Dokumenty=='Faktury' and CzyWgDatZapl:
        SQL="SELECT f.wyznacznik_id, w.opis"
        SQL+=" FROM rs_zaleglosci z INNER JOIN rs_faktury f ON (z.firma_id=f.firma_id AND z.wyznacznik_id=f.wyznacznik_id AND z.data=f.data AND z.numer=f.numer)"
        SQL+=" LEFT OUTER JOIN rs_wyznaczniki w  ON (f.firma_id=w.firma_id AND f.wyznacznik_id=w.wyznacznik_id)" 
        SQL+=" WHERE z.firma_id='"+self.firma_id+"' AND z.ureg_data>='"+DataOd+"' AND z.ureg_data<='"+DataDo+"' "
        SQL+= WHRWPL+" AND f.stan in ('Z','K') and rodzaj='Z' AND w.typ_faktury<>'RR' AND w.drukowac_w_sumach "
        SQL+=" GROUP BY f.wyznacznik_id, w.opis ORDER BY f.wyznacznik_id;"
    else:
        SQL="SELECT t.wyznacznik_id, w.opis"
        SQL+=" FROM "+tabela+" t LEFT OUTER JOIN rs_wyznaczniki w USING (firma_id, wyznacznik_id) "  
        SQL+=" WHERE "+WHERE+WFAKT+" AND t.stan in ('Z','K') AND t.wyznacznik_id<>'NO'"
        SQL+=" AND w.typ_faktury<>'RR' AND w.drukowac_w_sumach GROUP BY t.wyznacznik_id, w.opis "
        SQL+=" ORDER BY t.wyznacznik_id;"
    rsglobal.ZapiszDoLogow(SQL,5)
    stat,daneN,dump,dump = self.PolSQL.Execute(SQL,3)    
    if stat<>'OK':
        stat=u'Bd pobierania danych z dokumentw'
        dane.append(stat)
       
if stat=='OK': 
    daneprzed=[]
    dane=[]
    for wyzn in daneN:
        if stat=='OK':
            #dla kadego wyznacznika generujemy rekord (wyznacznik,nazwa,listastawek)
            # potem t liste rozcigamy wzgldem stawek ktre wystpi na raporcie

            SDaneSt={}
            Linia=[wyzn[0],wyzn[1],{}]
            #pobranie sum stawek vat
            SQL="SELECT t.wyznacznik_id,tv.stawka_vat,sum("+nettost+"),sum("+vatst+") FROM "+tabela+"_vat tv "
            SQL+="INNER JOIN "+tabela+" t USING (firma_id,wyznacznik_id, data,numer)"
            SQL+=" WHERE tv.wyznacznik_id='"+rsglobal.Dekoduj(wyzn[0])+"' AND "+WHERE+WFAKT
            SQL+=" AND t.stan in ('Z','K')  GROUP BY t.wyznacznik_id, tv.stawka_vat ORDER BY t.wyznacznik_id;"
            stat,daneST,dump,dump = self.PolSQL.Execute(SQL,3)        
        if stat<>'OK':
            stat=u'Bd pobierania danych VAT'
            dane.append(stat)
        
        if stat=='OK':    
            for st in daneST:
                if st[1] in self.ListaStawekZn:
                    Stawka=(1,st[1])
                else:
                    Stawka=(2,st[1]) 
                if not Stawka in LStawek:
                    LStawek.append(Stawka) 
            
                SDaneSt[Stawka]=[st[2],st[3]]
                Linia[-1]=eval(str(SDaneSt))
                
            daneprzed.append(Linia)

    # gdy ju znamy wszystkie stawki to jeszcze przebiegamy dane i "rozcigamy je" o kolumny ze stawkami
    LStawek.sort()
    LStawek.reverse()
    for l in daneprzed:
        SDaneSt=l[-1]
        linia=eval(str(l[:-1]))
        
        for st in LStawek:
            if st in SDaneSt:
                linia+=[SDaneSt[st][0],SDaneSt[st][1]]
            else:
                linia+=[0,0]
        dane.append(linia)
        
    wyn2=LStawek