# -*- coding: iso8859_2 -*-
#-----------------------------------------------------------------------------
# Name:        fs_wydruki_sumy_ceny_detaliczne_dostaw
# Purpose:     Pobranie danych do zestawienia dostaw/zwrotw do sklepw firmowych w cenach detalicznych
# Author:      Micha Raburski
# Created:     2011/01/28
# RCS-ID:      $Id: fs_wydruki_sumy_ceny_detaliczne_dostaw.py $
# Copyright:   (c) 2011 Record System
# Licence:     GNU GPL
#-----------------------------------------------------------------------------

#klucze= dataod,datado,czydostawy
DataOd=klucze[0]
DataDo=klucze[1]
CzyDostawy=klucze[2]

stat = "OK"
dane = []

if CzyDostawy:
    Ilosc='ilosc_dost1'
else:
    Ilosc='ilosc_zwr1'
WersjaDet="rsf_podaj_pole_z_danych_do_fakturowania(k.firma_id,k.kontrahent_id,dp.data,'wersja_detaliczna')"
CenaDet="rsf_podaj_cene_dla_kontrahenta(dp.firma_id, '', 'PLN',dp.data::TEXT, dp.artykul_id,'b1',"
CenaDet+="rsf_podaj_pole_z_danych_do_fakturowania(k.firma_id,k.kontrahent_id,dp.data,'wersja_detaliczna') , 0)"
WspolStawki="100/(100+CASE WHEN dp.stawka_vat IN ("+str(self.ListaStawekZn)[1:-1]+") THEN 0 ELSE dp.stawka_vat::INT END)"

SQL= "SELECT k.kontrahent_id,k.nazwa,SUM(ROUND("+Ilosc+"*"+CenaDet+",2)),"
SQL+="SUM(CASE WHEN dp.stawka_vat='05' THEN ROUND("+Ilosc+"*"+CenaDet+",2) ELSE 0 END), "
SQL+="SUM(CASE WHEN dp.stawka_vat='08' THEN ROUND("+Ilosc+"*"+CenaDet+",2) ELSE 0 END), "
SQL+="SUM(CASE WHEN dp.stawka_vat='23' THEN ROUND("+Ilosc+"*"+CenaDet+",2) ELSE 0 END), "
SQL+="SUM(ROUND("+Ilosc+"*dp.cena_upust1,2)), "
SQL+="SUM(CASE WHEN dp.stawka_vat='05' THEN ROUND(("+Ilosc+"*"+CenaDet+")-("+Ilosc+"*"+CenaDet+"*"+WspolStawki+"),2) ELSE 0 END),"
SQL+="SUM(CASE WHEN dp.stawka_vat='08' THEN ROUND(("+Ilosc+"*"+CenaDet+")-("+Ilosc+"*"+CenaDet+"*"+WspolStawki+"),2) ELSE 0 END),"
SQL+="SUM(CASE WHEN dp.stawka_vat='23' THEN ROUND(("+Ilosc+"*"+CenaDet+")-("+Ilosc+"*"+CenaDet+"*"+WspolStawki+"),2) ELSE 0 END),"
SQL+="SUM(ROUND(("+Ilosc+"*"+CenaDet+")-("+Ilosc+"*"+CenaDet+"*"+WspolStawki+"),2))"
SQL+=" FROM rs_dowody_dostaw_pozycje dp "
SQL+=" INNER JOIN rs_dowody_dostaw dd USING (firma_id, oddzial_id, trasa, data, tryb_dostawy, numer)"
SQL+=" INNER JOIN rs_kontrahenci k ON (k.firma_id=dd.firma_id AND k.kontrahent_id=dd.kontrahent_id)"
SQL+=" WHERE dp.firma_id='"+self.firma_id+"' AND dp.oddzial_id='"+self.oddzial_id+"'"
SQL+=" AND dp.data<='"+DataDo+"' AND dp.data>='"+DataOd+"'"
SQL+=" AND LENGTH("+WersjaDet+")>0 "
SQL+=" GROUP BY k.kontrahent_id,k.nazwa ORDER BY k.kontrahent_id,k.nazwa"

stat,dane,dump,dump=self.PolSQL.Execute(SQL,3)
