# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_wydruki_sumy_opakowan_w_sumach_zamowien
# Purpose:     Pobranie danych do zestawienia sum koszy dla kontrahenta, artykuu i rzutu na dzie
# Author:      Micha Raburski
# Created:     2014/08/21
# RCS-ID:      $Id: fs_wydruki_sumy_opakowan_w_sumach_zamowien.py $
# Copyright:   (c) 2014 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------


#klucze= Oddzial,Data,Artykul,Platnik,Rzut
Oddzial=klucze[0]
Data=klucze[1]
Artykul=klucze[2]
Platnik=klucze[3]
Rzut=klucze[4]

stat = "OK"
dane = [{},'','','']

# pobranie sum - w podziale na rzuty
SQL = "SELECT 'Rzut '||td.rzut,dd.kontrahent_id,SUM(ddp.ilosc_zam1) FROM rs_dowody_dostaw_pozycje ddp"
SQL+=" INNER JOIN rs_dowody_dostaw dd USING (firma_id, oddzial_id, trasa, data, tryb_dostawy, numer)"
SQL+=" INNER JOIN rs_tryby_dostaw td ON (td.firma_id = dd.firma_id AND td.kod = dd.tryb_dostawy)"
SQL+=" WHERE ddp.firma_id='"+self.firma_id+"' AND ddp.data='"+Data+"' AND ddp.oddzial_id='"+Oddzial+"'"
SQL+=" AND ddp.artykul_id='"+Artykul+"' AND dd.platnik_id='"+Platnik+"'"
if Rzut.strip() <> '':
    SQL+=" AND td.rzut='"+Rzut+"'"
SQL+=" GROUP BY td.rzut,dd.kontrahent_id"
stat,DanePoz,dump,dump=self.PolSQL.Execute(SQL,3)

if stat=='OK':
    # pobranie pojemnoci opakowania
    SQL="SELECT ilosc1 FROM rs_artykuly_opakowania_zbiorcze WHERE firma_id='"+self.firma_id+"'"
    SQL+=" AND artykul_id='"+Artykul+"' ORDER BY opakowanie_id LIMIT 1"
    stat,DaneOpak,dump,dump=self.PolSQL.Execute(SQL,3)

if stat=='OK':
    if len(DaneOpak) == 0:
        stat = 'Brak opakowania zbiorczego dla wybranego artykuu'
        
if stat=='OK':
    IloscOpak = DaneOpak[0][0]
    SOpakowania = {}
    for poz in DanePoz:
        Rzut = poz[0]
        Pelne,Reszta = divmod(poz[2],IloscOpak)
        if Pelne > 0:
            if not (Rzut, IloscOpak) in SOpakowania:
                SOpakowania[(Rzut, IloscOpak)] = 0
            SOpakowania[(Rzut, IloscOpak)] += Pelne
            
        if Reszta > 0:
            if not (Rzut, Reszta) in SOpakowania:
                SOpakowania[(Rzut, Reszta)] = 0
            SOpakowania[(Rzut, Reszta)] += 1
    
    dane[0] = SOpakowania
    
# pobranie opisu patnika
if stat == 'OK':
    SQL= "SELECT nazwa FROM rs_kontrahenci WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+Platnik+"'"
    stat,DKontr,dump,dump=self.PolSQL.Execute(SQL,3)
    if stat == 'OK':
        if len(DKontr) == 0:
            stat = 'Brak patnika o podanym symbolu'  
            
    if stat == 'OK':
        dane[1] = DKontr[0][0]
            
# pobranie opisu oddziau
if stat == 'OK':
    SQL= "SELECT nazwa FROM rs_oddzialy WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+Oddzial+"'"
    stat,DOddz,dump,dump=self.PolSQL.Execute(SQL,3)
    if stat == 'OK':
        if len(DOddz) == 0:
            stat = 'Brak oddziau o podanym symbolu'  
            
    if stat == 'OK':
        dane[2] = DOddz[0][0]

# pobranie nazwy artykuu
if stat == 'OK':
    SQL= "SELECT nazwa FROM rs_artykuly WHERE firma_id='"+self.firma_id+"' AND artykul_id='"+Artykul+"'"
    stat,DArt,dump,dump=self.PolSQL.Execute(SQL,3)
    if stat == 'OK':
        if len(DArt) == 0:
            stat = 'Brak artykuu o podanym symbolu'  
            
    if stat == 'OK':
        dane[3] = DArt[0][0]
