# -*- coding: iso8859_2 -*-
#-----------------------------------------------------------------------------
# Name:        fs_wzory_dekretacji.py
# Purpose:     pobieranie listy wzorow dekretacji/usuwanie wzoru dekretacji 
#
# Author:      Mariusz Rajfura
# Created:     2009/07/26
# RCS-ID:      $Id: fs_wzory_dekretacji.py $
# Copyright:   (c) 2009 Record System
# Licence:     GNU GPL
#-----------------------------------------------------------------------------
# 2016-09-01 Piotr Witkowski  (9772)  dodanie warunkw przy przegldaniu jeli s upawnienia
# 2021-02-15 Wojciech Skowron (12335) sprawdzenie powiza z kasy/banki oraz dowodami ksigowymi przed usuniciem

stat = 'OK'

if not 'Funkcja' in klucze:
    stat = 'Brak podanej funkcji w kluczach'
    Funkcja = 999 #WS

if stat=='OK':
    Funkcja = klucze['Funkcja']

    SlPar = {'DowodFiltr':[1,5], 'NazwaFiltr':[1,5], 'Typ':[1,5], 'Okres':[5]}
    Lista = rsglobal.SprawdzParametryWKluczach(SlPar,Funkcja,klucze)
    if Lista <> '':
        stat = 'Uwaga : wywoanie funkcji fs_wzory_dekretacji z numerem '+str(Funkcja)+' bez parametrw: '+Lista

if stat == 'OK':
    if Funkcja in [1,5]:
        DowodF = klucze['DowodFiltr']
        NazwaF = klucze['NazwaFiltr']
        TypF   = klucze['Typ']
        Okres = self.okres_id
    if Funkcja in [5]:
        Okres = klucze['Okres']

dane = []
wyn1 = []
wyn2 = []

#uprawnienia
if not((self.oddzial_id,'074110') in self.uprawnienia) and self.operator_id <> STANDARD_OPERATOR_ID:
    stat = 'Brak uprawnie do przegldania wzorw dekretacji'

UprPrzegl   = (((self.oddzial_id,'074110') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID))
UprUsuwanie = (((self.oddzial_id,'074114') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID))

#-------------------------------------------------------------------------------
#-------- EDYCJA GRIDA EDYTOWALNEGO (1)
#-------------------------------------------------------------------------------

Delete = []

if Funkcja == 1:
    Delete=klucze['Delete']


#-------------------------------------------------------------------------------
#-------  SPRAWDZANIE DELETE  --------------------------------------------------
#-------------------------------------------------------------------------------

if Funkcja == 1 and stat == 'OK':
    if len(Delete[0])>0:
        if not UprUsuwanie:
            stat='Brak uprawnie do usuwania wzorw dekretacji.'
            dane.append(stat)


#-------------------------------------------------------------------------------
#-------  DELETE
#-------------------------------------------------------------------------------

        if stat == 'OK':
            sql = ''
            for i in xrange(len(Delete[0])):
                DELETE ="DELETE FROM rs_wzory_dekretacji "
                WHERE ="WHERE firma_id='"+self.firma_id+"' AND okres_id = '"+self.okres_id+"'"
                for j in xrange(len(Delete[0][i])):
                    pole=Delete[1][j]
                    wart=Delete[0][i][j]
                    if pole == 'dowod_id':
                        if wart in ('BO','BK'):
                            stat = 'Nie mona usuwa wzorw dekretacji dokumentw BO i BK'
                            dane.append(stat)  #WS 2021-02-15

                        WHERE+=" AND "+pole+"='"+wart+"'"
                    if pole == 'nazwa_id':
                        WHERE+=" AND "+pole+"='"+wart+"'"
                sql+=DELETE+WHERE+";"
            #WS 2021-02-15 - sprawdzenie powizanych kas/bankw
            if sql != '':
                sel = "SELECT kasa_bank_id FROM rs_kasy_banki "+WHERE
                stat, danekasybanki, dump, dump = self.PolSQL.Execute(sel,3)
                if stat != 'OK':
                    stat = u'Bd przy sprawdzaniu powizanych kas/bankw: '+stat
                    dane.append(stat)
                elif len(danekasybanki) > 0:
                    stat = u"Nie mona usun wzoru dekretacji, poniewa istniej przypisane kasy/banki: "+", ".join(d[0].strip() for d in danekasybanki)
                    dane.append(stat)
            #WS 2021-02-15 - sprawdzenie powizanych dowodw ksigowych
            if sql != '':
                sel = "SELECT data,numer FROM rs_dowody_ksiegowe "+WHERE
                stat, danedk, dump, dump = self.PolSQL.Execute(sel,3)
                if stat != 'OK':
                    stat = u'Bd przy sprawdzaniu powizanych dowodw ksigowych: '+stat
                    dane.append(stat)
                elif len(danedk) > 0:
                    stat = u"Nie mona usun, dla wzoru dekretacji istniej dowody ksigowe: "+", ".join(d[0]+'/'+str(int(d[1])) for d in danedk)
                    dane.append(stat)

            #WS 2021-02-15
            if len(dane) > 0:
                stat = dane[0]

            if sql != '' and stat == 'OK':
                rsglobal.ZapiszDoLogow(sql)
                stat,dump,dump,dump=self.PolSQL.Execute(rsglobal.Dekoduj(sql),1)
                if stat != 'OK':
                    stat=u"Bd przy usuwaniu danych: "+stat
                    dane.append(stat)
        
#-------------------------------------------------------------------------------
# Pobranie danych do grida wzorow dekretacji
#-------------------------------------------------------------------------------

if stat == 'OK' and Funkcja in (1,5):
    Filtr = ''
    if self.operator_id <> STANDARD_OPERATOR_ID:
        sql="SELECT dowod_id,nazwa_id "
        sql+="FROM rs_wzory_dekretacji_upr WHERE firma_id='"+self.firma_id+"' "
        sql+="AND operator_id in "+str(self.operatorzy).replace("[","(").replace("]",")")
        sql+=" AND okres_id='"+Okres+"' and (wprowadzanie = true or edycja =true or usuwanie=true "
        sql+="or przegladanie=true or zamykanie=true or otwieranie = true); "
        stat,daneupr,dump,dump = self.PolSQL.Execute(sql,3)
        if stat=='OK':
            if len(daneupr)>0:
                Filtr += ' AND ('
                Pierwszy = True
                for dok in daneupr:
                    if Pierwszy:
                        Pierwszy = False
                    else:
                        Filtr+=' OR '
                    Filtr+="(d.dowod_id='"+rsglobal.Dekoduj(dok[0])+"' AND d.nazwa_id='"+rsglobal.Dekoduj(dok[1])+"')"
                Filtr += ') '

    if stat =='OK':
        sql ="SELECT d.dowod_id,d.nazwa_id,d.nazwa,d.typ_wzoru FROM rs_wzory_dekretacji d "
        sql+=" WHERE d.firma_id = '"+self.firma_id+"' AND d.okres_id = '"+Okres+"'"
        if DowodF <> '':
            sql+=" AND d.dowod_id LIKE '"+DowodF+"%'"
        if NazwaF <> '':
            sql+=" AND d.nazwa_id LIKE '"+NazwaF+"%'"
        if TypF <> '':
            sql+=" AND d.typ_wzoru = '"+TypF+"'"
        sql+=Filtr
        sql+=" ORDER BY d.dowod_id,d.nazwa_id;"

        stat,dane,wyn1,dump = self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Bd pobrania listy wzorw dekretacji : '+stat