# -*- coding: iso8859_2 -*-

#-----------------------------------------------------------------------------
# Name:        fs_wzory_dekretacji_magazynow_dane.py
# Purpose:     wczytuje/edytuje dane pozycji wzoru dekretacji faktury
#
# Author:      Marcin Grzeda
# Created:     2007/02/15
# RCS-ID:      $Id: fs_wzory_dekretacji_magazynow_dane.py $
# Copyright:   (c) 2007 Record System
# Licence:     GNU GPL
#-----------------------------------------------------------------------------
# 2018-10-16 Aleksander Bargie (11260) - Wzory dekretacji - pusty string w kontrahent_id
# 2019-02-19 Wojciech Skowron  refaktoryzacja (10389) - klucze w postaci slownika zamiast listy, kontrola uprawnien wyciagnieta na poczatek
# 2019-04-16 Wojciech Skowron  refaktoryzacja (10389) - sprawdzanie bdw

stat='OK'
#WS
# Dowod=rsglobal.Dekoduj(klucze[0][0])
# Nazwa=rsglobal.Dekoduj(klucze[0][1])
# NrP=str(rsglobal.Dekoduj(klucze[1][0]))

#WS

if not 'Funkcja' in klucze:
    stat = 'Brak podanej funkcji w kluczach'
    Fun = 999

if stat == 'OK':
    Fun = klucze['Funkcja']

    SlPar = {'Dowod':[1,3,4,5], 'Nazwa':[1,3,4,5], 'NrPoz':[1,3,4,5]}
    Lista = rsglobal.SprawdzParametryWKluczach(SlPar, Fun, klucze)
    if Lista != '':
        stat = 'Uwaga : wywoanie funkcji fs_wzory_dekretacji_magazynow_dane z numerem '+str(Fun)+' bez parametrw: '+Lista

if stat == 'OK':
    Dowod = rsglobal.Dekoduj(klucze['Dowod'])
    Nazwa = rsglobal.Dekoduj(klucze['Nazwa'])
    NrPoz = rsglobal.Dekoduj(klucze['NrPoz'])

    WHERE = " WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"' AND dowod_id='"+Dowod+"' AND nazwa_id='"+Nazwa+"' AND nr_poz="+str(NrPoz) #NrP #WS

#-------------------------------------------------------------------------------
#---   KONTROLA UPRAWNIEN
#-------------------------------------------------------------------------------

#WS
if Fun in [3,4] and stat == 'OK':
    if not (((self.oddzial_id,'074122') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID):
        stat='UPR UPD'

#-------------------------------------------------------------------------------
#---   UPDATE DANYCH (4- bez pobierania,3- z pobieraniem)
#-------------------------------------------------------------------------------

#WS
if Fun in [3,4] and stat == 'OK':
# if klucze[-1] in [3,4]:
#     if (((self.oddzial_id,'074122') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID):
#     stat = "OK"
    dane = []

    #sprawdzenie danych
    for i in range(len(pola)):
        pole = pola[i]
        wart = wartosci[i]

        if pole=="wyznacznik_id":
            if wart <> "":
                sql = "SELECT wyznacznik_id FROM rs_wyznaczniki WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+wart+"';"
                #WS 2019-04-16
                stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                # dump,d,dump,dump = self.PolSQL.Execute(sql,3)
                if stat != 'OK':
                    stat = 'BL SQL WYZN'
                else:
                    if len(d)==0:
                        stat='BL WYZN'
                        dane.append(stat)

        elif pole == "konto_wn":
            if wart == "":
                stat="BR K WN"
                dane.append(stat)
            else:
                sql = "SELECT rsf_podaj_parametry_konta('"+self.firma_id+"','"+self.okres_id+"','"+wart+"');"
                #WS 2019-04-16
                stat,DaneTmp,dump,dump = self.PolSQL.Execute(sql, 3)
                # DaneTmp = self.PolSQL.Execute(sql,3)[1]
                if stat != 'OK':
                    stat = 'BL SQL K WN'
                else:
                    if (DaneTmp <> []) and (DaneTmp <> None):
                        Dane = rsglobal.rseval(DaneTmp[0][0])
                        if Dane[0] == '':
                            stat='BL K WN'
                            dane.append(stat)

        elif pole == "konto_ma":
            if wart == "":
                stat="BR K MA"
                dane.append(stat)
            else:
                sql = "SELECT rsf_podaj_parametry_konta('"+self.firma_id+"','"+self.okres_id+"','"+wart+"');"
                #WS 2019-04-16
                stat, DaneTmp, dump, dump = self.PolSQL.Execute(sql, 3)
                # DaneTmp = self.PolSQL.Execute(sql,3)[1]
                if stat != 'OK':
                    stat = 'BL SQL K MA'
                else:
                    if (DaneTmp <> []) and (DaneTmp <> None):
                        Dane = rsglobal.rseval(DaneTmp[0][0])
                        if Dane[0] == '':
                            stat='BL K MA'
                            dane.append(stat)

        elif pole == "magazyn_id":
            if wart <> "":
                sql = "SELECT magazyn_id FROM rs_magazyny WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+wart+"';"
                #WS 2019-04-16
                stat, d, dump, dump = self.PolSQL.Execute(sql, 3)
                # dump,d,dump,dump = self.PolSQL.Execute(sql,3)
                if stat != 'OK':
                    stat = 'BL SQL MAG'
                else:
                    if len(d)==0:
                        stat='BL MAG'
                        dane.append(stat)

        elif pole == "magazyn_dokad":
            if wart <> "":
                sql = "SELECT magazyn_id FROM rs_magazyny WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+wart+"';"
                #WS 2019-04-16
                stat, d, dump, dump = self.PolSQL.Execute(sql, 3)
                # dump,d,dump,dump = self.PolSQL.Execute(sql,3)
                if stat != 'OK':
                    stat = 'BL SQL MAGD'
                else:
                    if len(d)==0:
                        stat='BL MAGD'
                        dane.append(stat)

        elif pole == "kontrahent_id":
            if wart<>'':
                sql = "SELECT kontrahent_id FROM rs_kontrahenci WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+wart+"';"
                #WS 2019-04-16
                stat, d, dump, dump = self.PolSQL.Execute(sql, 3)
                # dump,d,dump,dump = self.PolSQL.Execute(sql,3)
                if stat != 'OK':
                    stat = 'BL SQL KONTR'
                else:
                    if len(d)==0:
                        stat='BL KONTR'
                        dane.append(stat)

    #Jak ok to update
    if stat=='OK':
        upd = "UPDATE rs_wzory_dekretacji_magazynow SET "
        for i in range(len(pola)):
            pole = pola[i]
            wart = wartosci[i]

            if pole in ['konto_wn','konto_ma','kontrahent_id']:
                #AB 16.10.18r
                if str(wart).strip() == '':
                    upd=upd+pole+"='NULL',"
                else:
                    upd=upd+pole+"='"+str(wart)+"',"
            elif pole in ['z_wylaczeniem','pozostali','zlecenie_wn','zlecenie_ma','konto_koszt_wn','konto_koszt_ma','magazyn_wn','magazyn_ma','magazyn_dokad_wn','magazyn_dokad_ma','projekt_wn','projekt_ma']:
                upd=upd+pole+"="+str(wart)+","
            elif pole in ['magazyn_id','magazyn_dokad','wyznacznik_id']:
                if wart=='':
                    upd=upd+pole+"=NULL,"
                else:
                    upd=upd+pole+"='"+str(wart)+"',"



        upd = upd[0:len(upd)-1]+WHERE+";"
        rsglobal.ZapiszDoLogow(upd,1)
        stat,dump,dump,dump = self.PolSQL.Execute(upd ,1)
        if stat != 'OK':
            stat = 'BL UPD'
    # else:
    #     stat='UPR UPD'

   

#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (5 -select, 3 -update z pobraniem, 1 -insert z pobraniem)
#-------------------------------------------------------------------------------

#WS
if (Fun in [5,3,1]) and (stat=='OK'):
# if (klucze[-1] in [5,3,1]) and (stat=='OK'):
    # pobranie danych kasy/banku
    stat,dane,wyn1,tr = self.PolSQL.Execute("SELECT * FROM rs_wzory_dekretacji_magazynow "+WHERE+";",3)
    if stat != 'OK':
        stat = 'BL SEL'
    else:
        # pobranie sownika
        if len(dane) == 1:
            tr = rssql.RSTableRowset(dane,wyn1)

            #--- wyznacznik
            if ((self.oddzial_id,'021000') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
                dump,d,dump,dump = self.PolSQL.Execute("SELECT opis FROM rs_wyznaczniki WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+tr.GetVal(0,"wyznacznik_id")+"';" ,3)
                if len(d) == 0:
                    wyn2.append('')
                else:
                    wyn2.append(d[0][0])
            else:
                wyn2.append('Brak uprawnie do sownika. Poinformuj administratora.')

            #--- magazyn skad
            if ((self.oddzial_id,'031010') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
                dump,d,dump,dump = self.PolSQL.Execute("SELECT opis FROM rs_magazyny WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+tr.GetVal(0,"magazyn_id")+"';" ,3)
                if len(d) == 0:
                    wyn2.append('')
                else:
                    wyn2.append(d[0][0])
            else:
                wyn2.append('Brak uprawnie do sownika. Poinformuj administratora.')

            #--- magazyn dokad
            if ((self.oddzial_id,'031010') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
                dump,d,dump,dump = self.PolSQL.Execute("SELECT opis FROM rs_magazyny WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+tr.GetVal(0,"magazyn_dokad")+"';" ,3)
                if len(d) == 0:
                    wyn2.append('')
                else:
                    wyn2.append(d[0][0])
            else:
                wyn2.append('Brak uprawnie do sownika. Poinformuj administratora.')

            #--- kontrahent
            if ((self.oddzial_id,'012010') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
                dump,d,dump,dump = self.PolSQL.Execute("SELECT nazwa FROM rs_kontrahenci WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+tr.GetVal(0,"kontrahent_id")+"';" ,3)
                if len(d) == 0:
                    wyn2.append('')
                else:
                    wyn2.append(d[0][0])
            else:
                wyn2.append('Brak uprawnie do sownika. Poinformuj administratora.')
            
        
