# -*- coding: iso8859_2 -*-

#-----------------------------------------------------------------------------
# Name:        fs_wzory_dekretacji_magazynow_typy.py
# Purpose:     edycja pozycji typow dekretacji dla wzoru dekretacji magazynu
#
# Author:      Mariusz Rajfura
# Created:     2011/07/25
# RCS-ID:      $Id: fs_wzory_dekretacji_magazynow_typy.py $
# Copyright:   (c) 2011 Record System
# Licence:     GNU GPL
#-----------------------------------------------------------------------------

# 2019-02-19 Wojciech Skowron  refaktoryzacja (10389) - klucze w postaci slownika zamiast listy
# 2019-04-16 Wojciech Skowron  refaktoryzacja (10389) - sprawdzanie bdw

stat = 'OK'

#WS
if not 'Funkcja' in klucze:
    stat = 'Brak podanej funkcji w kluczach'
    Fun = 999

if stat == 'OK':
    Fun = klucze['Funkcja']

    SlPar = {'Dowod':[1,3,4,5], 'Nazwa':[1,3,4,5], 'NrPoz':[1,3,4,5]}
    Lista = rsglobal.SprawdzParametryWKluczach(SlPar, Fun, klucze)
    if Lista != '':
        stat = 'Uwaga : wywoanie funkcji fs_wzory_dekretacji_magazynow_typy z numerem '+str(Fun)+' bez parametrw: '+Lista

if stat == 'OK':
    Dowod = rsglobal.Dekoduj(klucze['Dowod'])
    Nazwa = rsglobal.Dekoduj(klucze['Nazwa'])
    NrPoz = rsglobal.Dekoduj(klucze['NrPoz'])
# Dowod = rsglobal.Dekoduj(klucze[0][0])
# Nazwa = rsglobal.Dekoduj(klucze[0][1])
# NrPoz = rsglobal.Dekoduj(klucze[1][0])

# Fun = klucze[-1]

    WHERE = " firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"'"+\
            " AND dowod_id='"+Dowod+"' AND nazwa_id='"+Nazwa+"' AND nr_poz="+str(NrPoz)

dane = []
wyn1 = []
wyn2 = []

#-------------------------------------------------------------------------------
#--- EDYCJA (3,4)
#-------------------------------------------------------------------------------

if Fun in (3,4) and stat == 'OK':                
    for i in xrange(len(pola)):
        pole = pola[i]
        wart = wartosci[i]
        
        if pole in ['konto_mag_wn_01','konto_mag_wn_02','konto_mag_wn_03',
                    'konto_mag_wn_04','konto_mag_wn_05','konto_mag_wn_11','konto_mag_wn_12',
                    'konto_mag_wn_21','konto_mag_wn_31','konto_mag_wn_99',
                    'konto_mag_ma_01','konto_mag_ma_02','konto_mag_ma_03',
                    'konto_mag_ma_04','konto_mag_ma_05','konto_mag_ma_11','konto_mag_ma_12',
                    'konto_mag_ma_21','konto_mag_ma_31','konto_mag_ma_99']:
                        
            wart = wart.strip()
                        
            if wart <>'':
                sql = "SELECT rsf_podaj_parametry_konta('"+self.firma_id+"','"+self.okres_id+"','"+wart+"');"
                #WS 2019-04-16
                stat,DaneTmp,dump,dump = self.PolSQL.Execute(sql, 3)
                # DaneTmp = self.PolSQL.Execute(sql,3)[1]
                if stat != 'OK':
                    stat = 'BL SQL rsf_podaj_parametry_konta'
                else:
                    if (DaneTmp <> []) and (DaneTmp <> None):
                        Dane = rsglobal.rseval(DaneTmp[0][0])
                        if Dane[0] == '':
                            stat = 'BL '+pole
                            # dane.append('BL '+pole)
                    else:
                        stat = 'BL NR KONTA'
                        # dane.append('Bd sprawdzenia numeru konta')
                
    if stat == 'OK':
        if len(dane) > 0:
            stat = dane[0]

    if stat == 'OK':
        UPD = "UPDATE rs_wzory_dekretacji_magazynow SET "
        for i in xrange(len(pola)):
            pole = pola[i]
            wart = wartosci[i]
            
            if pole in ['konto_mag_wn_01','konto_mag_wn_02','konto_mag_wn_03',
                        'konto_mag_wn_04','konto_mag_wn_05','konto_mag_wn_11','konto_mag_wn_12',
                        'konto_mag_wn_21','konto_mag_wn_31','konto_mag_wn_99',
                        'konto_mag_ma_01','konto_mag_ma_02','konto_mag_ma_03',
                        'konto_mag_ma_04','konto_mag_ma_05','konto_mag_ma_11','konto_mag_ma_12',
                        'konto_mag_ma_21','konto_mag_ma_31','konto_mag_ma_99']:
                            
                UPD += pole+"='"+rsglobal.Dekoduj(wart).strip()+"',"
                
        UPD = UPD[:-1]
        UPD+= " WHERE "+WHERE
        
        stat,dump,dump,dump = self.PolSQL.Execute(UPD ,1)
        if stat <> 'OK':
            stat = 'BL UPD'
            dane.append(stat)

        
#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (5 -select, 3 -update z pobraniem, 1 -insert z pobraniem)
#-------------------------------------------------------------------------------

if Fun in (5,3,1) and stat=='OK':
    sql ="SELECT * FROM rs_wzory_dekretacji_magazynow"
    sql+=" WHERE "+WHERE+";"

    stat,dane,wyn1,dump = self.PolSQL.Execute(sql,3)
    if stat <> 'OK':
        stat = 'BL SEL'
