# -*- coding: iso8859_2 -*-
#-----------------------------------------------------------------------------
# Name:        fs_xml_intrastat.py
# Purpose:      
# Author:      Dariusz Boduch
# Created:     2008/05/06
# RCS-ID:      $Id: fs_xml_intrastat.py $
# Copyright:   (c) 2007 Record System
# Licence:     GNU GPL
#-----------------------------------------------------------------------------

#klucze= Firma,Rok,Miesiac,NrZgloszenia,NrWersji,RodzDeklaracji,WywPrzyw

Firma = klucze[0]
Rok = klucze[1]
Miesiac = klucze[2]
NrZgloszenia = klucze[3]
NrWersji = klucze[4]
RodzDeklaracji = klucze[5]
WywPrzyw = klucze[6]

stat = "OK"
dane = []

#pobieranie danych firmy:
if stat=='OK':
    Pola = "nazwa, adr_kod, adr_miej, adr_ulica, adr_nry, regon, nip "
    stat,daneF,naglF,dump = self.PolSQL.Execute("SELECT "+Pola+" FROM rs_oddzialy WHERE firma_id='"+Firma+"' AND oddzial_id='01';",3)
    if stat<>'OK':
        stat=u'Bd w pobieraniu danych oddziau'
        dane.append(stat)

#pobieranie danych nagwka i pozycji deklaracji
if stat=='OK':
    SQL="SELECT i.wypelniajacy as wypel, i.telefon as telefon, i.fax as faks, i.email as emailw," # 0-3
    SQL+=" i.email_zwrotny as emailz, i.miasto as miastow, i.data as data, i.rodzaj_deklaracji as rodz_dekl," # 4-7
    SQL+=" i.izba_celna as i_celna, i.wartosc_fakturowa as wart_fakt, i.wartosc_statystyczna as wart_stat," # 8 -10
    SQL+=" CAST(i.liczba_pozycji AS TEXT) as liczba_poz, i.nr_wlasny_intr,COALESCE(CAST(ip.nr_poz AS TEXT),'') as nrpoz, " #11-13
    SQL+=" ip.kraj_wysylki as kraj_w, ip.kraj_pochodz as kraj_p, COALESCE(ip.kod_towaru ,'') as kod_tow," # 14-16
    SQL+=" ip.warunki_dostawy as war_dost, ip.rodzaj_transportu as rodz_transp, ip.masa_netto as masa_n,ip.ilosc as ilosc," # 17-20
    SQL+=" ip.wartosc_fakturowa as wart_faktp, ip.wartosc_statystyczna as wart_statp, ip.kod_transakcji as kod_trans" #21-23
    SQL+=" FROM  rs_intrastat i LEFT OUTER JOIN rs_intrastat_pozycje ip " 
    SQL+=" ON (i.firma_id=ip.firma_id AND i.rok=ip.rok AND i.miesiac=ip.miesiac "
    SQL+=" AND i.nr_zgloszenia=ip.nr_zgloszenia AND i.nr_wersji=ip.nr_wersji "
    SQL+=" AND i.rodzaj_deklaracji=ip.rodzaj_deklaracji AND i.wywoz_przywoz=ip.wywoz_przywoz) "
    SQL+=" WHERE  i.firma_id='"+Firma+"' AND i.rok = '"+Rok+"' AND i.miesiac='"+Miesiac+"'"
    SQL+=" AND i.nr_zgloszenia='"+NrZgloszenia+"' AND i.nr_wersji='"+NrWersji+"' "
    SQL+=" AND i.rodzaj_deklaracji='"+RodzDeklaracji+"' AND i.wywoz_przywoz='"+WywPrzyw+"' "
    SQL+=" ORDER BY ip.nr_poz;"
    
    stat,daneP,naglP,dump = self.PolSQL.Execute(SQL,3)
    if stat<>'OK':
        stat=u'Bd w pobieraniu danych deklaracji'
        dane.append(stat)

#pobieranie i skadanie nazw kodw towaru
if stat=='OK':
    Nazwa=[]
    for w in daneP:
        KodTowaru=str(w[16])
        if KodTowaru == '':
            Nazwa.append([['']])
        else:
            stat,daneK,dump,dump = self.PolSQL.Execute("SELECT opis FROM rs_kody_intrastat WHERE firma_id='"+Firma+"' AND strpos('"+KodTowaru+"',kod)=1 ORDER BY length(trim(kod));",3)
            if stat<>'OK':
                stat=u'Bd w pobieraniu opisu kodu towarowego: '+KodTowaru
                dane.append(stat)
            if len(daneK)>0:
                Nazwa.append(daneK)
            else:
                Nazwa.append([['']])

#czy jednostka uzupeniajca
if stat =='OK':
    Jednostka=[]
    for w in daneP:
        KodTowaru=str(w[16])
        if KodTowaru == '':
            Jednostka.append([['']])
        else:
            stat,daneJ,dump,dump = self.PolSQL.Execute("SELECT czy_jednostka_uzup FROM rs_kody_intrastat WHERE firma_id='"+Firma+"' AND kod ='"+KodTowaru+"';",3)
            if stat<>'OK':
                stat=u'Bd w pobieraniu opisu kodu towarowego: '+KodTowaru
                dane.append(stat)
            if len(daneJ)>0:
                Jednostka.append(daneJ)
            else:
                Jednostka.append([['']])

# zebranie wszystkich danych
if stat=='OK':
    dane=str([daneF,naglF,daneP,naglP,Nazwa,Jednostka])