# -*- coding: iso8859_2 -*-
#-----------------------------------------------------------------------------
# Name:        fs_zamowienia_dostawcy_import_poz.py
# Purpose:     Importuje pozycje zamwienia do dostawcy z pliku CVS.
# Author:      Dariusz Boduch    
# Created:     2009/09/09
# RCS-ID:      $Id: s_zamowienia_dostawcy_import_poz.py $
# Copyright:   (c) 2006 Record System
# Licence:     GNU GPL
#-----------------------------------------------------------------------------

#klucz glowny zamowienia dostawcy

Wyznacznik = klucze[0][0]
Data= klucze[0][1]
Numer = klucze[0][2]

#lista z artykulami ( symbol_artykulu, ilosc zam1, cena netto )
file_data = klucze[1]

#aliasy dla dostepnych zmiennych
firma = self.firma_id
Filtr="firma_id='"+firma+"' AND wyznacznik_id='"+str(Wyznacznik)+"' AND data='"+str(Data)+"' AND numer="+str(Numer)


stat = "OK"
dane = []
lista_art = []
art_istn = []
maxNr = 0


if((self.oddzial_id,'037023') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
    stat = "OK"
else:
    stat='UPR IMPORT'
    dane.append(stat)

if stat=='OK':
    if file_data in (None,'','None'):
        stat='BL FORM'
        dane.append(stat)

if stat=='OK':
#pobranie danych z naglowka zamowienia
    sql="SELECT upust FROM rs_zamowienia_dostawcy WHERE "+Filtr+" ;"
    stat, zamdost, dump, dump = self.PolSQL.Execute( sql, 3 )
    if stat<>'OK':
        stat='BL SQL UP'
        dane.append(stat)
    elif len(zamdost)==0:
        stat='BL KLUCZ'
        dane.append(stat)
    else:
        Upust=zamdost[0][0]

if stat == 'OK':
#sprawdzenie, czy istniej pozycje w zamwieniu, pobranie ostatniego nr pozycji, listy artykulow w zamowieniu
    sql="SELECT nr_poz, artykul_id FROM rs_zamowienia_dostawcy_pozycje "
    sql+="WHERE "+Filtr
    sql+=" ORDER BY nr_poz ;"
    stat, ArtZd, dump, dump = self.PolSQL.Execute( sql, 3 )

    if stat<>'OK':
        stat="BL SQL ZAM"
        dane.append(stat)
    if len(ArtZd)>0:
        for zd in ArtZd:
            maxNr=zd[0]
            artzd=str(zd[1]).strip()
            lista_art.append(artzd)   
    
if stat == "OK":
#KONTROLA DANYCH
#sprawdzenie czy artykul jest poprawny
#pobranie pozostalych danych artykulu
#Przygotowanie danych do insertu
    INSERT=''
    for w in file_data:
        maxNr=maxNr+1
        artykul=w[0]
        ilosc1=w[1]
        cenan1=w[2]
        Artykul=str(artykul).replace('"','').strip()
        if ilosc1==0:
            stat='IL ZER$%s' %Artykul
            dane.append(stat)
        if Artykul in lista_art:
            art_istn.append(Artykul)
        lista_art.append(Artykul)
        sql = "SELECT artykul_id, przelicznik FROM rs_artykuly WHERE firma_id='"+firma+"' AND artykul_id='"+Artykul+"' AND aktywny = True ;" 
        stat, art, dump, dump = self.PolSQL.Execute( sql, 3 )
        if stat<>'OK':
            stat='BL SQL ART'
            dane.append(stat)
        elif len(art)==0:
            stat='BR ART$%s' % Artykul
            dane.append(stat)
        else:
            #przelicznik
            przel=art[0][1]
        
        #skadanie insertu dla pozycji
        INSQL="INSERT INTO rs_zamowienia_dostawcy_pozycje (firma_id, wyznacznik_id,data,numer, nr_poz,artykul_id "
        INSQL+=",cena_netto1,cena_netto2,ilosc1,ilosc2 "
        INSQL+=",cena_upust1,cena_upust2,upust_wartosc,wartosc_netto ) "
        INSQL+="VALUES ( '"+str(firma)+"', '"+str(Wyznacznik)+"', '"+str(Data)+"', "+str(Numer)+", "+str(maxNr)+",'"+str(Artykul)+"'"
        INSQL+=",round("+str(cenan1)+",2),round("+str(cenan1/przel)+",2),round("+str(ilosc1)+",2),round("+str(ilosc1*przel)+",2)"
        INSQL+=",round("+str(cenan1)+",2),round("+str(cenan1/przel)+",2), round("+str(cenan1*ilosc1)+",2),round("+str(cenan1*ilosc1)+",2)); "
        
        INSERT=INSERT+INSQL
if stat=='OK' and dane==[]:
    stat,dump,dump,dump = self.PolSQL.Execute(INSERT, 1)
    if stat<>'OK':
        stat='BL SQL'
        dane.append(stat)
        
#lista artykulow powtarzajacych sie (zwracana jako komunikat)
if len(art_istn)>0 and stat=='OK':
    Lista_index=[]
    for d in art_istn:
        ArtIst=str(d)
        if ArtIst not in Lista_index:
            Txt='ART ISTN$%s' % ArtIst
            dane.append(Txt)
        Lista_index.append(ArtIst) 