# -*- coding: iso8859_2 -*-
#-----------------------------------------------------------------------------
# Name:        fs_zamowienia_dostawcy_pliki_dane.py
# Purpose:     zapis danych pliku zamwie dostawcy
# Author:      Wojciech Skowron
# Created:     2021/06/10
# RCS-ID:      $Id: fs_zamowienia_dostawcy_pliki_dane.py $
# Copyright:   (c) 2021 Record System
# Licence:     GNU GPL
#-----------------------------------------------------------------------------

stat = 'OK'
dane = []
wyn1 = []
wyn2 = []

if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=='OK':
    Fun = klucze['Funkcja']
    
    SlPar={'Wyznacznik':[3,4,5],'Data':[3,4,5],'Numer':[3,4,5],'PlikId':[3,4,5]}    
    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Fun,klucze)
    if Lista<>'':
        stat='Uwaga : wywoanie funkcji fs_zamowienia_dostawcy_pliki_dane z numerem '+str(Fun)+' bez parametrw: '+Lista
        
    if Fun in [3,4,5]:
        Wyzn=rsglobal.Dekoduj(klucze['Wyznacznik'])
        Data=rsglobal.Dekoduj(klucze['Data'])
        Nr=str(klucze['Numer'])
        PlikId=str(klucze['PlikId'])
    
if stat == 'OK':    
    UprEdycja = (((self.oddzial_id,'037042') in self.uprawnienia) or ((self.oddzial_id,'037043') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID))

#-------------------------------------------------------------------------------
# sprawdzenie uprawnien
#-------------------------------------------------------------------------------
    
if Fun in [3,4] and stat == 'OK':
    if not UprEdycja:
        stat = 'BR UPR'
    
#-------------------------------------------------------------------------------
#   UPDATE DANYCH ( 3-update, 4 -update z pobraniem)
#-------------------------------------------------------------------------------

    if stat=='OK':
        SQL = "UPDATE rs_zamowienia_dostawcy_pliki SET "
        
        for i in range(len(pola)):
            pole = pola[i]
            wart = wartosci[i]
            if pole in ['opis']:
                SQL+=pole+"='"+wart+"',"
        SQL=SQL.strip(',')            
        SQL+=" WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyzn+"' AND data='"+Data+"' AND numer="+Nr
        SQL+=" AND plik_id="+PlikId
        stat,dump,dump,dump = self.PolSQL.Execute(SQL ,1)
        if stat<>'OK':
            stat='BL UPD'
            dane.append(stat)
    
#-------------------------------------------------------------------------------
#   POBRANIE DANYCH ( 5-select, 3 -update z pobraniem)
#-------------------------------------------------------------------------------

if stat=='OK' and Fun in [3,5]:
    SQL="SELECT opis,z_op_id,z_czas,z_typ FROM rs_zamowienia_dostawcy_pliki "
    SQL+=" WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyzn+"' AND data='"+Data+"' AND numer="+Nr
    SQL+=" AND plik_id="+PlikId
    stat,dane,wyn1,dump = self.PolSQL.Execute(SQL,3)