# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_zamowienia_dostawcy_pom.py
# Purpose:     funkcje pomocnicze zamwie dostawcw
#
# Author:      Micha Raburski
# Created:     2012/10/01
# RCS-ID:      $Id: fs_zamowienia_dostawcy_pom.py $
# Copyright:   (c) 2012 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

# 2021-06-10 Wojciech Skowron - (121514) UsunPlikiZamowienia()

from funkcje import fs_pliki_global

#-------------------------------------------------------------------------------
# funkcja pomocnicza przeliczajca ceny na zamwieniu w zalenoci od parametrw (wersja, upust itp)
#-------------------------------------------------------------------------------

def PrzeliczCenyZamowienia(Firma,Wyznacznik,Data,Numer,PolSQL):
    import rsglobal
    Numer=str(Numer)
    SQL="SELECT kontrahent_id,wersja,upust,waluta FROM rs_zamowienia_dostawcy WHERE firma_id='"+Firma+"' AND wyznacznik_id='"+Wyznacznik+"' AND data='"+Data+"' AND numer="+Numer
    stat,d,dump,dump = PolSQL.Execute(SQL,3)
    if stat<>'OK':
        return "Bdy pobrania danych z zamwienia dostawcy : "+stat
    if len(d)==0:
        return "Brak zamwienia o podanym kluczu : "+Wyznacznik+'/'+Data+'/'+Numer
    
    Kontrahent=rsglobal.Dekoduj(d[0][0])
    Wersja=rsglobal.Dekoduj(d[0][1])
    Upust=d[0][2]
    Waluta=rsglobal.Dekoduj(d[0][3])
    SQL="SELECT nr_poz,artykul_id FROM rs_zamowienia_dostawcy_pozycje WHERE firma_id='"+Firma+"' AND wyznacznik_id='"+Wyznacznik+"' AND data='"+Data+"' AND numer="+Numer+"; "
    stat,dane_wyn,dump,dump = PolSQL.Execute(SQL,3)
    if stat<>'OK':
        return "Bdy pobrania danych pozycji zamwienia dostawcy : "+stat
    
    for i in dane_wyn:
        SQL="SELECT rsf_podaj_ceny_tylko_dla_kontrahenta('"+Firma+"',CAST('"+Kontrahent+"' AS TEXT),CAST('"+Waluta+"' AS TEXT),CAST('"+Data+"' AS TEXT),CAST('"+rsglobal.Dekoduj(i[1])+"' AS TEXT),CAST('"+Wersja+"' AS TEXT),"+str(Upust)+")"
        stat,d_c,dump,dump=PolSQL.Execute(SQL,3)
        if stat<>'OK':
            return "Bdy pobrania cen artykuu "+rsglobal.Dekoduj(i[1])+": "+stat

        d=rsglobal.rseval(d_c[0][0])
        Update="UPDATE rs_zamowienia_dostawcy_pozycje SET cena_netto1=round("+str(d[0])+",2)"
        Update+=",cena_netto2=round("+str(d[1])+",2),cena_upust1=round("+str(d[4])+",2)"
        Update+=",cena_upust2=round("+str(d[5])+",2),wartosc_netto=round(ilosc1*"+str(d[4])+",2)"
        Update+=",upust=round("+str(d[8])+",2)"
        Update+=",upust_wartosc=round((ilosc1*"+str(d[0])+")-("+str(d[4])+"*ilosc1),2)"
        Update+=" WHERE firma_id='"+Firma+"' AND wyznacznik_id='"+Wyznacznik+"' AND data='"+Data+"' AND numer="+Numer+" AND nr_poz="+str(i[0])+"; "
        stat,dump,dump,dump=PolSQL.Execute(Update,1)
            
        if stat<>'OK':
            return 'BL UPD POZ'

    return 'OK'

#-------------------------------------------------------------------------------

#WS 2021-06-10
def UsunPlikiZamowienia(self,Wyzn,Data,Numer):
    # pobranie listy plikw do usunicia
    SQL="SELECT nr_pliku,typ_pliku,plik_id FROM rs_zamowienia_dostawcy_pliki WHERE firma_id='"+self.firma_id+"'"
    SQL+=" AND wyznacznik_id = '"+Wyzn+"' AND data='"+Data+"' AND numer="+str(Numer)
    stat,DPliki,dump,dump = self.PolSQL.Execute(SQL,3)
    if stat <> 'OK':
        return u'Bdy pobierania listy plikw do usunicia: '+stat

    if len(DPliki) == 0:
        return 'OK'

    # pobranie typw do ktrych operator ma uprawnienia
    UprDel=((self.oddzial_id,'037044') in self.uprawnienia) or (self.operator_id == '0')
    if not UprDel:
        return u'Brak uprawnie do usuwania plikw przypitych do zamwienia'

    # faktyczne usunicie wszystkich plikw
    for plik in DPliki:
        stat=fs_pliki_global.UsunPlikZSerwera(self.KatalogPlikow,plik[0])
        if stat <> 'OK':
            return u'Wystpi bd usunicia pliku binarnego '+str(plik[0])+' z serwera: '+stat


        SQL="DELETE FROM rs_zamowienia_dostawcy_pliki WHERE plik_id="+str(plik[2])+";"
        SQL+="DELETE FROM rs_pliki WHERE plik_id="+str(plik[0])
        stat,dump,dump,dump = self.PolSQL.Execute(SQL ,1)
        if stat <> 'OK':
            return u'Wystpi bd usunicia pliku '+str(plik[2])+' z serwera: '+stat

    return 'OK'
