# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_zamowienia_dostawcy_pozycje_dane.py
# Purpose:     wczytuje/edytuje dane dotyczace pozycji zamowienia dostawcy
#
# Author:      Marcin Grzeda
# Created:     2008/04/04
# RCS-ID:      $Id:$
# Copyright:   (c) 2008 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

# 2011-09-23 Mariusz Rajfura (5042) blokada modyfikacji danych w stanie G
# 2014-02-03 Micha Raburski (7623) obsuga cech na pozycji zamwienia
# 2014-07-25 Konrad Opieka (7648) zmiana pobierania cech na fs_artykuly_pom

#klucze = [Wyznacznik,Data,Numer,Poz,Artykul,Funkcja]

stat='OK'
Wyznacznik=rsglobal.Dekoduj(klucze[0]) 
Data=rsglobal.Dekoduj(klucze[1]) 
Numer=rsglobal.Dekoduj(klucze[2]) 
Poz=rsglobal.Dekoduj(klucze[3])
Artykul=rsglobal.Dekoduj(klucze[4])
Funkcja=klucze[-1]

Pola=pola
Wartosci=wartosci

puste_pola = [[],"","    -  -  "]

if stat=='OK':
    Lista=[self.firma_id,self.oddzial_id,self.operator_id]
    sql = "SELECT rsf_podaj_wyznaczniki('"+str(Lista).replace("'",'"')+"','[]','None');"    
    stat,wyzn,dump,dump=self.PolSQL.Execute(sql,3)
    
    if stat<>'OK':
        stat='BL SQL WYZN $'+stat
        dane.append(stat)

if stat=='OK':
    LWyzn=rsglobal.rseval(wyzn[0][0])[1]
    if LWyzn==[]:
        stat='BR LWYZN'
if stat=='OK':
    if self.operator_id == STANDARD_OPERATOR_ID:
        UprEdy=True
        UprIns=True
        LEdy=LWyzn
        LIns=LWyzn
    else:
        UprEdy=(self.oddzial_id,'037022') in self.uprawnienia
        UprIns=(self.oddzial_id,'037023') in self.uprawnienia
        if UprIns:
            UprEdy = True
        
        LEdy=[]
        LIns=[]
                             
        if stat=='OK':                       
            if UprEdy and Funkcja in [3,4]:
                Lista=[self.firma_id,self.oddzial_id,self.operator_id]
                sql = "SELECT rsf_podaj_wyznaczniki('"+str(Lista).replace("'",'"')+"','[]','[False,False,True,False,False,False]');"    
                stat,wyzn,dump,dump=self.PolSQL.Execute(sql,3)
                if stat=='OK':
                    LEdy=rsglobal.rseval(wyzn[0][0])[1]
                                        
        if stat=='OK': 
            if UprIns and Funkcja in [1,2]:
                Lista=[self.firma_id,self.oddzial_id,self.operator_id]
                sql = "SELECT rsf_podaj_wyznaczniki('"+str(Lista).replace("'",'"')+"','[]','[False,True,False,False,False,False]');"    
                stat,wyzn,dump,dump=self.PolSQL.Execute(sql,3)
                if stat=='OK':
                    LIns=rsglobal.rseval(wyzn[0][0])[1]


#-------------------------------------------------------------------------------
#        Funkcja pobierajca walute, upust, wersje z nagwka (9)
#-------------------------------------------------------------------------------

if Funkcja == 9 and stat=='OK': 
    dane=[]
    sql ="SELECT waluta,upust,wersja,stan"
    sql+=" FROM rs_zamowienia_dostawcy"
    sql+=" WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyznacznik+"'"
    sql+=" AND data ='"+Data+"' AND numer="+str(Numer)+";"
    st,dane,dump,dump = self.PolSQL.Execute(sql ,3)
    if st<>'OK':
        stat='BL SQL WERS'
        dane.append(stat)    

#-------------------------------------------------------------------------------
#                Pobieranie kolejnego numeru dla nowej pozycji  (10)
#-------------------------------------------------------------------------------

if Funkcja == 10 and stat=='OK':
    dane=[]
    sql = "SELECT nr_poz FROM rs_zamowienia_dostawcy_pozycje WHERE firma_id = '"+self.firma_id+"'"
    sql+= " AND wyznacznik_id='"+Wyznacznik+"' AND data = '"+Data+"' AND numer="+Numer+" ORDER BY nr_poz DESC LIMIT 1"
    st,dane,dump,dump = self.PolSQL.Execute(sql ,3)
    if st<>'OK':
        stat='BL POB NR POZ'
        dane.append(stat)    
    elif len(dane)==0:
        dane = 1
    else:
        dane = int(dane[0][0]) + 1
        
#-------------------------------------------------------------------------------------
#        Funkcja pobierajca przelicznik i jednostki miary dla artykuu
#-------------------------------------------------------------------------------------
        
if Funkcja in [11,12] and stat=='OK':
    dane = []
    sql = "SELECT przelicznik,jm1,jm2 FROM rs_artykuly WHERE artykul_id='"+Artykul+"' AND firma_id = '"+self.firma_id+"';"
    stat,d_art,dump,dump = self.PolSQL.Execute(sql,3)
    if stat<>'OK':
        stat='BL POB JM'
        dane.append(stat)
    elif Funkcja==11:
        dane=d_art

#--------------------------------------------------------------------------------------
#---Pobieranie cen artykuu dla kontrahenta (12) - wczesniej pobierany przelicznik i jm
#--------------------------------------------------------------------------------------


if Funkcja == 12 and stat=='OK':
    Select="SELECT kontrahent_id,wersja,upust,waluta FROM rs_zamowienia_dostawcy"
    Select+=" WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyznacznik+"' AND data='"+Data+"' AND numer="+str(Numer)
    stat,d,dump,dump = self.PolSQL.Execute(Select,3)
    if stat<>'OK':
        stat='BL POB NAGL'
        dane.append(stat)
    elif len(d)==0:
        stat='BL KLUCZ'
        dane.append(stat)
    else:
        Kontrahent=rsglobal.Dekoduj(d[0][0])
        Wersja=rsglobal.Dekoduj(d[0][1])
        Upust=d[0][2]
        Waluta=rsglobal.Dekoduj(d[0][3])
        sql="SELECT rsf_podaj_ceny_tylko_dla_kontrahenta('"+self.firma_id+"',CAST('"+Kontrahent+"' AS TEXT),"
        sql+="CAST('"+Waluta+"' AS TEXT),CAST('"+Data+"' AS TEXT),CAST('"+Artykul+"' AS TEXT),CAST('"+Wersja+"' AS TEXT)"
        sql+=","+str(Upust)+")"
        stat,d_c,dump,dump=self.PolSQL.Execute(sql,3)
        if stat<>'OK' or len(d)==0:
            stat=='BL POB CEN'
            dane.append(stat)
        else:
            d=rsglobal.rseval(d_c[0][0])
            if len(d_art)==0:
                d_art=[[1,'','']]
            dane=d_art[0]+[d[8],d[0],d[1],d[4],d[5]]
            
#-------------------------------------------------------------------------------
# Pobranie cech (25)
#-------------------------------------------------------------------------------

if Funkcja == 25 and stat == 'OK':
    from funkcje import fs_artykuly_pom
    
    stat,dane = fs_artykuly_pom.PodajDaneArtykuluIFaktury(self,Artykul,'','',0,'','','',0,'')
    if stat<>'OK':
        stat='Bd pobrania danych artykuu'
        dane.append(stat)
    
#-------------------------------------------------------------------------------
#---   Sprawdzam dane
#-------------------------------------------------------------------------------

if Funkcja in [1,2,3,4] and stat=='OK':
    if Data not in puste_pola:
        if not rsglobal.SprawdzCzyToData(Data):
            stat = "BL KLUCZ DAT"
        else:
            sql="SELECT rsf_sprawdz_date_z_zakresem('"+self.firma_id+self.oddzial_id+"','"+Data+"',1);"
            st,dane_wyn,dump,dump = self.PolSQL.Execute(sql ,3)
            if st<>'OK' or dane_wyn <> 1:
                stat="BL ZAK DAT"
                stat='OK'
                dane_wyn.append(stat)
        Filtr = "firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyznacznik+"' AND data='"+Data+"' AND numer="+str(Numer)
        sql="SELECT wyznacznik_id FROM rs_zamowienia_dostawcy WHERE "+Filtr+";"
        st,dane_wyn,dump,dump = self.PolSQL.Execute(sql ,3)
        if st<>'OK' or  len(dane_wyn) == 0:
            stat = "BL KLUCZ"
            dane.append(stat)
    else:
        stat = "BL KLUCZ"
        dane.append(stat)
        
    if stat == "OK":
        dane = []
        NrPoz = Poz
        i = 0
        art_id = None
        
        # pobranie informacji o cechach (dla update)
        CechaArt=''
        Cecha=''
        CechaWart=''
        if Funkcja in [3,4]:
            SQL = "SELECT TRIM(COALESCE(a.cecha1_opis,'')),TRIM(COALESCE(dp.cecha1_opis,'')),"
            SQL+=" TRIM(COALESCE(dp.cecha1_wartosc,''))"
            SQL+= " FROM rs_zamowienia_dostawcy_pozycje dp LEFT OUTER JOIN rs_artykuly a USING (firma_id,artykul_id)"
            SQL+= " WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyznacznik+"'"
            SQL+= " AND data='"+Data+"' AND numer="+Numer+" AND nr_poz="+str(Poz)
            stat,Dane,dump,dump = self.PolSQL.Execute(SQL ,3)
            if stat <> 'OK':
                stat = "Bd pobierania danych artykuu z pozycji zamwienia dostawcy"
                dane.append(stat)
            else:
                CechaArt=Dane[0][0]
                Cecha=Dane[0][1]
                CechaWart=Dane[0][2]
        
        for pole in Pola:
            wart = Wartosci[i]
            if pole=='nr_poz':
                if wart < 1:
                    stat = "BL NR POZ"
                    dane.append(stat)
                else:
                    sql = "SELECT nr_poz FROM rs_zamowienia_dostawcy_pozycje WHERE firma_id='"+self.firma_id+"'"
                    sql+=" AND wyznacznik_id='"+Wyznacznik+"' AND data='"+Data+"' AND numer="+Numer+" AND nr_poz="+str(wart)+";"
                    st,Dane,dump,dump = self.PolSQL.Execute(sql ,3)
                    if st<>'OK':
                        stat='BL SQL NR POZ'
                        dane.append(stat) 
                    elif len(Dane) <> 0:
                        stat = "NR POZ ISTN"
                        dane.append(stat)
            elif pole == 'artykul_id':
                if wart == '':
                    stat = "BR ART"
                    dane.append(stat)
                else:
                    sql = "SELECT artykul_id,TRIM(COALESCE(cecha1_opis,'')),aktywny FROM rs_artykuly WHERE firma_id='"+self.firma_id+"' AND artykul_id = '"+wart+"';"
                    stat,Dane,dump,dump = self.PolSQL.Execute(sql ,3) 
                    if stat<>'OK':
                        stat='BL SQL ART'
                        dane.append(stat)
                    elif Dane == []:
                        stat = "BL ART"
                        dane.append(stat)
                    elif not Dane[0][2]:
                        stat='ART NIEAKT'
                        dane.append(stat)
                    else:
                        art_id = wart
                        CechaArt = Dane[0][1]
                        #sprawdzam czy dokument jest w stanie 'A' i czy zmieniany w edycji artykul jest zamiennikiem 
                        if stat == "OK" and Funkcja in [3,4]:
                            SQL="SELECT stan FROM rs_zamowienia_dostawcy WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyznacznik+"' "
                            SQL+= "AND data='"+Data+"' AND numer="+str(Numer)+" ;"
                            stat,DaneZ,dump,dump = self.PolSQL.Execute(SQL ,3) 
                            if stat<>'OK':
                                stat='BL SQL STAN'
                                dane.append(stat)
                            elif DaneZ==[[]]:
                                stat='BL KLUCZ'
                                dane.append(stat)
                            else:
                                if str(DaneZ[0][0])=='G':
                                    SQL= "SELECT artykul_id FROM rs_zamowienia_dostawcy_pozycje WHERE firma_id='"+self.firma_id+"' "
                                    SQL+= " AND wyznacznik_id='"+Wyznacznik+"' AND data='"+Data+"' AND numer="+str(Numer)+" AND nr_poz="+str(Poz)+"; "
                                    stat,ArtykulSt,dump,dump = self.PolSQL.Execute(SQL ,3) 
                                    if stat<>'OK':
                                        stat='BL SQL ART ST'
                                        dane.append(stat)
                                    elif ArtykulSt==[[]]:
                                        stat='BL KLUCZ POZ'
                                        dane.append(stat)
                                    else:
                                        ArtykulStary=str(ArtykulSt[0][0])
                                        ArtykulNowy=str(art_id)
                                        Zamienniki=[]
                                        
                                        SELECT = "SELECT DISTINCT(aa.artykul_id ) "
                                        SELECT += "FROM rs_artykuly a "
                                        SELECT += "INNER JOIN rs_artykuly aa ON(a.firma_id=aa.firma_id AND (a.zamiennik_id=aa.zamiennik_id OR aa.artykul_id=a.zamiennik_id or a.artykul_id=aa.artykul_id)) "
                                        SELECT += "WHERE a.firma_id='"+self.firma_id+"' AND (a.zamiennik_id='"+ArtykulStary+"' OR a.artykul_id='"+ArtykulStary+"'); "
                                        stat,dane_z,dump,dump = self.PolSQL.Execute(SELECT,3)
                                        
                                        if stat<>'OK':
                                            stat='BL SQL ZAMIEN'
                                            dane.append(stat)
                                        if len(dane_z)==0 and stat=='OK':
                                            stat='BL ART'
                                            dane.append(stat)
                                        for w in dane_z:
                                            Zamienniki.append(str(w[0]))
                                        if str(ArtykulNowy) not in str(Zamienniki).replace("[","(").replace("]",")") and stat=='OK':
                                            stat='BL ZAM'
                                            dane.append(stat)
                                                                
                                                        
            elif pole == 'ilosc1':
                if wart <= 0:
                    stat = "BL IL ART1"
                    dane.append(stat)
            elif pole == 'ilosc2':
                if wart <= 0:
                    stat = "BL IL ART2"
                    dane.append(stat)
            elif pole == 'cena_netto1':
                if wart < 0:
                    stat = "BL CEN NET1"
                    dane.append(stat)
            elif pole == 'cena_netto2':
                if wart < 0:
                    stat = "BL CEN NET2"
                    dane.append(stat)
            elif pole == 'cecha1_opis':
                Cecha = wart.strip()                   
            elif pole == 'cecha1_wartosc':
                CechaWart = wart.strip()           
            i= i+1
    
    # sprawdzenie spjnoci informacji o cechach
    if stat == 'OK' :
        # jeli opis cechy pozycji inny ni artykuu
        if Cecha <> CechaArt:
            stat = 'BL CECHA'
            dane.append(stat)
        # jeli opis podany a warto pusta
        elif Cecha <> '' and CechaWart =='':
            stat = 'BR CECHA WART'
            dane.append(stat)
        # jeli opis pusty a warto podana
        elif Cecha == '' and CechaWart <>'':
            stat = 'CECHA WART NIEPUSTA'
            dane.append(stat)
        else:
            SQL="SELECT rsf_podaj_parametry_cechy('"+self.firma_id+"','"+Cecha+"','"+CechaWart+"','poprawna')"
            stat,d,dump,dump = self.PolSQL.Execute(SQL,3)
            if stat <> 'OK':
                stat = 'Bd sprawdzenia wartoci cechy: '+stat
            else:
                Wynik=eval(d[0][0])
                if not Wynik[0]:
                    stat = Wynik[1]
                    dane.append(stat)
    
    if stat == 'OK':
        if len(dane) > 0:
            stat = dane[0]

          
#-------------------------------------------------------------------------------
#---   INSERT DANYCH (2- bez pobierania,1- z pobieraniem)
#-------------------------------------------------------------------------------

if stat == "OK" and Funkcja in [2,1]:
    if not (UprIns and (Wyznacznik in LIns)) and self.operator_id <> STANDARD_OPERATOR_ID:
        stat='UPR INS'
        dane.append(stat)
    if stat=='OK':
        sql = "INSERT INTO rs_zamowienia_dostawcy_pozycje"
        PolaN="firma_id,wyznacznik_id,data,numer"
        WartosciN = "'"+self.firma_id+"','"+Wyznacznik+"','"+Data+"','"+Numer+"'"
        for i in range(len(pola)):
            pole = pola[i]
            wart = wartosci[i]
            if pole in ['artykul_id','cecha1_opis','cecha1_wartosc']:
                PolaN += ","+pole
                WartosciN += ",'"+str(wart)+"'"
            elif pole in ['nr_poz','ilosc1','ilosc2','dostarczono1','dostarczono2','anulowano1','anulowano2','cena_netto1','cena_netto2','cena_upust1','cena_upust2','upust','upust_wartosc','wartosc_netto']:
                PolaN += ","+pole
                WartosciN += ","+str(wart)
            if pole == "nr_poz":
                Poz = wart
        sql += " ("+PolaN+") VALUES ("+WartosciN+");"
        st,dump,dump,dump = self.PolSQL.Execute(sql ,1)
        if st<>'OK':
            stat='BL INS'
            dane.append(stat)


#-------------------------------------------------------------------------------
#---   UPDATE DANYCH (4- bez pobierania,3- z pobieraniem)
#-------------------------------------------------------------------------------

if stat == "OK" and Funkcja in [3,4]:
     if not (UprEdy and (Wyznacznik in LEdy)) and self.operator_id <> STANDARD_OPERATOR_ID:
        stat='UPR UPD'
        dane.append(stat)
     if stat=='OK':
        dane = []
        sql = "UPDATE rs_zamowienia_dostawcy_pozycje SET "
        Filtr = "firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyznacznik+"' AND data='"+Data+"' AND numer="+Numer+" AND nr_poz="+str(Poz)
        for i in range(len(Pola)):
            wart = Wartosci[i]
            pole = Pola[i]
            if pole in ['artykul_id','cecha1_opis','cecha1_wartosc']:
                sql += pole+"='"+str(wart)+"',"
            elif pole in ['nr_poz','ilosc1','ilosc2','dostarczono1','dostarczono2','anulowano1','anulowano2','cena_netto1','cena_netto2','cena_upust1','cena_upust2','upust','upust_wartosc','wartosc_netto']:
                sql += pole+"="+str(wart)+","
            if pole == "nr_poz":
                Poz = wart
        sql = sql.strip(',')
        sql += " WHERE "+Filtr+";"
        stat,dump,dump,dump = self.PolSQL.Execute(sql ,1)
        if stat != 'OK':
            stat = 'BL UPD'
            dane.append(stat)

 
#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (5 -select, 3 -update z pobraniem, 1 -insert z pobraniem)
#-------------------------------------------------------------------------------

if stat == "OK" and Funkcja in [5,3,1]:
    dane = []
    where =" WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyznacznik+"' AND data='"+Data+"'"
    where+=" AND numer="+Numer+" AND nr_poz="+str(Poz)
    sql = "SELECT * FROM rs_zamowienia_dostawcy_pozycje"+where+";"
    st,dane,wyn1,dump = self.PolSQL.Execute(sql,3)
    if st<>'OK':
        stat='BL SQL PRZ'
        dane.append(stat)
    else:
        tr = rssql.RSTableRowset(dane,wyn1)

        wyn2=[]
        if ((self.oddzial_id,'013010') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
            sql = "SELECT nazwa,przelicznik,jm1,jm2 FROM rs_artykuly WHERE firma_id = '"+self.firma_id+"' AND artykul_id = '"+tr.GetVal(0,"artykul_id")+"' "
            st,d,dump,dump=self.PolSQL.Execute(sql,3)
            if stat<>'OK':
                wyn2=[u'Wystpiy bdy podczas pobierania opisu artykuu oraz jednostek miary i przelicznika',1,'','']
            if len(d) == 0:
                wyn2=['',1,'','']
            else:
                wyn2=d[0]
        else:
            wyn2=['Brak uprawnie do przegldania artykuw. Poinformuj administratora.',1,'','']
