#!/usr/bin/python
# -*- coding: iso8859_2 -*-
#-----------------------------------------------------------------------------
# Name:             fs_zamowienia_dostawcy_pozycje_opisowe.py
# Purpose:          pobiera/usuwa zamowienia dostawcy
# Author:           Marcin Grzeda
# Created:          2008/04/05
# RCS-ID:           $Id: fs_zamowienia_dostawcy_pozycje_opisowe.py $
# Copyright:        (c) 2008 RecordSystem
# Licence:          GNU GPL
#-----------------------------------------------------------------------------
# 2017-05-16 Piotr Witkowski - Refaktoryzacja okna (10501)

stat='OK'

if stat == 'OK' and not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=='OK':
    Funkcja = klucze['Funkcja']
    SlPar={'Wyznacznik':[5,6],'Data':[5,6],'Numer':[5,6],'NrPoz':[6],}

    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Funkcja,klucze)
    if Lista<>'':
        stat=u'Uwaga : wywoanie funkcji fs_zamowienia_dostawcy_pozycje_opisowe z numerem ' +str(Funkcja)+u' bez parametrw: '+Lista
    if stat=='OK':
        if Funkcja in [6]:
            NrPoz = str(klucze['NrPoz'])
        if Funkcja in [5,6]:
            Wyznacznik = str(klucze['Wyznacznik'])
            Data = str(klucze['Data'])
            Numer = str(klucze['Numer'])

if stat=='OK':
    dane = []
    wyn1 = []
    wyn2 = []
    puste_pola = ['    -  -  ','',[]]

if self.operator_id <> STANDARD_OPERATOR_ID:
    if (Funkcja in [6]) and ((self.oddzial_id,'037034') not in self.uprawnienia):
        stat='UPR DEL'
        dane.append(stat)
    if (Funkcja in [5,6]) and ((self.oddzial_id,'037030') not in self.uprawnienia):
        stat='UPR PRZ'
        dane.append(stat)

if stat=='OK':
    Lista=[self.firma_id,self.oddzial_id,self.operator_id]
    sql = "SELECT rsf_podaj_wyznaczniki('"+str(Lista).replace("'",'"')+"','[]','None');"    
    stat,wyzn,dump,dump=self.PolSQL.Execute(sql,3)
    
    if stat<>'OK':
        stat='BL SQL WYZN $'+stat
        dane.append(stat)

if stat=='OK':
    LWyzn=rsglobal.rseval(wyzn[0][0])[1]
    if LWyzn==[]:
        stat='BR LWYZN'
if stat=='OK':
    if self.operator_id == STANDARD_OPERATOR_ID:
        UprPrz=True
        UprDel=True
        LPrz=LWyzn
        LDel=LWyzn
    else:
        UprPrz=(self.oddzial_id,'037030') in self.uprawnienia
        UprDel=(self.oddzial_id,'037034') in self.uprawnienia
        LPrz=[]
        LDel=[]
        if stat=='OK':                       
            if UprPrz and Funkcja in [5,6]:
                Lista=[self.firma_id,self.oddzial_id,self.operator_id]
                sql = "SELECT rsf_podaj_wyznaczniki('"+str(Lista).replace("'",'"')+"','[]','[True,False,False,False,False,False]');"    
                stat,wyzn,dump,dump=self.PolSQL.Execute(sql,3)
                if stat=='OK':
                    LPrz=rsglobal.rseval(wyzn[0][0])[1]
                                        
        if stat=='OK': 
            if UprDel and Funkcja in [6]:
                Lista=[self.firma_id,self.oddzial_id,self.operator_id]
                sql = "SELECT rsf_podaj_wyznaczniki('"+str(Lista).replace("'",'"')+"','[]','[False,False,False,True,False,False]');"    
                stat,wyzn,dump,dump=self.PolSQL.Execute(sql,3)
                if stat=='OK':
                    LDel=rsglobal.rseval(wyzn[0][0])[1]


#-------------------------------------------------------------------------------
# -- Usuwanie 6 -- #
#-------------------------------------------------------------------------------

if stat=='OK' and Funkcja in [6,]:
    if not (UprDel and (Wyznacznik in LDel)) and self.operator_id <> STANDARD_OPERATOR_ID:
        stat='UPR DEL'
        dane.append(stat)    
    if stat=='OK':
        sql ="DELETE FROM rs_zamowienia_dostawcy_pozycje_opisowe WHERE firma_id='"+self.firma_id+"' "
        sql+="AND wyznacznik_id = '"+Wyznacznik+"' AND data = '"+Data+"' AND numer = "+str(Numer)+" AND nr_poz = "+NrPoz+" "
        st,dump,dump,dump=self.PolSQL.Execute(sql,1)
        if st=='OK':
            sql="UPDATE rs_zamowienia_dostawcy_pozycje_opisowe SET nr_poz=nr_poz-1 WHERE firma_id='"+self.firma_id+"' "
            sql+="AND wyznacznik_id = '"+Wyznacznik+"' AND data = '"+Data+"' AND numer = "+str(Numer)+" AND nr_poz > "+NrPoz+";"
            st,dump,dump,dump=self.PolSQL.Execute(sql,1)
            if st<>'OK':
                stat='BL SQL UPD'
                dane.append(stat)
        else:
            stat='BL SQL DEL'
            dane.append(stat)


#-------------------------------------------------------------------------------
# -- przegladanie 5, usuwanie 6 -- #
#-------------------------------------------------------------------------------

if stat=='OK' and Funkcja in [5,6]:
    if not (UprPrz and (Wyznacznik in LPrz)) and self.operator_id <> STANDARD_OPERATOR_ID:
        stat='UPR PRZ'
        dane.append(stat)    
    if stat=='OK':
        pola ="nr_poz,opis_pozycji,wartosc_netto"
        
        sql ="SELECT "+pola+" FROM rs_zamowienia_dostawcy_pozycje_opisowe WHERE firma_id='"+self.firma_id+"'"
        sql+=" AND wyznacznik_id='"+Wyznacznik+"' AND data='"+Data+"' AND numer="+str(Numer)+"  ORDER BY nr_poz"
        stat,dane,wyn1,wyn2=self.PolSQL.Execute(rsglobal.Dekoduj(sql),3)
        if stat!="OK":
            stat="BL SQL PRZ"
            dane.append(stat)