# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_zamowienia_odbiorcy_dane.py
# Purpose:     wczytuje/edytuje dane podstawowe zamowien odborcy
#
# Author:      Marcin Grzeda
# Created:     2007/01/26
# RCS-ID:      $Id: fs_zamowienia_odbiorcy_dane.py $
# Copyright:   (c) 2007 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

# 2010-11-25 Marcin Natkaski  blokada modyfikacji wierszy dla zamwie ze stanem <> W (4085)
# 2011-09-06 Mariusz Rajfura  nowe pole 'magazyn_id' (4983)
# 2012-09-03 Mariusz Rajfura (6029) pobranie waluty z danych do fakturowania
# 2019-08-06 Aleksander Bargie - (11581) [SP] czy_mpp w zamowieniach odbiorcw
# 2021-06-14 Aleksander Bargie [ZO] statusy w zamowieniach odbiorcow   (12529)

#klucze = [Wyznacznik,Data,Numer]

from funkcje import fs_zaleglosci_sprawdzenie
import rsglobal

stat='OK'
Wyznacznik=rsglobal.Dekoduj(klucze[0])
Data=rsglobal.Dekoduj(klucze[1])
Numer=str(rsglobal.Dekoduj(klucze[2]))
Typ=rsglobal.Dekoduj(klucze[3])
Funkcja=klucze[-1]
#w celach informacyjno rozeznaniowych
Pola=pola
Wartosci=wartosci

puste_pola = [[],"","    -  -  "]
LWyzn=[]
LEdy=[]


if stat=='OK':
    Lista=[self.firma_id,self.oddzial_id,self.operator_id]
    sql = "SELECT rsf_podaj_wyznaczniki('"+str(Lista).replace("'",'"')+"','[]','None');"
    stat,wyzn,dump,dump=self.PolSQL.Execute(sql,3)
if stat=='OK':
    LWyzn=rsglobal.rseval(wyzn[0][0])[1]

if stat=='OK':
    if self.operator_id == STANDARD_OPERATOR_ID:
        UprEdy=True
        UprPrz=True
        LEdy=LWyzn
        LPrz=LWyzn
    else:
        UprEdy=((self.oddzial_id,'024012') in self.uprawnienia or (self.oddzial_id,'024013') in self.uprawnienia)
        LEdy=[]

        if UprEdy and (Funkcja in [3,4]):
            Lista=[self.firma_id,self.oddzial_id,self.operator_id]
            sql = "SELECT rsf_podaj_wyznaczniki('"+str(Lista).replace("'",'"')+"','[]','[False,False,True,False,False,False]');"
            stat,wyzn,dump,dump=self.PolSQL.Execute(sql,3)
            if stat=='OK':
                LEdy=rsglobal.rseval(wyzn[0][0])[1]

        UprPrz=((self.oddzial_id,'024010') in self.uprawnienia)
        LPrz=[]

        if UprPrz and (Funkcja in [1,3,5]):
            Lista=[self.firma_id,self.oddzial_id,self.operator_id]
            sql = "SELECT rsf_podaj_wyznaczniki('"+str(Lista).replace("'",'"')+"','[]','[True,False,False,False,False,False]');"
            stat,wyzn,dump,dump=self.PolSQL.Execute(sql,3)
            if stat=='OK':
                LPrz=rsglobal.rseval(wyzn[0][0])[1]



if Funkcja == "9": #sprawdzam walute
    if Wyznacznik not in puste_pola:
        sql = "SELECT data,nr_tabeli,kurs_sredni/ilosc_waluty,kurs_zakup/ilosc_waluty,kurs_sprzedaz/ilosc_waluty FROM rs_kursy_walut WHERE firma_id = '"+self.firma_id+"' AND waluta = '"+Numer+"' AND data='"+Wyznacznik+"';"
    elif Data not in puste_pola:
        sql = "SELECT data,nr_tabeli,kurs_sredni/ilosc_waluty,kurs_zakup/ilosc_waluty,kurs_sprzedaz/ilosc_waluty FROM rs_kursy_walut WHERE firma_id = '"+self.firma_id+"' AND waluta = '"+Numer+"' AND nr_tabeli='"+Data+"';"
    stat,dane,dump,dump = self.PolSQL.Execute(sql ,3)

#--------------------------------------------------------------------------------------------------
#Funkcja (21)
#Pobieranie danych, ktre musz ulec modyfikacji po zmianie kontrahenta w danych zamowienia
#--------------------------------------------------------------------------------------------------

if Funkcja==21 and stat=='OK':
    Kontr = rsglobal.Dekoduj(klucze[0])
    Data=rsglobal.Dekoduj(klucze[1])
    Wyzn=rsglobal.Dekoduj(klucze[2])
    Zamawiajacy = Kontr
    Platnik = Kontr
    dane=[]
    stat=='OK'

    if Kontr.strip()<>"":
        st,d,dump,dump = self.PolSQL.Execute("SELECT zamawiajacy_id,platnik_id FROM rs_kontrahenci WHERE firma_id=\'"+self.firma_id+"\' AND kontrahent_id=\'"+str(Kontr)+"\';",3)
        if st<>'OK':
            stat='BL SQL PLAT ZAM'
        elif len(d) <> 0:
            if d[0][0] not in ["     ",u'None']:
                Zamawiajacy = rsglobal.Dekoduj(d[0][0])
            if d[0][1] not in ["     ",u'None']:
                Platnik = rsglobal.Dekoduj(d[0][1])

            Kontrahenci=[Kontr,Platnik,Zamawiajacy]
            wyn2=[]

            #odbiorca
            if ((self.oddzial_id,'012010') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
                dump,d,dump,dump = self.PolSQL.Execute("SELECT nazwa FROM rs_kontrahenci WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+Kontr+"';" ,3)
                if len(d) == 0:
                    wyn2.append('')
                else:
                    wyn2.append(d[0][0])
            else:
                wyn2.append('Brak uprawnie do sownika. Poinformuj administratora.')

            #platnik
            if ((self.oddzial_id,'012010') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
                dump,d,dump,dump = self.PolSQL.Execute("SELECT nazwa FROM rs_kontrahenci WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+Platnik+"';" ,3)
                if len(d) == 0:
                    wyn2.append('')
                else:
                    wyn2.append(d[0][0])
            else:
                wyn2.append('Brak uprawnie do sownika. Poinformuj administratora.')

            #zamawiajacy
            if ((self.oddzial_id,'012010') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
                dump,d,dump,dump = self.PolSQL.Execute("SELECT nazwa FROM rs_kontrahenci WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+Zamawiajacy+"';" ,3)
                if len(d) == 0:
                    wyn2.append('')
                else:
                    wyn2.append(d[0][0])
            else:
                wyn2.append('Brak uprawnie do sownika. Poinformuj administratora.')

            sql ="SELECT wersja,spos_zaplaty,spos_dostawy,handlowiec,sposob_odbioru_faktury,projekt_id,dni,upust,"
            sql+=" COALESCE(waluta_sprzedaz,'PLN'::TEXT) AS waluta_sprzedaz"
            sql+=" FROM rs_kontrahenci_fakturowanie"
            sql+=" WHERE firma_id=\'"+self.firma_id+"\' AND kontrahent_id = \'"+Kontr+"\' AND data_od <= \'"+Data+"\'"
            sql+=" ORDER BY data_od DESC LIMIT 1;"

            st,dane,wyn1,dump = self.PolSQL.Execute(sql, 3)
            if st<>'OK':
                stat='BL SQL DAN KONT'
                dane.append(stat)
            elif len(dane)<>1 and Platnik<>Kontr:
                sql ="SELECT wersja,spos_zaplaty,spos_dostawy,handlowiec,sposob_odbioru_faktury,projekt_id,dni,upust,"
                sql+=" COALESCE(waluta_sprzedaz,'PLN'::TEXT) AS waluta_sprzedaz"
                sql+=" FROM rs_kontrahenci_fakturowanie"
                sql+=" WHERE firma_id=\'"+self.firma_id+"\' AND kontrahent_id = \'"+Platnik+"\' AND data_od <= \'"+Data+"\'"
                sql+=" ORDER BY data_od DESC LIMIT 1;"

                st,dane,wyn1,dump = self.PolSQL.Execute(sql, 3)
                if st<>'OK':
                    stat='BL SQL DAN KONT'
                    dane.append(stat)
            if stat=='OK' and len(dane) == 1:
                tr = rssql.RSTableRowset(dane,wyn1)
                dane=Kontrahenci+dane[0]
                for i in xrange(len(dane)):
                    if dane[i]==u'None':
                        dane[i]=''

                #wersja
                if ((self.oddzial_id,'011100') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
                    st,d,dump,dump = self.PolSQL.Execute("SELECT opis FROM rs_wersje_cenowe WHERE firma_id='"+self.firma_id+"' AND kod='"+tr.GetVal(0,"wersja")+"';" ,3)
                    if st<>'OK':
                        wyn2.append(u'Wystpiy bdy podczas pobierania sownika.')
                    elif len(d) == 0:
                        wyn2.append('')
                    else:
                        wyn2.append(d[0][0])
                else:
                    wyn2.append(u'Brak uprawnie do sownika. Poinformuj administratora.')

                #sposob zaplaty
                if ((self.oddzial_id,'011090') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
                    st,d,dump,dump = self.PolSQL.Execute("SELECT opis FROM rs_sposoby_zaplaty WHERE firma_id='"+self.firma_id+"' AND kod='"+tr.GetVal(0,"spos_zaplaty")+"';" ,3)
                    if st<>'OK':
                        wyn2.append(u'Wystpiy bdy podczas pobierania sownika.')
                    elif len(d) == 0:
                        wyn2.append('')
                    else:
                        wyn2.append(d[0][0])
                else:
                    wyn2.append(u'Brak uprawnie do sownika. Poinformuj administratora.')

                #sposob dostawy
                if ((self.oddzial_id,'011030') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
                    st,d,dump,dump = self.PolSQL.Execute("SELECT opis FROM rs_sposoby_dostaw WHERE firma_id='"+self.firma_id+"' AND kod='"+tr.GetVal(0,"spos_dostawy")+"';" ,3)
                    if st<>'OK':
                        wyn2.append(u'Wystpiy bdy podczas pobierania sownika.')
                    elif len(d) == 0:
                        wyn2.append('')
                    else:
                        wyn2.append(d[0][0])
                else:
                    wyn2.append(u'Brak uprawnie do sownika. Poinformuj administratora.')

                #handlowiec
                if ((self.oddzial_id,'011220') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
                    st,d,dump,dump = self.PolSQL.Execute("SELECT opis FROM rs_handlowcy WHERE firma_id='"+self.firma_id+"' AND kod='"+tr.GetVal(0,"handlowiec")+"';" ,3)
                    if st<>'OK':
                        wyn2.append(u'Wystpiy bdy podczas pobierania sownika.')
                    elif len(d) == 0:
                        wyn2.append('')
                    else:
                        wyn2.append(d[0][0])
                else:
                    wyn2.append('Brak uprawnie do sownika. Poinformuj administratora.')

                #sposob odbioru faktury
                if ((self.oddzial_id,'011230') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
                    st,d,dump,dump = self.PolSQL.Execute("SELECT opis FROM rs_sposoby_odbioru_faktury WHERE firma_id='"+self.firma_id+"' AND kod='"+tr.GetVal(0,"sposob_odbioru_faktury")+"';" ,3)
                    if st<>'OK':
                        wyn2.append(u'Wystpiy bdy podczas pobierania sownika.')
                    elif len(d) == 0:
                        wyn2.append('')
                    else:
                        wyn2.append(d[0][0])
                else:
                    wyn2.append(u'Brak uprawnie do sownika. Poinformuj administratora.')

                #projekt
                if ((self.oddzial_id,'027000') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
                    st,d,dump,dump = self.PolSQL.Execute("SELECT nazwa FROM rs_projekty WHERE firma_id='"+self.firma_id+"' AND projekt_id='"+tr.GetVal(0,"projekt_id")+"';" ,3)
                    if st<>'OK':
                        wyn2.append(u'Wystpiy bdy podczas pobierania sownika.')
                    elif len(d) == 0:
                        wyn2.append('')
                    else:
                        wyn2.append(d[0][0])
                else:
                    wyn2.append(u'Brak uprawnie do sownika. Poinformuj administratora.')

                #dla wyrownania pozycji z lista dane[]
                wyn2.append(0)
                wyn2.append(0)

                #waluta
                if ((self.oddzial_id,'011130') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
                    st,d,dump,dump = self.PolSQL.Execute("SELECT opis FROM rs_waluty WHERE firma_id='"+self.firma_id+"' AND kod='"+tr.GetVal(0,"waluta_sprzedaz")+"';" ,3)
                    if st<>'OK':
                        wyn2.append(u'Wystpiy bdy podczas pobierania sownika.')
                    elif len(d) == 0:
                        wyn2.append('')
                    else:
                        wyn2.append(d[0][0])
                else:
                    wyn2.append(u'Brak uprawnie do sownika. Poinformuj administratora.')

            else:
                dane=Kontrahenci+['','','','','','',0,0,'PLN']
                wyn2=wyn2+       ['','','','','','',0,0,'polski zoty']


#-------------------------------------------------------------------------------
#---   Sprawdzam dane
#-----------------------------------------------------------------------------

if Funkcja in [3,4]:
    if stat=='OK':
        Wersja=''
        Upust=-1
        Kontrahent=''
        Waluta=''
        Kurs=0
        #AB 06.08.19r
        MPPPlatnik = False
        MPPKontrahent = False
    if stat=='OK':
        if Data not in puste_pola:
            dane_wyn = rsglobal.SprawdzCzyToData(Data)
            if not dane_wyn:
                stat = "BL KLUCZ"
            else:
                sql="SELECT rsf_sprawdz_date_z_zakresem(\'"+self.firma_id+self.oddzial_id+"\',\'"+Data+"\',1);"
                stat,dane_wyn,dump,dump = self.PolSQL.Execute(sql ,3)
                if dane_wyn <> 1:
                    stat="ZK DATA"
                    dane_wyn.append(stat)
            Filtr = "firma_id=\'"+self.firma_id+"\' AND wyznacznik_id=\'"+Wyznacznik+"\' AND data=\'"+Data+"\' AND numer="+str(Numer)
            sql="SELECT wyznacznik_id FROM rs_zamowienia_odbiorcy WHERE "+Filtr+";"
            stat,dane_wyn,dump,dump = self.PolSQL.Execute(sql ,3)
            if len(dane_wyn) == 0:
                stat = "BL KLUCZ"
                dane.append(stat)
        else:
            stat = "BL KLUCZ"
            dane.append(stat)

        if stat=="OK":
            if Typ <> "":
                stat,dane_typz,dump,dump = self.PolSQL.Execute("SELECT kod FROM rs_typy_zamowien WHERE firma_id=\'"+self.firma_id+"\' AND kod='"+Typ+"\';",3)
                if len(dane_typz) == 0:
                    stat="BL TYP ZAM"
                    dane.append(stat)

        if stat=='OK':
            for i in range(len(Pola)):
                pole = Pola[i]
                wart = Wartosci[i]
                if pole == "kontrahent_id":
                    if wart == "":
                        stat="BR KONTR"
                        dane.append(stat)
                    else:                                       #AB 06.08.19r
                        sql = "SELECT kontrahent_id,zablokowany, czy_mpp FROM rs_kontrahenci WHERE firma_id=\'"+self.firma_id+"\' AND kontrahent_id = \'"+wart+"\' AND aktywny;"

                        rsglobal.ZapiszDoLogow(sql, 5)
                        stat,dane_wyn,dump,dump = self.PolSQL.Execute(sql ,3)
                        if len(dane_wyn) == 0:
                            stat="BL KONTR"
                            dane.append(stat)
                        elif dane_wyn[0][1]:
                            stat="KONTR ZABL"
                            dane.append(stat)
                            #AB 06.08.19r
                        else:
                            MPPKontrahent = dane_wyn[0][2]

                elif pole == "wyznacznik_id" and stat== 'OK':
                    if wart == "":
                        stat="BR WYZN"
                        dane.append(stat)
                    else:
                        stat,dane_wyn,dump,dump = self.PolSQL.Execute("SELECT wyznacznik_id FROM rs_wyznaczniki WHERE firma_id=\'"+self.firma_id+"\' AND wyznacznik_id = \'"+wart+"\';",3)
                        if len(dane_wyn) == 0:
                            stat="BL WYZN"
                            dane.append(stat)

                elif pole == "numer" and stat== 'OK':
                    if wart <=0:
                        stat="BL NUMER"
                        dane.append(stat)

                elif pole == "oddzial_id" and stat== 'OK':
                    if wart == "":
                        stat="BR ODDZ"
                        dane.append(stat)
                    else:
                        if wart <> Oddzial:
                            stat="NG ODDZ"
                            dane.append(stat)

                elif pole == "stan" and stat== 'OK':
                    if wart == "":
                        stat="BR STAN"
                        dane.append(stat)
                    else:
                        if not wart in ["W","Z"]:
                            stat="BL STAN"
                            dane.append(stat)

                elif pole == "zamawiajacy_id" and stat== 'OK':
                    if wart == "":
                        stat="BR ZAMAW"
                        dane.append(stat)
                    else:
                        stat,dane_wyn,dump,dump = self.PolSQL.Execute("SELECT kontrahent_id FROM rs_kontrahenci WHERE firma_id=\'"+self.firma_id+"\' AND kontrahent_id = \'"+wart+"\' AND aktywny;",3)
                        if len(dane_wyn) == 0:
                            stat="BL ZAMAW"
                            dane.append(stat)

                elif pole == "platnik_id" and stat== 'OK':
                    if wart == "":
                        stat="BR PLATNIK"
                        dane.append(stat)
                    else:                                           #AB 06.08.19r
                        rsglobal.ZapiszDoLogow("SELECT kontrahent_id, czy_mpp FROM rs_kontrahenci WHERE firma_id=\'"+self.firma_id+"\' AND kontrahent_id = \'"+wart+"\' AND aktywny;", 5)
                        stat,dane_wyn,dump,dump = self.PolSQL.Execute("SELECT kontrahent_id, czy_mpp FROM rs_kontrahenci WHERE firma_id=\'"+self.firma_id+"\' AND kontrahent_id = \'"+wart+"\' AND aktywny;",3)
                        if len(dane_wyn) == 0:
                            stat="BL PLATNIK"
                            dane.append(stat)
                            #AB 06.08.19r
                        else:
                            MPPPlatnik = dane_wyn[0][1]
#---------- platnik_id end ------------------------------------
                elif pole == "kierowca" and stat== 'OK':
                    if wart<>'':
                        stat,dane_wyn,dump,dump = self.PolSQL.Execute("SELECT kod FROM rs_kierowcy WHERE firma_id=\'"+self.firma_id+"\' AND kod = \'"+wart+"\';",3)
                        if len(dane_wyn) == 0:
                            stat="BL KIEROWCA"
                            dane.append(stat)
#---------- kierowca end -----------------------------------------
                elif pole == "miejsce_dostawy_id" and stat== 'OK':
                    if wart == "":
                        Wartosci[i] = "NULL"
                    else:
                        stat,dane_wyn,dump,dump = self.PolSQL.Execute("SELECT kontrahent_id FROM rs_kontrahenci WHERE firma_id=\'"+self.firma_id+"\' AND kontrahent_id = \'"+wart+"\' AND aktywny;",3)
                        if len(dane_wyn) == 0:
                            stat= "BL MIEJDOST"
                            dane.append(stat)
#---------- miejsce_dostawy_id end ----------------------------
                #AB 14.06.21r
                elif pole == "status_zamowienia":
                    if wart == "":
                        Wartosci[i] = "NULL"
                    else:
                        st,dane_wyn,dump,dump = self.PolSQL.Execute("SELECT kod FROM rs_zamowienia_dostawcy_statusy WHERE firma_id='"+self.firma_id+"' AND kod = '"+wart+"';",3)
                        if st<>'OK':
                            stat='BL SQL STATUS'
                            dane.append(stat)
                        elif len(dane_wyn) == 0:
                            stat="BL STATUS"
                            dane.append(stat)
#---------- status_zamowienia end ----------------------------
                elif pole == "dostawy_od_dnia" and stat== 'OK':
                    if wart == "    -  -  ":
                        Wartosci[i] = "NULL"
                    else:
                        dane_wyn = rsglobal.SprawdzCzyToData(wart)
                        if not dane_wyn:
                            stat="BL DATADOD"
                            dane.append(stat)
#---------- dostawa_od end ------------------------------------
                elif pole == "dostawy_do_dnia" and stat== 'OK':
                    if wart == "    -  -  ":
                        Wartosci[i] = "NULL"
                    else:
                        dane_wyn = rsglobal.SprawdzCzyToData(wart)
                        if not dane_wyn:
                            stat="BL DATADDO"
                            dane.append(stat)
#---------- dostawa_do end ------------------------------------

                elif pole == "zamowienie_data" and stat== 'OK':
                    if wart == "    -  -  ":
                        Wartosci[i] = "NULL"
                    else:
                        dane_wyn = rsglobal.SprawdzCzyToData(wart)
                        if not dane_wyn:
                            stat="BL DATA ZAM"
                            dane.append(stat)
#---------- dostawa_do end --------------------------------
                elif pole == "waluta" and stat== 'OK':
                    if wart == "":
                        stat="BR WALUTA"
                        dane.append(stat)
                    else:
                        stat,dane_wyn,dump,dump = self.PolSQL.Execute("SELECT kod FROM rs_waluty WHERE firma_id=\'"+self.firma_id+"\' AND kod= \'"+wart+"\';",3)
                        if len(dane_wyn) == 0:
                            stat="BL WALUTA"
                            dane.append(stat)
                        else:
                            Waluta=wart
#---------- waluta end -----------------------------------------
                elif pole == "wersja" and stat== 'OK':
                    if wart == "":
                        Wartosci[i] = "NULL"
                    else:
                        stat,dane_wyn,dump,dump = self.PolSQL.Execute("SELECT kod FROM rs_wersje_cenowe WHERE firma_id=\'"+self.firma_id+"\' AND kod = \'"+wart+"\';",3)
                        if len(dane_wyn) == 0:
                            stat="BL WERSJA"
                            dane.append(stat)
                        else:
                            Wersja=wart
#-----------wersja end ----------------------------------------
                elif pole == "data_tabeli" and stat== 'OK':
                    if wart in ['    -  -  ','']:
                        Wartosci[i] = "NULL"
#----------data_tabeli end ------------------------------------
                elif pole == "sposob_zaplaty" and stat== 'OK':
                    if wart == "":
                        stat="BR SPOSZAPL"
                        dane.append(stat)
                    else:
                        stat,dane_wyn,dump,dump = self.PolSQL.Execute("SELECT kod FROM rs_sposoby_zaplaty WHERE firma_id=\'"+self.firma_id+"\' AND kod = \'"+wart+"\';",3)
                        if len(dane_wyn) == 0:
                            stat="BL SPOSZAPL"
                            dane.append(stat)
#---------- sposob_zaplaty end --------------------------------
                elif pole == "termin_zaplaty" and stat== 'OK':
                    if not rsglobal.SprawdzCzyToData(wart):
                        stat="BL TERM ZAPL"
                        dane.append(stat)
#---------- termin_zaplaty end --------------------------------
                elif pole == "sposob_dostawy" and stat== 'OK':
                    if wart == "":
                        Wartosci[i] = "NULL"
                        dane.append(stat)
                    else:
                        stat,dane_wyn,dump,dump = self.PolSQL.Execute("SELECT kod FROM rs_sposoby_dostaw WHERE firma_id=\'"+self.firma_id+"\' AND kod = \'"+wart+"\';",3)
                        if len(dane_wyn) == 0:
                            stat="BL SPOSDOST"
                            dane.append(stat)
#---------- sposob_dostawy end -------------------------------
                elif pole == "handlowiec" and stat== 'OK':
                    if wart == "":
                        Wartosci[i] = "NULL"
                    else:
                        stat,dane_wyn,dump,dump = self.PolSQL.Execute("SELECT kod FROM rs_handlowcy WHERE firma_id=\'"+self.firma_id+"\' AND kod = \'"+wart+"\';",3)
                        if len(dane_wyn) == 0:
                            stat="BL HANDL"
                            dane.append(stat)
#---------- handlowiec end -----------------------------------
                elif pole == "sposob_odbioru_faktury" and stat== 'OK':
                    if wart == "":
                        Wartosci[i] = "NULL"
                    else:
                        stat,dane_wyn,dump,dump = self.PolSQL.Execute("SELECT kod FROM rs_sposoby_odbioru_faktury WHERE firma_id=\'"+self.firma_id+"\' AND kod = \'"+wart+"\';",3)
                        if len(dane_wyn) == 0:
                            stat="BL SPOSODBFAKT"
                            dane.append(stat)
#---------- sposob_odbioru_faktury end -----------------------
                elif pole == "projekt_id" and stat== 'OK':
                    if wart == "":
                        Wartosci[i] = "NULL"
                    else:
                        stat,dane_wyn,dump,dump = self.PolSQL.Execute("SELECT projekt_id FROM rs_projekty WHERE firma_id='"+self.firma_id+"' AND projekt_id = '"+wart+"';",3)
                        if len(dane_wyn) == 0:
                            stat="BL PROJ"
                            dane.append(stat)
#-----------projekt_id end------------------------------------
                elif pole == "czy_proforma" and stat== 'OK':
                    if wart:
                        Wartosci[i] = "TRUE"
                    else:
                        Wartosci[i] = "FALSE"
#-----------czy_proforma end----------------------------------
                elif pole == "blokada_cen" and stat== 'OK':
                    if wart:
                        Wartosci[i] = "TRUE"
                    else:
                        Wartosci[i] = "FALSE"
#-----------blokada_cen end-----------------------------------
                elif pole == "upust":
                    Upust=wart
#-----------upust end-----------------------------------------
                elif pole == "magazyn_id" and stat== 'OK':
                    if wart == "":
                        Wartosci[i] = "NULL"
                        dane.append(stat)
                    else:
                        sql ="SELECT magazyn_id FROM rs_magazyny"
                        sql+=" WHERE firma_id='"+self.firma_id+"'"
                        sql+=" AND magazyn_id='"+wart+"';"

                        stat,dane_wyn,dump,dump = self.PolSQL.Execute(sql,3)
                        if stat <> 'OK':
                            stat = 'Bd sprawdzenia magazynu: '+stat
                            dane.append(stat)
                        elif len(dane_wyn) == 0:
                            stat="BL MAGAZYN"
                            dane.append(stat)
                        elif self.operator_id <> STANDARD_OPERATOR_ID:
                            sql ="SELECT DISTINCT magazyn_id"
                            sql+=" FROM rs_magazyny_upr"
                            sql+=" WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+wart+"'"
                            sql+=" AND operator_id IN "+str(self.operatorzy).replace("[","(").replace("]",")")+";"

                            stat,d,dump,dump= self.PolSQL.Execute(sql,3)
                            if stat <> 'OK':
                                stat='Bd pobrania listy dozwolonych magazynw: '+stat
                                dane.append(stat)
                            elif len(d) == 0:
                                stat = 'BL MAGAZYN NUPR'
                                dane.append(stat)
#-----------magazyn_id end-----------------------------------


#-------------------------------------------------------------------------------
#-------------------------------------------------------------------------------
#---   UPDATE DANYCH (4- bez pobierania,3- z pobieraniem)
#-------------------------------------------------------------------------------
#-------------------------------------------------------------------------------

if stat == "OK" and Funkcja in [4,3]:
    if not (UprEdy and (Wyznacznik in LEdy)) and self.operator_id <> STANDARD_OPERATOR_ID:
        stat='BR_UPR_EDY'
        dane.append(stat)
    if stat=='OK':
        ZmKurs=False
        dane = []
        sql = "UPDATE rs_zamowienia_odbiorcy SET "
        Filtr = "firma_id=\'"+self.firma_id+"\' AND wyznacznik_id=\'"+Wyznacznik+"\' AND data=\'"+Data+"\' AND numer="+str(Numer)
        for i in range(len(Pola)):
            wart = Wartosci[i]
            pole = Pola[i]
            if pole in ["zamowienie_data","typ_zamowienia","miejsce_dostawy_id",
                        "kierowca","dostawy_od_dnia","data_tabeli","dostawy_do_dnia",
                        "handlowiec","sposob_odbioru_faktury","sposob_dostawy",
                        "wersja","projekt_id","opis","magazyn_id", "status_zamowienia"]:
                if wart == "NULL":
                    sql += pole+"="+str(wart)+","
                else:
                    sql += pole+"=\'"+str(wart)+"\',"
            elif pole in ["numer","dni","data_odbioru","upust","upust_wartosc","upust_wartosc_wal","rabat","rabat_wartosc","rabat_wartosc_wal","kwota_netto","kwota_vat","wartosc_opakowan","do_zaplaty","kwota_netto_wal","kwota_vat_wal","wartosc_opakowan_wal","do_zaplaty_wal","czy_proforma","blokada_cen","priorytet"]:
            #elif pole in ["numer","dni","data_odbioru","upust","rabat","wartosc_opakowan","wartosc_opakowan_wal","czy_proforma","blokada_cen","priorytet"]:
                sql += pole+"="+str(wart)+","
            elif pole in ["zamowienie_nr","wyznacznik_id","data","oddzial_id","stan","kontrahent_id","termin_zaplaty","zamawiajacy_id","platnik_id","waluta","nr_tabeli","sposob_zaplaty","tekst_nad_podp","tekst_pod_podp"]:
                sql += pole+"=\'"+str(wart)+"\',"
            elif pole in ["kurs"]:
                ZmKurs=True
                Kurs=wart
                sql += pole+"="+str(wart)+","
                #AB 06.08.19r
            elif pole == 'czy_mpp':
                war = "{} OR {} OR {}".format('TRUE' if wart else 'FALSE', 'TRUE' if MPPPlatnik else 'FALSE',
                                              'TRUE' if MPPKontrahent else 'FALSE')
                sql += pole+"=("+war+"),"
        if 'czy_mpp' not in Pola:
            war = "czy_mpp OR {} OR {}".format('TRUE' if MPPPlatnik else 'FALSE', 'TRUE' if MPPKontrahent else 'FALSE')
            sql += "czy_mpp=("+war+"),"
        sql = sql.strip(',')
        sql += " WHERE "+Filtr+";"
        #sprawdzam stan zamwienia przed update
        sprSql  ="SELECT stan from rs_zamowienia_odbiorcy WHERE firma_id='"+self.firma_id+"'"
        sprSql +=" AND wyznacznik_id='"+Wyznacznik+"' AND data='"+Data+"'"
        sprSql +=" AND stan!='Z' AND numer='"+Numer+"' FOR UPDATE NOWAIT;"
        stat,d,dump,dump = self.PolSQL.Execute(sprSql,3)
        if stat<>'OK':
            stat="Bdy zapytania sprawdzajcego stan zamwienia przed aktualizacj danych "+stat
            dane.append(stat)
        elif len(d)==0:
            stat='STAN GN'
            dane.append(stat)
        # update waciwy
        else:
            rsglobal.ZapiszDoLogow(sql, 5)
            stat,dump,dump,dump = self.PolSQL.Execute(sql ,1)
            if stat != 'OK':
                stat = 'BL_UPD'
                dane.append(stat)
            else:
                sql=''

            if (Wersja<>'' or Upust<>-1 or Kontrahent<>'' or 'kurs' in Pola) :
                sql=''
                Select="SELECT kontrahent_id,wersja,upust,waluta,kurs FROM rs_zamowienia_odbiorcy WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyznacznik+"' AND data='"+Data+"' AND numer="+Numer
                stat,d,dump,dump = self.PolSQL.Execute(Select,3)
                if stat=='OK':
                    if Kontrahent=='':
                        Kontrahent=rsglobal.Dekoduj(d[0][0])
                    if Wersja=='' and rsglobal.Dekoduj(d[0][1]) <> 'None':
                        Wersja=rsglobal.Dekoduj(d[0][1])
                    if Upust== -1:
                        Upust=d[0][2]
                    if Waluta=='':
                        Waluta=rsglobal.Dekoduj(d[0][3])
                    if Kurs== 0:
                        Kurs=d[0][4]
                    stat,dane_wyn,dump,dump = self.PolSQL.Execute("SELECT nr_poz,nr_ppoz,artykul_id,ilosc1,cena_wal1,cena_wal2,cena_netto1,cena_netto2,cena_brutto1,cena_brutto2 FROM rs_zamowienia_odbiorcy_pozycje WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyznacznik+"' AND data='"+Data+"' AND numer="+str(Numer)+"; ",3)
                    if stat<>'OK':
                        stat='Bd pobierania danych: '+stat
                        dane.append(stat)
                    else:
                        for i in dane_wyn:
                            CaseVAT="CASE WHEN stawka_vat IN ("+str(self.ListaStawekZn)[1:-1]+") THEN 0 ELSE stawka_vat::INT END"
                            sdl="SELECT rsf_podaj_ceny_dla_kontrahenta('"+self.firma_id+"',CAST('"+Kontrahent+"' AS TEXT),CAST('"+Waluta+"' AS TEXT),CAST('"+Data+"' AS TEXT),CAST('"+rsglobal.Dekoduj(i[2])+"' AS TEXT),CAST('"+Wersja+"' AS TEXT),"+str(Upust)+")"
                            stat,d_c,dump,dump=self.PolSQL.Execute(sdl,3)
                            if stat=='OK':
                                d=eval(d_c[0][0])
                                if d<>[0,0,0,0,0,0,0,0,0]:
                                    Ilosc1=i[3]
                                    Upust=d[8]
                                    CenaWal1=d[0]
                                    CenaWal2=d[1]
                                    CenaUpustWal1=rsglobal.RSRound(CenaWal1*((100-Upust)*0.01),2)
                                    CenaUpustWal2=rsglobal.RSRound(CenaWal2*((100-Upust)*0.01),2)
                                    WartoscWalNetto=rsglobal.RSRound(d[4]*Ilosc1,2)

                                    if ZmKurs:
                                        CenaNetto1=rsglobal.RSRound(CenaWal1*Kurs,2)
                                        CenaNetto2=rsglobal.RSRound(CenaWal2*Kurs,2)
                                        CenaBrutto1=rsglobal.RSRound(d[6]*Kurs,2)
                                        CenaBrutto2=rsglobal.RSRound(d[7]*Kurs,2)
                                        CenaUpust1=rsglobal.RSRound(d[4]*Kurs,2)
                                        CenaUpust2=rsglobal.RSRound(d[5]*Kurs,2)
                                        UpustWartosc=rsglobal.RSRound(rsglobal.RSRound(d[0]-d[4],2)*Ilosc1*Kurs,2)
                                    else:
                                        CenaNetto1=rsglobal.RSRound(CenaWal1,2)
                                        CenaNetto2=rsglobal.RSRound(CenaWal2,2)
                                        CenaBrutto1=rsglobal.RSRound(d[6],2)
                                        CenaBrutto2=rsglobal.RSRound(d[7],2)
                                        CenaUpust1=rsglobal.RSRound(d[4],2)
                                        CenaUpust2=rsglobal.RSRound(d[5],2)
                                        UpustWartosc=rsglobal.RSRound(rsglobal.RSRound(d[0]-d[4],2)*Ilosc1,2)

                                    WartoscNetto=rsglobal.RSRound(CenaUpust1*i[3],2)
                                    UpustWartoscWal=rsglobal.RSRound(rsglobal.RSRound(CenaWal1-CenaUpustWal1,2)*Ilosc1,2)

                                else:
                                    Wersja='BRAK'
                                    Ilosc1=i[3]
                                    CenaWal1=i[4]
                                    CenaWal2=i[5]
                                    CenaUpustWal1=rsglobal.RSRound(CenaWal1*((100-Upust)*0.01),2)
                                    CenaUpustWal2=rsglobal.RSRound(CenaWal2*((100-Upust)*0.01),2)
                                    WartoscWalNetto=rsglobal.RSRound(CenaUpustWal1*Ilosc1,2)
                                    CenaNetto1=rsglobal.RSRound(CenaWal1*Kurs,2)
                                    CenaNetto2=rsglobal.RSRound(CenaWal2*Kurs,2)
                                    CenaBrutto1=rsglobal.RSRound(i[8]*Kurs,2)
                                    CenaBrutto2=rsglobal.RSRound(i[9]*Kurs,2)
                                    CenaUpust1=rsglobal.RSRound(CenaNetto1*((100-Upust)*0.01),2)
                                    CenaUpust2=rsglobal.RSRound(CenaNetto2*((100-Upust)*0.01),2)
                                    WartoscNetto=rsglobal.RSRound(CenaUpust1*i[3],2)
                                    UpustWartosc=rsglobal.RSRound(rsglobal.RSRound(CenaNetto1-CenaUpust1,2)*Ilosc1,2)
                                    UpustWartoscWal=rsglobal.RSRound(rsglobal.RSRound(CenaWal1-CenaUpustWal1,2)*Ilosc1,2)

                                rsglobal.ZapiszDoLogow('kurs '+str(Kurs),1)
                                rsglobal.ZapiszDoLogow(Wersja,1)
                                rsglobal.ZapiszDoLogow(CenaWal1,1)
                                rsglobal.ZapiszDoLogow(CenaWal2,1)
                                rsglobal.ZapiszDoLogow(CenaUpustWal1,1)
                                rsglobal.ZapiszDoLogow(CenaUpustWal2,1)
                                rsglobal.ZapiszDoLogow(CenaNetto1,1)
                                rsglobal.ZapiszDoLogow(CenaNetto2,1)
                                rsglobal.ZapiszDoLogow(CenaBrutto1,1)
                                rsglobal.ZapiszDoLogow(CenaBrutto2,1)
                                rsglobal.ZapiszDoLogow('cena u1 '+str(CenaUpust1),1)
                                rsglobal.ZapiszDoLogow(CenaUpust2,1)
                                rsglobal.ZapiszDoLogow(WartoscNetto,1)
                                rsglobal.ZapiszDoLogow(WartoscWalNetto,1)
                                rsglobal.ZapiszDoLogow(UpustWartosc,1)
                                rsglobal.ZapiszDoLogow(UpustWartoscWal,1)


                                Update="UPDATE rs_zamowienia_odbiorcy_pozycje SET cena_wal1=round("+str(CenaWal1)+",2)"
                                Update+=",cena_wal2=round("+str(CenaWal2)+",2),cena_upust_wal1=round("+str(CenaUpustWal1)+",2)"
                                Update+=",cena_upust_wal2=round("+str(CenaUpustWal2)+",2),wartosc_wal_netto=round("+str(WartoscWalNetto)+",2)"

                                Update+=",wartosc_wal_vat=round(("+str(WartoscWalNetto)+"*"+CaseVAT+")*0.01,2)"
                                Update+=",wartosc_wal_brutto=round("+str(WartoscWalNetto)+"+(("+str(WartoscWalNetto)+"*"+CaseVAT+")*0.01),2)"
                                Update+=",cena_netto1=round("+str(CenaNetto1)+",2)"
                                Update+=",cena_netto2=round("+str(CenaNetto2)+",2)"
                                Update+=",cena_brutto1=round("+str(CenaBrutto1)+",2)"
                                Update+=",cena_brutto2=round("+str(CenaBrutto2)+",2)"
                                Update+=",cena_upust1=round("+str(CenaUpust1)+",2)"
                                Update+=",cena_upust2=round("+str(CenaUpust2)+",2)"
                                Update+=",wartosc_netto=round("+str(WartoscNetto)+",2)"
                                Update+=",wartosc_vat=round(("+str(WartoscNetto)+"*"+CaseVAT+" )*0.01,2)"
                                Update+=",wartosc_brutto=round("+str(WartoscNetto)+"+(("+str(WartoscNetto)+"*"+CaseVAT+" )*0.01),2),upust=round("+str(Upust)+",2)"
                                Update+=",upust_wartosc=round("+str(UpustWartosc)+",2)"

                                Update+=" WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyznacznik+"' AND data='"+Data+"' AND numer="+str(Numer)+" AND nr_poz="+str(i[0])+" AND nr_ppoz="+str(i[1])+" ; "
                                rsglobal.ZapiszDoLogow("UPD CEN "+Update,1)
                                sql=sql+Update

                stat,dane_wyn,dump,dump = self.PolSQL.Execute("SELECT nr_poz FROM rs_zamowienia_odbiorcy_pozycje_opisowe WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyznacznik+"' AND data='"+Data+"' AND numer="+str(Numer)+"; ",3)
                if len(dane_wyn) > 0:
                    Update="UPDATE rs_zamowienia_odbiorcy_pozycje_opisowe SET wartosc_netto=round(wartosc_wal_netto*"+str(Kurs)+",2),wartosc_vat=round(wartosc_wal_vat*"+str(Kurs)+",2),wartosc_brutto=round(wartosc_wal_brutto*"+str(Kurs)+",2) WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyznacznik+"' AND data='"+Data+"' AND numer="+str(Numer)+"; "
                    sql=sql+Update

            #sprawdzenie czy nie zmieniamy VATU na "np"
            if 'nie_podlega_vat' in Pola and stat=='OK':
                if NiePodlVAT:
                    #nie podlega
                    UpdKrajPZ="UPDATE rs_zamowienia_odbiorcy_pozycje SET stawka_vat='np',cena_brutto1=cena_netto1,cena_brutto2=cena_netto2,wartosc_vat=0,wartosc_brutto=wartosc_netto,wartosc_wal_vat=0,wartosc_wal_brutto=wartosc_wal_netto WHERE "+Filtr+";"
                    UpdKrajPO="UPDATE rs_zamowienia_odbiorcy_pozycje_opisowe SET stawka_vat='np',wartosc_vat=0,wartosc_brutto=wartosc_netto,wartosc_wal_vat=0,wartosc_wal_brutto=wartosc_wal_netto WHERE "+Filtr+" ;"
                    sql+=UpdKrajPZ
                    sql+=UpdKrajPO
                else:
                    #wiemy ze podlega i sie zmienia czyli trzeba uwzglednic kraj opodatkowania
                    if not 'kraj_opodatkowania' in Pola:
                        #nie wiadomo jaki kraj to trzeba go pobrac
                        SQL = "SELECT kraj_opodatkowania FROM rs_zamowienia_odbiorcy WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyznacznik+"' AND data='"+Data+"' AND numer="+str(Numer)
                        stat,DaneK,dump,dump=self.PolSQL.Execute(SQL,3)
                        if stat=='OK':
                            Kraj=DaneK[0][0]

                    if Kraj <>'PL' and stat=='OK':
                        #zamiana vatu np na vat 0.
                        UpdKrajPZ="UPDATE rs_zamowienia_odbiorcy_pozycje SET stawka_vat='00' WHERE "+Filtr+";"
                        UpdKrajPO="UPDATE rs_zamowienia_odbiorcy_pozycje_opisowe SET stawka_vat='00' WHERE "+Filtr+";"
                        sql+=UpdKrajPZ
                        sql+=UpdKrajPO
                    elif stat=='OK':
                        #zamiana vatu "np" na stawki vat z artykulow
                        VAT=" (SELECT a.stawka_vat FROM rs_artykuly a WHERE a.firma_id=rs_zamowienia_odbiorcy_pozycje_pozycje.firma_id AND a.artykul_id=rs_zamowienia_odbiorcy_pozycje_pozycje.artykul_id) "
                        PrVAT=" (SELECT CASE WHEN a.stawka_vat IN ("+str(self.ListaStawekZn)[1:-1]+") THEN 0 ELSE (0.01*CAST (a.stawka_vat AS integer)) END FROM rs_artykuly a WHERE a.firma_id=rs_zamowienia_odbiorcy_pozycje.firma_id AND a.artykul_id=rs_zamowienia_odbiorcy_pozycje.artykul_id) "
                        UpdKrajPZ="UPDATE rs_zamowienia_odbiorcy_pozycje SET stawka_vat="+VAT+",cena_brutto1=cena_netto1*(1+"+PrVAT+"),cena_brutto2=cena_netto2*(1+"+PrVAT+"),"
                        UpdKrajPZ+="wartosc_vat=wartosc_netto*"+PrVAT+",wartosc_brutto=wartosc_netto*(1+"+PrVAT+"),wartosc_wal_vat=wartosc_wal_netto*"+PrVAT+",wartosc_wal_brutto=wartosc_wal_netto*(1+"+PrVAT+") WHERE "+Filtr+" ;"
                        sql+=UpdKrajPZ

            elif 'kraj_opodatkowania' in Pola :
                #zmiana vatu w zalenoci od kraju opodatkowania
                if Kraj<> 'PL':
                    #zamiana dowolnego vatu na vat 0.
                    UpdKrajPZ="UPDATE rs_zamowienia_odbiorcy_pozycje SET stawka_vat='00',cena_brutto1=cena_netto1,cena_brutto2=cena_netto2,wartosc_vat=0,wartosc_brutto=wartosc_netto,wartosc_wal_vat=0,wartosc_wal_brutto=wartosc_wal_netto WHERE "+Filtr+";"
                    UpdKrajPO="UPDATE rs_zamowienia_odbiorcy_pozycje_opisowe SET stawka_vat='00',wartosc_vat=0,wartosc_brutto=wartosc_netto,wartosc_wal_vat=0,wartosc_wal_brutto=wartosc_wal_netto WHERE "+Filtr+" ;"
                    sql+=UpdKrajPZ
                    sql+=UpdKrajPO
                else:
                    #zamiana na stawki vat z artykulow
                    VAT=" (SELECT a.stawka_vat FROM rs_artykuly a WHERE a.firma_id=rs_zamowienia_odbiorcy_pozycje.firma_id AND a.artykul_id=rs_zamowienia_odbiorcy_pozycje.artykul_id) "
                    PrVAT=" (SELECT CASE WHEN a.stawka_vat IN ("+str(self.ListaStawekZn)[1:-1]+") THEN 0 ELSE (0.01*CAST (a.stawka_vat AS integer)) END FROM rs_artykuly a WHERE a.firma_id=rs_zamowienia_odbiorcy_pozycje.firma_id AND a.artykul_id=rs_zamowienia_odbiorcy_pozycje.artykul_id) "
                    UpdKrajPZ="UPDATE rs_zamowienia_odbiorcy_pozycje SET stawka_vat="+VAT+",cena_brutto1=cena_netto1*(1+"+PrVAT+"),cena_brutto2=cena_netto2*(1+"+PrVAT+"),"
                    UpdKrajPZ+="wartosc_vat=wartosc_netto*"+PrVAT+",wartosc_brutto=wartosc_netto*(1+"+PrVAT+"),wartosc_wal_vat=wartosc_wal_netto*"+PrVAT+",wartosc_wal_brutto=wartosc_wal_netto*(1+"+PrVAT+") WHERE "+Filtr+" ;"
                    sql+=UpdKrajPZ


            if stat=='OK' and sql<>'':
                rsglobal.ZapiszDoLogow(sql,1)
                stat,dump,dump,dump = self.PolSQL.Execute(sql ,1)
                if stat != 'OK':
                    stat = 'BL_SQL'
                    dane.append(stat)

#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (5 -select, 3 -update z pobraniem, 1 -insert z pobraniem)
#-------------------------------------------------------------------------------

if (Funkcja in [5,3,1]) and (stat=='OK'):
    if not (UprPrz and (Wyznacznik in LPrz)) and self.operator_id <> STANDARD_OPERATOR_ID:
        stat='BR_UPR_PRZ'
        dane.append(stat)
    if stat=='OK':
        where="WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyznacznik+"' AND data='"+Data+"' AND numer='"+Numer+"' "
        sql = " SELECT * FROM rs_zamowienia_odbiorcy " + where + ";"

        # pobranie danych
        stat,dane,wyn1,tr = self.PolSQL.Execute(sql,3)
        rsglobal.ZapiszDoLogow('dane po update <<<<<<<<<<<<<<<<<<<<<<<<<<<<<>>>>>>>>>>>>>>>>>>>>>>>>>>',3)
        rsglobal.ZapiszDoLogow(dane,3)
        #pobranie danych do opisow
        if len(dane) == 1:
            tr = rssql.RSTableRowset(dane,wyn1)

            #odbiorca (0)
            if ((self.oddzial_id,'012010') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
                dump,d,dump,dump = self.PolSQL.Execute("SELECT nazwa FROM rs_kontrahenci WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+tr.GetVal(0,"kontrahent_id")+"';" ,3)
                if len(d) == 0:
                    wyn2.append('')
                else:
                    wyn2.append(d[0][0])
            else:
                wyn2.append('Brak uprawnie do sownika. Poinformuj administratora.')

            #zamawiajacy (1)
            if ((self.oddzial_id,'012010') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
                dump,d,dump,dump = self.PolSQL.Execute("SELECT nazwa FROM rs_kontrahenci WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+tr.GetVal(0,"zamawiajacy_id")+"';" ,3)
                if len(d) == 0:
                    wyn2.append('')
                else:
                    wyn2.append(d[0][0])
            else:
                wyn2.append('Brak uprawnie do sownika. Poinformuj administratora.')

            #platnik (2)
            if ((self.oddzial_id,'012010') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
                dump,d,dump,dump = self.PolSQL.Execute("SELECT nazwa FROM rs_kontrahenci WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+tr.GetVal(0,"platnik_id")+"';" ,3)
                if len(d) == 0:
                    wyn2.append('')
                else:
                    wyn2.append(d[0][0])
            else:
                wyn2.append('Brak uprawnie do sownika. Poinformuj administratora.')

            #miejsce dostawy (3)
            if ((self.oddzial_id,'012010') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
                dump,d,dump,dump = self.PolSQL.Execute("SELECT nazwa FROM rs_kontrahenci WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+tr.GetVal(0,"miejsce_dostawy_id")+"';" ,3)
                if len(d) == 0:
                    wyn2.append('')
                else:
                    wyn2.append(d[0][0])
            else:
                wyn2.append('Brak uprawnie do sownika. Poinformuj administratora.')

            #waluta (4)
            if ((self.oddzial_id,'011130') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
                dump,d,dump,dump = self.PolSQL.Execute("SELECT opis FROM rs_waluty WHERE firma_id='"+self.firma_id+"' AND kod='"+tr.GetVal(0,"waluta")+"';" ,3)
                if len(d) == 0:
                    wyn2.append('')
                else:
                    wyn2.append(d[0][0])
            else:
                wyn2.append('Brak uprawnie do sownika. Poinformuj administratora.')

            #wersja (5)
            if ((self.oddzial_id,'011100') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
                dump,d,dump,dump = self.PolSQL.Execute("SELECT opis FROM rs_wersje_cenowe WHERE firma_id='"+self.firma_id+"' AND kod='"+tr.GetVal(0,"wersja")+"';" ,3)
                if len(d) == 0:
                    wyn2.append('')
                else:
                    wyn2.append(d[0][0])
            else:
                wyn2.append('Brak uprawnie do sownika. Poinformuj administratora.')

            #sposob zaplaty (6)
            if ((self.oddzial_id,'011090') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
                dump,d,dump,dump = self.PolSQL.Execute("SELECT opis FROM rs_sposoby_zaplaty WHERE firma_id='"+self.firma_id+"' AND kod='"+tr.GetVal(0,"sposob_zaplaty")+"';" ,3)
                if len(d) == 0:
                    wyn2.append('')
                else:
                    wyn2.append(d[0][0])
            else:
                wyn2.append('Brak uprawnie do sownika. Poinformuj administratora.')

            #handlowiec (7)
            if ((self.oddzial_id,'011220') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
                dump,d,dump,dump = self.PolSQL.Execute("SELECT opis FROM rs_handlowcy WHERE firma_id='"+self.firma_id+"' AND kod='"+tr.GetVal(0,"handlowiec")+"';" ,3)
                if len(d) == 0:
                    wyn2.append('')
                else:
                    wyn2.append(d[0][0])
            else:
                wyn2.append('Brak uprawnie do sownika. Poinformuj administratora.')

            #sposob odbioru zamowienia (8)
            if ((self.oddzial_id,'011230') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
                dump,d,dump,dump = self.PolSQL.Execute("SELECT opis FROM rs_sposoby_odbioru_faktury WHERE firma_id='"+self.firma_id+"' AND kod='"+tr.GetVal(0,"sposob_odbioru_faktury")+"';" ,3)
                if len(d) == 0:
                    wyn2.append('')
                else:
                    wyn2.append(d[0][0])
            else:
                wyn2.append('Brak uprawnie do sownika. Poinformuj administratora.')

            #sposob dostawy (9)
            if ((self.oddzial_id,'011030') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
                dump,d,dump,dump = self.PolSQL.Execute("SELECT opis FROM rs_sposoby_dostaw WHERE firma_id='"+self.firma_id+"' AND kod='"+tr.GetVal(0,"sposob_dostawy")+"';" ,3)
                if len(d) == 0:
                    wyn2.append('')
                else:
                    wyn2.append(d[0][0])
            else:
                wyn2.append('Brak uprawnie do sownika. Poinformuj administratora.')

            #projekt (10)
            if ((self.oddzial_id,'027000') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
                dump,d,dump,dump = self.PolSQL.Execute("SELECT nazwa FROM rs_projekty WHERE firma_id='"+self.firma_id+"' AND projekt_id='"+tr.GetVal(0,"projekt_id")+"';" ,3)
                if len(d) == 0:
                    wyn2.append('')
                else:
                    wyn2.append(d[0][0])
            else:
                wyn2.append('Brak uprawnie do sownika. Poinformuj administratora.')

            #kierowca (11)
            if ((self.oddzial_id,'011250') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
                dump,d,dump,dump = self.PolSQL.Execute("SELECT opis FROM rs_kierowcy WHERE firma_id='"+self.firma_id+"' AND kod='"+tr.GetVal(0,"kierowca")+"';" ,3)
                if len(d) == 0:
                    wyn2.append('')
                else:
                    wyn2.append(d[0][0])
            else:
                wyn2.append('Brak uprawnie do sownika. Poinformuj administratora.')

            #czy handlowiec (12)
            Handlowiec=self.handlowiec_id
            if str(Handlowiec).strip() == 'None':
                wyn2.append('')
            else:
                wyn2.append(Handlowiec)

            #kontrola limitu zaleglosci (13)
            Stan = tr.GetVal(0,"stan")
            Kontrahent = tr.GetVal(0,"kontrahent_id")
            Kwota = tr.GetVal(0,"do_zaplaty")
            if Stan == 'W':
                limit = fs_zaleglosci_sprawdzenie.SprawdzLimitKontrahenta(self,Kontrahent,Kwota,Data)
                wyn2.append(limit)
            else:
                wyn2.append('')

            #magazyn_id (14)
            if ((self.oddzial_id,'031010') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
                dump,d,dump,dump = self.PolSQL.Execute("SELECT opis FROM rs_magazyny WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+tr.GetVal(0,"magazyn_id")+"';" ,3)
                if len(d) == 0:
                    wyn2.append('')
                else:
                    wyn2.append(d[0][0])
            else:
                wyn2.append('Brak uprawnie do listy magazynw. Poinformuj administratora.')

            #lista dozwolonych magazynow [[magazyn_id,opis]] (15)
            LDozwoloneMagazyny = []
            SQL ="SELECT magazyn_id, opis FROM rs_magazyny"
            SQL+=" WHERE firma_id='"+self.firma_id+"'"

            if self.operator_id <> STANDARD_OPERATOR_ID:
                sql ="SELECT DISTINCT magazyn_id"
                sql+=" FROM rs_magazyny_upr WHERE firma_id='"+self.firma_id+"'"
                sql+=" AND operator_id IN "+str(self.operatorzy).replace("[","(").replace("]",")")+";"

                stat,d,dump,dump= self.PolSQL.Execute(sql,3)
                if stat <> 'OK':
                    stat='Bd pobrania dozwolonych magazynw: '+stat
                    dane.append(stat)
                else:
                    if len(d)>0:
                        ListaMagazynow = "("
                        for i in xrange(len(d)):
                            ListaMagazynow += "'"+rsglobal.Dekoduj(d[i][0])+"'"
                            if i < len(d)-1:
                                ListaMagazynow += ","
                        ListaMagazynow += ")"
                        SQL+=" AND magazyn_id IN "+ListaMagazynow
                    else:
                        SQL+=" AND FALSE"

            SQL+=";"

            stat,LDozwoloneMagazyny,dump,dump = self.PolSQL.Execute(SQL,3)
            if stat <> 'OK':
                stat = 'Bd pobrania listy dozwolonych magazynw: '+stat
                dane.append(stat)
            elif not (self.operator_id == STANDARD_OPERATOR_ID or (self.oddzial_id,'031010') in self.uprawnienia):
                for i in xrange(len(LDozwoloneMagazyny)):
                    LDozwoloneMagazyny[i][1] = 'Brak uprawnie do listy magazynw. Poinformuj administratora.'
                
            wyn2.append(LDozwoloneMagazyny)

            #AB 14.06.21r
            #status zamowienia
            if ((self.oddzial_id,'211560') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
                dump,d,dump,dump = self.PolSQL.Execute("SELECT opis FROM rs_zamowienia_dostawcy_statusy WHERE firma_id='"+self.firma_id+"' AND kod='"+tr.GetVal(0,"status_zamowienia")+"';" ,3)
                if len(d) == 0:
                    wyn2.append('')
                else:
                    wyn2.append(d[0][0])
            else:
                wyn2.append('Brak uprawnie do sownika. Poinformuj administratora.')