#!/usr/bin/python
# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:             fs_zamowienia_odbiorcy_daty.py
# Purpose:          dodaje/pobiera/usuwa zamowienia odbiorcy
# Author:           Marcin Grzeda
# Created:          2007/10/13
# RCS-ID:           $Id: fs_zamowienia_odbiorcy_daty.py $
# Copyright:        (c) 2015 RecordSystem
# Licence:          GNU GPL
#-------------------------------------------------------------------------------

# 2011-08-05 Mariusz Rajfura  refaktoring
# 2015-12-26 Piotr Witkowski (9496) refaktoryzacja - okno gwne zamwie, Daty, pozycje opisowe, wartoci VAT

stat='OK'
if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=='OK':
    Funkcja = klucze['Funkcja']
    SlPar={'Wyznacznik':[5,6],'Data':[5,6],'Numer':[5,6],'NaKiedy':[6]}

    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Funkcja,klucze)
    if Lista<>'':
        stat=u'Uwaga : wywoanie funkcji fs_zamowienia_odbiorcy_daty z numerem ' +str(Funkcja)+u' bez parametrw: '+Lista
    if stat=='OK':
        DodF = []
        if Funkcja in [5,6]:
            Wyznacznik = str(klucze['Wyznacznik'])
            Data = str(klucze['Data'])
            Numer = str(klucze['Numer'])
        if Funkcja in [6]:
            NaKiedy = klucze['NaKiedy']

dane = []
wyn1 = []
wyn2 = []

UprDel = (self.oddzial_id,'024064') in self.uprawnienia or self.operator_id == STANDARD_OPERATOR_ID

    
#-------------------------------------------------------------------------------
# -- Usuwanie (6)
#-------------------------------------------------------------------------------

if Funkcja in (6,):
    if not UprDel:
        stat = "UPR DEL"   
        dane.append(stat)

    if stat == 'OK':
        sql ="DELETE FROM rs_zamowienia_odbiorcy_daty"
        sql+=" WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyznacznik+"'"
        sql+=" AND data='"+Data+"' AND numer="+str(Numer)
        sql+=" AND zamowienie_na_kiedy='"+NaKiedy+"';"
        stat,dump,dump,dump=self.PolSQL.Execute(sql,1)
        if stat <> 'OK':
            stat = 'BL SQL DEL'
            dane.append(stat)

            
#-------------------------------------------------------------------------------
# -- Pobieranie danych (5,6)
#-------------------------------------------------------------------------------

if Funkcja in (5,6) and stat == 'OK':
    sql ="SELECT zamowienie_nr,zamowienie_data,zamowienie_na_kiedy"
    sql+=" FROM rs_zamowienia_odbiorcy_daty"
    sql+=" WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyznacznik+"'"
    sql+=" AND data='"+Data+"' AND numer="+str(Numer)
    sql+=" ORDER BY zamowienie_data DESC,zamowienie_nr"
    stat,dane,wyn1,wyn2=self.PolSQL.Execute(rsglobal.Dekoduj(sql),3)
    if stat <> 'OK':
        stat = 'BL SQL SEL'
        dane.append(stat)