#!/usr/bin/python
# -*- coding: iso8859_2 -*-
#-----------------------------------------------------------------------------
# Name:			fs_zamowienia_odbiorcy_import_poz.py
# Purpose:		importuje pozycje na zamwienie odbiorcy
# Author:		Micha Raburski
# Created:		2010/11/03
# RCS-ID:		$Id: fs_zamowienia_odbiorcy_import_poz.py $
# Copyright:	(c) 2010 RecordSystem
# Licence:		GNU GPL
#-----------------------------------------------------------------------------

Wyznacznik = klucze[0]
Data=klucze[1]
Numer=str(klucze[2])
Wiersze=klucze[3]

stat = "OK"
dane = []

# sprawdzenie uprawnie
if self.operator_id != STANDARD_OPERATOR_ID:
    Lista=[self.firma_id,self.oddzial_id,self.operator_id]
    SQL = "SELECT rsf_podaj_wyznaczniki('"+str(Lista).replace("'",'"')+"','[]','[False,True,False,False,False,False]');"    
    stat,DWyzn,dump,dump=self.PolSQL.Execute(SQL,3)
    if stat=='OK':
        if not Wyznacznik in rsglobal.rseval(DWyzn[0][0])[1]:
            stat='Brak uprawnie do dodawania pozycji w zamwieniach o wyznaczniku '+Wyznacznik
        
if stat=='OK':
    FiltrZam=" firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyznacznik+"' AND data='"+Data+"' AND numer="+Numer
    
    # sprawdzenie istnienia zamwienia do ktrego dodajemy pozycje i blokada zamwienia do edycji
    SQL ="SELECT * FROM rs_zamowienia_odbiorcy WHERE "+FiltrZam+" FOR UPDATE NOWAIT"
    stat,DZam,dump,dump=self.PolSQL.Execute(SQL,3)
if stat=='OK':
    if len(DZam)==0:
        stat='Brak podanego zamwienia :'+Wyznacznik+'/'+Data+'/'+Numer+' w bazie danych'
    
if stat=='OK':
    # pobranie istniejcych pozycji w celu weryfikacji duplikacji indeksw artykuw
    SQL="SELECT nr_poz,nr_ppoz,artykul_id FROM rs_zamowienia_odbiorcy_pozycje WHERE "+FiltrZam+" ORDER BY nr_poz,nr_ppoz"
    stat,DPozZam,dump,dump=self.PolSQL.Execute(SQL,3)
if stat=='OK':
    NrPoz=0
    LPoz=[]
    for poz in DPozZam:
        NrPoz=poz[0]
        if not rsglobal.Dekoduj(poz[2].strip()) in LPoz:
            LPoz.append(rsglobal.Dekoduj(poz[2].strip()))
    
    # ptla po pozycjach z pliku
    Lp=0
    NrPoz=NrPoz+1
    LArtPlik=[]
    for wiersz in Wiersze:
        Lp=Lp+1
        if stat=='OK':
            # sprawdzenie istnienia artykuu i ew. pobranie danych
            w=wiersz.split(';')
            rsglobal.ZapiszDoLogow('! '+str(w)+' '+str(w[0]),1)
            if len(w)<>3:
                dane.append('Wiersz '+str(Lp)+'. Nieprawidowa liczba kolumn')
                continue
            
            Art=w[0].strip("'").strip('"').strip().strip("'").strip('"').strip().strip("'").strip('"').strip()
            SQL="SELECT CASE WHEN stawka_vat IN ("+str(self.ListaStawekZn)[1:-1]+") THEN '0' ELSE stawka_vat END,przelicznik,stawka_vat "
            SQL+=" FROM rs_artykuly WHERE firma_id='"+self.firma_id+"' AND artykul_id='"+Art+"'" 
            stat,DArt,dump,dump=self.PolSQL.Execute(SQL,3)
        if stat=='OK':
            if len(DArt)==0:
                dane.append('Wiersz '+str(Lp)+'. Brak artykuu o indeksie '+Art)
                continue
    
        if stat=='OK':
            # sprawdzenie czy artyku by na pozycjach/ w innym wierszu
            if Art in LPoz:
                dane.append('Wiersz '+str(Lp)+'. Artyku o indeksie '+Art+' wystpuje na pozycjach zamwienia')
            elif Art in LArtPlik:
                dane.append('Wiersz '+str(Lp)+'. Artyku o indeksie '+Art+' wystpuje we wczeniejszych wierszach pliku')

            # dodanie artykuu do listy artykuw z pliku
            LArtPlik.append(Art)
            
            # wstawienie pozycji zamwienia
            Ilosc1=str(w[1]).strip("'").strip('"').strip().strip("'").strip('"').strip().replace(',','.')
            CenaN1=str(w[2]).strip("'").strip('"').strip().strip("'").strip('"').strip().replace(',','.')
            StVat=rsglobal.Dekoduj(DArt[0][0])
            Przel=str(DArt[0][1])
            Ilosc2="ROUND("+Ilosc1+"*"+Przel+",4)"
            CenaB1="ROUND("+CenaN1+"*(100+"+StVat+")*0.01,2)"
            CenaN2="ROUND("+CenaN1+"/"+Przel+",2)"
            CenaB2="ROUND("+CenaN2+"*(100+"+StVat+")*0.01,2)"
            WartN="ROUND("+Ilosc1+"*"+CenaN1+",2)"
            WartV="ROUND("+WartN+"*"+StVat+"*0.01,2)"
            WartB=WartN+"+"+WartV
            
            INS="INSERT INTO rs_zamowienia_odbiorcy_pozycje "
            INS+="(firma_id, wyznacznik_id, data, numer, nr_poz, nr_ppoz, data_od, data_do, tryb_dostawy,"
            INS+="artykul_id, ilosc1, ilosc2, cena_netto1, cena_netto2, cena_upust1, cena_upust2,"
            INS+="cena_brutto1, cena_brutto2, upust, upust_wartosc, stawka_vat, "
            INS+="wartosc_netto, wartosc_vat, wartosc_brutto, nr_serii, termin_przyd,"
            INS+="cena_wal1, cena_wal2, cena_upust_wal1, cena_upust_wal2,"
            INS+="wartosc_wal_netto, wartosc_wal_vat, wartosc_wal_brutto,"
            INS+="dostarczono1, dostarczono2, anulowano1, anulowano2) VALUES "            
            INS+="('"+self.firma_id+"','"+Wyznacznik+"','"+Data+"',"+Numer+","+str(NrPoz)+",0,NULL,NULL,NULL,"
            INS+="'"+Art+"',"+Ilosc1+","+Ilosc2+","+CenaN1+","+CenaN2+","+CenaN1+","+CenaN2+","
            INS+=CenaB1+","+CenaB2+",0,0,'"+rsglobal.Dekoduj(DArt[0][0])+"',"
            INS+=WartN+","+WartV+","+WartB+",'',NULL,"
            INS+=CenaN1+","+CenaN2+","+CenaN1+","+CenaN2+","
            INS+=WartN+","+WartV+","+WartB+","
            INS+="0,0,0,0);"
            stat,dump,dump,dump=self.PolSQL.Execute(INS,1)
            if stat=='OK':
                NrPoz=NrPoz+1