#!/usr/bin/python
# -*- coding: iso8859_2 -*-
#-----------------------------------------------------------------------------
# Name:			fs_zamowienia_odbiorcy_pozycje_upr.py
# Purpose:		dodaje/pobiera/usuwa pozycje zamowienia odbiorcy w wersji uproszczonej
# Author:		Michal Raburski
# Created:		2008/10/27
# RCS-ID:		$Id: fs_zamowienia_odbiorcy_pozycje_upr.py $
# Copyright:	(c) 2004-2009 RecordSystem
# Licence:		GNU GPL
# 2010-11-25    Marcin Natkaski - blokada modyfikacji wierszy dla zamwie ze stanem <> W (mantis: 4085)
#-----------------------------------------------------------------------------

Wyznacznik = klucze[0]
Data=klucze[1]
Numer=klucze[2]

stat='OK'
wyn2=[]
UprPrzegl=True

Fun=klucze[-1]
dane=[]

if stat=='OK':
    Lista=[self.firma_id,self.oddzial_id,self.operator_id]
    sql = "SELECT rsf_podaj_wyznaczniki('"+str(Lista).replace("'",'"')+"','[]','None');"    
    stat,wyzn,dump,dump=self.PolSQL.Execute(sql,3)
if stat=='OK':
    LWyzn=rsglobal.rseval(wyzn[0][0])[1]

if stat=='OK':
    SQL = "SELECT rsf_podaj_uprawnienia_do_zamowienia_wzgledem_tras('"+self.firma_id+"','"+Wyznacznik+"','"+Data+"',"+str(Numer)+")"
    stat,DTras,dump,dump=self.PolSQL.Execute(SQL,3)
    if stat <> 'OK':
        stat = u"Wystpiy bdy sprawdzania uprawnie operatora do tras : "+stat
    else:
        UprTrasy = eval(DTras[0][0])

    # oglne uprawnienia
    if stat == 'OK':
        if self.operator_id == STANDARD_OPERATOR_ID:
            UprPrzeg=True
            UprEdy=True
            UprDod=True
            UprDel=True
        else:
            UprPrzeg = (self.oddzial_id,'024050') in self.uprawnienia
            UprEdy = (self.oddzial_id,'024052') in self.uprawnienia and UprTrasy[2]
            UprDel = ((self.oddzial_id,'024054') in self.uprawnienia)
            UprDod = ((self.oddzial_id,'024053') in self.uprawnienia) and UprTrasy[1]
       
#pobranie opisu i jednostki miary artykuu
if (Fun==7):
    Art=rsglobal.Dekoduj(klucze[3])
    SQL="SELECT nazwa,jm1 FROM rs_artykuly WHERE firma_id='"+self.firma_id+"' AND artykul_id='"+Art+"';"
    stat,dane,dump,dump=self.PolSQL.Execute(SQL,3)    
    

if (Fun==1):
    Update=klucze[-2]
    Insert=klucze[-3]
    Delete=klucze[-4]
    Kontr = ''
    Platnik = ''
    
    #sprawdzam stan zamwienia przed UPDATE i blokuje wiersze
    sprSql  ="SELECT * from rs_zamowienia_odbiorcy WHERE firma_id='"+self.firma_id+"'"
    sprSql +=" AND wyznacznik_id='"+Wyznacznik+"' AND data='"+Data+"'"
    sprSql +=" AND stan='W' AND numer='"+Numer+"' FOR UPDATE NOWAIT;"
    stat,d,dump,dump = self.PolSQL.Execute(sprSql,3)
    if stat<>'OK':
        stat="Bdy zapytania sprawdzajcego stan zamwienia przed aktualizacj danych "+stat
        dane.append(stat)
    elif len(d)==0:
        stat='STAN G'
        dane.append(stat)
    #---      
    if stat=='OK':
        SELECT="SELECT czy_stale,COALESCE(kontrahent_id,''),COALESCE(platnik_id,'') FROM rs_zamowienia_odbiorcy WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyznacznik+"' AND data='"+Data+"' AND numer="+Numer
        stat,d,dump,dump=self.PolSQL.Execute(SELECT,3)
        if stat == 'OK':
            if len(d)>0:
                if d[0][0]:
                    stat='ZAM STAL'
                    dane.append(stat) 
                else:
                    Kontr=d[0][1]
                    Platnik=d[0][2]
            else:
                stat='BR ZAM'
                dane.append(stat)

    if stat=='OK': #sprawdzanie danych
        for i in xrange(len(Update[0])):   # petla po ilosci wierszy updatowanych
            for j in xrange(len(Update[0][i])): # petla po pozycjach do zmiany
                pole=Update[0][i][j]
                wart=Update[1][i][j] 
                if pole=='artykul_id': 
                    if wart.strip()<>'':
                        Sql="Select artykul_id, aktywny,"
                        Sql+="rsf_podaj_date_limitu_zamowien('"+self.firma_id+"','"+wart+"','"+Kontr+"','"+Platnik+"','"+Data+"') " # data zamwienia jest graniczna i by byo ok powinna by wyliczonym limitem
                        Sql+=" FROM rs_artykuly WHERE firma_id='"+self.firma_id+"' AND artykul_id='"+str(wart)+"'"
                        stat,d,dump,dump=self.PolSQL.Execute(Sql,3)
                        if stat=='OK':
                            if len(d)==0:
                                stat='BL ART$'+str(Update[-1][i])
                                dane.append(stat)
                                wyn2.append([Update[-1][i],2])
                            elif not d[0][1]:
                                stat='ART AKT$'+str(Update[-1][i])
                                dane.append(stat)
                                wyn2.append([Update[-1][i],2])
                            elif Data > d[0][2]:
                                stat='ART LIMIT$'+str(Update[-1][i])
                                dane.append(stat)
                                wyn2.append([Update[-1][i],2])
                        else:
                            stat='BL SQL ART$'+str(st)
                            dane.append(stat)
                    else:
                        stat='BR ART$'+str(Update[-1][i])
                        dane.append(stat)
                        wyn2.append([Update[-1][i],2])
                        
                       
        for i in xrange(len(Insert[0])):
            for j in xrange(len(Insert[0][i])):
                pole=Insert[1][j]
                wart=Insert[0][i][j]
                if pole=='artykul_id': 
                    if wart.strip()<>'':
                        Sql="Select artykul_id, aktywny,"
                        Sql+="rsf_podaj_date_limitu_zamowien('"+self.firma_id+"','"+wart+"','"+Kontr+"','"+Platnik+"','"+Data+"') " # data zamwienia jest graniczna i by byo ok powinna by wyliczonym limitem
                        Sql+=" FROM rs_artykuly WHERE firma_id='"+self.firma_id+"' AND artykul_id='"+str(wart)+"'"
                        st,d,dump,dump=self.PolSQL.Execute(Sql,3)
                        if st=='OK':
                            if len(d)==0:
                                stat='BL ART$'+str(Insert[-1][i])
                                dane.append(stat)
                                wyn2.append([Insert[-1][i],2])
                            elif not d[0][1]:
                                stat='ART AKT$'+str(Insert[-1][i])
                                dane.append(stat)
                                wyn2.append([Insert[-1][i],2])
                            elif Data > d[0][2]:
                                stat='ART LIMIT$'+str(Insert[-1][i])
                                dane.append(stat)
                                wyn2.append([Insert[-1][i],2])
                        else:
                            stat='BL SQL ART$'+str(st)
                            dane.append(stat)
                    else:
                        stat='BR ART$'+str(Insert[-1][i])
                        dane.append(stat)
                        wyn2.append([Insert[-1][i],2])
                
        if len(dane)>0:
            stat=dane[-1]
    
    #FAKTYCZNA ZMIANA DANYCH
    if stat=='OK':
        if len(Delete[0])>0:
            if not UprDel:
                stat='BR UPRDEL'
            
    if stat=='OK':
        sql=''
        for i in xrange(len(Delete[0])):
            DELETE="DELETE FROM rs_zamowienia_odbiorcy_pozycje "
            WHERE="WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyznacznik+"' AND data='"+Data+"' AND numer="+Numer
            for j in xrange(len(Delete[0][i])):
                pole=Delete[1][j]
                wart=str(Delete[0][i][j])
                WHERE+=" AND "+pole+"='"+wart+"'"
            sql+=DELETE+WHERE+";"
        if sql<>'': 
            stat,dump,dump,dump=self.PolSQL.Execute(rsglobal.Dekoduj(sql),1)
            if stat<>'OK':
                stat='BL DEL'
                dane.append(stat)
        
    
    if stat=='OK':
        if len(Update[0])>0:
            if not UprEdy:
                stat='BR UPRUPD'
            
    if stat=='OK':
        sql=''
        for i in xrange(len(Update[0])):   # petla po ilosci wierszy updatowanych
            UPDATE="UPDATE rs_zamowienia_odbiorcy_pozycje "
            SET='SET '
            
            WHERE=" WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyznacznik+"' AND data='"+Data+"' AND numer="+Numer
            for j in xrange(len(Update[2][i])): # petla po kluczu
                pole=Update[3][j]
                wart=Update[2][i][j]
                WHERE+=" AND "+pole+"='"+str(wart)+"'"
            
            Przelicznik=0
            Ilosc2=''
            for j in xrange(len(Update[0][i])): # petla po pozycjach do zmiany
                pole=Update[0][i][j]
                wart=Update[1][i][j]
                if pole in ['artykul_id']:
                    if wart<>'':
                        SQL="SELECT rsf_podaj_vat_artykulu(firma_id,artykul_id,'"+Data+"'),przelicznik FROM rs_artykuly WHERE firma_id='"+self.firma_id+"' AND artykul_id='"+str(wart)+"'"
                        stat,d,dump,dump=self.PolSQL.Execute(SQL,3)
                        if stat<>'OK':
                            stat='BL SQL ART STVAT$'+str(st)
                            dane.append(stat)    
                        elif len(d)==0:
                                stat='BL ART$'+str(Update[2])
                                dane.append(stat)
                                wyn2.append([Update[2],0])
                        elif len(d[0][0])>2:
                            stat='BL ART VAT$'+str(Update[2][0])
                            dane.append(stat)
                            wyn2.append([Update[2][0],0])    
                        else:
                            SET+=pole+"='"+wart+"',"
                            SET+="stawka_vat='"+rsglobal.Dekoduj(d[0][0])+"',"
                            Przelicznik=d[0][1]
                            Ilosc2="ilosc2=round(ilosc1*"+str(d[0][1])+",2),"
                            
                            
            if Przelicznik==0 and stat=='OK':
                PodSQL="(SELECT artykul_id FROM rs_zamowienia_odbiorcy_pozycje "+WHERE+")"
                SQL="SELECT przelicznik FROM rs_artykuly WHERE firma_id='"+self.firma_id+"' AND artykul_id="+PodSQL
                stat,d,dump,dump=self.PolSQL.Execute(SQL,3)
                if stat<>'OK':
                    stat='BL SQL ART PRZEL$'+str(st)
                    dane.append(stat)    
                elif len(d)==0:
                    stat='BL ART$'+str(Insert[-1][i])
                    dane.append(stat)
                    wyn2.append([Insert[-1][i],0])
                else:
                    Przelicznik=d[0][0]
                
                
            for j in xrange(len(Update[0][i])): # petla po pozycjach do zmiany
                pole=Update[0][i][j]
                wart=Update[1][i][j]
                if pole in ['ilosc1']: 
                    SET+=pole+"="+str(wart)+","
                    Ilosc2="ilosc2="+str(rsglobal.RSRound(wart*Przelicznik,2))+","                    
                if pole in ['nr_poz']: 
                    SET+=pole+"="+str(wart)+","
                
            if Ilosc2 <> '':
                SET+=Ilosc2
            SET=SET.strip(",")
            
            sql+=UPDATE+SET+WHERE+";"
        if sql<>'' and stat=='OK': 
            stat,dump,dump,dump=self.PolSQL.Execute(rsglobal.Dekoduj(sql),1)
            if stat<>'OK':
                stat='BL UPD$'+str(st)
                dane.append(stat)
                
    if stat=='OK':    
        if len(Insert[0])>0:
            if not UprDod:
                stat='BR UPRINS'
            
    if stat=='OK':
        sql=''
        for i in xrange(len(Insert[0])):
            INSERT="INSERT INTO rs_zamowienia_odbiorcy_pozycje "
            KOLUMNY="(firma_id,wyznacznik_id,data,numer"
            VALUES=" VALUES ('"+self.firma_id+"','"+Wyznacznik+"','"+Data+"',"+Numer
            Przelicznik=0
            
            for j in xrange(len(Insert[0][i])):
                pole=Insert[1][j]
                wart=Insert[0][i][j]
                
                if pole =='artykul_id':
                    if wart=='':
                        stat='BL KLUCZ INS'
                        dane.append(stat)
                    else:
                        KOLUMNY+=","+pole
                        VALUES+=",'"+wart+"'"
                        SQL="SELECT rsf_podaj_vat_artykulu(firma_id,artykul_id,'"+Data+"'),przelicznik FROM rs_artykuly WHERE firma_id='"+self.firma_id+"' AND artykul_id='"+str(wart)+"'"
                        st,d,dump,dump=self.PolSQL.Execute(SQL,3)
                        if st=='OK':
                            if len(d)==0:
                                stat='BL ART$'+str(Insert[-1][i])
                                dane.append(stat)
                                wyn2.append([Insert[-1][i],0])
                            elif len(d[0][0])>2:
                                stat='BL ART VAT$'+str(Insert[-1][i])
                                dane.append(stat)
                                wyn2.append([Insert[-1][i],0])    
                            else:
                                KOLUMNY+=",stawka_vat"
                                VALUES+=",'"+rsglobal.Dekoduj(d[0][0])+"'"
                                Przelicznik=d[0][1]

                        else:
                            stat='BL SQL ART STVAT$'+str(st)
                            dane.append(stat)
                            
            for j in xrange(len(Insert[0][i])):
                pole=Insert[1][j]
                wart=Insert[0][i][j]
                
                if pole == 'ilosc1':
                    KOLUMNY+=","+pole
                    VALUES+=","+str(wart)
                    KOLUMNY+=",ilosc2"
                    VALUES+=","+str(rsglobal.RSRound(wart*Przelicznik,2))
                elif pole in ['nr_poz','nr_ppoz']:
                    KOLUMNY+=","+pole
                    VALUES+=","+str(wart)
                
    
            KOLUMNY+=")"
            VALUES+=");"
            sql+=INSERT+KOLUMNY+VALUES
        if sql<>'': 
            rsglobal.ZapiszDoLogow('INS '+sql)
            stat,dump,dump,dump=self.PolSQL.Execute(rsglobal.Dekoduj(sql),1)
            if stat<>'OK':
                stat='BL INS'
                dane.append(stat)            
                    

if (Fun in [1,5,6]) and (stat=='OK'):
    if UprPrzegl:    
        Select="SELECT zp.nr_poz,zp.nr_ppoz,zp.artykul_id,art.nazwa,zp.ilosc1,art.jm1 FROM rs_zamowienia_odbiorcy_pozycje zp "
        Select+=" INNER JOIN rs_artykuly art USING (firma_id,artykul_id) WHERE zp.firma_id='"+self.firma_id+"'"
        Select+=" AND zp.wyznacznik_id='"+Wyznacznik+"' AND zp.data='"+Data+"' AND zp.numer="+Numer 
        Select+=" ORDER BY zp.nr_poz,zp.nr_ppoz;"
        stat,dane,wyn,dump=self.PolSQL.Execute(Select,3)
            
    else:
        stat="BR_UPR_PRZ"

    if stat == 'OK':
        wyn1 = UprTrasy
