
# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_zmiany_dostepu_rodo.py
# Purpose:     Funkcje do grida nieedytowalnego z wpisami na temat zmian dostpw do systemw teleinformatycznych.
# Author:      Mikoaj Kozowski
# Created:     2019/06/20
# RCS-ID:      $Id: fs_zmiany_dostepu_rodo.py $
# Copyright:   (c) 2019 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

stat = 'OK'
if not 'Funkcja' in klucze:
    stat = 'Brak podanej funkcji w kluczach'

if stat == 'OK':
    Funkcja = klucze['Funkcja']

    SlPar = {'SystemF': [5,10 ], 'AnulowaneF': [5,10 ], 'PracownikF': [5,10 ],'DataOdF': [5,10 ],'DataDoF': [5,10 ], 'Numer': [10, ], 'Numery': [5, ] }
    Lista = rsglobal.SprawdzParametryWKluczach(SlPar, Funkcja, klucze)
    if Lista <> '':
        stat = 'Uwaga : wywoanie funkcji fs_dziennik_rodo.py ' + str(Funkcja) + ' bez parametrw: ' + Lista

    if Funkcja in [5,10 ]:
        SystemF = rsglobal.Dekoduj(klucze['SystemF'])
        AnulowaneF = rsglobal.Dekoduj(klucze['AnulowaneF'])
        PracownikF = rsglobal.Dekoduj(klucze['PracownikF'])
        DataOdF = rsglobal.Dekoduj(klucze['DataOdF'])
        DataDoF = rsglobal.Dekoduj(klucze['DataDoF'])
        Numery = rsglobal.Dekoduj(klucze['Numery'])
    if Funkcja in [10, ]:
        Numer = rsglobal.Dekoduj(klucze['Numer'])
dane = []
wyn1 = []
wyn2 = []
 
UprModyfikacja = ((self.oddzial_id,'002202') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)

#-------------------------------------------------------------------------------
#---   ANULOWANIE ROZLICZENIA (10)
#-------------------------------------------------------------------------------

if Funkcja == 10:
    if not UprModyfikacja:
        stat='UPR AN'
    if stat == 'OK':
        UPD=" UPDATE rs_rodo_zmiany_dostepu SET czy_anulowany=True WHERE firma_id='"+self.firma_id+"' AND lp="+str(Numer)+" AND czy_anulowany=False;"
        stat,dump,dump,dump = self.PolSQL.Execute(UPD,1)
        if stat<>'OK':
            stat="Nie udao si anulowa wpisu. Poinformuj serwis."
            dane.append(stat)

#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (5 -select, 10 -anulowanie)
#-------------------------------------------------------------------------------

if Funkcja in (5,10) and stat=='OK':
    Filtr="firma_id='"+self.firma_id+"'"
    
    if SystemF <> '':
        Filtr = Filtr+" AND z.system_teleinformatyczny='"+str(SystemF)+"'"

    if PracownikF <> '':
        PracownikF = ('000000' + str(PracownikF))[-6:]
        Filtr = Filtr+" AND z.zmieniony_pracownik='"+str(PracownikF)+"'"
    
    if AnulowaneF:
        Filtr+=" AND z.czy_anulowany="+str(AnulowaneF)

    if DataOdF.strip() <> '-  -':
        Filtr += " AND z.data >='"+DataOdF+"'"

    if DataDoF.strip() <> '-  -':
        Filtr += " AND z.data <='"+DataDoF+"'"
    
    SELECT ="SELECT z.system_teleinformatyczny, (z.zmieniony_pracownik||' - '||(SELECT o.imie||' '||o.nazwisko FROM rs_kp_dane_osobowe o WHERE firma_id='"+self.firma_id+"' AND z.zmieniony_pracownik=o.pracownik_id)) AS zmieniony_pracownik,"
    SELECT+="z.opis,z.data,(z.kto_zatwierdzil||' - '||(SELECT o.imie||' '||o.nazwisko FROM rs_kp_dane_osobowe o WHERE firma_id='"+self.firma_id+"' AND z.kto_zatwierdzil=o.pracownik_id)) AS kto_zatwierdzil,z.kto_zmodyfikowal,z.czy_anulowany,z.lp "
    SELECT+=" FROM rs_rodo_zmiany_dostepu z INNER JOIN rs_kp_dane_osobowe o USING (firma_id)"
    SELECT+="WHERE (("+Filtr+") OR firma_id='"+self.firma_id+"' AND lp IN ("+','.join(['NULL'] + Numery)+ ")) AND z.zmieniony_pracownik=o.pracownik_id ORDER BY data, lp;"
    stat,dane,wyn1,wyn2 = self.PolSQL.Execute(SELECT,3,CzyDodawacBlad=True )
    if stat <> 'OK':
        rsglobal.ZapiszDoLogow(SELECT)
        stat = "Bd przy pobieraniu danych: "+stat
        dane.append(stat)