
# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_zmiany_dostepu_rodo_dane.py
# Purpose:     wczytuje/dodaje dane w zmianach dostpw do systemw teleinformatycznych
# Author:      Mikoaj Kozowski
# Created:     2019/06/25
# RCS-ID:      $Id: fs_zmiany_dostepu_rodo_dane.py $
# Copyright:   (c) 2019 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

stat = 'OK'
if not 'Funkcja' in klucze:
    stat = 'Brak podanej funkcji w kluczach'

if stat == 'OK':
    Funkcja = klucze['Funkcja']

    SlPar = {'Numer': [5, ], }
    Lista = rsglobal.SprawdzParametryWKluczach(SlPar, Funkcja, klucze)
    if Lista <> '':
        stat = 'Uwaga : wywoanie funkcji fs_zmiany_dostepu_rodo_dane.py ' + str(Funkcja) + ' bez parametrw: ' + Lista

    if Funkcja in [5, ]:
        Numer = rsglobal.Dekoduj(klucze['Numer'])

dane = []
wyn1 = []
wyn2 = []

UprEdycja = ((self.oddzial_id,'002202') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID


#-------------------------------------------------------------------------------
#---   INSERT (z pobraniem - 1, bez pobrania - 2)
#-------------------------------------------------------------------------------

if stat == 'OK' and Funkcja in (2,1 ):
    INS = "INSERT INTO rs_rodo_zmiany_dostepu (firma_id, kto_zmodyfikowal, "
    for i in xrange(len(pola)):
        if pola[i] != 'lp':
            INS += pola[i]
            if i < len(pola) - 1:
                INS += ","

    INS += ") VALUES ('" + self.firma_id + "', rsf_getuserid(), "
    for i in xrange(len(wartosci)):
        pole = pola[i]
        if pole <> 'lp':
            wart = wartosci[i]
            if pole in ['zmieniony_pracownik','kto_zatwierdzil']:
                wart = ('000000' + str(wart))[-6:]
            if wart == '' or wart == u'':
                stat = 'PUS POLE ' + pole
                rsglobal.ZapiszDoLogow(pole,5)
                break
            elif type(wart) == type('') or type(wart) == type(u''):
                wart = "'" + wart + "'"
            else:
                wart = str(wart)

            INS += wart
            if i < len(wartosci) - 1:
                INS += ","

    if stat == 'OK':
        INS += "); "

        stat, dump, dump, dump = self.PolSQL.Execute(INS, 1, CzyDodawacBlad=True)
        if stat <> 'OK':
            stat = 'Bd wstawiania danych.'
            dane.append(stat)
        else:
            stat, nr, dump, dump = self.PolSQL.Execute("SELECT currval('rs_rodo_zmiany_dostepu_lp_seq');", 3, CzyDodawacBlad=True)
            if stat <> 'OK':
                stat = 'Bd wstawiania danych.'
                dane.append(stat)
            else:
                Numer=str(nr[0][0])
#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (5 -select, 1 -insert z pobraniem)
#-------------------------------------------------------------------------------

if stat == 'OK' and Funkcja in (5,1):
    SELECT = "SELECT * FROM rs_rodo_zmiany_dostepu WHERE lp="+Numer+";"
    stat,dane,wyn1,dump = self.PolSQL.Execute(SELECT, 3, CzyDodawacBlad=True)
    if stat <> 'OK':
        stat = 'Bd pobrania danych zmiany dostpu : '+stat