# -*- coding: iso8859_2 -*-

lista = ['dni']
SprawdzArgumenty(lista)

# stworzenie sownika bdw
stat='OK'
if dni<365:
    dni=365
    
# wyznaczenie daty granicznej
SQL="SELECT current_date - INTEGER '"+str(dni)+"'"
stat,DData,dump,dump=PolSQL.Execute(SQL,3)
KonczJesliBlad(stat,'Bd pobierania daty : '+stat)

Data=DData[0][0]

# pobranie listy aktywnych kontrahentw 
SQL="SELECT kontrahent_id FROM rs_kontrahenci WHERE firma_id='"+firma_id+"' AND aktywny AND (odbiorca OR dostawca);"
stat,DKontr,dump,dump=PolSQL.Execute(SQL,3)
KonczJesliBlad(stat,'Bd pobierania listy kontrahentw : '+stat)

LKontrAkt=[]
Bufor=str(DKontr)
for poz in DKontr:
    LKontrAkt.append(rsglobal.Dekoduj(poz[0].strip()))

if LKontrAkt==[]:
    KonczJesliBlad('BLAD','Brak aktywnych odbiorcw do analizy')

# jeli jaki kontrahent nie ma dokumentw przed dat graniczn, ale jego data utworzenia w rs_kontrahenci jest
# przed dat graniczn to te trafia na list. Zaczynamy od tych, bo ich wykrycie bdzie zdecydowanie szybsze ni
# przegldanie par dokumentw
LKontr=[]
LKontrAktN=[]
SQL="SELECT DISTINCT kontrahent_id FROM rsa_kontrahenci WHERE firma_id='"+firma_id+"' AND z_czas<'"+Data+"'"
SQL+=" AND kontrahent_id IN ("+str(LKontrAkt)[1:-1]+");"
stat,DKontr,dump,dump=PolSQL.Execute(SQL,3)
KonczJesliBlad(stat,'Bd pobierania kontrahentw z archiwum : '+stat)
# rozdzielenie kontrahentw na przestarzaych i do sprawdzenia
for poz in DKontr:
    LKontr.append(rsglobal.Dekoduj(poz[0].strip()))

for kontr in LKontrAkt:
    if not kontr in LKontr:
        LKontrAktN.append(kontr)
    
# pary dokumentw
LPary=[('kontrahent_id','rs_faktury'),('zamawiajacy_id','rs_faktury'),('platnik_id','rs_faktury'),
       ('miejsce_dostawy_id','rs_faktury'),
       ('kontrahent_id','rs_korekty'),('zamawiajacy_id','rs_korekty'),('platnik_id','rs_korekty'),
       ('miejsce_dostawy_id','rs_korekty'),
       ('kontrahent_id','rs_dokumenty_magazynowe'),('miejsce_dostawy','rs_dokumenty_magazynowe'),
       ('kontrahent_id','rs_dostawy'),
       ('kontrahent_id','rs_dowody_dostaw'),('platnik_id','rs_dowody_dostaw'),
       ('kontrahent_id','rs_zamowienia_dostawcy'),('miejsce_dostawy_id','rs_zamowienia_dostawcy'),
       ('kontrahent_id','rs_zamowienia_odbiorcy'),('zamawiajacy_id','rs_zamowienia_odbiorcy'),
       ('platnik_id','rs_zamowienia_odbiorcy'), ('miejsce_dostawy_id','rs_zamowienia_odbiorcy')]

# pobranie moliwych kontrahentw z rnych dokumentw. Najpierw sprawdzamy, czy w ogle s 
# dokumenty przed dat graniczn. 
for para in LPary:
    SQL="SELECT DISTINCT "+para[0]+" FROM "+para[1]+" WHERE firma_id='"+firma_id+"' AND data<'"+Data+"'" 
    SQL+=" AND "+para[0]+" IN ("+str(LKontrAktN)[1:-1]+");"
    stat,DKontr,dump,dump=PolSQL.Execute(SQL,3)
    KonczJesliBlad(stat,'Bd pobierania kontrahentw : pole '+para[0]+' tabela '+para[1]+' stat : '+stat)
    
    for poz in DKontr:
        kontr=rsglobal.Dekoduj(poz[0].strip())
        if not kontr in LKontr:
            LKontr.append(kontr)

if LKontr==[]:
    KonczJesliBlad('BLAD','Brak dokumentw przed dat graniczn dla wybranych kontrahentw')

    
# mamy bardziej okrojon list kontrahentw - teraz sprawdzimy czy s dokumenty po dacie granicznej
for para in LPary:
    SQL="SELECT DISTINCT "+para[0]+" FROM "+para[1]+" WHERE firma_id='"+firma_id+"' AND data>='"+Data+"'" 
    SQL+=" AND "+para[0]+" IN ("+str(LKontr)[1:-1]+");"
    stat,DKontr,dump,dump=PolSQL.Execute(SQL,3)
    KonczJesliBlad(stat,'Bd pobierania kontrahentw : pole '+para[0]+' tabela '+para[1]+' stat : '+stat)
    
    for poz in DKontr:
        kontr=rsglobal.Dekoduj(poz[0].strip())
        if kontr in LKontr:
            LKontr.remove(kontr)

    if LKontr==[]:
        KonczJesliBlad('BLAD','Brak kontrahentw bez dokumentw po dacie granicznej dla wybranych kontrahentw')
            
# trzeba jeszcze sprawdzi czy ta lista kontrahentw nie zawiera kodw, ktre wystpuj w ksigowoci
# zakadamy, e kontrahent jest na kocu konta

# pobieramy list okresw ktych dotyczy analiza PO dacie granicznej
SQL="SELECT okres_id FROM rs_definicje_okresow WHERE firma_id='"+firma_id+"' AND data_do>='"+Data+"';"
stat,DOkr,dump,dump=PolSQL.Execute(SQL,3)
KonczJesliBlad(stat,'Bd pobierania okresw : '+stat)

LOkr=[]
SGrupy={}
LKont=[]
for poz in DOkr:
    LOkr.append(rsglobal.Dekoduj(poz[0]))

# pobieramy list grup analitycznych zawierajcych kontrahenta
if LOkr<>[]:
    SQL="SELECT okres_id,grupa_id FROM rs_grupy_analityczne WHERE firma_id='"+firma_id+"' AND okres_id IN ("+str(LOkr)[1:-1]+") "
    SQL+=" AND (kontrahenci OR odbiorcy OR dostawcy OR pracownicy OR inni) ORDER BY okres_id"
    stat,DGrupy,dump,dump=PolSQL.Execute(SQL,3)
    KonczJesliBlad(stat,'Bd pobierania grup analitycznych : '+stat)
    
    for poz in DGrupy:
        okres=rsglobal.Dekoduj(poz[0])
        if not okres in SGrupy:
            SGrupy[okres]=[rsglobal.Dekoduj(poz[1])]
        else:
            SGrupy[okres].append(rsglobal.Dekoduj(poz[1]))

# dla kadego okresu pobieramy list kont z kontrahentem
if SGrupy<>{}:
    Filtr=''
    for kl in SGrupy:
        SQL="SELECT kontos_id,konto_id FROM rs_plan_kont WHERE firma_id='"+firma_id+"' AND okres_id='"+kl+"'"
        SQL+=" AND (grupa1 IN ("+str(SGrupy[kl])[1:-1]+") OR grupa2 IN ("+str(SGrupy[kl])[1:-1]+") "
        SQL+=" OR grupa3 IN ("+str(SGrupy[kl])[1:-1]+") OR grupa4 IN ("+str(SGrupy[kl])[1:-1]+") OR grupa5 IN ("+str(SGrupy[kl])[1:-1]+"))"
        stat,DKonta,dump,dump=PolSQL.Execute(SQL,3)
        KonczJesliBlad(stat,'Bd pobierania kont dla okresu '+kl+' : '+stat)
        
        for poz in DKonta:
            Konto=rsglobal.Dekoduj(poz[0])
            if not poz[1] in ['',None,'None']:
                Konto+='-'+rsglobal.Dekoduj(poz[1])
                
            LKont.append([kl,Konto])

# dla kadego okresu sprawdzamy czy kontrahenci wystpuj na odpowiednich stanach kont
if LKont<>[]:
    for poz in LKont:
        SQL="SELECT DISTINCT regexp_replace(konto,'^.*-','') FROM rs_stany_kont WHERE firma_id='"+firma_id+"' AND okres_id='"+poz[0]+"' AND konto LIKE '"+poz[1]+"%'"
        SQL+=" AND regexp_replace(konto,'^.*-','') IN ("+str(LKontr)[1:-1]+")"
        stat,DKontr,dump,dump=PolSQL.Execute(SQL,3)
        KonczJesliBlad(stat,'Bd pobierania kont kontrahentw dla konta '+str(poz)+' : '+stat+' '+SQL)
        
        for poz in DKontr:
            kontr=rsglobal.Dekoduj(poz[0].strip())
            if kontr in LKontr:
                LKontr.remove(kontr)

        if LKontr==[]:
            KonczJesliBlad('BLAD','Brak kontrahentw do deaktywacji')

# jeli lista kontrahentw jest niepusta to robimy update
SQL="UPDATE rs_kontrahenci SET aktywny=FALSE WHERE firma_id='"+firma_id+"' AND kontrahent_id IN ("+str(LKontr)[1:-1]+")"    
stat,dump,dump,dump=PolSQL.Execute(SQL,1)
KonczJesliBlad(stat,'Bd zmiany kontrahentw : '+stat)