# -*- coding: iso8859_2 -*-
# 2023-06-29 Aleksander Bargie (13474) Filtr 'Nip' w d.k.

lista = ['DniOd','DniDo','Operator']
SprawdzArgumenty(lista)
# utworzenie sownika bdw
SBledyDekr = {
  "BL SQL":(u"Bd wykonania polecenia SQL. Ponw prb lub  skontaktuj si z administratorem.",None),
  "BR DOWOD":(u"Brak dowodu wzoru dekretacji",None),
  "BR NAZWA":(u"Brak nazwy wzoru dekretacji",None),
  "BR WZORU":(u"Brak wzoru dekretacji",None),
  "BR WYZN":(u"Brak jakiegokolwiek wyznacznika we wzorze dekretacji faktur",None),
  "BL TYP":(u"Nieobsugiwany typ wzoru dekretacji",None),
  "BL OKR":(u"Brak okresu dekretacji",None),
  "BR KTM":(u"Brak danych o kontach dla poszczeglnych typw artykuw",None),
  "BR DATAOD":(u"Brak daty od",None),
  "BL DATAOD":(u"Niepoprawna data od",None),
  "ZK DATAOD":(u"Data od spoza zakresu",None),
  "OKR DATAOD":(u"Data od poza datami okresu obrachunkowego",None),
  "BR DATADO":(u"Brak daty do",None),
  "BL DATADO":(u"Niepoprawna data do",None),
  "ZK DATADO":(u"Data do spoza zakresu",None),
  "OKR DATADO":(u"Data do poza datami okresu obrachunkowego",None),
  "OD WIE DO":(u"Data od wiksza od daty do",None),
  "NZK FAKT":(u"Faktura $ nie jest zadekretowana.",None),
  "NZK KOR":(u"Korekta $ nie jest zadekretowana.",None),
  "NZK MAG":(u"Dokument magazynowy $ nie jest zadekretowany.",None),
  "NZK DOST":(u"Dostawa $ nie jest zadekretowana.",None),
  "NZAM FAKT":(u"Faktura $ nie jest zamknita ani zadekretowana.",None),
  "NZAM KOR":(u"Korekta $ nie jest zamknita ani zadekretowana.",None),
  "NZAM MAG":(u"Dokument magazynowy $ nie jest zamknity ani zadekretowany.",None),
  "NZAM DOST":(u"Dostawa $ nie jest zamknita ani zadekretowana.",None),
  "BR DOK":(u"Brak dokumentw do dekretacji",None),
  "BR POZ":(u"Brak pozycji na wzorze dekretacji",None),
  "BR POZ WZ":(u"Brak pozycji na wzorze dekretacji speniajcej podstawowe kryteria. Dokument: $",None),
  "BR KWN":(u"Brak konta wn na wzorze - dokument: $.",None),
  "BR KMA":(u"Brak konta ma na wzorze - dokument: $.",None),
  "BL WAR":(u"Bdy sprawdzania warunku : dokument $",None),
  "BR POZWZM":(u"Brak wzorca dekretacji dla dokumentu $.",None),
  "BLOK STAN":(u"Nie mona byo zaoy blokady stanu dla dokumentu $.",None),
  "BL STAN":(u"Stwierdzono nieprawidowy stan dla dokumentu $.",None),
  "BR KOR":(u"Brak korekty na dokumencie $.",None),
  "BR WZDEK":(u"Brak pozycji wzoru dekretacji dla wyznacznikw : $",None),
  "BR KT":(u"Brak zdefiniowanych kont w rozbiciu na stawki vat na fakturze $.",None),
  "BR GW":(u"Poniewa faktura $ bdzie rozbita typami artykuw to wszystkie konta ma na wzorze dekretacji powinny mie *.",None),
  "BR GWMWN":(u"Poniewa dokumenty magazynowe bd rozbite typami artykuw to wszystkie konta wn na wzorze dekretacji powinny mie *.",None),
  "BR GWMMA":(u"Poniewa dokumenty magazynowe bd rozbite typami artykuw to wszystkie konta ma na wzorze dekretacji powinny mie *.",None),
  "BR KTYP":(u"Konto zastpujce * nie jest zdefiniowane $.",None),
  "PO DOK":(u"Nie mona tworzy dowodw - istniej dowody z pniejsz dat.",None),
  "BL SPR UPR":(u"Bdy sprawdzania uprawnie",None),
  "UPR DOD":(u"Brak uprawnie do dodawnia dowodu o podanym wzorze.",None),
  "BR DAT":(u"Brak danych zamknitych miesicy, sprawd wprowadzone daty.",None),
  "ZAM MC":(u"Wprowadzony zakres dat obejmuje zamknity miesic.",None),
}

#-------------------------------------------------------------------------------
#-------------------------------------------------------------------------------

# pobranie konkretnych dat wykonania
SQL="SELECT NOW()::DATE + INTEGER '"+str(DniOd)+"',NOW()::DATE + INTEGER '"+str(DniDo)+"';"
stat,DZakres,dump,dump=PolSQL.Execute(SQL,3)
KonczJesliBlad(stat,'Daty '+stat)
DataOd=rsglobal.Dekoduj(DZakres[0][0])
DataDo=rsglobal.Dekoduj(DZakres[0][1])

# pobranie listy wzorw dekretacji do przetworzenia
SWzoryDekretacji = {} # klucz to okres a wynik - lista wzorw


Data = DataOd
while Data <= DataDo:
    # pobranie dat okresu do ktrego naley data
    SQL="SELECT okres_id FROM rs_definicje_okresow WHERE firma_id='"+firma_id+"' "
    SQL+="AND '"+Data+"' BETWEEN data_od AND data_do;"
    stat,DOkres,dump,dump=PolSQL.Execute(SQL,3)
    KonczJesliBlad(stat,'Bd pobrania okresu dla daty '+Data+': '+stat)
    if len(DOkres)==0:
        KonczJesliBlad("BLAD","Brak okresu zawierajcego wyliczon dat :"+Data)

    Okres=rsglobal.Dekoduj(DOkres[0][0])

    if not Okres in SWzoryDekretacji:
        SQL="SELECT dowod_id, nazwa_id FROM rs_wzory_dekretacji WHERE firma_id='"+firma_id+"' AND okres_id ='"+Okres+"' AND typ_wzoru IN ('F','K');"
        stat,DWzory,dump,dump=PolSQL.Execute(SQL,3)
        KonczJesliBlad(stat,'Wzory okresu '+Okres+' : '+stat)
        SWzoryDekretacji[Okres] = eval(str(DWzory))

    # analizujemy wzr po wzorze
    for Wzor in SWzoryDekretacji[Okres]:
        Dowod = Wzor[0]
        Nazwa = Wzor[1]

        KluczeDekr = [Dowod,Nazwa,Data,Data,Okres]
        stat, dane, none, none = WykonajFunkcje('fs_dekretacja_automatyczna', KluczeDekr, [], [])

        if stat == 'BR DOK':
            stat = 'OK'
        if 'BR DOK' in dane:
            dane.remove('BR DOK')

        if stat<>'OK' or len(dane)>0:
            PolSQL.Rollback()

            if Operator >= 0:
                stat2=stat
                query = "SELECT nextval('rs_wiadomosci_id')"
                stat,wiadomosc_id,none,none=PolSQL.Execute(query,4)
                KonczJesliBlad(stat,'Bd pobrania numeru wiadomoci :'+stat)

                temat="Bdy w wykonaniu dekretacji automatycznej w harmonogramie"
                tresc='Dzie :'+Data+'\nWzr: '+Dowod+'/'+Nazwa+'\n\n'
                if stat2<>'OK':
                    tresc=rsglobal.WyswietlBladZeSlownika(stat2,SBledyDekr).replace('\\','\\\\').replace("'","''")
                else:
                    for poz in dane:
                        tresc+=rsglobal.WyswietlBladZeSlownika(poz,SBledyDekr).replace('\\','\\\\').replace("'","''")+'\n'

                SQL="INSERT INTO rs_wiadomosci (firma_id,wiadomosc_id,operator_id,naglowek,tresc,priorytet,usunieta) "
                SQL+="VALUES "+"('"+firma_id+"',"+str(wiadomosc_id)+","+str(operator_id)+","+rsglobal.ObrobTekst(temat)
                SQL+=",'"+rsglobal.Dekoduj(tresc)+"','N',False);"
                SQL+="INSERT INTO rs_wiadomosci_operatorzy (wiadomosc_id, folder_id, operator_id,usunieta,nowa) "
                SQL+="VALUES "+"("+str(wiadomosc_id)+",0,"+str(Operator)+",False,True)"
                stat,none,none,none=PolSQL.Execute(SQL,1)
                KonczJesliBlad(stat, stat)
                PolSQL.Commit()
                if stat=='OK':
                    stat=rsglobal.WyswietlBladZeSlownika(stat2,SBledyDekr)

    KonczJesliBlad(stat, stat)

    # sprawdzenie czy zostay niezadekretowane faktury/korekty (najprawdopodobniej brak wzoru dekretacji)
    Tresc =''
    Temat ='Dekretacja faktur, korekt - bdy z dnia '+Data
    SQL = "SELECT wyznacznik_id||'/'||data||'/'||numer,stan FROM rs_faktury "
    SQL+=" WHERE firma_id='"+firma_id+"' AND data='"+Data+"' AND stan != 'K' ORDER BY wyznacznik_id,data,numer;"
    stat, DTest, dump, dump = PolSQL.Execute(rsglobal.Dekoduj(SQL), 3)
    KonczJesliBlad(stat, stat)

    if len(DTest) > 0:
        # faktury stan W
        Ile = 0
        for poz in DTest:
            if poz[1] == 'W':
                if Ile ==0:
                    Tresc += "Niezadekretowane faktury w stanie W:\n "
                Tresc += poz[0]+'\n'
                Ile += 1
        if Ile > 0:
            Tresc += '\n'

        # faktury stan G
        Ile = 0
        for poz in DTest:
            if poz[1] == 'G':
                if Ile ==0:
                    Tresc += "Niezadekretowane faktury w stanie G:\n "
                Tresc += poz[0]+'\n'
                Ile += 1
        if Ile > 0:
            Tresc += '\n'

        # faktury stan Z
        Ile = 0
        for poz in DTest:
            if poz[1] == 'Z':
                if Ile ==0:
                    Tresc += "Niezadekretowane faktury w stanie Z:\n "
                Tresc += poz[0]+'\n'
                Ile += 1
        if Ile > 0:
            Tresc += '\n'

    # lista korekt
    SQL = "SELECT wyznacznik_id||'/'||data||'/'||numer,stan FROM rs_korekty "
    SQL+=" WHERE firma_id='"+firma_id+"' AND data='"+Data+"' AND stan != 'K' ORDER BY wyznacznik_id,data,numer;"
    stat, DTest, dump, dump = PolSQL.Execute(rsglobal.Dekoduj(SQL), 3)
    KonczJesliBlad(stat, stat)

    if len(DTest) > 0:
        # korekty stan W
        Ile = 0
        for poz in DTest:
            if poz[1] == 'W':
                if Ile ==0:
                    Tresc += "Niezadekretowane korekty w stanie W:\n "
                Tresc += poz[0]+'\n'
                Ile += 1
        if Ile > 0:
            Tresc += '\n'

        # korekty stan G
        Ile = 0
        for poz in DTest:
            if poz[1] == 'G':
                if Ile ==0:
                    Tresc += "Niezadekretowane korekty w stanie G:\n "
                Tresc += poz[0]+'\n'
                Ile += 1
        if Ile > 0:
            Tresc += '\n'

        # korekty stan Z
        Ile = 0
        for poz in DTest:
            if poz[1] == 'Z':
                if Ile ==0:
                    Tresc += "Niezadekretowane korekty w stanie Z:\n "
                Tresc += poz[0]+'\n'
                Ile += 1
        if Ile > 0:
            Tresc += '\n'

    if Tresc != '':
        # pobranie adresw na ktre ma to pj dla konkretnego oddziau
        SQL = "SELECT DISTINCT email FROM rs_powiadomienia_pozycje WHERE firma_id='" + firma_id + "'"
        SQL += " AND powiadomienie='D0001';"
        stat, DPoczta, dump, dump = PolSQL.Execute(rsglobal.Dekoduj(SQL), 3)
        if stat != 'OK':
            stat = "Bd pobierania listy kont pocztowych dla oddziau " + oddz + " : " + stat
        KonczJesliBlad(stat)

        # wysanie maili
        rsglobal.ZapiszDoLogow('Tresc ' + str(Tresc), 1)
        ZapiszLog('\nTEMAT ' + str(Temat))
        ZapiszLog('\nTRE ' + str(Tresc) + '\n\n')
        for mail in DPoczta:
            ZapiszLog('Mail do ' + mail[0])
            stat = rsglobal.RSWyslijEmail(mail[0], Temat, Tresc, [], 0, PolSQL)
            if stat != 'OK':
                ZapiszLog(stat)

        ZapiszLog('Wysano maile')
        KonczJesliBlad("ZLE", 'Niezadekretowane faktury/korekty w dniu '+Data)

    SQL="SELECT '"+Data+"'::DATE + 1;"
    stat,DDaty,dump,dump=PolSQL.Execute(SQL,3)
    KonczJesliBlad(stat,'Bd przesunicia daty: '+stat)
    
    Data = DDaty[0][0]

#-------------------------------------------------------------------------------
#-- TERAZ ZAMYKAMY DOKUMENTY NA G I NA Z
#-------------------------------------------------------------------------------
KluczeZM = {}
Data = DataOd

rsglobal.ZapiszDoLogow('SWzoryDekretacji przed zamykaniem '+str(SWzoryDekretacji), 1)
while Data <= DataDo:
    # pobranie dat okresu do ktrego naley data
    SQL="SELECT okres_id FROM rs_definicje_okresow WHERE firma_id='"+firma_id+"' "
    SQL+="AND '"+Data+"' BETWEEN data_od AND data_do;"
    stat,DOkres,dump,dump=PolSQL.Execute(SQL,3)
    KonczJesliBlad(stat,'Bd pobrania okresu dla daty '+Data+': '+stat)
    if len(DOkres)==0:
        KonczJesliBlad("BLAD","Brak okresu zawierajcego wyliczon dat :"+Data)

    Okres=rsglobal.Dekoduj(DOkres[0][0])

    # przetwarzanie w ptli kolejnych wzorw dekretacji
    for Wzor in SWzoryDekretacji[Okres]:
        rsglobal.ZapiszDoLogow('WZOR '+str(Wzor), 1)
        Dowod = Wzor[0]
        Nazwa = Wzor[1]

        # W->G
        KluczeZM['StanF'] = 'W'
        KluczeZM['DowodF'] = Dowod
        KluczeZM['NazwaF'] = Nazwa
        KluczeZM['DataOdF'] = Data
        KluczeZM['DataDoF'] = Data
        KluczeZM['OkresDow'] = Okres
        KluczeZM['KontrF'] = '' #To jest zalepka dla filtrowania
        KluczeZM['SymbF'] = '' #To jest zalepka dla filtrowania
        KluczeZM['PlatnosciF'] = '' #To jest zalepka dla filtrowania
        KluczeZM['KontaVATF'] = '' #To jest zalepka dla filtrowania
        KluczeZM['TrescF'] = '' #To jest zalepka dla filtrowania
        KluczeZM['NumerF'] = '' #To jest zalepka dla filtrowania
        KluczeZM['KluczDokF'] = [] #To jest zalepka dla filtrowania
        KluczeZM['NoweKlucze'] = [] #To jest zalepka dla filtrowania
        klucze['ZagadnienieF'] = 0 #To jest zalepka dla filtrowania  #AB 21.02.22r
        klucze['NipF'] = '' #To jest zalepka dla filtrowania  #AB 2023-06-29

        KluczeZM['Funkcja'] = 11
        rsglobal.ZapiszDoLogow('!!!1 '+str(KluczeZM), 1)
        stat, dane, wyn1, wyn2 = WykonajFunkcje('fs_dowody_ksiegowe', KluczeZM, [], [])
        rsglobal.ZapiszDoLogow('!!!11 '+stat, 1)
        rsglobal.ZapiszDoLogow('!!!12 '+str(dane), 1)
        rsglobal.ZapiszDoLogow('!!!23 '+str(wyn2), 1)
        KonczJesliBlad(stat, stat)

        # G->Z
        KluczeZM['StanF'] = 'G'
        KluczeZM['Funkcja'] = 21

        rsglobal.ZapiszDoLogow('!!!2 '+str(KluczeZM), 1)
        stat, dane, wyn1, wyn2 = WykonajFunkcje('fs_dowody_ksiegowe', KluczeZM, [], [])
        rsglobal.ZapiszDoLogow('!!!21 '+stat, 1)
        rsglobal.ZapiszDoLogow('!!!22 '+str(dane), 1)
        rsglobal.ZapiszDoLogow('!!!23 '+str(wyn2), 1)
        KonczJesliBlad(stat, stat)
        PolSQL.Commit()

    SQL="SELECT '"+Data+"'::DATE + 1;"
    stat,DDaty,dump,dump=PolSQL.Execute(SQL,3)
    KonczJesliBlad(stat,'Bd przesunicia daty: '+stat)

    Data = DDaty[0][0]