# -*- coding: iso8859_2 -*-
# funkcja eksportu jest uruchamiana w harmonogramie i rcznie w dowodach dostaw. W przypadku zmian
# oba te mechanizmy musz by sprawdzone i zaktualizowane

# 2019-10-04 (11673) Aleksander Bargie fs_eksport_dowodow_dostaw_do_pc_market - obsuy polskie znaki w nazwie pliku

lista = ['Katalog', 'DniWstecz']
SprawdzArgumenty(lista)

import os
import os.path

# pobranie listy kontrahentw do obsuenia
SQL = "SELECT kontrahent_id FROM rs_kontrahenci WHERE firma_id='"+firma_id+"'"
SQL += " AND COALESCE(TRIM(folder_dowody_dostaw),'') <> '';"
stat, DKontr, dump, dump = PolSQL.Execute(SQL,3)
if stat != 'OK':
    KonczJesliBlad(stat, u"Bd pobierania listy kontrahentw do eksportu :"+stat)

# wyznaczenie daty dowodw dostaw
SQL = "SELECT NOW()::DATE + "+str(DniWstecz)
stat, DData, dump, dump = PolSQL.Execute(SQL, 3)
if stat != 'OK':
    KonczJesliBlad(stat, u"Bd pobierania daty dowodw :"+stat)

Data = DData[0][0]

# ptla po kontrahentach
KatalogK = Katalog
# ewentualne utworzenie katalogu
#if not os.path.exists(KatalogK):
#    try:
#        os.makedirs(KatalogK)
#    except:
#        stat = "Katalog"
#        KonczJesliBlad(stat, u"Bd tworzenia katalogu " + KatalogK + " :" + stat)
if not os.path.exists(KatalogK):
    stat = "Katalog"
    KonczJesliBlad(stat, u"Brak katalogu " + KatalogK + " :" + stat)

if stat == "OK":
    for kontr in DKontr:
        # pobranie dowodw dostaw dla kontrahenta
        SQL = "SELECT oddzial_id, trasa,tryb_dostawy,numer FROM rs_dowody_dostaw WHERE firma_id='" + firma_id + "'"
        SQL += " AND data='" + Data + "' AND kontrahent_id='" + kontr[0] + "' AND data_eksportu IS NULL;"
        stat, DDowody, dump, dump = PolSQL.Execute(SQL, 3)
        if stat <> 'OK':
            KonczJesliBlad(stat,
                           u"Bd pobierania listy dowodw dostaw dla kontrahenta " + kontr[0].strip() + " :" + stat)

        # ptla po dowodach dostaw
        for dowod in DDowody:
            # pobranie danych do wyeksportowania
            Klucze = {'Funkcja': 2, 'Trasa': dowod[1], 'Data': Data,
                      'Tryb': dowod[2], 'Numer': dowod[3], 'Oddzial': dowod[0]}
            stat, dane, wyn1, wyn2 = WykonajFunkcje('fs_dowody_dostaw_eksport', Klucze, [], [])
            if stat <> 'OK':
                KonczJesliBlad(stat, u"Bd pobrania danych dowodu " + str(Klucze) + " :" + stat)

            # zapis danych dowodu dostawy w pliku
            if len(dane) > 0:
                # zapis pliku
                if len(wyn1) > 0 and stat == "OK":
                    # zapis dostaw
                    try:
                        plik = None
                        # plik = open(KatalogK + '/' + dane[1], "w")
                        # sprawdzilem, str i unicode oba obsluguja .encode, wiec nie wazne jak sciezka jest zakodowana,
                        # powinno dzialac
                        nazwa = (KatalogK + '/' + dane[1]).encode('utf-8')
                        plik = open(nazwa, "w")
                        plik.writelines(wyn1)
                    except Exception, e:
                        stat = "Plik"
                        KonczJesliBlad(stat, u"Bd otwarcia / zapisu pliku " + KatalogK + '/' + dane[1] + " :" + stat)
                    #finally:
                    if plik != None:
                        plik.close()

                if len(wyn2) > 0 and stat == "OK":
                    # zapis zwrotow
                    try:
                        plik = None
                        #AB 04.10.19r
                        # plik = open(KatalogK + '/' + dane[2], "w")
                        # sprawdzilem, str i unicode oba obsluguja .encode, wiec nie wazne jak sciezka jest zakodowana,
                        # powinno dzialac
                        nazwa = (KatalogK + '/' + dane[2]).encode('utf-8')
                        plik = open(nazwa, "w")
                        plik.writelines(wyn2)
                    except:
                        stat = "Plik"
                        KonczJesliBlad(stat, u"Bd otwarcia / zapisu pliku " + KatalogK + '/' + dane[2] + " :" + stat)
                    #finally:
                    if plik != None:
                        plik.close()

                if stat == "OK":
                    # zapis daty eksportu do dowodu dostawy
                    SQL = "UPDATE rs_dowody_dostaw SET data_eksportu=NOW()::DATE "
                    SQL += "WHERE firma_id='" + firma_id + "' AND oddzial_id='" + dowod[0] + "' AND trasa='" + dowod[
                        1] + "'"
                    SQL += " AND data='" + Data + "' AND tryb_dostawy='" + dowod[2] + "' AND numer=" + str(dowod[3])
                    stat, dump, dump, dump = PolSQL.Execute(SQL, 1)
                    if stat != 'OK':
                        KonczJesliBlad(stat, u"Bd zapisu daty eksportu w dowodzie " + str(Klucze) + " :" + stat)
