# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_popraw_salda_rozrachunkow.py
# Purpose:     Poprawianie sald rozrachunkw
# Author:      Piotr Witkowski
# Created:     2017/05/18
# RCS-ID:      $Id: funkcje_harmonogramu/fs_popraw_salda_rozrachunkow.py $
# Copyright:   (c) 2017 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

stat = 'OK'
SprawdzArgumenty(['okres','konto'])

if not okres and not konto:
    stat = 'Brak uzupenionego okresu i konta'
elif not okres:
    stat = 'Brak uzupenionego okresu'
elif not konto:
    stat = 'Brak uzupenionego konta'

if stat=='OK':
    SQL= "SELECT DISTINCT konto from rs_rozrachunki where firma_id='"+firma_id+"' and okres_id='"+str(okres)+"' and konto like '"+str(konto)+"%' and abs(saldo_ma)>abs(kwota_ma) UNION "
    SQL+="SELECT DISTINCT konto from rs_rozrachunki where firma_id='"+firma_id+"' and okres_id='"+str(okres)+"' and konto like '"+str(konto)+"%' and abs(saldo_ma)>abs(kwota_bo_ma) UNION "
    SQL+="SELECT DISTINCT konto from rs_rozrachunki where firma_id='"+firma_id+"' and okres_id='"+str(okres)+"' and konto like '"+str(konto)+"%' and abs(saldo_wn)>abs(kwota_wn) UNION "
    SQL+="SELECT DISTINCT konto from rs_rozrachunki where firma_id='"+firma_id+"' and okres_id='"+str(okres)+"' and konto like '"+str(konto)+"%' and abs(saldo_wn)>abs(kwota_bo_wn); "
    stat,dane,dump,dump = PolSQL.Execute(SQL,3)
    if stat <> 'OK':
        KonczJesliBlad(stat, 'Bd pobrania konto z rozrachunkw: '+stat)

    elif len(dane)==0:
        stat="Nie wykonano funkcji, gdy dla wybranych parametrw nie znaleziono kont"
    else:
        ile_kont=0
        for Dkonto in dane:
            SQL="SELECT rsf_popraw_za_duze_salda_w_rozrachunkach('"+firma_id+"','"+str(okres)+"','"+str(Dkonto[0])+"');"
            OK,d,dump,dump = PolSQL.Execute(SQL,3)
            if OK=='OK' and d[0][0] <> "Brak rozrachunk\xf3w do poprawienia":
                ile_kont+=1

        if len(dane)==1:
            konto = "Z parametrw wyszukano "+str(len(dane))+" konto,"
        elif len(dane) in [2,3,4]:
            konto = "Z parametrw wyszukano "+str(len(dane))+" konta,"
        elif len(dane) > 4:
            konto = "Z parametrw wyszukano "+str(len(dane))+" kont,"

        if ile_kont==1:
            wynik = konto + " wykonano "+str(ile_kont)+" napraw."
        elif ile_kont in [2,3,4]:
            wynik =  konto + " wykonano "+str(ile_kont)+" naprawy."
        elif ile_kont > 4:
            wynik =  konto + " wykonano "+str(ile_kont)+" napraw."
        else:
            wynik =  konto + " nie poprawiono kont."


        ZapiszLog('\nWynik:\n' + str(wynik))
