# -*- coding: iso8859_2 -*-
# Autor: Marcin Wodarczyk
# Funkcja harmonogramu: fs_usun_z_archiwum
# Funkcja usuwa z tabel archiwalnych (rsa_%) rekordy starsze 
# niz dzisiaj - liczba_dni podawana jako argument.
# Argumenty: liczba_dni


stat='OK'

SprawdzArgumenty(['liczba_dni'])

query = "SELECT distinct(table_name) FROM INFORMATION_SCHEMA.COLUMNS WHERE TABLE_NAME like 'rsa\_%'"
stat,data,none,none=PolSQL.Execute(query,3)

if stat == 'OK' and data:
    wystapilBlad = False
    for rekord in data:
        tabela = rekord[0]
        query = "DELETE FROM "+str(tabela)+" WHERE z_arch_czas < clock_timestamp() - interval '"+str(liczba_dni)+" days';"
        stat,none,none,none=PolSQL.Execute(query,1)
        if stat != 'OK':    
            ZapiszLog(query + "\n  " + str(stat))
            wystapilBlad = True
        # TODO: a moe by jeszcze commity po kadej?
    if not wystapilBlad:
        ZapiszLog("Wykonano")
    else:
        ZapiszLog("Wykonano, ale wystapiy bdy")
        stat = "BLAD"
else:
    ZapiszLog(str(stat))

 

