# -*- coding: iso8859_2 -*-
# Funkcja uzupeniajca tabel dla widoku eureki
# autor: Marcin Natkaski
# 2014-11-20  

import rsglobal
SprawdzArgumenty(['miesic'])
#tworzymy zmienne
MiesiaceWstecz = rsglobal.Dekoduj(argumenty['miesic'])
Data=rsglobal.PodajDzis()  
lista_dat = []
    
#tworzymy list list z datami poczatku i koca miesica w postaci [[data_poczatek,data_koniec]]
if int(MiesiaceWstecz)>0:
    for a in range(0,int(MiesiaceWstecz)):
        lista_dat.append([rsglobal.PierwszyDzienMiesiaca(Data, -a),rsglobal.OstatniDzienMiesiaca(Data, -a)])
else:
    lista_dat = [[rsglobal.PierwszyDzienMiesiaca(Data),rsglobal.OstatniDzienMiesiaca(Data)]]
    
#Dla kadej pary dat z listy usuwamy zawarto tabeli rs_eureka_zest_srodki_trwale
for i in xrange(len(lista_dat)):
    DEL = "DELETE FROM rs_eureka_zest_srodki_trwale WHERE firma_id='"+firma_id+"' AND "
    DEL+= "data_od>='"+lista_dat[i][0]+"' AND data_do<='"+lista_dat[i][1]+"'"
    stat,dump,dump,dump=PolSQL.Execute(DEL,1)
    if stat <> 'OK':
        KonczJesliBlad(stat, 'Bd usuwania danych z tabeli rs_eureka_zest_srodki_trwale : '+stat)

#Dla kadej pary dat z listy wywoujemy funkcj
for i in xrange(len(lista_dat)):
    Klucz = [lista_dat[i][0],lista_dat[i][1],'',0]
    stat, Dane, none, none = WykonajFunkcje('fs_wydruki_zestawienie_srodkow_dla_grupy_analityka', Klucz, [], [])
    #jeeli funkcja zwrci brak rodkw trwaych
    if stat.startswith('Brak'):
        stat='OK'
        continue
    
    if stat <> 'OK' and not stat.startswith('Brak'):
        KonczJesliBlad(stat, 'Bd pobierania danych do tabeli rs_eureka_zest_srodki_trwale : '+stat)

    for m in xrange(len(Dane[0])):        
        #tutaj zabezpieczamy si przed NONE w KST
        KST = ''
        if Dane[0][m][6].strip() in ('None','none',None):
            KST = ''
        else:
            KST = Dane[0][m][6].strip()
        stat,dump,dump,dump=PolSQL.Execute("BEGIN;",1)
        INS= "INSERT INTO rs_eureka_zest_srodki_trwale (firma_id,data_od,data_do,srodek_id,pocz_wart_pocz,zwiek_wart_pocz, "
        INS+="zmn_wart_pocz, biez_wart_pocz,wart_netto,kst,stopa_umorzenia,pocz_umorz,zwiek_umorz,zmn_umorz,biez_umorz) "
        INS+=" VALUES ('"+firma_id+"','"+lista_dat[i][0]+"','"+lista_dat[i][1]+"','"+str(Dane[0][m][0])+"','"+str(Dane[0][m][2])+"', "
        INS+=" '"+str(Dane[0][m][3])+"','"+str(Dane[0][m][4])+"','"+str(Dane[0][m][5])+"','"+str(Dane[0][m][5]-Dane[0][m][11])+"', "
        INS+=" '"+str(KST)+"', '"+str(Dane[0][m][7])+"','"+str(Dane[0][m][8])+"','"+str(Dane[0][m][9])+"', "
        INS+=" '"+str(Dane[0][m][10])+"', '"+str(Dane[0][m][11])+"') ;"
        stat,dump,dump,dump=PolSQL.Execute(INS,1)
        if stat <> 'OK':
            KonczJesliBlad(stat, 'Bd dodawania danych z tabeli rs_eureka_zest_srodki_trwale : '+stat)

        else:
            stat,dump,dump,dump=PolSQL.Execute("COMMIT;",1)