# -*- coding: iso8859_2 -*-
# Pobranie danych z podanego okresu czasu do tabeli generatora raport?w: rs_gr_dowody_dostaw_sumy
# Autor: Mariusz Rajfura  2012-11-12  (6244)

import datetime

SprawdzArgumenty(['data_od','data_do'])

data_od=data_od[:4]+'-'+data_od[5:7]+'-'+data_od[8:]
data_do=data_do[:4]+'-'+data_do[5:7]+'-'+data_do[8:]

if not rsglobal.SprawdzCzyToData(data_od):
    KonczJesliBlad(u'Podana data od jest nieprawidowa: '+str(data_od))
if not rsglobal.SprawdzCzyToData(data_do):
    KonczJesliBlad(u'Podana data do jest nieprawidowa: '+str(data_do))

DataOd = datetime.datetime(int(data_od[:4]),int(data_od[5:7]),int(data_od[8:]))
DataDo = datetime.datetime(int(data_do[:4]),int(data_do[5:7]),int(data_do[8:]))


query = "SELECT funkcja FROM rs_tabele_generatora WHERE tabela = 'rs_gr_dowody_dostaw_sumy'"
stat, funkcja, none, none = PolSQL2.Execute(query, 5)

if stat == "OK":
    funkcja = rsglobal.Dekoduj(funkcja)

    sdata = DataOd.strftime("%F")
    kdata = DataDo.strftime("%F")
    query = "SELECT " + funkcja + "('" + firma_id + "', '" + sdata + "', '" + kdata + "')"
    stat, none, none, none = PolSQL2.Execute(query, 1)
    KonczJesliBlad(stat)

else:
    ZapiszLog(stat + " funkcja:" + funkcja)

