# -*- coding: iso8859_2 -*-
# Pobranie danych z podanego okresu czasu do tabeli generatora raportw: rs_gr_kadry_place.
# Autor: Mikoaj Kozowski 2020-02-27 (11881)


import datetime

SprawdzArgumenty(['data_od','data_do'])

data_od=data_od[:4]+'-'+data_od[5:7]+'-'+data_od[8:]
data_do=data_do[:4]+'-'+data_do[5:7]+'-'+data_do[8:]

if not rsglobal.SprawdzCzyToData(data_od):
    KonczJesliBlad(u'Podana data od jest nieprawidowa: '+str(data_od))
if not rsglobal.SprawdzCzyToData(data_do):
    KonczJesliBlad(u'Podana data do jest nieprawidowa: '+str(data_do))

DataOd = datetime.datetime(int(data_od[:4]),int(data_od[5:7]),int(data_od[8:]))
DataDo = datetime.datetime(int(data_do[:4]),int(data_do[5:7]),int(data_do[8:]))


query = "SELECT funkcja FROM rs_tabele_generatora WHERE tabela = 'rs_gr_kadry_place'"
stat, funkcja, none, none = PolSQL2.Execute(query, 5)

if stat == "OK":
    funkcja = rsglobal.Dekoduj(funkcja)

    while DataOd <= DataDo:
        print 'naliczam dla dnia ', str(DataOd.date())

        sdata = DataOd.strftime("%F")
        query = "SELECT " + funkcja + "('" + firma_id + "', '" + sdata + "', '" + sdata + "')"
        stat, none, none, none = PolSQL2.Execute(query, 1)

        if stat == 'OK':
            PolSQL2.Commit()

        KonczJesliBlad(stat)

        DataOd += datetime.timedelta(days=1)

else:
    ZapiszLog(stat + " funkcja:" + funkcja)

