# -*- coding: iso8859_2 -*-
# Autor: Mariusz Rajfura  2011-07-11  (4759)
# Funkcja harmonogramu: fs_uzupelnij_rs_gr_obroty_magazynowe_za_okres
# Pobranie danych z okresu od - do do tabeli generatora
# raport?w: rs_gr_obroty_magazynowe (wersja dla SPC)

import datetime

SprawdzArgumenty(['data_od','data_do'])

data_od=data_od[:4]+'-'+data_od[5:7]+'-'+data_od[8:]
data_do=data_do[:4]+'-'+data_do[5:7]+'-'+data_do[8:]

if not rsglobal.SprawdzCzyToData(data_od):
    KonczJesliBlad(u'Podana data od jest nieprawidowa: '+str(data_od))
if not rsglobal.SprawdzCzyToData(data_do):
    KonczJesliBlad(u'Podana data do jest nieprawidowa: '+str(data_do))

DataOd = datetime.datetime(int(data_od[:4]),int(data_od[5:7]),int(data_od[8:]))
DataDo = datetime.datetime(int(data_do[:4]),int(data_do[5:7]),int(data_do[8:]))

while DataOd <= DataDo:
    sdata = DataOd.strftime("%F")
    query = "SELECT rsf_gr_obroty_magazynowe" + "('" + firma_id + "', '" + sdata + "', '" + sdata + "')"
    stat, none, none, none = PolSQL2.Execute(query, 1)
    if stat == 'OK':
        PolSQL2.Commit()

    KonczJesliBlad(stat)

    DataOd += datetime.timedelta(days=1) 