# -*- coding: iso8859_2 -*-
# Autor: Mariusz Rajfura - 2012-01-19  (5408)
# Funkcja harmonogramu: fs_uzupelnij_rs_gr_operacje_za_okres
# Pobranie danych z podanego okresu do tabeli generatora
# raport?w: rs_gr_operacje

import datetime

SprawdzArgumenty(['data_od','data_do'])

data_od=data_od[:4]+'-'+data_od[5:7]+'-'+data_od[8:]
data_do=data_do[:4]+'-'+data_do[5:7]+'-'+data_do[8:]

if not rsglobal.SprawdzCzyToData(data_od):
    KonczJesliBlad(u'Podana data od jest nieprawidowa: '+str(data_od))
if not rsglobal.SprawdzCzyToData(data_do):
    KonczJesliBlad(u'Podana data do jest nieprawidowa: '+str(data_do))

DataOd = datetime.datetime(int(data_od[:4]),int(data_od[5:7]),int(data_od[8:]))
DataDo = datetime.datetime(int(data_do[:4]),int(data_do[5:7]),int(data_do[8:]))

rsglobal.ZapiszDoLogow('Funkcja uzupelnij gen oper za okres bedzie robiona za okres '+str(DataOd)+' - '+str(DataDo),1)

query = "SELECT funkcja FROM rs_tabele_generatora WHERE tabela = 'rs_gr_operacje'"
stat, funkcja, none, none = PolSQL2.Execute(query, 5)
if stat <> 'OK':
    KonczJesliBlad(stat, 'Bd pobrania funkcji do wykonania : '+stat)
if len(funkcja) == 0:
    KonczJesliBlad('Brak funkcji pobierajcej do wykonania', 'Brak funkcji pobierajcej do wykonania')

if stat == "OK":
    funkcja = rsglobal.Dekoduj(funkcja)

    while DataOd <= DataDo:
        sdata = DataOd.strftime("%F")
        query = "SELECT " + funkcja + "('" + firma_id + "', '" + sdata + "', '" + sdata + "')"
        rsglobal.ZapiszDoLogow('Funkcja uzupelnij gen oper za okres SQL:'+query,1)
        stat, none, none, none = PolSQL2.Execute(query, 1)
        rsglobal.ZapiszDoLogow('Funkcja uzupelnij gen oper za okres '+str(DataOd)+' - '+str(DataDo)+':'+stat,1)
        if stat == 'OK':
            PolSQL2.Commit()

        KonczJesliBlad(stat)
        DataOd += datetime.timedelta(days=1) 
        
else:
    ZapiszLog(stat + " funkcja:" + funkcja)
