# -*- coding: iso8859_2 -*-
# Funkcja harmonogramu: fs_wczytaj_dane_z_od01_z_foxa
#  Wczytanie danych z plikow generowanych przez fox
# raportw: rs_gr_sprzedaz
#

import datetime
import os
import os.path

query = "SELECT funkcja FROM rs_tabele_generatora WHERE tabela = 'rs_gr_sprzedaz'"
stat, funkcja, none, none = PolSQL.Execute(query, 5)

if stat == "OK":
    funkcja = rsglobal.Dekoduj(funkcja)

    data = fs_time
    for ile in range(14):
        sdata = data.strftime("%F")
        query = "SELECT " + funkcja + "('" + firma_id + "', '" + sdata + "', '" + sdata + "')"
        stat, none, none, none = PolSQL.Execute(query, 1)

        KonczJesliBlad(stat)

        data -= datetime.timedelta(days=1)

    if not os.path.isfile('./fox'):
        #----- powrot - nie ma pliku fox -powrot z bledem ze jest uruchomiona w harmonogramie funkcja
        pass
    else:
        try:
            f=file('./fox','r')
        except:
            #---- powrot z bledem - blad otwarcia pliku fox
            pass
        parametry=f.read()
        f.close()
        parametry=parametry.splitlines()
        if len(parametry)==0:
            #--- pusty plik - powrot z bledem o pustym pliku fox
            pass
        else:
            katalog=parametry[0].strip()
            if not os.path.isdir(katalog):
                #---- bledna sciezka lub brak mapowania - napisac jaka 
                pass
            else:
                pliktxt=katalog+'fa01.txt'
                plikana=katalog+'fa01.ana'
                plikerr=katalog+'fa01.err'
                pliktxt2=katalog+'fa02.txt'
                plikana2=katalog+'fa02.ana'
                plikzwr=katalog+'fa.ana'
                if os.path.isfile(plikana):
                    #--- powrot z bledem sie nie zakonczylo poprzednie wykonanie
                    pass
                else:
                    if not os.path.isfile(pliktxt):
                        #--- powrot z info ze nie bylo zmian do wczytania
                        pass
                    else:
                        try:
                            os.rename(pliktxt, plikana)
                        except:
                            #--- powrot z bledem - brak dostepu do pliku albo plik zajety przez foxa
                            pass
                        try:
                            f=file(plikana,'r')
                        except:
                            #--- powrot z bledem - brak dostepu do pliku
                            pass
                        wiersze=f.read()
                        f.close()
                        try:
                            os.remove(plikana)
                        except:
                            #--- zapamietac blad, ale obsluzyc wczytane wiersze- brak dostepu do pliku
                            pass
                        wiersze=wiersze.splitlines()
                        # w petli obslugiwac wiersze i tworzyc liste bledow
                        bledy=[]
                        pierwszy=True
                        for w in wiersze:
                            w=w.strip()
                            if pierwszy:
                                #---- obrobka pierwszego
                                pass
                            else:
                                #obrobka drugiego (insert lub update)
                                pass
                            pierwszy=not pierwszy
                        
                        if len(bledy)>0:
                            #---- zapis bledow
                            try:
                                f=file(plikerr,'a+')
                            except:
                                #--- powrot z bledem - wystapily bledy ale nie udalo sie zapisac
                                pass
                            for b in bledy:
                                f.write(b+'\n')
                            f.close()
        
else:
    ZapiszLog(stat + " funkcja:" + funkcja)

