# -*- coding: iso8859_2 -*-
# -------------------------------------------------------------------------------
# Name:        fs_wyslij_sms_z_kolejki.py
# Purpose:     wysyanie wiadomoci zapisanych w tabeli rs_sms
# Authors:     Aleksander Bargie
# Created:     2023/03/23
# Copyright:   (c) 2023 Record System
# Licence:     GNU GPL
# -------------------------------------------------------------------------------
import time

wiadomosci = None
bledy  = []
zrobione = set([0])

SprawdzArgumenty(['uwzgledniac_firme'])

while wiadomosci is None or wiadomosci != []:
    if uwzgledniac_firme and uwzgledniac_firme not in ('Nie', 'False', 'nie', 'false'):
        sql = """SELECT sms_id, odbiorca, tresc
                 FROM rs_sms
                 WHERE firma_id=%s AND COALESCE(stat, '') != 'OK' AND sms_id NOT IN ({}); """.format(", ".join([str(x) for x in zrobione]))
        args = [firma_id]
    else:
        sql = """SELECT sms_id, odbiorca, tresc
                 FROM rs_sms
                 WHERE COALESCE(stat, '') != 'OK' AND sms_id NOT IN ({}); """.format(", ".join([str(x) for x in zrobione]))
        args = []
    rsglobal.ZapiszDoLogow(PolSQL.Mogrify(sql, args))
    stat, wiadomosci, dump, dump = PolSQL.Execute(sql, 3, args, CzyDodawacBlad=True)
    rsglobal.ZapiszDoLogow("Pobrano wiadomosci: {}".format(wiadomosci))
    if stat != 'OK':
        stat = 'Bd pobrania wiadomoci do wysyki: ' + stat
        break
    else:
        if wiadomosci:
            zrobione.update([x[0] for x in wiadomosci])
            bledy = rsglobal._WyslijSmsy(PolSQL, wiadomosci)
            time.sleep(5)
            rsglobal.ZapiszDoLogow("bledy: {}".format(bledy))

if bledy:
    stat += "\nBdy wysyki wiadomoci:\n" + ("\n".join(bledy))
KonczJesliBlad(stat, 'Bd wysyki: '+stat)