# -*- coding: iso8859_2 -*-
# Autor: Dariusz Boduch
# Funkcja harmonogramu: fs_zamknij_rezerwacje.py
#Funkcja ma zamykac rezerwacje, ktorych termin minal. 
#Po usunieciu poczta wewnetrzna Anakondy wysylac o tym informacje do operatora, 
#ktory rezerwacje wprowadzil
# ktory rezerwacje wprowadzil (uwzgledniajac zastepstwa)
# parametr: data z parametru serwera czas

stat='OK'
SQL="SELECT substring(koniec::text from 0 for 11), kontrahent_id,artykul_id, magazyn_id, handlowiec_id, rezerwacja, zrealizowano, "
SQL+="rezerwacja_id, z_op_id "
SQL+="FROM rs_artykuly_rezerwacje "
SQL+="WHERE firma_id='"+firma_id+"' "
SQL+="AND substring(koniec::text from 0 for 11)<'"+czas[0:10]+"' "
SQL+="AND zrealizowano<rezerwacja AND rezerwacja<>0 AND zamknieta is FALSE "
SQL+="ORDER BY 9 "
stat,data,dump,dump=PolSQL.Execute(SQL,3)
if stat<>'OK':
    ZapiszLog("Bd wykonania funkcji 'fs_zamknij_rezerwacje' z dnia "+str(czas[0:10])+": "+stat)
else:
    if len(data)<>0:
        LOp=[]
        for w in data:
            Operator=w[-1]
            if Operator not in LOp:
                LOp.append(Operator)
        for o in LOp:
            
            Update="UPDATE rs_artykuly_rezerwacje set zamknieta=True where firma_id='"+str(firma_id)+"' and rezerwacja_id in ("
            MailText='W dniu '+str(czas[0:10])+' zamknito nastpujce rezerwacje: \n\n'
            
            UpdateArt=''
            UpdateArtMag=''
            for s in data:
                if o==s[-1]:
                    Update+=""+str(s[7])+","
                    
                    
                    MailText+='Artyku: '+str(s[2]).strip()+' -'
                    stat,d,dump,dump=PolSQL.Execute("SELECT nazwa FROM rs_artykuly WHERE firma_id='"+str(firma_id)+"' AND artykul_id='"+str(s[2])+"'; ",3)
                    if stat<>'OK':
                        ZapiszLog('Bd pobierania nazwy artykuu: '+stat)
                    else:
                        MailText+=' '+str(d[0][0]).strip()+' \n'
                    MailText+='Magazyn :'+str(s[3])+' -'
                    stat,m,dump,dump=PolSQL.Execute("SELECT opis FROM rs_magazyny WHERE firma_id='"+str(firma_id)+"' AND magazyn_id='"+str(s[3])+"'; ",3)       
                    if stat<>'OK':
                        ZapiszLog('Bd pobierania nazwy magazynu: '+stat)
                        MailText+='Bd pobierania nazwy magazynu: '+str(stat)+' '
                    else:
                         MailText+=' '+str(m[0][0]).strip()+' \n'
                    MailText+='Zarezerwowano: '+str(s[5]).strip()+' ; zrealizowano: '+str(s[6]).strip()+' \n'
                    MailText+='Kontrahent :'+str(s[1])+' -'
                    stat,k,dump,dump=PolSQL.Execute("SELECT nazwa FROM rs_kontrahenci WHERE firma_id='"+str(firma_id)+"' AND kontrahent_id='"+str(s[1])+"'; ",3)
                    if stat<>'OK':
                        ZapiszLog('Bd pobierania nazwy kontrahenta: '+stat)
                        MailText+='Bd pobierania nazwy kontrahenta: '+str(stat)+' '
                    else:
                        MailText+=' '+str(k[0][0])+' \n'
                    MailText+='Handlowiec :'+str(s[4])+' -'
                    stat,h,dump,dump=PolSQL.Execute("SELECT opis FROM rs_handlowcy WHERE firma_id='"+str(firma_id)+"' AND kod='"+str(s[4])+"'; ",3)
                    if stat<>'OK':
                        ZapiszLog('Bd pobierania nazwy handlowca: '+stat)
                        MailText+='Bd pobierania nazwy handlowca: '+str(stat)+' '
                    else:
                        MailText+=' '+str(h[0][0]).strip()+' \n'
                    MailText+='---------------------------------------\n'
                    MailText+='\n'
                    
                    #modyikacja rezerwacji w rs_artykuly i rs_artykuly_magazyny
                    #przeliczenie modyfikownych iloci
                    #przelicznik
                    stat,p,dump,dump=PolSQL.Execute("SELECT przelicznik FROM rs_artykuly WHERE firma_id='"+str(firma_id)+"' AND artykul_id='"+str(s[2])+"'; ",3)
                    if stat<> 'OK':
                        ZapiszLog('Bd pobierania przelicznika: '+stat)
                    else:
                        Przelicznik=p[0][0]
                        Rezerw1=float(s[5])-float(s[6])
                        Rezerw2=Przelicznik*float(Rezerw1)
                    UpdateArt+="UPDATE rs_artykuly set rezerwacja1=rezerwacja1 - "+str(+Rezerw1)+", rezerwacja2=rezerwacja2 - "+str(Rezerw2)+" \
                                WHERE firma_id='"+str(firma_id)+"' AND artykul_id='"+str(s[2])+"'; "
                    UpdateArtMag+="UPDATE rs_artykuly_magazyny set rezerwacja1=rezerwacja1 - "+str(Rezerw1)+", rezerwacja2=rezerwacja2 - "+str(Rezerw2)+" \
                                WHERE firma_id='"+str(firma_id)+"' AND artykul_id='"+str(s[2])+"' AND magazyn_id='"+str(s[3])+"'; "
            

            Update=Update[:-1]+"); "
            stat,dump,dump,dump=PolSQL.Execute(Update+UpdateArt+UpdateArtMag,1)
            if stat<>'OK':
                ZapiszLog('Bd zamykania przeterminowanych rezerwacji: '+stat)
            else:
                #Pobranie adresata (jesli zastepstwo to do zastepcy)
                stat,adr,dump,dump=PolSQL.Execute("SELECT CASE WHEN zastepca_id=0 THEN operator_id ELSE zastepca_id END  from rs_operatorzy WHERE operator_id="+str(o)+";",3)
                if stat<>'OK':
                    ZapiszLog('Bd pobierania id adresata poczty: '+stat)
                else:
                    adresat_id=str(adr[0][0])
                    
                    stat,wiadomosc_id,none,none=PolSQL.Execute("SELECT nextval('rs_wiadomosci_id')",4)
                    if stat != 'OK':
                        ZapiszLog('Bd nextval wiadomoci')
                    else:
                        temat='INFORMACJA O ZAMKNITYCH REZERWACJACH'.replace('/','//').replace("'","''")
                        tresc=MailText.replace('/','//').replace("'","''")
                        query = "INSERT INTO rs_wiadomosci (firma_id,wiadomosc_id,operator_id,naglowek,tresc,priorytet,usunieta) VALUES " + "('" + firma_id + "'," + str(wiadomosc_id) + "," + str(operator_id) + "," + rsglobal.ObrobTekst(temat) + "," + rsglobal.ObrobTekst(tresc) + ",'N',False)"
                        stat,none,none,none=PolSQL.Execute(query,1)
                        if stat != 'OK':
                            ZapiszLog("Bd wysyania wiadomoci: "+stat)
                        else:
                            query = "INSERT INTO rs_wiadomosci_operatorzy (wiadomosc_id, folder_id, operator_id,usunieta,nowa) VALUES " + "(" +  str(wiadomosc_id) + ",0,'"  + str(adresat_id) + "',False,True)"
                            stat,none,none,none = PolSQL.Execute(query,1)
                            if stat<>'OK':
                                ZapiszLog("Bd wysyania wiadomoci: "+stat)