# -*- coding: iso8859_2 -*-
#-----------------------------------------------------------------------------------------------------------------------
# Name:        fs_amortyzacje_pozycje.py
# Purpose:     operacje na arkuszach amortyzacji
# Author:      Pawel Wojcikowski
# Created:     2008/11/27
# RCS-ID:      $Id: fs_amortyzacje_pozycje.py $
# Copyright:   (c) 2008 Record System
# Licence:     GNU GPL
#-----------------------------------------------------------------------------------------------------------------------
# 2017-03-22 Konrad Opieka (10402) Refaktoryzacja

stat='OK'

if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=='OK':
    Funkcja = klucze['Funkcja']

    SlPar={'Data':[5], 'Numer':[5], 'SrodekId':[5]}
    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Funkcja,klucze)
    if Lista<>'':
        stat='Uwaga: wywoanie funkcji fs_amortyzacje_pozycje z numerem '+str(Funkcja)+' bez parametrw: '+Lista

if stat=='OK':
    if Funkcja in [5]:
        Data = klucze['Data']
        Numer = klucze['Numer']
        SrodekId = klucze['SrodekId']

dane = []
wyn1 = []
wyn2 = []

UprPrzegladanie=(((self.oddzial_id,'174221') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID))


#-----------------------------------------------------------------------------------------------------------------------
#------Pobieranie planu amortyzacji (5)
#-----------------------------------------------------------------------------------------------------------------------

if Funkcja == 5 and stat == 'OK':
    if not UprPrzegladanie:
        stat = 'UPR PRZ'
        dane.append(stat)
    if stat == 'OK':
        SQL = "SELECT aap.srodek_id, st.nazwa, aap.rach_przed, aap.rach_umorz, "
        SQL+= "aap.rach_po, aap.podat_przed, aap.podat_umorz, aap.podat_po "
        SQL+= "FROM rs_arkusze_amortyzacji_pozycje aap "
        SQL+= "INNER JOIN rs_srodki_trwale st USING (firma_id,srodek_id) "
        SQL+= "WHERE aap.firma_id='"+self.firma_id+"' AND aap.numer="+str(Numer)+" AND aap.data='"+str(Data)+"';"
        stat,dane,wyn1,wyn2=self.PolSQL.Execute(SQL,3)
        if stat <> 'OK':
            stat='BL PRZ'
            dane.append(stat) 
