# -*- coding: iso8859_2 -*-
#-----------------------------------------------------------------------------
# Name:        fs_archiwum_dane_tabela.py
# Purpose:     obsluguje komunikacje z tabela archiwalna
#
# Author:      Tomasz Romanczuk
#              
# Created:     2006/11/21
# RCS-ID:      $Id: fs_archiwum_dane_tabela.py $
# Copyright:   (c) 2006 Record System
# Licence:     GNU GPL
#-----------------------------------------------------------------------------
# modyfik. Mariusz Rajfura  mantis: 2043 

stat = "OK"
dane = []
Fun = klucze[-1]

#-------------------------------------------------------------------------------
# Fun == 1 pobranie OID bazy
#-------------------------------------------------------------------------------

if Fun == 1 :
    tabela = klucze[0]
    stat,dane,wyn1,wyn2 = self.PolSQL.Execute("SELECT oid FROM pg_class WHERE relname='"+tabela+"';", 2)
    if stat <> 'OK':
        stat = 'Bd pobrania OID tabeli '+tabela+' : '+stat

#-------------------------------------------------------------------------------
# Fun == 2 pobranie struktury bazy
#-------------------------------------------------------------------------------

if Fun == 2 :
    OID = klucze[0]
    sql = "SELECT atr.attname,typ.typname,atr.atttypmod"
    sql+=" FROM pg_attribute atr"
    sql+=" INNER JOIN pg_type typ ON atr.atttypid=typ.oid"
    sql+=" WHERE atr.attrelid="+str(OID)+" AND atr.attstattarget=-1;"
    
    stat,dane,wyn1,wyn2 = self.PolSQL.Execute(sql, 2)
    if stat <> 'OK':
        stat = 'Bd pobrania struktury tabeli z OID : '+OID+' : '+stat
    
#-------------------------------------------------------------------------------
# Fun == 3 pobranie danych
#-------------------------------------------------------------------------------

if Fun == 3 :
    pola = klucze[0]
    tabela = klucze[1]
    firma = klucze[2]
    filtr = rsglobal.UsSl(klucze[3])
    
    sql = "SELECT "+pola+" FROM "+tabela+" WHERE firma_id='"+firma+"'"
    if filtr <> '':
        sql+=" AND "+filtr
    sql+=";"

    stat,dane,nagl,wyn2 = self.PolSQL.Execute(sql,3)
    if stat <> 'OK':
        stat = 'Bd pobrania danych z '+tabela+' : '+stat
