# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_artykuly_cechy.py
# Purpose:     obsluga grida edytowalnego cech artykulow
# Author:      Mariusz Rajfura
# Created:     2013/05/29
# RCS-ID:      $Id: fs_artykuly_cechy.py $
# Copyright:   (c) 2013 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

stat = 'OK'

if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=='OK':
    Funkcja = klucze['Funkcja']
    Cecha = klucze['Cecha']
    
    SlPar={'Kod':[9]}
    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Funkcja,klucze)
    if Lista<>'':
        stat='Uwaga : wywoanie funkcji fs_artykuly_cechy z numerem '+str(Funkcja)+' bez parametrw: '+Lista

    if Funkcja == 9:
        Kod = rsglobal.Dekoduj(klucze['Kod'])

dane = []
wyn1 = []
wyn2 = []

# maksymalne dlugosci pol opisowych
dlugosci = {'kod':20,'opis':50}

UprIns=((self.oddzial_id,'017013') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID
UprUpd=((self.oddzial_id,'017012') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID or UprIns
UprDel=((self.oddzial_id,'017014') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID


#-------------------------------------------------------------------------------
#-------  POBRANIE OPISU CECHY ARTYKULU (9)
#-------------------------------------------------------------------------------

if Funkcja == 9 and stat == "OK":
    sql ="SELECT COALESCE(opis,'') FROM rs_artykuly_cechy"
    sql+=" WHERE firma_id='"+self.firma_id+"' AND kod='"+Kod+"'"
    stat,dane,dump,dump = self.PolSQL.Execute(sql,3)
    if stat <> 'OK':
        stat = 'Bd przy pobieraniu opisu cechy artykuu: '+stat
        dane.append(stat)


#-------------------------------------------------------------------------------
#-------- EDYCJA GRIDA EDYTOWALNEGO (1)
#-------------------------------------------------------------------------------

Insert = []
Update = []
Delete = []

if Funkcja == 1:
    Update=klucze['Update']
    Insert=klucze['Insert']
    Delete=klucze['Delete']


#-------------------------------------------------------------------------------
#-------  SPRAWDZANIE DELETE  --------------------------------------------------
#-------------------------------------------------------------------------------

if Funkcja == 1 and stat=="OK":
    if len(Delete[0])>0:
        if not UprDel:
            stat='BR UPR DEL'
            dane.append(stat)
        
        # wykonanie DELETE 
        if stat == 'OK':
            SQLDEL = ''
            SQLFU = ''
            for i in xrange(len(Delete[0])):
                SQLFU = "SELECT kod FROM rs_artykuly_cechy WHERE firma_id='"+self.firma_id+"'"
                DELETE = "DELETE FROM rs_artykuly_cechy "
                WHERE = "WHERE firma_id='"+self.firma_id+"'"
                for j in xrange(len(Delete[0][i])):
                    pole = Delete[1][j]
                    wart = Delete[0][i][j]
                    if pole in ['kod']:
                        WHERE += " AND "+pole+"='"+wart+"'"
                        SQLFU += " AND "+pole+"='"+wart+"'"

                        # sprawdzenie, czy usuwana cecha jest w artykulach
                        # uwaga: cecha stripowana
                        sql ="SELECT artykul_id FROM rs_artykuly"
                        sql+=" WHERE firma_id='"+self.firma_id+"' AND cecha1_opis='"+wart.strip()+"';"
                        stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                        if stat <> 'OK':
                            stat = 'Bd sprawdzenia usuwanej cechy w artykulach: '+stat
                            dane.append(stat)
                        elif len(d) > 0:
                            stat = 'Nie mona usun cechy '+wart.strip()+' poniewa jest uywana w artykuach'
                            dane.append(stat)
                
                SQLDEL += DELETE+WHERE+"; "
                SQLFU += " FOR UPDATE NOWAIT; "

            if stat == 'OK':
                if len(dane) > 0:
                    stat == dane[0]

            if SQLFU <> '' and stat == 'OK':
                stat,d,dump,dump = self.PolSQL.Execute(rsglobal.Dekoduj(SQLFU),3)
                if stat <> 'OK':
                    stat = 'Bd sprawdzenia danych do usunicia: '+stat
                    dane.append(stat)

            if stat == "OK" and SQLDEL <> '':
                stat,dump,dump,dump = self.PolSQL.Execute(rsglobal.Dekoduj(SQLDEL),1)
                if stat <> 'OK':
                    stat = "Bd przy usuwaniu danych: "+stat   
                    dane.append(stat)


#-------------------------------------------------------------------------------
#---   UPDATE DANYCH (1)
#-------------------------------------------------------------------------------

if Funkcja == 1 and stat=="OK":
    if len(Update[0])>0:
        if not UprUpd:
            stat='BR UPR UPD'
            dane.append(stat)

        if stat == 'OK':
            SQLFU = ''
            for i in xrange(len(Update[0])):
                SQLFU+="SELECT kod FROM rs_artykuly_cechy"
                SQLFU+=" WHERE firma_id='"+self.firma_id+"'"
                for j in xrange(len(Update[2][i])): # petla po kluczu
                    pole = Update[3][j]
                    wart = rsglobal.Dekoduj(Update[2][i][j])
                    if pole in ('kod',):
                        SQLFU += " AND "+pole+"='"+wart+"'"
                
                SQLFU += " FOR UPDATE NOWAIT; "
            
            if SQLFU <> '':
                stat,d,dump,dump = self.PolSQL.Execute(rsglobal.Dekoduj(SQLFU),3)
                if stat <> 'OK':
                    stat = 'Bd sprawdzenia danych do modyfikacji: '+stat
                    dane.append(stat)
            
        if stat == 'OK':
            WierszeNr = Update[-1]

            for i in xrange(len(Update[0])):
                KodNowy = None

                for j in xrange(len(Update[0][i])): 
                    pole = Update[0][i][j]
                    wart = Update[1][i][j]

                    if pole == 'kod':
                        KodNowy = str(wart)
                        if wart.strip() == '':
                            stat = 'BR KOD'
                            wyn2.append((WierszeNr[i],0))
                            dane.append(stat)
                        elif len(wart) > dlugosci[pole]:
                            stat = 'BL KOD DLG'
                            wyn2.append((WierszeNr[i],0))
                            dane.append(stat)
                        else:
                            sql ="SELECT kod FROM rs_artykuly_cechy"
                            sql+=" WHERE firma_id='"+self.firma_id+"' AND kod='"+wart+"';"
                            stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                            if stat <> 'OK':
                                stat = 'BL SQL KOD'
                                wyn2.append((WierszeNr[i],0))
                                dane.append(stat)
                            elif len(d) > 0:
                                stat = 'BL KOD IST'
                                wyn2.append((WierszeNr[i],0))
                                dane.append(stat)
                            
                    elif pole == 'opis':
                        if wart.strip() == '':
                            stat = 'BR OPIS'
                            wyn2.append((WierszeNr[i],1))
                            dane.append(stat)
                        elif len(wart) > dlugosci[pole]:
                            stat = 'BL OPIS DLG'
                            wyn2.append((WierszeNr[i],1))
                            dane.append(stat)
                            
                            
        if stat == 'OK':
            if len(dane) > 0:
                stat = dane[0]
                
        # wykonanie UPDATE
        if stat=='OK':
            sql=''
            for i in xrange(len(Update[0])):
                UPDATE="UPDATE rs_artykuly_cechy "
                SET='SET '
                for j in xrange(len(Update[0][i])): 
                    pole=Update[0][i][j]
                    wart=Update[1][i][j]
                    if pole in ['kod','opis']:
                        SET+=pole+"='"+wart+"',"

                SET=SET.strip(",")
                WHERE=" WHERE firma_id='"+self.firma_id+"'"
                for j in xrange(len(Update[2][i])): # petla po kluczu
                    pole=Update[3][j]
                    wart=rsglobal.Dekoduj(Update[2][i][j])
                    if pole in ['kod']:
                        WHERE+= " AND "+pole+"='"+wart+"'"

                WHERE+=";"
                
                sql+=UPDATE+SET+WHERE;
                
            if sql<>'':
                stat,dump,dump,dump=self.PolSQL.Execute(rsglobal.Dekoduj(sql),1)
                if stat<>'OK':
                    stat="Bd przy modyfikowaniu danych: "+stat   
                    dane.append(stat)  


#-------------------------------------------------------------------------------
#---------Sprawdzanie danych do Insert------
#-------------------------------------------------------------------------------

if Funkcja == 1 and stat=="OK":
    if len(Insert[0])>0:
        if not UprIns:
            stat='BR UPR INS'
            dane.append(stat)

        if stat == 'OK':
            WierszeNr = Insert[-1]
            for i in xrange(len(Insert[0])):
                KodNowy = None
                
                for j in xrange(len(Insert[0][i])): 
                    pole=Insert[1][j]
                    wart=Insert[0][i][j]

                    if pole == 'kod':
                        KodNowy = str(wart)
                        if wart.strip() == '':
                            stat = 'BR KOD'
                            wyn2.append((WierszeNr[i],0))
                            dane.append(stat)
                        elif len(wart) > dlugosci[pole]:
                            stat = 'BL KOD DLG'
                            wyn2.append((WierszeNr[i],0))
                            dane.append(stat)
                        else:
                            sql ="SELECT kod FROM rs_artykuly_cechy"
                            sql+=" WHERE firma_id='"+self.firma_id+"' AND kod='"+wart+"';"
                            stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                            if stat <> 'OK':
                                stat = 'BL SQL KOD'
                                wyn2.append((WierszeNr[i],0))
                                dane.append(stat)
                            elif len(d) > 0:
                                stat = 'BL KOD IST'
                                wyn2.append((WierszeNr[i],0))
                                dane.append(stat)

                    elif pole == 'opis':
                        if wart.strip() == '':
                            stat = 'BR OPIS'
                            wyn2.append((WierszeNr[i],1))
                            dane.append(stat)
                        elif len(wart) > dlugosci[pole]:
                            stat = 'BL OPIS DLG'
                            wyn2.append((WierszeNr[i],1))
                            dane.append(stat)
                            
                
        if stat == 'OK':
            if len(dane) > 0:
                stat = dane[0]

        # wykonanie INSERT
        if stat == 'OK':
            sqlIns=''
            for i in xrange(len(Insert[0])):
                INSERT="INSERT INTO rs_artykuly_cechy "
                KOLUMNY="(firma_id"
                VALUES=" VALUES ('"+self.firma_id+"'"
                for j in xrange(len(Insert[0][i])):
                    pole=Insert[1][j]
                    wart=Insert[0][i][j]
                    if pole in ['kod','opis']:
                        KOLUMNY+=","+pole
                        VALUES+=",'"+wart+"'"

                KOLUMNY+=")"
                VALUES+=");"
                sqlIns+=INSERT+KOLUMNY+VALUES
            if sqlIns<>'': 
                stat,dump,dump,dump=self.PolSQL.Execute(rsglobal.Dekoduj(sqlIns),1)
                if stat<>'OK':
                    stat="Bd przy dodawaniu danych: "+stat
                    dane.append(stat)


#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (1- insert 1 -select, 1 -delete), 5
#-------------------------------------------------------------------------------

if Funkcja in (1,5) and stat=='OK':
    SQL ="SELECT kod,COALESCE(opis)"
    SQL+=" FROM rs_artykuly_cechy"
    SQL+=" WHERE firma_id='"+self.firma_id+"'"
    if Cecha[0]<>'':
        SQL+=" AND kod LIKE '"+Cecha[0].strip().replace('"','').replace("'",'')+"%'"
    SQL+=" ORDER BY kod;"

    stat,dane,wyn1,wyn2 = self.PolSQL.Execute(SQL,3)
    if stat <> 'OK':
        stat = "Bd przy pobieraniu danych: "+stat
        dane.append(stat)
   
