
# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_artykuly_cechy_sekcje.py
# Purpose:     obsluga grida edytowalnego z sekcjami cech artykuw
# Author:      Micha Raburski
# Created:     2014/03/09
# RCS-ID:      $Id: fs_artykuly_cechy_sekcje
# Copyright:   (c) 2014 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

stat='OK'
rsglobal.ZapiszDoLogow('SEKCJE KLUCZE '+str(klucze),1)
from funkcje import fs_artykuly_cechy_pom

if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=='OK':
    Funkcja = klucze['Funkcja']
    
    SlPar={'Cecha':[1,4,5]}
    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Funkcja,klucze)
    if Lista<>'':
        stat='Uwaga : wywoanie funkcji fs_artykuly_cechy_sekcje z numerem '+str(Funkcja)+' bez parametrw: '+Lista
    
if stat == 'OK':
    if Funkcja in [1,4,5]:
        Cecha = rsglobal.Dekoduj(klucze["Cecha"])
        
dane = []
wyn1 = []
wyn2 = []
SprawdzacDlugosc=False

UprIns=((self.oddzial_id,'017023') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID
UprUpd=((self.oddzial_id,'017022') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID or UprIns
UprDel=((self.oddzial_id,'017024') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID


#-------------------------------------------------------------------------------
#-------- EDYCJA GRIDA EDYTOWALNEGO (1)
#-------------------------------------------------------------------------------

Insert = []
Update = []
Delete = []

if Funkcja == 1:
    Update=klucze['Update']
    Insert=klucze['Insert']
    Delete=klucze['Delete']


#-------------------------------------------------------------------------------
#-------  SPRAWDZANIE DO BLOKOWANIA EDYCJI  ------------------------------------
#-------------------------------------------------------------------------------

if Funkcja in (1,4) and stat=='OK':
    stat=fs_artykuly_cechy_pom.SprawdzanieDlaCechySekcje(self,Cecha)
            

#-------------------------------------------------------------------------------
#-------  SPRAWDZANIE DELETE  --------------------------------------------------
#-------------------------------------------------------------------------------

if Funkcja == 1 and stat=="OK":
    if len(Delete[0])>0:
        if not UprDel:
            stat='BR UPR DEL'
            dane.append(stat)
        
        # wykonanie DELETE 
        if stat == 'OK':
            SQLDEL = ''
            SQLDELWART = ''
            SQLFU = ''
            for i in xrange(len(Delete[0])):
                SQLFU = "SELECT lp FROM rs_artykuly_cechy_sekcje WHERE firma_id='"+self.firma_id+"' AND kod='"+Cecha+"'"
                DELETE = "DELETE FROM rs_artykuly_cechy_sekcje "
                DELETEWART = "DELETE FROM rs_artykuly_cechy_wartosci "
                WHERE = "WHERE firma_id='"+self.firma_id+"' AND kod='"+Cecha+"'"
                
                for j in xrange(len(Delete[0][i])):
                    pole = Delete[1][j]
                    wart = Delete[0][i][j]
                    if pole in ['lp']:
                        WHERE += " AND "+pole+"="+str(wart)
                        SQLFU += " AND "+pole+"="+str(wart)
                
                SQLDEL += DELETE+WHERE+"; "
                SQLDELWART += DELETEWART+WHERE+"; "
                SQLFU += " FOR UPDATE NOWAIT; "

            if SQLFU <> '':
                stat,d,dump,dump = self.PolSQL.Execute(rsglobal.Dekoduj(SQLFU),3)
                if stat <> 'OK':
                    stat = 'Bd sprawdzenia danych do usunicia: '+stat
                    dane.append(stat)

            if stat == 'OK' and SQLDEL <> '':
                stat,dump,dump,dump = self.PolSQL.Execute(rsglobal.Dekoduj(SQLDEL),1)
                if stat <> 'OK':
                    stat = "Bd przy usuwaniu danych: "+stat   
                                    
            if stat == 'OK' and SQLDELWART <> '':
                stat,dump,dump,dump = self.PolSQL.Execute(rsglobal.Dekoduj(SQLDELWART),1)
                if stat <> 'OK':
                    stat = "Bd przy usuwaniu danych: "+stat 
                    
    
#-------------------------------------------------------------------------------
#---   UPDATE DANYCH (1)
#-------------------------------------------------------------------------------

if Funkcja == 1 and stat=="OK":
    if len(Update[0])>0:
        if not UprUpd:
            stat='BR UPR UPD'
            dane.append(stat)

        if stat == 'OK':
            obecnelp=[]
            SQLFU = ''
            for i in xrange(len(Update[0])):
                SQLFU = "SELECT lp FROM rs_artykuly_cechy_sekcje WHERE firma_id='"+self.firma_id+"' AND kod='"+Cecha+"'"
                for j in xrange(len(Update[2][i])): # petla po kluczu
                    pole = Update[3][j]
                    wart = rsglobal.Dekoduj(Update[2][i][j])
                    if pole == 'lp':
                        SQLFU += " AND "+pole+"="+str(wart)
                
                SQLFU += " FOR UPDATE NOWAIT; "
                if SQLFU <> '':
                    stat,d,dump,dump = self.PolSQL.Execute(rsglobal.Dekoduj(SQLFU),3)
                    if stat <> 'OK':
                        stat = 'Bd sprawdzenia danych do modyfikacji: '+stat
                        dane.append(stat)
                    else:
                        obecnelp.append(d[0][0])
                    
        #spr czy istnieje jakas pozycja w cechach wartosci    
        if stat == 'OK':
            istnieje=[]
            SQLFU = ''
            for i in xrange(len(Update[0])):
                SQLFU = "SELECT lp FROM rs_artykuly_cechy_wartosci WHERE firma_id='"+self.firma_id+"' AND kod='"+Cecha+"'"
                for j in xrange(len(Update[2][i])): # petla po kluczu
                    pole = Update[3][j]
                    wart = rsglobal.Dekoduj(Update[2][i][j])
                    if pole == 'lp':
                        SQLFU += " AND "+pole+"="+str(wart)
                
                SQLFU += " FOR UPDATE NOWAIT; "
                if SQLFU <> '':
                    stat,da,dump,dump = self.PolSQL.Execute(rsglobal.Dekoduj(SQLFU),3)
                    if stat <> 'OK':
                        stat = 'Bd sprawdzenia danych do modyfikacji: '+stat
                        dane.append(stat)
                    else:
                        if da <> []:
                            istnieje.append(da[0][0])
                        else:
                            istnieje.append('')
            
        if stat == 'OK':
            WierszeNr = Update[-1]
            for i in xrange(len(Update[0])):
                for j in xrange(len(Update[0][i])): 
                    pole = Update[0][i][j]
                    wart = Update[1][i][j]
                    if pole == 'lp':
                        if wart <=0:
                            wyn2.append((WierszeNr[i],0))
                            dane.append('LP UJ')
                        elif wart == obecnelp[i]:
                            wyn2.append((WierszeNr[i],0))
                            dane.append('LP IST')
                            
                    if pole == 'dlugosc':
                        if istnieje[i] <> '':
                            wyn2.append((WierszeNr[i],2))
                            dane.append('DL NIE')
                        elif wart <=0:
                            wyn2.append((WierszeNr[i],2))
                            dane.append('DL UJ')
                        SprawdzacDlugosc=True
                        
        if stat == 'OK':
            if len(dane) > 0:
                stat = dane[0]
                
        # wykonanie UPDATE
        if stat=='OK':
            sql=''
            sqlwart=''
            SETWART=''
            for i in xrange(len(Update[0])):
                UPDATE="UPDATE rs_artykuly_cechy_sekcje "
                UPDATEWART="UPDATE rs_artykuly_cechy_wartosci "
                SET='SET '
                for j in xrange(len(Update[0][i])): 
                    pole=Update[0][i][j]
                    wart=Update[1][i][j]
                    if pole in ['lp']:
                        SET+=pole+"="+str(wart)+","
                        SETWART=pole+"="+str(wart)
                    elif pole in ['dlugosc']:
                        SET+=pole+"="+str(wart)+","
                    elif pole in ['opis']:
                        SET+=pole+"='"+wart+"',"
                SET=SET.strip(",")
                WHERE=" WHERE firma_id='"+self.firma_id+"' AND kod='"+Cecha+"'"
                for j in xrange(len(Update[2][i])): # petla po kluczu
                    pole=Update[3][j]
                    wart=rsglobal.Dekoduj(Update[2][i][j])
                    if pole in ['lp']:
                        WHERE+= " AND "+pole+"="+str(wart)

                WHERE+=";"
                sql+=UPDATE+SET+WHERE;
                
                if SETWART <> '':
                    sqlwart+=UPDATEWART+"SET "+SETWART+WHERE+";"
                    
            if sql<>'':
                stat,dump,dump,dump=self.PolSQL.Execute(rsglobal.Dekoduj(sql),1)
                if stat<>'OK':
                    stat="Bd przy modyfikowaniu danych: "+stat   
                    
            if sqlwart<>'':
                stat,dump,dump,dump=self.PolSQL.Execute(rsglobal.Dekoduj(sqlwart),1)
                if stat<>'OK':
                    stat="Bd przy modyfikowaniu danych 2: "+stat 


#-------------------------------------------------------------------------------
#---------Sprawdzanie danych do Insert------
#-------------------------------------------------------------------------------

if Funkcja == 1 and stat=="OK":
    if len(Insert[0])>0:
        if not UprIns:
            stat='BR UPR INS'
            dane.append(stat)
            
        if stat == 'OK':
            obecnelp=[]
            SQLFU = ''
            for i in xrange(len(Insert[0])):
                SQLFU = "SELECT lp FROM rs_artykuly_cechy_sekcje WHERE firma_id='"+self.firma_id+"' AND kod='"+Cecha+"'"
                for j in xrange(len(Insert[0][i])): # petla po kluczu
                    pole = Insert[1]
                    wart = rsglobal.Dekoduj(Insert[0][i])
                    if pole == 'lp':
                        SQLFU += " AND "+pole+"="+str(wart)
                
                SQLFU += " FOR UPDATE NOWAIT; "
                if SQLFU <> '':
                    stat,d,dump,dump = self.PolSQL.Execute(rsglobal.Dekoduj(SQLFU),3)
                    if stat <> 'OK':
                        stat = 'Bd sprawdzenia danych do modyfikacji: '+stat
                        dane.append(stat)

        if stat == 'OK':
            SprawdzacDlugosc=True
            WierszeNr = Insert[-1]
            for i in xrange(len(Insert[0])):
                for j in xrange(len(Insert[0][i])): 
                    pole=Insert[1][j]
                    wart=Insert[0][i][j]
                    
                    if pole == 'lp':                        
                        if wart <=0:
                            wyn2.append((WierszeNr[i],0))
                            dane.append('LP UJ')
                        for k in xrange(len(d)):
                            if wart == d[k][0]:
                                wyn2.append((WierszeNr[i],0))
                                dane.append('LP IST')

                    if pole == 'dlugosc':
                        if wart <=0:
                            wyn2.append((WierszeNr[i],2))
                            dane.append('DL UJ')

        if stat == 'OK':
            if len(dane) > 0:
                stat = dane[0]

        # wykonanie INSERT
        if stat == 'OK':
            sqlIns=''
            for i in xrange(len(Insert[0])):
                INSERT="INSERT INTO rs_artykuly_cechy_sekcje "
                KOLUMNY="(firma_id,kod"
                VALUES=" VALUES ('"+self.firma_id+"','"+Cecha+"'"
                for j in xrange(len(Insert[0][i])):
                    pole=Insert[1][j]
                    wart=Insert[0][i][j]
                    
                    KOLUMNY+=","+pole
                    if pole in ['lp','dlugosc']:
                        VALUES+=","+str(wart)
                    elif pole in ['opis']:
                        VALUES+=",'"+rsglobal.Dekoduj(wart)+"'"

                KOLUMNY+=")"
                VALUES+=");"
                sqlIns+=INSERT+KOLUMNY+VALUES
            if sqlIns<>'': 
                stat,dump,dump,dump=self.PolSQL.Execute(rsglobal.Dekoduj(sqlIns),1)
                if stat<>'OK':
                    stat="Bd przy dodawaniu danych: "+stat

    if stat == 'OK' and SprawdzacDlugosc:
        SQL="SELECT SUM(dlugosc) FROM rs_artykuly_cechy_sekcje WHERE firma_id='"+self.firma_id+"' AND kod='"+Cecha+"';"
        stat,DTest,dump,dump=self.PolSQL.Execute(SQL,3)
        if stat<>'OK':
            stat="Bd przy sprawdzaniu sumy dugoci: "+stat
        elif DTest[0][0] > 30:
            stat='Suma dugoci sekcji musi by mniejsza lub rwna 30, a w tej chwili wynosi '+str(DTest[0][0])

#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (1- insert 1 -select, 1 -delete, 5 - select)
#-------------------------------------------------------------------------------

if Funkcja in (1,5) and stat=='OK':
    SQL ="SELECT lp,opis,dlugosc FROM rs_artykuly_cechy_sekcje"
    SQL+=" WHERE firma_id='"+self.firma_id+"' AND kod='"+Cecha+"' ORDER BY lp;"

    stat,dane,wyn1,wyn2 = self.PolSQL.Execute(SQL,3)
    if stat <> 'OK':
        stat = "Bd przy pobieraniu danych: "+stat
