# -*- coding: iso8859_2 -*-
#-----------------------------------------------------------------------------
# Name:        fs_artykuly_ceny.py
# Purpose:     Pobieranie/usuwanie cen na gridzie z cenami artykuw
# Author:      Jarek Plawgo
# Created:     2006/08/30
# RCS-ID:      $Id: fs_artykuly_ceny.py $
# Copyright:   (c) 2004 Record System
# Licence:     GNU GPL
#-----------------------------------------------------------------------------
# 2010-12-29, Marcin Natkaksi, refaktoryzacja (4157)

stat = 'OK'
dane = []

if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=='OK':
    Funkcja = klucze['Funkcja']
    
    SlPar={'NrArt':[5,6],'Wersja':[6],'Data':[6],'Waluta':[6],
    'WersjaF':[5,6],'DataF':[5,6],'WalutaF':[5,6]}    
    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Funkcja,klucze)
    if Lista<>'':
        stat='Uwaga : wywoanie funkcji fs_artykuly_ceny z numerem '+str(Funkcja)+' bez parametrw: '+Lista

if stat=='OK':
    if Funkcja in [6,]:
        wersja=rsglobal.Dekoduj(klucze['Wersja'])
        waluta=rsglobal.Dekoduj(klucze['Waluta'])
        data=rsglobal.Dekoduj(klucze['Data'])
                
    if Funkcja in [5,6]:
        WersjaF=rsglobal.Dekoduj(klucze['WersjaF'])
        DataF=rsglobal.Dekoduj(klucze['DataF'])
        WalutaF=rsglobal.Dekoduj(klucze['WalutaF'])
        artykul=rsglobal.Dekoduj(klucze['NrArt'])

UprDel=((self.oddzial_id,"013034") in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)


#-------------------------------------------------------------------------------
#-------------------------------------------------------------------------------
#---   USUWANIE - 6 
#-------------------------------------------------------------------------------
#-------------------------------------------------------------------------------
    
if Funkcja==6:
    if not UprDel:
        stat="Brak uprawnie do usuwania."   
        dane.append(stat)
    if stat=='OK':
        SQL= "DELETE FROM rs_artykuly_ceny" 
        SQL+=" WHERE artykul_id='"+artykul+"' AND firma_id = '"+self.firma_id+"'" 
        SQL+=" AND wersja = '"+wersja+"' AND waluta= '"+waluta+"' AND data_od = '"+data+"';"
        stat,dane,wyn1,wyn2=self.PolSQL.Execute(SQL,1)
        if stat<>'OK':
            stat='Bdy usuwanie ceny'
            dane.append(stat)
            
            
#-------------------------------------------------------------------------------
#-------------------------------------------------------------------------------
#---   SELECT - 5, 6
#-------------------------------------------------------------------------------
#-------------------------------------------------------------------------------

if Funkcja in (5,6) and stat=='OK':
	# Jeeli nie podano daty_od
    if DataF=='    -  -  ':
        Select = "SELECT ac.wersja,ac.waluta,ac.data_od,ac.cena_netto1,ac.cena_brutto1,COALESCE(wc.po_przecinku,-1)"
        Select+= " FROM rs_artykuly_ceny ac LEFT JOIN rs_wersje_cenowe wc ON(wc.firma_id=ac.firma_id AND wc.kod=ac.wersja)" 
        Select+= " WHERE ac.firma_id='"+self.firma_id+"'AND ac.artykul_id='"+artykul+"' "
        if WersjaF<>'':
            Select+= " AND ac.wersja LIKE '"+WersjaF+"%' "
        if WalutaF<>'':
            Select+= " AND ac.waluta LIKE '"+WalutaF+"%' "
        Select+= " ORDER BY ac.wersja,ac.data_od;"
        stat,dane,wyn1,wyn2=self.PolSQL.Execute(Select,3)
    #Jeeli  podano date
    else:
        SQL=  " SELECT ac.wersja,ac.waluta,MAX(ac.data_od), "
        SQL+= " rsf_podaj_cene_n1('"+self.firma_id+"','"+artykul+"',wersja,waluta,'"+DataF+"'), "
        SQL+= " rsf_podaj_cene_b1('"+self.firma_id+"','"+artykul+"',wersja,waluta,'"+DataF+"'), "
        SQL+= " COALESCE(wc.po_przecinku,-1)"
        SQL+= " FROM rs_artykuly_ceny ac LEFT JOIN rs_wersje_cenowe wc ON(wc.firma_id=ac.firma_id AND wc.kod=ac.wersja)" 
        SQL+= " WHERE ac.firma_id='"+self.firma_id+"' AND ac.artykul_id='"+artykul+"' AND ac.data_od<='"+DataF+"'"
        if WersjaF<>'':
            SQL+=" AND ac.wersja like '"+WersjaF+"%' "
        if WalutaF<>'':
            SQL+=" AND ac.waluta like '"+WalutaF+"%' "
        SQL+=" GROUP BY ac.wersja,ac.waluta,"
        SQL+=" rsf_podaj_cene_n1('"+self.firma_id+"','"+artykul+"',wersja,waluta,'"+DataF+"'),"
        SQL+=" rsf_podaj_cene_b1('"+self.firma_id+"','"+artykul+"',wersja,waluta,'"+DataF+"'),"
        SQL+=" COALESCE(wc.po_przecinku,-1)"
        SQL+= "ORDER BY ac.wersja,ac.waluta,MAX(ac.data_od);"
        stat,dane,wyn1,wyn2=self.PolSQL.Execute(SQL,3)
        if stat<>'OK':
            stat='Bdy pobierania ceny'
            dane.append(stat)
    if stat<>'OK':
        stat='Bdy pobierania cen'
        dane.append(stat)

#----------------  sprawdzamy czy dane maj by przesyane dalej
if stat == "OK" and Funkcja in (6,) and self.firma_id == '01':  #WS 2020-12-16  - self.firma_id
    stat, jest, none, none = self.PolSQL.Execute("SELECT COUNT(*) FROM rs_komser_funkcje WHERE nazwa='fs_artykuly_ceny'", 4)
    if stat != "OK":
        stat = "BL rs_komser_funkcje"
    elif jest:
        stat, odp, none, none = self.WykonajFunkcje("fs_komser_zapisz", ["funkcja"], [funkcja, klucze, pola, wartosci])