# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_artykuly_daty_dostaw.py
# Purpose:     obsluga grida edytowalnego z limitami dat dostaw
# Author:      Micha Raburski
# Created:     2015/01/25
# RCS-ID:      $Id: fs_artykuly_daty_dostaw.py$
# Copyright:   (c) 2015 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

stat='OK'

if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=='OK':
    Funkcja = klucze['Funkcja']
    
    SlPar={'Artykul':[1,5],'Kontrahent':[1,5],'Kategoria':[1,5]}
    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Funkcja,klucze)
    if Lista<>'':
        stat='Uwaga : wywoanie funkcji fs_artykuly_daty_dostaw z numerem '+str(Funkcja)+' bez parametrw: '+Lista
        
    if Funkcja in [1,5]: 
        ArtF=str(klucze['Artykul'])
        KontrF=str(klucze['Kontrahent'])
        KategF=str(klucze['Kategoria'])
        
dane = []
wyn1 = []
wyn2 = []

UprIns=((self.oddzial_id,'018003') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID
UprUpd=((self.oddzial_id,'018002') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID or UprIns
UprDel=((self.oddzial_id,'018004') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID

Insert = []
Update = []
Delete = []

if Funkcja == 1 and stat =='OK':
    Update=klucze['Update']
    Insert=klucze['Insert']
    Delete=klucze['Delete']

#-------------------------------------------------------------------------------
#--- DELETE (1)
#-------------------------------------------------------------------------------

if Funkcja == 1 and stat=="OK":
    DZmDel = [] 
    DZmUpdPrzed = [] 
    DZmUpdPo = [] 
    DZmIns = [] 
    
    if len(Delete[0])>0:
        if not UprDel:
            stat='BR UPR DEL'
            dane.append(stat)
        
        # wykonanie DELETE  
        if stat == 'OK':
            SQLDEL = ''
            SQLFU = ''
            
            SQLZM = "SELECT DISTINCT COALESCE(kateg_artykulu,''),COALESCE(artykul_id,''),COALESCE(kontrahent_id,'')"
            SQLZM +=" FROM rs_artykuly_kontrahenci_daty_dostaw WHERE lp IN ("
            
            for i in xrange(len(Delete[0])):
                DELETE = "DELETE FROM rs_artykuly_kontrahenci_daty_dostaw "
                WHERE = "WHERE firma_id='"+self.firma_id+"'"
                SQLFU = "SELECT lp FROM rs_artykuly_kontrahenci_daty_dostaw"
                SQLFU+= " WHERE firma_id='"+self.firma_id+"'"
                for j in xrange(len(Delete[0][i])):
                    pole = Delete[1][j]
                    wart = str(Delete[0][i][j])
                    if pole in ['lp',]:
                        WHERE += " AND "+pole+"="+wart
                        SQLFU += " AND "+pole+"="+wart
                        SQLZM += wart+","

                SQLDEL += DELETE+WHERE+"; "
                SQLFU += " FOR UPDATE NOWAIT; "

            if SQLFU <> '':
                stat,d,dump,dump = self.PolSQL.Execute(rsglobal.Dekoduj(SQLFU),3)
                if stat <> 'OK':
                    stat = 'Bd sprawdzenia danych do usunicia: '+stat
                    dane.append(stat)
            # pobranie zmian do analizy
            if stat == 'OK':
                SQLZM = SQLZM.strip(',') + ") AND NOT dostarczac"
                rsglobal.ZapiszDoLogow('SQLZM1 '+SQLZM,1)
                stat,DZmDel,dump,dump = self.PolSQL.Execute(rsglobal.Dekoduj(SQLZM),3)
                if stat <> 'OK':
                    stat = 'Bd sprawdzenia usuwanych danych do analizy: '+stat
                    dane.append(stat)
            
            if stat == 'OK' and SQLDEL <> '':
                rsglobal.ZapiszDoLogow('SQLDEL '+str(SQLDEL),1)
                stat,dump,dump,dump = self.PolSQL.Execute(rsglobal.Dekoduj(SQLDEL),1)
                if stat <> 'OK':
                    stat = "Bd przy usuwaniu danych: "+stat   
                    dane.append(stat)

                                 
#-------------------------------------------------------------------------------
#---   UPDATE DANYCH (1)
#-------------------------------------------------------------------------------

if Funkcja == 1 and stat=="OK":
    if len(Update[0])>0:
        if not UprUpd:
            stat='BR UPR UPD'
            dane.append(stat)

        if stat == 'OK':
            SQLFU = ''
            SQLZM = "SELECT DISTINCT COALESCE(kateg_artykulu,''),COALESCE(artykul_id,''),COALESCE(kontrahent_id,'')"
            SQLZM +=" FROM rs_artykuly_kontrahenci_daty_dostaw WHERE lp IN ("
            
            for i in xrange(len(Update[0])):
                SQLFU+= "SELECT lp FROM rs_artykuly_kontrahenci_daty_dostaw"
                SQLFU+= " WHERE firma_id='"+self.firma_id+"'"
                for j in xrange(len(Update[2][i])): # petla po kluczu
                    pole = Update[3][j]
                    wart = rsglobal.Dekoduj(Update[2][i][j])
                    SQLFU += " AND "+pole+"="+str(wart)
                    SQLZM += str(wart)+","
                SQLFU += " FOR UPDATE NOWAIT; "
            
            if SQLFU <> '':
                stat,dFU,nFU,dump = self.PolSQL.Execute(rsglobal.Dekoduj(SQLFU),3)
                if stat <> 'OK':
                    stat = 'Bd sprawdzenia danych do modyfikacji: '+stat
                    dane.append(stat)

        # pobranie zmian do analizy - przed zmianami
        if stat == 'OK':
            SQLZM = SQLZM.strip(',') + ") AND NOT dostarczac"
            rsglobal.ZapiszDoLogow('SQLZM2 '+SQLZM,1)
            stat,DZmUpdPrzed,dump,dump = self.PolSQL.Execute(rsglobal.Dekoduj(SQLZM),3)
            if stat <> 'OK':
                stat = 'Bd sprawdzenia edytowanych danych do analizy - przed: '+stat
                dane.append(stat)
                
        if stat == 'OK':
            WierszeNr = Update[-1]
            for i in xrange(len(Update[0])):
                if stat =='OK':
                    #pobranie artykuu i kategorii w celu weryfikacji, czy na pewno cho jeden jest wypeniony:
    
                    sql = "SELECT kateg_artykulu,artykul_id FROM rs_artykuly_kontrahenci_daty_dostaw "
                    sql+= " WHERE firma_id='"+self.firma_id+"'"
                    for j in xrange(len(Update[2][i])): # petla po kluczu (lp)
                        pole = Update[3][j]
                        wart = rsglobal.Dekoduj(Update[2][i][j])
                        sql += " AND "+pole+"="+str(wart)
                    sql += ";"
    
                    stat,DPoz,dump,dump = self.PolSQL.Execute(sql,3)
                    if stat <> 'OK':
                        stat = 'Bd pobrania modyfikowanych danych: '+stat
                        dane.append(stat)
                        break
                    elif len(DPoz) == 0:
                        stat = 'Brak modyfikowanego wiersza w tabeli: '+stat
                        dane.append(stat)
                        break
                    elif len(DPoz) > 1:
                        stat = 'Niejednoznaczny klucz: '+stat
                        dane.append(stat)
                        break
                    
                if stat == 'OK':
                    KategS = DPoz[0][0]
                    ArtS = DPoz[0][1]

                    for j in xrange(len(Update[0][i])): 
                        pole = Update[0][i][j]
                        wart = Update[1][i][j]
        
                        if pole == 'kateg_artykulu':
                            wart = wart.strip()
                            KategS = str(wart)
                            if wart <> '':
                                SQL ="SELECT kod FROM rs_kateg_artykulow"
                                SQL+=" WHERE firma_id = '"+self.firma_id+"'"
                                SQL+=" AND  kod= '"+str(wart)+"'" 
                                stat,d,dump,dump = self.PolSQL.Execute(SQL,3)
                                if stat <> 'OK':
                                    stat = 'Bd sprawdzania kategorii artykuu :'+stat
                                elif len(d) == 0:
                                    wyn2.append((WierszeNr[i],1))
                                    dane.append('KATEG BL')
    
                        elif pole == 'artykul_id':
                            wart = wart.strip()
                            ArtS = str(wart)
                            if wart <> '':
                                SQL ="SELECT artykul_id FROM rs_artykuly"
                                SQL+=" WHERE firma_id = '"+self.firma_id+"'"
                                SQL+=" AND  artykul_id= '"+str(wart)+"'" 
                                stat,d,dump,dump = self.PolSQL.Execute(SQL,3)
                                if stat <> 'OK':
                                    stat = 'Bd sprawdzania symbolu artykuu :'+stat
                                elif len(d) == 0:
                                    wyn2.append((WierszeNr[i],3))
                                    dane.append('ART BL')
    
                        elif pole == 'kontrahent_id':
                            wart = wart.strip()
                            if wart <> '':
                                SQL ="SELECT kontrahent_id FROM rs_kontrahenci"
                                SQL+=" WHERE firma_id = '"+self.firma_id+"'"
                                SQL+=" AND  kontrahent_id= '"+str(wart)+"'" 
                                stat,d,dump,dump = self.PolSQL.Execute(SQL,3)
                                if stat <> 'OK':
                                    stat = 'Bd sprawdzania symbolu kontrahenta :'+stat
                                elif len(d) == 0:
                                    wyn2.append((WierszeNr[i],5))
                                    dane.append('KONTR BL')
    
                        elif pole == 'data':
                            wart = wart.strip()
                            DataNowy = str(wart)
                            if wart == '':
                                wyn2.append((WierszeNr[i],7))
                                dane.append('DATA BR')
                            elif not rsglobal.SprawdzCzyToData(wart):
                                wyn2.append((WierszeNr[i],7))
                                dane.append('DATA BL')

                if stat == 'OK':
                    if KategS == '' and ArtS == '':
                        wyn2.append((WierszeNr[i],1))
                        dane.append('ARTKATEG BR')

                if stat == 'OK':
                    if len(dane) > 0:
                        stat = dane[0]
                
                # wykonanie UPDATE
                if stat=='OK':
                    sql=''
                    UPDATE="UPDATE rs_artykuly_kontrahenci_daty_dostaw "
                    SET='SET '
                    for j in xrange(len(Update[0][i])): 
                        pole=Update[0][i][j]
                        wart=Update[1][i][j]
                        
                        if pole in ['kateg_artykulu','artykul_id','kontrahent_id','data']:
                            if wart.strip() == '':
                                SET+=pole+"=NULL,"
                            else:
                                SET+=pole+"='"+wart+"',"
                                
                        elif pole in ['dostarczac']:
                            SET+=pole+"="
                            if wart == 0:
                                SET+="FALSE,"
                            else:
                                SET+="TRUE,"
                        
                    SET=SET.strip(",")
                    WHERE=" WHERE firma_id='"+self.firma_id+"'" 
                    for j in xrange(len(Update[2][i])): # petla po kluczu
                        pole=Update[3][j]
                        wart=rsglobal.Dekoduj(Update[2][i][j])
                        if pole in ['lp',]:
                            WHERE+=" AND "+pole+"="+str(wart)
                        
                    WHERE+=";"
                        
                    sql+=UPDATE+SET+WHERE
                    rsglobal.ZapiszDoLogow('SQLUPD '+str(sql),1)
                    stat,dump,dump,dump = self.PolSQL.Execute(rsglobal.Dekoduj(sql),1)
                    if stat<>'OK':
                        stat="Istnieje ju wpis o podanym kluczu: "+stat   
                        dane.append(stat)
        
        # pobranie zmian do analizy - po zmianach
        if stat == 'OK':
            stat,DZmUpdPo,dump,dump = self.PolSQL.Execute(rsglobal.Dekoduj(SQLZM),3)
            if stat <> 'OK':
                stat = 'Bd sprawdzenia zmienianych danych do analizy - po: '+stat
                dane.append(stat)                
        
#-------------------------------------------------------------------------------
#---------Sprawdzanie danych do Insert
#-------------------------------------------------------------------------------

if Funkcja == 1 and stat=="OK":
    if len(Insert[0])>0:
        if not UprIns:
            stat='BR UPR INS'
            dane.append(stat)

        if stat == 'OK':
            WierszeNr = Insert[-1]
            for i in xrange(len(Insert[0])):
                KategNowa = ''
                ArtNowy = ''
                KontrNowy = ''
                DataNowy = ''
                Dostarczac = True
                
                for j in xrange(len(Insert[0][i])): 
                    pole=Insert[1][j]
                    wart=Insert[0][i][j]
                    
                    if pole == 'kateg_artykulu':
                        wart = wart.strip()
                        KategNowa = str(wart)
                        if wart <> '':
                            SQL ="SELECT kod FROM rs_kateg_artykulow"
                            SQL+=" WHERE firma_id = '"+self.firma_id+"'"
                            SQL+=" AND  kod= '"+str(wart)+"'" 
                            stat,d,dump,dump = self.PolSQL.Execute(SQL,3)
                            if stat <> 'OK':
                                stat = 'Bd sprawdzania kategorii artykuu :'+stat
                            elif len(d) == 0:
                                wyn2.append((WierszeNr[i],1))
                                dane.append('KATEG BL')

                    elif pole == 'artykul_id':
                        wart = wart.strip()
                        ArtNowy = str(wart)
                        if wart <> '':
                            SQL ="SELECT artykul_id FROM rs_artykuly"
                            SQL+=" WHERE firma_id = '"+self.firma_id+"'"
                            SQL+=" AND  artykul_id= '"+str(wart)+"'" 
                            stat,d,dump,dump = self.PolSQL.Execute(SQL,3)
                            if stat <> 'OK':
                                stat = 'Bd sprawdzania symbolu artykuu :'+stat
                            elif len(d) == 0:
                                wyn2.append((WierszeNr[i],3))
                                dane.append('ART BL')

                    elif pole == 'kontrahent_id':
                        wart = wart.strip()
                        KontrNowy = str(wart)
                        if wart <> '':
                            SQL ="SELECT kontrahent_id FROM rs_kontrahenci"
                            SQL+=" WHERE firma_id = '"+self.firma_id+"'"
                            SQL+=" AND  kontrahent_id= '"+str(wart)+"'" 
                            stat,d,dump,dump = self.PolSQL.Execute(SQL,3)
                            if stat <> 'OK':
                                stat = 'Bd sprawdzania symbolu kontrahenta :'+stat
                            elif len(d) == 0:
                                wyn2.append((WierszeNr[i],5))
                                dane.append('KONTR BL')

                    elif pole == 'data':
                        wart = wart.strip()
                        DataNowy = str(wart)
                        if wart == '':
                            wyn2.append((WierszeNr[i],7))
                            dane.append('DATA BR')
                        elif not rsglobal.SprawdzCzyToData(wart):
                            wyn2.append((WierszeNr[i],7))
                            dane.append('DATA BL')
                            
                    elif pole == 'dostarczac':
                        if not wart:
                            Dostarczac = False

                if stat == 'OK':
                    if KategNowa == '' and ArtNowy == '':
                        wyn2.append((WierszeNr[i],1))
                        dane.append('ARTKATEG BR')

                # sprawdzenie, czy nie ma bledow
                if stat == 'OK':
                    if len(dane) > 0:
                        stat = dane[0]
        
                # wykonanie INSERT do pojedynczego wiersza
                if stat == 'OK':    
                    sqlIns=''
                    INSERT="INSERT INTO rs_artykuly_kontrahenci_daty_dostaw "
                    KOLUMNY="(firma_id"
                    VALUES=" VALUES ('"+self.firma_id+"'"

                    for j in xrange(len(Insert[0][i])): 
                        pole=Insert[1][j]
                        wart=Insert[0][i][j]

                        if pole in ['kateg_artykulu','artykul_id','kontrahent_id','data']:
                            KOLUMNY+=","+pole
                            if wart.strip() == '':
                                VALUES+=",NULL"
                            else:
                                VALUES+=",'"+wart+"'"
    
                        elif pole in ['dostarczac']:
                            KOLUMNY+=","+pole
                            if wart:
                                VALUES+=",TRUE"
                            else:
                                VALUES+=",FALSE"
                        
                    KOLUMNY+=")"
                    VALUES+=");"
                    sqlIns+=INSERT+KOLUMNY+VALUES
                    
                # zapis wiersza do analizy pozycji staych zamwie
                if stat =='OK' and not Dostarczac:
                    DZmIns.append([KategNowa,ArtNowy,KontrNowy])
                    
                if stat == 'OK' and sqlIns<>'': 
                    stat,dump,dump,dump=self.PolSQL.Execute(rsglobal.Dekoduj(sqlIns),1)
                    if stat<>'OK':
                        stat="Bd przy dodawaniu danych: "+stat   
                        dane.append(stat)

    # zmiana pozycji zamwie staych po zmianach w gridzie limitw
    if stat == 'OK':
        SPozZm = {} # klucz to artyku, a wynik - lista kontrahentw
        LZmian = DZmDel+DZmUpdPrzed+DZmUpdPo+DZmIns
        rsglobal.ZapiszDoLogow('LZmian'+str(LZmian),1)
        for poz in LZmian:
            # jeli wypeniona kategoria to pobieramy dla niej list artykuw
            if poz[0] <> '':
                SQL = "SELECT artykul_id FROM rs_artykuly WHERE firma_id = '"+self.firma_id+"' AND kateg_artykulu LIKE '"+poz[0]+"%'"
                stat,DKateg,dump,dump=self.PolSQL.Execute(SQL,3)
                if stat<>'OK':
                    stat="Bd przy analizie artykuw dla kategorii: "+stat   
                    dane.append(stat)
                else:
                    LArt = []
                    for art in DKateg:
                        LArt.append(rsglobal.Dekoduj(art[0]))
            else:
                # jeli nie to robimy prost list [artykul]
                LArt = [rsglobal.Dekoduj(poz[1])]
            
            # dla kadego artykuu sprawdzamy czy jest na licie (w kombinacji z kontrahentem).
            for art in LArt:
                # jeli go nie ma to go dodajemy
                if not art in SPozZm:
                    SPozZm[art] = [poz[2]]
                # jeli kontrahent oglny to usuwamy poprzedni list i zapeniamy j jednym oglnym
                elif poz[2] == '':
                    SPozZm[art] = [poz[2]]
                # dodajemy konkretnego kontrahenta do listy
                elif (not poz[2] in SPozZm[art]) and (not '' in SPozZm[art]):
                    SPozZm[art].append(poz[2])
            
        
    if stat =='OK':    
        rsglobal.ZapiszDoLogow('SPozZm '+str(SPozZm),1)
        # dla kadego artykuu robimy wyliczenie limitw (idc po licie kontrahentw)
        for Art in SPozZm:
            for Kontr in SPozZm[Art]:
                if stat =='OK':
                    UPD = "UPDATE rs_zamowienia_odbiorcy_pozycje_stale SET data_do = rsf_podaj_date_limitu_zamowien(firma_id,"
                    UPD+=" artykul_id,(SELECT COALESCE(kontrahent_id,'') FROM rs_zamowienia_odbiorcy WHERE "
                    UPD+=" firma_id=rs_zamowienia_odbiorcy_pozycje_stale.firma_id "
                    UPD+=" AND wyznacznik_id=rs_zamowienia_odbiorcy_pozycje_stale.wyznacznik_id "
                    UPD+=" AND data=rs_zamowienia_odbiorcy_pozycje_stale.data "
                    UPD+=" AND numer=rs_zamowienia_odbiorcy_pozycje_stale.numer),"
                    UPD+="(SELECT COALESCE(platnik_id,'') FROM rs_zamowienia_odbiorcy WHERE "
                    UPD+=" firma_id=rs_zamowienia_odbiorcy_pozycje_stale.firma_id "
                    UPD+=" AND wyznacznik_id=rs_zamowienia_odbiorcy_pozycje_stale.wyznacznik_id "
                    UPD+=" AND data=rs_zamowienia_odbiorcy_pozycje_stale.data "
                    UPD+=" AND numer=rs_zamowienia_odbiorcy_pozycje_stale.numer),data_reczna)"
                    UPD+=" WHERE firma_id= '"+self.firma_id+"' AND artykul_id= '"+Art+"'"
                    if Kontr <> '':
                        # uwzgldniamy patnika
                        UPD+=" AND ((SELECT COALESCE(platnik_id,'') FROM rs_zamowienia_odbiorcy WHERE "
                        UPD+=" firma_id=rs_zamowienia_odbiorcy_pozycje_stale.firma_id "
                        UPD+=" AND wyznacznik_id=rs_zamowienia_odbiorcy_pozycje_stale.wyznacznik_id "
                        UPD+=" AND data=rs_zamowienia_odbiorcy_pozycje_stale.data "
                        UPD+=" AND numer=rs_zamowienia_odbiorcy_pozycje_stale.numer) = '"+Kontr+"'"
                        UPD+=" OR (SELECT COALESCE(kontrahent_id,'') FROM rs_zamowienia_odbiorcy WHERE "
                        # uwzgldniamy te kontrahenta
                        UPD+=" firma_id=rs_zamowienia_odbiorcy_pozycje_stale.firma_id "
                        UPD+=" AND wyznacznik_id=rs_zamowienia_odbiorcy_pozycje_stale.wyznacznik_id "
                        UPD+=" AND data=rs_zamowienia_odbiorcy_pozycje_stale.data "
                        UPD+=" AND numer=rs_zamowienia_odbiorcy_pozycje_stale.numer) = '"+Kontr+"')"
                    stat,dump,dump,dump=self.PolSQL.Execute(UPD,1)
                    if stat <> 'OK':
                        stat = 'Bdy zmiany limitw dla parametrw '+Art+'/'+Kontr+" : "+stat
                    

#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (1- insert 1 -select, 1 -delete), (5-odczyt)
#-------------------------------------------------------------------------------

if Funkcja in [1,5] and stat == 'OK':
    SQL ="SELECT add.lp, COALESCE(add.kateg_artykulu,''), COALESCE(ka.opis,''),"
    SQL+=" COALESCE(add.artykul_id,''), COALESCE(a.nazwa,''), "
    SQL+=" COALESCE(add.kontrahent_id,''), COALESCE(k.nazwa,''), "
    SQL+=" add.data, add.dostarczac"
    SQL+=" FROM rs_artykuly_kontrahenci_daty_dostaw add"
    SQL+=" LEFT OUTER JOIN rs_artykuly a USING(firma_id,artykul_id)"
    SQL+=" LEFT OUTER JOIN rs_kontrahenci k USING(firma_id,kontrahent_id)"
    SQL+=" LEFT OUTER JOIN rs_kateg_artykulow ka ON (ka.firma_id=add.firma_id AND ka.kod = add.kateg_artykulu)"
    SQL+=" WHERE add.firma_id='"+self.firma_id+"'"

    #dane filtru uzywane tylko przy zwyklym odczycie do grida
    if ArtF <> '':
        SQL+=" AND add.artykul_id LIKE '"+ArtF+"%'"
        
    if KategF <> '':
        SQL+=" AND add.kateg_artykulu LIKE '"+KategF+"%'"
        
    if KontrF <> '':
        SQL+=" AND add.kontrahent_id LIKE '"+KontrF+"%'"

    SQL+=" ORDER BY add.data;"

    stat,dane,wyn1,wyn2 = self.PolSQL.Execute(SQL,3)
    if stat <> 'OK':
        stat = "Bd przy pobieraniu danych: "+stat