# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_artykuly_kontrahenci_zamowienia_oddzialy.py
# Purpose:     obsluga grida edytowalnego z zamwieniami oddziaami
# Author:      Micha Raburski
# Created:     2015/05/14
# RCS-ID:      $Id: fs_artykuly_kontrahenci_zamowienia_oddzialy.py$
# Copyright:   (c) 2015 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

stat='OK'

if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=='OK':
    Funkcja = klucze['Funkcja']
    
    SlPar={'FArtykul':[1,5],'FKontrahent':[1,5],'Typ':[1,5]}
    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Funkcja,klucze)
    if Lista<>'':
        stat='Uwaga : wywoanie funkcji fs_artykuly_kontrahenci_zamowienia_oddzialy z numerem '+str(Funkcja)+' bez parametrw: '+Lista
        
    if Funkcja in [1,5]: 
        FKontrahent = rsglobal.Dekoduj(klucze['FKontrahent'])
        FArtykul = rsglobal.Dekoduj(klucze['FArtykul'])
        Typ = rsglobal.Dekoduj(klucze['Typ'])
        
dane = []
wyn1 = []
wyn2 = []

Puste = (None,'')

Insert = []
Update = []
Delete = []

if stat == 'OK':
    if Typ == 'K':
        UprOkno=((self.oddzial_id,'012150') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID
    else:
        UprOkno=((self.oddzial_id,'013130') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID

    if UprOkno == 0:
        stat = 'Brak uprawnie do uruchomienia funkcji fs_artykuly_kontrahenci_zamowienia_oddzialy'

rsglobal.ZapiszDoLogow('!!!klucze '+str(klucze),1)
if stat=='OK' and Funkcja == 1:
    Update=klucze['Update']
    Insert=klucze['Insert']
    Delete=klucze['Delete']

#-------------------------------------------------------------------------------
#-------  SPRAWDZANIE DELETE  --------------------------------------------------
#-------------------------------------------------------------------------------

if Funkcja == 1 and stat=="OK":
    if len(Delete[0])>0:
        
        # wykonanie DELETE 
        if stat == 'OK':
            SQLDEL = ''
            SQLFU = ''
            for i in xrange(len(Delete[0])):
                DELETE = "DELETE FROM rs_artykuly_zamowienia_oddzialy "
                WHERE = " WHERE firma_id='"+self.firma_id+"' "
                SQLFU = "SELECT artykul_id FROM rs_artykuly_zamowienia_oddzialy "
                SQLFU+= " WHERE firma_id='"+self.firma_id+"' " 
                for j in xrange(len(Delete[0][i])):
                    pole = Delete[1][j]
                    wart = Delete[0][i][j]
                    if pole in ['numer_id',]:
                        WHERE += " AND "+pole+"="+str(wart)
                        SQLFU += " AND "+pole+"="+str(wart)
                        

                SQLDEL += DELETE+WHERE+"; "
                SQLFU += " FOR UPDATE NOWAIT; "

            if SQLFU <> '':
                stat,d,dump,dump = self.PolSQL.Execute(rsglobal.Dekoduj(SQLFU),3)
                if stat <> 'OK':
                    stat = 'Bd sprawdzenia danych do usunicia: '+stat
                    dane.append(stat)
            
            if stat == 'OK' and SQLDEL <> '':
                stat,dump,dump,dump = self.PolSQL.Execute(rsglobal.Dekoduj(SQLDEL),1)
                if stat <> 'OK':
                    stat = "Bd przy usuwaniu danych: "+stat   
                    dane.append(stat)

                                 
#-------------------------------------------------------------------------------
#---   UPDATE DANYCH (1)
#-------------------------------------------------------------------------------

if Funkcja == 1 and stat=="OK":
    if len(Update[0])>0:

        if stat == 'OK':
            SQLFU = ''
            for i in xrange(len(Update[0])):
                SQLFU+= "SELECT artykul_id FROM rs_artykuly_zamowienia_oddzialy"
                SQLFU+= " WHERE firma_id='"+self.firma_id+"' "
                for j in xrange(len(Update[2][i])): # petla po kluczu
                    pole = Update[3][j]
                    wart = rsglobal.Dekoduj(Update[2][i][j])
                    if pole in ['numer_id',]:
                        SQLFU += " AND "+pole+"="+str(wart)
                SQLFU += " FOR UPDATE NOWAIT; "
            
            if SQLFU <> '':
                stat,dFU,nFU,dump = self.PolSQL.Execute(rsglobal.Dekoduj(SQLFU),3)
                if stat <> 'OK':
                    stat = 'Bd sprawdzenia danych do modyfikacji: '+stat
                    dane.append(stat)

        if stat == 'OK':
            WierszeNr = Update[-1]
            for i in xrange(len(Update[0])):
                for j in xrange(len(Update[0][i])): 
                    pole = Update[0][i][j]
                    wart = Update[1][i][j]
                    
                    if pole == 'oddzial_id':
                        wart = wart.strip()
                        if wart == '':
                            dane.append('ODDZ BR')
                            wyn2.append((WierszeNr[i],1))
                        else:
                            sql ="SELECT oddzial_id FROM rs_oddzialy"
                            sql+=" WHERE firma_id='"+self.firma_id+"' AND oddzial_id = '"+str(wart)+"';"
                            stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                            if stat <> 'OK':
                                stat = 'Bd sprawdzania oddziau : '+stat
                            elif len(d) == 0:
                                dane.append('ODDZ BL')
                                wyn2.append((WierszeNr[i],1))
  
                    elif pole == 'artykul_id':
                        wart = wart.strip()
                        artykul = wart
                        if wart == '':
                            dane.append('ART BR')
                            wyn2.append((WierszeNr[i],3))
                        else:
                            sql ="SELECT artykul_id FROM rs_artykuly"
                            sql+=" WHERE firma_id='"+self.firma_id+"' AND artykul_id = '"+str(wart)+"';"
                            stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                            if stat <> 'OK':
                                stat = 'Bd sprawdzania artykuu : '+stat
                            elif len(d) == 0:
                                dane.append('ART BL')
                                wyn2.append((WierszeNr[i],3))

                    elif pole == 'kontrahent_id':
                        wart = wart.strip()
                        kontrahent=wart
                        if wart == '':
                            dane.append('KONTR BR')
                            wyn2.append((WierszeNr[i],5))
                            
                        else:
                            sql ="SELECT kontrahent_id FROM rs_kontrahenci "
                            sql+=" WHERE firma_id='"+self.firma_id+"' AND kontrahent_id = '"+str(wart)+"';"
                            stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                            if stat <> 'OK':
                                stat = 'Bd sprawdzenia kontrahenta: '+stat
                            elif len(d) == 0:
                                dane.append('KONTR BL')
                                wyn2.append((WierszeNr[i],5))
                                
                    elif pole == 'data_od':
                        if not wart.strip() in ['','-  -']:
                            if not rsglobal.SprawdzCzyToData(wart):
                                dane.append('DATAOD BL')
                                wyn2.append((WierszeNr[i],7))
                                
                    elif pole == 'data_do':
                        if not wart.strip() in ['','-  -']:
                            if not rsglobal.SprawdzCzyToData(wart):
                                dane.append('DATADO BL')
                                wyn2.append((WierszeNr[i],8))
                    
                            
                if stat == 'OK':
                    if len(dane) > 0:
                        stat = dane[0]
                
                # wykonanie UPDATE
                if stat=='OK':
                    sql=''
                    UPDATE="UPDATE rs_artykuly_zamowienia_oddzialy "
                    SET='SET '
                    for j in xrange(len(Update[0][i])): 
                        pole=Update[0][i][j]
                        wart=Update[1][i][j]
    
                        if pole in ['artykul_id', 'kontrahent_id']:
                            SET+=pole+"='"+wart+"',"
                        elif pole in ['oddzial_id','data_od','data_do']:
                            if wart.strip() in ['','-  -']:
                                SET+=pole+"=NULL,"
                            else:
                                SET+=pole+"='"+wart+"',"
                            
                    SET=SET.strip(",")
                    WHERE=" WHERE firma_id='"+self.firma_id+"'" 
                    for j in xrange(len(Update[2][i])): # petla po kluczu
                        pole=Update[3][j]
                        wart=rsglobal.Dekoduj(Update[2][i][j])
                        if pole in ['numer_id',]:
                            WHERE+=" AND "+pole+"='"+str(wart)+"'"
                        
                    WHERE+=";"
                        
                    sql+=UPDATE+SET+WHERE
                        
                    stat,dump,dump,dump = self.PolSQL.Execute(rsglobal.Dekoduj(sql),1)
                    if stat<>'OK':
                        stat="Istnieje ju wpis o podanym kluczu: "+stat   
                        dane.append(stat)
                    

#-------------------------------------------------------------------------------
#--- INSERT DANYCH (1)
#-------------------------------------------------------------------------------

if Funkcja == 1 and stat=="OK":
    if len(Insert[0])>0:

        if stat == 'OK':
            WierszeNr = Insert[-1]
            
            # sprawdzenie danych
            for i in xrange(len(Insert[0])):
                artykul=None
                kontrahent=None
                for j in xrange(len(Insert[0][i])): 
                    pole=Insert[1][j]
                    wart=Insert[0][i][j]

                    if pole == 'oddzial_id':
                        wart = wart.strip()
                        if wart == '':
                            dane.append('ODDZ BR')
                            wyn2.append((WierszeNr[i],1))
                        else:
                            sql ="SELECT oddzial_id FROM rs_oddzialy"
                            sql+=" WHERE firma_id='"+self.firma_id+"' AND oddzial_id = '"+str(wart)+"';"
                            stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                            if stat <> 'OK':
                                stat = 'Bd sprawdzania oddziau : '+stat
                            elif len(d) == 0:
                                dane.append('ODDZ BL')
                                wyn2.append((WierszeNr[i],1))
                    
                    elif pole == 'artykul_id':
                        wart = wart.strip()
                        artykul = wart
                        if wart == '':
                            dane.append('ART BR')
                            wyn2.append((WierszeNr[i],3))
                        else:
                            sql ="SELECT artykul_id FROM rs_artykuly"
                            sql+=" WHERE firma_id='"+self.firma_id+"' AND artykul_id = '"+str(wart)+"';"
                            stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                            if stat <> 'OK':
                                stat = 'Bd sprawdzania artykuu : '+stat
                            elif len(d) == 0:
                                dane.append('ART BL')
                                wyn2.append((WierszeNr[i],3))

                    elif pole == 'kontrahent_id':
                        wart = wart.strip()
                        kontrahent=wart
                        if wart == '':
                            dane.append('KONTR BR')
                            wyn2.append((WierszeNr[i],5))
                            
                        else:
                            sql ="SELECT kontrahent_id FROM rs_kontrahenci "
                            sql+=" WHERE firma_id='"+self.firma_id+"' AND kontrahent_id = '"+str(wart)+"';"
                            stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                            if stat <> 'OK':
                                stat = 'Bd sprawdzenia kontrahenta: '+stat
                            elif len(d) == 0:
                                dane.append('KONTR BL')
                                wyn2.append((WierszeNr[i],5))
                                
                    elif pole == 'data_od':
                        if not wart.strip() in ['','-  -']:
                            if not rsglobal.SprawdzCzyToData(wart):
                                dane.append('DATAOD BL')
                                wyn2.append((WierszeNr[i],7))
                                
                    elif pole == 'data_do':
                        if not wart.strip() in ['','-  -']:
                            if not rsglobal.SprawdzCzyToData(wart):
                                dane.append('DATADO BL')
                                wyn2.append((WierszeNr[i],8))
                        
                            
                # sprawdzenie, czy nie ma bledow
                if stat == 'OK':
                    if len(dane) > 0:
                        stat = dane[0]
                        
                # wykonanie INSERT do pojedynczego wiersza
                if stat == 'OK':    
                    sqlIns=''
                    INSERT="INSERT INTO rs_artykuly_zamowienia_oddzialy "
                    KOLUMNY="(firma_id"
                    VALUES=" VALUES ('"+self.firma_id+"'"

                    for j in xrange(len(Insert[0][i])): 
                        pole=Insert[1][j]
                        wart=Insert[0][i][j]

                        if pole in ['artykul_id', 'kontrahent_id']:
                            KOLUMNY+=","+pole
                            VALUES+=",'"+wart+"'"
    
                        elif pole in ['oddzial_id','data_od','data_do']:
                            KOLUMNY+=","+pole
                            if wart.strip() in ['','-  -']:
                                VALUES+=",NULL"
                            else:
                                VALUES+=",'"+wart+"'"
    
                    KOLUMNY+=")"
                    VALUES+=");"
                    sqlIns+=INSERT+KOLUMNY+VALUES
                if stat == 'OK' and sqlIns<>'': 
                    stat,dump,dump,dump=self.PolSQL.Execute(rsglobal.Dekoduj(sqlIns),1)
                    if stat<>'OK':
                        stat="Bd przy dodawaniu danych: "+stat   
                        dane.append(stat)

#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (1- insert 1 -select, 1 -delete), (5-odczyt)
#-------------------------------------------------------------------------------

if Funkcja in [1,5] and stat == 'OK':
    SQL ="SELECT numer_id,azo.oddzial_id,o.opis,azo.artykul_id,a.nazwa,azo.kontrahent_id,k.nazwa,azo.data_od,azo.data_do"
    SQL+=" FROM rs_artykuly_zamowienia_oddzialy azo"
    SQL+=" INNER JOIN rs_oddzialy o ON (o.firma_id=azo.firma_id AND o.oddzial_id=azo.oddzial_id)"
    SQL+=" INNER JOIN rs_artykuly a ON (a.firma_id=azo.firma_id AND a.artykul_id=azo.artykul_id)"
    SQL+=" INNER JOIN rs_kontrahenci k ON (k.firma_id=azo.firma_id AND k.kontrahent_id=azo.kontrahent_id)"
    SQL+=" WHERE a.firma_id='"+self.firma_id+"'"
    
    if FArtykul <> '':
        SQL+=" AND azo.artykul_id = '"+FArtykul+"'"
        SQL+=" ORDER BY azo.oddzial_id,azo.kontrahent_id,azo.data_od,azo.data_do;"    
        
    if FKontrahent <> '':
        SQL+=" AND azo.kontrahent_id = '"+FKontrahent+"'"
        SQL+=" ORDER BY azo.oddzial_id,azo.artykul_id,azo.data_od,azo.data_do;"    
    
    stat,dane,wyn1,wyn2 = self.PolSQL.Execute(SQL,3)
    if stat <> 'OK':
        stat = "Bd przy pobieraniu danych: "+stat
        dane.append(stat)