#!/usr/bin/python
# -*- coding: iso8859_2 -*-
#-----------------------------------------------------------------------------
# Name:			fs_artykuly_opakowania_zbiorcze.py
# Purpose:		dodaje/pobiera/usuwa opakowan zbiorczych
# Author:		Marcin Grzeda
# Created:		2007/11/07
# RCS-ID:		$Id: fs_artykuly_opakowania_zbiorcze.py $
# Copyright:	(c) 2007 RecordSystem
# Licence:		GNU GPL
#-----------------------------------------------------------------------------
# 2014-08-20 Konrad Opieka (8269) dodanie pl kontrahent_id,lp,pojemnosc paletowa,
#                                 rodzaj palety,data do i przejscie na nowego grida

stat='OK'

if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=='OK':
    Funkcja = klucze['Funkcja']
    
    SlPar={'Artykul':[1,5,8,20],'Opakowanie':[1,5,20],'Cecha':[7],'WartCechy':[7],
           'KontrF':[1,5],'CechaF':[1,5],'CzyZZamowien':[1,5]}
    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Funkcja,klucze)
    if Lista<>'':
        stat='Uwaga : wywoanie funkcji fs_zamowiania_odbiorcy_pozycje   z numerem '+str(Funkcja)+' bez parametrw: '+Lista

if stat=='OK':
    if Funkcja in [1,5,8,20]:
        Artykul = klucze['Artykul']
    if Funkcja in [1,5]:
        KontrF = klucze['KontrF']
        CechaF = klucze['CechaF']
        CzyZZamowien = klucze['CzyZZamowien']
    if Funkcja in [1,5,20]:
        Opakowanie = klucze['Opakowanie']      
    if Funkcja == 7: 
        Cecha=str(klucze['Cecha'])
        WartCechy=str(klucze['WartCechy'])
                
dane = []
wyn1 = []
wyn2 = []

UprIns=((self.oddzial_id,'013063') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID
UprUpd=((self.oddzial_id,'013062') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID or UprIns
UprDel=((self.oddzial_id,'013064') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID

#-------------------------------------------------------------------------------
#-------- POBRANIE OPISU CECHY (7)
#-------------------------------------------------------------------------------

if stat =='OK' and Funkcja == 7: 
    SQL="SELECT rsf_podaj_parametry_cechy('"+self.firma_id+"','"+Cecha+"','"+WartCechy+"','poprawna'),"
    SQL+="rsf_podaj_parametry_cechy('"+self.firma_id+"','"+Cecha+"','"+WartCechy+"','opis');"
    stat,dane,dump,dump = self.PolSQL.Execute(SQL,3)
    if stat <> 'OK':
        stat = 'Bdy pobierania danych artykuu : '+stat

#-------------------------------------------------------------------------------
#-------- SPRAWDZENIE SPJNOCI DANYCH (8)
#-------------------------------------------------------------------------------

if stat =='OK' and Funkcja == 8: 
    # jeli istnieje rekord z palet to musi istnie rekord z 
    # palet, pust cech i pustym kontrahentem
    SQL="SELECT lp FROM rs_artykuly_opakowania_zbiorcze WHERE firma_id='"+self.firma_id+"'"
    SQL+=" AND artykul_id='"+Artykul+"' AND NOT paleta_id IS NULL"
    stat,DTest,dump,dump = self.PolSQL.Execute(SQL,3)
    if stat <> 'OK':
        stat = 'Bdy pobierania danych artykuu : '+stat
    if stat == 'OK':
        if len(DTest) > 0:
            SQL+=" AND COALESCE(cecha1_wartosc,'') = '' AND COALESCE(kontrahent_id,'') = ''"
            stat,DTest2,dump,dump = self.PolSQL.Execute(SQL,3)                
            if stat <> 'OK':
                stat = 'Bdy pobierania danych artykuu SQL2 : '+stat
            elif len(DTest2) == 0:
                stat = 'Brak wiersza z uzupenion palet bez zdefiniowanej wartoci cechy i kontrahenta'

#-------------------------------------------------------------------------------
#-------- Pobranie max(LP) (20)
#-------------------------------------------------------------------------------

if stat=='OK' and Funkcja ==20:
    SQL = "SELECT MAX(lp) FROM rs_artykuly_opakowania_zbiorcze"
    SQL+=" WHERE firma_id='"+self.firma_id+"' AND artykul_id='"+Artykul+"'" 
    if Opakowanie<>"":
        SQL+=" AND opakowanie_id='"+Opakowanie+"'"
    st,dane,dump,dump=self.PolSQL.Execute(SQL,3)
    if stat<>'OK':
        stat='MAX BL'
        dane.append(stat)
            
#-------------------------------------------------------------------------------
#-------- EDYCJA GRIDA EDYTOWALNEGO (1)
#-------------------------------------------------------------------------------

Insert = []
Update = []
Delete = []

if stat=='OK' and Funkcja == 1:
    Insert=klucze['Insert']
    Update=klucze['Update']
    Delete=klucze['Delete']

#-------------------------------------------------------------------------------
#-------  SPRAWDZANIE DELETE  --------------------------------------------------
#-------------------------------------------------------------------------------

if Funkcja == 1 and stat=="OK":
    if len(Delete[0])>0:
        if not UprDel:
            stat='DEL BR UPR'
            dane.append(stat)
                
        # wykonanie DELETE 
        if stat == 'OK':
            SQL=''
            for i in xrange(len(Delete[0])):
                DELETE="DELETE FROM rs_artykuly_opakowania_zbiorcze "
                WHERE="WHERE firma_id='"+self.firma_id+"' AND artykul_id='"+Artykul+"'"
                for j in xrange(len(Delete[0][i])):
                    pole=Delete[1][j]
                    wart=Delete[0][i][j]
                    if pole in ['lp']: 
                        LpUsuniete=str(wart)
                        WHERE+=" AND "+pole+"="+str(wart)
                    elif pole in ['opakowanie_id']:
                        WHERE+=" AND "+pole+"='"+wart+"'"
                SQL+=DELETE+WHERE+";"
            
            if SQL<>'': 
                stat,dump,dump,dump=self.PolSQL.Execute(SQL ,1)
                if stat<>'OK':
                    stat='DEL BL'
                    dane.append(stat)
    

#-------------------------------------------------------------------------------
#---   UPDATE DANYCH (1)
#-------------------------------------------------------------------------------

if Funkcja == 1 and stat=="OK":
    if len(Update[0])>0:
        if not UprUpd:
            stat='UPD BR UPR'
            dane.append(stat)
    
        if stat=='OK': #sprawdzanie danych
            for i in xrange(len(Update[0])):   # petla po ilosci wierszy updatowanych
                for j in xrange(len(Update[0][i])): # petla po pozycjach do zmiany
                    if stat=='OK':
                        pole=Update[0][i][j]
                        wart=Update[1][i][j] 
                        if pole=='opakowanie_id': 
                            if wart.strip()<>'':
                                SQL ="SELECT kod FROM rs_opakowania_zbiorcze "
                                SQL+="WHERE firma_id='"+self.firma_id+"' AND kod='"+str(wart)+"'; "
                                st,d,dump,dump=self.PolSQL.Execute(SQL,3)
                                if st=='OK':
                                    if len(d)==0:
                                        stat='OPAK BL$'+str(Update[-1][i])
                                        dane.append(stat)
                                        wyn2.append([Update[-1][i],0])
                                else:
                                    stat='OPAK BL SQL'
                                    dane.append(stat)
                            else:
                                stat='OPAK BR$'+str(Update[-1][i])
                                dane.append(stat)
                                wyn2.append([Update[-1][i],0])                
                        elif pole=='ilosc1':
                            if wart<=0:
                                stat='IL1 BL$'+str(Update[-1][i])
                                dane.append(stat)
                                wyn2.append([Update[-1][i],2])
                        elif pole=='ilosc2':
                            if wart<0:
                                stat='IL2 BL$'+str(Update[-1][i])
                                dane.append(stat)
                                wyn2.append([Update[-1][i],3])
                        elif pole=='pojemnosc_paletowa':
                            if wart<0:
                                stat='POJ BL$'+str(Update[-1][i])
                                dane.append(stat)
                                wyn2.append([Update[-1][i],3])
                        elif pole=='kontrahent_id':
                            if wart.strip()<>'':
                                SQL ="SELECT kontrahent_id FROM rs_kontrahenci "
                                SQL+="WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+str(wart)+"' ;"
                                st,d,dump,dump=self.PolSQL.Execute(SQL,3)
                                if st=='OK':
                                    if len(d)==0:
                                        stat='KON BL$'+str(Update[-1][i])
                                        dane.append(stat)
                                        wyn2.append([Update[-1][i],3])
                                else:
                                    stat='KON BL SQL'
                                    dane.append(stat)
                        elif pole=='paleta_id':
                            if wart.strip()<>'':
                                SQL ="SELECT paleta_id FROM rs_palety "
                                SQL+="WHERE firma_id='"+self.firma_id+"' AND paleta_id='"+str(wart)+"' ;"
                                st,d,dump,dump=self.PolSQL.Execute(SQL,3)
                                if st=='OK':
                                    if len(d)==0:
                                        stat='PAL BL$'+str(Update[-1][i])
                                        dane.append(stat)
                                        wyn2.append([Update[-1][i],3])
                                else:
                                    stat='PAL BL SQL'
                                    dane.append(stat)
        if stat=='OK':
            if len(dane)>0:
                stat=dane[-1]
                
        if stat=='OK':
            SQL=''
            for i in xrange(len(Update[0])):   # petla po ilosci wierszy updatowanych
                UPDATE="UPDATE rs_artykuly_opakowania_zbiorcze "
                SET='SET '
                for j in xrange(len(Update[0][i])): # petla po pozycjach do zmiany
                    pole=Update[0][i][j]
                    wart=Update[1][i][j]
                    
                    if pole in ['ilosc1','ilosc2','pojemnosc_paletowa']: 
                        SET+=pole+"="+str(wart)+","
                        
                    elif pole in ['opakowanie_id']:
                        if wart<>'':
                            SET+=pole+"='"+wart+"',"
                    
                    elif pole in ['paleta_id','kontrahent_id']:
                        if wart<>'':
                            SET+=pole+"='"+wart+"',"
                        else:
                            SET+=pole+"=NULL,"
                            
                    elif pole in ['cecha1_opis','cecha1_wartosc']:
                        SET+=pole+"='"+wart+"',"
                            
                    elif pole in ['data_do']:
                        SET+=pole+"="
                        if wart=='    -  -  ':
                            SET+= "NULL,"
                        else:
                            SET+= "'"+str(wart)+"',"
                    elif pole in ['czy_unikalna',]:
                            if wart == 0:
                                SET+=pole+"='False',"
                            else:
                                SET+=pole+"='True',"
                SET=SET.strip(",")
                WHERE=" WHERE firma_id='"+self.firma_id+"' AND artykul_id='"+Artykul+"'"
                
                for j in xrange(len(Update[2][i])): # petla po kluczu
                    pole=Update[3][j]
                    wart=Update[2][i][j]
                    if pole in ['lp']: 
                        WHERE+=" AND "+pole+"="+str(wart)
                    elif pole in ['opakowanie_id']:
                        WHERE+=" AND "+pole+"='"+wart+"'"
                        
                SQL+=UPDATE+SET+WHERE+";"
                
            if SQL<>'': 
                stat,dump,dump,dump=self.PolSQL.Execute(SQL ,1)
                if stat<>'OK':
                    stat='UPD BL'
                    dane.append(stat)
    
#-------------------------------------------------------------------------------
#---------Sprawdzanie danych do Insert------
#-------------------------------------------------------------------------------

if Funkcja == 1 and stat=="OK":
    if len(Insert[0])>0:
        if not UprIns:
            stat='INS BR UPR'
            dane.append(stat)   
            
        if stat == 'OK':
            for i in xrange(len(Insert[0])):
                for j in xrange(len(Insert[0][i])):
                    if stat=='OK':
                        pole=Insert[1][j]
                        wart=Insert[0][i][j]
                        if pole=='opakowanie_id': 
                            if wart.strip()<>'':
                                SQL ="SELECT kod FROM rs_opakowania_zbiorcze "
                                SQL+="WHERE firma_id='"+self.firma_id+"' AND kod='"+str(wart)+"' ;"
                                st,d,dump,dump=self.PolSQL.Execute(SQL,3)
                                if st=='OK':
                                    if len(d)==0:
                                        stat='OPAK BL$'+str(Insert[-1][i])
                                        dane.append(stat)
                                        wyn2.append([Insert[-1][i],0])
                                else:
                                    stat='OPAK BL SQL'
                                    dane.append(stat)
                            else:
                                stat='OPAK BR$'+str(Insert[-1][i])
                                dane.append(stat)
                                wyn2.append([Insert[-1][i],0])   
                        elif pole=='ilosc1':
                            if wart<=0:
                                stat='IL1 BL$'+str(Insert[-1][i])
                                dane.append(stat)
                                wyn2.append([Insert[-1][i],2])
                        elif pole=='ilosc2':
                            if wart<0:
                                stat='IL2 BL$'+str(Insert[-1][i])
                                dane.append(stat)
                                wyn2.append([Insert[-1][i],3])
                        elif pole=='pojemnosc_paletowa':
                            if wart<0:
                                stat='POJ BL$'+str(Insert[-1][i])
                                dane.append(stat)
                                wyn2.append([Insert[-1][i],3])
                        elif pole=='kontrahent_id':
                            if wart.strip()<>'':
                                SQL ="SELECT kontrahent_id FROM rs_kontrahenci "
                                SQL+="WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+str(wart)+"' ;"
                                st,d,dump,dump=self.PolSQL.Execute(SQL,3)
                                if st=='OK':
                                    if len(d)==0:
                                        stat='KON BL$'+str(Insert[-1][i])
                                        dane.append(stat)
                                        wyn2.append([Insert[-1][i],0])
                                else:
                                    stat='KON BL SQL'
                                    dane.append(stat)
                        elif pole=='paleta_id':
                            if wart.strip()<>'':
                                SQL ="SELECT paleta_id FROM rs_palety "
                                SQL+="WHERE firma_id='"+self.firma_id+"' AND paleta_id='"+str(wart)+"' ;"
                                st,d,dump,dump=self.PolSQL.Execute(SQL,3)
                                if st=='OK':
                                    if len(d)==0:
                                        stat='PAL BL$'+str(Insert[-1][i])
                                        dane.append(stat)
                                        wyn2.append([Insert[-1][i],0])
                                else:
                                    stat='PAL BL SQL'
                                    dane.append(stat)
                    
        if stat=='OK':        
            if len(dane)>0:
                stat=dane[-1]
                
        if stat=='OK':    
            SQL=''
            for i in xrange(len(Insert[0])):
                INSERT="INSERT INTO rs_artykuly_opakowania_zbiorcze "
                KOLUMNY="(firma_id,artykul_id"
                VALUES=" VALUES ('"+self.firma_id+"','"+Artykul+"'"
                for j in xrange(len(Insert[0][i])):
                    pole=Insert[1][j]
                    wart=Insert[0][i][j]
                    if pole in ['ilosc1','ilosc2','pojemnosc_paletowa','lp']:
                        KOLUMNY+=","+pole
                        VALUES+=","+str(wart)
                        
                    elif pole in ['opakowanie_id']:
                        if wart=='':
                            stat='BL KLUCZ INS'
                            dane.append(stat)
                        else:
                            KOLUMNY+=","+pole
                            VALUES+=",'"+wart+"'"
                            
                    elif pole in ['kontrahent_id','paleta_id']:
                        KOLUMNY+=","+pole
                        if wart=='':
                            VALUES+=",NULL"
                        else:
                            VALUES+=",'"+wart+"'"
                            
                    elif pole in ['cecha1_opis','cecha1_wartosc']:
                        KOLUMNY+=","+pole
                        VALUES+=",'"+wart+"'"
                            
                    elif pole in ['data_do']:
                        KOLUMNY+= ","+pole
                        if wart=='    -  -  ':
                            VALUES+= ",NULL"
                        else:
                            VALUES+= ",'"+str(wart)+"'"
                            
                    elif pole in ['czy_unikalna']:
                        KOLUMNY+=","+pole
                        if wart == 0:
                            VALUES+=",FALSE"
                        else:
                            VALUES+=",TRUE"
            
                KOLUMNY+=")"
                VALUES+=");"
                SQL+=INSERT+KOLUMNY+VALUES
                
            if SQL<>'': 
                stat,dump,dump,dump=self.PolSQL.Execute(SQL ,1)
                if stat<>'OK':
                    stat='INS BL'
                    dane.append(stat)  

#-------------------------------------------------------------------------------
#-- PO ZMIANIE DANYCH - TESTY OGLNE
#-------------------------------------------------------------------------------
    
if Funkcja == 1 and stat == "OK":
    # sprawdzenie czy wszystkie pary cecha1_opis_a i cecha1_wartosc_a s zgodne i poprawne
    SQL="SELECT az.lp"
    SQL+=" FROM rs_artykuly_opakowania_zbiorcze az"
    SQL+=" WHERE az.firma_id='"+self.firma_id+"' AND az.artykul_id='"+Artykul+"'"
    SQL+=" AND COALESCE(az.cecha1_opis,'')<>''"
    SQL+=" AND COALESCE(az.cecha1_wartosc,'')<>''"
    SQL+=" AND rsf_podaj_parametry_cechy(az.firma_id,az.cecha1_opis,az.cecha1_wartosc,'poprtech') = 'FALSE'"
    stat,DTest,dump,dump=self.PolSQL.Execute(SQL,3)
    if stat == 'OK':
        if len(DTest)>0:
            stat='Bdne pary cecha/warto dla pozycji:'
            for poz in DTest:
                stat+=str(poz[0]).strip()
                
    if stat == 'OK':
        # sprawdzenie czy wszystkie pozycje maj uzupenion rwnoczenie palet i jej pojemno
        SQL="SELECT az.lp"
        SQL+=" FROM rs_artykuly_opakowania_zbiorcze az"
        SQL+=" WHERE az.firma_id='"+self.firma_id+"' AND az.artykul_id='"+Artykul+"'"
        SQL+=" AND ((COALESCE(az.paleta_id,'')<>'' AND az.pojemnosc_paletowa = 0)"
        SQL+=" OR  (COALESCE(az.paleta_id,'')='' AND az.pojemnosc_paletowa <> 0))"
        stat,DTest,dump,dump=self.PolSQL.Execute(SQL,3)
        if stat == 'OK':
            if len(DTest)>0:
                stat='Nieuzupenione pary paleta/pojemno paletowa dla pozycji:'
                for poz in DTest:
                    stat+=str(poz[0]).strip()

    #przenumerowanie
    if stat == 'OK':
        SQL = "SELECT opakowanie_id,lp FROM rs_artykuly_opakowania_zbiorcze "
        SQL+=" WHERE firma_id='"+self.firma_id+"' AND artykul_id='"+Artykul+"' ORDER BY opakowanie_id,lp;"
        stat,DLp,dump,dump=self.PolSQL.Execute(SQL,3)
        if stat == 'OK':
            OpakTmp = ''
            for poz in DLp:
                if OpakTmp <> poz[0]:
                    Lp = 1
                    OpakTmp = poz[0]
            
                if stat == 'OK':
                    if Lp <> poz[1]:
                        SQL = "UPDATE rs_artykuly_opakowania_zbiorcze SET lp="+str(Lp)
                        SQL+=" WHERE firma_id='"+self.firma_id+"' AND artykul_id='"+Artykul+"'"
                        SQL+=" AND opakowanie_id='"+OpakTmp+"' AND lp="+str(poz[1])
                        stat,dump,dump,dump=self.PolSQL.Execute(SQL,1)
                        if stat <> 'OK':
                            stat='Bd przenumerowania pozycji: '+stat
                            dane.append(stat)
                    Lp = Lp + 1
        
#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (1- insert 1 -select, 1 -delete, 5 -select) 
#-------------------------------------------------------------------------------
                
if (Funkcja in [1,5]) and (stat=='OK'):   
    Select ="SELECT p.lp,COALESCE(p.cecha1_opis,''),COALESCE(ac.opis,''),p.cecha1_wartosc,"
    Select+="rsf_podaj_parametry_cechy(p.firma_id,p.cecha1_opis,p.cecha1_wartosc,'opis'),"
    Select+="p.opakowanie_id,COALESCE(op.opis,''),p.kontrahent_id,k.nazwa,"
    Select+="p.ilosc1,p.ilosc2,p.pojemnosc_paletowa,p.paleta_id,pal.opis,p.data_do,czy_unikalna"
    Select+=" FROM rs_artykuly_opakowania_zbiorcze p "
    Select+=" INNER JOIN rs_opakowania_zbiorcze op ON p.firma_id = op.firma_id AND p.opakowanie_id = op.kod"
    Select+=" LEFT JOIN rs_kontrahenci k ON p.firma_id = k.firma_id AND p.kontrahent_id = k.kontrahent_id"
    Select+=" LEFT OUTER JOIN rs_artykuly_cechy ac ON (ac.firma_id=p.firma_id AND ac.kod=p.cecha1_opis)"
    Select+=" LEFT OUTER JOIN rs_palety pal ON (pal.firma_id=p.firma_id AND pal.paleta_id=p.paleta_id)"
    Select+=" WHERE p.firma_id='"+self.firma_id+"' AND p.artykul_id='"+Artykul+"'" 
    if Opakowanie<>'':
        Select+=" AND p.opakowanie_id='"+Opakowanie+"'"
    if KontrF <> '':
        Select+=" AND COALESCE(p.kontrahent_id,'"+KontrF+"') = '"+KontrF+"'"
    if CzyZZamowien:
        Select+=" AND p.cecha1_wartosc ='"+CechaF+"'"
    if CechaF <> '':
        Select+=" AND p.cecha1_wartosc IN ('"+CechaF+"','')"
    Select+=" ORDER BY p.lp;"
    stat,dane,wyn,dump=self.PolSQL.Execute(Select,3)
    if stat<>'OK':
        stat='PRZ BL'
        
    if stat=='OK':
        SQL= " SELECT a.przelicznik,COALESCE(a.cecha1_opis,''),COALESCE(ac.opis,''),COALESCE(acs.lp,0) "
        SQL+=" FROM rs_artykuly a"
        SQL+=" LEFT OUTER JOIN rs_artykuly_cechy ac ON (ac.firma_id=a.firma_id AND ac.kod=a.cecha1_opis)"
        SQL+=" LEFT OUTER JOIN rs_artykuly_cechy_sekcje acs ON (acs.firma_id=a.firma_id AND acs.kod=a.cecha1_opis)"
        SQL+=" WHERE a.firma_id='"+self.firma_id+"' AND a.artykul_id='"+Artykul+"'"
        stat,przel,dump,dump=self.PolSQL.Execute(SQL,3)
        if stat<>'OK' or len(przel)==0:
            stat='PRZEL BL'
        else:
            wyn2.append(przel[0][0])
            wyn2.append(przel[0][1])
            wyn2.append(przel[0][2])
            wyn2.append({przel[0][1]:przel[0][3] > 0}) # sownik z uywanymi cechami z informacj czy s sekcje
            for d in dane:
                if d[1] <> '' and stat =='OK':
                    if not d[1] in wyn2[3]:
                        SQL="SELECT COUNT(*) FROM rs_artykuly_cechy_sekcje WHERE firma_id='"+self.firma_id+"'"
                        SQL+=" AND kod = '"+d[1]+"'"
                        stat,DCechy,dump,dump=self.PolSQL.Execute(SQL,3)
                        if stat == 'OK':
                            wyn2[3][d[1]] = DCechy[0][0] > 0
                                
            