# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_artykuly_producenci.py
# Purpose:     
# Author:      Dariusz Boduch
# Author:      Dariusz Boduch
# Created:     2007/07/26
# RCS-ID:      $Id: fs_artykuly_producenci.py $
# Copyright:   (c) 2006 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------
# 2012-11-19 Mariusz Rajfura (6270) nowe pola 'data_od','data_do','rzut';
#                                   zmiany w kluczu, przejscie na slowniki w kluczach


stat = 'OK'

if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=='OK':
    Funkcja = klucze['Funkcja']
    
    SlPar={'Artykul':(5,6), 'OddzialZam':(6,), 'OddzialProd':(6,),
           'DataOd':(6,), 'Rzut':(6,)}
           
    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Funkcja,klucze)
    if Lista<>'':
        stat='Uwaga : wywoanie funkcji fs_artykuly_producenci z numerem '+str(Funkcja)+' bez parametrw: '+Lista
        
    if Funkcja in (5,6): 
        Artykul = rsglobal.Dekoduj(klucze['Artykul'])
        
    if Funkcja in (6,):
        OddzialZam = rsglobal.Dekoduj(klucze['OddzialZam'])
        OddzialProd = rsglobal.Dekoduj(klucze['OddzialProd'])
        DataOd = rsglobal.Dekoduj(klucze['DataOd'])
        Rzut = rsglobal.Dekoduj(klucze['Rzut'])

dane=[]
wyn1=[]
wyn2=[]

UprDel=(self.oddzial_id,'013084') in self.uprawnienia or (self.operator_id == STANDARD_OPERATOR_ID)


#-------------------------------------------------------------------------------
#-------- USUWANIE
#-------------------------------------------------------------------------------

if stat == 'OK' and Funkcja in (6,):
    if not UprDel:
        stat='UPR DEL'
        dane.append(stat)

    if stat == 'OK':
        sql ="SELECT * FROM rs_artykuly_producenci"
        sql+=" WHERE firma_id='"+self.firma_id+"' AND artykul_id='"+Artykul+"'"
        sql+=" AND oddzial_zam='"+OddzialZam+"' AND oddzial_prod='"+OddzialProd+"'"
        sql+=" AND rzut='"+Rzut+"' FOR UPDATE;"
        stat,d,dump,dump = self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Bd sprawdzenia usuwanego zapisu: '+stat
        elif len(d) == 0:
            stat = 'Brak pozycji o podanym kluczu'
        
        if stat == 'OK':
                
            DEL ="DELETE FROM rs_artykuly_producenci"
            DEL+=" WHERE firma_id ='"+self.firma_id+"' AND artykul_id='"+Artykul+"'"
            DEL+=" AND oddzial_zam='"+OddzialZam+"' AND oddzial_prod='"+OddzialProd+"'"
            DEL+=" AND data_od='"+DataOd+"' AND rzut='"+Rzut+"';"
            
            stat,dump,dump,dump = self.PolSQL.Execute(DEL,1)
            if stat<>'OK':
                stat='BL DEL'
                dane.append(stat)


#--------------------------------------------------------------------
#----------  POBIERANIE DANYCH
#--------------------------------------------------------------------

if stat == 'OK' and Funkcja in (5,):
    SEL ="SELECT ap.oddzial_prod, op.opis, ap.oddzial_zam, oz.opis,"
    SEL+=" COALESCE(ap.data_od::TEXT,''),COALESCE(data_do::TEXT,''),"
    SEL+=" COALESCE(ap.rzut,''), CASE WHEN ap.hala_id IS NULL THEN '' ELSE TRIM(ap.hala_id)||' - '||TRIM(hp.opis) END"
    SEL+=" FROM rs_artykuly_producenci ap "
    SEL+=" LEFT OUTER JOIN rs_oddzialy oz ON (ap.firma_id=oz.firma_id AND ap.oddzial_zam=oz.oddzial_id)"
    SEL+=" LEFT OUTER JOIN rs_oddzialy op ON (ap.firma_id=op.firma_id AND ap.oddzial_prod=op.oddzial_id)"
    SEL+=" LEFT OUTER JOIN rs_hale_produkcyjne hp ON (hp.firma_id=ap.firma_id AND hp.kod=ap.hala_id)"
    SEL+=" WHERE ap.firma_id='"+self.firma_id+"' AND ap.artykul_id='"+Artykul+"'"
    SEL+=" ORDER BY ap.oddzial_zam,ap.oddzial_prod,ap.data_od,ap.rzut"
    
    stat,dane,wyn1,wyn2 = self.PolSQL.Execute(SEL,3)
    if stat <> 'OK':
        stat = 'Bd pobrania danych: '+stat
