# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_artykuly_producenci_dane.py
# Purpose:     pobiera liste oddziaw
# Author:      Dariusz Boduch
# Created:     2006/08/30
# RCS-ID:      $Id: fs_artykuly_producenci_dane.py $
# Copyright:   (c) 2004 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

# 2012-11-20 Mariusz Rajfura (6270) nowe pola: data_od,data_do,rzut;
#                                   nowy klucz; przejscie na slowniki w kluczach

#-------------------------------------------------------------------------------
def SprNakladanieDat(self, Fun, Artykul, OddzialZam, OddzialProd, Data_Od, Data_Do, Rzut, KluczUpd):
    # Fun: 1,2 INSERT; 3,4 UPDATE
    
    stat = 'OK'
    SELECT ="SELECT artykul_id,oddzial_zam,oddzial_prod,data_od,data_do,rzut"
    SELECT+=" FROM rs_artykuly_producenci"
    SELECT+=" WHERE firma_id='"+self.firma_id+"' AND artykul_id='"+Artykul+"'"
    SELECT+=" AND oddzial_zam='"+OddzialZam+"' AND oddzial_prod='"+OddzialProd+"'"
    SELECT+=" AND rzut='"+Rzut+"'"

    if Fun in (3,4):
        #wykluczenie z SELECT modyfikowanej pozycji w przypadku UPDATE
        # KluczUpd to slownik dla wygody

        SELECT+=" AND NOT (artykul_id,oddzial_zam,oddzial_prod,data_od,data_do,rzut)"
        SELECT+=" IN (('"+KluczUpd['Artykul']+"','"+KluczUpd['OddzialZam']+"',"
        SELECT+=" '"+KluczUpd['OddzialProd']+"','"+KluczUpd['DataOd']+"',"
        if KluczUpd['DataDo'] in ('    -  -  ','NULL',None,'','None'):
            SELECT+="NULL"
        else:
            SELECT+="'"+KluczUpd['DataDo']+"'"
        SELECT += ",'"+KluczUpd['Rzut']+"'"
        SELECT += "))"

    #wlasciwe sprawdzenie unikalnosci zakresow
    SELECT+=" AND ("
    #sprawdzamy, czy data poczatkowa nie miesci sie
    #w jakims dokladnie okreslonym zakresie od-do
    SELECT+="( data_do IS NOT NULL AND '"+Data_Od+"' >= data_od AND '"+Data_Od+"' <= data_do )"

    if not Data_Do in ('NULL','None','    -  -  ',None):
        #czy w podanym zakresie od-do zlapiemy jakas istniejeca date_od
        SELECT+=" OR (data_do IS NOT NULL AND data_od >= '"+Data_Od+"' AND data_od <= '"+Data_Do+"' )"

        #czy w podanym zakresie od-do zlapiemy jakas istniejaca date_do
        SELECT+=" OR (data_do IS NOT NULL AND data_do >= '"+Data_Od+"' AND data_do <= '"+Data_Do+"' )"

        #czy data koncowa nie znajduje sie w jakims dokladnie okreslonym zakresie
        SELECT+=" OR (data_do IS NOT NULL AND data_od >= '"+Data_Do+"' AND data_do <= '"+Data_Do+"')"

    SELECT+=");"

    stat,d,dump,dump = self.PolSQL.Execute(SELECT,2)
    if stat <> 'OK':
        stat = 'Bd sprawdzenia pokrywania si zakresw dat w artykuach-producentach: '+stat

    if stat == 'OK':
        if len(d) > 0:
            stat = 'BL DATY_POKRYWAJA'

    return stat

#-------------------------------------------------------------------------------

stat = 'OK'

if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=='OK':
    Funkcja = klucze['Funkcja']
    
    SlPar={'Artykul':(1,2,3,4,5), 'OddzialZam':(1,2,3,4,5), 'OddzialProd':(1,2,3,4,5),
           'DataOd':(1,2,3,4,5), 'Rzut':(1,2,3,4,5), 'KluczUpd':(3,4)}
           
    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Funkcja,klucze)
    if Lista<>'':
        stat='Uwaga : wywoanie funkcji fs_artykuly_producenci_dane z numerem '+str(Funkcja)+' bez parametrw: '+Lista
        
    if Funkcja in (1,2,3,4,5): 
        Artykul = rsglobal.Dekoduj(klucze['Artykul'])
        OddzialZam = rsglobal.Dekoduj(klucze['OddzialZam'])
        OddzialProd = rsglobal.Dekoduj(klucze['OddzialProd'])
        DataOd = rsglobal.Dekoduj(klucze['DataOd'])
        Rzut = rsglobal.Dekoduj(klucze['Rzut'])

UprIns=(self.oddzial_id,'013083') in self.uprawnienia or (self.operator_id == STANDARD_OPERATOR_ID)
UprMod=(self.oddzial_id,'013082') in self.uprawnienia or (self.operator_id == STANDARD_OPERATOR_ID) or UprIns

PustaData = ('    -  -  ','None','NULL',None)

stat='OK'
dane=[]
wyn1=[]
wyn2=[]

#-------------------------------------------------------------------------------
#    SPRAWDZANIE DANYCH
#-------------------------------------------------------------------------------

if stat == 'OK' and Funkcja in (1,2,3,4):
    if Funkcja in (3,4):
        SQLFU ="SELECT * FROM rs_artykuly_producenci"
        SQLFU+=" WHERE firma_id='"+self.firma_id+"' AND artykul_id='"+Artykul+"'"
        SQLFU+=" AND oddzial_zam='"+OddzialZam+"' AND oddzial_prod='"+OddzialProd+"'"
        SQLFU+=" AND data_od='"+DataOd+"' AND rzut='"+Rzut+"' FOR UPDATE;"
        
        stat,dPoz,dNag,dump = self.PolSQL.Execute(SQLFU,3)
        if stat <> 'OK':
            stat = 'Bd pobrania danych do sprawdzenia: '+stat
            dane.append(stat)
        elif len(dPoz) == 0:
            stat = 'Brak pozycji o podanym kluczu'
            dane.append(stat)
        else:
            tr = rssql.RSTableRowset(dPoz,dNag)
            # do sprawdzenia w przypadku UPDATE - potrzebne do wykluczenia
            DataDo = tr.GetVal(0,'data_do')
    
    if stat == 'OK':
        ArtykulNowy = None
        OddzialZamNowy = None
        OddzialProdNowy = None
        DataOdNowy = None
        DataDoNowy = None
        RzutNowy = None
        
        for i in xrange(len(pola)):
            pole = pola[i]
            wart = wartosci[i]
            
            if pole == 'artykul_id':
                wart = wart.strip()
                if wart == '':
                    stat = 'BR ART'
                    dane.append(stat)
                else:
                    ArtykulNowy = wart
                    sql ="SELECT artykul_id FROM rs_artykuly"
                    sql+=" WHERE firma_id='"+self.firma_id+"' AND artykul_id='"+wart+"'"
                    sql+=" AND aktywny;"
                    stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                    if stat <> 'OK':
                        stat = 'Bd sprawdzenia artykuu: '+stat
                        dane.append(stat)
                    elif len(d) == 0:
                        stat = 'BL ART'
                        dane.append(stat)
    
            elif pole == 'oddzial_zam':
                wart = wart.strip()
                if wart == '':
                    stat = 'BR ODDZ_ZAM'
                    dane.append(stat)
                else:
                    OddzialZamNowy = wart
                    sql ="SELECT oddzial_id FROM rs_oddzialy"
                    sql+=" WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+wart+"';"
                    stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                    if stat <> 'OK':
                        stat = 'Bd sprawdzenia oddziau zamawiajcego: '+stat
                        dane.append(stat)
                    elif len(d) == 0:
                        stat = 'BL ODDZ_ZAM'
                        dane.append(stat)
    
            elif pole == 'oddzial_prod':
                wart = wart.strip()
                if wart == '':
                    stat = 'BR ODDZ_PROD'
                    dane.append(stat)
                else:
                    OddzialProdNowy = wart
                    sql ="SELECT oddzial_id FROM rs_oddzialy"
                    sql+=" WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+wart+"';"
                    stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                    if stat <> 'OK':
                        stat = 'Bd sprawdzenia oddziau produkujcego: '+stat
                        dane.append(stat)
                    elif len(d) == 0:
                        stat = 'BL ODDZ_PROD'
                        dane.append(stat)
    
            elif pole == 'data_od':
                if wart == '    -  -  ':
                    stat = 'BR DATA_OD'
                    dane.append(stat)
                elif not rsglobal.SprawdzCzyToData(wart):
                    stat = 'BL DATA_OD'
                    dane.append(stat)
                else:
                    DataOdNowy = wart
            
            elif pole == 'data_do':
                if wart == '    -  -  ':
                    DataDoNowy = wart
                elif not rsglobal.SprawdzCzyToData(wart):
                    stat = 'BL DATA_DO'
                    dane.append(stat)
                else:
                    DataDoNowy = wart
            
            elif pole == 'rzut':
                RzutNowy = wart
                
            elif pole == 'hala_id':
                wart = wart.strip()
                if wart <>'':
                    sql ="SELECT kod FROM rs_hale_produkcyjne"
                    sql+=" WHERE firma_id='"+self.firma_id+"' AND kod='"+wart+"';"
                    stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                    if stat <> 'OK':
                        stat = 'Bd sprawdzenia hali produkcyjnej: '+stat
                        dane.append(stat)
                    elif len(d) == 0:
                        stat = 'BL HALA'
                        dane.append(stat)
            
    # czy byly bledy 
    if stat == 'OK':
        if len(dane) > 0:
            stat == dane[0]

    if stat == 'OK' and Funkcja in (1,2):
        # sprawdzenie unikalnosci klucza
        sql ="SELECT * FROM rs_artykuly_producenci"
        sql+=" WHERE firma_id='"+self.firma_id+"' AND artykul_id='"+ArtykulNowy+"'"
        sql+=" AND oddzial_zam='"+OddzialZamNowy+"' AND oddzial_prod='"+OddzialProdNowy+"'"
        sql+=" AND data_od='"+DataOdNowy+"' AND rzut='"+RzutNowy+"';"
        
        stat,d,dump,dump = self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat =  'Bd sprawdzenia unikalnoci klucza: '+stat
            dane.append(stat)
        elif len(d) > 0:
            stat = 'Podany klucz ju istnieje'
            dane.append(stat)

    if stat == 'OK':
        # w przypadku edycji moga byc zmienione tylko wybrane pola
        # dlatego trzeba je uzupelnic dla pelnego sprawdzenia
        # nakladania dat. pola nie bedace kluczem poierane z obiektu tr

        if Funkcja in (3,4):

            if ArtykulNowy == None:
                ArtykulNowy = Artykul
    
            if OddzialZamNowy == None:
                OddzialZamNowy = OddzialZam
                
            if OddzialProdNowy == None:
                OddzialProdNowy = OddzialProd
                
            if DataOdNowy == None:
                DataOdNowy = DataOd
                
            if DataDoNowy in PustaData:
                DataDoNowy = tr.GetVal(0,'data_do')
                if DataDoNowy == 'None':
                    DataDoNowy = 'NULL'
                    
            if RzutNowy == None:
                RzutNowy = Rzut

    if stat == 'OK':
        if not DataDoNowy in PustaData:
            if DataOdNowy > DataDoNowy:
                stat = 'Data OD pniejsza od daty DO'
                dane.append(stat)
            else:
                # wykonujemy sprawdzenie nakladania dat
                KluczUpd = {}
                if Funkcja in (3,4):
                    KluczUpd['Artykul'] = Artykul
                    KluczUpd['OddzialZam'] = OddzialZam
                    KluczUpd['OddzialProd'] = OddzialProd
                    KluczUpd['DataOd'] = DataOd
                    # to nie jest klucz ale jest potrzebny do sprawdzenia
                    KluczUpd['DataDo'] = DataDo
                    KluczUpd['Rzut'] = Rzut
    
                stat = SprNakladanieDat(self,Funkcja,ArtykulNowy,OddzialZamNowy,OddzialProdNowy,DataOdNowy,DataDoNowy,RzutNowy,KluczUpd)
                
                if stat <> 'OK':
                    dane.append(stat)
            

#-------------------------------------------------------------------------------
#   DODANIE DANYCH (1 -insert, 2 -insert z pobraniem)
#-------------------------------------------------------------------------------

if stat == 'OK' and Funkcja in (1,2): 
    if not UprIns:
        stat='UPR INS'
    
    if stat == 'OK':
        POLA = "firma_id"
        WART = "'"+self.firma_id+"'"
        
        for i in xrange(len(pola)):
            pole = pola[i]
            wart = wartosci[i]
            POLA+=","+pole
            if pole in ['artykul_id','oddzial_zam','oddzial_prod','data_od','rzut']:
                WART+=",'"+wart+"'"
            elif pole in ['data_do',]:
                if wart == '    -  -  ':
                    WART+=",NULL"
                else:
                    WART+=",'"+wart+"'"
            elif pole in ['hala_id',]:
                if wart == '':
                    WART+=",NULL"
                else:
                    WART+=",'"+wart+"'"
                
        INSERT = "INSERT INTO rs_artykuly_producenci ("+POLA+") VALUES ("+WART+");"
        stat,dump,dump,dump = self.PolSQL.Execute(INSERT,1)
            
        if stat <> 'OK':
            stat = 'Bd dodawania danych: '+stat


#-------------------------------------------------------------------------------
#   MODYFIKACJA DANYCH (3 -update, 4 -update z pobraniem)
#-------------------------------------------------------------------------------

if stat == 'OK' and Funkcja in (3,4):
    if not UprMod:
        stat='UPR MOD'
    
    if stat == 'OK':
        UPDATE = "UPDATE rs_artykuly_producenci SET "
        
        for i in xrange(len(pola)):
            pole = pola[i]
            wart = wartosci[i]
            if pole in ['artykul_id','oddzial_zam','oddzial_prod','data_od','rzut']:
                UPDATE+=pole+"='"+wart+"',"
            elif pole in ['data_do',]:
                if wart == '    -  -  ':
                    UPDATE+=pole+"=NULL,"
                else:
                    UPDATE+=pole+"='"+wart+"',"
            elif pole in ['hala_id',]:
                if wart == '':
                    UPDATE+=pole+"=NULL,"
                else:
                    UPDATE+=pole+"='"+wart+"',"
                    
        UPDATE = UPDATE[:-1]
        UPDATE+=" WHERE firma_id='"+self.firma_id+"' AND artykul_id='"+Artykul+"'"
        UPDATE+=" AND oddzial_zam='"+OddzialZam+"' AND oddzial_prod='"+OddzialProd+"'"
        UPDATE+=" AND data_od='"+DataOd+"' AND rzut='"+Rzut+"';"
            
        stat,dump,dump,dump = self.PolSQL.Execute(UPDATE,1)
            
        if stat <> 'OK':
            stat = 'Bd modyfikacji danych: '+stat
        else:
            Artykul = ArtykulNowy
            OddzialZam = OddzialZamNowy
            OddzialProd = OddzialProdNowy
            DataOd = DataOdNowy
            Rzut = RzutNowy


#-------------------------------------------------------------------------------
#    POBRANIE DANYCH (5)
#-------------------------------------------------------------------------------
if stat == 'OK' and Funkcja in (5,3,1):
    wyn2 = []
    
    SEL ="SELECT * FROM rs_artykuly_producenci"
    SEL+=" WHERE firma_id='"+self.firma_id+"' AND artykul_id='"+Artykul+"'"
    SEL+=" AND oddzial_zam='"+OddzialZam+"' AND oddzial_prod='"+OddzialProd+"'"
    SEL+=" AND data_od='"+DataOd+"' AND rzut='"+Rzut+"';"
    
    stat,dane,wyn1,dump = self.PolSQL.Execute(SEL,3)
    if stat <> 'OK':
        stat = 'Bd pobrania danych: '+stat
    elif len(dane) == 1:
        tr = rssql.RSTableRowset(dane,wyn1)

        # [0] oddzial_prod
        if (self.oddzial_id,'001100') in self.uprawnienia or self.operator_id == STANDARD_OPERATOR_ID:
            sql ="SELECT nazwa FROM rs_oddzialy"
            sql+=" WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+tr.GetVal(0,"oddzial_prod")+"';"
            stat,d,dump,dump = self.PolSQL.Execute(sql, 3)
            if stat <> 'OK':
                wyn2.append('Bd pobrania opisu oddziau produkujcego: '+stat)
            else:
                if len(d) == 0:
                    wyn2.append('Bdny kod oddziau produkujcego.')
                else:
                    wyn2.append(d[0][0])
        else:
            wyn2.append('Brak uprawnie do listy oddziaow. Poinformuj administratora.')

        # [1] oddzial_zam
        if (self.oddzial_id,'001100') in self.uprawnienia or self.operator_id == STANDARD_OPERATOR_ID:
            sql ="SELECT nazwa FROM rs_oddzialy"
            sql+=" WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+tr.GetVal(0,"oddzial_zam")+"';"
            stat,d,dump,dump = self.PolSQL.Execute(sql, 3)
            if stat <> 'OK':
                wyn2.append('Bd pobrania opisu oddziau zamawiajcego: '+stat)
            else:
                if len(d) == 0:
                    wyn2.append('Bdny kod oddziau produkujcego.')
                else:
                    wyn2.append(d[0][0])
        else:
            wyn2.append('Brak uprawnie do listy oddziaow. Poinformuj administratora.')
            
        # [2] hala produkcyjna
        if (self.oddzial_id,'211220') in self.uprawnienia or self.operator_id == STANDARD_OPERATOR_ID:
            if tr.GetVal(0,"hala_id") in ['None',None,'']:
                wyn2.append('')
            else:
                sql ="SELECT opis FROM rs_hale_produkcyjne"
                sql+=" WHERE firma_id='"+self.firma_id+"' AND kod='"+tr.GetVal(0,"hala_id")+"';"
                stat,d,dump,dump = self.PolSQL.Execute(sql, 3)
                if stat <> 'OK':
                    wyn2.append('Bd pobrania opisu hali produkcyjnej: '+stat)
                else:
                    if len(d) == 0:
                        wyn2.append('Bdny kod hali produkcyjnej.')
                    else:
                        wyn2.append(d[0][0])
        else:
            wyn2.append('Brak uprawnie do listy hal produkcyjnych. Poinformuj administratora.')
