# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_artykuly_rezerwacje_dane.py
# Purpose:     rezerwacje artykulw - wprowadzanie i edycja
# Author:      Pawe Wjcikowski
# Created:     2009-09-30
# RCS-ID:      $Id: fs_artykuly_rezerwacje_dane.py $
# Copyright:   (c) 2009 Record System
# Licence:     GNU GPL   
#-------------------------------------------------------------------------------

from funkcje import fs_zaleglosci_sprawdzenie

Rezerwacja = klucze[0]
ArtPodst = klucze[1] 
Zamowienie = klucze[2] 
IloscPodst = klucze[3] 
Fun = klucze[-1]

dane = []
stat = 'OK'

upd2=''

UprDodawanie=((self.oddzial_id,'039013') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)
UprEdycja=((self.oddzial_id,'039012') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID) or UprDodawanie


#-------------------------------------------------------------------------------
#---   POBIERANIU NOWEGO ID DLA REZERWACJI (12)
#-------------------------------------------------------------------------------

if Fun in [12] and stat=='OK':
    Select="SELECT rezerwacja_id FROM rs_artykuly_rezerwacje ORDER BY rezerwacja_id DESC LIMIT 1;"  
    stat,dane,wyn1,tr = self.PolSQL.Execute(Select,3)
    if stat<>'OK':
        stat = 'Bdy pobierania danych :'+stat
        dane.append(stat)    


#-------------------------------------------------------------------------------
#---   SPRAWDZENIE CZY OPERATOR JEST HANDLOWCEM (13)
#-------------------------------------------------------------------------------

if Fun in [13] and stat=='OK':        
    SQL="SELECT handlowiec_id FROM rs_operatorzy WHERE operator_id='"+str(self.operator_id)+"';"
    stat,dane,dump,dump = self.PolSQL.Execute(SQL ,3)
    if stat<>'OK':
        stat = 'Bdy przy sprawdzaniu operatora :'+stat
        dane.append(stat)


#-------------------------------------------------------------------------------
#---   SPRAWDZANIE DANYCH (1,2,3,4)
#-------------------------------------------------------------------------------

if Fun in [1,2,3,4] and stat=='OK':
    #pobranie artykuu
    if 'artykul_id' in pola:
        Artykul=wartosci[pola.index('artykul_id')]
    elif Fun in [1,2]:
        stat = 'BR ART'
        dane.append(stat)    
    else:
        SQL="SELECT artykul_id FROM rs_artykuly_rezerwacje WHERE firma_id='"+self.firma_id+"' "
        SQL+= "AND rezerwacja_id = '"+str(Rezerwacja)+"';"
        stat,Dane,dump,dump = self.PolSQL.Execute(SQL ,3) 
        if stat<>'OK':
            stat = 'Bdy pobierania artykuu:'+stat
            dane.append(stat) 
        else:
            Artykul=Dane[0][0]
        
    # ptla testujca kolejne pola
    for i in range(len(pola)):
        if stat=='OK':
            pole = pola[i]
            wart = wartosci[i]
            
            if pole=='rezerwacja':
                if wart==0:
                    stat = 'BR REZER'
                    dane.append(stat)    
                # jeli z zamwienia to nie powinna przekracza zamwienia
                elif Zamowienie <> []:
                    if IloscPodst<wart:
                        stat = 'IL WIEK NIZ ZAMOW'
                        dane.append(stat)
        
            elif pole=='magazyn_id':
                if wart=='':
                    stat = "BR MAG"
                    dane.append(stat)
                else:
                    sql = "SELECT magazyn_id FROM rs_magazyny WHERE firma_id='"+self.firma_id+"' "
                    sql+= "AND magazyn_id = '"+wart+"';"
                    stat,Dane,dump,dump = self.PolSQL.Execute(sql ,3) 
                    if stat<>'OK':
                        stat = 'Bdy pobierania magazynu:'+stat
                        dane.append(stat) 
                    elif Dane == []:
                        stat = "BL MAG"
                        dane.append(stat) 

            elif pole=='kontrahent_id':
                if wart == '':
                    stat = "BR KONTR"
                    dane.append(stat)
                else:            
                    sql = "SELECT kontrahent_id FROM rs_kontrahenci WHERE firma_id='"+self.firma_id+"' "
                    sql+= "AND kontrahent_id = '"+wart+"';"
                    stat,Dane,dump,dump = self.PolSQL.Execute(sql ,3) 
                    if stat<>'OK':
                        stat = 'Bdy pobierania kontrahenta:'+stat
                        dane.append(stat) 
                    elif Dane == []:
                        stat = "BL KONTR"
                        dane.append(stat)  

            elif pole=='handlowiec_id':
                if wart == '':
                    stat = "BR HANDL"
                    dane.append(stat)
                else:            
                    sql = "SELECT kod FROM rs_handlowcy WHERE firma_id='"+self.firma_id+"' "
                    sql+= "AND kod = '"+wart+"';"
                    stat,Dane,dump,dump = self.PolSQL.Execute(sql ,3)             
                    if stat<>'OK':
                        stat = 'Bdy pobierania handlowca:'+stat
                        dane.append(stat) 
                    elif Dane == []:
                        stat = "BL HANDL"
                        dane.append(stat)  
                    
            elif pole=='handlowiec_id':
                if len(wart) > 100:
                    stat = "DL OPIS"
                    dane.append(stat)        
                    
            elif pole=='koniec':
                if wart == '    -  -  ':
                    stat = "BR DATA"
                    dane.append(stat)
                elif not rsglobal.SprawdzCzyToData(wart):
                    stat='BL DATA'
                    dane.append(stat)   
                else:
                    Dzis=rsglobal.PodajDzis()
                    if wart<Dzis:
                        stat='Data "do kiedy" wczeniejsza ni data bieca.'
                        dane.append(stat)                   
                            
            elif pole=='artykul_id':
                if wart=='':
                    stat = "BR ART"
                    dane.append(stat)                    
                    
    # testy na zmian rezerwacji i ew na zamiennik                
    if 'rezerwacja' in pola:                    
        if stat=='OK':
            sql = "SELECT artykul_id,zamiennik_id FROM rs_artykuly WHERE firma_id='"+self.firma_id+"' "
            sql+= "AND artykul_id = '"+str(Artykul)+"';"
            stat,Dane,dump,dump = self.PolSQL.Execute(sql ,3) 
            if stat<>'OK':
                stat = 'Bdy pobierania artykuu:'+stat
                dane.append(stat) 
            elif len(Dane)==0:
                stat = "BL ART"
                dane.append(stat) 

        if stat=='OK':
            zamiennik = Dane[0][1] 
            #sprawdza ilosci tylko gdy przy update zmieniono pole rezerwacja.
            #badz gdy wykonujemy insert
            Magazyn=''
            Zarezerwowano=0
            
            if Fun in [1,2]:
                Zarezerwowano=wartosci[pola.index('rezerwacja')]
                ZarezerwowanoG=0
                ZrealizowanoG=0
                if 'magazyn_id' in pola:
                    Magazyn=wartosci[pola.index('magazyn_id')]

            #gdy update pobieram dane z tabeli        
            elif Fun in [3,4]:
                sql = "SELECT rezerwacja,zrealizowano,magazyn_id FROM rs_artykuly_rezerwacje WHERE firma_id='"+self.firma_id+"' "
                sql+= "AND rezerwacja_id = '"+str(Rezerwacja)+"';"
                stat,d,dump,dump = self.PolSQL.Execute(sql ,3) 
                if stat<>'OK':
                    stat = 'Bdy pobierania artykuu:'+stat
                    dane.append(stat)     
                if stat=='OK':
                    if len(d)<>0:
                        Zarezerwowano=wartosci[pola.index('rezerwacja')]
                        ZarezerwowanoG=d[0][0]
                        ZrealizowanoG=d[0][1]
                        Magazyn=d[0][2]
                        
            if stat=='OK':
                if Magazyn=='':
                    stat = "BR MAG"
                    dane.append(stat) 
            if stat=='OK':
                if float(Zarezerwowano) < float(ZrealizowanoG):
                    stat = "BL ILOSC"
                    dane.append(stat) 
                    
            if stat=="OK": 
                # pobieranie danych artykuu - inf. o jego ilosci i rezerwacji
                sql = "SELECT artykul_id,ilosc1,rezerwacja1 FROM rs_artykuly_magazyny WHERE firma_id='"+self.firma_id+"' "
                sql+= "AND artykul_id = '"+str(Artykul)+"' and magazyn_id='"+str(Magazyn)+"';"
                stat,Dane,dump,dump = self.PolSQL.Execute(sql ,3) 
                if stat<>'OK':
                    stat = 'Bdy w pobieraniu artykulu:'+stat
                    dane.append(stat) 
                elif Dane==[]:
                    stat = 'BR ARTWMAG'
                    dane.append(stat)                     
                
            if stat=='OK':
                art_ilosc=Dane[0][1]
                art_rezerwacja=Dane[0][2]
                # sprawdzamy czy musimy szuka zamienika, czy moemy wyda ten artyku 
                # (poniej przypadek e robimy z zamiennikiem)
                if float(art_ilosc)-float(art_rezerwacja)<float(Zarezerwowano)-float(ZarezerwowanoG)-float(ZrealizowanoG):                      
                    if zamiennik in ['','None',None]:
                        stat = "BR ZAM"
                        dane.append(stat)                       
                    if stat=='OK':
                        sql = "SELECT artykul_id,ilosc1,rezerwacja1 FROM rs_artykuly_magazyny WHERE firma_id='"+self.firma_id+"' "
                        sql+= "AND artykul_id = '"+str(zamiennik)+"' and magazyn_id='"+str(Magazyn)+"';"
                        stat,DaneZAM,dump,dump = self.PolSQL.Execute(sql ,3) 
                        if stat<>'OK':
                            stat = 'Bdy w pobieraniu zamiennika:'+stat
                            dane.append(stat)    
                        elif len(DaneZAM)>0:
                            zam_ilosc=DaneZAM[0][1]
                            zam_rezerwacja=DaneZAM[0][2]
                            if float(zam_ilosc)-float(zam_rezerwacja)>=float(Zarezerwowano)-float(ZarezerwowanoG)-float(ZrealizowanoG):
                                stat = "JEST ZAMWMAG"
                                dane.append(stat)    
                            else:
                                stat = "BR ZAMWMAG"
                                dane.append(stat)
                        else:
                            stat = "BR ZAMWMAG"
                            dane.append(stat)
                        

#-------------------------------------------------------------------------------
#---   INSERT DANYCH (2- bez pobierania,1- z pobieraniem)
#-------------------------------------------------------------------------------

if Fun in [1,2] and stat=='OK':
    if not UprDodawanie:
        stat=="Brak uprawnie do dodawania danych."
        dane.append(stat)    
    
    if stat=='OK':
        Select="SELECT przelicznik,stawka_vat FROM rs_artykuly WHERE "
        Select+="firma_id='"+self.firma_id+"' AND artykul_id='"+str(Artykul)+"';"
        stat,d,dump,dump = self.PolSQL.Execute(Select ,3)
        if stat<>'OK':
            stat = 'Bdy pobierania przelicznika i stawki vat:'+stat
            dane.append(stat) 
        else:
            if len(d) <> 0:
                przelicznik=d[0][0] 
                zmiana1=float(Zarezerwowano)
                zmiana2=przelicznik*float(zmiana1)   
                stawka=rsglobal.Dekoduj(d[0][1])
    
    # pobranie numeru rezerwacji
    Select="SELECT MAX(rezerwacja_id) FROM rs_artykuly_rezerwacje;"  
    stat,DNum,wyn1,tr = self.PolSQL.Execute(Select,3)
    if stat<>'OK':
        stat = 'Bdy pobierania danych :'+stat
        dane.append(stat)    
    
    if stat=='OK':    
        Rezerwacja=DNum[0][0]+1
        
        ins = "INSERT INTO rs_artykuly_rezerwacje"
        Pola="firma_id,rezerwacja_id"
        Wartosci="'"+self.firma_id+"',"+str(Rezerwacja)
        for i in range(len(pola)):
            pole = pola[i]
            wart = wartosci[i]
            if pole in ['artykul_id','magazyn_id','kontrahent_id','handlowiec_id','koniec','opis']:
                Pola= Pola+","+pole
                if wart.strip()=='':
                    Wartosci= Wartosci+",NULL"
                else:
                    Wartosci= Wartosci+",'"+str(wart)+"'"      
            if pole in ['rezerwacja','zrealizowano']:
                Pola= Pola+","+pole
                Wartosci= Wartosci+","+str(wart)+""       
                
        # dodanie pozycji zamwienia jeli jest
        UpdZam=''
        if Zamowienie <> []:
            # jeli nie zmieniamy artykuu to robimy na podstawie istniejcego algorytmu
            if Artykul==ArtPodst:
                Pola+=",wyznacznik_id_z,data_z,numer_z,nr_poz_z,nr_ppoz_z"
                Wartosci+=",'"+str(Zamowienie[0])+"','"+str(Zamowienie[1])+"',"+str(Zamowienie[2])+","+str(Zamowienie[3])+","+str(Zamowienie[4])
            else:
                # w przypadku zamiennika :
                
                # pobranie danych z zamwienia
                SQL="SELECT zp.data_od,zp.data_do,zp.tryb_dostawy,z.kontrahent_id,z.waluta "     
                SQL+=" FROM rs_zamowienia_odbiorcy_pozycje zp INNER JOIN rs_zamowienia_odbiorcy z "
                SQL+=" USING (firma_id,wyznacznik_id,data,numer)"
                SQL+=" WHERE zp.firma_id='"+self.firma_id+"' AND zp.wyznacznik_id='"+str(Zamowienie[0])+"'"
                SQL+=" AND zp.data='"+str(Zamowienie[1])+"' AND zp.numer="+str(Zamowienie[2])
                SQL+=" AND zp.nr_poz="+str(Zamowienie[3])+" AND zp.nr_ppoz="+str(Zamowienie[4])+";"
                stat,DZamow,dump,dump = self.PolSQL.Execute(SQL,3)
                if stat=='OK':
                    DataOd=rsglobal.Dekoduj(DZamow[0][0])
                    if DataOd in ['',None,'None']:
                        DataOd='NULL'
                    else:
                        DataOd="'"+DataOd+"'"
                    
                    DataDo=rsglobal.Dekoduj(DZamow[0][1])
                    if DataDo in ['',None,'None']:
                        DataDo='NULL'
                    else:
                        DataDo="'"+DataDo+"'"
                        
                    Tryb=rsglobal.Dekoduj(DZamow[0][2])
                    if Tryb in ['',None,'None']:
                        Tryb='NULL'
                    else:
                        Tryb="'"+Tryb+"'"
                        
                    Kontr=rsglobal.Dekoduj(DZamow[0][3])
                    if Kontr in [None,'None']:
                        Kontr=''
                    
                    Waluta=rsglobal.Dekoduj(DZamow[0][4])
                    if Waluta in ['',None,'None']:
                        Waluta='PLN'
                    
                    
                    NrPoz=int(Zamowienie[3])+1
                    
                    # przesuwamy pozycje o 1 w d od wybranej przez nas pozycji zamwienia
                    UpdZam="UPDATE rs_zamowienia_odbiorcy_pozycje SET nr_poz=nr_poz+1, nr_ppoz=nr_ppoz+100 "
                    UpdZam+=" WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+str(Zamowienie[0])+"'"
                    UpdZam+=" AND data='"+str(Zamowienie[1])+"' AND numer="+str(Zamowienie[2])
                    UpdZam+=" AND nr_poz>"+str(Zamowienie[3])+";"
                    UpdZam+="UPDATE rs_zamowienia_odbiorcy_pozycje SET nr_ppoz=nr_ppoz-100 "
                    UpdZam+=" WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+str(Zamowienie[0])+"'"
                    UpdZam+=" AND data='"+str(Zamowienie[1])+"' AND numer="+str(Zamowienie[2])
                    UpdZam+=" AND nr_poz>"+str(Zamowienie[3])+";"
                    
                    # dodajemy now pozycj na zamwienie gdzie artyku jest zamiennikiem
                    # cena wzr to wzr gdzie mona podmieni walut i typ
                    CenaWzor=" rsf_podaj_cene_dla_kontrahenta('"+self.firma_id+"','"+Kontr+"',"
                    CenaWzor+="'%s','"+str(Zamowienie[1])+"','"+Artykul+"','%s','',-1) "
                    
                    CenaN1=CenaWzor % ('PLN','n1')
                    CenaN2=CenaWzor % ('PLN','n2')
                    CenaU1=CenaWzor % ('PLN','n1u')
                    CenaU2=CenaWzor % ('PLN','n2u')
                    CenaB1=CenaWzor % ('PLN','b1')
                    CenaB2=CenaWzor % ('PLN','b2')
                    CenaWalN1=CenaWzor % (Waluta,'n1')
                    CenaWalN2=CenaWzor % (Waluta,'n2')
                    CenaWalU1=CenaWzor % (Waluta,'n1u')
                    CenaWalU2=CenaWzor % (Waluta,'n2u')
                    Upust=" CASE WHEN "+CenaN1+">0 THEN ROUND(100-("+CenaU1+"/"+CenaN1+")*100,2) ELSE 0 END "
                    UpustW=" ROUND("+Upust+"*"+str(zmiana1)+"*0.01,2) "
                    WartN=" ROUND("+CenaU1+"*"+str(zmiana1)+",2) "
                    StawkaN=" CASE WHEN '"+str(stawka)+"' IN ("+str(self.ListaStawekZn)[1:-1]+") THEN 0 ELSE "+str(stawka)+" END "
                    WartB=" ROUND("+WartN+"*(100+"+StawkaN+")*0.01 ,2) "
                    WartV=WartB+"-"+WartN
                    WartWalN=" ROUND("+CenaWalU1+"*"+str(zmiana1)+",2) "
                    WartWalB=" ROUND("+WartWalN+"*(100+"+StawkaN+")*0.01 ,2) "
                    WartWalV=WartWalB+"-"+WartWalN
                    
                    UpdZam+="INSERT INTO rs_zamowienia_odbiorcy_pozycje (firma_id,wyznacznik_id,data,numer,"
                    UpdZam+="nr_poz,nr_ppoz,data_od,data_do,tryb_dostawy,artykul_id,ilosc1,ilosc2,"
                    UpdZam+="cena_netto1, cena_netto2, cena_upust1,cena_upust2,cena_brutto1,cena_brutto2,"
                    UpdZam+="upust,upust_wartosc,stawka_vat, wartosc_netto,wartosc_vat,wartosc_brutto,"
                    UpdZam+="cena_wal1,cena_wal2,cena_upust_wal1,cena_upust_wal2,"
                    UpdZam+="wartosc_wal_netto,wartosc_wal_vat,wartosc_wal_brutto) VALUES "
                    UpdZam+="('"+self.firma_id+"','"+str(Zamowienie[0])+"','"+str(Zamowienie[1])+"',"+str(Zamowienie[2])+","
                    UpdZam+=str(NrPoz)+",0,"+DataOd+","+DataDo+","+Tryb+",'"+Artykul+"',"+str(zmiana1)+","+str(zmiana2)+","
                    UpdZam+=CenaN1+","+CenaN2+","+CenaU1+","+CenaU2+","+CenaB1+","+CenaB2+","
                    UpdZam+=Upust+","+UpustW+",'"+stawka+"',"+WartN+","+WartV+","+WartB+","
                    UpdZam+=CenaWalN1+","+CenaWalN2+","+CenaWalU1+","+CenaWalU2+","
                    UpdZam+=WartWalN+","+WartWalV+","+WartWalB
                    UpdZam+=");"
    
                    # zmieniamy ilo zamwion i wartosci na podstawowej pozycji zamwienia
                    Ilosc1="(ilosc1-"+str(zmiana1)+")"
                    Ilosc2="(ilosc2-"+str(zmiana2)+")"
                    StawkaN=" CASE WHEN stawka_vat IN ("+(self.ListaStawekZn)[1:-1]+") THEN 0 ELSE stawka_vat::INTEGER END "
                    UpustW="ROUND(upust*"+Ilosc1+"*0.01,2) "
                    WartN=" ROUND(cena_upust1*"+Ilosc1+",2) "
                    WartB=" ROUND("+WartN+"*(100+"+StawkaN+")*0.01 ,2) "
                    WartV=WartB+"-"+WartN
                    WartWalN=" ROUND(cena_upust_wal1*"+Ilosc1+",2) "
                    WartWalB=" ROUND("+WartWalN+"*(100+"+StawkaN+")*0.01 ,2) "
                    WartWalV=WartWalB+"-"+WartWalN
                    
                    UpdZam+="UPDATE rs_zamowienia_odbiorcy_pozycje SET ilosc1="+Ilosc1+",ilosc2="+Ilosc2+","
                    UpdZam+="upust_wartosc="+UpustW+",wartosc_netto="+WartN+",wartosc_vat="+WartV+","
                    UpdZam+="wartosc_brutto="+WartB+",wartosc_wal_netto="+WartWalN+","
                    UpdZam+="wartosc_wal_vat="+WartWalV+",wartosc_wal_brutto="+WartWalB
                    UpdZam+=" WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+str(Zamowienie[0])+"'"
                    UpdZam+=" AND data='"+str(Zamowienie[1])+"' AND numer="+str(Zamowienie[2])
                    UpdZam+=" AND nr_poz="+str(Zamowienie[3])+" AND nr_ppoz="+str(Zamowienie[4])+";"
                    rsglobal.ZapiszDoLogow("UPDZAM "+UpdZam,1)
                    # dodajemy rezerwacj do nowej pozycji zamwienia
                    Pola+=",wyznacznik_id_z,data_z,numer_z,nr_poz_z,nr_ppoz_z"
                    Wartosci+=",'"+str(Zamowienie[0])+"','"+str(Zamowienie[1])+"',"+str(Zamowienie[2])+","+str(NrPoz)+",0"
        
    if stat=='OK':    
        ins = ins+" ("+Pola+") VALUES ("+Wartosci+");" 
                      
        up=" UPDATE rs_artykuly_magazyny SET rezerwacja1=(rezerwacja1+"+str(zmiana1)+")"        
        up+=",rezerwacja2=(rezerwacja2+"+str(zmiana2)+") WHERE firma_id='"+self.firma_id+"' "
        up+="AND magazyn_id='"+str(Magazyn)+"' AND artykul_id='"+str(Artykul)+"';"
        up+=" UPDATE rs_artykuly SET rezerwacja1=(rezerwacja1+"+str(zmiana1)+")"        
        up+=",rezerwacja2=(rezerwacja2+"+str(zmiana2)+") WHERE firma_id='"+self.firma_id+"' "
        up+="AND artykul_id='"+str(Artykul)+"';"
        
        stat,dump,dump,dump = self.PolSQL.Execute(UpdZam+ins+up,1)
        if stat<>'OK':
            stat = 'Bdy dodawania danych:'+stat
            dane.append(stat)
           
           
#-------------------------------------------------------------------------------
#---   UPDATE DANYCH (4- bez pobierania,3- z pobieraniem)
#-------------------------------------------------------------------------------

if Fun in [3,4] and stat=='OK':
    if not UprEdycja:
        stat=="Brak uprawnie do edycji danych."
        dane.append(stat)  
    
    if stat=='OK':     
        rezerw=0
        zrealizow=0
        przelicznik=1.0

    if stat=='OK' and 'rezerwacja' in pola:
        sql = "SELECT rezerwacja FROM rs_artykuly_rezerwacje WHERE firma_id='"+self.firma_id+"' "
        sql+= "AND rezerwacja_id = '"+str(Rezerwacja)+"';"
        stat,d,dump,dump = self.PolSQL.Execute(sql ,3) 
        if stat<>'OK':
            stat = 'Bdy pobierania rezerwacji:'+stat
            dane.append(stat)     
        else:
            if len(d)<>0:
                ZarezerwowanoG=d[0][0] 
                Zarezerwowano=wartosci[pola.index('rezerwacja')]
                Select="SELECT przelicznik FROM rs_artykuly WHERE "
                Select+="firma_id='"+self.firma_id+"' AND artykul_id='"+str(Artykul)+"';"
                stat,d,dump,dump = self.PolSQL.Execute(Select ,3)
                if stat<>'OK':
                    stat = 'Bdy pobierania przelicznika :'+stat
                    dane.append(stat) 
                else:
                    if len(d) <> 0:
                        przelicznik=d[0][0]            
                        zmiana1=float(Zarezerwowano)-float(ZarezerwowanoG)
                        zmiana2=float(zmiana1)*przelicznik
                                                 
    if stat=='OK':                          
        where = " WHERE firma_id='"+self.firma_id+"' AND rezerwacja_id='"+str(Rezerwacja)+"'; "
        upd = "UPDATE rs_artykuly_rezerwacje SET "
        SaPola=False
        for i in range(len(pola)):
            pole = pola[i]
            wart = wartosci[i]   
            if pole in ['koniec']:
                SaPola=True
                upd += pole+"='"+str(wart)+"',"
            if pole in ['rezerwacja']:
                SaPola=True
                upd += pole+"="+str(wart)+","
                
        if SaPola:
            upd = upd[0:len(upd)-1]+where        
            
            if 'rezerwacja' in pola:        
                upd2="UPDATE rs_artykuly_magazyny SET rezerwacja1=rezerwacja1+"+str(zmiana1)
                upd2+=",rezerwacja2=rezerwacja2+"+str(zmiana2)     
                upd2+=" WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+str(Magazyn)+"' AND artykul_id='"+str(Artykul)+"';"
                upd2+="UPDATE rs_artykuly SET rezerwacja1=rezerwacja1+"+str(zmiana1)
                upd2+=",rezerwacja2=rezerwacja2+"+str(zmiana2)     
                upd2+=" WHERE firma_id='"+self.firma_id+"' AND artykul_id='"+str(Artykul)+"';" 
                          
            stat,dump,dump,dump = self.PolSQL.Execute(upd+upd2 ,1)
            if stat<>'OK':
                stat = 'Bdy modyfikowania danych:'+stat
                dane.append(stat)    


#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (1- insert 5 -select, 6 -delete)
#-------------------------------------------------------------------------------

if (Fun in [1,3,5,6,11]) and (stat=='OK') :
    Select="SELECT * FROM rs_artykuly_rezerwacje WHERE firma_id='"+self.firma_id+"' "
    Select+=" AND rezerwacja_id="+str(Rezerwacja)+";"    
    stat,dane,wyn1,tr = self.PolSQL.Execute(Select,3)
    if stat<>'OK':
        stat = 'Bdy pobierania danych :'+stat
        dane.append(stat)

    if len(dane) == 1:
        tr = rssql.RSTableRowset(dane,wyn1)

        #--- artykul
        if ((self.oddzial_id,'013010') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
            dump,d,dump,dump = self.PolSQL.Execute("SELECT nazwa FROM rs_artykuly WHERE firma_id='"+self.firma_id+"' AND artykul_id='"+tr.GetVal(0,"artykul_id")+"';" ,3)
            if len(d) == 0:
                wyn2.append('')
            else:
                wyn2.append(d[0][0])
        else:
            wyn2.append('Brak uprawnie do sownika. Poinformuj administratora.')

        #---magazyn
        if ((self.oddzial_id,'031010') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
            dump,d,dump,dump = self.PolSQL.Execute("SELECT opis FROM rs_magazyny WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+tr.GetVal(0,"magazyn_id")+"';" ,3)
            if len(d) == 0:
                wyn2.append('')
            else:
                wyn2.append(d[0][0])
        else:
            wyn2.append('Brak uprawnie do magazynw. Poinformuj administratora.')
        
        #---kontrahent
        if ((self.oddzial_id,'012010') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
            dump,d,dump,dump = self.PolSQL.Execute("SELECT nazwa FROM rs_kontrahenci WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+tr.GetVal(0,"kontrahent_id")+"';" ,3)
            if len(d) == 0:
                wyn2.append('')
            else:
                wyn2.append(d[0][0])
        else:
            wyn2.append('Brak uprawnie do kontrahentw. Poinformuj administratora.')
        
        #---handlowiec
        if ((self.oddzial_id,'011220') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
            dump,d,dump,dump = self.PolSQL.Execute("SELECT opis FROM rs_handlowcy WHERE firma_id='"+self.firma_id+"' AND kod='"+tr.GetVal(0,"handlowiec_id")+"';" ,3)
            if len(d) == 0:
                wyn2.append('')
            else:
                wyn2.append(d[0][0])
        else:
            wyn2.append('Brak uprawnie do sownika - handlowcy. Poinformuj administratora.')
            
        #kontrola limitu zaleglosci
        Kontrahent = tr.GetVal(0,"kontrahent_id").strip()
        Data = tr.GetVal(0,"koniec")
        if not Kontrahent in ('','None'):
            limit = fs_zaleglosci_sprawdzenie.SprawdzLimitKontrahenta(self,Kontrahent,0,Data)
            wyn2.append(limit)
        else:
            wyn2.append('')