# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_artykuly_stany_magazynowe_przyjecia.py
# Purpose:     wczytuje artykuly przyjcia
# Author:      Dariusz Boduch
# Created:     2008/04/16
# RCS-ID:      $Id: fs_artykuly_stany_magazynowe_przyjecia.py $
# Copyright:   (c) 2006 RecordSystem
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

# 2011-10-27 Mariusz Rajfura     (5143) 'termin_przyd' do grida
# 2013-05-27 Micha Raburski     (6872) kolejkowanie wywietlania na gridzie
# 2023-09-22 Aleksander Bargie (13560) Wybr przyjcia artykuu - nie wymaga od Anakondy uprawnie do magazynw.
# 2023-09-28 Aleksander Bargie (13563) Artykuy - stany magazynowe zawsze zwraca Brak uprawnie do magazynu

from funkcje import fs_kolejkowanie_pom

Firma=str(klucze[0])
Klucz=klucze[1]
CzyWiekszeOdZera=klucze[2]
CzyZamiennik=klucze[3]
Zamiennik=rsglobal.Dekoduj(klucze[4]).replace("\\\\'","'").replace("\\'","'")
CzyPusty=str(klucze[5])
ArtykulZGrida=str(klucze[6])
MagazynZGrida=str(klucze[7])
Dokument=klucze[8]
Cecha = klucze[9]
FMagazyny = klucze[10] # s nadrzdne nad innymi magazynami
stat = 'OK'

Fun = klucze[-1]

ArtykulZKlucza = str(Klucz[0])
MagazynZKlucza = str(Klucz[1])
if Dokument==[] and Klucz[3] ==3:
    Dokument = [MagazynZKlucza]

if Fun == 10:
    dane = []
    
    FiltrF = " ap.firma_id='"+Firma+"'"
    if FMagazyny != '':
        LMagF = FMagazyny.split(',')
        FiltrF += " AND ap.magazyn_id IN ("
        for mag in LMagF:
            FiltrF+="'"+mag.strip("'")+"',"
        FiltrF = FiltrF.strip(',')
        FiltrF+=")"
    
    if ArtykulZGrida != '':
        if CzyZamiennik:
            FiltrA = " AND ap.artykul_id in ('"+ArtykulZGrida+"',"+Zamiennik+")"
        else:
            FiltrA = " AND ap.artykul_id = '"+ArtykulZGrida+"'"
        
        Filtr = FiltrF+FiltrA
        if FMagazyny != '':
            Filtr+= " AND ap.magazyn_id = '"+MagazynZGrida+"'"
        Artykul = ArtykulZGrida
        
    elif ArtykulZKlucza!= '':
        if CzyZamiennik == True:
            FiltrA = " AND ap.artykul_id in ('"+ArtykulZKlucza+"',"+Zamiennik+")"
        else:
            FiltrA = " AND ap.artykul_id = '"+ArtykulZKlucza+"'"
        Artykul = ArtykulZKlucza
        
        Filtr = FiltrF+FiltrA
        if FMagazyny == '':
            Rodzaj=len(Klucz)
            if Rodzaj==2:
                Filtr += " AND ap.magazyn_id = '"+MagazynZKlucza+"'"
            else:
                Rodzaj=Klucz[3]
                if Rodzaj == 2:
                    Filtr += " AND ap.magazyn_id IN ( SELECT magazyn_id FROM rs_magazyny WHERE firma_id = '"+Firma+"' AND oddzial_id = '"+rsglobal.Dekoduj(Klucz[1])+"')"
                elif Rodzaj == 3:
                    Filtr +=" AND ap.magazyn_id = '"+MagazynZKlucza+"'"

    if CzyWiekszeOdZera:
        Filtr = Filtr+" AND ap.ilosc1 - ap.rezerwacja1 > 0 "   
    if Cecha.strip() != '':
        if not '%' in Cecha:
            Cecha=Cecha+'%'
        Filtr+=" AND UPPER(ap.cecha1_wartosc) LIKE UPPER('"+Cecha+"')"

        #uprawnienia operatora do poszczeglnych magazynw
    if self.operator_id != STANDARD_OPERATOR_ID:  #AB 2023-09-28
        sql = "SELECT magazyn_id FROM rs_magazyny_upr WHERE firma_id='"+str(Firma)+"'"
        sql += " AND  '"+str(self.operator_id)+"'=operator_id AND ilosc;"
    else:
        sql = "SELECT magazyn_id FROM rs_magazyny WHERE  firma_id='"+str(Firma)+"'"
    rsglobal.ZapiszDoLogow(sql)
    stat,mag,dump,dump = self.PolSQL.Execute(sql,3)
    if stat != 'OK':
        stat = stat
        dane.append(stat)

    if stat == 'OK': # magazyny do ktorych mamy uprawnienia
        if len(mag)<>0:
            Magazyny = " AND ap.magazyn_id IN (   "
            for i in mag:
                Magazyny += "'"+str(i[0])+"' , "
            Magazyny = Magazyny[0:-3]+" ) "
            Filtr = Filtr + Magazyny
            if MagazynZKlucza and [MagazynZKlucza] not in mag:  #AB 2023-09-28
                stat = "Brak uprawnie do magazynu "+MagazynZKlucza

    # wyznaczenie kolejnoci sprawdzania danych na podstawie wpisw w bazie
    if stat=='OK':
        rsglobal.ZapiszDoLogow('1',1)
        stat,OrderZDanych = fs_kolejkowanie_pom.PodajOrderByDokumentuLubTekstu(self.PolSQL,self.firma_id,Dokument)
        if stat == 'OK':
            if OrderZDanych == '':
                stat='Brak okrelonego kolejkowania w artykuach przyjcia'
        rsglobal.ZapiszDoLogow('1',1)
        
    if stat=='OK':        
        sql ="SELECT ap.artykul_id,COALESCE(ap.cecha1_opis,''),ap.cecha1_wartosc,rsf_podaj_parametry_cechy(ap.firma_id,ap.cecha1_opis,ap.cecha1_wartosc,'opis'),"
        sql+=" ap.data,ap.magazyn_id,ap.dokument_id,ap.numer,ap.nr_poz,"
        sql+=" ap.nr_ppoz,ap.dostawca_id,ap.nr_serii,ap.cena1,ap.ilosc_prz1,ap.rezerwacja1,"
        sql+=" ap.ilosc1-ap.rezerwacja1,ap.cena_pierw1,ap.cena2,ap.ilosc_prz2,ap.rezerwacja2,"
        sql+=" ap.ilosc2-ap.rezerwacja2,ap.cena_pierw2,k.nazwa, COALESCE(ap.lokacja_id,''),"
        sql+=" COALESCE(ap.termin_przyd::TEXT,''::TEXT),COALESCE(opakowanie_id,''),COALESCE(oz.opis,''),COALESCE(wsp_ilosci_opakowanie,0),"
        sql+=" COALESCE(paleta_id,''),COALESCE(p.opis,''),COALESCE(wsp_ilosci_paleta,0),"
        sql+=" COALESCE(wsp_ilosci_lokacja,0),COALESCE(ilosc_lokacja,0),"
        sql+=" rsf_podaj_parametry_zlecenia_zo(ap.firma_id,ap.magazyn_id,ap.dokument_id,ap.data,ap.numer,ap.nr_poz,ap.nr_ppoz)"
        sql+=" FROM rs_artykuly_przyjecia ap"
        sql+=" LEFT OUTER JOIN rs_palety p USING (firma_id,paleta_id)"
        sql+=" LEFT OUTER JOIN rs_kontrahenci k ON (ap.firma_id=k.firma_id AND ap.dostawca_id=k.kontrahent_id)"
        sql+=" LEFT OUTER JOIN rs_opakowania_zbiorcze oz ON (ap.firma_id=oz.firma_id AND ap.opakowanie_id=oz.kod)"
        sql+=" WHERE "+Filtr+" AND NOT ap.wirtualne ORDER BY "+OrderZDanych+";"        
        stat,dane,dump,dump = self.PolSQL.Execute(sql,3, CzyDodawacBlad=True)
        if stat != 'OK':
            stat= stat
            dane.append(stat)
    
if Fun==11:
    Firma=str(klucze[0])
    ArtykulZGrida=str(klucze[6])
    ArtykulZKlucza = str(Klucz[0])
    if ArtykulZGrida<>'':
        Artykul = ArtykulZGrida
    else:
        Artykul = ArtykulZKlucza 
    dane=[]
    sql = "SELECT COALESCE(jm1,''),COALESCE(jm2,''), nazwa,COALESCE(cecha1_opis,'')"
    sql+=" FROM rs_artykuly WHERE firma_id='"+Firma+"' AND artykul_id='"+Artykul+"';"
    stat,dane,dump,dump = self.PolSQL.Execute(sql,3)
    if stat != 'OK':
        stat = stat
        jm.append(stat)   
    
    if stat=='OK':
        sql = "SELECT COUNT(*) FROM rs_artykuly_cechy_wartosci"
        sql+=" WHERE firma_id='"+Firma+"' AND kod='"+dane[0][3]+"';"
        stat,d,dump,dump = self.PolSQL.Execute(sql,3)
        if stat != 'OK':
            stat = 'Bd pobrania domylnej wartoci cechy artykuu : '+stat
        elif len(d) > 0:
            wyn2 = [d[0][0]]
