# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_artykuly_zestawy_kontrahenci.py
# Purpose:     obsluga grida z kontrahentami dotyczcymi podanego zestawu
# Author:      Micha Raburski
# Created:     2014/04/29
# RCS-ID:      $Id: fs_artykuly_zestawy_kontrahenci.py$
# Copyright:   (c) 2014 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

dane = []
wyn1 = []
wyn2 = []
stat = 'OK'

if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=='OK':
    Fun = klucze['Funkcja']
    
    SlPar={'Artykul':[3,5,6,10],'Kontr':[3,6],'Cecha':[3,6],'WartCechy':[3,6],
           'KontrP':[3],'CechaP':[3],'WartCechyP':[3]}    
    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Fun,klucze)
    if Lista<>'':
        stat='Uwaga : wywoanie funkcji fs_artykuly_zestawy_kontrahenci z numerem '+str(Fun)+' bez parametrw: '+Lista

if stat=='OK':
    if Fun in [3,5,6,10]:
        Art=rsglobal.Dekoduj(klucze['Artykul']).strip()
    if Fun in [3,6]:
        Kontr=rsglobal.Dekoduj(klucze['Kontr'])
        Cecha=rsglobal.Dekoduj(klucze['Cecha'])
        WartCechy=rsglobal.Dekoduj(klucze['WartCechy'])
    if Fun in [3]:
        KontrP=rsglobal.Dekoduj(klucze['KontrP'])
        CechaP=rsglobal.Dekoduj(klucze['CechaP'])
        WartCechyP=rsglobal.Dekoduj(klucze['WartCechyP'])

UprMod=((self.oddzial_id,'013112') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID

#-------------------------------------------------------------------------------
#-------  SPRAWDZENIE CZY ARTYKU JEST ZESTAWEM (10)
#-------------------------------------------------------------------------------

if Fun == 10 and stat == "OK":
    SQL ="SELECT a.typ_artykulu,COALESCE(a.cecha1_opis,''),COALESCE(ac.opis,''),COALESCE(acs.lp,0) "
    SQL+=" FROM rs_artykuly a "
    SQL+=" LEFT OUTER JOIN rs_artykuly_cechy ac ON (ac.firma_id=a.firma_id AND ac.kod=a.cecha1_opis)"
    SQL+=" LEFT OUTER JOIN rs_artykuly_cechy_sekcje acs ON (acs.firma_id=a.firma_id AND acs.kod=a.cecha1_opis)"
    SQL+=" WHERE a.firma_id='"+self.firma_id+"' AND a.artykul_id='"+Art+"' LIMIT 1"

    stat,dane,dump,dump = self.PolSQL.Execute(SQL,3)
    if stat <> 'OK':
        stat = 'Bd przy sprawdzaniu typu artykuu: '+stat
        dane.append(stat)
    if len(dane)==0:
        stat = 'Brak artykuu o symbolu '+Art

#-------------------------------------------------------------------------------
#-------  SKOPIOWANIE DEFINICJI Z INNEGO ZESTAWU (3)
#-------------------------------------------------------------------------------

if Fun == 3 and stat == "OK":
    if not UprMod:
        stat='BR UPR MOD'
        dane.append(stat)
        
    if stat == 'OK':
        # sprawdzenie poprawnoci cechy
        if WartCechy <> '':
            SQL="SELECT rsf_podaj_parametry_cechy('"+self.firma_id+"','"+Cecha+"','"+WartCechy+"','poprawna')"
            stat,DTest,dump,dump = self.PolSQL.Execute(SQL,3)
            if stat <> 'OK':
                stat = 'Bd sprawdzenia wartoci cechy: '+stat
            else:
                Wynik=eval(DTest[0][0])
                if not Wynik[0]:
                    stat = Wynik[1]
                    dane.append(stat)
        
    if stat == 'OK':
        SQL = "INSERT INTO rs_artykuly_zestawy (firma_id,zestaw_id,kontrahent_id,"
        SQL+=" cecha1_opis_z,cecha1_wartosc_z,artykul_id,cecha1_opis_a,cecha1_wartosc_a,ilosc1) "
        SQL+= "SELECT firma_id,zestaw_id,'"+Kontr+"','"+Cecha+"','"+WartCechy+"',artykul_id,"
        SQL+=" cecha1_opis_a,cecha1_wartosc_a,ilosc1 FROM rs_artykuly_zestawy" 
        SQL+=" WHERE firma_id='"+self.firma_id+"' AND zestaw_id='"+Art+"' AND kontrahent_id='"+KontrP+"'"
        SQL+=" AND cecha1_opis_z='"+CechaP+"' AND cecha1_wartosc_z='"+WartCechyP+"';"
        stat,dump,dump,dump = self.PolSQL.Execute(SQL,1)
        

#-------------------------------------------------------------------------------
#-------  USUNICIE ZESTAWU (6)
#-------------------------------------------------------------------------------

if Fun == 6 and stat == "OK":
    if not UprMod:
        stat='BR UPR US'
        dane.append(stat)
        
    if stat == 'OK':
        SQL = "DELETE FROM rs_artykuly_zestawy "
        SQL+=" WHERE firma_id='"+self.firma_id+"' AND zestaw_id='"+Art+"' AND kontrahent_id='"+Kontr+"'"
        SQL+=" AND cecha1_opis_z='"+Cecha+"' AND cecha1_wartosc_z='"+WartCechy+"';"
        stat,dump,dump,dump = self.PolSQL.Execute(SQL,1)


#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (5-odczyt, 6-usuwanie)
#-------------------------------------------------------------------------------

if Fun in [5,6] and stat == 'OK':
    # sprawdzenie czy istnieje pusty kontrahent. Jeli nie to go dodajemy
    SQL="SELECT kontrahent_id FROM rs_kontrahenci WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='ZS';"
    stat,DTest,dump,dump = self.PolSQL.Execute(SQL,3)
    if stat<>'OK':
        stat='Bd sprawdzania istnienia technicznego kontrahenta'
    if stat=='OK':
        if len(DTest) == 0:
            SQL="INSERT INTO rs_kontrahenci (firma_id,kontrahent_id,nazwa,aktywny) "
            SQL+=" VALUES ('"+self.firma_id+"','ZS','zestaw standardowy',TRUE);"
            stat,dump,dump,dump = self.PolSQL.Execute(SQL,1)    
            if stat<>'OK':
                stat='Bd wstawiania technicznego kontrahenta'
                
    if stat=='OK':
        # pobranie danych do grida
        SQL ="SELECT az.kontrahent_id, CASE WHEN az.kontrahent_id='ZS' THEN 'zestaw standardowy' ELSE k.nazwa END,"
        SQL+=" az.cecha1_opis_z,COALESCE(ac.opis,''),az.cecha1_wartosc_z,"
        SQL+=" rsf_podaj_parametry_cechy(az.firma_id,az.cecha1_opis_z,az.cecha1_wartosc_z,'opis'),"
        SQL+=" CASE WHEN kontrahent_id='ZS' THEN 1 ELSE 2 END AS kolejnosc"
        SQL+=" FROM rs_artykuly_zestawy az"
        SQL+=" LEFT OUTER JOIN rs_kontrahenci k USING (firma_id,kontrahent_id)"
        SQL+=" LEFT OUTER JOIN rs_artykuly_cechy ac ON (ac.firma_id=az.firma_id AND ac.kod=az.cecha1_opis_z)"
        SQL+=" WHERE az.firma_id='"+self.firma_id+"' AND az.zestaw_id='"+Art+"'"
        SQL+=" UNION "
        SQL+=" SELECT 'ZS   ' ,'zestaw standardowy','','','','',1"
        SQL+=" ORDER BY kolejnosc,kontrahent_id"
        stat,dane,wyn1,wyn2 = self.PolSQL.Execute(SQL,3)
        if stat <> 'OK':
            stat = "Bd przy pobieraniu danych: "+stat
        else:
            DTmp=[]
            for w in dane:
                DTmp.append(w[:-1])
            dane = DTmp