# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_boksy.py
# Purpose:     obsluga grida edytowalnego
# Author:      mariusz rajfura
# Created:     2010/07/15
# RCS-ID:      $Id: fs_boksy.py$
# Copyright:   (c) 2010 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

# 2013-11-21 Mariusz Rajfura (7409) nowe pole 'pomieszczenie'

Oddzial = rsglobal.Dekoduj(klucze[0]).strip()
Boks = rsglobal.Dekoduj(klucze[1]).strip()
OddzialF = rsglobal.Dekoduj(klucze[2][0]).strip()
Fun = klucze[-1]

stat = 'OK'
dane = []

UprIns=((self.oddzial_id,'014213') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID
UprUpd=((self.oddzial_id,'014212') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID or UprIns
UprDel=((self.oddzial_id,'014214') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID

Insert = []
Update = []
Delete = []

if Fun == 1:
    Update=klucze[-2]
    Insert=klucze[-3]
    Delete=klucze[-4]


#-------------------------------------------------------------------------------
# POBRANIE LISTY DOZWOLONYCH DZIALOW (10)
# Wykorzystane na oknie do informacji o dozwolonym uzyciu filtrowania wg oddzialow
# Wykorzystywane takze przy pobieraniu do grida (Fun in (1,5))
#-------------------------------------------------------------------------------

if Fun in (1,5,10) and stat == 'OK':
    if self.operator_id == STANDARD_OPERATOR_ID:
        sql="SELECT oddzial_id FROM rs_oddzialy WHERE firma_id = '"+self.firma_id+"' AND oddzial_id <> '**' ORDER BY oddzial_id;"
    else:
        sql ="SELECT DISTINCT o.oddzial_id FROM rs_oddzialy o "
        sql+="INNER JOIN rs_grupa_operator_oddzial go ON (o.firma_id=go.firma_id"
        sql+=" AND (o.oddzial_id=go.oddzial_id OR go.oddzial_id='**'))"
        sql+=" WHERE o.firma_id='"+self.firma_id+"' AND o.oddzial_id <> '**'"
        sql+=" AND go.operator_id IN "+str(self.operatorzy).replace("[","(").replace("]",")")
        sql+=" ORDER BY o.oddzial_id;"

    stat,oddz,dump,dump = self.PolSQL.Execute(sql,3)
    if stat <> 'OK':
        stat = 'Bd pobrania listy dozwolonych oddziaw : '+stat
    else:
        if len(oddz) == 0:
            stat = 'Brak oddzialw, do ktrych operator ma prawa.'
        else:
            UprOddzialy = '('
            for i in oddz:
                UprOddzialy += "'"+str(i[0])+"',"

            UprOddzialy = UprOddzialy[:-1]+")"

    if Fun == 10 and stat == 'OK':
        dane = oddz


#-------------------------------------------------------------------------------
#-------  SPRAWDZANIE DELETE  --------------------------------------------------
#-------------------------------------------------------------------------------

if Fun == 1 and stat=="OK":
    if len(Delete[0])>0:
        if not UprDel:
            stat='BR UPR DEL'
            dane.append(stat)
        
        if stat == 'OK':
            SQLDEL = ''
            SQLFU = ''
            for i in xrange(len(Delete[0])):
                DELETE = "DELETE FROM rs_boksy "
                WHERE = "WHERE firma_id='"+self.firma_id+"'"
                SQLFU ="SELECT boks_id FROM rs_boksy WHERE firma_id='"+self.firma_id+"' "
                for j in xrange(len(Delete[0][i])):
                    pole = Delete[1][j]
                    wart = Delete[0][i][j]
                    if pole in ['oddzial_id','boks_id','boks_ip']:
                        WHERE += " AND "+pole+"='"+wart+"'"
                        SQLFU += " AND "+pole+"='"+wart+"'"
                        
                SQLFU += " FOR UPDATE NOWAIT; "
                SQLDEL += DELETE+WHERE+"; "
                
            if SQLFU <> '':
                stat,d,dump,dump = self.PolSQL.Execute(rsglobal.Dekoduj(SQLFU),3)
                if stat <> 'OK':
                    stat = 'Bd sprawdzenia danych do usunicia: '+stat
                    dane.append(stat)
                    
            if stat == 'OK' and SQLDEL <> '' :
                stat,dump,dump,dump = self.PolSQL.Execute(rsglobal.Dekoduj(SQLDEL),1)
                if stat <> 'OK':
                    stat = "Usunicie niemoliwe. Boks wystpuje w innych tabelach"
                    dane.append(stat)

                                 
#-------------------------------------------------------------------------------
#---   UPDATE DANYCH (1)
#-------------------------------------------------------------------------------

if Fun == 1 and stat=="OK":
    if len(Update[0])>0:
        if not UprUpd:
            stat='BR UPR UPD'
            dane.append(stat)
            
        if stat == 'OK':
            SQLFU = ''
            for i in xrange(len(Update[0])):
                SQLFU += "SELECT boks_id FROM rs_boksy WHERE firma_id='"+self.firma_id+"'"
                for j in xrange(len(Update[2][i])): # petla po kluczu
                    pole = Update[3][j]
                    wart = rsglobal.Dekoduj(Update[2][i][j])
                    SQLFU += " AND "+pole+"='"+wart+"'"
                SQLFU += " FOR UPDATE NOWAIT; "
            
            if SQLFU <> '':
                stat,d,dump,dump = self.PolSQL.Execute(rsglobal.Dekoduj(SQLFU),3)
                if stat <> 'OK':
                    stat = 'Bd sprawdzenia danych do modyfikacji: '+stat
                    dane.append(stat)

        if stat == 'OK':
            WierszeNr = Update[-1]
            for i in xrange(len(Update[0])):
                for j in xrange(len(Update[0][i])): 
                    pole = Update[0][i][j]
                    wart = Update[1][i][j]

                    if pole == 'oddzial_id':
                        if wart.strip() == '':
                            stat = 'BR ODDZ'
                            wyn2.append((WierszeNr[i],0))
                            dane.append(stat)
                        else:
                            sql ="SELECT oddzial_id FROM rs_oddzialy"
                            sql+=" WHERE firma_id = '"+self.firma_id+"'"
                            sql+=" AND oddzial_id = '"+str(wart)+"'"
                            sql+=" AND oddzial_id IN "+UprOddzialy+";" 
                            stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                            if stat <> 'OK':
                                stat = 'BL SQL ODDZ'
                                wyn2.append((WierszeNr[i],0))
                                dane.append(stat)
                            elif len(d) == 0:
                                stat = 'BL ODDZ'
                                wyn2.append((WierszeNr[i],0))
                                dane.append(stat)
                            else:
                                Oddzial = str(wart)

                    elif pole == 'boks_id':
                        if len(wart.strip()) > 4:
                            stat = 'DL BOKS_ID'
                            wyn2.append((WierszeNr[i],2))
                            dane.append(stat)
                                
                    elif pole == 'boks_ip':
                        wart = wart.strip()
                        if wart <> '':
                            if self.operator_id <> STANDARD_OPERATOR_ID:
                                stat = 'UPR BOKS_IP'
                                wyn2.append((WierszeNr[i],3))
                                dane.append(stat)
                            elif len(wart) > 15:
                                stat = 'DL BOKS_IP'
                                wyn2.append((WierszeNr[i],3))
                                dane.append(stat)
                            elif not rsglobal.SprawdzAdresIp(wart):
                                stat = 'BL BOKS_IP'
                                wyn2.append((WierszeNr[i],3))
                                dane.append(stat)

                    elif pole == 'pomieszczenie':
                        if len(wart.strip()) > 2:
                            stat = 'DL POMIESZCZENIE'
                            wyn2.append((WierszeNr[i],4))
                            dane.append(stat)

        if stat == 'OK':
            if len(dane) > 0:
                stat = dane[0]
                
        # wykonanie UPDATE
        if stat=='OK':
            sql=''
            for i in xrange(len(Update[0])):
                UPDATE="UPDATE rs_boksy "
                SET='SET '
                for j in xrange(len(Update[0][i])): 
                    pole=Update[0][i][j]
                    wart=Update[1][i][j]
                    if pole in ['oddzial_id', 'boks_id', 'boks_ip']:
                        SET+=pole+"='"+wart.strip()+"',"
                    else:
                        if wart.strip()=='':
                            SET+=pole+"=NULL,"
                        else:
                            SET+=pole+"='"+wart+"',"
                
                SET=SET.strip(",")
                WHERE=" WHERE firma_id='"+self.firma_id+"'" 
                for j in xrange(len(Update[2][i])): # petla po kluczu
                    pole=Update[3][j]
                    wart=rsglobal.Dekoduj(Update[2][i][j])
                    WHERE+=" AND "+pole+"='"+wart+"'"
                WHERE+=";"    
                
                sql+=UPDATE+SET+WHERE;
                
            if sql<>'':
                stat,dump,dump,dump=self.PolSQL.Execute(rsglobal.Dekoduj(sql),1)
                if stat<>'OK':
                    stat="Bd przy modyfikowaniu danych: "+stat   
                    dane.append(stat)  


#-------------------------------------------------------------------------------
#---------Sprawdzanie danych do Insert------
#-------------------------------------------------------------------------------

if Fun == 1 and stat=="OK":
    Oddzial = ''
    if len(Insert[0])>0:
        if not UprIns:
            stat='BR UPR INS'
            dane.append(stat)

        if stat == 'OK':
            WierszeNr = Insert[-1]
            for i in xrange(len(Insert[0])):
                OddzialNowy = None
                BoksNowy = None
                
                for j in xrange(len(Insert[0][i])): 
                        pole=Insert[1][j]
                        wart=Insert[0][i][j].strip()
                        
                        if pole == 'oddzial_id':
                            wart = wart.strip()
                            OddzialNowy = wart
                            if wart == '':
                                stat = 'BR ODDZ'
                                wyn2.append((WierszeNr[i],0))
                                dane.append(stat)
                            else:
                                sql ="SELECT oddzial_id FROM rs_oddzialy"
                                sql+=" WHERE firma_id = '"+self.firma_id+"'"
                                sql+=" AND oddzial_id = '"+str(wart)+"'" 
                                sql+=" AND oddzial_id IN "+UprOddzialy+";" 
                                stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                                if stat <> 'OK':
                                    stat = 'BL SQL ODDZ'
                                    wyn2.append((WierszeNr[i],0))
                                    dane.append(stat)
                                elif len(d) == 0:
                                    stat = 'BL ODDZ'
                                    wyn2.append((WierszeNr[i],0))
                                    dane.append(stat)

                        elif pole == 'boks_id':
                            wart = wart.strip()
                            BoksNowy = wart
                            if wart == '':
                                stat = 'BR BOKS_ID'
                                wyn2.append((WierszeNr[i],2))
                                dane.append(stat)
                            elif len(wart) > 4:
                                stat = 'DL BOKS_ID'
                                wyn2.append((WierszeNr[i],2))
                                dane.append(stat)

                        elif pole == 'pomieszczenie':
                            wart = wart.strip()
                            if len(wart) > 2:
                                stat = 'DL POMIESZCZENIE'
                                wyn2.append((WierszeNr[i],4))
                                dane.append(stat)

                
                #sprawdzam przed dodawaniem, czy podany klucz juz istniej,
                #bo operator moze miec na gridzie filtr i nie widziec,
                #ze podany (choc dozwolony) klucz juz istnieje
                
                if len(dane) == 0 and OddzialNowy <> None and BoksNowy <> None:
                    sql ="SELECT boks_id FROM rs_boksy"
                    sql+=" WHERE firma_id='"+self.firma_id+"'"
                    sql+=" AND oddzial_id='"+str(OddzialNowy)+"'"
                    sql+=" AND boks_id='"+str(BoksNowy)+"';"
                    stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                    if stat <> 'OK':
                        stat = 'Bd sprawdzenia nowego klucza: '+stat
                        dane.append(stat)
                        wyn2.append((WierszeNr[i],0))
                        wyn2.append((WierszeNr[i],2))
                    elif len(d) > 0:
                        stat = 'BL BOKS IST'
                        dane.append(stat)
                        wyn2.append((WierszeNr[i],0))
                        wyn2.append((WierszeNr[i],2))
                                    
            if stat == 'OK':
                if len(dane) > 0:
                    stat = dane[0]
        
        if stat == 'OK':
            #petla sprawdzenia pozostalych pol
            WierszeNr = Insert[-1]
            for i in xrange(len(Insert[0])):
                for j in xrange(len(Insert[0][i])): 
                        pole=Insert[1][j]
                        wart=Insert[0][i][j].strip()
                        
                        if pole == 'boks_ip':
                            wart = wart.strip()
                            if wart <> '':
                                if self.operator_id <> STANDARD_OPERATOR_ID:
                                    stat = 'UPR BOKS_IP'
                                    wyn2.append((WierszeNr[i],3))
                                    dane.append(stat)
                                elif len(wart) > 15:
                                    stat = 'DL BOKS_IP'
                                    wyn2.append((WierszeNr[i],3))
                                    dane.append(stat)
                                elif not rsglobal.SprawdzAdresIp(wart):
                                    stat = 'BL BOKS_IP'
                                    wyn2.append((WierszeNr[i],3))
                                    dane.append(stat)

        if stat == 'OK':
            if len(dane) > 0:
                stat = dane[0]
                                                        
        # wykonanie INSERT
        if stat=='OK':    
            sqlIns=''
            for i in xrange(len(Insert[0])):
                INSERT="INSERT INTO rs_boksy "
                KOLUMNY="(firma_id"
                VALUES=" VALUES ('"+self.firma_id+"'"
                for j in xrange(len(Insert[0][i])):
                    pole=Insert[1][j]
                    wart=Insert[0][i][j]
                    if pole in ['oddzial_id','boks_id','boks_ip','pomieszczenie']:
                        wart = wart.strip()
                        if len(wart)==0:
                            KOLUMNY+=","+pole
                            VALUES+=","+str('NULL')
                        else:
                            KOLUMNY+=","+pole
                            VALUES+=",'"+wart+"'"
                KOLUMNY+=")"
                VALUES+=");"
                sqlIns+=INSERT+KOLUMNY+VALUES
            if sqlIns<>'': 
                stat,dump,dump,dump=self.PolSQL.Execute(rsglobal.Dekoduj(sqlIns),1)
                if stat<>'OK':
                    stat="Bd przy dodawaniu danych: "+stat   
                    dane.append(stat)                   


#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (1- insert 1 -select, 1 -delete)
#-------------------------------------------------------------------------------

if Fun in (1,5) and stat=='OK':
    SQL ="SELECT b.oddzial_id, o.opis, b.boks_id, COALESCE(b.boks_ip,''::TEXT),"
    SQL+=" COALESCE(b.pomieszczenie,'')"
    SQL+=" FROM rs_boksy b"
    SQL+=" LEFT OUTER JOIN rs_oddzialy o USING(firma_id,oddzial_id)"
    SQL+=" WHERE b.firma_id='"+self.firma_id+"'"
    
    if self.operator_id <> STANDARD_OPERATOR:
        SQL+=" AND b.oddzial_id IN "+UprOddzialy
        
    if OddzialF <> '':
        SQL+=" AND b.oddzial_id LIKE '"+OddzialF+"%'"
    SQL+=" ORDER BY b.oddzial_id, b.boks_id;"

    stat,dane,wyn1,wyn2=self.PolSQL.Execute(SQL,3)
    if stat<>'OK':
        stat="Bd przy pobieraniu danych: "+stat
        dane.append(stat)
