# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_boksy_trasy.py
# Purpose:     obsluga grida edytowalnego
# Author:      mariusz rajfura
# Created:     2010/07/16
# RCS-ID:      $Id: fs_boksy_trasy.py$
# Copyright:   (c) 2010 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

Oddzial = rsglobal.Dekoduj(klucze[0][0]).strip()
Boks = rsglobal.Dekoduj(klucze[0][1]).strip()
Trasa = rsglobal.Dekoduj(klucze[0][2]).strip()
TrybDostawy = rsglobal.Dekoduj(klucze[0][3]).strip()
DzienTygodnia = klucze[0][4]

OddzialF = rsglobal.Dekoduj(klucze[1][0]).strip()
BoksF = rsglobal.Dekoduj(klucze[1][1]).strip()
TrasaF = rsglobal.Dekoduj(klucze[1][2]).strip()
TrybDostawyF = rsglobal.Dekoduj(klucze[1][3]).strip()
DzienTygodniaF = klucze[1][4]

Fun = klucze[-1]

stat = 'OK'
dane = []

UprIns=((self.oddzial_id,'014223') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID
UprUpd=((self.oddzial_id,'014222') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID or UprIns
UprDel=((self.oddzial_id,'014224') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID

Insert = []
Update = []
Delete = []

if Fun == 1:
    Update=klucze[-2]
    Insert=klucze[-3]
    Delete=klucze[-4]


#-------------------------------------------------------------------------------
#-------  POBRANIE OPISU TRASY (8)
#-------------------------------------------------------------------------------

if Fun == 8 and stat == "OK":
    sql ="SELECT opis FROM rs_trasy"
    sql+=" WHERE firma_id='"+self.firma_id+"' AND kod='"+Trasa+"';"

    stat,dane,dump,dump = self.PolSQL.Execute(sql,3)
    if stat <> 'OK':
        stat = 'Bd przy sprawdzaniu opisu trasy: '+stat
        dane.append(stat)


#-------------------------------------------------------------------------------
# POBRANIE LISTY DOZWOLONYCH DZIALOW (10)
# Wykorzystane na oknie do informacji o dozwolonym uzyciu filtrowania wg oddzialow
# Wykorzystywane takze przy pobieraniu do grida (Fun in (1,5))
#-------------------------------------------------------------------------------

if Fun in (1,5,10) and stat == 'OK':
    if self.operator_id == STANDARD_OPERATOR_ID:
        sql="SELECT oddzial_id FROM rs_oddzialy WHERE firma_id = '"+self.firma_id+"' AND oddzial_id <> '**' ORDER BY oddzial_id;"
    else:
        sql ="SELECT DISTINCT o.oddzial_id FROM rs_oddzialy o "
        sql+="INNER JOIN rs_grupa_operator_oddzial go ON (o.firma_id=go.firma_id"
        sql+=" AND (o.oddzial_id=go.oddzial_id OR go.oddzial_id='**'))"
        sql+=" WHERE o.firma_id='"+self.firma_id+"' AND o.oddzial_id <> '**'"
        sql+=" AND go.operator_id IN "+str(self.operatorzy).replace("[","(").replace("]",")")
        sql+=" ORDER BY o.oddzial_id;"

    stat,oddz,dump,dump = self.PolSQL.Execute(sql,3)
    if stat <> 'OK':
        stat = 'Bd pobrania listy dozwolonych oddziaw : '+stat
    else:
        if len(oddz) == 0:
            stat = 'Brak oddzialw, do ktrych operator ma prawa.'
        else:
            UprOddzialy = '('
            for i in oddz:
                UprOddzialy += "'"+str(i[0])+"',"

            UprOddzialy = UprOddzialy[:-1]+")"

    if Fun == 10 and stat == 'OK':
        dane = oddz


#-------------------------------------------------------------------------------
#-------  SPRAWDZANIE DELETE  --------------------------------------------------
#-------------------------------------------------------------------------------

if Fun == 1 and stat=="OK":
    if len(Delete[0])>0:
        if not UprDel:
            stat='BR UPR DEL'
            dane.append(stat)
        
        # wykonanie DELETE 
        if stat == 'OK':
            SQLDEL = ''
            SQLFU = ''
            for i in xrange(len(Delete[0])):
                SQLFU = "SELECT boks_id FROM rs_boksy_trasy WHERE firma_id='"+self.firma_id+"'"
                DELETE = "DELETE FROM rs_boksy_trasy "
                WHERE = "WHERE firma_id='"+self.firma_id+"'"
                for j in xrange(len(Delete[0][i])):
                    pole = Delete[1][j]
                    wart = Delete[0][i][j]
                    if pole in ['oddzial_id','boks_id','trasa','tryb_dostawy']:
                        WHERE += " AND "+pole+"='"+wart+"'"
                        SQLFU += " AND "+pole+"='"+wart+"'"
                        
                    elif pole in ['dzien_tygodnia']:
                        WHERE += " AND "+pole+"="+str(wart)
                        SQLFU += " AND "+pole+"="+str(wart)
                
                SQLDEL += DELETE+WHERE+"; "
                SQLFU += " FOR UPDATE NOWAIT; "

            if SQLFU <> '':
                stat,d,dump,dump = self.PolSQL.Execute(rsglobal.Dekoduj(SQLFU),3)
                if stat <> 'OK':
                    stat = 'Bd sprawdzenia danych do usunicia: '+stat
                    dane.append(stat)

            if stat == "OK" and SQLDEL <> '':
                stat,dump,dump,dump = self.PolSQL.Execute(rsglobal.Dekoduj(SQLDEL),1)
                if stat <> 'OK':
                    stat = "Bd przy usuwaniu danych: "+stat   
                    dane.append(stat)

                                 
#-------------------------------------------------------------------------------
#---   UPDATE DANYCH (1)
#-------------------------------------------------------------------------------

if Fun == 1 and stat=="OK":
    if len(Update[0])>0:
        if not UprUpd:
            stat='BR UPR UPD'
            dane.append(stat)

        if stat == 'OK':
            SQLFU = ''
            for i in xrange(len(Update[0])):
                SQLFU += "SELECT boks_id FROM rs_boksy_trasy WHERE firma_id='"+self.firma_id+"'"
                for j in xrange(len(Update[2][i])): # petla po kluczu
                    pole = Update[3][j]
                    wart = rsglobal.Dekoduj(Update[2][i][j])
                    if pole == 'dzien_tygodnia':
                        SQLFU += " AND "+pole+"="+str(wart)
                    else:
                        SQLFU += " AND "+pole+"='"+wart+"'"
                        
                SQLFU += " FOR UPDATE NOWAIT; "
            
            if SQLFU <> '':
                stat,d,dump,dump = self.PolSQL.Execute(rsglobal.Dekoduj(SQLFU),3)
                if stat <> 'OK':
                    stat = 'Bd sprawdzenia danych do modyfikacji: '+stat
                    dane.append(stat)
            
        if stat == 'OK':
            WierszeNr = Update[-1]
            for i in xrange(len(Update[0])):
                #pobranie klucza (oddzial,boks) dla sprawdzenia boksu w rs_boksy
                for j in xrange(len(Update[2][i])): # petla po kluczu
                    pole = Update[3][j]
                    wart = rsglobal.Dekoduj(Update[2][i][j])
                    if pole == 'oddzial_id':
                        Oddzial = str(wart)
                    elif pole == 'boks_id':
                        Boks = str(wart)

                OddzialNowy = None
                BoksNowy = None

                for j in xrange(len(Update[0][i])): 
                    pole = Update[0][i][j]
                    wart = Update[1][i][j]

                    if pole == 'oddzial_id':
                        wart = wart.strip()
                        OddzialNowy = str(wart)
                        if wart == '':
                            stat = 'BR ODDZ'
                            wyn2.append((WierszeNr[i],0))
                            dane.append(stat)
                        else:
                            sql ="SELECT oddzial_id FROM rs_oddzialy"
                            sql+=" WHERE firma_id = '"+self.firma_id+"'"
                            sql+=" AND oddzial_id = '"+Oddzial+"'"
                            sql+=" AND oddzial_id IN "+UprOddzialy+";" 
                            stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                            if stat <> 'OK':
                                stat = 'BL SQL ODDZ'
                                wyn2.append((WierszeNr[i],0))
                                dane.append(stat)
                            elif len(d) == 0:
                                stat = 'BL ODDZ'
                                wyn2.append((WierszeNr[i],0))
                                dane.append(stat)

                    elif pole == 'boks_id':
                        wart = wart.strip()
                        BoksNowy = str(wart)
                        if wart == '':
                            stat = 'BR BOKS'
                            wyn2.append((WierszeNr[i],2))
                            dane.append(stat)

                    elif pole == 'trasa':
                        if wart.strip() == '':
                            stat = 'BR TRASA'
                            wyn2.append((WierszeNr[i],3))
                            dane.append(stat)
                        else:
                            sql ="SELECT kod FROM rs_trasy"
                            sql+=" WHERE firma_id = '"+self.firma_id+"'"
                            sql+=" AND kod = '"+str(wart)+"';"
                            stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                            if stat <> 'OK':
                                stat = 'BL SQL TRASA'
                                wyn2.append((WierszeNr[i],3))
                                dane.append(stat)
                            elif len(d) == 0:
                                stat = 'BL TRASA'
                                wyn2.append((WierszeNr[i],3))
                                dane.append(stat)

                    elif pole == 'tryb_dostawy':
                        if wart.strip() == '':
                            stat = 'BR TRYB_DOSTAWY'
                            wyn2.append((WierszeNr[i],5))
                            dane.append(stat)
                        else:
                            sql ="SELECT kod FROM rs_tryby_dostaw"
                            sql+=" WHERE firma_id = '"+self.firma_id+"'"
                            sql+=" AND kod = '"+str(wart)+"';"
                            stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                            if stat <> 'OK':
                                stat = 'BL SQL TRYBY_DOSTAW'
                                wyn2.append((WierszeNr[i],5))
                                dane.append(stat)
                            elif len(d) == 0:
                                stat = 'BL TRYB_DOSTAWY'
                                wyn2.append((WierszeNr[i],5))
                                dane.append(stat)

                    elif pole == 'dzien_tygodnia':
                        wart = str(int(wart))
                        if wart.strip() == '':
                            stat = 'BR DZIEN_TYGODNIA'
                            wyn2.append((WierszeNr[i],7))
                            dane.append(stat)
                        else:
                            sql ="SELECT kod FROM rs_dni_tygodnia"
                            sql+=" WHERE kod = '"+wart+"';"
                            stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                            if stat <> 'OK':
                                stat = 'BL SQL DZIEN_TYGODNIA'
                                wyn2.append((WierszeNr[i],7))
                                dane.append(stat)
                            elif len(d) == 0:
                                stat = 'BL DZIEN_TYGODNIA'
                                wyn2.append((WierszeNr[i],7))
                                dane.append(stat)

                #sprawdzenie poprawnosci klucza dla boksu (oddzial,boks)
                #w przypadku zmiany oddzialu lub boksa z uwzgl.uprawnien do oddzialow
                if len(dane) == 0 and (OddzialNowy <> None or BoksNowy <> None):
                    sql ="SELECT boks_id FROM rs_boksy"
                    sql+=" WHERE firma_id='"+self.firma_id+"'"
                    if OddzialNowy <> None:
                        sql+=" AND oddzial_id='"+OddzialNowy+"'"
                    else:
                        sql+=" AND oddzial_id='"+Oddzial+"'"
                    if BoksNowy <> None:    
                        sql+=" AND boks_id='"+str(BoksNowy)+"'"
                    else:
                        sql+=" AND boks_id='"+str(Boks)+"'"
                    sql+=" AND oddzial_id IN "+UprOddzialy+";"

                    stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                    if stat <> 'OK':
                        stat = 'BL SQL BOKS'
                        wyn2.append((WierszeNr[i],0))
                        wyn2.append((WierszeNr[i],2))
                        dane.append(stat)
                    elif len(d) == 0:
                        stat = 'BL BOKS'
                        wyn2.append((WierszeNr[i],0))
                        wyn2.append((WierszeNr[i],2))
                        dane.append(stat)

        if stat == 'OK':
            if len(dane) > 0:
                stat = dane[0]
                
        # wykonanie UPDATE
        if stat=='OK':
            sql=''
            for i in xrange(len(Update[0])):
                UPDATE="UPDATE rs_boksy_trasy "
                SET='SET '
                for j in xrange(len(Update[0][i])): 
                    pole=Update[0][i][j]
                    wart=Update[1][i][j]
                    if pole in ['oddzial_id', 'boks_id', 'trasa', 'tryb_dostawy']:
                        SET+=pole+"='"+wart+"',"
                    elif pole in ['dzien_tygodnia']:
                        SET+=pole+"="+str(wart)+","
                
                SET=SET.strip(",")
                WHERE=" WHERE firma_id='"+self.firma_id+"'" 
                for j in xrange(len(Update[2][i])): # petla po kluczu
                    pole=Update[3][j]
                    wart=rsglobal.Dekoduj(Update[2][i][j])
                    if pole in ['oddzial_id', 'boks_id', 'trasa', 'tryb_dostawy']:
                        WHERE+=" AND "+pole+"='"+wart+"'"
                    elif pole in ['dzien_tygodnia']:
                        WHERE+=" AND "+pole+"="+str(wart)
                        
                WHERE+=";"    
                
                sql+=UPDATE+SET+WHERE;
                
            if sql<>'':
                stat,dump,dump,dump=self.PolSQL.Execute(rsglobal.Dekoduj(sql),1)
                if stat<>'OK':
                    stat="Bd przy modyfikowaniu danych: "+stat   
                    dane.append(stat)  


#-------------------------------------------------------------------------------
#---------Sprawdzanie danych do Insert------
#-------------------------------------------------------------------------------

if Fun == 1 and stat=="OK":
    if len(Insert[0])>0:
        if not UprIns:
            stat='BR UPR INS'
            dane.append(stat)

        if stat == 'OK':
            WierszeNr = Insert[-1]
            for i in xrange(len(Insert[0])):
                OddzialNowy = None
                BoksNowy = None
                TrasaNowy = None
                TrybDostawyNowy = None
                DzienTygodniaNowy = None
                
                for j in xrange(len(Insert[0][i])): 
                        pole=Insert[1][j]
                        wart=Insert[0][i][j]
                        
                        if pole == 'oddzial_id':
                            wart = wart.strip()
                            OddzialNowy = str(wart)
                            if wart == '':
                                stat = 'BR ODDZ'
                                wyn2.append((WierszeNr[i],0))
                                dane.append(stat)
                            else:
                                sql ="SELECT oddzial_id FROM rs_oddzialy"
                                sql+=" WHERE firma_id = '"+self.firma_id+"'"
                                sql+=" AND oddzial_id = '"+str(wart)+"'" 
                                sql+=" AND oddzial_id IN "+UprOddzialy+";" 
                                stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                                if stat <> 'OK':
                                    stat = 'BL SQL ODDZ'
                                    wyn2.append((WierszeNr[i],0))
                                    dane.append(stat)
                                elif len(d) == 0:
                                    stat = 'BL ODDZ'
                                    wyn2.append((WierszeNr[i],0))
                                    dane.append(stat)

                        elif pole == 'boks_id':
                            wart = wart.strip()
                            BoksNowy = str(wart)
                            if wart == '':
                                stat = 'BR BOKS'
                                wyn2.append((WierszeNr[i],2))
                                dane.append(stat)

                        elif pole == 'trasa':
                            wart = wart.strip()
                            TrasaNowy = str(wart)
                            if wart == '':
                                stat = 'BR TRASA'
                                wyn2.append((WierszeNr[i],3))
                                dane.append(stat)
                            else:
                                sql ="SELECT kod FROM rs_trasy"
                                sql+=" WHERE firma_id = '"+self.firma_id+"'"
                                sql+=" AND kod = '"+str(wart)+"';"
                                stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                                if stat <> 'OK':
                                    stat = 'BL SQL TRASA'
                                    wyn2.append((WierszeNr[i],3))
                                    dane.append(stat)
                                elif len(d) == 0:
                                    stat = 'BL TRASA'
                                    wyn2.append((WierszeNr[i],3))
                                    dane.append(stat)

                        elif pole == 'tryb_dostawy':
                            wart = wart.strip()
                            TrybDostawyNowy = str(wart)
                            if wart == '':
                                stat = 'BR TRYB_DOSTAWY'
                                wyn2.append((WierszeNr[i],5))
                                dane.append(stat)
                            else:
                                sql ="SELECT kod FROM rs_tryby_dostaw"
                                sql+=" WHERE firma_id = '"+self.firma_id+"'"
                                sql+=" AND kod = '"+str(wart)+"';"
                                stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                                if stat <> 'OK':
                                    stat = 'BL SQL TRYBY_DOSTAW'
                                    wyn2.append((WierszeNr[i],5))
                                    dane.append(stat)
                                elif len(d) == 0:
                                    stat = 'BL TRYB_DOSTAWY'
                                    wyn2.append((WierszeNr[i],5))
                                    dane.append(stat)

                        elif pole == 'dzien_tygodnia':
                            wart = str(int(wart))
                            DzienTygodniaNowy = wart
                            if wart.strip() == '':
                                stat = 'BR DZIEN_TYGODNIA'
                                wyn2.append((WierszeNr[i],7))
                                dane.append(stat)
                            else:
                                sql ="SELECT kod FROM rs_dni_tygodnia"
                                sql+=" WHERE kod = '"+wart+"';"
                                stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                                if stat <> 'OK':
                                    stat = 'BL SQL DZIEN_TYGODNIA'
                                    wyn2.append((WierszeNr[i],7))
                                    dane.append(stat)
                                elif len(d) == 0:
                                    stat = 'BL DZIEN_TYGODNIA'
                                    wyn2.append((WierszeNr[i],7))
                                    dane.append(stat)

                #sprawdzam istnienie boksu w podanym oddziale
                # z uwzgl.uprawnien do oddzialow
                if len(dane) == 0 and OddzialNowy <> None and BoksNowy <> None:
                    sql ="SELECT boks_id FROM rs_boksy"
                    sql+=" WHERE firma_id='"+self.firma_id+"'"
                    sql+=" AND oddzial_id='"+OddzialNowy+"'"
                    sql+=" AND boks_id='"+BoksNowy+"'"
                    sql+=" AND oddzial_id IN "+UprOddzialy+";"

                    stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                    if stat <> 'OK':
                        stat = 'BL SQL BOKS'
                        wyn2.append((WierszeNr[i],0))
                        wyn2.append((WierszeNr[i],2))
                        dane.append(stat)
                    elif len(d) == 0:
                        stat = 'BL BOKS'
                        wyn2.append((WierszeNr[i],0))
                        wyn2.append((WierszeNr[i],2))
                        dane.append(stat)
                
                #sprawdzam przed dodawaniem, czy podany klucz juz istnieje,
                #bo operator moze miec na gridzie filtr i nie widziec,
                #ze podany (choc dozwolony) klucz juz istnieje
                if len(dane) == 0 and OddzialNowy <> None and BoksNowy <> None \
                    and TrasaNowy <> None and TrybDostawyNowy <> None and DzienTygodniaNowy <> None:
                    sql ="SELECT boks_id FROM rs_boksy_trasy"
                    sql+=" WHERE firma_id='"+self.firma_id+"'"
                    sql+=" AND oddzial_id='"+OddzialNowy+"'"
                    sql+=" AND boks_id='"+BoksNowy+"'"
                    sql+=" AND trasa='"+TrasaNowy+"'"
                    sql+=" AND tryb_dostawy='"+TrybDostawyNowy+"'"
                    sql+=" AND dzien_tygodnia="+str(DzienTygodniaNowy)+";"

                    stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                    if stat <> 'OK':
                        stat = 'BL SQL KLUCZ'+stat
                        dane.append(stat)
                        wyn2.append((WierszeNr[i],0))
                        wyn2.append((WierszeNr[i],2))
                        wyn2.append((WierszeNr[i],3))
                        wyn2.append((WierszeNr[i],5))
                        wyn2.append((WierszeNr[i],7))
                    elif len(d) > 0:
                        stat = 'BL KLUCZ IST'
                        dane.append(stat)
                        wyn2.append((WierszeNr[i],0))
                        wyn2.append((WierszeNr[i],2))
                        wyn2.append((WierszeNr[i],3))
                        wyn2.append((WierszeNr[i],5))
                        wyn2.append((WierszeNr[i],7))
                                    
        if stat == 'OK':
            if len(dane) > 0:
                stat = dane[0]
                                                        
        # wykonanie INSERT
        if stat == 'OK':    
            sqlIns=''
            for i in xrange(len(Insert[0])):
                INSERT="INSERT INTO rs_boksy_trasy "
                KOLUMNY="(firma_id"
                VALUES=" VALUES ('"+self.firma_id+"'"
                for j in xrange(len(Insert[0][i])):
                    pole=Insert[1][j]
                    wart=Insert[0][i][j]
                    if pole in ['oddzial_id','boks_id','trasa','tryb_dostawy']:
                        KOLUMNY+=","+pole
                        VALUES+=",'"+wart+"'"
                    elif pole in ['dzien_tygodnia']:
                        KOLUMNY+=","+pole
                        VALUES+=","+str(wart)                        
                        
                KOLUMNY+=")"
                VALUES+=");"
                sqlIns+=INSERT+KOLUMNY+VALUES
            if sqlIns<>'': 
                stat,dump,dump,dump=self.PolSQL.Execute(rsglobal.Dekoduj(sqlIns),1)
                if stat<>'OK':
                    stat="Bd przy dodawaniu danych: "+stat   
                    dane.append(stat)                   


#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (1- insert 1 -select, 1 -delete)
#-------------------------------------------------------------------------------

if Fun in (1,5) and stat=='OK':
    SQL ="SELECT bt.oddzial_id, o.opis, bt.boks_id, bt.trasa, t.opis,"
    SQL+=" bt.tryb_dostawy, td.opis, bt.dzien_tygodnia, dt.opis"
    SQL+=" FROM rs_boksy_trasy bt"
    SQL+=" LEFT OUTER JOIN rs_oddzialy o USING(firma_id,oddzial_id)"
    SQL+=" LEFT OUTER JOIN rs_trasy t ON (t.firma_id=bt.firma_id AND t.kod=bt.trasa)"
    SQL+=" LEFT OUTER JOIN rs_tryby_dostaw td ON (td.firma_id=bt.firma_id AND td.kod=bt.tryb_dostawy)"
    SQL+=" LEFT OUTER JOIN rs_dni_tygodnia dt ON (dt.kod=bt.dzien_tygodnia::TEXT)"
    SQL+=" WHERE bt.firma_id='"+self.firma_id+"'"
    
    if self.operator_id <> STANDARD_OPERATOR:
        SQL+=" AND bt.oddzial_id IN "+UprOddzialy
        
    if OddzialF <> '':
        SQL+=" AND bt.oddzial_id LIKE '"+OddzialF+"%'"
        
    if BoksF <> '':
        SQL+=" AND bt.boks_id LIKE '"+BoksF+"%'"
        
    if TrasaF <> '':
        SQL+=" AND bt.trasa LIKE '"+TrasaF+"%'"

    if TrybDostawyF <> '':
        SQL+=" AND bt.tryb_dostawy LIKE '"+TrybDostawyF+"%'"

    if DzienTygodniaF <> 0:
        SQL+=" AND bt.dzien_tygodnia="+str(DzienTygodniaF)
        
    SQL+=" ORDER BY bt.oddzial_id, bt.boks_id, bt.trasa, bt.tryb_dostawy, bt.dzien_tygodnia;"

    stat,dane,wyn1,wyn2 = self.PolSQL.Execute(SQL,3)
    if stat <> 'OK':
        stat = "Bd przy pobieraniu danych: "+stat
        dane.append(stat)