#!/usr/bin/python
# -*- coding: iso8859_2 -*-
#-----------------------------------------------------------------------------
# Name:             fs_cennik_import.py
# Purpose:          importuje cenniki
# Author:           Marcin Grzeda
# Created:          2007/05/10
# RCS-ID:           $Id: fs_cennik_import.py $
# Copyright:        (c) 2007 RecordSystem
# Licence:          GNU GPL
#-----------------------------------------------------------------------------
# 2021-11-12 (12691) Aleksander Bargie - W obsudze cennika oraz dodawaniu wersji cenowych uwzgldnia rs_artykuly_stawki_vat
import rsglobal

Wersja=klucze[0]
Data=klucze[1]
Waluta=klucze[2]
Jm=klucze[3]
f=klucze[4]
lmpp = 2
stat='OK'
dane=[]
firma_id = self.firma_id  #AB 12.11.21r

if not (((self.oddzial_id,'016012') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)):
    stat='UPR IMPORT'

if stat=='OK':
    if Wersja.strip()<>'':
        sql="SELECT kod,po_przecinku,czy_cena_brutto FROM rs_wersje_cenowe WHERE firma_id='"+self.firma_id+"' AND kod='"+Wersja+"'"
        stat,d,dump,dump=self.PolSQL.Execute(sql,3)
        if stat=='OK':
            if len(d)==0:
                stat='BL WERS'
            elif 0 <= d[0][1] <= 4:
                lmpp = d[0][1]
        else:
            stat='BL SQL WERS'
    else:
        stat='BR WERS'
        
if stat=='OK':
    CzyBrutto=d[0][2]
    
    
if stat=='OK':    
    if not rsglobal.SprawdzCzyToData(Data):
        stat='BL DAT'
        
    if Waluta.strip()<>'':
        sql="SELECT kod FROM rs_waluty WHERE firma_id='"+self.firma_id+"' AND kod='"+Waluta+"'"
        stat,d,dump,dump=self.PolSQL.Execute(sql,3)
        if stat=='OK':
            if len(d)==0:
                stat='BL WAL'
        else:
            stat='BL SQL WAL'
    else:
        stat='BR WAL'
        
    
if stat=='OK':
    lista=f.splitlines()
    Nagl=lista[0].strip()
    Nagl=Nagl.replace('"','')
    Nagl=Nagl.lower()
    if Nagl not in ('indeks;cena','indeks,cena'):
        stat='BL PLIK'

if stat=='OK':
    #OD TEGO MIEJSCA BYLO KIEDYS TO CO NA DOLE ZAKOMENTARZOWANE. ZMIENIONE PRZEZ MR 2008/05/09            
    dane=[]
    SQL=''
    laduje = 0
    ARTS={} #w celu sprawdzenia czy sie artykul nie powtarza DB mantis 0003839
    for i in xrange(len(lista)-1):
        j=i+1
        if stat=='OK':
            if not lista[j].strip():
                continue
            wiersz=lista[j].split(';')
            if not len(wiersz) == 2:
                stat = 'BL PLIK WIERSZ'
                wyn2 = [j+1]
                break
            Art=wiersz[0].strip('"')
            if ARTS.has_key(Art):
                stat='W pliku powtarza si artyku: '+Art
                wyn2 = [j+1]
                break
            else:
                ARTS[Art]=1
            Kwota=wiersz[1].strip('"')
            Kwota=Kwota.replace('.',',')
            Kwota=Kwota.replace(',','.').replace(' ', '')
            
            try:
                kwt = float(Kwota)
            except ValueError:
                stat = 'BL PLIK WIERSZ'
                wyn2 = [j+1]
                break
            
            if Art <> '':
                #AB 12.11.21r zmienione zapytanie
                SELECT="""SELECT COALESCE(v.stawka_vat, a.stawka_vat) AS stawka_vat, a.przelicznik
                          FROM rs_artykuly a
                          LEFT JOIN rs_artykuly_stawki_vat v ON (a.firma_id, a.artykul_id) = (v.firma_id, v.artykul_id) 
                                                              AND v.od_dnia=(SELECT max(od_dnia) 
                                                                             FROM rs_artykuly_stawki_vat tmp 
                                                                             WHERE (firma_id, artykul_id) = (v.firma_id, v.artykul_id) AND od_dnia <= '{Data}')
                          WHERE a.firma_id='{firma_id}' AND a.artykul_id='{Art}'
                          ;""".format(**locals())
                stat,d,dump,dump=self.PolSQL.Execute(SELECT,3)
                rsglobal.ZapiszDoLogow("Pobraniestawki Vat aasdfgaS")
                rsglobal.ZapiszDoLogow(SELECT)
                if stat != 'OK':  #AB 12.11.21r dodany test statu
                    stat = "Bd pobierania stawki VAT " + stat
                    rsglabal.ZapiszDoLogow(stat)
                    rsglabal.ZapiszDoLogow(SELECT)
                elif len(d)>0:  #AB 12.11.21r if na elif
                    if d[0][0] in self.ListaStawekZn or d[0][0]=='00':
                        stawka_vat='0'
                    else:
                        stawka_vat=rsglobal.Dekoduj(d[0][0]).lstrip('0')
                    przelicznik=d[0][1]
                    
                    #sprawdzenie czy cena dla tego artykulu juz istnieje
                    Filtr="WHERE firma_id='"+self.firma_id+"' AND artykul_id='"+Art+"' AND wersja='"+Wersja+"'"
                    Filtr+=" AND waluta='"+Waluta+"' AND data_od='"+Data+"';"
                    
                    stat,dart,dump,dump=self.PolSQL.Execute("SELECT * FROM rs_artykuly_ceny "+Filtr,3)
                    if stat=='OK':
                        laduje += 1
                        if CzyBrutto:
                            cbruI = kwt
                            cnetI = "ROUND((%s * 100/(100 + %s)), %d)" % (cbruI, stawka_vat, lmpp)
                            if Jm:
                                cbruP = "%s / %s" % (cbruI, przelicznik)
                            else:
                                cbruP = "%s * %s" % (cbruI, przelicznik)
                            cnetP = "ROUND((%s * 100/(100 + %s)), %d)" % (cbruP, stawka_vat, lmpp)   
                            # do tej pory byy uywane w wyraeniach, ale teraz i je mona zaokrgli
                            cbruI = "ROUND(%s, %d)" % (cbruI, lmpp)
                            cbruP = "ROUND(%s, %d)" % (cbruP, lmpp)         
                        else:
                            cnetI = kwt
                            cbruI = "ROUND((%s * (100 + %s)) * 0.01, %d)" % (cnetI, stawka_vat, lmpp)
                            if Jm:
                                cnetP = "%s / %s" % (cnetI, przelicznik)
                            else:
                                cnetP = "%s * %s" % (cnetI, przelicznik)
                            cbruP = "ROUND((%s * (100 + %s)) * 0.01, %d)" % (cnetP, stawka_vat, lmpp)        
                            # do tej pory byy uywane w wyraeniach, ale teraz i je mona zaokrgli
                            cnetI = "ROUND(%s, %d)" % (cnetI, lmpp)
                            cnetP = "ROUND(%s, %d)" % (cnetP, lmpp)        
                        
                        # jeli wczytujemy w pierwszej jednostce to wczytana do ceny1 a z przelicznikiem do ceny2
                        if Jm:
                            cnet1 = cnetI
                            cbru1 = cbruI
                            cnet2 = cnetP
                            cbru2 = cbruP
                        else:
                            cnet1 = cnetP
                            cbru1 = cbruP
                            cnet2 = cnetI
                            cbru2 = cbruI

                        if len(dart)>0:
                            #zmiana cen artykulu
                            dane.append(Art)
                            SQL+="UPDATE rs_artykuly_ceny SET cena_netto1=%s, cena_brutto1=%s, cena_netto2=%s, cena_brutto2=%s %s" % (
                                    cnet1, cbru1, cnet2, cbru2, Filtr)
                        else:
                            #wstawienie nowych cen
                            SQL+="INSERT INTO rs_artykuly_ceny (firma_id,artykul_id,wersja,waluta,data_od,cena_netto1,cena_brutto1,"
                            SQL+="cena_netto2,cena_brutto2) VALUES "
                            SQL+="('"+self.firma_id+"','"+Art+"','"+Wersja+"','"+Waluta+"','"+Data+"',"
                            SQL+=cnet1 + "," + cbru1 + "," + cnet2 + "," + cbru2 + ");"

    if SQL <> '' and stat=='OK':
        stat,dump,dump,dump=self.PolSQL.Execute(SQL,1)