# -*- coding: iso8859_2 -*-
#-----------------------------------------------------------------------------
# Name:        fs_crm_kontakty.py
# Purpose:     wywietlanie danych o osobach-kontaktach u naszych klientw
#
# Author:      Micha Raburski
#
# Created:     2011/01/18
# RCS-ID:      $Id: fs_crm_kontakty.py $
# Copyright:   (c) 2011 Record System
# Licence:     GNU GPL
#-----------------------------------------------------------------------------

stat='OK'
dane=[]
Fun=klucze[-1]

# pobranie danych : 1 - dla kontrahenta, 2 - dla patnika, 3 - dla patnika i podkontrahentw
if Fun in [1,2,3]:
    Kontr=klucze[0]
    Kateg=klucze[1]
    Plat=''

    if Fun in [2,3]:
        if Kontr=='':
            stat='Naley poda konkretnego kontrahenta, by pobra dane zwizane z jego patnikiem'
        
        if stat=='OK':
            # pobranie patnika
            SQL="SELECT COALESCE(platnik_id,kontrahent_id) FROM rs_kontrahenci "
            SQL+="WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+Kontr+"'"
            stat,DPlat,dump,dump=self.PolSQL.Execute(SQL,2)
            if stat<>"OK":
                stat="Bd pobierania danych patnika :"+stat
            
            elif len(DPlat)==0:
                stat='Brak podanego kontrahenta: '+Kontr
            
            if stat=='OK':
                Plat=DPlat[0][0]

    if stat=='OK':
        SQL="SELECT ko.osoba_id,ko.nazwisko,ko.imie,st.opis,ko.tel1,ko.tel2,ko.email,ko.fax,ko.kontrahent_id,k.nazwa "    
        SQL+=" FROM rs_kontrahenci_osoby ko INNER JOIN rs_kontrahenci k USING (firma_id,kontrahent_id) "
        SQL+=" LEFT OUTER JOIN rs_stanowiska st ON (st.firma_id=ko.firma_id AND st.kod=ko.stanowisko) "
        SQL+=" WHERE ko.firma_id='"+self.firma_id+"' "
        if Kateg<>'':
            SQL+=" AND k.kateg_kontrahenta='"+Kateg+"' "
        if Kontr<>'':
            if Fun==1:
                SQL+=" AND ko.kontrahent_id='"+Kontr+"'"
            elif Fun==2:
                SQL+=" AND ko.kontrahent_id='"+Plat+"'"
            elif Fun==3:
                SQL+=" AND (ko.kontrahent_id IN ('"+Kontr+"','"+Plat+"') OR k.platnik_id IN ('"+Kontr+"','"+Plat+"'))"
        stat,dane,wyn1,wyn2=self.PolSQL.Execute(SQL,2)
        if stat<>"OK":
            stat="Bd pobierania danych do grida :"+stat