# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_dokumenty_kontrahenci_szablony.py
# Purpose:     grid szablonow dokumentow dla kontrahentow
#
# Author:      Mariusz Rajfura
# Created:     2012/01/10
# RCS-ID:      $Id: fs_procesy.py $
# Copyright:   (c) 2012 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

# 2012-01-16 Mariusz Rajfura  pobranie opisu szablonu (5362)

stat = 'OK'
dane = []

if not 'Funkcja' in klucze:
    stat = 'Brak podanej funkcji w kluczach'

if stat == 'OK':
    Funkcja = klucze['Funkcja']

    SlPar = {'Typ': [1, 5, 6, 9], 'Szablon': [1, 5, 6, 9]}
    Lista = rsglobal.SprawdzParametryWKluczach(SlPar, Funkcja, klucze)

    if Lista <> '':
        stat = 'Uwaga : wywoanie funkcji fs_kp_dane_osobowe_zobowiazanie_ratalne z numerem '+str(Funkcja)+' bez parametrw: '+Lista

if stat == 'OK':
    if Funkcja in [1, 5, 6, 9]:
        Typ = rsglobal.Dekoduj(klucze['Typ'])
        Szablon = rsglobal.Dekoduj(klucze['Szablon'])

UprUsuwanie = ((self.oddzial_id,'175004') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID

Insert = []
Update = []
Delete = []

if stat == 'OK' and Funkcja == 1:
    Update = klucze['Update']
    Insert = klucze['Insert']
    Delete = klucze['Delete']

wyn1 = []
wyn2 = []

#-------------------------------------------------------------------------------
# POBRANIE OPISU SZABLONU (9)
#-------------------------------------------------------------------------------

if Funkcja == 9 and stat == 'OK':
    sql ="SELECT dkt.opis,dks.opis,COALESCE(dks.karencja_dni,0),"
    sql+=" COALESCE(dks.czy_strona_ma,FALSE),COALESCE(dks.kwota_minimum,0)"
    sql+=" FROM rs_dokumenty_kontrahenci_szablony dks"
    sql+=" INNER JOIN rs_dokumenty_kontrahenci_typy dkt ON (dkt.kod=dks.typ)"
    sql+=" WHERE dks.firma_id='"+self.firma_id+"'"
    sql+=" AND dks.typ='"+Typ+"' AND dks.szablon_id='"+Szablon+"';"
    stat,dane,dump,dump = self.PolSQL.Execute(sql,3)


#-------------------------------------------------------------------------------
# DELETE - 6
#-------------------------------------------------------------------------------

if Funkcja == 6:
    if not UprUsuwanie:
        stat = 'Brak uprawnie do usuwania szablonw'

    if stat == 'OK':
        sql ="SELECT typ FROM rs_dokumenty_kontrahenci_szablony"
        sql+=" WHERE firma_id='"+self.firma_id+"' AND typ='"+Typ+"'"
        sql+=" AND szablon_id='"+Szablon+"' FOR UPDATE NOWAIT;"
        stat,d,dump,dump = self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Bd pobrania informacji o procesie : '+stat
        elif len(d) == 0:
            stat = 'Szablon o podanym kluczu nie istnieje.'

    if stat == 'OK':
        DELETE ="DELETE FROM rs_dokumenty_kontrahenci_szablony"
        DELETE+=" WHERE firma_id='"+self.firma_id+"' AND typ='"+Typ+"'"
        DELETE+=" AND szablon_id='"+Szablon+"';"

        stat,d,dump,dump = self.PolSQL.Execute(DELETE, 1)
        if stat <> 'OK':
            stat = 'Szablon uywany w innych tabelach. Usunicie niemoliwe.'


#-------------------------------------------------------------------------------
# SELECT 5,6
#-------------------------------------------------------------------------------

if Funkcja in (5,6) and stat == 'OK':
    SELECT ="SELECT typ,szablon_id,COALESCE(opis,''::TEXT)"
    SELECT+=" FROM rs_dokumenty_kontrahenci_szablony"
    SELECT+=" WHERE firma_id='"+self.firma_id+"'"
    SELECT+=" ORDER BY typ,szablon_id;"

    stat,dane,wyn1,dump = self.PolSQL.Execute(SELECT, 3)
    if stat <> 'OK':
        stat = 'Bd pobrania listy szablonw : '+stat
