#!/usr/bin/python
# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:			fs_dokumenty_magazynowe_dostawy.py
# Purpose:		
# Author:		Dariusz Boduch  
# Created:		2009/04/14
# RCS-ID:		$Id: fs_dokumenty_magazynowe_dostawy.py $
# Copyright:	(c) 2004-2009 RecordSystem
# Licence:		GNU GPL
#-------------------------------------------------------------------------------
# 2013-07-26 Mariusz Rajfura    ( 7061) nowe pole 'osobne_dokumenty'
# 2018-11-06 Aleksander Bargie (11271) Bdy w Dokumenty dostawy

Fun=klucze[-1]

stat='OK'
wyn1=[]
wyn2=[]
dane=[]

if self.operator_id == STANDARD_OPERATOR_ID:
    UprEdycja = UprUsuwanie = UprDodawanie = True
else:
    UprUsuwanie=((self.oddzial_id,'014084') in self.uprawnienia)
    UprDodawanie=((self.oddzial_id,'014083') in self.uprawnienia)
    UprEdycja=((self.oddzial_id,'014082') in self.uprawnienia) or UprDodawanie
    
#-------------------------------------------------------------------------------
#-------  SPRAWDZANIE DELETE
#-------------------------------------------------------------------------------

if Fun == 1 and stat=="OK":
    Delete=klucze[-4]
    if len(Delete[0])>0:
        if not UprUsuwanie:
            stat='UPR DEL'
            dane.append(stat)
   
#------------------------------------------------------------------------------------------------------------        
#-------------------------- DELETE    
#------------------------------------------------------------------------------------------------------------        
        
        if stat=='OK':
            sql=''
            for i in xrange(len(Delete[0])):
                DELETE="DELETE FROM rs_dokumenty_magazynowe_dowody_dostaw "
                WHERE="WHERE firma_id='"+self.firma_id+"'"
                for j in xrange(len(Delete[0][i])):
                    pole=Delete[1][j]
                    wart=Delete[0][i][j]                                   #AB 2018.11.06
                    if pole in ['oddzial_id','magazyn_id','magazyn_zw_id','magazyn_rw_id',
                                'zmiana','kontrahent_id','tryby_dostaw']:
                        if wart.strip() == '':
                            WHERE+=" AND "+pole+" IS NULL"
                        else:
                            WHERE+=" AND "+pole+"='"+wart+"'"
                        
                sql+=DELETE+WHERE+";"
            if sql<>'':
                rsglobal.ZapiszDoLogow(Delete, 5)
                rsglobal.ZapiszDoLogow(sql, 5)
                stat,dump,dump,dump=self.PolSQL.Execute(rsglobal.Dekoduj(sql),1)
                if stat<>'OK':
                    stat='BL DEL'
                    dane.append(stat)
                                 
#-------------------------------------------------------------------------------
#---   UPDATE DANYCH (1)
#-------------------------------------------------------------------------------

if Fun == 1 and stat=="OK":
    Update=klucze[-2]
    if len(Update[0])>0:
        if not UprEdycja:
            stat='UPR UPD'
            dane.append(stat)
        if stat=='OK':
            WierszeNr = Update[-1]
            for i in xrange(len(Update[0])):
                for j in xrange(len(Update[0][i])): 
                    pole=Update[0][i][j]
                    wart=rsglobal.Dekoduj(Update[1][i][j])
                    if pole == 'oddzial_id':
                        if wart.strip()=='':
                            stat = 'Brak symbolu oddziau'
                            wyn2.append((WierszeNr[i],0))
                            dane.append(stat)
                        else:
                            stat,D,dump,dump = self.PolSQL.Execute("SELECT oddzial_id FROM rs_oddzialy WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+wart+"';",3)
                            if stat<>'OK':
                                stat='Bd sprawdzania danych oddziau :'+stat
                                wyn2.append((WierszeNr[i],0))
                                dane.append(stat)
                            else:
                                if len(D)==0:
                                    stat = 'Niepoprawny symbol oddziau'
                                    wyn2.append((WierszeNr[i],0))
                                    dane.append(stat)
                    elif pole == 'magazyn_id':
                        if wart.strip()<>'':
                            stat,D,dump,dump = self.PolSQL.Execute("SELECT magazyn_id FROM rs_magazyny WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+wart+"';",3)
                            if stat<>'OK':
                                stat = 'Bd sprawdzania danych magazynu WZ: '+stat
                                wyn2.append((WierszeNr[i],1))
                                dane.appen(stat)
                            else:
                                if len(D)==0:
                                    stat = 'Niepoprawny magazyn WZ'
                                    wyn2.append((WierszeNr[i],1))
                                    dane.append(stat)
                    
                    elif pole == 'magazyn_zw_id':
                        if wart<>'':
                            stat,D,dump,dump = self.PolSQL.Execute("SELECT magazyn_id FROM rs_magazyny WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+wart+"';",3)
                            if stat<>'OK':
                                stat = 'Bd sprawdzania danych magazynu ZW: '+stat
                                wyn2.append((WierszeNr[i],1))
                                dane.append(stat)
                            else:
                                if len(D)==0:
                                    stat = 'Niepoprawny magazyn ZW'
                                    wyn2.append((WierszeNr[i],2))
                                    dane.append(stat)
                                
                    elif pole == 'magazyn_rw_id':
                        if wart<>'':
                            stat,D,dump,dump = self.PolSQL.Execute("SELECT magazyn_id FROM rs_magazyny WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+wart+"';",3)
                            if stat<>'OK':
                                stat = 'Bd sprawdzania danych magazynu RW: '+stat
                                wyn2.append((WierszeNr[i],1))
                                dane.append(stat)
                            else:
                                if len(D)==0:
                                    stat = 'Niepoprawny magazyn RW'
                                    wyn2.append((WierszeNr[i],2))
                                    dane.append(stat)

                    elif pole == 'zmiana':
                        if wart.strip() =='':
                            stat = 'Brak symbolu zmiany'
                            wyn2.append((WierszeNr[i],3))
                            dane.append(stat)
                        elif len(wart.strip())<>1:
                            stat = 'Symbol zmiany to jeden znak'
                            wyn2.append((WierszeNr[i],3))
                            dane.append(stat)
                    elif pole == 'kontrahent_id':
                        if wart.strip()<>'':
                            stat,D,dump,dump = self.PolSQL.Execute("SELECT kontrahent_id FROM rs_kontrahenci WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+wart+"';",3)
                            if stat<>'OK':
                                stat = 'Bd sprawdzania danych kontrahenta: '+stat
                                wyn2.append((WierszeNr[i],4))
                                dane.append(stat)
                            if len(D)==0:
                                stat = 'Niepoprawny kontrahent'
                                wyn2.append((WierszeNr[i],4))
                                dane.append(stat)
                    elif pole == 'tryby_dostaw':
                        if wart.strip() =='':
                            stat = 'Niewypenione pole z trybami dostaw'
                            wyn2.append((WierszeNr[i],6))
                            dane.append(stat)
                                
    # czy byly jakies bledy
    if stat=='OK':
        if len(dane) > 0:
            stat = dane[0]

    if stat=='OK':
        sql=''
        for i in xrange(len(Update[0])):
            UPDATE="UPDATE rs_dokumenty_magazynowe_dowody_dostaw "
            SET='SET '
            for j in xrange(len(Update[0][i])): 
                pole=Update[0][i][j]
                wart=Update[1][i][j]
                if pole in ['zmiana', 'tryby_dostaw']: 
                    SET+=pole+"='"+wart+"',"
                elif pole in ['osobne_dokumenty']:
                    if wart > 0:
                        SET+=pole+"=TRUE,"
                    else:
                        SET+=pole+"=FALSE,"
                else:
                    if wart.strip()=='':
                        SET+=pole+"=NULL,"
                    else:
                        SET+=pole+"='"+wart+"',"
                
            SET=SET.strip(",")
            WHERE=" WHERE firma_id='"+self.firma_id+"'" 
            for j in xrange(len(Update[2][i])): # petla po kluczu
                pole=Update[3][j]
                wart=rsglobal.Dekoduj(Update[2][i][j])
                if wart.strip() == '':
                    WHERE+=" AND "+pole+" IS NULL"
                else:
                    WHERE+=" AND "+pole+"='"+wart+"'"
                    
            WHERE+=";"    
            
            sql+=UPDATE+SET+WHERE;
        if sql<>'':
            rsglobal.ZapiszDoLogow(sql, 5)
            rsglobal.ZapiszDoLogow(Update, 5)
            stat,dump,dump,dump=self.PolSQL.Execute(rsglobal.Dekoduj(sql),1)    
            
#----------------------------------------------------------------------------------------------------------------------
#---------Sprawdzanie danych do Insert------
#----------------------------------------------------------------------------------------------------------------------
                        
if Fun == 1 and stat=="OK":
    Insert=klucze[-3]
    if len(Insert[0])>0:
        if not UprDodawanie:
            stat='UPR INS'
            dane.append(stat)   
        if stat=='OK':
            Insert=klucze[-3]
            WierszeNr = Insert[-1]
            for i in xrange(len(Insert[0])):
                for j in xrange(len(Insert[0][i])):
                    pole=Insert[1][j]
                    wart=rsglobal.Dekoduj(Insert[0][i][j])
                    if pole == 'oddzial_id':
                        if wart.strip()=='':
                            stat = 'Brak symbolu oddziau'
                            wyn2.append((WierszeNr[i],0))
                            dane.append(stat)
                        else:
                            stat,D,dump,dump = self.PolSQL.Execute("SELECT oddzial_id FROM rs_oddzialy WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+wart+"';",3)
                            if len(D)==0:
                                stat = 'Niepoprawny symbol oddziau'
                                wyn2.append((WierszeNr[i],0))
                                dane.append(stat)
                    
                    elif pole == 'magazyn_id':
                        if wart.strip()<>'':
                            stat,D,dump,dump = self.PolSQL.Execute("SELECT magazyn_id FROM rs_magazyny WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+wart+"';",3)
                            if stat<>'OK':
                                stat = 'Bd sprawdzania danych magazynu WZ :'+stat
                                wyn2.append((WierszeNr[i],1))
                                dane.append(stat)
                            else:
                                if len(D)==0:
                                    stat = 'Niepoprawny magazyn WZ'
                                    wyn2.append((WierszeNr[i],1))
                                    dane.append(stat)
                    
                    elif pole == 'magazyn_zw_id':
                        if wart<>'':
                            stat,D,dump,dump = self.PolSQL.Execute("SELECT magazyn_id FROM rs_magazyny WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+wart+"';",3)
                            if stat<>'OK':
                                stat = 'Bd sprawdzania danych magazynu ZW: '+stat
                                wyn2.append((WierszeNr[i],2))
                                dane.append(stat)
                            else:
                                if len(D)==0:
                                    stat = 'Niepoprawny magazyn ZW'
                                    wyn2.append((WierszeNr[i],2))
                                    dane.append(stat)
                                    
                    elif pole == 'magazyn_rw_id':
                        if wart<>'':
                            stat,D,dump,dump = self.PolSQL.Execute("SELECT magazyn_id FROM rs_magazyny WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+wart+"';",3)
                            if stat<>'OK':
                                stat = 'Bd sprawdzania danych magazynu RW: '+stat
                                wyn2.append((WierszeNr[i],2))
                                dane.append(stat)
                            else:
                                if len(D)==0:
                                    stat = 'Niepoprawny magazyn RW'
                                    wyn2.append((WierszeNr[i],2))
                                    dane.append(stat)
                                    
                    elif pole == 'zmiana':
                        if wart.strip() =='':
                            stat = 'Brak symbolu zmiany'
                            wyn2.append((WierszeNr[i],3))
                            dane.append(stat)
                        elif len(wart.strip())<>1:
                            stat = 'Symbol zmiany to jeden znak'
                            wyn2.append((WierszeNr[i],3))
                            dane.append(stat)
                    elif pole == 'kontrahent_id':
                        if wart.strip()<>'':
                            stat,D,dump,dump = self.PolSQL.Execute("SELECT kontrahent_id FROM rs_kontrahenci WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+wart+"';",3)
                            if stat<>'OK':
                                stat = 'Bd sprawdzania danych kontrahenta: '+stat
                                wyn2.append((WierszeNr[i],4))
                                dane.append(stat)
                            if len(D)==0:
                                stat = 'Niepoprawny kontrahent'
                                wyn2.append((WierszeNr[i],4))
                                dane.append(stat)
                    elif pole == 'tryby_dostaw':
                        if wart.strip() =='':
                            stat = 'Niewypenione pole z trybami dostaw'
                            wyn2.append((WierszeNr[i],6))
                            dane.append(stat)
            
            # czy byly jakies bledy  
            if stat=='OK':
                if len(dane) > 0:
                    stat = dane[0]


 #------------------------------------------------------------------------------------------------------------   
 #---------------   INSERT
 #-------------------------------------------------------------------------------------------------------------       

    if stat=='OK':  
        sqlIns=''
        for i in xrange(len(Insert[0])):
            INSERT="INSERT INTO rs_dokumenty_magazynowe_dowody_dostaw "
            KOLUMNY="(firma_id"
            VALUES=" VALUES ('"+self.firma_id+"'"
            for j in xrange(len(Insert[0][i])):
                pole=Insert[1][j]
                wart=Insert[0][i][j]
                KOLUMNY+=","+pole
                if pole in [ 'zmiana', 'tryby_dostaw']:
                    VALUES+=",'"+wart+"'"  
                elif pole in ['osobne_dokumenty']:
                    if wart > 0:
                        VALUES+=",TRUE"
                    else:
                        VALUES+=",FALSE"
                else:
                    if wart=='':
                        VALUES+=",NULL"                 
                    else:
                       VALUES+=",'"+wart+"'"                 
            KOLUMNY+=")"
            VALUES+=");"
            sqlIns+=INSERT+KOLUMNY+VALUES
            
        if sqlIns<>'':
            rsglobal.ZapiszDoLogow(Insert, 5)
            rsglobal.ZapiszDoLogow(sql, 5)
            stat,dump,dump,dump=self.PolSQL.Execute(rsglobal.Dekoduj(sqlIns),1)
            if stat<>'OK':
                stat='BL INS'
                dane.append(stat)            

                
#-------------------------------------------------------------------------------
# POBIERANIE DANYCH
#-------------------------------------------------------------------------------

if Fun in [1,5,6] and stat=='OK':
    SQL="SELECT oddzial_id,COALESCE(magazyn_id,''), COALESCE(magazyn_zw_id,''),COALESCE(magazyn_rw_id,''),"
    SQL+=" zmiana,COALESCE(kontrahent_id,''),osobne_dokumenty,tryby_dostaw"
    SQL+=" FROM rs_dokumenty_magazynowe_dowody_dostaw"
    SQL+=" WHERE firma_id='"+self.firma_id+"'"
    SQL+=" ORDER BY oddzial_id,magazyn_id,zmiana,kontrahent_id;"	
    stat,dane,wyn1,wyn2=self.PolSQL.Execute(SQL,3)
    if stat <>'OK':
        stat = 'BL SQL DANE'
        dane.append(stat)
