# -*- coding: iso8859_2 -*-
#-----------------------------------------------------------------------------
# Name:        fs_dokumenty_magazynowe_import_nr_serii_poz.py
# Purpose:     Importuje numery serii z pliku tekstowego
# Author:      Marcin Grzda    
# Created:     2006/07/28
# RCS-ID:      $Id: fs_dokumenty_magazynowe_import_nr_serii_poz.py $
# Copyright:   (c) 2005-2008 Record System
# Licence:     GNU GPL
#-----------------------------------------------------------------------------

Magazyn = klucze[0]
Dokument= klucze[1]
Data = klucze[2]
Numer = klucze[3]
NrPoz=klucze[4]
Stan=klucze[6]

file_data = klucze[5]
stat='OK'
dane=[]
if not ((self.operator_id==STANDARD_OPERATOR_ID) or ((self.oddzial_id,'032022') in self.uprawnienia)):
    stat='UPR UPD'
    dane.append(stat)
    
if stat=='OK':
    
    slownik_artykulow={}
    for wiersz in file_data:
        if len(wiersz)==3:
            if wiersz[0]<>'..':
                Artykul=wiersz[0].rstrip('\n')
            if Artykul.strip()=='':
                rsglobal.ZapiszDoLogow('BL PLIK Artykul',5)
                stat='BL PLIK'
                dane.append(stat)
                break
            else:
                if Artykul in slownik_artykulow:
                    if wiersz[2] in slownik_artykulow[Artykul]:
                        stat="POWT NR SERII$ '"+Artykul+"'" 
                        dane.append(stat)
                        break
                    else:
                        slownik_artykulow[Artykul].append(wiersz[2].rstrip('\n'))
                else:
                    slownik_artykulow[Artykul]=[wiersz[2].rstrip('\n')]
        else:
            stat='BL PLIK'
            dane.append(stat)
            break
    
    if Stan=='G':
        CzyDodNrSerii='TRUE'
    else:
        CzyDodNrSerii='FALSE'

if stat=='OK':
    # pobieramy potencjalny magazyn i numer dokd z dokumentu, bo moe si okaza, e w artykuy
    # przyjcia jest inny klucz ni na pozycjach
    MagAP=Magazyn
    NrAP=str(Numer)
    SQL="SELECT magazyn_dokad,COALESCE(numer_dokad,0) FROM rs_dokumenty_magazynowe "
    SQL+=" WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+Magazyn+"' AND dokument_id='"+Dokument+"'"
    SQL+=" AND data='"+Data+"' AND numer="+str(Numer)+";"
    stat,DNagl,dump,dump=self.PolSQL.Execute(SQL,3)

if stat=='OK':
    if DNagl[0][1]>0:
        MagAP=rsglobal.Dekoduj(DNagl[0][0])
        NrAP=str(DNagl[0][1])
    
    for Artykul in slownik_artykulow:
        if Artykul.strip()<>'':
            d_poz=[]
            Select="SELECT nr_poz,nr_ppoz FROM rs_dokumenty_magazynowe_pozycje WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+Magazyn+"' AND dokument_id='"+Dokument+"' AND data='"+Data+"' AND numer="+str(Numer)+" AND artykul_id='"+Artykul+"' AND (nr_serii='' OR nr_serii='None' OR nr_serii is NULL) ORDER BY nr_poz,nr_ppoz"
            stat,d_poz,dump,dump=self.PolSQL.Execute(Select,3)
            if stat<>'OK':
                stat="BL SEL NR POZ"
                dane.append(stat)
                break            
            if len(d_poz)<>len(slownik_artykulow[Artykul]):
                stat="BL IL ART$ '"+Artykul+"'"
                dane.append(stat)
                break

            for i in xrange(len(d_poz)):
                NrPoz=d_poz[i][0]
                NrPpoz=d_poz[i][1]
                NrSerii=slownik_artykulow[Artykul][i]
                Update="UPDATE rs_dokumenty_magazynowe_pozycje SET nr_serii='"+NrSerii+"',czy_dodatkowy_nr_serii="+CzyDodNrSerii
                Update+=" WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+Magazyn+"' AND dokument_id='"+Dokument+"'"
                Update+=" AND data='"+Data+"' AND numer="+str(Numer)+" AND artykul_id='"+Artykul+"' AND nr_poz="+str(NrPoz)
                Update+=" AND nr_ppoz="+str(NrPpoz)+';'
                
                
                Update+="UPDATE rs_artykuly_przyjecia SET nr_serii='"+NrSerii+"'"
                Update+=" WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+MagAP+"' AND dokument_id='"+Dokument+"'"
                Update+=" AND data='"+Data+"' AND numer="+NrAP+" AND artykul_id='"+Artykul+"' AND nr_poz="+str(NrPoz)
                Update+=" AND nr_ppoz="+str(NrPpoz)+';'
                st,dump,dump,dump=self.PolSQL.Execute(Update,1)
                if stat<>'OK':
                    stat='BL UPD'
                    dane.append(stat)
                    break
            if stat<>'OK':
                break
                
        