# -*- coding: iso8859_2 -*-
#-----------------------------------------------------------------------------
# Name:        fs_dokumenty_magazynowe_import_poz.py
# Purpose:     Importuje pozycje dokumentu magazynowego z pliku TXT
# Author:      Dariusz Boduch 
# Created:     2009/10/29
# RCS-ID:      $Id: fs_dokumenty_magazynowe_import_poz.py $
# Copyright:   (c) 2006 Record System
# Licence:     GNU GPL
#-----------------------------------------------------------------------------

#przychodza parametry: KLUCZ,NIC,NIC 

#klucz glowny dok. magazynowego
mag_id = klucze[0][0]
dok_id= klucze[0][1]
dok_data = klucze[0][2]
numer = klucze[0][3]

#lista z tuplami ( lp,symbol_artykulu, ilosc1, cena1, nr_serii, termin_przyd )
file_data = klucze[1]

#Status i bledy
dane=[]
stat = "OK"

if((self.oddzial_id,'032023') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
    stat = "OK"
else:
    stat='UPR INS'
    dane.append(stat)

#Kontrola danych
FILTR="firma_id='"+str(self.firma_id)+"' AND magazyn_id='"+str(mag_id)+"' AND dokument_id='"+str(dok_id)+"' AND data='"+dok_data+"' AND numer="+str(numer)+" ;"

if stat == "OK":
    #poprawnosc klucza 
    SQL = "SELECT dokument_id FROM rs_dokumenty_magazynowe WHERE "+FILTR+" ;"
    stat,daned,dump,dump = self.PolSQL.Execute(SQL,3) 
    if stat<>'OK':
        stat='BL_SQL_KLUCZ$'+stat
        dane.append(stat)
    elif len(daned)==0:
        stat='BR_DOK'
        dane.append(stat)
if stat=='OK':
    #czy w dokumencie nie ma pozycji
    SQL=" SELECT * FROM rs_dokumenty_magazynowe_pozycje WHERE "+FILTR+"; "
    stat,danep,dump,dump = self.PolSQL.Execute(SQL,3) 
    if stat<>'OK':
        stat='BL_SQL_POZ$'+stat
        dane.append(stat)
    elif len(danep)>0:
        stat='POZ_ISTN'
        dane.append(stat)

if stat=='OK':
    TenSamNrP=[]
    wiersze=[]
    nryserii=[]
    NrWiersza=1
    #poprawnosc danych w wierszach do insertu
    INSERT=''
    for w in file_data:
        wiersz=str(w[0])[:-2]
        if wiersz<>str(NrWiersza):
            wyn1.append(wiersz)
        if wiersz in wiersze:
            TenSamNrP.append(wiersz)
        wiersze.append(wiersz)
        Art=w[1]
        NrSerii=w[4]
        ArtSer=(Art,NrSerii)
        if NrSerii.strip()<>'':
            if ArtSer in nryserii:
                stat='POWT NR SERII$'+Art
                dane.append(stat)
            nryserii.append(ArtSer)
            
            
        #NR POZYCJI
        if w[0] =='' or int(w[0])==0:
            stat='BL_NRP$'+wiersz
            dane.append(stat)
        #ILOSC 1
        Il1=w[2]
        if w[2]=='' or w[2]==0:
            stat='BL_IL$'+wiersz
            dane.append(stat)
        #CENA1
        Cena1=w[3]
        
        #NR SERII
        NrSerii=w[4]
        
        #TERMIN PRZYDATNOSCI
        TerminPrzyd=w[5]
        if TerminPrzyd.strip() not in('','-  -'):
            if not rsglobal.SprawdzCzyToData(w[5]):
                stat='BL_TERM$'+wiersz
                dane.append(stat)
            TerminPrzyd="\'"+TerminPrzyd+"\'"
        else:
            TerminPrzyd="NULL"
            
    
        #POBRANIE PRZELICZNIKA, SPRAWDZENIE INDEKSU ARTYKULU
        SELECT="SELECT przelicznik FROM rs_artykuly WHERE firma_id='"+self.firma_id+"' AND artykul_id='"+str(w[1])+"'; "
        stat,dp,dump,dump= self.PolSQL.Execute(SELECT,3)  
        if stat<>'OK':
            stat='BL_SQL_PRZ$'+stat
            dane.append(stat)
        if len(dp)==0:
            stat='BL_ART$'+wiersz
            dane.append(stat)     

        Przelicznik=dp[0][0]
        if Przelicznik==0:
            stat='BL_PRZEL$'+Art
            dane.append(stat)
        
        if stat=='OK':
            Insert="INSERT INTO rs_dokumenty_magazynowe_pozycje "\
                    "(firma_id,magazyn_id,dokument_id,data,numer, "\
                    "nr_poz,nr_ppoz,artykul_id,ilosc1,ilosc2,"\
                    "cena1,cena2,"\
                    "cena_wal1,cena_wal2, "\
                    "nr_serii,termin_przyd) "\
                    "VALUES('"+str(self.firma_id)+"','"+str(mag_id)+"','"+str(dok_id)+"','"+str(dok_data)+"',"+str(numer)+", "\
                    ""+str(NrWiersza)+",0,'"+str(Art)+"',"+str(round(Il1,4))+","+str(round((Il1*Przelicznik),4))+", "\
                    ""+str(round(Cena1,2))+","+str(round((Cena1/Przelicznik),2))+", "\
                    ""+str(round(Cena1,2))+","+str(round((Cena1/Przelicznik),2))+", "\
                    "'"+NrSerii+"',"+str(TerminPrzyd)+"); "
            INSERT+=Insert
            NrWiersza+=1                
    
    if TenSamNrP<>[]:
        stat='BL_NRPD$'+str(TenSamNrP).replace('[','').replace(']','')
        dane.append(stat)    
    
    if stat=='OK' and dane==[]:
         stat,dump,dump,dump= self.PolSQL.Execute(INSERT,1) 
         if stat<>'OK':
            stat='BL_INS$'+stat
            dane.append(stat)
