# -*- coding: iso8859_2 -*-
#-----------------------------------------------------------------------------
# Name:        fs_dokumenty_magazynowe_import_z_pliku.py
# Purpose:     Importuje cay dokument magazynowy z pliku.
# Author:      Micha Raburski    
# Created:     2007/01/06
# RCS-ID:      $Id: fs_dokumenty_magazynowe_import_z_pliku.py $
# Copyright:   (c) 2007 Record System
# Licence:     GNU GPL
#-----------------------------------------------------------------------------

#przychodza parametry: KLUCZ,NIC,NIC 
#gdzie KLUCZ jest ca zawartoci wybranego pliku

#F= eval(str(klucze))
F= klucze
file_data=[]
naglowek=''
test=''
i=0
ile=-1
maxi=len(F)
for f in F:
    if i==0:
        test=f[0:19]
        ile=-1*(len(f)-19)
    elif i==1:
        naglowek=rsglobal.rseval("["+f[0:ile]+"]")
    elif f[0:16] <> 'koniec dokumentu':
        file_data.append(rsglobal.rseval("["+f[0:ile]+"]"))
    else:
        break
    i=i+1
   
#Status i bledy
stat = "OK"
lista_bledow = []

if not (((self.oddzial_id,'032013') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)):
    stat='UPR INS'
    lista_bledow.append( stat )

if stat=='OK':
    if not (((self.oddzial_id,'032023') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)):
        stat='UPR INSP'
        lista_bledow.append( stat )

if stat=='OK':
    if test <> 'dokument magazynowy':
        stat = "BL_ZFOR"
        lista_bledow.append( stat )

if stat=='OK':
    Oddzial=naglowek[0]
    Mag1=Oddzial+naglowek[1]
    Mag2=naglowek[1]
    DokId=rsglobal.DekodujRS(naglowek[2])
    Data=naglowek[4]
    Kontr=rsglobal.DekodujRS(naglowek[5])
    NrZlec=rsglobal.DekodujRS(naglowek[6])
    KontoK=rsglobal.DekodujRS(naglowek[7])
    Fakt= rsglobal.DekodujRS(naglowek[8])
    
    stat,wyn,dump,dump = self.PolSQL.Execute("SELECT oddzial_id FROM rs_oddzialy WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+Oddzial+"';",3)
if stat=='OK':
    if len(wyn)==0:
        stat='BL ODD'
        lista_bledow.append( stat )

if stat=='OK':
    stat, DDokT, dump, dump = self.PolSQL.Execute("SELECT typ_dokumentu FROM rs_typy_dokumentow_m WHERE firma_id='"+self.firma_id+"' AND dokument_id='"+DokId+"'", 3 )
    
if stat=='OK':
    if len(DDokT)==0:
        stat = "BL DOKID"
        lista_bledow.append( stat )
    else:
        TypD=rsglobal.Dekoduj(DDokT[0][0])
    
if stat=='OK':
    stat,wyn,dump,dump = self.PolSQL.Execute("SELECT magazyn_id FROM rs_magazyny WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+Mag1+"';", 3)

if stat =='OK':
    if len(wyn)==0:
        stat,wyn,dump,dump = self.PolSQL.Execute("SELECT magazyn_id FROM rs_magazyny WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+Mag2+"';", 3)
        if stat=='OK':
            if len(wyn)==0:
                stat='BL MAG'
                lista_bledow.append( stat )
            else:
                Mag=Mag2
    else:
        Mag=Mag1
        
    
    if Kontr <> '':
        ok,wyn,dump,dump = self.PolSQL.Execute("SELECT kontrahent_id FROM rs_kontrahenci WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+Kontr+"';", 3)
        if ok=='OK':
            if len(wyn)==0:
                stat='BL KONTR'
                lista_bledow.append( stat )
    
    if NrZlec <> '':
        ok,wyn,dump,dump = self.PolSQL.Execute("SELECT kod FROM rs_numery_zlecen WHERE firma_id='"+self.firma_id+"' AND kod='"+NrZlec+"';", 3)
        if ok=='OK':
            if len(wyn)==0:
                stat='BL NRZLEC'
                lista_bledow.append( stat )
                
    if KontoK <> '':
        ok,wyn,dump,dump = self.PolSQL.Execute("SELECT kod FROM rs_konta_kosztow WHERE firma_id='"+self.firma_id+"' AND kod='"+KontoK+"';", 3)
        if ok=='OK':
            if len(wyn)==0:
                stat='BL KK'
                lista_bledow.append( stat )

if stat=='OK':
    #Pobranie numeru zwykego
    ok,wyn,dump,dump = self.PolSQL.Execute("SELECT rsf_podaj_numer_mm('"+self.firma_id+"','"+Mag+"','"+DokId+"','"+Data+"')",3)
    if ok=='OK':
        Numer=wyn[0][0]
    
    #pobranie magazynw i numeru dokad
    MagP='NULL'
    MagW='NULL'
    NumerD='NULL'
    if TypD == 'W':
        MagP ='NULL'
        MagW = "'"+Mag+"'"
    elif TypD == 'P':
        MagP = "'"+Mag+"'"
        MagW = 'NULL'
    elif TypD == 'M':
        if Kontr=='':
            stat='BR KON M'
            lista_bledow.append( stat )

        if stat=='OK':
            MagD=Oddzial+Kontr[1:3]
            stat,wyn,dump,dump = self.PolSQL.Execute("SELECT magazyn_id FROM rs_magazyny WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+MagD+"';", 3)

        if stat =='OK':
            if len(wyn)==0:
                MagD=Kontr[1:3]
                stat,wyn,dump,dump = self.PolSQL.Execute("SELECT magazyn_id FROM rs_magazyny WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+MagD+"';", 3)
                if stat=='OK':
                    if len(wyn)==0:
                        stat='BL MAG'
                        lista_bledow.append( stat )

        if stat =='OK':
            MagP = "'"+MagD+"'"
            MagW = "'"+Mag+"'"
            ok,wyn,dump,dump = self.PolSQL.Execute("SELECT rsf_podaj_numer_mm('"+self.firma_id+"','"+MagD+"','"+DokId+"','"+Data+"')",3)
            if ok=='OK':
                NumerD=wyn[0][0]

    if MagP <> 'NULL':
        ok,wyn,dump,dump = self.PolSQL.Execute("SELECT magazyn_id FROM rs_magazyny WHERE firma_id='"+self.firma_id+"' AND magazyn_id="+MagP+";", 3)
        if ok=='OK':
            if len(wyn)==0:
                stat='BL MAGP'
                lista_bledow.append( stat )

    if MagW <> 'NULL':
        ok,wyn,dump,dump = self.PolSQL.Execute("SELECT magazyn_id FROM rs_magazyny WHERE firma_id='"+self.firma_id+"' AND magazyn_id="+MagW+";", 3)
        if ok=='OK':
            if len(wyn)==0:
                stat='BL MAGW'
                lista_bledow.append( stat )
        
    if Kontr=='':
        Kontr='NULL'
    else:
        Kontr="'"+Kontr+"'"

    if NrZlec=='':
        NrZlec='NULL'        
    else:
        NrZlec="'"+NrZlec+"'"

    if KontoK=='':
        KontoK='NULL'
    else:
        KontoK="'"+KontoK+"'"

    SQLN="INSERT INTO rs_dokumenty_magazynowe (firma_id,magazyn_id,dokument_id,data,numer,stan,magazyn_skad,magazyn_dokad,numer_dokad,"
    SQLN+="kontrahent_id,nr_faktury,nr_zlecenia,konto_kosztow,waluta) VALUES "
    SQLN+="('"+self.firma_id+"','"+Mag+"','"+DokId+"','"+Data+"',"+str(Numer)+",'W',"+MagW+","+MagP+","+str(NumerD)+","
    SQLN+=Kontr+",'"+Fakt+"',"+NrZlec+","+KontoK+",'PLN');"
    
    #sprawdzenie czy wszystkie artykuly sa na liscie (i uzupelnienie danych)
if stat=='OK':    
    LPoz=[]
    lp=1
    for poz in file_data:
        stat, data, dump, dump = self.PolSQL.Execute("SELECT przelicznik FROM rs_artykuly  WHERE firma_id='"+self.firma_id+"' AND artykul_id='"+poz[1]+"';", 3 )    
        if stat != "OK":
            stat="BL_SQL"
            lista_bledow.append( stat )
        else:
            #Nazwa artykulu pusta wiec symbol nie wystepuje w bazie.
            if len( data ) == 0: 
                stat = "BL_NSYM$%s" % poz[1]
                lista_bledow.append( stat ) 
            else:
                #jest ok - dodajemy pozycje do Listy
                Przel=data[0][0]
                Termin=poz[5]
                if Termin=='    -  -  ':
                    Termin= 'NULL'
                else:
                    Termin="'"+Termin+"'"
                    
                LPoz.append([str(lp),poz[1],str(poz[2]),str(round(poz[2]*Przel,4)),str(poz[3]),str(round(poz[3]/Przel,2)),poz[4],Termin,str(poz[3]),str(round(poz[3]/Przel,2))])
                lp=lp+1
                
#Jesli kontrola przeszla pomyslne to dodajemy pozycje do dokumentu oraz naglowek.
if len( lista_bledow ) == 0:
    #Skadamy superselecta w oparciu o naglowek
    SQL=SQLN
    for poz in LPoz:
        sql = "INSERT INTO rs_dokumenty_magazynowe_pozycje" \
                "(firma_id,magazyn_id,dokument_id,data,numer,nr_poz,nr_ppoz," \
                "artykul_id,ilosc1,ilosc2,cena1,cena2,nr_serii,termin_przyd,cena_wal1,cena_wal2)" \
                " VALUES ('"+self.firma_id+"','"+Mag+"','"+DokId+"','"+Data+"',"+str(Numer)+","+poz[0]+",0,'"+ \
                  poz[1]+"',"+poz[2]+","+poz[3]+","+poz[4]+","+poz[5]+",'"+poz[6]+"',"+poz[7]+","+poz[8]+","+poz[9]+");"
        
        SQL+=sql
        
    stat,wyn,dump,dump = self.PolSQL.Execute(SQL,1)

    if stat != "OK":
        stat = "BL_SQL"
        lista_bledow.append( stat )
            
#zwroc liste bledow jako dane
dane = lista_bledow
