#!/usr/bin/python
# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_dokumenty_magazynowe_palety.py
# Author:      Marcin Natkaski
# Created:     2015/03/15
# RCS-ID:      $Id: fs_dokumenty_magazynowe_palety.py$
# Copyright:   (c) 2015 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------
# 2019-01-31 Aleksander Bargie (11362) Doda wag palety do wydruku etykiety logistycznej. (tylko zapis do bazy)

stat='OK'
if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=='OK':
    Funkcja = klucze['Funkcja']
                    #AB 31.01.19r
    SlPar={'Artykul':[1,11, 20],'Paleta':[1,10,15], 'Opakowanie':[1],'Ilosc':[1],'NumerSerii':[1],'TerminWaznosci':[1],'IloscPalet':[1],
                                                                    #AB 31.01.19r
            'IloscOpakowan':[1],'IloscWOpakowaniu':[1],'Kontrahent':[1], 'Waga': [1]}
    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Funkcja,klucze)
    if Lista<>'':
        stat='Uwaga : wywoanie funkcji fs_dokumenty_magazynowe_palety z numerem '+str(Funkcja)+' bez parametrw: '+Lista

if stat=='OK':
    if Funkcja in [1,]:
        Kontrahent = klucze['Kontrahent']
        Opakowanie = klucze['Opakowanie']
        Ilosc = klucze['Ilosc'] 
        NumerSerii = klucze['NumerSerii']
        TerminWaznosci = klucze['TerminWaznosci']
        IloscPalet = klucze['IloscPalet']
        IloscOpakowan = klucze['IloscOpakowan']
        IloscWOpakowaniu = klucze['IloscWOpakowaniu']
        #AB 31.01.19r
        Waga = klucze['Waga']
        if Ilosc > IloscOpakowan:
            Ilosc = Ilosc - Ilosc%IloscOpakowan

    if Funkcja in [1,10,15]:
        Paleta=klucze['Paleta']

                 #AB 31.01.19r
    if Funkcja in [1, 11, 20]:
        Artykul = klucze['Artykul']
    

    
dane=[]
wyn1=[]
wyn2=[]
dane_do_wydruku = []

UprIns=((self.oddzial_id,'032040') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID

def ObliczSumeKontrolna(numer):
    suma = 69 + int(numer[0])*3 + int(numer[1]) + int(numer[2])*3 +int(numer[3])
    suma=suma+int(numer[4])*3 + int(numer[5]) + int(numer[6])*3 + int(numer[7]) + int(numer[8])*3
    if suma%10==0:
        suma_kontrolna = 0
    else:
        suma_kontrolna = int(suma/10*10+10)-int(suma)
    return str(suma_kontrolna)

#-------------------------------------------------------------------------------
#---   Sprawdzam dane
#-------------------------------------------------------------------------------

if Funkcja in [1,] and not UprIns:
    stat='INS UPR'
    dane.append(stat)

#-------------------------------------------------------------------------------
#--- Pobieranie i wstawianie terminu waznosci (11)
#-------------------------------------------------------------------------------

if Funkcja == 11 and stat=='OK':
    SQL= "SELECT CASE WHEN dni_przydatnosci<> 0 THEN now()::DATE + dni_przydatnosci::INTEGER END"
    SQL+=" FROM rs_artykuly WHERE firma_id='"+self.firma_id+"' AND artykul_id='"+Artykul+"'"
    stat,dane,dump,dump = self.PolSQL.Execute(SQL,3)
    if stat <> 'OK':
        stat = 'Bd pobierania daty wanoci : '+stat
        dane.append(stat)
    
#-------------------------------------------------------------------------------
#----   Pobranie nazwy palety (10)
#-------------------------------------------------------------------------------

if Funkcja == 10 and stat=='OK':
    SQL="SELECT opis from rs_palety WHERE firma_id='"+self.firma_id+"' AND paleta_id='"+Paleta+"' "
    stat,dane,dump,dump = self.PolSQL.Execute(SQL,3)
    if stat <> 'OK':
        stat = 'Bd pobierania nazwy palety ; '+stat
        dane.append(stat)

#AB 31.01.19r
#-------------------------------------------------------------------------------
#----   Pobranie wagi artykuu (20)
#-------------------------------------------------------------------------------

if Funkcja == 20 and stat=='OK':
    SQL = "SELECT waga FROM rs_artykuly WHERE firma_id='{}' AND artykul_id='{}';".format(self.firma_id, Artykul)
    stat, dane, dump, dump = self.PolSQL.Execute(SQL, 3)
    if stat != 'OK':
        stat = 'Bd pobierania wagi artykuu; '+stat
        dane.append(stat)
        
#-------------------------------------------------------------------------------
#--- Sprawdzamy zestaw kontrahent - paleta - opakowanie
#-------------------------------------------------------------------------------

if Funkcja == 1 and stat=='OK' and Kontrahent.strip()<>'':
    SPR = " SELECT * FROM rs_artykuly_opakowania_zbiorcze WHERE firma_id='"+self.firma_id+"' AND"
    SPR+= " kontrahent_id='"+Kontrahent+"' AND opakowanie_id='"+Opakowanie+"' AND paleta_id='"+Paleta+"'"
    stat,kontrahent_paleta,dump,dump = self.PolSQL.Execute(SPR,3)
    if stat<>'OK':
        stat='Bdy sprawdzaniu zestawu: kontrahent - opakowanie - palety :'+stat
        dane.append(stat)
    elif len(kontrahent_paleta)==0:
        stat='Brak zestawu: kontrahent - opakowanie - paleta'
        dane.append(stat)
        
#-------------------------------------------------------------------------------
#---   Insert numeru palety wraz z danymi (1)
#-------------------------------------------------------------------------------

if Funkcja == 1 and stat=='OK':
    #pobieramy przelicznik odwrotny
    SQL = "SELECT przelicznik FROM rs_artykuly WHERE firma_id='"+self.firma_id+"' AND artykul_id='"+Artykul+"'"
    stat,DPrzel,dump,dump = self.PolSQL.Execute(SQL,3)
    if stat<>'OK':
        stat='Bdy pobierania przelicznika artykulu :'+stat
        dane.append(stat)
    else:
        Przel = DPrzel[0][0]
        
    if stat=='OK':    
        Dzielnik = IloscPalet
        numer_palety = []
        while IloscPalet > 0:
            pal = ''
            NUMER = "select nextval('rs_palety_numery_id_seq');"
            stat,DNumPalety,dump,dump = self.PolSQL.Execute(NUMER,3)
            if stat<>'OK':
                stat='Bdy przy pobieraniu danych z sekwencji :'+stat
                dane.append(stat)
            else:
                pal = str(DNumPalety[0][0]).zfill(9)
            if stat == 'OK':
                INSERT = " INSERT INTO rs_palety_numery (firma_id,nr_palety_id,artykul_id,ilosc1,ilosc2,opakowanie_id,paleta_id,wsp_ilosci_opakowanie,"
                                                                                                            #AB 31.01.19r
                INSERT+= " termin_przyd,wsp_ilosci_paleta,wsp_ilosci_lokacja,ilosc_lokacja,kontrahent_id,nr_serii, waga_palety) "
                INSERT+= " VALUES ('"+self.firma_id+"','0005901486"+pal+ObliczSumeKontrolna(pal)+"'  ,'"+Artykul+"',"+str((Ilosc*IloscWOpakowaniu)/Dzielnik)+","+str(((Ilosc*IloscWOpakowaniu)*Przel)/Dzielnik)+","
                INSERT+= " '"+Opakowanie+"','"+Paleta+"',"+str(IloscWOpakowaniu)
                if TerminWaznosci == '    -  -  ':
                    INSERT+= ",NULL"
                else:
                    INSERT+= " ,'"+TerminWaznosci+"' "
                INSERT+=" ,"+str(IloscOpakowan)+",1,1"
                if Kontrahent=='':
                    INSERT+=",Null" 
                else:
                    INSERT+=",'"+Kontrahent+"' "
                if NumerSerii=='':
                    INSERT+=",Null"
                else:
                    INSERT+=",'"+NumerSerii+"' "
                #AB 31.01.19r
                INSERT += ", "+str(Waga)
                INSERT+=" )"
                stat,dump,dump,dump = self.PolSQL.Execute(INSERT,1)
                if stat<>'OK':
                    stat='Bdy przy dodawaniu numeru palety :'+stat
                    dane.append(stat)
                    break
                
                else:
                    IloscPalet = IloscPalet - 1
                    numer_palety.append(pal)
        dane_do_wydruku.append(numer_palety)
        

#-------------------------------------------------------------------------------
#---   Pobranie danych palety do wydruku duplikatu (15)
#-------------------------------------------------------------------------------

if Funkcja == 15 and stat=='OK':
    SQL = "SELECT pn.artykul_id, pn.paleta_id, pn.opakowanie_id, pn.ilosc1, pn.nr_serii,pn.termin_przyd,"
                                                                                            #AB 31.01.19r
    SQL +=" COALESCE(pn.kontrahent_id,''),a.nazwa, wsp_ilosci_opakowanie, wsp_ilosci_paleta, pn.waga_palety"
    SQL+= " FROM rs_palety_numery pn INNER JOIN rs_artykuly a USING (firma_id, artykul_id)"
    SQL+= " WHERE pn.firma_id='"+self.firma_id+"' AND pn.nr_palety_id='"+Paleta+"'"        
    stat,DPalety,dump,dump = self.PolSQL.Execute(SQL,3)
    if stat<>'OK':
        stat='Bdy przy pobieraniu danych palety :'+stat
    elif len(DPalety) == 0:
        stat='Brak palety o podanym numerze '+Paleta.strip()
    
    if stat == 'OK':
        wyn1 = DPalety
        Artykul = DPalety[0][0]
        Kontrahent = DPalety[0][6]
        dane_do_wydruku = [[str(Paleta[10:19]).zfill(9)]]
        
#-------------------------------------------------------------------------------
#---  POBIERANIE DANYCH NA WYDRUK
#-------------------------------------------------------------------------------
if Funkcja in [1,15] and stat=='OK':
    #zbieramy dane firmy do nagwka
    SQL =" SELECT nazwa,adr_kod,adr_miej,adr_ulica,adr_nry,tel1,email FROM rs_oddzialy"
    SQL+=" WHERE firma_id='"+self.firma_id+"' and oddzial_id='01'"
    stat,dane_firmy,dump,dump = self.PolSQL.Execute(SQL,3)
    if stat<>'OK':
        stat='Bdy przy pobieraniu danych firmy :'+stat
        dane.append(stat)
    else:
        dane_do_wydruku.append(dane_firmy)
        
    #pobieramy obc nazw artykuu jeli jest
    if stat=='OK':
        if Kontrahent<>'':
            SQL =" SELECT obca_nazwa FROM rs_artykuly_obce WHERE firma_id='"+self.firma_id+"' "
            SQL+=" AND kontrahent_id='"+Kontrahent+"' AND artykul_id='"+Artykul+"' "
            stat,dane_artykulu,dump,dump = self.PolSQL.Execute(SQL,3)
            if stat<>'OK':
                stat='Bdy przy pobieraniu obcych danych artykulu :'+stat
                dane.append(stat)
            elif len(dane_artykulu)>0:
                dane_do_wydruku.append(dane_artykulu)
            else:
                dane_do_wydruku.append([['BRAK OBCYCH DANYCH']])
        else:
               dane_do_wydruku.append([['BRAK OBCYCH DANYCH']])
    #pobieramy KOD EAN artykulu
    if stat =='OK':
        SQL= " SELECT ean,glowny FROM rs_artykuly_ean WHERE firma_id='"+self.firma_id+"' AND artykul_id='"+Artykul+"';"
        stat,ean,dump,dump = self.PolSQL.Execute(SQL,3)
        if stat<>'OK':
            stat='Bdy przy pobieraniu kodu ean artykulu :'+stat
            dane.append(stat)
        elif len(ean)==1:
            dane_do_wydruku.append(ean)
        elif len(ean)>1:
            l=0
            for i in ean:
                if i[1]==True:
                    dane_do_wydruku.append([i])
                    l=1
            if l==0:
                stat='Artyku posiada kilka kodw EAN, z ktrych aden nie jest gwnym'
                dane.append(stat)
        else:
            stat='Dla artykuu nie zosta zdefiniowany EAN'
            dane.append(stat)
            
    if stat=='OK':
        dane.append(dane_do_wydruku)