# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_dokumenty_magazynowe_zmiany.py
# Purpose:     obsuga listy zmian w dokumencie magazynowym
# Author:      Micha Raburski
# Created:     2014/01/05
# RCS-ID:      $Id: fs_dokumenty_magazynowe_zmiany.py $
# Copyright:   (c) 2014 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

dane = []
wyn1 = []
wyn2 = []
stat = 'OK'

if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=='OK':
    Fun = klucze['Funkcja']
    
    SlPar={'Magazyn':[5],'Dokument':[5],'Data':[5],'Numer':[5],'ArtykulF':[5]}    
    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Fun,klucze)
    if Lista<>'':
        stat='Uwaga : wywoanie funkcji fs_dokumenty_magazynowe_zmiany z numerem '+str(Fun)+' bez parametrw: '+Lista

if stat=='OK':
    if Fun == 5:
        Magazyn=rsglobal.Dekoduj(klucze['Magazyn'])
        Dokument=rsglobal.Dekoduj(klucze['Dokument'])
        Data=rsglobal.Dekoduj(klucze['Data'])
        Numer=str(klucze['Numer'])
        FArtykul=rsglobal.Dekoduj(klucze['ArtykulF'])
                
#-------------------------------------------------------------------------------
#---- SELECT - 5 Pobieranie listy zmian dokumentu magazynowego
#-------------------------------------------------------------------------------

if Fun in (5,6)  and stat == 'OK':    
    SQL =" SELECT pz.magazyn_id,pz.dokument_id,pz.data,pz.numer,pz.nr_poz,pz.nr_ppoz,pz.artykul_id,a.nazwa,"
    SQL+=" pz.cena_n1,pz.cena_n2,pz.cena_s1,pz.cena_s2, pz.wartosc_n,pz.wartosc_s,"
    SQL+=" pz.opis,pz.zmieniajacy_id,o.login,pz.czas_zmiany::TEXT"
    SQL+=" FROM rs_dokumenty_magazynowe_pozycje_zmiany pz "
    SQL+=" INNER JOIN rs_artykuly a USING (firma_id,artykul_id) "  
    SQL+=" INNER JOIN rs_operatorzy o ON (zmieniajacy_id=o.operator_id) "  
    SQL+=" WHERE  pz.firma_id = '"+self.firma_id+"' AND pz.magazyn_id='"+Magazyn+"'"
    SQL+=" AND pz.dokument_id = '"+Dokument+"' AND pz.data='"+Data+"' AND pz.numer = "+Numer
    if FArtykul <> '' :    
        SQL+=" AND pz.artykul_id LIKE '"+FArtykul+"%'"
    SQL+=" ORDER BY pz.nr_poz,pz.nr_ppoz"
    stat,dane,wyn1,dump =self.PolSQL.Execute(SQL, 3)
    if stat <> 'OK':
        stat='Bd pobrania listy zmian dokumentu : '+stat