# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_dowody_dostaw_pom.py
# Purpose:     funkcje pomocnicze dla dowodow dostaw
# Author:      Mariusz Rajfura
# Created:     2012/09/20
# RCS-ID:      $Id: fs_dowody_dostaw_pom.py $
# Copyright:   (c) 2012 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

def PodajListeTrasZInnychOddzialow(PolSQL,Firma,Oddzial,Tryb,Rzut,DataOd,DataDo):
    import rsglobal
    # lista tras z innych oddzialow, ktore maja wpisane zastepstwo
    # przez podany oddzial w rs_boksy_trasy_dni
    
    stat = 'OK'
    Lista = ''
    ListaTrybow = ''
    
    if Rzut <> '':
        sql = "SELECT kod FROM rs_tryby_dostaw WHERE firma_id='"+Firma+"' AND rzut='"+Rzut+"';"
        stat,d,dump,dump = PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Bd pobrania listy trybw nalecych do podanego rzutu: '+stat
            return stat,Lista
        elif len(d) > 0:
            for i in xrange(len(d)):
                if i > 0:
                    ListaTrybow += ","
                ListaTrybow += "'"+rsglobal.Dekoduj(d[i][0])+"'"

    if Tryb <> '':
        if ListaTrybow <> '':
            ListaTrybow += ",'"
        ListaTrybow += "'"+Tryb+"'"

    sql ="SELECT DISTINCT oddzial_id,trasa,data,tryb_dostawy FROM rs_dowody_dostaw"
    sql+=" WHERE firma_id='"+Firma+"'"
    if not DataOd in ('','    -  -  '):
        sql+=" AND data>='"+DataOd+"'"
    if not DataDo in ('','    -  -  '):
        sql+=" AND data<='"+DataDo+"'"
        
    sql+=" AND oddzial_id<>'"+Oddzial+"'"
    sql+=" AND (trasa,data,tryb_dostawy) IN ("
    sql+="  SELECT DISTINCT trasa,data,tryb_dostawy FROM rs_boksy_trasy_dni"
    sql+="  WHERE firma_id='"+Firma+"'"
    if not DataOd in ('','    -  -  '):
        sql+=" AND data>='"+DataOd+"'"
    if not DataDo in ('','    -  -  '):
        sql+=" AND data<='"+DataDo+"'"
    sql+="  AND oddzial_id='"+Oddzial+"'"
    
    if ListaTrybow <> '':
        sql+=" AND tryb_dostawy IN ("+ListaTrybow+" )"
    sql += "  );"
    
    stat,d,dump,dump = PolSQL.Execute(sql,3)
    if stat <> 'OK':
        stat = 'Bd pobrania listy tras z dowodw dostaw dla innych oddziaw: '+stat
        return stat,Lista
    elif len(d) > 0:
        Lista = "("
        for i in xrange(len(d)):
            if i > 0:
                Lista += ","
            Lista += "('"+rsglobal.Dekoduj(d[i][0])+"','"+rsglobal.Dekoduj(d[i][1])+"','"+\
                     rsglobal.Dekoduj(d[i][2])+"','"+rsglobal.Dekoduj(d[i][3])+"')"
        Lista += ")"
    else:
        Lista = "(('','',NULL,''))"
    
    return stat,Lista
    
#-------------------------------------------------------------------------------
    
def PodajTrasyDlaOddzialuZKoncowkiTras(PolSQL,Firma,Oddzial,Koncowka):
    import rsglobal
    LTras = []
    stat='OK'
    SQL = "SELECT kod FROM rs_trasy WHERE firma_id='"+Firma+"' AND oddzial_id='"+Oddzial+"'"
    SQL+= " AND kod LIKE '__"+Koncowka+"';"
    stat,DTras,dump,dump = PolSQL.Execute(SQL,3)
    if stat <> 'OK':
        stat = 'Bd pobrania listy tras dla podanej kocwki'
        return stat,LTras

    for trasa in DTras:
        LTras.append(rsglobal.Dekoduj(trasa[0]))
    
    return stat,LTras