# -*- coding: iso-8859-2  -*-
import suds   
#https://bramka.e-deklaracje.mf.gov.pl/uslugi/dokumenty?wsdl
def WyslijDeklaracjeTestowaNiepodpisana(tresc_deklaracji):
    '''
    Teść deklaracji to zakodowany w base64 plik xml, wczytany jako dane binarne
    czyli z parametrem 'rb'
    '''
    
    adres_bramki = 'https://test-bramka.edeklaracje.gov.pl/uslugi/dokumenty?wsdl'
    client = suds.client.Client(adres_bramki)
    
    wyslij = client.service.sendUnsignDocument
    #wysyla deklaracje niepodpisana podpisem elektronicznym
    
    r = wyslij(tresc_deklaracji)    
    return r[0] #Zwraca ID zgłoszenia

def WyslijDeklaracjeTestowaPodpisana(tesc_deklaracji):
    pass
    
def OdbierzTestowePotwierdzenie(identyfikator):
    adres_bramki = 'https://test-bramka.edeklaracje.gov.pl/uslugi/dokumenty?wsdl'
    client = suds.client.Client(adres_bramki)
    odbierz = client.service.requestUPO
    
    return odbierz(identyfikator)
	#Zwraca potwierdzenie. Element [0] jest kodem bledu. Jesli 200 to znaczy,
	#ze wszystko ok
