# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_firmy_dane.py
# Purpose:      
# Author:      Mariusz Rajfura
# Created:     2009/04/15
# RCS-ID:      $Id: fs_firmy_dane.py $
# Copyright:   (c) 2009 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

# 2011-11-10 Mariusz Rajfura  zmiana typu dla dok.mag.przeceny 'PR' : M->R (5194)
# 2014-08-21 Marcin Natkaski - dodanie insertw dla tabeli rs_kp_typy_stalych
# 2018-06-06 Aleksander Bargie - (11082) MPP od dnia w danych do fakurowania
# 2018-08-14 Aleksander Bargie - (11177) Wycofa zbdne informacje o MPP
# 2020-01-14 Wojciech Skowron   - (11814) Dla pierwszego oddziau centrala=True

# AB 14.08.18r
#import rsglobal

Symbol = klucze[0].strip()

Fun = klucze[-1]

stat = 'OK'
dane = []
wyn2 = []

if self.operator_id <> STANDARD_OPERATOR_ID:
    stat = 'BR_UPR'
    dane.append(stat)


# sprawdzenie danych

if stat=='OK':
    if len(Symbol) <> 2:
        stat='BL_SYMB_DLG'
        dane.append(stat)
    else:
        sql="SELECT * FROM rs_firmy WHERE firma_id = '"+Symbol+"';"
        stat,d,dump,dump = self.PolSQL.Execute(sql,3)
        if stat=='OK':
            if (Fun in [3,4,7] and len(d)==0):
                stat='BL_SYMB_BRAK'
                dane.append(stat)
            elif (Fun in [1,2] and len(d) > 0):
                stat='BL_SYMB_UZYW'
                dane.append(stat)


#-------------------------------------------------------------------------------
#---   DODANIE DANYCH (1 -insert, 2 -insert z pobraniem)
#-------------------------------------------------------------------------------

if  stat=='OK' and Fun in (1,2):
        
    sql="INSERT INTO rs_firmy (firma_id,opis) VALUES ('"+Symbol+"','');"
    sql+="INSERT INTO rs_grupy (firma_id,grupa_id,opis) VALUES ('"+Symbol+"','**','Wszystkie grupy');"
    sql+="INSERT INTO rs_oddzialy (firma_id,oddzial_id,opis) VALUES ('"+Symbol+"','**','Wszystkie oddziay');"
    #WS 2020-01-14
    sql += "INSERT INTO rs_oddzialy (firma_id,oddzial_id,opis,centrala) VALUES ('" + Symbol + "','01','Centrala',True);"
    # sql+="INSERT INTO rs_oddzialy (firma_id,oddzial_id,opis) VALUES ('"+Symbol+"','01','Centrala');"
    
    sql+="INSERT INTO rs_typy_dokumentow_m (firma_id,dokument_id,typ_dokumentu,nazwa_dokumentu,"
    sql+="czy_kontrahent,czy_zlecenie,czy_konto_kosztow,czy_faktura,czy_poddokumenty) "
    sql+="VALUES ('"+Symbol+"','PZ','P','Przyjcie zewntrzne',"
    sql+="TRUE,FALSE,FALSE,TRUE,FALSE);"
    
    sql+="INSERT INTO rs_typy_dokumentow_m (firma_id,dokument_id,typ_dokumentu,nazwa_dokumentu,"
    sql+="czy_kontrahent,czy_zlecenie,czy_konto_kosztow,czy_faktura,czy_poddokumenty) "
    sql+="VALUES ('"+Symbol+"','WZ','W','Wydanie zewntrzne',"
    sql+="TRUE,FALSE,FALSE,TRUE,FALSE);"
    
    sql+="INSERT INTO rs_typy_dokumentow_m (firma_id,dokument_id,typ_dokumentu,nazwa_dokumentu,"
    sql+="czy_kontrahent,czy_zlecenie,czy_konto_kosztow,czy_faktura,czy_poddokumenty) "
    sql+="VALUES ('"+Symbol+"','RW','W','Rozchd wewntrzny',"
    sql+="FALSE,TRUE,TRUE,FALSE,FALSE);"
    
    sql+="INSERT INTO rs_typy_dokumentow_m (firma_id,dokument_id,typ_dokumentu,nazwa_dokumentu,"
    sql+="czy_kontrahent,czy_zlecenie,czy_konto_kosztow,czy_faktura,czy_poddokumenty) "
    sql+="VALUES ('"+Symbol+"','PW','P','Przyjcie wewntrzne',FALSE,TRUE,FALSE,FALSE,FALSE);"
    
    sql+="INSERT INTO rs_typy_dokumentow_m (firma_id,dokument_id,typ_dokumentu,nazwa_dokumentu,"
    sql+="czy_kontrahent,czy_zlecenie,czy_konto_kosztow,czy_faktura,czy_poddokumenty) "
    sql+="VALUES ('"+Symbol+"','MM','M','Przesunicie midzymagazynowe',"
    sql+="FALSE,FALSE,FALSE,FALSE,FALSE);"
    
    sql+="INSERT INTO rs_typy_dokumentow_m (firma_id,dokument_id,typ_dokumentu,nazwa_dokumentu,"
    sql+="czy_kontrahent,czy_zlecenie,czy_konto_kosztow,czy_faktura,czy_poddokumenty) "
    sql+="VALUES ('"+Symbol+"','PR','R','Przecena',"
    sql+="FALSE,FALSE,FALSE,FALSE,FALSE);"
    
    sql+="INSERT INTO rs_waluty (firma_id,kod,opis) VALUES ('"+Symbol+"','PLN','polski zoty');"
    sql+="INSERT INTO rs_waluty (firma_id,kod,opis) VALUES ('"+Symbol+"','USD','dolar amerykaski');"
    sql+="INSERT INTO rs_waluty (firma_id,kod,opis) VALUES ('"+Symbol+"','EUR','euro');"
    
    sql+="INSERT INTO rs_hale_produkcyjne (firma_id,kod,opis) VALUES ('"+Symbol+"','00','brak hali');"
        
    # Dodanie domylnych typw staych kadrowych
    sql+="INSERT INTO rs_kp_typy_stalych (firma_id,stala_id,nazwa,grupa,format,domyslna) "
    sql+="VALUES ('"+Symbol+"','SP1','Kwota wolna od podatku','SP','N',True); "  
    sql+="INSERT INTO rs_kp_typy_stalych (firma_id,stala_id,nazwa,grupa,format,domyslna) "
    sql+="VALUES ('"+Symbol+"','SP2','Kwota graniczna pierwszego progu podatkowego','SP','N',True); "
    sql+="INSERT INTO rs_kp_typy_stalych (firma_id,stala_id,nazwa,grupa,format,domyslna) "
    sql+="VALUES ('"+Symbol+"','SP3','Kwota graniczna drugiego progu podatkowego','SP','N',True); "
    sql+="INSERT INTO rs_kp_typy_stalych (firma_id,stala_id,nazwa,grupa,format,domyslna) "
    sql+="VALUES ('"+Symbol+"','SP4','Stawka procentowa dla 1 progu podatkowego','SP','N',True); "
    sql+="INSERT INTO rs_kp_typy_stalych (firma_id,stala_id,nazwa,grupa,format,domyslna) "
    sql+="VALUES ('"+Symbol+"','SP5','Stawka procentowa dla 2 progu podatkowego','SP','N',True); "
    sql+="INSERT INTO rs_kp_typy_stalych (firma_id,stala_id,nazwa,grupa,format,domyslna) "
    sql+="VALUES ('"+Symbol+"','SP6','Stawka procentowa dla wiadczenia dla emerytw bdcych byymi pracownikami','SP','N',True); "
    sql+="INSERT INTO rs_kp_typy_stalych (firma_id,stala_id,nazwa,grupa,format,domyslna) "
    sql+="VALUES ('"+Symbol+"','SP7','Stawka procentowa dla nalenoci dla osb zagranicznych wymienionych w art. 29  ustawy','SP','N',True); "
    sql+="INSERT INTO rs_kp_typy_stalych (firma_id,stala_id,nazwa,grupa,format,domyslna) "
    sql+="VALUES ('"+Symbol+"','SP8','Stawka procentowa dla dywidendy i innych przychodw z tytuu udziau w zyskach osb prawnych','SP','N',True); "
    sql+="INSERT INTO rs_kp_typy_stalych (firma_id,stala_id,nazwa,grupa,format,domyslna) "
    sql+="VALUES ('"+Symbol+"','SP9','Stawka procentowa dla innych nalenoci objtych zryczatowanym podatkiem dochodowym','SP','N',True); "
    sql+="INSERT INTO rs_kp_typy_stalych (firma_id,stala_id,nazwa,grupa,format,domyslna) "
    sql+="VALUES ('"+Symbol+"','SP10','Kwota podstawowych kosztw uzyskania przychodu','SP','N',True); "
    sql+="INSERT INTO rs_kp_typy_stalych (firma_id,stala_id,nazwa,grupa,format,domyslna) "
    sql+="VALUES ('"+Symbol+"','SP11','Kwota zwikszonych  kosztw uzyskania przychodu','SP','N',True); "
    sql+="INSERT INTO rs_kp_typy_stalych (firma_id,stala_id,nazwa,grupa,format,domyslna) "
    sql+="VALUES ('"+Symbol+"','SP12','Kwota miesicznej ulgi zaliczki','SP','N',True); "
    sql+="INSERT INTO rs_kp_typy_stalych (firma_id,stala_id,nazwa,grupa,format,domyslna) "
    sql+="VALUES ('"+Symbol+"','SP13','Kwota graniczna umw cywilnych obcionych ryczatem','SP','N',True); "
    sql+="INSERT INTO rs_kp_typy_stalych (firma_id,stala_id,nazwa,grupa,format,domyslna) "
    sql+="VALUES ('"+Symbol+"','SP14','Kwota limitu rocznego przychodw z 50 % kosztami uzyskania','SP','N',True); "
    sql+="INSERT INTO rs_kp_typy_stalych (firma_id,stala_id,nazwa,grupa,format,domyslna) "
    sql+="VALUES ('"+Symbol+"','SZ1','Skladki pracownika  (procentowe) - emerytalna','SZ','N',True); "
    sql+="INSERT INTO rs_kp_typy_stalych (firma_id,stala_id,nazwa,grupa,format,domyslna) "
    sql+="VALUES ('"+Symbol+"','SZ2','Skadki pracownika  (procentowe) - rentowa','SZ','N',True); "
    sql+="INSERT INTO rs_kp_typy_stalych (firma_id,stala_id,nazwa,grupa,format,domyslna) "
    sql+="VALUES ('"+Symbol+"','SZ3','Skadki pracownika  (procentowe) - chorobowa','SZ','N',True); "
    sql+="INSERT INTO rs_kp_typy_stalych (firma_id,stala_id,nazwa,grupa,format,domyslna) "
    sql+="VALUES ('"+Symbol+"','SZ4','Skadki pracownika  (procentowe) - zdrowotna naliczana','SZ','N',True); "
    sql+="INSERT INTO rs_kp_typy_stalych (firma_id,stala_id,nazwa,grupa,format,domyslna) "
    sql+="VALUES ('"+Symbol+"','SZ5','Skadki pracownika  (procentowe) - zdrowotna odliczana','SZ','N',True); "
    sql+="INSERT INTO rs_kp_typy_stalych (firma_id,stala_id,nazwa,grupa,format,domyslna) "
    sql+="VALUES ('"+Symbol+"','SZ6','Skadki pracodawcy  (procentowe) - emerytalna','SZ','N',True); "
    sql+="INSERT INTO rs_kp_typy_stalych (firma_id,stala_id,nazwa,grupa,format,domyslna) "
    sql+="VALUES ('"+Symbol+"','SZ7','Skadki pracodawcy  (procentowe) - rentowa','SZ','N',True); "
    sql+="INSERT INTO rs_kp_typy_stalych (firma_id,stala_id,nazwa,grupa,format,domyslna) "
    sql+="VALUES ('"+Symbol+"','SZ8','Skadki pracodawcy  (procentowe) - wypadkowa','SZ','N',True); "
    sql+="INSERT INTO rs_kp_typy_stalych (firma_id,stala_id,nazwa,grupa,format,domyslna) "
    sql+="VALUES ('"+Symbol+"','SZ9','Skadki pracodawcy  (procentowe) - FP','SZ','N',True); "
    sql+="INSERT INTO rs_kp_typy_stalych (firma_id,stala_id,nazwa,grupa,format,domyslna) "
    sql+="VALUES ('"+Symbol+"','SZ10','Skadki pracodawcy  (procentowe) - FGP','SZ','N',True); "
    sql+="INSERT INTO rs_kp_typy_stalych (firma_id,stala_id,nazwa,grupa,format,domyslna) "
    sql+="VALUES ('"+Symbol+"','SZ11','Skadki pracodawcy  (procentowe) - FEP','SZ','N',True); "
    sql+="INSERT INTO rs_kp_typy_stalych (firma_id,stala_id,nazwa,grupa,format,domyslna) "
    sql+="VALUES ('"+Symbol+"','SZ12','Procent wynagrodzenia patnika za wypacone wiadczenia chorobowe','SZ','N',True); "
    sql+="INSERT INTO rs_kp_typy_stalych (firma_id,stala_id,nazwa,grupa,format,domyslna) "
    sql+="VALUES ('"+Symbol+"','SZ13','Procent wynagrodzenia patnika za pobrane skadki na ubezpieczenie zdrowotne','SZ','N',True); "
    sql+="INSERT INTO rs_kp_typy_stalych (firma_id,stala_id,nazwa,grupa,format,domyslna) "
    sql+="VALUES ('"+Symbol+"','SZ14','Kwota max.  podstawy skadki na emerytalne i rentowe','SZ','N',True); "
    sql+="INSERT INTO rs_kp_typy_stalych (firma_id,stala_id,nazwa,grupa,format,domyslna) "
    sql+="VALUES ('"+Symbol+"','SZ15','Kwota podstawy ubezpieczenia spoecznego wacicieli','SZ','N',True); "
    sql+="INSERT INTO rs_kp_typy_stalych (firma_id,stala_id,nazwa,grupa,format,domyslna) "
    sql+="VALUES ('"+Symbol+"','SZ16','Kwota podstawy ubezpieczenia zdrowotnego wacicieli','SZ','N',True); "
    sql+="INSERT INTO rs_kp_typy_stalych (firma_id,stala_id,nazwa,grupa,format,domyslna) "
    sql+="VALUES ('"+Symbol+"','SZ17','Kwota dobrowolnego ubezpieczenia chorobowego','SZ','N',True); "
    sql+="INSERT INTO rs_kp_typy_stalych (firma_id,stala_id,nazwa,grupa,format,domyslna) "
    sql+="VALUES ('"+Symbol+"','SZ18','Kwota wynagrodzenia minimalnego','SZ','N',True); "
    sql+="INSERT INTO rs_kp_typy_stalych (firma_id,stala_id,nazwa,grupa,format,domyslna) "
    sql+="VALUES ('"+Symbol+"','SZ19','Kwota podstawy skadek spoecznych dla zasiku wychowawczego','SZ','N',True); "
    sql+="INSERT INTO rs_kp_typy_stalych (firma_id,stala_id,nazwa,grupa,format,domyslna) "
    sql+="VALUES ('"+Symbol+"','SZ20','Kwota podstawy skadki zdrowotnej dla zasiku wychowawczego','SZ','N',True); "
    sql+="INSERT INTO rs_kp_typy_stalych (firma_id,stala_id,nazwa,grupa,format,domyslna) "
    sql+="VALUES ('"+Symbol+"','SZ21','Wspczynnik (procentowy) waloryzacji podstawy zasiku chorobowego','SZ','N',True); "
    sql+="INSERT INTO rs_kp_typy_stalych (firma_id,stala_id,nazwa,grupa,format,domyslna) "
    sql+="VALUES ('"+Symbol+"','SZ22','Prawo do wypaty zasikw','SZ','B',True); "
    sql+="INSERT INTO rs_kp_typy_stalych (firma_id,stala_id,nazwa,grupa,format,domyslna) "
    sql+="VALUES ('"+Symbol+"','LK1','Dni witeczne','LK','I',True); "
    sql+="INSERT INTO rs_kp_typy_stalych (firma_id,stala_id,nazwa,grupa,format,domyslna) "
    sql+="VALUES ('"+Symbol+"','LK2','Ilo dni wynagrodzenia chorobowego','LK','I',True); "
    sql+="INSERT INTO rs_kp_typy_stalych (firma_id,stala_id,nazwa,grupa,format,domyslna) "
    sql+="VALUES ('"+Symbol+"','LK3','Ilo dni wynagrodzenia chorobowego dla osb powyej 50 roku ycia','LK','I',True); "
    sql+="INSERT INTO rs_kp_typy_stalych (firma_id,stala_id,nazwa,grupa,format,domyslna) "
    sql+="VALUES ('"+Symbol+"','LK4','Limit okresu zasikowego','LK','I',True); "
    sql+="INSERT INTO rs_kp_typy_stalych (firma_id,stala_id,nazwa,grupa,format,domyslna) "
    sql+="VALUES ('"+Symbol+"','LK5','Limit dni przerwy do okresu zasikowego','LK','I',True); "
    sql+="INSERT INTO rs_kp_typy_stalych (firma_id,stala_id,nazwa,grupa,format,domyslna) "
    sql+="VALUES ('"+Symbol+"','LK6','Limit dni opieki nad dzieckiem','LK','I',True); "
    sql+="INSERT INTO rs_kp_typy_stalych (firma_id,stala_id,nazwa,grupa,format,domyslna) "
    sql+="VALUES ('"+Symbol+"','LK7','Limit dni opieki nad innymi czonkami rodziny','LK','I',True); "
    sql+="INSERT INTO rs_kp_typy_stalych (firma_id,stala_id,nazwa,grupa,format,domyslna) "
    sql+="VALUES ('"+Symbol+"','LK8','Limit dni opieki nad noworodkiem','LK','I',True); "
    sql+="INSERT INTO rs_kp_typy_stalych (firma_id,stala_id,nazwa,grupa,format,domyslna) "
    sql+="VALUES ('"+Symbol+"','LK9','Limit dni urlopu wypoczynkowego na danie','LK','I',True); "
    sql+="INSERT INTO rs_kp_typy_stalych (firma_id,stala_id,nazwa,grupa,format,domyslna) "
    sql+="VALUES ('"+Symbol+"','LK10','Limit dni na poszukiwanie pracy','LK','I',True); "
    sql+="INSERT INTO rs_kp_typy_stalych (firma_id,stala_id,nazwa,grupa,format,domyslna) "
    sql+="VALUES ('"+Symbol+"','LK11','Limit dni urlopu z art. 188 KP','LK','I',True); "
    sql+="INSERT INTO rs_kp_typy_stalych (firma_id,stala_id,nazwa,grupa,format,domyslna) "
    sql+="VALUES ('"+Symbol+"','LK12','Zasiek rodzinny na 1 i 2 dziecko','LK','N',True); "
    sql+="INSERT INTO rs_kp_typy_stalych (firma_id,stala_id,nazwa,grupa,format,domyslna) "
    sql+="VALUES ('"+Symbol+"','LK13','Zasiek rodzinny na 3 dziecko','LK','N',True); "
    sql+="INSERT INTO rs_kp_typy_stalych (firma_id,stala_id,nazwa,grupa,format,domyslna) "
    sql+="VALUES ('"+Symbol+"','LK14','Zasiek rodzinny na 4 i kade nastpne dziecko','LK','N',True); "
    sql+="INSERT INTO rs_kp_typy_stalych (firma_id,stala_id,nazwa,grupa,format,domyslna) "
    sql+="VALUES ('"+Symbol+"','LK15','Zasiek pielgnacyjny','LK','N',True); "
    sql+="INSERT INTO rs_kp_typy_stalych (firma_id,stala_id,nazwa,grupa,format,domyslna) "
    sql+="VALUES ('"+Symbol+"','UR1','Ilo lat pierwszego przedziau urlopu wg Kodeksu Pracy','UR','I',True); "
    sql+="INSERT INTO rs_kp_typy_stalych (firma_id,stala_id,nazwa,grupa,format,domyslna) "
    sql+="VALUES ('"+Symbol+"','UR2','Wymiar urlopu pierwszego przedziau urlopu wg Kodeksu Pracy','UR','I',True); "
    sql+="INSERT INTO rs_kp_typy_stalych (firma_id,stala_id,nazwa,grupa,format,domyslna) "
    sql+="VALUES ('"+Symbol+"','UR3','Ilo lat drugiego przedziau urlopu wg Kodeksu Pracy','UR','I',True); "
    sql+="INSERT INTO rs_kp_typy_stalych (firma_id,stala_id,nazwa,grupa,format,domyslna) "
    sql+="VALUES ('"+Symbol+"','UR4','Wymiar urlopu drugiego przedziau urlopu wg Kodeksu Pracy','UR','I',True); "
    sql+="INSERT INTO rs_kp_typy_stalych (firma_id,stala_id,nazwa,grupa,format,domyslna) "
    sql+="VALUES ('"+Symbol+"','UR5','Wymiar urlopu pracownikw naukowych','UR','I',True); "
    sql+="INSERT INTO rs_kp_typy_stalych (firma_id,stala_id,nazwa,grupa,format,domyslna) "
    sql+="VALUES ('"+Symbol+"','UR6','Zaokrglenie wymiaru absolwentw do penych dni w gr','UR','B',True); "
    sql+="INSERT INTO rs_kp_typy_stalych (firma_id,stala_id,nazwa,grupa,format,domyslna) "
    sql+="VALUES ('"+Symbol+"','PS1','Podre Krajowe','PS','N',True); "
    sql+="INSERT INTO rs_kp_typy_stalych (firma_id,stala_id,nazwa,grupa,format,domyslna) "
    sql+="VALUES ('"+Symbol+"','PS2','Podre Krajowe - Ryczat za nocleg','PS','N',True); "
    sql+="INSERT INTO rs_kp_typy_stalych (firma_id,stala_id,nazwa,grupa,format,domyslna) "
    sql+="VALUES ('"+Symbol+"','PS3','Podre Krajowe - Ryczat za dojazdy','PS','N',True); "
    sql+="INSERT INTO rs_kp_typy_stalych (firma_id,stala_id,nazwa,grupa,format,domyslna) "
    sql+="VALUES ('"+Symbol+"','PS4','Stawka za km do 900 cm3','PS','N',True); "
    sql+="INSERT INTO rs_kp_typy_stalych (firma_id,stala_id,nazwa,grupa,format,domyslna) "
    sql+="VALUES ('"+Symbol+"','PS5','Stawka za km pozyej 900 cm3','PS','N',True); "
    sql+="INSERT INTO rs_kp_typy_stalych (firma_id,stala_id,nazwa,grupa,format,domyslna) "
    sql+="VALUES ('"+Symbol+"','PS6','20. Podre Zagraniczne - Dieta','PS','N',True); "
    sql+="INSERT INTO rs_kp_typy_stalych (firma_id,stala_id,nazwa,grupa,format,domyslna) "
    sql+="VALUES ('"+Symbol+"','PS7','20. Podre Zagraniczne - Ryczat za nocleg','PS','N',True); "
       
    stat,d,d2,d3 = self.PolSQL.Execute(sql,1)
        
    if stat<>'OK':
        stat='BL_INIT'
        dane.append(stat)
                                

#-------------------------------------------------------------------------------
#---   UPDATE DANYCH ( 3-update, 4 -update z pobraniem )
#-------------------------------------------------------------------------------
 
if stat=='OK' and Fun in (3,4):
    
    upd = "UPDATE rs_firmy SET "
    for i in range(len(pola)):
        
        pole = pola[i].lower()
        wart = wartosci[i]
            
        if pole == 'opis':
            if len(wart.strip()) == 0:
                stat = 'BL_OPIS_PUSTY'
                dane.append(stat)
        elif pole == 'lokacje_jm':
            if not wart in ['1','2']:
                stat = 'BL_JM_LOK'
                dane.append(stat)
            #sprawdzenie czy zmiana wystpuje przy pustych lokacjach
            if stat=='OK':
                SQL="SELECT lokacja_id FROM rs_lokacje WHERE firma_id='"+Symbol+"'"
                SQL+=" AND rsf_podaj_dane_lokacji(firma_id,lokacja_id,'zajete')::NUMERIC>0;"
                stat,DLok,dump,dump = self.PolSQL.Execute(SQL,3)        
            if stat=='OK':
                if len(DLok)>0:
                    stat = 'IL_JM_LOK'
                    dane.append(stat)
        #AB 14.08.18r
        # #od kiedy sprawdzac
        # elif pole == 'mpp_od_dnia':
        #     if wart != '    -  -  ':
        #         if not rsglobal.SprawdzCzyToData(wart):
        #             stat = "BL_OD_KIEDY_SPRAWDZAC"
        #             dane.append(stat)
        #     else:
        #         wart = ''
        
        # sprawdzenie poprawnoci wpisanego kolejkowania
        elif pole == 'kolejkowanie':
            if wart<>'':
                from funkcje import fs_kolejkowanie_pom
                stat,wart=fs_kolejkowanie_pom.SprawdzPoprawnoscListyKolejkowania(wart)
            
        
                    
            
        if stat == 'OK':
            if wart=='':
                wart='NULL'
            else:
                wart= "'"+str(wart)+"'"
                
            upd += pole + "=" + str(wart)+","
                

    if stat == 'OK':
        upd = upd[0:len(upd)-1]
        sql = upd+" WHERE firma_id='"+Symbol+"';"
            
        stat,d,wyn1,dump = self.PolSQL.Execute(sql,1)
        
        if stat <> 'OK':
            stat='BL_UPDATE'
            dane.append(stat)


#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH ( 5-select, 3 -update z pobraniem)
#-------------------------------------------------------------------------------

if stat=='OK' and Fun in (1,2,3,4,5):
    sql="SELECT * FROM rs_firmy WHERE firma_id='"+Symbol+"';"
    stat,dane,wyn1,dump = self.PolSQL.Execute(sql,3)
    if stat<>'OK':
        stat='BL_SELECT'
        dane.append(stat)
