
# -*- coding: iso8859_2 -*-

#-------------------------------------------------------------------------------
# Name:        fs_formularze_pozycje.py
# Purpose:     operacje na tabeli rs_formularze_pozycje
# Author:      Pawe Wjcikowski
# Created:     2009/07/27
# RCS-ID:      $Id: fs_formularze_pozycje.py$
# Copyright:   (c) 2009 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

FormularzId=klucze[0]
Wiersz=klucze[1]
Kolumna=klucze[2]
NrPoz=klucze[3]

Fun = klucze[-1]
stat = "OK"
dane = []
                
UprDodawanie=((self.oddzial_id,'077063') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)
UprUsuwanie=((self.oddzial_id,'077064') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)
  
                
#-------------------------------------------------------------------------------
#---   POBRANIE KOLEJNEGO nr_poz z dodaniem nowej def. (1)
#-------------------------------------------------------------------------------

if (Fun in [1]) and (stat=='OK'):
    if not UprDodawanie:
        stat='Brak uprawnie do dodawania danych'
        dane.append(stat)
    if stat=='OK':
        sql= "SELECT nr_poz FROM rs_formularze_definicje WHERE "
        sql+="firma_id='"+str(self.firma_id)+"' AND formularz_id='"+str(FormularzId)+"' AND wiersz="+str(Wiersz)+" "
        sql+="AND kolumna="+str(Kolumna)+" ORDER BY nr_poz DESC LIMIT 1;"
        stat,d,wyn1,tr=self.PolSQL.Execute(sql,3)
        if stat<>'OK':
            stat='Bdy przy pobieraniu nowego numeru :'+stat
            dane.append(stat)
        else:
            if len(d)==0:
                NrPoz=1
            else:
                NrPoz=d[0][0]+1
            query="INSERT INTO rs_formularze_definicje "
            query+="(firma_id,formularz_id,wiersz,kolumna,nr_poz) "
            query+="VALUES ('"+self.firma_id+"','"+str(FormularzId)+"','"+str(Wiersz)+"','"+str(Kolumna)+"','"+str(NrPoz)+"');"
            stat,dump,dump,dump = self.PolSQL.Execute(query ,1)
            if stat<>'OK':
                stat='Bdy przy dodawaniu definicji :'+stat
                dane.append(stat)
            else:
                wyn2 = NrPoz


#-------------------------------------------------------------------------------
#---   DELETE DANYCH (6)
#-------------------------------------------------------------------------------

if Fun == 6 and stat=='OK':
    if not UprUsuwanie:
        stat='Brak uprawnie do usuwania danych'
        dane.append(stat) 
    else:       
        DEL="DELETE FROM rs_formularze_definicje WHERE firma_id='"+self.firma_id+"' AND formularz_id='"+str(FormularzId)+"'"
        DEL+=" AND wiersz='"+str(Wiersz)+"' AND kolumna='"+str(Kolumna)+"' AND nr_poz='"+str(NrPoz)+"';"
        
        DEL+="UPDATE rs_formularze_definicje SET nr_poz=nr_poz-1 WHERE "
        DEL+="firma_id='"+self.firma_id+"' AND formularz_id='"+str(FormularzId)+"'"
        DEL+=" AND wiersz='"+str(Wiersz)+"' AND kolumna='"+str(Kolumna)+"' AND nr_poz >'"+str(NrPoz)+"';"
        
        stat,dump,dump,dump = self.PolSQL.Execute(DEL ,1)
        if stat<>'OK':
            stat = 'Bdy przy usuwaniu danych :'+stat
            dane.append(stat)        
 
                
#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (1- insert 5 -select, 6 -delete 9-kopiowanie)
#-------------------------------------------------------------------------------

if (Fun in [1,5,6,9]) and (stat=='OK') :
    sql= "SELECT nr_poz,COALESCE(konto,''),wartosc FROM rs_formularze_definicje WHERE "
    sql+="firma_id='"+str(self.firma_id)+"' AND formularz_id='"+str(FormularzId)+"' AND wiersz="+str(Wiersz)+" "
    sql+="AND kolumna="+str(Kolumna)+" ORDER BY nr_poz;"
    stat,dane,wyn1,tr=self.PolSQL.Execute(sql,3)
    if stat<>'OK':
        stat='Bdy przy pobieraniu danych :'+stat
        dane.append(stat)