
# -*- coding: iso8859_2 -*-

#-------------------------------------------------------------------------------
# Name:        fs_formularze_definicje_dane.py
# Purpose:     formularze definicje - wprowadzanie i edycja
# Author:      Pawe Wojcikowski
# Created:     2009/07/16
# RCS-ID:      $Id: fs_formularze_definicje_dane.py $
# Copyright:   (c) 2009 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

FormularzId = klucze[0]
Wiersz = klucze[1]
Kolumna = klucze[2]
NrPoz = klucze[3]
Sposob = klucze[4]
Dzialanie = klucze[5]
Ujemna = klucze[6]

Pola=pola
Wartosci=wartosci

stat='OK'
dane = []

UprDodawanie=((self.oddzial_id,'077063') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)
UprEdycja=((self.oddzial_id,'077062') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID) or UprDodawanie


#-------------------------------------------------------------------------------
#---   POBRANIE KOLEJNEGO nr_poz z dodaniem nowej def. (1)
#-------------------------------------------------------------------------------

if (klucze[-1] in [7]) and (stat=='OK') :
    sql= "SELECT nr_poz FROM rs_formularze_definicje WHERE "
    sql+="firma_id='"+str(self.firma_id)+"' AND formularz_id='"+str(FormularzId)+"' AND wiersz="+str(Wiersz)+" "
    sql+="AND kolumna="+str(Kolumna)+" ORDER BY nr_poz DESC LIMIT 1;"
    stat,dane,wyn1,tr=self.PolSQL.Execute(sql,3)
    if stat<>'OK':
        stat='Bdy przy pobieraniu nowego numeru :'+stat
        dane.append(stat)


#-------------------------------------------------------------------------------
#---   SPRAWDZENIE DANYCH (4,3,2,1)
#-------------------------------------------------------------------------------

if klucze[-1] in [1,2,3,4] and stat=='OK': 
    if Sposob=='':
        stat='PUS SPOSOB'   
        dane.append(stat)               
    else:
        sql= "SELECT kod FROM rs_formularze_sposoby WHERE "
        sql+="kod='"+str(Sposob)+"';"
        stat,d,wyn1,tr=self.PolSQL.Execute(sql,3)
        if stat<>'OK':
            stat='Bdy przy sprawdzaniu sposobu :'+stat
            dane.append(stat)
        else:
            if len(d)==0:
                stat='BL SPOSOB'   
                dane.append(stat)
    if Dzialanie=='':
        stat='PUS DZIALANIE'   
        dane.append(stat)
    else:
        if Dzialanie not in ['+','/','-','*']:
            stat='BL DZIALANIE'   
            dane.append(stat)              
    if Ujemna=='':
        stat='PUS UJEMNA'   
        dane.append(stat)
    else:
        if Ujemna not in ['=','0','-']:
            stat='BL UJEMNA'   
            dane.append(stat) 
    for i in range(len(Pola)):
        pole = Pola[i]
        wart = Wartosci[i]
        if pole=="konto":
            if wart <> '':
                sql = "SELECT rsf_podaj_parametry_konta('"+self.firma_id+"','"+self.okres_id+"','"+wart+"');"
                DaneTmp = self.PolSQL.Execute(sql,3)[1]
                if (DaneTmp <> []) and (DaneTmp <> None):
                    Dane = rsglobal.rseval(DaneTmp[0][0])
                    if Dane[0] == '':
                        stat='Bdnie wypenione konto.'
                        dane.append(stat)                  
        if pole=="miesiac":
            if wart <> '':
                if int(wart)>12 or int(wart)<(-12):
                    stat='Bdnie wypenione pole miesic.'
                    dane.append(stat)       
        if pole=="f_nr_poz":
            if wart <> 0:
                sql = "SELECT nr_poz FROM rs_formularze_definicje "
                sql+= "WHERE firma_id='"+str(self.firma_id)+"' AND formularz_id='"+str(FormularzId)+"' "
                sql+= "AND kolumna='"+str(Kolumna)+"' AND wiersz='"+str(Wiersz)+"' AND nr_poz='"+str(wart)+"';"
                stat,d,wyn1,tr=self.PolSQL.Execute(sql,3)
                if stat<>'OK':
                    stat = 'Bdy przy sprawdzaniu pozycji :'+stat
                    dane.append(stat)
                else:
                    if len(d) == 0:
                        stat='Brak podanego numeru definicji.'
                        dane.append(stat)   
        if pole=="f_wiersz":
            if wart <> 0:
                sql = "SELECT wiersz FROM rs_formularze_pozycje "
                sql+= "WHERE firma_id='"+str(self.firma_id)+"' AND formularz_id='"+str(FormularzId)+"' "
                sql+= "AND wiersz='"+str(wart)+"';"
                stat,d,wyn1,tr=self.PolSQL.Execute(sql,3)
                if stat<>'OK':
                    stat = 'Bdy przy sprawdzaniu wierszy :'+stat
                    dane.append(stat)
                else:
                    if len(d) == 0:
                        stat='Brak podanego wiersza w formularzu.'
                        dane.append(stat)   
        if pole=="f_kolumna":
            if wart <> 0:
                sql = "SELECT kolumna FROM rs_formularze_pozycje "
                sql+= "WHERE firma_id='"+str(self.firma_id)+"' AND formularz_id='"+str(FormularzId)+"' "
                sql+= "AND kolumna='"+str(wart)+"';"
                stat,d,wyn1,tr=self.PolSQL.Execute(sql,3)
                if stat<>'OK':
                    stat = 'Bdy przy sprawdzaniu kolumn :'+stat
                    dane.append(stat)
                else:
                    if len(d) == 0:
                        stat='Brak podanej kolumny w formularzu.'
                        dane.append(stat)                            
                        
                            
#-------------------------------------------------------------------------------
#---   INSERT DANYCH (2- bez pobierania,1- z pobieraniem)
#-------------------------------------------------------------------------------
              
if klucze[-1] in [1,2] and stat=='OK':
    if not UprDodawanie:
        stat='Brak uprawnie do dodawania danych'
        dane.append(stat)  
    else:
        ins = "INSERT INTO rs_formularze_definicje"
        Pola="firma_id,formularz_id,wiersz,kolumna,nr_poz"
        Wartosci="'"+str(self.firma_id)+"','"+str(FormularzId)+"','"+str(Wiersz)+"','"+str(Kolumna)+"','"+str(NrPoz)+"'"
        for i in range(len(pola)):
            pole = pola[i]
            wart = wartosci[i]                  
            if pole in ['f_wiersz','f_kolumna','f_nr_poz','wartosc','analityka1_od','analityka2_od','miesiac']:
                Pola= Pola+","+pole
                Wartosci= Wartosci+",'"+str(wart)+"'"
            elif pole in ['konto','sposob','dzialanie','ujemna','analityka1','analityka2']:
                Pola= Pola+","+pole
                if wart=='    -  -  ' or wart=='':
                    Wartosci= Wartosci+",NULL"
                else:
                    Wartosci= Wartosci+",'"+wart+"'"        
        ins = ins+" ("+Pola+") VALUES ("+Wartosci+");"
        stat,dump,dump,dump = self.PolSQL.Execute(ins ,1)
        if stat<>'OK':
            stat='Bd podczas dodawnia danych :'+stat
            dane.append(stat)            
            

#-------------------------------------------------------------------------------
#---   DELETE PUSTYCH POZYCJI  (9)
#-------------------------------------------------------------------------------

if klucze[-1] == 9 and stat=='OK':  
    DEL="DELETE FROM rs_formularze_definicje WHERE firma_id='"+self.firma_id+"' AND formularz_id='"+str(FormularzId)+"'"
    DEL+=" AND wiersz='"+str(Wiersz)+"' AND kolumna='"+str(Kolumna)+"'"
    DEL+=" AND (sposob IS NULL OR trim(sposob) in ('','None'));"       
    stat,dump,dump,dump = self.PolSQL.Execute(DEL ,1)
    if stat<>'OK':
        stat = 'Bdy przy usuwaniu pustych pozycji :'+stat
        dane.append(stat)  


#-------------------------------------------------------------------------------
#---   UPDATE DANYCH (4- bez pobierania,3- z pobieraniem)
#-------------------------------------------------------------------------------

if klucze[-1] == 4 or klucze[-1]==3:   
    if not UprEdycja:
        stat='Brak uprawnie do modyfikowania danych'
        dane.append(stat)       
    if stat == 'OK':        
        where = " WHERE firma_id='"+self.firma_id+"' AND formularz_id='"+FormularzId+"'"
        where+= " AND wiersz='"+Wiersz+"' AND kolumna='"+Kolumna+"' AND nr_poz='"+str(NrPoz)+"' ;"
        upd = "UPDATE rs_formularze_definicje SET "
        for i in range(len(pola)):
            pole = pola[i]
            wart = wartosci[i]
            if pole in ['f_wiersz','f_kolumna','f_nr_poz','wartosc']:
                if wart=='':
                    upd=upd+pole+"=NULL,"
                else:
                    upd=upd+pole+"="+str(wart)+","
            elif pole in ['konto','sposob','dzialanie','ujemna','analityka1',
                          'analityka1_od','analityka2','analityka2_od','miesiac']:
                if wart=='':
                    upd=upd+pole+"=NULL,"
                else:
                    upd=upd+pole+"='"+str(wart)+"',"   
        upd = upd[0:len(upd)-1]+where                        
        stat,dump,dump,dump = self.PolSQL.Execute(upd ,1)         
        if stat!="OK":
            stat="Bd przy modyfikowaniu danych : "+stat   
            dane.append(stat)                 


#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (5 -select, 3 -update z pobraniem, 1 -insert z pobraniem)
#-------------------------------------------------------------------------------

if (klucze[-1] in [5,3,1]) and (stat=='OK'):
    Select="SELECT * FROM rs_formularze_definicje WHERE firma_id='"+str(self.firma_id)+"' "
    Select+="AND formularz_id='"+str(FormularzId)+"' AND kolumna='"+str(Kolumna)+"' AND wiersz='"+str(Wiersz)+"'"
    Select+=" AND nr_poz='"+str(NrPoz)+"';"
    stat,dane,wyn1,tr = self.PolSQL.Execute(Select,3)   
    if stat!="OK":
        stat="Bd przy pobieraniu danych : "+stat   
        dane.append(stat)