#!/usr/bin/python
# -*- coding: iso8859_2 -*-
#-----------------------------------------------------------------------------
# Name:             fs_generator_dane_edycja.py
# Purpose:          generator raportw edycja zapytania
# Author:           Piotr Witkowski
# Created:          2016/04/21
# RCS-ID:           $Id: fs_generator_dane_edycja.py $
# Copyright:        (c) 2016 RecordSystem
# Licence:          GNU GPL
#-----------------------------------------------------------------------------

stat='OK'

if not self.operator_id == STANDARD_OPERATOR_ID:
    stat = 'Brak uprawnie.'

if stat == 'OK' and not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=='OK':
    Funkcja = klucze['Funkcja']
    SlPar={'Symbol':[3,5,6,7,10],}

    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Funkcja,klucze)
    if Lista<>'':
        stat=u'Uwaga : wywoanie funkcji fs_generator_dane z numerem ' +str(Funkcja)+u' bez parametrw: '+Lista
    if stat=='OK':
        if Funkcja in [3,5,6,7,10]:
            Symbol = str(klucze['Symbol'])

if stat=='OK':
    dane = []
    wyn1 = []
    wyn2 = []


#----------------------------------------------
# Modyfikowanie Zapytania SQL
#----------------------------------------------

if Funkcja==3 and stat=='OK':
    SQL="SELECT 1 FROM rs_raporty WHERE firma_id='"+self.firma_id+"'"
    SQL+=" AND raport_id='" + Symbol +"'ORDER BY 1;"
    stat,d,wyn1,tr = self.PolSQL.Execute(SQL,3)
    if stat<>'OK':
        stat = 'Bdy pobierania danych :'+stat
        dane.append(stat)

if Funkcja == 3 and stat == "OK":
    if len(pola)>0:
        dane = []
        sql = "UPDATE rs_raporty SET "
        for j in range(len(pola)):
            wart = wartosci[j]
            pole = pola[j]
            if stat == 'OK':
                if 'UPDATE' in wart.upper():
                    stat = u"W zapytaniu wystpuje sowo UPDATE"
                    dane.append(stat)
                elif 'DELETE' in wart.upper():
                    stat = u"W zapytaniu wystpuje sowo DELETE"
                    dane.append(stat)
                elif 'INSERT' in wart.upper():
                    stat = u"W zapytaniu wystpuje sowo INSERT"
                    dane.append(stat)
                elif 'DROP' in wart.upper():
                    stat = u"W zapytaniu wystpuje sowo DROP"
                    dane.append(stat)
                elif 'ALTER' in wart.upper():
                    stat = u"W zapytaniu wystpuje sowo ALTER"
                    dane.append(stat)
                elif 'TRUNCATE' in wart.upper():
                    stat = u"W zapytaniu wystpuje sowo TRUNCATE"
                    dane.append(stat)

            if stat == 'OK':
                if len(dane) > 0:
                    stat = dane[0]

            # wykonanie UPDATE
            if stat == 'OK':
                if pole in ["sql_przed","sql_raport","sql_po"]:
                    if wart in [None,"NULL",'']:
                        sql += pole+"=Null,"
                    else:
                        sql += pole+"='"+str(wart)+"',"

        if len(dane) == 0:
            sql = sql.strip(",")
            sql += " WHERE firma_id='" + self.firma_id + "' AND raport_id='" + Symbol + "';"
            stat, dump, dump, dump = self.PolSQL.Execute(rsglobal.Dekoduj(sql), 1)
            if stat <> 'OK':
                stat = "Bd przy modyfikowaniu danych parametrw: " + stat
                dane.append(stat)

#----------------------------------------------
# POBIERANIE DANYCH - Zapytanie SQL
#----------------------------------------------

if Funkcja in [3,5] and stat=='OK':
    SQL="SELECT sql_przed,sql_raport,sql_po FROM rs_raporty WHERE firma_id='"+self.firma_id+"'"
    SQL+=" AND raport_id='" + Symbol +"'ORDER BY 1;"
    stat,dane,wyn1,dump=self.PolSQL.Execute(SQL,3)

#----------------------------------------------
# POBIERANIE DANYCH - Tabele, kolumny
#----------------------------------------------

if Funkcja ==6 and stat=='OK':
    SQL="SELECT DISTINCT relname FROM pg_class INNER JOIN pg_attribute ON (pg_class.oid=attrelid)"
    SQL+=" WHERE NOT pg_class.relname LIKE 'rsi%' AND NOT pg_class.relname LIKE '%pkey' AND NOT pg_class.relname LIKE 'rsa%' "
    SQL+=" AND pg_attribute.attname='firma_id' ORDER BY relname;"
    stat,dane,wyn1,wyn2=self.PolSQL.Execute(SQL,3)

    # od razu s pobierane pozycje
    SPoz={}

    for d in dane:
        SQL="SELECT DISTINCT pg_attribute.attnum,attname,pg_type.typname FROM  pg_attribute"
        SQL+=" INNER JOIN pg_class ON (pg_class.oid=attrelid) INNER JOIN pg_type ON (atttypid=pg_type.oid)"
        SQL+=" WHERE pg_class.relname='"+rsglobal.Dekoduj(d[0])+"' AND NOT pg_attribute.attname IN ('z_czas','z_typ','z_op_id') "
        SQL+=" AND NOT pg_type.typname IN ('cid','xid','oid','tid') ORDER BY pg_attribute.attnum;"
        stat,DanePoz,Nagl,dump=self.PolSQL.Execute(SQL,3)
        if stat=='OK':
            SPoz[d[0]]=DanePoz

    wyn2=SPoz

#----------------------------------------------
# POBIERANIE DANYCH - Parametry
#----------------------------------------------

if Funkcja == 7 and stat=='OK':
    if Symbol not in ['',None]:
        SQL="SELECT lp, nazwa,opis, typ,dlugosc,po_przec,wsp_gora,wsp_lewa,wsp_dlug "
        SQL+="FROM rs_raporty_parametry WHERE firma_id='"+self.firma_id+"'"
        SQL+=" AND raport_id='" + Symbol +"'ORDER BY 1;"
        stat,dane,wyn1,dump=self.PolSQL.Execute(SQL,3)