#!/usr/bin/python
# -*- coding: iso8859_2 -*-
#-----------------------------------------------------------------------------
# Name:             fs_global_srodki_trwale.py
# Purpose:          modu zawiera funkcje dotyczace operacji na srodkach trwaych
# Author:           Micha Raburski
# Created:          2011/01/14
# RCS-ID:           $Id: fs_global_srodki_trwale.py $
# Copyright:        (c) 2011 RecordSystem
# Licence:          GNU GPL
#-----------------------------------------------------------------------------

import rsglobal

def PrzeliczWartoscSrodka(parent,Firma,SrodekId):
    SQL="SELECT metoda_amortyzacji,okres_amortyzacji,wartosc_poczatkowa,wartosc_koncowa,stawka_procent,"
    SQL+="metoda_amortyzacji_p,okres_amortyzacji_p,wartosc_poczatkowa_p,wartosc_koncowa,stawka_procent_p "
    SQL+=" FROM rs_srodki_trwale WHERE firma_id='"+Firma+"' AND srodek_id='"+SrodekId+"';"
    stat,Dane,dump,dump=parent.PolSQL.Execute(SQL,3)
    if stat=='OK':
        if len(Dane)==0:
            stat="Brak rodka o symbolu :"+SrodekId.strip()
        
    SQL=''
    
    # KSIGOWA
    if stat=='OK':
        # tylko amortyzacja liniowa
        if Dane[0][0]=='L':
            Ile=1
            if Dane[0][1]=='M':
                Ile=12
            elif Dane[0][1]=='K':
                Ile=4
            elif Dane[0][1]=='R':
                Ile=1

            # WZR : WartSt=RSGlobal.RSRound((WartPocz-WartKonc)*self.TCStawkaProc.GetValue()*0.01/Ile,2)
            WartSt=rsglobal.RSRound((Dane[0][2]-Dane[0][3])*Dane[0][4]*0.01/Ile,2)
            SQL+="UPDATE rs_srodki_trwale SET stawka_wartosc="+str(WartSt)
            SQL+=" WHERE firma_id='"+Firma+"' AND srodek_id='"+SrodekId+"';"
    
        # PODATKOWA
        # tylko amortyzacja liniowa
        if Dane[0][5]=='L':
            Ile=1
            if Dane[0][6]=='M':
                Ile=12
            elif Dane[0][6]=='K':
                Ile=4
            elif Dane[0][6]=='R':
                Ile=1

            # WZR : WartSt=RSGlobal.RSRound((WartPocz-WartKonc)*self.TCStawkaProc.GetValue()*0.01/Ile,2)
            WartStP=rsglobal.RSRound((Dane[0][7]-Dane[0][8])*Dane[0][9]*0.01/Ile,2)
            SQL+="UPDATE rs_srodki_trwale SET stawka_wartosc_p="+str(WartStP)
            SQL+=" WHERE firma_id='"+Firma+"' AND srodek_id='"+SrodekId+"';"
    
    if stat=='OK':
        if SQL<>'':
            stat,dump,dump,dump=parent.PolSQL.Execute(SQL,1)
    return stat