# -*- coding: iso8859_2 -*-
#-----------------------------------------------------------------------------
# Name:        fs_gr_raporty_uzytkownikow_dane.py
# Purpose:     obsuga raportu - dodawanie i edycja
#
# Author:      Micha Raburski
#
# Created:     2007/09/26
# RCS-ID:      $Id: fs_gr_raporty_uzytkownikow_dane.py $
# Copyright:   (c) 2004-2008 Record System
# Licence:     GNU GPL
#-----------------------------------------------------------------------------
# 2020-02-21 Aleksander Bargie (11865) Generator - kadry/pace.

Typ=klucze[0]
Tabela=rsglobal.Dekoduj(klucze[1].strip())
Numer=str(klucze[2])
Raport=rsglobal.Dekoduj(klucze[3])
Rodzaj=rsglobal.Dekoduj(klucze[4])
Filtr=rsglobal.Dekoduj(klucze[5])
Pola=klucze[6][0]
Pola2=klucze[6][1]
rsglobal.ZapiszDoLogow("Pola: {} ".format(Pola))
rsglobal.ZapiszDoLogow("Pola2: {} ".format(Pola2))
Fun=klucze[-1]


Nr='0' 

stat='OK'
dane=[]

self.UprCokolwiek=False
if Typ=='SP':
    self.UprCokolwiek=(self.operator_id == STANDARD_OPERATOR_ID) or ((self.oddzial_id,'083000') in self.uprawnienia)
    self.UprMod=(self.operator_id == STANDARD_OPERATOR_ID) or ((self.oddzial_id,'083002') in self.uprawnienia)
    self.UprModCudze=(self.operator_id == STANDARD_OPERATOR_ID) or ((self.oddzial_id,'083004') in self.uprawnienia)
elif Typ=='KS':
    self.UprCokolwiek=(self.operator_id == STANDARD_OPERATOR_ID) or ((self.oddzial_id,'084000') in self.uprawnienia)
    self.UprMod=(self.operator_id == STANDARD_OPERATOR_ID) or ((self.oddzial_id,'084002') in self.uprawnienia)
    self.UprModCudze=(self.operator_id == STANDARD_OPERATOR_ID) or ((self.oddzial_id,'084004') in self.uprawnienia)
    #AB 21.02.20r
elif Typ=='KP':
    self.UprCokolwiek=(self.operator_id == STANDARD_OPERATOR_ID) or ((self.oddzial_id,'086000') in self.uprawnienia)
    self.UprMod=(self.operator_id == STANDARD_OPERATOR_ID) or ((self.oddzial_id,'086002') in self.uprawnienia)
    self.UprModCudze=(self.operator_id == STANDARD_OPERATOR_ID) or ((self.oddzial_id,'086004') in self.uprawnienia)
    
if not self.UprCokolwiek:
    stat='UPR'

#----------------------------------
#--- SPRAWDZENIE
#----------------------------------

if stat=='OK' and Fun in [4,10]:
    #sprawdzenie mozliwosci edycji z ew kontrola bledow
    if not self.UprMod:
        stat='UPR ED'

    if stat=='OK':
        if Numer=='0':
            #wstawianie
            dump,d,dump,dump = self.PolSQL.Execute("SELECT max(numer) FROM rs_raporty_generatora WHERE tabela='"+Tabela+"';",3)
            if len(d)>0:
                Nr=str(d[0][0]+1)
            else:
                Nr='1'
            dane=[False]
        else:
            #sprawdzenie czy edytowac czy kopiowac
            dump,d,dump,dump = self.PolSQL.Execute("SELECT wlasciciel_id FROM rs_raporty_generatora WHERE tabela='"+Tabela+"' AND numer="+Numer+";",3)
            if d[0][0]<>self.operator_id:
                if self.UprModCudze:
                    dane=[False]
                else:
                    dane=[True]
            else:
                dane=[False]

#----------------------------------
#--- EDYCJA
#----------------------------------

if stat=='OK' and Fun in [4]:
#zapis danych
    if dane[0]:
        #kopiowanie
        dump,d,dump,dump = self.PolSQL.Execute("SELECT max(numer) FROM rs_raporty_generatora WHERE tabela='"+Tabela+"';",3)
        if len(d)>0:
            Nr=str(d[0][0]+1)[0:-2]
        else:
            Nr='1'
    
    dane=[]
    if Nr<>'0':
        #insert wynikajcy z nowego raportu lub kopiowania
        SQL="INSERT INTO rs_raporty_generatora (tabela,numer,raport,rodzaj,wlasciciel_id,klauzula_where) VALUES ('"+Tabela+"',"+Nr+",'"+Raport+"','"+Rodzaj+"',"+str(self.operator_id)+",'"+Filtr+"');"
        Numer=Nr
    else:
        #update istniejacego raportu
        SQL="UPDATE rs_raporty_generatora SET raport='"+Raport+"', rodzaj='"+Rodzaj+"', klauzula_where='"+Filtr+"' WHERE tabela='"+Tabela+"' AND numer="+Numer+";"
        SQL+="DELETE FROM rs_raporty_generatora_pola WHERE tabela='"+Tabela+"' AND numer="+Numer+";"

    #wstawienie pozycji raportu
    for p in Pola:
        if p[2]:
            Grup='TRUE'
        else:
            Grup='FALSE'

        SQL+="INSERT INTO rs_raporty_generatora_pola (tabela,numer,nr_poz,nazwa,definicja,grupowanie,kolejnosc) VALUES ('"+Tabela+"',"+Numer+","+str(p[0])+",'"+rsglobal.Dekoduj(p[1])+"','"+rsglobal.Dekoduj(p[4].replace("'","\\\'"))+"',"+Grup+","+str(p[3])+");"

    #wstawienie pozycji raportu dla wierszy
    for p in Pola2:
        if p[2]:
            Grup='TRUE'
        else:
            Grup='FALSE'

        SQL+="INSERT INTO rs_raporty_generatora_pola (tabela,numer,nr_poz,nazwa,definicja,grupowanie,kolejnosc, wiersz) VALUES ('"+Tabela+"',"+Numer+","+str(p[0])+",'"+rsglobal.Dekoduj(p[1])+"','"+rsglobal.Dekoduj(p[4].replace("'","\\\'"))+"',"+Grup+","+str(p[3])+", TRUE);"
    rsglobal.ZapiszDoLogow('SQL'*100 + SQL)
    stat,dump,dump,dump = self.PolSQL.Execute(SQL, 1)
    dane=[Numer]


#----------------------------------
#--- POBRANIE DANYCH DO DODAWANIA WSZYSTKICH POZYCJI
#----------------------------------
if stat=='OK' and Fun in [7]:
    stat,dane,dump,dump = self.PolSQL.Execute("SELECT nazwa FROM rs_tabele_generatora_pola WHERE tabela='"+Tabela+"' ORDER BY nr_poz;",3)

#----------------------------------
#--- POBIERANIE
#----------------------------------
if stat=='OK' and Fun in [5]:
    dump,DR,dump,dump = self.PolSQL.Execute("SELECT raport,rodzaj,klauzula_where FROM rs_raporty_generatora WHERE tabela='"+Tabela+"' AND numer="+Numer+";",3)
    dump,DP,dump,dump = self.PolSQL.Execute("SELECT nr_poz,nazwa,grupowanie,kolejnosc,definicja FROM rs_raporty_generatora_pola WHERE tabela='"+Tabela+"' AND numer="+Numer+" AND NOT wiersz ORDER BY nr_poz;",3)
    dump,DP2,dump,dump = self.PolSQL.Execute("SELECT nr_poz,nazwa,grupowanie,kolejnosc,definicja FROM rs_raporty_generatora_pola WHERE tabela='"+Tabela+"' AND numer="+Numer+" AND wiersz ORDER BY nr_poz;",3)

    dane=[DR[0][0],DR[0][1],DR[0][2],str(DP),str(DP2)]