# -*- coding: iso8859_2 -*-

#-------------------------------------------------------------------------------
# Name:        fs_grupy_analityczne.py
# Purpose:     obsluga grup analitycznych
#
# Author:      Mariusz Rajfura
# Created:     2009/09/05
# RCS-ID:      $Id: fs_grupy_analityczne.py $
# Copyright:   (c) 2009 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

Grupa = rsglobal.Dekoduj(klucze[0])
GrupaF = rsglobal.Dekoduj(klucze[1]).strip()
NazwaF = rsglobal.Dekoduj(klucze[2]).strip()

Fun = klucze[-1]
stat = 'OK'
dane = []
wyn1 = []

UprUsuwanie = (((self.oddzial_id,'072014') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID)
UprKontaAnal = (((self.oddzial_id,'072020') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID)

#-------------------------------------------------------------------------------
# POBRANIE INFORMACJI O TYM, CZY GRUPA MA KONTA ANALITYCZNE (TZW. Z LISTY) - 9
#-------------------------------------------------------------------------------

if Fun == 9:
    if UprKontaAnal:
        sql ="SELECT lista,dlugosc FROM rs_grupy_analityczne WHERE firma_id = '"+self.firma_id+"'"
        sql+=" AND okres_id = '"+self.okres_id+"' AND grupa_id = '"+Grupa+"';"
        stat,dane,dump,dump = self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Bd pobrania informacji o grupie analitycznej : '+stat
        else:
            if len(dane) == 0:
                stat = 'Grupa o podanym numerze nie istnieje.'
    else:
        stat = 'Brak uprawnie do kont analitycznych.'
    
#-------------------------------------------------------------------------------
# DELETE - 6
#-------------------------------------------------------------------------------

if Fun == 6:
    if UprUsuwanie:
        #czy grupa jest uzywana w planie kont
        sql ="SELECT kontos_id FROM rs_plan_kont WHERE firma_id = '"+self.firma_id+"' AND okres_id = '"+self.okres_id+"'"
        sql+=" AND (grupa1='"+Grupa+"' OR grupa2='"+Grupa+"' OR grupa3='"+Grupa+"' OR grupa4='"+Grupa+"' OR grupa5='"+Grupa+"');"
    
        stat,d,dump,dump = self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Bd pobrania informacji z planu kont : '+stat
        else:
            if len(d) > 0:
                stat = 'Grupa jest uyta w planie kont.\nUsunicie grupy moliwe po usuniciu z planu kont.'
        
        if stat == 'OK':
            #czy grupa zawiera liste kont analitycznych
            sql ="SELECT lista FROM rs_grupy_analityczne WHERE firma_id = '"+self.firma_id+"'"
            sql+=" AND okres_id = '"+self.okres_id+"' AND grupa_id = '"+Grupa+"' FOR UPDATE NOWAIT;"
            stat,d,dump,dump = self.PolSQL.Execute(sql,3)
            if stat <> 'OK':
                stat = 'Bd pobrania informacji o grupie analitycznej : '+stat
            else:
                if len(d) == 0:
                    stat = 'Grupa o podanym numerze nie istnieje.'
                else:
                    #jesli to lista, to czy ma konta analityczne
                    if d[0][0]:
                        sql ="SELECT kontoa_id FROM rs_konta_analityczne WHERE firma_id = '"+self.firma_id+"'"
                        sql+=" AND okres_id = '"+self.okres_id+"' AND grupa_id = '"+Grupa+"'"
                        stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                        if stat <> 'OK':
                            stat = 'Bd pobrania informacji o kontach analitycznych : '+stat
                        else:
                            if len(d) > 0:
                                stat = 'Grupa posiada konta analityczne.\n'
                                stat+= 'Usunicie grupy moliwe po usuniciu kont analitycznych.'
            
        if stat == 'OK':
            sqldel ="DELETE FROM rs_grupy_analityczne WHERE firma_id = '"+self.firma_id+"'"
            sqldel+=" AND okres_id = '"+self.okres_id+"' AND grupa_id = '"+Grupa+"';"
            stat,d,dump,dump = self.PolSQL.Execute(sqldel,1)
            if stat <> 'OK':
                stat = 'Bd usuwania grupy analitycznej : '+stat
    else:
        stat = 'Brak uprawnie do usuwania grup analitycznych.'
                
#-------------------------------------------------------------------------------
# SELECT 5,6
#-------------------------------------------------------------------------------

if Fun in (5,6) and stat == 'OK':
    FILTR = "firma_id = '"+self.firma_id+"' AND okres_id = '"+self.okres_id+"'"
    if GrupaF <> '':
        FILTR += " AND grupa_id LIKE '"+GrupaF+"%'"
    if NazwaF <> '':
        FILTR += " AND nazwa LIKE '"+NazwaF+"%'"

    sql ="SELECT grupa_id,nazwa FROM rs_grupy_analityczne WHERE "+FILTR+" ORDER BY grupa_id;"
    stat,dane,wyn1,dump = self.PolSQL.Execute(sql, 3)
    if stat <> 'OK':
        stat = 'Bd pobrania listy grup analitycznych : '+stat
