# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_grupy_odbiorcow_asortyment.py
# Purpose:     grid z asortymentem grupy odbiorcw
# Author:      Piotr Witkowski
# Created:     2016/02/07
# RCS-ID:      $Id: fs_grupy_odbiorcow_asortyment.py $
# Copyright:   (c) 2016 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

stat='OK'
if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=='OK':
    Funkcja = klucze['Funkcja']
    SlPar={'GrupaF':[1,5], 'ArtykulF':[1,5],'DataOdF':[1,5], 'DataDoF':[1,5]}

    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Funkcja,klucze)
    if Lista<>'':
        stat='Uwaga : wywoanie funkcji fs_grupy_odbiorcow_asortyment z numerem ' +str(Funkcja)+' bez parametrw: '+Lista

    if stat=='OK':
        if Funkcja in [1,5]:
            GrupaF = str(klucze['GrupaF'])
            ArtykulF = str(klucze['ArtykulF'])
            DataOdF = str(klucze['DataOdF'])
            DataDoF = str(klucze['DataDoF'])
dane = []


#-------------------------------------------------------------------------------
#----------   UPRAWNIENIA
#-------------------------------------------------------------------------------

UprModyfikowanie=True

if stat=='OK':
    if self.operator_id == STANDARD_OPERATOR_ID:
        UprIns=True
        UprUpd=True
        UprDel=True
    else:
        UprIns=(self.oddzial_id,'019003') in self.uprawnienia
        UprUpd=(self.oddzial_id,'019002') in self.uprawnienia
        UprDel=(self.oddzial_id,'019004') in self.uprawnienia

    Insert = []
    Update = []
    Delete = []

if stat=='OK' and Funkcja == 1:
    Update=klucze['Update']
    Insert=klucze['Insert']
    Delete=klucze['Delete']


#-------------------------------------------------------------------------------
#---   DELETE (1)
#-------------------------------------------------------------------------------

if Funkcja == 1 and stat=="OK":
    if len(Delete[0])>0:
        if not UprDel:
            stat='UPR DEL'
            dane.append(stat)
        if stat == 'OK':
            for i in xrange(len(Delete[0])):
                DELETE = "DELETE FROM rs_grupy_odbiorcow_asortyment "
                DELETE+= "WHERE firma_id='"+self.firma_id+"'"

                for j in xrange(len(Delete[0][i])):
                    pole = Delete[1][j]
                    wart = Delete[0][i][j]
                    if pole in ['grupa_id', 'artykul_id', 'data_od']:
                        if wart<>'':
                            DELETE+=" AND "+str(pole)+"='"+str(wart)+"'"
                DELETE+=";"
                stat,dump,dump,dump = self.PolSQL.Execute(rsglobal.Dekoduj(DELETE),1)
                if stat <> 'OK':
                    stat = "Bd przy usuwaniu danych: "+stat
                    dane.append(stat)


#-------------------------------------------------------------------------------
#---   UPDATE (1)
#-------------------------------------------------------------------------------

if Funkcja == 1 and stat=="OK":
    if len(Update[0])>0:
        if not UprUpd:
            stat='UPR UPD'
            dane.append(stat)

        if stat == 'OK':
            WierszeNr = Update[-1]
            for i in xrange(len(Update[0])):
                WHERE=" WHERE firma_id='"+self.firma_id+"'"
                for j in xrange(len(Update[2][i])): # petla po kluczu
                    pole=Update[3][j]
                    wart=rsglobal.Dekoduj(Update[2][i][j])
                    if pole in ['grupa_id','artykul_id','data_od']:
                        WHERE+=" AND "+pole+"='"+wart+"'"

                for j in xrange(len(Update[0][i])):
                    pole = Update[0][i][j]
                    wart = Update[1][i][j]
                    if pole == 'grupa_id':
                        if wart.strip()=='':
                            dane.append('GR BR')
                            wyn2.append((WierszeNr[i],0))
                        elif len(wart.strip())>3:
                            dane.append('GR DL')
                            wyn2.append((WierszeNr[i],0))
                        else:
                            spr ="SELECT 1 FROM rs_grupy_odbiorcow "
                            spr+="WHERE firma_id='"+str(self.firma_id)+"' AND kod = '"+wart.strip()+"';"
                            stat,s,wyn1,dump=self.PolSQL.Execute(spr,3)
                            if len(s)==0:
                                wyn2.append((WierszeNr[i],0))
                                dane.append('GR BL')

                    elif pole == 'artykul_id':
                        if len(wart.strip())==0:
                            wyn2.append((WierszeNr[i],2))
                            dane.append('ART BR')
                        else:
                            spr ="SELECT 1 FROM rs_artykuly "
                            spr+="WHERE firma_id='"+str(self.firma_id)+"' AND artykul_id = '"+wart.strip()+"';"
                            stat,s,wyn1,dump=self.PolSQL.Execute(spr,3)
                            if len(s)==0:
                                wyn2.append((WierszeNr[i],2))
                                dane.append('ART BL')

                    elif pole=='data_od':
                        if  wart not in (None,'None') and wart.strip()<>'':
                            if not rsglobal.SprawdzCzyToData(wart.strip()):
                                wyn2.append((WierszeNr[i],4))
                                dane.append('DATA OD BL')
                        else:
                            wyn2.append((WierszeNr[i],4))
                            dane.append('DATA OD BR')

                    elif pole=='data_do':
                        if wart not in (None,'None') and wart.strip()<>'':
                            if not rsglobal.SprawdzCzyToData(wart.strip()):
                                wyn2.append((WierszeNr[i],5))
                                dane.append('DATA DO BL')

                if stat == 'OK':
                    if len(dane) > 0:
                        stat = dane[0]

                # wykonanie UPDATE
                if stat=='OK':
                    sql=''
                    UPDATE="UPDATE rs_grupy_odbiorcow_asortyment "
                    SET='SET '
                    for j in xrange(len(Update[0][i])):
                        pole=Update[0][i][j]
                        wart=Update[1][i][j]
                        if pole in ['grupa_id','artykul_id','data_od']:
                            SET+=pole+"='"+str(wart)+"',"
                        elif pole in ['data_do']:
                            if wart not in (None,'None') and wart.strip()<>'':
                                SET+=pole+"='"+str(wart)+"',"
                            else:
                                SET+=pole+"=NULL,"

                    SET=SET.strip(",")
                    WHERE+=";"
                    sql+=UPDATE+SET+WHERE
                    stat,dump,dump,dump = self.PolSQL.Execute(rsglobal.Dekoduj(sql),1)
                    if stat<>'OK':
                        stat = "Bd przy modyfikowaniu danych: "+stat
                        dane.append(stat)


#-------------------------------------------------------------------------------
#---   INSERT (1)
#-------------------------------------------------------------------------------

if Funkcja == 1 and stat == 'OK':
    if len(Insert[0])>0:
        if not UprIns:
            stat='UPR INS'
            dane.append(stat)

        if stat == 'OK':
            WierszeNr = Insert[-1]

            for i in xrange(len(Insert[0])):
                for j in xrange(len(Insert[0][i])):

                    pole=Insert[1][j]
                    wart=Insert[0][i][j]
                    if pole == 'grupa_id':
                        if wart.strip()=='':
                            dane.append('GR BR')
                            wyn2.append((WierszeNr[i],0))
                        elif len(wart.strip())>3:
                            dane.append('GR DL')
                            wyn2.append((WierszeNr[i],0))
                        else:
                            spr ="SELECT 1 FROM rs_grupy_odbiorcow "
                            spr+="WHERE firma_id='"+str(self.firma_id)+"' AND kod = '"+wart.strip()+"';"
                            stat,s,wyn1,dump=self.PolSQL.Execute(spr,3)
                            if len(s)==0:
                                wyn2.append((WierszeNr[i],0))
                                dane.append('GR BL')

                    elif pole == 'artykul_id':
                        if len(wart.strip())==0:
                            wyn2.append((WierszeNr[i],2))
                            dane.append('ART BR')
                        else:
                            spr ="SELECT 1 FROM rs_artykuly "
                            spr+="WHERE firma_id='"+str(self.firma_id)+"' AND artykul_id = '"+wart.strip()+"';"
                            stat,s,wyn1,dump=self.PolSQL.Execute(spr,3)
                            if len(s)==0:
                                wyn2.append((WierszeNr[i],2))
                                dane.append('ART BL')

                    elif pole=='data_od':
                        if  wart not in (None,'None') and wart.strip()<>'':
                            if not rsglobal.SprawdzCzyToData(wart.strip()):
                                wyn2.append((WierszeNr[i],4))
                                dane.append('DATA OD BL')
                        else:
                            wyn2.append((WierszeNr[i],4))
                            dane.append('DATA OD BR')

                    elif pole=='data_do':
                        if wart not in (None,'None') and wart.strip()<>'':
                            if not rsglobal.SprawdzCzyToData(wart.strip()):
                                wyn2.append((WierszeNr[i],5))
                                dane.append('DATA DO BL')

        if stat == 'OK':
            if len(dane) > 0:
                stat = dane[0]

        # wykonanie INSERT
        if stat == 'OK':
            sqlIns=''
            for i in xrange(len(Insert[0])):
                INSERT="INSERT INTO rs_grupy_odbiorcow_asortyment"
                KOLUMNY="(firma_id"
                VALUES=" VALUES ('"+self.firma_id+"'"

                for j in xrange(len(Insert[0][i])):
                    pole=Insert[1][j]
                    wart=Insert[0][i][j]

                    if pole in ['grupa_id','artykul_id','data_od']:
                        KOLUMNY+=","+pole
                        VALUES+=",'"+str(wart)+"'"

                    elif pole in ['data_do']:
                        KOLUMNY+=","+pole
                        if str(wart)=='':
                            VALUES+=","+str('NULL')
                        else:
                            VALUES+=",'"+str(wart)+"'"

                KOLUMNY+=")"
                VALUES+=");"
                sqlIns+=INSERT+KOLUMNY+VALUES
            if sqlIns<>'':
                stat,dump,dump,dump=self.PolSQL.Execute(rsglobal.Dekoduj(sqlIns),1)
                if stat<>'OK':
                    stat = "Bd przy dodawaniu danych: "+stat
                    dane.append(stat)

#-------------------------------------------------------------------------------
#---   Sprawdzenie pokrywania si dat
#-------------------------------------------------------------------------------

if Funkcja == 1 and stat == 'OK':
    sql ="SELECT grupa_id,artykul_id,data_od,data_do FROM rs_grupy_odbiorcow_asortyment "
    sql+="WHERE firma_id='"+self.firma_id+"' AND data_do IS NOT NULL AND data_od>data_do;"
    stat,D,wyn1,dump=self.PolSQL.Execute(sql,3)
    if stat=='OK' and len(D)>0:
        stat=u"\nData od jest wiksza od daty do dla: "
        for i in xrange(len(D)):
            grupa=str(D[i][0])
            art=str(D[i][1])
            dataod=str(D[i][2])
            datado=str(D[i][3])
            stat+=u"\nGrupa: "+str(grupa)+u", artyku: "+str(art).strip()+u", data od: "+str(dataod)+u", data do: "+str(datado)
            D.append(stat)

#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (1,5)
#-------------------------------------------------------------------------------

if stat=='OK' and (Funkcja in [1,5]):
    sql ="SELECT a.grupa_id, g.opis, a.artykul_id, r.nazwa,data_od,data_do "
    sql+="FROM rs_grupy_odbiorcow_asortyment a JOIN rs_grupy_odbiorcow g ON a.firma_id = g.firma_id AND a.grupa_id = g.kod "
    sql+="JOIN rs_artykuly r ON a.firma_id = r.firma_id AND a.artykul_id = r.artykul_id "
    sql+="WHERE a.firma_id='"+str(self.firma_id)+"'"
    if rsglobal.SprawdzCzyToData(DataOdF):
        sql +=" AND data_od >= '"+DataOdF+"' AND data_do >= '"+DataOdF+"'"
    if rsglobal.SprawdzCzyToData(DataDoF):
        sql +=" AND data_do <= '"+DataDoF+"' AND data_do <= '"+DataDoF+"'"
    sql+=" AND grupa_id LIKE '"+GrupaF+"%' AND a.artykul_id like '"+ArtykulF+"%' ORDER BY 1,3;"
    stat,dane,wyn1,dump=self.PolSQL.Execute(sql,3)
    if stat<>'OK':
        stat="Bd przy pobieraniu danych : "+stat
        dane.append(stat)