# -*- coding: iso8859_2 -*-
#-----------------------------------------------------------------------------
# Name:        fs_harmonogram_zadan_log.py
# Author:      Piotr Szydeko
# Created:     2008/05/22
# Copyright:   (c) 2008 Record System
# Licence:     GNU GPL
#-----------------------------------------------------------------------------
# 2017-03-15 Piotr Wikowski (10375) Refaktoryzacja

stat='OK'
if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=='OK':
    Funkcja = klucze['Funkcja']
    SlPar={'hzid':[5,6,7],}

    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Funkcja,klucze)
    if Lista<>'':
        stat='Uwaga : wywoanie funkcji fs_harmonogram_zadan_log z numerem ' +str(Funkcja)+' bez parametrw: '+Lista

if stat=='OK':
    if Funkcja in [5,6,7,8]:
        hzid = klucze['hzid']
    if Funkcja in [5,7]:
        czas = klucze['czas']
    if Funkcja in [6,8]:
        szukaj = klucze['szukaj']
        dataOd = klucze['dataOd']
        dataDo = klucze['dataDo']

if stat=='OK':
    dane = []
    wyn1 = []
    wyn2 = []

UprWidziSwoje = (self.oddzial_id, "001701") in self.uprawnienia or self.operator_id == STANDARD_OPERATOR_ID
UprUsuwanie = (self.oddzial_id, "001704") in self.uprawnienia or self.operator_id == STANDARD_OPERATOR_ID

if stat=='OK' and Funkcja in [6,8]:
    if dataOd and dataDo and dataOd <> "    -  -  " and dataDo <> "    -  -  ":
        zakresDat = "BETWEEN '%s' AND (DATE '%s' + INTERVAL '1 DAY')" % (dataOd, dataDo)
    elif dataOd and dataOd <> "    -  -  ":
        zakresDat = " >= '%s'" % dataOd
    elif dataDo and dataDo <> "    -  -  ":
        zakresDat = " < (DATE '%s' + INTERVAL '1 DAY')" % dataDo
    else:
        zakresDat = ""
    if zakresDat:
        #zakresDat = " AND (moment %s OR uruchomione %s)" % (zakresDat, zakresDat)
        zakresDat = " AND (uruchomione " + zakresDat + ")"

    where = "firma_id='" + self.firma_id + "' AND harmzad_id=" + str(hzid) + zakresDat
    if szukaj:
        where += " AND (wypisane LIKE '%" + szukaj + "%' OR stat='" + szukaj +"') "

#------------------------------------------------------------------------------

if stat=='OK' and Funkcja==6:
    # pobranie listy logw z wykona
    if not UprWidziSwoje:
        stat = "BL upr"
    else:
        query ="SELECT uruchomione, trwalo, stat, CASE WHEN wypisane IS NULL THEN ''"
        query+="  WHEN char_length(wypisane) < 72 THEN replace(wypisane, '\\n', '  ')"
        query+="  ELSE replace(substring(wypisane FROM 0 FOR 68), '\\n', '  ') || '...[' || (char_length(wypisane) - 68) || ']'"
        query+=" END "
        query+=" FROM rs_harmonogram_zadan_log ZHL WHERE " + where
        query+=" ORDER BY uruchomione DESC;"
        stat, dane, none, none = self.PolSQL.Execute(query, 2)
        if stat<>'OK':
            stat="BL LS"

#------------------------------------------------------------------------------

if stat=='OK' and Funkcja == 7:
    if not UprUsuwanie:
        stat = "BL upr"
    else:
        query ="DELETE FROM rs_harmonogram_zadan_log WHERE firma_id='" + self.firma_id + "' "
        query+="AND harmzad_id=" + str(hzid) + " AND uruchomione='" + czas + "'"
        stat, dane, wyn1, none = self.PolSQL.Execute(query, 1)
        if stat<>'OK':
            stat = "BL DEL"

#------------------------------------------------------------------------------

if stat=='OK' and Funkcja == 8:
    # pobranie listy logw z wykona
    if not UprUsuwanie:
        stat = "BL upr"
    else:
        query = "DELETE FROM rs_harmonogram_zadan_log WHERE " + where
        stat, dane, dump, dump = self.PolSQL.Execute(query, 1)
        if stat<>'OK':
            stat = "BL DEL filtr"

#------------------------------------------------------------------------------

if stat=='OK' and Funkcja == 5:     # select danych do prezentacji w oddzielnym oknie
    if not UprWidziSwoje:
        stat = "BL upr"
    else:
        query ="SELECT firma_id, harmzad_id::TEXT AS harmzad_id, ZH.nazwa, ZH.opis, substr(text(ZHL.moment), 0, 17) AS moment,"
        query+=" substr(text(ZHL.uruchomione), 0, 17) AS uruchomione, ZHL.trwalo, ZHL.stat, ZHL.wypisane, ZH.z_czas, ZH.z_typ, ZH.z_op_id"
        query+=" FROM rs_harmonogram_zadan_log ZHL LEFT JOIN rs_harmonogram_zadan ZH USING(firma_id, harmzad_id)"
        query+=" WHERE firma_id='" + self.firma_id + "' AND harmzad_id=" + str(hzid) + " AND uruchomione='" + czas + "'"
        stat, dane, wyn1, none = self.PolSQL.Execute(query, 3)
        if stat<>'OK':
            stat = "BL DANE"