# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_hd_artykuly_import.py
# Purpose:     Import artykuw z PC Market
# Author:      Wojciech Skowron
# Created:     2019/07/29
# RCS-ID:      $Id: fs_hd_artykuly_import.py $
# Copyright:   (c) 2019 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

from funkcje import fs_hd_artykuly_import_pom

import rsglobal

stat = "OK"

if not 'Funkcja' in klucze:
    stat = 'Brak podanej funkcji w kluczach'

if stat == "OK":
    Funkcja = klucze['Funkcja']

    SlPar = {}
    Lista = rsglobal.SprawdzParametryWKluczach(SlPar,Funkcja,klucze)
    if Lista != '':
        stat = 'Uwaga : wywoanie funkcji fs_hd_artykuly_import z numerem '+str(Funkcja)+' bez parametrw: '+Lista

dane = []
wyn2 = []

#-------------------------------------------------------------------------------
#---   SPRAWDZENIE DANYCH
#-------------------------------------------------------------------------------

if stat == 'OK' and Funkcja == 1:
    stat, dane, wyn2 = fs_hd_artykuly_import_pom.Import(self)