# -*- coding: iso8859_2 -*-
# -------------------------------------------------------------------------------
# Name:        fs_hd_spis_z_natury_pozycje_przyjecia.py
# Purpose:     plik fs dla spisw z natury w handlu, kopia fs_spis_z_natury_pozycje przerobiona na wersj detaliczn
# Author:      Aleksander Bargie
# Created:     2020/09/18
# RCS-ID:      $Id: fs_hd_spis_z_natury_pozycje_przyjecia.py $
# Copyright:   (c) 2020 Record System
# Licence:     GNU GPL
# -------------------------------------------------------------------------------


from funkcje import fs_spis_z_natury_pom

stat = 'OK'
dane = []
wyn1 = []
wyn2 = []

Insert = []
Update = []
Delete = []


global SprawdzCzyLokacje


def SprawdzCzyLokacje(self, mag):
    SQL = "SELECT czy_lokacje FROM rs_magazyny WHERE firma_id = '{}' AND magazyn_id = '{}';"
    SQL = SQL.format(self.firma_id, mag)
    stat, Lok, dump, dump = self.PolSQL.Execute(SQL, 3)
    if stat != 'OK':
        return stat
    else:
        return str(Lok[0][0])

def SprawdzPoprawnoscLokacji(self, lok, mag):
    if SprawdzCzyLokacje(self, mag) == 'False':
        return 'OK'
    SQL = "SELECT 1 FROM rs_lokacje WHERE firma_id = '{}' AND magazyn_id = '{}' AND lokacja_id = '{}';"
    SQL = SQL.format(self.firma_id, mag, lok)
    stat, Lok, dump, dump = self.PolSQL.Execute(SQL, 3)
    if stat != 'OK':
        return stat
    else:
        if len(Lok) == 0:
            return u'Lokacja {} nie wystpuje w magazynie {}.'.format(lok, mag)
        else:
            return 'OK'

if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=='OK':
    Fun = klucze['Funkcja']
    
    SlPar={'Magazyn':[1,5, 11],'Kategoria':[1,5],'Data':[1,5],'Artykul':[1,5]}
    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Fun,klucze)
    if Lista<>'':
        stat='Uwaga : wywoanie funkcji fs_spis_z_natury_pozycje_przyjecia z numerem '+str(Fun)+' bez parametrw: '+Lista

if stat=='OK':
    if Fun in (1, 5, 11):
        Magazyn=rsglobal.Dekoduj(klucze['Magazyn'])
    if Fun in (1,5):
        Kategoria=rsglobal.Dekoduj(klucze['Kategoria'])
        Data=rsglobal.Dekoduj(klucze['Data'])
        Artykul=rsglobal.Dekoduj(klucze['Artykul'])

    if Fun==1:
        Insert = klucze['Insert']
        Update = klucze['Update']
        Delete = klucze['Delete']

if stat=='OK':
    UprEdycji=((self.oddzial_id,'097320') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID

#-------------------------------------------------------------------------------
#-------  SPRAWDZANIE CZY MAGAZYN MA LOKACJE  ----------------------------------
#-------------------------------------------------------------------------------


if Fun == 11 and stat=="OK":
    stat = SprawdzCzyLokacje(self, Magazyn)

#-------------------------------------------------------------------------------
#-------  SPRAWDZANIE DELETE  --------------------------------------------------
#-------------------------------------------------------------------------------

if Fun == 1 and stat=="OK":
    if not UprEdycji:
        stat='Brak uprawnie do edycji danych przyj dla pozycji spisu z natury'
        dane.append(stat)

if Fun == 1 and stat=="OK":    
    if stat=='OK':
        if len(Delete[0])>0:
            for i in xrange(len(Delete[0])):
                for j in xrange(len(Delete[0][i])): 
                    pole=Delete[1][j]
                    wart=str(Delete[0][i][j])
                    # sprawdzamy, czy przyjcie byo stworzone rcznie
                    if pole == 'lp':
                        if wart<>'':
                            SQL ="SELECT TRIM(COALESCE(ap_dokument_id,'')) FROM rs_inwentaryzacja_pozycje_przyjecia"
                            SQL+=" WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+Magazyn+"' AND kateg_artykulu='"+Kategoria+"'"
                            SQL+=" AND data='"+Data+"' AND artykul_id='"+Artykul+"' AND lp="+wart+";"
                            
                            stat,DTest,dump,dump = self.PolSQL.Execute(SQL,3)
                            if stat<>'OK':
                                stat="Bdy przy sprawdzaniu przyjcia przed usuwaniem : "+stat   
                                dane.append(stat)
                            elif len(DTest)==0:
                                stat = "Prba usunicia nieistniejcej pozycji : "+str(wart)
                                dane.append(stat)
                            elif DTest[0][0]<>'':
                                stat = "Prba usunicia pozycji utworzonej automatycznie : "+str(wart)
                                dane.append(stat)

        #czy nie bylo jakis bledow po drodze
        if stat == 'OK':
            if len(dane) > 0:
                stat = dane[0]

        # wykonanie DELETE 
        if stat=='OK':
            sql=''
            for i in xrange(len(Delete[0])):
                DELETE="DELETE FROM rs_inwentaryzacja_pozycje_przyjecia"
                WHERE=" WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+Magazyn+"' AND kateg_artykulu='"+Kategoria+"'"
                WHERE+=" AND data='"+Data+"' AND artykul_id='"+Artykul+"' "
                for j in xrange(len(Delete[0][i])):
                    pole=Delete[1][j]
                    wart=Delete[0][i][j]
                    if pole in ['lp']:
                        WHERE+=" AND "+pole+"='"+str(wart)+"'"
                sql+=DELETE+WHERE+";"
            if sql<>'':
                stat,dump,dump,dump=self.PolSQL.Execute(rsglobal.Dekoduj(sql),1)
                if stat<>'OK':
                    stat = "Bd przy usuwaniu danych: "+stat   
                    dane.append(stat)

#-------------------------------------------------------------------------------
#---   UPDATE DANYCH (1)
#-------------------------------------------------------------------------------



if Fun == 1 and stat == 'OK':
    if len(Update[0])>0:
        WierszeNr = Update[-1]
        for i in xrange(len(Update[0])):
            for j in xrange(len(Update[0][i])): 
                pole = Update[0][i][j]
                wart = Update[1][i][j]

                if pole == 'termin_przyd':
                    if not wart.strip() in ('', '-  -'):
                        if not rsglobal.SprawdzCzyToData(wart):
                            stat='Podano bdny termin przydatnoci'
                            dane.append(stat)
                    
                elif pole == 'cecha1_wartosc':
                    if wart<>'':
                        # pobranie cechy z artykuu
                        SQL = "SELECT cecha1_opis FROM rs_artykuly WHERE firma_id='"+self.firma_id+"' AND artykul_id='"+Artykul+"'"
                        stat,DArt,dump,dump = self.PolSQL.Execute(SQL,3)
                        if stat <> 'OK':
                            stat = 'Bd sprawdzenia pobierania cechy z artykuu: '+stat
                        elif len(DArt) == 0:
                            stat = 'Brak podanego artykuu: '+Artykul
                        elif DArt[0][0] =='':
                            stat = 'Dla podanego artykuu '+Artykul+' brak cechy'

                        if stat == "OK":
                            cechaopis = DArt[0][0]

                        SQL ="SELECT wartosc FROM rs_artykuly_cechy_wartosci"
                        SQL+=" WHERE firma_id='"+self.firma_id+"' AND kod='"+cechaopis+"' LIMIT 1;"
                        stat,d,dump,dump = self.PolSQL.Execute(SQL,3)
                        if stat <> 'OK':
                            stat = 'Bd sprawdzenia listy wartoci dla cechy: '+stat
                        elif len(d) > 0:
                            # poniewaz cecha ma zdefiniowane wartosci, to czy podana wartosc jest poprawna
                            SQL ="SELECT rsf_podaj_parametry_cechy('"+self.firma_id+"','"+cechaopis+"','"+wart+"','poprawna');"
                            stat,DTest,dump,dump = self.PolSQL.Execute(SQL,3)
                            if stat <> 'OK':
                                stat = 'Bd sprawdzenia wartoci cechy: '+stat
                            else:
                                Wynik=eval(DTest[0][0])
                                if not Wynik[0]:
                                    stat = Wynik[1]
                                    dane.append(stat)

                elif pole == 'lokacja_id':
                    stat = SprawdzPoprawnoscLokacji(self, wart, Magazyn)

    #czy nie bylo jakis bledow po drodze
    if stat == 'OK':
        if len(dane) > 0:
            stat = dane[0]

    # wykonanie UPDATE
    if stat=='OK':
        sql=''
        for i in xrange(len(Update[0])):
            UPDATE="UPDATE rs_inwentaryzacja_pozycje_przyjecia "
            SET='SET '
            for j in xrange(len(Update[0][i])): 
                pole=Update[0][i][j]
                wart=Update[1][i][j]
                if pole in ['termin_przyd']:
                    if wart.strip()=='':
                        SET+=pole+"=NULL,"
                    else:
                        SET+=pole+"='"+str(wart)+"',"
                        
                elif pole in ['lp','cena1','ilosc1','ilosc2','ilosc_ks1','ilosc_ks2']:
                    SET+=pole+"="+str(wart)+","
                elif pole in ['nr_serii','cecha1_wartosc']:
                    SET+=pole+"='"+str(wart)+"',"
                elif pole in ['lokacja_id', 'nr_palety_id'] and SprawdzCzyLokacje(self, Magazyn) == 'True':
                    if wart.strip()=='':
                        SET+=pole+"=NULL,"
                    else:
                        SET+=pole+"='"+str(wart)+"',"

            SET=SET.strip(",")
            WHERE=" WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+Magazyn+"' AND kateg_artykulu='"+Kategoria+"'"
            WHERE+=" AND data='"+Data+"' AND artykul_id='"+Artykul+"' "
            for j in xrange(len(Update[2][i])): # petla po kluczu
                pole=Update[3][j]
                wart=rsglobal.Dekoduj(Update[2][i][j])
                WHERE+=" AND "+pole+"='"+str(wart)+"'"
            sql+=UPDATE+SET+WHERE+";"

        if sql <> '':
            stat,dump,dump,dump=self.PolSQL.Execute(rsglobal.Dekoduj(sql),1)
            if stat<>'OK':
                stat = "Bd przy modyfikowaniu danych: "+stat   
                dane.append(stat)  


#-------------------------------------------------------------------------------
#---------Sprawdzanie danych do Insert------
#-------------------------------------------------------------------------------

if Fun == 1 and stat == 'OK':
    if len(Insert[0])>0:
        WierszeNr = Insert[-1]
        for i in xrange(len(Insert[0])):
            for j in xrange(len(Insert[0][i])): 
                pole=Insert[1][j]
                wart=Insert[0][i][j]

                if pole == 'termin_przyd':
                    if not wart.strip() in ('', '-  -'):
                        if not rsglobal.SprawdzCzyToData(wart):
                            stat='Podano bdny termin przydatnoci'
                            dane.append(stat)
                    
                elif pole == 'cecha1_wartosc':
                    if wart<>'':
                        # pobranie cechy z artykuu
                        SQL = "SELECT cecha1_opis FROM rs_artykuly WHERE firma_id='"+self.firma_id+"' AND artykul_id='"+Artykul+"'"
                        stat,DArt,dump,dump = self.PolSQL.Execute(SQL,3)
                        if stat <> 'OK':
                            stat = 'Bd sprawdzenia pobierania cechy z artykuu: '+stat
                        elif len(DArt) == 0:
                            stat = 'Brak podanego artykuu: '+Artykul
                        elif DArt[0][0] =='':
                            stat = 'Dla podanego artykuu '+Artykul+' brak cechy'

                        if stat == "OK":
                            cechaopis = DArt[0][0]

                        SQL ="SELECT wartosc FROM rs_artykuly_cechy_wartosci"
                        SQL+=" WHERE firma_id='"+self.firma_id+"' AND kod='"+cechaopis+"' LIMIT 1;"
                        stat,d,dump,dump = self.PolSQL.Execute(SQL,3)
                        if stat <> 'OK':
                            stat = 'Bd sprawdzenia listy wartoci dla cechy: '+stat
                        elif len(d) > 0:
                            # poniewaz cecha ma zdefiniowane wartosci, to czy podana wartosc jest poprawna
                            SQL ="SELECT rsf_podaj_parametry_cechy('"+self.firma_id+"','"+cechaopis+"','"+wart+"','poprawna');"
                            stat,DTest,dump,dump = self.PolSQL.Execute(SQL,3)
                            if stat <> 'OK':
                                stat = 'Bd sprawdzenia wartoci cechy: '+stat
                            else:
                                Wynik=eval(DTest[0][0])
                                if not Wynik[0]:
                                    stat = Wynik[1]
                                    dane.append(stat)
                elif pole == 'lokacja_id':
                    stat = SprawdzPoprawnoscLokacji(self, wart, Magazyn)

        #czy nie bylo jakis bledow po drodze
        if stat == 'OK':
            if len(dane) > 0:
                stat = dane[0]

        # wykonanie INSERT
        if stat == 'OK':    
            sqlIns=''
            for i in xrange(len(Insert[0])):
                INSERT="INSERT INTO rs_inwentaryzacja_pozycje_przyjecia "
                KOLUMNY="(firma_id,magazyn_id,kateg_artykulu,data,artykul_id"
                VALUES=" VALUES ('"+self.firma_id+"','"+Magazyn+"','"+Kategoria+"','"+Data+"','"+Artykul+"'"
                for j in xrange(len(Insert[0][i])):
                    pole=Insert[1][j]
                    wart=Insert[0][i][j]
                    if pole in ['termin_przyd']:
                        if str(wart)=='':
                            KOLUMNY+=","+pole
                            VALUES+=","+str('NULL')
                        else:
                            KOLUMNY+=","+pole
                            VALUES+=",'"+str(wart)+"'"
                    elif pole in ['lp','cena1','ilosc1','ilosc2','ilosc_ks1','ilosc_ks2']:
                        KOLUMNY+=","+pole
                        VALUES+=","+str(wart)
                    elif pole in ['nr_serii','cecha1_wartosc']:
                        KOLUMNY+=","+pole
                        VALUES+=",'"+str(wart)+"'"
                    elif pole in ['lokacja_id', 'nr_palety_id'] and SprawdzCzyLokacje(self, Magazyn) == 'True':
                        if str(wart)=='':
                            KOLUMNY+=","+pole
                            VALUES+=","+str('NULL')
                        else:
                            KOLUMNY+=","+pole
                            VALUES+=",'"+str(wart)+"'"

                KOLUMNY+=")"
                VALUES+=");"
                sqlIns+=INSERT+KOLUMNY+VALUES
            if sqlIns<>'': 
                stat,dump,dump,dump=self.PolSQL.Execute(rsglobal.Dekoduj(sqlIns),1)
                if stat<>'OK':
                    stat = "Bd przy dodawaniu danych: "+stat
                    dane.append(stat)  

# zapis sumy iloci stwierdzonych do pozycji spisu
if Fun == 1 and stat=="OK":
    stat=fs_spis_z_natury_pom.WstawIloscStwierdzonaDoPozycjiArtykuluNaSpisieZNatury(self, Data, Magazyn, Kategoria, Artykul)

#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (1- insert 1 -select, 1 -delete  5-select)
#-------------------------------------------------------------------------------

if Fun in (1,5) and stat == 'OK':
    SQL ="SELECT lp,CASE WHEN TRIM(COALESCE(ap_dokument_id,''))<>'' THEN "
    SQL+=" TRIM(magazyn_id)||'/'||TRIM(ap_dokument_id)||'/'||ap_data||'/'||ap_numer::TEXT"
    SQL+="||'/'||ap_nr_poz::TEXT||'/'||ap_nr_ppoz::TEXT ELSE ''END AS przyjecie,"
    SQL+=" cena1 AS cena, ilosc1, ilosc2, ilosc_ks1, ilosc_ks2, "
    SQL+=" COALESCE(termin_przyd::TEXT,''), COALESCE(nr_serii,''), COALESCE(cecha1_wartosc,''), "
    #AB 16.10.18r
    SQL+=" COALESCE(lokacja_id, ''), COALESCE(nr_palety_id, '') "
    SQL+=" FROM rs_inwentaryzacja_pozycje_przyjecia WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+Magazyn+"'"
    SQL+=" AND kateg_artykulu='"+Kategoria+"' AND data='"+Data+"' AND artykul_id='"+Artykul+"'"
    SQL+=" ORDER BY lp;"

    stat,dane,dump,dump=self.PolSQL.Execute(SQL,3)
    if stat<>'OK':
        stat="Bd przy pobieraniu danych: "+stat
        
    if stat=='OK':
        SQL="SELECT przelicznik,COALESCE(cecha1_opis,'') FROM rs_artykuly WHERE firma_id='"+self.firma_id+"' AND artykul_id='"+Artykul+"';"
        stat,DPrzel,dump,dump=self.PolSQL.Execute(SQL,3)
        wyn2=[DPrzel[0][0],DPrzel[0][1],0]
        
    if stat=='OK':
        # jeli artyku ma cech to sprawdzamy czy ma zdefiniowane wartoci
        if DPrzel[0][1]<>'':
            SQL="SELECT COUNT(*) FROM rs_artykuly_cechy_wartosci WHERE firma_id='"+self.firma_id+"' AND kod='"+rsglobal.Dekoduj(DPrzel[0][1])+"';"
            stat,DCechy,dump,dump=self.PolSQL.Execute(SQL,3)
            if stat=='OK':
                wyn2[2]=DCechy[0][0]
    
    if stat=='OK':
        # pobranie domylnej ceny artykuu w magazynie
        SQL="SELECT cena1 FROM rs_artykuly_przyjecia WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+Magazyn+"'"
        SQL+=" AND artykul_id='"+Artykul+"' ORDER BY data DESC,numer DESC LIMIT 1;"
        stat,DCena,dump,dump=self.PolSQL.Execute(SQL,3)
        if stat<> 'OK':
            stat='Bdy pobierania ceny z artykuw przyjcia : '+stat
    if stat=='OK':
        if len(DCena)>0:
            wyn2.append(DCena[0][0])
        else:
            wyn2.append(0)
