#!/usr/bin/python
# -*- coding: iso8859_2 -*-
#-----------------------------------------------------------------------------
# Name:             fs_intrastat_pozycje.py
# Purpose:          przeglda deklaracji intrastat
# Author:           Marcin Grzda
# Created:          2007/12/05
# RCS-ID:           $Id: fs_intrastat_pozycje.py $
# Copyright:        (c) 2007 RecordSystem
# Licence:          GNU GPL
# 2010-10-20        Marcin Natkaski (refaktoryzacja kodu)
# 2016-04-26        Piotr Bender (9619) refaktoryzacja
#-----------------------------------------------------------------------------
#
#   Funkcje :
#   5 - Pobieranie danych
#   6 - Usuwanie

stat = 'OK'

rsglobal.ZapiszDoLogow('TUTAJ', 1)

if not 'Funkcja' in klucze:
    stat = 'Brak podanej funkcji w kluczach'

if stat == 'OK':
    Funkcja = klucze['Funkcja']

    SlPar = {'Rok': [5, 6], 'Miesiac': [5, 6], 'NrZgloszenia': [5, 6], 'NrWersji': [5, 6], 'RodzajDeklaracji': [5, 6],
             'RodzajWydruku': [5, 6], 'NrPoz': [5, 6]}
    Lista = rsglobal.SprawdzParametryWKluczach(SlPar, Funkcja, klucze)

    if Lista <> '':
        stat = 'Uwaga : wywoanie funkcji fs_kp_dane_osobowe_zobowiazanie_ratalne z numerem '+str(Funkcja)+' bez parametrw: '+Lista

    if stat == 'OK':
        if Funkcja in [5, 6]:
            Rok = rsglobal.Dekoduj(klucze['Rok'])
            Miesiac = rsglobal.Dekoduj(klucze['Miesiac'])
            NrZgloszenia = rsglobal.Dekoduj(klucze['NrZgloszenia'])
            NrWersji = rsglobal.Dekoduj(klucze['NrWersji'])
            RodzajDeklaracji = rsglobal.Dekoduj(klucze['RodzajDeklaracji'])
            RodzajWydruku = rsglobal.Dekoduj(klucze['RodzajWydruku'])
            NrPoz = rsglobal.Dekoduj(klucze['NrPoz'])

if stat=='OK':
    dane = []
    wyn1 = []
    wyn2 = []

    UprDel = ((self.oddzial_id, '036024') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)

    Insert = []
    Update = []
    Delete = []

if stat == 'OK' and Funkcja == 1:
    Update = klucze['Update']
    Insert = klucze['Insert']
    Delete = klucze['Delete']

Filtr = " WHERE firma_id='"+self.firma_id+"'"
Filtr += " AND rok = '"+Rok+"' AND miesiac = '"+Miesiac+"' "
Filtr += " AND nr_zgloszenia='"+NrZgloszenia+"' AND nr_wersji='"+NrWersji+"'"
Filtr += " AND rodzaj_deklaracji='"+RodzajDeklaracji+"'"
Filtr += " AND wywoz_przywoz='"+RodzajWydruku+"'"

#-------------------------------------------------------------------------------
#-------------------------------------------------------------------------------
# -- USUWANIE -6 
#-------------------------------------------------------------------------------
#-------------------------------------------------------------------------------

if stat == 'OK' and Funkcja in [6,]:
    if not UprDel:
        stat="UPR DEL"   
        dane.append(stat)
    if stat == 'OK':
        sql = "DELETE FROM rs_intrastat_pozycje"+Filtr+ "AND nr_poz="+str(NrPoz)+";"
        sql += "UPDATE rs_intrastat_pozycje SET nr_poz=nr_poz-1"+Filtr+" AND nr_poz>"+str(NrPoz)+";"
        rsglobal.ZapiszDoLogow(sql, 5)
        stat, dump, dump, dump = self.PolSQL.Execute(sql, 1)
        if stat <> 'OK':
            stat = 'Bd zapytania usuwajcego pozycje deklaracji ' + stat
            dane.append(stat)  
            
        
#-------------------------------------------------------------------------------
#-------------------------------------------------------------------------------
# -- POBIERANIE DANYCH
#-------------------------------------------------------------------------------
#-------------------------------------------------------------------------------

if stat == 'OK' and (Funkcja in [5, 6, 7, 8, 1]):
    SELECT = "SELECT  nr_poz,kraj_wysylki,kraj_pochodz,kod_towaru"
    SELECT += ",warunki_dostawy,rodzaj_transportu,COALESCE(kod_transakcji::TEXT,''),masa_netto,ilosc,wartosc_fakturowa,wartosc_statystyczna"
    FROM = " FROM rs_intrastat_pozycje"
    ORDER = " ORDER BY nr_poz;"
    sql = SELECT+FROM+Filtr+ORDER
    stat, dane, wyn1, wyn2 = self.PolSQL.Execute(sql,3)
    if stat != "OK":
        stat = "Blad zapytania pobierajcego dane " + stat
        dane.append(stat)   