#!/usr/bin/python
# -*- coding: iso8859_2 -*-
#-----------------------------------------------------------------------------
# Name:             fs_kategorie_fakturowanie.py
# Purpose:          przegldanie kategorii fakturowania
# Author:           Marcin Grzda
# Created:          2008/03/14
# RCS-ID:           $Id: fs_kategorie_fakturowanie.py $
# Copyright:        (c) 2008 RecordSystem
# Licence:          GNU GPL
#-----------------------------------------------------------------------------

#klucze (czyli filtr):
# 0: Kategoria kontrahenta

Kateg=klucze[0]


Fun=klucze[-1]
stat = "OK"
dane = []

puste_pola = ['    -  -  ','',[]]

if self.operator_id == STANDARD_OPERATOR_ID:
    UprPrz=True
    UprDel=True
    UprIns=True
else:
    UprPrz=(self.oddzial_id,'014040') in self.uprawnienia
    UprDel=(self.oddzial_id,'014044') in self.uprawnienia
    UprIns=(self.oddzial_id,'014043') in self.uprawnienia


if Fun in [7]:
    Kateg=klucze[0]
    Data=klucze[1]
    
    SELECT= "SELECT kon.kontrahent_id,max(fakt.data_od)"
    SELECT+=" FROM rs_kontrahenci kon LEFT OUTER JOIN rs_kontrahenci_fakturowanie fakt"
    SELECT+=" ON (kon.firma_id=fakt.firma_id AND kon.kontrahent_id=fakt.kontrahent_id)"
    SELECT+=" WHERE kon.firma_id='01' AND kon.kateg_kontrahenta='"+Kateg+"'"
    SELECT+=" AND (fakt.data_od<='"+Data+"' OR fakt.kontrahent_id is NULL) GROUP BY kon.kontrahent_id"
    
    st,d,dump,dump=self.PolSQL.Execute(SELECT,3)
    if st=="OK":
        if len(d)>0:
            SelectKateg="SELECT wyznacznik,dni,wersja,upust,maks_wart,spos_zaplaty,spos_dostawy,projekt_id"
            SelectKateg+=" FROM rs_kategorie_fakturowanie WHERE firma_id='"+self.firma_id+"' AND kateg_kontrahenta='"+Kateg+"'"
            st_kat,d_kat,dump,dump=self.PolSQL.Execute(SelectKateg,2)
            if st_kat<>'OK':
                stat='BL SEL WYBR KAT'
                dane.append(stat)
            elif len(d_kat)==0:
                stat='BL KAT'
                dane.append(stat)
            else:
                Wyznacznik=rsglobal.Dekoduj(d_kat[0][0])
                Dni=d_kat[0][1]
                Wersja=rsglobal.Dekoduj(d_kat[0][2])
                Upust=d_kat[0][3]
                MaksWart=d_kat[0][4]
                SposZaplaty=rsglobal.Dekoduj(d_kat[0][5])
                SposDostawy=rsglobal.Dekoduj(d_kat[0][6])
                Projekt=rsglobal.Dekoduj(d_kat[0][7])
            
                for wiersz in d:
                    Kontrahent=rsglobal.Dekoduj(wiersz[0])
                    data_od=rsglobal.Dekoduj(wiersz[1])
                    if data_od=='None':
                        INSERT="INSERT INTO rs_kontrahenci_fakturowanie "
                        POLA=" (firma_id,data_od,kontrahent_id,wersja"
                        VALUES=" VALUES ('"+self.firma_id+"','"+Data+"','"+Kontrahent+"','"+Wersja+"'"
                        if Wyznacznik<>'None':
                            POLA+=",wyznacznik"
                            VALUES+=",'"+Wyznacznik+"'"
                        if SposZaplaty<>'None':
                            POLA+=",spos_zaplaty"
                            VALUES+=",'"+SposZaplaty+"'"
                        if SposDostawy<>'None':
                            POLA+=",spos_dostawy"
                            VALUES+=",'"+SposDostawy+"'"
                        if Projekt<>'None':
                            POLA+=",projekt_id"
                            VALUES+=",'"+Projekt+"'"
                        if Dni<>0:
                            POLA+=",dni"
                            VALUES+=","+str(Dni)
                        if Upust<>0:
                            POLA+=",upust"
                            VALUES+=","+str(Upust)
                        if MaksWart<>0:
                            POLA+=",maks_wart"
                            VALUES+=","+str(MaksWart)
                        POLA+=")"
                        VALUES+=")"
                        INSERT+=POLA+VALUES
                        st_ins,dump,dump,dump=self.PolSQL.Execute(INSERT,1)
                        if st_ins<>'OK':
                            stat='BL INS KONTR FAKT'
                            dane.append(stat)
                            break
                    elif data_od<Data:
                        INSERT="INSERT INTO rs_kontrahenci_fakturowanie "
                        POLA=" (firma_id,data_od,wersja,kontrahent_id,czy_upow,czy_fakt,czy_zbiorcza"
                        POLA+=",czy_osobna,czy_z_dostaw,rozliczac_zwroty,czy_ceny_na_dowodach"
                        POLA+=",czy_wg_indeksow,handlowiec,sposob_odbioru_faktury"
                        SELECT=" SELECT firma_id,'"+Data+"','"+Wersja+"',kontrahent_id,czy_upow,czy_fakt,czy_zbiorcza"
                        SELECT+=",czy_osobna,czy_z_dostaw,rozliczac_zwroty,czy_ceny_na_dowodach"
                        SELECT+=",czy_wg_indeksow,CASE WHEN handlowiec IS NULL THEN NULL ELSE handlowiec END"
                        SELECT+=",CASE WHEN sposob_odbioru_faktury IS NULL THEN NULL ELSE sposob_odbioru_faktury END"
                        POLA+=",wyznacznik"
                        if Wyznacznik<>'None':
                            SELECT+=",'"+Wyznacznik+"'"
                        else:
                            SELECT+=",CASE WHEN wyznacznik IS NULL THEN NULL ELSE wyznacznik END"
                        POLA+=",spos_zaplaty"    
                        if SposZaplaty<>'None':
                            SELECT+=",'"+SposZaplaty+"'"
                        else:
                            SELECT+=",CASE WHEN spos_zaplaty IS NULL THEN NULL ELSE spos_zaplaty END"
                        POLA+=",spos_dostawy"
                        if SposDostawy<>'None':
                            SELECT+=",'"+SposDostawy+"'"
                        else:
                            SELECT+=",CASE WHEN spos_dostawy IS NULL THEN NULL ELSE spos_dostawy END"
                        POLA+=",projekt_id"
                        if Projekt<>'None':
                            SELECT+=",'"+Projekt+"'"
                        else:
                            SELECT+=",CASE WHEN projekt_id IS NULL THEN NULL ELSE projekt_id END"
                        POLA+=",dni"
                        if Dni<>0:
                            SELECT+=","+str(Dni)
                        else:
                            SELECT+=",dni"
                        POLA+=",upust"
                        if Upust<>0:
                            SELECT+=","+str(Upust)
                        else:
                            SELECT+=",upust"
                        POLA+=",maks_wart"
                        if MaksWart<>0:
                            SELECT+=","+str(MaksWart)
                        else:
                            SELECT+=",maks_wart"
                        POLA+=")"
                        SELECT+=" FROM rs_kontrahenci_fakturowanie WHERE firma_id='"+self.firma_id+"' AND data_od='"+data_od+"' AND kontrahent_id='"+Kontrahent+"' ;"
                        INSERT+=POLA+SELECT
                        rsglobal.ZapiszDoLogow(INSERT,5)
                        st_ins,dump,dump,dump=self.PolSQL.Execute(INSERT,1)
                        if st_ins<>'OK':
                            stat='BL INS KONTR FAKT'
                            dane.append(stat)
                            break
                    elif data_od==Data:
                        UPDATE="UPDATE rs_kontrahenci_fakturowanie "
                        SET=" SET wersja='"+Wersja+"'"
                        if Wyznacznik<>'None':
                            SET+=",wyznacznik='"+Wyznacznik+"'"
                        if SposZaplaty<>'None':
                            SET+=",spos_zaplaty='"+SposZaplaty+"'"
                        if SposDostawy<>'None':
                            SET+=",spos_dostawy='"+SposDostawy+"'"
                        if Projekt<>'None':
                            SET+=",projekt_id='"+Projekt+"'"
                        if Dni<>0:
                            SET+=",dni="+str(Dni)
                        if Upust<>0:
                            SET+=",upust="+str(Upust)
                        if MaksWart<>0:
                            SET+=",maks_wart="+str(MaksWart)
                        WHERE=" WHERE firma_id='"+self.firma_id+"' AND data_od='"+Data+"' AND kontrahent_id='"+Kontrahent+"';"
                        UPDATE+=SET+WHERE
                        st_upd,dump,dump,dump=self.PolSQL.Execute(UPDATE,1)
                        if st_upd<>'OK':
                            stat='BL UPD KONTR FAKT'
                            dane.append(stat)
                            break
        
    else:
        stat='BL SEL KONTR FAKT'
        dane.append(stat)
    



# -- Usuwanie 6 -- #
if Fun in [6]:    
    if UprDel:
        sql="DELETE FROM rs_kategorie_fakturowanie WHERE firma_id='"+self.firma_id+"' AND kateg_kontrahenta = '"+Kateg+"';"
        st,dump,dump,dump=self.PolSQL.Execute(sql,1)
        if st<>'OK':
            stat='BL SQL DEL'
            dane.append(stat)
    else:
        stat="UPR DEL"   
        dane.append(stat)


if (Fun in [5,6]) and stat=='OK':
    if UprPrz:
        Filtr = " firma_id = '" + self.firma_id+"'"
            
        SELECT="SELECT kateg_kontrahenta, wyznacznik,dni,wersja,upust,maks_wart,spos_zaplaty,spos_dostawy,projekt_id "
        FROM=" FROM rs_kategorie_fakturowanie " 
        WHERE=" WHERE "+Filtr
        ORDER=" ORDER BY kateg_kontrahenta;"	
        
        sql=SELECT+FROM+WHERE+ORDER
        rsglobal.ZapiszDoLogow(sql,5)
        stat,dane,wyn1,wyn2=self.PolSQL.Execute(rsglobal.Dekoduj(sql),3)
        if stat!="OK":
            stat="BL SQL PRZ"
            dane.append(stat)
    else:
        stat='UPR PRZ'


#----------------  sprawdzamy czy dane maj by przesyane dalej
if stat == "OK" and Fun in (6, 7) and self.firma_id == '01':  #WS 2020-12-16 - self.firma_id
    stat, jest, none, none = self.PolSQL.Execute("SELECT COUNT(*) FROM rs_komser_funkcje WHERE nazwa='%s'" % funkcja, 4)
    if stat != "OK":
        stat = "BL rs_komser_funkcje"
    elif jest:
        stat, odp, none, none = self.WykonajFunkcje("fs_komser_zapisz", ["funkcja"], [funkcja, klucze, pola, wartosci])
