#!/usr/bin/python
# -*- coding: iso8859_2 -*-
#-----------------------------------------------------------------------------------------------------------------------
# Name:			fs_kierowcy_wersje_przewoznicy.py
# Purpose:		kierowcy przewonicy
# Author:		Piotr Witkowski
# Created:		2017/05/23
# RCS-ID:		$Id: fs_kierowcy_wersje_przewoznicy.py $
# Copyright:	(c) 2017 RecordSystem
# Licence:		GNU GPL
#-----------------------------------------------------------------------------------------------------------------------
# 2022-11-29 Aleksander Bargie (13252) Wystawianie faktur dla transportu - okno zlece transportowych(zmiana numerow uprawnien)

stat = 'OK'
wyn1 = []
wyn2 = []
dane = []

if not 'Funkcja' in klucze:
    stat = 'Brak podanej funkcji w kluczach'

if stat == 'OK':
    Funkcja = klucze['Funkcja']

    SlPar = {'DataOd':[6],'Kierowca':[1,5,6]}

    Lista = rsglobal.SprawdzParametryWKluczach(SlPar, Funkcja, klucze)
    if Lista != '':
        stat = "Uwaga: wywoanie funkcji fs_kierowcy_wersje_przewoznicy z numerem "+str(Funkcja)+" bez parametrw: "+Lista

    if Funkcja in [6,]:
        DataOd = klucze['DataOd']
    if Funkcja in [1,5,6]:
        Kierowca = klucze['Kierowca']

if stat == 'OK' and Funkcja == 1:
    Update = klucze['Update']
    Insert = klucze['Insert']
    Delete = klucze['Delete']

UprEdycja    = (((self.oddzial_id,'103000') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID))
UprUsuwanie  = (((self.oddzial_id,'103000') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID))
UprDodawanie = (((self.oddzial_id,'103000') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID))


#-----------------------------------------------------------------------------------------------------------------------
#-------  SPRAWDZANIE UPDATE
#-----------------------------------------------------------------------------------------------------------------------

if Funkcja == 1 and stat=="OK":
    if len(Update[0])>0:
        if not UprUsuwanie:
            stat='UPR UPD'
            dane.append(stat)


#-----------------------------------------------------------------------------------------------------------------------
#-------  UPDATE SPRAWDZANIE DANYCH
#-----------------------------------------------------------------------------------------------------------------------

        if stat == 'OK':
            for i in xrange(len(Update[0])):
                WierszeNr = Update[-1]
                for j in xrange(len(Update[0][i])):
                    pole = Update[0][i][j]
                    wart = Update[1][i][j]
                    if pole == 'data_od':
                        if wart in ['    -  -  ','',None,'None']:
                            dane.append(u'Brak daty od')
                            wyn2.append((WierszeNr[i],0))
                        else:
                            if not rsglobal.SprawdzCzyToData(wart):
                                stat = 'BL DATA'
                                dane.append('BL DATA')
                            else:
                                if not rsglobal.SprawdzCzyToData(wart):
                                    dane.append(u'Bdna data')
                                    wyn2.append((WierszeNr[i],0))

                    if pole in ['przewoznik_00','przewoznik_01','przewoznik_02','przewoznik_03','przewoznik_04','przewoznik_05','przewoznik_06','przewoznik_07']:
                        nr=0
                        if   pole=='przewoznik_00':
                            nr=1
                        elif pole=='przewoznik_01':
                            nr=2
                        elif pole=='przewoznik_02':
                            nr=3
                        elif pole=='przewoznik_03':
                            nr=4
                        elif pole=='przewoznik_04':
                            nr=5
                        elif pole=='przewoznik_05':
                            nr=6
                        elif pole=='przewoznik_06':
                            nr=7
                        elif pole=='przewoznik_08':
                            nr=8

                        if wart != '':
                            SQL ="SELECT 1 FROM rs_kontrahenci WHERE firma_id='"+self.firma_id+"' "
                            SQL+="AND kontrahent_id='"+wart+"';"
                            stat,D,dump,dump = self.PolSQL.Execute(SQL,3)
                            if stat != 'OK':
                                wyn2.append((WierszeNr[i],nr))
                                dane.append('Bdy pobrania przewonika '+wart)
                            elif len(D) == 0:
                                stat = 'Bdny przewonik - kontrahent '+wart+' nie istnieje'
                                wyn2.append((WierszeNr[i],nr))
                                dane.append(stat)


#-----------------------------------------------------------------------------------------------------------------------
#-------  UPDATE
#-----------------------------------------------------------------------------------------------------------------------

        if stat == 'OK':
            for i in xrange(len(Update[0])):
                UPDATE ="UPDATE rs_kierowcy_przewoznicy "
                SET ='SET '
                for j in xrange(len(Update[0][i])):
                    pole = Update[0][i][j]
                    wart = Update[1][i][j]
                    if pole in ['data_od','przewoznik_00','przewoznik_01','przewoznik_02','przewoznik_03','przewoznik_04','przewoznik_05','przewoznik_06','przewoznik_07']:
                        if wart<>'':
                            SET+=pole+"='"+wart+"',"
                        else:
                            SET+=pole+"=Null,"
                SET=SET.strip(",")
                WHERE=" WHERE firma_id='"+self.firma_id+"' AND kierowca_id='"+Kierowca+"'"
                for j in xrange(len(Update[2][i])): # petla po kluczu
                    pole=Update[3][j]
                    wart=rsglobal.Dekoduj(Update[2][i][j])
                    if pole in ['data_od']:
                        WHERE+=" AND "+pole+"='"+wart+"'"
                WHERE+=";"
                SQL=UPDATE+SET+WHERE
                stat,dump,dump,dump=self.PolSQL.Execute(SQL,1)
                if stat != 'OK':
                    dane.append('BL UPD')


#-----------------------------------------------------------------------------------------------------------------------
#-------  SPRAWDZANIE INSERT
#-----------------------------------------------------------------------------------------------------------------------

if Funkcja == 1 and stat=="OK":
    if len(Insert[0])>0:
        if not UprUsuwanie:
            stat='UPR INS'
            dane.append(stat)


#-----------------------------------------------------------------------------------------------------------------------
#-------  INSERT SPRAWDZANIE DANYCH
#-----------------------------------------------------------------------------------------------------------------------

        if stat == 'OK':
            for i in xrange(len(Insert[0])):
                WierszeNr = Insert[-1]
                for j in xrange(len(Insert[0][i])):
                    pole=Insert[1][j]
                    wart=Insert[0][i][j]
                    if pole == 'data_od':
                        if wart in ['    -  -  ','',None,'None']:
                            dane.append(u'Brak daty od')
                            wyn2.append((WierszeNr[i],0))
                        else:
                            if not rsglobal.SprawdzCzyToData(wart):
                                dane.append(u'Bdna data')
                                wyn2.append((WierszeNr[i],0))

                    if pole in ['przewoznik_00','przewoznik_01','przewoznik_02','przewoznik_03','przewoznik_04','przewoznik_05','przewoznik_06','przewoznik_07']:
                        nr=0
                        if   pole=='przewoznik_00':
                            nr=1
                        elif pole=='przewoznik_01':
                            nr=2
                        elif pole=='przewoznik_02':
                            nr=3
                        elif pole=='przewoznik_03':
                            nr=4
                        elif pole=='przewoznik_04':
                            nr=5
                        elif pole=='przewoznik_05':
                            nr=6
                        elif pole=='przewoznik_06':
                            nr=7
                        elif pole=='przewoznik_08':
                            nr=8
                        if wart != '':
                            SQL ="SELECT 1 FROM rs_kontrahenci WHERE firma_id='"+self.firma_id+"' "
                            SQL+="AND kontrahent_id='"+wart+"';"
                            stat,D,dump,dump = self.PolSQL.Execute(SQL,3)
                            if stat != 'OK':
                                wyn2.append((WierszeNr[i],nr))
                                dane.append('Bdy pobrania przewonika '+wart)
                            elif len(D) == 0:
                                stat = 'Bdny przewonik - kontrahent '+wart+' nie istnieje'
                                wyn2.append((WierszeNr[i],nr))
                                dane.append(stat)

#-----------------------------------------------------------------------------------------------------------------------
#-------  INSERT
#-----------------------------------------------------------------------------------------------------------------------

        if stat=='OK':
            for i in xrange(len(Insert[0])):
                INSERT ="INSERT INTO rs_kierowcy_przewoznicy "
                KOLUMNY="(firma_id,kierowca_id"
                VALUES =" VALUES ('"+self.firma_id+"','"+Kierowca+"'"
                for j in xrange(len(Insert[0][i])):
                    pole=Insert[1][j]
                    wart=Insert[0][i][j]
                    if pole in ['data_od','przewoznik_00','przewoznik_01','przewoznik_02','przewoznik_03',
                                'przewoznik_04','przewoznik_05','przewoznik_06','przewoznik_07']:
                        if pole == 'data_od':
                            data_od = wart
                        KOLUMNY+=","+pole
                        if wart<>'':
                            VALUES+=",'"+wart+"'"
                        else:
                            VALUES+=",Null"

                #sprawdzenie przed insert
                sql="SELECT 1 FROM rs_kierowcy_przewoznicy WHERE firma_id='"+self.firma_id+"' AND kierowca_id='"+Kierowca+"' "
                sql+="AND data_od='"+data_od+"';"
                stat,d,dump,dump=self.PolSQL.Execute(sql,3)
                if stat != 'OK':
                    dane.append('Bdy sprawdzenia danych przed dodaniem')
                elif len(d)>0:
                    stat="Na dat "+data_od+" istniej ju zdefiniowani przewonicy."
                    dane.append(stat)
                else:
                    KOLUMNY+=")"
                    VALUES+=");"
                    SQL=INSERT+KOLUMNY+VALUES
                    stat,dump,dump,dump=self.PolSQL.Execute(SQL,1)
                    if stat != 'OK':
                        dane.append('Bdy dodawania danych')


#-----------------------------------------------------------------------------------------------------------------------
#-------  SPRAWDZANIE DELETE
#-----------------------------------------------------------------------------------------------------------------------

if Funkcja == 1 and stat=="OK":
    if len(Delete[0])>0:
        if not UprUsuwanie:
            stat='UPR DEL'
            dane.append(stat)


#-----------------------------------------------------------------------------------------------------------------------
#-------  DELETE
#-----------------------------------------------------------------------------------------------------------------------

        if stat=='OK':
            for i in xrange(len(Delete[0])):
                DELETE = "DELETE FROM rs_kierowcy_przewoznicy "
                DELETE+= "WHERE firma_id='"+self.firma_id+"' AND kierowca_id='"+Kierowca+"'"
                for j in xrange(len(Delete[0][i])):
                    pole=Delete[1][j]
                    wart=Delete[0][i][j]
                    if pole in ['data_od']:
                        DELETE+= " AND "+pole+"='"+wart+"'"

                DELETE+= ";"
                stat,dump,dump,dump=self.PolSQL.Execute(DELETE,1)
                if stat<>'OK':
                    stat='BL DEL'
                    dane.append(stat)

#-----------------------------------------------------------------------------------------------------------------------
#-------  SPRAWDZENIE
#-----------------------------------------------------------------------------------------------------------------------

if stat=='OK' and Funkcja ==1:
    SQL ="SELECT 1 FROM rs_kierowcy_przewoznicy "
    SQL+="WHERE firma_id='" + self.firma_id + "' AND kierowca_id = '"+Kierowca+"' "
    SQL+="AND data_od IS NULL OR (przewoznik_00 IS NULL AND przewoznik_01 IS NULL "
    SQL+="AND przewoznik_02 IS NULL AND przewoznik_03 IS NULL AND przewoznik_04 IS NULL "
    SQL+="AND przewoznik_05 IS NULL AND przewoznik_06 IS NULL AND przewoznik_07 IS NULL) "
    stat,d,dump,dump=self.PolSQL.Execute(SQL,3)
    if stat<>'OK':
        stat = u'Bd pobrania pozycji przewonikw po modyfikacji danych'
    elif len(d)>0:
        stat=u'Musi by uzupeniona data i conajmniej jeden dzie'

#-----------------------------------------------------------------------------------------------------------------------
#-------  POBRANIE
#-----------------------------------------------------------------------------------------------------------------------

if stat=='OK' and Funkcja in [1,5]:
    SQL ="SELECT data_od,przewoznik_00,przewoznik_01,przewoznik_02,przewoznik_03,przewoznik_04, "
    SQL+="przewoznik_05,przewoznik_06,przewoznik_07 FROM rs_kierowcy_przewoznicy p "
    SQL+="JOIN rs_kierowcy k ON p.firma_id=k.firma_id and p.kierowca_id=k.kod "
    SQL+="WHERE p.firma_id='" + self.firma_id + "' AND kierowca_id = '"+Kierowca+"' "
    SQL+="ORDER BY kierowca_id, data_od;"
    stat,dane,wyn1,wyn2=self.PolSQL.Execute(SQL,3)
    if stat<>'OK':
        stat = 'Bd pobrania pozycji przewonikw'

#-----------------------------------------------------------------------------------------------------------------------
#-------  POBRANIE
#-----------------------------------------------------------------------------------------------------------------------

if stat=='OK' and Funkcja in [6,]:
    if DataOd not in ['','    -  -  ',None,'None']:
        if not rsglobal.SprawdzCzyToData(DataOd):
            stat='Bdna data od.'
            dane.append(stat)
        data="and pp.data_od<='"+DataOd+"'"
    else:
        data=''
    if Kierowca<>'':
        kierowca="AND kierowca_id ='"+Kierowca+"' "
    else:
        kierowca=''

    if stat=='OK':
        SQL = """
(SELECT kierowca_id, opis,data_od::TEXT,przewoznik_00,przewoznik_01,przewoznik_02,przewoznik_03,
        przewoznik_04, przewoznik_05,przewoznik_06,przewoznik_07 
FROM rs_kierowcy k JOIN rs_kierowcy_przewoznicy p ON p.firma_id=k.firma_id and p.kierowca_id=k.kod 
WHERE p.firma_id='""" + self.firma_id + """' AND data_od=(SELECT max(pp.data_od) FROM rs_kierowcy_przewoznicy pp
                                    WHERE p.firma_id=pp.firma_id and p.kierowca_id=pp.kierowca_id
                                    """+data+"""		)
"""+kierowca+""" ORDER BY p.kierowca_id)
UNION
SELECT rk.kod , rk.opis,'','','','','','','','','' 
FROM rs_kierowcy rk WHERE rk.firma_id='""" + self.firma_id + """' 
AND rk.kod not in(SELECT kierowca_id FROM rs_kierowcy k 
                    JOIN rs_kierowcy_przewoznicy p ON p.firma_id=k.firma_id and p.kierowca_id=k.kod 
                    WHERE p.firma_id='""" + self.firma_id + """' AND data_od=(SELECT max(pp.data_od) 
                    FROM rs_kierowcy_przewoznicy pp
                            WHERE p.firma_id=pp.firma_id and p.kierowca_id=pp.kierowca_id
                            """+data+""")
                    ORDER BY kierowca_id )
"""+kierowca.replace('kierowca_id','rk.kod')+""" ORDER BY 1
        """

        stat,dane,wyn1,wyn2=self.PolSQL.Execute(SQL,3, CzyDodawacBlad=True)
        if stat<>'OK':
            stat = 'Bd pobrania kierowcy wersje:' + stat
