#!/usr/bin/python
# -*- coding: iso8859_2 -*-
#-----------------------------------------------------------------------------------------------------------------------
# Name:			fs_kierowcy_wersje_przewoznik_dane.py
# Purpose:		zmiana stawek dla tras
# Author:		Konrad Opieka
# Created:		2017/03/27
# RCS-ID:		$Id: fs_kierowcy_wersje_przewoznik_dane.py $
# Copyright:	(c) 2017 RecordSystem
# Licence:		GNU GPL
#-----------------------------------------------------------------------------------------------------------------------
# 2022-11-29 Aleksander Bargie (13252) Wystawianie faktur dla transportu - okno zlece transportowych(zmiana numerow uprawnien)

stat = 'OK'
wyn2 = []
dane = []

if not 'Funkcja' in klucze:
    stat = 'Brak podanej funkcji w kluczach'

if stat == 'OK':
    Funkcja = klucze['Funkcja']

    SlPar = {'Kod':[1,5]}

    Lista = rsglobal.SprawdzParametryWKluczach(SlPar, Funkcja, klucze)
    if Lista != '':
        stat = "Uwaga: wywoanie funkcji fs_kierowcy_wersje_przewoznik_dane z numerem "+str(Funkcja)+" bez parametrw: "+Lista

if Funkcja in [1,5]:
    Kod = klucze['Kod']

UprEdycja    = (((self.oddzial_id,'103002') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID))
UprUsuwanie  = (((self.oddzial_id,'103004') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID))
UprDodawanie = (((self.oddzial_id,'103003') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID))

if stat == 'OK' and Funkcja == 1:
    Update = klucze['Update']
    Insert = klucze['Insert']
    Delete = klucze['Delete']


#-----------------------------------------------------------------------------------------------------------------------
#-------  SPRAWDZANIE UPDATE
#-----------------------------------------------------------------------------------------------------------------------

if Funkcja == 1 and stat=="OK":
    if len(Update[0])>0:
        if not UprUsuwanie:
            stat='UPR UPD'
            dane.append(stat)


#-----------------------------------------------------------------------------------------------------------------------
#-------  UPDATE SPRAWDZANIE DANYCH
#-----------------------------------------------------------------------------------------------------------------------

        if stat == 'OK':
            for i in xrange(len(Update[0])):
                for j in xrange(len(Update[0][i])):
                    pole = Update[0][i][j]
                    wart = Update[1][i][j]
                    if pole == 'od_dnia':
                        if wart == '    -  -  ':
                            stat = 'BR DATA'
                            dane.append('BR DATA')
                        elif wart != '    -  -  ':
                            if not rsglobal.SprawdzCzyToData(wart):
                                stat = 'BL DATA'
                                dane.append('BL DATA')
                            else:
                                SQL ="SELECT * FROM rs_trasy_przewoznicy WHERE firma_id='"+self.firma_id+"' "
                                SQL+="AND kod='"+Kod+"' AND od_dnia='"+wart+"';"
                                stat,D,dump,dump = self.PolSQL.Execute(SQL,3)
                                if stat != 'OK':
                                    dane.append('BL SPR DATA')
                                elif len(D) > 0:
                                    stat = 'EX DATA'
                                    dane.append('EX DATA')

                    if pole == 'przewoznik_id':
                        if wart == '':
                            stat = 'BR KON'
                            dane.append('BR KON')
                        else:
                            SQL ="SELECT * FROM rs_kontrahenci WHERE firma_id='"+self.firma_id+"' "
                            SQL+="AND kontrahent_id='"+wart+"';"
                            stat,D,dump,dump = self.PolSQL.Execute(SQL,3)
                            if stat != 'OK':
                                dane.append('BL SPR KON')
                            elif len(D) == 0:
                                stat = 'EX KON'
                                dane.append('EX KON')


#-----------------------------------------------------------------------------------------------------------------------
#-------  UPDATE
#-----------------------------------------------------------------------------------------------------------------------

        if stat == 'OK':
            for i in xrange(len(Update[0])):
                UPDATE ="UPDATE rs_trasy_przewoznicy "
                SET ='SET '
                for j in xrange(len(Update[0][i])):
                    pole = Update[0][i][j]
                    wart = Update[1][i][j]
                    if pole in ['od_dnia','przewoznik_id']:
                        SET+=pole+"='"+wart+"',"
                SET=SET.strip(",")
                WHERE=" WHERE firma_id='"+self.firma_id+"' AND kod='"+Kod+"'"
                for j in xrange(len(Update[2][i])): # petla po kluczu
                    pole=Update[3][j]
                    wart=rsglobal.Dekoduj(Update[2][i][j])
                    if pole in ['od_dnia']:
                        WHERE+=" AND "+pole+"='"+wart+"'"
                WHERE+=";"
                SQL=UPDATE+SET+WHERE
                stat,dump,dump,dump=self.PolSQL.Execute(SQL,1)
                if stat != 'OK':
                    dane.append('BL UPD')


#-----------------------------------------------------------------------------------------------------------------------
#-------  SPRAWDZANIE INSERT
#-----------------------------------------------------------------------------------------------------------------------

if Funkcja == 1 and stat=="OK":
    if len(Insert[0])>0:
        if not UprUsuwanie:
            stat='UPR INS'
            dane.append(stat)


#-----------------------------------------------------------------------------------------------------------------------
#-------  INSERT SPRAWDZANIE DANYCH
#-----------------------------------------------------------------------------------------------------------------------

        if stat == 'OK':
            for i in xrange(len(Insert[0])):
                for j in xrange(len(Insert[0][i])):
                    pole=Insert[1][j]
                    wart=Insert[0][i][j]
                    if pole == 'od_dnia':
                        if wart == '    -  -  ':
                            dane.append('BR DATA')
                        elif wart != '    -  -  ':
                            if not rsglobal.SprawdzCzyToData(wart):
                                dane.append('BL DATA')
                            else:
                                SQL ="SELECT * FROM rs_trasy_przewoznicy WHERE firma_id='"+self.firma_id+"' "
                                SQL+="AND kod='"+Kod+"' AND od_dnia='"+wart+"';"
                                stat,D,dump,dump = self.PolSQL.Execute(SQL,3)
                                if stat != 'OK':
                                    dane.append('BL SPR DATA')
                                elif len(D) > 0:
                                    stat = 'EX DATA'
                                    dane.append('EX DATA')

                    if pole == 'przewoznik_id':
                        if wart == '':
                            stat = 'BR KON'
                            dane.append('BR KON')
                        else:
                            SQL ="SELECT * FROM rs_kontrahenci WHERE firma_id='"+self.firma_id+"' "
                            SQL+="AND kontrahent_id='"+wart+"';"
                            stat,D,dump,dump = self.PolSQL.Execute(SQL,3)
                            if stat != 'OK':
                                dane.append('BL SPR KON')
                            elif len(D) == 0:
                                stat = 'EX KON'
                                dane.append('EX KON')


#-----------------------------------------------------------------------------------------------------------------------
#-------  INSERT
#-----------------------------------------------------------------------------------------------------------------------

        if stat=='OK':
            for i in xrange(len(Insert[0])):
                INSERT ="INSERT INTO rs_trasy_przewoznicy "
                KOLUMNY="(firma_id,kod"
                VALUES =" VALUES ('"+self.firma_id+"','"+Kod+"'"
                for j in xrange(len(Insert[0][i])):
                    pole=Insert[1][j]
                    wart=Insert[0][i][j]
                    if pole in ['od_dnia','przewoznik_id']:
                        KOLUMNY+=","+pole
                        VALUES+=",'"+wart+"'"
                KOLUMNY+=")"
                VALUES+=");"
                SQL=INSERT+KOLUMNY+VALUES
                stat,dump,dump,dump=self.PolSQL.Execute(SQL,1)
                if stat != 'OK':
                    dane.append('BL INS')


#-----------------------------------------------------------------------------------------------------------------------
#-------  SPRAWDZANIE DELETE
#-----------------------------------------------------------------------------------------------------------------------

if Funkcja == 1 and stat=="OK":
    if len(Delete[0])>0:
        if not UprUsuwanie:
            stat='UPR DEL'
            dane.append(stat)


#-----------------------------------------------------------------------------------------------------------------------
#-------  DELETE
#-----------------------------------------------------------------------------------------------------------------------

        if stat=='OK':
            for i in xrange(len(Delete[0])):
                DELETE = "DELETE FROM rs_trasy_przewoznicy "
                DELETE+= "WHERE firma_id='"+self.firma_id+"' AND kod='"+Kod+"'"
                for j in xrange(len(Delete[0][i])):
                    pole=Delete[1][j]
                    wart=Delete[0][i][j]
                    if pole in ['od_dnia']:
                        DELETE+= " AND "+pole+"='"+wart+"'"

                DELETE+= ";"
                stat,dump,dump,dump=self.PolSQL.Execute(DELETE,1)
                if stat<>'OK':
                    stat='BL DEL'
                    dane.append(stat)


#-----------------------------------------------------------------------------------------------------------------------
#-------  POBRANIE
#-----------------------------------------------------------------------------------------------------------------------

if stat=='OK' and Funkcja in [1, 5]:
    SQL ="SELECT od_dnia, przewoznik_id, nazwa FROM rs_trasy_przewoznicy tp "
    SQL+="INNER JOIN rs_kontrahenci k ON (tp.firma_id=k.firma_id AND tp.przewoznik_id=k.kontrahent_id) "
    SQL+="WHERE tp.firma_id='" + self.firma_id + "' AND kod='"+Kod+"' ORDER BY 1;"
    stat,dane,wyn1,wyn2=self.PolSQL.Execute(SQL,3)
    if stat<>'OK':
        stat = 'BL POB'
