# -*- coding: iso8859_2 -*-
#-----------------------------------------------------------------------------
# Name:        fs_komser_dowody_dostaw.py
# Purpose:     przetwarza dane dowodu dostaw otrzymane z innego serwera
#              wstawia tylko otrzymane dane do bazy
#
# Author:      Piotr Szydeko
# Created:     2008/12/12
# Copyright:   (c) 2006 Record System
# Licence:     GNU GPL
#-----------------------------------------------------------------------------
if isinstance(klucze, dict):
    wartosci = wartosci + [klucze['dodatkoweDane']]
    klucze = [klucze['TrasaF'], klucze['Data'], klucze['Tryb'], klucze['Numer'], klucze['TrasaF'], klucze['DataOdF'],
    klucze['DataDoF'], klucze['TrybF'], klucze['KontrF'], klucze['StanF'], [], klucze['KontrahentN'], 
    klucze['KorektaF'], klucze['RzutF'], klucze['Oddzial'], klucze['NiewyeksportowaneF'], klucze['NiezwroconeF'],
    klucze['Funkcja']] + ["dodatkoweDane"]
print 'KLUCZE', klucze
print type(klucze)
def zrobSQL(tabela, dane, podstaw={}):
    pol = []
    wart = []
    for k, v in dane:
        pol.append(k)
        if k in podstaw:
            v = podstaw[k]
        wart.append(rsglobal.Dekoduj(v))
    return "INSERT INTO %s(%s) VALUES(%s)" % (tabela, ",".join(pol), "%s," * (len(wart) - 1) + "%s"), wart

dodatkoweDane = []
stat = "OK"
# nie przekazuj do pozostaych serwerw po wykonaniu
wyn2 = False

if klucze[-1] == "dodatkoweDane":
    dodatkoweDane = wartosci.pop()
    klucze.pop()

if klucze[-1] not in (12, 19, 13):
    stat = "BLAD nieprawidlowy kod operacji: %s" % klucze[-1]

# wstawienie do bazy otrzymanego dowodu dostawy wraz z pozycjami
if stat == "OK" and klucze[-1] in (12, 19):
    if not dodatkoweDane:
        stat = "BLAD brak danych"

    for typ, pwar in dodatkoweDane:
        if typ == "DOW_DOST":
            query, dane = zrobSQL("rs_dowody_dostaw", pwar, {'kierowca': '0000', 'stan': '1'})
        elif typ == "DDOSTPOZ":
            query, dane = zrobSQL("rs_dowody_dostaw_pozycje", pwar)
        else:
            stat = "BLAD nie rozpoznaje klucza %s" % repr(typ)
            break
        stat, none, none, none = self.PolSQL.Execute(query, 1, dane)
        if stat != "OK":
            break

elif stat == "OK" and klucze[-1] == 13:
    # nie commituj po kadym wykonaniu funkcji, eby nie zostawi poowy pracy
    self.zdalne_zlecenie[1] = False

    # otwrz
    if stat == "OK":
        stat, dane, none, none = self.WykonajFunkcje("fs_dowody_dostaw", klucze, pola, wartosci)
    # usu
    if stat == "OK":
        klucze[-1] = 6
        stat, dane, none, none = self.WykonajFunkcje("fs_dowody_dostaw", klucze, pola, wartosci)
