# -*- coding: iso8859_2 -*-

#-------------------------------------------------------------------------------
# Name:        fs_konta_analityczne.py
# Purpose:     obsluga kont analitycznych
#
# Author:      Mariusz Rajfura
# Created:     2009/09/05
# RCS-ID:      $Id: fs_konta_analityczne.py $
# Copyright:   (c) 2009 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

from funkcje import fs_sprawdz_analityke

Grupa = rsglobal.Dekoduj(klucze[0])
KontoA = rsglobal.Dekoduj(klucze[1])

Fun = klucze[-1]
stat = 'OK'
dane = []
wyn1 = []

UprUsuwanie = (((self.oddzial_id,'072024') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID)
        
#-------------------------------------------------------------------------------
# DELETE - 6
#-------------------------------------------------------------------------------

if Fun == 6:
    if UprUsuwanie:
        sql ="SELECT kontoa_id FROM rs_konta_analityczne WHERE firma_id = '"+self.firma_id+"'"
        sql+=" AND okres_id = '"+self.okres_id+"' AND grupa_id = '"+Grupa+"' AND kontoa_id = '"+KontoA+"' FOR UPDATE NOWAIT;"
        stat,d,dump,dump = self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Bd pobrania informacji o koncie analitycznym : '+stat
        else:
            if len(d) == 0:
                stat = 'Konto o podanym numerze nie istnieje.'
                
        if stat == 'OK':
            #sprawdzenie, czy podane konto analityczne jest uzyte w dowodach ksiegowych
            stat = fs_sprawdz_analityke.CzyMoznaUsunac(self,'rs_konta_analityczne',KontoA,Grupa)
            
        if stat == 'OK':
            sql ="DELETE FROM rs_konta_analityczne WHERE firma_id = '"+self.firma_id+"'"
            sql+=" AND okres_id = '"+self.okres_id+"' AND grupa_id = '"+Grupa+"' AND kontoa_id = '"+KontoA+"';"
            stat,d,dump,dump = self.PolSQL.Execute(sql,1)
            if stat <> 'OK':
                stat = 'Bd usuwania konta analitycznego : '+stat
    else:
        stat = 'Brak uprawnie do usuwania kont analitycznych.'

#-------------------------------------------------------------------------------
# SELECT 5,6
#-------------------------------------------------------------------------------

if Fun in (5,6) and stat == 'OK':
    sql ="SELECT kontoa_id,nazwa FROM rs_konta_analityczne WHERE firma_id = '"+self.firma_id+"'"
    sql+=" AND okres_id = '"+self.okres_id+"' AND grupa_id = '"+Grupa+"' ORDER BY kontoa_id;"
    stat,dane,wyn1,dump = self.PolSQL.Execute(sql, 3)
    if stat <> 'OK':
        stat = 'Bd pobrania listy kont analitycznych analitycznych : '+stat
