# -*- coding: iso8859_2 -*-
#-----------------------------------------------------------------------------
# Name:        fs_konta_bankowe.py
# Purpose:     wczytuje/usuwa dane z rs_konta_bankowe
# Author:      Dariusz Boduch
# Created:     2008/10/27
# RCS-ID:      $Id: fs_konta_bankowe.py $
# Copyright:   (c) 2006 Record System
# Licence:     GNU GPL
#-----------------------------------------------------------------------------
# 2016-07-08 Piotr Witkowski (9943) Dodatkowe pole 'IBAN' w kontach bankowych plus refaktoryzacja

stat='OK'
if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=='OK':
    Funkcja = klucze['Funkcja']
    SlPar={'KontoId':[6,],}

    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Funkcja,klucze)
    if Lista<>'':
        stat='Uwaga : wywoanie funkcji fs_konta_bankowe z numerem ' +str(Funkcja)+' bez parametrw: '+Lista

if stat=='OK':
    if Funkcja in [6,]:
        KontoId = klucze['KontoId']

if stat=='OK':
    dane = []
    wyn1 = []
    wyn2 = []

#---   DELETE DANYCH (6)
if stat == 'OK' and Funkcja == 6:
    if not (((self.oddzial_id,"014054") in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)):
        stat=u'Brak uprawnie do usunicia konta'

    if stat =='OK':
        sql="select 1 from rs_wzory_dekretacji WHERE konto_id='"+KontoId+"' AND firma_id ='"+self.firma_id+"' LIMIT 1;"
        stat,d,dump,dump = self.PolSQL.Execute(sql,3)
        if stat=='OK' and len(d)>0:
            stat=u'Nie mona usun konta, gdy jest powizane z wzorami dekretacji'

    if stat =='OK':
        sql="select 1 from rs_kasy_banki WHERE konto_id='"+KontoId+"' AND firma_id ='"+self.firma_id+"' LIMIT 1;"
        stat,d,dump,dump = self.PolSQL.Execute(sql,3)
        if stat=='OK' and len(d)>0:
            stat=u'Nie mona usun konta, gdy jest powizane z kasy banki'

    if stat =='OK':
        sql="select 1 from rs_kp_szablony_list_plac WHERE konto_id='"+KontoId+"' AND firma_id ='"+self.firma_id+"' LIMIT 1;"
        stat,d,dump,dump = self.PolSQL.Execute(sql,3)
        if stat=='OK' and len(d)>0:
            stat=u'Nie mona usun konta, gdy jest powizane z szablonami list pac'

    if stat =='OK':
        sql="select 1 from rs_kp_listy_plac WHERE konto_id='"+KontoId+"' AND firma_id ='"+self.firma_id+"' LIMIT 1;"
        stat,d,dump,dump = self.PolSQL.Execute(sql,3)
        if stat=='OK' and len(d)>0:
            stat=u'Nie mona usun konta, gdy jest powizane z listami pac'

    if stat =='OK':
        sql="select 1 from rs_kontrahenci_fakturowanie WHERE konto_id='"+KontoId+"' AND firma_id ='"+self.firma_id+"' LIMIT 1;"
        stat,d,dump,dump = self.PolSQL.Execute(sql,3)
        if stat=='OK' and len(d)>0:
            stat=u'Nie mona usun konta, gdy jest powizane z fakturowaniem kontrahentw'

    if stat =='OK':
        sql="select 1 from rs_platnosci WHERE konto_id='"+KontoId+"' AND firma_id ='"+self.firma_id+"' LIMIT 1;"
        stat,d,dump,dump = self.PolSQL.Execute(sql,3)
        if stat=='OK' and len(d)>0:
            stat=u'Nie mona usun konta, gdy jest powizane z patnociami'

    if stat =='OK':
        sql="select 1 from rs_dowody_ksiegowe WHERE konto_id='"+KontoId+"' AND firma_id ='"+self.firma_id+"' LIMIT 1;"
        stat,d,dump,dump = self.PolSQL.Execute(sql,3)
        if stat=='OK' and len(d)>0:
            stat=u'Nie mona usun konta, gdy jest powizane z dowodami ksigowymi'

    if stat =='OK':
        sql="DELETE FROM rs_konta_bankowe WHERE konto_id='"+KontoId+"' AND firma_id ='"+self.firma_id+"';"
        stat,dump,dump,dump = self.PolSQL.Execute(sql,1)
        if stat<>'OK':
            stat=u'Wystpiy bdy przy usuwaniu konta'

#--- POBIERANIE DANYCH (5 -look, 6 -delete)
if stat== 'OK' and Funkcja in [5,6,] :
    if not (((self.oddzial_id,"014050") in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)):
        stat=u'Brak uprawnie do przegldania konta'

    if stat =='OK':
        Select  = "SELECT konto_id, bank, konto, pli_typ "
        Select += "FROM rs_konta_bankowe "
        Select += "WHERE firma_id='"+self.firma_id+"' ORDER BY konto_id;"
        stat,dane,wyn1,tr =self.PolSQL.Execute(Select,3)
        if stat<>'OK':
            stat=u'Wystpiy bdy przy pobieraniu danych'