# -*- coding: iso8859_2 -*-
#-----------------------------------------------------------------------------
# Name:        fs_kontrahenci_artykuly_obce_dane.py
# Purpose:     pobiera liste cen
# Author:      Marcin Grzeda
# Created:     2007/03/26
# RCS-ID:      $Id: fs_kontrahenci_artykuly_obce_dane.py $
# Copyright:   (c) 2007 Record System
# Licence:     GNU GPL
#-----------------------------------------------------------------------------

Kontrahent=klucze[0]
Artykul=klucze[1]
Fun=klucze[-1]
stat='OK'
dane=[]
d=[]

if self.operator_id != STANDARD_OPERATOR_ID:
    UprPrzegladanie = ((self.oddzial_id,'012090') in self.uprawnienia)
    UprModyfikowanie=((self.oddzial_id,'012092') in self.uprawnienia)
    UprDodawanie=((self.oddzial_id,'012093') in self.uprawnienia)
else:
    UprPrzegladanie = True
    UprModyfikowanie=True
    UprDodawanie=True

if Fun in [3,4,5]:
    if Artykul=='':
        stat='BR ART1'
        dane.append(stat)
    else:
        Sql="SELECT * FROM rs_artykuly WHERE firma_id='"+self.firma_id+"' AND artykul_id='"+Artykul+"'"
        st,d,dump,dump=self.PolSQL.Execute(Sql,3)
        if len(d)==0:
            stat='BL ART1'
            dane.append(stat)
        
    if Kontrahent=='':
        stat='BR KONTR1'
    else:
        Sql="SELECT * FROM rs_kontrahenci WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+Kontrahent+"'"
        st,d,dump,dump=self.PolSQL.Execute(Sql,3)
        if len(d)==0:
            stat='BL KONTR1'
            dane.append(stat)    

if Fun in [1,2,3,4]:
    for i in range(len(pola)):
        pole = pola[i]
        wart = wartosci[i]
        if pole=='artykul_id':
            if wart=='':
                stat='BR ART'
            else:
                Sql="SELECT * FROM rs_artykuly WHERE firma_id='"+self.firma_id+"' AND artykul_id='"+wart+"'"
                st,d,dump,dump=self.PolSQL.Execute(Sql,3)
                if len(d)==0:
                    stat='BL ART'
                    dane.append(stat)
    
        elif pole=='kontrahent_id' :
            if wart=='':
                stat='BR KONTR'
            else:
                Sql="SELECT * FROM rs_kontrahenci WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+wart+"'"
                st,d,dump,dump=self.PolSQL.Execute(Sql,3)
                if len(d)==0:
                    stat='BL KONTR'
                    dane.append(stat)

if len(dane)>0:
    stat=dane[-1]


#-------------------------------------------------------------------------------
#   DODANIE DANYCH (1 -select, 2 -update z pobraniem)
#-------------------------------------------------------------------------------
if stat == "OK" and Fun in [2,1]:
    if UprDodawanie:
        sql = "INSERT INTO rs_artykuly_obce"
        PolaN="firma_id"
        WartosciN = "'"+self.firma_id+"'"
        for i in range(len(pola)):
            pole = pola[i]
            wart = wartosci[i]
            if pole in ['kontrahent_id','artykul_id','obcy_id','obca_nazwa','obcy_ean','obca_jm']:
                PolaN += ","+pole
                WartosciN += ",'"+str(wart)+"'"
            if pole=='kontrahent_id':
                Kontrahent=wart
            if pole=='artykul_id':
                Artykul=wart
        if ('kontrahent_id' in pola) or ('artykul_id' in pola):
            select="SELECT * FROM rs_artykuly_obce WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+Kontrahent+"' AND artykul_id='"+Artykul+"'"
            st,d,dump,dump=self.PolSQL.Execute(select,3)
            if len(d)>0:
                stat='DANE ISTN'
                dane.append(stat)
        if stat=='OK': 
            sql += " ("+PolaN+") VALUES ("+WartosciN+");"
            stat,dump,dump,dump = self.PolSQL.Execute(sql ,1)
            if stat<>'OK':
                stat='BL INS'
                dane.append(stat)
    else:
        stat='UPR INS'
        dane.append(stat)


#-------------------------------------------------------------------------------
#   UPDATE DANYCH ( 3-select, 4 -update z pobraniem)
#-------------------------------------------------------------------------------
if (Fun in (3,4)) and stat=='OK': 
    if UprModyfikowanie :
        sql = "UPDATE rs_artykuly_obce SET firma_id='"+self.firma_id+"'"
        Where=" WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+Kontrahent+"' AND artykul_id='"+Artykul+"'"
        for i in range(len(pola)):
            pole = pola[i]
            wart = wartosci[i]
            if pole in ['kontrahent_id','artykul_id','obcy_id','obca_nazwa','obcy_ean','obca_jm']:
                sql+=","+pole+"='"+wart+"'"
            if pole=='kontrahent_id':
                Kontrahent=wart
            if pole=='artykul_id':
                Artykul=wart
        
        if ('kontrahent_id' in pola) or ('artykul_id' in pola):
            select="SELECT * FROM rs_artykuly_obce WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+Kontrahent+"' AND artykul_id='"+Artykul+"'"
            st,d,dump,dump=self.PolSQL.Execute(select,3)
            if len(d)>0:
                stat='DANE ISTN'
                dane.append(stat)
        if stat=='OK':
            sql+=Where
            stat,dump,dump,dump = self.PolSQL.Execute(sql ,1)
            if stat<>'OK':
                stat='BL UPD'
                dane.append(stat)
            
    else:
        stat="UPR UPD"   
        dane.append(stat)
    

#-------------------------------------------------------------------------------
#   POBRANIE DANYCH ( 5-select, 3 -update z pobraniem)
#-------------------------------------------------------------------------------
if (stat=='OK') and (Fun in [1,5,3]):
    if UprPrzegladanie:
        sel="SELECT * FROM rs_artykuly_obce "
        where=" WHERE kontrahent_id='"+Kontrahent+"' AND artykul_id='"+Artykul+"' AND firma_id='"+self.firma_id+"'"
        sql=sel+where
        stat,dane,wyn1,dump = self.PolSQL.Execute(sql,3)
        if stat!="OK":
            stat="BL PRZ"   
            dane.append(stat)
        else:
            if len(dane)==1:
                tr = rssql.RSTableRowset(dane,wyn1)
                
                #--- kontrahent
                if ((self.oddzial_id,'012010') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
                    dump,d,dump,dump = self.PolSQL.Execute("SELECT nazwa FROM rs_kontrahenci WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+tr.GetVal(0,"kontrahent_id")+"';" ,3)
                    if len(d) == 0:
                        wyn2.append('')
                    else:
                        wyn2.append(d[0][0])
                else:
                    wyn2.append('Brak uprawnie do sownika. Poinformuj administratora.')    
    
                
                
                #--- artykul
                if ((self.oddzial_id,'012010') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
                    dump,d,dump,dump = self.PolSQL.Execute("SELECT nazwa FROM rs_artykuly WHERE firma_id='"+self.firma_id+"' AND artykul_id='"+tr.GetVal(0,"artykul_id")+"';" ,3)
                    if len(d) == 0:
                        wyn2.append('')
                    else:
                        wyn2.append(d[0][0])
                else:
                    wyn2.append('Brak uprawnie do sownika. Poinformuj administratora.')

    else:
        stat='UPR PRZ'
        dane.append(stat)
        

