# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_kontrahenci_osoby_dane.py
# Purpose:     dziaania na osobach odpowiedzialnych danego kontrahenta 
# Author:      Wjcikowski Pawe
# Created:     2009/05/07
# RCS-ID:      $Id: fs_kontrahenci_osoby_dane.py $
# Copyright:   (c) 2009 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

# 2012-01-19 Mariusz Rajfura  popr.bledu przy UPDATE (5400)

Kontrahent = rsglobal.Dekoduj(klucze[0]).strip()
Symbol = rsglobal.Dekoduj(klucze[1]).strip()
Fun = klucze[-1]

stat = "OK"
dane = []
wyn1 = []
wyn2 = []
Dane = [] 
  
UprDodawanie=(((self.oddzial_id,'012033') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID))
UprEdycja=(((self.oddzial_id,'012032') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID) or UprDodawanie)
        
        
#-------------------------------------------------------------------------------
#---   SPRAWDZENIE DANYCH (1,2 - insert  3,4-update)
#-------------------------------------------------------------------------------

if Fun in [1,2,3,4] and stat=='OK':
    Stanowisko = None
    
    if Fun in (1,2):
        if Symbol == '':
            stat='BR SYMBOL'
            dane.append(stat)

        if stat=='OK':
            sql ="SELECT osoba_id FROM rs_kontrahenci_osoby"
            sql+=" WHERE firma_id='"+self.firma_id+"' AND osoba_id='"+Symbol+"'"
            sql+=" AND kontrahent_id='"+Kontrahent+"';"
            stat,d,dump,dump=self.PolSQL.Execute(sql,3)
            if stat<>'OK':
                stat = 'Bdy przy sprawdzaniu osoby: '+stat
                dane.append(stat)
            elif len(d) > 0:
                stat='BL SYMBOL IST'
                dane.append(stat)
                
    elif Fun in (3,4):
        sel ="SELECT osoba_id FROM rs_kontrahenci_osoby"
        sel+=" WHERE firma_id='"+self.firma_id+"' AND osoba_id='"+Symbol+"'"
        sel+=" AND kontrahent_id='"+Kontrahent+"' FOR UPDATE NOWAIT;"
        stat,daneO,dump,dump=self.PolSQL.Execute(sel,3)
        if stat<>'OK':
            stat = 'Bdy przy sprawdzaniu osoby :'+stat
            dane.append(stat)
        elif len(daneO) == 0:
            stat='BR SYMBOL'
            dane.append(stat)

    
    if stat == 'OK':
        for i in range(len(pola)):
            pole = pola[i]
            wart = wartosci[i]

            if pole == 'imie':
                wart = wart.strip()
                if wart == '':
                    stat = 'BR IMIE'
                    dane.append(stat)

            elif pole == 'nazwisko':
                wart = wart.strip()
                if wart == '':
                    stat = 'BR NAZWISKO'
                    dane.append(stat)
            
            elif pole == 'stanowisko':
                wart = wart.strip()
                Stanowisko = wart
                if wart == '':
                    stat = 'BR STANOWISKO'
                    dane.append(stat)
                else:
                    sql ="SELECT kod FROM rs_stanowiska"
                    sql+=" WHERE firma_id='"+self.firma_id+"' AND kod='"+wart+"';"
                    stat,d,dump,dump=self.PolSQL.Execute(sql,3)
                    if stat <> 'OK':
                        stat = 'Bdy sprawdzania stanowiska: '+stat
                        dane.append(stat)
                    elif len(d) == 0:
                        stat='BL STANOWISKO'
                        dane.append(stat)   
                
            elif pole == 'wyksztalcenie':
                wart = wart.strip()
                if wart <> '':
                    sql ="SELECT kod FROM rs_wyksztalcenie"
                    sql+=" WHERE firma_id='"+self.firma_id+"' AND kod='"+wart+"';"
                    stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                    if stat<>'OK':
                        stat = 'Bd sprawdzenia kodu wyksztacenia: '+stat
                        dane.append(stat)                        
                    elif len(d) == 0:
                        stat = 'BL WYKSZTALCENIE'
                        dane.append(stat)


    # jesli byly jakies bledy w polach
    if stat=='OK':
        if len(dane)>0:
            stat = dane[0]
            
    if Fun in (1,2) and stat == 'OK':
        if Stanowisko == None:
            stat = 'BR STANOWISKO'
            dane.append(stat)

                 
#-------------------------------------------------------------------------------
#---   INSERT DANYCH (2- bez pobierania,1- z pobieraniem)
#-------------------------------------------------------------------------------

if Fun in (1,2) and stat=='OK':
    if not UprDodawanie:
        stat = 'UPR INS'
    
    if stat == 'OK':            
        INSERT = "INSERT INTO rs_kontrahenci_osoby"
        Pola = "firma_id,kontrahent_id,osoba_id"
        Wartosci = "'"+self.firma_id+"','"+Kontrahent+"','"+Symbol+"'"
        
        for i in range(len(pola)):
            pole = pola[i]
            wart = wartosci[i]
            
            if pole in ['imie','nazwisko','stanowisko','wyksztalcenie',
                        'tel1','tel2','fax','email','samochod','opis','szkolenia']:
                Pola += ","+pole
                wart = wart.strip()
                if wart == '':
                    Wartosci += ",NULL"
                else:
                    Wartosci += ",'"+wart+"'"
                    
        INSERT += " ("+Pola+") VALUES ("+Wartosci+");"        
        stat,dump,dump,dump = self.PolSQL.Execute(INSERT ,1)
        if stat <> 'OK':
            stat = 'Bdy dodawania danych:'+stat
            dane.append(stat)             
           
           
#-------------------------------------------------------------------------------
#---   UPDATE DANYCH (4- bez pobierania,3- z pobieraniem)
#-------------------------------------------------------------------------------

if Fun in [3,4] and stat=='OK':
    if not UprEdycja:
        stat = 'UPR UPD'

    if stat=='OK':
        UPDATE = "UPDATE rs_kontrahenci_osoby SET "
        WHERE = " WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+Kontrahent+"' AND osoba_id='"+Symbol+"'; "

        for i in range(len(pola)):
            pole = pola[i]
            wart = wartosci[i]
            
            if pole in ('imie','nazwisko','stanowisko','wyksztalcenie',
                        'tel1','tel2','fax','email','samochod','opis','szkolenia'):
                wart = wart.strip()
                
                if i > 0:
                    UPDATE += ","
                
                if wart in ('    -  -  ',''):
                    UPDATE += pole+"=NULL"
                else:
                    UPDATE += pole+"='"+wart+"'"
                    
        UPDATE +=" WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+Kontrahent+"'"
        UPDATE +=" AND osoba_id='"+Symbol+"';"
        
        stat,dump,dump,dump = self.PolSQL.Execute(UPDATE ,1)
        if stat<>'OK':
            stat = 'Bdy modyfikowania danych:'+stat
            dane.append(stat)    
         
         
#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (5 -select)
#-------------------------------------------------------------------------------

if Fun in (5,3,1) and stat == 'OK':
    Select= "SELECT * FROM rs_kontrahenci_osoby WHERE osoba_id='"+Symbol+"'" 
    Select+= " AND firma_id='"+self.firma_id+"' AND kontrahent_id='"+Kontrahent+"';"
    stat,dane,wyn1,tr = self.PolSQL.Execute(Select,3)
    if stat<>'OK':
        stat = 'Bdy pobierania danych:'+stat
        dane.append(stat)

    if stat=='OK' and len(dane)==1:
        tr = rssql.RSTableRowset(dane,wyn1)
        
        # stanowisko [0]
        if (self.oddzial_id,'011080') in self.uprawnienia or self.operator_id == STANDARD_OPERATOR_ID:
            sql ="SELECT opis FROM rs_stanowiska"
            sql+=" WHERE firma_id='"+self.firma_id+"' AND kod='"+tr.GetVal(0,"stanowisko")+"';"
            stat,d,dump,dump = self.PolSQL.Execute(sql, 3)
            if stat <> 'OK':
                wyn2.append('Bd pobrania opisu ze sownika stanowisk: '+stat)
            elif len(d) == 0:
                wyn2.append('')
            else:
                wyn2.append(rsglobal.Dekoduj(d[0][0]))
        else:
            wyn2.append('Brak uprawnie do sownika. Poinformuj administratora.')

        # wyksztalcenie [1]
        if (self.oddzial_id,'011480') in self.uprawnienia or self.operator_id == STANDARD_OPERATOR_ID:
            sql ="SELECT opis FROM rs_wyksztalcenie"
            sql+=" WHERE firma_id='"+self.firma_id+"' AND kod='"+tr.GetVal(0,"wyksztalcenie")+"';"
            stat,d,dump,dump = self.PolSQL.Execute(sql, 3)
            if stat <> 'OK':
                wyn2.append('Bd pobrania opisu ze sownika wyksztacenia: '+stat)
            elif len(d) == 0:
                wyn2.append('')
            else:
                wyn2.append(rsglobal.Dekoduj(d[0][0]))
        else:
            wyn2.append('Brak uprawnie do sownika. Poinformuj administratora.')
