# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_kontrahenci_trasy.py
# Purpose:     wczytuje/usuwa trase dla kontrahenta
#
# Author:      Marcin Grzeda
# Created:     2006/10/28
# RCS-ID:      $Id: fs_kontrahenci_trasy.py $
# Copyright:   (c) 2006 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

Kontrahent = rsglobal.Dekoduj(klucze[0])
Trasa = rsglobal.Dekoduj(klucze[1])
DataOd = rsglobal.Dekoduj(klucze[2])

Fun = klucze[-1]
dane = []
wyn1 = []
stat = 'OK'

#-------------------------------------------------------------------------------
#--- DELETE - 6
#-------------------------------------------------------------------------------

if Fun == 6:
    if not ((self.oddzial_id,'012054') in self.uprawnienia or self.operator_id == STANDARD_OPERATOR_ID):
        stat='Brak uprawnie do usuwania tras kontrahenta.'
    
    if stat == 'OK':
        sql ="DELETE FROM rs_kontrahenci_trasy"
        sql+=" WHERE firma_id = '"+self.firma_id+"' AND kontrahent_id='"+Kontrahent+"'"
        sql+=" AND trasa = '"+Trasa+"' AND data_od= '"+DataOd+"';" 
        stat,dump,dump,dump = self.PolSQL.Execute(sql,1)
        if stat <> 'OK':
            stat='Bd usuwania trasy dla kontrahenta : '+stat

#-------------------------------------------------------------------------------
#---- SELECT - 5 Pobieranie listy tras dla kontrahenta
#-------------------------------------------------------------------------------

if Fun in [5,6] and stat == 'OK':
    sql ="SELECT tr.oddzial_id,kt.trasa||' - '||tr.opis,kt.data_od,kt.data_do "
    sql+=" FROM rs_kontrahenci_trasy kt " 
    sql+=" INNER JOIN rs_trasy tr ON kt.firma_id = tr.firma_id AND kt.trasa = tr.kod " 
    sql+=" WHERE kt.firma_id = '"+self.firma_id+"' AND kt.kontrahent_id = '"+Kontrahent+"'"
    sql+=" ORDER BY kt.trasa,kt.data_od;"
    
    stat,dane,wyn1,dump =self.PolSQL.Execute(sql,3)
    if stat <> 'OK':
        stat='Bd pobrania listy tras dla kontrahenta : '+stat
