# -*- coding: iso8859_2 -*-
# -------------------------------------------------------------------------------
# Name:        fs_kp_angaze.py
# Purpose:     odsluga grida angazy dla pracownika
#
# Author:      Mariusz Rajfura
# Created:     2009/09/26
# RCS-ID:      $Id: fs_kp_angaze.py $
# Copyright:   (c) 2009 Record System
# Licence:     GNU GPL
# -------------------------------------------------------------------------------

# 2019-06-27 Wojciech Skowron - (11529) Kolumny dodatek_fun i kategoria_zaszeregowania

Pracownik = rsglobal.Dekoduj(klucze[0])
Zatrudnienie = klucze[1]
Umowa = klucze[2]
Angaz = klucze[3]
OdKiedyF = rsglobal.Dekoduj(klucze[4][0])
DoKiedyF = rsglobal.Dekoduj(klucze[4][1])
KomorkaF = rsglobal.Dekoduj(klucze[4][2])
StanowiskoF = rsglobal.Dekoduj(klucze[4][3])
Wszystkie = rsglobal.Dekoduj(klucze[4][4])

Klucze_Id = klucze[5]

Fun = klucze[-1]
dane = []
wyn1 = []
wyn2 = []
stat = 'OK'

sql = "SELECT rsf_kadry_dozwolony_modul('" + self.firma_id + "','" + str(
    self.operator_id) + "','angaze','" + Pracownik + "');"
stat, d, dump, dump = self.PolSQL.Execute(sql, 3)
if stat == 'OK':
    stat == d[0][0]

UprUsuwanie = ((self.oddzial_id, '052044') in self.uprawnienia or self.operator_id == STANDARD_OPERATOR_ID)

# -------------------------------------------------------------------------------
# --- POBRANIE PODSTAWOWYCH DANYCH OSTATNIEGO ANGAZU Z OSTATNIEJ UMOWY - 9
# --- do ustawienia okna: edycja/przegladanie/skopiowanie danych do nowego
# -------------------------------------------------------------------------------

if Fun == 9 and stat == 'OK':
    if Umowa == 0:
        sql = "SELECT MAX(umowa_id) FROM rs_kp_umowy_o_prace"
        sql += " WHERE firma_id = '" + self.firma_id + "' AND pracownik_id = '" + Pracownik + "'"
        sql += " AND zatrudnienie_id = " + str(Zatrudnienie)

        stat, d, dump, dump = self.PolSQL.Execute(sql, 3)
        if stat <> 'OK':
            stat = 'Bd pobrania ostatniego numeru umowy : ' + stat
        elif len(d) == 0:
            stat = 'Brak jakiejkolwiek umowy o prac'

        if stat == 'OK':
            sql = "SELECT od_kiedy FROM rs_kp_umowy_o_prace"
            sql += " WHERE firma_id = '" + self.firma_id + "' AND pracownik_id = '" + Pracownik + "'"
            sql += " AND zatrudnienie_id = " + str(Zatrudnienie) + " AND umowa_id = " + str(d[0][0]) + ";"
            stat, wyn1, dump, dump = self.PolSQL.Execute(sql, 3)
            if stat <> 'OK':
                stat = 'Bd pobrania daty_od ostatniego numeru umowy : ' + stat
        Umowa = d[0][0]

    if stat == 'OK':
        sql = "SELECT MAX(angaz_id) FROM rs_kp_angaze"
        sql += " WHERE firma_id = '" + self.firma_id + "' AND pracownik_id = '" + Pracownik + "'"
        sql += " AND zatrudnienie_id = " + str(Zatrudnienie) + " AND umowa_id = " + str(Umowa) + ";"

        stat, d, dump, dump = self.PolSQL.Execute(sql, 3)
        if stat <> 'OK':
            stat = 'Bd pobrania ostatniego numeru angau z ostatniej umowy : ' + stat
        elif len(d) == 1:
            Angaz = d[0][0]

        if stat == 'OK':
            sql = "SELECT zatrudnienie_id,umowa_id,angaz_id,od_kiedy,do_kiedy FROM rs_kp_angaze"
            sql += " WHERE firma_id = '" + self.firma_id + "' AND pracownik_id = '" + Pracownik + "'"
            sql += " AND zatrudnienie_id = " + str(Zatrudnienie) + "AND umowa_id = " + str(
                Umowa) + " AND angaz_id = " + str(Angaz) + ";"

            stat, dane, dump, dump = self.PolSQL.Execute(sql, 3)
            if stat <> 'OK':
                stat = 'Bd pobrania danych ostatniego angau : ' + stat

# -------------------------------------------------------------------------------
# --- DELETE - 6
# -------------------------------------------------------------------------------

if Fun == 6 and stat == 'OK':
    if not UprUsuwanie:
        stat = 'Brak uprawnie do usuwania angau.'

    if stat == 'OK':
        sql = "SELECT angaz_id FROM rs_kp_angaze"
        sql += " WHERE firma_id = '" + self.firma_id + "' AND pracownik_id = '" + Pracownik + "'"
        sql += " AND zatrudnienie_id = " + str(Zatrudnienie) + " AND umowa_id = " + str(Umowa)
        sql += " AND angaz_id = " + str(Angaz) + " FOR UPDATE NOWAIT;"
        stat, d, dump, dump = self.PolSQL.Execute(sql, 3)
        if stat <> 'OK':
            stat = 'Bd pobrania danych angau dla pracownika : ' + stat
        elif len(d) == 0:
            stat = 'Brak angau o podanym numerze : ' + stat

        if stat == 'OK':
            sql = "SELECT MAX(angaz_id) FROM rs_kp_angaze"
            sql += " WHERE firma_id = '" + self.firma_id + "' AND pracownik_id = '" + Pracownik + "'"
            sql += " AND zatrudnienie_id = " + str(Zatrudnienie) + " AND umowa_id = " + str(Umowa) + ";"
            stat, d, dump, dump = self.PolSQL.Execute(sql, 3)
            if stat <> 'OK':
                stat = 'Bd pobrania informacji o licie angay dla pracownika : ' + stat
            elif d[0][0] > Angaz:
                stat = 'Usunicie niemoliwe. Mona usun tylko ostatni anga.'

        if stat == 'OK':
            sql = "SELECT numer_listy_id FROM rs_kp_listy_plac_osoby "
            sql += " WHERE firma_id = '" + self.firma_id + "' AND pracownik_id = '" + Pracownik + "'"
            stat, d, dump, dump = self.PolSQL.Execute(sql, 3)
            if stat <> 'OK':
                stat = 'Bd sprawdzenia, czy pracownik wystpuje na licie pac : ' + stat
            elif len(d) > 0:
                lista = ''
                for numer in d:
                    lista += str(numer[0]) + ', '
                stat = "Pracownik znajduj si na licie pac: " + lista.strip(', ')

        if stat == 'OK':
            DELETE = "DELETE FROM rs_kp_angaze"
            DELETE += " WHERE firma_id = '" + self.firma_id + "' AND pracownik_id = '" + Pracownik + "'"
            DELETE += " AND zatrudnienie_id = " + str(Zatrudnienie) + "AND umowa_id = " + str(Umowa)
            DELETE += " AND angaz_id = " + str(Angaz) + ";"
            stat, dump, dump, dump = self.PolSQL.Execute(DELETE, 1)
            if stat <> 'OK':
                stat = 'Bd usuwania angau dla pracownika : ' + stat

# -------------------------------------------------------------------------------
# ---- SELECT - 5 Pobieranie listy angazy dla pracownika
# -------------------------------------------------------------------------------

if Fun in (5, 6) and stat == 'OK':
    FILTR = "(firma_id = '" + self.firma_id + "' AND pracownik_id = '" + Pracownik + "'"
    if not Wszystkie and Zatrudnienie <> '':
        FILTR += " AND zatrudnienie_id = " + str(Zatrudnienie)
    if not Wszystkie and Umowa <> '':
        FILTR += " AND umowa_id = " + str(Umowa)

    if OdKiedyF <> '    -  -  ':
        FILTR += " AND od_kiedy >= '" + OdKiedyF + "'"
    if DoKiedyF <> '    -  -  ':
        FILTR += " AND do_kiedy <= '" + DoKiedyF + "'"
    if KomorkaF <> '':
        FILTR += " AND komorka_id LIKE '" + KomorkaF + "%'"
    if StanowiskoF <> '':
        FILTR += " AND stanowisko_id LIKE '" + StanowiskoF + "%'"
    FILTR += ")"

    # uzupelnienie podgladu o klucze nowe lub zmienione
    if len(Klucze_Id) > 0:
        FILTR += " OR (firma_id = '" + self.firma_id + "' AND pracownik_id = '" + Pracownik + "'"
        if not Wszystkie and Zatrudnienie <> '':
            FILTR += " AND zatrudnienie_id = " + str(Zatrudnienie)
        if not Wszystkie and Umowa <> '':
            FILTR += " AND umowa_id = " + str(Umowa)
        FILTR += " AND angaz_id IN ("
        for i in xrange(len(Klucze_Id)):
            if i > 0:
                FILTR += ","
            FILTR += str(Klucze_Id[i])
        FILTR += "))"

    SELECT = "SELECT umowa_id,angaz_id,od_kiedy,COALESCE(do_kiedy::TEXT,''::TEXT),"
    SELECT += " miejsce_id,komorka_id,stanowisko_id,placa,stawka,"
    SELECT += " dodatek_fun,COALESCE(kategoria_zaszeregowania,''),"  #WS 2019-06-27
    SELECT += " zatrudnienie_id,"
    SELECT += " do_kiedy >= now() or do_kiedy IS NULL"  #PW 2017-11-07
    SELECT += " FROM rs_kp_angaze WHERE " + FILTR + " ORDER BY umowa_id,angaz_id;"
    stat, dane, wyn1, dump = self.PolSQL.Execute(SELECT, 3)
    if stat <> 'OK':
        stat = 'Bd pobrania listy angay dla pracownika : ' + stat
