# -*- coding: iso8859_2 -*-

#-----------------------------------------------------------------------------
# Name:        fs_kp_bilans_otwarcia.py
# Purpose:     wczytuje/edytuje dane bilansu otwarcia pracownika#
# Author:      Piotr Witkowski
# Created:     2016/11/11
# RCS-ID:      $Id: fs_kp_bilans_otwarcia.py $
# Copyright:   (c) 2016 Record System
# Licence:     GNU GPL
#-----------------------------------------------------------------------------

stat = 'OK'
if not 'Funkcja' in klucze:
    stat = 'Brak podanej funkcji dodatkowej w kluczach'

if stat == 'OK':
    Funkcja = klucze['FunkcjaDodatkowa']
    SlPar = {'Pracownik': [1,3,4,5,6,7],}

    Lista = rsglobal.SprawdzParametryWKluczach(SlPar, Funkcja, klucze)
    if Lista <> '':
        stat = 'Uwaga : wywoanie funkcji fs_kp_bilans_otwarcia z numerem ' + str(
            Funkcja) + ' bez parametrw: ' + Lista

    if stat == 'OK':
        if Funkcja in [1,3,4,5,6,7]:
            Pracownik = str(klucze['Pracownik'])
if stat == 'OK':
    dane = []
    wyn1 = []
    wyn2 = []

#-------------------------------------------------------------------------------
#-------- EDYCJA GRIDA EDYTOWALNEGO (1)
#-------------------------------------------------------------------------------

upr =  ((self.oddzial_id,'052012') in self.uprawnienia or self.operator_id == STANDARD_OPERATOR_ID)
if not upr:
    stat = 'Brak uprawnie do okna bilans otwarcia'

Insert = []
Update = []
Delete = []

if stat=='OK' and Funkcja in [3,4,]:
    Update=klucze['Update']
    Insert=klucze['Insert']
    Delete=klucze['Delete']


# -------------------------------------------------------------------------------
# ---   UPDATE ZASIEK (3)
# -------------------------------------------------------------------------------

if stat == "OK" and Funkcja == 3:
    if len(Update[0]) > 0:
        WierszeNr = Update[-1]
        SQL=''
        for i in xrange(len(Update[0])):
            WHERE = " WHERE firma_id='" + self.firma_id + "' AND pracownik_id = '"+str(Pracownik)+"' "
            for j in xrange(len(Update[2][i])):  # petla po kluczu
                pole = Update[3][j]
                wart = rsglobal.Dekoduj(Update[2][i][j])
                if pole in ['rok', 'miesiac']:
                    WHERE += " AND " + pole + "=" + str(float(wart)) + " "

            for j in xrange(len(Update[0][i])):
                pole = Update[0][i][j]
                wart = Update[1][i][j]

                if pole == 'rok':
                    if int(wart)<1950 or int(wart)>2050:
                        wyn2.append((WierszeNr[i], 0))
                        dane.append('ROK DL')
                    elif len(str(int(wart))) == 0:
                        wyn2.append((WierszeNr[i], 0))
                        dane.append('ROK BR')

                if pole == 'miesiac':
                    if int(wart) not in [x+1 for x in range(12)]:
                        wyn2.append((WierszeNr[i], 1))
                        dane.append('MC DL')
                    elif len(str(int(wart))) == 0:
                        wyn2.append((WierszeNr[i], 1))
                        dane.append('MC BR')


                elif pole == 'nominalne_dni_pracy':
                    if len(str(int(wart))) > 2:
                        wyn2.append((WierszeNr[i], 2))
                        dane.append('DNI DL')
                    elif wart<0:
                        wyn2.append((WierszeNr[i], 2))
                        dane.append('DNI MINUS')

                elif pole == 'dni_pracy_urlopu':
                    if len(str(int(wart)))  > 2:
                        wyn2.append((WierszeNr[i], 3))
                        dane.append('DNI UR DL')
                    elif wart<0:
                        wyn2.append((WierszeNr[i], 3))
                        dane.append('DNI UR MINUS')

                elif pole == 'podst_zasilkow':
                    if len(str(int(wart))) > 12:
                        wyn2.append((WierszeNr[i], 4))
                        dane.append('ZAS DL')
                    elif wart<0:
                        wyn2.append((WierszeNr[i], 4))
                        dane.append('ZAS MINUS')

                elif pole == 'premia_kwartal':
                    if len(str(int(wart))) > 12:
                        wyn2.append((WierszeNr[i], 5))
                        dane.append('PREMIA1 DL')
                    elif wart<0:
                        wyn2.append((WierszeNr[i], 5))
                        dane.append('PREMIA1 MINUS')

                elif pole == 'premia_polrocze':
                    if len(str(int(wart)))  > 12:
                        wyn2.append((WierszeNr[i], 6))
                        dane.append('PREMIA2 DL')
                    elif wart<0:
                        wyn2.append((WierszeNr[i], 6))
                        dane.append('PREMIA2 MINUS')

                elif pole == 'premia_rok':
                    if len(str(int(wart)))  > 12:
                        wyn2.append((WierszeNr[i], 7))
                        dane.append('PREMIA3 DL')
                    elif wart<0:
                        wyn2.append((WierszeNr[i], 7))
                        dane.append('PREMIA3 MINUS')

            if stat == 'OK':
                if len(dane) > 0:
                    stat = dane[0]

            # wykonanie UPDATE
            if stat == 'OK':
                sql = ''
                UPDATE = "UPDATE rs_kp_bo_zasilek "
                SET = 'SET '

                for j in xrange(len(Update[0][i])):
                    pole = Update[0][i][j]
                    wart = Update[1][i][j]
                    if pole in ['rok', 'miesiac', 'nominalne_dni_pracy', 'dni_pracy_urlopu','podst_zasilkow', 'premia_kwartal', 'premia_polrocze', 'premia_rok']:
                        SET += pole + "=" + str(float(wart)) + ","

                SET = SET.strip(",")
                WHERE += ";"
                sql += UPDATE + SET + WHERE
                SQL+=sql

        if stat =='OK':
            stat, dump, dump, dump = self.PolSQL.Execute(rsglobal.Dekoduj(SQL), 1)
            if stat <> 'OK':
                stat = "Bd przy modyfikowaniu danych zasiku: " + stat
                dane.append(stat)


# -------------------------------------------------------------------------------
# ---   UPDATE URLOP (4)
# -------------------------------------------------------------------------------

if stat == "OK" and Funkcja == 4 and len(Update[0]) > 0:
    WierszeNr = Update[-1]
    for i in xrange(len(Update[0])):
        WHERE = " WHERE firma_id='" + self.firma_id + "' AND pracownik_id = '" + str(Pracownik) + "' "
        for j in xrange(len(Update[2][i])):  # petla po kluczu
            pole = Update[3][j]
            wart = rsglobal.Dekoduj(Update[2][i][j])
            if pole in ['rok', 'miesiac']:
                # WHERE += " AND " + pole + "='" + wart + "'" #
                WHERE += " AND " + pole + "=" + str(float(wart)) + " "

        for j in xrange(len(Update[0][i])):
            pole = Update[0][i][j]
            wart = Update[1][i][j]

            if pole == 'rok':
                if int(wart)<1950 or int(wart)>2050:
                    wyn2.append((WierszeNr[i], 0))
                    dane.append('UR ROK DL')
                elif len(str(int(wart))) == 0:
                    wyn2.append((WierszeNr[i], 0))
                    dane.append('UR ROK BR')

            if pole == 'miesiac':
                if int(wart) not in [x+1 for x in  range(12)]:
                    wyn2.append((WierszeNr[i], 1))
                    dane.append('MC DL')
                elif len(str(int(wart))) == 0:
                    wyn2.append((WierszeNr[i], 1))
                    dane.append('MC BR')

            elif pole == 'dni_pracy':
                if len(str(int(wart))) > 2:
                    wyn2.append((WierszeNr[i], 2))
                    dane.append('UR DNI BL')
                elif wart<0:
                    wyn2.append((WierszeNr[i], 2))
                    dane.append('UR DNI MINUS')
                    # elif wart == 0:
                    #    wyn2.append((WierszeNr[i], 4))
                    #    dane.append('KAL BR')

            elif pole == 'dni_urlopu':
                if len(str(int(wart))) > 2:
                    wyn2.append((WierszeNr[i], 3))
                    dane.append('UR DNI UR DL')
                elif wart<0:
                    wyn2.append((WierszeNr[i], 3))
                    dane.append('UR DNI UR MINUS')

            elif pole == 'godziny_pracy':
                if len(str(int(wart))) > 4:
                    wyn2.append((WierszeNr[i], 4))
                    dane.append('UR GODZ BL')
                elif wart<0:
                    wyn2.append((WierszeNr[i], 4))
                    dane.append('UR GODZ MINUS')

            elif pole == 'godziny_pracy_m':
                if wart<0 or wart > 59:
                    wyn2.append((WierszeNr[i], 5))
                    dane.append('UR MIN BL')

            elif pole == 'urlop_data':
                if wart not in (None, 'None') and wart <> '':
                    if not rsglobal.SprawdzCzyToData(wart):
                        wyn2.append((WierszeNr[i], 6))
                        dane.append('UR DATA BL')

            elif pole == 'urlop_wynagrodzenie':
                if len(str(int(wart))) > 12:
                    wyn2.append((WierszeNr[i], 7))
                    dane.append('UR WNYN BL')
                elif wart<0:
                    wyn2.append((WierszeNr[i], 7))
                    dane.append('UR WNYN MINUS')

        if stat == 'OK':
            if len(dane) > 0:
                stat = dane[0]

        # wykonanie UPDATE
        if stat == 'OK':
            sql = ''
            UPDATE = "UPDATE rs_kp_bo_urlop "
            SET = 'SET '

            for j in xrange(len(Update[0][i])):
                pole = Update[0][i][j]
                wart = Update[1][i][j]
                if pole in ['rok', 'miesiac', 'dni_pracy', 'dni_urlopu','urlop_wynagrodzenie','godziny_pracy','godziny_pracy_m']:
                    SET += pole + "=" + str(wart) + ","
                elif pole in ['urlop_data',]:
                    if wart not in ['', '    -  -  ']:
                        SET += pole + "='" + str(wart) + "',"
                    else:
                        SET += pole+"=Null,"

            SET = SET.strip(",")
            WHERE += ";"
            sql += UPDATE + SET + WHERE
            stat, dump, dump, dump = self.PolSQL.Execute(rsglobal.Dekoduj(sql), 1)
            if stat <> 'OK':
                stat = "Bd przy modyfikowaniu danych urlopu: " + stat
                dane.append(stat)


# -------------------------------------------------------------------------------
# ---   UPDATE DOCHOD (1)
# -------------------------------------------------------------------------------

if stat == "OK" and Funkcja == 1 and len(pola)>0:
    WHERE = " WHERE firma_id='" + self.firma_id + "' AND pracownik_id = '" + str(Pracownik) + "' "
    for j in range(len(pola)):
        wart = wartosci[j]
        pole = pola[j]

        if pole == 'przychod_wynagrodzenie':
            if len(str(int(wart))) > 12:
                dane.append('przychod_wynagrodzenie')
        elif pole == 'przychod_swiadczenia':
            if len(str(int(wart))) > 12:
                dane.append('przychod_swiadczenia')
        elif pole == 'przychod_umowy':
            if len(str(int(wart))) > 12:
                dane.append('przychod_umowy')
        elif pole == 'przychod_prawa_autorskie':
            if len(str(int(wart))) > 12:
                dane.append('przychod_prawa_autorskie')
        elif pole == 'przychod_zrodla':
            if len(str(int(wart))) > 12:
                dane.append('przychod_zrodla')
        elif pole == 'koszty_uzyskania_wynagrodzenie':
            if len(str(int(wart))) > 12:
                dane.append('koszty_uzyskania_wynagrodzenie')
        elif pole == 'koszty_uzyskania_swiadczenia':
            if len(str(int(wart))) > 12:
                dane.append('koszty_uzyskania_swiadczenia')
        elif pole == 'koszty_uzyskania_umowy':
            if len(str(int(wart))) > 12:
                dane.append('koszty_uzyskania_umowy')
        elif pole == 'koszty_uzyskania_prawa_autorskie':
            if len(str(int(wart))) > 12:
                dane.append('koszty_uzyskania_prawa_autorskie')
        elif pole == 'koszty_uzyskania_zrodla':
            if len(str(int(wart))) > 12:
                dane.append('koszty_uzyskania_zrodla')
        elif pole == 'dochod_wynagrodzenie':
            if len(str(int(wart))) > 12:
                dane.append('dochod_wynagrodzenie')
        elif pole == 'dochod_swiadczenia':
            if len(str(int(wart))) > 12:
                dane.append('dochod_swiadczenia')
        elif pole == 'dochod_umowy':
            if len(str(int(wart))) > 12:
                dane.append('dochod_umowy')
        elif pole == 'dochod_prawa_autorskie':
            if len(str(int(wart))) > 12:
                dane.append('dochod_prawa_autorskie')
        elif pole == 'dochod_zrodla':
            if len(str(int(wart))) > 12:
                dane.append('dochod_zrodla')
        elif pole == 'podatek_wynagrodzenie':
            if len(str(int(wart))) > 12:
                dane.append('podatek_wynagrodzenie')
        elif pole == 'podatek_swiadczenia':
            if len(str(int(wart))) > 12:
                dane.append('podatek_swiadczenia')
        elif pole == 'podatek_umowy':
            if len(str(int(wart))) > 12:
                dane.append('podatek_umowy')
        elif pole == 'podatek_prawa_autorskie':
            if len(str(int(wart))) > 12:
                dane.append('podatek_prawa_autorskie')
        elif pole == 'podatek_zrodla':
            if len(str(int(wart))) > 12:
                dane.append('podatek_zrodla')
        elif pole == 'podatek_zrodla':
            if len(str(int(wart))) > 12:
                dane.append('podatek_zrodla')
        elif pole == 'dane_na_dzien':
            if not rsglobal.SprawdzCzyToData(wart):
                dane.append('Bdna data "dane na dzie" ')
        elif pole == 'skladka_zus_pracownika':
            if len(str(int(wart))) > 12:
                dane.append('skladka_zus_pracownika')
        elif pole == 'skladka_zus_zdrowotna':
            if len(str(int(wart))) > 12:
                dane.append('skladka_zus_zdrowotna')

    if stat == 'OK':
        if len(dane) > 0:
            stat = dane[0]

    # wykonanie UPDATE
    if stat == 'OK':
        sqlA = ''
        UPDATEA = "UPDATE rs_kp_bo_dochod "
        SETA = 'SET '


        sqlB = ''
        UPDATEB = "UPDATE rs_kp_bo_dodatkowe "
        SETB = 'SET '

        for j in range(len(pola)):
            wart = wartosci[j]
            pole = pola[j]
            if pole in ['przychod_wynagrodzenie', 'przychod_swiadczenia', 'przychod_umowy', 'przychod_prawa_autorskie', 'przychod_zrodla',
                        'koszty_uzyskania_wynagrodzenie', 'koszty_uzyskania_swiadczenia', 'koszty_uzyskania_umowy', 'koszty_uzyskania_prawa_autorskie', 'koszty_uzyskania_zrodla',
                        'dochod_wynagrodzenie', 'dochod_swiadczenia', 'dochod_umowy', 'dochod_prawa_autorskie', 'dochod_zrodla',
                        'podatek_wynagrodzenie', 'podatek_swiadczenia', 'podatek_umowy', 'podatek_prawa_autorskie', 'podatek_zrodla',]:
                SETA += pole + "=" + str(float(wart)) + ","
            elif pole in ['dane_na_dzien']:
                SETA += pole + "='" + str(wart) + "',"

            elif pole in ['skladka_zus_pracownika', 'skladka_zus_zdrowotna', 'okres_nal_urlop']:
                SETB += pole + "=" + str(float(wart)) + ","

        if stat == 'OK' and SETA <> 'SET ':
            SETA = SETA.strip(",")
            WHERE += ";"
            sqlA += UPDATEA + SETA + WHERE
            stat, dump, dump, dump = self.PolSQL.Execute(rsglobal.Dekoduj(sqlA), 1)
            if stat <> 'OK':
                stat = "Bd przy modyfikowaniu danych dochodu: " + stat
                dane.append(stat)

        if stat == 'OK' and SETB <> 'SET ':
            SETB = SETB.strip(",")
            WHERE += ";"
            sqlB += UPDATEB + SETB + WHERE
            stat, dump, dump, dump = self.PolSQL.Execute(rsglobal.Dekoduj(sqlB), 1)
            if stat <> 'OK':
                stat = "Bd przy modyfikowaniu danych dodatkowych: " + stat
                dane.append(stat)

# -------------------------------------------------------------------------------
# ---   POBRANIE DANYCH (5) dochd
# -------------------------------------------------------------------------------

if stat == "OK" and Funkcja in [1,5]:
    #sprawdzenie czy jest ju w tabeli
    sql ="SELECT przychod_wynagrodzenie "
    sql+="FROM rs_kp_bo_dochod WHERE firma_id='"+str(self.firma_id)+"' AND pracownik_id = '"+str(Pracownik)+"';"
    stat, spr, wyn1, dump = self.PolSQL.Execute(sql, 3)
    if stat<>'OK':
        stat="Bd przy sprawdzeniu danych dochodu : "+stat
        dane.append(stat)
    elif stat == 'OK' and len(spr)>1:
        stat="W bazie urlopu wystpuje wicej ni jedna pozycja dochodu, naley skontaktowa si z serwisem : "+stat
        dane.append(stat)

    elif stat == 'OK' and len(spr) ==0: #dodajemy wiersz do bazy
        ins = "INSERT INTO rs_kp_bo_dochod(firma_id, pracownik_id) VALUES('"+str(self.firma_id)+"','"+str(Pracownik)+"');"
        ins +="INSERT INTO rs_kp_bo_dodatkowe(firma_id, pracownik_id,okres_nal_urlop) VALUES('"+str(self.firma_id)+"','"+str(Pracownik)+"',3);"
        stat, dump, dump, dump = self.PolSQL.Execute(rsglobal.Dekoduj(ins), 1)
        if stat <> 'OK':
            stat = u'Bd dodawania daty do tabeli dochod i dodatkowe: '+stat


    if stat =='OK':
        sql ="SELECT d.dane_na_dzien, "
        sql+="d.przychod_wynagrodzenie,d.przychod_swiadczenia,d.przychod_umowy,d.przychod_prawa_autorskie,d.przychod_zrodla,"
        sql+="d.koszty_uzyskania_wynagrodzenie,d.koszty_uzyskania_swiadczenia,d.koszty_uzyskania_umowy,d.koszty_uzyskania_prawa_autorskie,d.koszty_uzyskania_zrodla,"
        sql+="d.dochod_wynagrodzenie,d.dochod_swiadczenia,d.dochod_umowy,d.dochod_prawa_autorskie,d.dochod_zrodla,"
        sql+="d.podatek_wynagrodzenie,d.podatek_swiadczenia,d.podatek_umowy,d.podatek_prawa_autorskie,d.podatek_zrodla,"
        sql+="a.skladka_zus_pracownika,a.skladka_zus_zdrowotna,a.okres_nal_urlop "
        sql+="FROM rs_kp_bo_dochod d JOIN rs_kp_bo_dodatkowe a ON d.firma_id = a.firma_id AND d.pracownik_id=a.pracownik_id "
        sql+="WHERE d.firma_id='"+str(self.firma_id)+"' AND d.pracownik_id = '"+str(Pracownik)+"';"
        #print 'sql pobranie 5', sql
        stat, dane, wyn1, dump = self.PolSQL.Execute(sql, 3)
        if stat<>'OK':
            stat="Bd przy pobrania danych dochodu : "+stat
            dane.append(stat)


#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (6) zasiek
#-------------------------------------------------------------------------------

if stat=='OK' and Funkcja in [3,6]:
    #sprawdzenie czy jest ju w tabeli
    sql ="SELECT rok,miesiac "
    sql+="FROM rs_kp_bo_zasilek WHERE firma_id='"+str(self.firma_id)+"' AND pracownik_id = '"+str(Pracownik)+"' ORDER BY 1,2;"
    stat, spr, wyn1, dump = self.PolSQL.Execute(sql, 3)
    if stat<>'OK':
        stat="Bd przy sprawdzeniu danych zasiku : "+stat
        dane.append(stat)
    elif stat == 'OK' and len(spr)>0 and len(spr)<12:
        stat="W bazie zasiku wystpuje niepoprawna ilo miesicy, naley skontaktowa si z serwisem : "+stat
        dane.append(stat)

    elif stat == 'OK' and len(spr) ==0: #dodajemy miesice i roki
        Rok = 2016
        ins = "INSERT INTO rs_kp_bo_zasilek(firma_id, pracownik_id, rok, miesiac) "
        ins +="VALUES "
        for x in range(12):
            ins+="('"+str(self.firma_id)+"','"+str(Pracownik)+"',"+str(Rok)+","+str(x+1)+"),"
        ins = ins[:-1]+";"
        stat, dump, dump, dump = self.PolSQL.Execute(rsglobal.Dekoduj(ins), 1)
        if stat <> 'OK':
            stat = u'Bd dodawania daty do tabeli zasiel: '+stat

    # ---   POBRANIE DANYCH
    if stat =='OK':
        sql ="SELECT rok,miesiac,nominalne_dni_pracy,dni_pracy_urlopu,podst_zasilkow,premia_kwartal,premia_polrocze,premia_rok "
        sql+="FROM rs_kp_bo_zasilek WHERE firma_id='"+str(self.firma_id)+"' AND pracownik_id = '"+str(Pracownik)+"' ORDER BY 1,2;"
        stat,dane,wyn1,dump=self.PolSQL.Execute(sql,3)

        if stat<>'OK':
            stat="Bd przy pobieraniu danych zasiku : "+stat
            dane.append(stat)
        elif stat == 'OK' and len(dane)<12: #uzupenianie danych do 12 wierszy
            LKolumn = 8
            [dane.append(['' for y in range(LKolumn)]) for x in range(12 - len(dane))]

#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (7) urlop
#-------------------------------------------------------------------------------

if stat=='OK' and Funkcja in [4,7]:
    #sprawdzenie czy jest ju w tabeli
    sql ="SELECT rok,miesiac "
    sql+="FROM rs_kp_bo_urlop WHERE firma_id='"+str(self.firma_id)+"' AND pracownik_id = '"+str(Pracownik)+"' ORDER BY 1,2;"
    stat, spr, wyn1, dump = self.PolSQL.Execute(sql, 3)
    if stat<>'OK':
        stat="Bd przy sprawdzeniu danych urlopu : "+stat
        dane.append(stat)
    elif stat == 'OK' and len(spr)>0 and len(spr)<12:
        stat="W bazie urlopu wystpuje niepoprawna ilo miesicy, naley skontaktowa si z serwisem : "+stat
        dane.append(stat)

    elif stat == 'OK' and len(spr) ==0: #dodajemy miesice i roki
        Rok = 2016
        ins = "INSERT INTO rs_kp_bo_urlop(firma_id, pracownik_id, rok, miesiac) "
        ins +="VALUES "
        for x in range(12):
            ins+="('"+str(self.firma_id)+"','"+str(Pracownik)+"',"+str(Rok)+","+str(x+1)+"),"
        ins = ins[:-1]+";"
        stat, dump, dump, dump = self.PolSQL.Execute(rsglobal.Dekoduj(ins), 1)
        if stat <> 'OK':
            stat = u'Bd dodawania daty do tabeli urlop: '+stat

    # ---   POBRANIE DANYCH (7)
    if stat =='OK':
        sql ="SELECT rok,miesiac,dni_pracy,dni_urlopu,godziny_pracy,godziny_pracy_m,urlop_data,urlop_wynagrodzenie "
        sql+="FROM rs_kp_bo_urlop WHERE firma_id='"+str(self.firma_id)+"' AND pracownik_id = '"+str(Pracownik)+"' ORDER BY 1,2;"
        stat,dane,wyn1,dump=self.PolSQL.Execute(sql,3)

        if stat<>'OK':
            stat="Bd przy pobieraniu danych urlopu : "+stat
            dane.append(stat)
        elif stat == 'OK' and len(dane)<12: #uzupenianie danych do 12 wierszy
            LKolumn = 7
            [dane.append(['' for y in range(LKolumn)]) for x in range(12 - len(dane))]