# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_kp_dane_osobowe_badania_okresowe.py
# Purpose:     grid z badaniami pracownika
# Author:      Marcin Natkaski
# Created:     2010/08/04
# RCS-ID:      $Id: fs_kp_dane_osobowe_badania_okresowe.py $
# Copyright:   (c) 2010 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

stat = 'OK'
dane = []

if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=='OK':
    Fun = klucze['Funkcja']
    
    SlPar={'Pracownik':[5,6,10],'Badanie':[6],'DataUkonczenia':[6],'IDBadaniaF':[5,6],
    'DataBadaniaF':[5,6],'DodaneKlucze':[5]}    
    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Fun,klucze)
    if Lista<>'':
        stat='Uwaga : wywoanie funkcji fs_kp_dane_osobowe_badania_okresowe z numerem '+str(Fun)+' bez parametrw: '+Lista

if stat=='OK':
    if Fun in [6]:
        Badanie=rsglobal.Dekoduj(klucze['Badanie'])
        DataUkonczenia=rsglobal.Dekoduj(klucze['DataUkonczenia'])
                
    if Fun in [5,6]:
        IDBadaniaF=rsglobal.Dekoduj(klucze['IDBadaniaF'])
        DataBadaniaF=rsglobal.Dekoduj(klucze['DataBadaniaF'])
            
    if Fun in [5,6,10]:
        Pracownik=rsglobal.Dekoduj(klucze['Pracownik'])
        
    if Fun in [5,]:
        DodaneKlucze=rsglobal.Dekoduj(klucze['DodaneKlucze'])

DataWaznosci = ''
if stat=='OK' and Fun==10:
    #sprawdza uprawnienia
    sql ="SELECT rsf_kadry_dozwolony_modul('"+self.firma_id+"','"+str(self.operator_id)+"','badania','"+Pracownik+"');"
    stat,Dane,dump,dump = self.PolSQL.Execute(sql,3)
    if stat == 'OK':
        if Dane[0][0]<>'OK':       
            stat = Dane[0][0]
            dane.append(stat)
    else:
        stat='BR_UPR'
        dane.append(stat)

UprUsuwanie = ((self.oddzial_id,'052074') in self.uprawnienia or self.operator_id == STANDARD_OPERATOR_ID)


#-------------------------------------------------------------------------------
#--- SPRAWDZENIE DAT W FILTRZE - 5,6
#-------------------------------------------------------------------------------

if Fun in (5,6) and stat == 'OK':
    if DataBadaniaF <> '    -  -  ':
        if not rsglobal.SprawdzCzyToData(DataBadaniaF):
            stat='Bdna data "od kiedy" w filtrze'
            dane.append(stat)
    

#-------------------------------------------------------------------------------
#--- DELETE - 6
#-------------------------------------------------------------------------------

if Fun == 6 and stat == 'OK':
    if not UprUsuwanie:
        stat='BR_UPR_US'
        dane.append(stat)
    if stat == 'OK':          
        DELETE ="DELETE FROM rs_kp_dane_osobowe_badania_okresowe"
        DELETE+=" WHERE firma_id = '"+self.firma_id+"' AND pracownik_id = '"+str(Pracownik)+"'"
        DELETE+=" AND badanie_id = '"+str(Badanie)+"' AND data_ukonczenia = '"+str(DataUkonczenia)+"';" 
        stat,dump,dump,dump = self.PolSQL.Execute(DELETE, 1)
        if stat <> 'OK':
            stat='BL US'
            dane.append(stat)


#-------------------------------------------------------------------------------
#---- SELECT - 5,6  
#-------------------------------------------------------------------------------

if Fun in (5,6) and stat == 'OK':
    SQL="SELECT r.badanie_id,p.opis,r.data_ukonczenia,COALESCE(r.data_waznosci::TEXT,'')"
    SQL+=" FROM rs_kp_dane_osobowe_badania_okresowe r LEFT OUTER JOIN rs_rodzaje_badan p ON (r.badanie_id,r.firma_id)=(p.kod,p.firma_id)"
    SQL+=" WHERE r.firma_id = '"+self.firma_id+"' AND r.pracownik_id= '"+str(Pracownik)+"' "
    if IDBadaniaF <> '':               
        SQL+= " AND r.badanie_id = '"+IDBadaniaF+"' "
    if DataBadaniaF <>  '    -  -  ':
        SQL+=" AND r.data_waznosci='"+DataBadaniaF+"' "  
    if Fun==5:
        for i in xrange(len(DodaneKlucze)):
            SQL+=" OR (r.firma_id,r.pracownik_id,r.badanie_id,r.data_ukonczenia) "
            SQL+=" = ('"+self.firma_id+"','"+str(Pracownik)+"','"+DodaneKlucze[i][0]+"','"+DodaneKlucze[i][1]+"') "
    SQL+=" ORDER BY r.data_ukonczenia DESC,r.badanie_id;"
    stat,dane,wyn1,dump =self.PolSQL.Execute(SQL, 3)
    if stat <> 'OK':
        stat='Bdy zapytania pobierajcego dane '+stat
        dane.append(stat)