# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_kp_dane_osobowe_badania_okresowe_dane
# Purpose:     dodawanie/edycja danych o badaniach pracownika
# Author:      Marcin Natkaski
# Created:     2010/08/04
# RCS-ID:      $Id: fs_kp_dane_osobowe_badania_okresowe.py $
# Copyright:   (c) 2010 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

def SprNakladanieDat(self, Fun, Pracownik, Badanie, DataUkonczenia, DataWaznosci):
    dane= []
    stat = 'OK'
    sql = ''
    #sprawdzenie unikalnosci zakresow przed INSERT
    if Fun in (1,2):
        sql ="SELECT data_ukonczenia FROM rs_kp_dane_osobowe_badania_okresowe"
        sql+=" WHERE firma_id = '"+self.firma_id+"'"
        sql+=" AND pracownik_id = '"+Pracownik+"'" 
        sql+=" AND badanie_id = '"+Badanie+"'"
        # Jeeli data wanoci pusta.
        if DataWaznosci=="    -  -  ":
            DataWaznosci="9999-12-31" 
        # Jeeli dla badania istnieje pniejsza data wanoci.
        sql+=" AND data_waznosci >= '"+DataWaznosci+"'"
        sql+=";"

    #sprawdzenie unikalnosci zakresow przed UPDATE
    if Fun in (3,4):
        if DataWaznosci==None:
            sqlDataW  ="SELECT data_waznosci FROM rs_kp_dane_osobowe_badania_okresowe"
            sqlDataW +=" WHERE firma_id='"+self.firma_id+"' AND pracownik_id='"+Pracownik+"'"
            sqlDataW +=" AND badanie_id='"+Badanie+"' AND data_ukonczenia='"+DataUkonczenia+"';"
            stat,d,dump,dump = self.PolSQL.Execute(sqlDataW,2)
            if stat<>'OK':
                stat="Bdy pobierania daty wanoci"
                dane.append(stat)
            elif len(d)==1:
                DataWaznosci=str(d[0][0]) 
                        
        sql ="SELECT data_ukonczenia FROM rs_kp_dane_osobowe_badania_okresowe"
        sql+=" WHERE firma_id = '"+self.firma_id+"'"
        sql+=" AND pracownik_id = '"+Pracownik+"'"
        sql+=" AND badanie_id = '"+Badanie+"'"
        #jeeli data wanoci pusta
        if DataWaznosci in ("    -  -  ", None, 'None'):
            DataWaznosci="9999-12-31"
        #wykluczenie z SELECT modyfikowanej pozycji
        sql+=" AND data_ukonczenia <> '"+DataUkonczenia+"'"
        #czy istnieje data wanoci pniejsza ni proponowana.
        sql+=" AND "
        sql+=" data_waznosci >= '"+DataWaznosci+"'"
        sql+=";"
           
    if sql <> '':
        stat,d,dump,dump = self.PolSQL.Execute(sql,2)
        if stat <> 'OK':
            stat = 'Bd sprawdzenia pokrywania si zakresw dat ; '+stat
            dane.append(stat)
        elif stat == 'OK':
            if len(d) > 0:
                stat = 'BL_POKRYWANIA_DAT'
                dane.append(stat)
                
    #a tutaj sprawdzamy czy nie dubluje si klucz        
    SQLK =" SELECT badanie_id from rs_kp_dane_osobowe_badania_okresowe "
    SQLK+=" WHERE firma_id='"+self.firma_id+"' AND pracownik_id='"+Pracownik+"' "
    SQLK+=" AND badanie_id='"+Badanie+"' AND data_ukonczenia='"+DataUkonczenia+"' "
    if DataWaznosci<>'9999-12-31':
        SQLK+="AND data_waznosci='"+DataWaznosci+"'"
    stat,d,dump,dump = self.PolSQL.Execute(SQLK,2)
    if len(d)>0:
        stat = 'PODW_KLUCZ'
        dane.append(stat)
    return stat

#-------------------------------------------------------------------------------
stat='OK'

if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=='OK':
    Fun = klucze['Funkcja']
    
    SlPar={'Pracownik':[10],'Badanie':[1,2,3,4,5],'DataUkonczenia':[1,2,3,4,5],'BadanieStare':[4,3],'DataStara':[4,3]}    
    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Fun,klucze)
    if Lista<>'':
        stat='Uwaga : wywoanie funkcji fs_kp_dane_osobowe_badania_okresowe z numerem '+str(Fun)+' bez parametrw: '+Lista

if stat=='OK':
    
    if Fun in [1,2,3,4,5]:
        Badanie=rsglobal.Dekoduj(klucze['Badanie'])
        DataUkonczenia=rsglobal.Dekoduj(klucze['DataUkonczenia'])
 
    if Fun in [1,2,3,4,5,10]:
        Pracownik=rsglobal.Dekoduj(klucze['Pracownik'])
        
    if Fun in [4,3]:
        BadanieStare=rsglobal.Dekoduj(klucze['BadanieStare'])
        DataStara=rsglobal.Dekoduj(klucze['DataStara'])

if stat=='OK' and Fun==10:
    #sprawdza uprawnienia
    sql ="SELECT rsf_kadry_dozwolony_modul('"+self.firma_id+"','"+str(self.operator_id)+"','badania','"+Pracownik+"');"
    stat,Dane,dump,dump = self.PolSQL.Execute(sql,3)
    if stat == 'OK':
        if Dane[0][0]<>'OK':       
            stat = Dane[0][0]
            dane.append(stat)
    else:
        stat='BR_UPR'
        dane.append(stat)

UprDodawanie = (((self.oddzial_id,'052073') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID))
UprEdycja = (((self.oddzial_id,'052072') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)) or UprDodawanie


#-------------------------------------------------------------------------------
#---   SPRAWDZENIE UPRAWNIEN
#-------------------------------------------------------------------------------

if Fun in (1,2) and stat == 'OK':
    if not UprDodawanie:
        stat = 'BR UPR INS'
        dane.append(stat)

if Fun in (3,4) and stat == 'OK':
    if not UprEdycja:
        stat = 'BR UPR UPD'
        dane.append(stat)


#-------------------------------------------------------------------------------
#--- SPRAWDZENIE DANYCH (1,2,3,4) - bez 5 (pobieranie)
#-------------------------------------------------------------------------------

if Fun in (1,2,3,4) and stat == 'OK': 
    stat='OK'      
    for i in range(len(pola)):
        pole = pola[i]
        wart = wartosci[i]     
        if pole == 'data_ukonczenia':
            if wart == '    -  -  ':
                dane.append('BR DATA_UK')
            elif not rsglobal.SprawdzCzyToData(wart):
                dane.append('BL DATA_UK')
            else:       
                DataUkonczenia=wart
        elif pole == 'badanie_id':
            if wart <> '':
                SQL= " SELECT kod FROM rs_rodzaje_badan WHERE firma_id='"+self.firma_id+"' AND kod='"+Badanie+"'"
                stat,bad,dump,dump = self.PolSQL.Execute(SQL ,3)
                if stat<>'OK': 
                    dane.append('Bdy sprawdzania czy badanie istnieje.')
                elif len(bad)==0:
                    dane.append('BL_SYMBOL')               
                else:            
                    BadanieF=wart
            else:
                dane.append('BR_BADAN')
        elif pole == 'opis':
            if len(wart) > 30:
                stat='DL_OPIS'
                dane.append(stat)
        if pole == 'data_waznosci':
            if wart<>'    -  -  ':
                if not rsglobal.SprawdzCzyToData(wart):
                    dane.append('BL DATA_W')
                else:       
                    DataWaznosci=wart
    if len(dane) > 0:
        stat = dane[0]
    

#-------------------------------------------------------------------------------
#--- DODAWANIE DANYCH (1 -z pobraniem select  2 - bez pobrania
#-------------------------------------------------------------------------------

if Fun in (1,2) and stat == 'OK':
    ins = "INSERT INTO rs_kp_dane_osobowe_badania_okresowe"
    Pola="firma_id,pracownik_id"
    Wartosci="'"+self.firma_id+"','"+str(Pracownik)+"'"
    for i in range(len(pola)):
        pole = pola[i]
        wart = str(wartosci[i])
        if pole in ['badanie_id','opis','data_ukonczenia','data_waznosci']: 
            Pola += ","+pole
            if wart =='    -  -  ':
                Wartosci += ",NULL"                
            else:
                Wartosci += ",'"+str(wart)+"'" 
        if pole == 'data_waznosci':
            DataWaznosci = str(wart)
    stat = SprNakladanieDat(self, Fun, Pracownik, Badanie, DataUkonczenia, DataWaznosci)   
    if stat=='OK':                    
        ins = ins+" ("+Pola+") VALUES ("+Wartosci+");"      
        stat,dump,dump,dump = self.PolSQL.Execute(ins ,1)
    if stat <> 'OK':
        dane.append(stat)
          

#-------------------------------------------------------------------------------
#--- UPDATE DANYCH ( 3-select, 4 -update z pobraniem)
#-------------------------------------------------------------------------------

if Fun in (3,4) and stat == 'OK':
    DataWaznosci='9999-12-31'
    UPDATE = "UPDATE rs_kp_dane_osobowe_badania_okresowe SET "
    for i in xrange(len(pola)):
        pole = pola[i]
        wart = wartosci[i]
        if pole in ('badanie_id','data_ukonczenia'):
            UPDATE += pole+"='"+str(wart)+"',"
        elif pole == 'data_waznosci':
            DataWaznosci = wart
            if wart == '    -  -  ':
                UPDATE += pole+"= NULL"
            else:
                UPDATE += pole+"='"+str(wart)+"',"
    UPDATE = UPDATE[:-1]
    UPDATE+=" WHERE firma_id = '"+self.firma_id+"' AND pracownik_id = '"+Pracownik+"' "
    UPDATE+=" AND badanie_id = '"+BadanieStare+"' and data_ukonczenia= '"+DataStara+"';" 
    stat = SprNakladanieDat(self, Fun, Pracownik, Badanie, DataUkonczenia, DataWaznosci)    
    if stat=='OK':
        stat,dump,dump,dump = self.PolSQL.Execute(UPDATE ,1)    
    elif stat <> 'OK':
        dane.append(stat)
 

#-------------------------------------------------------------------------------
#--- POBRANIE DANYCH ( 5-select, 3 -update z pobraniem)
#-------------------------------------------------------------------------------

if Fun in (1,3,5) and stat=='OK':
    SELECT ="SELECT * FROM rs_kp_dane_osobowe_badania_okresowe"
    SELECT+=" WHERE firma_id = '"+self.firma_id+"' AND pracownik_id = '"+str(Pracownik)+"' "
    SELECT+="AND badanie_id = '"+str(Badanie)+"' and data_ukonczenia = '"+str(DataUkonczenia)+"';"
    stat,dane,wyn1,dump = self.PolSQL.Execute(SELECT,3)
    if stat <> 'OK':
        stat = 'Bd pobrania danych o badaniach pracownika : '+stat
        dane.append(stat)
    kw=''
    if stat == 'OK' and len(dane) == 1:
        tr = rssql.RSTableRowset(dane,wyn1)
        if (self.oddzial_id,'011890') in self.uprawnienia or self.operator_id == STANDARD_OPERATOR_ID:
            sql = "SELECT opis FROM rs_rodzaje_badan WHERE firma_id='"+self.firma_id+"' AND kod = '"+tr.GetVal(0,"badanie_id")+"';"
            stat,d,dump,dump = self.PolSQL.Execute(sql, 3)
            if stat <> 'OK':
                kw = 'Bd pobrania opisu ze sownika rodzaju bada : '+stat
            else:
                if len(d) == 0:
                    kw = 'Bdny kod badania.'
                else:
                    kw = str(d[0][0])
        else:
            kw = 'Brak uprawnie do sownika. Poinformuj administratora.'
    wyn2 = [kw]