#!/usr/bin/python
# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_kp_dane_osobowe_dane_dodatkowe.py
# Purpose:     pobieranie i usuwanie wartosci z grida
# Author:      Konrad Opieka
# Created:     2014-09-04
# RCS-ID:      $Id: fs_kp_dane_osobowe_dane_dodatkowe.py $
# Copyright:   (c) 2014 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

stat='OK'

if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=='OK':
    Funkcja = klucze['Funkcja']
    
    SlPar={'Pracownik':[1,5,6],'Typ':[1,5,6]}
    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Funkcja,klucze)
    if Lista<>'':
        stat='Uwaga : wywoanie funkcji fs_kontrahenci_kuke z numerem '+str(Fun)+' bez parametrw: '+Lista

if stat=='OK':
    if Funkcja in [1,5,6]:
        Pracownik = klucze['Pracownik']
        Typ = klucze['Typ']
        
dane = []
wyn1 = []
wyn2 = []
puste_pola = [[],"","    -  -  ",None,'None']
UprUsuwanie = ((self.oddzial_id,'052204') in self.uprawnienia or self.operator_id == STANDARD_OPERATOR_ID)


#-------------------------------------------------------------------------------
#--- POBRANIE OPISU TYPU (6)
#-------------------------------------------------------------------------------

if stat=='OK' and Funkcja == 6:
    SQL ="SELECT nazwa FROM rs_kp_typy_informacji "
    SQL+="WHERE firma_id='"+self.firma_id+"' AND typ_id='"+Typ+"'"
    stat,nazwa,dump,dump = self.PolSQL.Execute(SQL,3)
    if stat <> 'OK':
        stat = 'NAZ BL SQL'
        dane.append(stat)
    elif len(nazwa)<>0:
        dane=nazwa[0][0]
    else:
        dane=''
        

#-------------------------------------------------------------------------------
#--- SPRAWDZENIE DANYCH
#-------------------------------------------------------------------------------
if stat=='OK' and Funkcja in [1,5]:
    #sprawdzenie poprawnoci pracownika
    if stat=='OK':
        if Pracownik in puste_pola:
            stat = 'PR BR'
            dane.append(stat)
        else:
            SQL ="SELECT pracownik_id FROM rs_kp_dane_osobowe WHERE firma_id='"+self.firma_id+"'"
            SQL+=" AND pracownik_id='"+Pracownik+"'"
            stat,pr,dump,dump = self.PolSQL.Execute(SQL,3)
            if stat <> 'OK':
                stat = 'PR BL SQL'
                dane.append(stat)
            elif len(pr)==0:
                stat = 'PR BL'
                dane.append(stat)
                
                
#-------------------------------------------------------------------------------
#-------- EDYCJA GRIDA EDYTOWALNEGO (1)
#-------------------------------------------------------------------------------

Delete = []

if stat=='OK' and Funkcja == 1:
    Delete=klucze['Delete'] 
    
    
#-------------------------------------------------------------------------------
#-------  SPRAWDZANIE DELETE  --------------------------------------------------
#-------------------------------------------------------------------------------

if Funkcja == 1 and stat=="OK":
    if len(Delete[0])>0:
        if not UprUsuwanie:
            stat='DEL BR UPR'
            dane.append(stat)
                
        # wykonanie DELETE                                                
        if stat == 'OK':
            SQLDEL = ''
            SQLFU = ''
            for i in xrange(len(Delete[0])):
                SQLFU ="SELECT lp FROM rs_kp_dane_osobowe_dane_dodatkowe"
                SQLFU+=" WHERE firma_id='"+self.firma_id+"' AND pracownik_id='"+Pracownik+"'"
                DELETE = "DELETE FROM rs_kp_dane_osobowe_dane_dodatkowe "
                WHERE = "WHERE firma_id='"+self.firma_id+"' AND pracownik_id='"+Pracownik+"'"
                for j in xrange(len(Delete[0][i])):
                    pole = Delete[1][j]
                    wart = Delete[0][i][j]
                    if pole in ('lp'):
                        WHERE += " AND "+pole+"="+str(wart)
                        SQLFU += " AND "+pole+"="+str(wart)
                
                SQLDEL += DELETE+WHERE+"; "
                SQLFU += " FOR UPDATE NOWAIT; "
                
            if stat == "OK" and SQLFU <> '':
                stat,d,dump,dump = self.PolSQL.Execute(rsglobal.Dekoduj(SQLFU),3)
                if stat <> 'OK':
                    stat = 'DEL BL SPR'
                    dane.append(stat)

            if stat == "OK" and SQLDEL <> '':
                stat,dump,dump,dump = self.PolSQL.Execute(rsglobal.Dekoduj(SQLDEL),1)
                if stat <> 'OK':
                    stat = 'DEL BL SQL'  
                    dane.append(stat)
            

#-------------------------------------------------------------------------------
#--- POBRANIE DANYCH ( 5-select)
#-------------------------------------------------------------------------------

if Funkcja in (1,5) and stat=='OK':    
    SQL ="SELECT dd.lp,dd.typ_id,ti.nazwa,dd.wartosc1,dd.wartosc2,dd.wartosc3,dd.wartosc4,"
    SQL+="dd.wartosc5,dd.wartosc6,dd.wartosc7,dd.wartosc8,dd.wartosc9,dd.wartosc10 "
    SQL+="FROM rs_kp_dane_osobowe_dane_dodatkowe dd "
    SQL+="INNER JOIN rs_kp_typy_informacji ti ON (dd.firma_id=ti.firma_id AND dd.typ_id=ti.typ_id) "
    SQL+="WHERE dd.firma_id='"+self.firma_id+"' AND dd.pracownik_id='"+str(Pracownik)+"' "
    if Typ not in puste_pola:
        SQL+="AND dd.typ_id='"+str(Typ)+"'"
    stat,dane,wyn1,dump = self.PolSQL.Execute(SQL,3)
    if stat <> 'OK':
        stat = 'PO BL'
        dane.append(stat)