#!/usr/bin/python
# -*- coding: iso8859_2 -*-
#
#-------------------------------------------------------------------------------
# Name:        fs_kp_dane_osobowe_dane_dodatkowe_dane.py
# Author:      Konrad Opieka
# Created:     2014/09/10
# RCS-ID:      $Id: fs_kp_dane_osobowe_dane_dodatkowe_dane.py$
# Copyright:   (c) 2014 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

stat='OK'
if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=='OK':
    Funkcja = klucze['Funkcja']
    
    SlPar={'LP':[1,3,4,5],'Typ':[3,4,7],'Pracownik':[1,2,3,4,5,8],'TypPola':[5],'Nazwy':[1]}
    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Funkcja,klucze)
    if Lista<>'':
        stat='Uwaga : wywoanie funkcji fs_kp_dane_osobowe_dane_dodatkowe_dane z numerem '+str(Funkcja)+' bez parametrw: '+Lista

if stat=='OK':
    if Funkcja in [1,3,4,5]:
        LP=klucze['LP']
    if Funkcja in [3,4,7]:
        Typ=klucze['Typ']
    if Funkcja in [1,2,3,4,5,8]:
        Pracownik=klucze['Pracownik']
    if Funkcja in [1,3,5]:
        TypPola=klucze['TypPola']
    if Funkcja == 1:
        Nazwy=klucze['Nazwy']
    
dane=[]
wyn1=[]
wyn2=[]

UprIns=((self.oddzial_id,'052203') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID
UprUpd=((self.oddzial_id,'052202') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID or UprIns


#-------------------------------------------------------------------------------
#---   POBRANIE PARAMETROW DO TWORZENIA OKNA (7)
#-------------------------------------------------------------------------------

if Funkcja == 7:             
    SQL = "SELECT lp,opis_kolumny,typ,dlugosc,po_przecinku "
    SQL+= "FROM rs_kp_typy_informacji_pozycje "
    SQL+= "WHERE firma_id='"+self.firma_id+"' AND typ_id='"+str(Typ)+"' ORDER BY lp;"
    stat,dane,wyn1,tr = self.PolSQL.Execute(SQL,3)
    if stat<>'OK':
        stat='PAR BL'  
        dane.append(stat)
        
#-------------------------------------------------------------------------------
#---   POBRANIE NOWEGO NUMERU (8)
#-------------------------------------------------------------------------------

if Funkcja == 8:
    SQL = "SELECT COALESCE(MAX(lp),0) FROM rs_kp_dane_osobowe_dane_dodatkowe "
    SQL+= "WHERE firma_id='"+self.firma_id+"' AND pracownik_id='"+Pracownik+"';"
    stat,dane,wyn1,tr = self.PolSQL.Execute(SQL,3)
    if stat<>'OK':
        stat='LP BL'  
        dane.append(stat)
        
        
#-------------------------------------------------------------------------------
#---   Sprawdzam dane
#-------------------------------------------------------------------------------

if Funkcja in [1,2,3,4]:
    if Funkcja in [1,2] and not UprIns:
        stat='INS UPR'
        dane.append(stat)
    if Funkcja in [3,4] and not UprUpd:
        stat='UP UPR'
        dane.append(stat)
        

#-------------------------------------------------------------------------------
#---   INSERT DANYCH (2- bez pobierania,1- z pobieraniem)
#-------------------------------------------------------------------------------

    if stat=='OK' and Funkcja in [1,2]:
        SQL = "INSERT INTO rs_kp_dane_osobowe_dane_dodatkowe"
        PolaN="firma_id,pracownik_id"
        WartosciN = "'"+self.firma_id+"','"+Pracownik+"'"
        for i in range(len(pola)):
            pole = pola[i]
            wart = wartosci[i]
            PolaN += ","+pole
            WartosciN += ",'"+str(wart)+"'"
        for i in range(len(Nazwy)):
            PolaN += ", pole"+str(i+1)+"_id"
            WartosciN += ",'"+str(i+1)+"'"
        SQL += " ("+PolaN+") VALUES ("+WartosciN+");"
        stat,dump,dump,dump = self.PolSQL.Execute(SQL ,1)
        if stat<>'OK':
            stat = 'INS BL'
            dane.append(stat)

                
#-------------------------------------------------------------------------------
#---   UPDATE DANYCH (4- bez pobierania,3- z pobieraniem)
#-------------------------------------------------------------------------------

    if stat=='OK' and Funkcja in [3,4]:
        dane = []
        SQL = "UPDATE rs_kp_dane_osobowe_dane_dodatkowe SET "
        Filtr = "firma_id='"+self.firma_id+"' AND pracownik_id='"+Pracownik+"' AND typ_id='"+Typ+"' AND lp="+str(LP)
        for i in range(len(pola)):
            wart = wartosci[i]
            pole = pola[i]
            SQL += pole+"="
            SQL += "'"+str(wart)+"',"
        SQL = SQL.strip(',')
        SQL += " WHERE "+Filtr+";"
        stat,dump,dump,dump = self.PolSQL.Execute(SQL ,1)
        if stat<>'OK':
            stat = 'UP BL'
            dane.append(stat)

        
#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (1,3,5)
#-------------------------------------------------------------------------------

if Funkcja in [1,3,5]:
    dane=[]
    POLA = "lp,z_op_id,z_czas,z_typ,typ_id,"
    for i in range(len(TypPola)):
        Pole=TypPola[i]
        if Pole=='D':
            POLA+="(CASE WHEN wartosc"+str(i+1)+"='    -  -  ' THEN NULL ELSE wartosc"+str(i+1)+" END)::DATE,"
        if Pole=='B':
            POLA+="wartosc"+str(i+1)+"::BOOLEAN,"
        if Pole=='I':
            POLA+="wartosc"+str(i+1)+"::INTEGER,"
        if Pole=='N':
            POLA+="wartosc"+str(i+1)+"::FLOAT,"
        if Pole=='T':
            POLA+="wartosc"+str(i+1)+","
    POLA = POLA.strip(',')
    SQL = "SELECT "+POLA+" FROM rs_kp_dane_osobowe_dane_dodatkowe "
    SQL+= "WHERE firma_id='"+self.firma_id+"' AND lp="+str(LP)+" AND pracownik_id='"+Pracownik+"';"
    stat,dane,wyn1,tr = self.PolSQL.Execute(SQL,3)
    if stat<>'OK':
        stat = 'PO BL'  
        dane.append(stat)
    
    if stat=='OK':
        tr = rssql.RSTableRowset(dane,wyn1)
        
        if ((self.oddzial_id,'051051') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
            SQL = "SELECT nazwa FROM rs_kp_typy_informacji "
            SQL+= "WHERE firma_id='"+self.firma_id+"' AND typ_id='"+tr.GetVal(0,"typ_id")+"';"
            stat,d,dump,dump = self.PolSQL.Execute(SQL,3)
            if stat<>'OK':
                stat='NA BL'
                dane.append(stat)
            elif len(d) == 0:
                wyn2.append('')     
            else:
                wyn2.append(d[0][0])
        else:
            stat = 'NA BR'
            dane.append(stat)