# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_kp_dane_osobowe_jezyki_obce.py
# Purpose:     obsluga grida z jzykami pracownika
# Author:      Pawe Wjcikowski
# Created:     2010/09/07
# RCS-ID:      $Id: fs_kp_dane_osobowe_jezyki_obce.py $
# Copyright:   (c) 2010 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

Pracownik = rsglobal.Dekoduj(klucze[0])
Jezyk = rsglobal.Dekoduj(klucze[1])
Poziom = rsglobal.Dekoduj(klucze[2])
Fun = klucze[-1]
dane = []
wyn1 = []
wyn2 = []
stat = 'OK'

UprDodawanie = ((self.oddzial_id,'052163') in self.uprawnienia or self.operator_id == STANDARD_OPERATOR_ID)
UprEdycja = ((self.oddzial_id,'052162') in self.uprawnienia or self.operator_id == STANDARD_OPERATOR_ID) or UprDodawanie
UprUsuwanie = ((self.oddzial_id,'052164') in self.uprawnienia or self.operator_id == STANDARD_OPERATOR_ID)

Insert = []
Update = []
Delete = []
   
if Fun == 1:
    Update=klucze[-2]
    Insert=klucze[-3]
    Delete=klucze[-4]
  
  
#-------------------------------------------------------------------------------
#---   SPRAWDZENIE UPR. DO MODUU
#-------------------------------------------------------------------------------

sql ="SELECT rsf_kadry_dozwolony_modul('"+self.firma_id+"','"+str(self.operator_id)+"','jezyki_obce','"+Pracownik+"');"
stat,Dane,dump,dump = self.PolSQL.Execute(sql,3)
if stat == 'OK':
    if Dane[0][0]<>'OK':       
        stat = Dane[0][0]
        dane.append(stat)
else:
    stat='Problemy przy sprawdzaniu uprawnie do wybranego moduu :'+stat
    dane.append(stat)  
             
        
#-------------------------------------------------------------------------------
#---   POBRANIE JZYKA (7)
#-------------------------------------------------------------------------------

if Fun == 7 and stat=="OK":
    SELECT =" SELECT opis FROM rs_jezyki_obce WHERE kod = '"+str(Jezyk)+"' AND firma_id='"+self.firma_id+"'; "
    stat,dane,wyn1,dump =self.PolSQL.Execute(SELECT, 3)    
    if stat <> 'OK':
        stat='Bd pobrania informacji o jzyku obcym : '+stat


#-------------------------------------------------------------------------------
#---   POBRANIE POZIOMU (8)
#-------------------------------------------------------------------------------

if Fun == 8 and stat=="OK":
    SELECT =" SELECT opis FROM rs_stopnie_zaawansowania_jezyka WHERE kod = '"+str(Poziom)+"'; "
    stat,dane,wyn1,dump =self.PolSQL.Execute(SELECT, 3)    
    if stat <> 'OK':
        stat='Bd pobrania informacji o poziomie : '+stat                      
                
                      
#-------------------------------------------------------------------------------
#---   UPDATE DANYCH (1)
#-------------------------------------------------------------------------------

if Fun == 1 and stat=="OK":
    if len(Update[0])>0:
        if not UprEdycja:
            stat='Brak uprawnie do edycji danych'
            dane.append(stat)  
                  
        if stat == 'OK':
            WierszeNr = Update[-1]
            for i in xrange(len(Update[0])):                
                for j in xrange(len(Update[0][i])): 
                    pole = Update[0][i][j]
                    wart = Update[1][i][j]
                    if pole == 'jezyk_id':
                        wart=str(wart).strip()
                        if wart == '':
                            stat = 'BR JEZYKA'
                            wyn2.append((WierszeNr[i],0))
                            dane.append(stat)
                        else:
                            sql ="SELECT kod FROM rs_jezyki_obce"
                            sql+=" WHERE firma_id = '"+self.firma_id+"'"
                            sql+=" AND kod = '"+str(wart)+"';" 
                            st,d,dump,dump = self.PolSQL.Execute(sql,3)
                            if st <> 'OK':
                                stat = 'Bd pobrania danych o jzyku '
                                wyn2.append((WierszeNr[i],0))
                                dane.append(stat)
                            elif len(d) == 0:
                                stat = 'BL JEZYK'
                                wyn2.append((WierszeNr[i],0))
                                dane.append(stat)                 

                    elif pole == 'poziom':
                        wart=str(wart).strip()
                        if wart == '':
                            stat = 'BR POZIOM'
                            wyn2.append((WierszeNr[i],2))
                            dane.append(stat)
                        else:
                            sql ="SELECT kod FROM rs_stopnie_zaawansowania_jezyka"
                            sql+=" WHERE kod = '"+str(wart)+"';" 
                            st,d,dump,dump = self.PolSQL.Execute(sql,3)
                            if st <> 'OK':
                                stat = 'Bd pobrania danych o poziomie '
                                wyn2.append((WierszeNr[i],2))
                                dane.append(stat)
                            elif len(d) == 0:
                                stat = 'BL POZIOM'
                                wyn2.append((WierszeNr[i],2))
                                dane.append(stat) 
                                                    
        if stat == 'OK':
            if len(dane) > 0:
                stat = dane[0]
                                                                    
        if stat=='OK':
            sql=''        
            for i in xrange(len(Update[0])):   
                UPDATE="UPDATE rs_kp_dane_osobowe_jezyki_obce "
                SET='SET '
                for j in xrange(len(Update[0][i])): 
                    pole=Update[0][i][j]
                    wart=Update[1][i][j]
                    if pole in ['jezyk_id','poziom']:
                        if str(wart) =='':
                            SET+=pole+"=NULL,"
                        else:
                            SET+=pole+"='"+str(wart)+"',"
                SET=SET.strip(",")
                WHERE=" WHERE firma_id='"+self.firma_id+"' AND pracownik_id ='"+str(Pracownik)+"'"
                for j in xrange(len(Update[2][i])): # petla po kluczu
                    pole=Update[3][j]
                    wart=rsglobal.Dekoduj(Update[2][i][j])
                    WHERE+=" AND "+pole+"='"+str(wart)+"'"
                WHERE+=";" 
                if str(SET)=='SET ':
                    pass
                else:
                    sql+=UPDATE+SET+WHERE;
            if sql<>'':
                stat,dump,dump,dump=self.PolSQL.Execute(rsglobal.Dekoduj(sql),1)   
                if stat<>'OK':
                    stat=u"Bd przy modyfikowaniu danych: "+stat   
                    dane.append(stat)  


#-------------------------------------------------------------------------------
#-------   DELETE  (1)
#-------------------------------------------------------------------------------

if Fun == 1 and stat=="OK":
    if len(Delete[0])>0:
        if not UprUsuwanie:
            stat='Brak uprawnie do usuwania danych'
            dane.append(stat)    
                       
        if stat=='OK':
            sql=''
            for i in xrange(len(Delete[0])):               
                DELETE="DELETE FROM rs_kp_dane_osobowe_jezyki_obce "
                WHERE="WHERE firma_id='"+self.firma_id+"' AND pracownik_id='"+str(Pracownik)+"'"
                for j in xrange(len(Delete[0][i])):                    
                    pole=Delete[1][j]
                    wart=Delete[0][i][j]
                    if pole in ['jezyk_id','poziom']:
                        WHERE+=" AND "+pole+"='"+str(wart)+"'"
                sql+=DELETE+WHERE+";"
            if sql<>'':                
                stat,dump,dump,dump=self.PolSQL.Execute(rsglobal.Dekoduj(sql),1)
            if stat<>'OK':
                stat=u"Bd przy usuwaniu danych: "+stat   
                dane.append(stat)  

                                    
#-------------------------------------------------------------------------------
#--------- INSERT (1)
#-------------------------------------------------------------------------------

if Fun == 1 and stat=="OK":
    if len(Insert[0])>0:
        if not UprDodawanie:
            stat='Brak uprawnie do dodawania danych'
            dane.append(stat)
            
        if stat=='OK':        
            Insert=klucze[-3]
            WierszeNr = Insert[-1]        
            for i in xrange(len(Insert[0])):
                for j in xrange(len(Insert[0][i])): 
                    pole=Insert[1][j]
                    wart=Insert[0][i][j]
                    if pole == 'jezyk_id':
                        wart=str(wart).strip()
                        if wart == '':
                            stat = 'BR JEZYKA'
                            wyn2.append((WierszeNr[i],0))
                            dane.append(stat)
                        else:
                            sql ="SELECT kod FROM rs_jezyki_obce"
                            sql+=" WHERE firma_id = '"+self.firma_id+"'"
                            sql+=" AND kod = '"+str(wart)+"';" 
                            st,d,dump,dump = self.PolSQL.Execute(sql,3)
                            if st <> 'OK':
                                stat = 'Bd pobrania danych o jzyku '
                                wyn2.append((WierszeNr[i],0))
                                dane.append(stat)
                            elif len(d) == 0:
                                stat = 'BL JEZYK'
                                wyn2.append((WierszeNr[i],0))
                                dane.append(stat)                  

                    elif pole == 'poziom':
                        wart=str(wart).strip()
                        if wart == '':
                            stat = 'BR POZIOM'
                            wyn2.append((WierszeNr[i],2))
                            dane.append(stat)
                        else:
                            sql ="SELECT kod FROM rs_stopnie_zaawansowania_jezyka"
                            sql+=" WHERE kod = '"+str(wart)+"';" 
                            st,d,dump,dump = self.PolSQL.Execute(sql,3)
                            if st <> 'OK':
                                stat = 'Bd pobrania danych o poziomie '
                                wyn2.append((WierszeNr[i],2))
                                dane.append(stat)
                            elif len(d) == 0:
                                stat = 'BL POZIOM'
                                wyn2.append((WierszeNr[i],2))
                                dane.append(stat)                                

        if stat == 'OK':
            if len(dane) > 0:
                stat = dane[0]

        if stat=='OK':    
            sqlIns=''
            for i in xrange(len(Insert[0])):
                INSERT="INSERT INTO rs_kp_dane_osobowe_jezyki_obce "
                KOLUMNY="(firma_id,pracownik_id"
                VALUES=" VALUES ('"+self.firma_id+"','"+str(Pracownik)+"'"
                for j in xrange(len(Insert[0][i])):
                    pole=Insert[1][j]
                    wart=Insert[0][i][j]
                    if pole in ['jezyk_id','poziom']:
                        KOLUMNY+=","+pole
                        VALUES+=",'"+str(wart)+"'"             
                KOLUMNY+=")"
                VALUES+=");"
                sqlIns+=INSERT+KOLUMNY+VALUES
                            
            if sqlIns<>'':
                stat,dump,dump,dump=self.PolSQL.Execute(rsglobal.Dekoduj(sqlIns),1)
                if stat<>'OK':
                    stat=u"Bd przy dodawaniu danych: "+stat   
                    dane.append(stat)    
                    

#-------------------------------------------------------------------------------
#---- SELECT - 5 Pobieranie listy jezykow pracownika
#-------------------------------------------------------------------------------

if Fun in (1,5,6) and stat == 'OK':    
    SELECT =" SELECT kp.jezyk_id,j.opis,kp.poziom,szj.opis "
    SELECT+=" FROM rs_kp_dane_osobowe_jezyki_obce kp "
    SELECT+=" LEFT JOIN rs_jezyki_obce j ON (kp.firma_id=j.firma_id and kp.jezyk_id=j.kod)"
    SELECT+=" LEFT JOIN rs_stopnie_zaawansowania_jezyka szj ON (kp.poziom=szj.kod)"
    SELECT+=" WHERE kp.firma_id = '"+self.firma_id+"' AND kp.pracownik_id = '"+Pracownik+"';"      
    stat,dane,wyn1,dump =self.PolSQL.Execute(SELECT, 3)    
    if stat <> 'OK':
        stat='Bd pobrania listy pracownikow : '+stat