# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_kp_dane_osobowe_szkolenia.py
# Purpose:     grid z odbytymi szkoleniami pracownika
# Author:      Marcin Natkaski
# Created:     2012/10/07
# RCS-ID:      $Id: fs_kp_dane_osobowe_szkolenia.py $
# Copyright:   (c) 2012 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------
# 2023-10-19 Aleksander Bargie - (13564) refaktoryzacja okna
stat = 'OK'

if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=='OK':
    Fun = klucze['Funkcja']
    
    SlPar={'Pracownik':[5]}    
    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Fun,klucze)
    if Lista<>'':
        stat='Uwaga : wywoanie funkcji fs_kp_dane_osobowe_szkolenia z numerem '+str(Fun)+' bez parametrw: '+Lista

if stat=='OK':
    if Fun in [5,]:
        Pracownik=rsglobal.Dekoduj(klucze['Pracownik'])

#-------------------------------------------------------------------------------
#-------------------------------------------------------------------------------
#---- SELECT - 5  
#-------------------------------------------------------------------------------
#-------------------------------------------------------------------------------

if Fun == 5 and stat == 'OK':
    SQL ="SELECT szkolenie_id || ' - ' || s.nazwa AS szkolenie,"
    SQL+="typ_szkolenia || ' - ' || t.opis AS typ_szkolenia, "
    SQL+="NOT s.czy_zewnetrzne AS wewnetrzne, "
    SQL+="s.czy_obowiazkowe, "
    SQL+="COALESCE(data_szkolenia::TEXT,'') AS data_szkolenia, "
    SQL+="COALESCE(data_waznosci::TEXT,'') AS data_waznosci "
    SQL+=" FROM rs_kp_dane_osobowe_szkolenia ds "
    SQL+=" JOIN rs_szkolenia s USING (firma_id, szkolenie_id) "
    SQL+=" JOIN rs_szkolenia_typy t ON (ds.firma_id, s.typ_szkolenia) = (t.firma_id, t.kod) "
    SQL+=" WHERE ds.firma_id='"+self.firma_id+"' AND ds.pracownik_id='"+Pracownik+"'"
    SQL+=" ORDER BY szkolenie_id"
    stat,dane,wyn1,dump =self.PolSQL.Execute(SQL, 3)
    if stat != 'OK':
        stat='Bdy zapytania pobierajcego dane : '+stat
        dane.append(stat)