# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_kp_edeklaracje_skladniki.py
# Purpose:     obsluga grida edytowalnego laczacego skladniki list plac z edeklaracjami
# Author:      Aleksander Bargie
# Created:     2019/05/14
# RCS-ID:      $Id: fs_kp_edeklaracje_skladniki $
# Copyright:   (c) 2019 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

stat = 'OK'

"""Funkcje:
1. Update, Delete i Insert z RSEdit
5. Pobranie danych"""

if 'Funkcja' not in klucze:
    stat = 'Brak podanej funkcji w kluczach'

if stat == 'OK':
    Funkcja = klucze['Funkcja']

    SlPar = {'Typ': [1, 5]}
    Lista = rsglobal.SprawdzParametryWKluczach(SlPar, Funkcja, klucze)
    if Lista != '':
        stat = 'Uwaga : wywoanie funkcji fs_kp_skladniki_edeklaracji z numerem '+str(Funkcja)+' bez parametrw: '+Lista

if stat == 'OK':
    if Funkcja in (1, 5):
        typ_id = klucze['Typ']
dane = []
wyn1 = []
wyn2 = []

UprModyf = ((self.oddzial_id, '061032') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID
    
#-------------------------------------------------------------------------------
#-------- EDYCJA GRIDA EDYTOWALNEGO (1)
#-------------------------------------------------------------------------------

Insert = []
Update = []
Delete = []

if stat == 'OK' and Funkcja == 1:
    Update = klucze['Update']
    Insert = klucze['Insert']
    Delete = klucze['Delete']


#-------------------------------------------------------------------------------
#-----------------------------   DELETE (1) ------------------------------------
#-------------------------------------------------------------------------------

if stat == 'OK' and Funkcja == 1:
    if len(Delete[0])>0:
        if not UprModyf:
            stat='BR UPR MOD'
            dane.append(stat)
                
        # wykonanie DELETE 
        if stat == 'OK':
            SQLDEL = ''
            for i in xrange(len(Delete[0])):
                DELETE = "DELETE FROM rs_edeklaracje_wersje "
                WHERE  = "WHERE typ_id='"+typ_id+"'"
                for j in xrange(len(Delete[0][i])):
                    pole = Delete[1][j]
                    wart = Delete[0][i][j]
                    WHERE += " AND "+pole+"='"+wart+"'"
                
                SQLDEL += DELETE+WHERE+"; "

            if stat == "OK" and SQLDEL != '':
                stat,dump,dump,dump = self.PolSQL.Execute(rsglobal.Dekoduj(SQLDEL),1)
                if stat != 'OK':
                    stat = "Bd przy usuwaniu danych: "+stat   
                    dane.append(stat)


#-------------------------------------------------------------------------------
#-------------------------------  UPDATE (1)  ----------------------------------
#-------------------------------------------------------------------------------

if stat == 'OK' and Funkcja == 1:
    if len(Update[0])>0:
        if not UprModyf:
            stat='BR UPR MOD'
            dane.append(stat)

        if stat == 'OK':
            WierszeNr = Update[-1]

            for i in xrange(len(Update[0])):
                for j in xrange(len(Update[0][i])): 
                    pole = Update[0][i][j]
                    wart = Update[1][i][j]

                    if pole == 'data_od':
                        if wart.strip() in ['', '-  -']:
                            wyn2.append((WierszeNr[i], 0))
                            dane.append('DATAOD BR')
                        elif not rsglobal.SprawdzCzyToData(wart):
                            wyn2.append((WierszeNr[i], 0))
                            dane.append('DATAOD BL')
        if stat == 'OK':
            if len(dane) > 0:
                stat = dane[0]
                
        # wykonanie UPDATE
        if stat=='OK':
            sql=''
            for i in xrange(len(Update[0])):
                UPDATE="UPDATE rs_edeklaracje_wersje "
                SET='SET '
                for j in xrange(len(Update[0][i])): 
                    pole=Update[0][i][j]
                    wart=Update[1][i][j]
                    if pole in ['wersja_id', 'data_od', 'adres_url']:
                        SET+=pole+"='"+str(wart)+"',"

                SET=SET.strip(",")
                WHERE=" WHERE typ_id='"+typ_id+"'"
                for j in xrange(len(Update[2][i])):
                    pole=Update[3][j]
                    wart=rsglobal.Dekoduj(Update[2][i][j])
                    if pole in ['wersja_id']:
                        WHERE+= " AND "+pole+"='"+wart+"'"

                WHERE+=";"
                
                sql+=UPDATE+SET+WHERE;
            if sql!='':
                stat,dump,dump,dump=self.PolSQL.Execute(rsglobal.Dekoduj(sql),1)
                if stat!='OK':
                    stat="Bd przy modyfikowaniu danych: "+stat   
                    dane.append(stat)

#-------------------------------------------------------------------------------
#------------------------------  INSERT (1)  -----------------------------------
#-------------------------------------------------------------------------------

if stat == 'OK' and Funkcja == 1:
    if len(Insert[0])>0:
        if not UprModyf:
            stat='BR UPR MOD'
            dane.append(stat)

        if stat == 'OK':
            WierszeNr = Insert[-1]
            for i in xrange(len(Insert[0])):
                for j in xrange(len(Insert[0][i])): 
                    pole=Insert[1][j]
                    wart=Insert[0][i][j]

                    if pole == 'data_od':
                        if wart.strip() in ['','-  -']:
                            wyn2.append((WierszeNr[i],0))
                            dane.append('DATAOD BR')
                        elif not rsglobal.SprawdzCzyToData(wart):
                            wyn2.append((WierszeNr[i],0))
                            dane.append('DATAOD BL')

                    if pole == 'wersja_id':
                        wersja_id = wart
                                    
        if stat == 'OK':
            if len(dane) > 0:
                stat = dane[0]

        # wykonanie INSERT
        if stat == 'OK':
            sqlIns=''
            for i in xrange(len(Insert[0])):
                INSERT="INSERT INTO rs_edeklaracje_wersje "
                KOLUMNY="(typ_id "
                VALUES=" VALUES ('"+typ_id+"'"
                for j in xrange(len(Insert[0][i])):
                    pole=Insert[1][j]
                    wart=Insert[0][i][j]
                    KOLUMNY+=","+pole
                    if pole in ['data_od']:
                        data = wart
                        if wart.strip() in ['','-  -']:
                            VALUES+=",NULL"
                            datawar = ''
                        else:
                            VALUES+=",'"+wart+"'"
                            datawar = "AND data_od<'"+wart+"' "
                    elif pole in ['adres_url', 'wersja_id']:
                        VALUES+=",'"+str(wart)+"'"

                KOLUMNY+=")"
                VALUES+=");"
                SqlInsSkl = """\n INSERT INTO rs_edeklaracje_skladniki (firma_id, typ_id, wersja_id, platnik_id, kolumna_id, skladniki)
SELECT firma_id, typ_id, '{wersja}', platnik_id, kolumna_id, skladniki FROM rs_edeklaracje_skladniki s WHERE firma_id = '{firma_id}' AND typ_id = '{typ}' AND wersja_id=(SELECT wersja_id 
                                                                             FROM rs_edeklaracje_wersje s2
                                                                             WHERE s2.typ_id = s.typ_id {datawar} ORDER BY data_od DESC LIMIT 1);""".format(datawar=datawar, typ=typ_id, wersja=wersja_id, firma_id=self.firma_id)
                sqlIns+=INSERT+KOLUMNY+VALUES + SqlInsSkl
            if sqlIns!='': 
                stat,dump,dump,dump=self.PolSQL.Execute(rsglobal.Dekoduj(sqlIns), 1, CzyDodawacBlad=True)
                rsglobal.ZapiszDoLogow(rsglobal.Dekoduj(sqlIns), 5)
                rsglobal.ZapiszDoLogow(stat)
                if stat!='OK':
                    stat="Bd przy dodawaniu danych: "+stat
                    dane.append(stat)


#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (1- insert 1 -select, 1 -delete, 5 -select) 
#-------------------------------------------------------------------------------

if stat == 'OK' and Funkcja in (1, 5):
    SQL ="SELECT wersja_id, data_od, TRIM(adres_url) as adres_url "
    SQL+=" FROM rs_edeklaracje_wersje"
    SQL+=" WHERE typ_id='"+typ_id+"'"
    SQL+=" ORDER BY wersja_id;"
    stat,dane,wyn1,wyn2 = self.PolSQL.Execute(SQL,3)
    if stat != 'OK':
        stat = "Bd przy pobieraniu danych: "+stat
        dane.append(stat)