# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_kp_grafik_planowany_edycja.py
# Purpose:     obsluga grida edytowalnego z grafikami
# Author:      Marcin Natkaski
# Created:     2015/07/10
# RCS-ID:      $Id: fs_kp_grafik_planowany_edycja.py$
# Copyright:   (c) 2015 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

stat='OK'

if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=='OK':
    Funkcja = klucze['Funkcja']
    
    SlPar={'Indeksy':[6], 'Pracownik':[1,5,],'Data':[1,5,],
           'Oddzial':[1],'MiejscePracy':[1],'Kalendarz':[1],'Stan':[1],'StanowiskoMiejsce':[1], 'Stanowisko':[1], }
    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Funkcja,klucze)
    if Lista<>'':
        stat='Uwaga : wywoanie funkcji fs_kp_grafik_planowany_edycja z numerem '+str(Funkcja)+' bez parametrw: '+Lista
        
    if Funkcja in [6,]:
        Indeksy=rsglobal.Dekoduj(klucze['Indeksy'])
        #jako, e inkdeksy przychdz w dziwnej formie, przerobimy je na form urzyteczn
        Indeksy=Indeksy[0].split(';')
        tworzenie_warunku = '('
        for m in Indeksy[:-1]:
            tworzenie_warunku+=m+','
        Indeksy = tworzenie_warunku[:-1]+')'

    if Funkcja in [1,]:
        Oddzial=rsglobal.Dekoduj(klucze['Oddzial'])
        MiejscePracy=rsglobal.Dekoduj(klucze['MiejscePracy'])
        Kalendarz=rsglobal.Dekoduj(klucze['Kalendarz'])
        Stan=rsglobal.Dekoduj(klucze['Stan'])
        StanowiskoMiejsce=rsglobal.Dekoduj(klucze['StanowiskoMiejsce'])
        Stanowisko=rsglobal.Dekoduj(klucze['Stanowisko'])

    if Funkcja in [1,5,]:
        Data=rsglobal.Dekoduj(klucze['Data'])
        Pracownik=rsglobal.Dekoduj(klucze['Pracownik'])



dane = []
wyn1 = []
wyn2 = []

Puste = (None,'')

UprIns=((self.oddzial_id,'054103') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID
UprUpd=((self.oddzial_id,'054102') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID or UprIns
UprDel=((self.oddzial_id,'054104') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID

Insert = []
Update = []
Delete = []

if stat=='OK' and Funkcja == 1:
    Update=klucze['Update']
    Insert=klucze['Insert']
    Delete=klucze['Delete']

#-------------------------------------------------------------------------------
#-------  POBRANIE OPISU PRACOWNIKA (8)
#-------------------------------------------------------------------------------

#if Funkcja == 8 and stat == "OK":
#    sql ="SELECT imie||' '||nazwisko FROM rs_kp_dane_osobowe"
#    sql+=" WHERE firma_id='"+self.firma_id+"' AND pracownik_id='"+Pracownik+"';"
#    stat,dane,dump,dump = self.PolSQL.Execute(sql,3)
#    if stat <> 'OK':
#        stat = 'Bd przy sprawdzaniu opisu staej: '+stat
#        dane.append(stat)

#-------------------------------------------------------------------------------
#-------  SPRAWDZANIE DELETE  --------------------------------------------------
#-------------------------------------------------------------------------------

if Funkcja == 1 and stat=="OK":
    if len(Delete[0])>0:
        if not UprDel:
            stat='Brak uprawniedo usuwania'
            dane.append(stat)
        
        # wykonanie DELETE 
        if stat == 'OK':
            SQLDEL = ''
            SQLFU = ''
            for i in xrange(len(Delete[0])):
                DELETE = "DELETE FROM rs_kp_grafiki_pozycje "
                WHERE = "WHERE firma_id='"+self.firma_id+"' "
                SQLFU = "SELECT poz_grafiku_id FROM rs_kp_grafiki_pozycje"
                SQLFU+= " WHERE firma_id='"+self.firma_id+"' " 
                #sprawdzimy czy mona usuwa
                for j in xrange(len(Delete[0][i])):
                    pole = Delete[1][j]
                    wart = Delete[0][i][j]
                    if pole in ['poz_grafiku_id',]:
                        SQL=" SELECT poz_grafiku_id FROM rs_kp_grafiki_pozycje" 
                        SQL+=" WHERE firma_id='"+self.firma_id+"' AND poz_grafiku_id='"+str(wart)+"' AND stan='Z'"
                        stat,d,dump,dump = self.PolSQL.Execute(SQL,3)
                        if stat<>'OK':
                            wyn2.append((WierszeNr[i],0))
                            dane.append("Bd sprawdania stanu pozycji grafiku.")
                        elif len(d)>0:
                            dane.append("Nie mona usuwa pozycji '"+str(wart)+".'\n Pozycja grafiku jest w stanie Z.")
                            wyn2.append((WierszeNr[i],0))
                
                for j in xrange(len(Delete[0][i])):
                    pole = Delete[1][j]
                    wart = Delete[0][i][j]
                    if pole in ['poz_grafiku_id',]:
                        WHERE += " AND "+pole+"='"+str(wart)+"'"
                        SQLFU += " AND "+pole+"='"+str(wart)+"'"

                SQLDEL += DELETE+WHERE+"; "
                SQLFU += " FOR UPDATE NOWAIT; "

            if SQLFU <> '':
                stat,d,dump,dump = self.PolSQL.Execute(rsglobal.Dekoduj(SQLFU),3)
                if stat <> 'OK':
                    stat = 'Bd sprawdzenia danych do usunicia: '+stat
                    dane.append(stat)
            
            if stat == 'OK' and SQLDEL <> '':
                stat,dump,dump,dump = self.PolSQL.Execute(rsglobal.Dekoduj(SQLDEL),1)
                if stat <> 'OK':
                    stat = "Bd przy usuwaniu danych: "+stat   
                    dane.append(stat)

                                 
#-------------------------------------------------------------------------------
#---   UPDATE DANYCH (1)
#-------------------------------------------------------------------------------

if Funkcja == 1 and stat=="OK":
    if len(Update[0])>0:
        if not UprUpd:
            stat='Brak uprawnie do edycji'
            dane.append(stat)
        if stat == 'OK':
            WierszeNr = Update[-1]
            for i in xrange(len(Update[0])):
                #sprawdzimy czy moemy edytowa pozycje
                for j in xrange(len(Update[2][i])): # petla po kluczu
                    pole=Update[3][j]
                    wart=rsglobal.Dekoduj(Update[2][i][j])
                    if pole in ['poz_grafiku_id',]:
                        SQL=" SELECT poz_grafiku_id FROM rs_kp_grafiki_pozycje" 
                        SQL+=" WHERE firma_id='"+self.firma_id+"' AND poz_grafiku_id='"+str(wart)+"' AND stan='Z'"
                        stat,d,dump,dump = self.PolSQL.Execute(SQL,3)
                        if stat<>'OK':
                            wyn2.append((WierszeNr[i],0))
                            dane.append("Bd sprawdania stanu pozycji grafiku.")
                        elif len(d)>0:
                            dane.append("Nie mona dokona zmian dla pozycji '"+str(wart)+".'\n Pozycja grafiku jest w stanie Z.")
                            wyn2.append((WierszeNr[i],0))

                grafik_id=Update[2][i][0]
                usun = False
                for j in xrange(len(Update[0][i])):
                    pole=Update[0][i][j]
                    wart=Update[1][i][j]
                    if pole=='data' and wart.strip()=='':
                        usun = True
                if not usun:
                    for j in xrange(len(Update[0][i])):
                        pole=Update[0][i][j]
                        wart=Update[1][i][j]
                        if pole=='godzina_od' and wart.strip() =='':
                            dane.append("Brak uzupenionej godziny od")
                            wyn2.append((WierszeNr[i],5))

                        elif pole=='godzina_do' and wart.strip() =='':
                            dane.append("Brak uzupenionej godziny do")
                            wyn2.append((WierszeNr[i],6))

                if stat == 'OK':
                    if len(dane) > 0:
                        stat = dane[0]
                # wykonanie UPDATE
                if stat=='OK':
                    sql=''
                    UPDATE="UPDATE rs_kp_grafiki_pozycje "
                    SET='SET '
                    DELETE = ''
                    data=Update[2][i][1]
                    godz_od_klucz = Update[2][i][2]
                    godz_do_klucz = Update[2][i][3]
                    godz_od=''
                    godz_do=''
                    modyfikacja_daty = 'data' in Update[0][i]

                    for j in xrange(len(Update[0][i])):
                        pole=Update[0][i][j]
                        wart=Update[1][i][j]
                        if pole =='data':
                            if wart.strip() =='':
                                DELETE += " DELETE FROM rs_kp_grafiki_pozycje "
                                DELETE += "WHERE firma_id='" + self.firma_id + "' AND poz_grafiku_id='" + str(grafik_id) + "';"
                            else:
                                data=wart

                        elif pole=='godzina_od':
                            godz_od=wart.strip()

                        elif pole=='godzina_do':
                            godz_do=wart.strip()

                    if not usun:
                        if godz_od<>'':
                            SET+='plan_czas_od='+"'"+data+" "+godz_od+"'::TIMESTAMP,"
                        elif modyfikacja_daty:
                            SET+='plan_czas_od='+"'"+data+" "+godz_od_klucz+"'::TIMESTAMP,"

                        if godz_do<>'':
                            if rsglobal.PorownajGodziny(godz_od, godz_do):
                                interwal = ""
                            else:
                                interwal = "+interval '1 day'"
                            SET+='plan_czas_do='+"'"+data+" "+godz_do+"'::TIMESTAMP"+interwal+","
                        elif modyfikacja_daty:
                            if godz_od == '':
                                godz_od= godz_od_klucz
                            if rsglobal.PorownajGodziny(godz_od, godz_do_klucz):
                                interwal = ""
                            else:
                                interwal = "+interval '1 day'"
                            SET+='plan_czas_do='+"'"+data+" "+godz_do_klucz+"'::TIMESTAMP"+interwal+","

                    SET=SET.strip(",")
                    WHERE=" WHERE firma_id='"+self.firma_id+"'" 
                    for j in xrange(len(Update[2][i])): # petla po kluczu
                        pole=Update[3][j]
                        wart=rsglobal.Dekoduj(Update[2][i][j])
                        if pole in ['poz_grafiku_id',]:
                            WHERE+=" AND "+pole+"='"+str(wart)+"'"
                    WHERE+=";"
                    sql+=UPDATE+SET+WHERE
                    if len(SET)>4:
                        stat,dump,dump,dump = self.PolSQL.Execute(rsglobal.Dekoduj(sql),1)
                        if stat<>'OK':
                            stat="Bdy aktualizacji danych: "+stat
                            dane.append(stat)
                    if stat == 'OK' and DELETE<>'':
                        stat,dump,dump,dump = self.PolSQL.Execute(rsglobal.Dekoduj(DELETE),1)
                        if stat<>'OK':
                            stat="Bdy usuwania grafiku przy aktualizacji: "+stat
                            dane.append(stat)
                    

#-------------------------------------------------------------------------------
#---------Sprawdzanie danych do Insert
#-------------------------------------------------------------------------------

if stat=="OK" and Funkcja == 1:
    if len(Insert[0])>0:
        if not UprIns:
            stat='Brak uprawnie do dodawania'
            dane.append(stat)
        if stat == 'OK':
            WierszeNr = Insert[-1]
            for i in xrange(len(Insert[0])):
                for j in xrange(len(Insert[0][i])): 
                    pole=Insert[1][j]
                    wart=Insert[0][i][j]
                    if pole == 'data':
                        wart = wart.strip()
                        if wart == '':
                            stat = 'Niewypeniona data'
                            wyn2.append((WierszeNr[i],4))
                            dane.append(stat)
                        else:
                            data = wart

                    if pole == 'godzina_od':
                        wart = wart.strip()
                        if wart == '':
                            stat = 'Niewypeniona godzina od.'
                            wyn2.append((WierszeNr[i],5))
                            dane.append(stat)
                        else:
                            godzina_od = wart
                    if pole == 'godzina_do':
                        wart = wart.strip()
                        if wart == '':
                            stat = 'Niewypeniona godzina do.'
                            wyn2.append((WierszeNr[i],6))
                            dane.append(stat)
                        else:
                            godzina_do = wart
                # sprawdzenie, czy nie ma bledow
                if stat == 'OK':
                    if len(dane) > 0:
                        stat = dane[0]
                # wykonanie INSERT do pojedynczego wiersza
                if stat == 'OK':
                    SELECT="SELECT max(poz_grafiku_id)+1 FROM rs_kp_grafiki_pozycje WHERE firma_id='"+self.firma_id+"';"
                    stat,max,dump,dump = self.PolSQL.Execute(SELECT,3)
                    if stat <> 'OK':
                        stat = "Bd przy pobieraniu id nowego grafika: "+stat
                        dane.append(stat)
                    else:
                        INSERT=" INSERT INTO rs_kp_grafiki_pozycje (poz_grafiku_id,firma_id,pracownik_id,oddzial_id,plan_miejsce_pracy_id,"
                        INSERT+="plan_czas_od,plan_czas_do, kalendarz_id,stan, plan_stanowisko_miejsce_id,plan_stanowisko_pracy_id) "
                        INSERT+="VALUES('"+str(max[0][0])+"','"+self.firma_id+"','"+str(Pracownik)+"',"
                        if Oddzial.strip()<>'':
                            INSERT+="'"+str(Oddzial)+"',"
                        else:
                            INSERT+="Null,"
                        INSERT+="'"+str(MiejscePracy)+"',"
                        if rsglobal.PorownajGodziny(godzina_od, godzina_do):
                            interwal = ""
                        else:
                            interwal = "+interval '1 day'"
                        INSERT+="'"+data+" "+godzina_od+"'::TIMESTAMP, '"+data+" "+godzina_do+"'::TIMESTAMP "+interwal+", "
                        INSERT+="'"+str(Kalendarz)+"','"+str(Stan)+"','"+StanowiskoMiejsce+"','"+Stanowisko+"');"
                        stat,dump,dump,dump=self.PolSQL.Execute(rsglobal.Dekoduj(INSERT),1)
                        if stat<>'OK':
                            stat="Bd przy dodawaniu danych: "+stat
                            dane.append(stat)

                #zbieramy infomracje o dodanych pozycjach
                        #if stat=='OK':
                        #    Indeksy=Indeksy[:-1]+','+str(max[0][0])+')'


#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH OKNA EDYCJI EDYTUJ
#-------------------------------------------------------------------------------

if Funkcja in (5,1) and stat == 'OK':
    Data = Data.strip()
    rok = Data[0:4]
    mies = Data[5:7]
    DataOd = str(rok)+'-'+str(mies)+'-01'
    DataDo = str(rok)+'-'+str(mies)+'-'+str(rsglobal.PodajOstatniDzien(Data))

    if stat=='OK':
        SQL=" SELECT g.poz_grafiku_id, substring(g.plan_czas_od::TEXT from 1 for 10), "
        SQL+=" substring(g.plan_czas_od::TEXT from 12 for 5),substring(g.plan_czas_do::TEXT from 12 for 5),"
        SQL+=" substring(g.plan_czas_od::TEXT from 1 for 10),"
        SQL+=" substring(g.plan_czas_od::TEXT from 12 for 5),substring(g.plan_czas_do::TEXT from 12 for 5) "
        SQL+=" FROM rs_kp_grafiki_pozycje g "
        SQL+=" WHERE g.firma_id='"+self.firma_id+"' AND g.pracownik_id='"+Pracownik+"' "
        SQL+=" AND substring(g.plan_czas_od::TEXT from 1 for 10) BETWEEN '"+DataOd+"' and '"+DataDo+"'"
        SQL+=" ORDER BY g.plan_czas_od,g.plan_czas_do;"
        stat,dane,wyn1,wyn2 = self.PolSQL.Execute(SQL,3)
        if stat <> 'OK':
            stat = "Bd przy pobieraniu danych: "+stat
            dane.append(stat)

#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH OKNA EDYCJI
#-------------------------------------------------------------------------------

if stat == 'OK' and Funkcja ==6:
    SQL=" SELECT g.poz_grafiku_id, g.pracownik_id, o.imie||' '||o.nazwisko as pracownik, g.plan_stanowisko_pracy_id, s.opis,"
    SQL+=" oddzial_id,plan_miejsce_pracy_id,kalendarz_id,stan, plan_stanowisko_miejsce_id "
    SQL+=" FROM rs_kp_grafiki_pozycje g INNER JOIN rs_kp_dane_osobowe o USING(firma_id,pracownik_id) "
    SQL+=" INNER JOIN rs_stanowiska_pracy s ON g.plan_stanowisko_pracy_id=s.kod AND g.firma_id=s.firma_id"
    SQL+=" WHERE g.firma_id='"+self.firma_id+"' AND g.poz_grafiku_id in "+Indeksy+" ORDER BY g.poz_grafiku_id; "
    stat,dane,wyn1,wyn2 = self.PolSQL.Execute(SQL,3)
    if stat <> 'OK':
        stat = "Bd przy pobieraniu danych: "+stat
        dane.append(stat)