# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_kp_historia_zatrudnienia.py
# Purpose:     wczytuje liste/usuwa/ historie zatrudnienia dla pracownika
#
# Author:      Mariusz Rajfura
# Created:     2009/10/16
# RCS-ID:      $Id: fs_kp_historiazatrudnienia.py $
# Copyright:   (c) 2009 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

Pracownik = rsglobal.Dekoduj(klucze[0])
OdKiedy = rsglobal.Dekoduj(klucze[1])
OdKiedyF = rsglobal.Dekoduj(klucze[2][0])
DoKiedyF = rsglobal.Dekoduj(klucze[2][1])
NazwaFirmyF = rsglobal.Dekoduj(klucze[2][2])
Klucze_Id = klucze[3]

Fun = klucze[-1]
dane = []
wyn1 = []
stat = 'OK'

sql ="SELECT rsf_kadry_dozwolony_modul('"+self.firma_id+"','"+str(self.operator_id)+"','historia_zatrudnienia','"+Pracownik+"');"
stat,d,dump,dump = self.PolSQL.Execute(sql,3)
if stat == 'OK':
    stat = d[0][0]

UprUsuwanie = ((self.oddzial_id,'052054') in self.uprawnienia or self.operator_id == STANDARD_OPERATOR_ID)

#-------------------------------------------------------------------------------
#--- DELETE - 6
#-------------------------------------------------------------------------------

if Fun == 6 and stat == 'OK':
    if not UprUsuwanie:
        stat='Brak uprawnie do usuwania historii zatrudnienia.'

    if stat == 'OK':
        sql = "SELECT od_kiedy FROM rs_kp_historia_zatrudnienia"
        sql+=" WHERE firma_id = '"+self.firma_id+"' AND pracownik_id = '"+Pracownik+"'"
        sql+=" AND od_kiedy = '"+OdKiedy+"' FOR UPDATE NOWAIT;" 
        stat,d,dump,dump = self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Bd pobrania danych historii zatrudnienia dla pracownika : '+stat
        elif len(d) == 0:
            stat = 'Brak historii zatrudnienia rozpoczynajcej si podan dat : '+stat

        if stat == 'OK':
            sql ="SELECT od_kiedy FROM rs_kp_historia_bezplatnych"
            sql+=" WHERE firma_id = '"+self.firma_id+"' AND pracownik_id = '"+Pracownik+"'"
            sql+=" AND od_kiedy = '"+OdKiedy+"';"
            stat,d,dump,dump = self.PolSQL.Execute(sql, 3)
            if stat <> 'OK':
                stat = 'Bd pobrania informacji o urlopach bezpatnych dot.usuwanej historii zatrudnienia : '+stat
            elif len(d) > 0:
                stat = 'Usunicie niemoliwe. Istniej urlopy bezpatne w podanym okresie zatrudnienia ('+str(len(d))+').'

        if stat == 'OK':
            DELETE ="DELETE FROM rs_kp_historia_zatrudnienia"
            DELETE+=" WHERE firma_id = '"+self.firma_id+"' AND pracownik_id = '"+Pracownik+"'"
            DELETE+=" AND od_kiedy = '"+OdKiedy+"';" 
            stat,dump,dump,dump = self.PolSQL.Execute(DELETE, 1)
            if stat <> 'OK':
                stat='Bd usuwania historii zatrudnienia dla pracownika : '+stat

#-------------------------------------------------------------------------------
#---- SELECT - 5,6  Pobieranie listy historycznych zatrudnien
#-------------------------------------------------------------------------------

if Fun in (5,6) and stat == 'OK':
    FILTR = "(firma_id = '"+self.firma_id+"' AND pracownik_id = '"+Pracownik+"'"
    if OdKiedyF <> '    -  -  ':
        FILTR += " AND do_kiedy >= '"+OdKiedyF+"'"
    if DoKiedyF <> '    -  -  ':
        FILTR += " AND od_kiedy <= '"+DoKiedyF+"'"
    if NazwaFirmyF <> '':
        FILTR += " AND nazwa_firmy LIKE '"+NazwaFirmyF+"%'"
    FILTR += ")"

    #uzupelnienie podgladu o klucze nowe lub zmienione
    if len(Klucze_Id) > 0:
        FILTR += " OR (firma_id = '"+self.firma_id+"' AND pracownik_id = '"+Pracownik+"' AND od_kiedy IN ("
        for i in xrange(len(Klucze_Id)):
            if i > 0:
                FILTR += ","
            FILTR += "'"+str(Klucze_Id[i])+"'"
        FILTR += "))"

    SELECT ="SELECT od_kiedy,do_kiedy,nazwa_firmy FROM rs_kp_historia_zatrudnienia" 
    SELECT+=" WHERE "+FILTR+" ORDER BY od_kiedy;"

    stat,dane,wyn1,dump =self.PolSQL.Execute(SELECT, 3)
    if stat <> 'OK':
        stat='Bd pobrania listy historii zatrudnienia dla pracownika : '+stat
