# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_kp_kalendarze_dni.py
# Purpose:     obsluga grida z lista dni w kalendarzach
# Author:      Pawe Wjcikowski
# Created:     2010/08/02
# RCS-ID:      $Id: fs_kp_kalendarze_dni.py $
# Copyright:   (c) 2010 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------
# 2017-04-20 Piotr Witkowski (10459) [KP] - Kalendarze przyciski+refaktoryzacja

import rs_anakonda_daty
import rsglobal

stat='OK'
if stat == 'OK' and not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=='OK':
    Funkcja = klucze['Funkcja']
    SlPar={'KalendarzId':[1,5,9,11,12],'RokF':[1,5,9,11,12],'MiesiacF':[1,5,9,11,12],'Dodawac':[1,5,9,11,],}

    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Funkcja,klucze)
    if Lista<>'':
        stat=u'Uwaga : wywoanie funkcji fs_kp_kalendarze z numerem ' +str(Funkcja)+u' bez parametrw: '+Lista
    if stat=='OK':
        if Funkcja in [1,5,9,11,12]:
            KalendarzId = klucze['KalendarzId']
            RokF = klucze['RokF']
            MiesiacF = klucze['MiesiacF']
            Dodawac = klucze['Dodawac']

if stat=='OK':
    dane = []
    wyn1 = []
    wyn2 = []
    OdKiedy1=''
    DoKiedy1=''
    OdKiedy2=''
    DoKiedy2=''
    OdKiedy3=''
    DoKiedy3=''
    UprDodawanie = ((self.oddzial_id,'051033') in self.uprawnienia or self.operator_id == STANDARD_OPERATOR_ID)
    UprEdycja = ((self.oddzial_id,'051032') in self.uprawnienia or self.operator_id == STANDARD_OPERATOR_ID) or UprDodawanie
    if Funkcja==1:
        Update=klucze['Update']


#-------------------------------------------------------------------------------
# FUNKCJA SPRAWDZAJACA KAZDY WIERSZ
#-------------------------------------------------------------------------------

def SprawdzGodzinyZmian(OdKiedy1,DoKiedy1,OdKiedy2,DoKiedy2,OdKiedy3,DoKiedy3,row):  
    kol=[]
    dan=[]
    stat='OK'
                           
    if OdKiedy1 <> '':        
        if not rsglobal.SprCzyToGodzina(OdKiedy1):
            stat = u'Niepoprawna godzina rozpoczcia pierwszej zmiany'
            kol.append((row,2))
            dan.append(stat)               
                                                        
    if DoKiedy1 <> '':
        if not rsglobal.SprCzyToGodzina(DoKiedy1):
            stat = u'Niepoprawna godzina zakoczenia pierwszej zmiany'
            kol.append((row,3))
            dan.append(stat)                                      

    if OdKiedy2 <> '':
        if not rsglobal.SprCzyToGodzina(OdKiedy2):
            stat = u'Niepoprawna godzina rozpoczcia drugiej zmiany'
            kol.append((row,4))
            dan.append(stat)  
        #if stat=='OK':
        #    if OdKiedy1=='':
        #        stat = u'Nie mona zdefiniowa 2 zmiany nie definiujc pierwszej'
        #        kol.append((row,2))
        #        dan.append(stat)
                
    if DoKiedy2 <> '':
        if not rsglobal.SprCzyToGodzina(DoKiedy2):
            stat = u'Niepoprawna godzina zakoczenia drugiej zmiany'
            kol.append((row,5))
            dan.append(stat)                
        #if DoKiedy1=='':
        #    stat = u'Nie mona zdefiniowa 2 zmiany nie definiujc pierwszej'
        #    kol.append((row,3))
        #    dan.append(stat)
                    
    if (OdKiedy2 == '' and DoKiedy2 <> '') or (OdKiedy2 <> '' and DoKiedy2 == ''):
        stat = u'Do zdefiniowania drugiej zmiany potrzeba wypeni oba pola'
        dan.append(stat)                
        if OdKiedy2 =='':
            kol.append((row,4))
        else:
            kol.append((row,5))       
        
    #if (OdKiedy3 <> '' or DoKiedy3 <> '') and (OdKiedy2 == '' or DoKiedy2 == ''):
    #    stat = u'Nie mona zdefiniowa 3 zmiany nie definiujc drugiej'
    #    kol.append((row,4))
    #    dan.append(stat)
         
    if OdKiedy3 <> '':
        if not rsglobal.SprCzyToGodzina(OdKiedy3):
            stat = u'Niepoprawna godzina rozpoczcia trzeciej zmiany'
            kol.append((row,6))
            dan.append(stat) 
         
    if DoKiedy3 <> '':
        if not rsglobal.SprCzyToGodzina(DoKiedy3):           
            stat = u'Niepoprawna godzina zakoczenia trzeciej zmiany'
            kol.append((row,7))
            dan.append(stat)
              
    if (OdKiedy3 == '' and DoKiedy3 <> '') or (OdKiedy3 <> '' and DoKiedy3 == ''):
        stat = u'Do zdefiniowania trzeciej zmiany potrzeba wypeni oba pola'
        dan.append(stat)
        if OdKiedy3 =='':
            kol.append((row,6))
        else:
            kol.append((row,7)) 
                
    return [kol,dan]


#-------------------------------------------------------------------------------
#---- Sprawdzenie do inicjacji miesica - 12
#-------------------------------------------------------------------------------

if stat == 'OK' and Funkcja == 12:
    ilosc_dni = rsglobal.PodajOstatniDzien(str(RokF)+'-'+str(MiesiacF)+'-01')
    if int(MiesiacF)<2:
        mc_poprzedni='12'
        ilosc_dni_poprzedni = rsglobal.PodajOstatniDzien(str(int(RokF)-1)+'-'+str(mc_poprzedni)+'-01')
        data_cyklu_pocz = str(int(RokF)-1)+'-'+str(mc_poprzedni)+'-01'
        data_cyklu_kon = str(int(RokF)-1)+'-'+str(mc_poprzedni)+'-'+str(ilosc_dni_poprzedni)

    else:
        mc_poprzedni=int(MiesiacF)-1
        if mc_poprzedni<10:
            mc_poprzedni='0'+str(mc_poprzedni)
        ilosc_dni_poprzedni = rsglobal.PodajOstatniDzien(str(RokF)+'-'+str(mc_poprzedni)+'-01')
        data_cyklu_pocz = str(RokF)+'-'+str(mc_poprzedni)+'-01'
        data_cyklu_kon = str(RokF)+'-'+str(mc_poprzedni)+'-'+str(ilosc_dni_poprzedni)

    sql =" SELECT dzien,liczba_dni_cyklu FROM rs_kp_kalendarze_dni kd JOIN rs_kp_kalendarze k ON k.firma_id=kd.firma_id and k.kalendarz_id=kd.kalendarz_id"
    sql+=" WHERE kd.firma_id = '"+self.firma_id+"' AND kd.kalendarz_id = '"+KalendarzId+"'"
    sql+=" AND kd.dzien BETWEEN date '"+str(data_cyklu_pocz)+"' AND date '"+str(data_cyklu_kon)+"';"
    stat,dane,dump,dump = self.PolSQL.Execute(sql ,3)
    if stat<>"OK":
        stat="Bdy sprawdzania inicjacji miesica"
    elif len(dane)>0 and (dane[0][1] not in [0,None,'None','Null','']):
        stat='Dla liczby dni cyklu blokujemy moliwo inicjacji miesica'
    

#-------------------------------------------------------------------------------
#---- SELECT STAT's - 11  // statystyki wyswietlane na oknie
#-------------------------------------------------------------------------------

if stat == 'OK' and Funkcja == 11:
    ilosc_dni = rsglobal.PodajOstatniDzien(str(RokF)+'-'+str(MiesiacF)+'-01')   
                   
    SELECT=" SELECT (SUM(CASE WHEN do_kiedy1 < od_kiedy1 THEN '24:00:00'::time-COALESCE(do_kiedy1,'00:00:00')::time-COALESCE(od_kiedy1,'00:00:00')::time ELSE COALESCE(do_kiedy1,'00:00:00')::time-COALESCE(od_kiedy1,'00:00:00')::time END)+"
    SELECT+=" SUM(CASE WHEN do_kiedy2 < od_kiedy2 THEN '24:00:00'::time-COALESCE(do_kiedy2,'00:00:00')::time-COALESCE(od_kiedy2,'00:00:00')::time ELSE COALESCE(do_kiedy2,'00:00:00')::time-COALESCE(od_kiedy2,'00:00:00')::time END)+"
    SELECT+=" SUM(CASE WHEN do_kiedy3 < od_kiedy3 THEN '24:00:00'::time-COALESCE(do_kiedy3,'00:00:00')::time-COALESCE(od_kiedy3,'00:00:00')::time ELSE COALESCE(do_kiedy3,'00:00:00')::time-COALESCE(od_kiedy3,'00:00:00')::time END))::text"
    SELECT+=" FROM rs_kp_kalendarze_dni "
    SELECT+=" WHERE firma_id='"+self.firma_id+"' AND kalendarz_id = '"+KalendarzId+"' AND status_dnia = 'R' AND "
    SELECT+=" dzien BETWEEN '"+str(RokF)+"-"+str(MiesiacF)+"-01' "
    SELECT+=" AND '"+str(RokF)+"-"+str(MiesiacF)+"-"+str(ilosc_dni)+"';"   
    stat,dane_a,wyn1,dump =self.PolSQL.Execute(SELECT, 3)      
    if stat <> 'OK':
        stat='Bd pobrania statystyk : '+stat    
    else:
        SELECT=" SELECT (SUM(CASE WHEN do_kiedy1 < od_kiedy1 THEN '24:00:00'::time-COALESCE(do_kiedy1,'00:00:00')::time-COALESCE(od_kiedy1,'00:00:00')::time ELSE COALESCE(do_kiedy1,'00:00:00')::time-COALESCE(od_kiedy1,'00:00:00')::time END)+"
        SELECT+=" SUM(CASE WHEN do_kiedy2 < od_kiedy2 THEN '24:00:00'::time-COALESCE(do_kiedy2,'00:00:00')::time-COALESCE(od_kiedy2,'00:00:00')::time ELSE COALESCE(do_kiedy2,'00:00:00')::time-COALESCE(od_kiedy2,'00:00:00')::time END)+"
        SELECT+=" SUM(CASE WHEN do_kiedy3 < od_kiedy3 THEN '24:00:00'::time-COALESCE(do_kiedy3,'00:00:00')::time-COALESCE(od_kiedy3,'00:00:00')::time ELSE COALESCE(do_kiedy3,'00:00:00')::time-COALESCE(od_kiedy3,'00:00:00')::time END))::text"
        SELECT+=" FROM rs_kp_kalendarze_dni "
        SELECT+=" WHERE firma_id='"+self.firma_id+"' AND kalendarz_id = '"+KalendarzId+"' AND "
        SELECT+=" dzien BETWEEN '"+str(RokF)+"-"+str(MiesiacF)+"-01' "
        SELECT+=" AND '"+str(RokF)+"-"+str(MiesiacF)+"-"+str(ilosc_dni)+"';"  
        stat,dane_b,wyn1,dump =self.PolSQL.Execute(SELECT, 3)            
        if stat <> 'OK':
            stat='Bd pobrania statystyki : '+stat     
        else:           
            dane=[dane_a,dane_b]       


#-------------------------------------------------------------------------------
#---- SELECT ZMIAN - 10  // na edytowalnym gridzie o wiele szybciej odswieza sie zmiany wraz z godzinami //
#-------------------------------------------------------------------------------

if stat == 'OK' and Funkcja == 10:
    SELECT ="SELECT zmiana_id,od_kiedy1,do_kiedy1,od_kiedy2,do_kiedy2,od_kiedy3,do_kiedy3 FROM rs_kp_zmiany_pracy;"   
    stat,dane,wyn1,dump =self.PolSQL.Execute(SELECT, 3)    
    if stat <> 'OK':
        stat='Bd pobrania listy zmian : '+stat
                      
                      
#-------------------------------------------------------------------------------
#---   UPDATE DANYCH (1)
#-------------------------------------------------------------------------------

if stat == 'OK' and Funkcja == 1:
    if len(Update[0])>0:
        if not UprEdycja:
            stat='Brak uprawnie do edycji danych'
            dane.append(stat)
            
    if stat=='OK': # tworzymy liste z kodami
        sel1="SELECT kod FROM rs_statusy_dni;"
        stat,D,dump,dump = self.PolSQL.Execute(sel1,3)
        if stat<>'OK':
            stat=u"Bd przy sprawdzaniu statusu dnia: "+stat   
            dane.append(stat)        
        DaneS=[]

        for i in xrange(len(D)):
            for x in D[i]:
                DaneS.append(str(x).strip()) 
                             
    if stat=='OK': # tworzymy liste ze zmianami pracy
        sel1="SELECT zmiana_id FROM rs_kp_zmiany_pracy;"
        stat,D,dump,dump = self.PolSQL.Execute(sel1,3)
        if stat<>'OK':
            stat=u"Bd przy sprawdzaniu statusu dnia: "+stat   
            dane.append(stat)        
        DaneZ=[]

        for i in xrange(len(D)):
            for x in D[i]:
                DaneZ.append(str(x).strip()) 
        
    if stat=='OK':
        WierszeNr = Update[-1]
        for i in xrange(len(Update[0])):               
            for j in xrange(len(Update[0][i])): 
                pole=Update[0][i][j]
                wart=Update[1][i][j]
                if pole == 'status_dnia':
                    if str(wart).strip() not in DaneS:
                        stat = u'Wprowadzony status dnia jest niepoprawny.'
                        wyn2.append((WierszeNr[i],8))
                        dane.append(stat)    
                elif pole == 'zmiana_id':
                    if str(wart).strip()<>'' and str(wart).strip() not in DaneZ:
                        stat = u'Wprowadzona zmiana nie jest zdefiniowana w systemie.'
                        wyn2.append((WierszeNr[i],9))
                        dane.append(stat)   
                elif pole == 'od_kiedy1':
                    OdKiedy1=wart
                elif pole == 'do_kiedy1':
                    DoKiedy1=wart
                elif pole == 'od_kiedy2':
                    OdKiedy2=wart                                        
                elif pole == 'do_kiedy2':
                    DoKiedy2=wart       
                elif pole == 'od_kiedy3':
                    OdKiedy3=wart                                        
                elif pole == 'do_kiedy3':
                    DoKiedy3=wart

            if stat=='OK':
                D=Update[-3][i]
                    
                SELECT ="SELECT COALESCE(od_kiedy1::text,''),COALESCE(do_kiedy1::text,''),"
                SELECT+="COALESCE(od_kiedy2::text,''),COALESCE(do_kiedy2::text,''),"
                SELECT+="COALESCE(od_kiedy3::text,''),COALESCE(do_kiedy3::text,'') "
                SELECT+=" FROM rs_kp_kalendarze_dni WHERE firma_id = '"+self.firma_id+"' "
                SELECT+=" AND kalendarz_id = '"+KalendarzId+"' AND dzien = '"+str(D[0])+"';"   
                stat,daty,wyn1,dump =self.PolSQL.Execute(SELECT, 3)    
                if stat <> 'OK':
                    stat='Bdy przy sprawdzaniu danych : '+stat
                    dane.append(stat)   
            
            if stat=="OK":
                if len(daty)<>0:
                    # jesli nieedytowany i rozny od '00:00' to podmiana
                    if daty[0][0]<>OdKiedy1 and not ('od_kiedy1' in Update[0][i]): 
                            OdKiedy1=str(daty[0][0])[:-3]
                    if daty[0][1]<>DoKiedy1 and not ('do_kiedy1' in Update[0][i]):
                            DoKiedy1=str(daty[0][1])[:-3]                            
                    if daty[0][2]<>OdKiedy2 and not ('od_kiedy2' in Update[0][i]):
                            OdKiedy2=str(daty[0][2])[:-3]                           
                    if daty[0][3]<>DoKiedy2 and not ('do_kiedy2' in Update[0][i]):
                            DoKiedy2=str(daty[0][3])[:-3]  
                    if daty[0][4]<>OdKiedy3 and not ('od_kiedy3' in Update[0][i]):
                            OdKiedy3=str(daty[0][4])[:-3]                            
                    if daty[0][5]<>DoKiedy3 and not ('do_kiedy3' in Update[0][i]):
                            DoKiedy3=str(daty[0][5])[:-3] 

                if (('od_kiedy1' in Update[0][i]) or ('do_kiedy1' in Update[0][i]) or ('od_kiedy2' in Update[0][i]) or ('do_kiedy2' in Update[0][i]) or ('od_kiedy3' in Update[0][i]) or ('do_kiedy3' in Update[0][i])):
                    Dane = SprawdzGodzinyZmian(OdKiedy1,DoKiedy1,OdKiedy2,DoKiedy2,OdKiedy3,DoKiedy3,WierszeNr[i])    
                    for poz1 in Dane[0]:
                        wyn2.append(poz1)
                    for poz2 in Dane[1]:
                        dane.append(poz2)  
                                                    
    if stat == 'OK':
        if len(dane) > 0:
            stat = dane[0]
                                                                
    if stat=='OK':
        sql=''        
        for i in xrange(len(Update[0])):   
            UPDATE="UPDATE rs_kp_kalendarze_dni "
            SET='SET '
            for j in xrange(len(Update[0][i])): 
                pole=Update[0][i][j]
                wart=Update[1][i][j]
                if pole in ['od_kiedy1','do_kiedy1','od_kiedy2','do_kiedy2',
                            'od_kiedy3','do_kiedy3','status_dnia','zmiana_id']:
                    if str(wart) =='':
                        SET+=pole+"=NULL,"
                    else:
                        SET+=pole+"='"+wart+"',"
            SET=SET.strip(",")
            WHERE=" WHERE firma_id='"+self.firma_id+"' AND kalendarz_id ='"+str(KalendarzId)+"'"
            for j in xrange(len(Update[2][i])): # petla po kluczu
                pole=Update[3][j]
                wart=rsglobal.Dekoduj(Update[2][i][j])
                WHERE+=" AND "+pole+"='"+wart+"'"
            WHERE+=";" 
            if str(SET)=='SET ':
                pass
            else:
                sql+=UPDATE+SET+WHERE;
        if sql<>'':                                 
            stat,dump,dump,dump=self.PolSQL.Execute(rsglobal.Dekoduj(sql),1)   
            if stat<>'OK':
                stat=u"Bd przy modyfikowaniu danych: "+stat   
                dane.append(stat)  


#-------------------------------------------------------------------------------
#--- POBRANIE INFORMACJI O INSERCIE DANYCH/w oddzielnej bo wracam ze statem/ (9)
#-------------------------------------------------------------------------------

if stat == 'OK' and Funkcja == 9:
    if RokF=='' or MiesiacF=='': # sprawdzamy filtr
        stat=='BR_FILTR'
        dane.append(stat)    
    if stat=='OK':
        dane=['',[]]
        Dzien=str(RokF)+'-'+str(MiesiacF)+'-01'
        #sprawdzamy czy s dane w tabeli
        sql ="SELECT dzien FROM rs_kp_kalendarze_dni"
        sql+=" WHERE firma_id = '"+self.firma_id+"' AND kalendarz_id = '"+KalendarzId+"'"
        sql+=" AND dzien = '"+str(Dzien)+"';"
        stat1,d1,dump,dump = self.PolSQL.Execute(sql,3)        
        if stat1 <> 'OK':
            stat = 'Bd sprawdzania danych w kalendarzu : '+stat
        else:    
            sql ="SELECT dzien FROM rs_kp_kalendarze_dni"
            sql+=" WHERE firma_id = '"+self.firma_id+"' AND kalendarz_id = '"+KalendarzId+"'"
            sql+=" AND dzien BETWEEN '"+str(RokF)+'-01-01'"' AND '"+str(Dzien)+"';"
            stat2,d2,dump,dump = self.PolSQL.Execute(sql,3)             
            if stat2<>'OK':
                stat = 'Bd sprawdzania poprzednich miesicy w kalendarzu : '+stat
            if stat=='OK':
                if len(d1) == 0:
                    dane[0]='POBIERAC'
                if len(d2) <> 0:
                    dane[1] = d2

                
#-------------------------------------------------------------------------------
#--- insert w wypadku braku danych (5)
#-------------------------------------------------------------------------------

if stat == 'OK' and Funkcja in [1,5,6]:
    liczba_dni_cyklu=0
    ilosc_dni = rsglobal.PodajOstatniDzien(str(RokF)+'-'+str(MiesiacF)+'-01')
    czy_ciagly=False
    KAL= "SELECT liczba_dni_cyklu, czy_ruch_ciagly FROM rs_kp_kalendarze WHERE firma_id='"+self.firma_id+"' "
    KAL+=" AND kalendarz_id='"+KalendarzId+"' ;"
    stat,cykl,dump,dump = self.PolSQL.Execute(KAL ,3)
    if stat<>"OK":
        stat="Bdy sprawdzania liczby dni cyklu"
        dane.append(stat)
    elif len(cykl)>0:
        liczba_dni_cyklu = cykl[0][0]
        czy_ciagly = cykl[0][0]

    if stat == 'OK' and Dodawac:
        if not UprDodawanie:
            stat='Brak uprawnie do dodawania dni w kalendarzu.'
        else:
            #wypisywanie pustego kalendarza
            query=''
            for i in range(1,ilosc_dni+1): # od 1 do ilosc_dni
                numer=str(i)
                data="'"+str(RokF)+"-"+str(MiesiacF)+"-"+str(numer)+"'"
                datas=str(RokF)+"-"+str(MiesiacF)+"-"+str(numer)
                query+=" INSERT INTO rs_kp_kalendarze_dni (firma_id,kalendarz_id,dzien,"
                query+=" status_dnia) "
                query+="VALUES ('"+self.firma_id+"','"+str(KalendarzId)+"',"+str(data)+","
                #if not czy_ciagly:
                if rs_anakonda_daty.CzySwieto(datas):
                    query+=" 'S');"
                else: # reszta
                    query+=" CASE EXTRACT(DOW FROM TIMESTAMP "+str(data)+") "
                    query+=" WHEN 0 THEN 'S' "
                    query+=" WHEN 1 THEN 'R' WHEN 2 THEN 'R' WHEN 3 THEN 'R' WHEN 4 THEN 'R' "
                    query+=" WHEN 5 THEN 'R' WHEN 6 THEN 'W' END);"
                #else:
                #    query+=" 'R' );"
            if stat=='OK':
                stat,dump,dump,dump = self.PolSQL.Execute(query ,1)
                if stat!="OK":
                    stat="BL INS KAL"
                    dane.append(stat)
                        
            if stat=='OK':
                if liczba_dni_cyklu>0:
                    # przepisanie danych z poprzedniego kalendarza
                    query=""
                    for i in range(1,ilosc_dni+1): # od 1 do ilosc_dni
                        numer = str(i)
                        data = "'"+str(RokF)+"-"+str(MiesiacF)+"-"+str(numer)+"'"
                        datas = str(RokF)+"-"+str(MiesiacF)+"-"+str(numer)
                        datapop = rs_anakonda_daty.DodajKilkaDni(datas,-liczba_dni_cyklu)
                        if czy_ciagly:
                            querypop = "SELECT status_dnia, od_kiedy1, do_kiedy1, od_kiedy2,do_kiedy2,od_kiedy3,do_kiedy3 "
                            querypop += "FROM rs_kp_kalendarze_dni WHERE firma_id='"+self.firma_id+"' "
                            querypop += " AND kalendarz_id='"+KalendarzId+"' AND dzien='"+str(datapop)+"';"
                            stat,danep,dump,dump = self.PolSQL.Execute(querypop ,3)
                        else:
                            # szukamy dnia oddalonego o liczbe dni cyklu z tym samym statusem
                            querypop = "SELECT status_dnia "
                            querypop += "FROM rs_kp_kalendarze_dni WHERE firma_id='"+self.firma_id+"' "
                            querypop += " AND kalendarz_id='"+KalendarzId+"' AND dzien="+data+";"
                            stat,danep,dump,dump = self.PolSQL.Execute(querypop ,3)
                            if stat != 'OK':
                                stat="Bdy pobierania statusu dnia."
                                dane.append(stat)
                                break
                            else:
                                status_dnia=danep[0][0]
                            while True:
                                querypop = "SELECT status_dnia, od_kiedy1, do_kiedy1, od_kiedy2,do_kiedy2,od_kiedy3,do_kiedy3 "
                                querypop += "FROM rs_kp_kalendarze_dni WHERE firma_id='"+self.firma_id+"' "
                                querypop += " AND kalendarz_id='"+KalendarzId+"' AND dzien='"+str(datapop)+"';"
                                stat,danep,dump,dump = self.PolSQL.Execute(querypop ,3)
                                if stat<>"OK":
                                    stat="Bdy pobierania danych z dni cyklu"
                                    dane.append(stat)
                                    break
                                if len(danep)==0:
                                    break
                                if status_dnia==danep[0][0]:
                                    break
                                datapop = rs_anakonda_daty.DodajKilkaDni(datapop,-liczba_dni_cyklu)
                            
                        if stat<>"OK":
                            stat="Bdy pobierania danych z dni cyklu"
                            dane.append(stat)
                            break
                        elif len(danep)>0:
                            czysadane=False
                            querypom=" UPDATE rs_kp_kalendarze_dni SET "
                            if str(danep[0][1])<>'None':
                                querypom+=" od_kiedy1='"+str(danep[0][1])+"' "
                                czysadane=True
                            if str(danep[0][2])<>'None':
                                if czysadane:
                                    querypom+=", "
                                querypom+=" do_kiedy1='"+str(danep[0][2])+"' "
                                czysadane=True
                            if str(danep[0][3])<>'None':
                                if czysadane:
                                    querypom+=", "
                                querypom+=" od_kiedy2='"+str(danep[0][3])+"' "
                                czysadane=True
                            if str(danep[0][4])<>'None':
                                if czysadane:
                                    querypom+=", "
                                querypom+=" do_kiedy2='"+str(danep[0][4])+"' "
                                czysadane=True
                            if str(danep[0][5])<>'None':
                                if czysadane:
                                    querypom+=", "
                                querypom+=" od_kiedy3='"+str(danep[0][5])+"' "
                                czysadane=True
                            if str(danep[0][6])<>'None':
                                if czysadane:
                                    querypom+=", "
                                querypom+=" do_kiedy3='"+str(danep[0][6])+"'"
                                czysadane=True
                            querypom+=" WHERE firma_id='"+self.firma_id+"' "
                            querypom+=" AND kalendarz_id='"+KalendarzId+"' AND dzien="+data+";"
                            if czysadane and stat=='OK':
                                stat,dump,dump,dump = self.PolSQL.Execute(querypom ,1)
                                if stat!="OK":
                                    stat="BL INS KAL"
                                    dane.append(stat)
                                    break

                        
                    
                                        
#        elif stat=='OK' and ilosc_dni<>0:
#            if len(cykl)>0 and liczba_dni_cyklu >0:
#                if int(MiesiacF)<2:
#                    mc_poprzedni='12'
#                    ilosc_dni_poprzedni = rsglobal.PodajOstatniDzien(str(int(RokF)-1)+'-'+str(mc_poprzedni)+'-01')
#                    data_cyklu = str(int(RokF)-1)+'-'+str(mc_poprzedni)+'-'+str(ilosc_dni_poprzedni)###
#
#                else:
#                    mc_poprzedni=int(MiesiacF)-1
#                    if mc_poprzedni<10:
#                        mc_poprzedni='0'+str(mc_poprzedni)
#                    ilosc_dni_poprzedni = rsglobal.PodajOstatniDzien(str(RokF)+'-'+str(mc_poprzedni)+'-01')
#                    data_cyklu = str(RokF)+'-'+str(mc_poprzedni)+'-'+str(ilosc_dni_poprzedni)#
#
#                i=1
#                while True: #ptla jeli wito
#                    petla=True
#                    sql ="SELECT dzien,od_kiedy1,do_kiedy1,od_kiedy2,do_kiedy2,od_kiedy3,do_kiedy3,status_dnia,zmiana_id  FROM rs_kp_kalendarze_dni"
#                    sql+=" WHERE firma_id = '"+self.firma_id+"' AND kalendarz_id = '"+KalendarzId+"'"
#                    sql+=" AND dzien BETWEEN date '"+str(data_cyklu)+"' - integer '"+str(int(i*liczba_dni_cyklu-1))+"' "
#                    sql+=" AND date '"+str(data_cyklu)+"' - integer '"+str(int((i-1)*liczba_dni_cyklu))+"';"
#                    stat,d,dump,dump = self.PolSQL.Execute(sql ,3)
#                    if stat<>"OK":
#                        stat="Bdy sprawdzania daty cyklu"
#                        dane.append(stat)
#                        break
#                    else:
#                        if len(d)<liczba_dni_cyklu:
#                            liczba_dni_cyklu=0
#                            dane.append("Nie skopiowano kalendarza z dni cyklu.") #komunikat si nie wywietli
#                            break
#                        else:
#                            for x in d:
#                                #if x[0][5:] in ['01-01','05-01','05-03','08-15','11-01','11-11','12-25','12-26']:
#                                if rs_anakonda_daty.CzySwieto(str(x[0])):
#                                    i+=1
#                                    petla=False
#                                    break
#                            if petla:
#                                j=liczba_dni_cyklu
#                                j=0
#                                for k in range(1,ilosc_dni+1):
#                                    numer=str(k)
#                                    data="'"+str(RokF)+"-"+str(MiesiacF)+"-"+str(numer)+"'"

#                                    if j==liczba_dni_cyklu:#
#                                        j=0

#                                    query+=" INSERT INTO rs_kp_kalendarze_dni (firma_id,kalendarz_id,dzien,"
#                                    query+=" od_kiedy1,do_kiedy1,od_kiedy2,do_kiedy2,od_kiedy3,do_kiedy3,status_dnia,zmiana_id) "
#                                    query+="VALUES ('"+self.firma_id+"','"+str(KalendarzId)+"',"+str(data)
#                                    for z in range(1, 9):
#                                        if d[j][z] in ['','Null','None',None]:
#                                            query += ",Null"
#                                        else:
#                                            query += ",'" + str(d[j][z]) + "'"
#                                    query+=");"
#                                    j+=1

#                                if stat=='OK':
#                                    stat,dump,dump,dump = self.PolSQL.Execute(query ,1)
#                                    if stat<>"OK":
#                                        stat="Bdy dodawania dni do kalendarza za pomoc dni cyklu."
#                                        dane.append(stat)
#                                        break
#                                    else:
#                                        break


#-------------------------------------------------------------------------------
#---- SELECT - 5 Pobieranie listy angazy dla pracownika
#-------------------------------------------------------------------------------

if stat == 'OK' and Funkcja in (1,5,6):
    FILTR ="(firma_id = '"+self.firma_id+"' AND kalendarz_id = '"+KalendarzId+"'"

    if RokF <> '' and MiesiacF<>'':
        FILTR += " AND dzien BETWEEN '"+str(RokF)+"-"+str(MiesiacF)+"-01' AND "
        FILTR += "'"+str(RokF)+"-"+str(MiesiacF)+"-"+str(ilosc_dni)+"'"
    FILTR += ")"

    SELECT ="SELECT dzien,CASE EXTRACT(DOW FROM dzien) WHEN 0 THEN 'Niedziela' " 
    SELECT+=" WHEN 1 THEN 'Poniedziaek' WHEN 2 THEN 'Wtorek' WHEN 3 THEN 'roda' WHEN 4 THEN 'Czwartek' "
    SELECT+=" WHEN 5 THEN 'Pitek' WHEN 6 THEN 'Sobota' END,"
    SELECT+=" SUBSTR(COALESCE(od_kiedy1::text,''),0,6),SUBSTR(COALESCE(do_kiedy1::text,''),0,6),"
    SELECT+=" SUBSTR(COALESCE(od_kiedy2::text,''),0,6),SUBSTR(COALESCE(do_kiedy2::text,''),0,6),"
    SELECT+=" SUBSTR(COALESCE(od_kiedy3::text,''),0,6),SUBSTR(COALESCE(do_kiedy3::text,''),0,6), "
    SELECT+=" SUBSTR(COALESCE(status_dnia,''),0,6),SUBSTR(COALESCE(zmiana_id,''),0,6)"
    SELECT+=" FROM rs_kp_kalendarze_dni WHERE "+FILTR+" ORDER BY dzien;"   
    stat,dane,wyn1,dump =self.PolSQL.Execute(SELECT, 3)    
    if stat <> 'OK':
        stat='Bd pobrania listy dni : '+stat