# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_kp_stale_typy.py
# Purpose:     obsluga grida edytowalnego listami obecnosci
# Author:      Marcin Natkaski
# Created:     2015/07/22
# RCS-ID:      $Id: fs_kp_listy_obecnosci.py$
# Copyright:   (c) 2015 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

from datetime import datetime, timedelta
stat='OK'
if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=='OK':
    Funkcja = klucze['Funkcja']
    
    SlPar={'KomorkaF':[1,2,5],'DataOdF':[1,2,5],'DataDoF':[1,2,5],'StanF':[1,2,5],'Data':[7],'Komorka':[7,10],
            'Czas_od':[7],'Czas_do':[7],'DataOd':[10],'DataDo':[10],'Stan':[2,3]}
    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Funkcja,klucze)
    if Lista<>'':
        stat='Uwaga : wywoanie funkcji fs_kp_lista_obecnosci '+str(Funkcja)+' bez parametrw: '+Lista
        
    if Funkcja in [1,2,3,5]:
        KomorkaF=rsglobal.Dekoduj(klucze['KomorkaF'])
        DataOdF=rsglobal.Dekoduj(klucze['DataOdF'])
        DataDoF=rsglobal.Dekoduj(klucze['DataDoF'])
        StanF=rsglobal.Dekoduj(klucze['StanF'])
    if Funkcja in [2,3,7]:
        Komorka=rsglobal.Dekoduj(klucze['Komorka'])
        Czas_od=rsglobal.Dekoduj(klucze['Czas_od'])
        Czas_do=rsglobal.Dekoduj(klucze['Czas_do'])
    if Funkcja in [2,3]:
        Stan = rsglobal.Dekoduj(klucze['Stan'])
    if Funkcja in [7,]:
        Data=rsglobal.Dekoduj(klucze['Data'])
    if Funkcja in [10,]:
        Komorka=rsglobal.Dekoduj(klucze['Komorka'])
        DataOd=rsglobal.Dekoduj(klucze['DataOd'])
        DataDo=rsglobal.Dekoduj(klucze['DataDo'])

dane = []
wyn1 = []
wyn2 = []

#UprUpd=((self.oddzial_id,'991322') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID
#UprDel=((self.oddzial_id,'991322') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID
UprUpd=((self.oddzial_id,'054202') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID
UprDel=((self.oddzial_id,'054202') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID

Insert = []
Update = []
Delete = []

if stat=='OK' and Funkcja == 1:
    Update=klucze['Update']
    Insert=klucze['Insert']
    Delete=klucze['Delete']


#-------------------------------------------------------------------------------
#---- TWORZENIE LIST OBECNOCi (10)
#-------------------------------------------------------------------------------
if Funkcja == 10 and stat=='OK':
    naglowki = {}
    #pobieramy pracownika, czas_od, czas_do, komorke zatrudniajaca (z angazu - jeeli kilka to wybieramy jedn lub
    # jeeli sida to porwnujemy w JOIN dane z grafiku z danymi z angazu)
    PRAC= " Select DISTINCT a.pracownik_id, a.plan_czas_od, a.plan_czas_do, b.komorka_id "
    PRAC+=" FROM rs_kp_grafiki_pozycje a RIGHT JOIN rs_kp_angaze b "
    PRAC+=" ON ( a.firma_id=b.firma_id AND a.pracownik_id=b.pracownik_id AND a.plan_miejsce_pracy_id=b.miejsce_id "
    PRAC+=" AND a.plan_stanowisko_pracy_id=b.stanowisko_id "
    PRAC+=" AND a.plan_stanowisko_miejsce_id=b.stanowisko_miejsce_id AND SUBSTRING(a.plan_czas_od::TEXT FROM 1 FOR 10)::DATE>=b.od_kiedy "
    PRAC+=" AND ((SUBSTRING(a.plan_czas_do::TEXT FROM 1 FOR 10)::DATE<=b.do_kiedy) OR b.do_kiedy IS NULL)) "
    PRAC+=" WHERE a.firma_id='"+self.firma_id+"' AND SUBSTRING(a.plan_czas_od::TEXT FROM 1 FOR 10)>='"+DataOd+"' "
    PRAC+=" AND SUBSTRING(a.plan_czas_do::TEXT FROM 1 FOR 10)<='"+DataDo+"' AND b.komorka_id like '"+Komorka+"%'"
    #print PRAC
    stat,pracownicy,dump,dump = self.PolSQL.Execute(rsglobal.Dekoduj(PRAC),3)
    if stat <> 'OK':
        stat = 'Bdy pobierania pracownikw do list obecnoci: '+stat
        dane.append(stat)
    elif len(pracownicy)==0:
        stat = 'Brak pracownikw do utworzenia list obecnoci.\n\nPrawdopodobne przyczyny:\n- Brak utworzonych grafikw planowanych.\n' \
               '- Utworzone grafiki planowane nie mieszcz si w podanych datach.\n- Brak pracownikw zatrudnionych w podanej komrce organizacyjnej.'
        dane.append(stat)

    #dla kadego zamieniamy daty
    if stat=='OK':
        for g in pracownicy:
            if g[1].strip()[-8:]>g[2].strip()[-8:]:
                data=datetime.strptime(g[1].strip()[:10], "%Y-%m-%d")
                data=data = data+timedelta(days=1)
                data = str(data.date())
                g[2] = data+' '+g[2][-8:]
            g[2] = datetime.strptime(g[2], "%Y-%m-%d %H:%M:%S")
    #tworzymy slowniki, gdzie kluczem bedzie krotka (komorka,czas_od, czas_do)
    #w ptli po wszytkich cignitych pozycjach sprawdzamy czy krotka sizgadza i jak tak to walimy do sownika
    for i in pracownicy:
        #if (i[3].strip(),i[1].strip(),i[2].strip()) in naglowki:
        if (str(i[3]).strip(),str(i[1]).strip(),str(i[2]).strip()) in naglowki:
            naglowki[(str(i[3]).strip(),str(i[1]).strip(),str(i[2]).strip())].append(i[0])

        else:
            naglowki[(str(i[3]).strip(),str(i[1]).strip(),str(i[2]).strip())] = []
            naglowki[(str(i[3]).strip(),str(i[1]).strip(),str(i[2]).strip())].append(i[0])
    #dla kadego sownika tworzymy nagwek w tabeli
    #dla kadego pracownika w sowniku z odpowiednim kluczem INSERTY do tabeli z pozycjami
    INS=""
    for j in naglowki.keys():
        #spradzamy czy nagwek istnieje
        SEL= "SELECT firma_id FROM rs_kp_listy_obecnosci WHERE (firma_id,komorka_id,czas_od,czas_do) =   "
        SEL+=" ('"+self.firma_id+"','"+j[0]+"','"+j[1]+"','"+j[2]+"') "
        stat,ist,dump,dump = self.PolSQL.Execute(rsglobal.Dekoduj(SEL),3)
        if len(ist)>0:
            continue

        else:
            #najepierw tworzymy nagwek
            INS+="INSERT INTO rs_kp_listy_obecnosci (firma_id,komorka_id,czas_od,czas_do,stan) "
            INS+=" VALUES ('"+self.firma_id+"','"+j[0]+"','"+j[1]+"','"+j[2]+"','W');"
            if stat <> 'OK':
                stat = 'Bdy pobierania pracownikw do list obecnoci: '+stat
                dane.append(stat)
                continue

            for pracownik in naglowki[j]:
                INS+="INSERT INTO rs_kp_listy_obecnosci_pozycje (firma_id,komorka_id,czas_od,czas_do,pracownik_id,"
                INS+= "czas_fakt_od,czas_fakt_do) VALUES ('"+self.firma_id+"','"+j[0]+"','"+j[1]+"','"+j[2]+"',"
                INS+="   '"+pracownik+"','"+j[1]+"','"+j[2]+"'); "

    if stat=='OK' and len(INS)>0:
        stat,dump,dump,dump = self.PolSQL.Execute(rsglobal.Dekoduj(INS),1)
        if stat <> 'OK':
            stat = 'Bdy tworzenia listy obecnoci: '+stat
            dane.append(stat)


#-------------------------------------------------------------------------------
#---- USUWANIE LISTY OBECNOCI (7)
#-------------------------------------------------------------------------------
if Funkcja == 7 and stat=='OK':
    DEL= "DELETE FROM rs_kp_listy_obecnosci WHERE firma_id='"+self.firma_id+"' AND "
    DEL+=" komorka_id='"+Komorka.strip()+"' AND czas_od::TEXT='"+Czas_od+"' "
    DEL+=" AND czas_do::TEXT='"+Czas_do+"' AND stan='W' "
    stat,d,dump,dump = self.PolSQL.Execute(rsglobal.Dekoduj(DEL),1)
    if stat <> 'OK':
        stat = 'Bdy usuwania listy obecnoci: '+stat
        dane.append(stat)
    

#-------------------------------------------------------------------------------
#----   ZAMYKANIE LISTY OBECNOCI (2)
#-------------------------------------------------------------------------------
if Funkcja == 2 and stat=='OK':
    if stat=='OK':
        UPD=" UPDATE rs_kp_listy_obecnosci set stan= "
        if Stan=='W':
            UPD+=" 'G' "
        else:
            UPD+=" 'Z' "
        UPD+=" WHERE firma_id='"+self.firma_id+"' AND komorka_id='"+Komorka.strip()+"' AND czas_od::TEXT='"+Czas_od+"' "
        UPD+=" AND czas_do::TEXT='"+Czas_do+"' "
        stat,d,dump,dump = self.PolSQL.Execute(rsglobal.Dekoduj(UPD),1)
        if stat <> 'OK':
            stat = 'Bdy zamykania listy obecnoci: '+stat
            dane.append(stat)    

#-------------------------------------------------------------------------------
#----   OTWIERANIE LISTY OBECNOCI (3)
#-------------------------------------------------------------------------------
if Funkcja == 3 and stat=='OK':
    if stat=='OK':
        UPD=" UPDATE rs_kp_listy_obecnosci set stan= "
        if Stan=='Z':
            UPD+=" 'G' "
        else:
            UPD+=" 'W' "
        UPD+=" WHERE firma_id='"+self.firma_id+"' AND komorka_id='"+Komorka.strip()+"' AND czas_od::TEXT='"+Czas_od+"' "
        UPD+=" AND czas_do::TEXT='"+Czas_do+"' "
        stat,d,dump,dump = self.PolSQL.Execute(rsglobal.Dekoduj(UPD),1)
        if stat <> 'OK':
            stat = 'Bdy otwierania listy obecnoci: '+stat
            dane.append(stat)

#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (1- insert 1 -select, 1 -delete), (5-odczyt)
#-------------------------------------------------------------------------------

if Funkcja in (1,5) and stat == 'OK':
    SQL =" SELECT SUBSTRING(a.czas_od::TEXT FROM 1 FOR 10), a.komorka_id,b.opis, "
    SQL+=" SUBSTRING(a.czas_od::TEXT FROM 11 FOR 6),SUBSTRING(a.czas_do::TEXT FROM 11 FOR 6),a.stan "
    SQL+=" FROM rs_kp_listy_obecnosci a INNER JOIN rs_komorki_zatrudniajace b ON (a.firma_id=b.firma_id AND a.komorka_id=b.kod)"
    SQL+=" WHERE a.firma_id='"+self.firma_id+"' "
    if DataOdF<>'-  -':
        SQL+="AND SUBSTRING(a.czas_od::TEXT from 1 for 10)>='"+DataOdF+"' "
    if DataDoF<>'-  -':
        SQL+=" AND SUBSTRING(a.czas_do::TEXT from 1 for 10)<='"+DataDoF+"' "
    if KomorkaF<>'':
        SQL+=" AND a.komorka_id like '"+KomorkaF+"%'"
    if StanF<>'':
        SQL+=" AND a.stan='"+StanF+"'"
    SQL+=" ORDER BY SUBSTRING(a.czas_od::TEXT FROM 1 FOR 10), a.komorka_id, SUBSTRING(a.czas_od::TEXT FROM 11 FOR 6) "
    stat,dane,wyn1,wyn2 = self.PolSQL.Execute(SQL,3)
    if stat <> 'OK':
        stat = "Bd przy pobieraniu danych: "+stat
        dane.append(stat)
