# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_kp_pom.py
# Purpose:     pomocnicze funkcje w module kadr
# Author:      Mariusz Rajfura
# Created:     2012/04/06
# RCS-ID:      $Id: fs_kp_pom.py $
# Copyright:   (c) 2012 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------
# 27-01-2014 - Konrad Opieka - (3566) Liczenie dni zwolnienia i ZUS
#-------------------------------------------------------------------------------
#---   PODAJEMY OSTATNIE 12 MIESIECY W TABELI [['','']['','']...]
#-------------------------------------------------------------------------------

import rsglobal

def PodajPoprzednie12Miesiecy(DataOd):
    # podaje poprzednie 12 miesiacy [Miesiac,Rok], zak. e data zostaa sprawdzona
    
    #data od wypelniona
    Miesiace = []
    Rok=int(DataOd[:4])
    Miesiac=int(DataOd[5:7])
    temp=[Miesiac,Rok]   
  
    for i in range(12):
        if temp[0]-1==0: 
            temp=[12,temp[1]-1]
            i=[temp[0],temp[1]]
        else:
            i=[temp[0]-1,temp[1]]
            temp=[temp[0]-1,temp[1]]
        Miesiace.append(i)

    return Miesiace


#-----------------------------------------------------------------------------------
#---   DEFINIUJEMY INSERTY Z PODOKRESAMI OD DATA_OD DO DATA_DO ( PODZIAL NA MIESIACE)
#-----------------------------------------------------------------------------------
          
def ZdefiniujPodokresy(DataOd,DataDo,FirmaId,Pracownik,Absencja,Kalendarz,CzyZwolnienie,CzyPlaciZus):   
    # SQL
    poczatek= 'INSERT INTO rs_kp_dane_osobowe_absencje_podokresy '
    pola='(firma_id,pracownik_id,absencja_nr,od_kiedy,do_kiedy,kalendarz_id,liczba_dni,placi_zus'
    wartosci=") VALUES ('"+str(FirmaId)+"','"+str(Pracownik)+"','"+str(Absencja)+"'"
    koniec= ' ); '
    values=''
    SQL = ''
    # rozlozenie daty poczatku absencji
    RokOd=int(DataOd[:4])
    MiesiacOd=int(DataOd[5:7])
    DzienOd=int(DataOd[8:10])
    # rozlozenie daty koca absencji
    RokDo=int(DataDo[:4])
    MiesiacDo=int(DataDo[5:7])
    DzienDo=int(DataDo[8:10])
    # zmienne do podokresw ZUS

    ile_dni_ZUS=0
    ile_dni_ZUS_poprzedni=0
    ostatni=0
    platne_ZUS=33 # parametr systemowy - bedzie w przyszloci do tego kontrolka

    values = ",'"+str(RokOd)+"-"+str(MiesiacOd).zfill(2)+"-"+str(DzienOd).zfill(2)+"'" # wartosc startowa dla petli

    #wartoci startowe dla licznika ZUS
    ZUS=False
    temp_ZUS=False  
    # warunek : jesli DataDo wiksza bd rwna DataOd - czyli przez wszystkie podokresy  
    while (str(RokDo)+'-'+str(MiesiacDo).zfill(2)+'-'+str(DzienDo).zfill(2))>=(str(RokOd)+'-'+str(MiesiacOd).zfill(2)+'-'+str(DzienOd).zfill(2)):                           
        # sprawdzamy ilosc dni dla danego miesiaca     
        ilosc_dni = rsglobal.PodajOstatniDzien(str(RokOd)+'-'+str(MiesiacOd).zfill(2)+'-01')     
        if CzyZwolnienie: # tylko dla typu ZL zaznaczamy pole placi_zus 
            if CzyPlaciZus:
                ile_dni_ZUS_poprzedni=ile_dni_ZUS
                if RokOd==RokDo and MiesiacOd==MiesiacDo: # jeli ostatni miesic
                    ilosc_dni=int(DzienDo-DzienOd+1)
                else:    
                    ilosc_dni=int(ilosc_dni-DzienOd+1)
                    
                ile_dni_ZUS+=ilosc_dni
                if int(ile_dni_ZUS)<platne_ZUS:
                    ZUS=False 
                else:
                    ZUS=True
                    temp_ZUS=True
                    
            else:
                ZUS=False

        # jeli przekraczamy XX dni to nowy podokres
        if temp_ZUS == True and ZUS == True: # przeom w ktrym ZUS przestaje paci ( wiecej niz XX dni )  
            if MiesiacOd==MiesiacDo and platne_ZUS-ile_dni_ZUS_poprzedni+1>DzienDo:
                DzienOd=DzienDo
                ostatni=DzienDo
                temp_ZUS=False
                ZUS=False
            elif ile_dni_ZUS_poprzedni<platne_ZUS:
                DzienOd=platne_ZUS-ile_dni_ZUS_poprzedni
                ostatni=DzienOd
                temp_ZUS=False
                ZUS=False
            else:
                ostatni=int(ilosc_dni+DzienOd-1)
                DzienOd=ilosc_dni
                temp_ZUS=True
                ZUS=True
                
                
            values1 = ",'"+str(RokOd)+"-"+str(MiesiacOd).zfill(2)+"-"+str(ostatni).zfill(2)+"',"+str(Kalendarz)+",'"+str(DzienOd)+"','"+str(temp_ZUS)+"'" #insert do konca miesiaca       
            
            if DzienOd==ilosc_dni: # jesli koniec miesica to od pocztku
                DzienOd=01
                MiesiacOd+=1
            else:                  # jesli nie to od koca podokresu
                DzienOd=platne_ZUS-ile_dni_ZUS_poprzedni+1

        #jeli caa absencja ma mniej ni miesic albo jest to ostatni miesiac
        elif str(RokDo)+'-'+str(MiesiacDo).zfill(2)+'-'+str(DzienDo).zfill(2)<=str(RokOd)+'-'+str(MiesiacOd).zfill(2)+'-'+str(ilosc_dni).zfill(2):
            values1 = ",'"+str(RokOd)+"-"+str(MiesiacOd).zfill(2)+"-"+str(DzienDo).zfill(2)+"',"+str(Kalendarz)+",'"+str(DzienDo-DzienOd+1)+"','"+str(ZUS)+"'" #insert do konca miesiaca
            MiesiacOd=MiesiacOd+1 # koczymy ptle
            
        # wypeniami cae miesice wewntrz podokresu
        else:
            values1 = ",'"+str(RokOd)+"-"+str(MiesiacOd).zfill(2)+"-"+str(ilosc_dni).zfill(2)+"',"+str(Kalendarz)+",'"+str(ilosc_dni)+"','"+str(ZUS)+"'" #insert do konca miesiaca            
            DzienOd=01 # zaczynamy nastpny miesic
            MiesiacOd+=1 

        SQL+=poczatek+pola+wartosci+values+values1+koniec             

        if MiesiacOd==13: # jesli by juz grudzien (12) to zmieniamy na styczen i rok +1
            MiesiacOd=01
            RokOd+=1 
            
        values = ",'"+str(RokOd)+"-"+str(MiesiacOd).zfill(2)+"-"+str(DzienOd).zfill(2)+"'" # wartosc poczatkowa ustalana na nowo

        if CzyZwolnienie and not CzyPlaciZus:
            temp_ZUS=False
            ZUS=False
    return SQL
