# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_kp_pracownicy_adresy.py
# Purpose:     grid z danymi adresowymi pracownika
#
# Author:      Mariusz Rajfura
# Created:     2010/03/03
# RCS-ID:      $Id: fs_kp_pracownicy_adresy.py $
# Copyright:   (c) 2010 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

Pracownik = rsglobal.Dekoduj(klucze[0])
Adres = rsglobal.Dekoduj(klucze[1])
Klucze_Id = klucze[2]

Fun = klucze[-1]
dane = []
wyn1 = []
stat = 'OK'

sql ="SELECT rsf_kadry_dozwolony_modul('"+self.firma_id+"','"+str(self.operator_id)+"','dane_adresowe','"+Pracownik+"');"
stat,d,dump,dump = self.PolSQL.Execute(sql,3)
if stat == 'OK':
    stat = d[0][0]

UprUsuwanie = ((self.oddzial_id,'052104') in self.uprawnienia or self.operator_id == STANDARD_OPERATOR_ID)

#-------------------------------------------------------------------------------
#--- DELETE - 6
#-------------------------------------------------------------------------------

if Fun == 6 and stat == 'OK':
    if not UprUsuwanie:
        stat='Brak uprawnie do usuwania danych adresowych.'

    if stat == 'OK':
        sql = "SELECT adres_id FROM rs_kp_adresy"
        sql+=" WHERE firma_id = '"+self.firma_id+"' AND pracownik_id = '"+Pracownik+"'"
        sql+=" AND adres_id = '"+Adres+"' FOR UPDATE NOWAIT;" 
        stat,d,dump,dump = self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Bd pobrania danych adresowych pracownika: '+stat
        elif len(d) == 0:
            stat = 'Brak danych adresowych o podanym kodzie: '+stat

        if stat == 'OK':
            DELETE ="DELETE FROM rs_kp_adresy"
            DELETE+=" WHERE firma_id = '"+self.firma_id+"' AND pracownik_id = '"+Pracownik+"'"
            DELETE+=" AND adres_id = '"+Adres+"';" 
            stat,dump,dump,dump = self.PolSQL.Execute(DELETE, 1)
            if stat <> 'OK':
                stat='Bd usuwania danych adresowych dla pracownika : '+stat

#-------------------------------------------------------------------------------
#---- SELECT - 5,6  Pobieranie listy adresow
#-------------------------------------------------------------------------------

if Fun in (5,6) and stat == 'OK':
    FILTR = "(a.firma_id = '"+self.firma_id+"' AND a.pracownik_id = '"+Pracownik+"')"
    #uzupelnienie podgladu o klucze nowe lub zmienione
    if len(Klucze_Id) > 0:
        FILTR += " OR (a.firma_id = '"+self.firma_id+"' AND a.pracownik_id = '"+Pracownik+"' AND a.adres_id IN ("
        for i in xrange(len(Klucze_Id)):
            if i > 0:
                FILTR += ","
            FILTR += "'"+str(Klucze_Id[i])+"'"
        FILTR += "))"

    SELECT ="SELECT a.adres_id||' - '||ra.opis AS adres, COALESCE(a.kod_pocztowy,''::TEXT),"
    SELECT+=" COALESCE(a.miejscowosc,''::TEXT), COALESCE(a.ulica,''::TEXT),"
    SELECT+=" COALESCE(a.nr_domu,''::TEXT), COALESCE(a.nr_mieszkania,''::TEXT)"
    SELECT+=" FROM rs_kp_adresy a"
    SELECT+=" INNER JOIN rs_rodzaje_adresow ra ON ra.kod = a.adres_id"
    SELECT+=" WHERE "+FILTR
    SELECT+=" ORDER BY a.adres_id;"

    stat,dane,wyn1,dump =self.PolSQL.Execute(SELECT, 3)
    if stat <> 'OK':
        stat='Bd pobrania listy adresow dla pracownika : '+stat