# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_kp_pracownicy_adresy_dane
# Purpose:     dodawanie/edycja danych adresowych pracownika
# Author:      Mariusz Rajfura
# Created:     2010/03/03
# RCS-ID:      $Id: fs_kp_pracownicy_adresy_dane.py $
# Copyright:   (c) 2010 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

Pracownik = klucze[0]
Adres = rsglobal.Dekoduj(klucze[1]).strip()

Fun = klucze[-1]

stat = 'OK'
dane = []
wyn1 = []
wyn2 = []

sql ="SELECT rsf_kadry_dozwolony_modul('"+self.firma_id+"','"+str(self.operator_id)+"','dane_adresowe','"+Pracownik+"');"
stat,d,dump,dump = self.PolSQL.Execute(sql,3)
if stat == 'OK':
    stat = d[0][0]

UprDodawanie = (((self.oddzial_id,'052103') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID))
UprEdycja = (((self.oddzial_id,'052102') in self.uprawnienia) or UprDodawanie or (self.operator_id == STANDARD_OPERATOR_ID))

#-------------------------------------------------------------------------------
# sprawdzenie uprawnien
#-------------------------------------------------------------------------------

if Fun in (1,2) and stat == 'OK':
    if not UprDodawanie:
        stat = 'BR UPR INS'

if Fun in (3,4) and stat == 'OK':
    if not UprEdycja:
        stat = 'BR UPR UPD'

#-------------------------------------------------------------------------------
# sprawdzenie danych
#-------------------------------------------------------------------------------

if Fun in (1,2,3,4) and stat == 'OK':
    if Adres == '':
        stat = 'BR_RODZAJ_ADR'
        dane.append(stat)
    
    if Fun in (1,2) and stat == 'OK':
        sql ="SELECT adres_id FROM rs_kp_adresy"
        sql+=" WHERE firma_id='"+self.firma_id+"' AND pracownik_id='"+Pracownik+"' AND adres_id='"+Adres+"';"
        stat,d,dump,dump = self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Bd sprawdzenia danych adresowych: '+stat
            dane.append(stat)
        elif len(d) <> 0:
            stat = 'BL_RODZAJ_ISTNIEJE'
            dane.append(stat)

    if Fun in (3,4) and stat == 'OK':
        sql ="SELECT adres_id FROM rs_kp_adresy"
        sql+=" WHERE firma_id='"+self.firma_id+"' AND pracownik_id='"+Pracownik+"' AND adres_id='"+Adres+"' FOR UPDATE NOWAIT;"
        stat,d,dump,dump = self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Bd sprawdzenia danych adresowych: '+stat
            dane.append(stat)
        elif len(d) <> 1:
            stat = 'BL_RODZAJ_NIE_ISTNIEJE'
            dane.append(stat)
            

    for i in range(len(pola)):
        pole = pola[i]
        wart = wartosci[i]

        if pole in ('kod_pocztowy','miejscowosc','ulica','nr_domu','nr_mieszkania','poczta','telefon','email'):
            if wart == '':
                wartosci[i] = 'NULL'
            else:
                wartosci[i] = "'"+wart+"'"

        elif pole == 'kraj_id':
            if wart == '':
                dane.append('BR_KRAJ')
            else:
                sql ="SELECT kraj FROM rs_kraje WHERE kraj = '"+wart+"';"
                stat,d,dump,dump = self.PolSQL.Execute(sql, 3)
                if stat <> 'OK':
                    dane.append('Bd sprawdzenia kodu kraju: '+stat)
                elif len(d) == 0:
                    dane.append('BL_KRAJ')
                wartosci[i] = "'"+wart+"'"

        elif pole == 'gmina_id':
            wart = wart.strip()
            if wart == '':
                wartosci[i] = 'NULL'
            else:
                sql ="SELECT kod FROM rs_gminy WHERE firma_id='"+self.firma_id+"' AND kod='"+wart+"';"
                stat,d,dump,dump = self.PolSQL.Execute(sql, 3)
                if stat <> 'OK':
                    dane.append('Bd sprawdzenia kodu gminy: '+stat)
                elif len(d) == 0:
                    dane.append('BL_GMINA')
                wartosci[i] = "'"+wart+"'"
                
    if stat == 'OK':
        if len(dane) > 0:
            stat = dane[0]

#-------------------------------------------------------------------------------
#--- DODAWANIE DANYCH (1 -z pobraniem select  2 - bez pobrania
#-------------------------------------------------------------------------------

if Fun in (1,2) and stat == 'OK':
    inspola = "firma_id,pracownik_id,adres_id"
    inswart = "'"+self.firma_id+"','"+Pracownik+"','"+Adres+"'"

    for i in xrange(len(pola)):
        if pola[i] <> 'adres_id':
            inspola += ","+pola[i]
            inswart += ","+wartosci[i]

    INSERT = "INSERT INTO rs_kp_adresy ("+inspola+") VALUES ("+inswart+");"

    stat,dump,dump,dump = self.PolSQL.Execute(INSERT,1)
    if stat <> 'OK':
        stat = 'Bd dodawania nowego adresu: '+stat
        dane.append(stat)

#-------------------------------------------------------------------------------
#--- UPDATE DANYCH ( 3-select, 4 -update z pobraniem)
#-------------------------------------------------------------------------------

if Fun in (3,4) and stat == 'OK':
    UPDATE = "UPDATE rs_kp_adresy SET "

    for i in xrange(len(pola)):
        UPDATE += pola[i]+" = "+wartosci[i]+","

    UPDATE = UPDATE[:-1]
    UPDATE += " WHERE firma_id = '"+self.firma_id+"' AND pracownik_id = '"+Pracownik+"' AND adres_id = '"+Adres+"';"

    stat,d,dump,dump = self.PolSQL.Execute(UPDATE,1)
    if stat <> 'OK':
        stat = 'Bd aktualizacji danych adresowych: '+stat
        dane.append(stat)

#-------------------------------------------------------------------------------
#--- POBRANIE DANYCH ( 5-select, 3 -update z pobraniem)
#-------------------------------------------------------------------------------

if Fun in (1,3,5) and stat=='OK':
    SELECT ="SELECT * FROM rs_kp_adresy"
    SELECT+=" WHERE firma_id = '"+self.firma_id+"' AND pracownik_id = '"+Pracownik+"' AND adres_id = '"+Adres+"';"

    stat,dane,wyn1,dump = self.PolSQL.Execute(SELECT,3)
    if stat <> 'OK':
        stat = 'Bd pobrania danych zatrudnienia : '+stat
        dane.append(stat)

    if stat == 'OK' and len(dane) == 1:
        tr = rssql.RSTableRowset(dane,wyn1)
        
    RodzajAdresu = 'Brak danych'
    if stat == 'OK' and len(dane) == 1:        
        if (self.oddzial_id,'011850') in self.uprawnienia or self.operator_id == STANDARD_OPERATOR_ID:
            sql = "SELECT opis FROM rs_rodzaje_adresow WHERE kod = '"+tr.GetVal(0,"adres_id")+"';"
            stat,d,dump,dump = self.PolSQL.Execute(sql, 3)
            if stat <> 'OK':
                RodzajAdresu = 'Bd pobrania opisu ze sownika rodzajw adresw : '+stat
            else:
                if len(d) == 0:
                    RodzajAdresu = 'Bdny kod rodzaju adresu.'
                else:
                    RodzajAdresu = str(d[0][0])
        else:
            RodzajAdresu = 'Brak uprawnie do sownika. Poinformuj administratora.'
    wyn2 = [RodzajAdresu]
    

    Kraj = 'Brak danych'
    if stat == 'OK' and len(dane) == 1:
        if (self.oddzial_id,'011070') in self.uprawnienia or self.operator_id == STANDARD_OPERATOR_ID:
            sql = "SELECT nazwa FROM rs_kraje WHERE kraj = '"+tr.GetVal(0,"kraj_id")+"';"
            stat,d,dump,dump = self.PolSQL.Execute(sql, 3)
            if stat <> 'OK':
                Kraj = 'Bd pobrania opisu ze sownika krajw : '+stat
            else:
                if len(d) == 0:
                    Kraj = 'Bdny kod kraju.'
                else:
                    Kraj = str(d[0][0])
        else:
            Kraj = 'Brak uprawnie do sownika. Poinformuj administratora.'
    wyn2.append(Kraj)

    
    Gmina = ''
    if stat == 'OK' and len(dane) == 1:
        if (self.oddzial_id,'011860') in self.uprawnienia or self.operator_id == STANDARD_OPERATOR_ID:
            wart = tr.GetVal(0,"gmina_id").strip()
            if wart <> 'None' and len(wart) == 8:
                sql = "SELECT opis FROM rs_gminy WHERE firma_id = '"+self.firma_id+"' AND kod = '"+wart+"';"
                stat,d,dump,dump = self.PolSQL.Execute(sql, 3)
                if stat <> 'OK':
                    Gmina = 'Bd pobrania opisu ze sownika gmin : '+stat
                else:
                    if len(d) == 0:
                        Gmina = 'Bdny kod gminy.'
                    else:
                        Gmina = str(d[0][0])
        else:
            Gmina = 'Brak uprawnie do sownika. Poinformuj administratora.'
    wyn2.append(Gmina)


    Powiat = ''
    if stat == 'OK' and len(dane) == 1:
        if (self.oddzial_id,'011860') in self.uprawnienia or self.operator_id == STANDARD_OPERATOR_ID:
            wart = tr.GetVal(0,"gmina_id").strip()[:5]
            if wart <> 'None' and len(wart) == 5:
                sql = "SELECT opis FROM rs_gminy WHERE firma_id = '"+self.firma_id+"' AND kod = '"+wart+"';"
                stat,d,dump,dump = self.PolSQL.Execute(sql, 3)
                if stat <> 'OK':
                    Powiat = 'Bd pobrania opisu ze sownika gmin : '+stat
                else:
                    if len(d) == 0:
                        Powiat = 'Bdny kod powiatu.'
                    else:
                        Powiat = str(d[0][0])
        else:
            Powiat = 'Brak uprawnie do sownika. Poinformuj administratora.'
    wyn2.append(Powiat)

    
    Wojewodztwo = ''
    if stat == 'OK' and len(dane) == 1:
        if (self.oddzial_id,'011860') in self.uprawnienia or self.operator_id == STANDARD_OPERATOR_ID:
            wart = tr.GetVal(0,"gmina_id").strip()
            if wart <> 'None':
                wart = wart[:2]
                if len(wart) == 2:
                    sql = "SELECT opis FROM rs_gminy WHERE firma_id = '"+self.firma_id+"' AND kod = '"+wart+"';"
                    stat,d,dump,dump = self.PolSQL.Execute(sql, 3)
                    if stat <> 'OK':
                        Wojewodztwo = 'Bd pobrania opisu ze sownika gmin : '+stat
                    else:
                        if len(d) == 0:
                            Wojewodztwo = 'Bdny kod wojewdztwa.'
                        else:
                            Wojewodztwo = str(d[0][0])
        else:
            Wojewodztwo = 'Brak uprawnie do sownika. Poinformuj administratora.'
    wyn2.append(Wojewodztwo)
