# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_kp_pracownicy_zawieszenia.py
# Purpose:     grid z zawieszeniami dla pracownika
#
# Author:      Mariusz Rajfura
# Created:     2010/02/17
# RCS-ID:      $Id: fs_kp_pracownicy_zawieszenia.py $
# Copyright:   (c) 2010 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

Pracownik = rsglobal.Dekoduj(klucze[0])
OdKiedy = rsglobal.Dekoduj(klucze[1])
Umowa = rsglobal.Dekoduj(klucze[3])
Zatrudnienie = rsglobal.Dekoduj(klucze[4])


Klucze_Id = klucze[2]

Fun = klucze[-1]

dane = []
wyn1 = []
wyn2 = []
stat = 'OK'

sql ="SELECT rsf_kadry_dozwolony_modul('"+self.firma_id+"','"+str(self.operator_id)+"','zawieszenie_pracownika','"+Pracownik+"');"
stat,d,dump,dump = self.PolSQL.Execute(sql,3)
if stat == 'OK':
    stat = d[0][0]

UprUsuwanie = ((self.oddzial_id,'052094') in self.uprawnienia or self.operator_id == STANDARD_OPERATOR_ID)


#-------------------------------------------------------------------------------
#--- DELETE - 6
#-------------------------------------------------------------------------------

if Fun == 6 and stat == 'OK':
    if not UprUsuwanie:
        stat='Brak uprawnie do usuwania danych zawieszenia.'

    if stat == 'OK':
        sql = "SELECT od_kiedy FROM rs_kp_zawieszenia"
        sql+=" WHERE firma_id='"+self.firma_id+"' AND pracownik_id='"+Pracownik+"'"
        sql+=" AND od_kiedy='"+OdKiedy+"' FOR UPDATE NOWAIT;" 

        stat,d,dump,dump = self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Bd pobrania danych zawieszenia dla pracownika : '+stat
        elif len(d) == 0:
            stat = 'Brak zawieszenia rozpoczynajcego si podan dat : '+stat

    #sprawdzenie, czy usuwamy ostatnie zawieszenie
    if stat == 'OK':
        sql ="SELECT od_kiedy FROM rs_kp_zawieszenia"
        sql+=" WHERE firma_id='"+self.firma_id+"'"
        sql+=" AND pracownik_id='"+Pracownik+"' AND od_kiedy>'"+OdKiedy+"';"

        stat,d,dump,dump = self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Bd pobrania listy pniejszych zawiesze: '+stat
            dane.append(stat)
        elif len(d) > 0:
            stat = 'Dozwolone jest tylko usuwanie ostatniego zawieszenia'
            dane.append(stat)

    if stat == 'OK':
        DELETE ="DELETE FROM rs_kp_zawieszenia"
        DELETE+=" WHERE firma_id='"+self.firma_id+"' AND pracownik_id='"+Pracownik+"'"
        DELETE+=" AND od_kiedy='"+OdKiedy+"';" 

        stat,dump,dump,dump = self.PolSQL.Execute(DELETE, 1)
        if stat <> 'OK':
            stat = 'Bd usuwania zawieszenia dla pracownika : '+stat
    
    #jesli nie ma zadnych zawieszen, to zmieniamy pracownikow stan na 'Zatrudniony'
    if stat == 'OK':
        sql ="SELECT od_kiedy FROM rs_kp_zawieszenia"
        sql+=" WHERE firma_id='"+self.firma_id+"' AND pracownik_id='"+Pracownik+"';"

        stat,d,dump,dump = self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Bd pobrania listy zawiesze dla pracownika: '+stat
            dane.append(stat)
        elif len(d) == 0:
            sql ="SELECT numer_id FROM rs_kp_zatrudnienie"
            sql+=" WHERE firma_id='"+self.firma_id+"' AND pracownik_id='"+Pracownik+"'"
            sql+=" ORDER BY numer_id DESC LIMIT 1 FOR UPDATE NOWAIT;"

            stat,dZatr,dump,dump = self.PolSQL.Execute(sql,3)
            if stat <> 'OK':
                stat = 'Bd pobrania numeru ostatniego zatrudnienia: '+stat
                dane.append(stat)
            elif len(dZatr) == 0:
                stat = 'Brak jakiegokolwiek zatrudnienia.'
                dane.append(stat)
            
            if stat == 'OK':    
                #wpisanie stanu 'Zatrudniony' pracownikowi
                UPDATE ="UPDATE rs_kp_zatrudnienie SET stan_pracownika_id='A'"
                UPDATE+=" WHERE firma_id='"+self.firma_id+"' AND pracownik_id='"+Pracownik+"'"
                UPDATE+=" AND numer_id="+str(dZatr[0][0])+";"

                stat,dump,dump,dump = self.PolSQL.Execute(UPDATE,1)
                if stat <> 'OK':
                    stat = 'Bd aktualizacji stanu zatrudnienia: '+stat
                    dane.append(stat)
                    

#-------------------------------------------------------------------------------
#---- SELECT - 5,6  Pobieranie listy zawieszen dla pracownika
#-------------------------------------------------------------------------------

if Fun in (5,6) and stat == 'OK':
    FILTR = "(z.firma_id='"+self.firma_id+"' AND z.pracownik_id='"+Pracownik+"' AND z.umowa_id='"+str(Umowa)+"' AND z.zatrudnienie_id='"+str(Zatrudnienie)+"')"

    SELECT ="SELECT z.od_kiedy,z.do_kiedy,z.zawieszenie_id||' - '||ar.nazwa,"
    SELECT+="COALESCE(SUBSTRING(z.opis FOR 50),'')"
    SELECT+=" FROM rs_kp_zawieszenia z"
    SELECT+=" INNER JOIN rs_kp_absencje_rodzaje ar"
    SELECT+="  ON (ar.firma_id=z.firma_id AND ar.typ_absencji_id=z.zawieszenie_id)"
    SELECT+=" WHERE "+FILTR+" ORDER BY z.od_kiedy DESC;"

    stat,dane,wyn1,dump =self.PolSQL.Execute(SELECT, 3)
    if stat <> 'OK':
        stat='Bd pobrania listy zawieszen dla pracownika : '+stat