# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_kp_pracownicy_zawieszenie.py
# Purpose:     grid z zawieszeniami dla pracownika
#
# Author:      Mariusz Rajfura
# Created:     2010/02/17
# RCS-ID:      $Id: fs_kp_pracownicy_zawieszenie.py $
# Copyright:   (c) 2010 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

Pracownik = rsglobal.Dekoduj(klucze[0])
OdKiedy = rsglobal.Dekoduj(klucze[1])
Klucze_Id = klucze[3]

Fun = klucze[-1]
dane = []
wyn1 = []
stat = 'OK'

sql ="SELECT rsf_kadry_dozwolony_modul('"+self.firma_id+"','"+str(self.operator_id)+"','pracownicy_zawieszenie','"+Pracownik+"');"
stat,d,dump,dump = self.PolSQL.Execute(sql,3)
if stat == 'OK':
    stat = d[0][0]

#FIXME: kody
UprUsuwanie = ((self.oddzial_id,'051064') in self.uprawnienia or self.operator_id == STANDARD_OPERATOR_ID)

#-------------------------------------------------------------------------------
#--- DELETE - 6
#-------------------------------------------------------------------------------

if Fun == 6 and stat == 'OK':
    if not UprUsuwanie:
        stat='Brak uprawnie do usuwania danych zawieszenia.'

    if stat == 'OK':
        sql = "SELECT od_kiedy FROM rs_kp_zawieszenie"
        sql+=" WHERE firma_id = '"+self.firma_id+"' AND pracownik_id = '"+Pracownik+"'"
        sql+=" AND od_kiedy = '"+OdKiedy+"' AND poczatek_przerwy = '"+PoczatekPrzerwy+"' FOR UPDATE;" 
        stat,d,dump,dump = self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Bd pobrania danych zawieszeniaurlopu bezpatnego z historii zatrudnienia dla pracownika : '+stat
        elif len(d) == 0:
            stat = 'Brak urlopu bezpatnego z historii zatrudnienia rozpoczynajcej si podan dat : '+stat

        if stat == 'OK':
            DELETE ="DELETE FROM rs_kp_zawieszenie"
            DELETE+=" WHERE firma_id = '"+self.firma_id+"' AND pracownik_id = '"+Pracownik+"'"
            DELETE+=" AND od_kiedy = '"+OdKiedy+"' AND poczatek_przerwy = '"+PoczatekPrzerwy+"';" 
            stat,dump,dump,dump = self.PolSQL.Execute(DELETE, 1)
            if stat <> 'OK':
                stat='Bd usuwania urlopu bezpatnego z historii zatrudnienia dla pracownika : '+stat

#-------------------------------------------------------------------------------
#---- SELECT - 5,6  Pobieranie listy zawieszen dla pracownika
#-------------------------------------------------------------------------------

if Fun in (5,6) and stat == 'OK':
    FILTR = "(firma_id = '"+self.firma_id+"' AND pracownik_id = '"+Pracownik+"')"

    #uzupelnienie podgladu o klucze nowe lub zmienione
    if len(Klucze_Id) > 0:
        FILTR += " OR (firma_id = '"+self.firma_id+"' AND pracownik_id = '"+Pracownik+"' AND od_kiedy IN ("
        for i in xrange(len(Klucze_Id)):
            if i > 0:
                FILTR += ","
            FILTR += "'"+str(Klucze_Id[i])+"'"
        FILTR += "))"

    SELECT ="SELECT poczatek_przerwy,koniec_przerwy,COALESCE(SUBSTRING(opis FOR 50),'')"
    SELECT+=" FROM rs_kp_zawieszenie WHERE "+FILTR+" ORDER BY od_kiedy DESC;"

    stat,dane,wyn1,dump =self.PolSQL.Execute(SELECT, 3)
    if stat <> 'OK':
        stat='Bd pobrania listy zawieszen dla pracownika : '+stat