# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_kp_rodzina.py
# Purpose:     grid z biezacymi zatrudnieniami pracownika
#
# Author:      Mariusz Rajfura
# Created:     2009/11/19
# RCS-ID:      $Id: fs_kp_rodzina.py $
# Copyright:   (c) 2009 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

# 2019-07-19 Wojciech Skowron   (11369) - Filtr aktywnie ubezpieczeni

Pracownik = rsglobal.Dekoduj(klucze[0])
Numer = klucze[1]
FiltrAktywne = klucze[2] #WS 2019-07-19

Fun = klucze[-1]
dane = []
wyn1 = []
stat = 'OK'

sql ="SELECT rsf_kadry_dozwolony_modul('"+self.firma_id+"','"+str(self.operator_id)+"','rodzina','"+Pracownik+"');"
stat,dane,dump,dump = self.PolSQL.Execute(sql,3)
if stat == 'OK':
    stat = dane[0][0]

UprUsuwanie = ((self.oddzial_id,'052084') in self.uprawnienia or self.operator_id == STANDARD_OPERATOR_ID)

#-------------------------------------------------------------------------------
#--- POBRANIE MAKSYMALNEGO NUMERU ZATRUDNIENIA (9)
#-------------------------------------------------------------------------------

if Fun == 9 and stat == 'OK':
    sql ="SELECT MAX(rodzina_id) FROM rs_kp_rodzina"
    sql+=" WHERE firma_id = '"+self.firma_id+"' AND pracownik_id = '"+Pracownik+"';"
    stat,dane,dump,dump = self.PolSQL.Execute(sql,3)
    if stat <> 'OK':
        stat = 'Bd sprawdzenia ostatniego numeru czonka rodziny : '+stat
    else:
        if len(dane) == 0:
            stat = 'Brak jakiegokolwiek czonka rodziny'

#-------------------------------------------------------------------------------
#--- DELETE - 6
#-------------------------------------------------------------------------------

if Fun == 6 and stat == 'OK':
    if not UprUsuwanie:
        stat='Brak uprawnie do usuwania czonkw rodziny.'

    if stat == 'OK':
        sql = "SELECT rodzina_id FROM rs_kp_rodzina"
        sql+=" WHERE firma_id = '"+self.firma_id+"' AND pracownik_id = '"+Pracownik+"'"
        sql+=" AND rodzina_id = '"+str(Numer)+"' FOR UPDATE NOWAIT;" 
        stat,d,dump,dump = self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Bd pobrania danych czonak rodziny pracownika : '+stat
        elif len(d) == 0:
            stat = 'Brak czonka rodziny o podanym numerze : '+stat

        if stat == 'OK':
            DELETE ="DELETE FROM rs_kp_rodzina"
            DELETE+=" WHERE firma_id = '"+self.firma_id+"' AND pracownik_id = '"+Pracownik+"'"
            DELETE+=" AND rodzina_id = '"+str(Numer)+"';" 
            stat,dump,dump,dump = self.PolSQL.Execute(DELETE, 1)
            if stat <> 'OK':
                stat='Bd usuwania danych czonka rodziny pracownika : '+stat

#-------------------------------------------------------------------------------
#---- SELECT - 5,6  Pobieranie listy historycznych zatrudnien
#-------------------------------------------------------------------------------

if Fun in (5,6) and stat == 'OK':
    SQL ="SELECT r.rodzina_id,r.nazwisko,r.imie,COALESCE(p.opis,'') as pokrewienstwo,r.pesel,COALESCE(r.data_urodzenia::TEXT,'') as data_ur, ubezpieczony_od, ubezpieczony_do "
    SQL+=" FROM rs_kp_rodzina r LEFT OUTER JOIN rs_stopnie_pokrewienstwa p ON (r.pokrewienstwo_id=p.kod)"
    SQL+=" WHERE r.firma_id = '"+self.firma_id+"' AND r.pracownik_id = '"+Pracownik+"'"
    #WS 2019-07-19
    if FiltrAktywne:
        SQL+=" AND r.ubezpieczony_od <= NOW()::DATE AND (r.ubezpieczony_do >= NOW()::DATE OR r.ubezpieczony_do IS NULL)"
    SQL+=" ORDER BY r.rodzina_id;"

    stat,dane,wyn1,dump =self.PolSQL.Execute(SQL, 3)
    if stat <> 'OK':
        stat='Bd pobrania listy czonkw rodziny dla pracownika : '+stat
