# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_kp_stale_typy.py
# Purpose:     obsluga grida edytowalnego z typami staych kadrowych
# Author:      Marcin Natkaski
# Created:     2014/08/22
# RCS-ID:      $Id: fs_kp_stale_typy.py$
# Copyright:   (c) 2010 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

stat='OK'

if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=='OK':
    Funkcja = klucze['Funkcja']
    
    SlPar={'Stala':[1,5,6],'StalaF':[1,5,6],'GrupaF':[1,5,6],'TypF':[1,5,6],'Grupa':[8,]}
    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Funkcja,klucze)
    if Lista<>'':
        stat='Uwaga : wywoanie funkcji fs_artykuly_cechy_wartosci z numerem '+str(Funkcja)+' bez parametrw: '+Lista
        
    if Funkcja in [1,5,6]: 
        Stala=rsglobal.Dekoduj(klucze['Stala'])
        StalaF=rsglobal.Dekoduj(klucze['StalaF'])
        GrupaF=rsglobal.Dekoduj(klucze['GrupaF'])
        TypF=rsglobal.Dekoduj(klucze['TypF'])
        
    if Funkcja in [8,]: 
        Grupa=rsglobal.Dekoduj(klucze['Grupa'])
        
dane = []
wyn1 = []
wyn2 = []

Puste = (None,'')

UprIns=((self.oddzial_id,'014233') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID
UprUpd=((self.oddzial_id,'014232') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID or UprIns
UprDel=((self.oddzial_id,'014234') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID

Insert = []
Update = []
Delete = []



if stat=='OK' and Funkcja == 1:
    Update=klucze['Update']
    Insert=klucze['Insert']
    Delete=klucze['Delete']


#-------------------------------------------------------------------------------
#-------  POBRANIE OPISU GRUPY (8)
#-------------------------------------------------------------------------------

if Funkcja == 8 and stat == "OK":
    sql ="SELECT opis FROM rs_kp_stale_grupy"
    sql+=" WHERE kod='"+Grupa+"';"
    stat,dane,dump,dump = self.PolSQL.Execute(sql,3)
    if stat <> 'OK':
        stat = 'Bd przy sprawdzaniu opisu grupy: '+stat
        dane.append(stat)

#-------------------------------------------------------------------------------
#-------  SPRAWDZANIE DELETE  --------------------------------------------------
#-------------------------------------------------------------------------------

if Funkcja == 1 and stat=="OK":
    if len(Delete[0])>0:
        if not UprDel:
            stat='BR UPR DEL'
            dane.append(stat)
        
        # wykonanie DELETE 
        if stat == 'OK':
            SQLDEL = ''
            SQLFU = ''
            for i in xrange(len(Delete[0])):
                DELETE = "DELETE FROM rs_kp_typy_stalych "
                WHERE = "WHERE firma_id='"+self.firma_id+"' "
                SQLFU = "SELECT stala_id FROM rs_kp_typy_stalych"
                SQLFU+= " WHERE firma_id='"+self.firma_id+"' " 
                for j in xrange(len(Delete[0][i])):
                    pole = Delete[1][j]
                    wart = Delete[0][i][j]
                    if pole in ['stala_id',]:
                        WHERE += " AND "+pole+"='"+wart+"'"
                        SQLFU += " AND "+pole+"='"+wart+"'"
                        

                SQLDEL += DELETE+WHERE+"; "
                SQLFU += " FOR UPDATE NOWAIT; "

            if SQLFU <> '':
                stat,d,dump,dump = self.PolSQL.Execute(rsglobal.Dekoduj(SQLFU),3)
                if stat <> 'OK':
                    stat = 'Bd sprawdzenia danych do usunicia: '+stat
                    dane.append(stat)
            
            if stat == 'OK' and SQLDEL <> '':
                stat,dump,dump,dump = self.PolSQL.Execute(rsglobal.Dekoduj(SQLDEL),1)
                if stat <> 'OK':
                    stat = "Bd przy usuwaniu danych: "+stat   
                    dane.append(stat)

                                 
#-------------------------------------------------------------------------------
#---   UPDATE DANYCH (1)
#-------------------------------------------------------------------------------

if Funkcja == 1 and stat=="OK":
    if len(Update[0])>0:
        if not UprUpd:
            stat='BR UPR UPD'
            dane.append(stat)

        if stat == 'OK':
            SQLFU = ''
            for i in xrange(len(Update[0])):
                SQLFU+= "SELECT stala_id FROM rs_kp_typy_stalych"
                SQLFU+= " WHERE firma_id='"+self.firma_id+"' "
                for j in xrange(len(Update[2][i])): # petla po kluczu
                    pole = Update[3][j]
                    wart = rsglobal.Dekoduj(Update[2][i][j])
                    SQLFU += " AND "+pole+"='"+str(wart)+"'"
                SQLFU += " FOR UPDATE NOWAIT; "
            
            if SQLFU <> '':
                stat,dFU,nFU,dump = self.PolSQL.Execute(rsglobal.Dekoduj(SQLFU),3)
                if stat <> 'OK':
                    stat = 'Bd sprawdzenia danych do modyfikacji: '+stat
                    dane.append(stat)

        if stat == 'OK':
            WierszeNr = Update[-1]
            for i in xrange(len(Update[0])):
                for j in xrange(len(Update[0][i])): 
                    pole = Update[0][i][j]
                    wart = Update[1][i][j]

                    if pole == 'stala_id':
                        wart = wart.strip()
                        if wart == '':
                            stat = 'BR STALA'
                            wyn2.append((WierszeNr[i],0))
                            dane.append(stat)
                        elif len(wart) > 10:
                            stat = 'Warto kolumny Staa moe mie maksymalnie 10 znakw'
                            wyn2.append((WierszeNr[i],0))
                            dane.append(stat)
                        
                    elif pole == 'nazwa':
                        wart = wart.strip()
                        if wart == '':
                            stat = 'BR NAZWA'
                            wyn2.append((WierszeNr[i],2))
                            dane.append(stat)

                    elif pole == 'grupa':
                        if wart.strip() == '':
                            stat = 'BR GRUPA'
                            wyn2.append((WierszeNr[i],2))
                            dane.append(stat)
                        else:
                            sql ="SELECT kod FROM rs_kp_stale_grupy "
                            sql+=" WHERE kod = '"+str(wart)+"';"
                            stat,d,dump,dump = self.PolSQL.Execute(sql,2)
                            if stat <> 'OK':
                                stat = 'BL SQL GRUPA'
                                wyn2.append((WierszeNr[i],2))
                                dane.append(stat)
                            elif len(d) == 0:
                                stat = 'BL GRUPA'
                                wyn2.append((WierszeNr[i],2))
                                dane.append(stat)

                    elif pole == 'format':
                        SQL ="SELECT 1 FROM rs_kp_stale WHERE firma_id='"+self.firma_id+"' "
                        if self.operator_id <> STANDARD_OPERATOR_ID:
                            # jeeli operator<>anakonda to sprawdzamy dostp do grup
                            SQL+="AND grupa in (SELECT grupa FROM rs_grupy_stalych_upr "
                            SQL+=" WHERE firma_id='"+self.firma_id+"' AND operator_id="+str(self.operator_id)+") "
                        for j in xrange(len(Update[2][i])):  # petla po kluczu
                            p = Update[3][j]
                            w = rsglobal.Dekoduj(Update[2][i][j])
                            if p in ['stala_id', ]:
                                SQL += " AND " + p + "='" + w + "';"

                        stat,d,dump,dump = self.PolSQL.Execute(SQL,3)
                        if stat<>'OK':
                            stat=u'Bd pobraniwa grupy'
                        elif len(d)>0:
                            stat = u'Nie mona zmienia typu staych - istniej wpisy w staych wartociach.'
                            wyn2.append((WierszeNr[i],4))
                            d.append(stat)
                        else:
                            if wart.strip() == '':
                                stat = 'BR TYP'
                                wyn2.append((WierszeNr[i],4))
                                dane.append(stat)
                            else:
                                sql ="SELECT kod FROM rs_kp_stale_formaty_danych"
                                sql+=" WHERE kod = '"+str(wart)+"';"
                                stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                                if stat <> 'OK':
                                    stat = 'BL SQL TYP'
                                    wyn2.append((WierszeNr[i],4))
                                    dane.append(stat)
                                elif len(d) == 0:
                                    stat = 'BL TYP'
                                    wyn2.append((WierszeNr[i],4))
                                    dane.append(stat)

                if stat == 'OK':
                    if len(dane) > 0:
                        stat = dane[0]
                
                # wykonanie UPDATE
                if stat=='OK':
                    sql=''
                    UPDATE="UPDATE rs_kp_typy_stalych "
                    SET='SET '
                    for j in xrange(len(Update[0][i])): 
                        pole=Update[0][i][j]
                        wart=Update[1][i][j]
    
                        if pole in ['stala_id', 'nazwa', 'grupa', 'typ','format']:
                            SET+=pole+"='"+wart+"',"
                            
                        elif pole in ['osobny_przerzut']:
                            SET+="FALSE,"
                            
                    SET=SET.strip(",")
                    WHERE=" WHERE firma_id='"+self.firma_id+"'" 
                    for j in xrange(len(Update[2][i])): # petla po kluczu
                        pole=Update[3][j]
                        wart=rsglobal.Dekoduj(Update[2][i][j])
                        if pole in ['stala_id',]:
                            WHERE+=" AND "+pole+"='"+wart+"'"
                        
                    WHERE+=";"
                        
                    sql+=UPDATE+SET+WHERE

                    stat,dump,dump,dump = self.PolSQL.Execute(rsglobal.Dekoduj(sql),1)
                    if stat<>'OK':
                        stat="Istnieje ju wpis o podanym kluczu: "+stat   
                        dane.append(stat)
                    

#-------------------------------------------------------------------------------
#---------Sprawdzanie danych do Insert------
#-------------------------------------------------------------------------------

if Funkcja == 1 and stat=="OK":
    if len(Insert[0])>0:
        if not UprIns:
            stat='BR UPR INS'
            dane.append(stat)

        if stat == 'OK':
            WierszeNr = Insert[-1]
            for i in xrange(len(Insert[0])):
                
                for j in xrange(len(Insert[0][i])): 
                    pole=Insert[1][j]
                    wart=Insert[0][i][j]
                    
                    if pole == 'stala_id':
                        wart = wart.strip()
                        if wart == '':
                            stat = 'BR STALA'
                            wyn2.append((WierszeNr[i],0))
                            dane.append(stat)
                        elif len(wart)>10:
                            stat = 'Warto w kolumnie staa moe mie maksymalnie 10 znakw'
                            wyn2.append((WierszeNr[i],0))
                            dane.append(stat)
                    elif pole == 'nazwa':
                        wart = wart.strip()
                        if wart == '':
                            stat = 'BR NAZWA'
                            wyn2.append((WierszeNr[i],1))
                            dane.append(stat)

                    elif pole == 'grupa':
                        wart = wart.strip()
                        if wart == '':
                            stat = 'BR GRUPA'
                            wyn2.append((WierszeNr[i],2))
                            dane.append(stat)
                        else:
                            sql ="SELECT kod FROM rs_kp_stale_grupy"
                            sql+=" WHERE kod = '"+str(wart)+"';"
                            stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                            if stat <> 'OK':
                                stat = 'BL SQL GRUPA'
                                wyn2.append((WierszeNr[i],2))
                                dane.append(stat)
                            elif len(d) == 0:
                                stat = 'BL GRUPA'
                                wyn2.append((WierszeNr[i],2))
                                dane.append(stat)

                    elif pole == 'format':
                        wart = wart.strip()
                        if wart == '':
                            stat = 'BR TYP'
                            wyn2.append((WierszeNr[i],4))
                            dane.append(stat)
                        else:
                            sql ="SELECT kod FROM rs_kp_stale_formaty_danych"
                            sql+=" WHERE kod = '"+str(wart)+"';"
                            stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                            if stat <> 'OK':
                                stat = 'BL SQL TYP'
                                wyn2.append((WierszeNr[i],4))
                                dane.append(stat)
                            elif len(d) == 0:
                                stat = 'BL TYP'
                                wyn2.append((WierszeNr[i],4))
                                dane.append(stat)

               
                # sprawdzenie, czy nie ma bledow
                if stat == 'OK':
                    if len(dane) > 0:
                        stat = dane[0]
        
                # wykonanie INSERT do pojedynczego wiersza
                if stat == 'OK':    
                    sqlIns=''
                    INSERT="INSERT INTO rs_kp_typy_stalych "
                    KOLUMNY="(firma_id"
                    VALUES=" VALUES ('"+self.firma_id+"'"

                    for j in xrange(len(Insert[0][i])): 
                        pole=Insert[1][j]
                        wart=Insert[0][i][j]

                        if pole in ['stala_id', 'nazwa','grupa','format',]:
                            KOLUMNY+=","+pole
                            VALUES+=",'"+wart+"'"
    
                        elif pole in ['domyslna']:
                            KOLUMNY+=","+pole
                            VALUES+=",FALSE"
                            
                    KOLUMNY+=")"
                    VALUES+=");"
                    sqlIns+=INSERT+KOLUMNY+VALUES
                if stat == 'OK' and sqlIns<>'': 
                    stat,dump,dump,dump=self.PolSQL.Execute(rsglobal.Dekoduj(sqlIns),1)
                    if stat<>'OK':
                        stat="Bd przy dodawaniu danych: "+stat   
                        dane.append(stat)

#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (1- insert 1 -select, 1 -delete), (5-odczyt)
#-------------------------------------------------------------------------------

if Funkcja in (1,5,6) and stat == 'OK':
    SQL ="SELECT a.stala_id,a.nazwa,a.grupa,b.opis,a.format,a.domyslna"
    SQL+=" FROM rs_kp_typy_stalych a"
    SQL+=" INNER JOIN rs_kp_stale_grupy b ON (a.grupa=b.kod)"
    SQL+=" WHERE a.firma_id='"+self.firma_id+"'"

    if self.operator_id <> STANDARD_OPERATOR_ID and Funkcja==6:
        SQL+="AND a.grupa in (SELECT grupa FROM rs_grupy_stalych_upr "
        SQL+=" WHERE firma_id='"+self.firma_id+"' AND operator_id="+str(self.operator_id)+")"

    #dane filtru uzywane tylko przy zwyklym odczycie do grida
    if GrupaF <> '':
        SQL+=" AND a.grupa LIKE '"+GrupaF+"%'"
        
    if StalaF <> '':
        SQL+=" AND a.stala_id LIKE '"+StalaF+"%'"
        
    if TypF <> '':
        SQL+=" AND a.format LIKE '"+TypF+"%'"
    SQL+=" ORDER BY a.stala_id ;"
    stat,dane,wyn1,wyn2 = self.PolSQL.Execute(SQL,3)
    if stat <> 'OK':
        stat = "Bd przy pobieraniu danych: "+stat
        dane.append(stat)