# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_kp_szkolenia.py
# Purpose:     odsluga grida szkole
# Author:      Marcin Natkaski
# Created:     2012/06/14
# RCS-ID:      $Id: fs_kp_szkolenia.py $
# Copyright:   (c) 2012 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

dane = []
wyn1 = []
wyn2 = []
stat = 'OK'

if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=='OK':
    Fun = klucze['Funkcja']
    
    SlPar={'Szkolenie':[5,6,9],'Typ':[5,6],'Nazwa':[5,6],'Rodzaj':[5,6],
    'Projekt':[5,6],'Operator':[5,6],'UzupelniajaceDo':[5,6],'ZalezneOd':[5,6],
    'DoOpracowania':[5,6],'DoSprawdzenia':[5,6],'DoZweryfikowania':[5,6],
    'DoZatwierdzenia':[5,6],'Wewnetrzne':[5,6],'Obowiazkowe':[5,6],'SzkolenieF':[5,6],'DodaneKlucze':[5]}    
    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Fun,klucze)
    if Lista<>'':
        stat='Uwaga : wywoanie funkcji fs_kp_szkolenia z numerem '+str(Fun)+' bez parametrw: '+Lista

if stat=='OK':
    if Fun in [5,6]:
        FSzkolenie=rsglobal.Dekoduj(klucze['SzkolenieF'])
        FTyp=rsglobal.Dekoduj(klucze['Typ'])
        FNazwa=rsglobal.Dekoduj(klucze['Nazwa'])
        FRodzaj=rsglobal.Dekoduj(klucze['Rodzaj'])
        FProjekt=rsglobal.Dekoduj(klucze['Projekt'])
        FOperator=rsglobal.Dekoduj(klucze['Operator'])
        FUzupelniajaceDo=rsglobal.Dekoduj(klucze['UzupelniajaceDo'])
        FZalezneOd=rsglobal.Dekoduj(klucze['ZalezneOd'])
        FDoOpracowania=rsglobal.Dekoduj(klucze['DoOpracowania'])
        FDoSprawdzenia=rsglobal.Dekoduj(klucze['DoSprawdzenia'])
        FDoZweryfikowania=rsglobal.Dekoduj(klucze['DoZweryfikowania'])
        FDoZatwierdzenia=rsglobal.Dekoduj(klucze['DoZatwierdzenia'])
        FWewnetrzne=rsglobal.Dekoduj(klucze['Wewnetrzne'])
        FObowiazkowe=rsglobal.Dekoduj(klucze['Obowiazkowe'])
        
    if Fun in [6,9]: 
        Szkolenie=rsglobal.Dekoduj(klucze['Szkolenie'])
    if Fun in [5,6]:
        DodaneKlucze=rsglobal.Dekoduj(klucze['DodaneKlucze'])

UprUsuwanie = ((self.oddzial_id,'053104') in self.uprawnienia or self.operator_id == STANDARD_OPERATOR_ID)


#-------------------------------------------------------------------------------
#--- DELETE - 6
#-------------------------------------------------------------------------------

if Fun == 6 and stat == 'OK':
    if not UprUsuwanie:
        stat='Brak uprawnie do usuwania szkolenia.'
    # czy szkolenie nie jest zalene albo uzupeniajce
    if stat=='OK':
        sql="SELECT * FROM rs_szkolenia WHERE firma_id='"+self.firma_id+"' AND "
        sql+=" (uzupelniajace_do='"+Szkolenie+"' OR zalezne_od='"+Szkolenie+"');"
        stat,dane,dump,dump = self.PolSQL.Execute(sql, 3)
        if len(dane)>0:
            stat='Usuwane szkolenie wystpuje jako zalene lub uzupeniajce do innego.'
    # czy szkolenie nie ma ju przypisanego harmonogramu
    if stat=='OK':
        sql=" SELECT szkolenie_id FROM rs_szkolenia_harmonogram WHERE firma_id='"+self.firma_id+"' AND szkolenie_id='"+Szkolenie+"' ;" 
        stat,dane,dump,dump = self.PolSQL.Execute(sql, 3)
        if len(dane)>0:
            stat='Usuwane szkolenie zapisane jest ju w harmonogramie. Usunicie niemoliwe.'
    if stat=='OK':
        DELETE ="DELETE FROM rs_szkolenia"
        DELETE+=" WHERE firma_id = '"+self.firma_id+"' AND szkolenie_id = '"+Szkolenie+"';"
        stat,dump,dump,dump = self.PolSQL.Execute(DELETE, 1)
        if stat != 'OK':
            stat='Bd usuwania szkolenia : '+stat
            
                
#-------------------------------------------------------------------------------
#---- SELECT - 5 Pobieranie listy szkole
#-------------------------------------------------------------------------------

if Fun in (5,6)  and stat == 'OK':    
    SQL =" SELECT DISTINCT COALESCE(sz.szkolenie_id, ''),COALESCE(sz.nazwa, ''),COALESCE(sz.typ_szkolenia, ''),COALESCE(sz.rodzaj, ''),"
    SQL+=" sz.czy_obowiazkowe,sz.czy_zewnetrzne, COALESCE(sz.projekt_id, '') "
    SQL+=" FROM rs_szkolenia sz "
    SQL+="LEFT OUTER JOIN rs_szkolenia_wersje szw  USING (firma_id,szkolenie_id) "  
    SQL+=" WHERE  sz.firma_id = '"+self.firma_id+"'"
    if FSzkolenie != '' :    
        SQL+=" AND sz.szkolenie_id LIKE '"+FSzkolenie+"%'"
    if FTyp != '':
        SQL+=" AND sz.typ_szkolenia='"+FTyp+"'"
    if FNazwa != '':
        SQL+=" AND sz.nazwa LIKE'"+FNazwa+"%'"
    if FRodzaj != '':
        SQL+=" AND sz.rodzaj='"+FRodzaj+"'"
    if FProjekt!= '':
        SQL+= " AND sz.projekt_id='"+FProjekt+"'"   
    if FOperator != -1:                                
        SQL+=" AND (opracowal=" +str(FOperator)+ " OR sprawdzil=" +str(FOperator)+ " OR zweryfikowal=" +str(FOperator)+ " OR zatwierdzil=" +str(FOperator)+ ")"    
    if FUzupelniajaceDo!= '':
        SQL+=" AND uzupelniajace_do='"+FUzupelniajaceDo+"'"
    if FZalezneOd<>'':
        SQL+=" AND zalezne_od='"+FZalezneOd+"'"
    if FWewnetrzne:
        SQL+=" AND czy_zewnetrzne "
    if FObowiazkowe:
        SQL+=" AND czy_obowiazkowe "
    if FDoOpracowania or FDoSprawdzenia or FDoZweryfikowania or FDoZatwierdzenia:
        FPOM = " AND ("
        if FDoOpracowania:
            if FOperator != -1:
                FPOM+=" (szw.opracowal="+str(FOperator)+" AND szw.opracowal_data IS NULL) OR "
            else:
                FPOM+=" (szw.opracowal_data IS NULL AND szw.szkolenie_id is NOT NULL) OR "
        if FDoSprawdzenia:
            if FOperator != -1:
                FPOM+=" (szw.sprawdzil="+str(FOperator)+" AND szw.sprawdzil_data IS NULL) OR "
            else:
                FPOM+=" (szw.sprawdzil_data IS NULL) AND szw.szkolenie_id is NOT NULL OR "    
        if FDoZweryfikowania:
            if FOperator != -1:
                FPOM+=" (szw.zweryfikowal="+str(FOperator)+" AND szw.zweryfikowal_data IS NULL) OR "
            else:
                FPOM+=" (szw.zweryfikowal_data IS NULL) AND szw.szkolenie_id is NOT NULL  OR "    
        if FDoZatwierdzenia:
            if FOperator != -1:
                FPOM+=" (szw.zatwierdzil="+str(FOperator)+" AND szw.zatwierdzil_data IS NULL) OR "
            else:
                FPOM+=" (szw.zatwierdzil_data IS NULL) AND szw.szkolenie_id is NOT NULL  OR "    
        SQL+=FPOM[:-4]+") "
    for i in xrange(len(DodaneKlucze)):
            SQL+=" OR (firma_id,szkolenie_id) "
            SQL+=" = ('"+self.firma_id+"','"+DodaneKlucze[i]+"') "
    SQL+=" ORDER BY COALESCE(sz.szkolenie_id, '')"
    stat,dane,wyn1,dump =self.PolSQL.Execute(SQL, 3)
    if stat != 'OK':
        stat='Bd pobrania listy szkole : '+stat
        
        
#-------------------------------------------------------------------------------
#----- POBRANIE NAZWY SZKOLENIA - 9
#-------------------------------------------------------------------------------

if stat=='OK' and Fun == 9:
    SQL="SELECT nazwa FROM rs_szkolenia WHERE firma_id='"+self.firma_id+"' AND szkolenie_id='"+Szkolenie+"';"
    stat,dane,dump,dump = self.PolSQL.Execute(SQL, 3)
    if stat != 'OK':
        stat='Bd pobrania nazwy szkolenia : '+stat