# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_kp_szkolenia_dane
# Purpose:     dodawanie/edycja szkole
# Author:      Marcin Natkaski
# Created:     2012/06/14
# RCS-ID:      $Id: fs_kp_szkolenia_dane.py $
# Copyright:   (c) 2012 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

stat = 'OK'
dane = []
wyn1 = []
wyn2 = []

if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=='OK':
    Fun = klucze['Funkcja']
    
    SlPar={'Szkolenie':[1,2,3,4,5]}    
    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Fun,klucze)
    if Lista<>'':
        stat='Uwaga : wywoanie funkcji fs_kp_szkolenia_dane z numerem '+str(Fun)+' bez parametrw: '+Lista

    if Fun in (1,2,3,4,5,): 
        Szkolenie=rsglobal.Dekoduj(klucze['Szkolenie'])

UprDodawanie = (((self.oddzial_id,'053103') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID))
UprEdycja = (((self.oddzial_id,'053102') in self.uprawnienia) or UprDodawanie or (self.operator_id == STANDARD_OPERATOR_ID))

#-------------------------------------------------------------------------------
# sprawdzenie uprawnien
#-------------------------------------------------------------------------------

if Fun in (1,2) and stat == 'OK':
    if not UprDodawanie:
        stat = 'BR UPR INS'

if Fun in (3,4) and stat == 'OK':
    if not UprEdycja:
        stat = 'BR UPR UPD'

#-------------------------------------------------------------------------------
# sprawdzenie danych
#-------------------------------------------------------------------------------

if stat == 'OK':
    for i in range(len(pola)):
        pole = pola[i].lower()
        wart = wartosci[i]

        if pole == 'szkolenie_id':
            if wart == 0:
                dane.append('BR_SZKOL')
            else:
                sql ="SELECT szkolenie_id FROM rs_szkolenia"
                sql+=" WHERE firma_id = '"+self.firma_id+"' AND szkolenie_id = '"+Szkolenie+"';"
                stat,d,dump,dump = self.PolSQL.Execute(sql, 3)
                if stat != 'OK':
                    dane.append('Bd pobrania szkolenia : '+stat)
                elif len(d) > 0:
                    dane.append('BL_SZKOL')
                wartosci[i] = wart

        elif pole == 'nazwa':
            if wart == '':
                dane.append('BR_NAZWA')
            wartosci[i] = wart

        elif pole == 'zalezne_od':
            if wart != '':
                sql ="SELECT szkolenie_id FROM rs_szkolenia"
                sql+=" WHERE firma_id = '"+self.firma_id+"' AND szkolenie_id = '"+wart+"';"
                stat,d,dump,dump = self.PolSQL.Execute(sql, 3)
                if stat != 'OK':
                    dane.append('Bd pobrania szkolenia : '+stat)
                elif len(d) == 0:
                    stat='BL_ZAL'
                    dane.append(stat)
            wartosci[i] = wart

        elif pole == 'uzupelniajace_do':
            if wart != '':
                sql ="SELECT szkolenie_id FROM rs_szkolenia"
                sql+=" WHERE firma_id = '"+self.firma_id+"' AND szkolenie_id = '"+wart+"';"
                stat,d,dump,dump = self.PolSQL.Execute(sql, 3)
                if stat != 'OK':
                    dane.append('Bd pobrania szkolenia : '+stat)
                elif len(d) == 0:
                    dane.append('BL_UZU')
            wartosci[i] = wart

        elif pole == 'projekt_id':
            if wart != '':
                sql ="SELECT projekt_id FROM rs_projekty"
                sql+=" WHERE firma_id = '"+self.firma_id+"' AND projekt_id = '"+wart+"';"
                stat,d,dump,dump = self.PolSQL.Execute(sql, 3)
                if stat != 'OK':
                    dane.append('Bd pobrania projektu : '+stat)
                elif len(d) == 0:
                    dane.append('BL_PROJ')
            wartosci[i] = wart
            
        elif pole == 'typ_szkolenia':
            if wart != '':
                sql ="SELECT kod FROM rs_szkolenia_typy"
                sql+=" WHERE firma_id = '"+self.firma_id+"' AND kod = '"+wart+"';"
                stat,d,dump,dump = self.PolSQL.Execute(sql, 3)
                if stat != 'OK':
                    dane.append('Bd pobrania typu szkolenia : '+stat)
                elif len(d) == 0:
                    dane.append('BL_TYP')
            wartosci[i] = wart
        
        if len(dane) > 0:
            stat = dane[0]


#-------------------------------------------------------------------------------
#--- DODAWANIE DANYCH (1 -z pobraniem select  2 - bez pobrania
#-------------------------------------------------------------------------------

if Fun in (1,2):
    if stat == 'OK':
        ins = "INSERT INTO rs_szkolenia"
        Pola="firma_id" 
        Wartosci="'"+self.firma_id+"'" 
        for i in range(len(pola)):
            pole = pola[i]
            wart = wartosci[i]
            if pole in ['szkolenie_id','nazwa','opis','symbol_dokumentu','rodzaj','cel','zakres']:
                Pola= Pola+","+pole
                Wartosci= Wartosci+",'"+wart+"'"
                
            elif pole in ['typ_szkolenia','uzupelniajace_do','zalezne_od','projekt_id']: 
                Pola= Pola+","+pole
                
                if wart<>'':
                    Wartosci= Wartosci+",'"+wart+"'"
                else:                 
                    Wartosci= Wartosci+",NULL"
                    
            elif pole in ['okres_waznosci','dni_karencji','liczba_godzin']:
                Pola= Pola+","+pole
                Wartosci= Wartosci+","+str(wart)
                
            elif pole in ['czy_zewnetrzne','czy_obowiazkowe']:
                Pola= Pola+","+pole
                Wartosci= Wartosci+","+str(wart)
            
        ins = ins+" ("+Pola+") VALUES ("+Wartosci+");"        
        stat,dump,dump,dump = self.PolSQL.Execute(ins,1)
        if stat != 'OK':
            stat = 'Bd dodawania nowego szkolenia : '+stat
            dane.append(stat)


#-------------------------------------------------------------------------------
#--- UPDATE DANYCH ( 3-select, 4 -update z pobraniem)
#-------------------------------------------------------------------------------

if Fun in (3,4) and stat == 'OK':
    upd = "UPDATE rs_szkolenia SET "
    WHERE=" WHERE firma_id = '"+self.firma_id+"' and szkolenie_id = '"+Szkolenie+"';"
    Wartosci=''
    Pola=''
    for i in range(len(pola)):
            pole = pola[i]
            wart = wartosci[i]
            
            if pole in ['nazwa','opis','symbol_dok','rodzaj','cel','zakres']:
                Pola= Pola+","+pole
                Wartosci= Wartosci+",'"+wart+"'"
                
            elif pole in ['typ_szkolenia','uzupelniajace_do','zalezne_od','projekt_id']: 
                Pola= Pola+","+pole
                if wart<>'':
                    Wartosci= Wartosci+",'"+wart+"'"
                else:                 
                    Wartosci= Wartosci+",NULL"

            elif pole in ['okres_waznosci','dni_karencji','liczba_godzin']:
                Pola= Pola+","+pole
                Wartosci= Wartosci+","+str(wart)
            
            elif pole in ['czy_zewnetrzne','czy_obowiazkowe']:
                Pola= Pola+","+pole
                Wartosci= Wartosci+","+str(wart)

    if len(pola)>1:
        upd = upd+" ("+Pola[1:]+") = ("+Wartosci[1:]+")" + WHERE
    elif len(pola) == 1:
        upd = upd+" "+Pola[1:]+" = "+Wartosci[1:]+"" + WHERE

    if len(pola)>0:
        stat,d,dump,dump = self.PolSQL.Execute(upd,1)        
        if stat != 'OK':
            stat = 'Bd aktualizacji danych szkolenia : '+stat
            dane.append(stat)


#-------------------------------------------------------------------------------
#--- POBRANIE DANYCH ( 5-select, 3 -update z pobraniem)
#-------------------------------------------------------------------------------

if Fun in (1,3,5,9) and stat=='OK':
    SELECT ="SELECT * FROM rs_szkolenia"
    SELECT+=" WHERE firma_id='"+self.firma_id+"' AND szkolenie_id='"+Szkolenie+"';"
    stat,dane,wyn1,dump = self.PolSQL.Execute(SELECT,3)    
    if stat != 'OK':
        stat = 'Bd pobrania danych szkolenia : '+stat
        dane.append(stat)

    if stat == 'OK':
        tr = rssql.RSTableRowset(dane,wyn1)

        # [0] nazwa_szkolenia
        if tr.GetVal(0,"szkolenie_id")<>'None':
            if (self.oddzial_id,'053000') in self.uprawnienia or self.operator_id == STANDARD_OPERATOR_ID:
                sql ="SELECT nazwa FROM rs_szkolenia"
                sql+=" WHERE firma_id='"+self.firma_id+"' AND szkolenie_id='"+tr.GetVal(0,"szkolenie_id")+"';"
                stat,d,dump,dump = self.PolSQL.Execute(sql, 3)
                if stat != 'OK':
                    wyn2.append('Bd pobrania opisu szkolenia : '+stat)
                else:
                    if len(d) == 0:
                        wyn2.append('Bdny kod projektw.')
                    else:
                        wyn2.append(d[0][0])
            else:
                wyn2.append('Brak uprawnie do sownika. Poinformuj administratora.')
        else:
            wyn2.append('')

        # [1] typ_szkolenie 
        if tr.GetVal(0,"typ_szkolenia")<>'None':
            if (self.oddzial_id,'011700') in self.uprawnienia or self.operator_id == STANDARD_OPERATOR_ID:
                sql ="SELECT opis FROM rs_szkolenia_typy"
                sql+=" WHERE firma_id='"+self.firma_id+"' AND kod='"+tr.GetVal(0,"typ_szkolenia")+"';"
                stat,d,dump,dump = self.PolSQL.Execute(sql, 3)
                if stat != 'OK':
                    wyn2.append('Bd pobrania opisu ze sownika typw szkole : '+stat)
                else:
                    if len(d) == 0:
                        wyn2.append('Bdny typ szkolenia.')
                    else:
                        wyn2.append(d[0][0])
            else:
                wyn2.append('Brak uprawnie do sownika. Poinformuj administratora.')
        else:
            wyn2.append('')

        # [2] projekt_id
        if tr.GetVal(0,"projekt_id")<>'None':
            if (self.oddzial_id,'027011') in self.uprawnienia or self.operator_id == STANDARD_OPERATOR_ID:
                sql ="SELECT nazwa FROM rs_projekty"
                sql+=" WHERE firma_id='"+self.firma_id+"' AND projekt_id='"+tr.GetVal(0,"projekt_id")+"';"
                stat,d,dump,dump = self.PolSQL.Execute(sql, 3)
                if stat != 'OK':
                    wyn2.append('Bd pobrania opisu projektu : '+stat)
                else:
                    if len(d) == 0:
                        wyn2.append('Bdny kod projektw.')
                    else:
                        wyn2.append(d[0][0])
            else:
                wyn2.append('Brak uprawnie do sownika. Poinformuj administratora.')
        else:
            wyn2.append('')