# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_kp_szkolenia_harmonogram_pracownicy.py
# Purpose:     obsluga grida edytowalnego ze list pracownikw
# Author:      Marcin Natkaski
# Created:     2012/08/31
# RCS-ID:      $Id: fs_kp_szkolenia_harmonogram_pracownicy.py$
# Copyright:   (c) 2010 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

stat='OK'

if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=='OK':
    Funkcja = klucze['Funkcja']
    
    SlPar={'Szkolenie':[1,5], 'Pracownik':[1,5], 'Data':[1,5], 'PracownikG':[8], 'PrzyczynaG':[9],
           'Godzina':[1,5],'Miejsce':[1,5]}    
    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Funkcja,klucze)
    if Lista<>'':
        stat='Uwaga : wywoanie funkcji fs_kp_szkolenia_harmonogram_pacownicy z numerem '+str(Funkcja)+' bez parametrw: '+Lista
        
    if Funkcja in (1,5): 
        Szkolenie=rsglobal.Dekoduj(klucze['Szkolenie'])
        Data=rsglobal.Dekoduj(klucze['Data'])
        Godzina=rsglobal.Dekoduj(klucze['Godzina'])
        Miejsce=rsglobal.Dekoduj(klucze['Miejsce'])
        Pracownik=rsglobal.Dekoduj(klucze['Pracownik'])
        
    if Funkcja == 8:
        PracownikG = rsglobal.Dekoduj(klucze['PracownikG'])
        
    if Funkcja == 9:
        PrzyczynaG = rsglobal.Dekoduj(klucze['PrzyczynaG'])
        
UprDodawanie = (((self.oddzial_id,'053003') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID))
UprEdycja = (((self.oddzial_id,'053002') in self.uprawnienia) or UprDodawanie or (self.operator_id == STANDARD_OPERATOR_ID))
UprUsuwanie = (((self.oddzial_id,'053004') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID))

#-------------------------------------------------------------------------------
#-------  POBRANIE OPISU STANOWISKA (8)
#-------------------------------------------------------------------------------

if Funkcja == 8 and stat == "OK":
    sql ="SELECT imie||' '||nazwisko FROM rs_kp_dane_osobowe "
    sql+=" WHERE firma_id='"+self.firma_id+"' AND pracownik_id='"+PracownikG+"';"
    stat,dane,dump,dump = self.PolSQL.Execute(sql,3)
    if stat <> 'OK':
        stat = 'Bd przy sprawdzaniu opisu pracownika: '+stat
        dane.append(stat)
        
#-------------------------------------------------------------------------------
#-------  POBRANIE OPISU NIEOBECNOSCI (9)
#-------------------------------------------------------------------------------

if Funkcja == 9 and stat == "OK":
    sql ="SELECT opis FROM rs_rodzaje_nieobecnosci "
    sql+=" WHERE firma_id='"+self.firma_id+"' AND kod='"+PrzyczynaG+"';"
    stat,dane,dump,dump = self.PolSQL.Execute(sql,3)
    if stat <> 'OK':
        stat = 'Bd przy sprawdzaniu opisu przyczyny nieobecnosci: '+stat
        dane.append(stat)

#-------------------------------------------------------------------------------
#-------  SPRAWDZANIE DELETE  (1)
#-------------------------------------------------------------------------------

if Funkcja == 1 and stat=="OK":
    Delete=klucze['Delete']
    if len(Delete[0])>0:
        if not UprUsuwanie:
            stat='BR UPR DEL'
            dane.append(stat)
        
        # wykonanie DELETE 
        if stat == 'OK':
            SQLDEL = ''
            SQLFU = ''
            for i in xrange(len(Delete[0])):
                SQLFU+= "SELECT szkolenie_id FROM rs_szkolenia_harmonogram_pracownicy"
                SQLFU+=" WHERE firma_id='"+self.firma_id+"' AND szkolenie_id='"+Szkolenie+"' AND data='"+Data+"' AND miejsce='"+Miejsce+"' AND godzina='"+Godzina+"'"
                DELETE = "DELETE FROM rs_szkolenia_harmonogram_pracownicy "
                WHERE = "WHERE firma_id='"+self.firma_id+"' AND szkolenie_id='"+Szkolenie+"' AND data='"+Data+"' AND miejsce='"+Miejsce+"' AND godzina='"+Godzina+"' "
                for j in xrange(len(Delete[0][i])):
                    pole = Delete[1][j]
                    wart = Delete[0][i][j]
                    if pole in ['pracownik_id',]:
                        WHERE += " AND "+pole+"='"+wart+"'"
                        SQLFU += " AND "+pole+"='"+wart+"'"
                        
                SQLDEL += DELETE+WHERE+"; "
                SQLFU += " FOR UPDATE NOWAIT; "

            if SQLFU <> '':
                stat,d,dump,dump = self.PolSQL.Execute(rsglobal.Dekoduj(SQLFU),3)
                if stat <> 'OK':
                    stat = 'Bd sprawdzenia danych do usunicia: '+stat
                    dane.append(stat)

            if stat == "OK" and SQLDEL <> '':
                stat,dump,dump,dump = self.PolSQL.Execute(rsglobal.Dekoduj(SQLDEL),1)
                if stat <> 'OK':
                    stat = "Bd przy usuwaniu danych: "+stat   
                    dane.append(stat)

#-------------------------------------------------------------------------------
#---   UPDATE DANYCH (1)
#-------------------------------------------------------------------------------

if Funkcja == 1 and stat=="OK":
    Update=klucze['Update']

    if len(Update[0])>0:
        if not UprEdycja:
            stat='BR UPR UPD'
            dane.append(stat)

        if stat == 'OK':
            SQLFU = ''
            for i in xrange(len(Update[0])):
                SQLFU+= "SELECT szkolenie_id FROM rs_szkolenia_harmonogram_pracownicy"
                SQLFU+=" WHERE firma_id='"+self.firma_id+"' AND szkolenie_id='"+Szkolenie+"' AND data='"+Data+"' AND miejsce='"+Miejsce+"' AND godzina='"+Godzina+"'"

                for j in xrange(len(Update[2][i])): # petla po kluczu
                    pole = Update[3][j]
                    wart = rsglobal.Dekoduj(Update[2][i][j])
                    SQLFU += " AND "+pole+"='"+wart+"'"                        
                SQLFU += " FOR UPDATE NOWAIT; "
            
            if SQLFU <> '':
                stat,d,dump,dump = self.PolSQL.Execute(rsglobal.Dekoduj(SQLFU),3)
                if stat <> 'OK':
                    stat = 'Bd sprawdzenia danych do modyfikacji: '+stat
                    dane.append(stat)

        if stat == 'OK':
            WierszeNr = Update[-1]
            for i in xrange(len(Update[0])):
                for j in xrange(len(Update[0][i])): 
                    pole=Update[0][i][j]
                    wart=Update[1][i][j]
                    
                    if pole == 'pracownik_id':
                        if wart == '':
                            stat = 'BR PRAC'
                            wyn2.append((WierszeNr[i],0))
                            dane.append(stat)
                        else:
                            sql ="SELECT pracownik_id FROM rs_kp_dane_osobowe"
                            sql+=" WHERE firma_id = '"+self.firma_id+"'"
                            sql+=" AND pracownik_id = '"+str(wart)+"';" 
                            stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                            if stat <> 'OK':
                                stat = 'BL SQL PRAC'
                                wyn2.append((WierszeNr[i],0))
                                dane.append(stat)
                            elif len(d) == 0:
                                stat = 'BL PRAC'
                                wyn2.append((WierszeNr[i],0))
                                dane.append(stat)

                    elif pole == 'rodzaj_nieobecnosci':
                        wart = wart.strip() 
                        if wart=='':
                            wart='NULL'
                        else:                       
                            sql ="SELECT kod FROM rs_rodzaje_nieobecnosci"
                            sql+=" WHERE firma_id = '"+self.firma_id+"'"
                            sql+=" AND kod = '"+str(wart)+"';"
                            stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                            if stat <> 'OK':
                                stat = 'BL SQL RODZ'
                                wyn2.append((WierszeNr[i],3))
                                dane.append(stat)
                            elif len(d)==0:
                                stat = 'BR RODZ'
                                wyn2.append((WierszeNr[i],3))
                                dane.append(stat)
 
        if stat == 'OK':
            if len(dane) > 0:
                stat = dane[0]
                
        # wykonanie UPDATE
        if stat=='OK':
            sql=''
            for i in xrange(len(Update[0])):
                UPDATE="UPDATE rs_szkolenia_harmonogram_pracownicy "
                SET='SET '
                for j in xrange(len(Update[0][i])): 
                    pole=Update[0][i][j]
                    wart=Update[1][i][j]
                    if pole in ['pracownik_id']:
                        SET+=pole+"='"+wart+"',"
                    elif pole in ['obecny']:
                        SET+=pole+"="
                        if wart == 0:
                            SET+="FALSE ,"
                        else:
                            SET+="TRUE ,"
                    elif pole in ['rodzaj_nieobecnosci']:
                        SET+=pole+"="
                        if wart =='':
                            SET+='NULL ,' 
                        else:
                            SET+="'"+wart+"' ,"
                SET=SET.strip(",")
                WHERE=" WHERE firma_id='"+self.firma_id+"' AND szkolenie_id='"+Szkolenie+"' AND data='"+Data+"' AND miejsce='"+Miejsce+"' "
                WHERE+=" AND godzina='"+Godzina+"'" 
                for j in xrange(len(Update[2][i])): # petla po kluczu
                    pole=Update[3][j]
                    wart=rsglobal.Dekoduj(Update[2][i][j])
                    if pole in ['pracownik_id']:
                        WHERE+=" AND "+pole+"='"+wart+"'"
                WHERE+=";"    
                sql+=UPDATE+SET+WHERE;
            if sql<>'':
                stat,dump,dump,dump=self.PolSQL.Execute(rsglobal.Dekoduj(sql),1)
                if stat<>'OK':
                    stat="Bd przy modyfikowaniu danych: "+stat   
                    dane.append(stat)  

#-------------------------------------------------------------------------------
#---------INSERT DANYCH (1)
#-------------------------------------------------------------------------------

if Funkcja == 1 and stat=="OK":
    Insert=klucze['Insert']
    if len(Insert[0])>0:
        if not UprDodawanie:
            stat='BR UPR INS'
            dane.append(stat)

        if stat == 'OK':
            WierszeNr = Insert[-1]
            for i in xrange(len(Insert[0])):
                PracownikNowy = None
                for j in xrange(len(Insert[0][i])): 
                    pole=Insert[1][j]
                    wart=Insert[0][i][j]
                    if pole == 'pracownik_id':
                        if wart == '':
                            stat = 'BR PRAC'
                            wyn2.append((WierszeNr[i],0))
                            dane.append(stat)
                        else:
                            PracownikNowy=wart.strip()
                            sql ="SELECT pracownik_id FROM rs_kp_dane_osobowe"
                            sql+=" WHERE firma_id = '"+self.firma_id+"'"
                            sql+=" AND pracownik_id = '"+str(wart)+"';" 
                            stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                            if stat <> 'OK':
                                stat = 'BL SQL PRAC'
                                wyn2.append((WierszeNr[i],0))
                                dane.append(stat)
                            elif len(d) == 0:
                                stat = 'BL PRAC'
                                wyn2.append((WierszeNr[i],0))
                                dane.append(stat)
    
                    elif pole == 'rodzaj_nieobecnosci':
                        if wart<>'':
                            sql ="SELECT kod FROM rs_rodzaje_nieobecnosci"
                            sql+=" WHERE firma_id = '"+self.firma_id+"'"
                            sql+=" AND kod = '"+str(wart)+"';"
                            stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                            if stat <> 'OK':
                                stat = 'BL SQL RODZ'
                                wyn2.append((WierszeNr[i],3))
                                dane.append(stat)
                            elif len(d)==0:
                                stat = 'BR RODZ'
                                wyn2.append((WierszeNr[i],3))
                                dane.append(stat)
                                
                #sprawdzam przed dodawaniem, czy podany klucz ju istnieje,
                #bo operator moze miec na gridzie filtr i nie widziec,
                #ze podany (choc dozwolony) klucz juz istnieje
                if len(dane) == 0 and Pracownik <> None and stat=='OK':
                    sql ="SELECT szkolenie_id FROM rs_szkolenia_harmonogram_pracownicy"
                    sql+=" WHERE firma_id='"+self.firma_id+"' AND szkolenie_id='"+Szkolenie+"'"
                    sql+=" AND data='"+Data+"' AND miejsce='"+Miejsce+"'"
                    sql+=" AND godzina='"+Godzina+"' AND pracownik_id='"+Pracownik+"';"
                    stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                    if stat <> 'OK':
                        stat = 'BL SQL KLUCZ'+stat
                        dane.append(stat)
                        wyn2.append((WierszeNr[i],0))
                        wyn2.append((WierszeNr[i],2))
                    elif len(d) > 0:
                        stat = 'BL KLUCZ IST'
                        dane.append(stat)
                        wyn2.append((WierszeNr[i],0))
                        wyn2.append((WierszeNr[i],2))

        if stat == 'OK':
            if len(dane) > 0:
                stat = dane[0]
                                                        
        # wykonanie INSERT
        if stat == 'OK':    
            sqlIns=''
            for i in xrange(len(Insert[0])):
                INSERT="INSERT INTO rs_szkolenia_harmonogram_pracownicy "
                KOLUMNY="(firma_id, szkolenie_id,data,godzina,miejsce"
                VALUES=" VALUES ('"+self.firma_id+"','"+Szkolenie+"','"+Data+"','"+Godzina+"','"+Miejsce+"' "
                for j in xrange(len(Insert[0][i])):
                    pole=Insert[1][j]
                    wart=Insert[0][i][j]
                    if pole in ['pracownik_id']:
                        KOLUMNY+=","+pole
                        VALUES+=",'"+wart+"'"
                    elif pole in ['obecny']:
                        KOLUMNY+=","+pole
                        if wart == 0:
                            VALUES+=",FALSE"
                        else:
                            VALUES+=",TRUE"
                    elif pole in ['rodzaj_nieobecnosci']:
                        KOLUMNY+=","+pole
                        if wart in ['',None] :
                            VALUES+=",NULL"
                        else:
                            VALUES+=",'"+wart+"'"                        
                KOLUMNY+=")"
                VALUES+=");"
                sqlIns+=INSERT+KOLUMNY+VALUES
            if sqlIns<>'': 
                stat,dump,dump,dump=self.PolSQL.Execute(rsglobal.Dekoduj(sqlIns),1)
                if stat<>'OK':
                    stat="Bd przy dodawaniu danych: "+stat   
                    dane.append(stat)                   

#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (1- insert 1 -select, 1 -delete)
#-------------------------------------------------------------------------------

if Funkcja in (1,5) and stat=='OK':
    SQL ="SELECT szhp.pracownik_id, da.imie||' '||da.nazwisko, szhp.obecny, COALESCE(szhp.rodzaj_nieobecnosci,''), COALESCE(pn.opis,'')"
    SQL+=" FROM rs_szkolenia_harmonogram_pracownicy szhp"
    SQL+=" INNER JOIN rs_kp_dane_osobowe da USING (firma_id, pracownik_id)"
    SQL+=" LEFT JOIN rs_rodzaje_nieobecnosci pn ON (szhp.firma_id=pn.firma_id AND szhp.rodzaj_nieobecnosci=pn.kod)"
    SQL+=" WHERE szhp.firma_id='"+self.firma_id+"' AND szhp.szkolenie_id='"+Szkolenie+"' "
    SQL+=" AND szhp.data='"+Data+"' AND szhp.godzina='"+Godzina+"' AND miejsce='"+Miejsce+"'"
    if Pracownik <>'':
        SQL+=" AND szhp.pracownik_id ='"+Pracownik+"' "
    SQL+=" ORDER BY szhp.pracownik_id;"
    stat,dane,wyn1,wyn2 = self.PolSQL.Execute(SQL,3)
    if stat <> 'OK':
        stat = "Bd przy pobieraniu danych: "+stat
        dane.append(stat)