
# -*- coding: iso8859_2 -*-

#-----------------------------------------------------------------------------
# Name:        fs_kp_szkolenia_pliki.py
# Purpose:     wyswietla, dodaje, usuwa z bazy danych informacje o 
#              zalacznikach do wersji szkole                                
# Author:      Marcin Natkaski
# Created:     2012/07/24
# RCS-ID:      $Id: fs_kp_szkolenia_pliki.py $
# Copyright:   (c) 2012 Record System
# Licence:     GNU GPL
#-----------------------------------------------------------------------------

from funkcje import fs_pliki_global

dane = []
wyn1 = []
wyn2 = []
stat = 'OK'
NUMERPLIKU=0

if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=='OK':
    Fun = klucze['Funkcja']
    
    SlPar={'Szkolenie':[1,2,5,6],'Wersja':[1,2,5,6],'NazwaPliku':[1],'TrescPliku':[1],
    'Numer':[2,6]}    
    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Fun,klucze)
    if Lista<>'':
        stat='Uwaga : wywoanie funkcji fs_kp_szkolenia_pliki z numerem '+str(Fun)+' bez parametrw: '+Lista

if stat=='OK':
    if Fun in [1,2,5,6]:
        Szkolenie=rsglobal.Dekoduj(klucze['Szkolenie'])
        Wersja=rsglobal.Dekoduj(klucze['Wersja'])
    if Fun in [2,6]:    
        Numer=rsglobal.Dekoduj(klucze['Numer'])
    if Fun in [1]:
        NazwaPliku=rsglobal.Dekoduj(klucze['NazwaPliku'])
        TrescPliku=rsglobal.Dekoduj(klucze['TrescPliku'])

#-------------------------------------------------------------------------------
#---   SPRAWDZENIE UPRAWNIE/POPRAWNOCI DANYCH
#-------------------------------------------------------------------------------

UprIns=((self.oddzial_id,'053103') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)
UprDel=((self.oddzial_id,'053104') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)

if Fun == 1 :
    if not UprIns:
        stat='UPR INS'

if Fun == 6 :
    if not UprDel:
        stat='UPR DEL'

if stat=='OK':
    #sprawdzenie poprawnoci szkolenia
    SQL="SELECT szkolenie_id FROM rs_szkolenia WHERE firma_id='"+self.firma_id+"' AND szkolenie_id = '"+str(Szkolenie)+"'"
    stat,DTest,dump,dump = self.PolSQL.Execute(SQL,3)
if stat=='OK':
    if len(DTest)==0:
        stat='BR SZ'
    #wyznaczanie nr_pliku w rs_szkolenia_pliki    
if Fun == 1 and stat=='OK':
    SQL="SELECT max(nr_poz) FROM rs_szkolenia_pliki WHERE firma_id='"+self.firma_id+"' AND szkolenie_id = '"+str(Szkolenie)+"' AND wersja='"+str(Wersja)+"' ;"
    stat,DNRPOZ,dump,dump = self.PolSQL.Execute(SQL,3)
    if stat=='OK':    
        if DNRPOZ[0][0]<1:
            NUMERPLIKU=1
        else:
            NUMERPLIKU=DNRPOZ[0][0]+1
    else:
        stat='Bd wyznaczania numeru pliku'
      
#-------------------------------------------------------------------------------
#---   INSERT DANYCH (1)
#-------------------------------------------------------------------------------
    
if Fun==1:
    if stat=='OK':
        #wstawiamy plik do bazy
        SQL="INSERT INTO rs_szkolenia_pliki (firma_id,szkolenie_id,wersja,nr_poz) "
        SQL+= " VALUES ( '"+self.firma_id+"','"+Szkolenie+"','"+str(Wersja)+"','"+str(NUMERPLIKU)+"');"
        stat,dump,dump,dump = self.PolSQL.Execute(SQL,1)
        # wstawienie pustego rekordu do rs_pliki, potem pobranie numeru i poczenie klucza z obu tabel.
    if stat=='OK':
        SQL="INSERT INTO rs_pliki (firma_id,nazwa,tabela,kompresja) VALUES "
        SQL+="('"+self.firma_id+"','"+NazwaPliku+"','rs_szkolenia_pliki',FALSE);"
        stat,dump,dump,dump = self.PolSQL.Execute(SQL,1)
    if stat=='OK':
        SQL="SELECT max(plik_id) FROM rs_pliki WHERE firma_id='"+self.firma_id+"' AND tabela='rs_szkolenia_pliki';"
        stat,DNum,dump,dump = self.PolSQL.Execute(SQL,3)
    if stat=='OK':
        NrPliku=str(DNum[0][0])
        #wrzucamy plik na serwer
        stat=fs_pliki_global.WstawPlikNaSerwer(self.KatalogPlikow,NrPliku,TrescPliku)
    if stat=='OK':
        SQL="UPDATE rs_szkolenia_pliki SET plik_id="+NrPliku+" WHERE firma_id='"+self.firma_id+"' "
        SQL+=" AND szkolenie_id = '"+Szkolenie+"' AND wersja='"+str(Wersja)+"' AND nr_poz='"+str(NUMERPLIKU)+"' "
        stat,dump,dump,dump = self.PolSQL.Execute(SQL,1)
       
#-------------------------------------------------------------------------------
#---   POBRANIE PLIKU Z SERWERA (2,6)
#-------------------------------------------------------------------------------
    
if Fun in [2,6]:
    if stat=='OK':
        SQL="SELECT plik_id FROM rs_szkolenia_pliki WHERE firma_id='"+self.firma_id+"' "
        SQL+=" AND szkolenie_id = '"+Szkolenie+"' AND wersja='"+str(Wersja)+"' AND nr_poz='"+str(Numer)+"' "
        stat,DPlik,dump,dump = self.PolSQL.Execute(SQL,3)
        
    if stat=='OK':
        if len(DPlik)==0:
            stat="Plik nie istnieje"
 
#-------------------------------------------------------------------------------
#---   PLIK POBIERANY DO KLIENTA (2)
#-------------------------------------------------------------------------------
 
if Fun==2:   
    if stat=='OK':
        stat,Tresc=fs_pliki_global.PobierzPlikZSerwera(self.KatalogPlikow,DPlik[0][0])
        dane=[Tresc]    
                
#-------------------------------------------------------------------------------
#---   DELETE DANYCH (6)
#-------------------------------------------------------------------------------

if Fun == 6 :
    if stat=='OK':
        stat=fs_pliki_global.UsunPlikZSerwera(self.KatalogPlikow,DPlik[0][0])
        
    if stat=='OK':    
        stat,dump,dump,dump = self.PolSQL.Execute("DELETE FROM rs_szkolenia_pliki WHERE plik_id='"+str(DPlik[0][0])+"';" ,1)
  
#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (5 -select, 6 -delete)
#-------------------------------------------------------------------------------

if (Fun in [1,5,6]) and (stat=='OK'):
    SQL="SELECT sz.nr_poz, p.nazwa FROM rs_szkolenia_pliki sz INNER JOIN rs_pliki p "  
    SQL+=" USING (firma_id,plik_id)"
    SQL+=" WHERE firma_id='"+self.firma_id+"' AND szkolenie_id = '"+str(Szkolenie)+"' AND wersja='"+str(Wersja)+"'; "    
    stat,dane,wyn1,tr = self.PolSQL.Execute(SQL,3)