
# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_kp_typy_informacji.py
# Purpose:     obsluga grida edytowalnego z sekcjami cech artykuw
# Author:      Marcin Natkaski
# Created:     2014/08/01
# RCS-ID:      $Id: fs_kp_typy_informacji
# Copyright:   (c) 2014 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

stat='OK'

if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=='OK':
    Funkcja = klucze['Funkcja']

if Funkcja == 6:
    TypId = klucze['TypId']
        
dane = []
wyn1 = []
wyn2 = []
SprawdzacDlugosc=False

UprIns=self.operator_id == STANDARD_OPERATOR_ID
UprUpd=self.operator_id == STANDARD_OPERATOR_ID or UprIns
UprDel=self.operator_id == STANDARD_OPERATOR_ID


#-------------------------------------------------------------------------------
#-------- EDYCJA GRIDA EDYTOWALNEGO (1)
#-------------------------------------------------------------------------------

Insert = []
Update = []
Delete = []

if Funkcja == 1:
    Update=klucze['Update']
    Insert=klucze['Insert']
    Delete=klucze['Delete']


#-------------------------------------------------------------------------------
#-------  SPRAWDZANIE DELETE  --------------------------------------------------
#-------------------------------------------------------------------------------

if Funkcja == 1 and stat=="OK":
    if len(Delete[0])>0:
        if not UprDel:
            stat='BR UPR DEL'
            dane.append(stat)
        
        # wykonanie DELETE 
        if stat == 'OK':
            SQLDEL = ''
            SQLDELWART = ''
            SQLFU = ''
            for i in xrange(len(Delete[0])):
                SQLFU = "SELECT typ_id FROM rs_kp_typy_informacji WHERE firma_id='"+self.firma_id+"'"
                DELETE = "DELETE FROM rs_kp_typy_informacji "
                DELETEWART = "DELETE FROM rs_kp_typy_informacji_pozycje "
                WHERE = "WHERE firma_id='"+self.firma_id+"'"
                
                for j in xrange(len(Delete[0][i])):
                    pole = Delete[1][j]
                    wart = Delete[0][i][j]
                    if pole in ['typ_id']:
                        pole_typ =wart
                        WHERE += " AND "+pole+"='"+str(wart)+"'"
                        SQLFU += " AND "+pole+"='"+str(wart)+"'"
                
                SQLDEL += DELETE+WHERE+"; "
                SQLDELWART += DELETEWART+WHERE+"; "
                SQLFU += " FOR UPDATE NOWAIT; "
            #Sprawdzamy czy mona usuwa typ informacji    
            if stat == 'OK':
                CzyEdytowacSQL = "SELECT typ_id FROM rs_kp_dane_osobowe_dane_dodatkowe "
                CzyEdytowacSQL+= " WHERE firma_id='"+self.firma_id+"' AND typ_id='"+pole_typ+"';"
                stat,d,dump,dump = self.PolSQL.Execute(rsglobal.Dekoduj(CzyEdytowacSQL),3)
                if stat<>'OK':
                    stat='Bd sprawdzania moliwoci usuwania typu'
                elif len(d)>0:
                    stat='Nie mona usuwa typu '+pole_typ+', poniewa typ jest ju wykorzystywany'
                    dane.append(stat)
                    
            if stat=='OK' and SQLFU <> '':
                stat,d,dump,dump = self.PolSQL.Execute(rsglobal.Dekoduj(SQLFU),3)
                if stat <> 'OK':
                    stat = 'Bd sprawdzenia danych do usunicia: '+stat
                    dane.append(stat)
            
            if stat == 'OK' and SQLDEL <> '':
                stat,dump,dump,dump = self.PolSQL.Execute(rsglobal.Dekoduj(SQLDEL),1)
                if stat <> 'OK':
                    stat = "Bd przy usuwaniu danych: "+stat   
                                    
            if stat == 'OK' and SQLDELWART <> '':
                stat,dump,dump,dump = self.PolSQL.Execute(rsglobal.Dekoduj(SQLDELWART),1)
                if stat <> 'OK':
                    stat = "Bd przy usuwaniu danych: "+stat 
                    
    
#-------------------------------------------------------------------------------
#---   UPDATE DANYCH (1)
#-------------------------------------------------------------------------------

if Funkcja == 1 and stat=="OK":
    if len(Update[0])>0:
        if not UprUpd:
            stat='BR UPR UPD'
            dane.append(stat)

        if stat == 'OK':
            obecnelp=[]
            SQLFU = ''
            for i in xrange(len(Update[0])):
                SQLFU = "SELECT typ_id FROM rs_kp_typy_informacji WHERE firma_id='"+self.firma_id+"'"
                for j in xrange(len(Update[2][i])): # petla po kluczu
                    pole = Update[3][j]
                    wart = rsglobal.Dekoduj(Update[2][i][j])
                    if pole == 'typ_id':
                        SQLFU += " AND "+pole+"='"+str(wart)+"'"
                
                SQLFU += " FOR UPDATE NOWAIT; "
                if SQLFU <> '':
                    stat,d,dump,dump = self.PolSQL.Execute(rsglobal.Dekoduj(SQLFU),3)
                    if stat <> 'OK':
                        stat = 'Bd sprawdzenia danych do modyfikacji: '+stat
                        dane.append(stat)
                    else:
                        obecnelp.append(d[0][0])
                    
        if stat == 'OK':
            istnieje=[]
            SQLFU = ''
            for i in xrange(len(Update[0])):
                SQLFU = "SELECT typ_id FROM rs_kp_typy_informacji_pozycje WHERE firma_id='"+self.firma_id+"'"
                for j in xrange(len(Update[2][i])): # petla po kluczu
                    pole = Update[3][j]
                    wart = rsglobal.Dekoduj(Update[2][i][j])
                    if pole == 'typ_id':
                        SQLFU += " AND "+pole+"='"+str(wart)+"'"
                
                SQLFU += " FOR UPDATE NOWAIT; "
                if SQLFU <> '':
                    stat,da,dump,dump = self.PolSQL.Execute(rsglobal.Dekoduj(SQLFU),3)
                    if stat <> 'OK':
                        stat = 'Bd sprawdzenia danych do modyfikacji: '+stat
                        dane.append(stat)
            
        if stat == 'OK':
            WierszeNr = Update[-1]
            for i in xrange(len(Update[0])):
                for j in xrange(len(Update[0][i])): 
                    pole = Update[0][i][j]
                    wart = Update[1][i][j]
                    if pole == 'typ_id':
                        if len(wart)>5:
                            wyn2.append((WierszeNr[i],0))
                            dane.append('LP UJ')
                        if wart == '':
                            wyn2.append((WierszeNr[i],0))
                            dane.append('BR TYP')

                    if pole == 'nazwa':
                        if len(wart) > 30:
                            wyn2.append((WierszeNr[i],0))
                            dane.append('BL Nazwa')
                        if wart == '':
                            wyn2.append((WierszeNr[i],0))
                            dane.append('BR Nazwa')


        if stat == 'OK':
            if len(dane) > 0:
                stat = dane[0]
                
        # wykonanie UPDATE
        if stat=='OK':
            sql=''
            sqlwart=''
            SETWART=''
            for i in xrange(len(Update[0])):
                UPDATE="UPDATE rs_kp_typy_informacji "
                UPDATEWART="UPDATE rs_kp_typy_informacji_pozycje "
                SET='SET '
                for j in xrange(len(Update[0][i])): 
                    pole=Update[0][i][j]
                    wart=Update[1][i][j]
                    if pole in ['typ_id']:
                        SET+=pole+"='"+str(wart)+"'"
                        SETWART=pole+"='"+str(wart)+"'"
                    elif pole in ['nazwa']:
                        SET+=pole+"='"+str(wart)+"'"
                SET=SET.strip(",")
                WHERE=" WHERE firma_id='"+self.firma_id+"'"
                for j in xrange(len(Update[2][i])): # petla po kluczu
                    pole=Update[3][j]
                    wart=rsglobal.Dekoduj(Update[2][i][j])
                    if pole in ['typ_id']:
                        CzyEdytowacSQL = "SELECT typ_id FROM rs_kp_dane_osobowe_dane_dodatkowe "
                        CzyEdytowacSQL+= " WHERE typ_id='"+wart+"';"
                        stat,d,dump,dump = self.PolSQL.Execute(rsglobal.Dekoduj(CzyEdytowacSQL),3)
                        if stat<>'OK':
                            stat='Bd sprawdzania moliwoci edytowania typu'
                        elif len(d)>0:
                            stat='Nie mona modyfikowac typu '+wart+', poniewa typ jest ju wykorzystywany'
                            dane.append(stat)
                        else:
                            WHERE+= " AND "+pole+"='"+str(wart)+"'"

                WHERE+=";"
                sql+=UPDATE+SET+WHERE;
                
                if stat=='OK' and SETWART <> '':
                    sqlwart+=UPDATEWART+"SET "+SETWART+WHERE+";"
                    
            if stat=='OK' and sql<>'':
                stat,dump,dump,dump=self.PolSQL.Execute(rsglobal.Dekoduj(sql),1)
                if stat<>'OK':
                    stat="Bd przy modyfikowaniu danych: "+stat   
                    
            if stat=='OK' and sqlwart<>'':
                stat,dump,dump,dump=self.PolSQL.Execute(rsglobal.Dekoduj(sqlwart),1)
                if stat<>'OK':
                    stat="Bd przy modyfikowaniu danych 2: "+stat 


#-------------------------------------------------------------------------------
#---------Sprawdzanie danych do Insert------
#-------------------------------------------------------------------------------

if Funkcja == 1 and stat=="OK":
    if len(Insert[0])>0:
        if not UprIns:
            stat='BR UPR INS'
            dane.append(stat)
            
        if stat == 'OK':
            obecnelp=[]
            SQLFU = ''
            for i in xrange(len(Insert[0])):
                SQLFU = "SELECT typ_id FROM rs_kp_typy_informacji WHERE firma_id='"+self.firma_id+"'"
                for j in xrange(len(Insert[0][i])): # petla po kluczu
                    pole = Insert[1]
                    wart = rsglobal.Dekoduj(Insert[0][i])
                    if pole == 'typ_id':
                       SQLFU += " AND "+pole+"="+str(wart)
                
                SQLFU += " FOR UPDATE NOWAIT; "
                if SQLFU <> '':
                    stat,d,dump,dump = self.PolSQL.Execute(rsglobal.Dekoduj(SQLFU),3)
                    if stat <> 'OK':
                        stat = 'Bd sprawdzenia danych do modyfikacji: '+stat
                        dane.append(stat)

            for i in xrange(len(Insert[0])):
                WierszeNr = Insert[-1]
                for j in xrange(len(Insert[0][i])): 
                    
                    pole=Insert[1][j]
                    wart=Insert[0][i][j]
                    if pole == 'typ_id':
                        if len(wart) > 5:
                            wyn2.append((WierszeNr[i],0))
                            dane.append('LP UJ')
                        elif wart == '':
                            wyn2.append((WierszeNr[i],0))
                            dane.append('BR TYP')

                    if pole == 'nazwa':
                        if len(wart) > 30:
                            wyn2.append((WierszeNr[i],0))
                            dane.append('BL Nazwa')
                        if wart == '':
                            wyn2.append((WierszeNr[i],0))
                            dane.append('BR Nazwa')


        if stat == 'OK':
            if len(dane) > 0:
                stat = dane[0]

        # wykonanie INSERT
        if stat == 'OK':
            sqlIns=''
            for i in xrange(len(Insert[0])):
                INSERT="INSERT INTO rs_kp_typy_informacji "
                KOLUMNY="(firma_id"
                VALUES=" VALUES ('"+self.firma_id+"'"
                for j in xrange(len(Insert[0][i])):
                    pole=Insert[1][j]
                    wart=Insert[0][i][j]
                    
                    KOLUMNY+=","+pole
                    if pole in ['typ_id']:
                        
                        VALUES+=",'"+rsglobal.Dekoduj(wart)+"'"
                    elif pole in ['nazwa']:
                        VALUES+=",'"+rsglobal.Dekoduj(wart)+"'"

                KOLUMNY+=")"
                VALUES+=");"
                sqlIns+=INSERT+KOLUMNY+VALUES
            if sqlIns<>'': 
                stat,dump,dump,dump=self.PolSQL.Execute(rsglobal.Dekoduj(sqlIns),1)
                if stat<>'OK':
                    stat="Bd przy dodawaniu danych: "+stat

#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (1- insert 1 -select, 1 -delete, 5 - select)
#-------------------------------------------------------------------------------

if Funkcja in (1,5) and stat=='OK':
    SQL ="SELECT typ_id,nazwa FROM rs_kp_typy_informacji"
    SQL+=" WHERE firma_id='"+self.firma_id+"' ORDER BY typ_id;"
    stat,dane,wyn1,wyn2 = self.PolSQL.Execute(SQL,3)
    if stat <> 'OK':
        stat = "Bd przy pobieraniu danych: "+stat


#-------------------------------------------------------------------------------
#---   Sprawdzanie czy posiada pozycje
#-------------------------------------------------------------------------------

if Funkcja==6 and stat=='OK':
    SQL ="SELECT * FROM rs_kp_typy_informacji_pozycje "
    SQL+="WHERE firma_id='"+self.firma_id+"' AND typ_id='"+TypId+"';"
    stat,dane,wyn1,wyn2 = self.PolSQL.Execute(SQL,3)
    if stat <> 'OK':
        stat = "Bd sprawdzania posiadania pozycji: "+stat