# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_kp_umowy_umowy_o_prace.py
# Purpose:     obsluga grida z umowami o prace dla pracownika
#
# Author:      Mariusz Rajfura
# Created:     2009/09/16
# RCS-ID:      $Id: fs_kp_umowy_o_prace.py $
# Copyright:   (c) 2009 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------
# 2017-03-03 (10290)Piotr Witkowski - Zmiany w oknie Zatrudnienie - umowy

Pracownik = rsglobal.Dekoduj(klucze[0])
Zatrudnienie = klucze[1]
Umowa = klucze[2]
UmowaF = klucze[3][0]
RodzajUmowyF = rsglobal.Dekoduj(klucze[3][1]).strip()
OdKiedyF = rsglobal.Dekoduj(klucze[3][2])
DoKiedyF = rsglobal.Dekoduj(klucze[3][3])
Klucze_Id = klucze[4]

Fun = klucze[-1]
dane = []
wyn1 = []
stat = 'OK'

sql ="SELECT rsf_kadry_dozwolony_modul('"+self.firma_id+"','"+str(self.operator_id)+"','umowy_o_prace','"+Pracownik+"');"
stat,d,dump,dump = self.PolSQL.Execute(sql,3)
if stat == 'OK':
    stat = d[0][0]

UprUsuwanie = ((self.oddzial_id,'052034') in self.uprawnienia or self.operator_id == STANDARD_OPERATOR_ID)


#-------------------------------------------------------------------------------
# Pobranie daty plus 1 dzie z ostatniej umowy tego samego zatrudnienia
#-------------------------------------------------------------------------------

if stat == 'OK' and Fun == 10:
    sql = "SELECT do_kiedy + integer '1' FROM rs_kp_umowy_o_prace"
    sql += " WHERE firma_id = '" + self.firma_id + "' AND pracownik_id = '" + Pracownik + "'"
    sql += " AND zatrudnienie_id = " + str(Zatrudnienie) + " AND do_kiedy IS NOT NULL"
    sql += " ORDER BY do_kiedy DESC LIMIT 1;"
    stat, dane, dump, dump = self.PolSQL.Execute(sql, 3)
    if stat <> 'OK':
        stat = 'Bd sprawdzenia daty do zatrudnienia poprzedniej umowy: ' + stat


#-------------------------------------------------------------------------------
#--- POBRANIE PODSTAWOWYCH DANYCH UMOWY O PRACE (9) - JESLI UMOWA=0 - OSTATNIA UMOWA
# zwraca : nr_umowy, rodzaj_umowy_id, opis_rodzaju_umowy, od_kiedy, do_kiedy
# od_kiedy_zus, do_kiedy_zus 
#-------------------------------------------------------------------------------

if stat == 'OK' and Fun == 9:
    if Zatrudnienie == 0:
        sql ="SELECT MAX(numer_id) FROM rs_kp_zatrudnienie"
        sql+=" WHERE firma_id = '"+self.firma_id+"' AND pracownik_id = '"+Pracownik+"';"
        stat,d,dump,dump = self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Bd sprawdzenia ostatniego numeru zatrudnienia : '+stat
        elif d[0][0] == 0:
            stat = 'Brak jakiegokolwiek zatrudnienia'
        else:
            Zatrudnienie = d[0][0]
    
    if stat == 'OK' and Umowa == 0:
        sql ="SELECT MAX(umowa_id) FROM rs_kp_umowy_o_prace"
        sql+=" WHERE firma_id = '"+self.firma_id+"' AND pracownik_id = '"+Pracownik+"'"
        sql+=" AND zatrudnienie_id = "+str(Zatrudnienie)+";"
        stat,d,dump,dump = self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Bd sprawdzenia ostatniego numeru umowy o prac : '+stat
        elif d[0][0] == 0:
            stat = 'Brak jakiejkolwiek umowy o prac'
        else:
            Umowa = d[0][0]

    if stat == 'OK' and Zatrudnienie > 0 and Umowa > 0:
        sql ="SELECT zatrudnienie_id,umowa_id,rodzaj_umowy_id,'',od_kiedy,do_kiedy,od_kiedy_zus, do_kiedy_zus  FROM rs_kp_umowy_o_prace"
        sql+=" WHERE firma_id = '"+self.firma_id+"' AND pracownik_id = '"+Pracownik+"'"
        sql+=" AND zatrudnienie_id = "+str(Zatrudnienie)+" AND umowa_id = "+str(Umowa)+";"
        stat,dane,dump,dump = self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Bd pobrania danych umowy_o_prace : '+stat
        else:
            RodzajUmowy = str(dane[0][2])
            RodzajUmowyOpis = ''
            if (self.oddzial_id,'011680') in self.uprawnienia or self.operator_id == STANDARD_OPERATOR_ID:
                sql = "SELECT opis FROM rs_umowy_rodzaj WHERE firma_id = '"+self.firma_id+"' AND kod = '"+RodzajUmowy+"';"
                stat,d,dump,dump = self.PolSQL.Execute(sql, 3)
                if stat <> 'OK':
                    RodzajUmowyOpis = 'Bd pobrania opisu ze sownika rodzaju umowy : '+stat
                else:
                    if len(d) == 0:
                        RodzajUmowyOpis = 'Bdny kod rodzaju umowy.'
                    else:
                        RodzajUmowyOpis = str(d[0][0])
            else:
                RodzajUmowyOpis = 'Brak uprawnie do sownika. Poinformuj administratora.'

            if stat == 'OK':
                dane[0][3] = RodzajUmowyOpis


#-------------------------------------------------------------------------------
#--- DELETE - 6
#-------------------------------------------------------------------------------

if stat == 'OK' and Fun == 6:
    if not UprUsuwanie:
        stat='Brak uprawnie do usuwania umw o prac.'

    if stat == 'OK':
        sql = "SELECT umowa_id FROM rs_kp_umowy_o_prace"
        sql+=" WHERE firma_id = '"+self.firma_id+"' AND pracownik_id = '"+Pracownik+"'"
        sql+=" AND zatrudnienie_id = "+str(Zatrudnienie)+" AND umowa_id = "+str(Umowa)+" FOR UPDATE NOWAIT;" 
        stat,d,dump,dump = self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Bd pobrania danych umowy o prac dla pracownika : '+stat
        elif len(d) == 0:
            stat = 'Brak umowy o podanym numerze : '+stat

        if stat == 'OK':
            sql ="SELECT MAX(umowa_id) FROM rs_kp_umowy_o_prace"
            sql+=" WHERE firma_id = '"+self.firma_id+"' AND pracownik_id = '"+Pracownik+"'"
            sql+=" AND zatrudnienie_id = "+str(Zatrudnienie)+";"
            stat,d,dump,dump = self.PolSQL.Execute(sql, 3)
            if stat <> 'OK':
                stat = 'Bd pobrania informacji o licie umw dla pracownika : '+stat
            elif d[0][0] > Umowa:
                stat = 'Usunicie niemoliwe. Mona usun tylko ostatni umow o prac.'

        if stat == 'OK':
            sql ="SELECT angaz_id FROM rs_kp_angaze"
            sql+=" WHERE firma_id = '"+self.firma_id+"' AND pracownik_id = '"+Pracownik+"'"
            sql+=" AND zatrudnienie_id = "+str(Zatrudnienie)+" AND umowa_id = "+str(Umowa)+";"
            stat,d,dump,dump = self.PolSQL.Execute(sql, 3)
            if stat <> 'OK':
                stat = 'Bd pobrania informacji o angaach dot. usuwanej umowy o prac dla pracownika : '+stat
            elif len(d) > 0:
                stat = 'Usunicie niemoliwe. Istniej angae do usuwanej umowy o prac ('+str(len(d))+').'

        if stat == 'OK':
            DELETE ="DELETE FROM rs_kp_umowy_o_prace"
            DELETE+=" WHERE firma_id = '"+self.firma_id+"' AND pracownik_id = '"+Pracownik+"'"
            DELETE+=" AND zatrudnienie_id = "+str(Zatrudnienie)+" AND umowa_id = "+str(Umowa)+";" 
            stat,dump,dump,dump = self.PolSQL.Execute(DELETE, 1)
            if stat <> 'OK':
                stat='Bd usuwania umowy o prac dla pracownika : '+stat

#-------------------------------------------------------------------------------
#---- SELECT - 5 Pobieranie listy umow dla pracownika
#-------------------------------------------------------------------------------

if stat == 'OK' and Fun in (5,6):
    FILTR ="(um.firma_id = '"+self.firma_id+"' AND um.pracownik_id = '"+Pracownik+"'"
    FILTR+=" AND um.zatrudnienie_id = "+str(Zatrudnienie)
    if UmowaF > 0:
        FILTR += " AND um.umowa_id = "+str(UmowaF)
    if RodzajUmowyF <> '':
        FILTR += " AND um.rodzaj_umowy_id = '"+RodzajUmowyF+"'"
    if OdKiedyF <> '    -  -  ':
        FILTR += " AND um.od_kiedy >= '"+OdKiedyF+"'"
    if DoKiedyF <> '    -  -  ':
        FILTR += " AND um.do_kiedy <= '"+DoKiedyF+"'"
    FILTR += ")"

    #uzupelnienie podgladu o klucze nowe lub zmienione
    if len(Klucze_Id) > 0:
        FILTR += " OR (um.firma_id = '"+self.firma_id+"' AND pracownik_id = '"+Pracownik+"'"
        FILTR +=" AND um.zatrudnienie_id = "+str(Zatrudnienie)+"AND um.umowa_id IN ("
        for i in xrange(len(Klucze_Id)):
            if i > 0:
                FILTR += ","
            FILTR += str(Klucze_Id[i])
        FILTR += "))"

    SELECT ="SELECT um.zatrudnienie_id,um.umowa_id, um.data_zawarcia, um.rodzaj_umowy_id||' - '||umr.opis, um.od_kiedy,"
    SELECT+=" COALESCE(um.do_kiedy::TEXT,''::TEXT)"
    SELECT+=" FROM rs_kp_umowy_o_prace um" 
    SELECT+=" INNER JOIN rs_umowy_rodzaj umr ON umr.firma_id = um.firma_id AND umr.kod = um.rodzaj_umowy_id" 
    SELECT+=" WHERE "+FILTR+" ORDER BY um.umowa_id;"
    stat,dane,wyn1,dump =self.PolSQL.Execute(SELECT, 3)
    if stat <> 'OK':
        stat='Bd pobrania listy umw o prac dla pracownika : '+stat
