#!/usr/bin/python
# -*- coding: iso8859_2 -*-
#-----------------------------------------------------------------------------
# Name:			fs_zamowienia_odbiorcy_pozycje.py
# Purpose:		dodaje/pobiera/usuwa zamowienia odbiorcy
# Author:		Marcin Grzeda
# Created:		2007/04/20
# RCS-ID:		$Id: fs_zamowienia_odbiorcy_pozycje.py $
# Copyright:	(c) 2007 RecordSystem
# Licence:		GNU GPL
#-----------------------------------------------------------------------------

Kierowca = klucze[0]
Trasa=klucze[1]
Tryb=klucze[2]
stat='OK'
wyn2=[]

if (self.operator_id == STANDARD_OPERATOR_ID):
    UprPrzegl=True
    UprDel=True
    UprUpd=True
    UprIns=True
else:    
    UprPrzegl=(self.oddzial_id,'028031') in self.uprawnienia
    UprUpd=(self.oddzial_id,'028032') in self.uprawnienia
    UprIns=(self.oddzial_id,'028033') in self.uprawnienia
    UprDel=(self.oddzial_id,'028034') in self.uprawnienia



Fun=klucze[-1]


if (Fun in [1]):
    Update=klucze[-2]
    Insert=klucze[-3]
    Delete=klucze[-4]
    #for i in xrange(len(Delete[0])):
    if stat=='OK': 
    
#-------------------------------------------------------------------------------
#-------  SPRAWDZANIE DELETE
#-------------------------------------------------------------------------------

        if len(Delete[0])>0:
            if not UprDel:
                stat='UPR DEL'
                dane.append(stat)


#------------------------------------------------------------------------------------------------------------        
#-------------------------- DELETE    
#------------------------------------------------------------------------------------------------------------        
        
        if stat=='OK':
            sql=''
            for i in xrange(len(Delete[0])):
                DELETE="DELETE FROM rs_lista_tras "
                WHERE="WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+self.oddzial_id+"'"
                for j in xrange(len(Delete[0][i])):
                    pole=Delete[1][j]
                    wart=Delete[0][i][j]
                    if pole in ['nr_poz']:
                        WHERE+=" AND "+pole+"="+str(wart)
                    else:
                        WHERE+=" AND "+pole+"='"+wart+"'"
                sql+=DELETE+WHERE+";"
            if sql<>'': 
                stat,dump,dump,dump=self.PolSQL.Execute(rsglobal.Dekoduj(sql),1)
                if stat<>'OK':
                    stat='BL DEL'
                    dane.append(stat)
        
               

#------------------------------------------------------------------------------------------------------------------------------        
#-------     Sprawdzanie danych do Update   
#-----------------------------------------------------------------------------------------------------------------------------        
        
        if len(Update[0])>0:
            if UprUpd:
                for i in xrange(len(Update[0])):   # petla po ilosci wierszy updatowanych
                    for j in xrange(len(Update[0][i])): # petla po pozycjach do zmiany
                        pole=Update[0][i][j]
                        wart=Update[1][i][j] 
                        if pole=='kierowca': 
                            if wart.strip()<>'':
                                Sql="Select kod FROM rs_kierowcy WHERE firma_id='"+self.firma_id+"' AND kod='"+str(wart)+"'"
                                st,d,dump,dump=self.PolSQL.Execute(Sql,3)
                                if st=='OK':
                                    if len(d)==0:
                                        stat='BL KIER$'+str(Update[-1][i])
                                        dane.append(stat)
                                        wyn2.append([Update[-1][i],0])
                                else:
                                    stat='BL SQL KIER'
                                    dane.append(stat)
                            else:
                                stat='BR KIER$'+str(Update[-1][i])
                                dane.append(stat)
                                wyn2.append([Update[-1][i],0])
                        if pole=='trasa': 
                            if wart.strip()<>'':
                                Sql="Select kod FROM rs_trasy WHERE firma_id='"+self.firma_id+"' AND kod='"+str(wart)+"'"
                                st,d,dump,dump=self.PolSQL.Execute(Sql,3)
                                if st=='OK':
                                    if len(d)==0:
                                        stat='BL TRASA$'+str(Update[-1][i])
                                        dane.append(stat)
                                        wyn2.append([Update[-1][i],2])
                                else:
                                    stat='BL SQL TRASA'
                                    dane.append(stat)
                            else:
                                stat='BR TRASY$'+str(Update[-1][i])
                                dane.append(stat)
                                wyn2.append([Update[-1][i],2]) 
                        elif pole=='tryb_dostawy':
                            if wart.strip()<>'':
                                Sql="Select kod FROM rs_tryby_dostaw WHERE firma_id='"+self.firma_id+"' AND kod='"+str(wart)+"'"
                                st,d,dump,dump=self.PolSQL.Execute(Sql,3)
                                if st=='OK':
                                    if len(d)==0:
                                        stat='BL TRYB$'+str(Update[-1][i])
                                        dane.append(stat)
                                        wyn2.append([Update[-1][i],4])
                                else:
                                    stat='BL SQL TRYB'
                                    dane.append(stat)
                            else:
                                stat='BR TRYB$'+str(Update[-1][i])
                                dane.append(stat)
                                wyn2.append([Update[-1][i],4])
            else:
                stat='UPR UPD'
                dane.append(stat)
                            
        
        if len(dane)>0:
            stat=dane[-1]
 
 #-----------------------------------------------------------------------------------------------------------------       
 #---------- UPDATE       
 #-----------------------------------------------------------------------------------------------------------------                           
        
        if stat=='OK':
            sql=''
            for i in xrange(len(Update[0])):   # petla po ilosci wierszy updatowanych
                UPDATE="UPDATE rs_lista_tras "
                SET='SET '
                for j in xrange(len(Update[0][i])): # petla po pozycjach do zmiany
                    pole=Update[0][i][j]
                    wart=Update[1][i][j]
                    
                    if pole in ['dz_01','dz_02','dz_03','dz_04','dz_05','dz_06','dz_07']: 
                        if wart in [True,1]:
                            SET+=pole+"=True,"
                        else:
                            SET+=pole+"=False,"
                    elif pole in ['kierowca','trasa','tryb_dostawy']:
                        if wart<>'':
                            SET+=pole+"='"+wart+"',"
                SET=SET.strip(",")
                WHERE=" WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+self.oddzial_id+"'"
                for j in xrange(len(Update[2][i])): # petla po kluczu
                    pole=Update[3][j]
                    wart=Update[2][i][j]
                    if pole in ['nr_poz']:
                        WHERE+=" AND "+pole+"="+str(wart)
                    else:
                        WHERE+=" AND "+pole+"='"+wart+"'"
                sql+=UPDATE+SET+WHERE+";"
            if sql<>'': 
                stat,dump,dump,dump=self.PolSQL.Execute(rsglobal.Dekoduj(sql),1)
                if stat<>'OK':
                    stat='BL UPD'
                    dane.append(stat)
                    

                             
#----------------------------------------------------------------------------------------------------------------------
#---------Sprawdzanie danych do Insert------
#----------------------------------------------------------------------------------------------------------------------

        if len(Insert[0])>0:
            if UprIns:                
                for i in xrange(len(Insert[0])):
                    for j in xrange(len(Insert[0][i])):
                        pole=Insert[1][j]
                        wart=Insert[0][i][j]
                        if pole=='kierowca': 
                            if wart.strip()<>'':
                                Sql="Select kod FROM rs_kierowcy WHERE firma_id='"+self.firma_id+"' AND kod='"+str(wart)+"'"
                                st,d,dump,dump=self.PolSQL.Execute(Sql,3)
                                if st=='OK':
                                    if len(d)==0:
                                        stat='BL KIER$'+str(Insert[-1][i])
                                        dane.append(stat)
                                        wyn2.append([Insert[-1][i],0])
                                else:
                                    stat='BL SQL KIER'
                                    dane.append(stat) 
                            else:
                                stat='BR KIER$'+str(Insert[-1][i])
                                dane.append(stat)
                                wyn2.append([Insert[-1][i],0])      
                        if pole=='trasa': 
                            if wart.strip()<>'':
                                Sql="Select kod FROM rs_trasy WHERE firma_id='"+self.firma_id+"' AND kod='"+str(wart)+"'"
                                st,d,dump,dump=self.PolSQL.Execute(Sql,3)
                                if st=='OK':
                                    if len(d)==0:
                                        stat='BL TRASA$'+str(Insert[-1][i])
                                        dane.append(stat)
                                        wyn2.append([Insert[-1][i],2])
                                else:
                                    stat='BL SQL TRASA'
                                    dane.append(stat)
                            else:
                                stat='BR TRASY$'+str(Insert[-1][i])
                                dane.append(stat)
                                wyn2.append([Insert[-1][i],2])
                        elif pole=='tryb_dostawy':
                            if wart.strip()<>'':
                                Sql="Select kod FROM rs_tryby_dostaw WHERE firma_id='"+self.firma_id+"' AND kod='"+str(wart)+"'"
                                st,d,dump,dump=self.PolSQL.Execute(Sql,3)
                                if st=='OK':
                                    if len(d)==0:
                                        stat='BL TRYB$'+str(Insert[-1][i])
                                        dane.append(stat)
                                        wyn2.append([Insert[-1][i],4])
                                else:
                                    stat='BL SQL TRYB'
                                    dane.append(stat)
                            else:
                                stat='BR TRYB$'+str(Insert[-1][i])
                                dane.append(stat)
                                wyn2.append([Insert[-1][i],4])     
            else:
                stat='UPR INS'
                dane.append(stat)            
                
                
        if len(dane)>0:
            stat=dane[-1]
    
 #------------------------------------------------------------------------------------------------------------   
 #---------------   INSERT
 #-------------------------------------------------------------------------------------------------------------       
    
        if stat=='OK':    
            sql=''
            for i in xrange(len(Insert[0])):
                INSERT="INSERT INTO rs_lista_tras "
                KOLUMNY="(firma_id,oddzial_id"
                VALUES=" VALUES ('"+self.firma_id+"','"+self.oddzial_id+"'"
                for j in xrange(len(Insert[0][i])):
                    pole=Insert[1][j]
                    wart=Insert[0][i][j]
                    if pole in ['dz_01','dz_02','dz_03','dz_04','dz_05','dz_06','dz_07']:
                        KOLUMNY+=","+pole
                        if wart in [True,1]:
                            VALUES+=",True"
                        if wart in [False,0]:
                            VALUES+=",False"
                    if pole in ['kierowca','trasa','tryb_dostawy']:
                        if wart<>'':
                            KOLUMNY+=","+pole
                            VALUES+=",'"+wart+"'"
                    
                KOLUMNY+=")"
                VALUES+=");"
                sql+=INSERT+KOLUMNY+VALUES
            if sql<>'': 
                stat,dump,dump,dump=self.PolSQL.Execute(rsglobal.Dekoduj(sql),1)
                if stat<>'OK':
                    stat='BL INS'
                    dane.append(stat)            
                        
        else:
            Sql="ROLLBACK;"
            st,dump,dump,dump=self.PolSQL.Execute(Sql,1)
    
    
    
    
#---------------------------------------------------------------------------------------------------------------
#------- POBIERANIE DANYCH
#---------------------------------------------------------------------------------------------------------------

if (Fun in [1,5,6]) and (stat=='OK'):
    if UprPrzegl:    
        Select="SELECT a.kierowca,b.opis,a.trasa,c.opis,a.tryb_dostawy,d.opis,a.dz_02,a.dz_03,a.dz_04,a.dz_05,a.dz_06,a.dz_07,a.dz_01 FROM rs_lista_tras a INNER JOIN rs_kierowcy b ON (a.firma_id=b.firma_id AND a.kierowca=b.kod) INNER JOIN rs_trasy c ON (a.firma_id=c.firma_id AND a.trasa=c.kod) INNER JOIN rs_tryby_dostaw d ON (a.firma_id=d.firma_id AND a.tryb_dostawy=d.kod) WHERE a.firma_id='"+self.firma_id+"' AND a.oddzial_id='"+self.oddzial_id+"'"
        if Kierowca<>'':
            Select+=" AND a.kierowca='"+Kierowca+"' "
        if Trasa<>'':
            Select+=" AND a.trasa='"+Trasa+"' "
        if Tryb<>'':
            Select+=" AND a.tryb_dostawy='"+Tryb+"' "
        Select+=" ORDER BY a.kierowca;"
        stat,dane,wyn,dump=self.PolSQL.Execute(Select,3)
            
        if stat!="OK":
            stat="BL PRZ"
        
             
    else:
        stat="UPR PRZ"