#!/usr/bin/python
# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:			fs_lokalizacje.py
# Purpose:		dodaje/pobiera/usuwa lokalizacje
# Author:		Marcin Natkaski
# Created:		2014/09/08
# RCS-ID:		$Id: fs_lokalizacje.py $
# Copyright:	(c) 2014 RecordSystem
#-------------------------------------------------------------------------------

from funkcje import fs_lokalizacje_pom

stat='OK'
dane = []
wyn1 = []
wyn2 = []

if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'
if stat=='OK':
    Funkcja = klucze['Funkcja']
    SlPar={'MagazynF':[5,11],'LokacjaF':[5,11],'LokalizacjaF':[5,11],'Kod':[19],'Pozycje':[4],'Rodzic':[4,9],'Wezel':[6,12],
    'LokNow':[3,],'LokStar':[3,],'Poczatek':[7,],'Wysokosc':[7,],'Glebokosc':[7,],'Waga':[7,],'Szerokosc':[7,],'Magazyn':[7,],'Pojemnosc':[7,]}
    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Funkcja,klucze)
    if Lista<>'':
        stat='Uwaga : wywoanie funkcji fs_lokalizacje z numerem '+str(Funkcja)+' bez parametrw: '+Lista
    if Funkcja in [3,]:
        LokNow = rsglobal.Dekoduj(klucze['LokNow'])     
        LokStar = rsglobal.Dekoduj(klucze['LokStar']) 
    if Funkcja in [5,11]:
        MagazynF = rsglobal.Dekoduj(klucze['MagazynF'])
        BezLokacjiF = rsglobal.Dekoduj(klucze['LokacjaF'])
        LokalizacjaF = rsglobal.Dekoduj(klucze['LokalizacjaF'])
    if Funkcja in [19,]:
        Kod = rsglobal.Dekoduj(klucze['Kod'])     
    if Funkcja in [4,]:
        Pozycje = rsglobal.Dekoduj(klucze['Pozycje'])     
        Rodzic = rsglobal.Dekoduj(klucze['Rodzic'])     
    if Funkcja in [6,12]:
        Wezel = rsglobal.Dekoduj(klucze['Wezel'])    
    if Funkcja in [7,]:
        Poczatek = rsglobal.Dekoduj(klucze['Poczatek'])    
        if Poczatek=='Lokalizaje':
            Poczatek=''
        Wysokosc  = rsglobal.Dekoduj(klucze['Wysokosc'])
        Szerokosc = rsglobal.Dekoduj(klucze['Szerokosc'])    
        Glebokosc = rsglobal.Dekoduj(klucze['Glebokosc'])
        Waga      = rsglobal.Dekoduj(klucze['Waga'])
        Magazyn   = rsglobal.Dekoduj(klucze['Magazyn'])
        Pojemnosc = rsglobal.Dekoduj(klucze['Pojemnosc'])    
    if Funkcja in [9,]:
        Rodzic = rsglobal.Dekoduj(klucze['Rodzic'])     
        if Rodzic == 'Lokalizacje':
            Rodzic=''
if stat=='OK':
    UprModyfikacja = (((self.oddzial_id,'014122') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID))        
    
#-------------------------------------------------------------------------------
#--- Pobranie nazwy typu lokalizacji (19)
#-------------------------------------------------------------------------------

if Funkcja in [19,] and stat=='OK':
    SQL="SELECT opis FROM rs_lokalizacje_rodzaje WHERE firma_id='"+self.firma_id+"' and kod='"+Kod+"';"
    stat,dane,dump,dump=self.PolSQL.Execute(SQL,3)
    if stat<>'OK':
        stat = 'Nie udao si pobra nazwy kolalizacji '+ stat
        dane.append(stat)
    
#-------------------------------------------------------------------------------
#--- Tworzenie lokacji (9)
#-------------------------------------------------------------------------------

if not UprModyfikacja:
    stat = 'Brak uprawnie do tworzenia lokacji z lokalizacji'
if Funkcja in [9,] and stat=='OK':
    #pobieramy najwysza lokacje
    SEL= "SELECT REPLACE(lokacja_id,'$$','')::INT FROM rs_lokacje WHERE firma_id='"+self.firma_id+"' AND lokacja_id like '$$%' "
    SEL+="ORDER BY REPLACE(lokacja_id,'$$','')::INT DESC LIMIT 1 ;"
    stat,lokacja_numer,dump,dump=self.PolSQL.Execute(SEL,3)
    if stat<>'OK':
        stat = 'Nie udao si pobra najwyszego numerka automatycznych lokacji '+ stat
        dane.append(stat)
    else:
        if len(lokacja_numer)==0:
            lokacja_numer=0
        else:
            lokacja_numer=lokacja_numer[0][0]
        #pobieramy wszystkie potrzebne dane do tworzenia lokacji
        SQL= " SELECT lokalizacja_id,magazyn_id,pojemnosc_lokacji FROM rs_lokalizacje l "
        SQL+=" WHERE l.firma_id='"+self.firma_id+"' AND l.lokalizacja_id LIKE '"+Rodzic+"%' "
        SQL+=" AND (SELECT COUNT(*) FROM rs_lokalizacje WHERE rs_lokalizacje.firma_id = l.firma_id "
        SQL+=" AND rs_lokalizacje.lokalizacja_id LIKE l.lokalizacja_id||'%') = 1 AND l.lokacja_id is null "
        SQL+=" ORDER BY l.lokalizacja_id"
        stat,dane,dump,dump=self.PolSQL.Execute(SQL,3)
        if stat<>'OK':
            stat = 'Nie udao si pobra danych do tworzenia lokacji '+ stat
            dane.append(stat)
        else:
            for i in xrange(1,int(len(dane)+1)):
                #robimy inserta
                INS =" INSERT INTO rs_lokacje (firma_id,lokacja_id,magazyn_id,liczba) VALUES"
                INS+=" ('"+self.firma_id+"','$$"+str(lokacja_numer+i)+"' ,"
                if dane[i-1][1]=='None':
                    INS+=" NULL, "
                else:
                    INS+=" '"+dane[i-1][1]+"',"
                INS+="'"+str(dane[i-1][2])+"');"
                stat,dump,dump,dump=self.PolSQL.Execute(INS,1)
                if stat<>'OK':
                    stat = 'Nie udao si utworzy lokacji '+ stat
                    dane.append(stat)
                #robimy update
                if stat=='OK':
                    UPD =" UPDATE rs_lokalizacje SET lokacja_id='$$"+str(lokacja_numer+i)+"' WHERE firma_id='"+self.firma_id+"'"
                    UPD+=" AND lokalizacja_id='"+dane[i-1][0]+"';"
                    stat,dump,dump,dump=self.PolSQL.Execute(UPD,1)
                    if stat<>'OK':
                        stat = 'Nie udao si zmieni lokalizacji '+ stat
                        dane.append(stat)
                    else:
                        stat,dump,dump,dump=self.PolSQL.Execute('COMMIT',1)
                        
#-------------------------------------------------------------------------------
# --- Usuwanie lokacji z lokalizacji (12)
#-------------------------------------------------------------------------------

if not UprModyfikacja:
    stat = 'Brak uprawnie do usuwania lokacji'
if Funkcja in [12,] and stat=='OK':
    #sprawdzamy czy byy ruchy na lokacjach
    SQL= " SELECT l.lokacja_id FROM rs_lokalizacje l INNER JOIN rs_artykuly_przyjecia r "
    SQL+=" ON (l.firma_id=r.firma_id AND l.lokacja_id=r.lokacja_id)"
    SQL+=" WHERE l.firma_id='"+self.firma_id+"' "
    if Wezel.strip()<>'Lokalizacje':
        SQL+=" AND l.lokalizacja_id like '"+Wezel+"%'; "
    stat,lokacje,dump,dump=self.PolSQL.Execute(SQL,3)
    if stat<>'OK':
        stat = 'Nie udao si sprawdzi czy lokalizaje moga by usunite '+ stat
        dane.append(stat)
    elif len(dane)>0:
        stat='Nie mona usuwa lokacji, poniewa istniej ruchy magazynowe na lokacjach: '+str(lokacje)
        dane.append(stat)
    #Zbieramy lokacje do usunicia
    if stat=='OK':
        LOK =" SELECT lokacja_id from rs_lokalizacje WHERE firma_id='"+self.firma_id+"' "
        if Wezel.strip()<>'Lokalizacje':
            LOK+=" AND lokalizacja_id like '"+Wezel+"%';"
        stat,lokacje_usun,dump,dump=self.PolSQL.Execute(LOK,3)
        if stat<>'OK':
            stat = 'Nie udao si lokacji do usunicia '+ stat
            dane.append(stat)
        else:
            #przerabiamy zmienna lokacje na liste            
            lok = "("
            a=0
            for i in lokacje_usun:
                if i[0].startswith('$$'):
                    lok+="'"+i[0]+"',"
                    a=a+1
            lok=lok[:-1]+')'
            if a==0:
                stat = 'W wybraniej gazi nie istniej lokacje do usunicia '
                dane.append(stat)
    #Najpierw UPDATE bo klucze
    if stat=='OK':
        UPD =" UPDATE rs_lokalizacje set lokacja_id=null WHERE firma_id='"+self.firma_id+"' "
        if Wezel.strip()<>'Lokalizacje':
            UPD+=" AND lokalizacja_id like '"+Wezel+"%';" 
        stat,dump,dump,dump=self.PolSQL.Execute(UPD,1)
        if stat<>'OK':
            stat = 'Nie udao si zmieni lokalizacji '+ stat
            dane.append(stat)
    #Potem DELETE bo mona
    if stat=='OK':
        DEL="DELETE from rs_lokacje WHERE firma_id='"+self.firma_id+"' AND lokacja_id in "+str(lok)+";"
        stat,dump,dump,dump=self.PolSQL.Execute(DEL,1)
        if stat<>'OK':
            stat = 'Nie udao si usun lokacji '+ stat
            dane.append(stat)                  
                                  
#-------------------------------------------------------------------------------
#--- Dodawanie danych do lokalizacji (7)
#-------------------------------------------------------------------------------

if not UprModyfikacja:
    stat = 'Brak uprawnie do dodawania dodawania danych do lokalizacji'
if Funkcja in [7,] and stat=='OK':    
    #sprawdzamy czy dobry magazyn
    if Magazyn<>'':
        MAG="SELECT * from rs_magazyny WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+Magazyn+"';"
        stat,dane,dump,dump=self.PolSQL.Execute(MAG,3)
        if stat<>'OK':
            stat = 'Nie udao si sprawdzi poprawnoci magazynu '+ stat
            dane.append(stat)
        elif len(dane)==0:
            stat="Podano bdny magazyn"
            dane.append(stat)
    #robimy sprawdzenia dla kadego z elementw
    if Pojemnosc > 99999:
        stat="Za dua warto w polu pojemno"
        dane.append(stat)
    if Wysokosc > 99999:
        stat="Za dua warto w polu wysoko"
        dane.append(stat)
    if Szerokosc > 99999:
        stat="Za dua warto w polu szeroko"
        dane.append(stat)
    if Glebokosc > 99999:
        stat="Za dua warto w polu gboko"
        dane.append(stat)
    if Waga > 9999:
        stat="Za dua warto w polu dopuszczalna waga"
        dane.append(stat)
    if stat=='OK':
        #sprawdzamy czy byy ruchy na lokacjach
        SQL= " SELECT l.lokacja_id FROM rs_lokalizacje l INNER JOIN rs_artykuly_przyjecia r "
        SQL+=" ON (l.firma_id=r.firma_id AND l.lokacja_id=r.lokacja_id)"
        SQL+=" WHERE l.firma_id='"+self.firma_id+"' and l.lokalizacja_id like '"+Poczatek+"%'; "
        stat,dane,dump,dump=self.PolSQL.Execute(SQL,3)
        if stat<>'OK':
            stat = 'Nie udao si sprawdzi czy lokalizaje moga by usunite '+ stat
            dane.append(stat)
        elif len(dane)>0:
            stat='Nie mona usuwa lokalizacji, poniewa zawieraj lokacje, na ktry istniej ruchy magazynowe: '+str(dane)
            dane.append(stat)
    if stat=='OK':
        #jako, e nie byo pki co sprzeciwu wyapujemy wszystkie lokalizacje ostatnie.
        SQL= " SELECT lokalizacja_id FROM rs_lokalizacje l WHERE l.firma_id='"+self.firma_id+"' AND l.lokalizacja_id LIKE '"+Poczatek+"%' "
        SQL+=" AND (SELECT COUNT(*) FROM rs_lokalizacje WHERE rs_lokalizacje.firma_id = l.firma_id "
        SQL+=" AND rs_lokalizacje.lokalizacja_id LIKE l.lokalizacja_id||'%') = 1"
        SQL+=" ORDER BY l.lokalizacja_id"
        stat,dane,dump,dump=self.PolSQL.Execute(SQL,3)
        if stat<>'OK':
            stat = 'Nie udao si pobra listy lokalizacji '+ stat
            dane.append(stat)
        #tworzymy sobie liste stringow
        if stat=='OK':
            lista=[]
            for i in dane:
                lista=lista+i
            UPD= " UPDATE rs_lokalizacje SET "
            if Magazyn<>'':
                UPD+=" magazyn_id='"+Magazyn+"',"
            UPD+=" pojemnosc_lokacji="+str(Pojemnosc)+" ,"
            UPD+=" wys="+str(Wysokosc)+",gleb="+str(Glebokosc)+",szer="+str(Szerokosc)+" ,dopuszczalna_waga_palety="+str(Waga)+" "
            UPD+= " WHERE firma_id='"+self.firma_id+"' "
            if Poczatek<>'Lokalizacje':
                UPD+=" AND lokalizacja_id in "+str(lista).replace('[','(').replace(']',')').replace('u','')+" "
            UPD+=";"
            stat,dump,dump,dump=self.PolSQL.Execute(UPD,1)
            if stat<>'OK':
                stat = 'Nie udao si doda danych do lokalizacji '+ stat
                dane.append(stat)
            #No i robimy UPDATE na lokacje
            else:
                UPDLOK = "UPDATE rs_lokacje SET "
                if Magazyn<>'':
                    UPDLOK+= " magazyn_id='"+Magazyn+"',"
                UPDLOK+=" liczba="+str(Pojemnosc)+" "
                UPDLOK+= " WHERE firma_id='"+self.firma_id+"'  AND lokacja_id in "
                UPDLOK+=" ("
                UPDLOK+=" SELECT lokacja_id FROM rs_lokalizacje l WHERE l.firma_id='"+self.firma_id+"' "
                if Poczatek<>'Lokalizacje':
                    UPDLOK+=" AND l.lokalizacja_id LIKE '"+Poczatek+"%' "
                UPDLOK+=" AND (SELECT COUNT(*) FROM rs_lokalizacje WHERE rs_lokalizacje.firma_id = l.firma_id "
                UPDLOK+=" AND rs_lokalizacje.lokalizacja_id LIKE l.lokalizacja_id||'%') = 1"
                UPDLOK+=");"
                stat,dump,dump,dump=self.PolSQL.Execute(UPDLOK,1)
                if stat<>'OK':
                    stat = 'Nie udao si zmieni danych lokacji '+ stat
                    dane.append(stat)
                    
#-------------------------------------------------------------------------------
#   Zmiana klucza lokalizacji (3) (NA RAZIE WYCZONA OPCJA)
#-------------------------------------------------------------------------------

if not UprModyfikacja:
    stat = 'Brak uprawnie do zmiany klucza lokalizacji'
if Funkcja in [3,] and stat=='OK':
    #Wstpne testy
    if len(LokNow)<6:
        stat="Za krtki klucz lokalizacji"
        dane.append(stat)
    if len(LokNow)%6<>0:
        stat="Dgo klucza powinna by wielokrotnoci szstki"
        dane.append(stat)
    if stat=='OK':    
        #Pobieramy wszystkie klucze ze sloniwka typow lokalizacji
        SEL="SELECT kod FROM rs_lokalizacje_rodzaje WHERE firma_id='"+self.firma_id+"';"
        stat,RodzLok,dump,dump=self.PolSQL.Execute(SEL,3)
    #Sprawdzamy czy istnieje do czego podczepic zmieniony klucz
    if stat=='OK':
        SEL ="SELECT lokalizacja_id FROM rs_lokalizacje WHERE firma_id='"+self.firma_id+"' "
        SEL+="AND lokalizacja_id='"+LokNow[:-6]+"';"
        stat,dl,dump,dump=self.PolSQL.Execute(SEL,3)
        if stat<>'OK':
            stat = 'Nie udao si sprwadzi klucza lokalizacji '+ stat
            dane.append(stat)
        elif len(dl)==0:
            stat="Zmienionego klucza nie mona podpi do struktury drzewa"
            dane.append(stat)
    #Sprawdzamy czy ostatni element jest odpowiednio napisany
    if [LokNow[-6:][:2]] not in RodzLok:
        stat="Elementu '"+LokNow[-6:][:2]+"' brakuje w sowniku lokalizacji."
        dane.append(stat)
    if not LokNow[-6:][2:].isdigit():
        stat='Po dwch wielkich literach powinny wystpi 4 cyfry a tak si nie dzieje'
        dane.append(stat)
    if stat=='OK':
        #Sprawdzamy czy przypadkiem nowy klucz nie istnieje w caoci
        SEL ="SELECT lokalizacja_id FROM rs_lokalizacje WHERE firma_id='"+self.firma_id+"' "
        SEL+="AND lokalizacja_id='"+LokNow+"';"
        stat,dln,dump,dump=self.PolSQL.Execute(SEL,3)
        if stat<>'OK':
            stat = 'Nie udao si czy nowy klucz lokalizacji nie istnieje '+ stat
            dane.append(stat)
        elif len(dln)<>0:
            stat="Klucz zmieniono na juistniejcy"
            dane.append(stat)
    if LokNow[:-6] == LokStar[:-6]:
        stat="Pocztek nowego klucza jest taki sam jak starego."
        dane.append(stat)
    if stat=='OK':
        UPD = " UPDATE rs_lokalizacje set lokalizacja_id=REPLACE(lokalizacja_id,'"+LokStar+"','"+LokNow+"') "
        UPD+= " WHERE firma_id='"+self.firma_id+"' AND  lokalizacja_id like '"+LokStar+"%' ;"
        stat,dump,dump,dump=self.PolSQL.Execute(UPD,1)

#-------------------------------------------------------------------------------
#    dodanie elementw drzewa (4) 
#-------------------------------------------------------------------------------

if not UprModyfikacja:
    stat = 'Brak uprawnie do dodawania elementw drzewa'
if Funkcja in [4,] and stat == 'OK':
    Rodzic = [[Rodzic]]
    #jako, e pozycje dostarczylimy w odpowiedniej kolejnoci, bierzemy je po kolei
    lista = []
    for i in xrange(len(Pozycje)):
        if len(lista)<>0:
            Rodzic=lista
            lista=[]
        for j in xrange(len(Rodzic)):
            stat,wyn = fs_lokalizacje_pom.DodajPoziom(self,Rodzic[j][0],Pozycje[i])
            lista= lista+wyn
            
#-------------------------------------------------------------------------------
#    usuwanie pozycji (6)
#-------------------------------------------------------------------------------

if Funkcja == 6 and stat == 'OK':
    if not UprModyfikacja:
        stat = 'Brak uprawnie do modyfikacji zlece'
    if stat=='OK':   
        #sprawdzamy czy byy ruchy na lokacjach
        SQL= " SELECT l.lokacja_id FROM rs_lokalizacje l INNER JOIN rs_artykuly_przyjecia r "
        SQL+=" ON (l.firma_id=r.firma_id AND l.lokacja_id=r.lokacja_id)"
        SQL+=" WHERE l.firma_id='"+self.firma_id+"' and l.lokalizacja_id like '"+Wezel+"%'; "
        stat,dane,dump,dump=self.PolSQL.Execute(SQL,3)
        if stat<>'OK':
            stat = 'Nie udao si sprawdzi czy lokalizaje moga by usunite '+ stat
            dane.append(stat)
        elif len(dane)>0:
            stat='Nie mona usuwa lokalizacji, poniewa zawieraj lokacje, na ktry istniej ruchy magazynowe: '+str(dane)
            dane.append(stat)
        if stat=='OK':
            if Wezel == 'Lokalizacje':
                DEL =" DELETE FROM rs_lokalizacje WHERE firma_id='"+self.firma_id+"';"
            else:            
                DEL =" DELETE FROM rs_lokalizacje WHERE firma_id='"+self.firma_id+"' and lokalizacja_id like '"+Wezel+"%';"
            stat,dump,dump,dump=self.PolSQL.Execute(DEL,1)
            if stat<>'OK':
                stat = 'Nie udao si usun gazi drzewa lokalizacji '+ stat
                dane.append(stat)

#-------------------------------------------------------------------------------
# -- pobranie danych (1,5)
#-------------------------------------------------------------------------------

if (Funkcja in [1,5]) and (stat=='OK'):
    #pobieramy tylko ostatnie lokalalizacje bo nie ma sensu przesya przez sie miliarda danych
    SQL= " SELECT lokalizacja_id,lokacja_id FROM rs_lokalizacje l WHERE l.firma_id='"+self.firma_id+"' "
    if LokalizacjaF<>'':
        SQL+=" AND l.lokalizacja_id LIKE '"+LokalizacjaF+"%' "
    if MagazynF<>'': 
        SQL+=" AND l.magazyn_id like '"+MagazynF+"%' "    
    SQL+=" AND (SELECT COUNT(*) FROM rs_lokalizacje WHERE rs_lokalizacje.firma_id = l.firma_id "
    SQL+=" AND rs_lokalizacje.lokalizacja_id LIKE l.lokalizacja_id||'%') = 1 "
    if BezLokacjiF:
        SQL+=" AND l.lokacja_id is NULL "
    SQL+=" ORDER by character_length(l.lokalizacja_id),l.lokalizacja_id"
    SQL+=" ;"
    stat,dane,dump,dump=self.PolSQL.Execute(SQL,3)
    if stat<>'OK':
        stat = 'Bdy pobierania danych '+ stat
        dane.append(stat)
        
#-------------------------------------------------------------------------------
# -- Pobranie parametrw lokacji
#-------------------------------------------------------------------------------

if Funkcja in [11,] and stat=='OK':
    #pobieramy wszystkie lokacje i dane lokacji (uwzgldniajc filtr) 
    SQL= " SELECT lokalizacja_id, 'Lokacja: '||coalesce(lokacja_id,'Brak')||'; '||'Pojemno: '||pojemnosc_lokacji||'; '||  "
    SQL+=" 'wys.: '||wys||'; '||'szer.: '||szer||'; '||'gb.: '||gleb||'; '||"
    SQL+=" 'magazyn: '||coalesce(magazyn_id,'Brak')||'; '||'wspczynnik: '||wsp_obciaz||'; '||'Dop. waga: '||dopuszczalna_waga_palety "
    SQL+=" FROM rs_lokalizacje WHERE firma_id='"+self.firma_id+"' "
    SQL+=" ORDER by character_length(lokalizacja_id),lokalizacja_id"
    SQL+=" ;"
    stat,dane,dump,dump=self.PolSQL.Execute(SQL,3)
    if stat<>'OK':
        stat = 'Bdy pobierania danych '+ stat
        dane.append(stat)