# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_kp_szkolenia_dane
# Purpose:     dodawanie/edycja szkole
# Author:      Marcin Natkaski
# Created:     2012/06/14
# RCS-ID:      $Id: fs_kp_szkolenia_dane.py $
# Copyright:   (c) 2012 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

stat = 'OK'
dane = []
wyn1 = []
wyn2 = []

if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=='OK':
    Fun = klucze['Funkcja']
    
    SlPar={'Nota':[1,2,3,4,5]}    
    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Fun,klucze)
    if Lista<>'':
        stat='Uwaga : wywoanie funkcji fs_noty_ilosciowe_dane z numerem '+str(Fun)+' bez parametrw: '+Lista

    if Fun in (1,2,3,4,5,): 
        Nota=str(klucze['Nota'])

UprDodawanie = (((self.oddzial_id,'027203') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID))
UprEdycja = (((self.oddzial_id,'027202') in self.uprawnienia) or UprDodawanie or (self.operator_id == STANDARD_OPERATOR_ID))

#-------------------------------------------------------------------------------
# sprawdzenie uprawnien
#-------------------------------------------------------------------------------

if Fun in (1,2) and stat == 'OK':
    if not UprDodawanie:
        stat = 'BR UPR INS'

if Fun in (3,4) and stat == 'OK':
    if not UprEdycja:
        stat = 'BR UPR UPD'

#-------------------------------------------------------------------------------
# sprawdzenie danych
#-------------------------------------------------------------------------------

if stat == 'OK':
    NazwaNoty=''
    for i in range(len(pola)):
        pole = pola[i].lower()
        wart = wartosci[i]

        if pole == 'numer':
            if Fun in (3,4):
                if wart in [0,'0','']:
                    dane.append('BR NOTY')
                else:
                    SQL="SELECT stan FROM rs_noty_ilosciowe"
                    SQL+=" WHERE firma_id = '"+self.firma_id+"' AND nota = "+Nota+";"
                    stat,d,dump,dump = self.PolSQL.Execute(SQL, 3)
                    if stat <> 'OK':
                        dane.append('Bd pobrania stanu noty ilociowej : '+stat)
                    elif len(d) == 0:
                        dane.append('BL NOTA')
                    else:
                        if d[0][0]<>'W':
                            dane.append('Nie mona modyfikowa noty ilociowej bo jest w stanie '+d[0][0])

        elif pole == 'numer_noty':
            if wart == '':
                dane.append('BR NAZWA')
            else:
                NazwaNoty=wart

        elif pole == 'kontrahent_id':
            if wart == '':
                dane.append('BR KONTR')
            else:
                SQL="SELECT kontrahent_id FROM rs_kontrahenci"
                SQL+=" WHERE firma_id = '"+self.firma_id+"' AND kontrahent_id = '"+wart+"';"
                stat,d,dump,dump = self.PolSQL.Execute(SQL, 3)
                if stat <> 'OK':
                    dane.append('Bd pobrania kontrahenta : '+stat)
                elif len(d) == 0:
                    dane.append('BL KONTR')

        elif pole == 'data_wprowadzenia':
            if Fun in (3,4):
                if wart == '    -  -  ':
                    dane.append('BR DATA WPR')
                elif not rsglobal.SprawdzCzyToData(wart):
                    dane.append('BL DATA WPR')
        
        elif pole == 'data_wystawienia':
            if wart == '    -  -  ':
                dane.append('BR DATA WYST')
            elif not rsglobal.SprawdzCzyToData(wart):
                dane.append('BL DATA WYST')
                
        elif pole == 'data_potracenia':
            if wart <> '    -  -  ':
                if not rsglobal.SprawdzCzyToData(wart):
                    dane.append('BL DATA POTR')
        
        elif pole == 'dostawy_od':
            if wart <> '    -  -  ':
                if not rsglobal.SprawdzCzyToData(wart):
                    dane.append('BL DATA DOST OD')
                
        elif pole == 'dostawy_do':
            if wart <> '    -  -  ':
                if not rsglobal.SprawdzCzyToData(wart):
                    dane.append('BL DATA DOST DO')
                
        elif pole == 'zwroty_od':
            if wart <> '    -  -  ':
                if not rsglobal.SprawdzCzyToData(wart):
                    dane.append('BL DATA ZWR OD')
                
        elif pole == 'zwroty_do':
            if wart <> '    -  -  ':
                if not rsglobal.SprawdzCzyToData(wart):
                    dane.append('BL DATA ZWR DO')
                
        if len(dane) > 0:
            stat = dane[0]


#-------------------------------------------------------------------------------
#--- DODAWANIE DANYCH (1 -z pobraniem select  2 - bez pobrania
#-------------------------------------------------------------------------------

if Fun in (1,2) and stat=='OK':
    if NazwaNoty<>'':
        INS = "INSERT INTO rs_noty_ilosciowe"
        Pola="firma_id,oddzial_id,data_wprowadzenia,stan" 
        Wartosci="'"+self.firma_id+"','"+self.oddzial_id+"',NOW()::DATE,'W'" 
        for i in range(len(pola)):
            pole = pola[i]
            wart = wartosci[i]
            if pole in ['numer_noty']:
                Pola+=","+pole
                Wartosci+=",'"+wart+"'"
                
            elif pole in ['kontrahent_id']: 
                Pola+=","+pole
                if wart<>'':
                    Wartosci+=",'"+wart+"'"
                else:                 
                    Wartosci+=",NULL"
                    
            elif pole in ['data_wystawienia','data_potracenia','dostawy_od','dostawy_do','zwroty_od','zwroty_do']:
                Pola+=","+pole
                rsglobal.ZapiszDoLogow('wart '+pole+' !'+str(wart)+'!',1)
                if wart<>'    -  -  ':
                    Wartosci+=",'"+wart+"'"
                else:                 
                    Wartosci+=",NULL"
                    
        INS+=" ("+Pola+") VALUES ("+Wartosci+");" 
        rsglobal.ZapiszDoLogow('INS '+INS,1)       
        stat,dump,dump,dump = self.PolSQL.Execute(INS,1)
        if stat <> 'OK':
            stat = 'Bd dodawania nowej noty ilociowej : '+stat
            dane.append(stat)
        
        if stat=='OK':
            # pobranie nowego numeru noty
            SQL="SELECT MAX(numer) FROM rs_noty_ilosciowe WHERE firma_id='"+self.firma_id+"'"
            SQL+=" AND oddzial_id='"+self.oddzial_id+"' AND numer_noty='"+NazwaNoty+"' AND stan='W';"
            stat,d,dump,dump = self.PolSQL.Execute(SQL, 3)
            if stat <> 'OK':
                stat='Bd pobrania numeru noty : '+stat
            elif len(d)==0:
                stat='Bd wstawienia numeru noty - nie mona jej znale w bazie'
            else:
                Nota=str(d[0][0])


#-------------------------------------------------------------------------------
#--- UPDATE DANYCH ( 3-select, 4 -update z pobraniem)
#-------------------------------------------------------------------------------

if Fun in (3,4) and stat == 'OK':
    UPD = "UPDATE rs_noty_ilosciowe SET "
    WHERE=" WHERE firma_id = '"+self.firma_id+"' and numer = "+Nota+";"
    Wartosci=''
    Pola=''
    for i in range(len(pola)):
        pole = pola[i]
        wart = wartosci[i]
        
        if pole in ['numer_noty']:
            Pola+=","+pole
            Wartosci+=",'"+wart+"'"
            
        elif pole in ['kontrahent_id']: 
            Pola+=","+pole
            if wart<>'':
                Wartosci+=",'"+wart+"'"
            else:                 
                Wartosci+=",NULL"

        elif pole in ['data_wystawienia','data_potracenia','dostawy_od','dostawy_do','zwroty_od','zwroty_do']:
            Pola+=","+pole
            if wart<>'    -  -  ':
                Wartosci+=",'"+wart+"'"
            else:                 
                Wartosci+=",NULL"
            
    if len(Wartosci)>0:    
        UPD+=" ("+Pola[1:]+") = ("+Wartosci[1:]+")" + WHERE        
        stat,d,dump,dump = self.PolSQL.Execute(UPD,1)        
        if stat <> 'OK':
            stat = 'Bd aktualizacji danych noty ilociowej : '+stat
            dane.append(stat)


#-------------------------------------------------------------------------------
#--- POBRANIE DANYCH ( 5-select, 3 -update z pobraniem)
#-------------------------------------------------------------------------------

if Fun in (1,3,5,9) and stat=='OK':
    SELECT ="SELECT * FROM rs_noty_ilosciowe"
    SELECT+=" WHERE firma_id='"+self.firma_id+"' AND numer='"+Nota+"';"
    stat,dane,wyn1,dump = self.PolSQL.Execute(SELECT,3)    
    if stat <> 'OK':
        stat = 'Bd pobrania danych noty ilociowej : '+stat
        dane.append(stat)

    if stat == 'OK':
        tr = rssql.RSTableRowset(dane,wyn1)

        # [0] kontrahent
        if tr.GetVal(0,"kontrahent_id")<>'None':
            if (self.oddzial_id,'012000') in self.uprawnienia or self.operator_id == STANDARD_OPERATOR_ID:
                SQL="SELECT nazwa FROM rs_kontrahenci"
                SQL+=" WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+tr.GetVal(0,"kontrahent_id")+"';"
                stat,d,dump,dump = self.PolSQL.Execute(SQL, 3)
                if stat <> 'OK':
                    wyn2.append('Bd pobrania opisu kontrahenta : '+stat)
                elif len(d) == 0:
                    wyn2.append('Bdny kod kontrahenta.')
                else:
                    wyn2.append(d[0][0])
            else:
                wyn2.append('Brak uprawnie do sownika. Poinformuj administratora.')
        else:
            wyn2.append('')
