# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_oddzialy_zmiany.py
# Purpose:     nowe okno oddziay zmiany + obsuga
# Author:      Pawe Wjcikowski
# Created:     2009/06/22
# RCS-ID:      $Id: fs_oddzialy_zmiany.py$
# Copyright:   (c) 2009 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

# 2011-12-28 Mariusz Rajfura  brak 'firma_id' w kontroli i pobieraniu danych (5297)


Fun = klucze[-1]

stat = "OK"
dane = []
DaneI = []

UprDodawanie=(((self.oddzial_id,'044003') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID))
UprEdycja=(((self.oddzial_id,'044002') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)) or UprDodawanie
UprUsuwanie=(((self.oddzial_id,'044004') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID))

if Fun == 1 and stat=="OK":
    Update=klucze[-2]
    Insert=klucze[-3]
    Delete=klucze[-4]   
 
 
#-------------------------------------------------------------------------------
#-------  SPRAWDZANIE DELETE  --------------------------------------------------
#-------------------------------------------------------------------------------

if Fun == 1 and stat=="OK":
    if len(Delete[0])>0:
        if not UprUsuwanie:
            stat='Brak uprawnie do usuwania danych'
            dane.append(stat)    
            
            
#-------------------------------------------------------------------------------
#-------------------------- DELETE    
#-------------------------------------------------------------------------------
        
        if stat=='OK':
            sql=''
            for i in xrange(len(Delete[0])):
                DELETE="DELETE FROM rs_pr_oddzialy_zmiany "
                WHERE="WHERE firma_id='"+self.firma_id+"'"
                for j in xrange(len(Delete[0][i])):
                    pole=Delete[1][j]
                    wart=Delete[0][i][j]
                    if pole in ['oddzial_id','zmiana','tryby']:
                        WHERE+=" AND "+pole+"='"+wart+"'"
                sql+=DELETE+WHERE+";"
            if sql<>'': 
                stat,dump,dump,dump=self.PolSQL.Execute(rsglobal.Dekoduj(sql),1)
            if stat<>'OK':
                stat="Bd przy usuwaniu danych: "+stat   
                dane.append(stat)        
                       
                                 
#-------------------------------------------------------------------------------
#---   UPDATE DANYCH (1) - sprawdzanie
#-------------------------------------------------------------------------------

if Fun == 1 and stat=="OK":
    if len(Update[0])>0:
        if not UprEdycja:
            stat='Brak uprawnie do edycji danych'
            dane.append(stat)
        if stat=='OK':      
            sel1="SELECT oddzial_id FROM rs_oddzialy WHERE firma_id='"+self.firma_id+"';"
            stat,D,dump,dump = self.PolSQL.Execute(sel1,3)
            if stat<>'OK':
                stat="Bd przy sprawdzaniu kodu: "+stat   
                dane.append(stat) 
            DaneI=[]
    
            for i in xrange(len(D)):
                for x in D[i]:
                    DaneI.append(str(x).strip())  
                                         
            Update=klucze[-2]
            WierszeNr = Update[-1]
            for i in xrange(len(Update[0])):
                for j in xrange(len(Update[0][i])): 
                    pole=Update[0][i][j]
                    wart=Update[1][i][j]
                    if pole == 'oddzial_id':
                        if wart=='':
                            stat = 'PUSTY ODDZIAL'
                            wyn2.append((WierszeNr[i],0))
                            dane.append(stat)
                        elif str(wart).strip() not in DaneI:
                            stat = 'BL ODDZIAL'
                            wyn2.append((WierszeNr[i],0))
                            dane.append(stat)
                    elif pole == 'zmiana':
                        if wart=='':
                            stat = 'PUSTA ZMIANA'
                            wyn2.append((WierszeNr[i],1))
                            dane.append(stat)
                        elif len(wart)>1:
                            stat = 'ZMIANA DL'
                            wyn2.append((WierszeNr[i],1))
                            dane.append(stat)  
                          
                            
#-------------------------------------------------------------------------------
#---------------   UPDATE
#-------------------------------------------------------------------------------

        if stat=='OK':
            sql=''        
            for i in xrange(len(Update[0])):   
                UPDATE="UPDATE rs_pr_oddzialy_zmiany "
                SET='SET '
                for j in xrange(len(Update[0][i])): 
                    pole=Update[0][i][j]
                    wart=Update[1][i][j]
                    if pole in ['oddzial_id','zmiana','tryby']:
                        SET+=pole+"='"+wart+"',"
                SET=SET.strip(",")
                WHERE=" WHERE firma_id='"+self.firma_id+"'"
                for j in xrange(len(Update[2][i])): # petla po kluczu
                    pole=Update[3][j]
                    wart=rsglobal.Dekoduj(Update[2][i][j])
                    WHERE+=" AND "+pole+"='"+wart+"'"
                WHERE+=";" 
                if str(SET)=='SET ':
                    pass
                else:
                    sql+=UPDATE+SET+WHERE;
            if sql<>'': 
                stat,dump,dump,dump=self.PolSQL.Execute(rsglobal.Dekoduj(sql),1)   
                if stat<>'OK':
                    stat="Bd przy modyfikowaniu danych: "+stat   
                    dane.append(stat)  
                  
                                    
#-------------------------------------------------------------------------------
#---------Sprawdzanie danych do Insert------
#-------------------------------------------------------------------------------

if Fun == 1 and stat=="OK":
    if len(Insert[0])>0:
        if not UprDodawanie:
            stat='Brak uprawnie do dodawania danych'
            dane.append(stat)
        if stat=='OK':                    
            sel1="SELECT oddzial_id FROM rs_oddzialy WHERE firma_id='"+self.firma_id+"';"
            stat,I,dump,dump = self.PolSQL.Execute(sel1,3)
            if stat<>'OK':
                stat="Bd przy sprawdzaniu danych: "+stat   
                dane.append(stat)        
            Insert=klucze[-3]
            WierszeNr = Insert[-1]
            DaneI=[]
            for i in xrange(len(I)):
                for x in I[i]:
                    DaneI.append(str(x).strip())  
        
            for i in xrange(len(Insert[0])):
                for j in xrange(len(Insert[0][i])): 
                        pole=Insert[1][j]
                        wart=Insert[0][i][j]
                        if pole == 'oddzial_id':
                            if wart=='':
                                stat = 'PUSTY ODDZIAL'
                                wyn2.append((WierszeNr[i],0))
                                dane.append(stat)
                            elif str(wart).strip() not in DaneI:
                                stat = 'BL ODDZIAL'
                                wyn2.append((WierszeNr[i],0))
                                dane.append(stat)
                        elif pole == 'zmiana':
                            if wart=='':
                                stat = 'PUSTA ZMIANA'
                                wyn2.append((WierszeNr[i],1))
                                dane.append(stat)
                            elif len(wart)>1:
                                stat = 'ZMIANA DL'
                                wyn2.append((WierszeNr[i],1))
                                dane.append(stat)
                         
                                                        
#-------------------------------------------------------------------------------
#---------------   INSERT
#-------------------------------------------------------------------------------

        if stat=='OK':    
            sqlIns=''
            for i in xrange(len(Insert[0])):
                INSERT="INSERT INTO rs_pr_oddzialy_zmiany "
                KOLUMNY="(firma_id"
                VALUES=" VALUES ('"+self.firma_id+"'"
                for j in xrange(len(Insert[0][i])):
                    pole=Insert[1][j]
                    wart=Insert[0][i][j]
                    if pole in ['oddzial_id','zmiana','tryby']:
                        KOLUMNY+=","+pole
                        VALUES+=",'"+wart+"'"              
                KOLUMNY+=")"
                VALUES+=");"
                sqlIns+=INSERT+KOLUMNY+VALUES
            if sqlIns<>'': 
                stat,dump,dump,dump=self.PolSQL.Execute(rsglobal.Dekoduj(sqlIns),1)
                if stat<>'OK':
                    stat="Bd przy dodawaniu danych: "+stat   
                    dane.append(stat)   
                    
                                         
#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (1- insert 1 -select, 1 -delete)
#-------------------------------------------------------------------------------

if (Fun in [1,4,5,6]) and (stat=='OK') :
        # pobranie danych 
    Select ="SELECT oddzial_id,zmiana,tryby"
    Select+=" FROM rs_pr_oddzialy_zmiany"
    Select+=" WHERE firma_id='"+self.firma_id+"'"
    Select+=" ORDER BY oddzial_id,zmiana;"
    stat,dane,wyn1,tr = self.PolSQL.Execute(Select,3)
    if stat<>'OK':
        stat="Bd przy pobieraniu danych: "+stat   
        dane.append(stat)        