# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_okresy_miesiace.py
# Purpose:     wczytuje/zamyka okesy miesice
#
# Author:      Dariusz Boduch
# Created:     2007/09/06
# RCS-ID:      $Id: fs_okresy_miesiace.py $
# Copyright:   (c) 2005 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

# 2011-11-03 Mariusz Rajfura  przy zamykaniu aktualizacja pola 'data_minimum' (5159)

Okres=klucze[0]
Rok=klucze[1]
Miesiac=klucze[2]
Fun=klucze[-1]

stat = "OK"
dane = []

#-------------------------------------------------------------------------------
#---   ZAMYKANIE MIESICA (8)
#-------------------------------------------------------------------------------

if Fun ==8 and (stat=='OK'):
    # sprawdzenie czy wszystkie dokumenty w miesicu zamykanym s zamknite
    SQL="SELECT stan FROM rs_dowody_ksiegowe WHERE firma_id='"+self.firma_id+"' AND okres_id='"+Okres+"'"
    SQL+=" AND EXTRACT(MONTH FROM data)::TEXT='"+Miesiac.lstrip('0')+"' AND EXTRACT(YEAR FROM data)::TEXT='"+Rok+"'"
    SQL+=" AND stan <> 'Z';"
    stat,DStan,dump,dump = self.PolSQL.Execute(SQL,3)    
    if stat=='OK':
        if len(DStan)>0:
            stat='Nie mona zamkn miesica bo istniej w nim niezamknite dowody ksigowe'
            
    
    if stat=='OK':
        stat,DNr,wyn1,tr = self.PolSQL.Execute("SELECT max(dziennik) FROM rs_operacje WHERE firma_id='"+self.firma_id+"' AND okres_id='"+Okres+"'" ,3)
    if stat=='OK':
        if DNr[0][0] in (None,'None'):
            Nr=1
        else:
            Nr=DNr[0][0]+1
    
        SqlOper="SELECT dowod_id,nazwa_id,data,numer,nr_poz,nr_ppoz,kwota_wn,kwota_ma FROM rs_operacje "
        SqlOper+=" WHERE firma_id='"+self.firma_id+"' AND okres_id='"+Okres+"' AND EXTRACT(year FROM data)='"+Rok+"' AND EXTRACT(month FROM data)='"+Miesiac+"' AND (dziennik=0 OR dziennik IS NULL) AND dowod_id NOT IN ('BO','BK')"
        SqlOper+=" ORDER BY data,dowod_id,nazwa_id,numer,nr_poz,nr_ppoz"
        stat,DOper,wyn1,tr = self.PolSQL.Execute(SqlOper,3)
    
    if stat=='OK':
        SQL=''
        Lp=1
        for oper in DOper:
            if stat=='OK':
                if Lp==2000 and stat=='OK':
                    Lp=1
                    stat,dump,dump,dump = self.PolSQL.Execute(SQL,1)
                    SQL=''
                
                SQL+="UPDATE rs_operacje SET dziennik="+str(Nr)+" WHERE firma_id='"+self.firma_id+"' AND okres_id='"+Okres+"' AND dowod_id='"+rsglobal.Dekoduj(oper[0])+"' AND nazwa_id='"+rsglobal.Dekoduj(oper[1])+"' AND data='"+rsglobal.Dekoduj(oper[2])+"' AND numer="+str(oper[3])+" AND nr_poz="+str(oper[4])+" AND nr_ppoz="+str(oper[5])+" AND kwota_wn="+str(oper[6])+" AND kwota_ma="+str(oper[7])+";"
                Nr=Nr+1
                Lp=Lp+1


    if stat=='OK':
        # sprawdzenie z data minimum - tabela w rs_zakresy_dat moze byc pusta
        # trzeba ja zainicjowac
        MinimumRok = int(Rok)
        MinimumMiesiac = int(Miesiac) + 1
        if MinimumMiesiac > 12:
            MinimumMiesiac = 1
            MinimumRok += 1
            
        DataMinimum = str(MinimumRok)+'-'+str(MinimumMiesiac).zfill(2)+'-01'
        
        sql = "SELECT COALESCE(data_minimum::TEXT,''::TEXT) FROM rs_zakresy_dat"
        sql+= " WHERE firma_id='"+self.firma_id+"';"
        
        stat,ZakresyDat,dump,dump = self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Bd sprawdzenia daty minimum: '+stat
        elif len(ZakresyDat) == 0:
            # brak wiersza, wiec zainicjujemy od razu z dobra data_minimum
            SQL+="INSERT INTO rs_zakresy_dat (firma_id,data_minimum)"
            SQL+=" VALUES ('"+self.firma_id+"','"+DataMinimum+"');"
        elif ZakresyDat[0][0] == '' or rsglobal.Dekoduj(ZakresyDat[0][0]) < DataMinimum:
            # aktualizacja
            SQL+="UPDATE rs_zakresy_dat SET data_minimum='"+DataMinimum+"' WHERE firma_id='"+self.firma_id+"';"

    if stat=='OK':    
        SQL+="UPDATE rs_definicje_okresow_miesiace"
        SQL+=" SET zamkniety=TRUE WHERE firma_id='"+self.firma_id+"'"
        SQL+=" AND okres_id='"+Okres+"'AND rok='"+Rok+"' AND miesiac='"+Miesiac+"';"

        stat,dump,dump,dump = self.PolSQL.Execute(SQL,1)
        
    
#-------------------------------------------------------------------------------
#---   ZMIANA NUMERACJI REJESTRU (9)
#-------------------------------------------------------------------------------

if Fun ==9 and (stat=='OK'):
    SQL="UPDATE rs_definicje_okresow_miesiace SET numerowanie_pomijac_nazwe=(NOT COALESCE(numerowanie_pomijac_nazwe,FALSE)) WHERE firma_id='"+self.firma_id+"' AND okres_id='"+Okres+"'AND rok='"+Rok+"' AND miesiac='"+Miesiac+"';"
    stat,dump,dump,dump = self.PolSQL.Execute(SQL,1)


#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH ( 5 -select,8-zamykanie)
#-------------------------------------------------------------------------------

if (Fun in [5,8,9]) and (stat=='OK'):
    # pobranie danych o dokumentach
    Select= "SELECT rok,miesiac,zamkniety,numerowanie_pomijac_nazwe FROM rs_definicje_okresow_miesiace WHERE firma_id='"+self.firma_id+"' AND okres_id='"+Okres+"' ORDER BY rok,miesiac;"
    stat,dane,wyn1,tr = self.PolSQL.Execute(Select,3)

