# -*- coding: iso8859_2 -*-
#-----------------------------------------------------------------------------
# Name:        fs_operacje_dane.py
# Purpose:     zwraca dane operacji ksiegowej wg serii
#
# Author:      Mariusz Rajfura
#
# Created:     2009/06/29
# RCS-ID:      $Id: fs_operacje_dane.py $
# Copyright:   (c) 2009 Record System
# Licence:     GNU GPL
#-----------------------------------------------------------------------------

Seria = str(rsglobal.Dekoduj(klucze[0]))
DataKsiegKosztow = rsglobal.Dekoduj(klucze[1])

stat = 'OK'
dane = []
wyn1 = []
wyn2 = []

UprWal = ((self.oddzial_id,'011130') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)
UprKth = ((self.oddzial_id,'012000') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)
UprKont = ((self.oddzial_id,'073000') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)

#Pobranie okresu dla dziaa w planie kont jeli podana jest data ksigowania kosztw
OkresAktywny=self.okres_id
if not DataKsiegKosztow in ['','    -  -  ',None]:
    if rsglobal.SprawdzCzyToData(DataKsiegKosztow):
        Select= "SELECT rsf_podaj_okres_dla_daty('"+self.firma_id+"','"+DataKsiegKosztow+"');"
        stat,DOkr,dump,dump = self.PolSQL.Execute(Select,3)
        if stat=='OK':
            if len(DOkr)>0:
                if DOkr[0][0]<> 'Brak':
                    OkresAktywny=rsglobal.Dekoduj(DOkr[0][0])



sql ="SELECT * FROM rs_operacje"
sql+=" WHERE firma_id = '"+self.firma_id+"' AND okres_id = '"+OkresAktywny+"'"
sql+=" AND seria="+Seria+";"

stat,dane,wyn1,dump = self.PolSQL.Execute(sql,3)

if stat <> 'OK':
    stat = 'Bd pobrania operacji '+Seria+' : '+stat

Waluta = ''
Kontrahent = ''
Konto = ''
KontoPrz = ''

if stat=='OK':
    
    for i in xrange(len(dane[0])):
        pole = wyn1[i][0]
        wart = str(dane[0][i])
        
        if pole == 'waluta':
            if UprWal:
                
                sql = "SELECT opis FROM rs_waluty"
                sql+=" WHERE firma_id = '"+self.firma_id+"' AND kod = '"+wart+"';"
                
                stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                
                if stat<>'OK':
                    Waluta = 'Bd pobrania waluty : '+stat
                else:
                    if d <> []:
                        Waluta = d[0][0]
            else:
                Waluta = 'Brak uprawnie do sownika.'
                
        elif pole == 'kontrahent_id':
            if UprKth:
                sql ="SELECT nazwa from rs_kontrahenci"
                sql+=" WHERE kontrahent_id = '"+wart+"'"
                sql+=" AND firma_id = '"+self.firma_id+"';"
                stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                
                if stat<>'OK':
                    Kontrahent = 'Bd pobrania kontrahenta : '+stat
                else:
                    if d <> []:
                        Kontrahent = d[0][0]
            else:
                Kontrahent = 'Brak uprawnie do kat.kontrahentw.'

        elif pole == 'konto':
            if UprKont:
                sql ="SELECT rsf_podaj_parametry_konta('"+self.firma_id+"','"+OkresAktywny+"','"+wart+"');"
                stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                
                if stat<>'OK':
                    Konto = 'Bd pobrania opisu konta '+wart+' : '+stat
                else:
                    d = rsglobal.rseval(d[0][0])
                    Konto = d[1]
            else:
                Konto = 'Brak uprawnie do planu kont.'    

        elif pole == 'konto_prz':
            if UprKont:
                sql ="SELECT rsf_podaj_parametry_konta('"+self.firma_id+"','"+OkresAktywny+"','"+wart+"');"
                stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                if stat<>'OK':
                    KontoPrz = 'Bd pobrania opisu konta '+wart+' : '+stat
                else:
                    d = rsglobal.rseval(d[0][0])
                    KontoPrz = d[1]
            else:
                KontoPrz = 'Brak uprawnie do planu kont.'

if stat=='OK':
    wyn2.append([Kontrahent,Konto,KontoPrz,Waluta])
