# -*- coding: iso8859_2 -*-
#-----------------------------------------------------------------------------
# Name:        fs_operatorzy_uprawnienia_magzyny.py
# Purpose:     operacje na oknie RSOperatorzyMagazyny.py (pobieranie danych oraz usuwanie)
# Author:      Pawe Wjcikowski
# Created:     2009/04/27
# RCS-ID:      $Id: fs_operatorzy_uprawnienia_magazyny.py $
# Copyright:   (c) 2009 Record System
# Licence:     GNU GPL
#-----------------------------------------------------------------------------

# 2018-02-09 Rafa Woniak (10536) refaktoryzacja rsoperatorzy i podokien

stat = 'OK'
if not 'Funkcja' in klucze:
    stat = 'Brak podanej funkcji w kluczach'

if stat == 'OK':
    Fun = klucze['Funkcja']
    if Fun in [5,6]:
        Operator = str(klucze['Operator'])
    if Fun in [6]:
        NrOperatora = str(klucze['NrOperatora'])
        NrMagazynu = str(klucze['NrMagazynu'])

dane = []

UprUsuwanie=(((self.oddzial_id,'001344') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID))

#---   DELETE DANYCH (6)

if stat == "OK":
    if Fun == 6 :
        if not UprUsuwanie:
            stat='UPR DEL'

        if stat=="OK":
            SQL="DELETE FROM rs_dokumenty_m_upr WHERE operator_id='"+NrOperatora+"' AND firma_id = '"+self.firma_id+"' "
            SQL+="AND magazyn_id = '"+NrMagazynu+"';"

            SQL+="DELETE FROM rs_magazyny_upr WHERE operator_id='"+NrOperatora+"' AND firma_id = '"+self.firma_id+"' "
            SQL+="AND magazyn_id = '"+NrMagazynu+"';"

            stat,dump,dump,dump = self.PolSQL.Execute(SQL,1)
            if stat!="OK":
                stat="BL DEL"
                dane.append(stat)

#---   POBRANIE DANYCH (1- insert 5 -select, 6 -delete)
if (Fun in [1,5,6]) and (stat=='OK') :
   
    if stat=="OK": 
        Select="SELECT upr.magazyn_id||' - '||mag.opis,ilosc,dostawy,dokumenty,przeceny" 
        Select+=" FROM rs_magazyny_upr upr INNER JOIN rs_magazyny mag ON upr.firma_id = mag.firma_id"
        Select+=" AND upr.magazyn_id = mag.magazyn_id WHERE upr.firma_id='"+self.firma_id+"'"
        Select+=" AND upr.operator_id="+str(Operator)+" ORDER BY upr.magazyn_id;"
        stat,dane,wyn1,tr = self.PolSQL.Execute(Select,3)
        if stat!="OK":
            stat="BL PRZ"   
            dane.append(stat)