
# -*- coding: iso8859_2 -*-

#-----------------------------------------------------------------------------
# Name:        fs_operatorzy_uprawnienia_magazyny_dokumenty_dane.py
# Purpose:     wczytuje/edytuje/zapisuje dane uprawnien do dokumentw w magazynie dla operatora
#
# Author:      Micha Raburski
# Created:     2005/11/08
# RCS-ID:      $Id: fs_operatorzy_uprawnienia_magazyny_dokumenty_dane.py $
# Copyright:   (c) 2005 Record System
# Licence:     GNU GPL
#-----------------------------------------------------------------------------


#-------------------------------------------------------------------------------
#---   INSERT DANYCH (2- bez pobierania,1- z pobieraniem)
#-------------------------------------------------------------------------------

if klucze[len(klucze)-1] == 2 or klucze[len(klucze)-1]==1:
    if (((self.oddzial_id,'001345') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID):
    #---   Sprawdzenie danych
        stat = "OK"
        dane = []
        
        #lista z kolejnymi opcjami - przegladanie,wprowadzanie,edycja,usuwanie,w na g,zamykanie,otwieranie, g na w,zmiana cen,
            #  wprowadzanie poz, edycja poz, usuwanie poz
        Lista=['False','False','False','False','False','False','False','False','False','False','False','False']
        
        for i in range(len(pola)):
            pole = pola[i]
            wart = wartosci[i]
            
            if pole=='przegladanie':
                Lista[0]=str(wart)
            elif pole=='wprowadzanie':
                Lista[1]=str(wart)
            elif pole=='edycja':
                Lista[2]=str(wart)
            elif pole=='usuwanie':
                Lista[3]=str(wart)
            elif pole=='wnag':
                Lista[4]=str(wart)
            elif pole=='zamykanie':
                Lista[5]=str(wart)
            elif pole=='otwieranie':
                Lista[6]=str(wart)
            elif pole=='gnaw':
                Lista[7]=str(wart)
            elif pole=='zmiana_ceny':
                Lista[8]=str(wart)
            elif pole=='wprowadzanie_poz':
                Lista[9]=str(wart)
            elif pole=='edycja_poz':
                Lista[10]=str(wart)
            elif pole=='usuwanie_poz':
                Lista[11]=str(wart)

            if pole=='dokument_id':
                if wart == '':
                    stat = "BR DOK"
                    dane.append(stat)
                else:
                    dump,d,dump,dump = self.PolSQL.Execute("SELECT dokument_id FROM rs_typy_dokumentow_m WHERE firma_id='"+self.firma_id+"' AND dokument_id='"+wart+"';" ,3)
                    if len(d) == 0:
                        stat = "BL DOK"
                        dane.append(stat)
                    else:
                        dump,d,dump,dump = self.PolSQL.Execute("SELECT dokument_id FROM rs_dokumenty_m_upr WHERE firma_id='"+self.firma_id+"' AND operator_id="+klucze[0]+" AND magazyn_id='"+klucze[1]+"' AND dokument_id='"+wart+"';" ,3)
                        if len(d) > 0:
                            stat = "UZ DOK"
                            dane.append(stat)

        if stat == 'OK':
            ins = "INSERT INTO rs_dokumenty_m_upr (firma_id,operator_id,magazyn_id,dokument_id,przegladanie,wprowadzanie,edycja,"
            ins+=" usuwanie,wnag,zamykanie,otwieranie,gnaw,zmiana_ceny,wprowadzanie_poz,edycja_poz,usuwanie_poz) "
            ins+=" VALUES ('"+self.firma_id+"',"+str(klucze[0])+",'"+klucze[1]+"','"+wartosci[0]+"',"
            ins+=Lista[0]+","+Lista[1]+","+Lista[2]+","+Lista[3]+","+Lista[4]+","+Lista[5]+","+Lista[6]+","+Lista[7]+","+Lista[8]+","+Lista[9]+","+Lista[10]+","+Lista[11]+");"

            stat,dump,dump,dump = self.PolSQL.Execute(ins ,1)
               
    else:
        stat='UPR INS'

#-------------------------------------------------------------------------------
#---   UPDATE DANYCH (4- bez pobierania,3- z pobieraniem)
#-------------------------------------------------------------------------------

if klucze[len(klucze)-1] == 4 or klucze[len(klucze)-1]==3:
    if (((self.oddzial_id,'001345') in self.uprawnienia) or ((self.oddzial_id,'001342') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID):
    #---   Sprawdzenie danych
        stat = "OK"
        dane = []

        if stat == 'OK':
            where = " WHERE firma_id='"+self.firma_id+"' AND operator_id="+str(klucze[0])+" AND magazyn_id='"+klucze[1]+"' AND dokument_id='"+klucze[2]+"';"
            upd = "UPDATE rs_dokumenty_m_upr SET "
        
            for i in range(len(pola)):
                pole = pola[i]
                wart = wartosci[i]
            
                if pole in ['przegladanie','wprowadzanie','edycja','usuwanie','wnag','zamykanie','otwieranie','gnaw',
                            'zmiana_ceny', 'wprowadzanie_poz','edycja_poz','usuwanie_poz']:
                    upd=upd+pole+"="+str(wart)+","

            upd = upd[0:len(upd)-1]+where
            
            stat,dump,dump,dump = self.PolSQL.Execute(upd ,1)
    else:
        stat='UPR UPD'

   

#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (5 -select, 3 -update z pobraniem, 1 -insert z pobraniem)
#-------------------------------------------------------------------------------

if (klucze[len(klucze)-1]==5) or (((klucze[len(klucze)-1]==3) or (klucze[len(klucze)-1]==1)) and (stat=='OK')):
    # pobranie danych magazynowych
    rsglobal.ZapiszDoLogow(str(klucze),1)
    stat,dane,wyn1,tr = self.PolSQL.Execute("SELECT * FROM rs_dokumenty_m_upr WHERE operator_id="+klucze[0]
        +" AND magazyn_id='"+klucze[1]+"' AND dokument_id='"+klucze[2]+"' AND firma_id='"+self.firma_id+"';",3)

    #pobranie danych do opisow

    if len(dane) == 1:
        tr = rssql.RSTableRowset(dane,wyn1)

        #--- magazyn
        if ((self.oddzial_id,'014020') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
            dump,d,dump,dump = self.PolSQL.Execute("SELECT nazwa_dokumentu FROM rs_typy_dokumentow_m WHERE firma_id='"+self.firma_id+"' AND dokument_id='"+tr.GetVal(0,"dokument_id")+"';" ,3)
            if len(d) == 0:
                wyn2.append('')
            else:
                wyn2.append(d[0][0])
        else:
            wyn2.append('Brak uprawnie do sownika. Poinformuj administratora.')
