# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_operatorzy_uprawnienia_stale_grupy_kadrowe.py
# Purpose:     obsluga grida edytowalnego
# Author:      Marcin Natkaski
# Created:     2014/08/16
# RCS-ID:      $Id: fs_boksy_trasy.py$
# Copyright:   (c) 2014 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

stat='OK'

if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=='OK':
    Funkcja = klucze['Funkcja']
    
    SlPar={'Operator':[1,5]}
    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Funkcja,klucze)
    if Lista<>'':
        stat='Uwaga : wywoanie funkcji fs_artykuly_cechy_wartosci z numerem '+str(Funkcja)+' bez parametrw: '+Lista
        
    if Funkcja in [1,5]: 
        Operator=rsglobal.Dekoduj(klucze['Operator'])
        
    if Funkcja in [8,]: 
        Grupa=rsglobal.Dekoduj(klucze['Grupa'])
        
dane = []
wyn1 = []
wyn2 = []

Puste = (None,'')

UprIns=((self.oddzial_id,'991323') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID
UprUpd=((self.oddzial_id,'991322') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID or UprIns
UprDel=((self.oddzial_id,'991324') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID

Insert = []
Update = []
Delete = []



if stat=='OK' and Funkcja == 1:
    Update=klucze['Update']
    Insert=klucze['Insert']
    Delete=klucze['Delete']


#-------------------------------------------------------------------------------
#-------  POBRANIE OPISU GRUPY (8)
#-------------------------------------------------------------------------------

if Funkcja == 8 and stat == "OK":
    sql ="SELECT opis FROM rs_kp_stale_grupy"
    sql+=" WHERE kod='"+Grupa+"';"
    stat,dane,dump,dump = self.PolSQL.Execute(sql,3)
    if stat <> 'OK':
        stat = 'Bd przy sprawdzaniu opisu grupy: '+stat
        dane.append(stat)


#-------------------------------------------------------------------------------
#-------  SPRAWDZANIE DELETE  --------------------------------------------------
#-------------------------------------------------------------------------------

if Funkcja == 1 and stat=="OK":
    if len(Delete[0])>0:
        if not UprDel:
            stat='BR UPR DEL'
            dane.append(stat)
        
        # wykonanie DELETE 
        if stat == 'OK':
            SQLDEL = ''
            SQLFU = ''
            for i in xrange(len(Delete[0])):
                DELETE = "DELETE FROM rs_grupy_stalych_upr "
                WHERE = "WHERE firma_id='"+self.firma_id+"' AND operator_id='"+str(Operator)+"' "
                SQLFU = "SELECT firma_id FROM rs_grupy_stalych_upr"
                SQLFU+= " WHERE firma_id='"+self.firma_id+"' AND operator_id='"+str(Operator)+"' "
                for j in xrange(len(Delete[0][i])):
                    pole = Delete[1][j]
                    wart = Delete[0][i][j]
                    if pole in ['grupa',]:
                        WHERE += " AND "+pole+"='"+wart+"'"
                        SQLFU += " AND "+pole+"='"+wart+"'"

                SQLDEL += DELETE+WHERE+"; "
                SQLFU += " FOR UPDATE NOWAIT; "

            if SQLFU <> '':
                stat,d,dump,dump = self.PolSQL.Execute(rsglobal.Dekoduj(SQLFU),3)
                if stat <> 'OK':
                    stat = 'Bd sprawdzenia danych do usunicia: '+stat
                    dane.append(stat)
            
            if stat == 'OK' and SQLDEL <> '':
                stat,dump,dump,dump = self.PolSQL.Execute(rsglobal.Dekoduj(SQLDEL),1)
                if stat <> 'OK':
                    stat = "Bd przy usuwaniu danych: "+stat   
                    dane.append(stat)

                                 
#-------------------------------------------------------------------------------
#---   UPDATE DANYCH (1)
#-------------------------------------------------------------------------------

if Funkcja == 1 and stat=="OK":
    if len(Update[0])>0:
        if not UprUpd:
            stat='BR UPR UPD'
            dane.append(stat)

        if stat == 'OK':
            SQLFU = ''
            for i in xrange(len(Update[0])):
                SQLFU+= "SELECT operator_id FROM rs_grupy_stalych_upr"
                SQLFU+= " WHERE firma_id='"+self.firma_id+"' AND operator_id='"+str(Operator)+"' "
                for j in xrange(len(Update[2][i])): # petla po kluczu
                    pole = Update[3][j]
                    wart = rsglobal.Dekoduj(Update[2][i][j])
                    SQLFU += " AND "+pole+"='"+str(wart)+"'"
                SQLFU += " FOR UPDATE NOWAIT; "
            
            if SQLFU <> '':
                stat,dFU,nFU,dump = self.PolSQL.Execute(rsglobal.Dekoduj(SQLFU),3)
                if stat <> 'OK':
                    stat = 'Bd sprawdzenia danych do modyfikacji: '+stat
                    dane.append(stat)

        if stat == 'OK':
            WierszeNr = Update[-1]
            for i in xrange(len(Update[0])):
                for j in xrange(len(Update[0][i])): 
                    pole = Update[0][i][j]
                    wart = Update[1][i][j]

                    if pole == 'grupa':
                        wart = wart.strip()
                        OddzialNowy = str(wart)
                        SprOddzial = OddzialNowy
                        if wart == '':
                            stat = 'BR GR'
                            wyn2.append((WierszeNr[i],0))
                            dane.append(stat)
                        else:
                            sql ="SELECT kod FROM rs_kp_stale_grupy "
                            sql+=" WHERE kod = '"+str(wart)+"' ;" 
                            stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                            if stat <> 'OK':
                                stat = 'BL SQL GR'
                                wyn2.append((WierszeNr[i],0))
                                dane.append(stat)
                            elif len(d) == 0:
                                stat = 'BL GR'
                                wyn2.append((WierszeNr[i],0))
                                dane.append(stat)

                if stat == 'OK':
                    if len(dane) > 0:
                        stat = dane[0]
                
                # wykonanie UPDATE
                if stat=='OK':
                    sql=''
                    UPDATE="UPDATE rs_grupy_stalych_upr "
                    SET='SET '
                    for j in xrange(len(Update[0][i])): 
                        pole=Update[0][i][j]
                        wart=Update[1][i][j]
    
                        if pole in ['grupa',]:
                            SET+=pole+"='"+wart+"',"
    
                        elif pole in ['czy_edytowac']:
                            SET+=pole+"="
                            if wart == 0:
                                SET+="FALSE,"
                            else:
                                SET+="TRUE,"
                        
                    SET=SET.strip(",")
                    WHERE=" WHERE firma_id='"+self.firma_id+"' AND operator_id='"+str(Operator)+"' " 
                    for j in xrange(len(Update[2][i])): # petla po kluczu
                        pole=Update[3][j]
                        wart=rsglobal.Dekoduj(Update[2][i][j])
                        if pole in ['grupa',]:
                            WHERE+=" AND "+pole+"='"+wart+"'"
                        
                    WHERE+=";"
                        
                    sql+=UPDATE+SET+WHERE
                        
                    stat,dump,dump,dump = self.PolSQL.Execute(rsglobal.Dekoduj(sql),1)
                    if stat<>'OK':
                        stat="Istnieje ju wpis o podanym kluczu: "+stat   
                        dane.append(stat)
                    

#-------------------------------------------------------------------------------
#---------Sprawdzanie danych do Insert------
#-------------------------------------------------------------------------------

if Funkcja == 1 and stat=="OK":
    if len(Insert[0])>0:
        if not UprIns:
            stat='BR UPR INS'
            dane.append(stat)

        if stat == 'OK':
            WierszeNr = Insert[-1]
            for i in xrange(len(Insert[0])):
                for j in xrange(len(Insert[0][i])): 
                    pole=Insert[1][j]
                    wart=Insert[0][i][j]
                    
                    if pole == 'grupa':
                        wart = wart.strip()
                        #OddzialNowy = str(wart)
                        if wart == '':
                            stat = 'BR GR'
                            wyn2.append((WierszeNr[i],0))
                            dane.append(stat)
                        else:
                            sql ="SELECT kod FROM rs_kp_stale_grupy "
                            sql+=" WHERE kod = '"+str(wart)+"' ;" 
                            #print 'takie jest sql sprawdzajace grupe  ',sql
                            stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                            if stat <> 'OK':
                                stat = 'BL SQL GR'
                                wyn2.append((WierszeNr[i],0))
                                dane.append(stat)
                            elif len(d) == 0:
                                stat = 'BL GR'
                                wyn2.append((WierszeNr[i],0))
                                dane.append(stat)

                # sprawdzenie, czy nie ma bledow
                if stat == 'OK':
                    if len(dane) > 0:
                        stat = dane[0]
        
                # wykonanie INSERT do pojedynczego wiersza
                if stat == 'OK':    
                    sqlIns=''
                    INSERT="INSERT INTO rs_grupy_stalych_upr "
                    KOLUMNY="(firma_id, operator_id"
                    VALUES=" VALUES ('"+self.firma_id+"','"+str(Operator)+"' "

                    for j in xrange(len(Insert[0][i])): 
                        pole=Insert[1][j]
                        wart=Insert[0][i][j]

                        if pole in ['grupa',]:
                            KOLUMNY+=","+pole
                            VALUES+=",'"+wart+"'"
                        
                        elif pole in ['czy_edytowac',]:
                            KOLUMNY+=","+pole
                            VALUES+=",'"+str(wart)+"'"
    
                    KOLUMNY+=")"
                    VALUES+=");"
                    sqlIns+=INSERT+KOLUMNY+VALUES
                    
                if stat == 'OK' and sqlIns<>'': 
                    stat,dump,dump,dump=self.PolSQL.Execute(rsglobal.Dekoduj(sqlIns),1)
                    if stat<>'OK':
                        stat="Bd przy dodawaniu danych: "+stat   
                        dane.append(stat)

#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (1- insert 1 -select, 1 -delete), (5-odczyt)
#-------------------------------------------------------------------------------

if Funkcja in (1,5) and stat == 'OK':
    SQL ="SELECT a.grupa,b.opis,a.czy_edytowac"
    SQL+=" FROM rs_grupy_stalych_upr a "
    SQL+="INNER JOIN rs_kp_stale_grupy b "
    SQL+="ON (grupa=kod)"
    SQL+=" WHERE firma_id='"+self.firma_id+"' and operator_id = '"+str(Operator)+"'"
    SQL+=" ORDER BY grupa;"
    stat,dane,wyn1,wyn2 = self.PolSQL.Execute(SQL,3)
    if stat <> 'OK':
        stat = "Bd przy pobieraniu danych: "+stat
        dane.append(stat)