# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_operatorzy_uprawnienia_wyznaczniki_dane.py
# Purpose:     wczytuje/edytuje/zapisuje dane uprawnien do wyznacznikw dla operatora
#
# Author:      Micha Raburski
# Created:     2007/02/28
# RCS-ID:      $Id: fs_operatorzy_uprawnienia_wyznaczniki_dane.py $
# Copyright:   (c) 2007 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

# 2011-10-03 Mariusz Rajfura  dodawanie listy wyznacznikow (5069)

Oper = str(klucze[0])
Wyzn = str(klucze[1])
ListaWyznacznikow = klucze[2]
ListaCheckboxow = klucze[3]

Fun = klucze[-1]

stat = "OK"
dane = []
wyn1 = []
wyn2 = []


#-------------------------------------------------------------------------------
# Sprawdzenie uprawnien
#-------------------------------------------------------------------------------

if Fun in (1,2,11) and stat == 'OK':
    if not ((self.oddzial_id,'001382') in self.uprawnienia or (self.oddzial_id,'001342') in self.uprawnienia or self.operator_id==STANDARD_OPERATOR_ID):
        stat='UPR INS'

if Fun in (3,4) and stat == 'OK':
    if not ((self.oddzial_id,'001382') in self.uprawnienia or (self.oddzial_id,'001342') in self.uprawnienia or self.operator_id == STANDARD_OPERATOR_ID):
        stat='UPR UPD'


#-------------------------------------------------------------------------------
#---   INSERT DANYCH (2- bez pobierania,1- z pobieraniem)
#-------------------------------------------------------------------------------

if Fun in [1,2] and stat=='OK':
    for i in range(len(pola)):
        pole = pola[i]
        wart = wartosci[i]
    
        if pole== "wyznacznik_id":
            if wart=='':
                stat = "BR WYZN"
                dane.append(stat)
            else:
                dump,d,dump,dump = self.PolSQL.Execute("SELECT wyznacznik_id FROM rs_wyznaczniki WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+wart+"';" ,3)
                if len(d) == 0:
                    stat = "BL WYZN"
                    dane.append(stat)
                else:
                    dump,d,dump,dump = self.PolSQL.Execute("SELECT wyznacznik_id FROM rs_wyznaczniki_upr WHERE firma_id='"+self.firma_id+"' AND operator_id="+Oper+" AND wyznacznik_id='"+wart+"';" ,3)
                    if len(d) <> 0:
                        stat = "UZ WYZN"
                        dane.append(stat)
       
    if stat =='OK':    
        # przygotowanie listy pol
        Ins="INSERT INTO rs_wyznaczniki_upr (firma_id,operator_id,wyznacznik_id,przegladanie,wprowadzanie,edycja,usuwanie,zamykanie,otwieranie) "
        Ins=Ins+"VALUES ('"+self.firma_id+"',"+Oper+",'"+Wyzn+"',"+str(wartosci[1])+","+str(wartosci[2])+","+str(wartosci[3])+","+str(wartosci[4])+","+str(wartosci[5])+","+str(wartosci[6])+");"
        
        stat,dump,dump,dump = self.PolSQL.Execute(Ins ,1)


#-------------------------------------------------------------------------------
#---   UPDATE DANYCH (4- bez pobierania,3- z pobieraniem)
#-------------------------------------------------------------------------------

if Fun in [3,4] and stat=='OK':
    #---   Sprawdzenie danych
    stat = "OK"
    dane = []

    if stat == 'OK':
        where = " WHERE firma_id='"+self.firma_id+"' AND operator_id="+Oper+" AND wyznacznik_id='"+Wyzn+"';"
        upd = "UPDATE rs_wyznaczniki_upr SET "
        for i in range(len(pola)):
            pole = pola[i]
            wart = wartosci[i]
        
            if pole in ['przegladanie','wprowadzanie','edycja',
                        'usuwanie','zamykanie','otwieranie']:
                upd=upd+pole+"="+str(wart)+","

        upd = upd[0:len(upd)-1]+where
        
        stat,dump,dump,dump = self.PolSQL.Execute(upd ,1)


#-------------------------------------------------------------------------------
# Dodanie listy wyznacznikow (11)
#-------------------------------------------------------------------------------

if Fun == 11 and stat == 'OK':
    if not ((self.oddzial_id,'001382') in self.uprawnienia or (self.oddzial_id,'001342') in self.uprawnienia or self.operator_id==STANDARD_OPERATOR_ID):
        stat='UPR INS'

    if len(ListaWyznacznikow) == 0:
        stat = 'BL PUSTA LISTA'
        dane.append(stat)

    if stat == 'OK':
        INSLIST = ''
        LJuzByly = []
        
        for NowyWyzn in ListaWyznacznikow:
            # sprawdzenie pojedynczego wyznacznika, aby dodac te, ktrych operator
            # jeszcze nie posiada
            
            NowyWyzn = rsglobal.Dekoduj(NowyWyzn)
            
            sql ="SELECT wyznacznik_id FROM rs_wyznaczniki_upr"
            sql+=" WHERE firma_id='"+self.firma_id+"' AND operator_id="+Oper
            sql+=" AND wyznacznik_id='"+NowyWyzn+"';"

            stat,dWyzn,dump,dump = self.PolSQL.Execute(sql,3)
            if stat <> 'OK':
                stat = 'Bd sprawdzenia wyznacznika dla operatora: '+stat
                dane.append(stat)
                break
            elif len(dWyzn) == 0:
                INSLIST+="INSERT INTO rs_wyznaczniki_upr"
                INSLIST+=" (firma_id,operator_id,wyznacznik_id,"
                INSLIST+="  przegladanie,wprowadzanie,edycja,"
                INSLIST+="  usuwanie,zamykanie,otwieranie)"
                INSLIST+=" VALUES"
                INSLIST+=" ('"+self.firma_id+"',"+Oper+",'"+NowyWyzn+"',"
                INSLIST+="  "+str(ListaCheckboxow[0])+","+str(ListaCheckboxow[1])+","+str(ListaCheckboxow[2])+","
                INSLIST+="  "+str(ListaCheckboxow[3])+","+str(ListaCheckboxow[4])+","+str(ListaCheckboxow[5])+");"
            else:
                LJuzByly.append(NowyWyzn)
        
    if stat == 'OK':
        wyn2.append(LJuzByly)
        # moze tak byc, ze wybrane do dodanie wyznaczniki juz sa przydzielone
        # do operatora, wiec nie ma nic do dodania
        if INSLIST <> '':
            stat,dump,dump,dump = self.PolSQL.Execute(INSLIST,1)
            if stat <> 'OK':
                stat = 'Bd dodawania listy wyznacznikw: '+stat
                dane.append(stat)


#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (5 -select, 3 -update z pobraniem, 1 -insert z pobraniem)
#-------------------------------------------------------------------------------

if (klucze[-1] in [1,3,5]) and (stat=='OK'):
    if (((self.oddzial_id,'001380') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID):
        # pobranie danych uprawnien
        stat,dane,wyn1,tr = self.PolSQL.Execute("SELECT * FROM rs_wyznaczniki_upr WHERE firma_id='"+self.firma_id+"' AND operator_id="+Oper
                +" AND wyznacznik_id='"+klucze[1]+"';",3)

        #pobranie danych do opisow

        if len(dane) == 1:
            tr = rssql.RSTableRowset(dane,wyn1)

            #--- okres
            #if ((self.oddzial_id,'014020') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
            #    dump,d,dump,dump = self.PolSQL.Execute("SELECT nazwa_dokumentu FROM rs_typy_dokumentow_m WHERE firma_id='"+self.firma_id+"' AND dokument_id='"+tr.GetVal(0,"dokument_id")+"';" ,3)
            #    if len(d) == 0:
            #        wyn2.append('')
            #    else:
            #        wyn2.append(d[0][0])
            #else:
            #    wyn2.append('Brak uprawnie do sownika. Poinformuj administratora.')
    else:
        stat='UPR SEL'