# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_pan_pomocnicze.py
# Purpose:     plik z roznymi funkcjami dla panelu, ktore nie wymagaja uprawnien
# Author:      Mariusz Rajfura
# Created:     2013/11/04
# RCS-ID:      $Id: fs_pan_pomocnicze.py
# Copyright:   (c) 2013 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

dane = []
wyn1 = []
wyn2 = []
stat = 'OK'

if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=='OK':
    Fun = klucze['Funkcja']
    
    SlPar={'ListaLinii':[1],}
    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Fun,klucze)
    if Lista<>'':
        stat='Uwaga : wywoanie funkcji fs_zamowienia_odbiorcy_import_z_xls_sap z numerem '+str(Fun)+' bez parametrw: '+Lista


if stat=='OK':
    if Fun == 1:
        ListaLinii = klucze['ListaLinii']


#-------------------------------------------------------------------------------
# Pobranie listy linii produkcyjnych (1)
#-------------------------------------------------------------------------------

if Fun == 1 and stat == 'OK':
    # Pobranie listy linii produkcyjnych z wyjatkiem linii podanych jako parametr
    # To np. pozwala ominac linie, na ktorych operator jest zalogowany, ale ma
    # zawieszona sesje.

    sql ="SELECT kod,COALESCE(opis) FROM rs_linie_produkcyjne"
    sql+=" WHERE firma_id='"+self.firma_id+"'"
    if len(ListaLinii) > 0:
        sql+=" AND NOT kod IN ("
        for l in ListaLinii:
            sql+="'"+rsglobal.Dekoduj(l)+"',"
            
        sql = sql[:-1]+")"
    sql+=" ORDER BY kod; "
    
    stat,dane,wyn1,dump = self.PolSQL.Execute(sql,3)
    if stat <> 'OK':
        stat = 'Bd pobrania linii produkcyjnych: '+stat
    else:
        # dodanie opcji dla ogladania wszystkich linii
        dane.append(['','Wszystkie linie produkcyjne'])
