# -*- coding: iso8859_2 -*-

#-----------------------------------------------------------------------------
# Name:        fs_paragony_fiskalne_dane.py
# Purpose:     edytuje dane paragonu fiskalnego
#
# Author:      Dariusz Boduch
# Created:     2009/02/27
# RCS-ID:      $Id: fs_paragony_fiskalne_dane.py $
# Copyright:   (c) 2004-2007 Record System
# Licence:     GNU GPL
#-----------------------------------------------------------------------------

#2019-12-16 Mikoaj Kozowski - dodanie obsugi pola nip

#klucze = [Oddzial,Kasa,Data,Nr,funkcja]

stat='OK'
Oddzial=rsglobal.Dekoduj(klucze[0])
Kasa=rsglobal.Dekoduj(klucze[1])
Data=rsglobal.Dekoduj(klucze[2])
Nr=klucze[3]
Kontrahent=rsglobal.Dekoduj(klucze[4])
PNIP=rsglobal.Dekoduj(klucze[5])

Fun=klucze[-1]
stat='OK'

UprEdycja=((self.oddzial_id,'025012') in self.uprawnienia) or ((self.oddzial_id,'025013') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)

        
#-------------------------------------------------------------------------------
#---   UPDATE DANYCH (4- bez pobierania,3- z pobieraniem)
#-------------------------------------------------------------------------------

if Fun in [3,4] and (stat=='OK'):
    if not UprEdycja:
        stat='UPR UPD'

    Wersja=''
    rsglobal.ZapiszDoLogow(pola)
    rsglobal.ZapiszDoLogow(wartosci)
    if stat=='OK':
        for i in range(len(pola)):
            pole = pola[i]
            wart = wartosci[i]
            if pole == "wersja":
                if wart=='':
                    wartosci[i]='NULL'
                else:
                    stat,danew,dump,dump = self.PolSQL.Execute("SELECT kod FROM rs_wersje_cenowe WHERE firma_id='"+self.firma_id+"' AND kod='"+wart+"';",3)
                    if stat=='OK':
                        if len(danew)==0:
                            stat='BL WER'
                        else:
                            wartosci[i] = "'" + wart + "'"
                            Wersja=wart
        
            if pole == "kontrahent_id":
                if wart=='':
                    wartosci[i]='NULL'
                else:
                    stat,danew,dump,dump = self.PolSQL.Execute("SELECT kontrahent_id,nip FROM rs_kontrahenci WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+wart+"';",3)
                    if stat=='OK':
                        if len(danew)==0:
                            stat='BL KONTR'
                        else:
                            wartosci[i] = "'" + wart + "'"

            #sprawdzanie nipu
            #MK 2019-12-16

            if pole == 'nip':
                if re.sub('[^0-9]', '', wart) != '':
                    wart = re.sub('[^0-9]', '', wart)
                    stat = rsglobal.SprNip(wart)
                    rsglobal.ZapiszDoLogow(wart)
                    rsglobal.ZapiszDoLogow(stat)
                    if stat != 'OK':
                        dane.append(stat)
                    else:
                        wartosci[i] = "'" + wart + "'"
                else:
                    wartosci[i] = "'" + wart + "'"
    if stat=='OK':    
        where= " WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+self.oddzial_id+"'"
        where+=" AND kasa_id='"+Kasa+"' AND data='"+Data+"' AND numer="+str(Nr)+";"
        upd = "UPDATE rs_paragony_fiskalne SET "
    
        for i in range(len(pola)):
            pole = pola[i]
            wart = wartosci[i]


        
            upd=upd+pole+"="+str(wart)+","
        upd = upd[0:len(upd)-1]+where
        rsglobal.ZapiszDoLogow(upd)
        stat,dump,dump,dump = self.PolSQL.Execute(upd ,1)
        if stat<>'OK':
            stat='BL UPD$'+stat
            dane.append(stat)
    
        
    #przeliczanie wersji cenowej
    if stat=='OK':
        if Wersja<>'':
            SELECT="SELECT pp.nr_poz, pp.artykul_id, pp.rabat, a.stawka_vat "
            SELECT+="FROM rs_paragony_fiskalne_pozycje pp "
            SELECT+="LEFT OUTER JOIN rs_artykuly a ON (pp.firma_id=a.firma_id AND pp.artykul_id=a.artykul_id) "
            SELECT+="WHERE pp.firma_id='"+self.firma_id+"' AND pp.oddzial_id='"+self.oddzial_id+"' AND pp.kasa_id='"+Kasa+"' AND pp.data='"+Data+"' AND pp.numer="+str(Nr)+" ;"
            stat,danep,dump,dump = self.PolSQL.Execute(SELECT,3)
            
            if stat=='OK':
                for w in danep:
                    cny="SELECT rsf_podaj_ceny('"+self.firma_id+"','"+rsglobal.Dekoduj(w[1])+"','"+Wersja+"','PLN','"+Data+"') ;"
                    stat,danec,dump,dump = self.PolSQL.Execute(cny,3)
                    if stat=='OK':
                        c=eval(danec[0][0])
                        CenaBr="round(("+str(c[2])+" - (("+str(c[2])+" * "+str(w[2])+")/100))+0.00001,2)"
                        WartBr="round(("+CenaBr+"*ilosc1)+0.00001,2)"
                        WartVat="round(("+WartBr+"*"+str(w[3])+" / ( 100 + "+str(w[3])+"))+0.00001,2)"
                        UPDT="UPDATE rs_paragony_fiskalne_pozycje SET "
                        UPDT+="cena_przed_rabatem1 = "+str(c[0])+","
                        UPDT+="cena_przed_rabatem2 = "+str(c[1])+","
                        UPDT+="cena_netto1 = round("+str(c[0])+" - (("+str(c[0])+" * "+str(w[2])+")/100),2), "
                        UPDT+="cena_netto2 = round("+str(c[1])+" - (("+str(c[1])+" * "+str(w[2])+")/100),2), "
                        UPDT+="cena_brutto1 = "+CenaBr+", "
                        UPDT+="cena_brutto2 = round("+str(c[3])+" - (("+str(c[3])+" * "+str(w[2])+")/100),2), "
                        UPDT+="wartosc_brutto = "+WartBr+", "
                        UPDT+="wartosc_vat = "+WartVat+", "
                        UPDT+="wartosc_netto =round("+WartBr+"-"+WartVat+",2) "
                        UPDT+=" WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+self.oddzial_id+"' AND kasa_id='"+Kasa+"' AND data='"+Data+"' AND numer="+str(Nr)+" AND nr_poz="+str(w[0])+";"
                        stat,dump,dump,dump = self.PolSQL.Execute(UPDT,1)
           

#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (5 -select, 3 -update z pobraniem)
#-------------------------------------------------------------------------------

if (klucze[-1] in [5,3]) and (stat=='OK'):
    # pobranie danych paragonu fiskalnego
    stat,dane,wyn1,tr = self.PolSQL.Execute("SELECT * FROM rs_paragony_fiskalne WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+self.oddzial_id+"' AND kasa_id='"+Kasa+"' AND data='"+Data+"' AND numer="+str(Nr)+";",3)

#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH 15 - select do pobrania nipu
#-------------------------------------------------------------------------------

if (klucze[-1] in [15]) and (stat=='OK'):
    # pobranie nipu na podstawie kontrahent_id
    stat,danen,dump,dump = self.PolSQL.Execute("SELECT nip FROM rs_kontrahenci WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+Kontrahent+"';",3)
    if stat=='OK':
        if danen:
            NIPU=danen[0][0]
            dane=[NIPU]
    else:
        stat='Bd pobrania NIP dla kontrahenta: ' + stat
