# -*- coding: iso8859_2 -*-

#-----------------------------------------------------------------------------
# Name:        fs_paragony_fiskalne_pozycje.py
# Purpose:     wczytuje/usuwa dane pozycji paragonw fiskalnych
#
# Author:      Micha Raburski
# Created:     2007/04/26
# RCS-ID:      $Id: fs_paragony_fiskalne_pozycje.py $
# Copyright:   (c) 2007 Record System
# Licence:     GNU GPL
#-----------------------------------------------------------------------------
# 2019-04-29 (11479) Aleksander Bargie - Bd w pozycjach paragonu fiskalnego w firmie, ktra nie korzysta z 2 jm.

#klucze=[Poz,OddzialF,KasaF,DataF,NumerF,ArtykulF,DwieJm,funkcja]

Poz=klucze[0]
OddzialF=rsglobal.Dekoduj(klucze[1])
KasaF=rsglobal.Dekoduj(klucze[2])
DataF=rsglobal.Dekoduj(klucze[3])
NumerF=klucze[4]
ArtF=rsglobal.Dekoduj(klucze[5])
DwieJm=klucze[6]

Fun=klucze[-1]

stat = "OK"
dane = []

Filtr = " firma_id = '" + self.firma_id + "'"

#DELETE
if (Fun==6):
    if ((self.oddzial_id,'025024') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
        Filtr = " firma_id = '" + self.firma_id + "' AND oddzial_id ='" +OddzialF+ "' AND kasa_id ='" +KasaF+ "' AND data = '" +DataF+ "' AND numer = " +str(NumerF)
        sql="SELECT stan FROM rs_paragony_fiskalne WHERE "+Filtr
        stat,DStan,wyn1,wyn2=self.PolSQL.Execute(sql,3)
        if len(DStan)==0:
            stat="US PAR"
            dane.append(stat)
        elif DStan[0][0]=='Z':
            stat="US ZAM"
            dane.append(stat)
            
        if stat=='OK':
            sql = "DELETE FROM rs_paragony_fiskalne_pozycje WHERE"+Filtr+" AND nr_poz="+str(Poz)+";"
            stat,dump,dump,dump=self.PolSQL.Execute(sql,1)  
        if stat!="OK":
            stat="BL US"
            dane.append(stat)
        else:
            Filtr = " firma_id='" + self.firma_id + "' AND oddzial_id='" +OddzialF+ "' AND kasa_id ='" +KasaF+ "' AND data='"+DataF+"' AND numer=" +str(NumerF)+" AND nr_poz>" +str(Poz)
            sql = "UPDATE rs_paragony_fiskalne_pozycje SET nr_poz=nr_poz-1 WHERE"+Filtr+";"
            stat,dump,wyn1,wyn2=self.PolSQL.Execute(sql,1)
    else:
        stat="UPR US"   
        dane.append(stat)
        

#---   POBRANIE DANYCH (5 -select,6-delete)
if (Fun in [5,6]) and stat=='OK':
    Pola="pfp.nr_poz,pfp.artykul_id||' - '||a.nazwa,COALESCE(pfp.cecha1_opis,''),COALESCE(pfp.cecha1_wartosc,''),rsf_podaj_parametry_cechy(pfp.firma_id,pfp.cecha1_opis,pfp.cecha1_wartosc,'opis'),pfp.ilosc1,pfp.rabat,pfp.cena_przed_rabatem1,pfp.cena_netto1,pfp.cena_brutto1,"
    Pola+="pfp.stawka_vat,pfp.wartosc_netto,pfp.wartosc_vat,pfp.wartosc_brutto"
    #AB 29.04.18r
    # if DwieJm:
    Pola+=",pfp.ilosc2,pfp.cena_przed_rabatem2,pfp.cena_netto2,pfp.cena_brutto2,pfp.artykul_id||' - '||a.nazwa"
    
    Filtr = "pfp.firma_id='"+self.firma_id+"' AND pfp.oddzial_id='"+OddzialF+"' AND pfp.kasa_id ='" +KasaF+ "' AND pfp.data='"+DataF+"' AND pfp.numer="+str(NumerF)+" "
    if ArtF<>'':
        Filtr += "AND pfp.artykul_id LIKE '"+ArtF+"%'"

    sql = "SELECT "+Pola+" FROM rs_paragony_fiskalne_pozycje pfp INNER JOIN rs_artykuly a USING(firma_id,artykul_id) WHERE "+Filtr+" ORDER BY pfp.nr_poz;"
    stat,dane,wyn1,wyn2=self.PolSQL.Execute(sql,3)