# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_pobierz_upr_oddzialy_pom.py
# Purpose:     pobiera liste uprawninych oddzialw 
#
# Author:      Jarek Plawgo
# Created:     2006/01/10
# RCS-ID:      $Id: fs_pobierz_upr_oddzialy_pom.py $
# Copyright:   (c) 2005 Cybertronika
# Licence:     GNU GPL
#-------------------------------------------------------------------------------
#2013-06-14 Mariusz Rajfura (6915) uprawnienia do receptur: udostepnienie jako funkjca w fs-ach


#-------------------------------------------------------------------------------

def UprawnieniaDlaOddzialu(obj,oddzial,Lista=[]):
     ListaUprawnien=Lista[:]
     sql="SELECT grupa_id FROM rs_grupa_operator_oddzial"
     sql+=" WHERE firma_id='"+obj.firma_id+"' AND operator_id IN "+str(obj.operatorzy).replace("[","(").replace("]",")")
     sql+=" AND oddzial_id='"+oddzial+"';"
     
     stat,grupy,dump,dump = obj.PolSQL.Execute(str(sql),2)
     for row in grupy:
        sql="""SELECT menu_id FROM rs_grupa_menu 
        WHERE firma_id='%s' AND grupa_id='%s' AND menu_id LIKE ('04____');"""%(obj.firma_id,row[0])
        stat,uprawnienia,dump,dump = obj.PolSQL.Execute(str(sql),2)
        for row2 in uprawnienia:
            if not (row2[0] in  ListaUprawnien):      
                ListaUprawnien.append(row2[0])
     return ListaUprawnien           

#-------------------------------------------------------------------------------

def PobierzUprawnioneOddzialy(obj):
    import const
    import rsglobal
    
    global UprawnieniaDlaOddzialu
    
    stat = 'OK'
    dane = []
    wyn1 = []
    wyn2 = []

    if obj.operator_id == const.STANDARD_OPERATOR_ID:
         sql="SELECT  oddzial_id,opis FROM rs_oddzialy WHERE firma_id='%s';"%(obj.firma_id)
         stat,oddzialy,dump,dump = obj.PolSQL.Execute(sql,2)
    
         sql="SELECT  menu_id FROM rs_menu WHERE menu_id LIKE '04____';"
         stat,uprawnienia,dump,dump = obj.PolSQL.Execute(sql,2)
         ListUprawnienia=[]
         
         for row in uprawnienia:
            ListUprawnienia.append(row[0]) 
         dane=[]
         
         for row in oddzialy:
             row.append(ListUprawnienia)
             dane.append(row)
    else:
        sql="SELECT oddzial_id FROM rs_grupa_operator_oddzial "
        sql+="WHERE oddzial_id='**' AND firma_id='"+obj.firma_id+"'"
        sql+=" AND operator_id in "+str(obj.operatorzy).replace("[","(").replace("]",")")+";"
        stat,dane,dump,dump = obj.PolSQL.Execute(sql,2)
        rsglobal.ZapiszDoLogow(dane,5)
        if len(dane)>0:
            sql="SELECT  oddzial_id,opis FROM rs_oddzialy WHERE firma_id='%s';"%(obj.firma_id)
            stat,oddzialy,dump,dump = obj.PolSQL.Execute(str(sql),2)
            dane=[]
            upr=UprawnieniaDlaOddzialu(obj,'**')
            for row in oddzialy:
                uprawnienia=UprawnieniaDlaOddzialu(obj,unicode(row[0]),upr)
                row.append(uprawnienia)  
                dane.append(row)
            
        else:
            sql="SELECT rs_grupa_operator_oddzial.oddzial_id,rs_oddzialy.opis "
            sql+="FROM rs_grupa_operator_oddzial INNER JOIN rs_oddzialy  ON "
            sql+="rs_grupa_operator_oddzial.firma_id=rs_oddzialy.firma_id and "
            sql+="rs_grupa_operator_oddzial.oddzial_id=rs_oddzialy.oddzial_id "
            sql+="WHERE rs_oddzialy.firma_id='"+obj.firma_id+"' AND rs_grupa_operator_oddzial.operator_id in "+str(obj.operatorzy).replace("[","(").replace("]",")")+" "
            sql+="GROUP BY rs_grupa_operator_oddzial.oddzial_id,rs_oddzialy.opis;"
            stat,oddzialy,dump,dump = obj.PolSQL.Execute(sql,3)
            dane=[]
            ListUprawnienia=["040000"]
            
            for row in oddzialy:
                uprawnienia=UprawnieniaDlaOddzialu(obj,row[0],ListUprawnienia)
                row.append(uprawnienia)  
                dane.append(row)
            dane=[[u'**',u"Wszystkie oddzia\u0142y",ListUprawnienia]]+dane
    if stat!="OK":
       stat="BL_SQL"   
       dane.append(stat)
    
    return stat,dane,wyn1,wyn2

#-------------------------------------------------------------------------------
