
# -*- coding: iso8859_2 -*-

#-----------------------------------------------------------------------------
# Name:        fs_pokaz_grida.py
# Purpose:     wczytuje dane do grida zgodnie z podan funkcj
#
# Author:      Micha Raburski
# Created:     2008/09/13
# RCS-ID:      $Id: fs_pokaz_grida.py $
# Copyright:   (c) 2008 Record System
# Licence:     GNU GPL
#-----------------------------------------------------------------------------

Fun = klucze[-1]

stat='OK'
dane=[]

#----------------------------
# ILO ZAMWIONA W DRODZE - Z ANALIZY STANW  (1) 
#----------------------------
if (Fun==1) and (stat=='OK'):
    if not (((self.oddzial_id,'013013') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)):
        stat=='UPR SEL'

    if stat=='OK' and len(klucze) <> 4:
        stat=='BL PAR'

    if stat=='OK':
        Artykul=rsglobal.Dekoduj(klucze[0])
        Zamiennik=rsglobal.Dekoduj(klucze[1])
        CzyZamienniki=klucze[2]
        
        Filtr="WHERE zp.firma_id='"+self.firma_id+"' AND zp.ilosc1-zp.dostarczono1-zp.anulowano1>0 " 
        Filtr+=" AND z.stan <> 'W'"
        if CzyZamienniki:
            Filtr+=" AND (zp.artykul_id='"+Zamiennik+"' OR a.zamiennik_id='"+Zamiennik+"')"
        else:
            Filtr+=" AND zp.artykul_id='"+Artykul+"'"
        
        NumerP="rsf_podaj_numer_dokumentu_na_wydruk('"+self.firma_id+"', '[\"'||z.wyznacznik_id||'\",\"'||data||'\",'||numer||']','D')"
        
        SQL="SELECT zp.artykul_id,a.nazwa,zp.ilosc1-zp.dostarczono1-zp.anulowano1,a.jm1,"
        SQL+="zp.ilosc2-zp.dostarczono2-zp.anulowano2,a.jm2,z.data,z.data_odbioru,z.kontrahent_id,"
        SQL+=NumerP+" FROM rs_zamowienia_dostawcy_pozycje zp INNER JOIN rs_zamowienia_dostawcy z "
        SQL+=" USING (firma_id,wyznacznik_id,data,numer) INNER JOIN rs_artykuly a USING (firma_id,artykul_id) "
        SQL+=Filtr+" ORDER BY artykul_id,z.data_odbioru"

        stat,dane,wyn1,tr = self.PolSQL.Execute(SQL,3)

#----------------------------
# ILO ZAMWIONA PRZEZ ODBIORCW - Z ANALIZY STANW  (2) I Z ZUYCIA 1/3 (5) 
#----------------------------

elif (Fun in [2,5]) and (stat=='OK'):
    if not (((self.oddzial_id,'013013') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)):
        stat=='UPR SEL'

    if stat=='OK' and len(klucze) <> 4:
        stat=='BL PAR'

    if stat=='OK':
        Artykul=rsglobal.Dekoduj(klucze[0])
        Zamiennik=rsglobal.Dekoduj(klucze[1])
        CzyZamienniki=klucze[2]
        DataZam=''
        MagZam=''
        if Fun==5:
            DataZam=klucze[3]
            MagZam=klucze[4]
        
        Filtr="WHERE zp.firma_id='"+self.firma_id+"' AND zp.ilosc1-zp.dostarczono1-zp.anulowano1>0 " 
        Filtr+=" AND z.stan <> 'W'"
        if CzyZamienniki:
            Filtr+=" AND (zp.artykul_id='"+Zamiennik+"' OR a.zamiennik_id='"+Zamiennik+"')"
        else:
            Filtr+=" AND zp.artykul_id='"+Artykul+"'"
        if DataZam<>'' and rsglobal.SprawdzCzyToData(DataZam):
            Filtr+=" AND zp.data>='"+DataZam+"'"
        if MagZam <>'':
            Filtr+=" AND z.magazyn_id='"+MagZam+"'"
            
        
        NumerP="rsf_podaj_numer_dokumentu_na_wydruk('"+self.firma_id+"', '[\"'||z.wyznacznik_id||'\",\"'||data||'\",'||numer||']','D')"
        
        SQL="SELECT zp.artykul_id,a.nazwa,zp.ilosc1-zp.dostarczono1-zp.anulowano1,a.jm1,"
        SQL+="zp.ilosc2-zp.dostarczono2-zp.anulowano2,a.jm2,z.data,z.data_odbioru,z.kontrahent_id,"
        SQL+=NumerP+" FROM rs_zamowienia_odbiorcy_pozycje zp INNER JOIN rs_zamowienia_odbiorcy z "
        SQL+=" USING (firma_id,wyznacznik_id,data,numer) INNER JOIN rs_artykuly a USING (firma_id,artykul_id) "
        SQL+=Filtr+" ORDER BY artykul_id,z.data_odbioru"

        stat,dane,wyn1,tr = self.PolSQL.Execute(SQL,3)

#----------------------------
# ILOCI W MAGAZYNIE - Z ANALIZY STANW  (3,4) 
#----------------------------

elif (Fun in [3,4]) and (stat=='OK'):
    if not (((self.oddzial_id,'013013') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)):
        stat=='UPR SEL'

    if stat=='OK' and len(klucze) <> 6:
        stat=='BL PAR'

    if stat=='OK':
        Artykul=rsglobal.Dekoduj(klucze[0])
        Zamiennik=rsglobal.Dekoduj(klucze[1])
        CzyZamienniki=klucze[2]
        CzyWybraneMag=klucze[3]
        MagF=klucze[4]
        
        Filtr=" WHERE am.firma_id='"+self.firma_id+"'" 
        if CzyZamienniki:
            Filtr+=" AND (a.artykul_id='"+Zamiennik+"' OR a.zamiennik_id='"+Zamiennik+"')"
        else:
            Filtr+=" AND a.artykul_id='"+Artykul+"'"
            
        if CzyWybraneMag:
            Filtr+=" AND am.magazyn_id LIKE '"+MagF+"%' "
        Filtr+=" AND (NOT m.brakow OR m.brakow IS NULL)"
        Filtr+=" AND (am.ilosc1 >0 OR am.zapas_min1>0 OR am.zapas_max1 >0)"

        SQL="SELECT am.artykul_id,a.nazwa,am.magazyn_id,a.jm1, am.ilosc1,am.zapas_min1,am.zapas_max1, "
        SQL+="a.jm2, am.ilosc2,am.zapas_min2,am.zapas_max2 "
        SQL+="FROM rs_artykuly_magazyny am INNER JOIN rs_artykuly a USING (firma_id,artykul_id)"
        SQL+="INNER JOIN rs_magazyny m USING (firma_id,magazyn_id)"
        SQL+=Filtr+" ORDER BY a.artykul_id,m.magazyn_id;"

        stat,dane,wyn1,tr = self.PolSQL.Execute(SQL,3)

