# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_powiadomienia.py
# Purpose:     obsluga grida edytowalnego listy powiadomien
# Author:      Mariusz Rajfura
# Created:     2012/09/13
# RCS-ID:      $Id: fs_powiadomienia
# Copyright:   (c) 2012 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

# 2022-08-11 Wojciech Skowron - (13103) SprawdzAdresEmail przeniesione do rsglobal

#-------------------------------------------------------------------------------
# funkcja sprawdzajaca poprawnosc adresu e-mail na poziomie edycji
# zrodlo: http://stackoverflow.com/questions/8022530/python-check-for-valid-email-address
# def SprawdzAdresEmail(adres):
#     stat = 'OK'
#     import re
#     return re.match(r"^[A-Za-z0-9\.\+_-]+@[A-Za-z0-9\._-]+\.[a-zA-Z]*$", adres)
#-------------------------------------------------------------------------------

stat='OK'

if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=='OK':
    Funkcja = klucze['Funkcja']
    
    #SlPar={'Email':[1]}
    SlPar={}
    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Funkcja,klucze)
    if Lista<>'':
        stat='Uwaga : wywoanie funkcji fs_powiadomienia z numerem '+str(Funkcja)+' bez parametrw: '+Lista
        
dane = []
wyn1 = []
wyn2 = []

UprIns=((self.oddzial_id,'001903') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID
UprUpd=((self.oddzial_id,'001902') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID or UprIns
UprDel=((self.oddzial_id,'001904') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID


#-------------------------------------------------------------------------------
#-------- EDYCJA GRIDA EDYTOWALNEGO (1)
#-------------------------------------------------------------------------------

Insert = []
Update = []
Delete = []

if Funkcja == 1:
    Update=klucze['Update']
    Insert=klucze['Insert']
    Delete=klucze['Delete']


#-------------------------------------------------------------------------------
#-------  SPRAWDZANIE DELETE  --------------------------------------------------
#-------------------------------------------------------------------------------

if Funkcja == 1 and stat=="OK":
    if len(Delete[0])>0:
        if not UprDel:
            stat='BR UPR DEL'
            dane.append(stat)
        
        # wykonanie DELETE 
        if stat == 'OK':
            SQLDEL = ''
            SQLFU = ''
            for i in xrange(len(Delete[0])):
                SQLFU = "SELECT email FROM rs_powiadomienia WHERE firma_id='"+self.firma_id+"'"
                DELETE = "DELETE FROM rs_powiadomienia "
                WHERE = "WHERE firma_id='"+self.firma_id+"'"
                for j in xrange(len(Delete[0][i])):
                    pole = Delete[1][j]
                    wart = Delete[0][i][j]
                    if pole in ['email']:
                        WHERE += " AND "+pole+"='"+wart+"'"
                        SQLFU += " AND "+pole+"='"+wart+"'"
                
                SQLDEL += DELETE+WHERE+"; "
                SQLFU += " FOR UPDATE NOWAIT; "

            if SQLFU != '':
                stat,d,dump,dump = self.PolSQL.Execute(rsglobal.Dekoduj(SQLFU),3)
                if stat != 'OK':
                    stat = 'Bd sprawdzenia danych do usunicia: '+stat
                    dane.append(stat)

            if stat == "OK" and SQLDEL != '':
                stat,dump,dump,dump = self.PolSQL.Execute(rsglobal.Dekoduj(SQLDEL),1)
                if stat != 'OK':
                    stat = "Bd przy usuwaniu danych: "+stat   
                    dane.append(stat)


#-------------------------------------------------------------------------------
#---   UPDATE DANYCH (1)
#-------------------------------------------------------------------------------

if Funkcja == 1 and stat=="OK":
    if len(Update[0])>0:
        if not UprUpd:
            stat='BR UPR UPD'
            dane.append(stat)

        if stat == 'OK':
            SQLFU = ''
            for i in xrange(len(Update[0])):
                SQLFU += "SELECT email FROM rs_powiadomienia WHERE firma_id='"+self.firma_id+"'"
                for j in xrange(len(Update[2][i])): # petla po kluczu
                    pole = Update[3][j]
                    wart = rsglobal.Dekoduj(Update[2][i][j])
                    if pole == 'email':
                        SQLFU += " AND "+pole+"='"+wart+"'"
                
                SQLFU += " FOR UPDATE NOWAIT; "
            
            if SQLFU != '':
                stat,d,dump,dump = self.PolSQL.Execute(rsglobal.Dekoduj(SQLFU),3)
                if stat != 'OK':
                    stat = 'Bd sprawdzenia danych do modyfikacji: '+stat
                    dane.append(stat)
            
        if stat == 'OK':
            WierszeNr = Update[-1]

            for i in xrange(len(Update[0])):
                for j in xrange(len(Update[0][i])): 
                    pole = Update[0][i][j]
                    wart = Update[1][i][j]

                    if pole == 'email':
                        wart = wart.strip()
                        if wart == '':
                            stat = 'BR EMAIL'
                            wyn2.append((WierszeNr[i],0))
                            dane.append(stat)
                            
                        else:
                            if not rsglobal.SprawdzAdresEmail(wart):
                                stat = 'BL EMAIL'
                                wyn2.append((WierszeNr[i],0))
                                dane.append(stat)
                            else:
                                sql ="SELECT email FROM rs_powiadomienia"
                                sql+=" WHERE firma_id='"+self.firma_id+"'"
                                sql+=" AND email='"+wart+"';"
                                stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                                if stat != 'OK':
                                    stat = 'BL SQL EMAIL'
                                    wyn2.append((WierszeNr[i],0))
                                    dane.append(stat)
                                elif len(d) > 0:
                                    stat = 'BL EMAIL JUZ IST'
                                    wyn2.append((WierszeNr[i],0))
                                    dane.append(stat)

                    elif pole == 'opis':
                        wart = wart.strip()
                        if wart == '':
                            stat = 'BR OPIS'
                            wyn2.append((WierszeNr[i],1))
                            dane.append(stat)

        if stat == 'OK':
            if len(dane) > 0:
                stat = dane[0]
                
        # wykonanie UPDATE
        if stat=='OK':
            sql=''
            for i in xrange(len(Update[0])):
                UPDATE="UPDATE rs_powiadomienia "
                SET='SET '
                for j in xrange(len(Update[0][i])): 
                    pole=Update[0][i][j]
                    wart=Update[1][i][j]
                    if pole in ['email','opis']:
                        SET+=pole+"='"+wart+"',"

                SET=SET.strip(",")
                WHERE=" WHERE firma_id='"+self.firma_id+"'" 
                for j in xrange(len(Update[2][i])): # petla po kluczu
                    pole=Update[3][j]
                    wart=rsglobal.Dekoduj(Update[2][i][j])
                    if pole in ['email']:
                        WHERE+= " AND "+pole+"='"+wart+"'"

                WHERE+=";"
                
                sql+=UPDATE+SET+WHERE;
                
            if sql<>'':
                stat,dump,dump,dump=self.PolSQL.Execute(rsglobal.Dekoduj(sql),1)
                if stat<>'OK':
                    stat="Bd przy modyfikowaniu danych: "+stat   
                    dane.append(stat)  


#-------------------------------------------------------------------------------
#---------Sprawdzanie danych do Insert------
#-------------------------------------------------------------------------------

if Funkcja == 1 and stat=="OK":
    if len(Insert[0])>0:
        if not UprIns:
            stat='BR UPR INS'
            dane.append(stat)

        if stat == 'OK':
            WierszeNr = Insert[-1]
            for i in xrange(len(Insert[0])):
                for j in xrange(len(Insert[0][i])): 
                        pole=Insert[1][j]
                        wart=Insert[0][i][j]
                        
                        if pole == 'email':
                            wart = wart.strip()
                            if wart == '':
                                stat = 'BR EMAIL'
                                wyn2.append((WierszeNr[i],0))
                                dane.append(stat)
                            else:
                                if not rsglobal.SprawdzAdresEmail(wart):
                                    stat = "BL EMAIL"
                                    wyn2.append((WierszeNr[i],0))
                                    dane.append(stat)
                                else:
                                    sql ="SELECT email FROM rs_powiadomienia"
                                    sql+=" WHERE firma_id='"+self.firma_id+"'"
                                    sql+=" AND email='"+str(wart)+"';"
                                    stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                                    if stat != 'OK':
                                        stat = 'BL SQL EMAIL'
                                        wyn2.append((WierszeNr[i],0))
                                        dane.append(stat)
                                    elif len(d) > 0:
                                        stat = 'BL EMAIL JUZ IST'
                                        wyn2.append((WierszeNr[i],0))
                                        dane.append(stat)

                        elif pole == 'opis':
                            wart = wart.strip()
                            if wart == '':
                                stat = 'BR OPIS'
                                wyn2.append((WierszeNr[i],1))
                                dane.append(stat)

        if stat == 'OK':
            if len(dane) > 0:
                stat = dane[0]

        # wykonanie INSERT
        if stat == 'OK':
            sqlIns=''
            for i in xrange(len(Insert[0])):
                INSERT="INSERT INTO rs_powiadomienia "
                KOLUMNY="(firma_id"
                VALUES=" VALUES ('"+self.firma_id+"'"
                for j in xrange(len(Insert[0][i])):
                    pole=Insert[1][j]
                    wart=Insert[0][i][j]
                    if pole in ['email','opis']:
                        KOLUMNY+=","+pole
                        VALUES+=",'"+wart+"'"

                KOLUMNY+=")"
                VALUES+=");"
                sqlIns+=INSERT+KOLUMNY+VALUES
            if sqlIns<>'': 
                stat,dump,dump,dump=self.PolSQL.Execute(rsglobal.Dekoduj(sqlIns),1)
                if stat<>'OK':
                    stat="Bd przy dodawaniu danych: "+stat
                    dane.append(stat)


#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (1- insert 1 -select, 1 -delete)
#-------------------------------------------------------------------------------

if Funkcja in (1,5) and stat=='OK':
    SQL ="SELECT email,opis FROM rs_powiadomienia"
    SQL+=" WHERE firma_id='"+self.firma_id+"' ORDER BY email;"

    stat,dane,wyn1,wyn2 = self.PolSQL.Execute(SQL,3)
    if stat != 'OK':
        stat = "Bd przy pobieraniu danych: "+stat
        dane.append(stat)
