# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_powiadomienia.py
# Purpose:     obsluga grida edytowalnego pozycji powiadomienia
# Author:      Mariusz Rajfura
# Created:     2012/09/14
# RCS-ID:      $Id: fs_powiadomienia_pozycje
# Copyright:   (c) 2012 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

stat='OK'

if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=='OK':
    Funkcja = klucze['Funkcja']
    
    SlPar={'Email':[1,5], 'PowiadomienieOpis':[8], 'OddzialOpis':[9]}
    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Funkcja,klucze)
    if Lista<>'':
        stat='Uwaga : wywoanie funkcji fs_powiadomienia z numerem '+str(Funkcja)+' bez parametrw: '+Lista
        
    if Funkcja in (1,5): 
        Email=rsglobal.Dekoduj(klucze['Email'])

    if Funkcja == 8:
        PowiadomienieOpis = rsglobal.Dekoduj(klucze['PowiadomienieOpis'])
        
    if Funkcja == 9:
        OddzialOpis = rsglobal.Dekoduj(klucze['OddzialOpis'])

dane = []
wyn1 = []
wyn2 = []

UprIns=((self.oddzial_id,'001903') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID
UprUpd=((self.oddzial_id,'001902') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID or UprIns
UprDel=((self.oddzial_id,'001904') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID



#-------------------------------------------------------------------------------
#-------  POBRANIE OPISU POWIADOMIENIA (8)
#-------------------------------------------------------------------------------

if Funkcja == 8 and stat == "OK":
    sql ="SELECT opis FROM rs_powiadomienia_typy WHERE kod='"+PowiadomienieOpis+"';"
    stat,dane,dump,dump = self.PolSQL.Execute(sql,3)
    if stat <> 'OK':
        stat = 'Bd przy pobieraniu opisu powiadomienia: '+stat
        dane.append(stat)
        
        
#-------------------------------------------------------------------------------
#-------  POBRANIE OPISU DZIALU (9)
#-------------------------------------------------------------------------------

if Funkcja == 9 and stat == "OK":
    sql ="SELECT opis FROM rs_oddzialy "
    sql+=" WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+OddzialOpis+"';"

    stat,dane,dump,dump = self.PolSQL.Execute(sql,3)
    if stat <> 'OK':
        stat = 'Bd przy pobieraniu opisu oddziau: '+stat
        dane.append(stat)


#-------------------------------------------------------------------------------
#-------- EDYCJA GRIDA EDYTOWALNEGO (1)
#-------------------------------------------------------------------------------

Insert = []
Update = []
Delete = []

if Funkcja == 1:
    Update=klucze['Update']
    Insert=klucze['Insert']
    Delete=klucze['Delete']


#-------------------------------------------------------------------------------
#-------  SPRAWDZANIE DELETE  --------------------------------------------------
#-------------------------------------------------------------------------------

if Funkcja == 1 and stat=="OK":
    if len(Delete[0])>0:
        if not UprDel:
            stat='BR UPR DEL'
            dane.append(stat)
        
        # wykonanie DELETE 
        if stat == 'OK':
            SQLDEL = ''
            SQLFU = ''
            for i in xrange(len(Delete[0])):
                SQLFU = "SELECT powiadomienie,oddzial_id FROM rs_powiadomienia_pozycje WHERE firma_id='"+self.firma_id+"'"
                DELETE = "DELETE FROM rs_powiadomienia_pozycje "
                WHERE = "WHERE firma_id='"+self.firma_id+"' AND email='"+Email+"'"
                for j in xrange(len(Delete[0][i])):
                    pole = Delete[1][j]
                    wart = Delete[0][i][j]
                    if pole in ['powiadomienie','oddzial_id']:
                        WHERE += " AND "+pole+"='"+wart+"'"
                        SQLFU += " AND "+pole+"='"+wart+"'"
                
                SQLDEL += DELETE+WHERE+"; "
                SQLFU += " FOR UPDATE NOWAIT; "

            if SQLFU <> '':
                stat,d,dump,dump = self.PolSQL.Execute(rsglobal.Dekoduj(SQLFU),3)
                if stat <> 'OK':
                    stat = 'Bd sprawdzenia danych do usunicia: '+stat
                    dane.append(stat)

            if stat == "OK" and SQLDEL <> '':
                stat,dump,dump,dump = self.PolSQL.Execute(rsglobal.Dekoduj(SQLDEL),1)
                if stat <> 'OK':
                    stat = "Bd przy usuwaniu danych: "+stat   
                    dane.append(stat)


#-------------------------------------------------------------------------------
#---   UPDATE DANYCH (1)
#-------------------------------------------------------------------------------

if Funkcja == 1 and stat=="OK":
    if len(Update[0])>0:
        if not UprUpd:
            stat='BR UPR UPD'
            dane.append(stat)

        if stat == 'OK':
            SQLFU = ''
            for i in xrange(len(Update[0])):
                SQLFU+="SELECT powiadomienie,oddzial_id FROM rs_powiadomienia_pozycje"
                SQLFU+=" WHERE firma_id='"+self.firma_id+"' AND email='"+Email+"'"
                for j in xrange(len(Update[2][i])): # petla po kluczu
                    pole = Update[3][j]
                    wart = rsglobal.Dekoduj(Update[2][i][j])
                    if pole in ('powiadomienie','oddzial_id'):
                        SQLFU += " AND "+pole+"='"+wart+"'"
                
                SQLFU += " FOR UPDATE NOWAIT; "
            
            if SQLFU <> '':
                stat,d,dump,dump = self.PolSQL.Execute(rsglobal.Dekoduj(SQLFU),3)
                if stat <> 'OK':
                    stat = 'Bd sprawdzenia danych do modyfikacji: '+stat
                    dane.append(stat)
            
        if stat == 'OK':
            WierszeNr = Update[-1]

            for i in xrange(len(Update[0])):
                PowiadomienieNowe = None
                OddzialNowy = None

                for j in xrange(len(Update[0][i])): 
                    pole = Update[0][i][j]
                    wart = Update[1][i][j]

                    if pole == 'powiadomienie':
                        wart = wart.strip()
                        PowiadomienieNowe = str(wart)
                        if wart == '':
                            stat = 'BR POWIADOMIENIE'
                            wyn2.append((WierszeNr[i],0))
                            dane.append(stat)
                            
                        else:
                            sql ="SELECT kod FROM rs_powiadomienia_typy"
                            sql+=" WHERE kod='"+wart+"';"
                            stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                            if stat <> 'OK':
                                stat = 'BL SQL POWIADOMIENIE'
                                wyn2.append((WierszeNr[i],0))
                                dane.append(stat)
                            elif len(d) == 0:
                                stat = 'BL POWIADOMIENIE'
                                wyn2.append((WierszeNr[i],0))
                                dane.append(stat)

                    elif pole == 'oddzial_id':
                        wart = wart.strip()
                        OddzialNowy = str(wart)
                        if wart == '':
                            stat = 'BR ODDZIAL'
                            wyn2.append((WierszeNr[i],2))
                            dane.append(stat)
                            
                        else:
                            sql ="SELECT oddzial_id FROM rs_oddzialy"
                            sql+=" WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+wart+"';"
                            stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                            if stat <> 'OK':
                                stat = 'BL SQL ODDZIAL'
                                wyn2.append((WierszeNr[i],2))
                                dane.append(stat)
                            elif len(d) == 0:
                                stat = 'BL ODDZIAL'
                                wyn2.append((WierszeNr[i],2))
                                dane.append(stat)

        if stat == 'OK':
            if len(dane) > 0:
                stat = dane[0]
                
        # wykonanie UPDATE
        if stat=='OK':
            sql=''
            for i in xrange(len(Update[0])):
                UPDATE="UPDATE rs_powiadomienia_pozycje "
                SET='SET '
                for j in xrange(len(Update[0][i])): 
                    pole=Update[0][i][j]
                    wart=Update[1][i][j]
                    if pole in ['powiadomienie','oddzial_id']:
                        SET+=pole+"='"+wart+"',"

                SET=SET.strip(",")
                WHERE=" WHERE firma_id='"+self.firma_id+"' AND email='"+Email+"'"
                for j in xrange(len(Update[2][i])): # petla po kluczu
                    pole=Update[3][j]
                    wart=rsglobal.Dekoduj(Update[2][i][j])
                    if pole in ['powiadomienie','oddzial_id']:
                        WHERE+= " AND "+pole+"='"+wart+"'"

                WHERE+=";"
                
                sql+=UPDATE+SET+WHERE;
                
            if sql<>'':
                stat,dump,dump,dump=self.PolSQL.Execute(rsglobal.Dekoduj(sql),1)
                if stat<>'OK':
                    stat="Bd przy modyfikowaniu danych: "+stat   
                    dane.append(stat)  


#-------------------------------------------------------------------------------
#---------Sprawdzanie danych do Insert------
#-------------------------------------------------------------------------------

if Funkcja == 1 and stat=="OK":
    if len(Insert[0])>0:
        if not UprIns:
            stat='BR UPR INS'
            dane.append(stat)

        if stat == 'OK':
            WierszeNr = Insert[-1]
            for i in xrange(len(Insert[0])):
                PowiadomienieNowe = None
                OddzialNowy = None
                
                for j in xrange(len(Insert[0][i])): 
                    pole=Insert[1][j]
                    wart=Insert[0][i][j]

                    if pole == 'powiadomienie':
                        wart = wart.strip()
                        PowiadomienieNowe = str(wart)
                        if wart == '':
                            stat = 'BR POWIADOMIENIE'
                            wyn2.append((WierszeNr[i],0))
                            dane.append(stat)
                        else:
                            sql ="SELECT kod FROM rs_powiadomienia_typy"
                            sql+=" WHERE kod='"+wart+"';"
                            stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                            if stat <> 'OK':
                                stat = 'BL SQL POWIADOMIENIE'
                                wyn2.append((WierszeNr[i],0))
                                dane.append(stat)
                            elif len(d) == 0:
                                stat = 'BL POWIADOMIENIE'
                                wyn2.append((WierszeNr[i],0))
                                dane.append(stat)

                    elif pole == 'oddzial_id':
                        wart = wart.strip()
                        OddzialNowy = str(wart)
                        if wart == '':
                            stat = 'BR ODDZIAL'
                            wyn2.append((WierszeNr[i],2))
                            dane.append(stat)
                        else:
                            sql ="SELECT oddzial_id FROM rs_oddzialy"
                            sql+=" WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+wart+"';"
                            stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                            if stat <> 'OK':
                                stat = 'BL SQL ODDZIAL'
                                wyn2.append((WierszeNr[i],2))
                                dane.append(stat)
                            elif len(d) == 0:
                                stat = 'BL ODDZIAL'
                                wyn2.append((WierszeNr[i],2))
                                dane.append(stat)
                
                if stat == 'OK' and PowiadomienieNowe <> None and OddzialNowy <> None:
                    sql ="SELECT powiadomienie,oddzial_id FROM rs_powiadomienia_pozycje"
                    sql+=" WHERE firma_id='"+self.firma_id+"' AND email='"+Email+"'"
                    sql+=" AND powiadomienie='"+PowiadomienieNowe+"' AND oddzial_id='"+OddzialNowy+"';"
                    stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                    if stat <> 'OK':
                        stat = 'Bd sprawdzenia nowej pozycji: '+stat
                        wyn2.append((WierszeNr[i],0))
                        wyn2.append((WierszeNr[i],2))
                        dane.append(stat)
                    elif len(d) > 0:
                        stat = 'BL POZYCJA IST'
                        wyn2.append((WierszeNr[i],0))
                        wyn2.append((WierszeNr[i],2))
                        dane.append(stat)

        if stat == 'OK':
            if len(dane) > 0:
                stat = dane[0]

        # wykonanie INSERT
        if stat == 'OK':
            sqlIns=''
            for i in xrange(len(Insert[0])):
                INSERT="INSERT INTO rs_powiadomienia_pozycje "
                KOLUMNY="(firma_id,email"
                VALUES=" VALUES ('"+self.firma_id+"','"+Email+"'"
                for j in xrange(len(Insert[0][i])):
                    pole=Insert[1][j]
                    wart=Insert[0][i][j]
                    if pole in ['powiadomienie','oddzial_id']:
                        KOLUMNY+=","+pole
                        VALUES+=",'"+wart+"'"

                KOLUMNY+=")"
                VALUES+=");"
                sqlIns+=INSERT+KOLUMNY+VALUES
            if sqlIns<>'': 
                stat,dump,dump,dump=self.PolSQL.Execute(rsglobal.Dekoduj(sqlIns),1)
                if stat<>'OK':
                    stat="Bd przy dodawaniu danych: "+stat
                    dane.append(stat)


#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (1- insert 1 -select, 1 -delete)
#-------------------------------------------------------------------------------

if Funkcja in (1,5) and stat=='OK':
    SQL ="SELECT pp.powiadomienie,pt.opis AS opis_powiadomienia,pp.oddzial_id,o.opis AS opis_oodzialu"
    SQL+=" FROM rs_powiadomienia_pozycje pp"
    SQL+=" INNER JOIN rs_powiadomienia_typy pt ON (pt.kod=pp.powiadomienie)"
    SQL+=" INNER JOIN rs_oddzialy o USING(firma_id,oddzial_id)"
    SQL+=" WHERE pp.firma_id='"+self.firma_id+"' AND pp.email='"+Email+"'"
    SQL+=" ORDER BY pp.powiadomienie,pp.oddzial_id;"

    stat,dane,wyn1,wyn2 = self.PolSQL.Execute(SQL,3)
    if stat <> 'OK':
        stat = "Bd przy pobieraniu danych: "+stat
        dane.append(stat)
