#!/usr/bin/python
# -*- coding: iso8859_2 -*-
#-----------------------------------------------------------------------------
# Name:             fs_raporty_wyciagi_pozycje_dane.py
# Purpose:          dodaje/pobiera/usuwa raporty/wycigi
# Author:           Micha Raburski,Marcin Grzeda
# Created:          2007/02/15
# RCS-ID:           $Id: fs_raporty_wyciagi_pozycje_dane.py $
# Copyright:        (c) 2007 RecordSystem
# Licence:          GNU GPL
#-----------------------------------------------------------------------------

DataOd=klucze[0]
Fun=klucze[-1]
stat='OK'
dane=[]
puste_pola = ['    -  -  ','',[],'None']


if Fun in [3,4,5,6,7,8,9,10,11]:
    if not rsglobal.SprawdzCzyToData(DataOd):
        stat='BL DAT'
        dane.append(stat)
        
if self.operator_id != STANDARD_OPERATOR_ID:
    UprIns=(self.oddzial_id,'014033') in self.uprawnienia
    UprUpd=(self.oddzial_id,'014032') in self.uprawnienia or UprIns 
    UprPrz=(self.oddzial_id,'014031') in self.uprawnienia or UprUpd or UprIns
else:
    UprPrz=True
    UprUpd=True 
    UprIns=True 


#-------------------------------------------------------------------------------
#---   INSERT DANYCH (2- bez pobierania,1- z pobieraniem)
#-------------------------------------------------------------------------------

# sprawdzenie danych
if stat == "OK" and Fun in [1,2,3,4]:
    for i in range(len(pola)):
        wart = wartosci[i]
        pole = pola[i]
        if pole=='data_od':
            if wart<>'':
                if not rsglobal.SprawdzCzyToData(wart):
                    stat='BL DAT OD'
                    dane.append(stat)
                else:
                    Select="SELECT * FROM rs_procenty_odsetek WHERE firma_id='"+self.firma_id+"' AND data_od='"+str(wart)+"'"
                    st,d,dump,dump=self.PolSQL.Execute(Select,3)
                    if len(d)>0:
                        stat='DAT ISTN'
                        dane.append(stat)
            else:
                stat='BR DAT OD'
                dane.append(stat)
                    
if len(dane)>0:
    stat=dane[-1]
                
if stat == "OK" and Fun in [2,1]:
    if UprIns:
        sql = "INSERT INTO rs_procenty_odsetek "
        PolaN="firma_id"
        WartosciN = "'"+self.firma_id+"'"
        for i in range(len(pola)):
            pole = pola[i]
            wart = wartosci[i]
            if pole in ['data_od']:
                DataOd=wart
                PolaN += ","+pole
                WartosciN += ",'"+str(wart)+"'"
            else:
                PolaN += ","+pole
                WartosciN += ","+str(wart)
            
        sql += " ("+PolaN+") VALUES ("+WartosciN+");"

        stat,dump,dump,dump = self.PolSQL.Execute(sql ,1)
        if stat<>'OK':
            stat='BL INS'
            dane.append(stat)
    else:
        stat='UPR INS'
        dane.append(stat)
        
#-------------------------------------------------------------------------------
#--- Update danych (3,4)
#-------------------------------------------------------------------------------

if (Fun in [3,4]) and (stat=='OK'):
    if UprUpd:
        sql = "UPDATE rs_procenty_odsetek SET "
        Filtr = "firma_id='"+self.firma_id+"' AND data_od='"+DataOd+"'"
        for i in range(len(pola)):
            wart = wartosci[i]
            pole = pola[i]
            if pole in ['data_od']:
                sql += pole+"='"+str(wart)+"',"
                DataOd=wart
            elif pole in ['odsetki_zobow','odsetki_nalez','odsetki_podat']:
                sql += pole+"="+str(wart)+","
            
        sql=sql.strip(",")
        
        sql += " WHERE "+Filtr+";"
        stat,dump,dump,dump = self.PolSQL.Execute(sql ,1)
        if stat != 'OK':
            stat = 'BL UPD'
            dane.append(stat)
    else:
        stat='UPR UPD'
        dane.append(stat)


#SELECT
if (Fun in [1,2,3,4,5,6]) and (stat=='OK'):
    if UprPrz:
        Sql="SELECT * FROM rs_procenty_odsetek WHERE firma_id='"+self.firma_id+"' AND data_od='"+DataOd+"';"
        
        stat,dane,wyn1,wyn2=self.PolSQL.Execute(Sql,3)
        if stat<>'OK':
            stat='BL PRZ'
            dane.append(stat)
    else:
        stat='UPR PRZ'
        dane.append(stat)
      
