# -*- coding: iso8859_2 -*-

#-------------------------------------------------------------------------------
# Name:        fs_procesy_artykuly.py
# Purpose:     wczytuje/usuwa dane procesow artykulow
#
# Author:      Dariusz Boduch
# Created:     2009/11/27
# RCS-ID:      $Id: fs_procesy_artykuly.py $
# Copyright:   (c) 2006 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------
#  2017-03-28 Piotr Witkowski (10385) Refaktoryzacja receptury

stat='OK'

if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=='OK':
    Funkcja = klucze['Funkcja']
    SlPar={'ArtykulF':[5,6,],'UrzadzenieF':[5,6,],'ProcesF':[5,6,],
           'Artykul':[6,],'Urzadzenie':[6,],'Proces':[6,],'CzyProcesy':[5,6,],}

    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Funkcja,klucze)
    if Lista<>'':
        stat='Uwaga : wywoanie funkcji fs_procesy_artykuly z numerem ' +str(Funkcja)+' bez parametrw: '+Lista

if stat=='OK':
    if Funkcja in [5,6,]:
        ArtykulF = klucze['ArtykulF']
        UrzadzenieF = klucze['UrzadzenieF']
        ProcesF = klucze['ProcesF']
        CzyProcesy = klucze['CzyProcesy']
    if Funkcja in [6,]:
        Artykul = klucze['Artykul']
        Urzadzenie = klucze['Urzadzenie']
        Proces = klucze['Proces']

if stat=='OK':
    dane = []
    wyn1 = []
    wyn2 = []


UprDodawanie = (self.oddzial_id,'047013') in self.uprawnienia or self.operator_id == STANDARD_OPERATOR_ID
UprUsuwanie = (self.oddzial_id,'047014') in self.uprawnienia or self.operator_id == STANDARD_OPERATOR_ID

#-------------------------------------------------------------------------------
#           DELETE (6)
#-------------------------------------------------------------------------------

if Funkcja == 6 :
    if not UprUsuwanie:
        stat = "BR_UPR_DEL"   
        dane.append(stat)
        
    if stat == 'OK':
        Filtr = " firma_id='"+self.firma_id+"' AND oddzial_id='"+self.oddzial_id+"' AND proces_id='"+Proces+"'"
        Filtr+= " AND artykul_id ='"+Artykul+"' AND urzadzenie_id='"+Urzadzenie+"' "
        
        sqlfu ="SELECT artykul_id FROM rs_procesy_artykuly"
        sqlfu+=" WHERE "+Filtr+" FOR UPDATE NOWAIT;"
        stat,d,dump,dump = self.PolSQL.Execute(sqlfu,2)
        if stat <> 'OK':
            stat = 'Bd sprawdzenia danych do skasowania: '+stat
            dane.append(stat)
        elif len(d) <> 1:
            stat = 'Brak pozycji o podanym kluczu'
            dane.append(stat)
        
        if stat == 'OK':
            DEL = "DELETE FROM rs_procesy_artykuly WHERE"+Filtr+";"
            stat,dump,dump,dump=self.PolSQL.Execute(DEL,1)  
            if stat <> 'OK':
                stat = "BR_KAS_POZ"
                dane.append(stat)                                    

    
#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (5 -select)
#-------------------------------------------------------------------------------

if Funkcja in (5,6) and stat == 'OK':
    Filtr = "pa.firma_id='"+self.firma_id+"' AND pa.oddzial_id='"+self.oddzial_id+"' "
    if ArtykulF <> '':
        Filtr += "AND pa.artykul_id LIKE '"+ArtykulF+"%'"
    if UrzadzenieF <> '':
        Filtr += "AND pa.urzadzenie_id='"+UrzadzenieF+"' "
    if ProcesF <> '':
        Filtr += "AND pa.proces_id='"+ProcesF+"' "
    
    sql = "SELECT"
    if CzyProcesy:
        sql+=" pa.proces_id,pr.nazwa,"
    else:
        sql+=" pa.artykul_id,a.nazwa,"
    
    sql+=" pa.urzadzenie_id,u.nazwa,pa.czas,"
    sql+=" COALESCE(pa.stanowisko_pocz||' - '||spp.opis,''::TEXT),"
    sql+=" COALESCE(pa.stanowisko_koniec||' - '||spk.opis,''::TEXT),"
    sql+=" pa.maks_ilosc,pa.kolejnosc "
    sql+=" FROM rs_procesy_artykuly pa"
    sql+=" LEFT OUTER JOIN rs_urzadzenia u ON ( pa.firma_id=u.firma_id AND pa.urzadzenie_id=u.urzadzenie_id) "
    sql+=" LEFT OUTER JOIN rs_stanowiska_pracy spp ON (pa.firma_id=spp.firma_id AND pa.stanowisko_pocz=spp.kod) "
    sql+=" LEFT OUTER JOIN rs_stanowiska_pracy spk ON (pa.firma_id=spk.firma_id AND pa.stanowisko_koniec=spk.kod) "
    if CzyProcesy:
        sql+=" LEFT OUTER JOIN rs_procesy pr ON(pa.firma_id=pr.firma_id AND pa.proces_id=pr.proces_id) "
    else:
        sql+=" LEFT OUTER JOIN rs_artykuly a ON( pa.firma_id=a.firma_id AND pa.artykul_id=a.artykul_id) "        
        
    sql+= " WHERE "+Filtr+" "
    if CzyProcesy:
        sql+= "ORDER BY pa.kolejnosc ;"
    else:
        sql+= "ORDER BY pa.artykul_id,pa.urzadzenie_id ;"
        
    stat,dane,wyn1,wyn2 = self.PolSQL.Execute(sql,3)
    if stat <> 'OK':
        stat = 'Bd pobrania danych '+stat