# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:			fs_produkcja_plan_partie.py
# Purpose:		edycja partii i dodanie ich do planu produkcji
# Author:		Micha Raburski
# Created:		2011/11/02
# RCS-ID:		$Id: fs_produkcja_plan_partie.py $
# Copyright:	(c) 2011 RecordSystem
# Licence:		GNU GPL
#-------------------------------------------------------------------------------

#-##############################################################################
#-   FUNKCJA ZAPISUJCA KONKRETN PARTI
#-##############################################################################

def ZapiszPartie(self,Art,LProcesy,LWier,Ilosc,Data,Czas,klucze):
    import rsglobal
    import math
    
    stat='OK'
    # pobranie dugoci/proporcjonalnoci procesw dla artykuu
    SQL="SELECT pa.proces_id,pa.urzadzenie_id,pa.czas,pa.maks_ilosc,p.proporcjonalny,pa.czas_nastepny"
    SQL+=" FROM rs_procesy_artykuly pa"
    SQL+=" INNER JOIN rs_procesy p USING (firma_id,proces_id)"
    SQL+=" WHERE firma_id='"+self.firma_id+"' AND pa.oddzial_id='"+self.oddzial_id+"' AND artykul_id='"+Art+"' AND ("
    for poz in LProcesy:
        Proces=poz[0].split(' - ')[0]
        Urzadz=poz[1].split(' - ')[0]
        SQL+=" (pa.proces_id='"+Proces+"' AND urzadzenie_id='"+Urzadz+"') OR"
    SQL=SQL.strip('OR')
    SQL+=")"

    stat,DCzasy,dump,dump=self.PolSQL.Execute(SQL,3)
    
    if stat=='OK':
        # zmienna, ktra mwi jaka kolumna bya dopasowywana jako pierwsza w danym cyklu.
        # zaczynamy od ostatniej (ale kratka jest od koca czyli kolumna 0 jest ostatnia z LProcesy)
        NrKolPocz=0
        
        # zmienna, ktra mwi jaka jest aktualna proponowana godzina zakoczenia partii
        CzasAkt=[Data,Czas]
    
        # wygenerowanie konkretnych kratek do wstawienia w urzdzenia. W wierszu jest urzdzenie,
        # czas w minutach i czas od koca procesu - w celach obliczeniowych
        LKratki=[]
        IleOdPocz=0
        for i in range(len(LProcesy)):
            poz=LProcesy[len(LProcesy)-i-1]
            Proces=poz[0].split(' - ')[0].strip()
            Urzadz=poz[1].split(' - ')[0].strip()
            for czas in DCzasy:
                if czas[0].strip()==Proces and czas[1].strip()==Urzadz:
                    # jeli proporcjonalny
                    if czas[4]:
                        CzasTmp=math.ceil((czas[2]/czas[3])*Ilosc)
                        # jeli czas konca zajetosci 0 to rwny zwykemu
                        if czas[5]==0:
                            CzasTmpZaj=CzasTmp
                        else:
                            CzasTmpZaj=math.ceil((czas[5]/czas[3])*Ilosc)
                    # czas stay
                    else:
                        CzasTmp=czas[2]
                        if czas[5]==0:
                            CzasTmpZaj=CzasTmp
                        else:
                            CzasTmpZaj=czas[5]
                            
                    if CzasTmp==0:
                        CzasTmp=1
                    if CzasTmpZaj==0:
                        CzasTmpZaj=1
                    LKratki.append([Proces,Urzadz,CzasTmp,IleOdPocz,CzasTmpZaj])
                    IleOdPocz+=CzasTmp
                    
        rsglobal.ZapiszDoLogow('!!! LKratki '+str(LKratki),1) 
    
        # pobranie dnia o 1 mniejszego od wybranego
        SQL="SELECT date '"+Data+"' - interval '1 day';"
        stat,DWczoraj,dump,dump=self.PolSQL.Execute(SQL,3)
    
    if stat=='OK':
        CzasGraniczny=DWczoraj[0][0]+' '+Czas
        
        # ptla wyszukujca od koca woln luk do wstawienia schodkowo procesw,
        # wynikiem kocowym jest czas zakoczenia ostatniego procesu
        Znaleziony=False
        while stat=='OK' and not Znaleziony and CzasAkt[0]+' '+CzasAkt[1]>CzasGraniczny:
            # sprawdzamy kolumny czy pasuj.
            Znaleziony=True
            for i in range(len(LProcesy)):
                if stat=='OK' and Znaleziony:
                    KolAkt=(NrKolPocz+i) % len(LProcesy)
    
                    Urzadz=LKratki[KolAkt][1]
                    Czas=LKratki[KolAkt][2]
                    CzasOdPocz=LKratki[KolAkt][3]
                    CzasZaj=LKratki[KolAkt][4]
                    CzasPocz=" (data||' '||godz_minuta)::TIMESTAMP "
                    CzasKonc=" czas_konca_zajetosci "
                    DolnaGranica=" ('"+CzasAkt[0]+" "+CzasAkt[1]+"')::TIMESTAMP - INTERVAL '"+str(CzasOdPocz)+ \
                                 " MIN' - INTERVAL '"+str(Czas)+" MIN'"
                    GornaGranica= DolnaGranica+" + INTERVAL '"+str(CzasZaj)+" MIN'"
                    
                    # to zmienna pomocnicza wykorzystywana tylko jeli jest konflikt do ustalenia nowego czasu pocztkowego
                    CzasAktTmp=CzasPocz+"+ INTERVAL '"+str(CzasOdPocz)+" MIN'"
                    if Czas<>CzasZaj:
                        CzasAktTmp+="+ INTERVAL '"+str(Czas)+" MIN'""- INTERVAL '"+str(CzasZaj)+" MIN'"
                    
                    # test czy dla wybranego procesu/urzdzenia jest ju jaki konflikt
                    SQL="SELECT "+CzasAktTmp+" FROM rs_produkcja_plan "
                    SQL+=" WHERE firma_id='"+self.firma_id+"' AND urzadzenie_id='"+Urzadz+"'"
                    SQL+=" AND  ("+CzasPocz+","+CzasKonc+") OVERLAPS ("+DolnaGranica+","+GornaGranica+")"
                    SQL+=" ORDER BY data,godz_minuta;"
                
                    rsglobal.ZapiszDoLogow('!!! KolAkt '+str(KolAkt),1)
                    rsglobal.ZapiszDoLogow('!!! SQL testowy '+SQL,1)
                    
                    stat,DCzas,dump,dump=self.PolSQL.Execute(SQL,3)
                    rsglobal.ZapiszDoLogow('!!! stat '+stat,1)
                    rsglobal.ZapiszDoLogow('!!! DCzas '+str(DCzas),1)
                    if stat=='OK':
                        if len(DCzas)>0:
                            Znaleziony=False
                            NrKolPocz=KolAkt
                            CzasAkt[0]=DCzas[0][0][0:10]
                            CzasAkt[1]=DCzas[0][0][11:16]
                    
    
    # wstawienie wierszy do tabeli
    rsglobal.ZapiszDoLogow('Czas akt ostateczny '+str(CzasAkt),1)
    if stat=='OK' and Znaleziony:
        SQLINS=''
        # pobranie wsplnego numeru partii
        Partia=-1
        SQLPartia="SELECT NEXTVAL('rs_produkcja_partia_id');"
        stat,DPartia,dump,dump=self.PolSQL.Execute(SQLPartia,3)
        if stat=='OK':
            Partia=DPartia[0][0]
        
        Kolej=len(LKratki)
        for poz in LKratki:
            if stat=='OK':
                rsglobal.ZapiszDoLogow('poz '+str(poz),1)
                Proces=poz[0]
                Urzadz=poz[1]
                Czas=poz[2]
                CzasOdPocz=poz[3]
                CzasZaj=poz[4]
                Pocz=" ('"+CzasAkt[0]+" "+CzasAkt[1]+"')::TIMESTAMP - INTERVAL '"+str(CzasOdPocz)+ \
                                     " MIN' - INTERVAL '"+str(Czas)+" MIN'"
                Kon=" ('"+CzasAkt[0]+" "+CzasAkt[1]+"')::TIMESTAMP - INTERVAL '"+str(CzasOdPocz)+" MIN'"
                KonZaj=Pocz+" + INTERVAL '"+str(CzasZaj)+" MIN'"
                
                # pobranie dokadnych czasw pocztku i koca
                SQLTest="SELECT "+Pocz+","+Kon+","+KonZaj+";"
                rsglobal.ZapiszDoLogow('sqltest2 '+SQLTest,1)
                stat,DCzas,dump,dump=self.PolSQL.Execute(SQLTest,3)
            if stat=='OK':
                DataP=DCzas[0][0][0:10]
                GodzP=DCzas[0][0][11:16]
                DataK=DCzas[0][1][0:10]
                GodzK=DCzas[0][1][11:16]
                KonZaj=DCzas[0][2]
                rsglobal.ZapiszDoLogow('DataP Gp DK GK '+DataP+' '+GodzP+' '+DataK+' '+GodzK+" "+KonZaj,1)
                
                # oddzielnie zapisujemy kade lp z partii
                rsglobal.ZapiszDoLogow('Lwier '+str(LWier),1)                            
                for w in LWier:
                    rsglobal.ZapiszDoLogow('w '+str(w),1)                            
                    Lp=w[1]
                    Ilosc=w[4]
                    DataZmiany=w[5]
                    Zmiana=w[6]
                
                    SQLINS+="INSERT INTO rs_produkcja_plan "
                    SQLINS+="(firma_id,oddzial_id,data,zmiana,"
                    SQLINS+="proces_id,artykul_id,urzadzenie_id,godz_minuta,do_produkcji,"
                    SQLINS+="partia_id,kolejnosc,data_na_kiedy,data_ekspedycja,zmiana_ekspedycja,"
                    SQLINS+="lp,data_konca,godz_minuta_konca,czas_konca_zajetosci) "
                    SQLINS+="VALUES ('"+self.firma_id+"','"+klucze[0]+"','"+DataP+"','"+klucze[5]+"',"
                    SQLINS+="'"+Proces+"','"+Art+"','"+Urzadz+"','"+GodzP+"',"+str(Ilosc)+","
                    SQLINS+=str(Partia)+","+str(Kolej)+",'"+klucze[6]+"','"+DataZmiany+"','"+Zmiana+"',"
                    SQLINS+=str(Lp)+",'"+DataK+"','"+GodzK+"','"+KonZaj+"');"

                Kolej=Kolej-1

        if stat=='OK':
            if SQLINS<>'':
                rsglobal.ZapiszDoLogow('SQLINS '+SQLINS,1)
                stat,dump,dump,dump=self.PolSQL.Execute(SQLINS,1,CzyDodawacBlad=True)
                if stat <> 'OK':
                    if '_pkey' in stat:
                        stat='Nie mona doda partii - nastpia prba dodania do produkcji tego samego artykuu na tej samej maszynie i z tym samym procesem o tej samej godzinie. Jeli sytuacja si powtrzy przesu produkcj o 1 minut.'

    return stat

#-##############################################################################
#-   GWNA CZʦ OKNA
#-##############################################################################

Oddzial = klucze[0]
Data=klucze[1]
Czas=klucze[2]
LPartii=klucze[3]
LProcesy=klucze[4]
Zmiana=klucze[5]
DataNaKiedy=klucze[6]
stat='OK'
wyn2=[]
dane=[]

# zmiana LProcesy na SProcesy
SProcesy={}
for poz in LProcesy:
    SProcesy[poz[0].strip()]=poz[1]

#-------------------------------------------------------------------------------
# TEST POPRAWNOCI DANYCH
#-------------------------------------------------------------------------------

#sprawdzenie oddziau
SQL="SELECT oddzial_id FROM rs_oddzialy WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+Oddzial+"';"
stat,DTest,dump,dump=self.PolSQL.Execute(SQL,3)
if stat<>'OK':
    stat='Bd pobrania danych oddziau : '+stat
elif len(DTest)==0:
    stat='Brak oddziau : '+Oddzial
    
#sprawdzenie daty kocowej
if stat=='OK':
    if not rsglobal.SprawdzCzyToData(Data):
        stat='Bdna data kocowa : '+Data

#sprawdzenie zmiany produkcji
if stat=='OK':
    if Zmiana in ('',None):
        stat='Brak zmiany produkcji'
                           
if stat=='OK':
    for poz in LPartii:
        stat='OK'
        # sprawdzamy tylko dla ilosci >0
        if poz[4]>0:
            # sprawdzenie artykulu
            SQL="SELECT artykul_id FROM rs_artykuly WHERE firma_id='"+self.firma_id+"' AND artykul_id='"+poz[2]+"'"
            stat,DTest,dump,dump=self.PolSQL.Execute(SQL,3)
            if stat<>'OK':
                dane.append('Bd pobrania danych artykuu : '+stat+' dla partii '+str(poz[0])+'/'+str(poz[1]))
            elif len(DTest)==0:
                dane.append('Brak artykuu : '+poz[2]+' dla partii '+str(poz[0])+'/'+str(poz[1]))
            elif not poz[2] in SProcesy:
                dane.append('Artyku dla partii '+str(poz[0])+'/'+str(poz[1])+' nie ma zdefiniowanych procesw')
            
            # sprawdzenie daty przekazania
            if not rsglobal.SprawdzCzyToData(poz[5]):
                dane.append('Brak lub bdna data dla partii '+str(poz[0])+'/'+str(poz[1]))
    
            # sprawdzenie niepustoci zmiany
            if poz[6].strip()=='':
                dane.append('Brak zmiany przekazania dla partii '+str(poz[0])+'/'+str(poz[1]))
    
    if len(dane)>0:
        stat=dane[0]


#-------------------------------------------------------------------------------
# PTLA PO PARTIACH ZAPISYWANYCH PO KOLEI OD KOCA GRIDA
#-------------------------------------------------------------------------------
Partia=0
Art=''
LWier=[]
Ilosc=0
for i in range(len(LPartii)):
    if stat=='OK':
        poz=LPartii[len(LPartii)-1-i]
        if poz[4]>0:
            PartiaN=poz[0]
            if Partia <> PartiaN:
                # zapis poprzedniej partii
                if Partia<>0:
                    stat=ZapiszPartie(self,Art,SProcesy[Art],LWier,Ilosc,Data,Czas,klucze)
                
                # inicjalizacja nowej partii
                Partia=PartiaN
                Art=poz[2]
                LWier=[eval(str(poz))]
                Ilosc=poz[4]
            else:
                LWier.append(eval(str(poz)))
                Ilosc+=poz[4]
         
if Partia<>0 and stat=='OK':
    stat=ZapiszPartie(self,Art,SProcesy[Art],LWier,Ilosc,Data,Czas,klucze)            