
# -*- coding: iso8859_2 -*-

#-----------------------------------------------------------------------------
# Name:        fs_przeceny.py
# Purpose:     wczytuje/usuwa dane z przecenami
#
# Author:      Micha Raburski
# Created:     2007/01/11
# RCS-ID:      $Id: fs_przeceny.py $
# Copyright:   (c) 2006 Record System
# Licence:     GNU GPL
#-----------------------------------------------------------------------------


Data = klucze[0]
Mag = klucze[1]
Numer = str(klucze[2])
DataOdF = klucze[3]
DataDoF = klucze[4]
MagF = klucze[5]
Fun=klucze[-1]

stat = "OK"
dane = []

UprDodawanie=(((self.oddzial_id,'034014') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID))
UprUsuwanie=(((self.oddzial_id,'034014') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID))
UprZamykanie=(((self.oddzial_id,'034016') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID))


#-------------------------------------------------------------------------------
#pobranie magazynw do ktrych sa uprawnienia do przecen
#-------------------------------------------------------------------------------

LMag=["ZASLEPKA"]
if self.operator_id <> STANDARD_OPERATOR_ID:
    stat,dane,wyn1,tr = self.PolSQL.Execute("SELECT magazyn_id FROM rs_magazyny_upr WHERE firma_id='"+self.firma_id+"' AND przeceny AND operator_id in "+str(self.operatorzy).replace("[","(").replace("]",")")+";",3)
    for m in dane:
        LMag.append(rsglobal.Dekoduj(m[0]))


#-------------------------------------------------------------------------------
#---   INSERT DANYCH (2)
#-------------------------------------------------------------------------------

if Fun == 2 :
    if not UprDodawanie:
        stat="Brak uprawnie do dodawania przecen."
    else:
        SQL= "INSERT INTO rs_przeceny (firma_id,okres_id,dowod_id,nazwa_id,data,numer,kraj) VALUES "
        SQL+="('"+self.firma_id+"','"+self.okres_id+"','"+str(Dowod)+"','"+str(Nazwa)+"','"+str(Data)+"',"+str(Numer)+",'PL')"
        stat,dump,dump,dump = self.PolSQL.Execute(SQL,1)
        if stat!="OK":
            stat = 'Bdy dodawania kontrahenta : '+stat
            dane.append(stat)  
                    
                    
#-------------------------------------------------------------------------------
#---   DELETE DANYCH (6)
#-------------------------------------------------------------------------------

if Fun == 6 :
    if not UprUsuwanie:
        stat='UPR DEL'
    else:
        #Sprawdzenie operator ma uprawenienia do usuwania z magazynu
        if self.operator_id <> STANDARD_OPERATOR_ID:
            if not Mag in LMag:
                stat='UPR DELMAG'
        if stat=='OK':
            Filtr="WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+Mag+"'"
            Filtr=Filtr+" AND data_przec='"+Data+"' AND numer_przec="+Numer+";"                
            stat,dane,wyn1,tr = self.PolSQL.Execute("SELECT stan FROM rs_przeceny "+Filtr,3)        
            if len(dane) ==0:
                stat='BR DEL'
            else:
                if dane[0][0] =='Z':
                    stat='ZAMK DEL'
                if stat =='OK':  
                    Delete="DELETE FROM rs_przeceny "+Filtr 
                    Select="SELECT data,dokument_id,numer,nr_poz,nr_ppoz FROM rs_przeceny_pozycje "+Filtr
                    stat,poz,dump,dump = self.PolSQL.Execute(Select,3)
                    sql=''
                    for pozycja in poz:
                        Update="UPDATE rs_artykuly_przyjecia SET rezerwacja1=0,rezerwacja2=0 WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+Mag+"' AND data='"+rsglobal.Dekoduj(pozycja[0])+"' AND dokument_id='"+rsglobal.Dekoduj(pozycja[1])+"' AND numer='"+rsglobal.Dekoduj(str(pozycja[2]))+"' AND nr_poz='"+rsglobal.Dekoduj(str(pozycja[3]))+"' AND nr_ppoz='"+rsglobal.Dekoduj(str(pozycja[4]))+"'AND NOT wirtualne;"
                        sql=sql+Update
                    sql=sql+Delete
                    stat,dump,dump,dump = self.PolSQL.Execute(sql,1)
                    
                    
#-------------------------------------------------------------------------------
#---   ZAMKNICIE PRZECENY (7)
#-------------------------------------------------------------------------------

if Fun == 7 :
    if not UprZamykanie:
        stat='UPR ZAM'

    if stat=='OK':
        Filtr=" firma_id='"+self.firma_id+"' AND magazyn_id='"+Mag+"'"
        Filtr+=" AND data_przec='"+Data+"' AND numer_przec="+Numer
        
        #Sprawdzenie operator ma uprawenienia do usuwania z magazynu
        if self.operator_id <> STANDARD_OPERATOR_ID:
            if not Mag in LMag:
                stat='UPR ZAMMAG'
        Select="SELECT * FROM rs_przeceny_pozycje WHERE "+Filtr   
        stat,dane,wyn1,tr = self.PolSQL.Execute(Select,3) 
        if dane==[]:
            stat='BRAK POZYCJI'
            dane.apped(stat) 

    if stat=='OK':
        # sprawdzenie, czy na artykuach przyjcia s cigle dobre iloci
        SQLTest="SELECT * FROM rs_przeceny_pozycje pp "
        SQLTest+=" INNER JOIN rs_artykuly_przyjecia ap USING(firma_id,magazyn_id,dokument_id,data,numer,nr_poz,nr_ppoz)"
        SQLTest+="WHERE "+Filtr+" AND (pp.ilosc1<>ap.ilosc1 OR pp.ilosc1<>ap.rezerwacja1);"
        stat,DTest,dump,dump = self.PolSQL.Execute(SQLTest,3) 
        if stat <> 'OK':
            stat = u'Bd sprawdzenia artykuw przyjcia : '+stat
        elif len(DTest)>0:
            stat = u" Nie mona zamkn przeceny bo zmieniy si iloci w artykuach przyjcia"

    if stat == 'OK':
        SQL="SELECT stan FROM rs_przeceny WHERE "+Filtr
        stat,DPrzecN,dump,dump = self.PolSQL.Execute(SQL,3) 
        if stat <> 'OK':
            stat = u'Bd pobrania danych nagwka przeceny : '+stat
        elif len(DPrzecN)==0:
            stat = "BR PRZ"
        elif len(DPrzecN)>1:
            stat = "FATALNIE - Bd bazy"
        elif DPrzecN[0][0] <> "W":
            stat = "ZAM PRZ"
    
    if stat == 'OK':
        SQL="SELECT nr_serii,dokument_id,data,numer,nr_poz,nr_ppoz,cena1,cena2,cena_wal1,cena_wal2," # 0-9
        SQL+="nowa_cena1,nowa_cena2,nowa_cena_wal1,nowa_cena_wal2,artykul_id," # 10-14
        SQL+="ilosc1,ilosc2" # 15-16
        SQL+=" FROM rs_przeceny_pozycje WHERE "+Filtr
        stat,DPrzecP,dump,dump = self.PolSQL.Execute(SQL,3) 
        if stat <> 'OK':
            stat = u'Bd pobrania danych pozycji przeceny : '+stat

    if stat == 'OK':
        UPD=""
        Kwota=0
        Lp=0
        CzyRobic=False
        
        # stworzenie nagwka dokumentu magazynowego
        UPD+="INSERT INTO rs_dokumenty_magazynowe (firma_id,magazyn_id,dokument_id,data,numer,stan,"
        UPD+="magazyn_skad,magazyn_dokad) VALUES "
        UPD+="('"+self.firma_id+"','"+Mag+"','PR','"+Data+"',"+Numer+",'Z',"
        UPD+="'"+Mag+"','"+Mag+"');"
        
        # ptla po pozycjach przeceny
        for poz in DPrzecP:
            if stat=='OK':
                Lp=Lp+1
                seria=poz[0]
                if seria==None:
                    seria=" IS NULL"
                else:
                    seria="='"+seria+"'"
        
                FiltrArtP="WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+Mag+"'"
                FiltrArtP+=" AND dokument_id='"+poz[1]+"' AND data='"+poz[2]+"'"
                FiltrArtP+=" AND numer="+str(poz[3])+" AND nr_poz="+str(poz[4])+" AND nr_ppoz="+str(poz[5])
                FiltrArtP+=" AND nr_serii "+seria+" AND cena1="+str(poz[6])+" AND cena2="+str(poz[7])
                FiltrArtP+=" AND cena_wal1="+str(poz[8])+" AND cena_wal2="+str(poz[9])
                
                SQL="SELECT COALESCE(waluta,''),cena_pierw1,cena_pierw2,cena_pierw_wal1,cena_pierw_wal2"
                SQL+=" FROM rs_artykuly_przyjecia "+FiltrArtP+";"
                stat,DaneArt,dump,dump = self.PolSQL.Execute(SQL,3) 
                if stat <> 'OK':
                    stat = u'Bd pobrania danych z artykuw przyjcia : '+stat
                elif len(DaneArt) <> 1:
                    stat= "BL POZ"
            
            if stat=='OK':
                # jeli ceny si nie zmieniy
                if poz[6] == poz[10]:
                    UpdArt="UPDATE rs_artykuly_przyjecia SET rezerwacja1=0,rezerwacja2=0 " 
                    UpdArt+=FiltrArtP+";"
                    ObrotR=""
                    PozDMR=""
                    ObrotP=""    
                    PozDMP=""
                    
                # jeli ceny si zmieniy
                else:
                    if poz[10]==0:
                        stat='Zerowa cena w pozycji artykuw przyjcia o parametrach: '+FiltrArtP
                    UpdArt="UPDATE rs_artykuly_przyjecia SET rezerwacja1=0,rezerwacja2=0, cena1="+str(poz[10])+",cena2="+str(poz[11])
                    UpdArt+=",cena_wal1="+str(poz[12])+",cena_wal2="+str(poz[13])+","
                    UpdArt+="cena_pierw1= CASE WHEN cena_pierw1=0 THEN cena1 ELSE cena_pierw1 END,"
                    UpdArt+="cena_pierw2= CASE WHEN cena_pierw2=0 THEN cena2 ELSE cena_pierw2 END, "
                    UpdArt+="cena_pierw_wal1= CASE WHEN cena_pierw_wal1=0 THEN cena_wal1 ELSE cena_pierw_wal1 END,"
                    UpdArt+="cena_pierw_wal2= CASE WHEN cena_pierw_wal2=0 THEN cena_wal2 ELSE cena_pierw_wal2 END "
                    UpdArt+=FiltrArtP+";"
                    if poz[6]<> poz[10]:
                        if DaneArt[0][0] == '':
                            stat= "BL WALP"
            
                    if stat=='OK':
                        Waluta = DaneArt[0][0]
                        
                        CenaPierwW1=DaneArt[0][1]
                        CenaPierwW2=DaneArt[0][2]
                        CenaPierwWalW1=DaneArt[0][3]
                        CenaPierwWalW2=DaneArt[0][4]
        
                        if CenaPierwW1 >0:
                            CenaPierwP1=CenaPierwW1
                            CenaPierwP2=CenaPierwW2
                            CenaPierwWalP1=CenaPierwWalW1
                            CenaPierwWalP2=CenaPierwWalW2
                        else:
                            CenaPierwP1=poz[6]
                            CenaPierwP2=poz[7]
                            CenaPierwWalP1=poz[8]
                            CenaPierwWalP2=poz[9]
                     
                        nrtmp = "0000"+str(poz[3])
                        nrtmp = nrtmp[len(nrtmp)-6:len(nrtmp)-2]
                        poztmp = "0000"+str(poz[4])
                        poztmp = poztmp[len(poztmp)-6:len(poztmp)-2]
                        ppoztmp = "0000"+str(poz[5])
                        ppoztmp = ppoztmp[len(ppoztmp)-6:len(ppoztmp)-2]
                        magtmp=Mag+'    '

                        DokPrzych=self.firma_id+magtmp[:4]+poz[1]+str(poz[2])+nrtmp+poztmp+ppoztmp
                     
                        ObrotR="INSERT INTO rs_obroty_magazynowe "
                        ObrotR+="(firma_id,magazyn_id,dokument_id,data,numer,typ,typ_znak,nr_poz,nr_ppoz,artykul_id,"
                        ObrotR+="cena1,cena2,ilosc1,ilosc2,wartosc,waluta,cena_wal1,cena_wal2,wartosc_wal,"
                        ObrotR+="cena_pierw1,cena_pierw2,cena_pierw_wal1,cena_pierw_wal2)"
                        ObrotR+="VALUES "
                        ObrotR+="('"+self.firma_id+"','"+Mag+"','PR','"+Data+"',"+Numer+",'R',-1,"+str(Lp)+",1,'"+rsglobal.Dekoduj(poz[14])+"',"
                        ObrotR+=str(poz[6])+","+str(poz[7])+","+str(poz[15])+","+str(poz[16])+","+str(round(poz[15]*poz[6],2))+","
                        ObrotR+="'"+DaneArt[0][0]+"',"+str(poz[8])+","+str(poz[9])+","+str(rsglobal.RSRound(poz[15]*poz[8],2))+","
                        ObrotR+=str(CenaPierwW1)+","+str(CenaPierwW2)+","+str(CenaPierwWalW1)+","+str(CenaPierwWalW2)+");"
        
                        PozDMR="INSERT INTO rs_dokumenty_magazynowe_pozycje (firma_id,magazyn_id,dokument_id,data,numer,nr_poz,nr_ppoz,"
                        PozDMR+="artykul_id,ilosc1,ilosc2,cena1,cena2,cena_pierw1,cena_pierw2,cena_wal1,cena_wal2,"
                        PozDMR+="cena_pierw_wal1,cena_pierw_wal2,dokument_przych) VALUES "
                        PozDMR+="('"+self.firma_id+"','"+Mag+"','PR','"+Data+"',"+Numer+","+str(Lp)+",1,"
                        PozDMR+="'"+rsglobal.Dekoduj(poz[14])+"',-1*"+str(poz[15])+",-1*"+str(poz[16])+","+str(poz[6])+","+str(poz[7])+","+str(CenaPierwW1)+","+str(CenaPierwW1)+","+str(poz[8])+","+str(poz[9])+","
                        PozDMR+=str(CenaPierwWalW1)+","+str(CenaPierwWalW2)+",'"+DokPrzych+"');"
        
                        ObrotP="INSERT INTO rs_obroty_magazynowe "
                        ObrotP+="(firma_id,magazyn_id,dokument_id,data,numer,typ,typ_znak,nr_poz,nr_ppoz,artykul_id,"
                        ObrotP+="cena1,cena2,ilosc1,ilosc2,wartosc,waluta,cena_wal1,cena_wal2,wartosc_wal,"
                        ObrotP+="cena_pierw1,cena_pierw2,cena_pierw_wal1,cena_pierw_wal2)"
                        ObrotP+="VALUES "
                        ObrotP+="('"+self.firma_id+"','"+Mag+"','PR','"+Data+"',"+Numer+",'R',1,"+str(Lp)+",2,'"+rsglobal.Dekoduj(poz[14])+"',"
                        ObrotP+=str(poz[10])+","+str(poz[11])+","+str(poz[15])+","+str(poz[16])+","+str(rsglobal.RSRound(poz[15]*poz[10],2))+","
                        ObrotP+="'"+DaneArt[0][0]+"',"+str(poz[12])+","+str(poz[13])+","+str(rsglobal.RSRound(poz[15]*poz[12],2))+","
                        ObrotP+=str(CenaPierwP1)+","+str(CenaPierwP2)+","+str(CenaPierwWalP1)+","+str(CenaPierwWalP2)+");"

                        PozDMP="INSERT INTO rs_dokumenty_magazynowe_pozycje (firma_id,magazyn_id,dokument_id,data,numer,nr_poz,nr_ppoz,"
                        PozDMP+="artykul_id,ilosc1,ilosc2,cena1,cena2,cena_pierw1,cena_pierw2,cena_wal1,cena_wal2,"
                        PozDMP+="cena_pierw_wal1,cena_pierw_wal2,dokument_przych) VALUES "
                        PozDMP+="('"+self.firma_id+"','"+Mag+"','PR','"+Data+"',"+Numer+","+str(Lp)+",2,"
                        PozDMP+="'"+rsglobal.Dekoduj(poz[14])+"',"+str(poz[15])+","+str(poz[16])+","+str(poz[10])+","+str(poz[11])+","+str(CenaPierwP1)+","+str(CenaPierwP1)+","+str(poz[12])+","+str(poz[13])+","
                        PozDMP+=str(CenaPierwWalP1)+","+str(CenaPierwWalP2)+",'"+DokPrzych+"');"
        
                        Kwota=Kwota+((poz[10]-poz[6])*poz[15])
                        CzyRobic=True
                
            if stat=='OK':
                UPD+=UpdArt+ObrotR+PozDMR+ObrotP+PozDMP
                
    if stat=='OK':
        if not CzyRobic:
            stat= "BR ZMIAN"
        
    if stat=='OK':
        UPD=UPD+"UPDATE rs_przeceny SET stan='Z', kwota_przeceny="+str(Kwota)+" WHERE "+Filtr

        stat,dump,dump,dump = self.PolSQL.Execute(UPD,1) 
    
    if stat=='OK':
        # Update dokumentu magazynowego na kwoty
        SQL="SELECT SUM(ROUND(ilosc1*cena1,2)),SUM(ROUND(ilosc1*cena_wal1,2)),SUM(ROUND(ilosc1*cena_pierw1,2)),SUM(ROUND(ilosc1*cena_pierw_wal1,2))"
        SQL+=" FROM rs_dokumenty_magazynowe_pozycje WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+Mag+"'"
        SQL+=" AND dokument_id='PR' AND data='"+Data+"' AND numer="+Numer
        stat,DDok,dump,dump = self.PolSQL.Execute(SQL,3) 
        if stat <>'OK':
            stat = 'Bd pobierania sum z dokumentu magazynowego : '+stat
    
    if stat == 'OK':
        SQL="UPDATE rs_dokumenty_magazynowe SET waluta = '"+Waluta+"',kwota="+str(DDok[0][0])+","
        SQL+=" kwota_wal="+str(DDok[0][1])+",kwota_pierw="+str(DDok[0][2])+",kwota_pierw_wal="+str(DDok[0][3])
        SQL+=" WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+Mag+"'"
        SQL+=" AND dokument_id='PR' AND data='"+Data+"' AND numer="+Numer
        stat,dump,dump,dump = self.PolSQL.Execute(SQL,1) 


#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (2-insert, 5 -select, 6 -delete, 7 - zamknij)
#-------------------------------------------------------------------------------

if (Fun in [2,5,6,7,8]) and (stat=='OK'):
    # pobranie danych o dokumentach
    #rsglobal.ZapiszDoLogow(str(Fun),1)
    Filtr="WHERE p.firma_id='"+self.firma_id+"'"
    if MagF <> '':
        Filtr=Filtr+" AND p.magazyn_id='"+MagF+"'"
    if DataOdF <> '    -  -  ':
        Filtr=Filtr+" AND p.data_przec>='"+DataOdF+"'"                
    if DataDoF <> '    -  -  ':
        Filtr=Filtr+" AND p.data_przec<='"+DataDoF+"'" 
    if self.operator_id <> STANDARD_OPERATOR_ID:
        Filtr=Filtr+" AND p.magazyn_id IN ("+str(LMag)[1:-1]+")"
    Select="SELECT p.stan,p.magazyn_id||' - '||m.opis,p.data_przec,p.numer_przec,"
    Select+="p.kwota_przeceny FROM rs_przeceny p LEFT OUTER JOIN rs_magazyny m USING (firma_id,magazyn_id) "+Filtr+";"
    stat,dane,wyn1,tr = self.PolSQL.Execute(Select,3)