# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_przegladanie_archiwum.py
# Purpose:     uniwersalne okno z przegldaniem archiwum
# Author:      Piotr Witkowski
# Created:     2016/02/13
# RCS-ID:      $Id: fs_przegladanie_archiwum.py $
# Copyright:   (c) 2016 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

# 2021-09-06 Wojciech Skowron - (12635) Zamiana w zapytaniach: z_arch_czas -> z_czas, z_arch_op_id -> z_op_id


stat='OK'
if not 'Funkcja' in klucze:
    stat=u'Brak podanej funkcji w kluczach'

if stat=='OK':    
    Funkcja = klucze['Funkcja'] 
    SlPar={'Tabela':[5,],'klucz':[5,],'DataOd':[5,],'DataDo':[5,],'Operator':[5,]}

    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Funkcja,klucze)
    if Lista<>'':
        stat=u'Uwaga : wywoanie funkcji fs_przegladanie_archiwum z numerem ' +str(Funkcja)+u' bez parametrw: '+Lista
    
    if stat=='OK':
        if Funkcja in [5,]:
            Tabela = str(klucze['Tabela'])
            klucz = klucze['klucz']
            DataOd = str(klucze['DataOd'])
            DataDo = str(klucze['DataDo'])
            Operator = str(klucze['Operator'])

dane = []
wyn1 = []
wyn2 = []

if stat=='OK' and DataOd <> '    -  -  ':
    if not rsglobal.SprawdzCzyToData(DataOd):
        stat='DATAOD BL'
if stat=='OK' and DataDo <> '    -  -  ':
    if not rsglobal.SprawdzCzyToData(DataDo):
        stat='DATADO BL'
if stat=='OK' and (DataOd <> '    -  -  ') and (DataDo <> '    -  -  '):
    if DataOd > DataDo:
        stat='ZAKR DATA BL'


#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (5 -select, 6 -delete, 7 - zamknij)
#-------------------------------------------------------------------------------

if Funkcja ==5 and stat=='OK':

    if Tabela == u'ZamowieniaOdbiorcyPozycje':
        if not ((self.oddzial_id,'024020') in self.uprawnienia) and self.operator_id <> STANDARD_OPERATOR_ID:
            stat = u"Brak uprawnie do przegldania danych - pozycje jednorazowe zamwie odbiorcw"

        if stat=='OK':
            #WS 2021-09-06 z_arch_czas -> zo.z_czas, z_arch_op_id -> zo.z_op_id
            Select="SELECT zo.z_czas, zo.z_op_id, login, artykul_id, data_od, data_do, tryb_dostawy, "
            Select+="ilosc1, ilosc2, cena_netto1, cena_netto2, cena_upust1, cena_upust2,"
            Select+="cena_brutto1, cena_brutto2, upust, upust_wartosc, stawka_vat, wartosc_netto, wartosc_vat,"
            Select+="wartosc_brutto, zo.z_typ, zo.z_czas, zo.z_op_id, login "
            Select+="FROM rsa_zamowienia_odbiorcy_pozycje zo JOIN rs_operatorzy o ON zo.z_op_id = o.operator_id "
            Select+="WHERE zo.firma_id='"+self.firma_id+"'"
            Select+=" AND wyznacznik_id='"+str(klucz['Wyznacznik'])
            Select+="' AND data='"+str(klucz['Data'])
            Select+="' AND numer='"+str(klucz['Numer'])+"'"
            Select+=" AND nr_poz='"+klucz['NrPoz']+"' AND nr_ppoz='"+klucz['NrPPoz']+"'"

    elif Tabela == u'ZamowieniaOdbiorcyPozycjeStale':
        if not ((self.oddzial_id,'024050') in self.uprawnienia) and self.operator_id <> STANDARD_OPERATOR_ID:
            stat = u"Brak uprawnie do przegldania danych - pozycje stae zamwie odbiorcw"

        if stat=='OK':
            #WS 2021-09-06 z_arch_czas -> z_czas, z_arch_op_id -> z_op_id
            Select="SELECT zo.z_czas, zo.z_op_id, login, artykul_id, data_od, data_do, tryb_dostawy, "
            Select+="dz_00,dz_01,dz_02,dz_03,dz_04,dz_05,dz_06,dz_07,"
            Select+="zo.z_typ, zo.z_czas, zo.z_op_id, login "
            Select+="FROM rsa_zamowienia_odbiorcy_pozycje_stale zo JOIN rs_operatorzy o ON zo.z_op_id = o.operator_id "
            Select+="WHERE zo.firma_id='"+self.firma_id+"'"
            Select+=" AND wyznacznik_id='"+klucz['Wyznacznik']+"' AND data='"+str(klucz['Data'])+"' AND numer='"+str(int(klucz['Numer']))+"'"
            Select+=" AND artykul_id='"+klucz['Artykul'].strip()+"' AND data_od='"+klucz['DataOd']+"' AND tryb_dostawy='"+klucz['TrybDostawy']+"'"

    if stat =='OK':
        #WS 2021-09-06 z_arch_czas -> z_czas
        if Operator <> '':
            Select +=" AND login like '"+Operator+"%'"
        if DataOd <> '    -  -  ':
            Select +=" AND zo.z_czas>='"+DataOd+"'"
        if DataDo <> '    -  -  ':
            Select +=" AND zo.z_czas<='"+DataDo+" 23:59:59'"
        Select+=" ORDER BY zo.z_czas DESC;"
        stat,dane,wyn1,tr = self.PolSQL.Execute(Select,3)
        if stat<>'OK':
            stat=u"Bd przy pobieraniu danych: "+stat