# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_przesylki_dane.py
# Purpose:     przesylki - wprowadzanie i edycja
# Author:      Dariusz Boduch
# Created:     2010-07-05
# RCS-ID:      $Id: fs_artykuly_rezerwacje_dane.py $
# Copyright:   (c) 2009 Record System
# Licence:     GNU GPL   
#-------------------------------------------------------------------------------

Data = klucze[0]
Numer = klucze[1]
LiczbaPalet = klucze[2]
FirmaPrzew = klucze[3]
ListPrzew = klucze[4]
Dzialanie = klucze[5] # dzialanie true - edycja , false -insert
Fun = klucze[-1]

dane = []
stat = 'OK'

if self.operator_id == STANDARD_OPERATOR_ID:
    UprEdy=True
    UprIns=True
else:
    UprEdy=(self.oddzial_id,'231012') in self.uprawnienia
    UprDel=(self.oddzial_id,'231014') in self.uprawnienia
    UprIns=(self.oddzial_id,'231013') in self.uprawnienia
    UprZam=(self.oddzial_id,'231018') in self.uprawnienia
    UprOtw=(self.oddzial_id,'231019') in self.uprawnienia
     
#-------------------------------------------------------------------------------
#---   POBIERANIU NOWEGO NUMERU PRZESYLKI (12)
#-------------------------------------------------------------------------------

if Fun in [12] and stat=='OK':
    Select="SELECT MAX(numer) FROM rs_przesylki WHERE firma_id='"+self.firma_id+"' AND data='"+Data+"' ;"  
    stat,dane,wyn1,tr = self.PolSQL.Execute(Select,3)
    if stat<>'OK':
        stat = 'Bdy pobierania danych :'+stat
        dane.append(stat)    

#-------------------------------------------------------------------------------
#---   SPRAWDZANIE DANYCH (7)
#-------------------------------------------------------------------------------

if Fun in [1,2,3,4] and stat=='OK':                  
    if Data == '    -  -  ':
        stat = "BR DATA"
        dane.append(stat)
    elif not rsglobal.SprawdzCzyToData(Data):
        stat="BL DATA"
        dane.append(stat)    
        
    if stat=='OK':   
        if Numer== 0:
            stat = "BL NUMER"
            dane.append(stat)

    if str(FirmaPrzew)<>'' and stat=='OK':               
        sql = "SELECT kontrahent_id, aktywny FROM rs_kontrahenci WHERE firma_id='"+self.firma_id+"' "
        sql+= "AND kontrahent_id = '"+str(FirmaPrzew)+"' ;"
        stat,daneA,dump,dump = self.PolSQL.Execute(sql ,3) 
        if stat<>'OK':
            stat = 'Bdy pobierania firmy przewozowej:'+stat
            dane.append(stat) 
        elif len(daneA)==0:
            stat = "BL FIRMA"
            dane.append(stat)
        else:
            if not daneA[0][1]:
                stat = "BL ACTIV"
                dane.append(stat)
                          
#-------------------------------------------------------------------------------
#---   INSERT DANYCH (2- bez pobierania,1- z pobieraniem)
#-------------------------------------------------------------------------------

if Fun in [1,2] and stat=='OK':
    if not UprIns:
        stat=="UPR INS"
        dane.append(stat)    
    
    if stat=='OK':    
        ins = "INSERT INTO rs_przesylki"
        Pola="firma_id"
        Wartosci="'"+self.firma_id+"'"
        for i in range(len(pola)):
            pole = pola[i]
            wart = wartosci[i]
            if pole in ['data','firma_przewozowa','list_przewozowy']:
                Pola= Pola+","+pole
                if wart.strip()=='':
                    Wartosci= Wartosci+",NULL"
                else:
                    Wartosci= Wartosci+",'"+str(wart)+"'"      
            if pole in ['numer','liczba_palet']:
                Pola= Pola+","+str(pole)
                Wartosci= Wartosci+","+str(wart)+""       
        ins = ins+" ("+Pola+") VALUES ("+Wartosci+");" 
                
        stat,dump,dump,dump = self.PolSQL.Execute(ins ,1)
        if stat<>'OK':
            stat = 'Bdy dodawania danych:'+stat
            dane.append(stat)             
           
#-------------------------------------------------------------------------------
#---   UPDATE DANYCH (4- bez pobierania,3- z pobieraniem)
#-------------------------------------------------------------------------------

if Fun in [3,4] and stat=='OK':
    if not UprEdy:
        stat=="UPR EDY"
        dane.append(stat)  
    
    if stat=='OK':                          
        where = " WHERE firma_id='"+self.firma_id+"' AND data='"+Data+"' AND numer="+str(Numer)+"; "
        upd = "UPDATE rs_przesylki SET "
        for i in range(len(pola)):
            pole = pola[i]
            wart = wartosci[i]   
            if pole in ['list_przewozowy', 'firma_przewozowa']:
                upd += pole+"='"+str(wart)+"',"
            if pole in ['numer','liczba_palet']:
                upd += pole+"="+str(wart)+","
        upd = upd[0:len(upd)-1]+where        
        stat,dump,dump,dump = self.PolSQL.Execute(upd ,1)
        if stat<>'OK':
            stat = 'Bdy modyfikowania danych:'+stat
            dane.append(stat)    

#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (1- insert 5 -select, 6 -delete)
#-------------------------------------------------------------------------------

if (Fun in [1,3,5,6,11]) and (stat=='OK') :
    Select="SELECT * FROM rs_przesylki WHERE firma_id='"+self.firma_id+"' "
    Select+="AND data='"+Data+"' AND numer="+str(Numer)+" ;"    
    stat,dane,wyn1,tr = self.PolSQL.Execute(Select,3)
    if stat<>'OK':
        stat = 'Bdy pobierania danych :'+stat
        dane.append(stat)

    if len(dane) == 1:
        tr = rssql.RSTableRowset(dane,wyn1)

        #---firma przewozowa (kontrahent)
        if ((self.oddzial_id,'012010') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
            dump,d,dump,dump = self.PolSQL.Execute("SELECT nazwa FROM rs_kontrahenci WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+tr.GetVal(0,"firma_przewozowa")+"';" ,3)
            if len(d) == 0:
                wyn2.append('')
            else:
                wyn2.append(d[0][0])
        else:
            wyn2.append('Brak uprawnie do kontrahentw. Poinformuj administratora.')
    