
# -*- coding: iso8859_2 -*-

#-----------------------------------------------------------------------------
# Name:        fs_przesylki_pozycje.py
# Purpose:     wczytuje/usuwa pozycje przesylek magazynowych
#
# Author:      Dariusz Boduch   
# Created:     2010/07/09
# RCS-ID:      $Id: fs_przesylki_pozycje.py $
# Copyright:   (c) 2010 Record System
# Licence:     GNU GPL
#-----------------------------------------------------------------------------

DataP=klucze[0]
NumerP=klucze[1]
Magazyn=klucze[2]
Dokument=klucze[3]
DataM=klucze[4]
NumerM=klucze[5]
Dodane=klucze[6]

Fun=klucze[-1]

stat = "OK"
dane = []

if self.operator_id == STANDARD_OPERATOR_ID:
    UprDel=True
    UprIns=True
else:
    UprDel=(self.oddzial_id,'231024') in self.uprawnienia
    UprIns=(self.oddzial_id,'231023') in self.uprawnienia


#-------------------------------------------------------------------------------
#---   INSERT DANYCH (1)
#-------------------------------------------------------------------------------

if Fun == 1 and stat=='OK':
    if not UprIns:
        stat='Brak uprawnie do dodawania pozycji przesyek'
        dane.appedn(stat)
    if stat=='OK':
        if Dodane==[]:
            stat='Brak dokumentw magazynowych do dodania'
            dane.append(stat)
        else:
            UPD=''
            for w in Dodane:
                Upd="UPDATE rs_dokumenty_magazynowe SET p_data='"+DataP+"' , p_numer="+str(NumerP)+" "     
                Upd+=" WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+str(w[0])+"' AND dokument_id='"+str(w[1])+"' "
                Upd+=" AND data='"+str(w[2])+"' AND numer="+str(w[3])+"; "
                UPD=UPD+Upd        
            
            stat,dump,dump,dump = self.PolSQL.Execute(UPD,1)
            if stat<>'OK':
                stat="Bd dodawania pozycji przesyki: "+stat
                dane.append(stat)
                
#-------------------------------------------------------------------------------
#---   DELETE DANYCH (6)
#-------------------------------------------------------------------------------

if Fun == 6 and stat=='OK':
    if not UprDel:
        stat='Brak uprawnie do usuwania pozycji przesyek'
        dane.append(stat)
    
    if stat=='OK':
        Del="UPDATE rs_dokumenty_magazynowe SET p_data= NULL , p_numer=NULL "     
        Del+=" WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+str(Magazyn)+"' AND dokument_id='"+str(Dokument)+"' "
        Del+=" AND data='"+str(DataM)+"' AND numer="+str(NumerM)+"; "
           
        stat,dump,dump,dump = self.PolSQL.Execute(Del,1)
        if stat<>'OK':
            stat="Bd usuwania pozycji przesyki: "+stat
            dane.append(stat)

#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (1-insert, 5 -select, 6 -delete)
#-------------------------------------------------------------------------------

if (Fun in [1,5,6]) and (stat=='OK'):
    SQL="SELECT m.magazyn_id, m.dokument_id, m.data, m.numer, m.kontrahent_id, k.nazwa FROM rs_dokumenty_magazynowe m "
    SQL+="LEFT OUTER JOIN rs_kontrahenci k ON(m.firma_id=k.firma_id AND m.kontrahent_id=k.kontrahent_id) "
    SQL+="WHERE m.firma_id='"+self.firma_id+"' AND m.p_data='"+DataP+"' AND m.p_numer="+str(NumerP)+" "
    SQL+="ORDER BY m.magazyn_id, m.dokument_id, m.data, m.numer ; "

    stat,dane,wyn1,tr = self.PolSQL.Execute(SQL,3)
    if stat<>'OK':
        stat='Bd pobierania danych: '+stat
        dane.append(stat)