
# -*- coding: iso8859_2 -*-

#-------------------------------------------------------------------------------
# Name:        fs_przeszacowania.py
# Purpose:     wyswietla, dodaje,usuwa przeszacowania operujac na tabeli rs_arkusze_przeszacowania
# Author:      Marcin Wlodarczyk, Pawe Wjcikowski
# Created:     2008/11/12
# RCS-ID:      $Id: fs_przeszacowania.py$
# Copyright:   (c) 2008 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------
#2015-01-29 - Marcin Natkaski - przejcie na sowniki, klucze, delikatny refaktoring

stat = "OK"
dane = []
Num=''

if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=='OK':
    Fun = klucze['Funkcja']
    
    SlPar={'StanF':[1,5,6],'DataOdF':[1,5,6],'Numer':[6,11],'SrodekF':[1,5,6],
    'Data':[6,11],'Data':[8,],'DataDekr':[11,],'DataDod':[1,20],'DataDoF':[1,5,6],'KorektaDod':[1,],
    'Dowod':[11,],'Nazwa':[11],'Konto':[11,]}    
    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Fun,klucze)
    if Lista<>'':
        stat='Uwaga : wywoanie funkcji fs_przeszacowania z numerem '+str(Fun)+' bez parametrw: '+Lista

if stat=='OK':
    if Fun in [1,]:
        Data=rsglobal.Dekoduj(klucze['DataDod'])
        KorektaDod=rsglobal.Dekoduj(klucze['KorektaDod'])
    if Fun in [1,5,6]:
        StanF=rsglobal.Dekoduj(klucze['StanF'])
        DataOdF=rsglobal.Dekoduj(klucze['DataOdF'])
        DataDoF=rsglobal.Dekoduj(klucze['DataDoF'])
        SrodekF=rsglobal.Dekoduj(klucze['SrodekF'])
    if Fun in [6,11]:
        Numer=rsglobal.Dekoduj(klucze['Numer'])
        Data=rsglobal.Dekoduj(klucze['Data'])
    if Fun in [11,]:
        KontoMa=rsglobal.Dekoduj(klucze['Konto'])
        Dowod=rsglobal.Dekoduj(klucze['Dowod'])
        Nazwa=rsglobal.Dekoduj(klucze['Nazwa'])
        DataDekr=rsglobal.Dekoduj(klucze['DataDekr'])
    if Fun in [20]:
        DataDod=rsglobal.Dekoduj(klucze['DataDod']) 
 
UprDodawanie=(((self.oddzial_id,'174313') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID))
UprUsuwanie=(((self.oddzial_id,'174314') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID))
UprZamykanie=(((self.oddzial_id,'174316') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID))

#-------------------------------------------------------------------------------
#---- OKIENKO DODAWANA --
#-------------------------------------------------------------------------------
if Fun==20 and stat== "OK":
    if DataDod == "    -  -  ":
        stat = "BR_DATA"
        dane.append(stat)
    elif (not rsglobal.SprawdzCzyToData(DataDod)):
        stat = "BL_DATA"
        dane.append(stat)
    else:
        sql ="SELECT data_od,data_do FROM rs_definicje_okresow"
        sql+=" WHERE firma_id = '"+self.firma_id+"' AND okres_id = '"+self.okres_id+"';"
        stat,d,dump,dump = self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Bd pobrania zakresu dat dla okresu ksigowego : '+stat
            dane.append(stat)
        else:
            if len(d) <> 1:
                stat = 'BR_OKRES'
                dane.append(stat)
            else:
                if DataDod < str(d[0][0]) or DataDod > str(d[0][1]):
                    stat = 'BL_OKRES'
                    dane.append(stat)
        
#-------------------------------------------------------------------------------
#---   INSERT DANYCH (1)
#-------------------------------------------------------------------------------
if Fun == 1 and stat == "OK":
    if not UprDodawanie:
        stat="UPR INS"
    if stat=="OK": 
        if KorektaDod:
            Korekta='TRUE'
        else:
            Korekta='FALSE'
        Warunek = "firma_id=\\\'"+self.firma_id+"\\\' AND data=\\\'"+Data+"\\\'"
        Select = "SELECT rsf_klucz_where_new('rs_arkusze_przeszacowania','"+Warunek+"','numer');"
        stat,dane,wyn1,tr = self.PolSQL.Execute(Select,3)
        if stat!="OK":
            stat="BL NUM"   
            dane.append(stat)
        else:
            Num=str(dane[0][0])
            query="INSERT INTO rs_arkusze_przeszacowania (firma_id, numer, data, stan,korekta)"
            query+=" VALUES ('"+self.firma_id+"','"+str(Num)+"','"+str(Data)+"','W',"+Korekta+");"
            stat,dump,dump,dump = self.PolSQL.Execute(query ,1)
            if stat!="OK":
                stat="BL INS"   
                dane.append(stat)
            else:
                nowy_klucz = ['W',str(Data),Num]
                
#-------------------------------------------------------------------------------
#---   ZAMYKANIE DOKUMENTU (11)   
#-------------------------------------------------------------------------------
if Fun ==11 and stat=='OK':
    if not UprZamykanie:
        stat='UPR ZAM'
    
    if stat=='OK':
        from funkcje.fs_srodki_trwale_tworzenie_planu import StworzPlanSrodkaTrwalego
        if KontoMa=='':
            stat='Nie podano konta ma do dekretacji zmiany wartoci rodka'
        else:
            SQL="SELECT rsf_podaj_parametr_konta('"+self.firma_id+"','"+self.okres_id+"','"+KontoMa+"',0);"
            stat,DKonta,dump,dump=self.PolSQL.Execute(SQL,3)
            if stat=='OK':
                if DKonta[0][0]=='':
                    stat='Podano nieprawidowe konto ma'

    if stat=='OK':
        SQL="SELECT dowod_id FROM rs_wzory_dekretacji WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"'"
        SQL+=" AND dowod_id='"+Dowod+"' AND nazwa_id='"+Nazwa+"' FOR UPDATE;"
        stat,DDekr,dump,dump=self.PolSQL.Execute(SQL,3)
        if stat<>'OK':
            stat='Bdy pobierania dancych ze wzorw dekretacji :'+stat
        elif len(DDekr)==0:
            stat=' Podano nieprawidowy wzr dekretacji'
    
    if stat=='OK':
        if not rsglobal.SprawdzCzyToData(DataDekr):
            stat='Podana data dekretacji jest nieprawidowa'
            
    if stat=='OK':
        SQL="SELECT rsf_sprawdz_czy_mozna_dodac_dokument('"+self.firma_id+"',"
        SQL+="'[\""+self.okres_id+"\",\""+Dowod+"\",\""+Nazwa+"\",\""+DataDekr+"\"]','D')"
        stat,DTest,dump,dump=self.PolSQL.Execute(SQL,3)
        if stat=='OK':
            if DTest[0][0]<>'OK':
                stat=DTest[0][0]
                
    if stat=='OK':
        SQL="SELECT rsf_podaj_nowy_numer_dokumentu('"+self.firma_id+"',"
        SQL+="'[\\\'"+self.okres_id+"\\\',\\\'"+Dowod+"\\\',\\\'"+Nazwa+"\\\',\\\'"+DataDekr+"\\\']','D');"
        stat,DNr,dump,dump = self.PolSQL.Execute(SQL,3)
        if stat<>'OK':
            stat='Bdy pobierania dancych o nowym numerze : '+stat
    if stat=='OK':
        if DNr[0][0] in (None,'None',''):
            stat=="Bdy pobierania nowego numeru dokumentu"
        else:
            NumerD=rsglobal.Dekoduj(DNr[0][0])
    # sprawdzenie czy przeszacowanie jest korekt
    if stat=='OK':
        SQL="SELECT korekta FROM rs_arkusze_przeszacowania "
        SQL+="WHERE firma_id='"+self.firma_id+"' AND numer="+str(Numer)+" AND data='"+str(Data)+"' FOR UPDATE;"
        stat,Dane,dump,dump=self.PolSQL.Execute(SQL,3)
        if stat<>'OK':
            stat = 'Bdy przy pobieraniu informacji o przeszacowaniu :'+stat
            dane.append(stat)
        elif len(Dane)==0:
            stat = 'Brak zamykanej zmiany wartoci rodka'
            dane.append(stat)
    if stat=='OK':
        if Dane[0][0]:
            Korekta='TRUE'
        else:
            Korekta='FALSE'

        Rok=str(Data[0:4])
        Miesiac=str(Data[5:7])    
        Dzien=str(Data[8:10])
        sql="SELECT srodek_id,rach_przed,rach_przesz,rach_po,podat_przed,podat_przesz,podat_po"
        sql+=" FROM rs_arkusze_przeszacowania_pozycje "
        sql+="WHERE firma_id='"+self.firma_id+"' AND numer="+str(Numer)+" AND data='"+str(Data)+"';"
        stat,dane,wyn1,wyn2=self.PolSQL.Execute(sql,3)
        if stat<>'OK':
            stat = 'Bdy przy pobieraniu rodkw :'+stat
            dane.append(stat)
        elif len(dane)==0:
            stat = 'Brak pozycji w zamykanej zmianie wartoci rodka'
            dane.append(stat)
    
    #-------------------------------------------------------------------------------
    #--- sprawdzenie poprawnoci danych z przeszacowania - czy mona zrobi to z wybranymi rodkami
    #-------------------------------------------------------------------------------
    if stat=='OK':
        for wart in dane:
            SrodekId=str(wart[0])  
            if stat=='OK':    
                sql="SELECT data_przyjecia,data_sprzedazy,data_likwidacji FROM rs_srodki_trwale "
                sql+="WHERE firma_id='"+self.firma_id+"' AND srodek_id='"+str(SrodekId)+"';"
                stat,daneDP,wyn1,wyn2=self.PolSQL.Execute(sql,3)                   
                if stat<>'OK':
                    stat = 'Bdy przy pobieraniu dat :'+stat
                    dane.append(stat)
                elif len(daneDP)<>0:
                    data_przyjecia = daneDP[0][0]
                    data_sprzedazy = daneDP[0][1]
                    data_likwidacji = daneDP[0][2]
                    if data_przyjecia>Data:
                        stat = 'Data zamiany wartoci rodka :'+str(SrodekId).strip()+' jest wczeniejsza od daty przyjcia.'
                        dane.append(stat)    
                    elif data_sprzedazy<Data:
                        stat = 'rodek : '+str(SrodekId).strip()+' zosta ju sprzedany.'
                        dane.append(stat)    
                    elif data_likwidacji<Data:
                        stat = 'rodek : '+str(SrodekId).strip()+' zosta ju zlikwidowany.'
                        dane.append(stat)  
            if stat=='OK':    
                sql="SELECT umorzone FROM rs_srodki_trwale_plan "
                sql+="WHERE firma_id='"+self.firma_id+"' AND srodek_id='"+str(SrodekId)+"'"
                sql+=" AND (rok='"+str(Rok)+"' AND miesiac>'"+str(Miesiac)+"' OR rok>'"+str(Rok)+"') AND umorzone;"
                stat,daneUM,wyn1,wyn2=self.PolSQL.Execute(sql,3)                   
                if stat<>'OK':
                    stat = 'Bdy przy pobieraniu informacji o umorzeniu :'+stat
                    dane.append(stat)
                elif len(daneUM)>0:
                    stat ='rodek :'+str(SrodekId).strip()+' by ju umorzony po podanym miesicu .'
                    dane.append(stat)    
                            
    #-------------------------------------------------------------------------------
    #--- jeli dane poprawne to zamykamy
    #-------------------------------------------------------------------------------
    if stat=='OK':
        # tworzymy nagwek dowodu dostawy
        SQLDK="INSERT INTO rs_dowody_ksiegowe (firma_id,okres_id,dowod_id,nazwa_id,data,numer,stan) VALUES "
        SQLDK+="('"+self.firma_id+"','"+self.okres_id+"','"+Dowod+"','"+Nazwa+"','"+DataDekr+"',"+str(NumerD)+",'W');"
        NrPozDD=1
        for wart in dane:
            if stat=='OK':
                SrodekId=str(wart[0])                      
                sql="SELECT metoda_amortyzacji,wartosc_poczatkowa,wartosc_aktualna,stawka_procent,czy_podatkowa" # 0-4
                sql+=",metoda_amortyzacji_p,wartosc_poczatkowa_p,wartosc_aktualna_p,stawka_procent_p,okres_amortyzacji" #5-9
                sql+=",okres_amortyzacji_p,wartosc_umorzenia,wartosc_umorzenia_p,data_przeszac" #10-13
                sql+=",wartosc_koncowa,wartosc_koncowa_p,COALESCE(konto_ewid,''),nazwa FROM rs_srodki_trwale " #14-17
                sql+="WHERE firma_id='"+self.firma_id+"' AND srodek_id='"+str(SrodekId)+"';"
                stat,daneST,wyn1,wyn2=self.PolSQL.Execute(sql,3)            
                if stat<>'OK':
                    stat = 'Bdy przy pobieraniu danych rodka :'+stat
                    dane.append(stat)   
            if stat=='OK':
                #zapis danych do tabeli rs_srodki_trwale_dekrety
                SQLDK+="INSERT INTO rs_srodki_trwale_dekrety (firma_id,srodek_id,typ,okres_id,"
                SQLDK+="dowod_id,nazwa_id,data,numer) VALUES ('"+self.firma_id+"','"+SrodekId+"','ZW',"
                SQLDK+="'"+self.okres_id+"','"+Dowod+"','"+Nazwa+"','"+DataDekr+"',"+str(NumerD)+");"
            if stat=='OK':
                #dane pobierane z rs_srodki_trwale
                #dotyczace zm. wart. rachunkowej
                WartPocz=daneST[0][1]
                OkresAmort=str(daneST[0][9])
                MetodaAmort=str(daneST[0][0])
                StawkaProc=daneST[0][3]
                WartoscUmorzenia=daneST[0][11]
                #dotyczace zm. wart. podatkowej
                CzyPodatkowa=daneST[0][4]
                WartPoczP=daneST[0][6]
                OkresAmortP=str(daneST[0][10])
                MetodaAmortP=str(daneST[0][5])
                StawkaProcP=daneST[0][8]
                WartoscUmorzeniaP=daneST[0][12]
                DataPrzeszacowania=daneST[0][13]
                WartKoncowa=daneST[0][14]
                WartKoncowaP=daneST[0][15]
                KontoEwid=str(daneST[0][16])
                NazwaSr=str(daneST[0][17])
                #dane pobierane z rs_przeszacowania_pozycje
                RachPrzed=wart[1]
                RachPrzesz=wart[2]
                RachPo=wart[3]
                PodatPrzed=wart[4]
                PodatPrzesz=wart[5]
                PodatPo=wart[6]
                TrescDD="Zmiana wart. rodka "+SrodekId.strip()+' - '+rsglobal.Dekoduj(NazwaSr).strip()
                TrescDD=str(TrescDD[:100])
                #-----------------------------------
                # liczona amortyzacja zwyka
                #-----------------------------------
                WartPocz=WartPocz+RachPrzesz
                WartAkt=WartPocz-WartoscUmorzenia
                UPDPom=''
                if MetodaAmort=='L':
                    if WartPocz-WartKoncowa>0:
                        ProcUm=abs(min(rsglobal.RSRound((WartoscUmorzenia/(WartPocz-WartKoncowa))*100,2),999))
                    else:
                        ProcUm=0
                    Ile=1
                    if OkresAmort=='M':
                        Ile=12
                    elif OkresAmort=='K':
                        Ile=4
                    elif OkresAmort=='R':
                        Ile=1 
                    StawkaWart=rsglobal.RSRound((WartPocz-WartKoncowa)*StawkaProc*0.01/Ile,2)
                    UPDPom=",procent_umorzenia='"+str(ProcUm)+"',stawka_wartosc='"+str(StawkaWart)+"'"
                    if not CzyPodatkowa:                                
                        UPDPom+=",procent_umorzenia_p='"+str(ProcUm)+"',stawka_wartosc_p='"+str(StawkaWart)+"'"
                elif MetodaAmort=='C':
                    UPDPom=",stawka_wartosc='"+str(WartPocz)+"'"
                    if not CzyPodatkowa:
                        UPDPom+=",stawka_wartosc_p='"+str(WartPocz)+"'"
                #dodanie pozycji rachunkowej do dowodu ksigowego
                if stat=='OK':
                    if not RachPrzesz==0:
                        SQLDK+="INSERT INTO rs_dowody_ksiegowe_pozycje (firma_id,okres_id,dowod_id,nazwa_id,data,numer,"
                        SQLDK+="nr_poz,nr_ppoz,nr_pozw, konto_wn, kwota_wn, tresc_wn,waluta_wn, kurs_wn, kwota_wal_wn, "
                        SQLDK+="konto_ma, kwota_ma, tresc_ma,waluta_ma, kurs_ma, kwota_wal_ma,sposob_rozl) VALUES "
                        SQLDK+="('"+self.firma_id+"','"+self.okres_id+"','"+Dowod+"','"+Nazwa+"','"+DataDekr+"',"+str(NumerD)+","
                        SQLDK+=str(NrPozDD)+",0,1,'"+KontoEwid+"',"+str(RachPrzesz)+",'"+str(TrescDD)+"','PLN',1,"+str(RachPrzesz)+","
                        SQLDK+="'"+KontoMa+"',"+str(RachPrzesz)+",'"+TrescDD+"','PLN',1,"+str(RachPrzesz)+",'');"
                        NrPozDD=NrPozDD+1                
   
                #-----------------------------------
                # jeli osobna to liczona amortyzacja podatkowa
                #-----------------------------------
                if CzyPodatkowa:  
                    WartPoczP=WartPoczP+PodatPrzesz
                    WartAktP=WartPoczP-WartoscUmorzeniaP
                    if MetodaAmortP=='L':
                        if WartPoczP-WartKoncowaP>0:                                   
                            ProcUm=abs(min(round((WartoscUmorzeniaP/(WartPoczP-WartKoncowaP))*100,2),999))
                        else:
                            ProcUm=0
                        Ile=1
                        if OkresAmortP=='M':
                            Ile=12
                        elif OkresAmortP=='K':
                            Ile=4
                        elif OkresAmortP=='R':
                            Ile=1
                        StawkaWartP=rsglobal.RSRound((WartPoczP-WartKoncowaP)*StawkaProcP*0.01/Ile,2)
                        UPDPom+=",procent_umorzenia_p='"+str(ProcUm)+"',stawka_wartosc_p='"+str(StawkaWartP)+"'"
                    elif MetodaAmortP=='C':
                        UPDPom+=",stawka_wartosc_p='"+str(WartPoczP)+"'"    
                    #dodanie pozycji podatkowej
                    if PodatPrzesz<>0:
                        SQLDK+="INSERT INTO rs_dowody_ksiegowe_pozycje (firma_id,okres_id,dowod_id,nazwa_id,data,numer,"
                        SQLDK+="nr_poz,nr_ppoz,nr_pozw, konto_wn, kwota_wn, tresc_wn,waluta_wn, kurs_wn, kwota_wal_wn, "
                        SQLDK+="konto_ma, kwota_ma, tresc_ma,waluta_ma, kurs_ma, kwota_wal_ma,sposob_rozl) VALUES "
                        SQLDK+="('"+self.firma_id+"','"+self.okres_id+"','"+Dowod+"','"+Nazwa+"','"+DataDekr+"',"+str(NumerD)+","
                        SQLDK+=str(NrPozDD)+",0,1,'"+KontoEwid+"',"+str(PodatPrzesz)+",'"+str(TrescDD)+"','PLN',1,"+str(PodatPrzesz)+","
                        SQLDK+="'"+KontoMa+"',"+str(PodatPrzesz)+",'"+TrescDD+"','PLN',1,"+str(PodatPrzesz)+",'');"
                        NrPozDD=NrPozDD+1                
                UPD="UPDATE rs_srodki_trwale SET data_przeszac='"+str(Data)+"',"
                UPD+="wartosc_poczatkowa='"+str(WartPocz)+"', wartosc_aktualna='"+str(WartAkt)+"',"
                if CzyPodatkowa:
                    UPD+=" wartosc_poczatkowa_p='"+str(WartPoczP)+"', wartosc_aktualna_p='"+str(WartAktP)+"'"
                else:
                    UPD+=" wartosc_poczatkowa_p='"+str(WartPocz)+"', wartosc_aktualna_p='"+str(WartAkt)+"'"
                UPD+=UPDPom
                UPD+=" WHERE firma_id='"+self.firma_id+"' AND srodek_id='"+str(SrodekId)+"';"     
                # wstawienie przeliczonych
                stat,dump,dump,dump = self.PolSQL.Execute(UPD,1)                        
                if stat!="OK":
                    stat="Bd przy modyfikacji rodka "+(SrodekId).strip()+" : "+stat   
                    dane.append(stat) 
            # wstawiamy wiersz do przeszacowa srodkw trwaych
            if stat=='OK':
                SQL="INSERT INTO rs_srodki_trwale_przeszacowania (firma_id,srodek_id,rok,miesiac,data,numer," 
                SQL+="rach_przed, rach_przesz, rach_po, podat_przed, podat_przesz, podat_po,korekta)"
                SQL+=" VALUES ('"+self.firma_id+"','"+str(SrodekId)+"','"+str(Rok)+"','"+str(Miesiac)+"','"+Data+"',"+str(Numer)+","
                SQL+="'"+str(RachPrzed)+"','"+str(RachPrzesz)+"','"+str(RachPo)+"',"
                SQL+="'"+str(PodatPrzed)+"','"+str(PodatPrzesz)+"',"+str(PodatPo)+","+Korekta+"); "
                # zmiana histori przeszacowa
                stat,dump,dump,dump = self.PolSQL.Execute(SQL ,1)
                if stat!="OK":
                    stat="Bd przy dodawaniu/zmianie wpisu w histori zmian wartoci: "+stat   
                    dane.append(stat) 
            if stat=='OK':
                stat=StworzPlanSrodkaTrwalego(self.firma_id,SrodekId,self.PolSQL)                   
                if stat!="OK":
                    stat="Bd przy zamykaniu rodka "+(SrodekId).strip()+" : "+stat   
                    dane.append(stat) 
        if stat=='OK':  
            stat,dump,dump,dump = self.PolSQL.Execute(SQLDK,1)
            if stat!="OK":
                stat="Bd przy tworzeniu dowodu ksigowego: "+stat   
                dane.append(stat) 
        if stat=='OK':
            upd="UPDATE rs_arkusze_przeszacowania SET "
            upd+=" stan ='Z' " 
            upd+="WHERE firma_id='"+self.firma_id+"' AND data='"+str(Data)+"' AND numer="+str(Numer)+";"                            
            stat,d,wyn1,dump = self.PolSQL.Execute(upd,1)
            if stat!="OK":
                stat="Bd przy zamykaniu: "+stat   
                dane.append(stat) 
                
#-------------------------------------------------------------------------------
#---   DELETE DANYCH (6)   
#-------------------------------------------------------------------------------
if Fun == 6 and stat == "OK":
    if not UprUsuwanie:
        stat='UPR DEL' 
    if stat=="OK":      
        SQL="DELETE FROM rs_arkusze_przeszacowania_pozycje WHERE firma_id='"+self.firma_id+"' "
        SQL+="AND numer="+str(Numer)+" AND data='"+str(Data)+"'; "
        SQL+="DELETE FROM rs_arkusze_przeszacowania WHERE firma_id='"+self.firma_id+"' " 
        SQL+="AND data='"+str(Data)+"' AND numer="+str(Numer)+";"
        stat,dump,dump,dump = self.PolSQL.Execute(SQL,1)       
        if stat!="OK":
            stat="BL DEL"   
            dane.append(stat)
            
#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (1- insert 5 -select, 6 -delete)
#-------------------------------------------------------------------------------
if (Fun in [1,5,6]) and (stat=='OK') :
    Select=''
    #rozdzielam zapytania na dwa osobne bo nie ma sensu robi joina, gdy nie podano w filtrze
    #id srodka trwaego
    if SrodekF=='':
        Filtr="WHERE firma_id='"+self.firma_id+"' "
        if StanF <> '':
            Filtr = Filtr+" AND stan='"+str(StanF)+"'"
        if DataOdF <> '    -  -  ':
            Filtr = Filtr+" AND data>='"+str(DataOdF)+"'"
        if DataDoF <> '    -  -  ':
            Filtr = Filtr+" AND data<='"+str(DataDoF)+"'"
        if Fun == 1:
            Filtr = Filtr+" OR (firma_id='"+self.firma_id+"' AND stan='W' "
            Filtr = Filtr+" AND data='"+str(Data)+"' AND numer='"+str(Num)+"')"
        Select="SELECT stan,data,numer,korekta, rsf_podaj_srodki_przeszacowania('"+self.firma_id+"' ,data,numer::NUMERIC)"
        Select+=" FROM rs_arkusze_przeszacowania "+Filtr+" ORDER BY data,numer;"
    else:
        Select=''
        Filtr="WHERE a.firma_id='"+self.firma_id+"' AND b.srodek_id like '"+SrodekF+"%' "
        if StanF <> '':
            Filtr = Filtr+" AND a.stan='"+str(StanF)+"'"
        if DataOdF <> '    -  -  ':
            Filtr = Filtr+" AND a.data>='"+str(DataOdF)+"'"
        if DataDoF <> '    -  -  ':
            Filtr = Filtr+" AND a.data<='"+str(DataDoF)+"'"
        Select="SELECT a.stan,a.data,a.numer,korekta, rsf_podaj_srodki_przeszacowania('"+self.firma_id+"' ,a.data,a.numer::NUMERIC)"
        Select+=" FROM rs_arkusze_przeszacowania a"
        Select+=" INNER JOIN rs_arkusze_przeszacowania_pozycje b "
        Select+=" ON (a.firma_id=b.firma_id AND a.data=b.data AND a.numer=b.numer ) "+Filtr+"" 
        if Fun == 1:
            Select+=" UNION SELECT stan,data,numer,korekta,'' FROM rs_arkusze_przeszacowania WHERE firma_id='"+self.firma_id+"' AND stan='W'" 
            Select+=" AND data='"+str(Data)+"' AND numer='"+str(Num)+"'  "
    stat,dane,wyn1,wyn2 = self.PolSQL.Execute(Select,3) 
    if stat!="OK":
        stat="BL PRZ"   
        dane.append(stat)
    else:
        wyn2=Num
        if Fun == 1:
            wyn1 = nowy_klucz