#!/usr/bin/python
# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:             fs_raporty_generator.py
# Purpose:          dodaje/pobiera/usuwa raporty
# Author:           Piotr Witkowski
# Created:          2016/03/18
# RCS-ID:           $Id: fs_raporty_generator.py $
# Copyright:        (c) 2016 RecordSystem
# Licence:          GNU GPL
#-------------------------------------------------------------------------------

stat='OK'
if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=='OK':
    Funkcja = klucze['Funkcja']
    SlPar={'ModulF':[5,6],'RaportF':[5,6],'Raport':[6,8,9]}

    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Funkcja,klucze)
    if Lista<>'':
        stat='Uwaga : wywoanie funkcji fs_raporty_generator z numerem ' +str(Funkcja)+' bez parametrw: '+Lista

if stat=='OK':
    if Funkcja in [5,6]:
        ModulF = klucze['ModulF']
        RaportF = klucze['RaportF']
    if Funkcja in [6,8,9]:
        Raport = klucze['Raport']

if stat=='OK':
    dane = []
    wyn1 = []
    wyn2 = []

if stat=='OK' and Funkcja == 7:
    if self.operator_id == STANDARD_OPERATOR_ID:
        stat='0'


#-------------------------------------------------------------------------------
#--------------------Eksport raportow ----(10)
#-------------------------------------------------------------------------------

if stat=='OK' and Funkcja==10 :
    try:
        rsglobal.ZapiszDoLogow(os.listdir('./'),1)
        os.listdir('raporty')
    except IOError:
        os.mkdir('raporty')

    Sql="SELECT raport_id,nazwa,szer_okna,wys_okna,naglowek,kolumny,tabela,"
    Sql+="sql_przed,sql_raport,sql_po,autor,modul_id,czcionka_pdf,czy_znakowy,"
    Sql+="czy_graficzny,czy_agata FROM rs_raporty WHERE firma_id='"+self.firma_id+"'; "
    stat,dane,dump,dump=self.PolSQL.Execute(Sql,3)
    if stat<>'OK':
        stat = 'Bdy w pobieraniu danych :'+stat
        dane.append(stat)
    else:
        i=0

        for rap in dane:
            Sql="SELECT lp,nazwa,opis,typ,dlugosc,po_przec,wsp_gora,wsp_lewa,wsp_dlug,"
            Sql+="wartosc_domyslna FROM rs_raporty_parametry WHERE firma_id='"+self.firma_id+"' "
            Sql+="AND raport_id='"+rsglobal.Dekoduj(rap[0])+"'; "
            stat,d,dump,dump=self.PolSQL.Execute(Sql,3)
            if stat=='OK':
                raport=rsglobal.Dekoduj(rap[0])
                f=open('raporty/'+raport+'.rsr','w')
                f.write(str(rap[1])+'\n')
                f.write(str(rap[1:])+'\n')
                f.write(str(d)+'\n')
                f.close()
                i=i+1
            else:
                i=len(dane)


#-------------------------------------------------------------------------------
#--------------------Import raportow ----(11)
#-------------------------------------------------------------------------------

if stat=='OK' and Funkcja==11:
    #wczytanie listy plikw
    LPlikow=os.listdir('./raporty')

    LRap=[]
    for plik in LPlikow:
        if os.path.isfile('./raporty/'+plik):
            raport,roz=os.path.splitext(plik)
            if roz=='.rsr':
                LRap.append((raport,roz))

    for rap in LRap:
        file = open( './raporty/'+rap[0]+rap[1], 'r')
        dane = file.readlines()
        Nagl=rsglobal.rseval(dane[1])
        LKryt=rsglobal.rseval(dane[2])

        #ptle w celu zdekodowania
        for i in range(len(Nagl)):
            Nagl[i]=rsglobal.Dekoduj(Nagl[i])
        for kryt in LKryt:
            for i in range(len(kryt)):
                kryt[i]=rsglobal.Dekoduj(kryt[i])

        Select="SELECT * FROM rs_raporty WHERE firma_id='"+self.firma_id+"' AND raport_id='"+rap[0]+"';"
        stat,d,dump,dump=self.PolSQL.Execute(Select,3)
        if stat<>'OK':
            stat = 'Bdy pobierania danych raportu :'+stat
            dane.append(stat)
        else:
            if len(d)==0:
                #zapis nagwka
                Sql="INSERT INTO rs_raporty "
                Sql+="(firma_id,raport_id,nazwa,szer_okna,wys_okna,naglowek,kolumny,tabela,"
                Sql+="sql_przed,sql_raport,sql_po,autor,modul_id,czcionka_pdf,czy_znakowy,czy_graficzny,czy_agata) "
                Sql+=" VALUES "
                Sql+="('"+self.firma_id+"','"+rap[0]+"','"+str(Nagl[0])+"',"+str(Nagl[1])+","+str(Nagl[2])+",'"+str(Nagl[3])+"'"
                Sql+=",'"+str(Nagl[4])+"','"+str(Nagl[5])+"',"
                Sql+="'"+str(Nagl[6])+"','"+str(Nagl[7])+"','"+str(Nagl[8])+"','"+str(Nagl[9])+"','"+str(Nagl[10])+"',"
                Sql+="'"+str(Nagl[11])+"',"+str(Nagl[12])+","+str(Nagl[13])+","+str(Nagl[14])+");"
                stat,dump,dump,dump=self.PolSQL.Execute(Sql,1)
                if stat<>'OK':
                    stat = 'Bdy dodawania danych raportu :'+stat
                    dane.append(stat)
                else:
                    #zapis kryteriw
                    for kryt in LKryt:
                        Sql="INSERT INTO rs_raporty_parametry "
                        Sql+="(firma_id,raport_id,lp,nazwa,opis,typ,dlugosc,po_przec,wsp_gora,"
                        Sql+="wsp_lewa,wsp_dlug,wartosc_domyslna) "
                        Sql+=" VALUES "
                        Sql+="('"+self.firma_id+"','"+rap[0]+"',"+str(kryt[0])+",'"+str(kryt[1])+"','"+str(kryt[2])+"','"+str(kryt[3])+"'"
                        Sql+=","+str(kryt[4])+","+str(kryt[5])+","+str(kryt[6])+","+str(kryt[7])+","+str(kryt[8])+",'"+str(kryt[9])+"');"
                        stat,dump,dump,dump=self.PolSQL.Execute(Sql,1)
                        if stat<>'OK':
                            stat = 'Bdy dodawania parametrw :'+stat
                            dane.append(stat)
            else:
                Delete="DELETE FROM rs_raporty_parametry WHERE firma_id='"+self.firma_id+"' AND raport_id='"+rap[0]+"';"
                stat,dump,dump,dump=self.PolSQL.Execute(Delete,1)
                if stat=='OK':
                    #zapis kryteriw
                    for kryt in LKryt:
                        Sql="INSERT INTO rs_raporty_parametry "
                        Sql+="(firma_id,raport_id,lp,nazwa,opis,typ,dlugosc,po_przec,wsp_gora,"
                        Sql+="wsp_lewa,wsp_dlug,wartosc_domyslna) "
                        Sql+=" VALUES "
                        Sql+="('"+self.firma_id+"','"+rap[0]+"',"+str(kryt[0])+",'"+str(kryt[1])+"',"
                        Sql+="'"+str(kryt[2])+"','"+str(kryt[3])+"',"+str(kryt[4])+","+str(kryt[5])+","
                        Sql+=""+str(kryt[6])+","+str(kryt[7])+","+str(kryt[8])+",'"+str(kryt[9])+"');"
                        stat,dump,dump,dump=self.PolSQL.Execute(Sql,1)
                        if stat<>'OK':
                            stat = 'Bdy dodawania parametrw :'+stat
                            dane.append(stat)
                else:
                    stat='BL DEL'


#-------------------------------------------------------------------------------
#---   USUWANIE DANYCH RAPORTU (6)
#-------------------------------------------------------------------------------

if stat=='OK' and Funkcja == 6:
    DEL="DELETE FROM rs_raporty WHERE firma_id= '"+self.firma_id+"' AND raport_id='"+str(Raport)+"';"
    stat,dump,dump,dump = self.PolSQL.Execute(DEL,1)
    if stat<>'OK':
        stat = 'Bdy usuwania danych :'+stat
        dane.append(stat)


#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH RAPORTU (8)
#-------------------------------------------------------------------------------

if stat=='OK' and Funkcja == 8:
    Select="SELECT firma_id,raport_id,nazwa,szer_okna,wys_okna,naglowek,kolumny,tabela,sql_przed,"
    Select+="sql_raport,sql_po,autor,modul_id,czcionka_pdf,czy_znakowy,czy_graficzny,czy_agata "
    Select+="FROM rs_raporty WHERE firma_id='"+self.firma_id+"' AND raport_id='"+str(Raport)+"';"
    stat,dane,wyn1,tr = self.PolSQL.Execute(Select,3)
    if stat<>'OK':
        stat = 'Bdy pobierania raportu :'+stat
        dane.append(stat)


#-------------------------------------------------------------------------------
#---   POBRANIE NAZWY RAPORTU (9)
#-------------------------------------------------------------------------------

if stat=='OK' and Funkcja == 9:
    Select="SELECT nazwa FROM rs_raporty_parametry WHERE firma_id='"+self.firma_id+"' "
    Select+="AND raport_id='"+str(Raport)+"' ORDER BY lp;"
    stat,dane,wyn1,tr = self.PolSQL.Execute(Select,3)
    if stat<>'OK':
        stat = 'Bdy pobierania nazwy :'+stat
        dane.append(stat)


#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (1- insert 5 -select, 6 -delete)
#-------------------------------------------------------------------------------

if stat=='OK' and Funkcja in [1,5,6,11]:
    Filtr="firma_id='"+self.firma_id+"' "
    if Funkcja in [5,6]:
        Filtr = Filtr+" AND modul_id LIKE '"+str(ModulF)+"%'"
    if Funkcja in [5,6]:
        Filtr = Filtr+" AND raport_id LIKE '"+str(RaportF)+"%'"
    if int(self.operator_id) > 0:
        Select="SELECT DISTINCT grupa_id FROM rs_grupa_operator_oddzial WHERE "
        Select+="firma_id='"+self.firma_id+"' AND operator_id="+str(self.operator_id)+";"
        stat,Dane,wyn1,tr = self.PolSQL.Execute(Select,3)
        if stat<>'OK':
            stat = 'Bdy pobierania filtra :'+stat
            dane.append(stat)
        else:
            LGr="'Brak',"
            for gr in Dane:
                LGr=LGr+"'"+gr[0]+"',"
            Filtr = Filtr+" AND modul_id IN ("+str(LGr)[0:-1]+")"
    Select="SELECT raport_id,nazwa,modul_id FROM rs_raporty WHERE "+Filtr+" ORDER BY raport_id;"
    stat,dane,wyn1,tr = self.PolSQL.Execute(Select,3)
    if stat<>'OK':
        stat = 'Bdy pobierania danych :'+stat
        dane.append(stat)