
# -*- coding: iso8859_2 -*-

#-----------------------------------------------------------------------------
# Name:        fs_raporty_kryteria_dane.py
# Purpose:     wczytuje/usuwa dane okna kryterium raportu
#
# Author:      Dariusz Boduch
# Created:     2009/04/07
# RCS-ID:      $Id: s_raporty_kryteria_dane.py $
# Copyright:   (c) 2006 Record System
# Licence:     GNU GPL
#-----------------------------------------------------------------------------

Raport = klucze[0]
Lp = klucze[1]

Fun=klucze[-1]


stat = "OK"
dane = []
puste_pola = ['',[],'None',None]

if self.operator_id != STANDARD_OPERATOR_ID:
    UprPrz=(self.oddzial_id,'081021') in self.uprawnienia
    UprUpd=(self.oddzial_id,'081022') in self.uprawnienia 
    UprIns=(self.oddzial_id,'081023') in self.uprawnienia
else:
    UprPrz=True
    UprUpd=True 
    UprIns=True 



if Fun==9:
    Warunek = "firma_id=\\\'"+self.firma_id+"\\\' AND raport_id=\\\'"+Raport+"\\\'"
    sql = "SELECT rsf_klucz_where_new('rs_raporty_parametry','"+Warunek+"','lp');"
    stat,dane,dump,dump = self.PolSQL.Execute(sql,3)    
    if stat<>'OK':
        stat = 'BL SQL NR'
        dane.append(stat)
    
#-------------------------------------------------------------------------------
#---   SPRAWDZENIE POPRAWNOSCI DANYCH
#-------------------------------------------------------------------------------
if Fun in [1,2,3,4,5] and stat =='OK':        
    i = 0
    for i in range(len(pola)):
        wart = wartosci[i]
        pole = pola[i]

        if pole == 'typ':
            if not (wart in ['D','T','N','L','S']):
                stat = 'BL TYP'
                dane.append(stat)
            if wart in ['T','N','S']:
                if pole == 'dlugosc':
                    if wart < 1:
                        stat='BL DLUGOSC'
                        dane.append(stat)

        elif pole == 'opis' and stat =='OK':
            if wart == '':
                stat = 'BR OPIS'
                dane.append(stat)
                

        elif pole == 'nazwa' and stat =='OK':
            if wart == '':
                stat = 'BR POZ'
                dane.append(stat)

        elif pole == 'wsp_gora' and stat =='OK':
            if wart < 1:
                stat = 'BL WSPG'
                dane.append(stat)
                
        elif pole == 'wsp_lewa' and stat =='OK':
            if wart < 1:
                stat = 'BL WSPL'
                dane.append(stat)
                
        elif pole == 'wsp_dlug' and stat =='OK':
            if wart < 1:
                stat = 'BL WSPD'
                dane.append(stat)
                
        i= i+1

if Fun in [1,2] and stat=='OK':
    Select="SELECT * FROM rs_raporty_parametry WHERE firma_id='"+self.firma_id+"' AND raport_id='"+Raport+"' AND lp="+str(Lp)+" "
    st,d,dump,dump=self.PolSQL.Execute(Select,3)
    if (d not in puste_pola) and  len(d)>0:
        stat='NR ISTN'
        dane.append(stat)
            
#-------------------------------------------------------------------------------
#---   INSERT DANYCH (2- bez pobierania,1- z pobieraniem)
#-------------------------------------------------------------------------------

if stat == "OK" and Fun in [2,1]:
    if not UprIns:
        stat='UPR INS'
        dane.append(stat)
    if stat == 'OK' :   
        sql = "INSERT INTO rs_raporty_parametry "
        PolaN="firma_id, raport_id"
        WartosciN = "'"+self.firma_id+"', '"+Raport+"'"
        for i in range(len(pola)):
            pole = pola[i]
            wart = str(wartosci[i])
            PolaN += ","+pole
            WartosciN += ",'"+str(wart)+"'"
            
        sql += " ("+PolaN+") VALUES ("+WartosciN+");"
        
        stat,dump,dump,dump = self.PolSQL.Execute(sql ,1)
        
        if stat<>'OK':
            stat='BL INS'
            dane.append(stat)
    
#-------------------------------------------------------------------------------
#--- UPDATE DANYCH (3,4)
#-------------------------------------------------------------------------------

if (Fun in [3,4]) and (stat=='OK'):
    if not UprUpd:
        stat='UPR UPD'
        dane.append(stat)
    if stat == 'OK':
        sql = "UPDATE rs_raporty_parametry SET "
        Filtr = "firma_id='"+self.firma_id+"' AND raport_id='"+Raport+"' AND lp="+str(Lp)+" "
        for i in range(len(pola)):
            wart = wartosci[i]
            pole = pola[i]
            if pole in ['typ','opis','nazwa','wartosc_domyslna']:
                sql += pole+"="
                if wart in puste_pola:
                    sql += "NULL,"
                else:
                    sql += "'"+str(wart)+"',"
            else:
                sql+=pole+"="+str(wart)+","
        sql=sql.strip(",")
        
        sql += " WHERE "+Filtr+";"
        stat,dump,dump,dump = self.PolSQL.Execute(sql ,1)
        if stat != 'OK':
            stat = 'BL UPD'
            dane.append(stat)
        
#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (5 -select, 3 -update z pobraniem, 1 -insert z pobraniem)
#-------------------------------------------------------------------------------

if Fun in (1,3,5) and (stat=='OK'):
    if not UprPrz:
        stat='UPR PRZ'
        dane.append(stat)
    if stat=='OK':
        SQL= " SELECT * FROM rs_raporty_parametry WHERE firma_id='"+self.firma_id+"' "
        SQL+= "AND raport_id='"+Raport+"' AND lp="+str(Lp)+" ;"
        stat,dane,wyn1,tr = self.PolSQL.Execute(SQL,3)
        if stat<>'OK':
            stat='BL SQL DANE'
            dane.append(stat)