#!/usr/bin/python
# -*- coding: iso8859_2 -*-
#-----------------------------------------------------------------------------
# Name:             fs_raporty_wyciagi.py
# Purpose:          dodaje/pobiera/usuwa faktury
# Author:           Marcin Grzeda
# Created:          2007/02/12
# RCS-ID:           $Id: fs_raporty_wyciagi.py $
# Copyright:        (c) 2007 RecordSystem
# Licence:          GNU GPL
#-----------------------------------------------------------------------------

Kasa=klucze[0]
Data=klucze[1]
Numer=klucze[2]
Kurs=klucze[3]
KasaBankF=klucze[4]
DataOdF=klucze[5]
DataDoF=klucze[6]
StanF=klucze[7]

Fun=klucze[-1]
stat='OK'
dane=[]
puste_pola = ['    -  -  ','',[],'None']
stat1=''
wyn2=[]
UpdateZaleglosci=''
debug=7
rsglobal.ZapiszDoLogow('debug='+str(debug),1)

#pobranie uprawnie do Kas/Bankw dla operatora
if self.operator_id <> STANDARD_OPERATOR_ID:
    st,Upr,wyn1,tr = self.PolSQL.Execute("SELECT kasa_bank_id,wprowadzanie,edycja,usuwanie,przegladanie,zamykanie,otwieranie FROM rs_kasy_banki_upr WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"' AND operator_id in "+str(self.operatorzy).replace("[","(").replace("]",")")+"; ",3)
    LPrz=['ZASLEPKA']
    LDel=[]
    LUpd=[]
    LZam=[]
    LOtw=[]
    
    UprPrz=(self.oddzial_id,'172011') in self.uprawnienia
    UprDel=(self.oddzial_id,'172014') in self.uprawnienia
    UprUpd=(self.oddzial_id,'172012') in self.uprawnienia
    UprZam=(self.oddzial_id,'172016') in self.uprawnienia
    UprOtw=(self.oddzial_id,'172017') in self.uprawnienia
    
    for d in Upr:
        if UprPrz:
            if d[1] or d[2] or d[3] or d[4]:
                LPrz.append(rsglobal.Dekoduj(d[0]))
        if UprDel:
            if d[3]:
                LDel.append(rsglobal.Dekoduj(d[0]))
        if UprUpd:
            if d[2]:
                LUpd.append(rsglobal.Dekoduj(d[0]))
        if UprZam:
            if d[5]:
                LZam.append(rsglobal.Dekoduj(d[0]))
        if UprOtw:
            if d[6]:
                LOtw.append(rsglobal.Dekoduj(d[0]))

     
#wstpne sprawdzenie danych ktre przyszy
if not rsglobal.SprawdzCzyToData(DataOdF):        
    if DataOdF not in puste_pola:
        stat="BL DOD"
        dane.append(stat)
if not rsglobal.SprawdzCzyToData(DataDoF):
    if DataDoF not in puste_pola:
        stat="BL DDO"
        dane.append(stat)

if Fun in [3,4,6]:
    if not rsglobal.SprawdzCzyToData(Data):
        if Data <> '    - -  ':
            stat="BR DAT"
            dane.append(stat)
        else:
            stat="BL DAT"
            dane.append(stat)
    if Kasa=='':
        stat="BR KAS"
        dane.append(stat)
    if Numer=='':
        stat='BR NUM'
        dane.append(stat)
    if Fun in [3,4]:
        if Kurs=='':
            stat='BR KUR'
            dane.append(stat)

#Zamykanie raportow (7)

if Fun in [7]:
    if (self.operator_id == STANDARD_OPERATOR_ID):
        Uprawnienia=True
    else:
        Uprawnienia= UprZam and (Kasa in LUpd)
    
    if Uprawnienia:    
        #Na pocztek sprawdzamy czy raport istnieje i czy ma stan 'W' 
        Sql="Select stan,kompensata from rs_raporty_wyciagi WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"' AND kasa_bank_id='"+Kasa+"' AND data='"+Data+"' AND numer="+Numer
        stat,d,dump,dump=self.PolSQL.Execute(Sql,3)
        if stat<>'OK':
            stat='BL SQL STAN'
            dane.append(stat)
        elif rsglobal.Dekoduj(d[0][0])<>'W':
            stat='BL STAN'
            dane.append(stat)
        else:    
            kompensata=d[0][1]
            #---Sprawdzanie poprawnosci pozycji
            #Ponisze zapytanie sprawdza czy raport ma wogle jakie pozycjie. Raport bez pozycji nie moe by zamkniety
            Sql="SELECT nr_poz FROM rs_raporty_wyciagi_pozycje WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"'"
            Sql+=" AND kasa_bank_id='"+Kasa+"' AND data='"+Data+"' AND numer="+Numer
            stat,d,dump,dump=self.PolSQL.Execute(Sql,3)
            if len(d)<=0:
                stat="BR PPOZ"
                dane.append(stat)
            #A to zapytanie wypisuje liste blednych pozycji, ktre nie maj wpisanych danych konta mimo ze nie sa zadnym z typow 'F','K','D'. 
            #Takie pozycje sa niepoprawne, gdy s podpozycjami albo gdy nie maj podpozycji.
            #Innymi sowy s poprawne jedynie wtedy gdy s pozycjami rozbitymi na podpozycje.   
            Sql="SELECT nr_poz,nr_ppoz FROM rs_raporty_wyciagi_pozycje a WHERE konto='' AND typ_fakt not in ('F','K','D')"
            Sql+=" AND firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"'"
            Sql+=" AND kasa_bank_id='"+Kasa+"' AND data='"+Data+"' AND numer="+Numer
            Sql+=" AND (nr_ppoz<>0 or (nr_ppoz=0 AND NOT nr_poz in (SELECT nr_poz FROM rs_raporty_wyciagi_pozycje"
            Sql+=" WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"' AND kasa_bank_id='"+Kasa+"'"
            Sql+=" AND data='"+Data+"' AND numer="+Numer+" AND nr_ppoz>0 )));" 
            stat,d,dump,dump=self.PolSQL.Execute(Sql,3)
            if len(d)<>0:
                stat='BR KONT FAKT POZ$'+str(d[0][0])+' numer podpozycji: '+str(d[0][1])
                dane.append(stat)
                
            #To zapytanie wypisuje liste pozycji, ktre bdac typu 'F' lub 'K' nie maj wypenionej wyznacznika
            Sql="SELECT nr_poz,nr_ppoz FROM rs_raporty_wyciagi_pozycje a WHERE typ_fakt in ('F','K','D') AND (wyznacznik_id='' OR wyznacznik_id is NULL)"
            Sql+=" AND firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"'"
            Sql+=" AND kasa_bank_id='"+Kasa+"' AND data='"+Data+"' AND numer="+Numer
            stat,d,dump,dump=self.PolSQL.Execute(Sql,3)
            if len(d)<>0:
                stat='BR WYZN FAKT POZ$'+str(d[0][0])+' numer podpozycji: '+str(d[0][1])
                dane.append(stat)
            
            #To zapytanie wypisuje liste pozycji, ktre bdac typu 'F' lub 'K' nie maj wypenionej wyznacznika    
            Sql="SELECT nr_poz,nr_ppoz FROM rs_raporty_wyciagi_pozycje a WHERE typ_fakt in ('F','K') AND (data='' OR data is NULL)"
            Sql+=" AND firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"'"
            Sql+=" AND kasa_bank_id='"+Kasa+"' AND data='"+Data+"' AND numer="+Numer
            stat,d,dump,dump=self.PolSQL.Execute(Sql,3)
            if len(d)<>0:
                stat='BR DAT FAKT POZ$'+str(d[0][0])+' numer podpozycji: '+str(d[0][1])
                dane.append(stat)
                
            #To zapytanie wypisuje liste pozycji, ktre bdac typu 'F' lub 'K' nie maj wypenionej numer    
            Sql="SELECT nr_poz,nr_ppoz FROM rs_raporty_wyciagi_pozycje a WHERE typ_fakt in ('F','K') AND (numer=0 OR numer is NULL)"
            Sql+=" AND firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"'"
            Sql+=" AND kasa_bank_id='"+Kasa+"' AND data='"+Data+"' AND numer="+Numer
            stat,d,dump,dump=self.PolSQL.Execute(Sql,3)
            if len(d)<>0:
                stat='BR NR FAKT POZ$'+str(d[0][0])+' numer podpozycji: '+str(d[0][1])
                dane.append(stat)
                
            #Jesli raport jest kompensata to kazda pozycja musi mie wypenione zarwno dane dotyczce konta jak i faktury
            if kompensata:
                #1)wypisujemy wszystkie pozycje ktore nie maja wpisanego konta. Sa one niepoprawne, bo to kompensata.
                Sql="SELECT nr_poz,nr_ppoz FROM rs_raporty_wyciagi_pozycje WHERE konto='' and firma_id='"+self.firma_id+"'"
                Sql+=" AND okres_id='"+self.okres_id+"' AND kasa_bank_id='"+Kasa+"' AND data='"+Data+"' AND numer="+Numer
                st,d,dump,dump=self.PolSQL.Execute(Sql,3)
                if len(d)<>0:
                    stat='BR KOMP KONT$'+str(d[0][0])+' numer podpozycji: '+str(d[0][1])
                    dane.append(stat)
                
                #2)wypisujemy wszystkie pozycje ktre maj nie wypelnione dane dotyczce faktury. Sa one niepoprawne, bo to kompensata     
                Sql="SELECT nr_poz,nr_ppoz FROM rs_raporty_wyciagi_pozycje WHERE wyznacznik_id='' and firma_id='"+self.firma_id+"'"
                Sql+=" AND okres_id='"+self.okres_id+"' AND kasa_bank_id='"+Kasa+"' AND data='"+Data+"' AND numer="+Numer
                st,d,dump,dump=self.PolSQL.Execute(Sql,3)
                if len(d)<>0:
                    stat='BR KOMP WYZN$'+str(d[0][0])+' numer podpozycji: '+str(d[0][1])
                    dane.append(stat)
            
            #Standardowe sprawdzenie czy typ w pozycji raportu jest poprawny. Dopuszczalne s dwie moliwoci 'P' i 'W'
            Sql="SELECT nr_poz,nr_ppoz FROM rs_raporty_wyciagi_pozycje WHERE typ not in ('P','W')"
            Sql+=" AND  firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"'"
            Sql+=" AND kasa_bank_id='"+Kasa+"' AND data='"+Data+"' AND numer="+Numer+";" 
            stat,d,dump,dump=self.PolSQL.Execute(Sql,3)
            rsglobal.ZapiszDoLogow(d,1)
            if len(d)<>0:
                stat='BL TYP1 POZ$'+str(d[0][0])+' numer podpozycji: '+str(d[0][1])
                dane.append(stat)
            #Standardowe sprawdzenie czy kwota w pozycji jest wpisana poprawnie. NIE MOZE BYC ROWNA 0!!!
            Sql="SELECT nr_poz,nr_ppoz FROM rs_raporty_wyciagi_pozycje WHERE kwota=0 AND  firma_id='"+self.firma_id+"'"
            Sql+=" AND okres_id='"+self.okres_id+"' AND kasa_bank_id='"+Kasa+"' AND data='"+Data+"' AND numer="+Numer+";" 
            stat,d,dump,dump=self.PolSQL.Execute(Sql,3)
            if len(d)<>0:
                stat='BL KWOT POZ$'+str(d[0][0])+' numer podpozycji: '+str(d[0][1])
                dane.append(stat)
            #Standardowe sprawdzenie czy jest wpisana tre w sytuacji gdy mamy wypelnine konto. 
            #Jeli konto jest wpisane musi byc wpisana tresc.
            Sql="SELECT nr_poz,nr_ppoz FROM rs_raporty_wyciagi_pozycje WHERE konto<>'' AND tresc='' AND  firma_id='"+self.firma_id+"'"
            Sql+=" AND okres_id='"+self.okres_id+"' AND kasa_bank_id='"+Kasa+"' AND data='"+Data+"' AND numer="+Numer+";" 
            stat,d,dump,dump=self.PolSQL.Execute(Sql,3)
            if len(d)<>0:
                stat='BR TRES POZ$'+str(d[0][0])+' numer podpozycji: '+str(d[0][1])
                dane.append(stat)
            
            #Sprawdzamy czy wpisane w pozycjach numery kont sa poprawne. I czy podane konta s ksigowane
            Sql="SELECT konto,nr_poz,nr_ppoz FROM rs_raporty_wyciagi_pozycje WHERE konto<>'' AND firma_id='"+self.firma_id+"'"
            Sql+=" AND okres_id='"+self.okres_id+"' AND kasa_bank_id='"+Kasa+"' AND data='"+Data+"' AND numer="+Numer+";" 
            stat,d,dump,dump=self.PolSQL.Execute(Sql,3)
            if len(d)>0:
                i=0
                while i < len(d):
                    stat,d_p,dump,dump = self.PolSQL.Execute("SELECT rsf_podaj_parametry_konta('"+self.firma_id+"','"+self.okres_id+"','"+rsglobal.Dekoduj(d[i][0])+"');",3)
                    if d_p <> None:
                        if rsglobal.rseval(rsglobal.Dekoduj(d_p[0][0]))[0]=='':
                            stat='BL KONT POZ$'+str(d[i][1])+' podpozycji numer: '+str(d[i][2])
                            dane.append(stat)
                        elif not rsglobal.rseval(rsglobal.Dekoduj(d_p[0][0]))[2]:
                            stat='BL KONT NIE KSIE$'+str(d[i][1])+' podpozycji numer: '+str(d[i][2])
                            dane.append(stat)
                            
                    else:
                        stat='BL KRYT KONT POZ'
                        dane.append(stat)
                    i=i+1
            #--------------------------------------------------------------------------------------------------
            #---------------------------------------Z A L E G L O S C I ---------------------------------------
            #---Zakonczyl sie etap podstawowego sprawdzania. Nastepnym etapem bedzie dokonanie odpowiednich 
            #---zapisow do zaleglosci
            #--------------------------------------------------------------------------------------------------
            st,dump,dump,dump=self.PolSQL.Execute("BEGIN;",1)
            #Pobieramy pozycji ktre odnosz si do korekt lub faktur, Ich zamykanie wymaga zmian w zaleglosciach
            #z nimi zwiazanymi
            rsglobal.ZapiszDoLogow('Z A L E G L O S C I',debug)
            Sql="SELECT typ, typ_fakt,wyznacznik_id,data_fakt,numer_fakt,kwota,platnik_id,nr_poz,nr_ppoz"
            Sql+=" FROM rs_raporty_wyciagi_pozycje WHERE wyznacznik_id<>'' AND typ_fakt in ('F','K') AND firma_id='"+self.firma_id+"'"
            Sql+=" AND okres_id='"+self.okres_id+"' AND kasa_bank_id='"+Kasa+"' AND data='"+Data+"' AND numer="+Numer+";" 
            stat,d,dump,dump=self.PolSQL.Execute(Sql,3)
            if len(d)>0 and stat=='OK':       #jesli lista pozycji z wpisanymi danymi faktury jest rozna od 0
                #pobieramy walute raportu. Jest ona okrelona przez wybr Kasy. Z konkretn kas jest zwizana jedna waluta
                rsglobal.ZapiszDoLogow('sa pozycje z faktura',debug)
                Sql="SELECT waluta FROM rs_kasy_banki WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"'"
                Sql+=" AND kasa_bank_id='"+Kasa+"';"
                stat,d_wal_rap,dump,dump=self.PolSQL.Execute(Sql,3)
                if len(d_wal_rap)>0:
                    WalutaRap=d_wal_rap[0][0]     
                    #Bdziemy teraz w ptli iterowac po pozycjach ktre maja wpisane dane faktury
                    i=0
                    while i < len(d):                      
                        TypDokF=d[i][0]
                        #W tym zapytaniu pobieramy zaleglosci zwiazane z pozycja d[i] poprzez fakture.
                        #Zalezy nam na tym zeby w sytuacji gdy istnieja zaleglosci pobrac nieuregulowana.
                        #Moze istniec tylko jedna nieuregulowana zaleglosc zwiazana z dana faktura.
                        #Jest ona ostatnia zalegloscia. I zawiera informacje o obecnym stanie.
                        #W celu jej wylowienia wprowadzamy zmienna porzadek. Nie moemy napisac prostego
                        #warunku ureg_kwota=0 bo chcemy tez wiedziec czy istnieja wogle jakie zaleglosci
                        #zwiazane z nasza pozycja
                        Sql="SELECT platnik_id,kurs,waluta,ureg_kwota,do_zaplaty,do_zaplaty_wal,nr_zal"
                        Sql+=",CASE WHEN ureg_kwota=0 THEN 1 ELSE 0 END AS porzadek,rodzaj FROM rs_zaleglosci"
                        Sql+=" WHERE firma_id='"+self.firma_id+"' AND typ_dok='"+rsglobal.Dekoduj(d[i][1])+"'"
                        Sql+=" AND wyznacznik_id='"+rsglobal.Dekoduj(d[i][2])+"' AND data='"+rsglobal.Dekoduj(d[i][3])+"'"
                        Sql+=" AND numer="+str(d[i][4])+" ORDER BY porzadek desc"
                        stat,d_f,dump,dump = self.PolSQL.Execute(Sql,3)
                        if len(d_f)==0:   #Nie ma zadnej zaleglosci zwiazanej z nasza pozycja. Sytuacja juz jest zla bo oznacza ze mamy do czynienia z niezamknieta faktura lub korekta ewentualnie korekta lub faktura nie istnieje
                            if d[i][1]=='F': #Mamy do czynienia z faktura. Sprawdzamy powod nie istnienia zadnej zaleglosci
                                #Probujemy pobrac fakture o podanym kluczu
                                Sql="SELECT platnik_id FROM rs_faktury WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+rsglobal.Dekoduj(d[i][2])+"'"
                                Sql+=" AND data='"+rsglobal.Dekoduj(d[i][3])+"' AND numer="+str(d[i][4])
                                stat,d_f,dump,dump = self.PolSQL.Execute(Sql,3)
                                if len(d_f)==0: #Faktura o podanym kluczu nie istnieje
                                    stat='BL FAKT POZ$'+str(d[i][7])+' numer podpozycji:'+str(d[i][8])
                                    dane.append(stat)
                                else: #Faktura istnieje wiec musi bys nie zamknieta
                                    stat='NIE ZAM FAKT POZ$'+str(d[i][7])+' numer podpozycji:'+str(d[i][8])
                                    dane.append(stat)
                            elif d[i][1]=='K': #Mamy do czynienia z korekta. Sprawdzamy powd nie istnienia zadnej zaleglosci
                                #Probujemy pobrac korekte o podanym kluczu
                                Sql="SELECT platnik_id FROM rs_korekty WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+rsglobal.Dekoduj(d[i][2])+"'"
                                Sql+=" AND data='"+rsglobal.Dekoduj(d[i][3])+"' AND numer="+str(d[i][4])
                                stat,d_f,dump,dump = self.PolSQL.Execute(Sql,3)
                                if len(d_f)==0: #Korekta o podanym kluczu nie istnieje
                                    stat='BL KOR POZ$'+str(d[i][7])+' numer podpozycji:'+str(d[i][8])
                                    dane.append(stat)
                                else: #Korekta istnieje wiec musi byc nie zamknieta
                                    stat='NIE ZAM KOR POZ FAKT$'+str(d[i][7])+' numer podpozycji:'+str(d[i][8])
                                    dane.append(stat)
                                    
                                    
                        elif (d_f[0][0]<>d[i][6]) and (d[i][6]<>'None'): #Zaleglosc istnieje ale platnik jest inny niz ten wpisany w pozycji
                            stat='INNY PLAT$'+str(d[i][7])+' numer podpozycji:'+str(d[i][8])
                            dane.append(stat)
                            
                        else: #Zaleglosc istnieje i platnik jest taki sam jak w aktualnej pozycji raportu
                            rsglobal.ZapiszDoLogow('Zaleglosci istnieje i platnik jest taki sam ja w aktualnej pozycji raportu ',debug)
                            KursZZaleglosci=d_f[0][1]
                            WalutaZZaleglosci=d_f[0][2]
                            KwotaDoZaplatyWal=d_f[0][5]
                            KwotaDoZaplatyPLN = d_f[0][4]
                            NrZaleglosci=d_f[0][6]
                            RodzajZ=d_f[0][8]
                            KwotaZRaportu=d[i][5]
                            KwotaUreg=d_f[0][3]
                            KwotaDoZaplatyWal=d_f[0][5]
                            if KwotaUreg==0:
                                rsglobal.ZapiszDoLogow('KwotaUreg==0',debug)
                                if WalutaZZaleglosci==WalutaRap:
                                    rsglobal.ZapiszDoLogow('WalutaZZaleglosci==WalutaRap',debug)
                                    SymbolWplaty=Kasa+"/"+Data+"/"+str(Numer).strip('.0')+"/"+str(d[i][7]).strip('.0') #symbol wplaty daje informacje jaki byl sposob regulacji i jaka pozycja raportu reguluje dana zaleglosci. Zaleglosci moga byc rowniez kompensowane.
                                    if (KwotaDoZaplatyWal>0) and TypDokF=='P':
                                        if KwotaDoZaplatyWal==KwotaZRaportu: 
                                            UpdateZaleglosci= " UPDATE rs_zaleglosci SET ureg_kwota=do_zaplaty,ureg_data='"+Data+"',symbol_wplaty='"+SymbolWplaty+"'"
                                            UpdateZaleglosci+=" WHERE  firma_id='"+self.firma_id+"' AND typ_dok='"+rsglobal.Dekoduj(d[i][1])+"'"
                                            UpdateZaleglosci+=" AND wyznacznik_id='"+rsglobal.Dekoduj(d[i][2])+"' AND data='"+rsglobal.Dekoduj(d[i][3])+"'"
                                            UpdateZaleglosci+=" AND numer="+str(d[i][4])+" AND ureg_kwota=0;"
                                        if KwotaDoZaplatyWal>KwotaZRaportu:
                                            KwotaUreg=KwotaZRaportu*KursZZaleglosci
                                            UpdateZaleglosci= " UPDATE rs_zaleglosci SET ureg_kwota="+str(KwotaUreg)+",ureg_data='"+Data+"',symbol_wplaty='"+SymbolWplaty+"'"
                                            UpdateZaleglosci+=" WHERE  firma_id='"+self.firma_id+"' AND typ_dok='"+rsglobal.Dekoduj(d[i][1])+"'"
                                            UpdateZaleglosci+=" AND wyznacznik_id='"+rsglobal.Dekoduj(d[i][2])+"' AND data='"+rsglobal.Dekoduj(d[i][3])+"'"
                                            UpdateZaleglosci+=" AND numer="+str(d[i][4])+" AND ureg_kwota=0;"
                                            
                                            UpdateZaleglosci+=" INSERT INTO rs_zaleglosci (firma_id,nr_zal,typ_dok,wyznacznik_id,data,numer,oddzial_id,rodzaj,"
                                            UpdateZaleglosci+="typ_dok_p,wyznacznik_id_p,data_p,numer_p,kontrahent_id,zamawiajacy_id,platnik_id,kierowca,projekt_id,"
                                            UpdateZaleglosci+="waluta,kurs,nr_tabeli,data_tabeli,sposob_zaplaty,dni,data_odbioru,termin_zaplaty,handlowiec,"
                                            UpdateZaleglosci+="sposob_odbioru_faktury,czy_bonus,do_zaplaty,do_zaplaty_wal,ureg_kwota,ureg_data,ureg_typ,ureg_numer,"
                                            UpdateZaleglosci+="opis,numer_z_rs) SELECT firma_id,(SELECT nr_zal FROM rs_zaleglosci ORDER BY nr_zal desc LIMIT 1)+1,"
                                            UpdateZaleglosci+="typ_dok,wyznacznik_id,data,numer,oddzial_id,'P',typ_dok_p,wyznacznik_id_p,data_p,numer_p,kontrahent_id,"
                                            UpdateZaleglosci+="zamawiajacy_id,platnik_id,kierowca,projekt_id,waluta,kurs,nr_tabeli,data_tabeli,sposob_zaplaty,dni,"
                                            UpdateZaleglosci+="data_odbioru,termin_zaplaty,handlowiec,sposob_odbioru_faktury,czy_bonus,do_zaplaty - ureg_kwota,"
                                            UpdateZaleglosci+="round((do_zaplaty - ureg_kwota)/kurs,2),0,NULL,NULL,'',opis,numer_z_rs FROM rs_zaleglosci"
                                            UpdateZaleglosci+=" WHERE firma_id='"+self.firma_id+"' AND nr_zal="+str(NrZaleglosci)+"; "
                                        if KwotaDoZaplatyWal<KwotaZRaportu:
                                            KwotaUreg=KwotaZRaportu*KursZZaleglosci
                                            UpdateZaleglosci= " UPDATE rs_zaleglosci SET ureg_kwota="+str(KwotaUreg)+",ureg_data='"+Data+"',symbol_wplaty='"+SymbolWplaty+"'"
                                            UpdateZaleglosci+=" WHERE  firma_id='"+self.firma_id+"' AND typ_dok='"+rsglobal.Dekoduj(d[i][1])+"'"
                                            UpdateZaleglosci+=" AND wyznacznik_id='"+rsglobal.Dekoduj(d[i][2])+"' AND data='"+rsglobal.Dekoduj(d[i][3])+"'"
                                            UpdateZaleglosci+=" AND numer="+str(d[i][4])+" AND ureg_kwota=0;"
                                            
                                            UpdateZaleglosci+= " INSERT INTO rs_zaleglosci (firma_id,nr_zal,typ_dok,wyznacznik_id,data,numer,oddzial_id,rodzaj,"
                                            UpdateZaleglosci+="typ_dok_p,wyznacznik_id_p,data_p,numer_p,kontrahent_id,zamawiajacy_id,platnik_id,kierowca,projekt_id,"
                                            UpdateZaleglosci+="waluta,kurs,nr_tabeli,data_tabeli,sposob_zaplaty,dni,data_odbioru,termin_zaplaty,handlowiec,"
                                            UpdateZaleglosci+="sposob_odbioru_faktury,czy_bonus,do_zaplaty,do_zaplaty_wal,ureg_kwota,ureg_data,ureg_typ,ureg_numer,"
                                            UpdateZaleglosci+="opis,numer_z_rs) SELECT firma_id,(SELECT nr_zal FROM rs_zaleglosci ORDER BY nr_zal desc LIMIT 1)+1,"
                                            UpdateZaleglosci+="typ_dok,wyznacznik_id,data,numer,oddzial_id,'N',typ_dok_p,wyznacznik_id_p,data_p,numer_p,kontrahent_id,"
                                            UpdateZaleglosci+="zamawiajacy_id,platnik_id,kierowca,projekt_id,waluta,kurs,nr_tabeli,data_tabeli,sposob_zaplaty,dni,"
                                            UpdateZaleglosci+="data_odbioru,termin_zaplaty,handlowiec,sposob_odbioru_faktury,czy_bonus,(do_zaplaty - ureg_kwota),"
                                            UpdateZaleglosci+="round((do_zaplaty - ureg_kwota)/kurs,2),0,NULL,NULL,'',opis,numer_z_rs FROM rs_zaleglosci"
                                            UpdateZaleglosci+=" WHERE firma_id='"+self.firma_id+"' AND nr_zal="+str(NrZaleglosci)+"; "
                                    elif (KwotaDoZaplatyWal>0) and TypDokF=='W':
                                        KwotaZRaportu=-KwotaZRaportu
                                        if KwotaDoZaplatyWal==KwotaZRaportu:
                                            UpdateZaleglosci= " UPDATE rs_zaleglosci SET ureg_kwota=do_zaplaty,ureg_data='"+Data+"',symbol_wplaty='"+SymbolWplaty+"'"
                                            UpdateZaleglosci+=" WHERE  firma_id='"+self.firma_id+"' AND typ_dok='"+rsglobal.Dekoduj(d[i][1])+"'"
                                            UpdateZaleglosci+=" AND wyznacznik_id='"+rsglobal.Dekoduj(d[i][2])+"' AND data='"+rsglobal.Dekoduj(d[i][3])+"'"
                                            UpdateZaleglosci+=" AND numer="+str(d[i][4])+" AND ureg_kwota=0;"
                                        if KwotaDoZaplatyWal>KwotaZRaportu:
                                            KwotaUreg=KwotaZRaportu*KursZZaleglosci
                                            UpdateZaleglosci= " UPDATE rs_zaleglosci SET ureg_kwota="+str(KwotaUreg)+",ureg_data='"+Data+"',symbol_wplaty='"+SymbolWplaty+"'"
                                            UpdateZaleglosci+=" WHERE  firma_id='"+self.firma_id+"' AND typ_dok='"+rsglobal.Dekoduj(d[i][1])+"'"
                                            UpdateZaleglosci+=" AND wyznacznik_id='"+rsglobal.Dekoduj(d[i][2])+"' AND data='"+rsglobal.Dekoduj(d[i][3])+"'"
                                            UpdateZaleglosci+=" AND numer="+str(d[i][4])+" AND ureg_kwota=0;"
                                            
                                            UpdateZaleglosci+= " INSERT INTO rs_zaleglosci (firma_id,nr_zal,typ_dok,wyznacznik_id,data,numer,oddzial_id,rodzaj,"
                                            UpdateZaleglosci+="typ_dok_p,wyznacznik_id_p,data_p,numer_p,kontrahent_id,zamawiajacy_id,platnik_id,kierowca,projekt_id,"
                                            UpdateZaleglosci+="waluta,kurs,nr_tabeli,data_tabeli,sposob_zaplaty,dni,data_odbioru,termin_zaplaty,handlowiec,"
                                            UpdateZaleglosci+="sposob_odbioru_faktury,czy_bonus,do_zaplaty,do_zaplaty_wal,ureg_kwota,ureg_data,ureg_typ,ureg_numer,"
                                            UpdateZaleglosci+="opis,numer_z_rs) SELECT firma_id,(SELECT nr_zal FROM rs_zaleglosci ORDER BY nr_zal desc LIMIT 1)+1,"
                                            UpdateZaleglosci+="typ_dok,wyznacznik_id,data,numer,oddzial_id,'P',typ_dok_p,wyznacznik_id_p,data_p,numer_p,kontrahent_id,"
                                            UpdateZaleglosci+="zamawiajacy_id,platnik_id,kierowca,projekt_id,waluta,kurs,nr_tabeli,data_tabeli,sposob_zaplaty,dni,"
                                            UpdateZaleglosci+="data_odbioru,termin_zaplaty,handlowiec,sposob_odbioru_faktury,czy_bonus,do_zaplaty - ureg_kwota,"
                                            UpdateZaleglosci+="round((do_zaplaty - ureg_kwota)/kurs,2),0,NULL,NULL,'',opis,numer_z_rs FROM rs_zaleglosci"
                                            UpdateZaleglosci+=" WHERE firma_id='"+self.firma_id+"' AND nr_zal="+str(NrZaleglosci)+"; "
                                        if KwotaDoZaplatyWal<KwotaZRaportu:
                                            KwotaUreg=KwotaZRaportu*KursZZaleglosci
                                            UpdateZaleglosci= " UPDATE rs_zaleglosci SET ureg_kwota="+str(KwotaUreg)+",ureg_data='"+Data+"',symbol_wplaty='"+SymbolWplaty+"'"
                                            UpdateZaleglosci+=" WHERE  firma_id='"+self.firma_id+"' AND typ_dok='"+rsglobal.Dekoduj(d[i][1])+"'"
                                            UpdateZaleglosci+=" AND wyznacznik_id='"+rsglobal.Dekoduj(d[i][2])+"' AND data='"+rsglobal.Dekoduj(d[i][3])+"'"
                                            UpdateZaleglosci+=" AND numer="+str(d[i][4])+" AND ureg_kwota=0;"
                                            
                                            UpdateZaleglosci+= " INSERT INTO rs_zaleglosci (firma_id,nr_zal,typ_dok,wyznacznik_id,data,numer,oddzial_id,rodzaj,"
                                            UpdateZaleglosci+="typ_dok_p,wyznacznik_id_p,data_p,numer_p,kontrahent_id,zamawiajacy_id,platnik_id,kierowca,projekt_id,"
                                            UpdateZaleglosci+="waluta,kurs,nr_tabeli,data_tabeli,sposob_zaplaty,dni,data_odbioru,termin_zaplaty,handlowiec,"
                                            UpdateZaleglosci+="sposob_odbioru_faktury,czy_bonus,do_zaplaty,do_zaplaty_wal,ureg_kwota,ureg_data,ureg_typ,ureg_numer,"
                                            UpdateZaleglosci+="opis,numer_z_rs) SELECT firma_id,(SELECT nr_zal FROM rs_zaleglosci ORDER BY nr_zal desc LIMIT 1)+1,"
                                            UpdateZaleglosci+="typ_dok,wyznacznik_id,data,numer,oddzial_id,'N',typ_dok_p,wyznacznik_id_p,data_p,numer_p,kontrahent_id,"
                                            UpdateZaleglosci+="zamawiajacy_id,platnik_id,kierowca,projekt_id,waluta,kurs,nr_tabeli,data_tabeli,sposob_zaplaty,dni,"
                                            UpdateZaleglosci+="data_odbioru,termin_zaplaty,handlowiec,sposob_odbioru_faktury,czy_bonus,(do_zaplaty - ureg_kwota),"
                                            UpdateZaleglosci+="round((do_zaplaty - ureg_kwota)/kurs,2),0,NULL,NULL,'',opis,numer_z_rs FROM rs_zaleglosci"
                                            UpdateZaleglosci+=" WHERE firma_id='"+self.firma_id+"' AND nr_zal="+str(NrZaleglosci)+"; "
                                    elif (KwotaDoZaplatyWal<=0) and TypDokF=='W':
                                        if KwotaDoZaplatyWal==-KwotaZRaportu:
                                            UpdateZaleglosci= " UPDATE rs_zaleglosci SET ureg_kwota=do_zaplaty,ureg_data='"+Data+"',symbol_wplaty='"+SymbolWplaty+"'"
                                            UpdateZaleglosci+=" WHERE  firma_id='"+self.firma_id+"' AND typ_dok='"+rsglobal.Dekoduj(d[i][1])+"'"
                                            UpdateZaleglosci+=" AND wyznacznik_id='"+rsglobal.Dekoduj(d[i][2])+"' AND data='"+rsglobal.Dekoduj(d[i][3])+"'"
                                            UpdateZaleglosci+=" AND numer="+str(d[i][4])+" AND ureg_kwota=0;"
                                        if KwotaDoZaplatyWal<-KwotaZRaportu:
                                            KwotaUreg=-KwotaZRaportu*KursZZaleglosci
                                            UpdateZaleglosci= " UPDATE rs_zaleglosci SET ureg_kwota="+str(KwotaUreg)+",ureg_data='"+Data+"',symbol_wplaty='"+SymbolWplaty+"'"
                                            UpdateZaleglosci+=" WHERE  firma_id='"+self.firma_id+"' AND typ_dok='"+rsglobal.Dekoduj(d[i][1])+"'"
                                            UpdateZaleglosci+=" AND wyznacznik_id='"+rsglobal.Dekoduj(d[i][2])+"' AND data='"+rsglobal.Dekoduj(d[i][3])+"'"
                                            UpdateZaleglosci+=" AND numer="+str(d[i][4])+" AND ureg_kwota=0;"
                                            
                                            UpdateZaleglosci+= " INSERT INTO rs_zaleglosci (firma_id,nr_zal,typ_dok,wyznacznik_id,data,numer,oddzial_id,rodzaj,"
                                            UpdateZaleglosci+="typ_dok_p,wyznacznik_id_p,data_p,numer_p,kontrahent_id,zamawiajacy_id,platnik_id,kierowca,projekt_id,"
                                            UpdateZaleglosci+="waluta,kurs,nr_tabeli,data_tabeli,sposob_zaplaty,dni,data_odbioru,termin_zaplaty,handlowiec,"
                                            UpdateZaleglosci+="sposob_odbioru_faktury,czy_bonus,do_zaplaty,do_zaplaty_wal,ureg_kwota,ureg_data,ureg_typ,ureg_numer,"
                                            UpdateZaleglosci+="opis,numer_z_rs) SELECT firma_id,(SELECT nr_zal FROM rs_zaleglosci ORDER BY nr_zal desc LIMIT 1)+1,"
                                            UpdateZaleglosci+="typ_dok,wyznacznik_id,data,numer,oddzial_id,'N',typ_dok_p,wyznacznik_id_p,data_p,numer_p,kontrahent_id,"
                                            UpdateZaleglosci+="zamawiajacy_id,platnik_id,kierowca,projekt_id,waluta,kurs,nr_tabeli,data_tabeli,sposob_zaplaty,dni,"
                                            UpdateZaleglosci+="data_odbioru,termin_zaplaty,handlowiec,sposob_odbioru_faktury,czy_bonus,do_zaplaty - ureg_kwota,"
                                            UpdateZaleglosci+="round((do_zaplaty - ureg_kwota)/kurs,2),0,NULL,NULL,'',opis,numer_z_rs FROM rs_zaleglosci"
                                            UpdateZaleglosci+=" WHERE firma_id='"+self.firma_id+"' AND nr_zal="+str(NrZaleglosci)+"; "
                                        if KwotaDoZaplatyWal>-KwotaZRaportu:
                                            KwotaUreg=-KwotaZRaportu*KursZZaleglosci
                                            UpdateZaleglosci= " UPDATE rs_zaleglosci SET ureg_kwota="+str(KwotaUreg)+",ureg_data='"+Data+"',symbol_wplaty='"+SymbolWplaty+"'"
                                            UpdateZaleglosci+=" WHERE  firma_id='"+self.firma_id+"' AND typ_dok='"+rsglobal.Dekoduj(d[i][1])+"'"
                                            UpdateZaleglosci+=" AND wyznacznik_id='"+rsglobal.Dekoduj(d[i][2])+"' AND data='"+rsglobal.Dekoduj(d[i][3])+"'"
                                            UpdateZaleglosci+=" AND numer="+str(d[i][4])+" AND ureg_kwota=0;"
                                            
                                            UpdateZaleglosci+= " INSERT INTO rs_zaleglosci (firma_id,nr_zal,typ_dok,wyznacznik_id,data,numer,oddzial_id,rodzaj,"
                                            UpdateZaleglosci+="typ_dok_p,wyznacznik_id_p,data_p,numer_p,kontrahent_id,zamawiajacy_id,platnik_id,kierowca,projekt_id,"
                                            UpdateZaleglosci+="waluta,kurs,nr_tabeli,data_tabeli,sposob_zaplaty,dni,data_odbioru,termin_zaplaty,handlowiec,"
                                            UpdateZaleglosci+="sposob_odbioru_faktury,czy_bonus,do_zaplaty,do_zaplaty_wal,ureg_kwota,ureg_data,ureg_typ,ureg_numer,"
                                            UpdateZaleglosci+="opis,numer_z_rs) SELECT firma_id,(SELECT nr_zal FROM rs_zaleglosci ORDER BY nr_zal desc LIMIT 1)+1,"
                                            UpdateZaleglosci+="typ_dok,wyznacznik_id,data,numer,oddzial_id,'P',typ_dok_p,wyznacznik_id_p,data_p,numer_p,kontrahent_id,"
                                            UpdateZaleglosci+="zamawiajacy_id,platnik_id,kierowca,projekt_id,waluta,kurs,nr_tabeli,data_tabeli,sposob_zaplaty,"
                                            UpdateZaleglosci+="dni,data_odbioru,termin_zaplaty,handlowiec,sposob_odbioru_faktury,czy_bonus,(do_zaplaty - ureg_kwota),"
                                            UpdateZaleglosci+="round((do_zaplaty - ureg_kwota)/kurs,2),0,NULL,NULL,'',opis,numer_z_rs FROM rs_zaleglosci"
                                            UpdateZaleglosci+=" WHERE firma_id='"+self.firma_id+"' AND nr_zal="+str(NrZaleglosci)+"; "
                                    elif (KwotaDoZaplatyWal<=0) and TypDokF=='P':
                                        if KwotaDoZaplatyWal==KwotaZRaportu:
                                            UpdateZaleglosci= " UPDATE rs_zaleglosci SET ureg_kwota=do_zaplaty,ureg_data='"+Data+"',symbol_wplaty='"+SymbolWplaty+"'"
                                            UpdateZaleglosci+=" WHERE  firma_id='"+self.firma_id+"' AND typ_dok='"+rsglobal.Dekoduj(d[i][1])+"'"
                                            UpdateZaleglosci+=" AND wyznacznik_id='"+rsglobal.Dekoduj(d[i][2])+"' AND data='"+rsglobal.Dekoduj(d[i][3])+"'"
                                            UpdateZaleglosci+=" AND numer="+str(d[i][4])+" AND ureg_kwota=0;"
                                        if KwotaDoZaplatyWal<KwotaZRaportu:
                                            KwotaUreg=KwotaZRaportu*KursZZaleglosci
                                            UpdateZaleglosci= " UPDATE rs_zaleglosci SET ureg_kwota=- "+str(KwotaUreg)+",ureg_data='"+Data+"',symbol_wplaty='"+SymbolWplaty+"'"
                                            UpdateZaleglosci+=" WHERE  firma_id='"+self.firma_id+"' AND typ_dok='"+rsglobal.Dekoduj(d[i][1])+"'"
                                            UpdateZaleglosci+=" AND wyznacznik_id='"+rsglobal.Dekoduj(d[i][2])+"' AND data='"+rsglobal.Dekoduj(d[i][3])+"'"
                                            UpdateZaleglosci+=" AND numer="+str(d[i][4])+" AND ureg_kwota=0;"
                                            
                                            UpdateZaleglosci+= " INSERT INTO rs_zaleglosci (firma_id,nr_zal,typ_dok,wyznacznik_id,data,numer,oddzial_id,rodzaj,"
                                            UpdateZaleglosci+="typ_dok_p,wyznacznik_id_p,data_p,numer_p,kontrahent_id,zamawiajacy_id,platnik_id,kierowca,projekt_id,"
                                            UpdateZaleglosci+="waluta,kurs,nr_tabeli,data_tabeli,sposob_zaplaty,dni,data_odbioru,termin_zaplaty,handlowiec,"
                                            UpdateZaleglosci+="sposob_odbioru_faktury,czy_bonus,do_zaplaty,do_zaplaty_wal,ureg_kwota,ureg_data,ureg_typ,ureg_numer,"
                                            UpdateZaleglosci+="opis,numer_z_rs) SELECT firma_id,(SELECT nr_zal FROM rs_zaleglosci ORDER BY nr_zal desc LIMIT 1)+1,"
                                            UpdateZaleglosci+="typ_dok,wyznacznik_id,data,numer,oddzial_id,'N',typ_dok_p,wyznacznik_id_p,data_p,numer_p,kontrahent_id,"
                                            UpdateZaleglosci+="zamawiajacy_id,platnik_id,kierowca,projekt_id,waluta,kurs,nr_tabeli,data_tabeli,sposob_zaplaty,dni,"
                                            UpdateZaleglosci+="data_odbioru,termin_zaplaty,handlowiec,sposob_odbioru_faktury,czy_bonus,(do_zaplaty - ureg_kwota),"
                                            UpdateZaleglosci+="round((do_zaplaty - ureg_kwota)/kurs,2),0,NULL,NULL,'',opis,numer_z_rs FROM rs_zaleglosci"
                                            UpdateZaleglosci+=" WHERE firma_id='"+self.firma_id+"' AND nr_zal="+str(NrZaleglosci)+"; "
                                        if KwotaDoZaplatyWal>KwotaZRaportu:
                                            KwotaUreg=KwotaZRaportu*KursZZaleglosci
                                            UpdateZaleglosci= " UPDATE rs_zaleglosci SET ureg_kwota=- "+str(KwotaUreg)+",ureg_data='"+Data+"',symbol_wplaty='"+SymbolWplaty+"'"
                                            UpdateZaleglosci+=" WHERE  firma_id='"+self.firma_id+"' AND typ_dok='"+rsglobal.Dekoduj(d[i][1])+"'"
                                            UpdateZaleglosci+=" AND wyznacznik_id='"+rsglobal.Dekoduj(d[i][2])+"' AND data='"+rsglobal.Dekoduj(d[i][3])+"'"
                                            UpdateZaleglosci+=" AND numer="+str(d[i][4])+" AND ureg_kwota=0;"
                                            
                                            UpdateZaleglosci+= " INSERT INTO rs_zaleglosci (firma_id,nr_zal,typ_dok,wyznacznik_id,data,numer,oddzial_id,rodzaj,"
                                            UpdateZaleglosci+="typ_dok_p,wyznacznik_id_p,data_p,numer_p,kontrahent_id,zamawiajacy_id,platnik_id,kierowca,projekt_id,"
                                            UpdateZaleglosci+="waluta,kurs,nr_tabeli,data_tabeli,sposob_zaplaty,dni,data_odbioru,termin_zaplaty,handlowiec,"
                                            UpdateZaleglosci+="sposob_odbioru_faktury,czy_bonus,do_zaplaty,do_zaplaty_wal,ureg_kwota,ureg_data,ureg_typ,ureg_numer,"
                                            UpdateZaleglosci+="opis,numer_z_rs) SELECT firma_id,(SELECT nr_zal FROM rs_zaleglosci ORDER BY nr_zal desc LIMIT 1)+1,"
                                            UpdateZaleglosci+="typ_dok,wyznacznik_id,data,numer,oddzial_id,'P',typ_dok_p,wyznacznik_id_p,data_p,numer_p,kontrahent_id,"
                                            UpdateZaleglosci+="zamawiajacy_id,platnik_id,kierowca,projekt_id,waluta,kurs,nr_tabeli,data_tabeli,sposob_zaplaty,dni,"
                                            UpdateZaleglosci+="data_odbioru,termin_zaplaty,handlowiec,sposob_odbioru_faktury,czy_bonus,(do_zaplaty - ureg_kwota),"
                                            UpdateZaleglosci+="round((do_zaplaty - ureg_kwota)/kurs,2),0,NULL,NULL,'',opis,numer_z_rs FROM rs_zaleglosci"
                                            UpdateZaleglosci+=" WHERE firma_id='"+self.firma_id+"' AND nr_zal="+str(NrZaleglosci)+"; "
                                    
                                else: #Waluty raporotu i zaleglosci sa rozne
                                    rsglobal.ZapiszDoLogow('WalutaZZaleglosci<>WalutaRap',debug)
                                    stat='ROZNE WAL$'+str(d[i][7])+' numer podpozycji:'+str(d[i][8])
                                    dane.append(stat)
                                    
                            else:
                                rsglobal.ZapiszDoLogow('KwotaUreg<>0',debug)
                                if WalutaZZaleglosci==WalutaRap:
                                    rsglobal.ZapiszDoLogow('WalutaZZaleglosci==WalutaRap',debug)
                                    KwotaUreg=KwotaZRaportu*KursZZaleglosci
                                    if -KwotaUreg>0:
                                        UpdateZaleglosci= " INSERT INTO rs_zaleglosci (firma_id,nr_zal,typ_dok,wyznacznik_id,data,numer,oddzial_id,rodzaj,typ_dok_p,"
                                        UpdateZaleglosci+="wyznacznik_id_p,data_p,numer_p,kontrahent_id,zamawiajacy_id,platnik_id,kierowca,projekt_id,waluta,kurs,"
                                        UpdateZaleglosci+="nr_tabeli,data_tabeli,sposob_zaplaty,dni,data_odbioru,termin_zaplaty,handlowiec,sposob_odbioru_faktury,"
                                        UpdateZaleglosci+="czy_bonus,do_zaplaty,do_zaplaty_wal,ureg_kwota,ureg_data,ureg_typ,ureg_numer,opis,numer_z_rs)"
                                        UpdateZaleglosci+=" SELECT firma_id,(SELECT nr_zal FROM rs_zaleglosci ORDER BY nr_zal desc LIMIT 1)+1,typ_dok,wyznacznik_id,"
                                        UpdateZaleglosci+="data,numer,oddzial_id,'Z',typ_dok_p,wyznacznik_id_p,data_p,numer_p,kontrahent_id,zamawiajacy_id,platnik_id,"
                                        UpdateZaleglosci+="kierowca,projekt_id,waluta,kurs,nr_tabeli,data_tabeli,sposob_zaplaty,dni,data_odbioru,termin_zaplaty,"
                                        UpdateZaleglosci+="handlowiec,sposob_odbioru_faktury,czy_bonus, "+str(-KwotaUreg)+","+str(-KwotaZRaportu)+",0,NULL,NULL,'',"
                                        UpdateZaleglosci+="opis,numer_z_rs FROM rs_zaleglosci WHERE firma_id='"+self.firma_id+"' AND nr_zal="+str(NrZaleglosci)+"; "
                                    else:
                                        UpdateZaleglosci= " INSERT INTO rs_zaleglosci (firma_id,nr_zal,typ_dok,wyznacznik_id,data,numer,oddzial_id,rodzaj,typ_dok_p,"
                                        UpdateZaleglosci+="wyznacznik_id_p,data_p,numer_p,kontrahent_id,zamawiajacy_id,platnik_id,kierowca,projekt_id,waluta,kurs,"
                                        UpdateZaleglosci+="nr_tabeli,data_tabeli,sposob_zaplaty,dni,data_odbioru,termin_zaplaty,handlowiec,sposob_odbioru_faktury,"
                                        UpdateZaleglosci+="czy_bonus,do_zaplaty,do_zaplaty_wal,ureg_kwota,ureg_data,ureg_typ,ureg_numer,opis,numer_z_rs)"
                                        UpdateZaleglosci+=" SELECT firma_id,(SELECT nr_zal FROM rs_zaleglosci ORDER BY nr_zal desc LIMIT 1)+1,typ_dok,wyznacznik_id,"
                                        UpdateZaleglosci+="data,numer,oddzial_id,'N',typ_dok_p,wyznacznik_id_p,data_p,numer_p,kontrahent_id,zamawiajacy_id,platnik_id,"
                                        UpdateZaleglosci+="kierowca,projekt_id,waluta,kurs,nr_tabeli,data_tabeli,sposob_zaplaty,dni,data_odbioru,termin_zaplaty,"
                                        UpdateZaleglosci+="handlowiec,sposob_odbioru_faktury,czy_bonus, "+str(-KwotaUreg)+","+str(-KwotaZRaportu)+",0,NULL,NULL,'',"
                                        UpdateZaleglosci+="opis,numer_z_rs FROM rs_zaleglosci WHERE firma_id='"+self.firma_id+"' AND nr_zal="+str(NrZaleglosci)+"; "
                                else: #Waluty raporotu i zaleglosci sa rozne
                                    rsglobal.ZapiszDoLogow('WalutaZZaleglosci<>WalutaRap',debug)
                                    stat='ROZNE WAL$'+str(d[i][7])+' numer podpozycji:'+str(d[i][8])
                                    dane.append(stat)
                            
                            rsglobal.ZapiszDoLogow(UpdateZaleglosci,1)
                            st,d_z,dump,dump=self.PolSQL.Execute(UpdateZaleglosci,1)
                            rsglobal.ZapiszDoLogow(st,1)
                            if st<>"OK":
                                stat='BL UPD POZ ZAL'
                                dane.append(stat)
                            
                                                        
                        i=i+1
                
                else:
                    stat= "BL SQL WAL"
                    dane.append(stat)
        if stat=='OK':    
            Sql="SELECT nr_poz,suma FROM (SELECT SUM(CASE WHEN (nr_ppoz<>0 AND typ='P') OR (nr_ppoz=0 AND typ='W')"
            Sql+=" THEN round(-kwota,2) ELSE round(kwota,2) END) AS suma"
            Sql+=", nr_poz, SUM(nr_ppoz) AS ppoz FROM rs_raporty_wyciagi_pozycje "
            Sql+="WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"' AND kasa_bank_id='"+Kasa+"' "
            Sql+="AND data='"+Data+"' AND numer="+Numer+" GROUP BY nr_poz) AS tabela WHERE suma<>0 AND ppoz<>0;" 
            stat,d,dump,dump=self.PolSQL.Execute(Sql,3)
            if len(d)>0:
                stat="BL SUM KWOT PPOZ$"+str(d[0][0])
                dane.append(stat)      
        
        if len(dane)>0:
            stat=dane[-1]    
    else:    
        stat='UPR ZAM'
        dane.append(stat)
        



    if stat=='OK':            #Wykonywanie zamykania  
        Sql="SELECT dowod_id, nazwa_id,konto,waluta FROM rs_kasy_banki WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"'"
        Sql+=" AND kasa_bank_id='"+Kasa+"';"
        st,d,wyn,dump=self.PolSQL.Execute(Sql,3)
        if len(d)>0:
            DowodId=rsglobal.Dekoduj(d[0][0])
            DowodNazwa=rsglobal.Dekoduj(d[0][1])
            Konto=rsglobal.Dekoduj(d[0][2])
            Waluta=rsglobal.Dekoduj(d[0][3])
            Warunek = "firma_id=\\\'"+self.firma_id+"\\\' AND okres_id=\\\'"+self.okres_id+"\\\' AND dowod_id=\\\'"+DowodId+"\\\'"
            Warunek+=" AND nazwa_id=\\\'"+DowodNazwa+"\\\' AND data=\\\'"+Data+"\\\'"
            st,d,wyn,dump=self.PolSQL.Execute("SELECT rsf_klucz_where_new('rs_dowody_ksiegowe','"+Warunek+"','numer');",3)
            if len(d)>0:
                Nr=d[0][0]
                Sql="SELECT kurs FROM rs_raporty_wyciagi WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"'"
                Sql+=" AND kasa_bank_id='"+Kasa+"' AND data='"+Data+"' AND numer="+Numer+";" 
                stat,d,dump,dump=self.PolSQL.Execute(Sql,3)
                if stat=='OK':
                    Kurs=d[0][0]                
                    Insert="INSERT INTO rs_dowody_ksiegowe (firma_id, okres_id, dowod_id, nazwa_id, data, numer,stan)"
                    Insert+=" VALUES ('"+self.firma_id+"','"+self.okres_id+"','"+DowodId+"','"+DowodNazwa+"','"+Data+"',"+str(Nr)+",'W');"
                    
                    st,d,dump,dump=self.PolSQL.Execute(Insert,1)
                    
                    
                    Select="SELECT kasa_bank_id,data,numer,nr_poz,nr_ppoz,stan_poz,typ,symbol_dok,platnik_id,kierowca,typ_fakt,wyznacznik_id,"
                    Select+="data_fakt,numer_fakt,konto,kwota,tresc FROM rs_raporty_wyciagi_pozycje WHERE firma_id='"+self.firma_id+"'"
                    Select+=" AND okres_id='"+self.okres_id+"' AND kasa_bank_id='"+Kasa+"' AND data='"+Data+"' AND numer="+Numer                   
                    stat,d_s,dump,dump=self.PolSQL.Execute(Select,3)
                    for wiersz in d_s:
                        p_kasa_bank_id=rsglobal.Dekoduj(wiersz[0])
                        p_data=rsglobal.Dekoduj(wiersz[1])
                        p_numer=wiersz[2]
                        p_nr_poz=wiersz[3]
                        p_nr_ppoz=wiersz[4]
                        p_stan_poz=rsglobal.Dekoduj(wiersz[5])
                        p_typ=rsglobal.Dekoduj(wiersz[6])
                        p_symbol_dok=rsglobal.Dekoduj(wiersz[7])
                        p_platnik_id=rsglobal.Dekoduj(wiersz[8])
                        p_kierowca=rsglobal.Dekoduj(wiersz[9])
                        p_typ_fakt=rsglobal.Dekoduj(wiersz[10])
                        p_wyznacznik_id=rsglobal.Dekoduj(wiersz[11])
                        p_data_fakt=rsglobal.Dekoduj(wiersz[12])
                        p_numer_fakt=wiersz[13]
                        p_konto=rsglobal.Dekoduj(wiersz[14])
                        p_kwota=rsglobal.Dekoduj(wiersz[15])
                        p_tresc=rsglobal.Dekoduj(wiersz[16])
                        p_kurs_wn=Kurs
                        p_kurs_ma=Kurs
                        p_waluta_wn=Waluta
                        p_waluta_ma=Waluta
                        p_nr_pozw=1
                        Tresc=p_tresc
                        #Jaka tresc jesli faktura
                        if (p_typ_fakt in ['F','K']):
                            p_tresc='faktura '+p_wyznacznik_id+'/'+p_data_fakt+'/'+str(p_numer_fakt)
                        #Jaki termin platnosci
                        if (p_typ_fakt in ['F','K']):
                            sql="Select termin_zaplaty FROM rs_zaleglosci WHERE firma_id='"+self.firma_id+"' AND typ_dok='"+p_typ_fakt+"'"
                            sql+=" AND wyznacznik_id='"+p_wyznacznik_id+"' AND data='"+p_data_fakt+"' AND numer="+str(p_numer_fakt)+" LIMIT 1"
                            stat,d_termin,dump,dump=self.PolSQL.Execute(sql,3)
                            if stat=='OK' and len(d_termin)==1:
                                p_termin_plat="'"+rsglobal.Dekoduj(d_termin[0][0])+"'"                                
                        else:
                            p_termin_plat="NULL"    
                        #Jakie konto. W przypdaku kiedy mamy do czynienia z pozycja  powsta w trakcie regulacji korekty
                        # naley odnale fakture, z ktrej utworzono t korekte.(moze byc tak ze korekta powstala z korekty a ta korekta 
                        #z jeszcze innej korekty. Dlatego poszukujemy w gb a znajdziemy pierwsz fakture) Jak ju znajdziemy fakture to
                        #na podstawie wzoru dekretacji tej faktury wybieramy konto.
                        if (p_typ_fakt in ['F','K']):
                            r_typ_dok=p_typ_fakt
                            r_wyznacznik_id=p_wyznacznik_id
                            r_data_fakt=p_data_fakt
                            r_numer_fakt=p_numer_fakt
                            while r_typ_dok<>'F':
                                sql="SELECT typ_dok_p,wyznacznik_id_p,data_p,numer_p FROM rs_korekty WHERE firma_id='"+self.firma_id+"'"
                                sql+=" AND wyznacznik_id='"+r_wyznacznik_id+"' AND data='"+r_data_fakt+"' AND numer="+str(r_numer_fakt)
                                stat,d_korekty,dump,dump=self.PolSQL.Execute(sql,3)
                                if len(d_korekty)>0:
                                    r_typ_dok=rsglobal.Dekoduj(d_korekty[0][0])
                                    r_wyznacznik_id=rsglobal.Dekoduj(d_korekty[0][1])
                                    r_data_fakt=rsglobal.Dekoduj(d_korekty[0][2])
                                    r_numer_fakt=d_korekty[0][3]
                            sql="SELECT konto_wn FROM rs_wzory_dekretacji_faktur WHERE firma_id='"+self.firma_id+"' AND okres_id = '"+self.okres_id+"'"
                            sql+=" AND wyznacznik_id='"+r_wyznacznik_id+"' AND konto_wn<>'' AND (konto_wn is not NULL)"
                            stat,d_konto,dump,dump=self.PolSQL.Execute(sql,3)
                            if stat=='OK' and len(d_konto)>0:
                                if kompensata:
                                    Konto=p_konto
                                p_konto=rsglobal.Dekoduj(d_konto[0][0])
                        
                            
                            if p_konto<>'':
                                p_konto=p_konto+"-"+p_platnik_id
                        elif (p_typ_fakt in ['D']):
                            sql="SELECT konto_wn FROM rs_wzory_dekretacji_faktur WHERE firma_id='"+self.firma_id+"' AND okres_id = '"+self.okres_id+"'"
                            sql+=" AND wyznacznik_id='"+p_wyznacznik_id+"' AND konto_wn<>'' AND (konto_wn is not NULL)"
                            stat,d_konto,dump,dump=self.PolSQL.Execute(sql,3)
                            if stat=='OK' and len(d_konto)>0:
                                p_konto=rsglobal.Dekoduj(d_konto[0][0])
                        
                            
                            if p_konto<>'':
                                p_konto=p_konto+"-"+p_platnik_id
                            
                            
                        if  p_nr_ppoz>0 and p_typ=='P': 
                            przypadek=1
                        elif  p_nr_ppoz>0 and p_typ=='W':
                            przypadek=2
                        elif p_nr_ppoz==0:
                            sql="SELECT MAX(nr_ppoz) FROM rs_raporty_wyciagi_pozycje WHERE firma_id='"+self.firma_id+"'"
                            sql+=" AND okres_id='"+self.okres_id+"' AND kasa_bank_id='"+p_kasa_bank_id+"' AND data='"+p_data+"'"
                            sql+=" AND numer="+str(p_numer)+" AND nr_poz="+str(p_nr_poz)+";"
                            d_smax=[]
                            st,d_smax,dump,dump=self.PolSQL.Execute(sql,3)
                            if st=='OK' and len(d_smax)>0:
                                if d_smax[0][0]==0:
                                    przypadek=3
                                else:
                                    przypadek=4
                            else:
                                stat='BL SEL IL POZ'
                                dane.append(stat)
                           
                        
                        #Przypadki 1) podpozycja: mamy konto i wyplate 2)podpozycja: mamy konto i wyplate 3)
                        
                        
                               
                            
                        
                        
                        
                        if (Kurs not in (1,0)):
                            p_kwota_pln=round(Kurs*p_kwota,-2)
                        else:
                            p_kwota_pln=p_kwota
                        
                        
                        #Jaka Tresc Wn
                        if przypadek==3 and p_typ=='P' and kompensata:
                            p_tresc_wn=Tresc
                        elif (przypadek==1) or (przypadek==4 and p_typ=='W'):
                            p_tresc_wn=''
                        else:
                            p_tresc_wn=p_tresc
                        
                        #Jaka Tresc Ma
                        if przypadek==3 and p_typ=='W' and kompensata:
                            p_tresc_wn=Tresc
                        if (przypadek==2) or (przypadek==4 and p_typ=='P'):
                            p_tresc_ma=''
                        else:
                            p_tresc_ma=p_tresc
                             
                            
                        
                        #Jakie Konto Wn
                        if (przypadek==2) or (przypadek==3 and p_typ=='W'):
                            p_konto_wn=p_konto
                        elif (przypadek==3 or przypadek==4) and (p_typ=='P'):
                            p_konto_wn=Konto
                        else:
                            p_konto_wn=''
                        
                        #Jakie Konto Ma
                        if (przypadek==1) or (przypadek==3 and p_typ=='P'):    
                            p_konto_ma=p_konto
                        elif (przypadek==3 or przypadek==4) and (p_typ=='W'):
                            p_konto_ma=Konto
                        else:
                            p_konto_ma=''
                        
                        
                        #Jaka kwota Wn
                        if przypadek==1 or (przypadek==4 and p_typ=='W'):
                            p_kwota_wn=0
                            p_kwota_wal_wn=0
                        else:
                            p_kwota_wn=p_kwota_pln
                            p_kwota_wal_wn=p_kwota
                            
                        
                        #Jaka kwota Ma
                        if przypadek==2 or (przypadek==4 and p_typ=='P'):
                            p_kwota_ma=0
                            p_kwota_wal_ma=0
                        else:
                            p_kwota_ma=p_kwota_pln
                            p_kwota_wal_ma=p_kwota
                        
                        if p_platnik_id in ['','None']:
                            p_platnik_id='NULL'
                        else:
                            p_platnik_id="'"+p_platnik_id+"'"
                        
                        InsertPoz="INSERT INTO rs_dowody_ksiegowe_pozycje (firma_id,okres_id,dowod_id, nazwa_id, data, numer, nr_poz, nr_ppoz,"
                        InsertPoz+="nr_pozw,kontrahent_id,tresc_wn,tresc_ma,symbol_dok,data_zapl,termin_plat,konto_wn,kwota_wn,kwota_wal_wn,"
                        InsertPoz+="konto_ma,kwota_ma,kwota_wal_ma,kurs_wn,waluta_wn,kurs_ma,waluta_ma) VALUES ('"+self.firma_id+"',"
                        InsertPoz+="'"+self.okres_id+"','"+DowodId+"','"+DowodNazwa+"','"+Data+"',"+str(Nr)+","+str(p_nr_poz)+","+str(p_nr_ppoz)
                        InsertPoz+=","+str(p_nr_pozw)+","+p_platnik_id+",'"+p_tresc_wn+"','"+p_tresc_ma+"','"+p_symbol_dok+"','"+Data+"',"
                        InsertPoz+=p_termin_plat+",'"+p_konto_wn+"',"+str(p_kwota_wn)+","+str(p_kwota_wal_wn)+",'"+p_konto_ma+"',"+str(p_kwota_ma)+","
                        InsertPoz+=str(p_kwota_wal_ma)+","+str(p_kurs_wn)+",'"+p_waluta_wn+"',"+str(p_kurs_ma)+",'"+p_waluta_ma+"')"
                        stat,dump,dump,dump=self.PolSQL.Execute(InsertPoz,1)
                        if stat<>'OK':
                            stat='BL ZAM POZ'
                            dane.append(stat)
                        
                    
                        
                        
                        
                    
                    
                    
                    
                    if len(dane)==0:
                        rsglobal.ZapiszDoLogow(dane,1)
                        UpdateDow="Update rs_dowody_ksiegowe SET kwota_wn=(SELECT SUM(kwota_wn) FROM rs_dowody_ksiegowe_pozycje"
                        UpdateDow+=" WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"' AND dowod_id='"+DowodId+"'"
                        UpdateDow+=" AND nazwa_id='"+DowodNazwa+"' AND data='"+Data+"' AND numer="+str(Nr)+"),"
                        UpdateDow+="kwota_ma=(SELECT SUM(kwota_ma) FROM rs_dowody_ksiegowe_pozycje WHERE firma_id='"+self.firma_id+"'"
                        UpdateDow+=" AND okres_id='"+self.okres_id+"' AND dowod_id='"+DowodId+"' AND nazwa_id='"+DowodNazwa+"' AND data='"+Data+"'"
                        UpdateDow+=" AND numer="+str(Nr)+") WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"'"
                        UpdateDow+=" AND dowod_id='"+DowodId+"' AND nazwa_id='"+DowodNazwa+"' AND data='"+Data+"' AND numer="+str(Nr)+"; "
                        
                        Update="Update rs_raporty_wyciagi SET stan='Z' WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"'"
                        Update+=" AND kasa_bank_id='"+Kasa+"' AND data='"+Data+"' AND numer="+Numer+"; "
                        
                        UpdatePoz="Update rs_raporty_wyciagi_pozycje SET stan_poz='Z' WHERE  firma_id='"+self.firma_id+"'"
                        UpdatePoz+=" AND okres_id='"+self.okres_id+"' AND kasa_bank_id='"+Kasa+"' AND data='"+Data+"' AND numer="+Numer+"; "
                    
                        
                    
                        stat,dump,dump,dump=self.PolSQL.Execute(UpdateDow+Update+UpdatePoz,1)
                        if stat<>'OK':
                            stat='BL ZAM'
                            dane.append(stat)
                            st,dump,dump,dump=self.PolSQL.Execute("ROLLBACK;",1)
                        else:
                            st,dump,dump,dump=self.PolSQL.Execute("COMMIT;",1)
                    else:
                        stat=dane[-1]
                        st,dump,dump,dump=self.PolSQL.Execute("ROLLBACK;",1)
                    
                else:
                    stat='BL SQL KURS'
                    dane.append(stat)
                    st,dump,dump,dump=self.PolSQL.Execute("ROLLBACK;",1)
                
            else:
                stat='BL SQL NR DOW'
                dane.append(stat)
                st,dump,dump,dump=self.PolSQL.Execute("ROLLBACK;",1)
        else:
            stat='BL SQL DOW'
            dane.append(stat)
            st,dump,dump,dump=self.PolSQL.Execute("ROLLBACK;",1)
    else:
        st,dump,dump,dump=self.PolSQL.Execute("ROLLBACK;",1)




# UPDATE
if (Fun in [3,4]) and (stat=='OK'):
    if (self.operator_id == STANDARD_OPERATOR_ID):
        Uprawnienia=True
    else:
        Uprawnienia= UprUpd and (Kasa in LUpd)
        
    if Uprawnienia:
        Upd="UPDATE rs_raporty_wyciagi SET kurs="+Kurs+" WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"' AND kasa_bank_id='"+Kasa+"' AND data='"+Data+"' AND numer="+Numer+";"
        stat,dump,dump,dump=self.PolSQL.Execute(Upd,1)
        if stat<>'OK':
            stat='BL UPD'
            dane.append(stat)
    else:
        stat='UPR UPD'
        dane.append(stat)


# DELETE
if (Fun in [6]) and (stat=='OK'):
    if (self.operator_id == STANDARD_OPERATOR_ID):
        Uprawnienia=True
    else:
        Uprawnienia= UprDel and (Kasa in LDel)

    if Uprawnienia:
        Select="SELECT stan FROM rs_raporty_wyciagi WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"' AND kasa_bank_id='"+Kasa+"' AND data='"+Data+"' AND numer="+Numer+";"
        stat,d,wyn1,wyn2=self.PolSQL.Execute(Select,3)
        if d[0][0]<> 'W':
            stat='DEL STAN'
            dane.append(stat)            
        
        if stat=="OK":
            Select="SELECT nr_poz FROM rs_raporty_wyciagi_pozycje WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"' AND kasa_bank_id='"+Kasa+"' AND data='"+Data+"' AND numer="+Numer+" AND stan_poz<>'W';"
            stat,d,wyn1,wyn2=self.PolSQL.Execute(Select,3)
            if len(d)>0:
                stat='DEL STANP'
                dane.append(stat)
            
        if stat=="OK":    
            DeletePoz="DELETE FROM rs_raporty_wyciagi_pozycje WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"' AND kasa_bank_id='"+Kasa+"' AND data='"+Data+"' AND numer="+Numer+"; "
            
            Delete="DELETE FROM rs_raporty_wyciagi WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"' AND kasa_bank_id='"+Kasa+"' AND data='"+Data+"' AND numer="+Numer+"; "
            stat,dump,dump,dump=self.PolSQL.Execute(DeletePoz+Delete,1)
            if stat<>'OK':
                stat='BL DEL'
                dane.append(stat)
    else:
        stat='UPR DEL'
        dane.append(stat)

rsglobal.ZapiszDoLogow(4,1)
# POBIERANIE DANYCH
if (Fun in [5,3,4,6]) and (stat=='OK'):
    if (self.operator_id == STANDARD_OPERATOR_ID):
        Uprawnienia=True
    else:
        Uprawnienia= UprPrz
    
    if Uprawnienia:
        Sql="SELECT r.stan,r.kasa_bank_id,r.data,r.numer,r.saldo_pocz,r.wplaty,r.wyplaty,r.saldo_konc,k.waluta,r.kurs,r.kompensata FROM rs_raporty_wyciagi r INNER JOIN rs_kasy_banki k ON (r.firma_id=k.firma_id AND r.okres_id=k.okres_id AND r.kasa_bank_id=k.kasa_bank_id) WHERE r.firma_id='"+self.firma_id+"' AND r.okres_id='"+self.okres_id+"'"
        if KasaBankF<>'':
            Sql=Sql+" AND r.kasa_bank_id='"+KasaBankF+"'"
        if DataOdF <> '    -  -  ':
            Sql=Sql+" AND r.data>='"+DataOdF+"'"
        if DataDoF <> '    -  -  ':
            Sql=Sql+" AND r.data<='"+DataDoF+"'"
        if StanF<>'':
            Sql=Sql+" AND r.stan='"+StanF+"'"
        
        #uwzgldnienie tych kas do ktrych operator ma uprawnienia
        if self.operator_id <> STANDARD_OPERATOR_ID:    
            Sql=Sql+" AND r.kasa_bank_id IN ("+str(LPrz)[1:-1]+")"
            
        Sql=Sql+" ORDER BY r.data desc, r.numer desc ; "
        stat,dane,wyn1,wyn2=self.PolSQL.Execute(Sql,3)
        if stat<>'OK':
            stat='BL PRZ'
            dane.append(stat)
    else:
        stat='UPR PRZ'
        dane.append(stat)
