#!/usr/bin/python
# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:             fs_receptury_dane.py
# Purpose:          obsuga okna receptur
# Author:           Piotr Witkowski
# Created:          2017/03/27
# RCS-ID:           $Id: fs_receptury_dane.py $
# Copyright:        (c) 2017 RecordSystem
# Licence:          GNU GPL
#-------------------------------------------------------------------------------

import string
import rsglobal
from funkcje import fs_pobierz_upr_oddzialy_pom

stat='OK'
try:
    if not 'Funkcja' in klucze:
        stat='Brak podanej funkcji w kluczach'
except:
    stat=u'Brak kluczy'


def SprawdzPozycje(self,artykul_id,skladnik_id):
    Dane=[]
    stat='OK'
    if artykul_id=="":
        stat="BR_ART"   
        Dane.append(stat)
    if skladnik_id=="":
        stat="BR_SKL"   
        Dane.append(stat)
    if artykul_id==skladnik_id:
        stat="BL_ARTSKL"   
        Dane.append(stat)
    if stat=="OK":
            sql="SELECT artykul_id,typ_artykulu,nazwa,jm1,jm2,przelicznik,jm_kalk FROM rs_artykuly "
            sql+="WHERE firma_id='"+self.firma_id+"' and artykul_id = '"+skladnik_id+"';"
            stat,data,dump,dump = self.PolSQL.Execute(sql,2)
            if len(data)>0:
                if len(data)==1:
                    if data[0][1]  in ('04','05','03'):
                         Dane=[string.strip(data[0][0]),data[0][2],data[0][3],data[0][4],data[0][5],data[0][6]]
                    else:
                         stat='BL_NOT1'
                         Dane.append(stat)   
                else:
                    stat='BD GRUP'
                    Dane.append(stat)
            else:        
                    stat='BL_NOTIST '
                    Dane.append(stat)
    return stat,Dane

if stat=='OK':
    Funkcja = klucze['Funkcja']
    SlPar={'artykul_id':[1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17],'oddzial_id':[1,2,3,4,5,6,7,8,9,10,11,12,13,15,16,17],
           'data_od':[1,2,3,4,5,6,7,8,9,10,11,12,13,16,17],'data_do':[6,7,8,12],
           'artykul_opis':[6,7,8],'data_od_nowa':[9,12],'artykul_id_nowy':[9,],
           'stan':[13],'kier':[13],'skladnik':[10,15,16],'skladnik_nowy':[10,],}

    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Funkcja,klucze)
    if Lista<>'':
        stat='Uwaga : wywoanie funkcji fs_receptury_dane z numerem ' +str(Funkcja)+' bez parametrw: '+Lista

if stat=='OK':
    if Funkcja in [1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17]:
        artykul_id = klucze['artykul_id']
    if Funkcja in [1,2,3,4,5,6,7,8,9,10,11,12,13,15,16,17]:
        oddzial_id = klucze['oddzial_id']
    if Funkcja in [1,2,3,4,5,6,7,8,9,10,11,12,13,16,17]:
        data_od = klucze['data_od']
    if Funkcja in [6,7,8,12,]:
        data_do = klucze['data_do']
    if Funkcja in [6,7,8,]:
        artykul_opis = klucze['artykul_opis']
    if Funkcja in [9,12,]:
        data_od_nowa = klucze['data_od_nowa']
    if Funkcja in [9,]:
        artykul_id_nowy = klucze['artykul_id_nowy']
    if Funkcja in [13,]:
        stan = klucze['stan']
        kier = klucze['kier']
    if Funkcja in [10,15,16]:
        skladnik = klucze['skladnik']
    if Funkcja in [10,]:
        skladnik_nowy = klucze['skladnik_nowy']

if stat=='OK':
    dane = []
    wyn1 = []
    wyn2 = []
    ilosc1="0"
    ilosc2="0"
    
    
    
    
    
    
    
    


#-------------------------------------------------------------------------------
#---   Pierwsza cz kopiowania 12
#-------------------------------------------------------------------------------

if stat=="OK" and Funkcja==12:
    if not(((self.oddzial_id,'041013') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)):
        stat = u'Brak uprawnie do kopiowania'
    else:
        #rsglobal.ZapiszDoLogow('kl '+str(klucze),1)
        sql ="SELECT artykul_id FROM rs_receptury WHERE firma_id ='"+self.firma_id+"'"
        sql+=" AND oddzial_id='"+oddzial_id+"' AND data_od='"+data_od_nowa+"'"
        sql+=" AND artykul_id ='"+artykul_id+"';"
        stat,DaneR,dump,dump = self.PolSQL.Execute(sql,3)
        #rsglobal.ZapiszDoLogow(sql,5)
        #rsglobal.ZapiszDoLogow(stat,5)
        #rsglobal.ZapiszDoLogow(DaneR,5)
        if len(DaneR)>0:
            stat="BR_ISTN_REC"
    
        sql ="SELECT opis,wydajnosc,odchylenia,zalecenia,wymagania,ilosc1,ilosc2"
        sql+=" FROM rs_receptury"
        sql+=" WHERE firma_id='"+self.firma_id+"' AND oddzial_id ='"+oddzial_id+"'"
        sql+=" AND data_od='"+data_od+"' AND artykul_id ='"+artykul_id+"';"
    
        st,DaneR,dump,dump = self.PolSQL.Execute(sql,3)
        #rsglobal.ZapiszDoLogow(sql,5)
        if st<>'OK':
            stat=st
        #rsglobal.ZapiszDoLogow(stat,5)
        #rsglobal.ZapiszDoLogow(DaneR,5)
        if data_do in ['    -  -  ','',None]:
            data_do = 'None'
    
        if stat=="OK":
            sql="SELECT skladnik_id,ilosc1,ilosc2,iloscp1,iloscp2, COALESCE(magazyn_id,''::TEXT) FROM rs_receptury_pozycje "
            sql+="WHERE firma_id ='"+self.firma_id+"' AND oddzial_id = '"+oddzial_id+"' "
            sql+="AND data_od ='"+data_od+"' AND artykul_id ='"+artykul_id+"';"
            #rsglobal.ZapiszDoLogow(sql,5)
            stat,Dane,dump,dump = self.PolSQL.Execute(sql,3)
            #rsglobal.ZapiszDoLogow(stat,5)
            #rsglobal.ZapiszDoLogow(Dane,5)
            if stat<>"OK":
                stat=u"Bd pobrania listy pozycji"
                dane.append(stat)

        pola = ["ilosc1","ilosc2","data_od","artykul_id","data_do"]
        wartosci = [DaneR[0][5],DaneR[0][6],data_od_nowa,artykul_id,data_do,]


#-------------------------------------------------------------------------------
#---   Okno edycji danych
#-------------------------------------------------------------------------------

if stat=="OK" and Funkcja in (1,2,3,4,5,12):
    for i in range(len(pola)):
        pole = pola[i]
        wart = wartosci[i]
        if pole=="ilosc1":
            ilosc1=wart
        if pole=="ilosc2":
            ilosc2=wart    
    if artykul_id=="":
            stat="BR_ART"   
            dane.append(stat)
    else:
          sql ="SELECT nazwa,jm1,jm2,przelicznik,jm_kalk FROM rs_artykuly"
          sql+=" WHERE firma_id='"+self.firma_id+"' AND artykul_id='"+artykul_id+"';"
          stat,d,dump,dump = self.PolSQL.Execute(sql,2)
          if stat=="OK":
            if len(d)==0  : 
                stat="BL_ART"   
                dane.append(stat)
            else:
                 wyn2=d    
          else :
                stat="BL_SQL"   
                dane.append(stat)

    sql="SELECT rsf_sprawdz_date('"+str(data_od)+"');"
    stat,d,dump,dump = self.PolSQL.Execute(sql,3)
    if stat=="OK":
        if d[0][0]==0:
            stat="BL_DATY"   
            dane.append(stat)     
        elif d[0][0]==1:  
            stat="BL_DATY"   
            dane.append(stat)     
    else:
         stat="BL_SQL"   
         dane.append(stat)
    
    
    if stat=="OK" and Funkcja<>5:
        if str(ilosc1)=="":
                stat="BR_ILOSC1"   
                dane.append(stat)
        else:        
            if ilosc1<=0:
                    stat="BL_ILOSC1"   
                    dane.append(stat)
        if str(ilosc2)=="":
                stat="BR_ILOSC2"   
                dane.append(stat)
        else:        
            if ilosc2<=0:
                stat="BL_ILOSC2"   
                dane.append(stat)

#-------------------------------------------------------------------------------
#---   Okno edycji danych INSERT
#-------------------------------------------------------------------------------

if stat=="OK" and Funkcja in (1,2,12):
    if Funkcja == 12:
        data_od=data_od_nowa
    sql="SELECT artykul_id FROM rs_receptury "
    sql+=" WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+oddzial_id+"'"
    sql+=" AND data_od='"+data_od+"' AND artykul_id='"+artykul_id+"';"
    stat,d,dump,dump = self.PolSQL.Execute(sql,2)
    if stat <> 'OK':
        stat = 'Bd sprawdzenia istnienia receptury: '+stat
        dane.append(stat)
    elif len(d)>0:    
        stat = 'BL_ISTN'
        dane.append(stat)

#-------------------------------------------------------------------------------

if stat=="OK" and Funkcja in (1,2,12):
    POLA ="firma_id,oddzial_id,stan"
    WARTOSCI = "'"+self.firma_id+"','"+oddzial_id+"','W'"
    for i in xrange(len(pola)):
        pole = pola[i]
        wart = wartosci[i]
        POLA += ","+pole
        if pole in ('ilosc1','ilosc2'):
            WARTOSCI+=","+str(wart)
        else:
            if wart == '' or (pole == 'data_do' and wart in ['    -  -  ', '', None, 'None']):
                WARTOSCI+=",NULL"
            else:
                WARTOSCI+=",'"+wart+"'"

    INS ="INSERT INTO rs_receptury ("+POLA+") VALUES ("+WARTOSCI+"); "
    stat,dump,dump,dump = self.PolSQL.Execute(INS,1)
    if stat <> 'OK':
        stat = 'Bd dodawania nowej receptury: '+stat


#-------------------------------------------------------------------------------
#---   Okno edycji danych UPDATE
#-------------------------------------------------------------------------------
        
if stat=="OK" and Funkcja in (3,4):
    UPD="UPDATE rs_receptury SET "
    for i in range(len(pola)):
        pole = pola[i]
        wart = wartosci[i]
        if pole == 'data_do' and wart in ['    -  -  ','',None]:
            UPD+=pole+"=Null,"
        elif pole in ["oddzial_id","data_od","data_do","artykul_id","stan","ilosc1","ilosc2","opis","wydajnosc","odchylenia","zalecenia","wymagania"]:
            UPD+=pole+"='"+str(wart)+"',"
    UPD = UPD[:-1]
 
    UPD+=" WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+oddzial_id+"'"
    UPD+=" AND data_od='"+data_od+"' AND artykul_id='"+artykul_id+"';"
    stat,dump,dump,dump = self.PolSQL.Execute(UPD,1)
    if stat <> 'OK':
        stat = 'Bd modyfikacji danych: '+stat


#-------------------------------------------------------------------------------
#---   Okno edycji danych pobieranie SELECT
#-------------------------------------------------------------------------------
   
if stat=="OK" and Funkcja in (1,3,5):
    SEL ="SELECT artykul_id,ilosc1,ilosc2,data_od,data_do,opis,wydajnosc,odchylenia,zalecenia,wymagania FROM rs_receptury "
    SEL+=" WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+oddzial_id+"'"
    SEL+=" AND data_od='"+data_od+"' AND artykul_id='"+artykul_id+"';"
    stat,dane,wyn1,dump = self.PolSQL.Execute(SEL,3)
    if stat <> 'OK':
        stat = 'Bd pobrania danych proceduty: '+stat


#-------------------------------------------------------------------------------
#---   Druga cz kopiowania 12
#-------------------------------------------------------------------------------

if stat=="OK" and Funkcja==12:
    Upd ="UPDATE rs_receptury SET opis='"+rsglobal.Dekoduj(DaneR[0][0].replace("'",'`'))
    Upd+="',wydajnosc='"+rsglobal.Dekoduj(DaneR[0][1].replace("'",'`'))+"',odchylenia='"+rsglobal.Dekoduj(DaneR[0][2].replace("'",'`'))
    Upd+="',zalecenia='"+rsglobal.Dekoduj(DaneR[0][3].replace("'",'`'))+"',wymagania='"+rsglobal.Dekoduj(DaneR[0][4].replace("'",'`'))
    if data_do not in ['None',None,'']:
        Upd+="',data_do='"+data_do+"'"
    else:
        Upd+="',data_do=Null"
    Upd+=" WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+oddzial_id
    Upd+="' AND data_od='"+data_od_nowa+"' AND artykul_id='"+artykul_id+"'"
    stat,dane,dump,dump = self.PolSQL.Execute(Upd,1)
    for row in Dane:
        mag = rsglobal.Dekoduj(row[5]).strip()
        if mag == '':
            mag = 'NULL'
        else:
            mag = "'"+mag+"'"

        sql="INSERT INTO rs_receptury_pozycje (firma_id,oddzial_id,data_od,artykul_id, skladnik_id,ilosc1,ilosc2,magazyn_id) "
        sql+="VALUES ('"+self.firma_id+"','"+oddzial_id+"','"+data_od_nowa+"','"+artykul_id+"',"
        sql+="'"+str(row[0])+"','"+str(row[1])+"','"+str(row[2])+"',"+str(mag)+");"
        #rsglobal.ZapiszDoLogow(sql,5)
        stat,Dane,dump,dump = self.PolSQL.Execute(sql,1,CzyDodawacBlad=True)
        if stat<>"OK":
            stat="Bd kopiowania receptury: "+stat
            dane.append(stat)


#-------------------------------------------------------------------------------
#---   ZMIANA KLUCZA RECEPTUR (9)
#-------------------------------------------------------------------------------

if stat=="OK" and Funkcja==9:
    if not (((self.oddzial_id,'041015') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)):
        stat="Brak uprawnie do modyfikacji receptur w tym oddziale."   
        dane.append(stat)
        
    if stat == 'OK':    
        stat,row,dump,dump=self.WykonajFunkcje("fs_artykuly_pobierz",[artykul_id_nowy])
        if stat <> "OK":
            stat="BL_SQL"   
            dane.append(stat)
        elif len(row)==0:    
            stat="BL_ISTN"   
            dane.append(stat)
    
        if not rsglobal.SprawdzCzyToData(data_od_nowa):
            stat = 'BL_DATA'
            dane.append(stat)
        
        if stat == 'OK':
            sql ="SELECT artykul_id FROM rs_receptury"
            sql+=" WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+oddzial_id+"'"
            sql+=" AND data_od='"+data_od_nowa+"' AND artykul_id='"+artykul_id_nowy+"';"
                      
            stat,d,dump,dump = self.PolSQL.Execute(sql,2)
            if stat <> "OK":
                stat="BL_SQL"   
                dane.append(stat)
            elif len(d)>0:    
                stat="BL_ISTN_RECEP"   
                dane.append(stat)
                
        if stat=="OK":
            sql ="SELECT skladnik_id FROM rs_receptury_pozycje"
            sql+=" WHERE firma_id ='"+self.firma_id+"' AND oddzial_id = '"+oddzial_id+"'"
            sql+=" AND data_od='"+data_od+"' AND artykul_id='"+artykul_id+"';"
    
            stat,d,dump,dump = self.PolSQL.Execute(sql,3)
            if stat <> "OK":
                stat="BL_SQL"   
                dane.append(stat)
            else:    
                for row in d:
                    stat,row = SprawdzPozycje(self,artykul_id_nowy,row[0])
                    
                    if stat <> "OK":
                        stat="BL_SKL"   
                        dane.append(stat)
                        break
    
        if stat=="OK":
            sql ="UPDATE rs_receptury SET artykul_id='"+artykul_id_nowy+"',data_od='"+data_od_nowa+"'"
            sql+=" WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+oddzial_id+"'"
            sql+=" AND data_od='"+data_od+"' AND artykul_id='"+artykul_id+"';"
            
            if artykul_id_nowy<>artykul_id:
                # sprawdzenie czy w nowym artykule dla wybranego oddziau wystpuj ju procesy artykuy    
                SQLTest="SELECT COUNT(*) FROM rs_procesy_artykuly WHERE firma_id='"+self.firma_id+"'"
                SQLTest+=" AND artykul_id='"+artykul_id_nowy+"' AND oddzial_id='"+self.oddzial_id+"';"
                stat,DTest,wyn,dump = self.PolSQL.Execute(SQLTest,3)
                if stat<>'OK':
                    stat='Bd pobierania informacji z rs_procesy_artykuly :'+stat
            
                if stat=='OK' and DTest[0][0]==0:
                    # jeli nie to je kopiujemy ze starego artykuu
                    sql+="INSERT INTO rs_procesy_artykuly (firma_id,proces_id,artykul_id,urzadzenie_id,"
                    sql+="czas, stanowisko_pocz,stanowisko_koniec,maks_ilosc,kolejnosc,nastepny_proces,"
                    sql+="zmiana_cecha,zmiana_czas,czas_nastepny,oddzial_id) "
                    sql+=" SELECT firma_id,proces_id,'"+artykul_id_nowy+"',urzadzenie_id,"
                    sql+="czas, stanowisko_pocz,stanowisko_koniec,maks_ilosc,kolejnosc,nastepny_proces,"
                    sql+="zmiana_cecha,zmiana_czas,czas_nastepny,oddzial_id FROM rs_procesy_artykuly "
                    sql+=" WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+self.oddzial_id+"'"
                    sql+=" AND artykul_id='"+artykul_id+"';"
            
            stat,dump,dump,dump = self.PolSQL.Execute(sql,1)
            if stat <> "OK":
                stat ="Bd zmiany klucza receptury: "+stat
                dane.append(stat)
                
                
#-------------------------------------------------------------------------------
#---   ZMIANA KLUCZA POZYCJI RECEPTUR (10)
#-------------------------------------------------------------------------------

if stat=="OK" and Funkcja==10:
    if skladnik_nowy=="":
        stat="BR_SKL"
        dane.append(stat)
    else:
        stat,row,dump,dump=self.WykonajFunkcje("fs_artykuly_pobierz",[artykul_id])
        if stat<>"OK":
            stat="Bd pobrania artykuu"
            dane.append(stat)
        else:
            if len(row)==0:
                stat="BL_NOTISTN"
                dane.append(stat)

        stat,d = SprawdzPozycje(self,artykul_id,skladnik_nowy)
        if stat<>"OK":
            stat="BL_SKL"
            dane.append(stat)
        if stat=="OK":
            sql="SELECT rsf_sprawdz_date('"+str(data_od)+"') ;"
            stat,d,dump,dump = self.PolSQL.Execute(sql,3)
            spr ="SELECT 1 FROM rs_receptury_pozycje "
            spr+="WHERE firma_id ='"+self.firma_id+"' "
            spr+="AND oddzial_id = '"+oddzial_id+"' AND data_od ='"+data_od+"' "
            spr+="AND artykul_id ='"+artykul_id+"' AND skladnik_id ='"+skladnik_nowy+"';"
            stat,d,wyn1,dump = self.PolSQL.Execute(spr,3)
            if stat<>"OK":
                stat=u"Bd sprawdzenia skadnika pozycji receptur."
                dane.append(stat)
            elif len(d)>0:
                stat=u"Nie mona zmieni klucza, istnieje ju podany klucz."
                dane.append(stat)
            else:
                sql ="UPDATE rs_receptury_pozycje SET skladnik_id ='"+skladnik_nowy+"' "
                sql+="WHERE firma_id ='"+self.firma_id+"' "
                sql+="AND oddzial_id = '"+oddzial_id+"' AND data_od ='"+data_od+"' "
                sql+="AND artykul_id ='"+artykul_id+"' AND skladnik_id ='"+skladnik+"';"
                stat,d,wyn1,dump = self.PolSQL.Execute(sql,1)
                if stat<>"OK":
                    stat=u"Bd aktuallizacji klucza pozycji"
                    dane.append(stat)


#-------------------------------------------------------------------------------
#---   DELETE (11)
#-------------------------------------------------------------------------------

if stat=='OK' and Funkcja ==11:
    if not (((self.oddzial_id,"041014") in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)):
        stat='Brak uprawnie do usuwania receptury.'
    else:
        sql ="DELETE FROM rs_receptury_pozycje WHERE firma_id ='"+self.firma_id+"' AND oddzial_id = '"+oddzial_id+"' "
        sql+="AND data_od ='"+data_od+"' AND artykul_id ='"+artykul_id+"';"
        stat,dane,wyn1,wyn2=self.PolSQL.Execute(sql,1)
        if stat<>'OK':
            stst="BR_KAS_POZ"
        else:
            sql ="DELETE FROM rs_receptury WHERE firma_id ='"+self.firma_id+"' AND oddzial_id = '"+oddzial_id+"' "
            sql+="AND data_od ='"+data_od+"' AND artykul_id ='"+artykul_id+"';"
            stat,dane,wyn1,wyn2=self.PolSQL.Execute(sql,1)




#-------------------------------------------------------------------------------
#---   ZMIANA STANW W>G;G>Z;Z>G;G>W
#-------------------------------------------------------------------------------

if stat=="OK" and Funkcja==13:
    #zamykanie
    if stan=="W":
        if ((self.oddzial_id,'041016') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
            sql ="SELECT artykul_id FROM rs_receptury_pozycje WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+oddzial_id+"' "
            sql+="AND data_od ='"+data_od+"' AND artykul_id ='"+artykul_id+"';"
            stat,data,dump,dump = self.PolSQL.Execute(sql,2)
            if not ((stat=="OK") and (len(data))>0):
                stat="BR_ilosc_pozycji"
            if stat=="OK":
                sql ="SELECT ilosc1,ilosc2 FROM rs_receptury WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+oddzial_id+"' "
                sql+="AND data_od='"+data_od+"' AND artykul_id='"+artykul_id+"';"
                stat,data,dump,dump = self.PolSQL.Execute(sql,2)
            if stat=="OK":
                ilosc1=data[0][0]
                ilosc2=data[0][1]
                sql ="UPDATE rs_receptury_pozycje SET iloscp1 =round(ilosc1/"+str(ilosc1)+",6),iloscp2=round(ilosc2/"+str(ilosc1)+",6),"
                sql+="iloscp1j2 =round(ilosc1/"+str(ilosc1)+",6),iloscp2j2=round(ilosc2/"+str(ilosc2)+",6) "
                sql+="WHERE firma_id ='"+self.firma_id+"' AND oddzial_id = '"+oddzial_id+"' AND data_od ='"+data_od+"' AND artykul_id ='"+artykul_id+"';"

                stat,data,dump,dump = self.PolSQL.Execute(sql,1)
                sql ="UPDATE rs_receptury  SET stan = 'G',przyg_op_id="+str(self.operator_id)+",przyg_czas=now() "
                sql+="WHERE firma_id ='"+self.firma_id+"' AND oddzial_id = '"+oddzial_id+"' AND data_od ='"+data_od+"' AND artykul_id ='"+artykul_id+"';"
                stat,data,dump,dump = self.PolSQL.Execute(sql,1)
        else:
            stat='Brak uprawnie do zamykania receptury'

    #zatwierdzanie
    elif stan=="G" and kier=='gora':
        if ((self.oddzial_id,'041017') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
            sql ="UPDATE rs_receptury  SET stan = 'Z',zam_op_id="+str(self.operator_id)+",zam_czas=now() "
            sql+="WHERE firma_id ='"+self.firma_id+"' AND oddzial_id = '"+oddzial_id+"' AND data_od ='"+data_od+"' AND artykul_id ='"+artykul_id+"';"
            stat,data,dump,dump = self.PolSQL.Execute(sql,1)
        else:
            stat='Brak uprawnie do zatwierdzania receptury'

    #otwieranie
    elif stan=="G" and kier=='dol':
        if ((self.oddzial_id,'041018') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
             sql="UPDATE rs_receptury_pozycje SET iloscp1 =0,iloscp2=0,iloscp1j2=0,iloscp2j2=0 WHERE firma_id ='"+self.firma_id+"' "
             sql+="AND oddzial_id = '"+oddzial_id+"' AND data_od ='"+data_od+"' AND artykul_id ='"+artykul_id+"';"
             stat,data,dump,dump = self.PolSQL.Execute(sql,1)
             if stat=="OK":
                sql="UPDATE rs_receptury SET stan='W' WHERE firma_id ='"+self.firma_id+"' AND oddzial_id = '"+oddzial_id+"' "
                sql+="AND data_od ='"+data_od+"' AND artykul_id ='"+artykul_id+"';"
                stat,data,dump,dump = self.PolSQL.Execute(sql,1)
        else:
            stat='Brak uprawnie do otwierania receptury'

    #odblokowywanie
    elif stan=="Z":
        if ((self.oddzial_id,'041019') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
            sql="UPDATE rs_receptury SET stan='G' WHERE firma_id ='"+self.firma_id+"' AND oddzial_id = '"+oddzial_id+"' "
            sql+="AND data_od ='"+data_od+"' AND artykul_id ='"+artykul_id+"';"
            stat,data,dump,dump = self.PolSQL.Execute(sql,1)
        else:
            stat='Brak uprawnie do odblokowywania receptury'






#-------------------------------------------------------------------------------
#--- POBRANIE OPISU ARTYKULU LISTY (14)
#-------------------------------------------------------------------------------

if stat=='OK' and Funkcja==14:
    sql ="SELECT nazwa FROM rs_artykuly WHERE firma_id='"+self.firma_id+"' AND artykul_id='"+artykul_id+"';"
    stat,dane,dump,dump = self.PolSQL.Execute(sql,3)


#-------------------------------------------------------------------------------
#---- POBRANIE DANYCH LISTY (15)
#-------------------------------------------------------------------------------

if stat=='OK' and Funkcja ==15:
    if not self.operator_id == STANDARD_OPERATOR_ID:
        Dozwololony = False
        for oddz,upr in self.uprawnienia:
            if (oddzial_id,'04101') == (oddz,upr[:5]) or ('**','04101') == (oddz,upr[:5]):
                Dozwolony = True
                break
        if not Dozwolony:
            stat = 'Brak uprawnie do przegldania receptur. Oddzia '+oddzial_id
            dane.append(stat)

    if stat == 'OK':
        if skladnik <> '':
            # jesli podany skladnik, pobierzemy liste artykulow, w ktorych
            # wystepuje podany skladnik
            sql ="SELECT DISTINCT artykul_id,data_od,oddzial_id FROM rs_receptury_pozycje"
            sql+=" WHERE firma_id='"+self.firma_id+"'"
            if artykul_id <> '':
                # zawezamy receptury tylko tego artykulu
                sql+=" AND artykul_id='"+artykul_id+"'"
            sql+=" AND skladnik_id LIKE '"+skladnik+"%';"

            stat, dArt, dump,dump = self.PolSQL.Execute(sql,3)
            if stat <> 'OK':
                stat = 'Bd pobrania artykuw z receptur: '+stat
                dane.append(stat)
            elif len(dArt) == 0:
                # ten myk pozwoli ominac wszystkie receptury w przypadku
                # nieznaleziena skladnika w zadnej recepturze
                dArt.append(['x',None,None])

    if stat == 'OK':
        sql ="SELECT r.firma_id,r.oddzial_id,r.data_od,r.artykul_id,"
        sql+=" r.stan,a.nazwa,r.ilosc1,a.jm1,r.ilosc2,a.jm2,data_do"
        sql+=" FROM rs_receptury r"
        sql+=" INNER JOIN rs_artykuly a USING (firma_id,artykul_id)"
        sql+=" WHERE firma_id='"+self.firma_id+"'"

        if artykul_id <> '':
            sql+= " AND artykul_id='"+artykul_id+"'"
        if skladnik <> '':
            # tu obslugujemy wybor receptur zawezony przez skladnik
            sql+=" AND ("
            for poz in dArt:
                sql+="(artykul_id='"+rsglobal.Dekoduj(poz[0]).strip()+"'"
                if poz[1] <> None:
                    sql+=" AND oddzial_id='"+rsglobal.Dekoduj(poz[2])+"'"
                    sql+=" AND data_od='"+rsglobal.Dekoduj(poz[1])+"'"
                sql+=") OR "

            sql = sql.strip(' OR ')
            sql+=")"

        sql+=" ORDER BY r.oddzial_id,r.artykul_id,r.data_od;"

        stat,dane,wyn1,wyn2=self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Bd pobrania receptur: '+stat
            dane.append(stat)


#-------------------------------------------------------------------------------
#---   WYSYANIE MEILI (6,7,8)
#-------------------------------------------------------------------------------

if stat=='OK' and Funkcja in [6,7,8]:
    Liczba_Wyslanych = 0
    Sel = "SELECT DISTINCT email FROM rs_powiadomienia_pozycje WHERE firma_id='" + self.firma_id + "' "
    Sel += "AND oddzial_id='" + str(oddzial_id) + "' OR oddzial_id='**' AND powiadomienie = 'B0006'"
    stat, lmaile, dump, dump = self.PolSQL.Execute(Sel, 3)
    if stat <> 'OK':
        stat = 'Bd pobrania adresu email z tabeli rs_powiadomienia_pozycje: ' + stat

    elif stat == 'OK' and len(lmaile) > 0:
        Tresc = u'Dla produktu ' + str(artykul_id).strip() + '-' + str(artykul_opis).strip()
        if Funkcja == 6:
            Tresc += u' dodano '
            temat = u'Dodano receptur w oddziale '+str(oddzial_id)
        elif Funkcja == 7:
            Tresc += u' zmodyfikowano '
            temat = u'Zmodyfikowano receptur Z>G w oddziale '+str(oddzial_id)
        elif Funkcja == 8:
            Tresc += u' usunito '
            temat = u'Usunito receptur w oddziale '+str(oddzial_id)

        Tresc += u' receptur obowizujc od dnia ' + str(data_od)
        if data_do not in [None,'None','']:
            Tresc +=u' z dat wanoci ' + str(data_do)

        # gwna wiadomo
        if stat == 'OK':
            for l in range(len(lmaile)):
                Liczba_Wyslanych += 1
                stat = rsglobal.RSWyslijEmail(lmaile[l][0], str(temat), str(Tresc), [], 0, self.PolSQL)

            if stat <> 'OK':
                stat = 'Bd wysyania informacji o koczcej si wanoci receptury dla artykuu:' + stat


#-------------------------------------------------------------------------------
#---   DELETE pozycji (16)
#-------------------------------------------------------------------------------

if stat=='OK' and Funkcja ==16:
    if skladnik=="":
        stat="BR_SKL"
        dane.append(stat)
    if artykul_id=="":
        stat="BR_ART"
        dane.append(stat)

    if oddzial_id=="":
        stat="BR_ODDZ"
        dane.append(stat)
    sql="SELECT rsf_sprawdz_date('"+str(data_od)+"') ;"
    stat,d,dump,dump = self.PolSQL.Execute(sql ,3)

    if stat=="OK":
        if d[0][0]==0:
            stat="BL_DATY"
            dane.append(stat)
        elif d[0][0]==1:
            stat="BL_DATY"
            dane.append(stat)
    else:
         stat="BL_SQL"
         dane.append(stat)
    if stat=="OK":
        if ((self.oddzial_id,'041024') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):

            sql="DELETE FROM rs_receptury_pozycje WHERE firma_id ='"+self.firma_id+"' "
            sql+="AND oddzial_id = '"+oddzial_id+"' AND data_od ='"+data_od+"' "
            sql+="AND artykul_id ='"+artykul_id+"' AND skladnik_id ='"+skladnik+"';"
            stat,Dane,dump,dump = self.PolSQL.Execute(sql,1)
        else:
            wyn2.append(u'Brak uprawnie do usuwania pozycji. Poinformuj administratora.')


#-------------------------------------------------------------------------------
#---   POZYCJE LIST (17)
#-------------------------------------------------------------------------------

if stat=='OK' and Funkcja ==17:
    if not self.operator_id == STANDARD_OPERATOR_ID:
        stat,uprawnienia,w1,w2 = fs_pobierz_upr_oddzialy_pom.PobierzUprawnioneOddzialy(self)
        if stat == 'OK':
            Dozwolony = False
            for oddz,nazwa,upraw in uprawnienia:
                for upr in upraw:
                    if (oddzial_id,'04102') == (oddz,upr[:5]) or ('**','04102') == (oddz,upr[:5]):
                        Dozwolony = True
                        break
                if Dozwolony:
                    break

            if not Dozwolony:
                stat = 'Brak uprawnie do przegldania pozycji receptur. Oddzia '+oddzial_id
                dane.append(stat)

    if stat == 'OK':
        if artykul_id=="":
            stat="BR Art"
            dane.append(stat)

    if stat == 'OK':
        if oddzial_id=="":
            stat="BR Odz"
            dane.append(stat)

    if stat == 'OK':
        if not rsglobal.SprawdzCzyToData(data_od):
            stat="BR data"
            dane.append(stat)

    if stat == 'OK':
        sql ="SELECT rcp.skladnik_id,rcp.ilosc1,art.jm1, rcp.ilosc2, art.jm2,"
        sql+=" rcp.iloscp1, rcp.iloscp2, rcp.iloscp1j2, rcp.iloscp2j2,"
        sql+=" COALESCE(rcp.magazyn_id,''::TEXT) "
        sql+=" FROM rs_receptury_pozycje rcp"
        sql+=" INNER JOIN rs_artykuly art ON (art.artykul_id=rcp.skladnik_id AND art.firma_id=rcp.firma_id)"
        sql+=" WHERE rcp.firma_id='"+self.firma_id+"' AND rcp.oddzial_id='"+oddzial_id+"'"
        sql+=" AND rcp.artykul_id='"+artykul_id+"' AND rcp.data_od='"+data_od+"';"

        stat,dane,wyn1,wyn2=self.PolSQL.Execute(sql,3)