# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_receptury_pozycje_dane.py
# Purpose:     wczytuje/edytuje dane pozycji receptury
# Author:      Jarek Plawgo
# Created:     2005/11/08
# RCS-ID:      $Id: fs_receptury_pozycje_dane.py $
# Copyright:   (c) 2005 Cybertronika
# Licence:     GNU GPL
#-------------------------------------------------------------------------------
# 2011-01-23 Mariusz Rajfura  (4221) nowe pole 'magazyn_id'
# 2017-03-21 Piotr Witkowski (10385) Refaktoryzacja receptury

from funkcje import fs_receptury_dane

stat='OK'

if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=='OK':
    Funkcja = klucze['Funkcja']
    SlPar={'artykul_id':[1,2,3,4,5,6,],'oddzial_id':[1,2,3,4,5,],'data_od':[1,2,3,4,5,],'skladnik_id':[1,2,3,4,5,6],}

    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Funkcja,klucze)
    if Lista<>'':
        stat='Uwaga : wywoanie funkcji fs_receptury_pozycje_dane z numerem ' +str(Funkcja)+' bez parametrw: '+Lista

if stat=='OK':
    if Funkcja in [1,2,3,4,5,6,]:
        artykul_id = klucze['artykul_id']
        skladnik_id = klucze['skladnik_id']
    if Funkcja in [1,2,3,4,5,]:
        oddzial_id = klucze['oddzial_id']
        data_od = klucze['data_od']

if stat=='OK':
    dane = []
    wyn1 = []
    wyn2 = []
    danedod = []
    ilosc1 = None
    ilosc2 = None


if stat=='OK' and Funkcja==6:
    stat,dane = fs_receptury_dane.SprawdzPozycje(self,artykul_id,skladnik_id)

if stat=='OK' and Funkcja<>6:
    UprIns = ((self.oddzial_id,'041023') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)
    UprMod = UprIns or ((self.oddzial_id,'041022') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)

    if Funkcja in (1,2):
        if not UprIns:
            stat = 'BR UPR INS'
            dane.append(stat)

    if Funkcja in (3,4):
        if not UprMod:
            stat = 'BR UPR MOD'
            dane.append(stat)

    if stat == 'OK':
        if artykul_id=="":
            stat="BR_ART"
            dane.append(stat)

    if stat == 'OK':
        if oddzial_id=="":
            stat="BR_ODDZ"
            dane.append(stat)

    if stat == 'OK':
        if skladnik_id=="":
            stat="BR_SKL"
            dane.append(stat)

    if stat == 'OK':
        stat,d = fs_receptury_dane.SprawdzPozycje(self,artykul_id,skladnik_id)
        if stat<>"OK":
            stat="BL_NOTIST"
            dane.append(stat)

        if stat=="OK":
            danedod = d
            sql ="SELECT COUNT(*) FROM rs_receptury_pozycje"
            sql+=" WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+oddzial_id+"'"
            sql+=" AND artykul_id='"+artykul_id+"' AND data_od='"+data_od+"'"
            sql+=" AND skladnik_id='"+skladnik_id+"';"

            stat,data,dump,dump = self.PolSQL.Execute(sql,2)
            if stat <>"OK":
                stat="BR_SQL1"
                dane.append(stat)
            else:
                if Funkcja in [1,2]:
                     if data[0][0]>=1:
                         stat="BL_IST"
                         dane.append(stat)

if stat == 'OK' and Funkcja in (1,2,3,4):
    for i in range(len(pola)):
        pole = pola[i]
        wart = wartosci[i]
        if pole=="ilosc1":
            ilosc1=wart
            if ilosc1==0:
                stat='BR_ILOSC1'
                dane.append(stat)
    
        elif pole=="ilosc2":
            ilosc2=wart  
                
        if pole == 'magazyn_id':
            wart = rsglobal.Dekoduj(wart).strip()
            if wart <> '':
                sql ="SELECT magazyn_id FROM rs_magazyny"
                sql+=" WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+wart+"'"
                if oddzial_id <> '**':
                    sql+=" AND oddzial_id='"+oddzial_id+"'"
                
                sql+=";"

                stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                if stat <> 'OK':
                    stat = 'Bd sprawdzenia magazynu: '+stat
                    dane.append(stat)
                elif len(d) == 0:
                    if oddzial_id == '**':
                        stat = 'BL_MAGAZYN'
                    else:
                        stat = 'BL_MAGAZYN_ODDZIAL'
                    dane.append(stat)

    if stat == 'OK':
        if len(dane) > 0:
            stat =  dane[0]                

    if stat == 'OK':
        if ilosc2 == 0:
            stat='BR_ILOSC1'
            dane.append(stat)
        
    if stat == 'OK':
        stat,d,dump,dump = self.PolSQL.Execute("SELECT rsf_sprawdz_date('%s') ;"%(str(data_od)) ,3)

    if stat =="OK":
        if d[0][0]==0:
            stat="BL_DATY"   
            dane.append(stat)     
        elif d[0][0]==1:  
            stat="BL_DATY"   
            dane.append(stat)     


#-------------------------------------------------------------------------------
# DODAWANIE (1,2)
#-------------------------------------------------------------------------------
     
if stat=="OK" and Funkcja in (1,2):
    insp="(firma_id,oddzial_id,data_od,artykul_id,skladnik_id"
    insw="('"+self.firma_id+"','"+oddzial_id+"','"+data_od+"','"+artykul_id+"','"+skladnik_id+"'"
    
    for i in xrange(len(pola)):
        pole = pola[i]
        wart = wartosci[i]
        if pole == 'ilosc1':
            insp += ","+pole
            insw += ","+str(wart)
        elif pole == 'ilosc2':
            insp += ","+pole
            insw += ","+str(wart)
        if pole == 'magazyn_id':
            insp += ","+pole
            if wart.strip() == '':
                insw += ",NULL"
            else:
                insw += ",'"+str(wart)+"'"
    insp += ")"
    insw += ")"
                
    INS ="INSERT INTO rs_receptury_pozycje "+insp+" VALUES "+insw+";"

    stat,d,dump,dump = self.PolSQL.Execute(INS,1)
    if stat <> 'OK':
        stat = 'Bd dodawania nowej pozycji: '+stat
        dane.append(stat)


#-------------------------------------------------------------------------------
# MODYFIKACJA (1,2)
#-------------------------------------------------------------------------------
    
if stat == 'OK' and Funkcja in (3,4):
    upd="UPDATE rs_receptury_pozycje SET "
    for i in range(len(pola)):
        pole = pola[i]
        wart = wartosci[i]
        
        if pole in ["skladnik_id","data_od","artykul_id","ilosc1","ilosc2"]:
            upd += pole+"='"+str(wart)+"',"
            
        elif pole in ('ilosc1','ilosc2'):
            upd += pole+"="+str(wart)+","
            
        elif pole == 'magazyn_id':
            if wart.strip() == '':
                upd += pole+"=NULL,"
            else:
                upd += pole+"='"+str(wart)+"',"
            
    upd = upd[0:len(upd)-1]
    upd+=" WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+oddzial_id+"'"
    upd+=" AND data_od='"+data_od+"' AND artykul_id='"+artykul_id+"'"
    upd+=" AND skladnik_id='"+skladnik_id+"';"
    
    stat,dump,dump,dump = self.PolSQL.Execute(upd,1)
    if stat <> 'OK':
        stat = 'Bd modyfikacji danych: '+stat
        dane.append(stat)


#-------------------------------------------------------------------------------
# SELECT (5,3,1)
#-------------------------------------------------------------------------------
    
if stat == 'OK' and Funkcja in (5,3,1):
    sql ="SELECT * FROM rs_receptury_pozycje"
    sql+=" WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+oddzial_id+"'"
    sql+=" AND data_od='"+data_od+"' AND artykul_id='"+artykul_id+"'"
    sql+=" AND skladnik_id='"+skladnik_id+"';"
    
    stat,dane,wyn1,dump = self.PolSQL.Execute(sql,3)
    if stat <> 'OK':
        stat = 'Bd pobrania danych pozycji: '+stat
        dane.append(stat)
        
    if stat == 'OK':
        wyn2 = danedod