
# -*- coding: iso8859_2 -*-

#-----------------------------------------------------------------------------
# Name:        fs_repertorium_dane.py
# Purpose:     wczytuje/edytuje dane ze sprawy w repertorium
#
# Author:      Micha Raburski
# Created:     2006/12/28
# RCS-ID:      $Id: fs_repertorium_dane.py $
# Copyright:   (c) 2006 Record System
# Licence:     GNU GPL
#-----------------------------------------------------------------------------

#klucze = [Lp,funkcja]

stat='OK'
Lp=klucze[0]

#-------------------------------------------------------------------------------
#---   UPDATE DANYCH (4- bez pobierania,3- z pobieraniem)
#-------------------------------------------------------------------------------

if klucze[-1] == 4 or klucze[-1]==3:
    if (((self.oddzial_id,'015012') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID):
        stat = "OK"
        dane = []

        #---   Sprawdzenie danych
        for i in range(len(pola)):
            pole = pola[i]
            wart = wartosci[i]
            
            if pole=='dzial_id':
                if wart == '':
                    wartosci[i]='NULL'
                else:
                    dump,d,dump,dump = self.PolSQL.Execute("SELECT kod FROM rs_dzialy_repertorium WHERE firma_id='"+self.firma_id+"' AND kod='"+wart+"';" ,3)
                    if len(d) == 0:
                        stat = "BL DZIAL"
                        dane.append(stat)
                    else:
                        wartosci[i]="'"+wartosci[i]+"'"

        #--- zapis
        if stat == 'OK':
            where = " WHERE firma_id='"+self.firma_id+"' AND lp="+Lp+";"
            upd = "UPDATE rs_repertorium SET "
        
            for i in range(len(pola)):
                pole = pola[i]
                wart = wartosci[i]
            
                if pole in ['dzial_id']:
                    upd=upd+pole+"="+str(wart)+","
                elif pole in ['sprawa','pozwany','powod','sad','przedmiot','czynnosci_pod','czynnosci_sad','uwagi']:
                    upd=upd+pole+"='"+str(wart)+"',"

            upd = upd[0:len(upd)-1]+where
            
            stat,dump,dump,dump = self.PolSQL.Execute(upd ,1)
    else:
        stat='UPR UPD'

   

#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (5 -select, 3 -update z pobraniem, 1 -insert z pobraniem)
#-------------------------------------------------------------------------------

if (klucze[-1] in [5,3,1]) and (stat=='OK'):
    # pobranie danych sprawy
    stat,dane,wyn1,tr = self.PolSQL.Execute("SELECT * FROM rs_repertorium WHERE firma_id='"+self.firma_id+"' AND lp="+Lp+" ORDER BY lp;",3)
    
    # pobranie opisu dziau
    if len(dane) == 1:
        tr = rssql.RSTableRowset(dane,wyn1)

        #--- dzia
        if ((self.oddzial_id,'011290') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
            dump,d,dump,dump = self.PolSQL.Execute("SELECT opis FROM rs_dzialy_repertorium WHERE firma_id='"+self.firma_id+"' AND kod='"+tr.GetVal(0,"dzial_id")+"';" ,3)
            if len(d) == 0:
                wyn2.append('')
            else:
                wyn2.append(d[0][0])
        else:
            wyn2.append('Brak uprawnie do sownika. Poinformuj administratora.')


