# -*- coding: iso8859_2 -*-
# -------------------------------------------------------------------------------
# Name:        fs_zlecenia_transportowe.py
# Purpose:     Obsuga
# Author:      Aleksander Bargie
# Created:     2023/06/21
# RCS-ID:      $Id: fs_rodo_dziennik_asi.py$
# Copyright:   (c) 2022 Record System
# Licence:     GNU GPL
# -------------------------------------------------------------------------------
""" Modyfikacja = 002302"""

stat = 'OK'
firma_id = self.firma_id
oddzial_id = self.oddzial_id
Puste = ('', (), [], 'None', 'NULL', None, '    -  -  ', '-  -')
if 'Funkcja' not in klucze:
    stat = 'Brak podanej funkcji w kluczach'

if stat == 'OK':
    Fun = klucze['Funkcja']

    SlPar = {'CzynnoscF': [5, 6, ], 'KategoriaF': [5, 6, ], 'DataOdF': [5, 6, 7, 8], 'DataDoF': [5, 6, 7, 8],
             'OperatorF': [5, 6, ], 'OpisF':      [5, 6, ], 'NrF':     [5, 6, ],     'wpis_id': [6, ]}
    Lista = rsglobal.SprawdzParametryWKluczach(SlPar, Fun, klucze)
    if Lista != '':
        import os
        stat = 'Uwaga: wywoanie funkcji '+os.path.basename(__file__)+' z numerem '+str(Fun)+' bez parametrw: '+Lista

if stat == 'OK':
    if Fun in [6, ]:
        wpis_id = klucze['wpis_id']
    if Fun in [5, 6, ]:
        CzynnoscF  = klucze['CzynnoscF'].split(' - ')[0]
        KategoriaF = klucze['KategoriaF'].split(' - ')[0]
        DataOdF    = klucze['DataOdF']
        DataDoF    = klucze['DataDoF']
        OperatorF  = klucze['OperatorF']
        OpisF      = klucze['OpisF']
        NrF        = klucze['NrF']

if stat == 'OK':
    UprMod  = ((oddzial_id, '002302') in self.uprawnienia or (self.operator_id == STANDARD_OPERATOR_ID))

dane = []
wyn1 = []
wyn2 = []

# -------------------------------------------------------------------------------
# ---   USUWANIE DANYCH (6)
# -------------------------------------------------------------------------------
# -------------------------------------------------------------------------------

if stat == 'OK' and Fun == 6:
    if not UprMod:
        stat = "Brak uprawnie do modyfikacji zlece"
    else:
        DEL = """DELETE
                 FROM rs_rodo_dziennik_asi
                 WHERE wpis_id=%s;"""
        zmienne = [wpis_id]
        rsglobal.ZapiszDoLogow('SQL DEL rs_rodo_dziennik_asi: ' + self.PolSQL.Mogrify(DEL, zmienne))
        stat, dump, dump, dump = self.PolSQL.Execute(DEL, 1, zmienne, CzyDodawacBlad=True)
        if stat != 'OK':
            stat = 'Bd usuwania wpisu: ' + stat

# -------------------------------------------------------------------------------
# ---   POBRANIE DANYCH (5-odczyt, 6-Usuwanie)
# -------------------------------------------------------------------------------

if stat == 'OK' and Fun in (5, 6):
    SEL = """SELECT wpis_id, kategoria_id||' - '||k.opis, czynnosc_id||' - '||c.opis, da.opis, zmodyfikowano,
                    zmodyfikowal ||' - '||o.imie||' '||o.nazwisko as zmodyfikowal
             FROM rs_rodo_dziennik_asi as da
             JOIN rs_rodo_dziennik_asi_czynnosci c on c.firma_id=da.firma_id AND c.kod=da.czynnosc_id
             JOIN rs_rodo_dziennik_asi_kategorie k on k.firma_id=da.firma_id AND k.kod=da.kategoria_id
             LEFT JOIN rs_operatorzy o on o.operator_id = da.zmodyfikowal
             WHERE da.firma_id=%s """
    zmienne = [firma_id]
    if CzynnoscF not in Puste:
        zmienne.append(CzynnoscF)
        SEL = SEL + " AND czynnosc_id=%s"
    if KategoriaF not in Puste:
        zmienne.append(KategoriaF+'%')
        SEL = SEL + " AND kategoria_id LIKE %s"
    if DataOdF not in Puste:
        zmienne.append(DataOdF)
        SEL = SEL + " AND zmodyfikowano::DATE>=%s"
    if DataDoF not in Puste:
        zmienne.append(DataDoF)
        SEL = SEL + " AND zmodyfikowano::DATE<=%s"
    if OperatorF not in Puste and OperatorF != 0:
        zmienne.append(OperatorF)
        SEL = SEL + " AND zmodyfikowal=%s"
    if NrF not in Puste and NrF != 0:
        zmienne.append(NrF)
        SEL = SEL + " AND wpis_id=%s"
    if OpisF not in Puste:
        zmienne.append('%'+OpisF+'%')
        SEL = SEL + " AND da.opis LIKE %s"
    SEL = SEL + " ORDER BY wpis_id DESC;"
    rsglobal.ZapiszDoLogow('SQL rs_zlecenia_transportowe: '+self.PolSQL.Mogrify(SEL, zmienne))
    stat, dane, wyn1, dump = self.PolSQL.Execute(SEL, 3, zmienne)
    if stat != 'OK':
        stat = 'Bd pobrania listy wpisw '+stat

if dane is None:
    dane = []
