# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_rotacja_opakowan_kompensata.py
# Purpose:     kompensata rotacji opakowa
# Author:      Piotr Witkowski
# Created:     2017/06/01
# RCS-ID:      $Id: fs_rotacja_opakowan_kompensata.py $
# Copyright:   (c) 2017 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------
# 2017-11-08 Rafa Woniak (10811) Dodanie funkcji potrzebnych w oknie odpowiedzialnych za kompensate miedzy kierowcami
# 2018-01-15 Rafa Woniak (0010886) zmiana formatu danych

stat='OK'
Funkcja = ''
Kierowca = ''
Kierowca2 = ''
Przewoznik = ''
Przewoznik2 = ''
if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=='OK':
    Funkcja = klucze['Funkcja']
    SlPar = {'Kierowca': [1, 5, ], "KierA": [2, 3, 6], "KierB": [2, 3, 6], "Oddzial": [2, 3, 6, ]}
    Lista = rsglobal.SprawdzParametryWKluczach(SlPar,Funkcja,klucze)
    if Lista != '':
        stat = 'Uwaga : wywoanie funkcji fs_rotacja_opakowan_kompensata z numerem ' +str(Funkcja)+' bez parametrw: '+Lista

if stat=='OK':
    if Funkcja in [1, 5]:
        Kierowca = klucze['Kierowca']
    if Funkcja in [2, 3, 6]:
        Kierowca = klucze['KierA']
        Kierowca2 = klucze['KierB']
        Oddzial = klucze['Oddzial']

        if Kierowca == Kierowca2 and Kierowca not in ['', 'None', 'Null', None] and Kierowca2 not in ['', 'None', 'Null', None]:
            stat="Kierowca A musi by inny ni Kierowca B"
if stat=='OK':
    dane = []
    wyn1 = []
    wyn2 = []
    puste=['','    -  -  ','Null',None]

    if Funkcja in [1,2]:
        Update = []
        Update = klucze['Update']


#-------------------------------------------------------------------------------
# Pobranie czasu z serwera
#-------------------------------------------------------------------------------

if stat == 'OK' and Funkcja in [1,2]:
    Select ="SELECT CURRENT_TIMESTAMP::TIMESTAMP, (CURRENT_DATE- interval '1 week')::DATE, "
    Select+="CURRENT_DATE,CURRENT_TIME;"
    stat,Dane,dump,dump = self.PolSQL.Execute(Select,3)
    czas=[Dane[0][0],Dane[0][1][0:10],Dane[0][2][0:10],'']


#-------------------------------------------------------------------------------
# Pobranie przewonika
#-------------------------------------------------------------------------------

if stat == 'OK' and Funkcja in [1,2,3]:
    dzien = rsglobal.PodajNrDniaTygodnia(rsglobal.PodajDzis())
    SQL = "SELECT przewoznik_00,"
    SQL+="przewoznik_0"+str(int(dzien))
    SQL+="\nFROM rs_kierowcy k JOIN rs_kierowcy_przewoznicy p ON p.firma_id=k.firma_id and p.kierowca_id=k.kod "
    SQL+="\nWHERE p.firma_id='" + self.firma_id + "' AND data_od=(SELECT max(pp.data_od) FROM rs_kierowcy_przewoznicy pp "
    SQL+="\n\tWHERE p.firma_id=pp.firma_id and p.kierowca_id=pp.kierowca_id and pp.data_od<='"+rsglobal.PodajDzis()+"') "
    SQL+="\nAND kierowca_id ='" + Kierowca + "' AND (przewoznik_00 IS NOT NULL OR przewoznik_0"+str(int(dzien))+" IS NOT NULL);"
    stat,d,dump,dump=self.PolSQL.Execute(SQL,3)
    if stat<>"OK":
        stat=u"Bd pobrania przewonika."
        dane.append(stat)
    elif len(d)==0:
        stat=u'Na dzie dzisiejszy nie jest przypisany przewonik do kierowcy A'
        dane.append(stat)
    else:
        if d[0][1] not in ['','None','Null',None]:
            Przewoznik=d[0][1]
        elif d[0][0] not in ['','None','Null',None]:
            Przewoznik=d[0][0]
        else:
            stat=u'Na dzie dzisiejszy nie jest przypisany przewonik do kierowcy A'
    #RW sprawdzanie przewonika u drugiego kierowcy i sprawdzenie czy s tacy sami
    if Funkcja in [2, 3] and stat == "OK":
        if Kierowca2 not in [None,"Null",""]:
            SQL = "SELECT przewoznik_00,"
            SQL += "przewoznik_0" + str(int(dzien))
            SQL += "\nFROM rs_kierowcy k JOIN rs_kierowcy_przewoznicy p ON p.firma_id=k.firma_id and p.kierowca_id=k.kod "
            SQL += "\nWHERE p.firma_id='" + self.firma_id + "' AND data_od=(SELECT max(pp.data_od) FROM rs_kierowcy_przewoznicy pp "
            SQL += "\n\tWHERE p.firma_id=pp.firma_id and p.kierowca_id=pp.kierowca_id and pp.data_od<='" + rsglobal.PodajDzis() + "') "
            SQL += "\nAND kierowca_id ='" + Kierowca2 + "' AND (przewoznik_00 IS NOT NULL OR przewoznik_0" + str(
                int(dzien)) + " IS NOT NULL);"
            stat, d, dump, dump = self.PolSQL.Execute(SQL, 3)
            if stat <> "OK":
                stat = u"Bd pobrania przewonika kierowcy B."
                dane.append(stat)
            elif len(d) == 0:
                stat = u'Na dzie dzisiejszy nie jest przypisany przewonik do kierowcy B'
                dane.append(stat)
            else:
                if d[0][1] not in ['', 'None', 'Null', None]:
                    Przewoznik2 = d[0][1]
                elif d[0][0] not in ['', 'None', 'Null', None]:
                    Przewoznik2 = d[0][0]
                else:
                    stat = u'Na dzie dzisiejszy nie jest przypisany przewonik do kierowcy B'
            if Funkcja == 3:
                if Przewoznik != Przewoznik2:
                    stat = u"KAB_IP"

#-------------------------------------------------------------------------------
# DODAWANIE (1,2)
#-------------------------------------------------------------------------------

if stat=="OK" and Funkcja ==1 and len(Update[0])>0:
    dane=[]
    czas_zapisu=Dane[0][0]

    ## Gwne ciao funkcji
    WierszeNr = Update[-1]
    for i in xrange(len(Update[0])):
        insp1="(firma_id,kierowca_id,czas_zapisu,reczne,przewoznik_id,operator_id "
        #RW
        insw1="('"+self.firma_id+"','"+Kierowca+"','"+czas_zapisu+"','True','"+Przewoznik+"','"+str(self.operator_id)+"' "

        insp2=insp1
        insw2=insw1

        for j in xrange(len(Update[2][i])):
            pole=Update[3][j]
            wart=rsglobal.Dekoduj(Update[2][i][j])
            if pole =='opakowanie_id':
                opakowanie=wart.strip()
            elif pole=='oddzial_1':
                Oddzial1=wart.strip()
            elif pole=='stan_1':
                stan_1=wart
            elif pole=='oddzial_2':
                Oddzial2=wart.strip()
            elif pole=='stan_2':
                stan_2=wart

        for j in xrange(len(Update[0][i])):
            pole = Update[0][i][j]
            wart = Update[1][i][j]

            if pole =='kompensata':
                if int(wart)<0:
                    wyn2.append((WierszeNr[i],6))
                    dane.append(u"Warto kompensaty nie mog by ujemne")
                elif int(wart)>9999:
                    wyn2.append((WierszeNr[i],6))
                    dane.append(u"Warto kompensaty przekracza 4 znaki")
                else:
                    insp1+=",oddzial_id,opakowanie_id,stan_pocz,wydania,przyjecia,stan_konc,dm_numer) "
                    insw1+=",'"+str(Oddzial1)+"','"+opakowanie+"',"+str(stan_1)+","+str(wart)+",0,"+str(stan_1+wart)+",-1)"

                    insp2+=",oddzial_id,opakowanie_id,stan_pocz,wydania,przyjecia,stan_konc,dm_numer) "
                    insw2+=",'"+str(Oddzial2)+"','"+opakowanie+"',"+str(stan_2)+",0,"+str(wart)+","+str(stan_2-wart)+",-1)"

        if stat == 'OK':
            if len(dane) > 0:
                stat = dane[0]

        # wykonanie
        if stat=='OK':
            INS= "INSERT INTO rs_opakowania_rotacja "+insp1+" VALUES "+insw1+";\n"
            INS+="INSERT INTO rs_opakowania_rotacja "+insp2+" VALUES "+insw2+";"
            stat,d,dump,dump = self.PolSQL.Execute(INS,1)
            if stat <> 'OK':
                stat = 'Bd dodawania nowej pozycji: '+stat
                dane.append(stat)

# -------------------------------------------------------------------------------
# SELECT (2) wymiana opakowa miedzy kierowcami
# -------------------------------------------------------------------------------
#RW funkcja dodajca opwakowiedzialna za dodanie i usuniecie opakowan przy kompensacie miedzy kierowcami
if stat=="OK" and Funkcja ==2 and len(Update[0])>0:
    dane=[]
    czas_zapisu=Dane[0][0]

    ## Gwne ciao funkcji
    #RW
    WierszeNr = Update[-1]
    for i in xrange(len(Update[0])):
        insp1="(firma_id,czas_zapisu,reczne,operator_id "
        insw1="('"+self.firma_id+"','"+str(czas_zapisu)+"','True','"+str(self.operator_id)+"' "

        insp2=insp1
        insw2=insw1

        for j in xrange(len(Update[2][i])):
            pole=Update[3][j]
            wart=rsglobal.Dekoduj(Update[2][i][j])
            if pole =='opakowanie_id':
                opakowanie=wart.strip()
            elif pole=='stan_1':
                stan_1=wart
            elif pole=='stan_2':
                stan_2=wart

        if len(Update[0][i]) > 1:
            stat = (u"Dla kadego opakowania w co najmniej jednej z kolumn 'Do kierowcy' naley pozostawi 0")

        if stat == 'OK':
            if len(dane) > 0:
                stat = dane[0]

        if stat == 'OK':
            for j in xrange(len(Update[0][i])):
                pole = Update[0][i][j]
                wart = Update[1][i][j]
                if pole == 'kierowca_1':
                    stan_2_po = stan_2 + wart
                    stan_1_po = stan_1 - wart
                if pole == 'kierowca_2':
                    stan_1_po = stan_1 + wart
                    stan_2_po = stan_2 - wart

                if int(wart)<0:
                    wyn2.append((WierszeNr[i],6))
                    dane.append(u"Warto kompensaty nie mog by ujemne")
                elif int(wart)>9999:
                    wyn2.append((WierszeNr[i],6))
                    dane.append(u"Warto kompensaty przekracza 4 znaki")
                else:
                    insp1 += ",kierowca_id,oddzial_id,opakowanie_id,stan_pocz,wydania,przyjecia,stan_konc,przewoznik_id,dm_numer) "
                    insw1 += ",'" + Kierowca + "','" + Oddzial + "','" + opakowanie + "'," + str(stan_1)
                    if pole == 'kierowca_1':
                        if wart < 0:
                            insw1 += "," + str(wart) + ",0," + str(stan_1_po) + " , '" + str(Przewoznik) + "',-2)"
                        elif wart > 0:
                            insw1 += ",0," + str(wart) + "," + str(stan_1_po) + " , '" + str(Przewoznik) + "',-2)"
                    elif pole == 'kierowca_2':
                        if wart < 0:
                            insw1 += ",0," + str(wart) + "," + str(stan_1_po) + " , '" + str(Przewoznik) + "',-2)"
                        elif wart > 0:
                            insw1 += "," + str(wart) + ",0," + str(stan_1_po) + " , '" + str(Przewoznik) + "',-2)"

                    insp2 += ",kierowca_id,oddzial_id,opakowanie_id,stan_pocz,wydania,przyjecia,stan_konc,przewoznik_id,dm_numer) "
                    insw2 += ",'" + Kierowca2 + "','" + Oddzial + "','" + opakowanie + "'," + str(stan_2)
                    if pole == 'kierowca_1':
                        if wart < 0:
                            insw2 += ",0," + str(wart) + "," + str(stan_2_po) + " , '" + str(Przewoznik2) + "',-2)"
                        elif wart > 0:
                            insw2 += "," + str(wart) + ",0," + str(stan_2_po) + " , '" + str(Przewoznik2) + "',-2)"
                    elif pole == 'kierowca_2':
                        if wart < 0:
                            insw2 += "," + str(wart) + ",0," + str(stan_2_po) + " , '" + str(Przewoznik2) + "',-2)"
                        elif wart > 0:
                            insw2 += ",0," + str(wart) + "," + str(stan_2_po) + " , '" + str(Przewoznik2) + "',-2)"
            if stat == 'OK':
                if len(dane) > 0:
                    stat = dane[0]

            # wykonanie
            if stat=='OK':
                INS= "INSERT INTO rs_opakowania_rotacja "+insp1+" VALUES "+insw1+";\n"
                INS+="INSERT INTO rs_opakowania_rotacja "+insp2+" VALUES "+insw2+";"
                stat,d,dump,dump = self.PolSQL.Execute(INS,1)

                if stat <> 'OK':
                    stat = 'Bd dodawania nowej pozycji: '+stat
                    dane.append(stat)

#-------------------------------------------------------------------------------
# SELECT (6,5,3,2,1)
#-------------------------------------------------------------------------------
    
if stat == 'OK' and Funkcja in [1, 5]:

    SQL="""
SELECT r1.opakowanie_id, a.nazwa,r1.oddzial_id, r1.stan_konc,r2.oddzial_id,r2.stan_konc,0
--CASE WHEN abs(r1.stan_konc)<abs(r2.stan_konc) THEN abs(r1.stan_konc) ELSE abs(r2.stan_konc) END 
FROM (SELECT DISTINCT firma_id,oddzial_id,kierowca_id,opakowanie_id,stan_konc
	FROM rs_opakowania_rotacja r
	WHERE czas_zapisu = (Select MAX(rr.czas_zapisu) FROM rs_opakowania_rotacja rr
				WHERE r.firma_id=rr.firma_id AND r.oddzial_id=rr.oddzial_id
				AND r.kierowca_id=rr.kierowca_id AND r.opakowanie_id=rr.opakowanie_id)		
	AND stan_konc<0
) as r1

LEFT OUTER JOIN 
(SELECT DISTINCT firma_id,oddzial_id,kierowca_id,opakowanie_id,stan_konc
	FROM rs_opakowania_rotacja r
	WHERE czas_zapisu = (Select MAX(rr.czas_zapisu) FROM rs_opakowania_rotacja rr
			WHERE r.firma_id=rr.firma_id AND r.oddzial_id=rr.oddzial_id
			AND r.kierowca_id=rr.kierowca_id AND r.opakowanie_id=rr.opakowanie_id)		
	AND stan_konc>0
) as r2
ON r1.firma_id=r2.firma_id AND r1.kierowca_id=r2.kierowca_id AND r1.opakowanie_id =r2.opakowanie_id
JOIN rs_artykuly a 
ON r1.firma_id=a.firma_id AND r1.opakowanie_id =a.artykul_id    
WHERE r1.firma_id = '"""+self.firma_id+"""' AND r1.kierowca_id='"""+Kierowca+"""'
ORDER BY r1.opakowanie_id, r1.stan_konc, r2.stan_konc DESC
    """
    stat,d,wyn1,dump = self.PolSQL.Execute(SQL,3)
    if stat <> 'OK':
        stat = 'Bd pobrania danych pozycji: '+stat
        dane.append(stat)
    elif len(d)>0:
        opakowanie=[]
        for x in d:
            if x[1] not in opakowanie:
                opakowanie.append(x[1])
                dane.append(x)
            #else:
            #    for z,y in enumerate(dane):
            #        if y[3] <x[3] or y[5]>x[5]:
            #            dane[z]=y

#-------------------------------------------------------------------------------
# SELECT (2, 6)
#-------------------------------------------------------------------------------
#RW  wyszukiwanie opakowan kierowcw

if stat == "OK" and Funkcja in [2, 6]:
    SQL = """
           select * from (SELECT a.artykul_id, a.nazwa, 
           coalesce(r1.stan_konc,0),0, coalesce(r2.stan_konc,0),0
    FROM (select firma_id, artykul_id, nazwa from rs_artykuly where rotacja AND firma_id='"""+self.firma_id+"""') as a
	    FULL OUTER JOIN (SELECT DISTINCT firma_id,oddzial_id,kierowca_id,opakowanie_id, stan_konc
				from rs_opakowania_rotacja r
				WHERE czas_zapisu = (Select MAX(rr.czas_zapisu) FROM rs_opakowania_rotacja rr
							WHERE r.firma_id=rr.firma_id AND r.oddzial_id=rr.oddzial_id
							AND r.kierowca_id=rr.kierowca_id AND r.opakowanie_id=rr.opakowanie_id)	
				  and r.firma_id='"""+self.firma_id+"""' and r.oddzial_id = '"""+Oddzial+"""' and r.kierowca_id ='"""+Kierowca+"""'
				order by opakowanie_id) as r1
	ON a.firma_id = r1.firma_id and a.artykul_id = r1.opakowanie_id
	left OUTER JOIN (SELECT DISTINCT firma_id,oddzial_id,kierowca_id,opakowanie_id, stan_konc
				from rs_opakowania_rotacja r
				WHERE czas_zapisu = (Select MAX(rr.czas_zapisu) FROM rs_opakowania_rotacja rr
							WHERE r.firma_id=rr.firma_id AND r.oddzial_id=rr.oddzial_id
							AND r.kierowca_id=rr.kierowca_id AND r.opakowanie_id=rr.opakowanie_id)	
					and r.firma_id='"""+self.firma_id+"""' and r.oddzial_id = '"""+Oddzial+"""' and r.kierowca_id ='"""+Kierowca2+"""'
				order by opakowanie_id) as r2
	ON a.firma_id = r2.firma_id and a.artykul_id = r2.opakowanie_id
    order by r1.stan_konc, r2.stan_konc) as a
    where a.artykul_id is not null;
            """
    stat, d, wyn1, dump = self.PolSQL.Execute(SQL, 3)
    if stat != 'OK':
        stat = 'Bd pobrania danych pozycji: ' + stat
        dane.append(stat)
    elif len(d) > 0:
        opakowanie = []
        for x in d:
            if x[1] not in opakowanie:
                opakowanie.append(x[1])
                dane.append(x)