
# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_rozliczenia_miedzyokresowe.py
# Purpose:     
#
# Author:      Pawel Wojcikowski, Marcin Wlodarczyk
# Modyfikacja: Jan Raburski
# Created:     2008/08/11
# RCS-ID:      $Id: fs_repertorium.py $
# Copyright:   (c) 2008 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------
# Jan Kaliszewski,  2010-01-18: sprawdzanie w INSERT, czy podana grupa istnieje
# Marcin Natkaski, 2010-11-28: anulowanie rozliczenia (mantis: 4105)
# 2013-01-10 Mariusz Rajfura (6135) mozliwosc tworzenia korekty (kwoty ujemne)


Numer = klucze[0]
GrupaF = rsglobal.Dekoduj(klucze[1][0]).strip()
CzyAktywneF = klucze[1][1] 
Fun = klucze[-1]

stat = "OK"
dane = []
wyn2 = 0
 
UprDodawanie = ((self.oddzial_id,'173013') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)
UprUsuwanie = ((self.oddzial_id,'173014') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)

#-------------------------------------------------------------------------------
#---   ANULOWANIE ROZLICZENIA (10)
#-------------------------------------------------------------------------------

if Fun == 10:
    if not UprUsuwanie:
        stat='UPR AN'
    if stat == 'OK':
        UPD=" UPDATE rs_rozliczenia_miedzyokresowe SET kwota_akt=0 WHERE firma_id='"+self.firma_id+"' and numer="+Numer+";"
        stat,dump,dump,dump = self.PolSQL.Execute(UPD,1)        
        if stat<>'OK':
            stat="Bdy zapytania anulujcego rozliczenie : "+stat
            dane.append(stat)
            

#-------------------------------------------------------------------------------
#---   INSERT DANYCH (1)
#-------------------------------------------------------------------------------

if Fun == 1:
    if not UprDodawanie:
        stat='UPR INS'
        
    if stat == 'OK':
        if GrupaF == '':
            GrupaIns = 'NULL'
        else:
            # sprawdzamy, czy podana grupa istnieje, jeeli nie, to uyjemy pustej
            stat, Jest, dump, dump = self.PolSQL.Execute(
                    "SELECT kod FROM rs_grupy_rozliczen"
                    " WHERE firma_id='" + self.firma_id + "'"
                    " AND kod='" + GrupaF + "'",
                    2
            )
            if stat == 'OK':
                if Jest:
                    GrupaIns = "'" + GrupaF + "'"
                else:
                    stat = 'BL INS'
            else:
                stat = ('Bd przy sprawdzaniu grupy : %s. Poinformuj serwis.'
                        % stat)

        if stat == 'OK':
            INSERT ="INSERT INTO rs_rozliczenia_miedzyokresowe"
            INSERT+=" (firma_id,grupa) VALUES ('"+self.firma_id+"',"+GrupaIns+");"
            stat,dump,dump,dump = self.PolSQL.Execute(INSERT,1)
            if stat<>'OK':
                stat='Bd wstawiania danych : '+stat+'. Poinformuj serwis.'
            else:
                #pobranie numeru dodanego rozliczenia
                sql ="SELECT MAX(numer) FROM rs_rozliczenia_miedzyokresowe WHERE firma_id='"+self.firma_id+"';"
                stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                if stat <> 'OK':
                    stat = 'Bd pobrania numeru ostatniego rozliczenia : '+stat
                else:
                    wyn2 = d[0][0]
        
#-------------------------------------------------------------------------------
#---   DELETE DANYCH (6)
#-------------------------------------------------------------------------------

if Fun == 6:
    if not UprUsuwanie:
        stat='UPR DEL'
        
    if stat == 'OK':
        #sprawdzenie czy rozliczenie jest i przyblokowanie przed DELETE
        sql ="SELECT odpis_data FROM rs_rozliczenia_miedzyokresowe "
        sql+=" WHERE firma_id='"+self.firma_id+"' AND numer="+str(Numer)+" FOR UPDATE NOWAIT;"
        stat,d,dump,dump = self.PolSQL.Execute(sql,3)        
        if stat<>'OK':
            stat = 'Bd sprawdzenie podanego rozliczenia : '+stat
        elif len(d) <> 1:
            stat = 'Brak rozliczenia o podanym numerze lub rozliczenie jest niedostpne do usunicia : '+stat
        
    if stat == 'OK':
        #sprawdzenie czy mozna usunac: data_odpisu musi byc pusta
        if d[0][0] <> 'None':
            stat='BL DEL'
        else:
            DELETE ="DELETE FROM rs_rozliczenia_miedzyokresowe"
            DELETE+=" WHERE firma_id='"+self.firma_id+"' AND numer="+str(Numer)+";"
            stat,dump,dump,dump = self.PolSQL.Execute(DELETE,1)
            if stat <> 'OK':
                stat = 'Bd usuwania rozliczenia : '+stat
            
#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (1- insert 5 -select, 6 -delete)
#-------------------------------------------------------------------------------

if Fun in (1,5,6,10) and stat=='OK':
    Filtr="firma_id='"+self.firma_id+"'"
    
    if GrupaF <> '':
        Filtr = Filtr+" AND grupa='"+str(GrupaF)+"'"
    
    if CzyAktywneF:
        Filtr+=" AND ( ABS(kwota_akt)>0 OR odpis_data IS NULL)"    
    
    SELECT ="SELECT numer,grupa,opis,data_wprow,kwota_pocz,odpis_data,kwota_akt,liczba_miesiecy,"
    SELECT+=" odpis_kwota,odpis_ostatni,projekt_id,konto"
    SELECT+=" FROM rs_rozliczenia_miedzyokresowe WHERE "+Filtr+" ORDER BY numer;"
    stat,dane,wyn1,tr = self.PolSQL.Execute(SELECT,3)
