#!/usr/bin/python
# -*- coding: iso8859_2 -*-
#-----------------------------------------------------------------------------
# Name:        fs_rozliczenie_produkcji_pozycje.py
# Purpose:     pobiera dane dotyczce konkretnego rozliczenia
# Author:      Micha Raburski
# Created:     2006/04/19
# RCS-ID:      $Id: fs_rozliczenie_produkcji_pozycje.py $
# Copyright:   (c) 2005 Record System
# Licence:     GNU GPL
#-----------------------------------------------------------------------------
# 2017-03-20 Piotr Witkowski (10384) Refaktoryzacja rozlicze produkcji
stat='OK'

if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=='OK':
    Funkcja = klucze['Funkcja']
    SlPar={'Oddz':[1],'Od':[1],'Do':[1],'ArtK':[1],'Zlec':[1],
           'Art':[1], 'Wyr':[1], 'Elem':[1], 'Opak':[1], 'Sur':[1], 'Dwiejm':[1], }

    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Funkcja,klucze)
    if Lista<>'':
        stat='Uwaga : wywoanie funkcji fs_rozliczenie_produkcji_pozycje z numerem ' +str(Funkcja)+' bez parametrw: '+Lista

if stat=='OK':
    if Funkcja in [1]:
        Oddz = klucze['Oddz']
        Od = klucze['Od']
        Do = klucze['Do']
        ArtK = klucze['ArtK']
        Zlec = klucze['Zlec']
        Art = klucze['Art']
        Wyr = klucze['Wyr']
        Elem = klucze['Elem']
        Opak = klucze['Opak']
        Sur = klucze['Sur']
        Dwiejm = klucze['Dwiejm']

if stat=='OK':
    dane = []
    wyn1 = []
    wyn2 = []
    tabela=''

if stat =='OK' and ((self.oddzial_id,'043006') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
    #---   Pobranie danych
    if Wyr:
        #wyroby
        tabela='rs_rozliczenia_produkcji_wyroby'
        if Dwiejm:
            pola="rp.nr_zlecenia,rp.artykul_id||' - '||art.nazwa,rp.ilosc1,art.jm1,rp.ilosc2,art.jm2,rp.wartosc,rp.wartosc_kalk"
        else:
            pola="rp.nr_zlecenia,rp.artykul_id||' - '||art.nazwa,rp.ilosc1,art.jm1,rp.wartosc,rp.wartosc_kalk"
    else:
        #pozostae
        if Dwiejm:
            pola="rp.nr_zlecenia,rp.artykul_id||' - '||art.nazwa,rp.ilosc1,art.jm1,rp.ilosc2,"
            pola+="art.jm2,rp.wartosc,rp.ilosc_kalk1,rp.ilosc_kalk2,rp.wartosc_kalk"
        else:
            pola="rp.nr_zlecenia,rp.artykul_id||' - '||art.nazwa,rp.ilosc1,art.jm1,rp.wartosc,rp.ilosc_kalk1,rp.wartosc_kalk"
            
        if Elem:
            tabela='rs_rozliczenia_produkcji_elementy'
        elif Opak:
            tabela='rs_rozliczenia_produkcji_opakowania'
        elif Sur:
            tabela='rs_rozliczenia_produkcji_surowce'
        else:
            stat='Nie podany typ danych do pobrania'
            
    if Zlec <> '':
        if Art <> '':
            Filtr="WHERE rp.nr_zlecenia ='"+Zlec+"' AND rp.artykul_id LIKE '"+Art+"%' AND"
        else:
            Filtr="WHERE rp.nr_zlecenia ='"+Zlec+"' AND"
    elif Art <> '':
        Filtr="WHERE rp.artykul_id LIKE '"+Art+"%' AND"
    else:
        Filtr="WHERE "

    
    if tabela <> '':
        SQL="SELECT "+pola+" FROM "+tabela
        SQL+=" as rp INNER JOIN rs_artykuly art ON rp.firma_id=art.firma_id AND rp.artykul_id=art.artykul_id "+Filtr
        SQL+=" rp.firma_id='"+self.firma_id+"' AND rp.oddzial_id='"+Oddz+"' AND rp.data_od='"+Od+"' "
        SQL+="AND data_do = '"+Do+"' AND artykul_id_k='"+ArtK+"' ORDER BY rp.nr_zlecenia,rp.artykul_id;"
        stat,d,dump,dump = self.PolSQL.Execute(SQL ,3)
    if stat=="OK":
        dane=d
        
else:
    stat='Brak uprawnie do przegldania pozycji rozliczenia produkcji.'