#!/usr/bin/python
# -*- coding: iso8859_2 -*-
#-----------------------------------------------------------------------------
# Name:             fs_serwis_autoryzacja.py
# Purpose:          dodawanie, usuwanie, pozycji serwisie autoryzacji
# Author:           Dariusz Boduch
# Created:          2008/08/13
# RCS-ID:           $Id: fs_serwis_autoryzacja.py $
# Copyright:        (c) 2007 RecordSystem
# Licence:          GNU GPL
#-----------------------------------------------------------------------------

Kontrahent=rsglobal.Dekoduj(klucze[0])
Artykul=rsglobal.Dekoduj(klucze[1])
KontrahentU=rsglobal.Dekoduj(klucze[2])
ArtykulU=rsglobal.Dekoduj(klucze[3])

Fun=klucze[-1]
stat = "OK"
dane = []

puste_pola = ['    -  -  ','',[]]



if self.operator_id == STANDARD_OPERATOR_ID:
    UprPrz=True
    UprDel=True
    UprIns=True
    
else:
    UprPrz=(self.oddzial_id,'029311') in self.uprawnienia
    UprDel=(self.oddzial_id,'029314') in self.uprawnienia
    UprIns=(self.oddzial_id,'029313') in self.uprawnienia
    
#sprawdzanie poprawnosci danych

if Kontrahent.strip() not in puste_pola:
    SELECT="SELECT * FROM rs_kontrahenci WHERE firma_id='"+self.firma_id+"' AND kontrahent_id LIKE '"+Kontrahent+"%'; "
    stat,dane,dump,dump=self.PolSQL.Execute(SELECT,3)
    if stat=='OK':
        if len(dane)==0:
            stat='BL KONTR'

if stat=='OK' and Fun in [6] and KontrahentU.strip() not in puste_pola:
    SELECT="SELECT * FROM rs_kontrahenci WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+KontrahentU+"'; "
    stat,dane,dump,dump=self.PolSQL.Execute(SELECT,3)
    if stat=='OK':
        if len(dane)==0:
            stat='BL KONTRD'    

if stat=='OK' and Fun in [4] and KontrahentU.strip() not in puste_pola:
    SELECT="SELECT * FROM rs_kontrahenci WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+KontrahentU+"'; "
    stat,dane,dump,dump=self.PolSQL.Execute(SELECT,3)
    if stat=='OK':
        if len(dane)==0:
            stat='BL KONTRI'    

if stat=='OK' and Artykul.strip() not in puste_pola:
    SELECT="SELECT * FROM rs_artykuly WHERE firma_id='"+self.firma_id+"' AND artykul_id LIKE '"+Artykul+"%'; "
    stat,dane,dump,dump=self.PolSQL.Execute(SELECT,3)
    if stat=='OK':
        if len(dane)==0:
            stat='BL ART'            

if stat=='OK' and Fun in [6] and Artykul.strip() not in puste_pola:
    SELECT="SELECT * FROM rs_artykuly WHERE firma_id='"+self.firma_id+"' AND artykul_id = '"+ArtykulU+"'; "
    stat,dane,dump,dump=self.PolSQL.Execute(SELECT,3)
    if stat=='OK':
        if len(dane)==0:
            stat='BL ARTD'            

if stat=='OK' and Fun in [4] and Artykul.strip() not in puste_pola:
    SELECT="SELECT * FROM rs_artykuly WHERE firma_id='"+self.firma_id+"' AND artykul_id = '"+ArtykulU+"%'; "
    stat,dane,dump,dump=self.PolSQL.Execute(SELECT,3)
    if stat=='OK':
        if len(dane)==0:
            stat='BL ARTI'                        

# -- Usuwanie 6 -- #

if stat=='OK' and Fun in [6]:    
    if UprDel:
        sql="DELETE FROM rs_serwis_autoryzacja WHERE firma_id='"+self.firma_id+"' AND artykul_id = '"+ArtykulU+"' AND kontrahent_id='"+KontrahentU+"' "
        stat,dump,dump,dump=self.PolSQL.Execute(sql,1)
        if stat<>'OK':
            stat='BL SQL DEL'
            dane.append(stat)
    else:
        stat="UPR DEL"   
        dane.append(stat)
#insert danych
if stat=='OK' and Fun in [4]:
    if UprIns:
        select="SELECT * FROM rs_serwis_autoryzacja WHERE firma_id='"+self.firma_id+"' "
        select+="AND kontrahent_id='"+KontrahentU+"' AND artykul_id='"+ArtykulU+"';"
        stat,dane,dump,dump=self.PolSQL.Execute(select,3)
        if stat=='OK':
            if len(dane)>0:
                stat='UZ PARA'
                dane.append(stat)
        
        if stat=='OK':
            sql=" INSERT INTO rs_serwis_autoryzacja ( firma_id, kontrahent_id, artykul_id) "
            sql+=" VALUES ('"+self.firma_id+"','"+KontrahentU+"', '"+ArtykulU+"') "
            stat,dump,dump,dump = self.PolSQL.Execute(sql ,1)
            if stat<>'OK':
                stat='BL INS'
                dane.append(stat)
    else:
        stat='UPR INS'
        dane.append(stat)
        
# pobranie danych
if stat=='OK' and Fun in [4,5,6] :
    if UprPrz or UprIns:
        Filtr = " sa.firma_id = '" + self.firma_id+"'"
        if Artykul.strip() not in puste_pola:
            Filtr+=" AND sa.artykul_id LIKE '"+Artykul+"%'"
        if Kontrahent.strip() not in puste_pola:
            Filtr+=" AND sa.kontrahent_id LIKE '"+Kontrahent+"%'"
                    
        SELECT="SELECT sa.kontrahent_id, k.nazwa, sa.artykul_id, a.nazwa  "
        FROM=" FROM rs_serwis_autoryzacja sa" 
        FROM +=" LEFT OUTER JOIN rs_kontrahenci k ON(sa.firma_id=k.firma_id AND sa.kontrahent_id=k.kontrahent_id) "
        FROM+="LEFT OUTER JOIN rs_artykuly a ON(sa.firma_id=a.firma_id AND sa.artykul_id=a.artykul_id) "
        WHERE=" WHERE "+Filtr
        ORDER=" ORDER BY sa.kontrahent_id, sa.artykul_id;"	
        
        sql=SELECT+FROM+WHERE+ORDER
        stat,dane,dump,dump=self.PolSQL.Execute(rsglobal.Dekoduj(sql),3)
        if stat!="OK":
            stat="BL SQL PRZ$"+stat
            dane.append(stat)
    else:
        stat='UPR PRZ'