
# -*- coding: iso8859_2 -*-

#-----------------------------------------------------------------------------
# Name:        fs_kartoteka_napraw.py
# Purpose:     wyswietla, dodaje,usuwa naprawy operujac na tabeli rs_serwis_naprawy
#
# Author:      Pawel Wojcikowski, Marcin Wlodarczyk
# Created:     2008/08/11
# RCS-ID:      $Id: fs_kartoteka_napraw.py$
# Copyright:   (c) 2008 Record System
# Licence:     GNU GPL
#-----------------------------------------------------------------------------




Model=klucze[0]
NrSerii=klucze[1]
Kontrahent = klucze[2]
DataNaprawyOd = klucze[3]
DataNaprawyDo = klucze[4]
DataZgloszeniaOd = klucze[5]
DataZgloszeniaDo = klucze[6]
CzyNaprawione = klucze[7] 
Wykonawca = klucze[8]
RodzajNaprawy = klucze[9]

Fun = klucze[-1]


stat = "OK"
dane = []
 
 

for data in [DataNaprawyOd, DataNaprawyDo, DataZgloszeniaOd, DataZgloszeniaDo]:
    if (not rsglobal.SprawdzCzyToData(data)) and data != '    -  -  ':
        stat = 'BL DATA'
        
#---   POBRANIE DANYCH (1- insert 5 -select, 6 -delete)
if (Fun in [5]) and (stat=='OK') :
        # pobranie danych 
    if ((self.oddzial_id,'029410') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
        Filtr="WHERE sz.firma_id='"+self.firma_id+"' AND sn.firma_id='"+self.firma_id+"' " 
        if Model <> '':
            Filtr = Filtr+" AND sz.artykul_id LIKE '"+str(Model)+"%'"
        if NrSerii <> '':
            Filtr = Filtr+" AND sz.nr_serii LIKE '"+str(NrSerii)+"%'"
        if Kontrahent <> '':
            Filtr = Filtr+" AND sz.kontrahent_id LIKE '"+str(Kontrahent)+"%'"
        if DataNaprawyOd <> '    -  -  ':
            Filtr = Filtr+" AND sn.data_naprawy > '"+str(DataNaprawyOd)+"'"
        if DataNaprawyDo <> '    -  -  ':
            Filtr = Filtr+" AND sn.data_naprawy < '"+str(DataNaprawyDo)+"'"
        if DataZgloszeniaOd <> '    -  -  ':
            Filtr = Filtr+" AND sz.zgloszenie_data > '"+str(DataZgloszeniaOd)+"'"
        if DataZgloszeniaDo <> '    -  -  ':
            Filtr = Filtr+" AND sz.zgloszenie_data < '"+str(DataZgloszeniaDo)+"'"
        if Wykonawca <> '':
            Filtr = Filtr+" AND sn.wykonawca_id LIKE '"+str(Wykonawca)+"%'"
        if RodzajNaprawy <> '':
            Filtr = Filtr+" AND sn.rodzaj_naprawy = '"+str(RodzajNaprawy)+"'"
        if CzyNaprawione:
            Filtr = Filtr + "AND NOT (sn.data_naprawy IS NULL)"    
        Select="SELECT art.artykul_id,art.nazwa,sz.nr_serii,sz.kontrahent_id,k.nazwa,sn.wykonawca_id,sn.data_naprawy,sz.zgloszenie_data,sn.rodzaj_naprawy FROM rs_serwis_naprawy sn INNER JOIN rs_serwis_zgloszenia sz ON (sn.zgloszenie_id=sz.zgloszenie_id AND sn.firma_id = sz.firma_id)"  
        Select+=" INNER JOIN rs_artykuly art ON (art.artykul_id = sz.artykul_id AND art.firma_id=sz.firma_id) INNER JOIN rs_kontrahenci k ON (k.kontrahent_id=sz.kontrahent_id AND k.firma_id = sz.firma_id) "+ Filtr+" ORDER BY sn.data_naprawy,sz.zgloszenie_data;"
        stat,dane,wyn1,tr = self.PolSQL.Execute(Select,3)
    else :
        stat ='UPR PRZ'

