
# -*- coding: iso8859_2 -*-

#-----------------------------------------------------------------------------
# Name:        fs_serwis_urzadzenia_dane.py
# Purpose:     wczytuje/edytuje dane urzadzenia 
#
# Author:      Dariusz Boduch
# Created:     2008/07/28
# RCS-ID:      $Id: fs_serwis_urzadzenia_dane.py $
# Copyright:   (c) 2005 Record System
# Licence:     GNU GPL
#-----------------------------------------------------------------------------

#--- klucze to [Artykul,NrSerii,Kontrahent,KodUzytkownika]

Artykul=rsglobal.Dekoduj(klucze[0])
NrSerii=rsglobal.Dekoduj(klucze[1])
Kontrahent=rsglobal.Dekoduj(klucze[2])

ArtykulK=Artykul
NrSeriiK=NrSerii
KontrahentK=Kontrahent

Fun=klucze[-1]

stat='OK'
dane=[]
 
#-------------------------------------------------------------------------------
#---   SPRAWDZENIE UPRAWNIEN
#-------------------------------------------------------------------------------

if Fun in [1,2]:
    if ((self.oddzial_id,'029113') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
        stat = "OK"
    else:
        stat='UPR INS'
        
if Fun in [3,4]:
    if ((self.oddzial_id,'029112') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
        stat = "OK"
    else:
        stat='UPR UPD'
    if stat<>"OK":
        if ((self.oddzial_id,'029113') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
            stat = "OK"
            
#-------------------------------------------------------------------------------
#---   SPRAWDZENIE DANYCH (1,2 - insert; 3,4 update)
#-------------------------------------------------------------------------------
dane = []
PolaDod=[]
WartDod=[]
#sprawdzenie klucza
if Artykul.strip() in ('',None,'None'):
    stat='BR ART'
    dane.append(stat)
if NrSerii.strip() in ('','None',None):
    stat='BR NRS'
    dane.append(stat)
if Kontrahent.strip() in ('','None',None):
    stat='BR KONTR'
    dane.append(stat)

if Fun in [3,4] and stat=='OK':
    stat,dane_kl,dump,dump=self.PolSQL.Execute("SELECT artykul_id, nr_serii, kontrahent_id FROM rs_serwis_urzadzenia WHERE firma_id='"+self.firma_id+"' AND artykul_id='"+Artykul+"' AND nr_serii='"+NrSerii+"' AND kontrahent_id='"+Kontrahent+"';",3)
    if stat=='OK':
        if len(dane_kl)==0:
            stat='BL KL'
            dane.append(stat)

if Fun in [1,2,3,4] and stat=='OK':
    if ('artykul_id' in pola) or ('nr_serii' in pola) or ('kontrahent_id'in pola):
        for i in range(len(pola)):
            pole = pola[i]
            wart = wartosci[i]

            if pole == 'artykul_id':
                if wart.strip() =='':
                    stat = "BR ART"
                    dane.append(stat)
                else:
                    stat,daneA,dump,dupm=self.PolSQL.Execute("SELECT artykul_id FROM rs_artykuly WHERE firma_id='"+self.firma_id+"' AND artykul_id = '"+wart+"';",3)
                    if stat=='OK':
                        if len(daneA)==0:
                            stat='BL ART'
                            dane.append(stat)
                        else:
                            ArtykulK=wart
                                                    
            if pole == 'nr_serii':
                if wart.strip() =='':
                    stat = "BR NRS"
                    dane.append(stat)
                else:
                    NrSeriiK=wart
            
            if pole == 'kontrahent_id':
                if wart.strip() =='':
                    stat = "BR KONTR"
                    dane.append(stat)
                else:
                    stat,daneK,dump,dupm=self.PolSQL.Execute("SELECT kontrahent_id FROM rs_kontrahenci WHERE firma_id='"+self.firma_id+"' AND kontrahent_id = '"+wart+"';",3)
                    if stat=='OK':
                        if len(daneK)==0:
                            stat='BL KONTR'
                            dane.append(stat)
                        else:
                            KontrahentK=wart
        if stat=='OK':
            #sprawdzenie dla zmK czy nowy klucz juz nie wystepuje
            stat,dane_k,dump,dump=self.PolSQL.Execute("SELECT * FROM rs_serwis_urzadzenia WHERE firma_id='"+self.firma_id+"' AND artykul_id='"+ArtykulK+"' AND nr_serii='"+NrSeriiK+"' AND kontrahent_id='"+KontrahentK+"';",3) 
            if stat=='OK':
                if len(dane_k)>0:
                    stat='KL UZ'
                    dane.append(stat)
    if stat=="OK":
        for i in range(len(pola)):
            pole = pola[i]
            wart = wartosci[i]
    
            if pole == 'osoba_id' and stat=='OK':
                if wart <> '':
                    stat,daneO,dump,dump=self.PolSQL.Execute("SELECT * FROM rs_kontrahenci_osoby WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+KontrahentK+"' AND osoba_id='"+wart+"';",3)
                    if stat =='OK':
                        if len(daneO)==0:
                            stat='BL OS'
                            dane.append(stat)
                  
            if pole == 'gwarancja_warunki' and stat=='OK':
                if wart <> '':
                    stat,daneG,dump,dump=self.PolSQL.Execute("SELECT * FROM rs_gwarancja_warunki WHERE firma_id='"+self.firma_id+"' AND kod='"+wart+"';",3)
                    if stat=='OK':
                        if len(daneG)==0:
                            stat='BL WARGW'
                            dane.append(stat)
    
            if pole == 'serwis_warunki' and stat=='OK':
                if wart <> '':
                    stat,daneSW,dump,dump=self.PolSQL.Execute("SELECT * FROM rs_serwis_warunki WHERE firma_id='"+self.firma_id+"' AND kod='"+wart+"';",3)
                    if stat=='OK':
                        if len(daneSW)==0:
                            stat='BL WARSER'
                            dane.append(stat)
            
            if pole == 'region' and stat=='OK':
                if wart <> '':
                    stat,daneR,dump,dump=self.PolSQL.Execute("SELECT * FROM rs_regiony WHERE firma_id='"+self.firma_id+"' AND kod='"+wart+"';",3)
                    if stat=='OK':
                        if len(daneR)==0:
                            stat='BL REG'
                            dane.append(stat)
            
            if pole == 'sprzedaz_data' and stat=='OK':
                if wart<>'    -  -  ':
                    if not rsglobal.SprawdzCzyToData(wart):
                        stat='BL DATA SP'
                        dane.append(stat)
                            
            if pole == 'gwarancja_data' and stat=='OK':
                if wart<>'    -  -  ':
                    if not rsglobal.SprawdzCzyToData(wart):
                        stat='BL DATA GWAR'
                        dane.append(stat)
            if pole == 'gwarancja_data_dostawcy' and stat=='OK':
                if wart<>'    -  -  ':
                    if not rsglobal.SprawdzCzyToData(wart):
                        stat='BL DATA GWARD'
                        dane.append(stat)
                        
#-------------------------------------------------------------------------------
#---   INSERT DANYCH (2- bez pobierania,1- z pobieraniem)
#-------------------------------------------------------------------------------
if Fun in [1,2] and stat=='OK':
    
    ins = "INSERT INTO rs_serwis_urzadzenia"
    Pola="firma_id,artykul_id,nr_serii,kontrahent_id"
    Wartosci="'"+self.firma_id+"','"+Artykul+"','"+NrSerii+"','"+Kontrahent+"'"
    for i in range(len(pola)):
        pole = pola[i]
        wart = wartosci[i]
        
        if pole in ['osoba_id','gwarancja_warunki','serwis_warunki','region','gwarancja_nr','uwagi']:
            Pola= Pola+","+pole
            if wart.strip()=='':
                Wartosci= Wartosci+",NULL"
            else:
                Wartosci= Wartosci+",'"+wart+"'"
        elif pole in ['sprzedaz_data','gwarancja_data','gwarancja_data_dostawcy']:
            Pola= Pola+","+pole
            if wart=='    -  -  ':
                Wartosci= Wartosci+",NULL"
            else:
                Wartosci= Wartosci+",'"+wart+"'"
    ins = ins+" ("+Pola+") VALUES ("+Wartosci+");"
    stat,dump,dump,dump = self.PolSQL.Execute(ins ,1)
               
#-------------------------------------------------------------------------------
#---   UPDATE DANYCH (4- bez pobierania,3- z pobieraniem)
#-------------------------------------------------------------------------------

if Fun in [3,4] and stat=='OK':
    
    where = " WHERE firma_id='"+self.firma_id+"' AND artykul_id='"+Artykul+"' AND nr_serii='"+NrSerii+"' AND kontrahent_id='"+Kontrahent+"'; "
    upd = "UPDATE rs_serwis_urzadzenia SET "
    
    for i in range(len(pola)):
        pole = pola[i]
        wart = wartosci[i]
    
        if pole in ['artykul_id','nr_serii','kontrahent_id']:
            upd=upd+pole+"='"+wart+"',"
        elif pole in ['osoba_id','serwis_warunki','region','gwarancja_nr','uwagi','sprzedaz_data','gwarancja_data','gwarancja_data_dostawcy','gwarancja_warunki']:
            if wart=='    -  -  ' or wart=='':
                upd=upd+pole+"=NULL,"
            else:
                upd=upd+pole+"='"+wart+"',"

    upd = upd[0:len(upd)-1]+where
    stat,dump,dump,dump = self.PolSQL.Execute(upd ,1)

#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (5 -select, 3 -update z pobraniem, 1 -insert z pobraniem)
#-------------------------------------------------------------------------------

if stat=='OK' and Fun in (5,3,1):
    # pobranie danych magazynowych
    
    SELECT = "SELECT * , CASE WHEN magazyn_id IS NOT NULL AND dokument_id IS NOT NULL AND data_dok IS NOT NULL AND numer_dok IS NOT NULL "
    SELECT += "THEN rsf_podaj_numer_dokumentu_na_wydruk('"+self.firma_id+"','[\"'||magazyn_id||'\",\"'||dokument_id||'\",\"'||data_dok||'\",\"'||numer_dok||'\"]', 'M') "
    SELECT += "ELSE '' END as numer_dokumentu "
    FROM = " FROM rs_serwis_urzadzenia "
    WHERE = "WHERE firma_id = '"+self.firma_id+"' AND artykul_id='"+ArtykulK+"' AND nr_serii='"+NrSeriiK+"' AND kontrahent_id='"+KontrahentK+"';"
    stat,dane,wyn1,tr = self.PolSQL.Execute(SELECT+FROM+WHERE,3)
    #pobranie danych do opisow

    if len(dane) == 1:
        tr = rssql.RSTableRowset(dane,wyn1)

        #--- artykul
        if ((self.oddzial_id,'013010') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
            dump,d,dump,dump = self.PolSQL.Execute("SELECT nazwa FROM rs_artykuly WHERE firma_id='"+self.firma_id+"' AND artykul_id='"+ArtykulK+"';" ,3)
            if len(d) == 0:
                wyn2.append('')
            else:
                wyn2.append(d[0][0])
        else:
            wyn2.append('Brak uprawnie do sownika. Poinformuj administratora.')
        
        #---kontrahent
        if ((self.oddzial_id,'012010') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
            dump,d,dump,dump = self.PolSQL.Execute("SELECT nazwa FROM rs_kontrahenci WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+KontrahentK+"';" ,3)
            if len(d) == 0:
                wyn2.append('')
            else:
                wyn2.append(d[0][0])
        else:
            wyn2.append('Brak uprawnie do kontrahentw. Poinformuj administratora.')
        
        #---uzytkownik
        if ((self.oddzial_id,'012030') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
            dump,d,dump,dump = self.PolSQL.Execute("SELECT imie||' '||nazwisko FROM rs_kontrahenci_osoby WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+KontrahentK+"' AND osoba_id='"+str(dane[0][4])+"';" ,3)
            if len(d) == 0:
                wyn2.append('')
            else:
                wyn2.append(d[0][0])
        else:
            wyn2.append('Brak uprawnie do kontrahentw osb - osoby. Poinformuj administratora.')
        
        #---warunki gwarancji
        if ((self.oddzial_id,'011430') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
            dump,d,dump,dump = self.PolSQL.Execute("SELECT opis FROM rs_gwarancja_warunki WHERE firma_id='"+self.firma_id+"' AND kod='"+str(dane[0][9])+"';" ,3)
            if len(d) == 0:
                wyn2.append('')
            else:
                wyn2.append(d[0][0])
        else:
            wyn2.append('Brak uprawnie do sownika warunkw gwaracji. Poinformuj administratora.')
        
        #---warunki serwisu
        if ((self.oddzial_id,'011440') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
            dump,d,dump,dump = self.PolSQL.Execute("SELECT opis FROM rs_serwis_warunki WHERE firma_id='"+self.firma_id+"' AND kod='"+str(dane[0][10])+"';" ,3)
            if len(d) == 0:
                wyn2.append('')
            else:
                wyn2.append(d[0][0])
        else:
            wyn2.append('Brak uprawnie do sownika warunkw serwisu. Poinformuj administratora.')
            
        #---Regiony
        if ((self.oddzial_id,'011020') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
            dump,d,dump,dump = self.PolSQL.Execute("SELECT opis FROM rs_regiony WHERE firma_id='"+self.firma_id+"' AND kod='"+str(dane[0][11])+"';" ,3)
            if len(d) == 0:
                wyn2.append('')
            else:
                wyn2.append(d[0][0])
        else:
            wyn2.append('Brak uprawnie do sownika regionw. Poinformuj administratora.')