# -*- coding: iso8859_2 -*-

# -----------------------------------------------------------------------------
# Name:        fs_skroty.py
# Purpose:     Obsuga skrtw klawiszowych definiowanych przez uytkownikw programw dla konkretnych okien
# Author:      Aleksander Bargie
# Created:     2019/11/06
# RCS-ID:      $Id: fs_skroty.py $
# Copyright:   (c) 2019 RecordSystem
# Licence:     GNU GPL
# -----------------------------------------------------------------------------

"""Funkcje:
3. Zapis z pobraniem.
5. Pobranie listy skrtw"""
stat = 'OK'

"""Przyszlo FUNCTION2 {'wartosci': [u'', u'fdsgsdf', u'', u'', u'', u'', u'', u'', u'', u'', u'', u'', u'', u'', u'', u'', u'6345', u'', u'', u'', u'', u'', u'', u'', u'', u'', u'', u'', u'', u'', u'', u'', u'', u'', u'', u'', u'', u'', u'', u'', u'', u'', u'', u'', u'', u'', u''], 'funkcja_fs': 'fs_skroty', 'klucze': {'Funkcja': 1, 'Okno': u'WSkroty'}, 'pola': ["'", ',', '-', '.', '/', '0', '1', '2', '3', '4', '5', '6', '7', '8', '9', ';', '=', '[', '\\', ']', '`', 'a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i', 'j', 'k', 'l', 'm', 'n', 'o', 'p', 'q', 'r', 's', 't', 'u', 'v', 'w', 'x', 'y', 'z']}
"""

try:
    if 'Funkcja' not in klucze:
        stat = 'Brak podanej funkcji w kluczach'
except:
    stat = 'Brak podanej funkcji w kluczach'
    Fun = 9999

if stat == 'OK':
    Fun = klucze['Funkcja']
    SlPar = {'Okno': [1, 3, 5, 6, ], 'Kody': [1, 3, 5, ]}
    Lista = rsglobal.SprawdzParametryWKluczach(SlPar, Fun, klucze)
    if Lista != '':
        stat = 'Uwaga : wywoanie funkcji fs_ftp_obsluga z numerem '+str(Fun)+' bez parametrw: '+Lista

if stat == 'OK':
    if Fun in [1, 3, 5, 6, ]:
        Okno = klucze['Okno']
    if Fun in [1, 3, 5, ]:
        Kody = klucze['Kody']

dane = []
wyn1 = []
wyn2 = []

rsglobal.ZapiszDoLogow(10000 * ' ')
if stat == 'OK' and Fun in (1, 3, ):
    """Update"""
    rsglobal.ZapiszDoLogow(repr(klucze))
    # wartosci = klucze['wartosci']
    # pola = klucze['pola']
    UPD = []
    INS = []
    DEL = []
    SQL = ""
    for pole, wartosc in zip(pola, wartosci):
        rsglobal.ZapiszDoLogow(pole)
        rsglobal.ZapiszDoLogow(repr(pole))
        if wartosc.strip() == '':
            DEL.append(str(ord(pole[1:])))
        else:
            UPD.append("UPDATE rs_skroty SET tekst='{}' WHERE firma_id='{}' AND okno='{}' AND skrot={};".format(wartosc, self.firma_id, Okno, ord(pole[1:])))
            INS.append("INSERT INTO rs_skroty (firma_id, okno, skrot, tekst) "
                       "SELECT '{f}', '{o}', {s}, '{t}'"
                       "WHERE NOT EXISTS (SELECT 1 FROM rs_skroty WHERE firma_id='{f}' AND okno='{o}' AND skrot={s})"
                       ";".format(f=self.firma_id, o=Okno, s=ord(pole[1:]), t=wartosc))
    if len(DEL) > 0:
        SQL += "DELETE FROM rs_skroty WHERE firma_id='{}' AND okno='{}' AND skrot in (".format(self.firma_id, Okno) + \
               ', '.join(DEL) + ');'
    SQL += ' '.join(INS) + ' '
    SQL += ' '.join(UPD)
    rsglobal.ZapiszDoLogow(SQL)
    stat, dump, dump, dump = self.PolSQL.Execute(SQL, 1, CzyDodawacBlad=True)
    rsglobal.ZapiszDoLogow(stat, 5)


if stat == 'OK' and Fun in (1, 3, 5):
    """Select"""
    rsglobal.ZapiszDoLogow(repr(klucze))

    sql = """SELECT skrot, tekst FROM rs_skroty WHERE firma_id = '{}' AND okno = '{}';""".format(self.firma_id, Okno)
    rsglobal.ZapiszDoLogow(sql, 5)
    stat, s, wyn1, dump = self.PolSQL.Execute(sql, 3, CzyDodawacBlad=True)
    rsglobal.ZapiszDoLogow(stat, 5)
    rsglobal.ZapiszDoLogow(s, 5)
    rsglobal.ZapiszDoLogow(wyn1, 5)
    skroty = {}
    kolumny = []
    if stat != 'OK':
        stat = u"Bd pobierania skrtw: " + stat
    else:
        rsglobal.ZapiszDoLogow(Kody, 5)
        for skrot in s:
            skroty[chr(skrot[0])] = skrot[1]
        for Kod in Kody:
            if Kod in skroty:
                dane.append(skroty[Kod])
            else:
                dane.append('')
            kolumny.append(list(wyn1[1]))
            kolumny[-1][0] = 'p'+Kod

        dane = [dane]
        wyn1 = kolumny


if stat == 'OK' and Fun in (6, ):
    """Pobranie skrotow na okno"""
    rsglobal.ZapiszDoLogow(repr(klucze))

    sql = """SELECT skrot, tekst FROM rs_skroty WHERE firma_id = '{}' AND okno = '{}';""".format(self.firma_id, Okno)
    stat, s, dump, dump = self.PolSQL.Execute(sql, 3, CzyDodawacBlad=True)
    skroty = {}
    if stat != 'OK':
        stat = u"Bd pobierania skrtw: " + stat
    else:
        for skrot in s:
            skroty[skrot[0]] = skrot[1]
    dane.append(skroty)


rsglobal.ZapiszDoLogow(1000 * ' ')
