
# -*- coding: iso8859_2 -*-

#-----------------------------------------------------------------------------
# Name:        fs_spis_z_natury_pozycje_dane.py
# Purpose:     wczytuje/edytuje dane pozycji spisu z natury
#
# Author:      Micha Raburski
# Created:     2006/07/03
# RCS-ID:      $Id: fs_spis_z_natury_pozycje_dane.py $
# Copyright:   (c) 2004-2009 Record System
# Licence:     GNU GPL
#-----------------------------------------------------------------------------

#klucze = [Spis,artykul,funkcja]
#Spis=magazyn_id,kateg_artykulu,data

from funkcje import fs_spis_z_natury_pom
stat='OK'
Mag=rsglobal.Dekoduj(klucze[0][0])
Kat=rsglobal.Dekoduj(klucze[0][1])
Data=rsglobal.Dekoduj(klucze[0][2])
Art=rsglobal.Dekoduj(klucze[1])

#-------------------------------------------------------------------------------
#---   UPDATE DANYCH (4- bez pobierania,3- z pobieraniem)
#-------------------------------------------------------------------------------

if klucze[-1] == 4 or klucze[-1]==3:
    if not (((self.oddzial_id,'033022') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID):
        stat='UPR UPD'
    
    if stat=='OK':
    #---   Sprawdzenie danych
        stat = "OK"
        dane = []

        if stat == 'OK':
            where = " WHERE magazyn_id='"+Mag+"' AND kateg_artykulu='"+Kat+"' AND data='"+Data+"' AND artykul_id='"+Art+"' AND firma_id='"+self.firma_id+"';"
            upd = "UPDATE rs_inwentaryzacja_pozycje SET "
        
            for i in range(len(pola)):
                pole = pola[i]
                wart = wartosci[i]
            
                if pole in ['ilosc1','ilosc2']:
                    upd=upd+pole+"="+str(wart)+","

            upd = upd[0:len(upd)-1]+where
            
            stat,dump,dump,dump = self.PolSQL.Execute(upd ,1)
        # przeliczenie ilosci na przyjeciach pozycji spisu z natury
        if stat=='OK':
            rsglobal.ZapiszDoLogow('Przed przeliczeniem',1)
            stat,wyn2=fs_spis_z_natury_pom.WstawIlosciStwierdzoneDoPozycjiArtykulowPrzyjeciaNaSpisieZNatury(self, Data, Mag, Kat, Art, True)
            rsglobal.ZapiszDoLogow('Po przeliczeniu '+stat+' '+str(wyn2),1)

#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (5 -select, 3 -update z pobraniem, 1 -insert z pobraniem)
#-------------------------------------------------------------------------------

if (klucze[-1] in [5,3,1]) and (stat=='OK'):
    # pobranie danych magazynowych
    stat,dane,wyn1,tr = self.PolSQL.Execute("SELECT * FROM rs_inwentaryzacja_pozycje WHERE magazyn_id='"+Mag
        +"' AND kateg_artykulu='"+Kat+"' AND data='"+Data+"' AND artykul_id='"+Art+"' AND firma_id='"+self.firma_id+"';",3)