# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_sprawdz_usuwalnosc.py
# Purpose:     sprawdza, czy w rs_dowody_ksiegowe_pozycje wystepuje konto analityczne
#              zdefiniowane w rs_grupy_analitycze.
#              Ta fukcja to opakowanie do wywolania wlasciwej funkcji
#              sprawdzajacej dla tych okien, ktore nie przeszly na funkcje i musza wywolywac
#              wprost fs_*. Chodzi o problem z importem, ktory miesza.
#
# Author:      Mariusz Rajfura
# Created:     2009/08/07
# RCS-ID:      $Id: fs_sprawdz_usuwalnosc
# Copyright:   (c) 2009 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

# 2019-05-13 Wojciech Skowron (11486) RSSLowniki - refaktoryzacja - klucze w postaci sownika zamiast listy

from funkcje import fs_sprawdz_analityke

dane = []
stat = "OK"

# if not 'Funkcja' in klucze:
#     stat = 'Brak podanej funkcji w kluczach'
#     Fun = 999

if stat == 'OK':
    Fun = 1
    # Fun = klucze['Funkcja']

    SlPar = {'TypKonta':[1], 'Konto':[1], 'Grupa':[1]}
    Lista = rsglobal.SprawdzParametryWKluczach(SlPar, Fun, klucze)
    if Lista != '':
        stat = 'Uwaga : wywoanie funkcji fs_sprawdz_usuwalnosc z numerem '+str(Fun)+' bez parametrw: '+Lista

if stat == 'OK':
    TypKontaAnal = rsglobal.Dekoduj(klucze['TypKonta']).upper()
    KontoAnal = rsglobal.Dekoduj(klucze['Konto'])
    GrupaAnal = rsglobal.Dekoduj(klucze['Grupa'])

# TypKontaAnal = rsglobal.Dekoduj(klucze[0]).upper()
# KontoAnal = rsglobal.Dekoduj(klucze[1])
# GrupaAnal = rsglobal.Dekoduj(klucze[2])

if stat == 'OK' and Fun == 1:
    stat = fs_sprawdz_analityke.CzyMoznaUsunac(self, TypKontaAnal, KontoAnal, GrupaAnal)
