# -*- coding: iso8859_2 -*-
#-----------------------------------------------------------------------------
# Name:        fs_srodki_trwale_miejsca_uzytkowania.py
# Purpose:     wyswietla, dodaje,usuwa miejsca uytkowania operujc na tabeli rs_srodki_trwale_miejsca_uzytkowania
# Author:      Pawe Wjcikowski
# Created:     2009/03/11
# RCS-ID:      $Id: fs_srodki_trwale_miejsca_uzytkowania.py$
# Copyright:   (c) 2009 Record System
# Licence:     GNU GPL
#-----------------------------------------------------------------------------

# 2022-06-17 Wojciech Skowron (13060) Max 1 wiersz - blokada edycji grida i zamiast niej okienko z dodawaniem wiersza

stat='OK'

if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=='OK':
    Funkcja = klucze['Funkcja']

    SlPar={'SrodekId':[1,5],'Miejsce':[1,5,7],'DataOd':[1,5]}
    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Funkcja,klucze)
    if Lista<>'':
        stat='Uwaga : wywoanie funkcji fs_kontrahenci_kuke z numerem '+str(Fun)+' bez parametrw: '+Lista

if stat=='OK':
    if Funkcja in [1,5]:
        SrodekId = klucze['SrodekId']
        DataOd = klucze['DataOd']
    if Funkcja in [1,5,7]:
        MiejsceId = klucze['Miejsce']

dane = []
wyn1 = []
wyn2 = []

UprPrzeglSlown=(((self.oddzial_id,'011561') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID))    
UprDodawanie=(((self.oddzial_id,'174113') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID))
UprEdycja=(((self.oddzial_id,'174112') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)) or UprDodawanie
UprUsuwanie=(((self.oddzial_id,'174114') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID))


#-------------------------------------------------------------------------------
#-------- EDYCJA GRIDA EDYTOWALNEGO (1)
#-------------------------------------------------------------------------------

Insert = []
Update = []
Delete = []

if Funkcja == 1:
    Update=klucze['Update']
    Insert=klucze['Insert']
    Delete=klucze['Delete']

    
#-------------------------------------------------------------------------------
#-------   SPRAWDZANIE OPISU      ----------------------------------------------
#-------------------------------------------------------------------------------

if Funkcja == 7 and stat=='OK':
    sel1="SELECT opis FROM rs_miejsca_uzytkowania WHERE firma_id='"+self.firma_id+"' AND kod='"+MiejsceId+"';"
    stat,dane,dump,dump = self.PolSQL.Execute(sel1,3)   
    if stat<>'OK':
        stat=u"Bd przy sprawdzaniu opisu: "+stat   
        dane.append(stat)        
    if stat=='OK':
        if UprPrzeglSlown==0 and len(dane)<>0:
            stat='BR UPR SLOWN'
            dane.append(stat) 

#-------------------------------------------------------------------------------
#-------  SPRAWDZANIE DELETE  --------------------------------------------------
#-------------------------------------------------------------------------------

if Funkcja == 1 and stat=="OK":
    if len(Delete[0])>0:
        if not UprUsuwanie:
            stat='Brak uprawnie do usuwania danych'
            dane.append(stat)    
            
#------------------------------------------------------------------------------------------------------------        
#-------------------------- DELETE    
#------------------------------------------------------------------------------------------------------------        
        
        if stat=='OK':
            sql=''
            for i in xrange(len(Delete[0])):
                DELETE="DELETE FROM rs_srodki_trwale_miejsca_uzytkowania "
                WHERE="WHERE firma_id='"+self.firma_id+"' AND srodek_id='"+str(SrodekId)+"'"
                for j in xrange(len(Delete[0][i])):
                    pole=Delete[1][j]
                    wart=Delete[0][i][j]
                    if pole in ['miejsce_id','data_od','data_do']:
                        WHERE+=" AND "+pole+"='"+wart+"'"
                sql+=DELETE+WHERE+";"
            if sql<>'': 
                stat,dump,dump,dump=self.PolSQL.Execute(rsglobal.Dekoduj(sql),1)
            if stat<>'OK':
                stat=u"Bd przy usuwaniu danych: "+stat   
                dane.append(stat)        
                                 
# #-------------------------------------------------------------------------------
# #---   UPDATE DANYCH (1)
# #-------------------------------------------------------------------------------
#
# if Funkcja == 1 and stat=='OK':
#     if len(Update[0])>0:
#         if not UprEdycja:
#             stat='Brak uprawnie do edycji danych'
#             dane.append(stat)
#
#         if stat=='OK':
#             sel1="SELECT kod FROM rs_miejsca_uzytkowania;"
#             stat,D,dump,dump = self.PolSQL.Execute(sel1,3)
#             if stat<>'OK':
#                 stat=u"Bd przy sprawdzaniu kodu: "+stat
#                 dane.append(stat)
#             DaneI=[]
#
#             for i in xrange(len(D)):
#                 for x in D[i]:
#                     DaneI.append(str(x).strip())
#
#             WierszeNr = Update[-1]
#             for i in xrange(len(Update[0])):
#                 for j in xrange(len(Update[0][i])):
#                         #if stat == "OK":
#                         pole=Update[0][i][j]
#                         wart=Update[1][i][j]
#                         if pole == 'miejsce_id':
#                             if str(wart).strip() not in DaneI:
#                                 stat = u'Miejsce niepoprawne'
#                                 wyn2.append((WierszeNr[i],0))
#                                 dane.append(stat)
#                         if pole == 'data_od':
#                             if (not rsglobal.SprawdzCzyToData(wart)) and wart != '':
#                                 stat='BL DATA1'
#                                 dane.append(stat)
#                                 wyn2.append((WierszeNr[i],2))
#                             if wart == '':
#                                 stat='PUS DATA1'
#                                 dane.append(stat)
#                                 wyn2.append((WierszeNr[i],2))
#                         if pole == 'data_do':
#                             if (not rsglobal.SprawdzCzyToData(wart)) and wart != '':
#                                 stat='BL DATA2'
#                                 dane.append(stat)
#                                 wyn2.append((WierszeNr[i],3))
#
#
#         if stat=='OK':
#             sql=''
#             for i in xrange(len(Update[0])):
#                 UPDATE="UPDATE rs_srodki_trwale_miejsca_uzytkowania "
#                 SET='SET '
#                 for j in xrange(len(Update[0][i])):
#                     pole=Update[0][i][j]
#                     wart=Update[1][i][j]
#                     if pole in []:
#                         SET+=pole+"='"+wart+"',"
#                     if pole in ['data_do','miejsce_id','data_od']:
#                         if len(wart)==0:
#                             SET+=pole+"="+str('NULL')+","
#                         else:
#                             SET+=pole+"='"+wart+"',"
#                 SET=SET.strip(",")
#                 WHERE=" WHERE firma_id='"+self.firma_id+"' AND srodek_id ='"+str(SrodekId)+"'"
#                 for j in xrange(len(Update[2][i])): # petla po kluczu
#                     pole=Update[3][j]
#                     wart=rsglobal.Dekoduj(Update[2][i][j])
#                     WHERE+=" AND "+pole+"='"+wart+"'"
#                 WHERE+=";"
#                 if str(SET)=='SET ':
#                     pass
#                 else:
#                     sql+=UPDATE+SET+WHERE;
#             if sql<>'':
#                 stat,dump,dump,dump=self.PolSQL.Execute(rsglobal.Dekoduj(sql),1)
#                 if stat<>'OK':
#                     stat=u"Bd przy modyfikowaniu danych: "+stat
#                     dane.append(stat)
                                    
#----------------------------------------------------------------------------------------------------------------------
#---------Sprawdzanie danych do Insert------
#----------------------------------------------------------------------------------------------------------------------

if Funkcja == 1 and stat=='OK':
    if len(Insert[0])>0:
        if not UprDodawanie:
            stat='Brak uprawnie do dodawania danych'
            dane.append(stat)

        #WS 2022-06-17
        if stat=='OK':
            if len(Insert[0]) > 1:
                stat = 'Nie mona doda wicej ni 1 wiersza'
                dane.append(stat)
            else:
                sel = "SELECT * FROM rs_srodki_trwale_miejsca_uzytkowania WHERE firma_id='"+self.firma_id+"' AND srodek_id='"+SrodekId+"';"
                stat, d, dump, dump = self.PolSQL.Execute(sel, 3)
                if stat != 'OK':
                    stat = u"Bd przy sprawdzaniu danych: "+stat
                    dane.append(stat)
                elif len(d) > 0:
                    stat = 'Nie mona doda wicej ni 1 wiersza'
                    dane.append(stat)

        if stat=='OK':                    
            sel1="SELECT kod FROM rs_miejsca_uzytkowania;"
            stat,I,dump,dump = self.PolSQL.Execute(sel1,3)
            if stat<>'OK':
                stat=u"Bd przy sprawdzaniu danych: "+stat   
                dane.append(stat)        

            WierszeNr = Insert[-1]
            DaneI=[]
        
            for i in xrange(len(I)):
                for x in I[i]:
                    DaneI.append(str(x).strip())  
        
            for i in xrange(len(Insert[0])):
                for j in xrange(len(Insert[0][i])): 
                        pole=Insert[1][j]
                        wart=Insert[0][i][j]
                        if pole == 'miejsce_id':
                            if str(wart).strip() not in DaneI:
                                stat = u'Miejsce niepoprawne'
                                wyn2.append((WierszeNr[i],0))
                                dane.append(stat)
                        if pole == 'data_od':
                            if (not rsglobal.SprawdzCzyToData(wart)) and wart not in (None,'    -  -  ','','None'):
                                stat='BL DATA1'
                                dane.append(stat)
                                wyn2.append((WierszeNr[i],2))
                            if wart in (None,'    -  -  ','','None'):
                                stat='PUS DATA1'
                                dane.append(stat)
                                wyn2.append((WierszeNr[i],2))
                        if pole == 'data_do':
                            if (not rsglobal.SprawdzCzyToData(wart)) and wart not in (None,'    -  -  ','','None'):
                                stat='BL DATA2'
                                dane.append(stat)
                                wyn2.append((WierszeNr[i],3))
    
                                                        
 #------------------------------------------------------------------------------------------------------------   
 #---------------   INSERT
 #-------------------------------------------------------------------------------------------------------------       

        if stat=='OK':    
            sqlIns=''
            for i in xrange(len(Insert[0])):
                INSERT="INSERT INTO rs_srodki_trwale_miejsca_uzytkowania "
                KOLUMNY="(firma_id,srodek_id"
                VALUES=" VALUES ('"+self.firma_id+"','"+SrodekId+"'"
                for j in xrange(len(Insert[0][i])):
                    pole=Insert[1][j]
                    wart=Insert[0][i][j]
                    if pole in ['miejsce_id','data_od']:
                        KOLUMNY+=","+pole
                        VALUES+=",'"+wart+"'"  
                    if pole == 'data_do':
                        if wart in (None,'    -  -  ','','None'):
                            KOLUMNY+=","+pole
                            VALUES+=","+str('NULL')+""                        
                        else:
                            KOLUMNY+=","+pole
                            VALUES+=",'"+wart+"'"             
                KOLUMNY+=")"
                VALUES+=");"
                sqlIns+=INSERT+KOLUMNY+VALUES
            if sqlIns<>'': 
                stat,dump,dump,dump=self.PolSQL.Execute(rsglobal.Dekoduj(sqlIns),1)
                if stat<>'OK':
                    stat=u"Bd przy dodawaniu danych: "+stat   
                    dane.append(stat)                   

#-----------------------------------------------------------------------------------------------------------------------
#---   POBRANIE DANYCH (1- insert 1 -select, 1 -delete)
#-----------------------------------------------------------------------------------------------------------------------

if Funkcja in [1,5] and stat=='OK':
    # pobranie danych
    sql="SELECT stmu.miejsce_id"
    if UprPrzeglSlown<>0:
        sql+=",mu.opis"
    if UprPrzeglSlown==0:
        sql+=",'Brak uprawnie do przegldania sownikw'"
    sql+=",stmu.data_od,coalesce(cast (stmu.data_do as text),'') FROM rs_srodki_trwale_miejsca_uzytkowania stmu "
    sql+=" INNER JOIN rs_miejsca_uzytkowania mu ON (mu.firma_id='"+self.firma_id+"' AND stmu.miejsce_id=mu.kod) "
    sql+=" WHERE stmu.firma_id='"+self.firma_id+"' AND stmu.srodek_id = '"+str(SrodekId)+"' "
    sql+="ORDER BY data_od;"
    stat,dane,wyn1,wyn2=self.PolSQL.Execute(sql,3)
    if stat<>'OK':
        stat=u"Bd przy pobieraniu danych: "+stat
        dane.append(stat)