# -*- coding: iso8859_2 -*-
#-----------------------------------------------------------------------------
# Name:        fs_srodki_trwale_zmiany_stawki_dane.py
# Purpose:     wczytuje i edytuje dane zmiany stawki srodka trwalego
# Author:      Dariusz Boduch, Micha Raburski
# Created:     2010/11/09
# RCS-ID:      $Id: fs_srodki_trwale_zmiany_stawki_dane.py $
# Copyright:   (c) 2010 Record System
# Licence:     GNU GPL
#-----------------------------------------------------------------------------

SrodekId=klucze[0]
DataF=klucze[1]

Funkcja=klucze[-1]

stat = 'OK'
dane = []

#w celach informacyjno rozeznaniowych
Pola=pola
Wartosci=wartosci

puste_pola = [[],"","    -  -  "]

UprEdycja=((self.oddzial_id,'174132') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)
UprIns=((self.oddzial_id,'174133') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)

Filtr = "WHERE firma_id='"+self.firma_id+"' AND srodek_id='"+SrodekId+"' AND data='"+DataF+"'"

self.CzyLiczycPlan=False

#-------------------------------------------------------------------------------
#------- SPRAWDZAM CZY JEST UTWORZONY PLAN DLA SRODKA TRWAEGO
#-------------------------------------------------------------------------------

if stat=='OK':
    SQL="SELECT rok,miesiac FROM rs_srodki_trwale_plan WHERE firma_id='"+str(self.firma_id)+"' AND srodek_id='"+str(SrodekId)+"' "
    SQL+="ORDER BY rok DESC, miesiac DESC  LIMIT 1;"
    stat,dp,dump,dump=self.PolSQL.Execute(SQL,3)
    if stat<>'OK':
        stat='Bd pobrania danych planu amortyzacji: '+stat
        dane.append(stat)
    elif len(dp)==0:
        stat='BR PLAN'
        dane.append(stat)
    else:
        #Maksymalna data planu amortyzacji (zeby przy dodawaniu/edycji nie wyjsc poza plan data od)
        RokMax=dp[0][0]
        McMax =dp[0][1]
        DataMax=str(RokMax)+str(McMax)

#-------------------------------------------------------------------------------

if Funkcja==10:
    SQL="SELECT stawka_procent,stawka_procent_p FROM rs_srodki_trwale WHERE firma_id='"+self.firma_id+"' AND srodek_id='"+SrodekId+"' "
    stat,dane,dump,dump = self.PolSQL.Execute(SQL ,3)
    if stat<>'OK':
        stat='Bd zapytania: '+stat
        dane.append(stat)
 
#-------------------------------------------------------------------------------

if Funkcja==11:
    dane=True
    SQL="SELECT nowa_stawka FROM rs_srodki_trwale_zmiany_stawki WHERE firma_id='"+self.firma_id+"' AND srodek_id='"+SrodekId+"' AND data>'"+DataF+"' ORDER BY data"
    stat,dt,dump,dump = self.PolSQL.Execute(SQL ,3)
    if stat<>'OK':
        stat='Bd zapytania: '+stat
        dane.append(stat)
    else:
        RokF=DataF[0:4]
        McF=DataF[5:7]
        SQL="SELECT umorzone FROM rs_srodki_trwale_plan WHERE firma_id='"+self.firma_id+"' AND srodek_id='"+SrodekId+"' AND rok='"+RokF+"' AND miesiac='"+McF+"' ;"
        stat,dplan,dump,dump = self.PolSQL.Execute(SQL ,3)
        if stat<>'OK':
            stat='Bd zapytania: '+stat
            dane.append(stat)
        else:
            if len(dplan)==0:
                dane=False
            else:
                dane= not dplan[0][0]                      


#-------------------------------------------------------------------------------
#-------------------------------------------------------------------------------
#---SPRAWDZAM DANE
#-------------------------------------------------------------------------------
#-------------------------------------------------------------------------------

if Funkcja in [1,2,3,4] and stat=='OK':        
    for i in range(len(Pola)):
        pole = Pola[i]
        wart = Wartosci[i]

        if pole == "nowa_stawka" and (Funkcja in [1,2]):
             if wart == 0:
                 stat="WART NULL"
                 dane.append(stat)
             
        if pole == "nowa_stawka_p" and (Funkcja in [1,2]):
             if wart == 0:
                 stat="WART NULL P"
                 dane.append(stat)
                 
        if pole == "data" and (Funkcja in [1,2]):
            if str(wart)in ('','    -  -  '):
                stat='BR DATA'
                dane.append(stat)
            elif not rsglobal.SprawdzCzyToData(str(wart)):
                    stat='BL DATA'
                    dane.append(stat)
            else:
                rok=str(wart)[:4]
                mc=str(wart)[5:7]
                DATA=rok+mc
                if int(DATA)>int(DataMax):
                    stat='DATA MAX'
                    dane.append(stat)
            #czy nie ma pozniejszej daty
            if stat=='OK':
                SQL="SELECT data FROM rs_srodki_trwale_zmiany_stawki WHERE firma_id='"+self.firma_id+"' AND srodek_id='"+SrodekId+"' AND data>='"+str(wart)+"' ;"
                stat,date,dump,dump = self.PolSQL.Execute(SQL ,3)
                if stat<>'OK':
                    stat='Bd pobrania danych: '+stat
                    dane.append(stat)
                else:
                    if len(date)>0:
                        stat='DATA ISTN'
                        dane.append(stat)

            #jesli ok to sprawdzam czy w danym miesicu ju nie nastpia amortyzacja
            if stat=='OK':
                SQL="SELECT rok,miesiac FROM rs_srodki_trwale_plan  WHERE firma_id='"+self.firma_id+"'"
                SQL+=" AND srodek_id='"+SrodekId+"' AND umorzone AND ((rok='"+rok+"' AND miesiac>='"+mc+"') OR rok>'"+rok+"');"
                stat,amort,dump,dump = self.PolSQL.Execute(SQL ,3)
                if stat<>'OK':
                    stat='Bd pobrania danych amotyzacji rodka trwaego: '+stat
                    dane.append(stat)
                elif len(amort)>0:
                    stat='ROKMC UM'
                    dane.append(stat)

            #jesli ok to sprawdzam z datami wprowadzenia do systemu srodka lub okresow obrachunkowych
            if stat=='OK':
                SQL="SELECT rok,miesiac FROM rs_srodki_trwale_plan WHERE firma_id='"+self.firma_id+"' AND srodek_id='"+SrodekId+"' AND umorzone;"
                stat,amort,dump,dump = self.PolSQL.Execute(SQL ,3)
                if stat<>'OK':
                    stat='Bd pobrania danych amotyzacji rodka trwaego: '+stat
                    dane.append(stat)
                
            if stat=='OK':
                # jeli nie ma amortyzacji to mozna sprawdza czy data pasuje do "nowego rodka"
                # jeli s to spradzamy tylko pocztek okresu
                Mozna=False
                if len(amort)==0:
                    #nowo wprowadzony srodek
                    SQL="SELECT COALESCE(data_wprowadzenia_do_systemu,data_przyjecia),"
                    SQL+="COALESCE(data_wprowadzenia_do_systemu,data_przyjecia) + interval '1 month'"
                    SQL+=" FROM rs_srodki_trwale WHERE firma_id='"+self.firma_id+"' AND srodek_id='"+SrodekId+"'"
                    SQL+=" AND NOT COALESCE(data_wprowadzenia_do_systemu,data_przyjecia) IS NULL; "
                    stat,dwds,dump,dump = self.PolSQL.Execute(SQL ,3)
                    if stat<>'OK':
                        stat='Bd pobrania daty wprowadzenia do systemu: '+stat
                        dane.append(stat)
                    if stat=='OK':
                        if len(dwds)==0:
                            stat='Nie wprowadzono daty wprowadzenia do systemu ani daty przyjcia rodka'
                            dane.append(stat)
                        else:
                            DataWprS=dwds[0][0]
                            DataWprSMAX=dwds[0][1][:10]
                            if wart>=DataWprS and wart<=DataWprSMAX:
                                Mozna=True
                        
                if not Mozna and stat=='OK':
                    #rodek amortyzowany
                    SQL="SELECT data_od,data_od + interval '1 month' FROM rs_definicje_okresow "
                    SQL+=" WHERE firma_id='"+self.firma_id+"' and okres_id='"+self.okres_id+"' ;"
                    stat,DaneOkr,dump,dump = self.PolSQL.Execute(SQL ,3)
                    if stat<>'OK':
                        stat='Bd pobrania danych okresu: '+stat
                    if stat=='OK':
                        DataOd=DaneOkr[0][0]
                        DataOdMAX=DaneOkr[0][1][:10]
                        if wart>=DataOd and wart<=DataOdMAX:
                            Mozna=True
                
                if not Mozna and stat=='OK':
                    stat='WAR DATY'
                    
            
#-------------------------------------------------------------------------------
#-------------------------------------------------------------------------------
#----  INSERT DANYCH (1- z pobraniem, 2- bez pobrania)
#-------------------------------------------------------------------------------
#-------------------------------------------------------------------------------
    
if Funkcja in [1,2] and stat=='OK':
    if not UprIns:
        stat='BR INS'
        dane.append(stat)
    if stat=='OK':          
        sql = "INSERT INTO rs_srodki_trwale_zmiany_stawki"
        PolaN="firma_id,srodek_id "
        WartosciN = "'"+self.firma_id+"','"+SrodekId+"'"
        for i in range(len(pola)):
            pole = pola[i]
            wart = wartosci[i]
            if pole in ['data']:
                PolaN += ","+pole
                WartosciN += ",'"+str(wart)+"'"
            elif pole in ['poprzednia_stawka','nowa_stawka','poprzednia_stawka_p','nowa_stawka_p']:
                PolaN += ","+pole
                WartosciN += ","+str(wart)+" "
        sql += " ("+PolaN+") VALUES ("+WartosciN+");"
        stat,dump,dump,dump = self.PolSQL.Execute(sql ,1)
        if stat<>'OK':
            stat= 'Bdy przy dodawaniu zmiany: '+stat                
            dane.append(stat)
        else:
            self.CzyLiczycPlan=True
            

#-------------------------------------------------------------------------------
#-------------------------------------------------------------------------------
#---   UPDATE DANYCH (4- bez pobierania,3- z pobieraniem)-----------------------
#-------------------------------------------------------------------------------
#-------------------------------------------------------------------------------

if Funkcja in [4,3] and stat=='OK':
    if not UprIns:
        stat='BR INS'
        dane.append(stat)
    if stat=='OK':
        dane = []
        sql = "UPDATE rs_srodki_trwale_zmiany_stawki SET "
        for i in range(len(Pola)):
            wart = Wartosci[i]
            pole = Pola[i]
            if pole in ['data']:
                sql += pole+"='"+str(wart)+"',"
            elif pole in ['poprzednia_stawka','nowa_stawka','poprzednia_stawka_p','nowa_stawka_p']:
                sql += pole+"="+str(wart)+","
        sql = sql.strip(',')
        sql += " "+Filtr+";"
        stat,dump,dump,dump = self.PolSQL.Execute(sql ,1)
        if stat != 'OK':
            stat = 'Bd uaktualnienia danych'+stat
            dane.append(stat)
        else:
            self.CzyLiczycPlan=True

#-------------------------------------------------------------------------------
#   LICZENIE PLANU
#-------------------------------------------------------------------------------

if stat=='OK' and self.CzyLiczycPlan:
    # pobieramy stawki i wpisujemy je do rodka.
    SQL="UPDATE rs_srodki_trwale SET stawka_procent=stzs.nowa_stawka,stawka_procent_p=stzs.nowa_stawka_p"
    SQL+=" FROM rs_srodki_trwale_zmiany_stawki stzs"
    SQL+=" WHERE rs_srodki_trwale.firma_id='"+self.firma_id+"' AND rs_srodki_trwale.srodek_id='"+str(SrodekId)+"'"
    SQL+=" AND stzs.data='"+DataF+"' AND stzs.firma_id=rs_srodki_trwale.firma_id AND stzs.srodek_id=rs_srodki_trwale.srodek_id;"
    stat,dump,dump,dump=self.PolSQL.Execute(SQL,1)
    
    if stat=='OK':
        # przeliczamy warto stawki rodka
        from funkcje import fs_global_srodki_trwale
        stat=fs_global_srodki_trwale.PrzeliczWartoscSrodka(self,self.firma_id,SrodekId)          
    if stat=='OK':
        # Przeliczamy plan 
        from funkcje import fs_srodki_trwale_tworzenie_planu
        stat=fs_srodki_trwale_tworzenie_planu.StworzPlanSrodkaTrwalego(self.firma_id,SrodekId,self.PolSQL)         
                    
                
#-------------------------------------------------------------------------------
#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (5 -select, 3 -update z pobraniem, 1 -insert z pobraniem)
#-------------------------------------------------------------------------------
#-------------------------------------------------------------------------------

if (Funkcja in [5,3,1]) and (stat=='OK'):
    sql = "SELECT * FROM rs_srodki_trwale_zmiany_stawki "        
    sql += Filtr +";"
    
    # pobranie danych
    stat,dane,wyn1,tr = self.PolSQL.Execute(sql,3)
    if stat<> 'OK':
        stat='Bd zapytania pobierajcego dane'+stat
        dane.append(stat)
 