#!/usr/bin/python
# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_stany_kont.py
# Author:      Pawel Wojcikowski
# Created:     2009/08/10
# RCS-ID:      $Id: fs_stany_kont.py$
# Copyright:   (c) 2016 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------
# 2016-07-06 Piotr Witkowski  (9940) refaktoryzacja okna

stat='OK'
if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=='OK':
    Funkcja = klucze['Funkcja']
    SlPar={'Konto':[5,],'DataKsiegKosztow':[5,],}

    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Funkcja,klucze)
    if Lista<>'':
        stat='Uwaga : wywoanie funkcji fs_generator z numerem ' +str(Funkcja)+' bez parametrw: '+Lista

if stat=='OK':
    if Funkcja in [5,]:
        Konto = klucze['Konto']
        DataKsiegKosztow = klucze['DataKsiegKosztow']

if stat=='OK':
    dane = []
    wyn1 = []
    wyn2 = []

#Pobranie okresu dla dziaa w planie kont jeli podana jest data ksigowania kosztw
OkresAktywny=self.okres_id
if stat=='OK' and not DataKsiegKosztow in ['','    -  -  ',None]:
    if rsglobal.SprawdzCzyToData(DataKsiegKosztow):
        Select= "SELECT rsf_podaj_okres_dla_daty('"+self.firma_id+"','"+DataKsiegKosztow+"');"
        stat,DOkr,dump,dump = self.PolSQL.Execute(Select,3)
        if stat=='OK':
            if len(DOkr)>0:
                if DOkr[0][0]<> 'Brak':
                    OkresAktywny=rsglobal.Dekoduj(DOkr[0][0])


#-------------------------------------------------------------------------------
#---   SPRAWDZANIE DANYCH                                                       
#-------------------------------------------------------------------------------

if stat== 'OK' and Funkcja == 5 and Konto<>'':
    sql= "SELECT rsf_podaj_parametry_konta('"+str(self.firma_id)+"','"+str(OkresAktywny)+"','"+str(Konto)+"');"
    stat,d,wyn1,tr=self.PolSQL.Execute(sql,3)
    if stat<>'OK':
        stat='Bdy przy sprawdzaniu konta :'+stat
        dane.append(stat)
    elif len(d)==0:
        stat='BL KONTO'
        dane.append(stat)


#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (5 -select)                                              
#-------------------------------------------------------------------------------

if stat== 'OK' and Funkcja == 5:
    SQL="SELECT rok,miesiac,SUM(kwota_wn),SUM(kwota_ma),SUM(saldo_wn),SUM(saldo_ma),"
    SQL+="CASE WHEN SUM(kwota_wn)>SUM(kwota_ma) THEN SUM(kwota_wn)-SUM(kwota_ma) ELSE 0 END,"
    SQL+="CASE WHEN SUM(kwota_ma)>SUM(kwota_wn) THEN SUM(kwota_ma)-SUM(kwota_wn) ELSE 0 END,"
    SQL+="waluta,SUM(kwota_wal_wn),"
    SQL+="SUM(kwota_wal_ma),SUM(saldo_wal_wn),SUM(saldo_wal_ma) "
    SQL+="FROM rs_stany_kont WHERE firma_id='"+self.firma_id+"' AND okres_id='"+str(OkresAktywny)+"' "
    if Konto <> '':
        SQL +=" AND (konto='"+str(Konto)+"' OR "
        SQL +="'"+str(Konto)+"'||'-'=SUBSTRING(konto FROM 1 FOR LENGTH('"+str(Konto)+"')+1))"
    SQL+=" GROUP BY rok,miesiac,waluta ORDER BY rok,miesiac,waluta;"
    stat,dane,wyn1,tr = self.PolSQL.Execute(SQL,3)
    if stat<>'OK':
        stat='Bdy przy pobieraniu danych :'+stat
        dane.append(stat)