
# -*- coding: iso8859_2 -*-

#-----------------------------------------------------------------------------
# Name:        fs_systemowe_otworz_dokumenty_do_dnia.py
# Purpose:     otwiera dokumenty magazynowe i przeceny do wybranego dnia
#
# Author:      Micha Raburski
# Created:     2007/02/17
# RCS-ID:      $Id: fs_systemowe_otworz_dokumenty_do_dnia.py $
# Copyright:   (c) 2007 Record System
# Licence:     GNU GPL
#-----------------------------------------------------------------------------

Data=klucze[0]
stat='OK'
log='OtwieranieDokumentowDoDnia'+Data+'.log'

if self.operator_id <> STANDARD_OPERATOR_ID:
    stat=' Brak uprawnie do wykonania funkcji'

# blokada na czas naprawy funkcji
if False:
    if stat=='OK':    
        rsglobal.ZapiszDoPliku('   ',log)
        rsglobal.ZapiszDoPliku(' POCZTEK OTWIERANIA DOKUMENTW DO DNIA '+Data,log)
        rsglobal.ZapiszDoPliku('   ',log)
        #Pobieranie danych
        rsglobal.ZapiszDoPliku(' Pobieranie danych',log)
        stat,DMag1,DMag2,dump=self.PolSQL.Execute("SELECT dm.magazyn_id,dm.dokument_id,dm.data,dm.numer,dm.stan,t.typ_dokumentu FROM rs_dokumenty_magazynowe dm INNER JOIN rs_typy_dokumentow_m t USING (firma_id,dokument_id) WHERE firma_id='"+self.firma_id+"' AND dm.data >= '"+Data+"' AND dm.stan <> 'W' ORDER BY dm.data desc,dm.magazyn_id, dm.numer desc;",3)
    if stat=='OK':
        rsglobal.ZapiszDoPliku(' Pobieranie dokumentw magazynowych - OK',log)
    else:
        stat='Bdy pobierania dokumentw magazynowych'
        rsglobal.ZapiszDoPliku(' Pobieranie dokumentw magazynowych - BDY',log)
    
    if stat=='OK':
        stat,DPrzec1,DPrzec2,dump=self.PolSQL.Execute("SELECT magazyn_id,data_przec,numer_przec FROM rs_przeceny WHERE firma_id='"+self.firma_id+"' AND data_przec >= '"+Data+"' AND stan ='Z' ORDER BY data_przec desc,z_czas desc;",3)
    if stat=='OK':
        rsglobal.ZapiszDoPliku(' Pobieranie dokumentw przeceny - OK',log)
    else:
        stat='Bdy pobierania dokumentw przeceny'
        rsglobal.ZapiszDoPliku(' Pobieranie dokumentw przeceny - BDY',log)
    
    if stat=='OK':
        #Obrbka dokumentow
        rsglobal.ZapiszDoPliku(' Obrbka danych',log)
        #Lista dokumentw magazynowych - magazyn,typ,data,numer,stan,typ
        try:
            LDM=[]
            for d in DMag1:
                rsglobal.ZapiszDoPliku('Dokument magazynowy '+d[0]+"/"+d[1]+"/"+d[2]+"/"+str(d[3])+' '+d[4]+' '+d[5],log)
                LDM.append((d[0],d[1],d[2],d[3],d[4],d[5]))
        except Exception,e:
            rsglobal.ZapiszDoPliku('Bd obrbki danych magazynowych '+str(e),log)
            stat='Bd obrbki danych magazynowych '+str(e)
        else:
            rsglobal.ZapiszDoPliku(' Obrbka dokumentw magazynowych - OK',log)
    
    if stat=='OK':
        #Obrbka przecen
        #Lista przecen - magazyn,data,numer
        try:
            LPR=[]
            for d in DPrzec1:
                LPR.append((d[0],d[1],d[2]))
        except Exception,e:
            rsglobal.ZapiszDoPliku('Bd obrbki dokumentw przeceny '+str(e),log)
            stat='Bd obrbki dokumentw przeceny '+str(e)
        else:
            rsglobal.ZapiszDoPliku(' Obrbka dokumentw przeceny - OK',log)
    
    if stat=='OK':
        #PRAWDZIWE OTWIERANIE. Najpierw otwierane s wszystkie dokumenty ze stanem G. Potem program, leci datami.    
        #Stara si otworzy dokumenty od najstarszych do najmodszych. Najpierw otwiera dokumenty wydania, potem przyjcia. 
        #Jeli czci nie otworzy to stara si otworzy ostatni zamykan przecen z tego dnia i dalej leci
        # w ptli z otwieraniem dokumentw. Albo otworzy wszystkie z dnia albo nie. Jeli nie to otwieranie jest przerywane i 
        # zwracana jest informacja, ktre dokumenty si nie otworzyy. Inaczej program przechodzi do kolejnego (poprzedniego) dnia.
        
        #Otwieranie dokumentw ze stanem 'G'
        rsglobal.ZapiszDoPliku(' OTWIERANIE dokumentw ze stanem G',log)
        
        #LDMUsuw=LDM
        LNieOtw=[]
        for d in LDM:
            if d[4]=='G':
                #self.PolSQL.Execute("BEGIN;",1)
                rsglobal.ZapiszDoPliku('DOKUM ='+self.firma_id+"','"+rsglobal.Dekoduj(d[0])+"','"+rsglobal.Dekoduj(d[1])+"','"+rsglobal.Dekoduj(d[2])+"',"+str(d[3]),log)
                stat,dump,dump,dump=self.PolSQL.Execute("SELECT rsf_dok_mag_do_edycji('"+self.firma_id+"','"+rsglobal.Dekoduj(d[0])+"','"+rsglobal.Dekoduj(d[1])+"','"+rsglobal.Dekoduj(d[2])+"',"+str(d[3])+");",1)
                if stat=="OK":
                    self.PolSQL.Commit()
                    rsglobal.ZapiszDoPliku(' Otwarcie dokumentu '+d[0]+"/"+d[1]+"/"+d[2]+"/"+str(d[3])+' do edycji - OK',log)
                    #LDMUsuw.remove((d[0],d[1],d[2],d[3],d[4],d[5]))
                    
                else:
                    self.PolSQL.Rollback()
                    rsglobal.ZapiszDoPliku(' Otwarcie dokumentu '+d[0]+"/"+d[1]+"/"+d[2]+"/"+str(d[3])+' do edycji - BD : '+stat,log)
                    LNieOtw.append(' '+str(d[0])+"/"+str(d[1])+"/"+str(d[2])+"/"+str(d[3])+',')
        
        #LDM=LDMUsuw
        rsglobal.ZapiszDoPliku('KONIEC OTWIERANIA dokumentw ze stanem G',log)        
        #po tym nie powinno by adnych dokumentw o stanie G
        Opis='Nie udao si otworzy do edycji nastpujcych dokumentw :'
        for d in LNieOtw:
            Opis=Opis+d
                
        if len(LNieOtw)>0:
            stat=Opis[0:-1]
        
    if stat=='OK':
        #Otwieranie dokumentw dniami
        stat,Dane,dump,dump=self.PolSQL.Execute("SELECT max(data) FROM rs_dokumenty_magazynowe WHERE firma_id='"+self.firma_id+"' AND data >= '"+Data+"' AND stan <> 'W';",3)
        stat,DaneP,dump,dump=self.PolSQL.Execute("SELECT max(data_przec) FROM rs_przeceny WHERE firma_id='"+self.firma_id+"' AND data_przec >= '"+Data+"' AND stan ='Z';",3)
        DataBufAkt=rsglobal.Dekoduj(str(Dane[0][0]))
        DataBufAktP=rsglobal.Dekoduj(str(DaneP[0][0]))
        if DataBufAkt=='None':
            if DataBufAktP=='None':
                DataAkt='1900-01-01'
            else:
                DataAkt=DataBufAktP
        elif DataBufAktP=='None':
            DataAkt=DataBufAkt
        else:
            if DataBufAkt>DataBufAktP:
                DataAkt=DataBufAkt
            else:
                DataAkt=DataBufAktP
                
        
        rsglobal.ZapiszDoPliku('Przeceny do otwarcia '+str(LPR),log)        
        # sprawdzanie daty w ptli
        while DataAkt > Data:
            rsglobal.ZapiszDoPliku('OTWIERANIE dokumentw z dnia '+DataAkt,log)        
            Zostaly = 1
            ZostalyArch=0
            while Zostaly > 0:
                # jesli nie bedzie zadnych dokumentow lub wszystkie uda sie otworzyc to nic nie zostanie i bedzie mozna przejsc do nastepnej daty
                Zostaly =0
                #Najpierw otwierane sa dokumenty rozchodowe
                rsglobal.ZapiszDoPliku('Dokumenty rozchodowe',log)        
                #LDMUsuw=LDM
                LDMUsuw=[]
                for d in LDM:
                    if d[5]=='W' and d[2]==DataAkt:
                        #self.PolSQL.Execute("BEGIN;",1)
                        stat,dane,nagl,dump=self.PolSQL.Execute("SELECT rsf_otworz_dok_mag('"+self.firma_id+"','"+rsglobal.Dekoduj(d[0])+"','"+rsglobal.Dekoduj(d[1])+"','"+rsglobal.Dekoduj(d[2])+"',"+str(d[3])+");",3)            
                        st=rsglobal.Dekoduj(dane[0][0])
                        #dokument cofniety do stanu G
                        if st=="OK":
                            rsglobal.ZapiszDoPliku(' Otwarcie dokumentu '+d[0]+"/"+d[1]+"/"+d[2]+"/"+str(d[3])+' - OK',log)
                            #otwarcie dokumentu do edycji
                            stat,dane,dump,dump=self.PolSQL.Execute("SELECT rsf_dok_mag_do_edycji('"+self.firma_id+"','"+rsglobal.Dekoduj(d[0])+"','"+rsglobal.Dekoduj(d[1])+"','"+rsglobal.Dekoduj(d[2])+"',"+str(d[3])+");",3)                                
                            st=rsglobal.Dekoduj(dane[0][0])
                            #jesli dokuemnt otwarty do edycji    
                            if st=="OK":
                                self.PolSQL.Commit()
                                rsglobal.ZapiszDoPliku(' Otwarcie dokumentu '+d[0]+"/"+d[1]+"/"+d[2]+"/"+str(d[3])+' do edycji - OK',log)
                                #LDMUsuw.remove((d[0],d[1],d[2],d[3],d[4],d[5]))
                            else:
                                self.PolSQL.Rollback()
                                rsglobal.ZapiszDoPliku(' Otwarcie dokumentu '+d[0]+"/"+d[1]+"/"+d[2]+"/"+str(d[3])+' do edycji - BD : '+st,log)
                                Zostaly=Zostaly+1
                                LDMUsuw.append(d)
                        else:
                            self.PolSQL.Rollback()
                            rsglobal.ZapiszDoPliku(' Otwarcie dokumentu '+d[0]+"/"+d[1]+"/"+d[2]+"/"+str(d[3])+' - BD : '+st,log)
                            Zostaly=Zostaly+1
                            LDMUsuw.append(d)
                    else:
                        LDMUsuw.append(d)
                            
    
                LDM=LDMUsuw
                LDMUsuw=[]
                
                #Otwierane sa dokumenty MM
                rsglobal.ZapiszDoPliku('Dokumenty mm',log)        
                for d in LDM:
                    if d[5]=='M' and d[2]==DataAkt:
                        #self.PolSQL.Execute("BEGIN;",1)
                        stat,dane,dump,dump=self.PolSQL.Execute("SELECT rsf_otworz_dok_mag('"+self.firma_id+"','"+rsglobal.Dekoduj(d[0])+"','"+rsglobal.Dekoduj(d[1])+"','"+rsglobal.Dekoduj(d[2])+"',"+str(d[3])+");",3)            
                        st=rsglobal.Dekoduj(dane[0][0])
                        #dokument cofniety do stanu G
                        if st=="OK":
                            rsglobal.ZapiszDoPliku(' Otwarcie dokumentu '+d[0]+"/"+d[1]+"/"+d[2]+"/"+str(d[3])+' - OK',log)
                            #otwarcie dokumentu do edycji
                            stat,dane,dump,dump=self.PolSQL.Execute("SELECT rsf_dok_mag_do_edycji('"+self.firma_id+"','"+rsglobal.Dekoduj(d[0])+"','"+rsglobal.Dekoduj(d[1])+"','"+rsglobal.Dekoduj(d[2])+"',"+str(d[3])+");",3)                                
                            st=rsglobal.Dekoduj(dane[0][0])
                            #jesli dokuemnt otwarty do edycji    
                            if st=="OK":
                                self.PolSQL.Commit()
                                rsglobal.ZapiszDoPliku(' Otwarcie dokumentu '+d[0]+"/"+d[1]+"/"+d[2]+"/"+str(d[3])+' do edycji - OK',log)
                                #LDMUsuw.remove((d[0],d[1],d[2],d[3],d[4],d[5]))
                            else:
                                self.PolSQL.Rollback()
                                rsglobal.ZapiszDoPliku(' Otwarcie dokumentu '+d[0]+"/"+d[1]+"/"+d[2]+"/"+str(d[3])+' do edycji - BD : '+st,log)
                                Zostaly=Zostaly+1
                                LDMUsuw.append(d)
                        else:
                            self.PolSQL.Rollback()
                            rsglobal.ZapiszDoPliku(' Otwarcie dokumentu '+d[0]+"/"+d[1]+"/"+d[2]+"/"+str(d[3])+' - BD : '+st,log)
                            Zostaly=Zostaly+1
                            LDMUsuw.append(d)
                    else:
                        LDMUsuw.append(d)
                            
                            
                LDM=LDMUsuw
                LDMUsuw=[]
                
                #Otwierane sa dokumenty przychodowe
                rsglobal.ZapiszDoPliku('Dokumenty przychodowe',log)        
                for d in LDM:
                    if d[5]=='P' and d[2]==DataAkt:
                        #self.PolSQL.Execute("BEGIN;",1)
                        stat,dane,dump,dump=self.PolSQL.Execute("SELECT rsf_otworz_dok_mag('"+self.firma_id+"','"+rsglobal.Dekoduj(d[0])+"','"+rsglobal.Dekoduj(d[1])+"','"+rsglobal.Dekoduj(d[2])+"',"+str(d[3])+");",3)            
                        st=rsglobal.Dekoduj(dane[0][0])
                        #dokument cofniety do stanu G
                        if st=="OK":
                            rsglobal.ZapiszDoPliku(' Otwarcie dokumentu '+d[0]+"/"+d[1]+"/"+d[2]+"/"+str(d[3])+' - OK',log)
                            #otwarcie dokumentu do edycji
                            stat,dane,dump,dump=self.PolSQL.Execute("SELECT rsf_dok_mag_do_edycji('"+self.firma_id+"','"+rsglobal.Dekoduj(d[0])+"','"+rsglobal.Dekoduj(d[1])+"','"+rsglobal.Dekoduj(d[2])+"',"+str(d[3])+");",3)                                
                            st=rsglobal.Dekoduj(dane[0][0])
                            #jesli dokument otwarty do edycji    
                            if st=="OK":
                                self.PolSQL.Commit()
                                rsglobal.ZapiszDoPliku(' Otwarcie dokumentu '+d[0]+"/"+d[1]+"/"+d[2]+"/"+str(d[3])+' do edycji - OK',log)
                                #LDMUsuw.remove((d[0],d[1],d[2],d[3],d[4],d[5]))
                            else:
                                self.PolSQL.Rollback()
                                rsglobal.ZapiszDoPliku(' Otwarcie dokumentu '+d[0]+"/"+d[1]+"/"+d[2]+"/"+str(d[3])+' do edycji - BD : '+str(st),log)
                                Zostaly=Zostaly+1
                                LDMUsuw.append(d)
                        else:
                            self.PolSQL.Rollback()
                            rsglobal.ZapiszDoPliku(' Otwarcie dokumentu '+d[0]+"/"+d[1]+"/"+d[2]+"/"+str(d[3])+' - BD : '+str(st),log)
                            Zostaly=Zostaly+1
                            LDMUsuw.append(d)
                    else:
                        LDMUsuw.append(d)
                            
                LDM=LDMUsuw            
                            
                #jesli wszystkie dokumenty z dnia sa otwarte to mozna otworzyc wszystkie przeceny - inaczej tylko 1
                WszystkieP=(Zostaly==0)
                #Czy Otwierac przecene
                OtwPrzec=True
                
                LPRUsuw=[]
                
                rsglobal.ZapiszDoPliku('Przeceny',log)        
                for d in LPR:
                    rsglobal.ZapiszDoPliku(str(d),log)        
                    rsglobal.ZapiszDoPliku(str(d[1]),log)        
                    rsglobal.ZapiszDoPliku(DataAkt,log)        
                    if d[1]==DataAkt:
                        rsglobal.ZapiszDoPliku('111',log)        
                        if OtwPrzec or WszystkieP:
                            rsglobal.ZapiszDoPliku('222',log)        
                            #self.PolSQL.Execute("BEGIN;",1)
                            stat,dane,dump,dump=self.PolSQL.Execute("SELECT rsf_otworz_przecene('"+self.firma_id+"','"+rsglobal.Dekoduj(d[0])+"','"+rsglobal.Dekoduj(d[1])+"',"+str(d[2])+");",3)            
                            rsglobal.ZapiszDoPliku('333 '+str(stat),log)        
                            if stat=='OK':
                                st=rsglobal.Dekoduj(dane[0][0])
                                if st=="OK":
                                    self.PolSQL.Commit()
                                    rsglobal.ZapiszDoPliku(' Otwarcie przeceny '+d[0]+"/"+d[1]+"/"+str(d[2])+' do edycji - OK',log)
                                    OtwPrzec=False
                                else:
                                    self.PolSQL.Rollback()
                                    rsglobal.ZapiszDoPliku(' Otwarcie przeceny '+d[0]+"/"+d[1]+"/"+str(d[2])+' do edycji - BD : '+str(st),log)
                                    Zostaly=Zostaly+1
                                    LPRUsuw.append(d)
                            else:
                                self.PolSQL.Rollback()
                                rsglobal.ZapiszDoPliku(' Otwarcie przeceny '+d[0]+"/"+d[1]+"/"+str(d[2])+' - BD : '+str(stat),log)
                                Zostaly=Zostaly+1
                                LPRUsuw.append(d)
                        else:
                            LPRUsuw.append(d)
    
                    else:
                        LPRUsuw.append(d)
                            
                LPR=LPRUsuw            
                
                #nic nie otworzyl podczas calego przebiegu
                if Zostaly==ZostalyArch:
                    #w poprezednim przebiegu otworzyl wszystko
                    if Zostaly==0:
                        stat=="OK"
                    else:
                        #zostay nieotwarte dokumenty, ale nie da si ich otworzy
                        Zostaly=0   #by wyszed z ptli
                        stat= ' pozostay nieotwarte dokumenty:'
                        for d in LDM:
                            if d[2]==DataAkt:
                                stat=stat+' '+d[0]+"/"+d[1]+"/"+d[2]+"/"+str(d[3])+','
                        for d in LPR:
                            if d[2]==DataAkt:
                                stat=stat+' '+d[0]+"/"+d[1]+"/"+str(d[2])+','
                        stat=stat[0:-1]
                else:
                    #co zostao otwarte i trzeba powtrzy przebieg
                    ZostalyArch=Zostaly
                    
            
            if stat=="OK":
                stat,Dane,dump,dump=self.PolSQL.Execute("SELECT date '"+DataAkt+"' - integer '1';",3)
                DataAkt=rsglobal.Dekoduj(str(Dane[0][0]))
            else:
                DataAkt=Data #by wyszo w nastpnym przebiegu
    
    
    if stat <> "OK":
        rsglobal.ZapiszDoPliku(' Otwieranie nieudane - '+stat,log)
    else:
        rsglobal.ZapiszDoPliku(' KONIEC OTWIERANIA DOKUMENTW DO DNIA '+Data,log)

