# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_artykuly_cechy_wartosci.py
# Purpose:     obsluga grida edytowalnego wartosci dla cechy artykulu
# Author:      Mariusz Rajfura, Micha Raburski
# Created:     2013/05/31
# RCS-ID:      $Id: fs_artykuly_cechy_wartosci $
# Copyright:   (c) 2013 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

import binascii

from funkcje import fs_artykuly_cechy_pom
stat='OK'

if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=='OK':
    Funkcja = klucze['Funkcja']
    
    SlPar={'FNumer':[1,5],'FOpis':[1,5], 'FZapytanie':[1,5],'TestId':[9]}
    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Funkcja,klucze)
    if Lista<>'':
        stat='Uwaga : wywoanie funkcji fs_testy_kompletnosci z numerem '+str(Funkcja)+' bez parametrw: '+Lista
        
    if Funkcja in [1,5]:
        FNumer = klucze['FNumer']
        FOpis = klucze['FOpis']
        FZapytanie = klucze['FZapytanie']
    if Funkcja == 9: 
        TestId = klucze['TestId']
        
dane = []
wyn1 = []
wyn2 = []


#-------------------------------------------------------------------------------
#-------- WYKONANIE TESTOWEGO TESTU (9)
#-------------------------------------------------------------------------------

if Funkcja == 9 and stat=="OK":            
    from funkcje import fs_testy_kompletnosci_pom
    stat,dane,dump,dump = fs_testy_kompletnosci_pom.WykonajTestKompletnosci(self,TestId)
    rsglobal.ZapiszDoLogow('stat '+stat,1)
    if stat == 'OK':
       dane=binascii.hexlify(dane)

#-------------------------------------------------------------------------------
#-------- EDYCJA GRIDA EDYTOWALNEGO (1)
#-------------------------------------------------------------------------------

Insert = []
Update = []
Delete = []

if stat=='OK' and Funkcja == 1:
    Update=klucze['Update']
    Insert=klucze['Insert']
    Delete=klucze['Delete']

#-------------------------------------------------------------------------------
#-------  SPRAWDZANIE DELETE  --------------------------------------------------
#-------------------------------------------------------------------------------

if Funkcja == 1 and stat=="OK":
    if len(Delete[0])>0:
        # wykonanie DELETE 
        if stat == 'OK':
            SQLDEL = ''
            SQLFU = ''
            for i in xrange(len(Delete[0])):
                SQLFU+="SELECT raport_id FROM rs_testy_kompletnosci"
                SQLFU+=" WHERE firma_id='"+self.firma_id+"'"
                DELETE = "DELETE FROM rs_testy_kompletnosci "
                WHERE = "WHERE firma_id='"+self.firma_id+"'"
                for j in xrange(len(Delete[0][i])):
                    pole = Delete[1][j]
                    wart = Delete[0][i][j]
                    WHERE += " AND "+pole+"='"+str(wart)+"'"
                    SQLFU += " AND "+pole+"='"+str(wart)+"'"
                
                SQLDEL += DELETE+WHERE+"; "
                SQLFU += " FOR UPDATE NOWAIT; "
                
            if stat == "OK" and SQLFU <> '':
                stat,d,dump,dump = self.PolSQL.Execute(rsglobal.Dekoduj(SQLFU),3)
                if stat <> 'OK':
                    stat = 'Bd sprawdzenia danych do usunicia: '+stat
                    dane.append(stat)

            if stat == "OK" and SQLDEL <> '':
                stat,dump,dump,dump = self.PolSQL.Execute(rsglobal.Dekoduj(SQLDEL),1)
                if stat <> 'OK':
                    stat = "Bd przy usuwaniu danych: "+stat   
                    dane.append(stat)


#-------------------------------------------------------------------------------
#---   UPDATE DANYCH (1)
#-------------------------------------------------------------------------------

if Funkcja == 1 and stat=="OK":
    if len(Update[0])>0:
        SQLFU = ''
        for i in xrange(len(Update[0])):
            SQLFU+="SELECT raport_id FROM rs_testy_kompletnosci"
            SQLFU+=" WHERE firma_id='"+self.firma_id+"'"
            for j in xrange(len(Update[2][i])): # petla po kluczu
                pole = Update[3][j]
                wart = rsglobal.Dekoduj(Update[2][i][j])
                SQLFU += " AND "+pole+"='"+str(wart)+"'"
            
            SQLFU += " FOR UPDATE NOWAIT; "
        
        if SQLFU <> '' and stat == "OK":
            stat,d,dump,dump = self.PolSQL.Execute(rsglobal.Dekoduj(SQLFU),3)
            if stat <> 'OK':
                stat = 'Bd zablokowania danych do modyfikacji: '+stat
                dane.append(stat)
            
        if stat == 'OK':
            WierszeNr = Update[-1]

            for i in xrange(len(Update[0])):
                WartoscNowa = None

                for j in xrange(len(Update[0][i])): 
                    pole = Update[0][i][j]
                    wart = Update[1][i][j]

                    if pole == 'nazwa':
                        if wart.strip() == '':
                            stat = 'NAZWA BR'
                            wyn2.append((WierszeNr[i],1))
                            dane.append(stat)
                    elif pole == 'zapytanie':
                        if wart.strip() == '':
                            stat = 'ZAPYT BR'
                            wyn2.append((WierszeNr[i],2))
                            dane.append(stat)
                        elif 'UPDATE' in wart.upper():
                            stat = 'ZAPYT UPDATE'
                            wyn2.append((WierszeNr[i],2))
                            dane.append(stat)
                        elif 'DELETE' in wart.upper():
                            stat = 'ZAPYT DELETE'
                            wyn2.append((WierszeNr[i],2))
                            dane.append(stat)    
                        elif 'INSERT' in wart.upper():
                            stat = 'ZAPYT INSERT'
                            wyn2.append((WierszeNr[i],2))
                            dane.append(stat)    
                        elif 'DROP' in wart.upper():
                            stat = 'ZAPYT DROP'
                            wyn2.append((WierszeNr[i],2))
                            dane.append(stat)    
                        elif 'ALTER' in wart.upper():
                            stat = 'ZAPYT ALTER'
                            wyn2.append((WierszeNr[i],2))
                            dane.append(stat)
                        elif 'TRUNCATE' in wart.upper():
                            stat = 'W zapytaniu nie mona uywa sowa kluczowego TRUNCATE'
                            wyn2.append((WierszeNr[i],2))
                            dane.append(stat)
                            
                            
        if stat == 'OK':
            if len(dane) > 0:
                stat = dane[0]
                
        # wykonanie UPDATE
        if stat=='OK':
            sql=''
            for i in xrange(len(Update[0])):
                UPDATE="UPDATE rs_testy_kompletnosci "
                SET='SET '
                for j in xrange(len(Update[0][i])): 
                    pole=Update[0][i][j]
                    wart=Update[1][i][j]
                    if pole in ['nazwa','zapytanie','powiadomienia']:
                        SET+=pole+"='"+wart.replace("'","\\'")+"',"

                SET=SET.strip(",")
                WHERE=" WHERE firma_id='"+self.firma_id+"'"
                for j in xrange(len(Update[2][i])): # petla po kluczu
                    pole=Update[3][j]
                    wart=rsglobal.Dekoduj(Update[2][i][j])
                    WHERE+= " AND "+pole+"='"+str(wart)+"'"

                WHERE+=";"
                
                sql+=UPDATE+SET+WHERE;
                
            if sql<>'':
                stat,dump,dump,dump=self.PolSQL.Execute(rsglobal.Dekoduj(sql),1)
                if stat<>'OK':
                    stat="Bd przy modyfikowaniu danych: "+stat   
                    dane.append(stat)


#-------------------------------------------------------------------------------
#---------Sprawdzanie danych do Insert------
#-------------------------------------------------------------------------------

if Funkcja == 1 and stat=="OK":
    if len(Insert[0])>0:
        WierszeNr = Insert[-1]
        for i in xrange(len(Insert[0])):
            WartoscNowa = None
            
            for j in xrange(len(Insert[0][i])): 
                pole=Insert[1][j]
                wart=Insert[0][i][j]

                if pole == 'nazwa':
                    if wart.strip() == '':
                        stat = 'NAZWA BR'
                        wyn2.append((WierszeNr[i],1))
                        dane.append(stat)
                elif pole == 'zapytanie':
                    if wart.strip() == '':
                        stat = 'ZAPYT BR'
                        wyn2.append((WierszeNr[i],2))
                        dane.append(stat)
                    elif 'UPDATE' in wart.upper():
                        stat = 'ZAPYT UPDATE'
                        wyn2.append((WierszeNr[i],2))
                        dane.append(stat)
                    elif 'DELETE' in wart.upper():
                        stat = 'ZAPYT DELETE'
                        wyn2.append((WierszeNr[i],2))
                        dane.append(stat)    
                    elif 'INSERT' in wart.upper():
                        stat = 'ZAPYT INSERT'
                        wyn2.append((WierszeNr[i],2))
                        dane.append(stat)    
                    elif 'DROP' in wart.upper():
                        stat = 'ZAPYT DROP'
                        wyn2.append((WierszeNr[i],2))
                        dane.append(stat)    
                    elif 'ALTER' in wart.upper():
                        stat = 'ZAPYT ALTER'
                        wyn2.append((WierszeNr[i],2))
                        dane.append(stat)
                    elif 'TRUNCATE' in wart.upper():
                        stat = 'W zapytaniu nie mona uywa sowa kluczowego TRUNCATE'
                        wyn2.append((WierszeNr[i], 2))
                        dane.append(stat)

        if stat == 'OK':
            if len(dane) > 0:
                stat = dane[0]

        # wykonanie INSERT
        if stat == 'OK':
            sqlIns=''
            for i in xrange(len(Insert[0])):
                INSERT="INSERT INTO rs_testy_kompletnosci "
                KOLUMNY="(firma_id"
                VALUES=" VALUES ('"+self.firma_id+"'"
                for j in xrange(len(Insert[0][i])):
                    pole=Insert[1][j]
                    wart=Insert[0][i][j]
                    if pole in ['nazwa','zapytanie','powiadomienia']:
                        KOLUMNY+=","+pole
                        VALUES+=",'"+wart.replace("'","\\'")+"'"

                KOLUMNY+=")"
                VALUES+=");"
                sqlIns+=INSERT+KOLUMNY+VALUES
            if sqlIns<>'': 
                stat,dump,dump,dump=self.PolSQL.Execute(rsglobal.Dekoduj(sqlIns),1)
                if stat<>'OK':
                    stat="Bd przy dodawaniu danych: "+stat
                    dane.append(stat)


#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (1- insert 1 -select, 1 -delete, 5 -select) 
#-------------------------------------------------------------------------------

if Funkcja in (1,5) and stat=='OK':
    rsglobal.ZapiszDoLogow('1 '+str(FNumer)+' '+str(FNumer == 0)+' '+str(FNumer == '0')+' '+str(FNumer <> '0'),1)
    SQL ="SELECT raport_id,nazwa,zapytanie,powiadomienia"
    SQL+=" FROM rs_testy_kompletnosci"
    SQL+=" WHERE firma_id='"+self.firma_id+"'"
    if int(FNumer) <> 0:
        SQL+="AND raport_id="+FNumer
    if FOpis <> '':
        SQL+=" AND nazwa LIKE '"+FOpis+"%'"
    if FZapytanie <> '':
        SQL+=" AND zapytanie LIKE '"+FZapytanie+"%'"
    SQL+=" ORDER BY raport_id;"

    stat,dane,wyn1,wyn2 = self.PolSQL.Execute(SQL,3)
    if stat <> 'OK':
        stat = "Bd przy pobieraniu danych: "+stat
