# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_testy_kompletnosci_pom.py
# Purpose:     obsluga testw kompletnoci
# Author:      Micha Raburski
# Created:     2014/08/06
# RCS-ID:      $Id: fs_testy_kompletnosci_pom$
# Copyright:   (c) 2014 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

# funkcja pobierajca z bazy tre raportu do wykonania 
# i wykonujca go. Zwraca status operacji, dane w postaci CSV i list maili do powiadomienia

def WykonajTestKompletnosci(self,Nr):
    import rsglobal
    Tresc = ''
    LPowiad = []
    Nazwa = ''

    # pobranie definicji testu
    SQL = "SELECT nazwa,zapytanie,powiadomienia FROM rs_testy_kompletnosci "
    SQL+=" WHERE firma_id='"+self.firma_id+"' AND raport_id="+str(Nr)
    stat,DTest,dump,dump = self.PolSQL.Execute(SQL,3)
    if stat <> 'OK':
        return "Bd przy pobieraniu definicji testu "+str(Nr)+": "+stat,'',[],''
    
    if len(DTest) == 0:
        return "Brak definicji testu "+str(Nr)+" dla firmy "+self.firma_id,'',[],''
    
    # wykonanie testu
    stat,DDane,wyn1,dump = self.PolSQL.Execute(DTest[0][1].replace("`","'"),3,None,False,True)
    if stat <> 'OK':
        return "Bd przy wykonaniu testu "+str(Nr)+": "+stat,'',[],Nazwa
    
    # obrobienie wyniku w celu stworzenia CSV
    if len(DDane)>0:
        # wstawienie nazwy raportu
        Tresc=DTest[0][0]+'\n'
        Nazwa=DTest[0][0]
        
        # wstawienie nazw kolumn
        for pole in wyn1:
            Tresc+=pole[0]+';'
        Tresc=Tresc.strip(';')
        Tresc+='\n'

        # obrbka danych w celu optymalizacji czasu wykonania
        LDane =[]
        for poz in DDane:
            i = 1
            for pole in poz:
                wart = str(pole)
                # w liczbach zmieniamy kropk na przecinek
                if isinstance(pole,float) or isinstance(pole,int):
                    wart = wart.replace('.',',')
                
                if i < len(poz):
                    LDane.append(wart+';')
                else:
                    LDane.append(wart+'\n')
                i += 1
        
        # wstawienie danych
        Tresc=Tresc+"".join(LDane)
        Tresc=Tresc.strip('\n')
        
        LPowiad = DTest[0][2].split(',')

    return 'OK',Tresc,LPowiad,Nazwa