# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_typy_dokumentow_magazynowych_dane.py  
# Author:      Pawe Wjcikowski
# Created:     2009/11/22 
# RCS-ID:      $Id: fs_typy_dokumentow_magazynowych_dane.py $
# Copyright:   (c) 2009 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

# 2011-01-25 Mariusz Rajfura - nowe pole 'czy_wplywa_na_zamowienia' (4226)
# 2011-11-10 Mariusz Rajfura - blokada recznego zalozenia dokumentu o symbolu 'PR' (5194)
# 2013-07-30 Mariusz Rajfura (7069) nowe pola: 'korekta', 'korekta_do'
                                    
DokumentId=rsglobal.Dekoduj(klucze[0])

Fun=klucze[-1] 

stat="OK"
dane=[]

UprDodawanie=(((self.oddzial_id,'014013') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID))
UprEdycja=(((self.oddzial_id,'014012') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)) or UprDodawanie


#-------------------------------------------------------------------------------
#---   INSERT DANYCH (2- bez pobierania,1- z pobieraniem)
#-------------------------------------------------------------------------------

if Fun in [1,2]:
    if not UprDodawanie:
        stat = 'Brak uprawnie do dodawania danych'
        dane.append(stat)
    
    if stat=='OK':
        if DokumentId=='PR':
            stat="Symbol dokumentu 'PR' jest wykorzystywany do przecen i nie moe by uyty."
    
    if stat=="OK":   
        if DokumentId=='':
            stat='DOK_PUS'
            dane.append(stat)      
        else:      
            #Sprawdzenie klucza czy podany symbol nie jest juz w bazie
            Select="SELECT * FROM rs_typy_dokumentow_m WHERE firma_id='"+self.firma_id+"' AND "
            Select+="dokument_id='"+DokumentId+"';"
            stat,Dane,dump,dump=self.PolSQL.Execute(Select,3)
            if stat=='OK':
                if len(Dane)<>0:
                    stat='DOK_ISTN'
                    dane.append(stat) 
            else:
                stat = 'Bdy sprawdzania danych : '+stat
                dane.append(stat)                      
    if stat=='OK':
        CzyWplywaNaZamowienia = False
        TypDokumentu = None
        for i in range(len(pola)):
            pole = pola[i]
            wart = wartosci[i]           
            if pole=="nazwa_dokumentu":
                if wart=='' :
                    stat="BR_NAZWA"   
                    dane.append(stat)
            elif pole=="typ_dokumentu":
                TypDokumentu = rsglobal.Dekoduj(wart).strip()
            elif pole=="czy_wplywa_na_zamowienie":
                CzyWplywaNaZamowienia = wart
        
        if stat == 'OK':
            if len(dane) > 0:
                stat = dane[0]
        
        if stat == 'OK' and TypDokumentu <> 'P' and CzyWplywaNaZamowienia:
            stat = 'BL_WPLYWA_NA_ZAMOWIENIA'
            dane.append(stat)
      
    if stat=='OK':
        ins = "INSERT INTO rs_typy_dokumentow_m"
        Pola="firma_id,dokument_id"
        Wartosci="'"+self.firma_id+"','"+DokumentId+"'"
        for i in range(len(pola)):
            pole = pola[i]
            wart = wartosci[i]               
            if pole in ['typ_dokumentu','nazwa_dokumentu','czy_kontrahent',
                'czy_zlecenie','czy_konto_kosztow','czy_faktura','czy_poddokumenty',
                'czy_miejsce','czy_wartosci','czy_dostawca','czy_dostawca_z_korekty',
                'czy_sprzedaz','czy_urzadzenia','czy_projekt','czy_wplywa_na_zamowienia',
                'korekta']:
                Pola= Pola+","+pole
                Wartosci= Wartosci+",'"+str(wart)+"'"
            elif pole in ['korekta_do']:
                Pola= Pola+","+pole
                if wart=='    -  -  ' or wart=='':
                    Wartosci= Wartosci+",NULL"
                else:
                    Wartosci= Wartosci+",'"+wart+"'"
        ins = ins+" ("+Pola+") VALUES ("+Wartosci+");"        
        stat,dump,dump,dump = self.PolSQL.Execute(ins ,1)
        if stat<>'OK':
            stat = 'Bdy dodawania danych : '+stat
            dane.append(stat)             


#-------------------------------------------------------------------------------
#---   UPDATE DANYCH (4- bez pobierania,3- z pobieraniem)
#-------------------------------------------------------------------------------

if Fun in [4,3]:       
    if not UprEdycja:
        stat = 'Brak uprawnie do modyfikowania danych'
        dane.append(stat) 
        
    if stat=='OK':        
        for i in range(len(pola)):
            pole = pola[i]
            wart = wartosci[i]           
            if pole=="nazwa_dokumentu":
                if wart=='' :
                    stat="BR_NAZWA"   
                    dane.append(stat)
                elif pole=="czy_wplywa_na_zamowienia":
                    sql ="SELECT typ_dokumentu='P' FROM rs_typy_dokumentow_m"
                    sql+=" WHERE firma_id='"+self.firma_id+"' AND dokument_id='"+DokumentId+"';"
                    stat,d,dump,dump = self.PolSQL.Execute(sql,3)
                    if stat <> 'OK':
                        stat = 'Bd sprawdzenia typu dokumentu: '+stat
                        dane.append(stat)
                    elif len(d) <> 1:
                        stat = 'Brak dokumentu o podanym symbolu.'
                        dane.append(stat)
                    elif not d[0][0]:
                        stat = 'BL_WPLYWA_NA_ZAMOWIENIA'
                        dane.append(stat)
    
    if stat == 'OK':
        if len(dane) > 0:
            stat = dane[0]
                            
    #--- zapis
    if stat == 'OK':
        where = " WHERE firma_id='"+self.firma_id+"' AND dokument_id='"+DokumentId+"';"
        upd = "UPDATE rs_typy_dokumentow_m SET "
        for i in range(len(pola)):
            pole = pola[i]
            wart = wartosci[i]
            if pole in ['dokument_id','typ_dokumentu','nazwa_dokumentu','typ_wydruku','czy_kontrahent',
                        'czy_zlecenie','czy_konto_kosztow','czy_faktura','czy_poddokumenty',
                        'czy_miejsce','czy_wartosci','czy_dostawca','czy_dostawca_z_korekty',
                        'czy_sprzedaz','czy_urzadzenia','czy_projekt','czy_wplywa_na_zamowienia',
                        'korekta','korekta_do']:
                if wart=='    -  -  ' or wart=='':
                    upd=upd+pole+"=NULL,"
                else:
                    upd=upd+pole+"='"+str(wart)+"',"
        upd = upd[0:len(upd)-1]+where            
        stat,dump,dump,dump = self.PolSQL.Execute(upd ,1)
        if stat<>'OK':
            stat = 'Bdy zapisu danych : '+stat
            dane.append(stat)
                                   
                                   
#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (5 -select, 3 -update z pobraniem, 1 -insert z pobraniem)
#-------------------------------------------------------------------------------

if (Fun in [5,3,1]) and (stat=='OK'):
    Select= "SELECT * FROM rs_typy_dokumentow_m WHERE firma_id='"+self.firma_id+"' AND dokument_id='"+DokumentId+"';"
    stat,dane,wyn1,tr = self.PolSQL.Execute(Select,3)
    if stat<>'OK':
        stat = 'Bdy pobierania danych : '+stat
        dane.append(stat)