# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_uboje_kontrahenci.py
# Purpose:     grid podgladu kontrahentow z modulu linii ubojowej
#              uprawnienia identyczne, jak fs_kontrahenci.py
# Author:      Mariusz Rajfura
# Created:     2013/09/09
# RCS-ID:      $Id: fs_uboje_kontrahenci.py
# Copyright:   (c) 2013 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

stat = 'OK'
dane = []
wyn1 = []
wyn2 = {}

if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=='OK':
    Funkcja = klucze['Funkcja']
    
    SlPar={'KontrahentF':(5,), 'NazwaF':(5,), 'MiejscowoscF':(5,)}
    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Funkcja,klucze)
    if Lista<>'':
        stat='Uwaga : wywoanie funkcji fs_uboje_kontrahenci z numerem '+str(Funkcja)+' bez parametrw: '+Lista
        
    if Funkcja in (5,): 
        KontrahentF = rsglobal.Dekoduj(klucze['KontrahentF'])
        NazwaF = rsglobal.Dekoduj(klucze['NazwaF'])
        MiejscowoscF = rsglobal.Dekoduj(klucze['MiejscowoscF'])


#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (5)
#-------------------------------------------------------------------------------

if Funkcja in (5,) and stat=='OK':
    SQL ="SELECT kontrahent_id,nazwa,COALESCE(nip,''),COALESCE(adr_miej,'')"
    SQL+=" FROM rs_kontrahenci"
    SQL+=" WHERE firma_id='"+self.firma_id+"' AND aktywny"
    if KontrahentF <> '':
        SQL+=" AND UPPER(kontrahent_id) LIKE UPPER('"+KontrahentF+"%')"

    if NazwaF <> '':
        SQL+=" AND UPPER(nazwa) LIKE UPPER('"+NazwaF+"%')"

    if MiejscowoscF <> '':
        SQL+=" AND UPPER(adr_miej) LIKE UPPER('"+MiejscowoscF+"%')"
        
    SQL+=" ORDER BY kontrahent_id;"
    
    stat,dane,wyn1,dump = self.PolSQL.Execute(SQL,3)
    if stat <> 'OK':
        stat = "Bd przy pobieraniu danych: "+stat
        dane.append(stat)
