# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_uboje_poltusze.py
# Purpose:     grid poltusz dla uboju
# Author:      Mariusz Rajfura
# Created:     2013/09/10
# RCS-ID:      $Id: fs_uboje_poltusze.py
# Copyright:   (c) 2013 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

# 2013-10-18 Mariusz Rajfura (7272) nowe pole 'recznie', usuwanie 'recznych' wpisow

stat = 'OK'
dane = []
wyn1 = []
wyn2 = {}

if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=='OK':
    Funkcja = klucze['Funkcja']
    
    SlPar={'Data':(5,6), 'NumerUboju':(5,6),
           'NumerUbojowy':(6,), 'NumerPoltuszy':(6,)}
           
    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Funkcja,klucze)
    if Lista<>'':
        stat='Uwaga : wywoanie funkcji fs_uboje_poltusze z numerem '+str(Funkcja)+' bez parametrw: '+Lista
        
    if Funkcja in (5,6): 
        Data = rsglobal.Dekoduj(klucze['Data'])
        NumerUboju = rsglobal.Dekoduj(klucze['NumerUboju'])

    if Funkcja in (6,): 
        NumerUbojowy = rsglobal.Dekoduj(klucze['NumerUbojowy'])
        NumerPoltuszy = rsglobal.Dekoduj(klucze['NumerPoltuszy'])


UprUsuwanie = (((self.oddzial_id,'603004') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID))

if Funkcja in (6,) and stat == 'OK':
    if not UprUsuwanie:
        stat = 'BR UPR DEL'


#-------------------------------------------------------------------------------
#--- USUWANIE POLTUSZY (6)
#-------------------------------------------------------------------------------

if Funkcja == 6 and stat == 'OK':

    # sprawdzenie danych uboju
    sql ="SELECT stan FROM rs_uboje"
    sql+=" WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+self.oddzial_id+"'"
    sql+=" AND data='"+Data+"' AND numer_uboju="+str(NumerUboju)+"; "

    stat,uboj,dump,dump = self.PolSQL.Execute(sql,3)
    if stat <> 'OK':
        stat = 'Bd pobrania danych uboju: '+sql
    elif len(uboj) == 0:
        stat = 'Brak uboju o podanym kluczu'
    elif uboj[0][0] <> 'G':
        stat = 'Ubj w stanie '+uboj[0][0]+'. Usuwanie danych niemoliwe.'

    if stat == 'OK':
        sql ="SELECT recznie FROM rs_uboje_poltusze"
        sql+=" WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+self.oddzial_id+"'"
        sql+=" AND data='"+Data+"' AND numer_uboju="+str(NumerUboju)
        sql+=" AND numer_ubojowy="+str(NumerUbojowy)+" AND numer_poltuszy="+str(NumerPoltuszy)
        sql+=" FOR UPDATE NOWAIT; "
        
        stat,d,dump,dump = self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Bd sprawdzenie usuwanej pozycji: '+stat
        elif len(d) == 0:
            stat = 'Brak pozycji o podanym kluczu'
        elif not d[0][0]:
            stat = 'Pozycja dodana na stanowisku ubojowym. Usunicie niemoliwe.'

    if stat == 'OK':
        DELETE ="DELETE FROM rs_uboje_poltusze"
        DELETE+=" WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+self.oddzial_id+"'"
        DELETE+=" AND data='"+Data+"' AND numer_uboju="+str(NumerUboju)
        DELETE+=" AND numer_ubojowy="+str(NumerUbojowy)+" AND numer_poltuszy="+str(NumerPoltuszy)+"; "

        stat,dump,dump,dump = self.PolSQL.Execute(DELETE,1)
        if stat <> 'OK':
            stat = 'Bd usuwania pozycji: '+stat
            

#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (5)
#-------------------------------------------------------------------------------

if Funkcja in (5,6) and stat=='OK':
    SQL ="SELECT p.numer_ubojowy,p.numer_poltuszy,p.artykul_id,a.nazwa,"
    SQL+=" p.ilosc2,replace(to_char(p.miesnosc_konc,'9999,9'),',','.'),"
    SQL+=" COALESCE(p.klasyf_europ,''),p.data_ubicia,p.recznie"
    SQL+=" FROM rs_uboje_poltusze p"
    SQL+=" INNER JOIN rs_artykuly a USING(firma_id,artykul_id)"
    SQL+=" WHERE p.firma_id='"+self.firma_id+"' AND p.oddzial_id='"+self.oddzial_id+"'"
    SQL+=" AND p.data='"+Data+"' AND p.numer_uboju="+str(NumerUboju)
    SQL+=" ORDER BY p.numer_ubojowy,p.numer_poltuszy;"
    
    stat,dane,wyn1,dump = self.PolSQL.Execute(SQL,3)
    if stat <> 'OK':
        stat = "Bd przy pobieraniu danych: "+stat
        dane.append(stat)
