
# -*- coding: iso8859_2 -*-

#-----------------------------------------------------------------------------
# Name:        fs_umowy_dane.py
# Purpose:     wczytuje/edytuje dane umowy
# Author:      Marcin Wdarczyk, Pawe Wjcikowski
# Created:     2008/08/10
# RCS-ID:      $Id: fs_umowa_dane.py $
# Copyright:   (c) 2008 Record System
# Licence:     GNU GPL
#-----------------------------------------------------------------------------

stat='OK'
if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=='OK':
    Funkcja = klucze['Funkcja']
    
    SlPar={'Umowa_Id':[1,2,3,4,5],'Typ_Umowy':[1,2,3,4],'Kontrahent':[1,2,3,4]}
    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Funkcja,klucze)
    if Lista<>'':
        stat='Uwaga : wywoanie funkcji fs_umowy_dane z numerem '+str(Funkcja)+' bez parametrw: '+Lista

if stat=='OK':
    if Funkcja in [1,2,3,4,5]:
        UmowaId = klucze['Umowa_Id']
    if Funkcja in [1,2,3,4]:
        TypUmowy = klucze['Typ_Umowy'].strip()
        Kontrahent = klucze['Kontrahent']

dane = []
wyn1 = []
wyn2 = []
LIns = []
LEdytuj=[]

UprIns=((self.oddzial_id,'015023') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID
UprUpd=((self.oddzial_id,'015022') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID or UprIns


#-------------------------------------------------------------------------------
#--- NADANIE NUMERU (10)
#-------------------------------------------------------------------------------

if Funkcja == 10 and stat == 'OK':
    SQL ="SELECT umowa_id FROM rs_umowy ORDER BY umowa_id DESC LIMIT 1"
    stat,d,dump,dump = self.PolSQL.Execute(SQL ,3)  
    if stat<>'OK':
        stat='NR BL'
        dane.append(stat)
    elif len(d)==0:
        numer = 1
        dane.append(numer)
    else:
        numer = int(d[0][0]) + 1
        dane.append(numer)
        
        
#-------------------------------------------------------------------------------
#--- SPRAWDZANIE UPRAWNIEN DO DANEGO TYPU UMOWY
#-------------------------------------------------------------------------------

if Funkcja in [1,2,3,4,5] and stat=='OK':
    SQL ="SELECT umowa_typ,wprowadzanie,edycja FROM rs_umowy_typy_upr WHERE firma_id='"+self.firma_id+"' "
    SQL+="AND operator_id IN "+str(self.operatorzy).replace('[','(').replace(']',')')+";"
    stat,DTypy,dump,dump=self.PolSQL.Execute(SQL,3)
    if stat <> 'OK':
        stat = 'PO UPR BL'   
        dane.append(stat)
    else:   
        i=0
        while i < len(DTypy):
            if DTypy[i][1]==True:
                LIns.append(DTypy[i][0].strip())
            if DTypy[i][2]==True:
                LEdytuj.append(DTypy[i][0].strip())
            i=i+1
            
        LIns.append('None')
        LIns.append(None)
        LIns.append('')
        LEdytuj.append('None')
        LEdytuj.append(None)
        LEdytuj.append('')


#-------------------------------------------------------------------------------
#---   INSERT DANYCH (1- z pobieraniem, 2- bez pobierania)
#-------------------------------------------------------------------------------

if stat == 'OK' and Funkcja in [1,2]:
    if (not TypUmowy in LIns) and (not self.operator_id == STANDARD_OPERATOR_ID):
        stat = 'INS TYP BR'   
        dane.append(stat)
   
    if stat == 'OK' and not UprIns:
        stat = 'INS BR'   
        dane.append(stat)
        
    if stat == 'OK':
        #---   Sprawdzenie danych
        SQL ="INSERT INTO rs_umowy "
        SQLP="firma_id,umowa_id"
        SQLW="'"+self.firma_id+"',"+str(UmowaId)
        for i in range(len(pola)):
            pole = pola[i]
            wart = wartosci[i]
                             
            if pole == 'oddzial_id' and stat == 'OK':
                if wart <> '':
                    SPR ="SELECT oddzial_id FROM rs_oddzialy "
                    SPR+="WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+wart+"';"
                    dump,d,dump,dump = self.PolSQL.Execute(SPR ,3)
                    if stat <> 'OK':
                        stat = 'ODDZ BL'
                        dane.append(stat)
                    elif len(d) == 0:
                        stat = 'ODDZ BR'
                        dane.append(stat)
                    else:
                        SQLP+= ","+pole
                        SQLW+= ",'"+wart+"'"

            if pole == 'kontrahent_id' and stat == 'OK':
                if wart <> '':
                    SPR ="SELECT kontrahent_id FROM rs_kontrahenci "
                    SPR+="WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+wart+"';"
                    dump,d,dump,dump = self.PolSQL.Execute(SPR ,3)
                    if stat <> 'OK':
                        stat = 'KON BL'
                        dane.append(stat)
                    elif len(d) == 0:
                        stat = 'KON BR'
                        dane.append(stat)
                    else:
                        SQLP+= ","+pole
                        SQLW+= ",'"+wart+"'"
                    
            if pole == 'osoba_id' and stat == 'OK':
                if wart <> '':
                    SPR ="SELECT osoba_id FROM rs_kontrahenci_osoby WHERE firma_id='"+self.firma_id+"' " 
                    SPR+="AND osoba_id='"+str(wart)+"' AND kontrahent_id='"+Kontrahent+"';"
                    dump,d,dump,dump = self.PolSQL.Execute(SPR ,3)
                    if stat <> 'OK':
                        stat = 'OS BL'
                        dane.append(stat)
                    elif len(d) == 0:
                        stat = 'OS BR'
                        dane.append(stat)
                    else:
                        SQLP+= ","+pole
                        SQLW+= ",'"+wart+"'"
                        
            if pole == 'umowa_typ' and stat == 'OK':
                if wart <> '':
                    SPR ="SELECT kod FROM rs_umowy_typy "
                    SPR+="WHERE firma_id='"+self.firma_id+"' AND kod='"+wart+"';"
                    dump,d,dump,dump = self.PolSQL.Execute(SPR ,3)
                    if stat <> 'OK':
                        stat = 'TYP BL'
                        dane.append(stat)
                    if len(d) == 0:
                        stat = 'TYP BR'
                        dane.append(stat)
                    else:
                        SQLP+= ","+pole
                        SQLW+= ",'"+wart+"'"
                        
            if pole == 'umowa_data' and stat == 'OK':
                SQLP+= ","+pole
                if wart=='    -  -  ':
                    SQLW+= ",NULL"
                else:
                    if (not rsglobal.SprawdzCzyToData(wart)):
                        stat='DUM BL'
                        dane.append(stat)
                    else:
                        SQLW+= ",'"+str(wart)+"'"
            
            if pole == 'data_od' and stat == 'OK':
                SQLP+= ","+pole
                if wart=='    -  -  ':
                    SQLW+= ",NULL"
                else:
                    if (not rsglobal.SprawdzCzyToData(wart)):
                        stat='DOD BL'
                        dane.append(stat)
                    else:
                        SQLW+= ",'"+str(wart)+"'"
            
            if pole == 'data_do' and stat == 'OK':
                SQLP+= ","+pole
                if wart=='    -  -  ':
                    SQLW+= ",NULL"
                else:
                    if (not rsglobal.SprawdzCzyToData(wart)):
                        stat='DDO BL'
                        dane.append(stat)
                    else:
                        SQLW+= ",'"+str(wart)+"'"
                        
            if pole in ['umowa_nr','umowa_opis'] and stat == 'OK':
                if wart <> '':
                    SQLP+= ","+pole
                    SQLW+= ",'"+wart+"'"
               
        if stat == 'OK':
            SQL+= " ("+SQLP+") VALUES ("+SQLW+");"
            stat,dump,dump,dump = self.PolSQL.Execute(SQL ,1)
            if stat <> 'OK':
                stat = 'INS BL'
                dane.append(stat)
                
                
#-------------------------------------------------------------------------------
#---   UPDATE DANYCH (3- z pobieraniem, 4- bez pobierania)
#-------------------------------------------------------------------------------

if stat == 'OK' and Funkcja in [3,4]:
    if (not TypUmowy in LEdytuj) and (self.operator_id == STANDARD_OPERATOR_ID):
        stat = 'UPD TYP BR'   
        dane.append(stat)
        
    if stat == 'OK' and not UprUpd:
        stat = 'UPD BR'   
        dane.append(stat)
        
    if stat == 'OK':
        #---   Sprawdzenie danych
        SQL ="UPDATE rs_umowy SET "
        for i in range(len(pola)):
            pole = pola[i]
            wart = wartosci[i]
                             
            if pole == 'oddzial_id' and stat == 'OK':
                if wart <> '':
                    SPR ="SELECT oddzial_id FROM rs_oddzialy "
                    SPR+="WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+wart+"';"
                    dump,d,dump,dump = self.PolSQL.Execute(SPR ,3)
                    if stat <> 'OK':
                        stat = 'ODDZ BL'
                        dane.append(stat)
                    elif len(d) == 0:
                        stat = 'ODDZ BR'
                        dane.append(stat)
                    else:
                        SQL+=pole+"='"+wart+"',"
                else:
                    SQL+=pole+"=NULL,"

            if pole == 'kontrahent_id' and stat == 'OK':
                if wart <> '':
                    SPR ="SELECT kontrahent_id FROM rs_kontrahenci "
                    SPR+="WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+wart+"';"
                    dump,d,dump,dump = self.PolSQL.Execute(SPR ,3)
                    if stat <> 'OK':
                        stat = 'KON BL'
                        dane.append(stat)
                    elif len(d) == 0:
                        stat = 'KON BR'
                        dane.append(stat)
                    else:
                        SQL+=pole+"='"+wart+"',"
                else:
                    SQL+=pole+"=NULL,"
                    
            if pole == 'osoba_id' and stat == 'OK':
                if wart <> '':
                    SPR ="SELECT osoba_id FROM rs_kontrahenci_osoby WHERE firma_id='"+self.firma_id+"' " 
                    SPR+="AND osoba_id='"+str(wart)+"' AND kontrahent_id='"+Kontrahent+"';"
                    dump,d,dump,dump = self.PolSQL.Execute(SPR ,3)
                    if stat <> 'OK':
                        stat = 'OS BL'
                        dane.append(stat)
                    elif len(d) == 0:
                        stat = 'OS BR'
                        dane.append(stat)
                    else:
                        SQL+=pole+"='"+wart+"',"
                else:
                    SQL+=pole+"=NULL,"
                        
            if pole == 'umowa_typ' and stat == 'OK':
                if wart <> '':
                    SPR ="SELECT kod FROM rs_umowy_typy "
                    SPR+="WHERE firma_id='"+self.firma_id+"' AND kod='"+wart+"';"
                    dump,d,dump,dump = self.PolSQL.Execute(SPR ,3)
                    if stat <> 'OK':
                        stat = 'TYP BL'
                        dane.append(stat)
                    if len(d) == 0:
                        stat = 'TYP BR'
                        dane.append(stat)
                    else:
                        SQL+=pole+"='"+wart+"',"
                else:
                    SQL+=pole+"=NULL,"
                        
            if pole == 'umowa_data' and stat == 'OK':
                if wart=='    -  -  ':
                    SQL+=pole+"=NULL,"
                else:
                    if (not rsglobal.SprawdzCzyToData(wart)):
                        stat='DUM BL'
                        dane.append(stat)
                    else:
                        SQL+=pole+"='"+str(wart)+"',"
            
            if pole == 'data_od' and stat == 'OK':
                if wart=='    -  -  ':
                    SQL+=pole+"=""NULL,"
                else:
                    if (not rsglobal.SprawdzCzyToData(wart)):
                        stat='DOD BL'
                        dane.append(stat)
                    else:
                        SQL+=pole+"='"+str(wart)+"',"
            
            if pole == 'data_do' and stat == 'OK':
                if wart=='    -  -  ':
                    SQL+=pole+"=""NULL,"
                else:
                    if (not rsglobal.SprawdzCzyToData(wart)):
                        stat='DDO BL'
                        dane.append(stat)
                    else:
                        SQL+=pole+"='"+str(wart)+"',"
                        
            if pole in ['umowa_nr','umowa_opis'] and stat == 'OK':
                SQL+=pole+"='"+wart+"',"
               
        if stat == 'OK':
            SQL = SQL.strip(',')
            SQL+=" WHERE firma_id='"+self.firma_id+"' AND umowa_id="+str(UmowaId)+";"
            stat,dump,dump,dump = self.PolSQL.Execute(SQL ,1)
            if stat <> 'OK':
                stat = 'UPD BL'
                dane.append(stat)
    
   
#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (1 -insert z pobraniem, 3 -update z pobraniem, 5 -select)
#-------------------------------------------------------------------------------

if Funkcja in [1,3,5] and stat == 'OK':
    # pobranie danych sprawy
    SQL ="SELECT * FROM rs_umowy "
    SQL+="WHERE firma_id='"+self.firma_id+"' AND umowa_id='"+str(UmowaId)+"' "
    SQL+="ORDER BY umowa_id;"
    stat,dane,wyn1,tr = self.PolSQL.Execute(SQL,3)
    if stat <> 'OK':
        stat = 'PO BL'
        dane.append(stat)
   
    # pobranie opisu dziau
    if len(dane) == 1 and stat == 'OK':
        tr = rssql.RSTableRowset(dane,wyn1)

        # Opis oddziau
        if not (((self.oddzial_id,'001100') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)):
            wyn2.append('Brak uprawnie do sownika. Poinformuj administratora.')
        else:
            SQL ="SELECT opis FROM rs_oddzialy "
            SQL+="WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+tr.GetVal(0,"oddzial_id")+"';"
            dump,d,dump,dump = self.PolSQL.Execute(SQL ,3)
            if len(d) == 0:
                wyn2.append('')
            else:
                wyn2.append(d[0][0])

        # Opis kontrahenta
        if not(((self.oddzial_id,'012000') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)):
            wyn2.append('Brak uprawnie do sownika. Poinformuj administratora.')
        else:
            SQL ="SELECT nazwa FROM rs_kontrahenci "
            SQL+="WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+tr.GetVal(0,"kontrahent_id")+"';"
            dump,d,dump,dump = self.PolSQL.Execute(SQL ,3)
            if len(d) == 0:
                wyn2.append('')
            else:
                wyn2.append(d[0][0])
            
        # Opis osoby odpowiedzialnej
        if not (((self.oddzial_id,'012030') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)):
            wyn2.append('Brak uprawnie do sownika. Poinformuj administratora.')
        else:
            SQL ="SELECT imie,nazwisko FROM rs_kontrahenci_osoby "
            SQL+="WHERE firma_id='"+self.firma_id+"' AND osoba_id='"+tr.GetVal(0,"osoba_id")+"';" 
            dump,d,dump,dump = self.PolSQL.Execute(SQL ,3)
            if len(d)<>0:
                wyn2.append(str(d[0][0]+' '+d[0][1]))
            else:
                wyn2.append('')
            
        # Opis typu umowy
        if not (((self.oddzial_id,'011470') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID)):
            wyn2.append('Brak uprawnie do sownika. Poinformuj administratora.')
        else:
            SQL ="SELECT opis FROM rs_umowy_typy "
            SQL+="WHERE firma_id='"+self.firma_id+"' AND kod='"+tr.GetVal(0,"umowa_typ")+"';"
            dump,d,dump,dump = self.PolSQL.Execute(SQL ,3)
            if len(d) == 0:
                wyn2.append('')
            else:
                wyn2.append(d[0][0])
        
        wyn2.append(LEdytuj)