#!/usr/bin/python
# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_dokumenty_magazynowe_palety.py
# Author:      Marcin Natkaski
# Created:     2015/03/15
# RCS-ID:      $Id: fs_dokumenty_magazynowe_palety.py$
# Copyright:   (c) 2015 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

stat='OK'
if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=='OK':
    Funkcja = klucze['Funkcja']
    
    SlPar={'DataOd':[1,],'DataDo':[1,], 'Komorka':[1,]}
    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Funkcja,klucze)
    if Lista<>'':
        stat='Uwaga : wywoanie funkcji fs_dokumenty_magazynowe_palety z numerem '+str(Funkcja)+' bez parametrw: '+Lista

if stat=='OK':
    if Funkcja in [1,]:
        DataOd = klucze['DataOd']
        DataDo = klucze['DataDo']
        Komorka = klucze['Komorka']


    
dane=[]
wyn1=[]
wyn2=[]
dane_do_wydruku = []

UprIns=((self.oddzial_id,'032040') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID


#-------------------------------------------------------------------------------
#---   Sprawdzam dane
#-------------------------------------------------------------------------------

if Funkcja in [1,]:
    if Komorka.strip()<>'':
        SQL="SELECT kod FROM rs_komorki_zatrudniajace WHERE firma_id='"+self.firma_id+"' AND kod='"+Komorka+"'"
        stat,dane,dump,dump = self.PolSQL.Execute(SQL,3)
        if stat<>'OK':
            stat='Bdy przy sprawdzaniu komrki organizacyjnej :'+stat
            dane.append(stat)
        elif len(dane)==0:
            stat='W bazie danych brak podanej komrki organizacyjnej'+stat
            dane.append(stat)

#-------------------------------------------------------------------------------
#---  POBIERANIE DANYCH NA WYDRUK
#-------------------------------------------------------------------------------

if Funkcja in [1,] and stat=='OK':
    SQL= " SELECT a.komorka_id,a.czas_od,a.czas_do,a.pracownik_id, b.imie||' '||b.nazwisko,a.czas_fakt_od,a.czas_fakt_do,typ_absencji_id"
    SQL+=" FROM rs_kp_listy_obecnosci_pozycje a INNER JOIN rs_kp_dane_osobowe b USING (firma_id,pracownik_id)"
    SQL+=" WHERE a.firma_id='"+self.firma_id+"' AND substring(a.czas_od::TEXT from 1 for 10)>='"+DataOd+"' "
    SQL+=" AND substring(a.czas_do::TEXT from 1 for 10)<='"+DataDo+"'"
    if Komorka.strip()<>'':
        SQL+=" AND a.komorka_id = '"+Komorka+"' "
    SQL+="ORDER BY a.czas_od,b.imie||' '||b.nazwisko"
    stat,dane,dump,dump = self.PolSQL.Execute(SQL,3)
    if stat<>'OK':
        stat='Bdy przy pobieraniu danych listy obecnoci :'+stat
        dane.append(stat)
    elif len(dane)==0:
        stat='Brak danych do wydruku.'
        dane.append(stat)