#!/usr/bin/python
# -*- coding: iso8859_2 -*-
#-----------------------------------------------------------------------------
# Name:             fs_wydruki_deklaracja_zgodnosci.py
# Purpose:          wydruk deklaracji zgodnosci artykulu
# Author:           Dariusz Boduch
# Created:          2009/08/06
# RCS-ID:           $Id: fs_wydruki_deklaracja_zgodnosci.py $
# Copyright:        (c) 2007 RecordSystem
# Licence:          GNU GPL
#-----------------------------------------------------------------------------
#klucze: Wyzn,Data,Numer,Poz,PPoz
Wyzn=klucze[0]
Data=klucze[1]
Numer=klucze[2]
Poz=klucze[3]
PPoz=klucze[4]
Fun=klucze[-1]

stat = "OK"
dane = []

# Fun=1 wydruk pojedynczej deklaracji, 
# Fun=2 - funkcja do obslugi wysdruku wszystkich deklaracji z pozycji faktury

    
if self.operator_id == STANDARD_OPERATOR_ID:
    UprWyk=True
else:
    UprWyk=(self.oddzial_id,'022026') in self.uprawnienia

if stat=='OK' and Fun==1:
    if not UprWyk:
        stat='Brak uprawnie do wykonywania. Skontaktuj si z administratorem.'
    else:
       #pobranie danych oddzialu
        SELECT="SELECT o.nazwa as nazwa, o.nazwa1 as nazwa1, o.nazwa2 as nazwa2, o.adr_kod as kod, o.adr_poczta as poczta, "
        SELECT+="o.adr_miej as miejsc, o.adr_ulica as ulica , o.adr_nry as nry, o.nip as nip, o.tel1 as tel1, o.tel2 as tel2, "
        SELECT+="o.fax as fax, o.email as email "
        FROM="FROM rs_oddzialy o  "
        FROM+="INNER JOIN rs_faktury f USING(firma_id,oddzial_id)   "
        WHERE="WHERE o.firma_id='"+self.firma_id+"' AND f.wyznacznik_id='"+Wyzn+"' AND f.data='"+Data+"' AND f.numer="+str(Numer)+" ;"
        stat,daneO,naglO,dump=self.PolSQL.Execute(SELECT+FROM+WHERE,3)
        if stat!="OK":
            stat="Bd w pobieraniu danych oddziau: "+stat
        else:
            if len(daneO)==0:
                stat='Brak danych oddziau'
    if stat=='OK':
        #pobranie danych deklaracji
        SELECT="SELECT fp.artykul_id as artykul, a.nazwa as nazwa, rsf_podaj_sww_pkwiu_artykulu(fp.firma_id,fp.artykul_id,fp.data::TEXT) AS pkwiu, fp.deklaracja_zgodnosci_nr as dekl_nr, fp.deklaracja_zgodnosci_przeznaczenie as dekl_przezn, "
        SELECT+="fp.deklaracja_zgodnosci_dokumenty as dekl_dok, fp.deklaracja_zgodnosci_partia as dekl_partia "
        FROM="FROM rs_faktury_pozycje fp "
        FROM+="LEFT OUTER JOIN rs_artykuly a USING(firma_id,artykul_id) "
        WHERE="WHERE firma_id='"+self.firma_id+"' AND fp.wyznacznik_id='"+Wyzn+"' AND fp.data='"+Data+"' AND fp.numer="+str(Numer)+" "
        WHERE+=" AND fp.nr_poz="+str(Poz)+" AND fp.nr_ppoz="+str(PPoz)+" ;"
        stat,daneD,naglD,dump=self.PolSQL.Execute(SELECT+FROM+WHERE,3)
        if stat!="OK":
            stat="Bd w pobieraniu danych pozycji formularza: "+stat
        else:
            if len(daneD)==0:
                stat='Brak danych deklaracji'            
    if stat=='OK':
        #           0     1     2     3
        dane=str([daneO,naglO,daneD,naglD])


#obsluga wydruku wszystkich deklaracji z faktury
if stat=='OK' and Fun==2:
    #Czy s deklaracje do wydruku
    SELECT="SELECT nr_poz, nr_ppoz "
    SELECT+=" FROM rs_faktury_pozycje WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyzn+"' AND data='"+Data+"' AND numer="+str(Numer)+" "
    SELECT+=" AND  (deklaracja_zgodnosci_nr is not null AND deklaracja_zgodnosci_nr<>0) "
    SELECT+=" AND  (deklaracja_zgodnosci_przeznaczenie is not null AND deklaracja_zgodnosci_przeznaczenie<>'') "
    SELECT+=" AND  (deklaracja_zgodnosci_dokumenty is not null AND deklaracja_zgodnosci_dokumenty<>'') "
    SELECT+=" AND  (deklaracja_zgodnosci_partia is not null AND  deklaracja_zgodnosci_partia<>'') ;"
    stat,daneP,naglP,dump=self.PolSQL.Execute(SELECT,3)
    if stat<>'OK':
        stat="Bd pobierania danych deklaracji do wydruku: "+stat
    dane=str([daneP,naglP])