# -*- coding: iso8859_2 -*-
#-----------------------------------------------------------------------------
# Name:        fs_wydruki_dziennik
# Purpose:      
# Author:      Dariusz Boduch
# Created:     2007/12/20
# RCS-ID:      $Id: fs_wydruki_dziennik.py $
# Copyright:   (c) 2007 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

#klucze= DataOd, DataDo

DataOd=klucze[0]
DataDo=klucze[1]


stat = "OK"
dane = []


#jeli uprawnienia sa ok
if stat=='OK':
    
    #pobranie danych z operacji i danych operatora
    Pola =" CASE WHEN o.dziennik IS NOT NULL THEN o.dziennik ELSE 0 END as nr_dziennika, o.dowod_id, CAST(o.numer AS TEXT) as nr_dowodu, CAST(o.nr_poz AS TEXT) as nr_poz, CAST(o.nr_ppoz AS TEXT) as nr_ppoz"
    Pola+=", o.data, o.data_wyst, o.tresc, o.kwota_wn, o.kwota_ma, o.konto, o.konto_prz, SUBSTRING(u.imie FROM 1 FOR 1) as imie , u.nazwisko, p.pozabilansowe "
    From ="rs_operacje o LEFT OUTER JOIN rs_operatorzy u on(o.z_op_id=u.operator_id)"
    From+=" LEFT OUTER JOIN rs_plan_kont p on (o.firma_id=p.firma_id AND o.okres_id=p.okres_id AND (STRING_TO_ARRAY(o.konto,'-'))[1] = p.kontos_id)"
    Where=" o.firma_id='"+self.firma_id+"' AND o.okres_id='"+self.okres_id+"' AND o.data>='"+DataOd+"' AND o.data<='"+DataDo+"' AND o.dziennik IS NOT NULL"
    GroupBy=" o.dziennik, o.dowod_id,o.numer,o.nr_poz,o.nr_ppoz,o.data,o.data_wyst,o.tresc,o.kwota_wn, o.kwota_ma,o.konto,o.konto_prz,u.imie, u.nazwisko,p.pozabilansowe"
    stat,daneO,naglO,dump=self.PolSQL.Execute("SELECT "+Pola+" FROM "+From+" WHERE "+Where+" GROUP BY "+GroupBy+" ORDER BY o.dziennik;",3)
    if stat=='OK':
        if len(daneO)==0:
            stat='Brak danych do wydruku'

    if stat=="OK":
        #pobieranie sum kwota_wn, kwota_ma za okres_id 
        SQL="SELECT COALESCE(SUM(o.kwota_wn),0) AS KwotaWn, COALESCE(SUM(o.kwota_ma),0) AS KwotaMa "
        SQL+=" FROM rs_operacje o "
        SQL+=" LEFT OUTER JOIN rs_plan_kont p ON (o.firma_id=p.firma_id AND o.okres_id=p.okres_id AND (STRING_TO_ARRAY(o.konto,'-'))[1] = p.kontos_id AND TRIM(p.konto_id)='')"
        SQL+=" WHERE o.firma_id='"+self.firma_id+"' AND o.okres_id='"+self.okres_id+"' AND o.data<'"+DataOd+"'"
        SQL+=" AND o.dziennik IS NOT NULL"
        
        # bilansowe
        stat,daneS,naglS,dump=self.PolSQL.Execute(SQL+" AND NOT p.pozabilansowe;",3)
        if stat <> 'OK':
            stat='Bdy w pobieraniu sumy kont bilansowych :'+stat
        elif len(daneS)==0:
            stat='Bdy w pobieraniu sumy kont bilansowych'
            
        # pozabilansowe
        if stat=='OK':
            stat,daneSPB,naglSPB,dump=self.PolSQL.Execute(SQL+" AND p.pozabilansowe;",3)
            if stat <> 'OK':
                stat='Bdy w pobieraniu sumy kont pozabilansowych:'+stat
            elif len(daneSPB)==0:
                stat='Bdy w pobieraniu sumy kont pozabilansowych'
            
    if stat=='OK':
        #pobranie danych do obliczenia liczby wierszy
        stat,daneW,naglW,dump=self.PolSQL.Execute("SELECT COUNT(*)::NUMERIC as ile_wierszy FROM rs_operacje WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"' AND data<'"+DataOd+"' AND SUBSTRING(data::TEXT from 6 for 2) in ('01','02','03','04','05','06','07','08','09','10','11','12') AND dziennik IS NOT NULL GROUP BY SUBSTRING(data::TEXT from 6 for 2) ORDER BY SUBSTRING(data::TEXT from 6 for 2);",3)
        #rsglobal.ZapiszDoLogow(daneW,1)   
    if stat=='OK':
        dane=str([daneO,naglO,daneS,naglS,daneSPB,naglSPB,daneW,naglW])