# -*- coding: iso8859_2 -*-
#-----------------------------------------------------------------------------
# Name:        fs_wydruki_reklamacja.py
# Purpose:     podanie danych do wydruku arkusza reklamacji
# Author:      Micha Raburski
# Created:     2012/04/19
# RCS-ID:      $Id: fs_wydruki_reklamacja.py $
# Copyright:   (c) 2012 Record System
# Licence:     GNU GPL
#-----------------------------------------------------------------------------


DataOd = klucze[0]
DataDo = klucze[1]

stat = "OK"
dane = []
CzasOd=DataOd+' 00:00:01'
CzasDo=DataDo+' 23:59:59'

# pobranie danych o konkretnych zadaniach z harmonogramu
SQL ="SELECT nazwa,argumenty,ile_odstepow,odstep,czas"
SQL+=" FROM rs_harmonogram_zadan "
SQL+=" WHERE firma_id='"+self.firma_id+"' AND czas>='"+CzasOd+"' AND czas <='"+CzasDo+"' AND aktywne"
rsglobal.ZapiszDoLogow('SQL '+SQL,1)
stat,dane,dump,dump=self.PolSQL.Execute(SQL,3)

# zbudowanie listy zdarze, ktre zajd w podanym okresie
if stat=='OK':
    Lp=1
    SZdarzen={}
    for poz in dane:
        # klucz to czas wykonania, nazwa funkcji i LP ( w celu rozrnienia identycznych funkcji)
        Klucz=(poz[4]+":00",poz[0],Lp)
        # wynik to argumenty i odstp
        Wyn=[poz[1],str(poz[2])+' '+poz[3]]
        
        SZdarzen[Klucz]=Wyn
        Lp+=1
        # ptla po kolejnych czasach wykonania
        Czas=poz[4]
        Interwal="'"+str(poz[2])+' '
        SCzas={'m':'MINUTE','g':'HOUR','d':'DAY','t':'WEEK','M':'MONTH','R':'YEAR'}
        Interwal+=SCzas[poz[3]]+"'"
        
        while Czas < CzasDo and stat=='OK':
            # pobranie nowego czasu
            SQL="SELECT '"+Czas+"'::TIMESTAMP+"+Interwal
            stat,DCzas,dump,dump=self.PolSQL.Execute(SQL,3)
            if stat=='OK':
                if DCzas[0][0]<CzasDo:
                    Klucz=(DCzas[0][0],poz[0],Lp)
                    SZdarzen[Klucz]=Wyn
                    Lp+=1
                Czas=DCzas[0][0]

if stat=='OK':
    dane=[str(SZdarzen)]