# -*- coding: iso8859_2 -*-
#-----------------------------------------------------------------------------
# Name:        fs_wydruki_kierowcy_wersje_sumy.py
# Purpose:     pobiera dane do wydruku zestawen dostarczonego pieczywa dla sum
#
# Author:      Micha Raburski
#
# Created:     2011/07/25
# RCS-ID:      $Id: fs_wydruki_kierowcy_wersje_sumy.py $
# Copyright:   (c) 2011 Record System
# Licence:     GNU GPL
#-----------------------------------------------------------------------------
# 2022-11-29 Aleksander Bargie (13252) Wystawianie faktur dla transportu - okno zlece transportowych(zmiana numerow uprawnien)

#klucze= DataOd, DataDo, Kierowca, Normalny, Specjalny, Przerzuty 

DataOd = klucze[0]
DataDo = klucze[1]
Kierowca = klucze[2]
Normalny = klucze[3]
Specjalny = klucze[4]
Przerzuty = klucze[5]

Dane=[]
daneW=[]  
naglW=[]
#slownik z kluczem: (artykul, wersja cenowa) : [cena n1]
#                   (artykul) : [przelicznik na kosze]
LArt={}
stat='OK'

if (not (self.oddzial_id,'103007') in self.uprawnienia) and not (self.operator_id == STANDARD_OPERATOR_ID): 
    stat='Brak uprawnie do wydruku'
    dane.append(stat)
#sprawdzenie poprawnoci kierowcy:
if stat=='OK':
    if Kierowca.strip()<>'':
        stat,daneS,dump,dump=self.PolSQL.Execute("SELECT kod FROM rs_kierowcy WHERE firma_id='"+self.firma_id+"' AND kod='"+str(Kierowca)+"' ;",3)
        if stat<>'OK':
            stat='Bd pobierania danych kierowcy'
            dane.append(stat)
        else:
            if len(daneS)==0:
                stat='Niepoprawny symbol kierowcy'
                dane.append(stat)
            
   
if stat=='OK':  
    if Kierowca.strip()=='':
        WKierowca=''
    else:
        WKierowca= "AND kierowca='"+str(Kierowca)+"' "
            
#pobranie danych z rs_kierowcy_wersje
if stat=='OK':
    SQL="SELECT kw.wlasny,kw.specjalny, kw.wc_normal, kw.wc_swiat,kw.wc_przerz,kw.wc_noc, kw.magazyn_id,"
    SQL+=" kw.platnicy, m.opis "
    SQL+="FROM rs_kierowcy_wersje kw LEFT OUTER JOIN rs_magazyny m "
    SQL+=" ON(kw.firma_id=m.firma_id AND kw.oddzial_id=m.oddzial_id AND kw.magazyn_id=m.magazyn_id) "
    SQL+=" WHERE kw.firma_id='"+self.firma_id+"' and kw.oddzial_id='"+self.oddzial_id+"' ; "
    stat,daneK,naglK,dump=self.PolSQL.Execute(SQL,3)
    if stat<>'OK':
        stat='Bd pobierania danych wersji cenowych'
        dane.append(stat)
    else:
        if len(daneK)==0:
            stat='Brak danych wersji cenowych'
            dane.append(stat)
            
    #sprawdzenie czy nie zmienia si wersja cenowa
    if stat=='OK':
        wersja=[]
        for w in daneK:
            if str(w[2]) not in wersja:
                wersja.append(str(w[2]))
            if str(w[3]) not in wersja:
                wersja.append(str(w[3]))
            if str(w[4]) not in wersja:
                wersja.append(str(w[4]))
            if str(w[5]) not in wersja:
                wersja.append(str(w[5]))
        
        Wersje=str(wersja).replace('[','(').replace(']',')')
        SQL="SELECT wersja, data_od FROM rs_artykuly_ceny WHERE firma_id='"+self.firma_id+"' AND wersja in "+Wersje+" "
        SQL+="AND data_od>'"+DataOd+"' AND data_od <='"+DataDo+"' GROUP BY wersja, data_od ORDER BY wersja, data_od "
        stat,daneW,dump,dump=self.PolSQL.Execute(SQL,3)
        if stat<>'OK':
            stat='Bd sprawdzania czy zmieniana bya wersja cenowa'
            dane.append(stat)
        else:
            if len(daneW)>0:
                DaneBl=[]
                for w in daneW:
                    wiersz=str(w[0])+" - "+str(w[1])
                    DaneBl.append(wiersz)
                WersjeZm=str(DaneBl).replace('[','').replace(']','')
                stat='W okresie obejmujcym wydruk nastpiy nastpujce zmiany wersji cenowych: '+str(WersjeZm)            
            
#slownik z kluczem: (artykul, wersja cenowa) : [cena n1]
#                   (artykul) : [przelicznik na kosze]
if stat=='OK':
    SQL="SELECT DISTINCT ac.artykul_id, ac.wersja, "
    SQL+=" rsf_podaj_cene_n1('"+self.firma_id+"',ac.artykul_id ,ac.wersja, 'PLN', '"+DataDo+"'), "
    SQL+=" CASE WHEN ao.opakowanie_id IS NULL THEN 0 ELSE ao.ilosc1 END"
    SQL+=" FROM rs_artykuly_ceny ac LEFT OUTER JOIN rs_artykuly_opakowania_zbiorcze ao"
    SQL+=" ON (ac.firma_id=ao.firma_id AND ac.artykul_id=ao.artykul_id) "
    SQL+=" WHERE ac.firma_id='"+self.firma_id+"' AND ac.wersja in  "+Wersje+" "
    SQL+=" AND (ao.opakowanie_id=(SELECT az.opakowanie_id FROM rs_artykuly_opakowania_zbiorcze az WHERE "
    SQL+=" (ac.firma_id=az.firma_id AND ac.artykul_id=az.artykul_id) ORDER BY az.opakowanie_id LIMIT 1) "
    SQL+=" OR ao.opakowanie_id IS NULL) "
    SQL+="ORDER BY ac.artykul_id, ac.wersja "
    stat,daneA,dump,dump=self.PolSQL.Execute(SQL,3)
    if stat<>'OK':
        stat='Bd pobierania cen artykuw dla wersji cenowych'
        dane.append(stat)
    else:
        for w in daneA:
            LArt[(str(w[0]),str(w[1]))] = w[2]
            LArt[str(w[0])]=w[3]

#lista platnikow
if stat=='OK':
    Platnicy=daneK[0][-2]
    Magazyn=daneK[0][-3]
    
    if Platnicy.strip() in (None,'','None'):
        NPlatnicy=SPlatnicy=''
        Platnicy = "'',''"
    else:
        NPlatnicy=" AND dd.platnik_id not in ("+str(Platnicy)+") "
        SPlatnicy=" AND dd.platnik_id in ("+str(Platnicy)+") "

#pobranie danych wydruk Normalny i Specjalny za pomoc UNION. Pozwala to na wygodne posortowanie danych

if stat=='OK':
    SQL=''
    if Normalny:
        SQL+="SELECT dd.kierowca AS kierowca, dd.kierowca_opis AS kierowca_opis, 'N' AS typ,"
        SQL+="dd.trasa AS trasa,dd.trasa_opis AS trasa_opis,"
        SQL+="dd.artykul_id AS artykul,dd.artykul_opis AS artykul_opis, k.wlasny AS wlasny,"
        SQL+="SUM(CASE WHEN extract(DOW from dd.data)<>0 THEN dd.ilosc_dost1-dd.ilosc_zwr1 ELSE 0 END) as dostarczone,"
        SQL+="SUM(CASE WHEN extract(DOW from dd.data)=0 THEN dd.ilosc_dost1-dd.ilosc_zwr1 ELSE 0 END) as dostarczone_nd"
        SQL+=" FROM rs_gr_dowody_dostaw dd "
        SQL+=" LEFT OUTER JOIN rs_kierowcy k ON (dd.firma_id=k.firma_id AND dd.kierowca=k.kod) "
        SQL+=" WHERE dd.firma_id='"+self.firma_id+"' AND dd.oddzial_id='"+self.oddzial_id+"' "
        SQL+=" AND dd.data>='"+DataOd+"' and dd.data<='"+DataDo+"' "+WKierowca+" "+NPlatnicy+" "
        SQL+=" GROUP BY kierowca, kierowca_opis, typ,trasa,trasa_opis,artykul,artykul_opis,wlasny "

#pobranie danych wydruk Specjalny
    if Specjalny:
        if Normalny:
           SQL+=" UNION " 
        
        SQL+="SELECT dd.kierowca AS kierowca, dd.kierowca_opis AS kierowca_opis, 'S' AS typ,"
        SQL+="dd.trasa AS trasa,dd.trasa_opis AS trasa_opis,"
        SQL+="dd.artykul_id AS artykul, dd.artykul_opis AS artykul_opis,k.wlasny AS wlasny,"
        SQL+="SUM(CASE WHEN extract(DOW from dd.data)<>0 THEN dd.ilosc_dost1-dd.ilosc_zwr1 ELSE 0 END) as dostarczone,"
        SQL+="SUM(CASE WHEN extract(DOW from dd.data)=0 THEN dd.ilosc_dost1-dd.ilosc_zwr1 ELSE 0 END) as dostarczone_nd"
        SQL+=" FROM rs_gr_dowody_dostaw dd "
        SQL+=" LEFT OUTER JOIN rs_kierowcy k ON (dd.firma_id=k.firma_id AND dd.kierowca=k.kod) "
        SQL+=" WHERE dd.firma_id='"+self.firma_id+"' AND dd.oddzial_id='"+self.oddzial_id+"' "
        SQL+=" AND dd.data>='"+DataOd+"' and dd.data<='"+DataDo+"' "+WKierowca+" "+SPlatnicy+" "
        SQL+=" GROUP BY kierowca, kierowca_opis, typ,trasa,trasa_opis,artykul,artykul_opis,wlasny "

        
    SQL+=" ORDER BY trasa,kierowca, typ, artykul; "
    
    stat,daneW,naglW,dump=self.PolSQL2.Execute(SQL,3)
    if stat<>'OK':
        stat='Bd pobierania danych do wydruku: '+stat
        dane.append(stat)

if stat=='OK':
    dane=str([daneK,naglK,daneW,naglW,LArt])
