# -*- coding: iso8859_2 -*-
#-----------------------------------------------------------------------------
# Name:        fs_wydruki_reklamacja.py
# Purpose:     podanie danych do wydruku arkusza reklamacji
# Author:      Micha Raburski
# Created:     2012/04/19
# RCS-ID:      $Id: fs_wydruki_reklamacja.py $
# Copyright:   (c) 2012 Record System
# Licence:     GNU GPL
#-----------------------------------------------------------------------------
# 2021-02-05 Aleksander Bargie (12311) Problem z wydrukiem reklamacji z innego oddziau ni operator jest zalogowany


Data = klucze[0]
Numer = rsglobal.UsunKropkaZero(str(klucze[1]))
OddzialId = rsglobal.Dekoduj(klucze[2])  #AB 05.02.21r

stat = "OK"
dane = []

NrDok=self.oddzial_id+'/'+Data[2:4]+'/'+Numer
SQL ="SELECT r.konsumencka,'"+NrDok+"',fz.opis,r.data_dostawy,a.nazwa,r.ilosc_dostarczona,r.ilosc_reklamowana," # 0-6
SQL+=" r.nr_paragonu, r.zglaszajacy, r.przyjmujacy, r.zastrzezenie_opis,COALESCE(tp.opis,'brak'), COALESCE(pn.opis,'- brak'), dz.opis," # 7-13
SQL+=" COALESCE(r.arkusz_niezgodnosci,' - brak'), COALESCE(r.sposob_zalatwienia,'brak'),r.informacja_zwrotna," # 14-16
SQL+=" k.kontrahent_id,k.nazwa" # 17-18
SQL+=" FROM rs_reklamacje r "
SQL+=" LEFT OUTER JOIN rs_reklamacje_formy_zgloszenia fz ON (r.firma_id=fz.firma_id AND r.forma_zgloszenia=fz.kod) " 
SQL+=" LEFT OUTER JOIN rs_artykuly a ON (r.firma_id=a.firma_id AND r.artykul_id=a.artykul_id) " 
SQL+=" LEFT OUTER JOIN rs_kontrahenci k ON (r.firma_id=a.firma_id AND r.kontrahent_id=k.kontrahent_id) " 
SQL+=" LEFT OUTER JOIN rs_reklamacje_tryby_postepowania tp ON(r.firma_id=tp.firma_id AND r.tryb_postepowania=tp.kod) " 
SQL+=" LEFT OUTER JOIN rs_reklamacje_przyczyny_niezgodnosci pn ON(r.firma_id=pn.firma_id AND r.przyczyna_niezgodnosci=pn.kod) " 
SQL+=" LEFT OUTER JOIN rs_reklamacje_dzialania_zapobiegawcze dz ON(r.firma_id=dz.firma_id AND r.dzialanie_zapobiegawcze=dz.kod) " 
SQL+=" WHERE r.firma_id='"+self.firma_id+"' AND r.oddzial_id='"+OddzialId+"'"
SQL+=" AND r.data='"+Data+"' AND r.numer="+Numer+";"
stat,dane,dump,dump=self.PolSQL.Execute(SQL,3)