# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_wydruki_stan_rozrachunkow.py
# Purpose:      
# Author:      Micha Raburski
# Created:     2007/04/19
# RCS-ID:      $Id: fs_wydruki_stan_rozrachunkow.py $
# Copyright:   (c) 2007 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

# 2011-12-22 Mariusz Rajfura  dodatkowe parametry: DniOd, DniDo (5321)

from funkcje import fs_rozrachunki_pom

Data=rsglobal.Dekoduj(klucze[0])
KontoOd=rsglobal.Dekoduj(klucze[1])
KontoDo=rsglobal.Dekoduj(klucze[2])
Dwustronne=klucze[3]
DniOd=klucze[4]
DniDo=klucze[5]
DynamOkres=klucze[6]

stat = "OK"
dane = []

# sprawdzenie poprawnoci daty
if not rsglobal.SprawdzCzyToData(Data):
    stat='Podano bdn dat do raportu'
    

if stat=='OK':
    Okres=self.okres_id
    # potencjalne pobranie okresu zgodnego z dat
    if DynamOkres:
        SQL="SELECT okres_id FROM rs_definicje_okresow WHERE firma_id='"+self.firma_id+"' AND '"+Data+"' BETWEEN data_od AND data_do"
        stat,DZakr,dump,dump=self.PolSQL.Execute(SQL,3)
        if stat!="OK":
            stat="Bd zapytania pobierajcego okres dla daty:"+stat    
        elif len(DZakr)==0:
            stat="Brak okresu obrachunkowego pasujcego do daty"
        else:
            Okres=DZakr[0][0]
    else:
        # sprawdzenie czy data mieci si w podanym okresie obrachunkowym
        sql = "SELECT data_od, data_do FROM rs_definicje_okresow"
        sql+=" WHERE firma_id = '"+self.firma_id+"' AND okres_id = '"+self.okres_id+"';"
        stat,d,dump,dump = self.PolSQL.Execute(sql, 2)
        if stat <> 'OK':
            stat = 'Bd pobrania danych okresu ksigowego : '+stat
            dane.append(stat)
        else:
            if len(d) == 1:
                if Data < str(d[0][0]):
                    stat = 'Data wydruku jest wczeniejsza od daty pocztku okresu ksigowego'
                    dane.append(stat)
                
                if Data > str(d[0][1]):
                    stat = 'Data wydruku jest pniejsza ni data koca okresu okresu ksigowego'
                    dane.append(stat)
                    
            else:
                stat = 'Brak zdefiniowanego okresu ksigowego '+str(self.okres_id)
                dane.append(stat)
        
if stat =='OK':
    #pobranie kont pocztkowego i koncowego
    stat,DKOd,dump,dump = self.PolSQL.Execute("SELECT rsf_podaj_parametry_konta('"+self.firma_id+"','"+Okres+"','"+KontoOd+"');",3)        
    if rsglobal.rseval(DKOd[0][0])[1] <> '':
        NazwaOd = rsglobal.rseval(DKOd[0][0])[0]
    else:
        stat='Bdne konto pocztkowe'
    
if stat=='OK':
    stat,DKDo,dump,dump = self.PolSQL.Execute("SELECT rsf_podaj_parametry_konta('"+self.firma_id+"','"+Okres+"','"+KontoDo+"');",3)        
    if rsglobal.rseval(DKDo[0][0])[1] <> '':
        NazwaDo = rsglobal.rseval(DKDo[0][0])[0]
    else:
        stat='Bdne konto koncowe'

if stat=='OK':
    # wydruk klasycznego stanu rozrachunkw
    if not Dwustronne:
        stat,LOkr=fs_rozrachunki_pom.PodajOkresyDlaRozrachunkow(self,Okres)
        if stat <> 'OK':
            stat= 'Bdy pobierania okresu : '+stat

        if stat == 'OK':
            LOkr = rsglobal.Dekoduj(LOkr[0])
            if Data <> '    -  -  ':
                DataP=Data
            else:
                DataP=rsglobal.PodajDzis()
            
            WarOkr=""
            if DniOd <> -1 or DniDo <>-1:
                Dni="CASE WHEN (termin_plat IS NULL) THEN -1 ELSE '"+DataP+"'-termin_plat END "
                if DniOd<> -1:
                    WarOkr+=" AND "+Dni+">= "+str(DniOd)
                if DniDo<> -1:
                    WarOkr+=" AND "+Dni+"<= "+str(DniDo)
            
            SQL="SELECT konto,rsf_podaj_parametry_konta(firma_id,okres_id,konto)," # 0 - 1
            SQL+="TRIM(dowod_id)||'/'||trim(nazwa_id)||'/'||data||'/'||CAST(numer AS TEXT)||'/'||CAST(nr_poz AS TEXT)||'/'||CAST(nr_ppoz AS TEXT) as dowod," # 2
            SQL+="COALESCE(CASE WHEN symbol_dok='None' THEN NULL ELSE symbol_dok END,''),data_wyst,termin_plat,'',CASE WHEN (termin_plat IS NULL) THEN 'Br' ELSE CAST('"+DataP+"'-termin_plat AS TEXT) END," #3 - 7
            SQL+="trim(tresc),COALESCE(kwota_bo_wn,kwota_wn)-sum(CASE WHEN data_rozlicz <= '"+DataP+"' THEN rozliczone_wn ELSE 0 END),COALESCE(kwota_bo_ma,kwota_ma)-sum(CASE WHEN data_rozlicz <= '"+DataP+"' THEN rozliczone_ma ELSE 0 END)," # 8 - 10
            SQL+="waluta,COALESCE(kwota_bo_wal_wn,kwota_wal_wn)-sum(CASE WHEN data_rozlicz <= '"+DataP+"' THEN rozliczone_wal_wn ELSE 0 END),COALESCE(kwota_bo_wal_ma,kwota_wal_ma)-sum(CASE WHEN data_rozlicz <= '"+DataP+"' THEN rozliczone_wal_ma ELSE 0 END),kurs,kwota_wn,kwota_ma" # 11 - 13
            SQL+=" FROM rs_rozrachunki r"
            SQL+=" WHERE firma_id='"+self.firma_id+"' AND okres_id IN ("+LOkr+") AND (((konto>='"+KontoOd+"') AND (konto<='"+KontoDo+"')) OR (konto LIKE '"+KontoDo+"%')) "
            if Data <> '    -  -  ':
                SQL+=" AND COALESCE(data_ksieg_kosztow,data)<='"+DataP+"' "
            SQL+=WarOkr
        
            SQL+=" GROUP BY konto,rsf_podaj_parametry_konta(firma_id,okres_id,konto),"
            SQL+="dowod_id,nazwa_id,data,numer,nr_poz,nr_ppoz,"
            SQL+="COALESCE(CASE WHEN symbol_dok='None' THEN NULL ELSE symbol_dok END,''),data_wyst,termin_plat,CASE WHEN (termin_plat IS NULL) THEN 'Br' ELSE CAST('"+DataP+"'-termin_plat AS TEXT) END,"
            SQL+="trim(tresc),kwota_wn,kwota_ma,waluta,kwota_wal_wn,kwota_wal_ma,kurs,kwota_bo_wn,kwota_bo_ma,kwota_bo_wal_wn,kwota_bo_wal_ma"
            SQL+=" HAVING (COALESCE(kwota_bo_wn,kwota_wn)-sum(CASE WHEN data_rozlicz <= '"+DataP+"' THEN rozliczone_wn ELSE 0 END) <> 0)"
            SQL+="OR (COALESCE(kwota_bo_ma,kwota_ma)-sum(CASE WHEN data_rozlicz <= '"+DataP+"' THEN rozliczone_ma ELSE 0 END) <> 0)"
            SQL+=" ORDER BY konto,data,dowod_id||'/'||data||'/'||CAST(numer AS TEXT)||'/'||CAST(nr_poz AS TEXT)||'/'||CAST(nr_ppoz AS TEXT);"
            stat,daneP,naglP,dump = self.PolSQL.Execute(SQL,3)        
        
            if stat <>"OK":
                stat="Bdy w pobieraniu pozycji - "+stat
    
    else:
        # wydruk sald dwustronnych
        
        # pobranie daty koca okresu. Dane pobrane s ze stanw kont z ostatniego miesica okresu.
        SQL="SELECT data_do FROM rs_definicje_okresow WHERE firma_id='"+self.firma_id+"' AND okres_id='"+Okres+"';"
        stat,DaneOkr,dump,dump = self.PolSQL.Execute(SQL,3)        
        if stat=='OK':
            if len(DaneOkr)==0:
                stat='Brak podanego okresu w firmie'
            
        if stat=='OK':
            Rok=DaneOkr[0][0][0:4]
            Mc=DaneOkr[0][0][5:7]
            
            # pobranie danych
            SQL="SELECT konto,rsf_podaj_parametry_konta(firma_id,okres_id,konto),"
            SQL+="saldo_wn,saldo_ma FROM rs_stany_kont"
            SQL+=" WHERE firma_id='"+self.firma_id+"' AND okres_id='"+Okres+"' "
            SQL+=" AND rok='"+Rok+"' AND miesiac='"+Mc+"' "
            SQL+=" AND (((konto>='"+KontoOd+"') AND (konto<='"+KontoDo+"')) OR (konto LIKE '"+KontoDo+"%')) "
            SQL+=" AND saldo_wn <>0 AND saldo_ma <> 0"
            SQL+=" ORDER BY konto;"
            stat,daneP,naglP,dump = self.PolSQL.Execute(SQL,3)        

if stat=='OK':
    dane=str([daneP,naglP,NazwaOd,NazwaDo])