# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_wydruki_sumy_produkcji_ekspedycja
# Purpose:     funkcja pobierajca dane do wydruku zamwie produkcji na potrzeby ekspedycji 
# Author:      Micha Raburski
# Created:     2012/11/11
# RCS-ID:      $Id: fs_wydruki_sumy_produkcji_ekspedycja.py $
# Copyright:   (c) 2012 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

#klucze= oddzial,data,zmiana (rzut)

stat = 'OK'
dane = []
Otwarte=False

if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=='OK':
    Fun = klucze['Funkcja']
    
    SlPar={'Oddzial':[1],'Data':[1],'Zmiana':[1]}    
    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Fun,klucze)
    if Lista<>'':
        stat='Uwaga : wywoanie funkcji fs_wydruki_sumy_produkcji_ekspedycja z numerem '+str(Fun)+' bez parametrw: '+Lista

if stat=='OK':
    if Fun in [1,]:
        Oddzial=rsglobal.Dekoduj(klucze['Oddzial'])
        Data=rsglobal.Dekoduj(klucze['Data'])
        Zmiana=rsglobal.Dekoduj(klucze['Zmiana'])

if Fun==1 and stat=='OK':
    # sprawdzamy czy wszystkie analizowane pozycje s zamknite
    SQL="SELECT DISTINCT stan "
    SQL+=" FROM rs_produkcja_sumy ps INNER JOIN rs_artykuly a USING (firma_id,artykul_id) "
    SQL+="WHERE ps.firma_id='"+self.firma_id+"' AND ps.oddzial_prod='"+Oddzial+"'"
    SQL+=" AND ps.data='"+Data+"' AND ps.zmiana='"+Zmiana+"' AND NOT ps.oddzial_zam='"+Oddzial+"'"
    SQL+=" AND ps.stan='W';"
    stat,DaneTest,dump,dump= self.PolSQL.Execute(SQL,3)
    if stat<>'OK':
        stat='Bd pobierania danych do testu z rs_produkcja_sumy :'+stat
    elif len(DaneTest)>0:
        Otwarte=True
    
    if stat=='OK':
        # pobranie danych z rs_produkcja_sumy
        SQL="SELECT ps.oddzial_zam, ps.artykul_id,a.nazwa,SUM(ps.zamowione1)"
        SQL+=" FROM rs_produkcja_sumy ps INNER JOIN rs_artykuly a USING (firma_id,artykul_id) "
        SQL+="WHERE ps.firma_id='"+self.firma_id+"' AND ps.oddzial_prod='"+Oddzial+"'"
        SQL+=" AND ps.data='"+Data+"' AND ps.zmiana='"+Zmiana+"' AND NOT ps.oddzial_zam='"+Oddzial+"'"
        SQL+=" GROUP BY ps.oddzial_zam, ps.artykul_id,a.nazwa;"
        
        stat,DanePS,dump,dump= self.PolSQL.Execute(SQL,3)
        if stat<>'OK':
            stat='Bd pobierania danych z rs_produkcja_sumy :'+stat

    if stat=='OK':
        # zmiana danych na sownik. Klucze to (oddzia,artyku) a wartoci - (nazwa,ilo,ilo osobna)
        SDane={}
        # sownik z kodami i nazwami artykuw (do wstawiania)
        SArt={}
        for poz in DanePS:
            SDane[(poz[0],poz[1])]=[poz[2],poz[3],0]
            SArt[poz[1]]=poz[2]
    
        # pobieramy wszystkie przesunicia w oparciu o rs_boksy_trasy_dni.
        # przesunicia s midzyoddziaowe oraz do osobnego przerzutu
        # pola to - jaki artyku, ile artykuu przerzuci, czy jest to osobny przerzut,
        # skd go zabra w danych , dokd go wrzuci w danych
        OddzEksp="rsf_podaj_oddzial_ekspedycji(ddp.firma_id,ddp.oddzial_id,ddp.trasa,ddp.data,ddp.tryb_dostawy)"
        Producent="rsf_podaj_oddzial_producenta(ddp.firma_id,"+OddzEksp+","
        Producent+="ddp.artykul_id,ddp.data,COALESCE(td.rzut,''))"
        OsobnyPrzerzut="rsf_podaj_osobny_przerzut_ekspedycji(ddp.firma_id,ddp.oddzial_id,ddp.trasa,ddp.data,ddp.tryb_dostawy)"
        
        SQL="SELECT ddp.artykul_id,ddp.ilosc_zam1,"+OsobnyPrzerzut+",ddp.oddzial_id,"
        SQL+=" CASE WHEN "+OddzEksp+"='"+Oddzial+"' AND "+OsobnyPrzerzut
        SQL+=" THEN ddp.oddzial_id ELSE "+OddzEksp+" END"
        SQL+=" FROM rs_dowody_dostaw_pozycje ddp "
        SQL+=" INNER JOIN rs_dowody_dostaw dd USING (firma_id,oddzial_id, trasa, data, tryb_dostawy, numer)"
        SQL+=" INNER JOIN rs_tryby_dostaw td ON (td.firma_id=ddp.firma_id AND td.kod=ddp.tryb_dostawy)"
        SQL+=" WHERE ddp.firma_id='"+self.firma_id+"' AND ddp.data='"+Data+"' AND td.rzut='"+Zmiana+"'"
        SQL+=" AND "+Producent+"='"+Oddzial+"' AND ddp.oddzial_id<>'"+Oddzial+"'"
        stat,DaneDD,dump,dump= self.PolSQL.Execute(SQL,3)
        if stat<>'OK':
            stat='Bd pobierania danych z rs_dowody_dostaw_pozycje :'+stat
            
    if stat=='OK':
        # w ptli zmieniamy dane z produkcji sumy w oparciu o dane z dowodw dostaw
        for poz in DaneDD:
            if stat=='OK':
                Art=poz[0]
                Ilosc=poz[1]
                CzyOsobny=poz[2]
                Skad=poz[3]
                Dokad=poz[4]
                
                if not Art in SArt:
                    SQL="SELECT nazwa FROM rs_artykuly WHERE firma_id='"+self.firma_id+"' AND artykul_id='"+Art+"'"
                    stat,DaneArt,dump,dump= self.PolSQL.Execute(SQL,3)
                    if stat<>'OK':
                        stat='Bd pobierania danych z rs_artykuly:'+stat
                    elif len(DaneArt)==0:
                        stat='Brak artykuu '+Art
                    else:
                        SArt[Art]=DaneArt[0][0]
            
            if stat=='OK':        
                if not (Skad,Art) in SDane:
                    SDane[(Skad,Art)]=[SArt[Art],0,0]
                if not (Dokad,Art) in SDane:
                    SDane[(Dokad,Art)]=[SArt[Art],0,0]
                SDane[(Skad,Art)][1]=SDane[(Skad,Art)][1]-Ilosc
                if CzyOsobny:
                    SDane[(Dokad,Art)][2]=SDane[(Dokad,Art)][2]+Ilosc
                else:
                    SDane[(Dokad,Art)][1]=SDane[(Dokad,Art)][1]+Ilosc
        
    if stat=='OK':
        # w ptli czyscimy puste wiersze oraz te przypisane do oddziau produkujcego
        KluczeS=SDane.keys()
        for klucz in KluczeS:
            if SDane[klucz][1:]==[0,0] or klucz[0]==Oddzial:
                del SDane[klucz]
            
            
    # nazwy oddziaw
    if stat=='OK':
        SQL="SELECT oddzial_id, nazwa FROM rs_oddzialy"
        SQL+=" WHERE firma_id='"+self.firma_id+"'"
        stat,DaneNO,dump,dump= self.PolSQL.Execute(SQL,3)
        if stat<>'OK':
            stat='Bd pobierania nazw oddziaw :'+stat
            
    if stat=='OK':
        SOddz={}
        for poz in DaneNO:
            SOddz[poz[0]]=poz[1]
        
    if stat=='OK':
        dane=[SDane,SOddz,Otwarte]