# -*- coding: iso8859_2 -*-
#-----------------------------------------------------------------------------
# Name:        fs_wydruki_szkolenia_lista_obecnosci.py
# Purpose:     zebranie danych do listy obecnosci
# Author:      Micha Raburski
# Created:     2012/11/26
# RCS-ID:      $Id: fs_wydruki_szkolenia_lista_obecnosci.py $
# Copyright:   (c) 2012 Record System
# Licence:     GNU GPL
#-----------------------------------------------------------------------------

stat = 'OK'
dane = []

if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=='OK':
    Fun = klucze['Funkcja']
    
    SlPar={'Szkolenie':[1,2],'Data':[1,2],'Godzina':[1,2],'Miejsce':[1,2]}    
    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Fun,klucze)
    if Lista<>'':
        stat='Uwaga : wywoanie funkcji fs_wydruki_szkolenia_lista_obecnosci z numerem '+str(Fun)+' bez parametrw: '+Lista

if stat=='OK':
    if Fun in [1,2]:
        Szkolenie=rsglobal.Dekoduj(klucze['Szkolenie'])
        Data=rsglobal.Dekoduj(klucze['Data'])
        Godzina=rsglobal.Dekoduj(klucze['Godzina'])
        Miejsce=rsglobal.Dekoduj(klucze['Miejsce'])

#pobieranie danych na wydruk
if stat=='OK':
    SQL= " SELECT  kp.imie,kp.nazwisko, COALESCE(ang.komorka_id,''),COALESCE(rz.opis,''),kp.pracownik_id"
    SQL+=" FROM rs_szkolenia_harmonogram_pracownicy szp "
    SQL+=" INNER JOIN rs_kp_dane_osobowe kp USING (firma_id, pracownik_id)"
    SQL+=" LEFT JOIN rs_kp_angaze ang"
    SQL+=" ON (ang.firma_id=kp.firma_id AND (ang.od_kiedy<='"+Data+"' AND (ang.do_kiedy>='"+Data+"' OR ang.do_kiedy is NULL)) AND ang.pracownik_id=kp.pracownik_id )"
    SQL+=" LEFT JOIN rs_komorki_zatrudniajace rz ON (ang.firma_id=rz.firma_id AND ang.komorka_id=rz.kod)"
    SQL+=" WHERE szp.firma_id='"+self.firma_id+"' AND szp.szkolenie_id='"+Szkolenie+"' AND szp.data='"+Data+"' AND szp.godzina='"+Godzina+"' "
    if Fun==1:
        SQL+=" ORDER BY kp.nazwisko "
    else:
        SQL+=" ORDER BY ang.komorka_id, kp.nazwisko"
    stat,dane,dump,dump=self.PolSQL.Execute(SQL,3)

if stat<>'OK':
    dane.append(stat)