# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_wydruki_zamowienia_pozycje
# Purpose:      
# Author:      Dariusz Boduch
# Created:     2007/12/21
# RCS-ID:      $Id: fs_wydruki_zamowienia_pozycje.py $
# Copyright:   (c) 2007 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

# 2011-04-04 Mariusz Rajfura - pobieranie pozycji (sql) bez poz.jednorazowych (4444)
# 2019-04-23 Wojciech Skowron - pobieranie nr_bdo (11475)
# 2019-08-12 Wojciech Skowron - pobieranie czy_mpp (11589)

#klucze= data,wyznacznik,numer,CzyDrukowacBiuro
Data=klucze[0]
Wyznacznik=klucze[1]
Numer=str(klucze[2])
CzyDrB=klucze[3]


stat = "OK"
dane = []

   
#jeli uprawnienia sa ok
if stat=='OK':
    #--- pobranie danych nagwka zamwienia
    KlPom=str([Wyznacznik,Data,Numer]).replace("'",'"')
    Filtr="firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyznacznik+"' AND data='"+Data+"' AND numer="+Numer
    #WS 2019-08-12 - czy_mpp
    stat,daneN,naglN,dump= self.PolSQL.Execute("SELECT stan,numer_z_rs,wersja,handlowiec,oddzial_id,kontrahent_id,zamawiajacy_id,platnik_id,miejsce_dostawy_id,kwota_netto,kwota_vat,do_zaplaty,termin_zaplaty,sposob_zaplaty,waluta,kwota_netto_wal,do_zaplaty_wal,czy_proforma,czy_stale,rsf_podaj_numer_dokumentu_na_wydruk('"+self.firma_id+"','"+KlPom+"','F') as nr_dokumentu, sposob_dostawy, blokada_cen, zamowienie_nr, zamowienie_data, czy_mpp FROM rs_zamowienia_odbiorcy WHERE "+Filtr+";",3)
    if stat<>'OK':
        stat='Bd w pobieraniu danych zamwienia'
        dane.append(stat)
if stat=='OK':    
    DaneN = rssql.RSTableRowset(daneN,naglN)
    #---dane stawek i wartoci VAT zamwienia
    stat,daneV,naglV,dump= self.PolSQL.Execute("SELECT op.wartosc_netto as W_Netto,sv.opis,op.wartosc_vat as W_Vat,op.wartosc_brutto as W_Brutto FROM rs_zamowienia_odbiorcy_vat op INNER JOIN rs_stawki_vat sv ON (op.stawka_vat=sv.kod) WHERE "+Filtr+";",3)
    if stat<>'OK':
        stat='Bd w pobieraniu danych i stawek VAT'
        dane.append(stat)
if stat=='OK':
    #--- opis sposobu zapaty
    stat,daneSP,naglSP,dump= self.PolSQL.Execute("SELECT opis FROM rs_sposoby_zaplaty WHERE firma_id='"+self.firma_id+"' AND kod='"+DaneN.GetVal(0,"sposob_zaplaty")+"';",3)       
    if stat<>'OK':
        stat='Bd w pobieraniu opisu sposobu zapaty'
        dane.append(stat)
    if len(daneSP)==0 and stat=='OK':
        daneSP=[[None]]
if stat=='OK':
    #--- pobranie danych oddziau
    #WS 2019-04-23
    stat,daneOddz,naglOddz,dump= self.PolSQL.Execute("SELECT adr_kraj,oddzial_id,adr_miej,nazwa,nazwa1,nazwa2,nip,regon,adr_kod,adr_poczta,adr_ulica,adr_nry,nr_gios,konto_bank,konto_nr,nr_bdo FROM rs_oddzialy WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+DaneN.GetVal(0,"oddzial_id")+"';",3)
    # stat,daneOddz,naglOddz,dump= self.PolSQL.Execute("SELECT adr_kraj,oddzial_id,adr_miej,nazwa,nazwa1,nazwa2,nip,regon,adr_kod,adr_poczta,adr_ulica,adr_nry,nr_gios,konto_bank,konto_nr FROM rs_oddzialy WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+DaneN.GetVal(0,"oddzial_id")+"';",3)
    if stat<>'OK':
        stat='Bd pobierania danych oddziau'
        dane.append(stat)
if stat=='OK':    
    #pobranie nr telefonu oddziau
    stat,daneT,naglT,dump=self.PolSQL.Execute("SELECT tel1, tel2, fax, email, drukowac_podpisy FROM rs_oddzialy WHERE firma_id='"+self.firma_id+"'AND oddzial_id='"+DaneN.GetVal(0,"oddzial_id")+"';",3)
    if stat<>'OK':
        stat='Bd pobierania danych dodatkowych oddziau'
        dane.append(stat)
if stat=='OK':
    #wybr sposobu sortowania artykuw na fakturze
    kontrahent=DaneN.GetVal(0,"kontrahent_id")
    
    filtr=" firma_id='"+self.firma_id+"' AND kontrahent_id='"+kontrahent+"' AND (data_od<='"+Data+"' OR data_od IS NULL)  ORDER BY data_od DESC LIMIT 1"
    
    stat,daneC,naglC,dump=self.PolSQL.Execute("SELECT czy_ceny_na_dowodach, czy_wg_indeksow FROM rs_kontrahenci_fakturowanie WHERE "+filtr+";",3)
    if stat<>'OK':
        stat='Bd pobierania danych fakturowania'
        dane.append(stat)
    if len(daneC) >0 and stat=='OK':
        DaneC=rssql.RSTableRowset(daneC,naglC)    
        Sort1=DaneC.GetVal(0,"czy_wg_indeksow")
    else:
        Sort1=False
        
    if Sort1== True:
        OrderBy= 'artykul_id'
    else:
        OrderBy='op.nr_poz,op.nr_ppoz'
    
    #pobranie pozycji normalnych
    FILTR="o.firma_id='"+self.firma_id+"' AND o.wyznacznik_id='"+Wyznacznik+"' AND o.data='"+Data+"' AND o.numer="+Numer
    Pola ="ao.obcy_id as obcy_idk, ao.obca_nazwa as obca_nazwak,upper(ao.obca_jm) as obca_jmk, ap.obcy_id as obcy_idp "
    Pola+=",ap.obca_nazwa as obca_nazwap, upper(ap.obca_jm) as obca_jmp,CAST(op.nr_poz AS TEXT) as poz,CAST(op.nr_ppoz AS TEXT) as ppoz "
    Pola+=",a.nazwa as nazwa"
    Pola+=",rsf_podaj_sww_pkwiu_artykulu(COALESCE(op.firma_id,''::TEXT),COALESCE(op.artykul_id,''::TEXT),op.data::TEXT) AS sww_pkwiu "
    Pola+=",upper(a.jm1) as jm1,op.ilosc1,op.cena_upust1,op.wartosc_netto,sv.opis,op.wartosc_vat,op.wartosc_brutto "
    Pola+=",op.nr_serii, op.artykul_id,op.cena_upust_wal1,op.wartosc_wal_netto "
    From =" rs_zamowienia_odbiorcy o "
    From+=" INNER JOIN rs_zamowienia_odbiorcy_pozycje op ON (o.firma_id=op.firma_id AND o.wyznacznik_id=op.wyznacznik_id AND o.data=op.data AND o.numer=op.numer) "
    From+=" LEFT OUTER JOIN rs_artykuly a ON (o.firma_id=a.firma_id AND op.artykul_id=a.artykul_id) "
    From+=" LEFT OUTER JOIN rs_stawki_vat sv ON (op.stawka_vat=sv.kod) "
    From+=" LEFT OUTER JOIN rs_artykuly_obce ao ON (o.firma_id=ao.firma_id AND o.kontrahent_id=ao.kontrahent_id AND op.artykul_id=ao.artykul_id) "
    From+=" LEFT OUTER JOIN rs_artykuly_obce ap ON (o.firma_id=ap.firma_id AND o.platnik_id=ap.kontrahent_id AND op.artykul_id=ap.artykul_id)"
    
    sql = "SELECT "+Pola+" FROM "+From+" WHERE "+FILTR+" ORDER BY "+OrderBy+";"
    
    stat,daneP,naglP,dump= self.PolSQL.Execute(sql,3)
    if stat<>'OK':
        stat='Bd pobierania pozycji zamwienia'
        dane.append(stat)
        
if stat=='OK':    
    #pobranie pozycji opisowych
    filtr="o.firma_id='"+self.firma_id+"' AND o.wyznacznik_id='"+Wyznacznik+"' AND o.data='"+Data+"' AND o.numer="+Numer
    Pola= " CAST(op.nr_poz AS TEXT) as nr_poz, op.opis_pozycji, op.stawka_vat, s.opis, op.wartosc_netto, op.wartosc_vat,op.wartosc_brutto "
    From= " rs_zamowienia_odbiorcy o  "
    From+=" INNER JOIN rs_zamowienia_odbiorcy_pozycje_opisowe op ON (o.firma_id=op.firma_id AND o.wyznacznik_id=op.wyznacznik_id AND o.data=op.data AND o.numer=op.numer) "
    From+=" LEFT OUTER JOIN rs_stawki_vat s ON (op.stawka_vat=s.kod)"
    stat,danePO,naglPO, dump= self.PolSQL.Execute("SELECT "+Pola+" FROM "+From+" WHERE "+filtr+" ORDER BY op.nr_poz;",3)
    if stat<>'OK':
        stat='Bd pobierania pozycji opisowych'
        dane.append(stat)
if stat=='OK':
    #pobranie tekstu nad i pod podpisem
    Pola="tekst_nad_podp, tekst_pod_podp"
    From="rs_zamowienia_odbiorcy "
    stat,daneTX,naglTX,dump=self.PolSQL.Execute("SELECT "+Pola+" FROM "+From+" WHERE "+Filtr+";",3)
    if stat<>'OK':
        stat='Bd pobierania tekstu nad i pod podpisem'
        dane.append(stat)
if stat=='OK':
    #dane kontrahenta
    stat,daneK,naglK,dump= self.PolSQL.Execute("SELECT kraj,nasz_symb,nazwa,nazwa_f1,nazwa_f2,nip,regon,tel1,adr_kod,adr_miej,adr_poczta,adr_ulica,adr_nry,krajk,adrk_kod,adrk_miej,adrk_ulica,adrk_poczta,adrk_nry, kontrahent_id FROM rs_kontrahenci WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+DaneN.GetVal(0,"kontrahent_id")+"';",3)
    if stat<>'OK':
        stat='Bd pobierania danych kontrahenta'
        dane.append(stat)
    DaneK = rssql.RSTableRowset(daneK,naglK)
if stat=='OK':   
    #dane podpisu
    stat,danePodp,naglPodp,dump= self.PolSQL.Execute("SELECT czy_upow FROM rs_kontrahenci_fakturowanie WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+DaneN.GetVal(0,"kontrahent_id")+"' AND data_od < '"+Data+"' ORDER BY data_od ASC LIMIT 1;",3)
    if stat<>'OK':
        stat='Bd pobierania danych podpisu'
        dane.append(stat)
if stat=='OK':    
    #czy drukowac biuro
    if CzyDrB:
        #WS 2019-04-23
        stat,daneDod,naglDod,dump= self.PolSQL.Execute("SELECT adr_kraj,oddzial_id,adr_miej,nazwa,nazwa1,nazwa2,nip,regon,adr_kod,adr_poczta,adr_ulica,adr_nry,nr_gios,konto_bank,konto_nr,nr_bdo FROM rs_oddzialy WHERE firma_id='"+self.firma_id+"' AND oddzial_id<>'**' ORDER BY oddzial_id LIMIT 1;",3)
        # stat,daneDod,naglDod,dump= self.PolSQL.Execute("SELECT adr_kraj,oddzial_id,adr_miej,nazwa,nazwa1,nazwa2,nip,regon,adr_kod,adr_poczta,adr_ulica,adr_nry,nr_gios,konto_bank,konto_nr FROM rs_oddzialy WHERE firma_id='"+self.firma_id+"' AND oddzial_id<>'**' ORDER BY oddzial_id LIMIT 1;",3)
        if stat<>'OK':
            stat='Bd w pobieraniu danych centrali'
            dane.append(stat)
    else:
        daneDod=None
        naglDod=None
if stat=='OK':    
    #pobranie tekstu do nagwka faktury
    stat,daneNg,naglNg,dump=self.PolSQL.Execute("SELECT tekst_naglowka FROM rs_wyznaczniki WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyznacznik+"';",3)
    if stat<>'OK':
        stat='Bd pobierania tekstu nagwka'
        dane.append(stat)
if stat=='OK':
    #pobranie danych operatora
    stat,daneOP,naglOP,dump=self.PolSQL.Execute("SELECT imie, nazwisko FROM rs_operatorzy WHERE operator_id='"+str(self.operator_id)+"'",3)
    if stat<>"OK":
        stat="Bd w pobieraniu danych operatora"
        dane.append(stat)
if stat=='OK':
    #dane platnika
    platnik=DaneN.GetVal(0,"platnik_id")
    #stat,danePL,naglPL,dump= self.PolSQL.Execute("SELECT kraj,nasz_symb,nazwa,nazwa_f1,nazwa_f2,nip,regon,tel1,adr_kod,adr_miej,adr_poczta,adr_ulica,adr_nry,kontrahent_id FROM rs_kontrahenci WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+platnik+"';",3)
    stat,danePL,naglPL,dump= self.PolSQL.Execute("SELECT kraj,nasz_symb,nazwa,nazwa_f1,nazwa_f2,nip,regon,tel1,adr_kod,adr_miej,adr_poczta,adr_ulica,adr_nry,adrk_kod,adrk_miej,adrk_poczta,adrk_ulica,adrk_nry,kontrahent_id,nazwa_pelna FROM rs_kontrahenci WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+platnik+"';",3)
    if stat<>"OK":
        stat = 'Bd w pobieraniu danych patnika faktury.'
        dane.append(stat)
if stat=="OK":  
    #wsprzdne pocztku wydruku adresu odbiorcy faktury - koperta
    stat,daneWR,naglWR,dump = self.PolSQL.Execute("SELECT koperta_wiersz, koperta_kolumna FROM rs_wyznaczniki WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyznacznik+"';",3)
    if stat<>'OK':
        stat = 'Bd w pobieraniu danych wsprzdnych wydruku.'
        dane.append(stat)
if stat=='OK':
    #dane zamawiajacego
    stat,daneZAM,naglZAM,dump= self.PolSQL.Execute("SELECT kraj,nasz_symb,nazwa,nazwa_f1,nazwa_f2,nip,regon,tel1,adr_kod,adr_miej,adr_poczta,adr_ulica,adr_nry,krajk,adrk_kod,adrk_miej,adrk_ulica,adrk_poczta,adrk_nry, kontrahent_id FROM rs_kontrahenci WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+DaneN.GetVal(0,"zamawiajacy_id")+"';",3)
    if stat<>"OK":
        stat = 'Bd w pobieraniu danych zamawiajcego'
        dane.append(stat)    
if stat=='OK':
    #dane miejsca dostawy
    stat,daneMiejDost,naglMiejDost,dump=self.PolSQL.Execute("SELECT kraj,nasz_symb,nazwa,nazwa_f1,nazwa_f2,nip,regon,tel1,adr_kod,adr_miej,adr_poczta,adr_ulica,adr_nry,krajk,adrk_kod,adrk_miej,adrk_ulica,adrk_poczta,adrk_nry, kontrahent_id FROM rs_kontrahenci WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+DaneN.GetVal(0,"miejsce_dostawy_id")+"';",3)
    if stat<>'OK':
        stat = 'Bd w pobieraniu danych miejsca dostawy'
        dane.append(stat)
if stat=='OK':
    #sposob dostawy
    stat,daneSpDost,naglSpDost,dump=self.PolSQL.Execute("SELECT opis FROM rs_sposoby_dostaw WHERE firma_id='"+self.firma_id+"' AND kod='"+DaneN.GetVal(0,"sposob_dostawy")+"';",3)
    if stat<>'OK':
        stat = 'Bd w pobieraniu danych sposobu dostawy'
        dane.append(stat)
    if stat=='OK' and len(daneSpDost)==0:
        daneSpDost=[[None]]
    
    dane=str([daneN,naglN,daneV,naglV,daneSP,naglSP,daneOddz,naglOddz,daneT,naglT,daneP,naglP,danePO,naglPO,daneTX,naglTX,daneK,naglK,danePodp,naglPodp,daneDod,naglDod,daneNg,naglNg,daneOP,naglOP,danePL,naglPL,daneWR,naglWR,daneZAM,naglZAM,daneMiejDost,naglMiejDost,daneSpDost,naglSpDost])    