# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_wydruki_zest_operacji_wg_kont.py
# Purpose:      
# Author:      Micha Raburski
# Created:     2007/04/02
# RCS-ID:      $Id: fs_wydruki_zest_operacji_wg_kont.py $
# Copyright:   (c) 2007 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

#klucze= dataod,datado,kontood,kontodo

DataOd=klucze[0]
DataDo=klucze[1]
KontoOd=klucze[2]
KontoDo=klucze[3]

stat = "OK"
dane = []

#sprawdzenie poprawnosci kluczy
if DataOd=='    -  -  ':
    stat='Brak daty OD'
    dane.append(stat)  
else:
    if not rsglobal.SprawdzCzyToData(DataOd):
        stat='Bdna data OD'
        dane.append(stat)                  

if stat=='OK':
    if DataDo=='    -  -  ':
        stat='Brak daty DO'
        dane.append(stat)  
    else:
        if not rsglobal.SprawdzCzyToData(DataDo):
            stat='Bdna data DO'
            dane.append(stat)

if stat=='OK':
    if DataOd > DataDo:
        stat='Data OD jest starsza od daty DO.'
        dane.append(stat)

if stat=='OK':
    sql = "SELECT data_od, data_do FROM rs_definicje_okresow"
    sql+=" WHERE firma_id = '"+self.firma_id+"' AND okres_id = '"+self.okres_id+"';"
    stat,d,dump,dump = self.PolSQL.Execute(sql, 2)
    if stat <> 'OK':
        stat = 'Bd pobrania danych okresu ksigowego : '+stat
        dane.append(stat)
    else:
        if len(d) == 1:
            if DataOd < str(d[0][0]):
                stat = 'Data pocztkowa jest wczeniejsza od daty pocztku okresu ksigowego'
                dane.append(stat)
            
            if DataDo > str(d[0][1]):
                stat = 'Data kocowa jest pniejsza ni data koca okresu okresu ksigowego'
                dane.append(stat)
                
        else:
            stat = 'Brak zdefiniowanego okresu ksigowego '+str(self.okres_id)
            dane.append(stat)

if stat=='OK':
    if KontoOd=='':
        stat='Brak konta pocztkowego'
        dane.append(stat)  
    
    stat,Dane,dump,dump = self.PolSQL.Execute("SELECT rsf_podaj_parametry_konta('"+self.firma_id+"','"+self.okres_id+"','"+KontoOd+"');",3)            

    if Dane in ['',None,'None']:
        stat='Bdy przy sprawdzaniu konta pocztkowego'
        dane.append(stat)  
    else:
        DaneK = rsglobal.rseval(Dane[0][0])
        
        if KontoOd.find('-') == -1:
            nazwa=DaneK[1]
        else:
            nazwa=DaneK[0]

        if nazwa=='':
            stat='Bdne konto pocztkowe'
            dane.append(stat)  
            
if stat=='OK':
    NazwaKOd=nazwa

    if KontoDo=='':
        stat='Brak konta kocowego'
        dane.append(stat)  

    stat,Dane,dump,dump = self.PolSQL.Execute("SELECT rsf_podaj_parametry_konta('"+self.firma_id+"','"+self.okres_id+"','"+KontoDo+"');",3)            

    if Dane in ['',None,'None']:
        stat='Bdy przy sprawdzaniu konta kocowego'
        dane.append(stat)  
    else:
        DaneK = rsglobal.rseval(Dane[0][0])
        
        if KontoDo.find('-') == -1:
            nazwa=DaneK[1]
        else:
            nazwa=DaneK[0]

        if nazwa=='':
            stat='Bdne konto kocowe'
            dane.append(stat)  
            
if stat=='OK':
    NazwaKDo=nazwa

#jeli wszystko si zgadza to sprawdzamy czy dodawa dat z tyu symbolu
if stat=='OK':
    TekstDaty=''
    SQL="SELECT numer_dowody FROM rs_firmy_numeracja WHERE "
    SQL+="firma_id='"+self.firma_id+"' AND data_od <='"+DataOd+"' LIMIT 1;"
    stat,DaneNr,dump,dump = self.PolSQL.Execute(SQL,3)   
    if stat=='OK':
        if len(DaneNr)>0:
            if not '$D' in DaneNr[0][0]:
                TekstDaty="||' z '||o.data"

#pobranie daty pocztku wybranego okresu
    SQL="SELECT data_od FROM rs_definicje_okresow WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"';"
    stat,DaneOkr,dump,dump = self.PolSQL.Execute(SQL,3)   
    if stat=='OK':
        DataPoczOkr=rsglobal.Dekoduj(DaneOkr[0][0])

#jeli wszystko si zgadza  
if stat=='OK':
    #pobranie danych pozycji
    #Zmiana sposobu pobierania numeru dokumentu na wydruk
    #SQL="SELECT trim(o.dowod_id)||'/'||trim(o.nazwa_id)||'/'||o.data||'/'||o.numer,CASE WHEN o.data_wyst IS NULL THEN '          ' ELSE CAST (o.data_wyst AS TEXT) END,o.symbol_dok,o.konto,o.tresc,o.kwota_wn,o.kwota_ma,o.konto_prz,op.login,o.dziennik,o.waluta,o.kwota_wal_wn,o.kwota_wal_ma,o.data"
    SQL="SELECT rsf_podaj_numer_dokumentu_na_wydruk(o.firma_id,'[\"'||o.dowod_id||'\",\"'||o.nazwa_id||'\",\"'||o.data||'\",\"'||o.numer||'\"]','D')"+TekstDaty+","
    SQL+=" CASE WHEN o.data_wyst IS NULL THEN '          ' ELSE CAST (o.data_wyst AS TEXT) END,"
    SQL+=" o.symbol_dok,o.konto,CASE WHEN o.tresc IS NULL OR o.tresc='' THEN '.' ELSE o.tresc END,o.kwota_wn,o.kwota_ma,o.konto_prz,op.login,o.dziennik,o.waluta,"
    SQL+=" o.kwota_wal_wn,o.kwota_wal_ma,COALESCE(o.data_ksieg_kosztow,o.data),o.dowod_id"
    SQL+=" FROM rs_operacje o INNER JOIN rs_operatorzy op ON (o.operator_zam=op.operator_id)"
    SQL+=" WHERE o.firma_id='"+self.firma_id+"'"
    SQL+=" AND (((o.konto>='"+KontoOd+"') AND (o.konto<='"+KontoDo+"')) OR (o.konto LIKE '"+KontoDo+"\%')) "
    SQL+=" AND COALESCE(o.data_ksieg_kosztow,o.data) >='"+DataPoczOkr+"' AND COALESCE(o.data_ksieg_kosztow,o.data) <='"+DataDo+"' "
    SQL+=" ORDER BY konto DESC, o.data,o.dowod_id,o.nazwa_id,o.numer;"
    stat,Dane,dump,dump = self.PolSQL.Execute(SQL,3)        
    
#jesli pobralo wstepnie wszystkie dane potrzebne do zrobienia wydruku to obrabiamy je    
if stat=='OK':
    SKont={}
    LOper=[]
    for op in Dane:
        Konto=op[3]
        Data=op[13]
        Dowod=op[14]
        #jesli jest w zakresie to dodajemy operacje do listy
        if (Data >= DataOd) and (Dowod not in ["BO","BK"]):
            oper=[op[3],op[0],op[1],op[2],op[4],op[5],op[6],op[7],op[8],op[9],op[10],op[11],op[12]]
            LOper.append(oper)
        #zapis kwoty na poszczegolne konta
        while Konto <> '':
            #dodanie konta do sownika gdy go nie ma (ostatni jest sownik w podziale na waluty - docelowo tylko on zostanie)
            if Konto not in SKont:
                SKont[Konto]=[0,0,0,0,'{}']
            
            #dodanie kwot do konta w slowniku
            Sumy=SKont[Konto]
            if (Data >= DataOd) and (Dowod not in ["BO","BK"]):
                Sumy[2]+=op[5]
                Sumy[3]+=op[6]
            else:
                Sumy[0]+=op[5]
                Sumy[1]+=op[6]

            #obsuga sownika z tyu 
            SWal=eval(Sumy[4])
            Wal=op[10]
            if not 'PLN' in SWal:
                SWal['PLN']=[0,0,0,0,0,0,0,0]
            if not Wal in SWal:
                SWal[Wal]=[0,0,0,0,0,0,0,0]
                
                # niezalenie od waluty teraz pole kwota trafia do PLN, 
                # a do innych walut - tylko kwota walutowa
            
            if Data >= DataOd and (Dowod not in ["BO","BK"]):
                #kwoty w okresie (pln i potem w walucie)
                SWal['PLN'][4]+=rsglobal.RSRound(op[5],2)
                SWal['PLN'][5]+=rsglobal.RSRound(op[6],2)
                if Wal <> 'PLN':
                    SWal[Wal][6]+=rsglobal.RSRound(op[11],2)
                    SWal[Wal][7]+=rsglobal.RSRound(op[12],2)
            else:
                #kwoty przed okresem (pln i potem w walucie)
                SWal['PLN'][0]+=rsglobal.RSRound(op[5],2)
                SWal['PLN'][1]+=rsglobal.RSRound(op[6],2)
                if Wal <> 'PLN':
                    SWal[Wal][2]+=rsglobal.RSRound(op[11],2)
                    SWal[Wal][3]+=rsglobal.RSRound(op[12],2)
                    
            Sumy[4]=str(SWal)
            #cicie konta
            Miej=Konto.rfind('-')
            if Miej>-1:
                Konto=Konto[0:Miej]
            else:
                Konto=''

    #po analizie wszystkich operacji zmieniamy sownik na list i potem sortujemy
    LKont=[]
    for kl in SKont.keys():
        stat,Dane,dump,dump = self.PolSQL.Execute("SELECT rsf_podaj_parametry_konta('"+self.firma_id+"','"+self.okres_id+"','"+rsglobal.Dekoduj(kl)+"');",3)        
        if Dane in ['',None,'None']:
            stat='Bdy przy sprawdzaniu konta '+kl+" !"+str(Dane)+"!"
            dane.append(stat)  
            break
        
        Nazwa=''
        konto=rsglobal.Dekoduj(kl).strip()
       
        while konto.rfind('-')>-1:
            stat,nazwy,dump,dump = self.PolSQL.Execute("SELECT rsf_podaj_nazwe_konta('"+self.firma_id+"','"+self.okres_id+"','"+konto+"');",3)
            if stat<>'OK':
                stat='Bdy przy pobieraniu nazwy konta '+konto+ '!'
                dane.append(stat)
            Tekst=str(nazwy[0][0])
            Nazwa=Tekst.strip()+'~@~'+ Nazwa
            konto=konto[0:(konto.rfind('-'))]
                    
        stat,nazwy,dump,dump = self.PolSQL.Execute("SELECT rsf_podaj_nazwe_konta('"+self.firma_id+"','"+self.okres_id+"','"+konto+"');",3)       
        if stat<>'OK':
            stat='Bdy przy pobieraniu nazwy konta '+konto+ '!'
            dane.append(stat)
        Tekst=rsglobal.Dekoduj(str(nazwy[0][0]))
        Nazwa=Tekst.strip()+'~@~'+Nazwa
        LKont.append([kl+'-zzz',kl,Nazwa.strip('~@~'),SKont[kl][0],SKont[kl][1],SKont[kl][2],SKont[kl][3],SKont[kl][4]])

if stat=='OK':        
    LKont.sort()
    dane=str([NazwaKOd,NazwaKDo,LKont,LOper])
