# -*- coding: iso8859_2 -*-
#-----------------------------------------------------------------------------
# Name:        fs_wydruki_zestawienie_srodkow_dla_grupy.py
# Purpose:     pobiera dane do wydruku zestawienia srodkow trwalych wg grupy
# Author:      Dariusz Boduch, Micha Raburski
# Created:     2006/11/16
# RCS-ID:      $Id: fs_wydruki_zestawienie_srodkow_dla_grupy.py $
# Copyright:   (c) 2018 Record System
# Licence:     GNU GPL
#-----------------------------------------------------------------------------

# 2018-01-04 Piotr Witkowski (10880) Dodatkowa kolumna w zestawieniu rodkw trwaych
# 2020-09-10 Jan Raburski (12109) Grupa od i Grupa do + odrobaczenie

#klucze: rok, grupa, rodzaj: 1- wszystko, 2, sprzedane, 3 - zlikwidowane, 4- przyjete

Rok = klucze[0]
GrupaOd = klucze[1]
GrupaDo = klucze[2]
Rodzaj = klucze[3]
CzyPodatkowa = klucze[4]

stat = "OK"
dane = []

#sprawdzanie poprawnosci kluczy
#if stat=='OK':
#    if Grupa.strip()=='':
#        stat='Brak grupy'
#        dane.append(stat)
#if stat=='OK':

# wczytanie grup
SQL = "SELECT kod FROM rs_grupy_srodkow_trwalych WHERE firma_id='"+self.firma_id+"' "
if GrupaOd != '':
    SQL += " and kod>='"+GrupaOd+"' "
if GrupaDo != '':
    SQL += " and kod<='" + GrupaDo + "' "
SQL += " ORDER BY kod;"
stat,DaneG,dump,dump = self.PolSQL.Execute(SQL,3)
if stat != 'OK':
    stat = 'Bd pobierania grup.'
    dane.append(stat)
elif len(DaneG)==0:
    stat='Brak grup z podanego zakresu.'
    dane.append(stat)
   
if stat=='OK':
    Grupy = "("
    for w in DaneG:
        Grupy += "'" + w[0].strip() + "',"
    Grupy = Grupy[:-1] + ")"
    if CzyPodatkowa:
        PPod='podat'
        PP='_p'
    else:
        PPod='rach'
        PP=''
    
    if Rodzaj==1:
        Where=''
    elif Rodzaj==2:
        Where=" AND st.data_sprzedazy >= '"+Rok+"-01-01' AND st.data_sprzedazy<= '"+Rok+"-12-31' "
    elif Rodzaj==3:
        Where=" AND st.data_likwidacji >= '"+Rok+"-01-01' AND st.data_likwidacji<= '"+Rok+"-12-31' "
    elif Rodzaj==4:
        Where=" AND st.data_przyjecia >= '"+Rok+"-01-01' AND st.data_przyjecia<= '"+Rok+"-12-31' "
    elif Rodzaj==5:
        Where=" AND (NOT (st.data_sprzedazy >= '"+Rok+"-01-01' AND st.data_sprzedazy<= '"+Rok+"-12-31') OR st.data_sprzedazy IS NULL)"
        Where+=" AND (NOT (st.data_likwidacji >= '"+Rok+"-01-01' AND st.data_likwidacji<= '"+Rok+"-12-31') OR st.data_likwidacji IS NULL)"
        Where+=" AND NOT (st.data_przyjecia >= '"+Rok+"-01-01' AND st.data_przyjecia<= '"+Rok+"-12-31') "
        
    SQL="SELECT st.grupa,gs.opis, st.srodek_id, st.nazwa, st.data_przyjecia, ROUND(st.wartosc_poczatkowa"+PP+",2),st.data_likwidacji "
    SQL+=",st.data_sprzedazy, round(sum(CASE WHEN stu.rok < '"+Rok+"' THEN stu."+PPod+"_umorz ELSE 0 END),2)"
    SQL+=",round(sum(CASE WHEN stu.rok <='"+Rok+"' THEN stu."+PPod+"_umorz ELSE 0 END),2) "
    SQL+=", st.procent_umorzenia"+PP+", st.data_odpisu, st.symbol_kst_2018 "
    SQL+="FROM rs_srodki_trwale st "
    SQL+="LEFT OUTER JOIN rs_srodki_trwale_umorzenia stu ON ( st.firma_id=stu.firma_id AND st.srodek_id=stu.srodek_id) "
    SQL+="LEFT OUTER JOIN rs_grupy_srodkow_trwalych gs ON (st.firma_id=gs.firma_id AND st.grupa=gs.kod) "
    SQL+="WHERE st.firma_id='"+self.firma_id+"' and st.grupa IN " + Grupy
    SQL+=" AND (substring(data_sprzedazy::TEXT from 1 for 4) >='"+Rok+"' or data_sprzedazy is null) "
    SQL+=" AND  (substring(data_likwidacji::TEXT from 1 for 4) >='"+Rok+"' or data_likwidacji is null) "+Where+" "
    SQL+="GROUP BY st.grupa,gs.opis, st.srodek_id, st.nazwa, st.data_przyjecia, st.data_likwidacji, st.data_sprzedazy, st.wartosc_poczatkowa"+PP+" "
    SQL+=", st.procent_umorzenia"+PP+", st.data_odpisu, st.symbol_kst_2018 "
    SQL+="ORDER BY st.srodek_id ;"

    rsglobal.ZapiszDoLogow(SQL,1)
    stat,daneST,dump,dump = self.PolSQL.Execute(SQL,3)
    if stat<>'OK':
        stat='Bd pobierania danych rodkw trwaych'
        dane.append(stat)
    else:
        for w in daneST:
            #tworzenie jednego rekordu: grupa, nazwa,srodek, nazwa srodka, data prz., wart poczatkowa, data likwidacji,
            #data sprzedazy, wartosc amort na 01.01, amort za 01,..., amort za 12, wartosc amort na 31.12, % umorzenia, data , symbol_kst_2018
            WIERSZ=[w[0],w[1],w[2],w[3],w[4],w[5],w[6],w[7],w[8],0,0,0,0,0,0,0,0,0,0,0,0,w[9],w[10],w[11],0, w[12]]
            
            SQL="SELECT miesiac, ROUND("+PPod+"_umorz,2) FROM rs_srodki_trwale_umorzenia WHERE firma_id='"+self.firma_id+"' "
            SQL+="AND srodek_id='"+rsglobal.Dekoduj(w[2])+"' AND rok='"+Rok+"' "
            stat,daneAST,dump,dump = self.PolSQL.Execute(SQL,3)
            if stat<>'OK':
                stat='Bd pobierania danych amortyzacji rodkw trwaych'
                dane.append(stat)
            for amort in daneAST:
                if amort[0]=='01':
                    WIERSZ[9]+=round(amort[1],2)
                elif amort[0]=='02':
                    WIERSZ[10]+=round(amort[1],2)
                elif amort[0]=='03':
                    WIERSZ[11]+=round(amort[1],2)
                elif amort[0]=='04':
                    WIERSZ[12]+=round(amort[1],2)
                elif amort[0]=='05':
                    WIERSZ[13]+=round(amort[1],2)
                elif amort[0]=='06':
                    WIERSZ[14]+=round(amort[1],2)
                elif amort[0]=='07':
                    WIERSZ[15]+=round(amort[1],2)
                elif amort[0]=='08':
                    WIERSZ[16]+=round(amort[1],2)
                elif amort[0]=='09':
                    WIERSZ[17]+=round(amort[1],2)      
                elif amort[0]=='10':
                    WIERSZ[18]+=round(amort[1],2)
                elif amort[0]=='11':
                    WIERSZ[19]+=round(amort[1],2)
                elif amort[0]=='12':
                    WIERSZ[20]+=round(amort[1],2)
            
            #pobranie wartoci poczatkowej
            SQL="SELECT wartosc_poczatkowa"+PP+" FROM rs_srodki_trwale "
            SQL+=" WHERE firma_id='"+self.firma_id+"' AND srodek_id='"+rsglobal.Dekoduj(w[2])+"' "
            
            stat,danePST,dump,dump = self.PolSQL.Execute(SQL,3)
            if stat<>'OK':
                stat='Bd pobierania danych przeszacowa rodkw trwaych'
                dane.append(stat)
            else:
                if danePST<>[]:
                    WIERSZ[5]=round(danePST[0][0],2)
            #uwzgldnianie kwot zmiany wartosci
            SQL="SELECT sum("+PPod+"_przesz) FROM rs_srodki_trwale_przeszacowania  "
            SQL+=" WHERE firma_id='"+self.firma_id+"' AND srodek_id='"+rsglobal.Dekoduj(w[2])+"' "
            SQL+=" AND rok='"+Rok+"' "
            stat,daneST,dump,dump = self.PolSQL.Execute(SQL,3)
            if stat<>'OK':
                stat='Bd pobierania kwot przeszacowa rodkw trwaych'
                dane.append(stat)
            else:
                if daneST<>[]:
                    kwota=  WIERSZ[5]
                    WIERSZ[5]=kwota-round(daneST[0][0],2)
                    WIERSZ[24]=round(daneST[0][0],2)
            
            dane.append(WIERSZ)
if stat == 'OK':
    wyn1 = Grupy[1:-1].replace("'", "")