#!/usr/bin/python
# -*- coding: iso8859_2 -*-
#-----------------------------------------------------------------------------
# Name:             fs_wydruki_zestawienie_sum_transakcji.py
# Purpose:          wydruk zestawienia sum transakcji
# Author:           Dariusz Boduch
# Created:          2009/08/18
# RCS-ID:           $Id: fs_wydruki_zestawienie_sum_transakcji.py $
# Copyright:        (c) 2007 RecordSystem
# Licence:          GNU GPL
#-----------------------------------------------------------------------------
#klucze: Dowod id, Nazwa id (brak, jedna, lub kilka), data od, data do
DowodId=klucze[0]
NazwaId=klucze[1]
DataOd=klucze[2]
DataDo=klucze[3]

stat = "OK"
dane = []

#sprawdzenie poprawnosci danych
if DowodId.strip() in (None,'','None'):
    stat='Brak dowodu id'
if stat=='OK':
    SQL="SELECT dowod_id FROM rs_wzory_dekretacji WHERE firma_id='"+self.firma_id+"' "
    SQL+=" AND dowod_id='"+DowodId+"'  LIMIT 1 ;"
    stat,daneD,dump,dump = self.PolSQL.Execute(SQL,3)
    if stat<>'OK':
        stat='Bd sprawdzenia dowodu id '+stat
    else:
        if len(daneD)==0:
            stat='Niepoprawny symbol dowodu ksigowego'
if stat=="OK":
    if NazwaId.strip() not in (None,'','None'):
        Nazwa=NazwaId.split(',')
        NazwaID="'"
        for w in Nazwa:
            SQL="SELECT dowod_id FROM rs_wzory_dekretacji WHERE firma_id='"+self.firma_id+"' "
            SQL+=" AND dowod_id='"+DowodId+"' AND nazwa_id='"+str(w)+"' LIMIT 1 ;"
            stat,daneDN,dump,dump = self.PolSQL.Execute(SQL,3)
            if stat<>'OK':
                stat='Bd sprawdzenia dowodu id i nazwy id: '+stat
            else:
                if len(daneDN)==0:
                    stat="Symbol nazwy id '"+str(w)+"' nie wystpuje z dowodem ksigowym: '"+DowodId+"' "
            NazwaID=NazwaID+str(w)+"','"
        NazwaID=NazwaID[:-2]

if stat=='OK':
    if DataOd=='    -  -  ':
        stat='Brak daty od'
    else:
        if not rsglobal.SprawdzCzyToData(DataOd):
            stat='Bdna data od'
            
if stat=='OK':
    if DataDo=='    -  -  ' :
        stat='Brak daty do'
    else:
        if not rsglobal.SprawdzCzyToData(DataDo):
            stat='Bdna data do'
if stat=='OK':
    if DataDo < DataOd:
        stat='Bdny zakres dat'

if self.operator_id == STANDARD_OPERATOR_ID:
    UprWyk=True
else:
    UprWyk=(self.oddzial_id,'077070') in self.uprawnienia

if stat=='OK':
    if not UprWyk:
        stat='Brak uprawnie do wykonywania wydruku. Skontaktuj si z administratorem.'
    else:
        #pobieranie danych 
        SQL="SELECT CASE WHEN (konto is not null OR length(trim(konto))>0) "
        SQL+="THEN rtrim(split_part(konto,'-',1)||'-'||split_part(konto,'-',2),'-') END AS konto_id "
        SQL+=", sum(kwota_ma) AS kwota_ma, sum(kwota_wn) AS kwota_wn FROM rs_operacje WHERE firma_id='"+self.firma_id+"' "
        SQL+=" AND dowod_id='"+DowodId+"' "
        if NazwaId.strip() not in (None,'','None'):
            SQL+=" AND nazwa_id in ("+NazwaID+") "
        SQL+="AND COALESCE(data_ksieg_kosztow,data) >= '"+DataOd+"' AND COALESCE(data_ksieg_kosztow,data)<='"+DataDo+"' "
        SQL+="GROUP BY konto_id ORDER BY konto_id ;"
        stat,daneK,naglK,dump = self.PolSQL.Execute(SQL,3)
if stat=='OK':
    #           0     1 
    dane=str([daneK,naglK])