# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_wydruki_zestawienie_zbiorcze
# Purpose:      
# Author:      Dariusz Boduch - Micha Raburski
# Created:     2007/06/21
# RCS-ID:      $Id: fs_wydruki_zestawienie_zbiorcze.py $
# Copyright:   (c) 2007 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

# 2012-09-21 Mariusz Rajfura (6087) oddzial_id w kluczu

#klucze= trasa,data,tryb_dostawy,numer

from funkcje import fs_artykuly_pom

Trasa=klucze[0]
Data=klucze[1]
Tryb=klucze[2]
Zmienione=klucze[3]
Oddzial=klucze[4]

stat = "OK"
dane = []

#--- pobranie pozycji 
SQL="SELECT ddp.artykul_id AS artykul, a.nazwa AS nazwa, SUM(ddp.ilosc_zam1) AS zamowiono, SUM(ddp.ilosc_pobr1) AS pobrano,"
SQL+="SUM(ddp.ilosc_rozst1) AS rozstawiono, SUM(ddp.ilosc_dost1) AS dostarczono, SUM((ddp.ilosc_pobr1)-(ddp.ilosc_dost1)) AS zwrotysw, SUM(ddp.ilosc_zwr1) AS zwrotycz "
SQL+=" FROM rs_dowody_dostaw dd LEFT OUTER JOIN rs_dowody_dostaw_pozycje ddp USING (firma_id, oddzial_id, trasa, data,tryb_dostawy,numer) "
SQL+=" LEFT OUTER JOIN rs_artykuly a ON (ddp.firma_id=a.firma_id AND ddp.artykul_id=a.artykul_id) "
SQL+=" WHERE ddp.firma_id='"+self.firma_id+"' AND ddp.oddzial_id='"+Oddzial+"' AND ddp.trasa='"+Trasa+"' AND ddp.data='"+Data+"'"
SQL+=" AND ddp.tryb_dostawy='"+Tryb+"' AND ddp.artykul_id IS NOT NULL "
SQL+=" GROUP BY ddp.artykul_id, a.nazwa "
SQL+=" ORDER BY ddp.artykul_id;"

stat,daneP,naglP,dump=self.PolSQL.Execute(SQL,3)
DaneP = rssql.RSTableRowset(daneP,naglP)
if stat<>'OK':
    stat='Bd w pobieraniu pozycji'
    
if stat=='OK':
#---dane oddzialu
    SQL="SELECT oddzial_id, nazwa, adr_kod, adr_miej, adr_ulica, adr_nry, nip "
    SQL+=" FROM rs_dowody_dostaw LEFT OUTER JOIN rs_oddzialy USING (firma_id, oddzial_id) "
    SQL+=" WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+Oddzial+"' AND trasa='"+Trasa+"' AND data='"+Data+"'"
    SQL+=" AND tryb_dostawy='"+Tryb+"';"
    stat,daneO,naglO,dump= self.PolSQL.Execute(SQL,3)
    DaneO = rssql.RSTableRowset(daneO,naglO)
    if len(daneO)>0:
        oddzial = DaneO.GetVal(0,"oddzial_id")
        onazwa = DaneO.GetVal(0,"nazwa")
        okod = DaneO.GetVal(0,"adr_kod")
        omiejscowosc = DaneO.GetVal(0,"adr_miej")
        oulica = DaneO.GetVal(0,"adr_ulica")
        onumer = DaneO.GetVal(0,"adr_nry")
        onip = DaneO.GetVal(0,"nip")       
    else:   
        stat='Bdne dane oddzialu : '+self.oddzial_id+"' - '"+nazwa
        
if stat=='OK':
   
#--dane dowodu
    SQL="SELECT td.opis AS topis,dd.stan AS stan, dd.trasa AS trasa, t.opis AS opis, CAST(min(dd.numer) AS TEXT) AS numermin,"
    SQL+=" CAST(max(dd.numer)AS TEXT) AS numermax, dd.data AS data, dd.kierowca AS kierowca, k.opis AS kopis, dd.tryb_dostawy AS tryb, "
    SQL+=" SUM(CASE WHEN dd.czy_zmodyfikowany THEN 1 ELSE 0 END) as czy_zmodyfikowany"
    SQL+=" FROM rs_dowody_dostaw dd LEFT OUTER JOIN rs_trasy t ON (dd.firma_id=t.firma_id AND dd.oddzial_id=t.oddzial_id AND dd.trasa=t.kod)"
    SQL+=" LEFT OUTER JOIN rs_kierowcy k ON (dd.firma_id=k.firma_id AND dd.kierowca=k.kod) "
    SQL+=" LEFT OUTER JOIN rs_tryby_dostaw td ON (dd.firma_id=td.firma_id AND dd.tryb_dostawy=td.kod) "
    SQL+=" WHERE dd.firma_id='"+self.firma_id+"' AND dd.oddzial_id='"+Oddzial+"'AND dd.data='"+Data+"' AND dd.trasa='"+Trasa+"'"
    SQL+=" AND dd.tryb_dostawy='"+Tryb+"' GROUP BY td.opis, dd.stan, dd.trasa, t.opis, dd.kierowca,dd.data, k.opis, dd.tryb_dostawy ;"
    stat,daneD,naglD,dump= self.PolSQL.Execute(SQL,3)        
    DaneD = rssql.RSTableRowset(daneD,naglD)
#    if len(daneD)>0:
#        stan = DaneD.GetVal(0,"stan")
#        trasa = DaneD.GetVal(0,"trasa")
#        opis = DaneD.GetVal(0,"opis")
#        numermin = DaneD.GetVal(0,"numermin")
#        numermax = DaneD.GetVal(0,"numermax")
#        data = DaneD.GetVal(0,"data")
#        kierowca = DaneD.GetVal(0,"kierowca")
#        kopis = DaneD.GetVal(0,"kopis")
#        tryb = DaneD.GetVal(0,"tryb")
#        topis = DaneD.GetVal(0,"topis")
#    else:
#        stat='Bdne dane dowodu'
    if len(daneD)==0:
        stat='Bdne dane dowodu'
        
#--Opakowania dostarczone - zwrcone
if stat=='OK':
    SQL="SELECT SUM(opak_dostarczone1) AS dost1, SUM(opak_dostarczone2) AS dost2, SUM(opak_zwrocone1) AS zwr1, SUM(opak_zwrocone2) AS zwr2"
    SQL+=" FROM rs_dowody_dostaw WHERE firma_id='"+self.firma_id+"' AND oddzial_id='"+Oddzial+"' AND trasa='"+Trasa+"'"
    SQL+=" AND data='"+Data+"' AND tryb_dostawy='"+Tryb+"';"
    stat,daneW,naglW,dump= self.PolSQL.Execute(SQL,3)
    DaneW = rssql.RSTableRowset(daneW,naglW)
    if stat<>'OK':
        stat="Bdne dane Opakowania dost. - zwr."

#--Kosze odebrane 
if stat=='OK':
    wszystkie_daneK=[]
    daneK=[]
    naglK=[]
    for w in daneP:
        SQL="SELECT artykul_id, ilosc1 FROM rs_artykuly_opakowania_zbiorcze WHERE firma_id='"+self.firma_id+"' AND artykul_id='"+str(w[0])+"';"
        stat,daneK,naglK,dump= self.PolSQL.Execute(SQL,3)
        DaneK = rssql.RSTableRowset(daneK,naglK)    
        if stat<>"OK":
            stat="Bdy w pobieraniu informacji o odebranych koszach"
        if len(daneK)>0:
            wszystkie_daneK.append(daneK[0])
            
#--Opakowania dla trasy
if stat=='OK':
    SQL =" SELECT ddp.kontrahent_id,k.nazwa,k.adr_ulica,k.adr_nry,k.adr_miej,ddp.artykul_id,a.nazwa,ddp.ilosc_dost1"
    SQL+=" FROM rs_dowody_dostaw dd"
    SQL+=" LEFT OUTER JOIN rs_dowody_dostaw_pozycje ddp USING (firma_id, oddzial_id, trasa, data,tryb_dostawy,numer)"
    SQL+=" LEFT OUTER JOIN rs_artykuly a ON (ddp.firma_id=a.firma_id AND ddp.artykul_id=a.artykul_id)"
    SQL+=" LEFT OUTER JOIN rs_kontrahenci k ON(ddp.firma_id=k.firma_id AND ddp.kontrahent_id=k.kontrahent_id)"
    SQL+=" WHERE ddp.firma_id='"+self.firma_id+"' AND ddp.oddzial_id='"+Oddzial+"' AND ddp.trasa='"+Trasa+"'"
    SQL+=" AND ddp.data='"+Data+"' AND ddp.tryb_dostawy='"+Tryb+"' AND ddp.artykul_id IS NOT NULL "
    SQL+=" GROUP BY ddp.kontrahent_id,ddp.artykul_id,a.nazwa,ddp.ilosc_dost1,k.nazwa,k.adr_ulica,k.adr_nry,k.adr_miej "
    SQL+=" ORDER BY ddp.kontrahent_id,ddp.artykul_id;"
    stat,daneOT,dump,dump= self.PolSQL.Execute(SQL,3)
    if stat == 'OK': 
        daneOpakTrasy = []
        for w in daneOT:     
            stat,SOpakArt = fs_artykuly_pom.PodajOpakowaniaDlaArtykulu(self,w[5],w[7],w[0],'','',4)
            if SOpakArt <> {} and stat == 'OK':
                lista =[w[0]+"- "+w[1].strip()+", "+w[2].strip()+" "+str(w[3])+", "+w[4].strip(),w[5].strip()+"- "+w[6].strip()]
                opak = ''
                for s in SOpakArt:
                    if SOpakArt[s]>0:
                        SQL="SELECT opis FROM rs_opakowania_zbiorcze WHERE firma_id='"+self.firma_id+"' AND kod='"+s+"'"
                        stat,daneOP,dump,dump= self.PolSQL.Execute(SQL,3)
                        opak+=daneOP[0][0]+": "+str(SOpakArt[s])+" szt."+";"
                lista.append(opak[:-1])
                daneOpakTrasy.append(lista)
             
dane=str([daneP,naglP,daneO,naglO,daneD,naglD,daneW,naglW,wszystkie_daneK,naglK,daneOpakTrasy])

