# -*- coding: iso8859_2 -*-

#-----------------------------------------------------------------------------
# Name:        fs_wzory_dekretacji_dostaw_dane.py
# Purpose:     wczytuje/edytuje dane pozycji wzoru dekretacji dostawy
#
# Author:      Piotr Witkowski
# Created:     2016/12/21
# RCS-ID:      $Id: fs_wzory_dekretacji_dostaw_dane.py $
# Copyright:   (c) 2016 Record System
# Licence:     GNU GPL
#-----------------------------------------------------------------------------

# 2019-02-19 Wojciech Skowron  refaktoryzacja (10389) - klucze w postaci slownika zamiast listy, kontrola uprawnien wyciagnieta na poczatek
# 2019-04-16 Wojciech Skowron  refaktoryzacja (10389) - sprawdzanie bdw

stat='OK'
#WS
if not 'Funkcja' in klucze:
    stat = 'Brak podanej funkcji w kluczach'
    Fun = 999

if stat == 'OK':
    Fun = klucze['Funkcja']

    SlPar = {'Dowod':[1,3,4,5], 'Nazwa':[1,3,4,5], 'NrPoz':[1,3,4,5]}
    Lista = rsglobal.SprawdzParametryWKluczach(SlPar, Fun, klucze)
    if Lista != '':
        stat = 'Uwaga : wywoanie funkcji fs_wzory_dekretacji_dostaw_dane z numerem '+str(Fun)+' bez parametrw: '+Lista

if stat == 'OK':
    Dowod = rsglobal.Dekoduj(klucze['Dowod'])
    Nazwa = rsglobal.Dekoduj(klucze['Nazwa'])
    NrPoz = rsglobal.Dekoduj(klucze['NrPoz'])
# Dowod=rsglobal.Dekoduj(klucze[0][0])
# Nazwa=rsglobal.Dekoduj(klucze[0][1])
# NrP=str(rsglobal.Dekoduj(klucze[1][0]))
# Funkcja = klucze[-1]

#print (self.oddzial_id,'074122') in self.uprawnienia
#print (self.oddzial_id,'074123') in self.uprawnienia

    WHERE = " WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"' AND dowod_id='"+Dowod+"' AND nazwa_id='"+Nazwa+"' AND nr_poz="+str(NrPoz) #NrP #WS

#-------------------------------------------------------------------------------
#---   KONTROLA UPRAWNIEN
#-------------------------------------------------------------------------------

#WS
if Fun in [3,4] and stat == 'OK':
    if not (((self.oddzial_id,'074122') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID):
        stat='UPR UPD'

#-------------------------------------------------------------------------------
#---   UPDATE DANYCH (4- bez pobierania,3- z pobieraniem)
#-------------------------------------------------------------------------------

#WS
if Fun in [3,4] and stat == 'OK':
# if Funkcja in [3,4]:

    # if (((self.oddzial_id,'074122') in self.uprawnienia) or(self.oddzial_id,'074123') in self.uprawnienia or self.operator_id == STANDARD_OPERATOR_ID):
    # stat = "OK"
    dane = []

    #sprawdzenie danych
    for i in range(len(pola)):
        pole = pola[i]
        wart = wartosci[i]

        if pole == "sposob_rozl":
            if wart <> "":
                sql = "SELECT 1 FROM rs_sposob_rozl_vat WHERE kod = '"+wart+"';"
                #WS 2019-04-16
                stat,DaneTmp,dump,dump = self.PolSQL.Execute(sql, 3)
                # DaneTmp = self.PolSQL.Execute(sql,3)[1]
                if stat != 'OK':
                    stat = 'BL SQL SPOSOB ROZL'
                    dane.append(stat)
                else:
                    if (DaneTmp <> []) and (DaneTmp <> None):
                        Dane = rsglobal.rseval(DaneTmp[0][0])
                        if Dane[0] == '':
                            stat='BL SPOSOB ROZL'
                            dane.append(stat)

        elif pole == "konto_wn":
            if wart <> "":
                sql = "SELECT rsf_podaj_parametry_konta('"+self.firma_id+"','"+self.okres_id+"','"+wart+"');"
                #WS 2019-04-16
                stat, DaneTmp, dump, dump = self.PolSQL.Execute(sql, 3)
                # DaneTmp = self.PolSQL.Execute(sql,3)[1]
                if stat != 'OK':
                    stat = 'BL SQL K WN'
                    dane.append(stat)
                else:
                    if (DaneTmp <> []) and (DaneTmp <> None):
                        Dane = rsglobal.rseval(DaneTmp[0][0])
                        if Dane[0] == '':
                            stat='BL K WN'
                            dane.append(stat)

        elif pole == "konto_ma":
            if wart <> "":
                sql = "SELECT rsf_podaj_parametry_konta('"+self.firma_id+"','"+self.okres_id+"','"+wart+"');"
                #WS 2019-04-16
                stat, DaneTmp, dump, dump = self.PolSQL.Execute(sql, 3)
                # DaneTmp = self.PolSQL.Execute(sql,3)[1]
                if stat != 'OK':
                    stat = 'BL SQL K MA'
                else:
                    if (DaneTmp <> []) and (DaneTmp <> None):
                        Dane = rsglobal.rseval(DaneTmp[0][0])
                        if Dane[0] == '':
                            stat='BL K MA'
                            dane.append(stat)

        elif pole=="stawka_vat_wn":
            if wart == "":
                stat="BR VAT"
                dane.append(stat)
            else:
                sql = "SELECT kod FROM rs_stawki_vat WHERE  kod='"+wart+"';"
                #WS 2019-04-16
                stat, d, dump, dump = self.PolSQL.Execute(sql, 3)
                # dump,d,dump,dump = self.PolSQL.Execute(sql,3)
                if stat != 'OK':
                    stat = 'BL SQL VAT'
                else:
                    if len(d)==0:
                        stat='BL VAT'
                        dane.append(stat)

        elif pole == "konto_vat_wn":
            if wart == "":
                stat="BR K VWN"
                dane.append(stat)
            else:
                sql = "SELECT rsf_podaj_parametry_konta('"+self.firma_id+"','"+self.okres_id+"','"+wart+"');"
                #WS 2019-04-16
                stat, DaneTmp, dump, dump = self.PolSQL.Execute(sql, 3)
                # dump,d,dump,dump = self.PolSQL.Execute(sql,3)
                if stat != 'OK':
                    stat = 'BL SQL K VWN'
                    dane.append(stat)
                else:
                    if (DaneTmp <> []) and (DaneTmp <> None):
                        Dane = rsglobal.rseval(DaneTmp[0][0])
                        if Dane[0] == '':
                            stat='BL K VWN'
                            dane.append(stat)

    #Jak ok to update
    if stat=='OK':
        upd = "UPDATE rs_wzory_dekretacji_dostaw SET "
        for i in range(len(pola)):
            pole = pola[i]
            wart = wartosci[i]

            if pole in ['sposob_rozl','konto_wn','konto_ma','stawka_vat_wn','konto_vat_wn','warunek']:
                upd=upd+pole+"='"+str(wart)+"',"
            elif pole in ['czy_kontrahent','konto_ma_z_kontrahenta','pobierac_na_rejestr']:
                upd=upd+pole+"="+str(wart)+","

        upd = upd[0:len(upd)-1]+WHERE+";"
        rsglobal.ZapiszDoLogow(upd,1)
        stat,dump,dump,dump = self.PolSQL.Execute(upd ,1)
        #WS 2019-04-16
        if stat != 'OK':
            stat = 'BL UPD'
            dane.append(stat)
    # else:
    #     stat='UPR UPD'
   

#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (5 -select, 3 -update z pobraniem, 1 -insert z pobraniem)
#-------------------------------------------------------------------------------

#WS
if (Fun in [5,3,1]) and (stat=='OK'):
# if (Funkcja in [5,3,1]) and (stat=='OK'):
    # pobranie danych
    SQL="SELECT konto_wn,sposob_rozl,konto_vat_wn,stawka_vat_wn,konto_ma,"
    SQL+="czy_kontrahent,warunek,konto_ma_z_kontrahenta,pobierac_na_rejestr "
    SQL+="FROM rs_wzory_dekretacji_dostaw "+WHERE+";"
    stat,dane,wyn1,tr = self.PolSQL.Execute(SQL,3)
    if stat != 'OK':
        stat = 'BL SEL'
        dane.append(stat)
    else:
        # pobranie sownika
        if len(dane) == 1:
            tr = rssql.RSTableRowset(dane,wyn1)
            sql = "SELECT opis FROM rs_sposob_rozl_vat WHERE kod='"+tr.GetVal(0,"sposob_rozl")+"';"
            #--- sposob rozliczania
            dump,d,dump,dump = self.PolSQL.Execute(sql ,3)
            if len(d) == 0:
                wyn2.append('')
            else:
                wyn2.append(d[0][0])
            #--- stawka vat
            if ((self.oddzial_id,'011120') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
                sql = "SELECT opis FROM rs_stawki_vat WHERE kod='"+tr.GetVal(0,"stawka_vat_wn")+"';"
                dump,d,dump,dump = self.PolSQL.Execute(sql ,3)

                if len(d) == 0:
                    wyn2.append('')
                else:
                    wyn2.append(d[0][0])
            else:
                wyn2.append('Brak uprawnie do sownika. Poinformuj administratora.')
