# -*- coding: iso8859_2 -*-

#-----------------------------------------------------------------------------
# Name:        fs_wzory_dekretacji_faktur_dane.py
# Purpose:     wczytuje/edytuje dane pozycji wzoru dekretacji faktury
#
# Author:      Micha Raburski
# Created:     2007/02/15
# RCS-ID:      $Id: fs_wzory_dekretacji_faktur_dane.py $
# Copyright:   (c) 2004 - 2008 Record System
# Licence:     GNU GPL
#-----------------------------------------------------------------------------

# 2019-02-19 Wojciech Skowron  refaktoryzacja (10389) - klucze w postaci slownika zamiast listy, kontrola uprawnien wyciagnieta na poczatek
# 2019-04-16 Wojciech Skowron  refaktoryzacja (10389) - sprawdzanie bdw

#klucze = [Przecena,KluczPoz,funkcja]
#Przecena=dowod,nazwa
#KluczPoz=nr_poz

stat='OK'
#WS
if not 'Funkcja' in klucze:
    stat = 'Brak podanej funkcji w kluczach'
    Fun = 999

if stat == 'OK':
    Fun = klucze['Funkcja']

    SlPar = {'Dowod':[1,3,4,5], 'Nazwa':[1,3,4,5], 'NrPoz':[1,3,4,5]}
    Lista = rsglobal.SprawdzParametryWKluczach(SlPar, Fun, klucze)
    if Lista != '':
        stat = 'Uwaga : wywoanie funkcji fs_wzory_dekretacji_przeksiegowan_dane z numerem '+str(Fun)+' bez parametrw: '+Lista

if stat == 'OK':
    Dowod = rsglobal.Dekoduj(klucze['Dowod'])
    Nazwa = rsglobal.Dekoduj(klucze['Nazwa'])
    NrPoz = rsglobal.Dekoduj(klucze['NrPoz'])

# Dowod=rsglobal.Dekoduj(klucze[0][0])
# Nazwa=rsglobal.Dekoduj(klucze[0][1])
# NrP=str(rsglobal.Dekoduj(klucze[1][0]))

    WHERE = " WHERE firma_id='"+self.firma_id+"' AND okres_id='"+self.okres_id+"' AND dowod_id='"+Dowod+"' AND nazwa_id='"+Nazwa+"' AND nr_poz="+str(NrPoz) #NrP #WS

#-------------------------------------------------------------------------------
#---   KONTROLA UPRAWNIEN
#-------------------------------------------------------------------------------

#WS
if Fun in [3,4] and stat == 'OK':
    if not (((self.oddzial_id,'074122') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID):
        stat='UPR UPD'

#-------------------------------------------------------------------------------
#---   UPDATE DANYCH (4- bez pobierania,3- z pobieraniem)
#-------------------------------------------------------------------------------

#WS
if Fun in [3,4] and stat == 'OK':
# if klucze[-1] in [3,4]:
#     if (((self.oddzial_id,'074122') in self.uprawnienia) or self.operator_id == STANDARD_OPERATOR_ID):
#     stat = "OK"
    dane = []

    #sprawdzenie danych
    for i in range(len(pola)):
        pole = pola[i]
        wart = wartosci[i]

        if pole == "konto_bazowe":
            if wart == "":
                stat='BR K BAZ'
                dane.append(stat)
            elif wart <> "":
                sql = "SELECT rsf_podaj_parametry_konta('"+self.firma_id+"','"+self.okres_id+"','"+wart+"');"
                #WS 2019-04-16
                stat,DaneTmp,dump,dump = self.PolSQL.Execute(sql,3)
                # DaneTmp = self.PolSQL.Execute(sql,3)[1]
                if stat != 'OK':
                    stat='BL SQL K BAZ'
                else:
                    if (DaneTmp <> []) and (DaneTmp <> None):
                        Dane = rsglobal.rseval(DaneTmp[0][0])
                        if Dane[0] == '':
                            stat='BL K BAZ'
                            dane.append(stat)

        elif pole == "konto_wn":
            if wart == "":
                stat='BR K WN'
                dane.append(stat)
            elif wart <> "":
                sql = "SELECT rsf_podaj_parametry_konta('"+self.firma_id+"','"+self.okres_id+"','"+wart+"');"
                #WS 2019-04-16
                stat,DaneTmp,dump,dump = self.PolSQL.Execute(sql,3)
                # DaneTmp = self.PolSQL.Execute(sql,3)[1]
                if stat != 'OK':
                    stat='BL SQL K WN'
                else:
                    if (DaneTmp <> []) and (DaneTmp <> None):
                        Dane = rsglobal.rseval(DaneTmp[0][0])
                        if Dane[0] == '':
                            stat='BL K WN'
                            dane.append(stat)

        elif pole == "konto_ma":
            if wart == "":
                stat='BR K MA'
                dane.append(stat)
            elif wart <> "":
                sql = "SELECT rsf_podaj_parametry_konta('"+self.firma_id+"','"+self.okres_id+"','"+wart+"');"
                #WS 2019-04-16
                stat,DaneTmp,dump,dump = self.PolSQL.Execute(sql,3)
                # DaneTmp = self.PolSQL.Execute(sql,3)[1]
                if stat != 'OK':
                    stat='BL SQL K MA'
                else:
                    if (DaneTmp <> []) and (DaneTmp <> None):
                        Dane = rsglobal.rseval(DaneTmp[0][0])
                        if Dane[0] == '':
                            stat='BL K MA'
                            dane.append(stat)

    #Jak ok to update
    if stat=='OK':
        upd = "UPDATE rs_wzory_dekretacji_przeksiegowan SET "
        for i in range(len(pola)):
            pole = pola[i]
            wart = wartosci[i]


            if pole in ['konto_bazowe','konto_wn','konto_ma','rodzaj','tresc']:
                upd=upd+pole+"='"+str(wart)+"',"
            elif pole in ['ujemne',]:
                upd=upd+pole+"="+str(wart)+","

        upd = upd[0:len(upd)-1]+WHERE+";"
        rsglobal.ZapiszDoLogow(upd,1)
        stat,dump,dump,dump = self.PolSQL.Execute(upd ,1)
        #WS 2019-04-16
        if stat != 'OK':
            stat = 'BL UPD'
    # else:
    #     stat='UPR UPD'

   

#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (5 -select, 3 -update z pobraniem, 1 -insert z pobraniem)
#-------------------------------------------------------------------------------

#WS
if (Fun in [5,3,1]) and (stat=='OK'):
# if (klucze[-1] in [5,3,1]) and (stat=='OK'):
    # pobranie danych kasy/banku
    stat,dane,wyn1,tr = self.PolSQL.Execute("SELECT * FROM rs_wzory_dekretacji_przeksiegowan "+WHERE+";",3)
    #WS 2019-04-16
    if stat != 'OK':
        stat = 'BL SEL'
 
