# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_zamowienia_dostawcy_dane.py
# Purpose:     wczytuje/edytuje dane podstawowe zamowien dostawcy
#
# Author:      Marcin Grzeda
# Created:     2008/04/01
# RCS-ID:      $Id: fs_zamowienia_dostawcy_dane.py $
# Copyright:   (c) 2017 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

# 2012-08-29 Mariusz Rajfura (6031) popr.pobrania danych do fakturowania
#                                   a wlasciwie sprawdzenie bledow przy edycji
# 2012-09-04 Mariusz Rajfura (6029) pobranie waluty z danych do fakturowania
# 2014-05-15 Micha Raburski (7974) zmiana wymagalnoci miejsca dostawy
# 2014-05-15 Micha Raburski (7975) sprzedawca na zamwieniu dostawcy
# 2017-05-16 Piotr Witkowski - Refaktoryzacja okna (10501)
# 2021-06-08 Aleksander Bargie [MG] Status w zamwieniach do dostawcow  (12513)


import rsglobal

stat='OK'

if stat == 'OK' and not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=='OK':
    Funkcja = klucze['Funkcja']
    SlPar={'Wyznacznik':[1,2,3,4,5,6,21],'Data':[1,2,3,4,5,21],'Numer':[1,2,3,4,5],'Kontr':[21,],}

    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Funkcja,klucze)
    if Lista<>'':
        stat=u'Uwaga : wywoanie funkcji fs_zamowienia_dostawcy_dane z numerem ' +str(Funkcja)+u' bez parametrw: '+Lista
    if stat=='OK':
        if Funkcja in [1,2,3,4,5,6,21]:
            Wyznacznik = str(klucze['Wyznacznik'])
        if Funkcja in [1, 2, 3, 4, 5,21]:
            Data = str(klucze['Data'])
        if Funkcja in [1,2,3,4,5]:
            Numer = str(klucze['Numer'])
        if Funkcja in [21]:
            Kontr = str(klucze['Kontr'])

if stat=='OK':
    dane = []
    wyn1 = []
    wyn2 = []
    Pola=pola
    Wartosci=wartosci
    puste_pola = [[],"","    -  -  "]

if stat=='OK':
    Lista=[self.firma_id,self.oddzial_id,self.operator_id]
    sql = "SELECT rsf_podaj_wyznaczniki('"+str(Lista).replace("'",'"')+"','[]','None');"    
    stat,wyzn,dump,dump=self.PolSQL.Execute(sql,3)
    
    if stat<>'OK':
        stat='BL SQL WYZN $'+stat
        dane.append(stat)

if stat=='OK':
    LWyzn=rsglobal.rseval(wyzn[0][0])[1]
    if LWyzn==[]:
        stat='BR LWYZN'
if stat=='OK':
    if self.operator_id == STANDARD_OPERATOR_ID:
        UprPrz=True
        UprEdy=True
        LPrz=LWyzn
        LEdy=LWyzn
        LPrz.append('ZASLEPKA')
    else:
        UprPrz=(self.oddzial_id,'037010') in self.uprawnienia
        UprEdy=(self.oddzial_id,'037012') in self.uprawnienia or (self.oddzial_id,'037013') in self.uprawnienia
                
        LPrz=['ZASLEPKA']
        LEdy=[]
                      
                                   
        if UprPrz and Funkcja in [5,3,1]:
            Lista=[self.firma_id,self.oddzial_id,self.operator_id]
            sql = "SELECT rsf_podaj_wyznaczniki('"+str(Lista).replace("'",'"')+"','[]','[True,False,False,False,False,False]');"    
            stat,wyzn,dump,dump=self.PolSQL.Execute(sql,3)
            if stat=='OK':
                LPrz=rsglobal.rseval(wyzn[0][0])[1]
                             
                                               
        if stat=='OK': 
            if UprEdy and Funkcja in [4,3]:
                Lista=[self.firma_id,self.oddzial_id,self.operator_id]
                sql = "SELECT rsf_podaj_wyznaczniki('"+str(Lista).replace("'",'"')+"','[]','[False,False,True,False,False,False]');"    
                stat,wyzn,dump,dump=self.PolSQL.Execute(sql,3)
                if stat=='OK':
                    LEdy=rsglobal.rseval(wyzn[0][0])[1]

if Funkcja == "9": #sprawdzam walute
    if Wyznacznik not in puste_pola:
        sql = "SELECT data,nr_tabeli,kurs_sredni/ilosc_waluty,kurs_zakup/ilosc_waluty,kurs_sprzedaz/ilosc_waluty FROM rs_kursy_walut WHERE firma_id = '"+self.firma_id+"' AND waluta = '"+Numer+"' AND data='"+Wyznacznik+"';"
    elif Data not in puste_pola:
        sql = "SELECT data,nr_tabeli,kurs_sredni/ilosc_waluty,kurs_zakup/ilosc_waluty,kurs_sprzedaz/ilosc_waluty FROM rs_kursy_walut WHERE firma_id = '"+self.firma_id+"' AND waluta = '"+Numer+"' AND nr_tabeli='"+Data+"';"
    stat,dane,dump,dump = self.PolSQL.Execute(sql ,3)
    

#--------------------------------------------------------------------------------------------------
#Funkcja (21) 
#Pobieranie danych, ktre musz ulec modyfikacji po zmianie kontrahenta w danych faktury 
#--------------------------------------------------------------------------------------------------

if Funkcja==21:
    Wyzn=Wyznacznik
            
    if Kontr == "":
        stat = "BR KONTR"
    elif stat=='OK':
        stat,d,dump,dump = self.PolSQL.Execute("SELECT nazwa FROM rs_kontrahenci WHERE firma_id=\'"+self.firma_id+"\' AND kontrahent_id=\'"+str(Kontr)+"\' AND aktywny;",3)
                
        if stat<>'OK':
            stat='BL SQL PLAT ZAM'
        elif len(d) == 0:
            stat = "BL KONTR"
        else:
            Kontrahenci=[Kontr]
            wyn2=[]
                 
            #odbiorca
            if ((self.oddzial_id,'012010') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
                wyn2=[d[0][0]]
            else:
                wyn2.append('Brak uprawnie do sownika. Poinformuj administratora.')
            
            sql ="SELECT wersja,spos_zaplaty,spos_dostawy,handlowiec,sposob_odbioru_faktury,projekt_id,dni,upust,"
            sql+=" COALESCE (waluta_zakup,'PLN'::TEXT) AS waluta_zakup"
            sql+=" FROM rs_kontrahenci_fakturowanie"
            sql+=" WHERE firma_id=\'"+self.firma_id+"\' AND kontrahent_id = \'"+Kontr+"\' AND data_od <= \'"+Data+"\'"
            sql+=" ORDER BY data_od DESC LIMIT 1;"
            st,dane,wyn1,dump = self.PolSQL.Execute(sql, 3)
            if st<>'OK':
                stat='BL SQL DAN KONT'
                dane.append(stat)
            elif len(dane) == 1:
                tr = rssql.RSTableRowset(dane,wyn1)
                dane=Kontrahenci+dane[0]
                for i in xrange(len(dane)):
                    if dane[i]==u'None':
                        dane[i]=''
                    
                #wersja
                if ((self.oddzial_id,'011100') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
                    dump,d,dump,dump = self.PolSQL.Execute("SELECT opis FROM rs_wersje_cenowe WHERE firma_id='"+self.firma_id+"' AND kod='"+tr.GetVal(0,"wersja")+"';" ,3)
                    if len(d) == 0:
                        wyn2.append('')
                    else:
                        wyn2.append(d[0][0])
                else:
                    wyn2.append('Brak uprawnie do sownika. Poinformuj administratora.')   
                    
                #sposob zaplaty
                if ((self.oddzial_id,'011090') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
                    dump,d,dump,dump = self.PolSQL.Execute("SELECT opis FROM rs_sposoby_zaplaty WHERE firma_id='"+self.firma_id+"' AND kod='"+tr.GetVal(0,"spos_zaplaty")+"';" ,3)
                    if len(d) == 0:
                        wyn2.append('')
                    else:
                        wyn2.append(d[0][0])
                else:
                    wyn2.append('Brak uprawnie do sownika. Poinformuj administratora.')
                    
                #sposob dostawy                   
                if ((self.oddzial_id,'011030') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
                    dump,d,dump,dump = self.PolSQL.Execute("SELECT opis FROM rs_sposoby_dostaw WHERE firma_id='"+self.firma_id+"' AND kod='"+tr.GetVal(0,"spos_dostawy")+"';" ,3)
                    if len(d) == 0:
                        wyn2.append('')
                    else:
                        wyn2.append(d[0][0])
                else:
                    wyn2.append('Brak uprawnie do sownika. Poinformuj administratora.')
                
                #handlowiec
                if ((self.oddzial_id,'011220') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
                    dump,d,dump,dump = self.PolSQL.Execute("SELECT opis FROM rs_handlowcy WHERE firma_id='"+self.firma_id+"' AND kod='"+tr.GetVal(0,"handlowiec")+"';" ,3)
                    if len(d) == 0:
                        wyn2.append('')
                    else:
                        wyn2.append(d[0][0])
                else:
                    wyn2.append('Brak uprawnie do sownika. Poinformuj administratora.')
                
                #sposob odbioru faktury
                if ((self.oddzial_id,'011230') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
                    dump,d,dump,dump = self.PolSQL.Execute("SELECT opis FROM rs_sposoby_odbioru_faktury WHERE firma_id='"+self.firma_id+"' AND kod='"+tr.GetVal(0,"sposob_odbioru_faktury")+"';" ,3)
                    if len(d) == 0:
                        wyn2.append('')
                    else:
                        wyn2.append(d[0][0])
                else:
                    wyn2.append('Brak uprawnie do sownika. Poinformuj administratora.')
                
                #projekt
                if ((self.oddzial_id,'027000') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
                    dump,d,dump,dump = self.PolSQL.Execute("SELECT opis FROM rs_projekty WHERE firma_id='"+self.firma_id+"' AND projekt_id='"+tr.GetVal(0,"projekt_id")+"';" ,3)
                    if len(d) == 0:
                        wyn2.append('')
                    else:
                        wyn2.append(d[0][0])
                else:
                    wyn2.append('Brak uprawnie do sownika. Poinformuj administratora.')

                # dopasowanie ilosci pozycji wyn2[] do dane[]
                wyn2.append(0)  # dni
                wyn2.append(0)  # upust

                #waluta
                if ((self.oddzial_id,'011130') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
                    dump,d,dump,dump = self.PolSQL.Execute("SELECT opis FROM rs_waluty WHERE firma_id='"+self.firma_id+"' AND kod='"+tr.GetVal(0,"waluta_zakup")+"';" ,3)
                    if len(d) == 0:
                        wyn2.append('')
                    else:
                        wyn2.append(d[0][0])
                else:
                    wyn2.append('Brak uprawnie do sownika. Poinformuj administratora.')
                    
                # pobranie sprzedawcy
                SQL="SELECT kontrahent_id,nazwa FROM rs_kontrahenci WHERE firma_id='"+self.firma_id+"' AND "
                SQL+="kontrahent_id = (SELECT COALESCE(platnik_id,kontrahent_id) FROM rs_kontrahenci "
                SQL+="WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+Kontr+"');"
                stat,DSprzed,dump,dump = self.PolSQL.Execute(SQL,3)
                if stat <> 'OK':
                    stat= 'Bd pobierania sprzedawcy po zmianie kontrahenta : '+stat
                elif ((self.oddzial_id,'012010') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
                    wyn2.append(DSprzed[0][0]) # symbol sprzedawcy
                    wyn2.append(DSprzed[0][1]) # nazwa sprzedawcy
                else:
                    wyn2.append('')
                    wyn2.append('Brak uprawnie do sownika. Poinformuj administratora.')
            else:
                dane=Kontrahenci
                wyn2.append(['waluta','PLN','polski zoty'])

            
#-------------------------------------------------------------------------------
#---   Sprawdzam dane
#-------------------------------------------------------------------------------

if stat=='OK':
    if Funkcja in [3,4]:
        if Data not in puste_pola:
            dane_wyn = rsglobal.SprawdzCzyToData(Data)   
            if not dane_wyn:
                stat = "BL KLUCZ"
            else:
                sql="SELECT rsf_sprawdz_date_z_zakresem(\'"+self.firma_id+self.oddzial_id+"\',\'"+Data+"\',1);"
                stat,dane_wyn,dump,dump = self.PolSQL.Execute(sql ,3)
                if stat<>'OK':
                    stat='BL KLUCZ DANE'
                    dane.append(stat)
                if dane_wyn <> 1:
                    stat="ZK DATA"
                    dane_wyn.append(stat)
            Filtr = "firma_id=\'"+self.firma_id+"\' AND wyznacznik_id=\'"+Wyznacznik+"\' AND data=\'"+Data+"\' AND numer="+str(Numer)
            sql="SELECT wyznacznik_id FROM rs_zamowienia_dostawcy WHERE "+Filtr+";"
            stat,dane_wyn,dump,dump = self.PolSQL.Execute(sql ,3)
            if stat<>'OK':
                stat='BL KLUCZ DANE'
                dane.append(stat)
            if len(dane_wyn) == 0:
                stat = "BL KLUCZ"
                dane.append(stat)
        else:
            stat = "BL KLUCZ"
            dane.append(stat)

        if stat=="OK":
            Wersja=''
            Upust=-1
            Kontrahent=''
            Waluta=''
            for i in range(len(Pola)):
                pole = Pola[i]
                wart = Wartosci[i]
                if pole == "kontrahent_id":
                    if wart == "":
                        stat="BR KONTR"
                        dane.append(stat)
                    else:
                        sql = "SELECT kontrahent_id FROM rs_kontrahenci WHERE firma_id=\'"+self.firma_id+"\' AND kontrahent_id = \'"+wart+"\' AND aktywny;"
                        stat,dane_wyn,dump,dump = self.PolSQL.Execute(sql ,3)
                        if stat<>'OK':
                            stat='BL SQL DAN KONT'
                            dane.append(stat)
                        if len(dane_wyn) == 0:
                            stat="BL KONTR"
                            dane.append(stat)
                        else:
                            Kontrahent=wart
                            
            for i in range(len(Pola)):
                pole = Pola[i]
                wart = Wartosci[i]
                if pole == "sprzedawca_id":
                    if wart == "":
                        # uzupenienie go z automatu
                        if Kontrahent == '':
                            SQL="SELECT kontrahent_id FROM rs_zamowienia_dostawcy WHERE firma_id='"+self.firma_id+"'"
                            SQL+=" AND wyznacznik_id='"+Wyznacznik+"' AND data='"+Data+"' AND numer="+str(Numer)
                            stat,DKontr,dump,dump = self.PolSQL.Execute(SQL,3)
                            if stat<>'OK':
                                stat='Bd pobierania kontrahenta z zamwienia '+stat
                                dane.append(stat)
                            else:
                                Kontrahent = DKontr[0][0]
                        SQL="SELECT COALESCE(platnik_id,kontrahent_id) FROM rs_kontrahenci WHERE "
                        SQL+=" firma_id='"+self.firma_id+"' AND kontrahent_id='"+Kontrahent+"'"
                        stat,DPlat,dump,dump = self.PolSQL.Execute(SQL,3)
                        if stat<>'OK':
                            stat='Bd pobierania patnika z kontrahenta '+stat
                            dane.append(stat)
                        else:
                            Wartosci[i] = DPlat[0][0]
                    else:
                        sql = "SELECT kontrahent_id FROM rs_kontrahenci WHERE firma_id=\'"+self.firma_id+"\' AND kontrahent_id = \'"+wart+"\' AND aktywny;"
                        stat,dane_wyn,dump,dump = self.PolSQL.Execute(sql ,3)
                        if stat<>'OK':
                            stat='BL SQL DAN SPRZED'
                            dane.append(stat)
                        if len(dane_wyn) == 0:
                            stat="BL SPRZED"
                            dane.append(stat)

                elif pole == "wyznacznik_id":
                    if wart == "":
                        stat="BR WYZN"
                        dane.append(stat)
                    else:
                        stat,dane_wyn,dump,dump = self.PolSQL.Execute("SELECT wyznacznik_id FROM rs_wyznaczniki WHERE firma_id=\'"+self.firma_id+"\' AND wyznacznik_id = \'"+wart+"\';",3)
                        if stat<>'OK':
                            stat='BL SQL DANE WYZN'
                            dane.append(stat)
                        if len(dane_wyn) == 0:
                            stat="BL WYZN"
                            dane.append(stat)

                elif pole == "numer":
                    if wart <=0:
                        stat="BL NUMER"
                        dane.append(stat)

                elif pole == "oddzial_id":
                    if wart == "":
                        stat="BR ODDZ"
                        dane.append(stat)
                    else:
                        if wart <> Oddzial:
                            stat="NG ODDZ"
                            dane.append(stat)   

                elif pole == "stan":
                    if wart == "":
                        stat="BR STAN"
                        dane.append(stat)
                    else:
                        if not wart in ["W","Z"]:
                            stat="BL STAN"
                            dane.append(stat)

                elif pole == "miejsce_dostawy_id":
                    if wart == "":
                        Wartosci[i] = "NULL"
                    else:
                        stat,dane_wyn,dump,dump = self.PolSQL.Execute("SELECT kontrahent_id FROM rs_kontrahenci WHERE firma_id=\'"+self.firma_id+"\' AND kontrahent_id = \'"+wart+"\' AND aktywny;",3)
                        if stat<>'OK':
                            stat='BL SQL MIEJDOST'
                            dane.append(stat)
                        if len(dane_wyn) == 0:
                            stat= "BL MIEJDOST"
                            dane.append(stat)

                elif pole == "dostawy_od_dnia":
                    if wart == "    -  -  ":
                        Wartosci[i] = "NULL"
                    elif not rsglobal.SprawdzCzyToData(wart):
                        stat="BL DATADOD"
                        dane.append(stat)

                elif pole == "dostawy_do_dnia":
                    if wart == "    -  -  ":
                        Wartosci[i] = "NULL"
                    elif not rsglobal.SprawdzCzyToData(wart):
                        stat="BL DATADDO"
                        dane.append(stat)

                elif pole == "zamowienie_data":
                    if wart == "    -  -  ":
                        Wartosci[i] = "NULL"
                    elif not rsglobal.SprawdzCzyToData(wart):
                        stat="BL DATA ZAM"
                        dane.append(stat)

                elif pole == "waluta":
                    if wart == "":
                        stat="BR WALUTA"
                        dane.append(stat)
                    else:
                        st,dane_wyn,dump,dump = self.PolSQL.Execute("SELECT kod FROM rs_waluty WHERE firma_id=\'"+self.firma_id+"\' AND kod= \'"+wart+"\';",3)
                        if st<>'OK':
                            stat='BL SEL WAL'
                            dane.append(stat)
                        elif len(dane_wyn) == 0:
                            stat="BL WALUTA"
                            dane.append(stat)
                        else:
                            Waluta=wart

                elif pole == "wersja":
                    if wart == "":
                        Wartosci[i] = "NULL"
                    else:
                        st,dane_wyn,dump,dump = self.PolSQL.Execute("SELECT kod FROM rs_wersje_cenowe WHERE firma_id=\'"+self.firma_id+"\' AND kod = \'"+wart+"\';",3)
                        if st<>'OK':
                            stat='BL SEL WERS'
                            dane.append(stat)
                        elif len(dane_wyn) == 0:
                            stat="BL WERSJA"
                            dane.append(stat)
                        else:
                            Wersja=wart

                elif pole == "typ_zamowienia":
                    if wart in ['']:
                        Wartosci[i] = "NULL"
                    else:
                        st,dane_wyn,dump,dump = self.PolSQL.Execute("SELECT kod FROM rs_typy_zamowien WHERE firma_id=\'"+self.firma_id+"\' AND kod = \'"+wart+"\';",3)
                        if st<>'OK':
                            stat='BL SEL TYP'
                            dane.append(stat)
                        if len(dane_wyn)==0:
                            stat='BL TYP'
                            dane.append(stat)                                

                elif pole == "sposob_zaplaty":
                    if wart == "":
                        stat="BR SPOSZAPL"
                        dane.append(stat)
                    else:
                        st,dane_wyn,dump,dump = self.PolSQL.Execute("SELECT kod FROM rs_sposoby_zaplaty WHERE firma_id=\'"+self.firma_id+"\' AND kod = \'"+wart+"\';",3)
                        if st<>'OK':
                            stat='BL SEL SPOS ZAPL'
                            dane.append(stat)
                        elif len(dane_wyn) == 0:
                            stat="BL SPOSZAPL"
                            dane.append(stat)

                elif pole == "sposob_dostawy":
                    if wart == "":
                        Wartosci[i] = "NULL"
                        dane.append(stat)
                    else:
                        st,dane_wyn,dump,dump = self.PolSQL.Execute("SELECT kod FROM rs_sposoby_dostaw WHERE firma_id=\'"+self.firma_id+"\' AND kod = \'"+wart+"\';",3)
                        if st<>'OK':
                            stat='BL SQL SPOS DOST'
                            dane.append(stat)
                        elif len(dane_wyn) == 0:
                            stat="BL SPOSDOST"
                            dane.append(stat)

                elif pole == "handlowiec":    
                    if wart == "":
                        Wartosci[i] = "NULL"
                    else:
                        st,dane_wyn,dump,dump = self.PolSQL.Execute("SELECT kod FROM rs_handlowcy WHERE firma_id=\'"+self.firma_id+"\' AND kod = \'"+wart+"\';",3)
                        if st<>'OK':
                            stat='BL SQL HANDL'
                            dane.append(stat)
                        elif len(dane_wyn) == 0:
                            stat="BL HANDL"
                            dane.append(stat)

                elif pole == "sposob_odbioru_faktury":    
                    if wart == "":
                        Wartosci[i] = "NULL"
                    else:
                        st,dane_wyn,dump,dump = self.PolSQL.Execute("SELECT kod FROM rs_sposoby_odbioru_faktury WHERE firma_id=\'"+self.firma_id+"\' AND kod = \'"+wart+"\';",3)
                        if st<>'OK':
                            stat='BL SEL SPOS ODB FAKT'
                            dane.append(stat)
                        elif len(dane_wyn) == 0:
                            stat="BL SPOSODBFAKT"
                            dane.append(stat)

                elif pole == "projekt_id":    
                    if wart == "":
                        stat="BR PROJ"
                        dane.append(stat)
                    else:
                        st,dane_wyn,dump,dump = self.PolSQL.Execute("SELECT projekt_id FROM rs_projekty WHERE firma_id='"+self.firma_id+"' AND projekt_id = '"+wart+"';",3)
                        if st<>'OK':
                            stat='BL SQL PROJ'
                            dane.append(stat)
                        elif len(dane_wyn) == 0:
                            stat="BL PROJ"
                            dane.append(stat)
                #AB 08.06.21r
                elif pole == "status_zamowienia":
                    if wart == "":
                        Wartosci[i] = "NULL"
                    else:
                        st,dane_wyn,dump,dump = self.PolSQL.Execute("SELECT kod FROM rs_zamowienia_dostawcy_statusy WHERE firma_id='"+self.firma_id+"' AND kod = '"+wart+"';",3)
                        if st<>'OK':
                            stat='BL SQL STATUS'
                            dane.append(stat)
                        elif len(dane_wyn) == 0:
                            stat="BL STATUS"
                            dane.append(stat)
                    
                elif pole=='upust':
                    Upust=wart

        else:
            stat="BL_SQL"
            dane.append(stat)
            
        #jesli byly jakies bledy
        if stat == 'OK':
            if len(dane) > 0:
                stat = dane[0]


#-------------------------------------------------------------------------------
#---   UPDATE DANYCH (4- bez pobierania,3- z pobieraniem)
#-------------------------------------------------------------------------------

if stat == "OK" and Funkcja in [4,3]:
    if not (UprEdy and (Wyznacznik in LEdy)) and self.operator_id <> STANDARD_OPERATOR_ID:
        stat='BR_UPR_EDY'
        dane.append(stat)
    if stat=='OK':
        dane = []
        sql = "UPDATE rs_zamowienia_dostawcy SET "
        Filtr = "firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyznacznik+"' AND data='"+Data+"' AND numer="+str(Numer)
        for i in range(len(Pola)):
            wart = Wartosci[i]
            pole = Pola[i]
            if pole in ["typ_zamowienia","miejsce_dostawy_id","dostawy_od_dnia","dostawy_do_dnia","handlowiec","sposob_zaplaty",
                "sposob_odbioru_faktury","sposob_dostawy","wersja","projekt_id", "status_zamowienia"]:  #AB 08.06.21r
                if wart == "NULL":
                    sql += pole+"="+str(wart)+","
                else:
                    sql += pole+"='"+str(wart)+"',"
            elif pole in ["numer","dni","data_odbioru","upust","upust_wartosc","rabat","rabat_wartosc","kwota_netto",
                "wartosc_opakowan"]:
                sql += pole+"="+str(wart)+","
            elif pole in ["zamowienie_nr","wyznacznik_id","data","oddzial_id","stan","kontrahent_id",
                "sprzedawca_id","termin_zaplaty","waluta","tekst_nad_podp","tekst_pod_podp"]:
                sql += pole+"='"+str(wart)+"',"
        sql = sql.strip(',')
        sql += " WHERE "+Filtr+";"
        stat,dump,dump,dump = self.PolSQL.Execute(sql, 1)
        rsglobal.ZapiszDoLogow(sql)
        
        if stat != 'OK':
            stat = 'BL UPD'
            dane.append(stat)
        elif Wersja<>'' or Upust<>-1 or Kontrahent<>'' or Waluta<>'':   
            from funkcje import fs_zamowienia_dostawcy_pom
            stat=fs_zamowienia_dostawcy_pom.PrzeliczCenyZamowienia(self.firma_id,Wyznacznik,Data,str(Numer),self.PolSQL)
            if stat<>'OK':
                dane.append(stat)

        # sprawdzenie czy w wyznaczniku nie jest wymagane miejsce dostawy
        if stat=='OK':
            SQL="SELECT wymagane_miejsce_dostawy FROM rs_wyznaczniki "
            SQL+=" WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyznacznik+"';"
            stat,DWymag,dump,dump = self.PolSQL.Execute(SQL,3)
            if stat<>'OK':
                rsglobal.ZapiszDoLogow(SQL)
                stat = u'Bd sprawdzania wymagalnoci miejsca dostawy :'+stat
            if stat=='OK':
                if DWymag[0][0]:
                    # pobranie miejsca dostawy z zamwienia
                    SQL="SELECT COALESCE(miejsce_dostawy_id,'') FROM rs_zamowienia_dostawcy WHERE "
                    SQL+= "firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyznacznik+"' AND data='"+Data+"' AND numer="+str(Numer)
                    stat,DMiej,dump,dump = self.PolSQL.Execute(SQL,3)
                    if stat<>'OK':
                        rsglobal.ZapiszDoLogow(SQL)
                        stat = u'Bd sprawdzania miejsca dostawy na zamwieniu :'+stat
                    if stat=='OK' and DMiej[0][0] == '':
                        stat='WYM MIEJ DOST'


#-------------------------------------------------------------------------------
#---   Sprawdzenie wyznacznika
#-------------------------------------------------------------------------------

if stat == "OK" and Funkcja ==6:
    SQL = "SELECT wymagane_miejsce_dostawy FROM rs_wyznaczniki "
    SQL += " WHERE firma_id='" + self.firma_id + "' AND wyznacznik_id='" + Wyznacznik + "';"
    stat, dane, dump, dump = self.PolSQL.Execute(SQL, 3)
    if stat=='OK' and len(dane):
        rsglobal.ZapiszDoLogow(SQL)
        dane=dane[0][0]
    else:
        stat='Brak wyznacznika'


#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (5 -select, 3 -update z pobraniem, 1 -insert z pobraniem)
#-------------------------------------------------------------------------------
if stat=='OK' and Funkcja in [5,3,1]:
    if not (UprPrz and (Wyznacznik in LPrz)) and self.operator_id <> STANDARD_OPERATOR_ID:
        stat='BR_UPR_PRZ'
        dane.append(stat)
    if stat=='OK':
        where="WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyznacznik+"' AND data='"+Data+"' AND numer="+Numer
        sql = "SELECT * FROM rs_zamowienia_dostawcy " + where + ";"
        stat,dane,wyn1,tr = self.PolSQL.Execute(sql, 3)
       
        if len(dane) == 1:
            tr = rssql.RSTableRowset(dane,wyn1)
            
            #odbiorca
            if ((self.oddzial_id,'012010') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
                dump,d,dump,dump = self.PolSQL.Execute("SELECT nazwa FROM rs_kontrahenci WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+tr.GetVal(0,"kontrahent_id")+"';" ,3)
                if len(d) == 0:
                    wyn2.append('')
                else:
                    wyn2.append(d[0][0])
            else:
                wyn2.append('Brak uprawnie do sownika. Poinformuj administratora.')
                
            #miejsce dostawy
            if ((self.oddzial_id,'012010') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
                dump,d,dump,dump = self.PolSQL.Execute("SELECT nazwa FROM rs_kontrahenci WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+tr.GetVal(0,"miejsce_dostawy_id")+"';" ,3)
                if len(d) == 0:
                    wyn2.append('')
                else:
                    wyn2.append(d[0][0])
            else:
                wyn2.append('Brak uprawnie do sownika. Poinformuj administratora.') 
                
            #waluta
            if ((self.oddzial_id,'011130') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
                dump,d,dump,dump = self.PolSQL.Execute("SELECT opis FROM rs_waluty WHERE firma_id='"+self.firma_id+"' AND kod='"+tr.GetVal(0,"waluta")+"';" ,3)
                if len(d) == 0:
                    wyn2.append('')
                else:
                    wyn2.append(d[0][0])
            else:
                wyn2.append('Brak uprawnie do sownika. Poinformuj administratora.')  
                
            #wersja
            if ((self.oddzial_id,'011100') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
                dump,d,dump,dump = self.PolSQL.Execute("SELECT opis FROM rs_wersje_cenowe WHERE firma_id='"+self.firma_id+"' AND kod='"+tr.GetVal(0,"wersja")+"';" ,3)
                if len(d) == 0:
                    wyn2.append('')
                else:
                    wyn2.append(d[0][0])
            else:
                wyn2.append('Brak uprawnie do sownika. Poinformuj administratora.')   
                
            #sposob zaplaty
            if ((self.oddzial_id,'011090') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
                dump,d,dump,dump = self.PolSQL.Execute("SELECT opis FROM rs_sposoby_zaplaty WHERE firma_id='"+self.firma_id+"' AND kod='"+tr.GetVal(0,"sposob_zaplaty")+"';" ,3)
                if len(d) == 0:
                    wyn2.append('')
                else:
                    wyn2.append(d[0][0])
            else:
                wyn2.append('Brak uprawnie do sownika. Poinformuj administratora.')
            
            #handlowiec
            if ((self.oddzial_id,'011220') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
                dump,d,dump,dump = self.PolSQL.Execute("SELECT opis FROM rs_handlowcy WHERE firma_id='"+self.firma_id+"' AND kod='"+tr.GetVal(0,"handlowiec")+"';" ,3)
                if len(d) == 0:
                    wyn2.append('')
                else:
                    wyn2.append(d[0][0])
            else:
                wyn2.append('Brak uprawnie do sownika. Poinformuj administratora.')
            
            #sposob odbioru faktury
            if ((self.oddzial_id,'011230') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
                dump,d,dump,dump = self.PolSQL.Execute("SELECT opis FROM rs_sposoby_odbioru_faktury WHERE firma_id='"+self.firma_id+"' AND kod='"+tr.GetVal(0,"sposob_odbioru_faktury")+"';" ,3)
                if len(d) == 0:
                    wyn2.append('')
                else:
                    wyn2.append(d[0][0])
            else:
                wyn2.append('Brak uprawnie do sownika. Poinformuj administratora.')
            
            #sposob dostawy                   
            if ((self.oddzial_id,'011030') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
                dump,d,dump,dump = self.PolSQL.Execute("SELECT opis FROM rs_sposoby_dostaw WHERE firma_id='"+self.firma_id+"' AND kod='"+tr.GetVal(0,"sposob_dostawy")+"';" ,3)
                if len(d) == 0:
                    wyn2.append('')
                else:
                    wyn2.append(d[0][0])
            else:
                wyn2.append('Brak uprawnie do sownika. Poinformuj administratora.')
            
            #projekt
            if ((self.oddzial_id,'027000') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
                dump,d,dump,dump = self.PolSQL.Execute("SELECT nazwa FROM rs_projekty WHERE firma_id='"+self.firma_id+"' AND projekt_id='"+tr.GetVal(0,"projekt_id")+"';" ,3)
                if len(d) == 0:
                    wyn2.append('')
                else:
                    wyn2.append(d[0][0])
            else:
                wyn2.append('Brak uprawnie do sownika. Poinformuj administratora.') 
            
            #Typ zamowienia
            if ((self.oddzial_id,'011340') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
                dump,d,dump,dump = self.PolSQL.Execute("SELECT opis FROM rs_typy_zamowien WHERE firma_id='"+self.firma_id+"' AND kod='"+tr.GetVal(0,"typ_zamowienia")+"';" ,3)
                if len(d) == 0:
                    wyn2.append('')
                else:
                    wyn2.append(d[0][0])
            else:
                wyn2.append('Brak uprawnie do sownika. Poinformuj administratora.')  

            #sprzedawca
            if ((self.oddzial_id,'012010') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
                dump,d,dump,dump = self.PolSQL.Execute("SELECT nazwa FROM rs_kontrahenci WHERE firma_id='"+self.firma_id+"' AND kontrahent_id='"+tr.GetVal(0,"sprzedawca_id")+"';" ,3)
                if len(d) == 0:
                    wyn2.append('')
                else:
                    wyn2.append(d[0][0])
            else:
                wyn2.append('Brak uprawnie do sownika. Poinformuj administratora.')

            #AB 08.06.21r
            #status zamowienia
            if ((self.oddzial_id,'211560') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID):
                dump,d,dump,dump = self.PolSQL.Execute("SELECT opis FROM rs_zamowienia_dostawcy_statusy WHERE firma_id='"+self.firma_id+"' AND kod='"+tr.GetVal(0,"status_zamowienia")+"';" ,3)
                if len(d) == 0:
                    wyn2.append('')
                else:
                    wyn2.append(d[0][0])
            else:
                wyn2.append('Brak uprawnie do sownika. Poinformuj administratora.')
