#!/usr/bin/python
# -*- coding: iso8859_2 -*-
#-----------------------------------------------------------------------------
# Name:			fs_zamowienia_dostawcy_pozycje.py
# Purpose:		dodaje/pobiera/usuwa zamowienia dostawcy
# Author:		Marcin Grzeda
# Created:		2008/04/04
# RCS-ID:		$Id: fs_zamowienia_dostawcy_pozycje.py $
# Copyright:	(c) 2008 RecordSystem
# Licence:		GNU GPL
#-----------------------------------------------------------------------------
# 06.04.2009 - Dariusz Boduch - automatyczna zmiana stanu ZD na 'Z' kiedy zamwienie jest zrealizowane poprzez anulowanie - mantis: 1960
# 2017-05-16 Piotr Witkowski - Refaktoryzacja okna (10501)


stat='OK'

if stat == 'OK' and not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=='OK':
    Funkcja = klucze['Funkcja']
    SlPar={'Wyznacznik':[5,6,8,11],'Data':[5,6,8,11],'Numer':[5,6,8,11],
           'Art':[5,6,8],'DwieJednMiar':[5,6,8],'NrPoz':[6,8],'Anulowano':[8],}

    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Funkcja,klucze)
    if Lista<>'':
        stat=u'Uwaga : wywoanie funkcji fs_zamowienia_dostawcy_pozycje z numerem ' +str(Funkcja)+u' bez parametrw: '+Lista
    if stat=='OK':
        if Funkcja in [5,6,8,11]:
            Wyznacznik = str(klucze['Wyznacznik'])
            Data = str(klucze['Data'])
            Numer = str(klucze['Numer'])
        if Funkcja in [5,6,8]:
            DwieJednMiar = str(klucze['DwieJednMiar'])
            Art = str(klucze['Art'])
        if Funkcja in [6,8]:
            NrPoz = str(klucze['NrPoz'])
        if Funkcja in [8,]:
            Anulowano = float(klucze['Anulowano'])

if stat=='OK':
    dane = []
    wyn1 = []
    wyn2 = []

if stat=='OK':
    Lista=[self.firma_id,self.oddzial_id,self.operator_id]
    sql = "SELECT rsf_podaj_wyznaczniki('"+str(Lista).replace("'",'"')+"','[]','None');"    
    stat,wyzn,dump,dump=self.PolSQL.Execute(sql,3)
    
    if stat<>'OK':
        stat='BL SQL WYZN $'+stat
        dane.append(stat)

if stat=='OK':
    LWyzn=rsglobal.rseval(wyzn[0][0])[1]
    
if stat=='OK':
    if self.operator_id == STANDARD_OPERATOR_ID:
        UprPrz=True
        UprDel=True
        UprAnul=True
        LPrz=LWyzn
        LDel=LWyzn
        LPrz.append('ZASLEPKA')
    else:
        UprPrz=(self.oddzial_id,'037020') in self.uprawnienia
        UprDel=(self.oddzial_id,'037024') in self.uprawnienia
        UprAnul=(self.oddzial_id,'037026') in self.uprawnienia

        LPrz=['ZASLEPKA']
        LDel=[]
           
        if UprPrz and Funkcja in [5,6,8]:
            Lista=[self.firma_id,self.oddzial_id,self.operator_id]
            sql = "SELECT rsf_podaj_wyznaczniki('"+str(Lista).replace("'",'"')+"','[]','[True,False,False,False,False,False]');"    
            stat,wyzn,dump,dump=self.PolSQL.Execute(sql,3)
            if stat=='OK':
                LPrz=rsglobal.rseval(wyzn[0][0])[1]
                             
        if stat=='OK':                       
            if UprDel and Funkcja in [6]:
                Lista=[self.firma_id,self.oddzial_id,self.operator_id]
                sql = "SELECT rsf_podaj_wyznaczniki('"+str(Lista).replace("'",'"')+"','[]','[False,False,False,True,False,False]');"    
                stat,wyzn,dump,dump=self.PolSQL.Execute(sql,3)
                if stat=='OK':
                    LDel=rsglobal.rseval(wyzn[0][0])[1]

if Wyznacznik=='':
    stat="BR WYZ"
if Data=='':
    stat="BR DAT"
if Numer=='':
    stat="BR NR"


#-------------------------------------------------------------------------------
#----Funkcja suca do wpisywania iloci pozycji anulowanych (8)
#-------------------------------------------------------------------------------
    
    
if stat=='OK' and Funkcja== 8:
    if not UprAnul:
        stat='UPR CANCEL'
        dane.append(stat)
    if stat=='OK':
        Select ="SELECT z.ilosc1,z.dostarczono1,z.artykul_id,art.przelicznik"
        Select+=" FROM rs_zamowienia_dostawcy_pozycje z"
        Select+=" INNER JOIN rs_artykuly art ON (z.firma_id = art.firma_id AND z.artykul_id = art.artykul_id)"
        Select+=" WHERE z.firma_id='"+self.firma_id+"' AND z.wyznacznik_id = '"+Wyznacznik+"' AND z.data = '"+Data+"'"
        Select+=" AND z.numer = "+str(Numer)+" AND z.nr_poz="+str(NrPoz)+";"
        st,d_z,dump,dump=self.PolSQL.Execute(Select,3)
        if st=='OK':
            if len(d_z)>0:
                Zamowiono=d_z[0][0]
                Dostarczono=d_z[0][1]
                Przelicznik=d_z[0][3]
                if Zamowiono - Dostarczono>=Anulowano:
                    Anulowano2=round(Anulowano*Przelicznik,2)
                    Update ="UPDATE rs_zamowienia_dostawcy_pozycje"
                    Update+=" SET anulowano1="+str(Anulowano)+",anulowano2="+str(Anulowano2)
                    Update+=" WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id = '"+Wyznacznik+"' AND data = '"+Data+"'"
                    Update+=" AND numer = "+str(Numer)+" AND nr_poz="+str(NrPoz)+";"
                    stat,dump,dump,dump=self.PolSQL.Execute(Update,1)
                    if stat!="OK":
                        stat="BL UPD ANUL"
                        dane.append(stat)
                    else:
                        #sprawdzanie czy po anulowaniu mozna zamknac zamowienie 
                        Sql_spr = " SELECT count(*) FROM rs_zamowienia_dostawcy_pozycje WHERE "
                        Sql_spr += " firma_id='"+self.firma_id+"' AND wyznacznik_id = '"+Wyznacznik+"' AND data = '"+Data+"' AND numer = "+str(Numer)+" "
                        Sql_spr += " and ilosc1 - dostarczono1 - anulowano1 > 0 "
                        stat,danespr,dump,dump = self.PolSQL.Execute(Sql_spr,3)
                        if stat!='OK':
                            stat="BL SQL SPR ZAM"
                            dane.append(stat)
                        if danespr[0][0] == 0:
                            UPDStan = "UPDATE rs_zamowienia_dostawcy set stan='Z' "
                            UPDStan += " WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id = '"+Wyznacznik+"' "
                            UPDStan +=" AND data = '"+Data+"' AND numer = "+str(Numer)+" "
                            stat,dump,dump,dump=self.PolSQL.Execute(UPDStan,1)
                            if stat !='OK':
                                stat="BL UPDSTAN"
                                dane.append(stat)
                else:
                    stat='BL IL ANUL'
                    dane.append(stat)
            else:
                stat='BR POZ ANUL'
                dane.append(stat)
        else:
            stat='BL SEL ANUL'
            dane.append(stat)
    

#-------------------------------------------------------------------------------    
# -- usuwanie pozycji zamwienia dostawcy (6)
#-------------------------------------------------------------------------------

if stat=='OK' and Funkcja==6:
    if not (UprDel and (Wyznacznik in LDel)) and self.operator_id <> STANDARD_OPERATOR_ID:
        stat='UPR DEL'
        dane.append(stat)
    if stat=='OK':
        Delete="DELETE FROM rs_zamowienia_dostawcy_pozycje WHERE firma_id='"+self.firma_id+"' "
        Delete+="AND wyznacznik_id = '"+Wyznacznik+"' AND data = '"+Data+"' AND numer = "+Numer+" AND nr_poz = "+NrPoz+";"
        st,dump,dump,dump=self.PolSQL.Execute(Delete,1)
        if st!="OK":
            stat="BL DEL"
            dane.append(stat)
        else:
            Update="UPDATE rs_zamowienia_dostawcy_pozycje SET nr_poz=nr_poz+5000 WHERE firma_id='"+self.firma_id+"' "
            Update+="AND wyznacznik_id = '"+Wyznacznik+"' AND data = '"+Data+"' AND numer = "+Numer+" AND nr_poz > "+NrPoz+";"
            Update+="UPDATE rs_zamowienia_dostawcy_pozycje SET nr_poz=nr_poz-5001 WHERE firma_id='"+self.firma_id+"' "
            Update+="AND wyznacznik_id = '"+Wyznacznik+"' AND data = '"+Data+"' AND numer = "+Numer+" AND nr_poz > 5000+"+NrPoz+";"
            st,dump,dump,dump=self.PolSQL.Execute(Update,1)
            if st!="OK":
                stat="BL UPD NR POZ"
                dane.append(stat)
    
        
#------------------------------------------------------------------------------
# -- pobieranie waluty (11) - pki co niepotrzebna
#------------------------------------------------------------------------------


if stat=='OK' and Funkcja==11:
    Sql ="SELECT waluta FROM rs_zamowienia_dostawcy WHERE firma_id = '"+self.firma_id+"'"
    Sql+=" AND wyznacznik_id = '"+Wyznacznik+"' AND data='"+Data+"' AND numer = "+Numer+";"
    st,dane,dump,dump=self.PolSQL.Execute(Sql,2)
    if st<>'OK':
        stat='BL SQL WAL'
        dane.append(stat)
    elif len(dane)==0:
        stat="BL KLUCZ WAL"
    else:
        Waluta=dane[0][0]
        dane=Waluta                
    

#-------------------------------------------------------------------------------
# -- Funkcja pobierajca pozycje zamwienia dostawcy do grida
# -- przegladanie 5, usuwanie 6, anulowanie 8-- #
#-------------------------------------------------------------------------------

if stat=='OK' and Funkcja in [5,6,8]:
    if not (UprPrz and (Wyznacznik in LPrz)) and self.operator_id <> STANDARD_OPERATOR_ID:
        stat='UPR PRZ'
        dane.append(stat)
    if stat=='OK':
        pola = "zd.nr_poz,zd.artykul_id || ' - ' || art.nazwa,zd.cecha1_opis,zd.cecha1_wartosc,"
        pola+="rsf_podaj_parametry_cechy(zd.firma_id,zd.cecha1_opis,zd.cecha1_wartosc,'opis'),zd.ilosc1,zd.cena_upust1"
        pola+=",zd.wartosc_netto,zd.dostarczono1,zd.anulowano1"
        pola+=",zd.ilosc2,zd.cena_upust2,zd.dostarczono2,zd.anulowano2"
        pola+=",zd.artykul_id || ' - ' || art.nazwa"
        
        Filtr = "(zd.firma_id='"+self.firma_id+"' AND zd.wyznacznik_id='"+Wyznacznik+"'"
        Filtr+= " AND zd.data='"+Data+"' AND zd.numer="+str(Numer)+" "
        if Art <> '':
            Filtr = Filtr+"AND zd.artykul_id LIKE '"+Art+"%'"
        Filtr = Filtr+')'
        
        Select ="SELECT "+pola+" FROM rs_zamowienia_dostawcy_pozycje zd"
        Select+=" INNER JOIN rs_artykuly art ON zd.firma_id = art.firma_id AND zd.artykul_id = art.artykul_id"
        Select+=" WHERE "+Filtr+" ORDER BY zd.nr_poz;"
        stat,dane,wyn,dump=self.PolSQL.Execute(Select,3) 
        if stat!="OK":
            stat="BL SQL PRZ"
