# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:			fs_zamowienia_odbiorcy_analiza_stanow.py
# Purpose:		dodaje/edytuje pozycje zamowienia odbiorcy w oparciu o analiz stanw
# Author:		Micha Raburski
# Created:		2011/09/16
# RCS-ID:		$Id: fs_zamowienia_odbiorcy_analiza_stanow.py $
# Copyright:	(c) 2011 RecordSystem
# Licence:		GNU GPL
#-------------------------------------------------------------------------------


Wyznacznik = klucze[0]
Data=klucze[1]
Numer=str(klucze[2])
Magazyn=''
stat='OK'
wyn2=[]
dane=[]
Fun=klucze[-1]


#-------------------------------------------------------------------------------
# SPRAWDZENIE CZY MONA ZMIENIA POZYCJE
#-------------------------------------------------------------------------------

SQL="SELECT stan,magazyn_id,dostawy_od_dnia,dostawy_do_dnia,COALESCE(wersja,''),kurs,upust,"
SQL+="COALESCE(kontrahent_id,'')"
SQL+=" FROM rs_zamowienia_odbiorcy WHERE firma_id='"+self.firma_id+"'"
SQL+=" AND wyznacznik_id='"+Wyznacznik+"' AND data='"+Data+"' AND numer="+Numer

stat,DTest,dump,dump=self.PolSQL.Execute(SQL,3)
if stat=='OK':
    if len(DTest)==0:
        stat='Brak podanego zamwienia'
    elif DTest[0][0]<>'W':
        stat='Wybrane zamwienie nie jest w stanie W i nie mona zmienia jego pozycji'
    else:
        Magazyn=rsglobal.Dekoduj(DTest[0][1])
        if Magazyn in ('',None,'None'):
            stat='Na wybranym zamwieniu nie podano magazynu'
        DostOdDnia=rsglobal.Dekoduj(DTest[0][2])
        if DostOdDnia in ('    -  -  ',None,'None'):
            DostOdDnia='NULL'
        else:
            DostOdDnia="'"+DostOdDnia+"'"
        DostDoDnia=rsglobal.Dekoduj(DTest[0][3])
        if DostDoDnia in ('    -  -  ',None,'None'):
            DostDoDnia='NULL'
        else:
            DostDoDnia="'"+DostDoDnia+"'"
        Wersja=rsglobal.Dekoduj(DTest[0][4])
        if Wersja =='':
            Wersja='NULL'
        else:
            Wersja="'"+Wersja+"'"
        Kurs=str(DTest[0][5])
        Upust=str(DTest[0][6])
        Kontrahent=rsglobal.Dekoduj(DTest[0][7])
        if Kontrahent =='':
            Kontrahent='NULL'
        else:
            Kontrahent="'"+Kontrahent+"'"

#-------------------------------------------------------------------------------
#-------------------------------------------------------------------------------
# EDYCJA GRIDA
#-------------------------------------------------------------------------------
#-------------------------------------------------------------------------------
            
if Fun ==1 and stat=='OK':
    Update=klucze[-2]
    if len(Update[0])>0:
        SArt={}
        NrPoz=1
        
        # pobranie pomocniczych danych zamwienia
        SQLZam="SELECT nr_poz,nr_ppoz,TRIM(artykul_id), rsf_podaj_vat_artykulu(firma_id,artykul_id,data::TEXT)"
        SQLZam+=" FROM rs_zamowienia_odbiorcy_pozycje  WHERE firma_id='"+self.firma_id+"'"
        SQLZam+=" AND wyznacznik_id='"+Wyznacznik+"' AND data='"+Data+"' AND numer="+Numer
        stat,DZam,dump,dump=self.PolSQL.Execute(SQLZam,3)
        if stat=='OK':
            for poz in DZam:
                SArt[poz[2]]=(poz[0],poz[1],poz[3])
                if NrPoz<=poz[0]:
                    NrPoz=poz[0]+1
                # bd 'Brak stawki dla artykuu...'
                if len(poz[3])>4:
                    stat=poz[3]
                    dane.append(stat)
                
        if stat=='OK':
            SQL=''
            for i in xrange(len(Update[0])):   # petla po ilosci wierszy updatowanych
                # POJEDYNCZY WIERSZ
                IlZam1=0
                IlZam2=0
                if stat=='OK':
                    for j in xrange(len(Update[2][i])): # petla po kluczu
                        if Update[3][j]=='artykul_id':
                            Art=Update[2][i][j].strip()
                            
                    for j in xrange(len(Update[0][i])): # petla po pozycjach do zmiany
                        if Update[0][i][j]=='zamawiana':
                            IlZam1=Update[1][i][j]
                            IlZam2="ROUND((SELECT przelicznik FROM rs_artykuly WHERE firma_id='"+self.firma_id+"' "
                            IlZam2+=" AND artykul_id='"+str(Art)+"')*"+str(Update[1][i][j])+",8)"
                            
                    if IlZam1>0:
                        if Art in SArt:
                            VAT=SArt[Art][2]
                            if VAT in ['zw','np','oo']:
                                VATL='0'
                            else:
                                VATL=VAT
                                
                            WartN="ROUND("+str(IlZam1)+"*cena_upust1,2)"    
                            WartV="ROUND("+str(IlZam1)+"*cena_upust1*"+VATL+"*0.01,2)"    
                            WartB="ROUND("+str(IlZam1)+"*cena_upust1*(100+"+VATL+")*0.01,2)"    
                            WartU="ROUND("+str(IlZam1)+"*(cena_netto1-cena_upust1),2)"    
                            WartWalN="ROUND("+str(IlZam1)+"*cena_upust_wal1,2)"    
                            WartWalV="ROUND("+str(IlZam1)+"*cena_upust_wal1*"+VATL+"*0.01,2)"    
                            WartWalB="ROUND("+str(IlZam1)+"*cena_upust_wal1*(100+"+VATL+")*0.01,2)"    
                            
                            SQL+="UPDATE rs_zamowienia_odbiorcy_pozycje SET ilosc1="+str(IlZam1)+","
                            SQL+=" ilosc2="+str(IlZam2)+",wartosc_netto="+WartN+","
                            SQL+=" upust_wartosc="+WartU+",wartosc_vat="+WartV+","
                            SQL+=" wartosc_brutto="+WartB+",wartosc_wal_netto="+WartWalN+","
                            SQL+=" wartosc_wal_vat="+WartWalV+",wartosc_wal_brutto="+WartWalB
                            SQL+=" WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyznacznik+"' AND data='"+Data+"'"
                            SQL+=" AND numer="+Numer+" AND nr_poz="+str(SArt[Art][0])+" AND nr_ppoz="+str(SArt[Art][1])+";"
                        else:
                            SQLVAT="SELECT rsf_podaj_vat_artykulu(firma_id,artykul_id,'"+Data+"'::TEXT)"
                            SQLVAT+=" FROM rs_artykuly  WHERE firma_id='"+self.firma_id+"'"
                            SQLVAT+=" AND artykul_id='"+Art+"';"
                            stat,DVAT,dump,dump=self.PolSQL.Execute(SQLVAT,3)
                            if stat=='OK':
                                VAT=DVAT[0][0]
                                if VAT in ['zw','np','oo']:
                                    VATL='0'
                                else:
                                    VATL=VAT

                                if len(VATL)>4:
                                    stat=VATL
                                    dane.append(stat)                                        
                                    
                                if Wersja=='NULL':
                                    CenaN1='0'
                                    CenaN2='0'
                                    CenaU1='0'
                                    CenaU2='0'
                                    CenaB1='0'
                                    CenaB2='0'
                                    CenaNW1='0'
                                    CenaNW2='0'
                                    CenaUW1='0'
                                    CenaUW2='0'
                                else:
                                    CenaN1="rsf_podaj_cene_dla_kontrahenta('"+self.firma_id+"',"+Kontrahent+\
                                           ", 'PLN', '"+Data+"','"+Art+"', 'n1',"+Wersja+","+Upust+")"
                                    CenaN2="rsf_podaj_cene_dla_kontrahenta('"+self.firma_id+"',"+Kontrahent+\
                                           ", 'PLN', '"+Data+"','"+Art+"', 'n2',"+Wersja+","+Upust+")"
                                    CenaU1="rsf_podaj_cene_dla_kontrahenta('"+self.firma_id+"',"+Kontrahent+\
                                           ", 'PLN', '"+Data+"','"+Art+"', 'n1u',"+Wersja+","+Upust+")"
                                    CenaU2="rsf_podaj_cene_dla_kontrahenta('"+self.firma_id+"',"+Kontrahent+\
                                           ", 'PLN', '"+Data+"','"+Art+"', 'n2u',"+Wersja+","+Upust+")"
                                    CenaB1="rsf_podaj_cene_dla_kontrahenta('"+self.firma_id+"',"+Kontrahent+\
                                           ", 'PLN', '"+Data+"','"+Art+"', 'b1u',"+Wersja+","+Upust+")"
                                    CenaB2="rsf_podaj_cene_dla_kontrahenta('"+self.firma_id+"',"+Kontrahent+\
                                           ", 'PLN', '"+Data+"','"+Art+"', 'b2u',"+Wersja+","+Upust+")"
                                    CenaNW1="ROUND("+CenaN1+"*"+Kurs+",2)"
                                    CenaNW2="ROUND("+CenaN2+"*"+Kurs+",2)"
                                    CenaUW1="ROUND("+CenaU1+"*"+Kurs+",2)"
                                    CenaUW2="ROUND("+CenaU2+"*"+Kurs+",2)"
                                    
                                WartU="ROUND("+str(IlZam1)+"*("+CenaN1+"-"+CenaU1+"),2)"    
                                WartN="ROUND("+str(IlZam1)+"*"+CenaU1+",2)"    
                                WartV="ROUND("+str(IlZam1)+"*"+CenaU1+"*"+VATL+"*0.01,2)"    
                                WartB="ROUND("+str(IlZam1)+"*"+CenaU1+"*(100+"+VATL+")*0.01,2)"    
                                
                                WartWalN="ROUND("+str(IlZam1)+"*"+CenaU1+"*"+Kurs+",2)"    
                                WartWalV="ROUND("+str(IlZam1)+"*"+CenaU1+"*"+VATL+"*0.01*"+Kurs+",2)"    
                                WartWalB="ROUND("+str(IlZam1)+"*"+CenaU1+"*(100+"+VATL+")*0.01*"+Kurs+",2)"    
                                
                                SQL+=" INSERT INTO rs_zamowienia_odbiorcy_pozycje "
                                SQL+="(firma_id,wyznacznik_id,data,numer,nr_poz,nr_ppoz,"
                                SQL+=" data_od,data_do,artykul_id,"
                                SQL+=" ilosc1,ilosc2,cena_netto1,cena_netto2,cena_upust1,cena_upust2,"
                                SQL+=" cena_brutto1,cena_brutto2,upust,upust_wartosc,stawka_vat,"
                                SQL+=" wartosc_netto,wartosc_vat,wartosc_brutto,"
                                SQL+="cena_wal1,cena_wal2,cena_upust_wal1,cena_upust_wal2,"
                                SQL+=" wartosc_wal_netto,wartosc_wal_vat,wartosc_wal_brutto)"
                                SQL+=" VALUES "
                                SQL+="('"+self.firma_id+"','"+Wyznacznik+"','"+Data+"',"+Numer+","+str(NrPoz)+",0,"
                                SQL+=" "+DostOdDnia+","+DostDoDnia+",'"+Art+"',"
                                SQL+=" "+str(IlZam1)+","+str(IlZam2)+","+CenaN1+","+CenaN2+","+CenaU1+","+CenaU2+","
                                SQL+=" "+CenaB1+","+CenaB2+","+Upust+","+WartU+",'"+VAT+"',"
                                SQL+=" "+WartN+","+WartV+","+WartB+","
                                SQL+=" "+CenaNW1+","+CenaNW2+","+CenaUW1+","+CenaUW2+","
                                SQL+=" "+WartWalN+","+WartWalV+","+WartWalB+");"
                                
                                NrPoz=NrPoz+1
                                
            if SQL<>'' and stat=='OK':
                stat,dump,dump,dump=self.PolSQL.Execute(rsglobal.Dekoduj(SQL),1)
                if stat<>'OK':
                    stat='BL UPD'
                    
    
#---------------------------------------------------------------------------------------------------------------
#------- POBIERANIE DANYCH
#---------------------------------------------------------------------------------------------------------------

if Fun==5 and stat=='OK':
    # pobranie daty ostatniego spisu z natury
    SQL="SELECT data FROM rs_inwentaryzacja WHERE firma_id='"+self.firma_id+"'"
    SQL+=" AND magazyn_id='"+Magazyn+"' AND stan='Z' ORDER BY data DESC LIMIT 1"
    stat,DSpis,wyn,dump=self.PolSQL.Execute(SQL,3)
    if stat<>'OK':
        stat='Bd pobierania danych do tabeli z poz. zamwienia :'+stat
    elif len(DSpis)==0:
        stat='Brak spisu z natury w oparciu o ktry mona liczy dane do analizy stanw.'
    else:
        DataSpisu=rsglobal.Dekoduj(DSpis[0][0])
        
    if stat == 'OK':
        # sprawdzenie z ktrego algorytmu (z jedynk czy bez) bdziemy korzysta
        # jeli Spis z poprzedniego miesica jest zamknity to 0, jeli otwarty lub brak to 1
        WspWzoru = 1
        
        SQL = "SELECT stan FROM rs_inwentaryzacja WHERE firma_id= '"+self.firma_id+"'"
        SQL+= " AND magazyn_id='"+Magazyn+"'"
        SQL+= " AND EXTRACT(YEAR FROM NOW() - INTERVAL '1 MONTH')::INT = EXTRACT(YEAR FROM data)::INT"
        SQL+= " AND EXTRACT(MONTH FROM NOW() - INTERVAL '1 MONTH')::INT = EXTRACT(MONTH FROM data)::INT"
        stat,DSpisWz,wyn,dump=self.PolSQL.Execute(SQL,3)
        if stat<>'OK':
            stat='Bd pobierania danych inwentaryzacji do wzoru :'+stat
        elif len(DSpisWz)>0:
            if DSpisWz[0][0] == 'Z':
                WspWzoru = 0
            
    # pobranie handlowca z zamwienia odbiorcy
    if stat == 'OK':
        SQL="SELECT COALESCE(handlowiec,'') FROM rs_zamowienia_odbiorcy "
        SQL+=" WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyznacznik+"' AND data='"+Data+"' AND numer="+Numer 
        stat,DHandl,wyn,dump=self.PolSQL.Execute(SQL,3)
        if stat<>'OK':
            stat='Bd pobierania danych zamwienia :'+stat
        elif len(DHandl)==0:
            stat='Brak zamwienia z ktrego bd pobierane dane do analizy stanow.'
        else:
            Handl=rsglobal.Dekoduj(DHandl[0][0])
    
    
    if stat=='OK':
        # pobranie danych z pozycji zamwienia
        #                    0        1          2         3
        # jedna pozycja to artyku, nazwa, ile w mag1, zu 1 mc 1,
        #      4           5           6          7
        # zu 3 mce 1, sugestia 1,  zamw 1, zamwienia dost
        
        SQL="SELECT TRIM(a.artykul_id),a.nazwa,0,0,0,0,zp.ilosc1,0"
        SQL+=" FROM rs_zamowienia_odbiorcy_pozycje zp INNER JOIN rs_artykuly a USING(firma_id,artykul_id)"
        SQL+=" WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyznacznik+"' AND data='"+Data+"' AND numer="+Numer
        SQL+=" ORDER BY zp.nr_poz,zp.nr_ppoz"
        stat,dane,wyn,dump=self.PolSQL.Execute(SQL,3)
        if stat<>'OK':
            stat='Bd pobierania danych do tabeli z poz. zamwienia :'+stat

    if stat=='OK':
        ZPozycji=len(dane)<>0
        
        if len(dane)==0:
            # pobranie danych z aktualnego magazynu oraz z zuycia za ostatnie 3 miesice
            SQL="SELECT DISTINCT TRIM(a.artykul_id) AS artykul_id,a.nazwa,0,0,0,0,0,0,a.kateg_artykulu"
            SQL+=" FROM rs_inwentaryzacja_pozycje ip INNER JOIN rs_artykuly a USING(firma_id,artykul_id)"
            SQL+=" WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+Magazyn+"' AND data='"+DataSpisu+"'"
            SQL+=" UNION "
            SQL+="SELECT DISTINCT TRIM(a.artykul_id) AS artykul_id,a.nazwa,0,0,0,0,0,0,a.kateg_artykulu"    
            SQL+=" FROM rs_dokumenty_magazynowe_pozycje dmp INNER JOIN rs_artykuly a USING(firma_id,artykul_id)"
            SQL+=" WHERE firma_id='"+self.firma_id+"' AND dokument_id='RW' AND magazyn_id='"+Magazyn+"'"
            SQL+=" AND data<='"+DataSpisu+"' AND data>=date '"+DataSpisu+"' - interval '3 months'"
            SQL+=" ORDER BY kateg_artykulu,artykul_id"
            stat,dane,wyn,dump=self.PolSQL.Execute(SQL,3)
            if stat<>'OK':
                stat='Bd pobierania danych do tabeli z magazynu :'+stat
        
            if stat=='OK':
                if len(dane)==0:
                    stat=' Brak danych do wywietlenia'
                else:
                    Dane=[]
                    for poz in dane:
                        Dane.append(poz[:-1])
                        dane=eval(str(Dane))

    if stat=='OK':
        LArt=[]
        FArt=''
        for poz in dane:
            if rsglobal.Dekoduj(poz[0]) in LArt:
                stat='Bd - artyku '+poz[0].strip()+' wystpuje dwa razy na pozycjach'
                break
            else:
                LArt.append(rsglobal.Dekoduj(poz[0]))
                FArt+="'"+rsglobal.Dekoduj(poz[0])+"',"
        FArt=FArt.strip(',')
                
    # pobranie danych aktualnego stanu magazynu
    if stat=='OK':
        SQL= "SELECT TRIM(artykul_id),ilosc1 FROM rs_artykuly_magazyny "
        SQL+=" WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+Magazyn+"'"
        SQL+=" AND artykul_id IN ("+FArt+");"
        stat,DStany,wyn,dump=self.PolSQL.Execute(SQL,3)
        if stat<>'OK':
            stat='Bd pobierania danych o stanach magazynowych :'+stat
                
        if stat=='OK':
            SStany = {}
            for poz in DStany:
                SStany[rsglobal.Dekoduj(poz[0])]=poz[1]

            for d in dane:
                if d[0] in SStany:
                    d[2]=SStany[d[0]]
            
    if stat=='OK':
        # pobranie danych zuycia z dokumentw RW
        DataPoczM=DataSpisu[0:8]+'01'
        SQL="SELECT TRIM(artykul_id),SUM(CASE WHEN data>='"+DataPoczM+"' THEN ilosc1 ELSE 0 END),"
        SQL+=" SUM(ilosc1)"
        SQL+=" FROM rs_dokumenty_magazynowe_pozycje "
        SQL+=" WHERE firma_id='"+self.firma_id+"' AND dokument_id='RW' AND magazyn_id='"+Magazyn+"'"
        SQL+=" AND data<='"+DataSpisu+"' AND data>=date '"+DataPoczM+"' - interval '2 months'"
        SQL+=" AND artykul_id IN ("+FArt+") GROUP BY artykul_id ORDER BY artykul_id;"
        stat,DRW,wyn,dump=self.PolSQL.Execute(SQL,3)
        if stat<>'OK':
            stat='Bd pobierania danych z dokumentw RW :'+stat
        if stat=='OK':
            SRW = {}
            for poz in DRW:
                SRW[rsglobal.Dekoduj(poz[0])]=[poz[1],poz[2]]

            for d in dane:
                if d[0] in SRW:
                    # zuycie 1 mc
                    d[3]=SRW[d[0]][0]
                    # rednie zuycie 3 mc
                    d[4]=rsglobal.RSRound(SRW[d[0]][1]/3,4)

        if stat == 'OK':
            # pobranie danych o zamwieniach dostawcw
            SQL="SELECT TRIM(zdp.artykul_id),SUM(zdp.ilosc1-zdp.dostarczono1-zdp.anulowano1) "
            SQL+=" FROM rs_zamowienia_dostawcy_pozycje zdp "
            SQL+=" INNER JOIN rs_zamowienia_dostawcy zd USING(firma_id,wyznacznik_id,data,numer)"
            SQL+=" WHERE zdp.firma_id='"+self.firma_id+"' AND zd.stan = 'A' AND zdp.artykul_id IN ("+FArt+")"
            if Handl <> '':
                SQL+=" AND zd.handlowiec = '"+Handl+"'"
            if self.handlowiec_id <> None:
                SQL+=" AND zd.handlowiec ='"+self.handlowiec_id+"'"
            SQL+=" GROUP BY zdp.artykul_id;"
            stat,DZamDost,dump,dump=self.PolSQL.Execute(SQL,3)
            if stat<>'OK':
                stat='Bd pobierania danych zamwie do dostawcw :'+stat
            if stat=='OK':
                SZamDost = {}
                for poz in DZamDost:
                    SZamDost[rsglobal.Dekoduj(poz[0])]=poz[1]
                
                for d in dane:
                    if d[0] in SZamDost:
                        d[7] = SZamDost[d[0]]
            
        if stat=='OK':                
            # sugerowane zamwienie
            # najnowsze wzory z Alabu (6512)
            # obecny stan = Stan mag + Zamwienia do dost. - (rednie zuycie 3 mc * (WspWzoru+((dzie mies+6)/30))
            # Sugerowane zamwienie = (rednie zuycie 3 mc * 1.2) - obecny stan
            for d in dane:
                StanMag = 0
                ZamDost = 0

                if d[0] in SStany:
                    StanMag = SStany[d[0]]
                ObecnyStan = StanMag + d[7] - (d[4] * (WspWzoru+((int(rsglobal.PodajDzis()[8:])+6.0) / 30.0)))
                ObecnyStan = rsglobal.RSRound(ObecnyStan,4)
                if ObecnyStan < 0:
                    ObecnyStan = 0

                d[5] = (d[4] *1.2) - ObecnyStan
                if d[5] < 0:
                    d[5] = 0
                d[5]= rsglobal.RSRound(d[5],4)    
            # jeli pozycja z magazynw to wstawia w "zamwienie" sugerowane zamwienie.
            # wstawiane to jest dopiero na oknie, by program traktowa te pozycje jako zmienione przed zapisem
            wyn2=[ZPozycji]