#!/usr/bin/python
# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:			fs_zamowienia_odbiorcy_import_pom.py
# Purpose:		funkcje wykorzystywane w imporcie zamowien odbiorcy
# Author:		Jan Raburski
# Created:		2015/05/20 (mantis:8954)
# RCS-ID:		$Id: fs_zamowienia_odbiorcy_import_pom.py $
# Copyright:	(c) 2011 RecordSystem
# Licence:		GNU GPL
#-------------------------------------------------------------------------------

import rsglobal
from funkcje import fs_pliki_global

def PodzielZamowienieNaOddzialy(self, Kontrahent, Platnik, Data, Artykuly):
    dane = []
    stat='OK'
    for artykul in Artykuly:
        #petla po artykulach, dla kazdego trzeba wyznaczyc oddzial
        
        sql ="SELECT TRIM(oddzial_id),procent_zwrotow_wartosc,procent_zwrotow"
        sql+=" FROM rs_kontrahenci_artykuly_poziom_zwrotow"
        sql+=" WHERE firma_id='"+self.firma_id+"'"
        sql+=" AND kontrahent_id='"+rsglobal.Dekoduj(Kontrahent)+"'"
        sql+=" AND artykul_id IS NULL AND oddzial_id IN ('"+Oddzial+"','**');"
        
        stat,d,dump,dump = self.PolSQL.Execute(sql,3)
        if stat <> 'OK':
            stat = 'Bd pobrania danych o poziomach zwrotw: '+stat
            dane.append(stat)
            return stat,dane
    
        elif len(d) == 0:
            # brak danych o artykule - blad
            stat="?????????????|"
        elif len(d) == 1:
            # dane tylko dla jednego ze sprawdzanych oddzialow
            dane = [[d[0][1], d[0][2]]]
        elif rsglobal.Dekoduj(d[0][0]).strip() == rsglobal.Dekoduj(self.oddzial_id).strip():
            # dane oddzialu z dowodu na pozycji [0]
            dane = [[d[0][1], d[0][2]]]
        else:
            # dane oddzialu z dowodu na pozycji [1]
            dane = [[d[1][1], d[1][2]]]
    
    return stat,dane
