# -*- coding: iso8859_2 -*-
#-----------------------------------------------------------------------------
# Name:        fs_zamowienia_odbiorcy_pliki_dane.py
# Purpose:     zapis danych pliku zamwie odbiorcy
# Author:      Micha Raburski
# Created:     2014/03/03
# RCS-ID:      $Id: fs_zamowienia_odbiorcy_pliki_dane.py $
# Copyright:   (c) 2014 Record System
# Licence:     GNU GPL
#-----------------------------------------------------------------------------

stat = 'OK'
dane = []
wyn1 = []
wyn2 = []

if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=='OK':
    Fun = klucze['Funkcja']
    
    SlPar={'Wyznacznik':[3,4,5],'Data':[3,4,5],'Numer':[3,4,5],'PlikId':[3,4,5]}    
    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Fun,klucze)
    if Lista<>'':
        stat='Uwaga : wywoanie funkcji fs_zamowienia_odbiorcy_pliki_dane z numerem '+str(Fun)+' bez parametrw: '+Lista
        
    if Fun in [3,4,5]:
        Wyzn=rsglobal.Dekoduj(klucze['Wyznacznik'])
        Data=rsglobal.Dekoduj(klucze['Data'])
        Nr=str(klucze['Numer'])
        PlikId=str(klucze['PlikId'])
    
if stat == 'OK':    
    UprEdycja = (((self.oddzial_id,'024072') in self.uprawnienia) or ((self.oddzial_id,'024073') in self.uprawnienia) or (self.operator_id == STANDARD_OPERATOR_ID))

    if not self.operator_id == STANDARD_OPERATOR_ID:
        #sprawdzenie poprawnoci zamwienia
        SQL="SELECT stan FROM rs_zamowienia_odbiorcy WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id = '"+Wyzn+"'"
        SQL+=" AND data='"+Data+"' AND numer="+Nr+" FOR UPDATE NOWAIT;"
        stat,DTest,dump,dump = self.PolSQL.Execute(SQL,3)
        if stat <> 'OK':
            stat='Bdy zablokowania zamwienia :'+stat

        if stat == 'OK':
            Stan = DTest[0][0]
            # pobranie dostpnych typw
            SQL="SELECT DISTINCT typ_pliku,modyfikowac_w_zamknietym_zamowieniu "
            SQL+=" FROM rs_typy_plikow_zamowien_odb_upr WHERE firma_id='"+self.firma_id+"'"
            SQL+=" AND operator_id IN ("+str(self.operatorzy)[1:-1]+");"
            stat,DTypy,dump,dump = self.PolSQL.Execute(SQL,3)
            if stat <> 'OK':
                stat='Bdy pobrania typw plikw, do ktrych operator ma uprawnienia :'+stat
                
        if stat=='OK':
            if len(DTypy)==0:
                stat= "Brak uprawnie do wywietlenia jakiegokolwiek typu dokumentu"
            
        if stat=='OK':
            STypow={}
            for poz in DTypy:
                STypow[rsglobal.Dekoduj(poz[0])] = poz[1]
                    
            SQL="SELECT typ_pliku FROM rs_zamowienia_odbiorcy_pliki "
            SQL+=" WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyzn+"' AND data='"+Data+"' AND numer="+Nr
            SQL+=" AND plik_id="+PlikId
            stat,DTyp,dump,dump = self.PolSQL.Execute(SQL,3)
            if stat <> 'OK':
                stat='Bdy pobrania typu edytowanego pliku :'+stat                    
        
        if stat=='OK':
            if not DTyp[0][0] in STypow:
                stat= "Brak uprawnie do wywietlenia/modyfikacji typu wybranego pliku"
            elif Stan == 'Z' and Fun <> 5:
                if not STypow[DTyp[0][0]]:
                    stat='Brak uprawnie do modyfikacji plikw w zamknitych zamwieniach odbiorcw - modyfikacja niemoliwa'
            

                    
#-------------------------------------------------------------------------------
# sprawdzenie uprawnien
#-------------------------------------------------------------------------------
    
if Fun in [3,4] and stat == 'OK':
    if not UprEdycja:
        stat = 'BR UPR UPD'
    
#-------------------------------------------------------------------------------
#   UPDATE DANYCH ( 3-update, 4 -update z pobraniem)
#-------------------------------------------------------------------------------

    if stat=='OK':
        SQL = "UPDATE rs_zamowienia_odbiorcy_pliki SET "
        
        for i in range(len(pola)):
            pole = pola[i]
            wart = wartosci[i]
            if pole in ['opis']:
                SQL+=pole+"='"+wart+"',"
        SQL=SQL.strip(',')            
        SQL+=" WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyzn+"' AND data='"+Data+"' AND numer="+Nr
        SQL+=" AND plik_id="+PlikId
        stat,dump,dump,dump = self.PolSQL.Execute(SQL ,1)
        if stat<>'OK':
            stat='BL UPD'
            dane.append(stat)
    
#-------------------------------------------------------------------------------
#   POBRANIE DANYCH ( 5-select, 3 -update z pobraniem)
#-------------------------------------------------------------------------------

if stat=='OK' and Fun in [3,5]:
    SQL="SELECT opis,z_op_id,z_czas,z_typ FROM rs_zamowienia_odbiorcy_pliki "
    SQL+=" WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyzn+"' AND data='"+Data+"' AND numer="+Nr
    SQL+=" AND plik_id="+PlikId
    stat,dane,wyn1,dump = self.PolSQL.Execute(SQL,3)