#!/usr/bin/python
# -*- coding: iso8859_2 -*-
#-----------------------------------------------------------------------------
# Name:			fs_zamowienia_odbiorcy_pozycje_opisowe.py
# Purpose:		dodaje/pobiera/usuwa pozycje opisowe zamowienia odbiorcy
# Author:		Piotr Witkowski
# Created:		2015/12/26
# RCS-ID:		$Id: fs_zamowienia_odbiorcy_pozycje_opisowe.py $
# Copyright:	(c) 2015 RecordSystem
# Licence:		GNU GPL
#-----------------------------------------------------------------------------

# 2010-11-25    Marcin Natkaski (4085) blokada modyfikacji wierszy dla zamwie ze stanem <> W
# 2015-12-26    Piotr Witkowski (9496) refaktoryzacja - okno gwne zamwie, Daty, pozycje opisowe, wartoci VAT

stat='OK'
if not 'Funkcja' in klucze:
    stat='Brak podanej funkcji w kluczach'

if stat=='OK':
    Funkcja = klucze['Funkcja']
    SlPar={'Wyznacznik':[5,6,11],'Data':[5,6,11],'Numer':[5,6,11],'NrPoz':[6]}

    Lista=rsglobal.SprawdzParametryWKluczach(SlPar,Funkcja,klucze)
    if Lista<>'':
        stat=u'Uwaga : wywoanie funkcji fs_zamowienia_odbiorcy_pozycje_opisowe z numerem ' +str(Funkcja)+u' bez parametrw: '+Lista
    if stat=='OK':
        DodF = []
        if Funkcja in [5,6,11]:
            Wyznacznik = str(klucze['Wyznacznik'])
            Data = str(klucze['Data'])
            Numer = str(klucze['Numer'])
        if Funkcja in [6]:
            NrPoz = klucze['NrPoz']

if stat=='OK':
    dane = []
    wyn1 = []
    wyn2 = []
    puste_pola = [[],"","    -  -  "]

if stat=='OK' and (Wyznacznik.strip() in puste_pola):
    stat="WYZ BR"
if stat=='OK' and (Numer in puste_pola):
    stat="NR BR"
if stat=='OK' and (Data in puste_pola):
    stat="DAT BR"
else:
    if stat=='OK' and (not rsglobal.SprawdzCzyToData(Data)):
        stat="DAT BL"

LPrz=[]
LWyzn=[]
LEdy=[]
LDel=[]

if stat=='OK':
    Lista=[self.firma_id,self.oddzial_id,self.operator_id]
    sql = "SELECT rsf_podaj_wyznaczniki('"+str(Lista).replace("'",'"')+"','[]','None');"    
    stat,wyzn,dump,dump=self.PolSQL.Execute(sql,3)

if stat=='OK':
    LWyzn=rsglobal.rseval(wyzn[0][0])[1]

if stat=='OK':
    if stat =='OK' and self.operator_id != STANDARD_OPERATOR_ID:
        UprUsuwanie=(self.oddzial_id,'024034') in self.uprawnienia
        UprPrzeglWal=(self.oddzial_id,'011130') in self.uprawnienia
        UprUpd=(self.oddzial_id,'024032') in self.uprawnienia
        LPrz=LWyzn
        LPrz.append('ZASLEPKA')
        LEdy=[]
        LDel=[]
        Lista=[self.firma_id,self.oddzial_id,self.operator_id]


        if UprUpd and (Funkcja in [5,6]):
            sql = "SELECT rsf_podaj_wyznaczniki('"+str(Lista).replace("'",'"')+"','[]','[False,False,True,False,False,False]');"
            stat,wyzn,dump,dump=self.PolSQL.Execute(sql,3)
            if stat=='OK':
                LEdy=rsglobal.rseval(wyzn[0][0])[1]

        if stat=='OK':
            if UprUsuwanie and (Funkcja in [6]):
                sql = "SELECT rsf_podaj_wyznaczniki('"+str(Lista).replace("'",'"')+"','[]','[False,False,False,True,False,False]');"
                stat,wyzn,dump,dump=self.PolSQL.Execute(sql,3)
                if stat=='OK':
                    LDel=rsglobal.rseval(wyzn[0][0])[1]

    else:
        UprUsuwanie = UprPrzeglWal = UprUpd = True
        LPrz=LWyzn
        LPrz.append('ZASLEPKA')
        LEdy=LWyzn
        LDel=LWyzn

if stat=='OK':
    if stat=='OK' and self.operator_id != STANDARD_OPERATOR_ID:
        UprUsuwanie=(self.oddzial_id,'024034') in self.uprawnienia
        UprPrzeglWal=(self.oddzial_id,'011130') in self.uprawnienia

    else:
        UprUsuwanie =  UprPrzeglWal =True


#-------------------------------------------------------------------------------
# -- usuwanie (6)
#-------------------------------------------------------------------------------

if stat=='OK' and Funkcja == 6:
    if not (UprUsuwanie and (Wyznacznik in LDel)):
        stat="UPR DEL"

    if stat =='OK':
        # Sprawdzanie stanu zamwienia przed usuniciem pozycji
        sprSql  ="SELECT * from rs_zamowienia_odbiorcy WHERE firma_id='"+self.firma_id+"'"
        sprSql +=" AND wyznacznik_id='"+Wyznacznik+"' AND data='"+Data+"'"
        sprSql +=" AND stan='W' AND numer='"+str(Numer)+"' FOR UPDATE NOWAIT;"
        stat,d,dump,dump = self.PolSQL.Execute(sprSql,3)
        if stat<>'OK':
            stat="Bdy zapytania sprawdzajcego stan zamwienia przed usuniciem danych "+stat
            dane.append(stat)
        elif len(d)==0:
            stat='STAN G'
            dane.append(stat)        

    if stat =='OK':
        Delete="DELETE FROM rs_zamowienia_odbiorcy_pozycje_opisowe WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id = '"+Wyznacznik+"' AND data = '"+Data+"' AND numer = "+str(Numer)+" AND nr_poz = "+str(NrPoz)+";"
        stat,dump,dump,dump=self.PolSQL.Execute(Delete,1)
        if stat!="OK":
            stat="SQL DEL"
            dane.append(stat)

    if stat =='OK':
        Update="UPDATE rs_zamowienia_odbiorcy_pozycje_opisowe SET nr_poz=nr_poz-1 WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id = '"+Wyznacznik+"' AND data = '"+Data+"' AND numer = "+str(Numer)+" AND nr_poz > "+str(NrPoz)+";"
        stat,dump,dump,dump=self.PolSQL.Execute(Update,1)
        if stat!="OK":
            stat="SQL UPD"
            dane.append(stat)


#-------------------------------------------------------------------------------
# -- pobieranie waluty 11, 5, 6
#-------------------------------------------------------------------------------

if stat=='OK' and (Funkcja in [11,5,6]):
    Sql="SELECT waluta FROM rs_zamowienia_odbiorcy WHERE firma_id = '"+self.firma_id+"' AND wyznacznik_id = '"+Wyznacznik+"' AND data='"+Data+"' AND numer = "+str(Numer)+";"
    dane=self.PolSQL.Execute(Sql,3)[1]
    if len(dane)==0:
        stat="WAL BR"
    if stat=='OK':
        Waluta=dane[0][0]
        if Waluta<>'PLN':
            if not UprPrzeglWal:
                stat='UPR PRZ WAL'
                dane.append(stat)
        if Funkcja == 11 and stat=='OK':
            dane=Waluta


#-------------------------------------------------------------------------------
# -- przegladanie 5, usuwanie 6
#-------------------------------------------------------------------------------

if stat=='OK' and (Funkcja in [5,6]):
    if not (Wyznacznik in LPrz):
        stat="UPR PRZ"

    if stat=='OK' and Waluta=='':
        stat="WAL BR"

    if stat=='OK':
        pola = "nr_poz,opis_pozycji,stawka_vat,wartosc_netto,wartosc_vat,"
        pola+="wartosc_brutto,wartosc_wal_netto,wartosc_wal_vat,wartosc_wal_brutto "
        Filtr = "(firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyznacznik+"' AND data='"+Data+"' AND numer="+str(Numer)+" )"
        Select="SELECT "+pola+" FROM rs_zamowienia_odbiorcy_pozycje_opisowe WHERE "+Filtr+" ORDER BY nr_poz;"
        stat,dane,wyn,dump=self.PolSQL.Execute(Select,3)
        if stat!="OK":
            stat="SQL PRZ"