# -*- coding: iso8859_2 -*-

#-----------------------------------------------------------------------------
# Name:        fs_zamowienia_odbiorcy_pozycje_dane.py
# Purpose:     wczytuje/edytuje dane dotyczace pozycji zamowienia odbiorcy
#
# Author:      Marcin Grzeda
# Created:     2007/03/22
# RCS-ID:      $Id:$
# Copyright:   (c) 2007 Record System
# Licence:     GNU GPL
# 2010-11-25   Marcin Natkaski - blokada modyfikacji wierszy dla zamwie ze stanem <> W (mantis: 4085)
#-----------------------------------------------------------------------------

#klucze = [Wyznacznik,Data,Numer,Poz]
stat='OK'
Wyznacznik=rsglobal.Dekoduj(klucze[0]) 
Data=rsglobal.Dekoduj(klucze[1]) 
Numer=rsglobal.Dekoduj(klucze[2]) 
Poz=rsglobal.Dekoduj(klucze[3]) 
Funkcja=klucze[-1]
#w celach informacyjno rozeznaniowych
Pola=pola
Wartosci=wartosci

puste_pola = [[],"","    -  -  "]

if Wyznacznik.strip() in puste_pola:
    stat="BR_WYZ"
if Numer in puste_pola:
    stat="BR_NR"
if Data in puste_pola:
    stat="BR_DAT"
else:
    if not rsglobal.SprawdzCzyToData(Data):
        stat="BL_DAT"

LEdy=[]
LDod=[]

if stat=='OK':
    Lista=[self.firma_id,self.oddzial_id,self.operator_id]
    sql = "SELECT rsf_podaj_wyznaczniki('"+str(Lista).replace("'",'"')+"','[]','None');"    
    stat,wyzn,dump,dump=self.PolSQL.Execute(sql,3)
    
    if stat<>'OK':
        stat='BL SQL WYZN $'+stat
        dane.append(stat)

if stat=='OK':
    LWyzn=rsglobal.rseval(wyzn[0][0])[1]
    if LWyzn==[]:
        stat='BR LWYZN'
        
if self.operator_id != STANDARD_OPERATOR_ID:
    UprEdycja = ((self.oddzial_id,'024032') in self.uprawnienia)
    UprDodawanie = ((self.oddzial_id,'024033') in self.uprawnienia)
    
    if UprEdycja and (Funkcja in [3,4]):
        sql = "SELECT rsf_podaj_wyznaczniki('"+str(Lista).replace("'",'"')+"','[]','[False,False,True,False,False,False]');"    
        stat,wyzn,dump,dump=self.PolSQL.Execute(sql,3)
        if stat=='OK':
            LEdy=rsglobal.rseval(wyzn[0][0])[1]
    
    if UprDodawanie and (Funkcja in [1,2]):
        sql = "SELECT rsf_podaj_wyznaczniki('"+str(Lista).replace("'",'"')+"','[]','[False,True,False,False,False,False]');"    
        stat,wyzn,dump,dump=self.PolSQL.Execute(sql,3)
        if stat=='OK':
            LDod=rsglobal.rseval(wyzn[0][0])[1]
else:
    UprEdycja = UprDodawanie = True
    LEdy = LDod = LWyzn
        
if Funkcja == 9: #sprawdzam walute
    dane=[]
    sql = "SELECT waluta,kurs,upust,wersja FROM rs_zamowienia_odbiorcy WHERE firma_id='%s' AND wyznacznik_id = '%s' AND data = '%s' AND numer = %s;" % (self.firma_id,Wyznacznik,Data,Numer)
    stat,dane,dump,dump = self.PolSQL.Execute(sql ,3)
    if stat<>'OK':
        stat='BL_WAL'
        dane.append(stat)
    if len(dane)==0:
        stat='BR_WAL'
        dane.append(stat)

if Funkcja in [11]:
    Warunek = "firma_id=\\\'"+self.firma_id+"\\\' AND wyznacznik_id=\\\'"+Wyznacznik+"\\\' AND data=\\\'"+Data+"\\\' AND numer="+str(Numer)
    stat,dane,dump,dump = self.PolSQL.Execute("SELECT rsf_klucz_where_new('rs_zamowienia_odbiorcy_pozycje_opisowe','"+Warunek+"','nr_poz');",3)
    
    if stat<>'OK':
        stat='BL POB NR POZ'
        dane.append(stat)
        

#-------------------------------------------------------------------------------
#-------------------------------------------------------------------------------
#---   Sprawdzam dane
#-------------------------------------------------------------------------------
#-----------------------------------------------------------------------------

NrPozycji= -1

if Funkcja in [1,2] and UprDodawanie==False:
    stat='UPR INS'
    dane.append(stat)
if Funkcja in [3,4] and UprEdycja==False:
    stat='UPR UPD'
    dane.append(stat)

if (Funkcja in [1,2,3,4]) and (stat=="OK"):           
    StVAT=None
    Kwota=None
    
    
    for i in range(len(pola)):
        pole = pola[i]
        wart = wartosci[i]

        if pole=='nr_poz':
            if wart < 1:
                stat='BL NR POZ'
                dane.append(stat)
            else:
                stat,dane_p,dump,dump = self.PolSQL.Execute("SELECT nr_poz FROM rs_zamowienia_dostawcy_pozycje_opisowe \
                                                            WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyznacznik+"' \
                                                            AND data='"+Data+"' AND numer="+str(Numer)+" AND nr_poz="+str(wart)+";",3)
                if stat<>'OK':
                    stat='BL SPR NR POZ'
                    dane.append(stat)
                elif dane_p <> []:
                    stat='NR POZ ISTN'
                    dane.append(stat)
                else:
                    NrPozycji=wart                
        elif pole=='stawka_vat':
            StVAT=wart
            if wart == '':
                wartosci[i]='NULL'
            else:
                stat,dane_v,dump,dump = self.PolSQL.Execute("SELECT kod FROM rs_stawki_vat WHERE  kod='"+str(wart)+"';",3)
                if stat<>'OK':
                    stat='BL SPR VAT'
                    dane.append(stat)
                if len(dane_v)==0:
                    stat='BL STAWKA VAT'
                    dane.append(stat)
        elif pole == 'wartosc_netto':        
            Kwota=wart
            
        i = i+1        
        
    #sprawdzam stan zamwienia i blokuje wiersze
    sprSql  ="SELECT * from rs_zamowienia_odbiorcy WHERE firma_id='"+self.firma_id+"'"
    sprSql +=" AND wyznacznik_id='"+Wyznacznik+"' AND data='"+Data+"'"
    sprSql +=" AND stan='W' AND numer='"+Numer+"' FOR UPDATE NOWAIT;"
    stat,d,dump,dump = self.PolSQL.Execute(sprSql,3)
    if stat<>'OK':
        stat="Bdy zapytania sprawdzajcego stan zamwienia przed aktualizacj danych "+stat
        dane.append(stat)
    elif len(d)==0:
        stat='STAN G'
        dane.append(stat)
    
#-------------------------------------------------------------------------------
#sprawdzenie relacji stawka VAT - kwota netto
#-------------------------------------------------------------------------------

    if stat=='OK':
        if StVAT==None:
            st,d,dump,dump = self.PolSQL.Execute("SELECT stawka_vat FROM rs_zamowienia_odbiorcy_pozycje_opisowe WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyznacznik+"' AND data='"+Data+"' AND numer="+str(Numer)+" AND nr_poz="+str(Poz)+";",3)
            StVAT=d[0][0]
        if Kwota==None:
            st,d,dump,dump = self.PolSQL.Execute("SELECT wartosc_netto FROM rs_zamowienia_odbiorcy_pozycje_opisowe WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyznacznik+"' AND data='"+Data+"' AND numer="+str(Numer)+" AND nr_poz="+str(Poz)+";",3)
            Kwota=d[0][0]
        
        if (StVAT in (None,'None','')) and Kwota <> 0:
            stat='BR VAT'
            dane.append(stat)

        if (Kwota in (None,'None',0)) and StVAT not in (None,'None',''):
            stat='BR KW'
            dane.append(stat)


#-------------------------------------------------------------------------------
#-------------------------------------------------------------------------------
#---   INSERT DANYCH (2- bez pobierania,1- z pobieraniem)
#-------------------------------------------------------------------------------
#-------------------------------------------------------------------------------

if stat == "OK" and Funkcja in [2,1]:
    if not (UprDodawanie and (Wyznacznik in LDod)) and self.operator_id <> STANDARD_OPERATOR_ID:
        stat='UPR INS'
        dane.append(stat)
        
    if stat=='OK':    
        ins = "INSERT INTO rs_zamowienia_odbiorcy_pozycje_opisowe"
        Pola="firma_id,wyznacznik_id,data,numer"
        Wartosci = "'"+self.firma_id+"','"+Wyznacznik+"','"+Data+"','"+Numer+"'"
        for i in range(len(pola)):
            pole = pola[i]
            wart = wartosci[i]
            
            if pole in ['opis_pozycji']:
                Pola= Pola+","+pole
                Wartosci= Wartosci+",'"+wart+"'"
            elif pole in ['nr_poz','wartosc_netto','wartosc_vat','wartosc_brutto','wartosc_wal_netto','wartosc_wal_vat','wartosc_wal_brutto']:
                Pola= Pola+","+pole
                Wartosci= Wartosci+","+str(wart)
            elif pole in ['stawka_vat']:
                Pola= Pola+","+pole
                if wart=="NULL":
                    Wartosci= Wartosci+",NULL"
                else:
                    Wartosci= Wartosci+",'"+wart+"'"
            
        ins = ins+" ("+Pola+") VALUES ("+Wartosci+");"       
        stat,dump,dump,dump = self.PolSQL.Execute(ins ,1)
        if stat<>'OK':
            stat='BL SQL INS $'+stat
            dane.append(stat)
            

#-------------------------------------------------------------------------------
#-------------------------------------------------------------------------------
#---   UPDATE DANYCH (4- bez pobierania,3- z pobieraniem)
#-------------------------------------------------------------------------------
#-------------------------------------------------------------------------------

if stat == "OK" and Funkcja in [3,4]:
    if not (UprEdycja and (Wyznacznik in LEdy)) and self.operator_id <> STANDARD_OPERATOR_ID:
        stat='UPR UPD'
        dane.append(stat)
    if stat=='OK':    
        #dane = []
        sql = "UPDATE rs_zamowienia_odbiorcy_pozycje_opisowe SET "
        Filtr = "firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyznacznik+"' AND data='"+Data+"' AND numer="+Numer+" AND nr_poz="+str(Poz)
        for i in range(len(Pola)):
            wart = Wartosci[i]
            pole = Pola[i]
    
            if pole in ['opis_pozycji']:
                sql += pole+"='"+str(wart)+"',"
            elif pole in ['nr_poz','wartosc_netto','wartosc_vat','wartosc_brutto','wartosc_wal_netto','wartosc_wal_vat','wartosc_wal_brutto']:
                sql += pole+"="
                if wart in puste_pola:
                    sql += "NULL,"
                else:
                    sql += "'"+str(wart)+"',"
            elif pole in ['stawka_vat']:
                #sql= sql+","+pole
                if wart=="NULL":
                    sql= sql+pole+"=NULL,"
                else:
                    sql= sql+pole+"='"+wart+"',"
            
        sql = sql.strip(',')
        sql += " WHERE "+Filtr+";"
        stat,dump,dump,dump = self.PolSQL.Execute(sql ,1)
        if stat != 'OK':
            stat = 'BL SQL EDY $'+stat
            dane.append(stat)

    
#-------------------------------------------------------------------------------
#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (5 -select, 3 -update z pobraniem, 1 -insert z pobraniem)
#-------------------------------------------------------------------------------
#-------------------------------------------------------------------------------

if stat == "OK" and Funkcja in [5,3,1]:
    if NrPozycji<>-1:
        Poz=NrPozycji
    #dane = []
    where="WHERE firma_id='"+self.firma_id+"' AND wyznacznik_id='"+Wyznacznik+"' AND data='"+Data+"' AND numer="+Numer+" AND nr_poz="+str(Poz)
    sql = "SELECT * FROM rs_zamowienia_odbiorcy_pozycje_opisowe "+where+";"
    stat,dane,wyn1,tr = self.PolSQL.Execute(sql,3)
    if stat!='OK':
        stat='BL SQL DANE'
        dane.append(stat)