# -*- coding: iso8859_2 -*-

#-------------------------------------------------------------------------------
# Name:        fs_zamowienia_sumy_pozycje.py
# Purpose:     wczytuje/dodaje dane pozycji do produkcji
#
# Author:      Micha Raburski
# Created:     2009/08/26
# RCS-ID:      $Id: fs_zamowienia_sumy_pozycje.py $
# Copyright:   (c) 2006-2010 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

DataF=rsglobal.Dekoduj(klucze[0])
OddzialF=rsglobal.Dekoduj(klucze[1])
TypOdbF=rsglobal.Dekoduj(klucze[2])
ZmianaF=rsglobal.Dekoduj(klucze[3])
ZmianaProdF=rsglobal.Dekoduj(klucze[4])
ArtykulF=rsglobal.Dekoduj(klucze[5])
FunkcjaOkna=klucze[6]
Fun=klucze[-1]

stat = "OK"
dane = []

UprPrz= (self.operator_id == STANDARD_OPERATOR_ID) or \
        (((self.oddzial_id,'121000') in self.uprawnienia and FunkcjaOkna==1) or \
        ((self.oddzial_id,'045000') in self.uprawnienia and FunkcjaOkna==2))

UprEdy= (self.operator_id == STANDARD_OPERATOR_ID) or \
        (((self.oddzial_id,'121012') in self.uprawnienia and FunkcjaOkna==1) or
        ((self.oddzial_id,'045012') in self.uprawnienia and FunkcjaOkna==2)) 

#-------------------------------------------------------------------------------
#---   EDYCJA OPISU (11)
#-------------------------------------------------------------------------------

if (Fun ==11) and stat=='OK':
    if not UprEdy:
        stat='BR UPR EDY'
    
    if stat=='OK':
        if FunkcjaOkna==1:
            OddzFiltr='oddzial_zam'
        else:
            OddzFiltr='oddzial_prod'

        Opis=rsglobal.Dekoduj(klucze[7])
        CzasWpr=rsglobal.Dekoduj(klucze[8])
        SQL="UPDATE rs_produkcja_sumy SET opis='"+Opis+"' WHERE firma_id='"+self.firma_id+"'"
        SQL+=" AND data='"+DataF+"' AND "+OddzFiltr+"='"+OddzialF+"' AND zmiana='"+ZmianaF+"' AND zmiana_p='"+ZmianaProdF+"'"
        if len(CzasWpr)==10:
            SQL+=" AND czas_wprowadzenia='"+CzasWpr+"';"
        else:        
            SQL+=" AND czas_wprowadzenia::TEXT LIKE '"+CzasWpr+"%';"
        stat,dump,dump,dump=self.PolSQL.Execute(SQL,1)
    
#-------------------------------------------------------------------------------
#---   POBRANIE DANYCH (5 -select)
#-------------------------------------------------------------------------------

if (Fun in [5,11]) and stat=='OK':
    if FunkcjaOkna==1:
        #w sprzeday
        OddzSel='oddzial_prod'
        OddzFiltr='oddzial_zam'
    else:
        #w produkcji
        OddzSel='oddzial_zam'
        OddzFiltr='oddzial_prod'
   
    sql = "SELECT ps.stan,ps."+OddzSel+",COALESCE(ps.typ_odbiorcy,''),ps.zamowione1,ps.zamowione2,ps.wyprodukowane1,ps.wyprodukowane2,"
    sql+="ps.braki1,ps.braki2,ps.czas_wprowadzenia,op.imie||' '||op.nazwisko,COALESCE(ps.opis,'') FROM rs_produkcja_sumy ps "
    sql+=" INNER JOIN rs_operatorzy op ON (ps.z_op_id=op.operator_id) WHERE firma_id='"+self.firma_id+"'"
    sql+=" AND data='"+DataF+"' AND "+OddzFiltr+"='"+OddzialF+"' AND zmiana='"+ZmianaF+"' AND zmiana_p='"+ZmianaProdF+"'"
    if TypOdbF <>'':
        sql+= " AND typ_odbiorcy='"+TypOdbF+"' "
    sql+=" AND artykul_id='"+ArtykulF+"' ORDER BY czas_wprowadzenia;"
    stat,dane,wyn1,wyn2=self.PolSQL.Execute(sql,3)