# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_zloz_pozycje_dokumentu_magazynowego
# Purpose:     
# Author:      Michal Raburski
# Created:     2006/02/15
# RCS-ID:      $Id: fs_zloz_pozycje_dokumentu_magazynowego.py $
# Copyright:        (c) 2008 RecordSystem
# Licence:          GNU GPL
#-------------------------------------------------------------------------------

# wprowadzilem poprawke dotyczaca sprawdzania czy poz nie jest juz scalona (wczesniej wywalalo BLAD jesli bya)
# Pawe Wjcikowski 13.10.2009r.
#2011.02.02 - Mariusz Rajfura - nowe pole 'produkt_id' (4223)
#2011.04.11 - Mariusz Rajfura - uaktualnienie wirtualnych artykulow-przyjecia (4458)


from funkcje import fs_dokumenty_magazynowe_lokacje_pom

dl=10
rsglobal.ZapiszDoLogow('ZACZYNAM '+str(klucze),dl)
Mag = klucze[0]
Dok = klucze[1]
Data = klucze[2]
Numer = klucze[3]
NrPoz = klucze[4]

#sprawdzenie czy wszystkie pozycje sa takie same 
stat='OK'

Where="WHERE firma_id='"+self.firma_id+"' AND magazyn_id='"+str(Mag)+"' AND dokument_id='"+str(Dok)+"' "
Where+="AND data='"+str(Data)+"' AND numer="+str(Numer)+" AND nr_poz="+str(NrPoz)+"" 

Select="SELECT DISTINCT artykul_id,ilosc1,ilosc2,cena1,cena2,termin_przyd,cena_wal1," # 0 - 6
Select+=" cena_wal2,dokument_przych,czy_cena,czy_seria,dostawca_id,lokacja_skad,lokacja_dokad," # 7 - 13
Select+=" cecha1_opis,cecha1_wartosc,zo_wyznacznik_id,zo_data,zo_numer,zo_nr_poz,zo_nr_ppoz,produkt_id," # 14 - 21
Select+=" COALESCE(opakowanie_id,''),COALESCE(paleta_id,''),COALESCE(wsp_ilosci_opakowanie,0)," # 22 - 24
Select+=" COALESCE(wsp_ilosci_paleta,0),COALESCE(wsp_ilosci_lokacja,0)" # 25 - 26
Select+=" FROM rs_dokumenty_magazynowe_pozycje "+Where+";"
stat,dane,wyn1,wyn2=self.PolSQL.Execute(Select,2)
if len(dane)==0:
    stat='Brak pozycji'
elif len(dane) > 1:
    stat='Za duo rnych pozycji - nie mona poczy'
else:
    #wykonanie poczenia
    art=rsglobal.Dekoduj(dane[0][0])
    stat,suma,dump,dump=self.PolSQL.Execute("SELECT SUM(ilosc1) FROM rs_dokumenty_magazynowe_pozycje "+Where+";",2)
    il1=suma[0][0]
    il2=dane[0][2]*il1
    cena1=dane[0][3]
    cena2=dane[0][4]
    termin=dane[0][5]
    if termin == 'None':
        termin="NULL"
    else:
        termin = "'"+termin+"'"
    cenaw1=dane[0][6]
    cenaw2=dane[0][7]
    dp=rsglobal.Dekoduj(dane[0][8])
    czyc=dane[0][9]
    if czyc:
        czyc='TRUE'
    else:
        czyc='FALSE'
    czys=dane[0][10]
    if czys:
        czys='TRUE'
    else:
        czys='FALSE'
        
    dost=dane[0][11]
    if dost in (None,'None'):
        dost='NULL'
    else:
        dost="'"+rsglobal.Dekoduj(dost)+"'"
        
    LokSkad=dane[0][12]
    if LokSkad in (None,'None'):
        LokSkad='NULL'
    else:
        LokSkad="'"+rsglobal.Dekoduj(LokSkad)+"'"
        
    LokDokad=dane[0][13]
    if LokDokad in (None,'None'):
        LokDokad='NULL'
    else:
        LokDokad="'"+rsglobal.Dekoduj(LokDokad)+"'"
        
    CechaOpis=dane[0][14]
    if CechaOpis in (None,'None'):
        CechaOpis='NULL'
    else:
        CechaOpis="'"+rsglobal.Dekoduj(CechaOpis)+"'"

    CechaWart=dane[0][15]
    if CechaWart in (None,'None'):
        CechaWart='NULL'
    else:
        CechaWart="'"+rsglobal.Dekoduj(CechaWart)+"'"
        
    ZOWyzn=dane[0][16]
    if ZOWyzn in (None,'None'):
        ZOWyzn='NULL'
        ZOData='NULL'
        ZONr='NULL'
        ZONrPoz='NULL'
        ZONrPPoz='NULL'
    else:
        ZOWyzn="'"+rsglobal.Dekoduj(ZOWyzn)+"'"
        ZOData="'"+rsglobal.Dekoduj(dane[0][17])+"'"
        ZONr=str(dane[0][18])
        ZONrPoz=str(dane[0][19])
        ZONrPPoz=str(dane[0][20])

    Produkt=rsglobal.Dekoduj(dane[0][21]).strip()
    if Produkt in (None,'None'):
        Produkt='NULL'
    else:
        Produkt="'"+Produkt+"'"
        
    if dane[0][22] == '':
        Opak='NULL'
    else:
        Opak="'"+rsglobal.Dekoduj(dane[0][22])+"'"
        
    if dane[0][23] == '':
        Paleta='NULL'
    else:
        Paleta="'"+rsglobal.Dekoduj(dane[0][23])+"'"
        
    WspOpak = str(dane[0][24])
    WspPaleta = str(dane[0][25])
    WspLokacja = str(dane[0][26])
    
    if stat=="OK":
        spr2="SELECT * FROM rs_dokumenty_magazynowe_pozycje WHERE firma_id = '"+self.firma_id+"' "
        spr2+="AND magazyn_id = '"+str(Mag)+"' AND dokument_id='"+str(Dok)+"' AND data='"+str(Data)+"' "
        spr2+="AND numer="+str(Numer)+" AND nr_poz="+str(NrPoz)+" AND nr_ppoz=0 AND czy_rozbicie;"
        stat,d2,dump,dump = self.PolSQL.Execute(spr2,3)
        if stat<>'OK':
            stat="Bd przy sprawdzaniu danych : "+stat   
            dane.append(stat)     
        else:                        
            if len(d2)<>0:
                stat="Podana pozycja jest ju scalona lub podpozycje pochodz z rezerwacji, a nie z rozbicia."  
                dane.append(stat)   
                   
    if stat=='OK':                
        # obsuga lokacji. Najpierw zdejmujemy aktualne iloci z pozycji a potem wkadamy nowe - po zmianach.
        # Scalanie nie moe zwikszy iloci na lokacji oraz nie zmieni dokadnej iloci na lokacji zatem testy poprawnoci
        # lokacji s niepotrzebne. Nie zmieni si te ilo do wydania, wic nie ma po co tego sprawdza.
        
        # waciwe poczenie pozycji
        Insert="INSERT INTO rs_dokumenty_magazynowe_pozycje (firma_id,magazyn_id,dokument_id,data,numer,nr_poz,nr_ppoz,"
        Insert+="artykul_id,ilosc1,ilosc2,cena1,cena2,nr_serii,termin_przyd,cena_wal1,cena_wal2,dokument_przych,"
        Insert+="czy_cena,czy_seria,czy_rozbicie,dostawca_id,lokacja_skad,lokacja_dokad,"
        Insert+="cecha1_opis,cecha1_wartosc,zo_wyznacznik_id,zo_data,zo_numer,zo_nr_poz,zo_nr_ppoz,produkt_id,"
        Insert+="opakowanie_id,paleta_id,wsp_ilosci_opakowanie,wsp_ilosci_paleta,wsp_ilosci_lokacja)"
        Insert+=" VALUES('"+self.firma_id+"','"+Mag+"','"+Dok+"','"+Data+"',"+str(Numer)+","+str(NrPoz)+",0,"
        Insert+="'"+art+"',"+str(il1)+","+str(il2)+","+str(cena1)+","+str(cena2)+",'',"+termin+","+str(cenaw1)+","
        Insert+=""+str(cenaw2)+",'"+dp+"',"+czyc+","+czys+",FALSE,"+dost+","+LokSkad+","+LokDokad+","
        Insert+=CechaOpis+","+CechaWart+","+ZOWyzn+","+ZOData+","+ZONr+","+ZONrPoz+","+ZONrPPoz+","+Produkt+","
        Insert+=Opak+","+Paleta+","+WspOpak+","+WspPaleta+","+WspLokacja+");"        
        stat,dump,dump,dump=self.PolSQL.Execute(Insert,1)
        if stat=='OK':
            delete="DELETE FROM rs_dokumenty_magazynowe_pozycje "+Where+" AND nr_ppoz>0;"
            stat,dump,dump,dump=self.PolSQL.Execute(delete,1)
            
        # przeliczamy ilo lokacyjn na zoonej pozycji
        if stat=='OK':
            from funkcje import fs_dokumenty_magazynowe_lokacje_pom
            stat = fs_dokumenty_magazynowe_lokacje_pom.UstawWspIIloscLokacyjnaNaDM(self,Mag,Dok,Data,Numer,NrPoz,0,True)
        rsglobal.ZapiszDoLogow('1'+stat,1)
        # odwieenie wirtualnych artykuw przyjcia
        if stat=='OK':
            stat=fs_dokumenty_magazynowe_lokacje_pom.OdswiezWirtualnePozPrzyj(self,Mag,Dok,Data,Numer,NrPoz)
            rsglobal.ZapiszDoLogow('2'+stat,1)        