# -*- coding: iso8859_2 -*-

# 2011-12-18 Mariusz Rajfura    dodanie parametru do wywolania 'fs_dowody_ksiegowe' (5278)
# 2019-05-29 Wojciech Skowron   aktualizacja sownika bdw (dekretacja pac) (11490)
# 2022-02-21 Aleksander Bargie fs_dekretuj_i_zamknij_dowody :Bd wykonania funkcji wewntrznej fs_dowody_ksiegowe:name 'DataOdF' is not defined  (12894)
# 2023-06-29 Aleksander Bargie (13474) Filtr 'Nip' w d.k.

lista = ['Dowod', 'Nazwa', 'DniOd','DniDo','Operator']
SprawdzArgumenty(lista)
# utworzenie sownika bdw
SBledyDekr = {
  "BL SQL":(u"Bd wykonania polecenia SQL. Ponw prb lub  skontaktuj si z administratorem.",None),
  "BR DOWOD":(u"Brak dowodu wzoru dekretacji",None),
  "BR NAZWA":(u"Brak nazwy wzoru dekretacji",None),
  "BR WZORU":(u"Brak podanego w parametrach wzoru dekretacji: "+Dowod+"/"+Nazwa,None),
  "BR WYZN":(u"Brak jakiegokolwiek wyznacznika we wzorze dekretacji faktur",None),
  "BL TYP":(u"Nieobsugiwany typ wzoru dekretacji",None),
  "BL OKR":(u"Brak okresu dekretacji",None),
  "BR KTM":(u"Brak danych o kontach dla poszczeglnych typw artykuw",None),
  "BR DATAOD":(u"Brak daty od",None),
  "BL DATAOD":(u"Niepoprawna data od",None),
  "ZK DATAOD":(u"Data od spoza zakresu",None),
  "OKR DATAOD":(u"Data od poza datami okresu obrachunkowego",None),
  "BR DATADO":(u"Brak daty do",None),
  "BL DATADO":(u"Niepoprawna data do",None),
  "ZK DATADO":(u"Data do spoza zakresu",None),
  "OKR DATADO":(u"Data do poza datami okresu obrachunkowego",None),
  "OD WIE DO":(u"Data od wiksza od daty do",None),
  "NZK FAKT":(u"Faktura $ nie jest zadekretowana.",None),
  "NZK KOR":(u"Korekta $ nie jest zadekretowana.",None),
  "NZK MAG":(u"Dokument magazynowy $ nie jest zadekretowany.",None),
  "NZK DOST":(u"Dostawa $ nie jest zadekretowana.",None),
  "NZK LP":(u"Lista pac $ nie jest zadekretowana.",None), #WS 2019-05-29
  "NZAM FAKT":(u"Faktura $ nie jest zamknita ani zadekretowana.",None),
  "NZAM KOR":(u"Korekta $ nie jest zamknita ani zadekretowana.",None),
  "NZAM MAG":(u"Dokument magazynowy $ nie jest zamknity ani zadekretowany.",None),
  "NZAM DOST":(u"Dostawa $ nie jest zamknita ani zadekretowana.",None),
  "NZAM LP":(u"Lista pac $ nie jest zamknita ani zadekretowana.",None), #WS 2019-05-29
  "BR DOK":(u"Brak dokumentw do dekretacji",None),
  "BR POZ":(u"Brak pozycji na wzorze dekretacji",None),
  "BR POZ WZ":(u"Brak pozycji na wzorze dekretacji speniajcej podstawowe kryteria. Dokument: $",None),
  "BR KWN":(u"Brak konta wn na wzorze - dokument: $.",None),
  "BR KMA":(u"Brak konta ma na wzorze - dokument: $.",None),
  "BL WAR":(u"Bdy sprawdzania warunku : dokument $",None),
  "BR POZWZM":(u"Brak wzorca dekretacji dla dokumentu $.",None),
  "BLOK STAN":(u"Nie mona byo zaoy blokady stanu dla dokumentu $.",None),
  "BL STAN":(u"Stwierdzono nieprawidowy stan dla dokumentu $.",None),
  "BR KOR":(u"Brak korekty na dokumencie $.",None),
  "BR WZDEK":(u"Brak pozycji wzoru dekretacji dla wyznacznikw : $",None),
  "BR KT":(u"Brak zdefiniowanych kont w rozbiciu na stawki vat na fakturze $.",None),
  "BR GW":(u"Poniewa faktura $ bdzie rozbita typami artykuw to wszystkie konta ma na wzorze dekretacji powinny mie *.",None),
  "BR GWMWN":(u"Poniewa dokumenty magazynowe bd rozbite typami artykuw to wszystkie konta wn na wzorze dekretacji powinny mie *.",None),
  "BR GWMMA":(u"Poniewa dokumenty magazynowe bd rozbite typami artykuw to wszystkie konta ma na wzorze dekretacji powinny mie *.",None),
  "BR KTYP":(u"Konto zastpujce * nie jest zdefiniowane $.",None),
  "BR STR":(u"Brak zdefiniowanej strony w pozycji $ wzoru dekretacji.",None), #WS 2019-05-29
  "BR K":(u"Brak zdefiniowanego konta w pozycji $ wzoru dekretacji.",None), #WS 2019-05-29
  "BR D WYP": (u"Brak daty wypaty dla listy pac $.", None),  # WS 2019-05-29
  "PO DOK":(u"Nie mona tworzy dowodw - istniej dowody z pniejsz dat.",None),
  "BL SPR UPR":(u"Bdy sprawdzania uprawnie",None),
  "UPR DOD":(u"Brak uprawnie do dodawnia dowodu o podanym wzorze.",None),
  "BR DAT":(u"Brak danych zamknitych miesicy, sprawd wprowadzone daty.",None),
  "ZAM MC":(u"Wprowadzony zakres dat obejmuje zamknity miesic.",None),
}

#-------------------------------------------------------------------------------
#-------------------------------------------------------------------------------

# pobranie konkretnych dat wykonania
SQL="SELECT now()::DATE + INTEGER '"+str(DniOd)+"',now()::DATE + INTEGER '"+str(DniDo)+"';"
stat,DZakres,dump,dump=PolSQL.Execute(SQL,3)
KonczJesliBlad(stat,'1 '+stat)
DataOd=rsglobal.Dekoduj(DZakres[0][0])
DataDo=rsglobal.Dekoduj(DZakres[0][1])

Data = DataOd
while Data <= DataDo:
    # pobranie dat okresu do ktrego naley data
    SQL="SELECT okres_id FROM rs_definicje_okresow WHERE firma_id='"+firma_id+"' "
    SQL+="AND '"+Data+"' BETWEEN data_od AND data_do;"
    stat,DOkres,dump,dump=PolSQL.Execute(SQL,3)
    KonczJesliBlad(stat,'Bd pobrania okresu dla daty '+Data+': '+stat)
    if len(DOkres)==0:
        KonczJesliBlad("BLAD","Brak okresu zawierajcego wyliczon dat :"+Data)

    Okres=rsglobal.Dekoduj(DOkres[0][0])

    KluczeDekr = [Dowod,Nazwa,Data,Data,Okres]
    stat, dane, none, none = WykonajFunkcje('fs_dekretacja_automatyczna', KluczeDekr, [], [])

    if stat == 'BR DOK':
        stat = 'OK'
    if 'BR DOK' in dane:
        dane.remove('BR DOK')

    if stat<>'OK' or len(dane)>0:
        PolSQL.Rollback()
            
        if Operator >= 0:
            stat2=stat
            query = "SELECT nextval('rs_wiadomosci_id')"
            stat,wiadomosc_id,none,none=PolSQL.Execute(query,4)
            KonczJesliBlad(stat,'Bd pobrania numeru wiadomoci :'+stat)
            
            temat="Bdy w wykonaniu dekretacji automatycznej w harmonogramie"
            tresc=''
            if stat2<>'OK':
                tresc=rsglobal.WyswietlBladZeSlownika(stat2,SBledyDekr).replace('\\','\\\\').replace("'","''")
            else:
                for poz in dane:
                    tresc+=rsglobal.WyswietlBladZeSlownika(poz,SBledyDekr).replace('\\','\\\\').replace("'","''")+'\n'
    
            SQL="INSERT INTO rs_wiadomosci (firma_id,wiadomosc_id,operator_id,naglowek,tresc,priorytet,usunieta) "
            SQL+="VALUES "+"('"+firma_id+"',"+str(wiadomosc_id)+","+str(operator_id)+","+rsglobal.ObrobTekst(temat)
            SQL+=",'"+rsglobal.Dekoduj(tresc)+"','N',False);"
            SQL+="INSERT INTO rs_wiadomosci_operatorzy (wiadomosc_id, folder_id, operator_id,usunieta,nowa) "
            SQL+="VALUES "+"("+str(wiadomosc_id)+",0,"+str(Operator)+",False,True)"
            stat,none,none,none=PolSQL.Execute(SQL,1)
            PolSQL.Commit()
            KonczJesliBlad(stat, stat)
            if stat=='OK':
                stat=rsglobal.WyswietlBladZeSlownika(stat2,SBledyDekr)

    KonczJesliBlad(stat, stat)

    SQL="SELECT '"+Data+"'::DATE + 1;"
    stat,DDaty,dump,dump=PolSQL.Execute(SQL,3)
    KonczJesliBlad(stat,'Bd przesunicia daty: '+stat)
    
    Data = DDaty[0][0]

#-------------------------------------------------------------------------------
#-- TERAZ ZAMYKAMY DOKUMENTY NA G I NA Z
#-------------------------------------------------------------------------------
klucze = {}
Data = DataOd

while Data <= DataDo:
    # W->G
    klucze['StanF'] = 'W'
    klucze['DowodF'] = Dowod
    klucze['NazwaF'] = Nazwa #To jest zalepka dla filtrowania
    klucze['DataOd'] = DataOd
    klucze['DataDo'] = DataDo
    klucze['DataOdF'] = DataOd #To jest zalepka dla filtrowania
    klucze['DataDoF'] = DataDo #To jest zalepka dla filtrowania
    klucze['OkresDow'] = Okres
    klucze['KontrF'] = '' #To jest zalepka dla filtrowania
    klucze['SymbF'] = '' #To jest zalepka dla filtrowania
    klucze['PlatnosciF'] = '' #To jest zalepka dla filtrowania
    klucze['KontaVATF'] = '' #To jest zalepka dla filtrowania
    klucze['TrescF'] = '' #To jest zalepka dla filtrowania
    klucze['NumerF'] = 1 #To jest zalepka dla filtrowania
    klucze['KluczDokF'] = [] #To jest zalepka dla filtrowania
    klucze['NoweKlucze'] = [] #To jest zalepka dla filtrowania
    klucze['ZagadnienieF'] = 0 #To jest zalepka dla filtrowania  #AB 21.02.22r
    klucze['NipF'] = '' #To jest zalepka dla filtrowania  #AB 2023-06-29

    klucze['Funkcja'] = 11
    rsglobal.ZapiszDoLogow(klucze, 1)
    stat, dane, wyn1, wyn2 = WykonajFunkcje('fs_dowody_ksiegowe', klucze, [], [])
    KonczJesliBlad(stat, stat)
    
    # G->Z
    klucze['StanF'] = 'G'
    klucze['DowodF'] = Dowod
    klucze['NazwaF'] = Nazwa #To jest zalepka dla filtrowania
    klucze['DataOd'] = DataOd
    klucze['DataDo'] = DataDo
    klucze['DataOdF'] = DataOd #To jest zalepka dla filtrowania
    klucze['DataDoF'] = DataDo #To jest zalepka dla filtrowania
    klucze['OkresDow'] = Okres
    klucze['KontrF'] = '' #To jest zalepka dla filtrowania
    klucze['SymbF'] = '' #To jest zalepka dla filtrowania
    klucze['PlatnosciF'] = '' #To jest zalepka dla filtrowania
    klucze['KontaVATF'] = '' #To jest zalepka dla filtrowania
    klucze['TrescF'] = '' #To jest zalepka dla filtrowania
    klucze['NumerF'] = 1 #To jest zalepka dla filtrowania
    klucze['KluczDokF'] = [] #To jest zalepka dla filtrowania
    klucze['NoweKlucze'] = [] #To jest zalepka dla filtrowania
    klucze['ZagadnienieF'] = 0 #To jest zalepka dla filtrowania  #AB 21.02.22r
    klucze['NipF'] = '' #To jest zalepka dla filtrowania  #AB 2023-06-29

    klucze['Funkcja'] = 21
    rsglobal.ZapiszDoLogow(klucze, 1)
    stat, dane, wyn1, wyn2 = WykonajFunkcje('fs_dowody_ksiegowe', klucze, [], [])
    KonczJesliBlad(stat, stat)

    SQL="SELECT '"+Data+"'::DATE + 1;"
    stat,DDaty,dump,dump=PolSQL.Execute(SQL,3)
    KonczJesliBlad(stat,'Bd przesunicia daty: '+stat)
    
    Data = DDaty[0][0]