# -*- coding: iso8859_2 -*-

lista = ['KwotaLimitu', 'Kraje', 'KwotaTransakcji']
SprawdzArgumenty(lista)

Data=rsglobal.PodajDzis()  
LKraje = rsglobal.Dekoduj(argumenty['Kraje']).split(',')
KursSredniEUR = 0
LZablokowanych = []
LNiewstawionych = []
LWstawionych = []
LPrzedluzonych = []

# pobranie listy karencji
SQL="SELECT k.kontrahent_id,k.kraj,MAX(COALESCE(kk.karencja_do::TEXT,'')) "
SQL+=" FROM rs_kontrahenci k LEFT OUTER JOIN rs_kontrahenci_kuke kk USING (firma_id,kontrahent_id)"
SQL+=" WHERE k.firma_id='"+firma_id+"' AND k.kraj in ("+str(LKraje)[1:-1]+") AND k.aktywny"
SQL+=" GROUP BY k.kontrahent_id,k.kraj ORDER BY k.kontrahent_id"
stat,DKontr,dump,dump=PolSQL.Execute(SQL,3)
if stat <> 'OK':
    KonczJesliBlad(stat, 'Bd pobrania danych dotyczcych kontrahentw: '+stat)
    
SKontr = {} # SKontr[kontr] = [waluta,kurs,czy karencja,suma zaliczkowych, liczba faktur w zalegociach,
                             # data nieuregulowanej faktury, termin nieuregulowanej faktury]
for poz in DKontr:
    Kontr = poz[0]
    if not Kontr in SKontr:
        SKontr[Kontr] = ['PLN',1,False,0,0,'','']
    if poz[2] <> '':
        if Data <= poz[2]:
            #kontrahent w okresie karencji
            SKontr[Kontr][2] = True
    if poz[1]<>'PL':
        SKontr[Kontr][0]='EUR'
    
#Select do sumy faktur zaliczkowych
SQL ="SELECT f.kontrahent_id,SUM(do_zaplaty) FROM rs_faktury f " 
SQL+=" INNER JOIN rs_wyznaczniki w USING (firma_id,wyznacznik_id) "
SQL+=" INNER JOIN rs_kontrahenci k USING (firma_id,kontrahent_id)"
SQL+=" WHERE f.firma_id='"+firma_id+"' AND w.typ_faktury='FZ' AND f.data>'"+Data+"'::DATE - INTERVAL '1 YEAR'"
SQL+=" AND k.kraj in ("+str(LKraje)[1:-1]+") AND k.aktywny GROUP BY f.kontrahent_id ORDER BY f.kontrahent_id"
stat,DSumaZapl,dump,dump=PolSQL.Execute(SQL,3)
if stat <> 'OK':
    KonczJesliBlad(stat, 'Bd pobrania danych kwoty faktur: '+stat)
            
for poz in DSumaZapl:
    SKontr[poz[0]][3]=poz[1]

# pobranie zalegoci nieprzeterminowanych
SQL ="SELECT k.kontrahent_id,COUNT(*) FROM rs_rozrachunki r "
SQL+=" INNER JOIN rs_kontrahenci k ON (k.firma_id=r.firma_id AND r.konto = TRIM('-' FROM k.konto_odbiorca)||'-'||k.kontrahent_id) "
SQL+=" WHERE r.firma_id='"+firma_id+"' AND COALESCE(r.pdk_data,r.data)>'"+Data+"'::DATE - INTERVAL '1 YEAR' "
SQL+=" AND r.data_rozlicz < r.termin_plat + 31 AND NOT r.data_rozlicz IS NULL "
SQL+=" AND r.saldo_wal_wn=r.rozliczone_wal_wn AND r.kwota_wn>0 AND r.saldo_wal_wn>0"
SQL+=" AND k.kraj in ("+str(LKraje)[1:-1]+") AND k.aktywny"
SQL+=" GROUP BY k.kontrahent_id ORDER BY k.kontrahent_id"
stat,DUreg,dump,dump=PolSQL.Execute(SQL,3)
if stat <> 'OK':
    KonczJesliBlad(stat, 'Bd pobrania danych o liczbie nieprzeterminowanych faktur : '+stat)

for poz in DUreg:
    SKontr[poz[0]][4]=poz[1]

# pobranie potencjalnych zalegoci przeterminowanych
SQL ="SELECT DISTINCT k.kontrahent_id,r.data,r.termin_plat FROM rs_rozrachunki r "
SQL+=" INNER JOIN rs_kontrahenci k ON (k.firma_id=r.firma_id AND r.konto = TRIM('-' FROM k.konto_odbiorca)||'-'||k.kontrahent_id) "
SQL+=" WHERE r.firma_id='"+firma_id+"' AND COALESCE(r.pdk_data,r.data) > '"+Data+"'::DATE - INTERVAL '1 YEAR' "
SQL+=" AND COALESCE(r.data_rozlicz,'"+Data+"'::DATE) >=r.termin_plat + 31 "
SQL+=" AND r.kwota_wn > 0 AND k.kraj in ("+str(LKraje)[1:-1]+") AND k.aktywny"
SQL+=" AND r.saldo_wal_wn > 0"
SQL+=" ORDER BY k.kontrahent_id,r.termin_plat"
stat,DNieUreg,dump,dump=PolSQL.Execute(SQL,3)
if stat <> 'OK':
    KonczJesliBlad(stat, 'Bd pobrania danych o przeterminowanych fakturach: '+stat)
    
KontrNU = ''
for poz in DNieUreg:
    if poz[0] <> KontrNU:
    # jeli nie uregulowano przeterminowanej faktury lub uregulowanie byo 30 dni po terminie
        SKontr[poz[0]][5]=poz[1]
        SKontr[poz[0]][6]=poz[2]
        KontrNU=poz[0]

LKluczy = SKontr.keys()
LKluczy.sort()

for kontr in LKluczy:
    # jeli w karencji
    if SKontr[kontr][2]:
        continue

    DataKukeOd =''
    DataKukeDo =''
    DataKarencji =''
    DataOpoznienia = SKontr[kontr][5]
    TerminOpoznienia = SKontr[kontr][6]
    #sprawdza czy istnieje pozycja dla dnia wczorajszego i pobiera dzien rozpoczecia jesli istnieje
    SQL ="SELECT data_od,data_do,COALESCE(karencja_do::TEXT,'') FROM rs_kontrahenci_kuke WHERE firma_id='"+firma_id+"' "
    SQL+=" AND kontrahent_id='"+kontr+"' AND data_do>=date'"+Data+"'-1 AND NOT nazwany AND NOT prywatny"
    stat,DDataOd,dump,dump=PolSQL.Execute(SQL,3)
    if stat <> 'OK':
        KonczJesliBlad(stat, 'Bd pobrania danych z dat pocztkow: '+stat)
    if len(DDataOd) >0:
        DataKukeOd =DDataOd[0][0]
        DataKukeDo =DDataOd[0][1]
        DataKarencji =DDataOd[0][2]
    
    # jeli jest opnione uregulowanie i aktywne kuke
    if DataOpoznienia <> '' and DataKukeOd <> '' and DataKarencji == '':
        # robimy blokad z karencj dla aktywnego kuke
        SQL ="UPDATE rs_kontrahenci_kuke SET "
        SQL+=" data_przerwania='"+TerminOpoznienia+"'::DATE + 31,karencja_do='"+DataOpoznienia+"'::DATE + 1 + INTERVAL '1 YEAR' "
        SQL+=" WHERE firma_id='"+firma_id+"' AND kontrahent_id='"+kontr+"' AND data_od='"+DataKukeOd+"' "
        SQL+=" AND data_do>='"+Data+"'::DATE - 1 AND NOT nazwany AND NOT prywatny"
        stat,dump,dump,dump=PolSQL.Execute(SQL,1)
        if stat <> 'OK':
            KonczJesliBlad(stat, 'Bd blokady ubezpieczenia: '+stat)
        LZablokowanych.append(kontr)

    # jeli kuke obowizuje
    if DataOpoznienia == '' and (SKontr[kontr][3]>=KwotaTransakcji or SKontr[kontr][4] >1):
        if DataKukeOd == '':
            #jesli nie ma nieoznaczonego na dany dzien
            if SKontr[kontr][0] == 'EUR':
                if KursSredniEUR ==0:
                    SQL="SELECT kurs_sredni FROM rs_kursy_walut WHERE firma_id='"+firma_id+"' AND data='"+Data+"' AND waluta='EUR'"
                    stat,DKurs,dump,dump=PolSQL.Execute(SQL,3)
                    if stat <> 'OK':
                        KonczJesliBlad(stat, 'Bd pobrania danych kursu: '+stat)
                    elif len(DKurs)==0:
                        KursSredniEUR = -1
                    elif DKurs[0][0]==0:
                        KursSredniEUR = -1
                    else:
                        KursSredniEUR = DKurs[0][0]
                    
                    SKontr[kontr][1]=KursSredniEUR
                else:
                    SKontr[kontr][1]=KursSredniEUR
                    
            if SKontr[kontr][1] == -1:
                LNiewstawionych.append(kontr)
            else:
                
                SQL ="INSERT INTO rs_kontrahenci_kuke (firma_id,kontrahent_id,data_od,data_do,kwota,"
                SQL+=" kurs,waluta,kwota_wal,nazwany,prywatny)"
                SQL+=" VALUES ('"+firma_id+"','"+kontr+"','"+Data+"','"+Data+"',"+str(KwotaLimitu)+","
                SQL+=""+str(SKontr[kontr][1])+",'"+SKontr[kontr][0]+"',"+str(KwotaLimitu/SKontr[kontr][1])+",FALSE,FALSE)"
                stat,dump,dump,dump=PolSQL.Execute(SQL,1)
                if stat <> 'OK':
                    KonczJesliBlad(stat, 'Bd dodania ubezpieczenia: '+stat)
                
                LWstawionych.append(kontr)
        else:
            #jesli jest juz ubezpieczenie
            SQL ="UPDATE rs_kontrahenci_kuke SET "
            SQL+=" data_do=CASE WHEN '"+Data+"' > data_do THEN '"+Data+"' ELSE data_do END"
            SQL+=" WHERE firma_id='"+firma_id+"' AND kontrahent_id='"+kontr+"' AND data_od='"+DataKukeOd+"' "
            SQL+=" AND data_do='"+DataKukeDo+"' AND NOT nazwany AND NOT prywatny"
            stat,dump,dump,dump=PolSQL.Execute(SQL,1)
            if stat <> 'OK':
                KonczJesliBlad(stat, 'Bd zmiany ubezpieczenia: '+stat)
            LPrzedluzonych.append(kontr)
            
# zapisanie do logw kontrahentw uwzgldnionychw KUKE
if len(LZablokowanych) > 0:
    LZablokowanych.sort()
    LKontr=''
    for k in LZablokowanych:
        LKontr+=k+','
    ZapiszLog('LISTA KONTRAHENTW ZABLOKOWANYCH:\n     '+LKontr.strip(','))
    
if len(LNiewstawionych) > 0:
    LNiewstawionych.sort()
    LKontr=''
    for k in LNiewstawionych:
        LKontr+=k+','
    ZapiszLog('LISTA KONTRAHENTW NIEWSTAWIONYCH ZE WZGLDU NA BRAK KURSU EUR:\n     '+LKontr.strip(','))
    
if len(LWstawionych) > 0:
    LWstawionych.sort()
    LKontr=''
    for k in LWstawionych:
        LKontr+=k+','
    ZapiszLog('LISTA KONTRAHENTW Z DODANYM UBEZPIECZENIEM:\n     '+LKontr.strip(','))
    
if len(LPrzedluzonych) > 0:
    LPrzedluzonych.sort()
    LKontr=''
    for k in LPrzedluzonych:
        LKontr+=k+','
    ZapiszLog('LISTA KONTRAHENTW Z PRZEDUONYM UBEZPIECZENIEM:\n     '+LKontr.strip(','))