# -*- coding: iso8859_2 -*- 
 
import rsglobal
Data_dzis = rsglobal.PodajDzis()  
CzyWyslacPrzyszly = False
CzyWysylacZwolnienie = False

# pobranie listy pracownikw ktrzy zostan zwolnieni w najbliszym tygodniu
SQL=" SELECT up.pracownik_id,d.nazwisko,d.imie,up.do_kiedy"
SQL+=" FROM rs_kp_umowy_o_prace up"
SQL+=" INNER JOIN rs_kp_zatrudnienie z ON (up.firma_id=z.firma_id AND up.pracownik_id=z.pracownik_id AND up.umowa_id=z.numer_id)"
SQL+=" INNER JOIN rs_kp_dane_osobowe d ON (up.firma_id=d.firma_id AND up.pracownik_id=d.pracownik_id)"
#SQL+=" WHERE up.firma_id='"+firma_id+"' AND up.do_kiedy <=date'"+Data_dzis+"'+7"
#SQL+=" AND up.do_kiedy >='"+Data_dzis+"' AND z.stan_pracownika_id<>'Z'"
SQL+=" WHERE up.firma_id='"+firma_id+"' AND z.zwolnienie_data <=date'"+Data_dzis+"'+7"
SQL+=" AND z.zwolnienie_data >='"+Data_dzis+"' AND z.stan_pracownika_id<>'Z'"
stat,DPrPrzy,dump,dump = PolSQL.Execute(SQL,3)
if stat != 'OK':
    KonczJesliBlad(stat, 'Bd pobrania pracownikw, ktrzy bd do zwolnienia: '+stat)

if len(DPrPrzy)>0:
    CzyWyslacPrzyszly = True
    # skadanie tekstu z list pracownikw, ktrzy bd w przyszoci zwalniani
    TrescPrzyszly="W cigu tygodnia koczy si okres zatrudnienia dla:\n"
    for pr in DPrPrzy:
        TrescPrzyszly+=pr[0]+"- "+pr[1]+" "+pr[2]+" data koca umowy: "+pr[3]+"\n"

# pobranie listy pracownikw, ktrzy zostan zwolnieni dzisiaj
SQL=" SELECT up.pracownik_id,d.nazwisko,d.imie,up.do_kiedy,numer_id"
SQL+=" FROM rs_kp_umowy_o_prace up"
SQL+=" INNER JOIN rs_kp_zatrudnienie z ON (up.firma_id=z.firma_id AND up.pracownik_id=z.pracownik_id AND up.umowa_id=z.numer_id)"
SQL+=" INNER JOIN rs_kp_dane_osobowe d ON (up.firma_id=d.firma_id AND up.pracownik_id=d.pracownik_id)"
#SQL+=" WHERE up.firma_id='"+firma_id+"' AND up.do_kiedy <'"+Data_dzis+"' AND z.stan_pracownika_id<>'Z'"
SQL+=" WHERE up.firma_id='"+firma_id+"' AND z.zwolnienie_data <'"+Data_dzis+"' AND z.stan_pracownika_id<>'Z'"
stat,DPrZwol,dump,dump = PolSQL.Execute(SQL,3)
if stat != 'OK':
    KonczJesliBlad(stat, 'Bd pobrania pracownikw, ktrzy zostali zwolnieni: '+stat)

if len(DPrZwol)>0:
    CzyWysylacZwolnienie = True   
    # Zmiana stanu u pracownikw i skladanie listy, ktorym zmienilismy stan
    TrescZwolnieni="\n\nZmieniono stan z zatrudniony na zwolniony dla:\n"
    for pr in DPrZwol:
        SQL ="UPDATE rs_kp_zatrudnienie SET "
        SQL+="stan_pracownika_id='Z' "
        SQL+="WHERE firma_id='"+firma_id+"' AND pracownik_id='"+pr[0]+"' "
        SQL+="AND numer_id= "+str(pr[4])
        stat,dump,dump,dump = PolSQL.Execute(SQL,1)
        if stat != 'OK':
            KonczJesliBlad(stat, 'Bd zmiany stanu pracownika "'+pr[0]+'": '+stat)
          
        TrescZwolnieni+=pr[0]+"- "+pr[1]+" "+pr[2]+" umowa zostaa zakoczona: "+pr[3]+"\n"

if CzyWyslacPrzyszly or CzyWysylacZwolnienie:
    Temat="Informacja o zakoczeniu stosunku pracy wygenerowane dnia "+rsglobal.PodajDzis()
    Tresc=""
    if CzyWyslacPrzyszly:
        Tresc+=TrescPrzyszly
    if CzyWysylacZwolnienie:
        Tresc+=TrescZwolnieni
        
    # pobranie adresw na ktre ma to pj dla konkretnego oddziau
    SQL="SELECT DISTINCT email FROM rs_powiadomienia_pozycje WHERE firma_id='"+firma_id+"'"
    SQL+=" AND powiadomienie='KP001';"
    stat,DPoczta,dump,dump=PolSQL.Execute(SQL,3)
    if stat != 'OK':    
        stat="Bd pobierania listy kont pocztowych : "+stat
        KonczJesliBlad(stat)

    # wysanie maili
    for mail in DPoczta:
        stat = rsglobal.RSWyslijEmail(mail[0], Temat,Tresc,[],0,PolSQL)
        if stat != 'OK':
            stat="Bd przy wysaniu maila: "+stat
            KonczJesliBlad(stat)