# -*- coding: iso8859_2 -*-
import time

# 2020-04-14 Wojciech Skowron - (11928) Zmiany w tworzeniu WZ z paragonw w handlu

SprawdzArgumenty(['tylko_sklep', 'dni_wstecz'])
import datetime
from funkcje import fs_hd_tworzenie_wz_z_paragonow_pom

self = rsglobal.StworzAtrapeSelfa(firma_id,PolSQL)
dzis = datetime.datetime.now()
data = dzis - datetime.timedelta(days=int(dni_wstecz) + 1)
stat = 'OK'

while data < dzis - datetime.timedelta(days=1):  # ptla po dniach
    bledy   = []
    sukcesy = []
    data = data + datetime.timedelta(days=1)
    data_str = data.strftime("%Y-%m-%d")
    ZapiszLog(data_str)
    # pobranie sklepw w ktrych w danym dniu byy paragony
    #WS 2020-04-14 - wz_data -> data_tworzenia_wz
    SQLSKLEPY = """SELECT DISTINCT sklep_id  FROM rs_hd_paragony
                WHERE firma_id ='{firma_id}' AND data_tworzenia_wz IS NULL AND czas::DATE = '{data_str}' AND '{tylko_sklep}' in ('', sklep_id)
                ORDER BY sklep_id;""".format(**locals())
    rsglobal.ZapiszDoLogow(SQLSKLEPY)
    stat, dane, dump, dump = PolSQL.Execute(SQLSKLEPY, 3, CzyDodawacBlad=True)
    if stat != 'OK':  # blad w pierszym sqlu - konczymy funkcje
        KonczJesliBlad(stat)
    if len(dane) < 1:  # jesli nie ma paragonow z ktorych mozna tworzyc dokumenty, stat wroci OK, a w tresci bedzie ponizsza informacja
        ZapiszLog("Na {data_str} nie odnaleziono paragonw do ktrych naley utworzy dokumenty WZ".format(**locals()))
    else:
        for sklep in dane:  # wywolanie funkcji tworzacej WZ dla kazdego sklepu i daty po kolei
            sklep_id = sklep[0]
            rsglobal.ZapiszDoLogow("sklep: "+sklep_id)
            # time.sleep(1)
            stat = fs_hd_tworzenie_wz_z_paragonow_pom.UtworzWZZParagonow(self, data_str, sklep_id)
            if stat == 'OK':  # dopisanie id sklepu do sukcesow, commit
                sukcesy.append(sklep_id)
                PolSQL.CommitCzysty()
            else:  # dopisanie tresci bledu do bledow, rollback na wypadek jakby cos zostalo juz wprowadzone
                bledy.append(stat)
                PolSQL.Rollback()

    if bledy:  # jesli wystapily bledy, wiersz po wierszu wypisana zostanie ich tresc
        ZapiszLog(u'Napotkano bdy:')
        for blad in bledy:
            ZapiszLog(blad)

    if sukcesy:  # jesli udalo sie utworzyc dokumenty, lista sklepow zostanie wypisana po przecinkach
        sklepy = ', '.join(sukcesy)
        ZapiszLog(u'Utworzono dokumenty dla sklepw: ' + sklepy)

    if bledy:
        stat = 'BLAD'
