# -*- coding: iso8859_2 -*-
# Autor: Jan Raburski,Micha Raburski
# Funkcja harmonogramu: fs_vacuum_analyze
# Funkcja wykonuje vacuum dla tabel (rs%)
# Argumenty: Serwery (1,2)


lista = ['Serwery']
SprawdzArgumenty(lista)

stat='OK'

query = "SELECT distinct(table_name) FROM information_schema.columns "
query+=" WHERE table_name LIKE 'rs%' ORDER BY table_name;"
stat,data,none,none=PolSQL.Execute(query,3)
if stat == 'OK' and data != [[]]:
    for rekord in data:
        tabela = rekord[0]
        query = "VACUUM ANALYZE "+str(tabela)+";"
        # poczenie serwera gwnego
        if '1' in Serwery:
            try:
                PoziomIzolacji = PolSQL.Polaczenie.isolation_level
            except:
                PoziomIzolacji = -1
                
            PolSQL.Polaczenie.set_isolation_level(0)
            ZapiszLog('PolSQL '+query)
            stat,none,none,none=PolSQL.Execute(query,1)
            if stat != 'OK':    
                ZapiszLog(str(stat))
                
            if PoziomIzolacji==-1:
                PolSQL.Polaczenie.set_isolation_level(1)
            else:
                PolSQL.Polaczenie.set_isolation_level(PoziomIzolacji)
                
        # poczenie serwera zapasowego/raportowego
        if '2' in Serwery and not PolSQL2 in [None,PolSQL]:
            try:
                PoziomIzolacji = PolSQL2.Polaczenie.isolation_level
            except:
                PoziomIzolacji = -1
            PolSQL2.Polaczenie.set_isolation_level(0)
            ZapiszLog('PolSQL2 '+query)
            stat,none,none,none=PolSQL2.Execute(query,1)
            if stat != 'OK':    
                ZapiszLog(str(stat))
            
            if PoziomIzolacji==-1:
                PolSQL2.Polaczenie.set_isolation_level(1)
            else:
                PolSQL2.Polaczenie.set_isolation_level(PoziomIzolacji)
        
    if stat == 'OK':
        ZapiszLog("Wykonano")
else:
    ZapiszLog(str(stat))

 

