# -*- coding: iso8859_2 -*-
# -------------------------------------------------------------------------------
# Name:        fs_wysylanie_pdf_dla_przewoznikow.py
# Purpose:     wysyanie meili z zestwieniami przejazdw
# Authors:     Piotr Witkowski
# Created:     2017/05/12
# Copyright:   (c) 2017 Record System
# Licence:     GNU GPL
# -------------------------------------------------------------------------------

# 2022-10-04 Wojciech Skowron - (12174) Poprawiona obsuga pliku

import os
import binascii
import tempfile
import rsglobal

klucze={}
klucze['Funkcja'] = 1
stat, Dane, wyn1, wyn2 = WykonajFunkcje('fs_kierowcy_wersje_wydruk_pdf', klucze, [], [])
#stat, Dane=fs_kierowcy_wersje_wydruk_pdf_pom.Funkcja1('OK',[])
if stat=='OK' and len(Dane)==0:
    stat = u'Brak przewonikw w wybranym okresie.'
elif not (stat=='OK' and len(Dane)>0):
    stat=u'Bdy odczytu: '+stat
else:
    dzis = rsglobal.PodajDzis()
    Dzien = int(dzis[8:10])
    if Dzien<16:
        Rok = int(dzis[0:4])
        Mc = int(dzis[5:7])
        Mc=Mc-1
        if Mc<1:
            Mc=12
            Rok=Rok-1

        if Mc<10:
            Miesiac='0'+str(Mc)
        else:
            Miesiac=str(Mc)

        DataOd=str(Rok)+'-'+str(Miesiac)+'-16'
        DataDo=str(Rok)+'-'+str(Miesiac)+'-'+str(rsglobal.PodajOstatniDzien(str(Rok)+'-'+str(Miesiac)+'-16'))
    else:
        DataOd=dzis[0:4]+'-'+dzis[5:7]+'-01'
        DataDo=dzis[0:4]+'-'+dzis[5:7]+'-'+'15'

    Liczba_Wyslanych = 0
    for x in range(len(Dane)):
        pzw = Dane[x][0].strip()
        klucze['Funkcja'] = 3
        klucze['DataOd'] = DataOd
        klucze['DataDo'] = DataDo
        klucze['Przewoznik'] = pzw
        stat, Oddzialy, wyn1, wyn2 = WykonajFunkcje('fs_kierowcy_wersje_wydruk_pdf', klucze, [], [])

        #stat, Oddzialy = fs_kierowcy_wersje_wydruk_pdf_pom.Funkcja3(self,'OK', [],DataOd,DataDo,pzw)
        if stat<>'OK':
            stat=u'Bdy w pobieraniu oddziaw'
        #elif len(Oddzialy)==0:
        #    stat=u"Brak oddziau dla przewonika "+pzw
        elif stat=='OK' and len(Oddzialy)>0:
            for oddzial, oddzialopis in Oddzialy:
                dane=[]
                Plik=oddzial+'-'+str(pzw).strip()+'-'+DataOd[2:4]+DataOd[5:7]+DataOd[8:10]+'-'+DataDo[2:4]+DataDo[5:7]+DataDo[8:10]+'.pdf'
                Folder= tempfile.gettempdir()
                if Folder<>'':
                    Plik=Folder+'/'+Plik

                Sel =  "SELECT DISTINCT email FROM rs_powiadomienia_pozycje WHERE firma_id='" + firma_id + "' "
                Sel += "AND (oddzial_id='" + oddzial + "' OR oddzial_id='**') AND powiadomienie = 'B0007' "
                Sel += "ORDER BY email ASC"
                stat, lmaile, dump, dump = PolSQL.Execute(Sel, 3)
                if stat != 'OK':
                    stat = 'Bd pobrania adresu email z tabeli rs_powiadomienia_pozycje: ' + stat

                if stat=='OK' and len(lmaile) > 0:
                    klucze['Funkcja'] = 2
                    klucze['DataOd'] = DataOd
                    klucze['DataDo'] = DataDo
                    klucze['OddzialOpis'] = oddzialopis
                    klucze['Oddzial'] = oddzial
                    klucze['Przewoznik'] = pzw
                    stat, dane, wyn1, wyn2 = WykonajFunkcje('fs_kierowcy_wersje_wydruk_pdf', klucze, [], [])

                    #stat, dane = fs_kierowcy_wersje_wydruk_pdf_pom.Funkcja2(self,stat,[],oddzial,oddzialopis,DataOd,DataDo,pzw)
                    if stat != 'OK':
                        stat=u'Bd wykonania pliku: '+stat
                    ##--------------------------Zapis pliku na dysku--------------------------------
                    if stat == 'OK' and dane<>[]:
                        Tresc = binascii.unhexlify(dane[0])
                        try:
                            #WS 2022-10-04
                            with open(Plik, 'wb') as p:
                                p.write(Tresc)
                            # open(Plik, 'wb').write(Tresc)
                        except Exception, e:
                            stat = u'Bd zapisu pliku na dysku: ' + str(e)

                        dane1 = []
                        dane2 = []
                        temat = u'Zestawienie przejazdw dla przewonika:'+pzw+u' w oddziale '+oddzial+':'+oddzialopis

                        if stat == 'OK':
                            # gwna wiadomo
                            Tresc = temat
                            for l in range(len(lmaile)):
                                Liczba_Wyslanych += 1
                                stat = rsglobal.RSWyslijEmail(lmaile[l][0], str(temat), str(Tresc),[Plik], 0, PolSQL)
                            os.remove(Plik)

                            if stat != 'OK':
                                stat = 'Bd wysyania zestawie dla przewonikw:' + stat

    if stat == 'OK' and Liczba_Wyslanych > 0:
        stat += ' Pomylnie wysano '+str(Liczba_Wyslanych)+' powiadomie dla przewonikw'

    elif stat == 'OK' and Liczba_Wyslanych == 0:
        stat += " Brak powiadomie w systemie"