# -*- coding: iso8859_2 -*-
#-------------------------------------------------------------------------------
# Name:        fs_zamykanie_zatrudnienia.py
# Purpose:     Zamykanie zatrudnienia pracownikw
# Author:      Marcin Natkaski
# Created:     2016/06/10
# RCS-ID:      $Id: funkcje_harmonogramu/fs_zamykanie_zatrudnienia.py $
# Copyright:   (c) 2016 Record System
# Licence:     GNU GPL
#-------------------------------------------------------------------------------

stat = 'OK'
SQL=''
SprawdzArgumenty(['liczba_dni'])

SQL = """SELECT pracownik_id, data_rezygnacji_wyslanie, data_konca_zatrudnienia, rkdop.data_przystapienia, bit_and(numer_id), zwolnienie_data
         FROM rs_kp_dane_osobowe dos
         LEFT JOIN rs_kp_dane_osobowe_ppk rkdop USING(firma_id, pracownik_id) 
         LEFT JOIN rs_kp_zatrudnienie rkz USING(firma_id, pracownik_id)
         WHERE firma_id ='{}' AND data_rezygnacji_wyslanie IS NULL AND stan_pracownika_id IN ('A', 'S')   
               AND zwolnienie_data IS NOT NULL AND data_konca_zatrudnienia IS NULL
             AND (SELECT max(do_kiedy) FROM rs_kp_umowy_o_prace WHERE firma_id=dos.firma_id 
             AND pracownik_id=dos.pracownik_id AND numer_id=zatrudnienie_id) < now() + INTERVAL '{} days '
         GROUP BY pracownik_id, data_rezygnacji_wyslanie, data_konca_zatrudnienia, rkdop.data_przystapienia, zwolnienie_data
         HAVING count(rkz.numer_id) = 1
         ORDER BY data_rezygnacji_wyslanie IS NOT NULL;
         """.format(firma_id, liczba_dni)
stat, do_ppk, dump, dump = PolSQL.Execute(SQL, 3)
if stat != 'OK':
    KonczJesliBlad(stat, 'Bd sprawdzania PPK do aktualizacji: '+stat)
for wiersz_ppk in do_ppk:
    pracownik   = wiersz_ppk[0]
    data_przyst = wiersz_ppk[3]
    koniec      = wiersz_ppk[5]
    SQL = """UPDATE rs_kp_dane_osobowe_ppk SET data_konca_zatrudnienia = '{}'
             WHERE firma_id = '{}' AND pracownik_id ='{}' AND data_rezygnacji_wyslanie IS NULL
             ;""".format(koniec, firma_id, pracownik, data_przyst)
    stat, dump, dump, dump = PolSQL.Execute(SQL, 1)
    if stat != 'OK':
        stat = 'Blad aktualizacji danych PPK:'

if stat =='OK':
    SQL=" UPDATE rs_kp_zatrudnienie SET stan_pracownika_id='Z'"
    SQL+=" WHERE (firma_id, pracownik_id, numer_id) in ("
    SQL+=" SELECT a.firma_id, a.pracownik_id, a.numer_id"
    SQL+=" FROM rs_kp_zatrudnienie a "
    SQL+=" WHERE a.firma_id='"+firma_id+"' AND "
    SQL+="(SELECT max(do_kiedy) FROM rs_kp_umowy_o_prace WHERE firma_id=a.firma_id "
    SQL+=" AND pracownik_id=a.pracownik_id AND numer_id=zatrudnienie_id) < now() + INTERVAL '"+str(liczba_dni)+" days '"
    SQL+=" AND (SELECT count(*) FROM rs_kp_umowy_o_prace "
    SQL+=" WHERE firma_id=a.firma_id AND pracownik_id=a.pracownik_id AND numer_id=zatrudnienie_id AND do_kiedy is null)=0) AND stan_pracownika_id='A' ;"
    stat,dump,dump,dump = PolSQL.Execute(SQL,1)
    if stat <> 'OK':
        KonczJesliBlad(stat, 'Bd zamykania zatrudnienia: '+stat)